/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ee=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/base/common/uri","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/base/common/types","vs/nls","vs/base/common/errors","vs/base/common/network","electron","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/platform/product/common/productService","vs/base/common/cancellation","vs/base/node/pfs","vs/platform/telemetry/common/telemetry","os","vs/base/common/strings","vs/base/common/arrays","vs/platform/workspace/common/workspace","vs/platform/environment/electron-main/environmentMainService","vs/platform/windows/electron-main/windows","vs/base/common/uuid","vs/base/common/extpath","vs/platform/state/node/state","vs/platform/environment/common/environment","vs/base/common/map","vs/base/common/process","vs/base/common/objects","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","fs","vs/base/parts/ipc/electron-main/ipcMain","vs/base/common/json","vs/base/common/errorMessage","vs/base/common/labels","child_process","vs/base/parts/ipc/common/ipc","vs/platform/telemetry/common/telemetryUtils","vs/platform/update/common/update","vs/base/common/functional","vs/platform/registry/common/platform","vs/platform/request/common/request","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/base/common/hash","vs/platform/remote/common/remoteHosts","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/platform/theme/electron-main/themeMainService","vs/platform/utilityProcess/electron-main/utilityProcess","vs/base/common/iterator","crypto","net","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/platform/window/common/window","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/normalization","vs/base/common/marshalling","vs/base/node/id","vs/base/node/processes","vs/platform/diagnostics/common/diagnostics","vs/platform/dialogs/common/dialogs","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/storage/electron-main/storageMainService","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/linkedList","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/environment/node/environmentService","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/shell/node/shellEnv","vs/platform/state/node/stateService","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/symbols","vs/base/common/codicons","vs/base/common/themables","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/credentials/common/credentialsMainService","vs/platform/encryption/node/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetryUtils","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/launch/electron-main/launchMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/remote/node/nodeSocketFactory","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","string_decoder","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","@vscode/policy-watcher","https","vs/code/electron-main/main"],te=function(G){for(var e=[],P=0,L=G.length;P<L;P++)e[P]=ee[G[P]];return e};define(ee[126],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function P(k,f){const c=Math.pow(10,f);return Math.round(k*c)/c}class L{constructor(f,c,m,v=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,f))|0,this.g=Math.min(255,Math.max(0,c))|0,this.b=Math.min(255,Math.max(0,m))|0,this.a=P(Math.max(Math.min(1,v),0),3)}static equals(f,c){return f.r===c.r&&f.g===c.g&&f.b===c.b&&f.a===c.a}}e.RGBA=L;class o{constructor(f,c,m,v){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=P(Math.max(Math.min(1,c),0),3),this.l=P(Math.max(Math.min(1,m),0),3),this.a=P(Math.max(Math.min(1,v),0),3)}static equals(f,c){return f.h===c.h&&f.s===c.s&&f.l===c.l&&f.a===c.a}static fromRGBA(f){const c=f.r/255,m=f.g/255,v=f.b/255,b=f.a,d=Math.max(c,m,v),S=Math.min(c,m,v);let w=0,r=0;const u=(S+d)/2,g=d-S;if(g>0){switch(r=Math.min(u<=.5?g/(2*u):g/(2-2*u),1),d){case c:w=(m-v)/g+(m<v?6:0);break;case m:w=(v-c)/g+2;break;case v:w=(c-m)/g+4;break}w*=60,w=Math.round(w)}return new o(w,r,u,b)}static i(f,c,m){return m<0&&(m+=1),m>1&&(m-=1),m<1/6?f+(c-f)*6*m:m<1/2?c:m<2/3?f+(c-f)*(2/3-m)*6:f}static toRGBA(f){const c=f.h/360,{s:m,l:v,a:b}=f;let d,S,w;if(m===0)d=S=w=v;else{const r=v<.5?v*(1+m):v+m-v*m,u=2*v-r;d=o.i(u,r,c+1/3),S=o.i(u,r,c),w=o.i(u,r,c-1/3)}return new L(Math.round(d*255),Math.round(S*255),Math.round(w*255),b)}}e.HSLA=o;class A{constructor(f,c,m,v){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=P(Math.max(Math.min(1,c),0),3),this.v=P(Math.max(Math.min(1,m),0),3),this.a=P(Math.max(Math.min(1,v),0),3)}static equals(f,c){return f.h===c.h&&f.s===c.s&&f.v===c.v&&f.a===c.a}static fromRGBA(f){const c=f.r/255,m=f.g/255,v=f.b/255,b=Math.max(c,m,v),d=Math.min(c,m,v),S=b-d,w=b===0?0:S/b;let r;return S===0?r=0:b===c?r=((m-v)/S%6+6)%6:b===m?r=(v-c)/S+2:r=(c-m)/S+4,new A(Math.round(r*60),w,b,f.a)}static toRGBA(f){const{h:c,s:m,v,a:b}=f,d=v*m,S=d*(1-Math.abs(c/60%2-1)),w=v-d;let[r,u,g]=[0,0,0];return c<60?(r=d,u=S):c<120?(r=S,u=d):c<180?(u=d,g=S):c<240?(u=S,g=d):c<300?(r=S,g=d):c<=360&&(r=d,g=S),r=Math.round((r+w)*255),u=Math.round((u+w)*255),g=Math.round((g+w)*255),new L(r,u,g,b)}}e.HSVA=A;class M{static fromHex(f){return M.Format.CSS.parseHex(f)||M.red}static equals(f,c){return!f&&!c?!0:!f||!c?!1:f.equals(c)}get hsla(){return this.i?this.i:o.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:A.fromRGBA(this.rgba)}constructor(f){if(f)if(f instanceof L)this.rgba=f;else if(f instanceof o)this.i=f,this.rgba=o.toRGBA(f);else if(f instanceof A)this.j=f,this.rgba=A.toRGBA(f);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(f){return!!f&&L.equals(this.rgba,f.rgba)&&o.equals(this.hsla,f.hsla)&&A.equals(this.hsva,f.hsva)}getRelativeLuminance(){const f=M.k(this.rgba.r),c=M.k(this.rgba.g),m=M.k(this.rgba.b),v=.2126*f+.7152*c+.0722*m;return P(v,4)}static k(f){const c=f/255;return c<=.03928?c/12.92:Math.pow((c+.055)/1.055,2.4)}getContrastRatio(f){const c=this.getRelativeLuminance(),m=f.getRelativeLuminance();return c>m?(c+.05)/(m+.05):(m+.05)/(c+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(f){const c=this.getRelativeLuminance(),m=f.getRelativeLuminance();return c>m}isDarkerThan(f){const c=this.getRelativeLuminance(),m=f.getRelativeLuminance();return c<m}lighten(f){return new M(new o(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*f,this.hsla.a))}darken(f){return new M(new o(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*f,this.hsla.a))}transparent(f){const{r:c,g:m,b:v,a:b}=this.rgba;return new M(new L(c,m,v,b*f))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new M(new L(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(f){const c=f.rgba,m=this.rgba.a,v=c.a,b=m+v*(1-m);if(b<1e-6)return M.transparent;const d=this.rgba.r*m/b+c.r*v*(1-m)/b,S=this.rgba.g*m/b+c.g*v*(1-m)/b,w=this.rgba.b*m/b+c.b*v*(1-m)/b;return new M(new L(d,S,w,b))}makeOpaque(f){if(this.isOpaque()||f.rgba.a!==1)return this;const{r:c,g:m,b:v,a:b}=this.rgba;return new M(new L(f.rgba.r-b*(f.rgba.r-c),f.rgba.g-b*(f.rgba.g-m),f.rgba.b-b*(f.rgba.b-v),1))}flatten(...f){const c=f.reduceRight((m,v)=>M.o(v,m));return M.o(this,c)}static o(f,c){const m=1-f.rgba.a;return new M(new L(m*c.rgba.r+f.rgba.a*f.rgba.r,m*c.rgba.g+f.rgba.a*f.rgba.g,m*c.rgba.b+f.rgba.a*f.rgba.b))}toString(){return this.u||(this.u=M.Format.CSS.format(this)),this.u}static getLighterColor(f,c,m){if(f.isLighterThan(c))return f;m=m||.5;const v=f.getRelativeLuminance(),b=c.getRelativeLuminance();return m=m*(b-v)/b,f.lighten(m)}static getDarkerColor(f,c,m){if(f.isDarkerThan(c))return f;m=m||.5;const v=f.getRelativeLuminance(),b=c.getRelativeLuminance();return m=m*(v-b)/v,f.darken(m)}}M.white=new M(new L(255,255,255,1)),M.black=new M(new L(0,0,0,1)),M.red=new M(new L(255,0,0,1)),M.blue=new M(new L(0,0,255,1)),M.green=new M(new L(0,255,0,1)),M.cyan=new M(new L(0,255,255,1)),M.lightgrey=new M(new L(211,211,211,1)),M.transparent=new M(new L(0,0,0,0)),e.Color=M,function(k){let f;(function(c){let m;(function(v){function b(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:k.Format.CSS.formatRGBA(t)}v.formatRGB=b;function d(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}v.formatRGBA=d;function S(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:k.Format.CSS.formatHSLA(t)}v.formatHSL=S;function w(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}v.formatHSLA=w;function r(t){const a=t.toString(16);return a.length!==2?"0"+a:a}function u(t){return`#${r(t.rgba.r)}${r(t.rgba.g)}${r(t.rgba.b)}`}v.formatHex=u;function g(t,a=!1){return a&&t.rgba.a===1?k.Format.CSS.formatHex(t):`#${r(t.rgba.r)}${r(t.rgba.g)}${r(t.rgba.b)}${r(Math.round(t.rgba.a*255))}`}v.formatHexA=g;function p(t){return t.isOpaque()?k.Format.CSS.formatHex(t):k.Format.CSS.formatRGBA(t)}v.format=p;function y(t){const a=t.length;if(a===0||t.charCodeAt(0)!==35)return null;if(a===7){const i=16*D(t.charCodeAt(1))+D(t.charCodeAt(2)),s=16*D(t.charCodeAt(3))+D(t.charCodeAt(4)),n=16*D(t.charCodeAt(5))+D(t.charCodeAt(6));return new k(new L(i,s,n,1))}if(a===9){const i=16*D(t.charCodeAt(1))+D(t.charCodeAt(2)),s=16*D(t.charCodeAt(3))+D(t.charCodeAt(4)),n=16*D(t.charCodeAt(5))+D(t.charCodeAt(6)),h=16*D(t.charCodeAt(7))+D(t.charCodeAt(8));return new k(new L(i,s,n,h/255))}if(a===4){const i=D(t.charCodeAt(1)),s=D(t.charCodeAt(2)),n=D(t.charCodeAt(3));return new k(new L(16*i+i,16*s+s,16*n+n))}if(a===5){const i=D(t.charCodeAt(1)),s=D(t.charCodeAt(2)),n=D(t.charCodeAt(3)),h=D(t.charCodeAt(4));return new k(new L(16*i+i,16*s+s,16*n+n,(16*h+h)/255))}return null}v.parseHex=y;function D(t){switch(t){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(m=c.CSS||(c.CSS={}))})(f=k.Format||(k.Format={}))}(M=e.Color||(e.Color={})),e.Color=M}),define(ee[55],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function P(M){return(k,f,c)=>{let m=null,v=null;if(typeof c.value=="function"?(m="value",v=c.value):typeof c.get=="function"&&(m="get",v=c.get),!v)throw new Error("not supported");c[m]=M(v,f)}}function L(M,k,f){let c=null,m=null;if(typeof f.value=="function"?(c="value",m=f.value,m.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(c="get",m=f.get),!m)throw new Error("not supported");const v=`$memoize$${k}`;f[c]=function(...b){return this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!1,enumerable:!1,writable:!1,value:m.apply(this,b)}),this[v]}}e.memoize=L;function o(M,k,f){return P((c,m)=>{const v=`$debounce$${m}`,b=`$debounce$result$${m}`;return function(...d){this[b]||(this[b]=f?f():void 0),clearTimeout(this[v]),k&&(this[b]=k(this[b],...d),d=[this[b]]),this[v]=setTimeout(()=>{c.apply(this,d),this[b]=f?f():void 0},M)}})}e.debounce=o;function A(M,k,f){return P((c,m)=>{const v=`$throttle$timer$${m}`,b=`$throttle$result$${m}`,d=`$throttle$lastRun$${m}`,S=`$throttle$pending$${m}`;return function(...w){if(this[b]||(this[b]=f?f():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),k&&(this[b]=k(this[b],...w)),this[S])return;const r=this[d]+M;r<=Date.now()?(this[d]=Date.now(),c.apply(this,[this[b]]),this[b]=f?f():void 0):(this[S]=!0,this[v]=setTimeout(()=>{this[S]=!1,this[d]=Date.now(),c.apply(this,[this[b]]),this[b]=f?f():void 0},r-Date.now()))}})}e.throttle=A}),define(ee[13],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class P{constructor(){this.b=[],this.a=function(a){setTimeout(()=>{throw a.stack?y.isErrorNoTelemetry(a)?new y(a.message+`

`+a.stack):new Error(a.message+`

`+a.stack):a},0)}}addListener(a){return this.b.push(a),()=>{this.d(a)}}c(a){this.b.forEach(i=>{i(a)})}d(a){this.b.splice(this.b.indexOf(a),1)}setUnexpectedErrorHandler(a){this.a=a}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(a){this.a(a),this.c(a)}onUnexpectedExternalError(a){this.a(a)}}e.ErrorHandler=P,e.errorHandler=new P;function L(t){e.errorHandler.setUnexpectedErrorHandler(t)}e.setUnexpectedErrorHandler=L;function o(t){if(!t||typeof t!="object")return!1;const a=t;return a.code==="EPIPE"&&a.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=o;function A(t){c(t)||e.errorHandler.onUnexpectedError(t)}e.onUnexpectedError=A;function M(t){c(t)||e.errorHandler.onUnexpectedExternalError(t)}e.onUnexpectedExternalError=M;function k(t){if(t instanceof Error){const{name:a,message:i}=t,s=t.stacktrace||t.stack;return{$isError:!0,name:a,message:i,stack:s,noTelemetry:y.isErrorNoTelemetry(t)}}return t}e.transformErrorForSerialization=k;const f="Canceled";function c(t){return t instanceof m?!0:t instanceof Error&&t.name===f&&t.message===f}e.isCancellationError=c;class m extends Error{constructor(){super(f),this.name=this.message}}e.CancellationError=m;function v(){const t=new Error(f);return t.name=t.message,t}e.canceled=v;function b(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}e.illegalArgument=b;function d(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}e.illegalState=d;function S(t){return t?new Error(`readonly property '${t} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=S;function w(t){const a=new Error(`${t} has been disposed`);return a.name="DISPOSED",a}e.disposed=w;function r(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}e.getErrorMessage=r;class u extends Error{constructor(a){super("NotImplemented"),a&&(this.message=a)}}e.NotImplementedError=u;class g extends Error{constructor(a){super("NotSupported"),a&&(this.message=a)}}e.NotSupportedError=g;class p extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=p;class y extends Error{constructor(a){super(a),this.name="CodeExpectedError"}static fromError(a){if(a instanceof y)return a;const i=new y;return i.message=a.message,i.stack=a.stack,i}static isErrorNoTelemetry(a){return a.name==="CodeExpectedError"}}e.ErrorNoTelemetry=y;class D extends Error{constructor(a){super(a||"An unexpected bug occurred."),Object.setPrototypeOf(this,D.prototype);debugger}}e.BugIndicatingError=D}),define(ee[27],te([0,1,13]),function(G,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function L($,V=0){return $[$.length-(1+V)]}e.tail=L;function o($){if($.length===0)throw new Error("Invalid tail call");return[$.slice(0,$.length-1),$[$.length-1]]}e.tail2=o;function A($,V,K=(oe,fe)=>oe===fe){if($===V)return!0;if(!$||!V||$.length!==V.length)return!1;for(let oe=0,fe=$.length;oe<fe;oe++)if(!K($[oe],V[oe]))return!1;return!0}e.equals=A;function M($,V){const K=$.length-1;V<K&&($[V]=$[K]),$.pop()}e.removeFastWithoutKeepingOrder=M;function k($,V,K){return f($.length,oe=>K($[oe],V))}e.binarySearch=k;function f($,V){let K=0,oe=$-1;for(;K<=oe;){const fe=(K+oe)/2|0,Ce=V(fe);if(Ce<0)K=fe+1;else if(Ce>0)oe=fe-1;else return fe}return-(K+1)}e.binarySearch2=f;function c($,V){let K=0,oe=$.length;if(oe===0)return 0;for(;K<oe;){const fe=Math.floor((K+oe)/2);V($[fe])?oe=fe:K=fe+1}return K}e.findFirstInSorted=c;function m($,V,K){if($=$|0,$>=V.length)throw new TypeError("invalid index");const oe=V[Math.floor(V.length*Math.random())],fe=[],Ce=[],Ee=[];for(const Re of V){const Oe=K(Re,oe);Oe<0?fe.push(Re):Oe>0?Ce.push(Re):Ee.push(Re)}return $<fe.length?m($,fe,K):$<fe.length+Ee.length?Ee[0]:m($-(fe.length+Ee.length),Ce,K)}e.quickSelect=m;function v($,V){const K=[];let oe;for(const fe of $.slice(0).sort(V))!oe||V(oe[0],fe)!==0?(oe=[fe],K.push(oe)):oe.push(fe);return K}e.groupBy=v;function b($,V,K){const oe=[];function fe(Re,Oe,ze){if(Oe===0&&ze.length===0)return;const ge=oe[oe.length-1];ge&&ge.start+ge.deleteCount===Re?(ge.deleteCount+=Oe,ge.toInsert.push(...ze)):oe.push({start:Re,deleteCount:Oe,toInsert:ze})}let Ce=0,Ee=0;for(;;){if(Ce===$.length){fe(Ce,0,V.slice(Ee));break}if(Ee===V.length){fe(Ce,$.length-Ce,[]);break}const Re=$[Ce],Oe=V[Ee],ze=K(Re,Oe);ze===0?(Ce+=1,Ee+=1):ze<0?(fe(Ce,1,[]),Ce+=1):ze>0&&(fe(Ce,0,[Oe]),Ee+=1)}return oe}e.sortedDiff=b;function d($,V,K){const oe=b($,V,K),fe=[],Ce=[];for(const Ee of oe)fe.push(...$.slice(Ee.start,Ee.start+Ee.deleteCount)),Ce.push(...Ee.toInsert);return{removed:fe,added:Ce}}e.delta=d;function S($,V,K){if(K===0)return[];const oe=$.slice(0,K).sort(V);return r($,V,oe,K,$.length),oe}e.top=S;function w($,V,K,oe,fe){return K===0?Promise.resolve([]):new Promise((Ce,Ee)=>{(async()=>{const Re=$.length,Oe=$.slice(0,K).sort(V);for(let ze=K,ge=Math.min(K+oe,Re);ze<Re;ze=ge,ge=Math.min(ge+oe,Re)){if(ze>K&&await new Promise(pe=>setTimeout(pe)),fe&&fe.isCancellationRequested)throw new P.CancellationError;r($,V,Oe,ze,ge)}return Oe})().then(Ce,Ee)})}e.topAsync=w;function r($,V,K,oe,fe){for(const Ce=K.length;oe<fe;oe++){const Ee=$[oe];if(V(Ee,K[Ce-1])<0){K.pop();const Re=c(K,Oe=>V(Ee,Oe)<0);K.splice(Re,0,Ee)}}}function u($){return $.filter(V=>!!V)}e.coalesce=u;function g($){let V=0;for(let K=0;K<$.length;K++)$[K]&&($[V]=$[K],V+=1);$.length=V}e.coalesceInPlace=g;function p($,V,K){$.splice(K,0,$.splice(V,1)[0])}e.move=p;function y($){return!Array.isArray($)||$.length===0}e.isFalsyOrEmpty=y;function D($){return Array.isArray($)&&$.length>0}e.isNonEmptyArray=D;function t($,V=K=>K){const K=new Set;return $.filter(oe=>{const fe=V(oe);return K.has(fe)?!1:(K.add(fe),!0)})}e.distinct=t;function a($){const V=new Set;return K=>{const oe=$(K);return V.has(oe)?!1:(V.add(oe),!0)}}e.uniqueFilter=a;function i($,V){const K=s($,V);if(K!==-1)return $[K]}e.findLast=i;function s($,V){for(let K=$.length-1;K>=0;K--){const oe=$[K];if(V(oe))return K}return-1}e.lastIndex=s;function n($,V){return $.length>0?$[0]:V}e.firstOrDefault=n;function h($,V){return $.length>0?$[$.length-1]:V}e.lastOrDefault=h;function l($,V,K=(oe,fe)=>oe===fe){let oe=0;for(let fe=0,Ce=Math.min($.length,V.length);fe<Ce&&K($[fe],V[fe]);fe++)oe++;return oe}e.commonPrefixLength=l;function E($){return[].concat(...$)}e.flatten=E;function R($,V){let K=typeof V=="number"?$:0;typeof V=="number"?K=$:(K=0,V=$);const oe=[];if(K<=V)for(let fe=K;fe<V;fe++)oe.push(fe);else for(let fe=K;fe>V;fe--)oe.push(fe);return oe}e.range=R;function C($,V,K){return $.reduce((oe,fe)=>(oe[V(fe)]=K?K(fe):fe,oe),Object.create(null))}e.index=C;function T($,V){return $.push(V),()=>N($,V)}e.insert=T;function N($,V){const K=$.indexOf(V);if(K>-1)return $.splice(K,1),V}e.remove=N;function z($,V,K){const oe=$.slice(0,V),fe=$.slice(V);return oe.concat(K,fe)}e.arrayInsert=z;function B($,V){let K;if(typeof V=="number"){let oe=V;K=()=>{const fe=Math.sin(oe++)*179426549;return fe-Math.floor(fe)}}else K=Math.random;for(let oe=$.length-1;oe>0;oe-=1){const fe=Math.floor(K()*(oe+1)),Ce=$[oe];$[oe]=$[fe],$[fe]=Ce}}e.shuffle=B;function _($,V){const K=$.indexOf(V);K>-1&&($.splice(K,1),$.unshift(V))}e.pushToStart=_;function ne($,V){const K=$.indexOf(V);K>-1&&($.splice(K,1),$.push(V))}e.pushToEnd=ne;function ae($,V){for(const K of V)$.push(K)}e.pushMany=ae;function he($,V){return Array.isArray($)?$.map(V):V($)}e.mapArrayOrNot=he;function ce($){return Array.isArray($)?$:[$]}e.asArray=ce;function J($){return $[Math.floor(Math.random()*$.length)]}e.getRandomElement=J;function Y($,V){for(const K of $){const oe=V(K);if(oe!==void 0)return oe}}e.mapFind=Y;function q($,V,K){const oe=H($,V),fe=$.length,Ce=K.length;$.length=fe+Ce;for(let Ee=fe-1;Ee>=oe;Ee--)$[Ee+Ce]=$[Ee];for(let Ee=0;Ee<Ce;Ee++)$[Ee+oe]=K[Ee]}e.insertInto=q;function W($,V,K,oe){const fe=H($,V),Ce=$.splice(fe,K);return q($,fe,oe),Ce}e.splice=W;function H($,V){return V<0?Math.max(V+$.length,0):Math.min(V,$.length)}var Q;(function($){function V(fe){return fe<0}$.isLessThan=V;function K(fe){return fe>0}$.isGreaterThan=K;function oe(fe){return fe===0}$.isNeitherLessOrGreaterThan=oe,$.greaterThan=1,$.lessThan=-1,$.neitherLessOrGreaterThan=0})(Q=e.CompareResult||(e.CompareResult={}));function se($,V){return(K,oe)=>V($(K),$(oe))}e.compareBy=se;function re(...$){return(V,K)=>{for(const oe of $){const fe=oe(V,K);if(!Q.isNeitherLessOrGreaterThan(fe))return fe}return Q.neitherLessOrGreaterThan}}e.tieBreakComparators=re;const F=($,V)=>$-V;e.numberComparator=F;function I($,V){if($.length===0)return;let K=$[0];for(let oe=1;oe<$.length;oe++){const fe=$[oe];V(fe,K)>0&&(K=fe)}return K}e.findMaxBy=I;function O($,V){if($.length===0)return;let K=$[0];for(let oe=1;oe<$.length;oe++){const fe=$[oe];V(fe,K)>=0&&(K=fe)}return K}e.findLastMaxBy=O;function U($,V){return I($,(K,oe)=>-V(K,oe))}e.findMinBy=U;class j{constructor(V){this.f=V,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(V){let K=this.c;for(;K<this.f.length&&V(this.f[K]);)K++;const oe=K===this.c?null:this.f.slice(this.c,K);return this.c=K,oe}takeFromEndWhile(V){let K=this.d;for(;K>=0&&V(this.f[K]);)K--;const oe=K===this.d?null:this.f.slice(K+1,this.d+1);return this.d=K,oe}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const V=this.f[this.c];return this.c++,V}removeLast(){const V=this.f[this.d];return this.d--,V}takeCount(V){const K=this.f.slice(this.c,this.c+V);return this.c+=V,K}}e.ArrayQueue=j;class x{constructor(V){this.iterate=V}forEach(V){this.iterate(K=>(V(K),!0))}toArray(){const V=[];return this.iterate(K=>(V.push(K),!0)),V}filter(V){return new x(K=>this.iterate(oe=>V(oe)?K(oe):!0))}map(V){return new x(K=>this.iterate(oe=>K(V(oe))))}some(V){let K=!1;return this.iterate(oe=>(K=V(oe),!K)),K}findFirst(V){let K;return this.iterate(oe=>V(oe)?(K=oe,!1):!0),K}findLast(V){let K;return this.iterate(oe=>(V(oe)&&(K=oe),!0)),K}findLastMaxBy(V){let K,oe=!0;return this.iterate(fe=>((oe||Q.isGreaterThan(V(fe,K)))&&(oe=!1,K=fe),!0)),K}}x.empty=new x($=>{}),e.CallbackIterable=x}),define(ee[127],te([0,1,13]),function(G,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function L(f,c){if(!f)throw new Error(c?`Assertion failed (${c})`:"Assertion Failed")}e.ok=L;function o(f,c="Unreachable"){throw new Error(c)}e.assertNever=o;function A(f){if(!f)throw new P.BugIndicatingError("Assertion Failed")}e.assert=A;function M(f){if(!f()){debugger;f(),(0,P.onUnexpectedError)(new P.BugIndicatingError("Assertion Failed"))}}e.assertFn=M;function k(f,c){let m=0;for(;m<f.length-1;){const v=f[m],b=f[m+1];if(!c(v,b))return!1;m++}return!0}e.checkAdjacentItems=k}),define(ee[50],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function P(L){const o=this;let A=!1,M;return function(){return A||(A=!0,M=L.apply(o,arguments)),M}}e.once=P}),define(ee[71],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var P;(function(L){function o(y){return y&&typeof y=="object"&&typeof y[Symbol.iterator]=="function"}L.is=o;const A=Object.freeze([]);function M(){return A}L.empty=M;function*k(y){yield y}L.single=k;function f(y){return o(y)?y:k(y)}L.wrap=f;function c(y){return y||A}L.from=c;function m(y){return!y||y[Symbol.iterator]().next().done===!0}L.isEmpty=m;function v(y){return y[Symbol.iterator]().next().value}L.first=v;function b(y,D){for(const t of y)if(D(t))return!0;return!1}L.some=b;function d(y,D){for(const t of y)if(D(t))return t}L.find=d;function*S(y,D){for(const t of y)D(t)&&(yield t)}L.filter=S;function*w(y,D){let t=0;for(const a of y)yield D(a,t++)}L.map=w;function*r(...y){for(const D of y)for(const t of D)yield t}L.concat=r;function u(y,D,t){let a=t;for(const i of y)a=D(a,i);return a}L.reduce=u;function*g(y,D,t=y.length){for(D<0&&(D+=y.length),t<0?t+=y.length:t>y.length&&(t=y.length);D<t;D++)yield y[D]}L.slice=g;function p(y,D=Number.POSITIVE_INFINITY){const t=[];if(D===0)return[t,y];const a=y[Symbol.iterator]();for(let i=0;i<D;i++){const s=a.next();if(s.done)return[t,L.empty()];t.push(s.value)}return[t,{[Symbol.iterator](){return a}}]}L.consume=p})(P=e.Iterable||(e.Iterable={}))}),define(ee[43],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var P;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(P=e.ScanError||(e.ScanError={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var o;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(o=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function M(t,a=!1){let i=0;const s=t.length;let n="",h=0,l=16,E=0;function R(ne){let ae=0,he=0;for(;ae<ne;){const ce=t.charCodeAt(i);if(ce>=48&&ce<=57)he=he*16+ce-48;else if(ce>=65&&ce<=70)he=he*16+ce-65+10;else if(ce>=97&&ce<=102)he=he*16+ce-97+10;else break;i++,ae++}return ae<ne&&(he=-1),he}function C(ne){i=ne,n="",h=0,l=16,E=0}function T(){const ne=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&c(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&c(t.charCodeAt(i)))for(i++;i<t.length&&c(t.charCodeAt(i));)i++;else return E=3,t.substring(ne,i);let ae=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&c(t.charCodeAt(i))){for(i++;i<t.length&&c(t.charCodeAt(i));)i++;ae=i}else E=3;return t.substring(ne,ae)}function N(){let ne="",ae=i;for(;;){if(i>=s){ne+=t.substring(ae,i),E=2;break}const he=t.charCodeAt(i);if(he===34){ne+=t.substring(ae,i),i++;break}if(he===92){if(ne+=t.substring(ae,i),i++,i>=s){E=2;break}switch(t.charCodeAt(i++)){case 34:ne+='"';break;case 92:ne+="\\";break;case 47:ne+="/";break;case 98:ne+="\b";break;case 102:ne+="\f";break;case 110:ne+=`
`;break;case 114:ne+="\r";break;case 116:ne+="	";break;case 117:{const J=R(4);J>=0?ne+=String.fromCharCode(J):E=4;break}default:E=5}ae=i;continue}if(he>=0&&he<=31)if(f(he)){ne+=t.substring(ae,i),E=2;break}else E=6;i++}return ne}function z(){if(n="",E=0,h=i,i>=s)return h=s,l=17;let ne=t.charCodeAt(i);if(k(ne)){do i++,n+=String.fromCharCode(ne),ne=t.charCodeAt(i);while(k(ne));return l=15}if(f(ne))return i++,n+=String.fromCharCode(ne),ne===13&&t.charCodeAt(i)===10&&(i++,n+=`
`),l=14;switch(ne){case 123:return i++,l=1;case 125:return i++,l=2;case 91:return i++,l=3;case 93:return i++,l=4;case 58:return i++,l=6;case 44:return i++,l=5;case 34:return i++,n=N(),l=10;case 47:{const ae=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<s&&!f(t.charCodeAt(i));)i++;return n=t.substring(ae,i),l=12}if(t.charCodeAt(i+1)===42){i+=2;const he=s-1;let ce=!1;for(;i<he;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,ce=!0;break}i++}return ce||(i++,E=1),n=t.substring(ae,i),l=13}return n+=String.fromCharCode(ne),i++,l=16}case 45:if(n+=String.fromCharCode(ne),i++,i===s||!c(t.charCodeAt(i)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=T(),l=11;default:for(;i<s&&B(ne);)i++,ne=t.charCodeAt(i);if(h!==i){switch(n=t.substring(h,i),n){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return n+=String.fromCharCode(ne),i++,l=16}}function B(ne){if(k(ne)||f(ne))return!1;switch(ne){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function _(){let ne;do ne=z();while(ne>=12&&ne<=15);return ne}return{setPosition:C,getPosition:()=>i,scan:a?_:z,getToken:()=>l,getTokenValue:()=>n,getTokenOffset:()=>h,getTokenLength:()=>i-h,getTokenError:()=>E}}e.createScanner=M;function k(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function f(t){return t===10||t===13||t===8232||t===8233}function c(t){return t>=48&&t<=57}var m;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(m||(m={}));function v(t,a){const i=[],s=new Object;let n;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function E(R,C,T,N){h.value=R,h.offset=C,h.length=T,h.type=N,h.colonOffset=void 0,n=h}try{p(t,{onObjectBegin:(R,C)=>{if(a<=R)throw s;n=void 0,l=a>R,i.push("")},onObjectProperty:(R,C,T)=>{if(a<C||(E(R,C,T,"property"),i[i.length-1]=R,a<=C+T))throw s},onObjectEnd:(R,C)=>{if(a<=R)throw s;n=void 0,i.pop()},onArrayBegin:(R,C)=>{if(a<=R)throw s;n=void 0,i.push(0)},onArrayEnd:(R,C)=>{if(a<=R)throw s;n=void 0,i.pop()},onLiteralValue:(R,C,T)=>{if(a<C||(E(R,C,T,D(R)),a<=C+T))throw s},onSeparator:(R,C,T)=>{if(a<=C)throw s;if(R===":"&&n&&n.type==="property")n.colonOffset=C,l=!1,n=void 0;else if(R===","){const N=i[i.length-1];typeof N=="number"?i[i.length-1]=N+1:(l=!0,i[i.length-1]=""),n=void 0}}})}catch(R){if(R!==s)throw R}return{path:i,previousNode:n,isAtPropertyKey:l,matches:R=>{let C=0;for(let T=0;C<R.length&&T<i.length;T++)if(R[C]===i[T]||R[C]==="*")C++;else if(R[C]!=="**")return!1;return C===R.length}}}e.getLocation=v;function b(t,a=[],i=A.DEFAULT){let s=null,n=[];const h=[];function l(R){Array.isArray(n)?n.push(R):s!==null&&(n[s]=R)}return p(t,{onObjectBegin:()=>{const R={};l(R),h.push(n),n=R,s=null},onObjectProperty:R=>{s=R},onObjectEnd:()=>{n=h.pop()},onArrayBegin:()=>{const R=[];l(R),h.push(n),n=R,s=null},onArrayEnd:()=>{n=h.pop()},onLiteralValue:l,onError:(R,C,T)=>{a.push({error:R,offset:C,length:T})}},i),n[0]}e.parse=b;function d(t,a=[],i=A.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(R){s.type==="property"&&(s.length=R-s.offset,s=s.parent)}function h(R){return s.children.push(R),R}p(t,{onObjectBegin:R=>{s=h({type:"object",offset:R,length:-1,parent:s,children:[]})},onObjectProperty:(R,C,T)=>{s=h({type:"property",offset:C,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:R,offset:C,length:T,parent:s})},onObjectEnd:(R,C)=>{s.length=R+C-s.offset,s=s.parent,n(R+C)},onArrayBegin:(R,C)=>{s=h({type:"array",offset:R,length:-1,parent:s,children:[]})},onArrayEnd:(R,C)=>{s.length=R+C-s.offset,s=s.parent,n(R+C)},onLiteralValue:(R,C,T)=>{h({type:D(R),offset:C,length:T,parent:s,value:R}),n(C+T)},onSeparator:(R,C,T)=>{s.type==="property"&&(R===":"?s.colonOffset=C:R===","&&n(C))},onError:(R,C,T)=>{a.push({error:R,offset:C,length:T})}},i);const E=s.children[0];return E&&delete E.parent,E}e.parseTree=d;function S(t,a){if(!t)return;let i=t;for(const s of a)if(typeof s=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let n=!1;for(const h of i.children)if(Array.isArray(h.children)&&h.children[0].value===s){i=h.children[1],n=!0;break}if(!n)return}else{const n=s;if(i.type!=="array"||n<0||!Array.isArray(i.children)||n>=i.children.length)return;i=i.children[n]}return i}e.findNodeAtLocation=S;function w(t){if(!t.parent||!t.parent.children)return[];const a=w(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;a.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&a.push(i)}return a}e.getNodePath=w;function r(t){switch(t.type){case"array":return t.children.map(r);case"object":{const a=Object.create(null);for(const i of t.children){const s=i.children[1];s&&(a[i.children[0].value]=r(s))}return a}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=r;function u(t,a,i=!1){return a>=t.offset&&a<t.offset+t.length||i&&a===t.offset+t.length}e.contains=u;function g(t,a,i=!1){if(u(t,a,i)){const s=t.children;if(Array.isArray(s))for(let n=0;n<s.length&&s[n].offset<=a;n++){const h=g(s[n],a,i);if(h)return h}return t}}e.findNodeAtOffset=g;function p(t,a,i=A.DEFAULT){const s=M(t,!1);function n(se){return se?()=>se(s.getTokenOffset(),s.getTokenLength()):()=>!0}function h(se){return se?re=>se(re,s.getTokenOffset(),s.getTokenLength()):()=>!0}const l=n(a.onObjectBegin),E=h(a.onObjectProperty),R=n(a.onObjectEnd),C=n(a.onArrayBegin),T=n(a.onArrayEnd),N=h(a.onLiteralValue),z=h(a.onSeparator),B=n(a.onComment),_=h(a.onError),ne=i&&i.disallowComments,ae=i&&i.allowTrailingComma;function he(){for(;;){const se=s.scan();switch(s.getTokenError()){case 4:ce(14);break;case 5:ce(15);break;case 3:ce(13);break;case 1:ne||ce(11);break;case 2:ce(12);break;case 6:ce(16);break}switch(se){case 12:case 13:ne?ce(10):B();break;case 16:ce(1);break;case 15:case 14:break;default:return se}}}function ce(se,re=[],F=[]){if(_(se),re.length+F.length>0){let I=s.getToken();for(;I!==17;){if(re.indexOf(I)!==-1){he();break}else if(F.indexOf(I)!==-1)break;I=he()}}}function J(se){const re=s.getTokenValue();return se?N(re):E(re),he(),!0}function Y(){switch(s.getToken()){case 11:{let se=0;try{se=JSON.parse(s.getTokenValue()),typeof se!="number"&&(ce(2),se=0)}catch{ce(2)}N(se);break}case 7:N(null);break;case 8:N(!0);break;case 9:N(!1);break;default:return!1}return he(),!0}function q(){return s.getToken()!==10?(ce(3,[],[2,5]),!1):(J(!1),s.getToken()===6?(z(":"),he(),Q()||ce(4,[],[2,5])):ce(5,[],[2,5]),!0)}function W(){l(),he();let se=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(se||ce(4,[],[]),z(","),he(),s.getToken()===2&&ae)break}else se&&ce(6,[],[]);q()||ce(4,[],[2,5]),se=!0}return R(),s.getToken()!==2?ce(7,[2],[]):he(),!0}function H(){C(),he();let se=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(se||ce(4,[],[]),z(","),he(),s.getToken()===4&&ae)break}else se&&ce(6,[],[]);Q()||ce(4,[],[4,5]),se=!0}return T(),s.getToken()!==4?ce(8,[4],[]):he(),!0}function Q(){switch(s.getToken()){case 3:return H();case 1:return W();case 10:return J(!0);default:return Y()}}return he(),s.getToken()===17?i.allowEmptyContent?!0:(ce(4,[],[]),!1):Q()?(s.getToken()!==17&&ce(9,[],[]),!0):(ce(4,[],[]),!1)}e.visit=p;function y(t,a){const i=M(t),s=[];let n,h=0,l;do switch(l=i.getPosition(),n=i.scan(),n){case 12:case 13:case 17:h!==l&&s.push(t.substring(h,l)),a!==void 0&&s.push(i.getTokenValue().replace(/[^\r\n]/g,a)),h=i.getPosition();break}while(n!==17);return s.join("")}e.stripComments=y;function D(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=D}),define(ee[128],te([0,1,43]),function(G,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function L(c,m,v){let b,d,S,w,r;if(m){for(w=m.offset,r=w+m.length,S=w;S>0&&!f(c,S-1);)S--;let l=r;for(;l<c.length&&!f(c,l);)l++;d=c.substring(S,l),b=M(d,v)}else d=c,b=0,S=0,w=0,r=c.length;const u=k(v,c);let g=!1,p=0,y;v.insertSpaces?y=A(" ",v.tabSize||4):y="	";const D=(0,P.createScanner)(d,!1);let t=!1;function a(){return u+A(y,b+p)}function i(){let l=D.scan();for(g=!1;l===15||l===14;)g=g||l===14,l=D.scan();return t=l===16||D.getTokenError()!==0,l}const s=[];function n(l,E,R){!t&&E<r&&R>w&&c.substring(E,R)!==l&&s.push({offset:E,length:R-E,content:l})}let h=i();if(h!==17){const l=D.getTokenOffset()+S,E=A(y,b);n(E,S,l)}for(;h!==17;){let l=D.getTokenOffset()+D.getTokenLength()+S,E=i(),R="";for(;!g&&(E===12||E===13);){const T=D.getTokenOffset()+S;n(" ",l,T),l=D.getTokenOffset()+D.getTokenLength()+S,R=E===12?a():"",E=i()}if(E===2)h!==1&&(p--,R=a());else if(E===4)h!==3&&(p--,R=a());else{switch(h){case 3:case 1:p++,R=a();break;case 5:case 12:R=a();break;case 13:g?R=a():R=" ";break;case 6:R=" ";break;case 10:if(E===6){R="";break}case 7:case 8:case 9:case 11:case 2:case 4:E===12||E===13?R=" ":E!==5&&E!==17&&(t=!0);break;case 16:t=!0;break}g&&(E===12||E===13)&&(R=a())}const C=D.getTokenOffset()+S;n(R,l,C),h=E}return s}e.format=L;function o(c,m){const v=JSON.stringify(c,void 0,m.insertSpaces?m.tabSize||4:"	");return m.eol!==void 0?v.replace(/\r\n|\r|\n/g,m.eol):v}e.toFormattedString=o;function A(c,m){let v="";for(let b=0;b<m;b++)v+=c;return v}function M(c,m){let v=0,b=0;const d=m.tabSize||4;for(;v<c.length;){const S=c.charAt(v);if(S===" ")b++;else if(S==="	")b+=d;else break;v++}return Math.floor(b/d)}function k(c,m){for(let v=0;v<m.length;v++){const b=m.charAt(v);if(b==="\r")return v+1<m.length&&m.charAt(v+1)===`
`?`\r
`:"\r";if(b===`
`)return`
`}return c&&c.eol||`
`}e.getEOL=k;function f(c,m){return`\r
`.indexOf(c.charAt(m))!==-1}e.isEOL=f}),define(ee[129],te([0,1,43,128]),function(G,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function o(c,m,v){return A(c,m,void 0,v)}e.removeProperty=o;function A(c,m,v,b,d){const S=m.slice(),w=[],r=(0,P.parseTree)(c,w);let u,g;for(;S.length>0&&(g=S.pop(),u=(0,P.findNodeAtLocation)(r,S),u===void 0&&v!==void 0);)typeof g=="string"?v={[g]:v}:v=[v];if(u)if(u.type==="object"&&typeof g=="string"&&Array.isArray(u.children)){const p=(0,P.findNodeAtLocation)(u,[g]);if(p!==void 0)if(v===void 0){if(!p.parent)throw new Error("Malformed AST");const y=u.children.indexOf(p.parent);let D,t=p.parent.offset+p.parent.length;if(y>0){const a=u.children[y-1];D=a.offset+a.length}else D=u.offset+1,u.children.length>1&&(t=u.children[1].offset);return M(c,{offset:D,length:t-D,content:""},b)}else return M(c,{offset:p.offset,length:p.length,content:JSON.stringify(v)},b);else{if(v===void 0)return[];const y=`${JSON.stringify(g)}: ${JSON.stringify(v)}`,D=d?d(u.children.map(a=>a.children[0].value)):u.children.length;let t;if(D>0){const a=u.children[D-1];t={offset:a.offset+a.length,length:0,content:","+y}}else u.children.length===0?t={offset:u.offset+1,length:0,content:y}:t={offset:u.offset+1,length:0,content:y+","};return M(c,t,b)}}else if(u.type==="array"&&typeof g=="number"&&Array.isArray(u.children))if(v!==void 0){const p=`${JSON.stringify(v)}`;let y;if(u.children.length===0||g===0)y={offset:u.offset+1,length:0,content:u.children.length===0?p:p+","};else{const D=g===-1||g>u.children.length?u.children.length:g,t=u.children[D-1];y={offset:t.offset+t.length,length:0,content:","+p}}return M(c,y,b)}else{const p=g,y=u.children[p];let D;if(u.children.length===1)D={offset:u.offset+1,length:u.length-2,content:""};else if(u.children.length-1===p){const t=u.children[p-1],a=t.offset+t.length,i=u.offset+u.length;D={offset:a,length:i-2-a,content:""}}else D={offset:y.offset,length:u.children[p+1].offset-y.offset,content:""};return M(c,D,b)}else throw new Error(`Can not add ${typeof g!="number"?"index":"property"} to parent of type ${u.type}`);else{if(v===void 0)throw new Error("Can not delete in empty document");return M(c,{offset:r?r.offset:0,length:r?r.length:0,content:JSON.stringify(v)},b)}}e.setProperty=A;function M(c,m,v){let b=k(c,m),d=m.offset,S=m.offset+m.content.length;if(m.length===0||m.content.length===0){for(;d>0&&!(0,L.isEOL)(b,d-1);)d--;for(;S<b.length&&!(0,L.isEOL)(b,S);)S++}const w=(0,L.format)(b,{offset:d,length:S-d},v);for(let u=w.length-1;u>=0;u--){const g=w[u];b=k(b,g),d=Math.min(d,g.offset),S=Math.max(S,g.offset+g.length),S+=g.content.length-g.length}const r=c.length-(b.length-S)-d;return[{offset:d,length:r,content:b.substring(d,S)}]}e.withFormatting=M;function k(c,m){return c.substring(0,m.offset)+m.content+c.substring(m.offset+m.length)}e.applyEdit=k;function f(c,m){const v=m.slice(0).sort((d,S)=>{const w=d.offset-S.offset;return w===0?d.length-S.length:w});let b=c.length;for(let d=v.length-1;d>=0;d--){const S=v[d];if(S.offset+S.length<=b)c=k(c,S);else throw new Error("Overlapping edit");b=S.offset}return c}e.applyEdits=f}),define(ee[130],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class P{constructor(o){this.d=o,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(o){this.c=o}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.Lazy=P}),define(ee[2],te([0,1,50,71]),function(G,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const o=!1;let A=null;function M(h){A=h}if(e.setDisposableTracker=M,o){const h="__is_disposable_tracked__";M(new class{trackDisposable(l){const E=new Error("Potentially leaked disposable").stack;setTimeout(()=>{l[h]||console.log(E)},3e3)}setParent(l,E){if(l&&l!==g.None)try{l[h]=!0}catch{}}markAsDisposed(l){if(l&&l!==g.None)try{l[h]=!0}catch{}}markAsSingleton(l){}})}function k(h){return A?.trackDisposable(h),h}function f(h){A?.markAsDisposed(h)}function c(h,l){A?.setParent(h,l)}function m(h,l){if(!!A)for(const E of h)A.setParent(E,l)}function v(h){return A?.markAsSingleton(h),h}e.markAsSingleton=v;function b(h){return typeof h.dispose=="function"&&h.dispose.length===0}e.isDisposable=b;function d(h){if(L.Iterable.is(h)){const l=[];for(const E of h)if(E)try{E.dispose()}catch(R){l.push(R)}if(l.length===1)throw l[0];if(l.length>1)throw new AggregateError(l,"Encountered errors while disposing of store");return Array.isArray(h)?[]:h}else if(h)return h.dispose(),h}e.dispose=d;function S(h){for(const l of h)b(l)&&l.dispose();return[]}e.disposeIfDisposable=S;function w(...h){const l=r(()=>d(h));return m(h,l),l}e.combinedDisposable=w;function r(h){const l=k({dispose:(0,P.once)(()=>{f(l),h()})});return l}e.toDisposable=r;class u{constructor(){this.c=new Set,this.f=!1,k(this)}dispose(){this.f||(f(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{d(this.c)}finally{this.c.clear()}}add(l){if(!l)return l;if(l===this)throw new Error("Cannot register a disposable on itself!");return c(l,this),this.f?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(l),l}}u.DISABLE_DISPOSED_WARNING=!1,e.DisposableStore=u;class g{constructor(){this.B=new u,k(this),c(this.B,this)}dispose(){f(this),this.B.dispose()}D(l){if(l===this)throw new Error("Cannot register a disposable on itself!");return this.B.add(l)}}g.None=Object.freeze({dispose(){}}),e.Disposable=g;class p{constructor(){this.b=!1,k(this)}get value(){return this.b?void 0:this.a}set value(l){this.b||l===this.a||(this.a?.dispose(),l&&c(l,this),this.a=l)}clear(){this.value=void 0}dispose(){this.b=!0,f(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const l=this.a;return this.a=void 0,l&&c(l,null),l}}e.MutableDisposable=p;class y{constructor(l){this.b=l,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=y;class D{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,k(this)}set(l){let E=l;return this.unset=()=>E=void 0,this.isset=()=>E!==void 0,this.dispose=()=>{E&&(E(),E=void 0,f(this))},this}}e.SafeDisposable=D;class t{constructor(){this.a=new Map}acquire(l,...E){let R=this.a.get(l);R||(R={counter:0,object:this.b(l,...E)},this.a.set(l,R));const{object:C}=R,T=(0,P.once)(()=>{--R.counter===0&&(this.c(l,R.object),this.a.delete(l))});return R.counter++,{object:C,dispose:T}}}e.ReferenceCollection=t;class a{constructor(l){this.a=l}async acquire(l,...E){const R=this.a.acquire(l,...E);try{return{object:await R.object,dispose:()=>R.dispose()}}catch(C){throw R.dispose(),C}}}e.AsyncReferenceCollection=a;class i{constructor(l){this.object=l}dispose(){}}e.ImmortalReference=i;function s(h){const l=new u;try{h(l)}finally{l.dispose()}}e.disposeOnReturn=s;class n{constructor(){this.a=new Map,this.b=!1,k(this)}dispose(){f(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{d(this.a.values())}finally{this.a.clear()}}has(l){return this.a.has(l)}get(l){return this.a.get(l)}set(l,E,R=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),R||this.a.get(l)?.dispose(),this.a.set(l,E)}deleteAndDispose(l){this.a.get(l)?.dispose(),this.a.delete(l)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=n}),define(ee[99],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class P{constructor(A){this.element=A,this.next=P.Undefined,this.prev=P.Undefined}}P.Undefined=new P(void 0);class L{constructor(){this.a=P.Undefined,this.b=P.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===P.Undefined}clear(){let A=this.a;for(;A!==P.Undefined;){const M=A.next;A.prev=P.Undefined,A.next=P.Undefined,A=M}this.a=P.Undefined,this.b=P.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,M){const k=new P(A);if(this.a===P.Undefined)this.a=k,this.b=k;else if(M){const c=this.b;this.b=k,k.prev=c,c.next=k}else{const c=this.a;this.a=k,k.next=c,c.prev=k}this.c+=1;let f=!1;return()=>{f||(f=!0,this.e(k))}}shift(){if(this.a!==P.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==P.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==P.Undefined&&A.next!==P.Undefined){const M=A.prev;M.next=A.next,A.next.prev=M}else A.prev===P.Undefined&&A.next===P.Undefined?(this.a=P.Undefined,this.b=P.Undefined):A.next===P.Undefined?(this.b=this.b.prev,this.b.next=P.Undefined):A.prev===P.Undefined&&(this.a=this.a.next,this.a.prev=P.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==P.Undefined;)yield A.element,A=A.next}}e.LinkedList=L}),define(ee[35],te([0,1]),function(G,e){"use strict";var P,L,o;Object.defineProperty(e,"__esModule",{value:!0}),e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function A(w,r,u){let g=w.get(r);return g===void 0&&(g=u,w.set(r,g)),g}e.getOrSet=A;function M(w){const r=[];return w.forEach((u,g)=>{r.push(`${g} => ${u}`)}),`Map(${w.size}) {${r.join(", ")}}`}e.mapToString=M;function k(w){const r=[];return w.forEach(u=>{r.push(u)}),`Set(${w.size}) {${r.join(", ")}}`}e.setToString=k;class f{constructor(r,u){this.uri=r,this.value=u}}class c{constructor(r,u){this[P]="ResourceMap",r instanceof c?(this.b=new Map(r.b),this.c=u??c.a):(this.b=new Map,this.c=r??c.a)}set(r,u){return this.b.set(this.c(r),new f(r,u)),this}get(r){return this.b.get(this.c(r))?.value}has(r){return this.b.has(this.c(r))}get size(){return this.b.size}clear(){this.b.clear()}delete(r){return this.b.delete(this.c(r))}forEach(r,u){typeof u<"u"&&(r=r.bind(u));for(const[g,p]of this.b)r(p.value,p.uri,this)}*values(){for(const r of this.b.values())yield r.value}*keys(){for(const r of this.b.values())yield r.uri}*entries(){for(const r of this.b.values())yield[r.uri,r.value]}*[(P=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.b)yield[r.uri,r.value]}}c.a=w=>w.toString(),e.ResourceMap=c;class m{constructor(r,u){this[L]="ResourceSet",!r||typeof r=="function"?this.a=new c(r):(this.a=new c(u),r.forEach(this.add,this))}get size(){return this.a.size}add(r){return this.a.set(r,r),this}clear(){this.a.clear()}delete(r){return this.a.delete(r)}forEach(r,u){this.a.forEach((g,p)=>r.call(u,p,p,this))}has(r){return this.a.has(r)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=m;var v;(function(w){w[w.None=0]="None",w[w.AsOld=1]="AsOld",w[w.AsNew=2]="AsNew"})(v=e.Touch||(e.Touch={}));class b{constructor(){this[o]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(r){return this.a.has(r)}get(r,u=0){const g=this.a.get(r);if(!!g)return u!==0&&this.j(g,u),g.value}set(r,u,g=0){let p=this.a.get(r);if(p)p.value=u,g!==0&&this.j(p,g);else{switch(p={key:r,value:u,next:void 0,previous:void 0},g){case 0:this.h(p);break;case 1:this.g(p);break;case 2:this.h(p);break;default:this.h(p);break}this.a.set(r,p),this.d++}return this}delete(r){return!!this.remove(r)}remove(r){const u=this.a.get(r);if(!!u)return this.a.delete(r),this.i(u),this.d--,u.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const r=this.b;return this.a.delete(r.key),this.i(r),this.d--,r.value}forEach(r,u){const g=this.e;let p=this.b;for(;p;){if(u?r.bind(u)(p.value,p.key,this):r(p.value,p.key,this),this.e!==g)throw new Error("LinkedMap got modified during iteration.");p=p.next}}keys(){const r=this,u=this.e;let g=this.b;const p={[Symbol.iterator](){return p},next(){if(r.e!==u)throw new Error("LinkedMap got modified during iteration.");if(g){const y={value:g.key,done:!1};return g=g.next,y}else return{value:void 0,done:!0}}};return p}values(){const r=this,u=this.e;let g=this.b;const p={[Symbol.iterator](){return p},next(){if(r.e!==u)throw new Error("LinkedMap got modified during iteration.");if(g){const y={value:g.value,done:!1};return g=g.next,y}else return{value:void 0,done:!0}}};return p}entries(){const r=this,u=this.e;let g=this.b;const p={[Symbol.iterator](){return p},next(){if(r.e!==u)throw new Error("LinkedMap got modified during iteration.");if(g){const y={value:[g.key,g.value],done:!1};return g=g.next,y}else return{value:void 0,done:!0}}};return p}[(o=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(r){if(r>=this.size)return;if(r===0){this.clear();return}let u=this.b,g=this.size;for(;u&&g>r;)this.a.delete(u.key),u=u.next,g--;this.b=u,this.d=g,u&&(u.previous=void 0),this.e++}g(r){if(!this.b&&!this.c)this.c=r;else if(this.b)r.next=this.b,this.b.previous=r;else throw new Error("Invalid list");this.b=r,this.e++}h(r){if(!this.b&&!this.c)this.b=r;else if(this.c)r.previous=this.c,this.c.next=r;else throw new Error("Invalid list");this.c=r,this.e++}i(r){if(r===this.b&&r===this.c)this.b=void 0,this.c=void 0;else if(r===this.b){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this.b=r.next}else if(r===this.c){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this.c=r.previous}else{const u=r.next,g=r.previous;if(!u||!g)throw new Error("Invalid list");u.previous=g,g.next=u}r.next=void 0,r.previous=void 0,this.e++}j(r,u){if(!this.b||!this.c)throw new Error("Invalid list");if(!(u!==1&&u!==2)){if(u===1){if(r===this.b)return;const g=r.next,p=r.previous;r===this.c?(p.next=void 0,this.c=p):(g.previous=p,p.next=g),r.previous=void 0,r.next=this.b,this.b.previous=r,this.b=r,this.e++}else if(u===2){if(r===this.c)return;const g=r.next,p=r.previous;r===this.b?(g.previous=void 0,this.b=g):(g.previous=p,p.next=g),r.next=void 0,r.previous=this.c,this.c.next=r,this.c=r,this.e++}}}toJSON(){const r=[];return this.forEach((u,g)=>{r.push([g,u])}),r}fromJSON(r){this.clear();for(const[u,g]of r)this.set(u,g)}}e.LinkedMap=b;class d extends b{constructor(r,u=1){super(),this.k=r,this.l=Math.min(Math.max(0,u),1)}get limit(){return this.k}set limit(r){this.k=r,this.m()}get ratio(){return this.l}set ratio(r){this.l=Math.min(Math.max(0,r),1),this.m()}get(r,u=2){return super.get(r,u)}peek(r){return super.get(r,0)}set(r,u){return super.set(r,u,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=d;class S{constructor(){this.a=new Map}add(r){return this.a.set(r,(this.a.get(r)||0)+1),this}delete(r){let u=this.a.get(r)||0;return u===0?!1:(u--,u===0?this.a.delete(r):this.a.set(r,u),!0)}has(r){return this.a.has(r)}}e.CounterSet=S}),define(ee[83],te([0,1,35]),function(G,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new P.LRUCache(1e4);function o(c){return f(c,"NFC",L)}e.normalizeNFC=o;const A=new P.LRUCache(1e4);function M(c){return f(c,"NFD",A)}e.normalizeNFD=M;const k=/[^\u0000-\u0080]/;function f(c,m,v){if(!c)return c;const b=v.get(c);if(b)return b;let d;return k.test(c)?d=c.normalize(m):d=c,v.set(c,d),d}e.removeAccents=function(){const c=/[\u0300-\u036f]/g;return function(m){return M(m).replace(c,"")}}()}),define(ee[131],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function P(k,f,c){return Math.min(Math.max(k,f),c)}e.clamp=P;function L(k,f){return(f+k%f)%f}e.rot=L;class o{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=o;class A{constructor(){this.a=1,this.b=0}update(f){return this.b=this.b+(f-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=A;class M{constructor(f){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(f),this.c.fill(0,0,f)}update(f){const c=this.c[this.d];return this.c[this.d]=f,this.d=(this.d+1)%this.c.length,this.e-=c,this.e+=f,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=M}),function(){function G(o){const A=[];typeof o=="number"&&A.push("code/timeOrigin",o);function M(f){A.push(f,Date.now())}function k(){const f=[];for(let c=0;c<A.length;c+=2)f.push({name:A[c],startTime:A[c+1]});return f}return{mark:M,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?G():{mark(o){performance.mark(o)},getMarks(){let o=performance.timeOrigin;typeof o!="number"&&(o=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(o)}];for(const M of performance.getEntriesByType("mark"))A.push({name:M.name,startTime:Math.round(o+M.startTime)});return A}};if(typeof process=="object"){const o=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return G(o)}else return console.trace("perf-util loaded in UNKNOWN environment"),G()}function P(o){return o.MonacoPerformanceMarks||(o.MonacoPerformanceMarks=e()),o.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return P(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=P(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=P(L))}(),function(G,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var P=e();for(var L in P)(typeof exports=="object"?exports:G)[L]=P[L]}}(typeof self<"u"?self:this,function(){return function(G){var e={};function P(L){if(e[L])return e[L].exports;var o=e[L]={i:L,l:!1,exports:{}};return G[L].call(o.exports,o,o.exports,P),o.l=!0,o.exports}return P.m=G,P.c=e,P.d=function(L,o,A){P.o(L,o)||Object.defineProperty(L,o,{enumerable:!0,get:A})},P.r=function(L){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},P.t=function(L,o){if(1&o&&(L=P(L)),8&o||4&o&&typeof L=="object"&&L&&L.__esModule)return L;var A=Object.create(null);if(P.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:L}),2&o&&typeof L!="string")for(var M in L)P.d(A,M,function(k){return L[k]}.bind(null,M));return A},P.n=function(L){var o=L&&L.__esModule?function(){return L.default}:function(){return L};return P.d(o,"a",o),o},P.o=function(L,o){return Object.prototype.hasOwnProperty.call(L,o)},P.p="",P(P.s=0)}([function(G,e,P){(function(L){var o;e=G.exports=F,o=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var ie=Array.prototype.slice.call(arguments,0);ie.unshift("SEMVER"),console.log.apply(console,ie)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,M=Number.MAX_SAFE_INTEGER||9007199254740991,k=e.re=[],f=e.src=[],c=0,m=c++;f[m]="0|[1-9]\\d*";var v=c++;f[v]="[0-9]+";var b=c++;f[b]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var d=c++;f[d]="("+f[m]+")\\.("+f[m]+")\\.("+f[m]+")";var S=c++;f[S]="("+f[v]+")\\.("+f[v]+")\\.("+f[v]+")";var w=c++;f[w]="(?:"+f[m]+"|"+f[b]+")";var r=c++;f[r]="(?:"+f[v]+"|"+f[b]+")";var u=c++;f[u]="(?:-("+f[w]+"(?:\\."+f[w]+")*))";var g=c++;f[g]="(?:-?("+f[r]+"(?:\\."+f[r]+")*))";var p=c++;f[p]="[0-9A-Za-z-]+";var y=c++;f[y]="(?:\\+("+f[p]+"(?:\\."+f[p]+")*))";var D=c++,t="v?"+f[d]+f[u]+"?"+f[y]+"?";f[D]="^"+t+"$";var a="[v=\\s]*"+f[S]+f[g]+"?"+f[y]+"?",i=c++;f[i]="^"+a+"$";var s=c++;f[s]="((?:<|>)?=?)";var n=c++;f[n]=f[v]+"|x|X|\\*";var h=c++;f[h]=f[m]+"|x|X|\\*";var l=c++;f[l]="[v=\\s]*("+f[h]+")(?:\\.("+f[h]+")(?:\\.("+f[h]+")(?:"+f[u]+")?"+f[y]+"?)?)?";var E=c++;f[E]="[v=\\s]*("+f[n]+")(?:\\.("+f[n]+")(?:\\.("+f[n]+")(?:"+f[g]+")?"+f[y]+"?)?)?";var R=c++;f[R]="^"+f[s]+"\\s*"+f[l]+"$";var C=c++;f[C]="^"+f[s]+"\\s*"+f[E]+"$";var T=c++;f[T]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var N=c++;f[N]="(?:~>?)";var z=c++;f[z]="(\\s*)"+f[N]+"\\s+",k[z]=new RegExp(f[z],"g");var B=c++;f[B]="^"+f[N]+f[l]+"$";var _=c++;f[_]="^"+f[N]+f[E]+"$";var ne=c++;f[ne]="(?:\\^)";var ae=c++;f[ae]="(\\s*)"+f[ne]+"\\s+",k[ae]=new RegExp(f[ae],"g");var he=c++;f[he]="^"+f[ne]+f[l]+"$";var ce=c++;f[ce]="^"+f[ne]+f[E]+"$";var J=c++;f[J]="^"+f[s]+"\\s*("+a+")$|^$";var Y=c++;f[Y]="^"+f[s]+"\\s*("+t+")$|^$";var q=c++;f[q]="(\\s*)"+f[s]+"\\s*("+a+"|"+f[l]+")",k[q]=new RegExp(f[q],"g");var W=c++;f[W]="^\\s*("+f[l]+")\\s+-\\s+("+f[l]+")\\s*$";var H=c++;f[H]="^\\s*("+f[E]+")\\s+-\\s+("+f[E]+")\\s*$";var Q=c++;f[Q]="(<|>)?=?\\s*\\*";for(var se=0;se<35;se++)o(se,f[se]),k[se]||(k[se]=new RegExp(f[se]));function re(ie,ue){if(ie instanceof F)return ie;if(typeof ie!="string"||ie.length>A||!(ue?k[i]:k[D]).test(ie))return null;try{return new F(ie,ue)}catch{return null}}function F(ie,ue){if(ie instanceof F){if(ie.loose===ue)return ie;ie=ie.version}else if(typeof ie!="string")throw new TypeError("Invalid Version: "+ie);if(ie.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof F))return new F(ie,ue);o("SemVer",ie,ue),this.loose=ue;var de=ie.trim().match(ue?k[i]:k[D]);if(!de)throw new TypeError("Invalid Version: "+ie);if(this.raw=ie,this.major=+de[1],this.minor=+de[2],this.patch=+de[3],this.major>M||this.major<0)throw new TypeError("Invalid major version");if(this.minor>M||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>M||this.patch<0)throw new TypeError("Invalid patch version");de[4]?this.prerelease=de[4].split(".").map(function(Pe){if(/^[0-9]+$/.test(Pe)){var Me=+Pe;if(Me>=0&&Me<M)return Me}return Pe}):this.prerelease=[],this.build=de[5]?de[5].split("."):[],this.format()}e.parse=re,e.valid=function(ie,ue){var de=re(ie,ue);return de?de.version:null},e.clean=function(ie,ue){var de=re(ie.trim().replace(/^[=v]+/,""),ue);return de?de.version:null},e.SemVer=F,F.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},F.prototype.toString=function(){return this.version},F.prototype.compare=function(ie){return o("SemVer.compare",this.version,this.loose,ie),ie instanceof F||(ie=new F(ie,this.loose)),this.compareMain(ie)||this.comparePre(ie)},F.prototype.compareMain=function(ie){return ie instanceof F||(ie=new F(ie,this.loose)),O(this.major,ie.major)||O(this.minor,ie.minor)||O(this.patch,ie.patch)},F.prototype.comparePre=function(ie){if(ie instanceof F||(ie=new F(ie,this.loose)),this.prerelease.length&&!ie.prerelease.length)return-1;if(!this.prerelease.length&&ie.prerelease.length)return 1;if(!this.prerelease.length&&!ie.prerelease.length)return 0;var ue=0;do{var de=this.prerelease[ue],Pe=ie.prerelease[ue];if(o("prerelease compare",ue,de,Pe),de===void 0&&Pe===void 0)return 0;if(Pe===void 0)return 1;if(de===void 0)return-1;if(de!==Pe)return O(de,Pe)}while(++ue)},F.prototype.inc=function(ie,ue){switch(ie){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ue);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ue);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ue),this.inc("pre",ue);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ue),this.inc("pre",ue);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var de=this.prerelease.length;--de>=0;)typeof this.prerelease[de]=="number"&&(this.prerelease[de]++,de=-2);de===-1&&this.prerelease.push(0)}ue&&(this.prerelease[0]===ue?isNaN(this.prerelease[1])&&(this.prerelease=[ue,0]):this.prerelease=[ue,0]);break;default:throw new Error("invalid increment argument: "+ie)}return this.format(),this.raw=this.version,this},e.inc=function(ie,ue,de,Pe){typeof de=="string"&&(Pe=de,de=void 0);try{return new F(ie,de).inc(ue,Pe).version}catch{return null}},e.diff=function(ie,ue){if($(ie,ue))return null;var de=re(ie),Pe=re(ue);if(de.prerelease.length||Pe.prerelease.length){for(var Me in de)if((Me==="major"||Me==="minor"||Me==="patch")&&de[Me]!==Pe[Me])return"pre"+Me;return"prerelease"}for(var Me in de)if((Me==="major"||Me==="minor"||Me==="patch")&&de[Me]!==Pe[Me])return Me},e.compareIdentifiers=O;var I=/^[0-9]+$/;function O(ie,ue){var de=I.test(ie),Pe=I.test(ue);return de&&Pe&&(ie=+ie,ue=+ue),de&&!Pe?-1:Pe&&!de?1:ie<ue?-1:ie>ue?1:0}function U(ie,ue,de){return new F(ie,de).compare(new F(ue,de))}function j(ie,ue,de){return U(ie,ue,de)>0}function x(ie,ue,de){return U(ie,ue,de)<0}function $(ie,ue,de){return U(ie,ue,de)===0}function V(ie,ue,de){return U(ie,ue,de)!==0}function K(ie,ue,de){return U(ie,ue,de)>=0}function oe(ie,ue,de){return U(ie,ue,de)<=0}function fe(ie,ue,de,Pe){var Me;switch(ue){case"===":typeof ie=="object"&&(ie=ie.version),typeof de=="object"&&(de=de.version),Me=ie===de;break;case"!==":typeof ie=="object"&&(ie=ie.version),typeof de=="object"&&(de=de.version),Me=ie!==de;break;case"":case"=":case"==":Me=$(ie,de,Pe);break;case"!=":Me=V(ie,de,Pe);break;case">":Me=j(ie,de,Pe);break;case">=":Me=K(ie,de,Pe);break;case"<":Me=x(ie,de,Pe);break;case"<=":Me=oe(ie,de,Pe);break;default:throw new TypeError("Invalid operator: "+ue)}return Me}function Ce(ie,ue){if(ie instanceof Ce){if(ie.loose===ue)return ie;ie=ie.value}if(!(this instanceof Ce))return new Ce(ie,ue);o("comparator",ie,ue),this.loose=ue,this.parse(ie),this.semver===Ee?this.value="":this.value=this.operator+this.semver.version,o("comp",this)}e.rcompareIdentifiers=function(ie,ue){return O(ue,ie)},e.major=function(ie,ue){return new F(ie,ue).major},e.minor=function(ie,ue){return new F(ie,ue).minor},e.patch=function(ie,ue){return new F(ie,ue).patch},e.compare=U,e.compareLoose=function(ie,ue){return U(ie,ue,!0)},e.rcompare=function(ie,ue,de){return U(ue,ie,de)},e.sort=function(ie,ue){return ie.sort(function(de,Pe){return e.compare(de,Pe,ue)})},e.rsort=function(ie,ue){return ie.sort(function(de,Pe){return e.rcompare(de,Pe,ue)})},e.gt=j,e.lt=x,e.eq=$,e.neq=V,e.gte=K,e.lte=oe,e.cmp=fe,e.Comparator=Ce;var Ee={};function Re(ie,ue){if(ie instanceof Re)return ie.loose===ue?ie:new Re(ie.raw,ue);if(ie instanceof Ce)return new Re(ie.value,ue);if(!(this instanceof Re))return new Re(ie,ue);if(this.loose=ue,this.raw=ie,this.set=ie.split(/\s*\|\|\s*/).map(function(de){return this.parseRange(de.trim())},this).filter(function(de){return de.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ie);this.format()}function Oe(ie){return!ie||ie.toLowerCase()==="x"||ie==="*"}function ze(ie,ue,de,Pe,Me,Te,Fe,je,Be,We,He,X,le){return((ue=Oe(de)?"":Oe(Pe)?">="+de+".0.0":Oe(Me)?">="+de+"."+Pe+".0":">="+ue)+" "+(je=Oe(Be)?"":Oe(We)?"<"+(+Be+1)+".0.0":Oe(He)?"<"+Be+"."+(+We+1)+".0":X?"<="+Be+"."+We+"."+He+"-"+X:"<="+je)).trim()}function ge(ie,ue){for(var de=0;de<ie.length;de++)if(!ie[de].test(ue))return!1;if(ue.prerelease.length){for(de=0;de<ie.length;de++)if(o(ie[de].semver),ie[de].semver!==Ee&&ie[de].semver.prerelease.length>0){var Pe=ie[de].semver;if(Pe.major===ue.major&&Pe.minor===ue.minor&&Pe.patch===ue.patch)return!0}return!1}return!0}function pe(ie,ue,de){try{ue=new Re(ue,de)}catch{return!1}return ue.test(ie)}function Le(ie,ue,de,Pe){var Me,Te,Fe,je,Be;switch(ie=new F(ie,Pe),ue=new Re(ue,Pe),de){case">":Me=j,Te=oe,Fe=x,je=">",Be=">=";break;case"<":Me=x,Te=K,Fe=j,je="<",Be="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(pe(ie,ue,Pe))return!1;for(var We=0;We<ue.set.length;++We){var He=ue.set[We],X=null,le=null;if(He.forEach(function(me){me.semver===Ee&&(me=new Ce(">=0.0.0")),X=X||me,le=le||me,Me(me.semver,X.semver,Pe)?X=me:Fe(me.semver,le.semver,Pe)&&(le=me)}),X.operator===je||X.operator===Be||(!le.operator||le.operator===je)&&Te(ie,le.semver)||le.operator===Be&&Fe(ie,le.semver))return!1}return!0}Ce.prototype.parse=function(ie){var ue=this.loose?k[J]:k[Y],de=ie.match(ue);if(!de)throw new TypeError("Invalid comparator: "+ie);this.operator=de[1],this.operator==="="&&(this.operator=""),de[2]?this.semver=new F(de[2],this.loose):this.semver=Ee},Ce.prototype.toString=function(){return this.value},Ce.prototype.test=function(ie){return o("Comparator.test",ie,this.loose),this.semver===Ee||(typeof ie=="string"&&(ie=new F(ie,this.loose)),fe(ie,this.operator,this.semver,this.loose))},Ce.prototype.intersects=function(ie,ue){if(!(ie instanceof Ce))throw new TypeError("a Comparator is required");var de;if(this.operator==="")return de=new Re(ie.value,ue),pe(this.value,de,ue);if(ie.operator==="")return de=new Re(this.value,ue),pe(ie.semver,de,ue);var Pe=!(this.operator!==">="&&this.operator!==">"||ie.operator!==">="&&ie.operator!==">"),Me=!(this.operator!=="<="&&this.operator!=="<"||ie.operator!=="<="&&ie.operator!=="<"),Te=this.semver.version===ie.semver.version,Fe=!(this.operator!==">="&&this.operator!=="<="||ie.operator!==">="&&ie.operator!=="<="),je=fe(this.semver,"<",ie.semver,ue)&&(this.operator===">="||this.operator===">")&&(ie.operator==="<="||ie.operator==="<"),Be=fe(this.semver,">",ie.semver,ue)&&(this.operator==="<="||this.operator==="<")&&(ie.operator===">="||ie.operator===">");return Pe||Me||Te&&Fe||je||Be},e.Range=Re,Re.prototype.format=function(){return this.range=this.set.map(function(ie){return ie.join(" ").trim()}).join("||").trim(),this.range},Re.prototype.toString=function(){return this.range},Re.prototype.parseRange=function(ie){var ue=this.loose;ie=ie.trim(),o("range",ie,ue);var de=ue?k[H]:k[W];ie=ie.replace(de,ze),o("hyphen replace",ie),ie=ie.replace(k[q],"$1$2$3"),o("comparator trim",ie,k[q]),ie=(ie=(ie=ie.replace(k[z],"$1~")).replace(k[ae],"$1^")).split(/\s+/).join(" ");var Pe=ue?k[J]:k[Y],Me=ie.split(" ").map(function(Te){return function(Fe,je){return o("comp",Fe),Fe=function(Be,We){return Be.trim().split(/\s+/).map(function(He){return function(X,le){o("caret",X,le);var me=le?k[ce]:k[he];return X.replace(me,function(ve,we,Ae,Ue,xe){var Ge;return o("caret",X,ve,we,Ae,Ue,xe),Oe(we)?Ge="":Oe(Ae)?Ge=">="+we+".0.0 <"+(+we+1)+".0.0":Oe(Ue)?Ge=we==="0"?">="+we+"."+Ae+".0 <"+we+"."+(+Ae+1)+".0":">="+we+"."+Ae+".0 <"+(+we+1)+".0.0":xe?(o("replaceCaret pr",xe),xe.charAt(0)!=="-"&&(xe="-"+xe),Ge=we==="0"?Ae==="0"?">="+we+"."+Ae+"."+Ue+xe+" <"+we+"."+Ae+"."+(+Ue+1):">="+we+"."+Ae+"."+Ue+xe+" <"+we+"."+(+Ae+1)+".0":">="+we+"."+Ae+"."+Ue+xe+" <"+(+we+1)+".0.0"):(o("no pr"),Ge=we==="0"?Ae==="0"?">="+we+"."+Ae+"."+Ue+" <"+we+"."+Ae+"."+(+Ue+1):">="+we+"."+Ae+"."+Ue+" <"+we+"."+(+Ae+1)+".0":">="+we+"."+Ae+"."+Ue+" <"+(+we+1)+".0.0"),o("caret return",Ge),Ge})}(He,We)}).join(" ")}(Fe,je),o("caret",Fe),Fe=function(Be,We){return Be.trim().split(/\s+/).map(function(He){return function(X,le){var me=le?k[_]:k[B];return X.replace(me,function(ve,we,Ae,Ue,xe){var Ge;return o("tilde",X,ve,we,Ae,Ue,xe),Oe(we)?Ge="":Oe(Ae)?Ge=">="+we+".0.0 <"+(+we+1)+".0.0":Oe(Ue)?Ge=">="+we+"."+Ae+".0 <"+we+"."+(+Ae+1)+".0":xe?(o("replaceTilde pr",xe),xe.charAt(0)!=="-"&&(xe="-"+xe),Ge=">="+we+"."+Ae+"."+Ue+xe+" <"+we+"."+(+Ae+1)+".0"):Ge=">="+we+"."+Ae+"."+Ue+" <"+we+"."+(+Ae+1)+".0",o("tilde return",Ge),Ge})}(He,We)}).join(" ")}(Fe,je),o("tildes",Fe),Fe=function(Be,We){return o("replaceXRanges",Be,We),Be.split(/\s+/).map(function(He){return function(X,le){X=X.trim();var me=le?k[C]:k[R];return X.replace(me,function(ve,we,Ae,Ue,xe,Ge){o("xRange",X,ve,we,Ae,Ue,xe,Ge);var Ke=Oe(Ae),Ye=Ke||Oe(Ue),Ze=Ye||Oe(xe);return we==="="&&Ze&&(we=""),Ke?ve=we===">"||we==="<"?"<0.0.0":"*":we&&Ze?(Ye&&(Ue=0),Ze&&(xe=0),we===">"?(we=">=",Ye?(Ae=+Ae+1,Ue=0,xe=0):Ze&&(Ue=+Ue+1,xe=0)):we==="<="&&(we="<",Ye?Ae=+Ae+1:Ue=+Ue+1),ve=we+Ae+"."+Ue+"."+xe):Ye?ve=">="+Ae+".0.0 <"+(+Ae+1)+".0.0":Ze&&(ve=">="+Ae+"."+Ue+".0 <"+Ae+"."+(+Ue+1)+".0"),o("xRange return",ve),ve})}(He,We)}).join(" ")}(Fe,je),o("xrange",Fe),Fe=function(Be,We){return o("replaceStars",Be,We),Be.trim().replace(k[Q],"")}(Fe,je),o("stars",Fe),Fe}(Te,ue)}).join(" ").split(/\s+/);return this.loose&&(Me=Me.filter(function(Te){return!!Te.match(Pe)})),Me=Me.map(function(Te){return new Ce(Te,ue)})},Re.prototype.intersects=function(ie,ue){if(!(ie instanceof Re))throw new TypeError("a Range is required");return this.set.some(function(de){return de.every(function(Pe){return ie.set.some(function(Me){return Me.every(function(Te){return Pe.intersects(Te,ue)})})})})},e.toComparators=function(ie,ue){return new Re(ie,ue).set.map(function(de){return de.map(function(Pe){return Pe.value}).join(" ").trim().split(" ")})},Re.prototype.test=function(ie){if(!ie)return!1;typeof ie=="string"&&(ie=new F(ie,this.loose));for(var ue=0;ue<this.set.length;ue++)if(ge(this.set[ue],ie))return!0;return!1},e.satisfies=pe,e.maxSatisfying=function(ie,ue,de){var Pe=null,Me=null;try{var Te=new Re(ue,de)}catch{return null}return ie.forEach(function(Fe){Te.test(Fe)&&(Pe&&Me.compare(Fe)!==-1||(Me=new F(Pe=Fe,de)))}),Pe},e.minSatisfying=function(ie,ue,de){var Pe=null,Me=null;try{var Te=new Re(ue,de)}catch{return null}return ie.forEach(function(Fe){Te.test(Fe)&&(Pe&&Me.compare(Fe)!==1||(Me=new F(Pe=Fe,de)))}),Pe},e.validRange=function(ie,ue){try{return new Re(ie,ue).range||"*"}catch{return null}},e.ltr=function(ie,ue,de){return Le(ie,ue,"<",de)},e.gtr=function(ie,ue,de){return Le(ie,ue,">",de)},e.outside=Le,e.prerelease=function(ie,ue){var de=re(ie,ue);return de&&de.prerelease.length?de.prerelease:null},e.intersects=function(ie,ue,de){return ie=new Re(ie,de),ue=new Re(ue,de),ie.intersects(ue)},e.coerce=function(ie){if(ie instanceof F)return ie;if(typeof ie!="string")return null;var ue=ie.match(k[T]);return ue==null?null:re((ue[1]||"0")+"."+(ue[2]||"0")+"."+(ue[3]||"0"))}}).call(this,P(1))},function(G,e){var P,L,o=G.exports={};function A(){throw new Error("setTimeout has not been defined")}function M(){throw new Error("clearTimeout has not been defined")}function k(r){if(P===setTimeout)return setTimeout(r,0);if((P===A||!P)&&setTimeout)return P=setTimeout,setTimeout(r,0);try{return P(r,0)}catch{try{return P.call(null,r,0)}catch{return P.call(this,r,0)}}}(function(){try{P=typeof setTimeout=="function"?setTimeout:A}catch{P=A}try{L=typeof clearTimeout=="function"?clearTimeout:M}catch{L=M}})();var f,c=[],m=!1,v=-1;function b(){m&&f&&(m=!1,f.length?c=f.concat(c):v=-1,c.length&&d())}function d(){if(!m){var r=k(b);m=!0;for(var u=c.length;u;){for(f=c,c=[];++v<u;)f&&f[v].run();v=-1,u=c.length}f=null,m=!1,function(g){if(L===clearTimeout)return clearTimeout(g);if((L===M||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(g);try{L(g)}catch{try{return L.call(null,g)}catch{return L.call(this,g)}}}(r)}}function S(r,u){this.fun=r,this.array=u}function w(){}o.nextTick=function(r){var u=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)u[g-1]=arguments[g];c.push(new S(r,u)),c.length!==1||m||k(d)},S.prototype.run=function(){this.fun.apply(null,this.array)},o.title="browser",o.browser=!0,o.env={},o.argv=[],o.version="",o.versions={},o.on=w,o.addListener=w,o.once=w,o.off=w,o.removeListener=w,o.removeAllListeners=w,o.emit=w,o.prependListener=w,o.prependOnceListener=w,o.listeners=function(r){return[]},o.binding=function(r){throw new Error("process.binding is not supported")},o.cwd=function(){return"/"},o.chdir=function(r){throw new Error("process.chdir is not supported")},o.umask=function(){return 0}}])}),define(ee[132],te([0,1]),function(G,e){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class L{constructor(k,f,c){this.level=k,this.key=f,this.value=c,this.forward=[]}}const o=void 0;class A{constructor(k,f=2**16){this.comparator=k,this[P]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(f)|0),this.e=new L(this.c,o,o)}get size(){return this.f}clear(){this.e=new L(this.c,o,o)}has(k){return Boolean(A.g(this,k,this.comparator))}get(k){return A.g(this,k,this.comparator)?.value}set(k,f){return A.h(this,k,f,this.comparator)&&(this.f+=1),this}delete(k){const f=A.k(this,k,this.comparator);return f&&(this.f-=1),f}forEach(k,f){let c=this.e.forward[0];for(;c;)k.call(f,c.value,c.key,this),c=c.forward[0]}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let k=this.e.forward[0];for(;k;)yield[k.key,k.value],k=k.forward[0]}*keys(){let k=this.e.forward[0];for(;k;)yield k.key,k=k.forward[0]}*values(){let k=this.e.forward[0];for(;k;)yield k.value,k=k.forward[0]}toString(){let k="[SkipList]:",f=this.e.forward[0];for(;f;)k+=`node(${f.key}, ${f.value}, lvl:${f.level})`,f=f.forward[0];return k}static g(k,f,c){let m=k.e;for(let v=k.d-1;v>=0;v--)for(;m.forward[v]&&c(m.forward[v].key,f)<0;)m=m.forward[v];if(m=m.forward[0],m&&c(m.key,f)===0)return m}static h(k,f,c,m){const v=[];let b=k.e;for(let d=k.d-1;d>=0;d--){for(;b.forward[d]&&m(b.forward[d].key,f)<0;)b=b.forward[d];v[d]=b}if(b=b.forward[0],b&&m(b.key,f)===0)return b.value=c,!1;{const d=A.j(k);if(d>k.d){for(let S=k.d;S<d;S++)v[S]=k.e;k.d=d}b=new L(d,f,c);for(let S=0;S<d;S++)b.forward[S]=v[S].forward[S],v[S].forward[S]=b;return!0}}static j(k,f=.5){let c=1;for(;Math.random()<f&&c<k.c;)c+=1;return c}static k(k,f,c){const m=[];let v=k.e;for(let b=k.d-1;b>=0;b--){for(;v.forward[b]&&c(v.forward[b].key,f)<0;)v=v.forward[b];m[b]=v}if(v=v.forward[0],!v||c(v.key,f)!==0)return!1;for(let b=0;b<k.d&&m[b].forward[b]===v;b++)m[b].forward[b]=v.forward[b];for(;k.d>0&&k.e.forward[k.d-1]===o;)k.d-=1;return!0}}e.SkipList=A}),define(ee[60],te([0,1,13,2]),function(G,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function o(y){const D=y;return D?typeof D.read=="function":!1}e.isReadable=o;function A(y){const D=y;return D?[D.on,D.pause,D.resume,D.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=A;function M(y){const D=y;return D?A(D.stream)&&Array.isArray(D.buffer)&&typeof D.ended=="boolean":!1}e.isReadableBufferedStream=M;function k(y,D){return new f(y,D)}e.newWriteableStream=k;class f{constructor(D,t){this.e=D,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(D){if(!this.a.destroyed){if(this.a.flowing)this.g(D);else if(this.b.data.push(D),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(D){this.a.destroyed||(this.a.flowing?this.h(D):this.b.error.push(D))}end(D){this.a.destroyed||(typeof D<"u"&&this.write(D),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(D){this.c.data.slice(0).forEach(t=>t(D))}h(D){this.c.error.length===0?(0,P.onUnexpectedError)(D):this.c.error.slice(0).forEach(t=>t(D))}i(){this.c.end.slice(0).forEach(D=>D())}on(D,t){if(!this.a.destroyed)switch(D){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(D,t){if(this.a.destroyed)return;let a;switch(D){case"data":a=this.c.data;break;case"end":a=this.c.end;break;case"error":a=this.c.error;break}if(a){const i=a.indexOf(t);i>=0&&a.splice(i,1)}}j(){if(this.b.data.length>0){const D=this.e(this.b.data);this.g(D),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(a=>a())}}k(){if(this.c.error.length>0){for(const D of this.b.error)this.h(D);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(y,D){const t=[];let a;for(;(a=y.read())!==null;)t.push(a);return D(t)}e.consumeReadable=c;function m(y,D,t){const a=[];let i;for(;(i=y.read())!==null&&a.length<t;)a.push(i);return i===null&&a.length>0?D(a):{read:()=>{if(a.length>0)return a.shift();if(typeof i<"u"){const s=i;return i=void 0,s}return y.read()}}}e.peekReadable=m;function v(y,D){return new Promise((t,a)=>{const i=[];b(y,{onData:s=>{D&&i.push(s)},onError:s=>{D?a(s):t(void 0)},onEnd:()=>{t(D?D(i):void 0)}})})}e.consumeStream=v;function b(y,D){let t=!1;return y.on("error",a=>{t||D.onError(a)}),y.on("end",()=>{t||D.onEnd()}),y.on("data",a=>{t||D.onData(a)}),(0,L.toDisposable)(()=>t=!0)}e.listenStream=b;function d(y,D){return new Promise((t,a)=>{const i=new L.DisposableStore,s=[],n=E=>{if(s.push(E),s.length>D)return i.dispose(),y.pause(),t({stream:y,buffer:s,ended:!1})},h=E=>a(E),l=()=>t({stream:y,buffer:s,ended:!0});i.add((0,L.toDisposable)(()=>y.removeListener("error",h))),y.on("error",h),i.add((0,L.toDisposable)(()=>y.removeListener("end",l))),y.on("end",l),i.add((0,L.toDisposable)(()=>y.removeListener("data",n))),y.on("data",n)})}e.peekStream=d;function S(y,D){const t=k(D);return t.end(y),t}e.toStream=S;function w(){const y=k(()=>{throw new Error("not supported")});return y.end(),y}e.emptyStream=w;function r(y){let D=!1;return{read:()=>D?null:(D=!0,y)}}e.toReadable=r;function u(y,D,t){const a=k(t);return b(y,{onData:i=>a.write(D.data(i)),onError:i=>a.error(D.error?D.error(i):i),onEnd:()=>a.end()}),a}e.transform=u;function g(y,D,t){let a=!1;return{read:()=>{const i=D.read();return a?i:(a=!0,i!==null?t([y,i]):y)}}}e.prefixedReadable=g;function p(y,D,t){let a=!1;const i=k(t);return b(D,{onData:s=>a?i.write(s):(a=!0,i.write(t([y,s]))),onError:s=>i.error(s),onEnd:()=>{a||(a=!0,i.write(y)),i.end()}}),i}e.prefixedStream=p}),define(ee[17],te([0,1,60]),function(G,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer<"u";let o,A;class M{static alloc(E){return L?new M(Buffer.allocUnsafe(E)):new M(new Uint8Array(E))}static wrap(E){return L&&!Buffer.isBuffer(E)&&(E=Buffer.from(E.buffer,E.byteOffset,E.byteLength)),new M(E)}static fromString(E,R){return!(R?.dontUseNodeBuffer||!1)&&L?new M(Buffer.from(E)):(o||(o=new TextEncoder),new M(o.encode(E)))}static fromByteArray(E){const R=M.alloc(E.length);for(let C=0,T=E.length;C<T;C++)R.buffer[C]=E[C];return R}static concat(E,R){if(typeof R>"u"){R=0;for(let N=0,z=E.length;N<z;N++)R+=E[N].byteLength}const C=M.alloc(R);let T=0;for(let N=0,z=E.length;N<z;N++){const B=E[N];C.set(B,T),T+=B.byteLength}return C}constructor(E){this.buffer=E,this.byteLength=this.buffer.byteLength}clone(){const E=M.alloc(this.byteLength);return E.set(this),E}toString(){return L?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(E,R){return new M(this.buffer.subarray(E,R))}set(E,R){if(E instanceof M)this.buffer.set(E.buffer,R);else if(E instanceof Uint8Array)this.buffer.set(E,R);else if(E instanceof ArrayBuffer)this.buffer.set(new Uint8Array(E),R);else if(ArrayBuffer.isView(E))this.buffer.set(new Uint8Array(E.buffer,E.byteOffset,E.byteLength),R);else throw new Error("Unknown argument 'array'")}readUInt32BE(E){return c(this.buffer,E)}writeUInt32BE(E,R){m(this.buffer,E,R)}readUInt32LE(E){return v(this.buffer,E)}writeUInt32LE(E,R){b(this.buffer,E,R)}readUInt8(E){return d(this.buffer,E)}writeUInt8(E,R){S(this.buffer,E,R)}}e.VSBuffer=M;function k(l,E){return l[E+0]<<0>>>0|l[E+1]<<8>>>0}e.readUInt16LE=k;function f(l,E,R){l[R+0]=E&255,E=E>>>8,l[R+1]=E&255}e.writeUInt16LE=f;function c(l,E){return l[E]*2**24+l[E+1]*2**16+l[E+2]*2**8+l[E+3]}e.readUInt32BE=c;function m(l,E,R){l[R+3]=E,E=E>>>8,l[R+2]=E,E=E>>>8,l[R+1]=E,E=E>>>8,l[R]=E}e.writeUInt32BE=m;function v(l,E){return l[E+0]<<0>>>0|l[E+1]<<8>>>0|l[E+2]<<16>>>0|l[E+3]<<24>>>0}e.readUInt32LE=v;function b(l,E,R){l[R+0]=E&255,E=E>>>8,l[R+1]=E&255,E=E>>>8,l[R+2]=E&255,E=E>>>8,l[R+3]=E&255}e.writeUInt32LE=b;function d(l,E){return l[E]}e.readUInt8=d;function S(l,E,R){l[R]=E}e.writeUInt8=S;function w(l){return P.consumeReadable(l,E=>M.concat(E))}e.readableToBuffer=w;function r(l){return P.toReadable(l)}e.bufferToReadable=r;function u(l){return P.consumeStream(l,E=>M.concat(E))}e.streamToBuffer=u;async function g(l){return l.ended?M.concat(l.buffer):M.concat([...l.buffer,await u(l.stream)])}e.bufferedStreamToBuffer=g;function p(l){return P.toStream(l,E=>M.concat(E))}e.bufferToStream=p;function y(l){return P.transform(l,{data:E=>typeof E=="string"?M.fromString(E):M.wrap(E)},E=>M.concat(E))}e.streamToBufferReadableStream=y;function D(l){return P.newWriteableStream(E=>M.concat(E),l)}e.newWriteableBufferStream=D;function t(l,E){return P.prefixedReadable(l,E,R=>M.concat(R))}e.prefixedBufferReadable=t;function a(l,E){return P.prefixedStream(l,E,R=>M.concat(R))}e.prefixedBufferStream=a;function i(l){let E=0,R=0,C=0;const T=new Uint8Array(Math.floor(l.length/4*3)),N=B=>{switch(R){case 3:T[C++]=E|B,R=0;break;case 2:T[C++]=E|B>>>2,E=B<<6,R=3;break;case 1:T[C++]=E|B>>>4,E=B<<4,R=2;break;default:E=B<<2,R=1}};for(let B=0;B<l.length;B++){const _=l.charCodeAt(B);if(_>=65&&_<=90)N(_-65);else if(_>=97&&_<=122)N(_-97+26);else if(_>=48&&_<=57)N(_-48+52);else if(_===43||_===45)N(62);else if(_===47||_===95)N(63);else{if(_===61)break;throw new SyntaxError(`Unexpected base64 character ${l[B]}`)}}const z=C;for(;R>0;)N(0);return M.wrap(T).slice(0,z)}e.decodeBase64=i;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function h({buffer:l},E=!0,R=!1){const C=R?n:s;let T="";const N=l.byteLength%3;let z=0;for(;z<l.byteLength-N;z+=3){const B=l[z+0],_=l[z+1],ne=l[z+2];T+=C[B>>>2],T+=C[(B<<4|_>>>4)&63],T+=C[(_<<2|ne>>>6)&63],T+=C[ne&63]}if(N===1){const B=l[z+0];T+=C[B>>>2],T+=C[B<<4&63],E&&(T+="==")}else if(N===2){const B=l[z+0],_=l[z+1];T+=C[B>>>2],T+=C[(B<<4|_>>>4)&63],T+=C[_<<2&63],E&&(T+="=")}return T}e.encodeBase64=h}),define(ee[133],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(ee[11],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function P(a){return typeof a=="string"}e.isString=P;function L(a){return Array.isArray(a)&&a.every(i=>P(i))}e.isStringArray=L;function o(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}e.isObject=o;function A(a){const i=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof i}e.isTypedArray=A;function M(a){return typeof a=="number"&&!isNaN(a)}e.isNumber=M;function k(a){return!!a&&typeof a[Symbol.iterator]=="function"}e.isIterable=k;function f(a){return a===!0||a===!1}e.isBoolean=f;function c(a){return typeof a>"u"}e.isUndefined=c;function m(a){return!v(a)}e.isDefined=m;function v(a){return c(a)||a===null}e.isUndefinedOrNull=v;function b(a,i){if(!a)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.assertType=b;function d(a){if(v(a))throw new Error("Assertion Failed: argument is undefined or null");return a}e.assertIsDefined=d;function S(...a){const i=[];for(let s=0;s<a.length;s++){const n=a[s];if(v(n))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);i.push(n)}return i}e.assertAllDefined=S;const w=Object.prototype.hasOwnProperty;function r(a){if(!o(a))return!1;for(const i in a)if(w.call(a,i))return!1;return!0}e.isEmptyObject=r;function u(a){return typeof a=="function"}e.isFunction=u;function g(...a){return a.length>0&&a.every(u)}e.areFunctions=g;function p(a,i){const s=Math.min(a.length,i.length);for(let n=0;n<s;n++)y(a[n],i[n])}e.validateConstraints=p;function y(a,i){if(P(i)){if(typeof a!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(u(i)){try{if(a instanceof i)return}catch{}if(!v(a)&&a.constructor===i||i.length===1&&i.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=y;function D(a){return a===null?void 0:a}e.withNullAsUndefined=D;function t(a){return typeof a>"u"?null:a}e.withUndefinedAsNull=t}),define(ee[134],te([0,1,11]),function(G,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const L=Object.create(null);function o(k,f){if((0,P.isString)(f)){const c=L[f];if(c===void 0)throw new Error(`${k} references an unknown codicon: ${f}`);f=c}return L[k]=f,{id:k}}function A(){return L}e.getCodiconFontCharacters=A;function M(){return Object.values(e.Codicon)}e.getAllCodicons=M,e.Codicon={add:o("add",6e4),plus:o("plus",6e4),gistNew:o("gist-new",6e4),repoCreate:o("repo-create",6e4),lightbulb:o("lightbulb",60001),lightBulb:o("light-bulb",60001),repo:o("repo",60002),repoDelete:o("repo-delete",60002),gistFork:o("gist-fork",60003),repoForked:o("repo-forked",60003),gitPullRequest:o("git-pull-request",60004),gitPullRequestAbandoned:o("git-pull-request-abandoned",60004),recordKeys:o("record-keys",60005),keyboard:o("keyboard",60005),tag:o("tag",60006),tagAdd:o("tag-add",60006),tagRemove:o("tag-remove",60006),person:o("person",60007),personFollow:o("person-follow",60007),personOutline:o("person-outline",60007),personFilled:o("person-filled",60007),gitBranch:o("git-branch",60008),gitBranchCreate:o("git-branch-create",60008),gitBranchDelete:o("git-branch-delete",60008),sourceControl:o("source-control",60008),mirror:o("mirror",60009),mirrorPublic:o("mirror-public",60009),star:o("star",60010),starAdd:o("star-add",60010),starDelete:o("star-delete",60010),starEmpty:o("star-empty",60010),comment:o("comment",60011),commentAdd:o("comment-add",60011),alert:o("alert",60012),warning:o("warning",60012),search:o("search",60013),searchSave:o("search-save",60013),logOut:o("log-out",60014),signOut:o("sign-out",60014),logIn:o("log-in",60015),signIn:o("sign-in",60015),eye:o("eye",60016),eyeUnwatch:o("eye-unwatch",60016),eyeWatch:o("eye-watch",60016),circleFilled:o("circle-filled",60017),primitiveDot:o("primitive-dot",60017),closeDirty:o("close-dirty",60017),debugBreakpoint:o("debug-breakpoint",60017),debugBreakpointDisabled:o("debug-breakpoint-disabled",60017),debugHint:o("debug-hint",60017),primitiveSquare:o("primitive-square",60018),edit:o("edit",60019),pencil:o("pencil",60019),info:o("info",60020),issueOpened:o("issue-opened",60020),gistPrivate:o("gist-private",60021),gitForkPrivate:o("git-fork-private",60021),lock:o("lock",60021),mirrorPrivate:o("mirror-private",60021),close:o("close",60022),removeClose:o("remove-close",60022),x:o("x",60022),repoSync:o("repo-sync",60023),sync:o("sync",60023),clone:o("clone",60024),desktopDownload:o("desktop-download",60024),beaker:o("beaker",60025),microscope:o("microscope",60025),vm:o("vm",60026),deviceDesktop:o("device-desktop",60026),file:o("file",60027),fileText:o("file-text",60027),more:o("more",60028),ellipsis:o("ellipsis",60028),kebabHorizontal:o("kebab-horizontal",60028),mailReply:o("mail-reply",60029),reply:o("reply",60029),organization:o("organization",60030),organizationFilled:o("organization-filled",60030),organizationOutline:o("organization-outline",60030),newFile:o("new-file",60031),fileAdd:o("file-add",60031),newFolder:o("new-folder",60032),fileDirectoryCreate:o("file-directory-create",60032),trash:o("trash",60033),trashcan:o("trashcan",60033),history:o("history",60034),clock:o("clock",60034),folder:o("folder",60035),fileDirectory:o("file-directory",60035),symbolFolder:o("symbol-folder",60035),logoGithub:o("logo-github",60036),markGithub:o("mark-github",60036),github:o("github",60036),terminal:o("terminal",60037),console:o("console",60037),repl:o("repl",60037),zap:o("zap",60038),symbolEvent:o("symbol-event",60038),error:o("error",60039),stop:o("stop",60039),variable:o("variable",60040),symbolVariable:o("symbol-variable",60040),array:o("array",60042),symbolArray:o("symbol-array",60042),symbolModule:o("symbol-module",60043),symbolPackage:o("symbol-package",60043),symbolNamespace:o("symbol-namespace",60043),symbolObject:o("symbol-object",60043),symbolMethod:o("symbol-method",60044),symbolFunction:o("symbol-function",60044),symbolConstructor:o("symbol-constructor",60044),symbolBoolean:o("symbol-boolean",60047),symbolNull:o("symbol-null",60047),symbolNumeric:o("symbol-numeric",60048),symbolNumber:o("symbol-number",60048),symbolStructure:o("symbol-structure",60049),symbolStruct:o("symbol-struct",60049),symbolParameter:o("symbol-parameter",60050),symbolTypeParameter:o("symbol-type-parameter",60050),symbolKey:o("symbol-key",60051),symbolText:o("symbol-text",60051),symbolReference:o("symbol-reference",60052),goToFile:o("go-to-file",60052),symbolEnum:o("symbol-enum",60053),symbolValue:o("symbol-value",60053),symbolRuler:o("symbol-ruler",60054),symbolUnit:o("symbol-unit",60054),activateBreakpoints:o("activate-breakpoints",60055),archive:o("archive",60056),arrowBoth:o("arrow-both",60057),arrowDown:o("arrow-down",60058),arrowLeft:o("arrow-left",60059),arrowRight:o("arrow-right",60060),arrowSmallDown:o("arrow-small-down",60061),arrowSmallLeft:o("arrow-small-left",60062),arrowSmallRight:o("arrow-small-right",60063),arrowSmallUp:o("arrow-small-up",60064),arrowUp:o("arrow-up",60065),bell:o("bell",60066),bold:o("bold",60067),book:o("book",60068),bookmark:o("bookmark",60069),debugBreakpointConditionalUnverified:o("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:o("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:o("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:o("debug-breakpoint-data-unverified",60072),debugBreakpointData:o("debug-breakpoint-data",60073),debugBreakpointDataDisabled:o("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:o("debug-breakpoint-log-unverified",60074),debugBreakpointLog:o("debug-breakpoint-log",60075),debugBreakpointLogDisabled:o("debug-breakpoint-log-disabled",60075),briefcase:o("briefcase",60076),broadcast:o("broadcast",60077),browser:o("browser",60078),bug:o("bug",60079),calendar:o("calendar",60080),caseSensitive:o("case-sensitive",60081),check:o("check",60082),checklist:o("checklist",60083),chevronDown:o("chevron-down",60084),dropDownButton:o("drop-down-button",60084),chevronLeft:o("chevron-left",60085),chevronRight:o("chevron-right",60086),chevronUp:o("chevron-up",60087),chromeClose:o("chrome-close",60088),chromeMaximize:o("chrome-maximize",60089),chromeMinimize:o("chrome-minimize",60090),chromeRestore:o("chrome-restore",60091),circle:o("circle",60092),circleOutline:o("circle-outline",60092),debugBreakpointUnverified:o("debug-breakpoint-unverified",60092),circleSlash:o("circle-slash",60093),circuitBoard:o("circuit-board",60094),clearAll:o("clear-all",60095),clippy:o("clippy",60096),closeAll:o("close-all",60097),cloudDownload:o("cloud-download",60098),cloudUpload:o("cloud-upload",60099),code:o("code",60100),collapseAll:o("collapse-all",60101),colorMode:o("color-mode",60102),commentDiscussion:o("comment-discussion",60103),compareChanges:o("compare-changes",60157),creditCard:o("credit-card",60105),dash:o("dash",60108),dashboard:o("dashboard",60109),database:o("database",60110),debugContinue:o("debug-continue",60111),debugDisconnect:o("debug-disconnect",60112),debugPause:o("debug-pause",60113),debugRestart:o("debug-restart",60114),debugStart:o("debug-start",60115),debugStepInto:o("debug-step-into",60116),debugStepOut:o("debug-step-out",60117),debugStepOver:o("debug-step-over",60118),debugStop:o("debug-stop",60119),debug:o("debug",60120),deviceCameraVideo:o("device-camera-video",60121),deviceCamera:o("device-camera",60122),deviceMobile:o("device-mobile",60123),diffAdded:o("diff-added",60124),diffIgnored:o("diff-ignored",60125),diffModified:o("diff-modified",60126),diffRemoved:o("diff-removed",60127),diffRenamed:o("diff-renamed",60128),diff:o("diff",60129),discard:o("discard",60130),editorLayout:o("editor-layout",60131),emptyWindow:o("empty-window",60132),exclude:o("exclude",60133),extensions:o("extensions",60134),eyeClosed:o("eye-closed",60135),fileBinary:o("file-binary",60136),fileCode:o("file-code",60137),fileMedia:o("file-media",60138),filePdf:o("file-pdf",60139),fileSubmodule:o("file-submodule",60140),fileSymlinkDirectory:o("file-symlink-directory",60141),fileSymlinkFile:o("file-symlink-file",60142),fileZip:o("file-zip",60143),files:o("files",60144),filter:o("filter",60145),flame:o("flame",60146),foldDown:o("fold-down",60147),foldUp:o("fold-up",60148),fold:o("fold",60149),folderActive:o("folder-active",60150),folderOpened:o("folder-opened",60151),gear:o("gear",60152),gift:o("gift",60153),gistSecret:o("gist-secret",60154),gist:o("gist",60155),gitCommit:o("git-commit",60156),gitCompare:o("git-compare",60157),gitMerge:o("git-merge",60158),githubAction:o("github-action",60159),githubAlt:o("github-alt",60160),globe:o("globe",60161),grabber:o("grabber",60162),graph:o("graph",60163),gripper:o("gripper",60164),heart:o("heart",60165),home:o("home",60166),horizontalRule:o("horizontal-rule",60167),hubot:o("hubot",60168),inbox:o("inbox",60169),issueClosed:o("issue-closed",60324),issueReopened:o("issue-reopened",60171),issues:o("issues",60172),italic:o("italic",60173),jersey:o("jersey",60174),json:o("json",60175),bracket:o("bracket",60175),kebabVertical:o("kebab-vertical",60176),key:o("key",60177),law:o("law",60178),lightbulbAutofix:o("lightbulb-autofix",60179),linkExternal:o("link-external",60180),link:o("link",60181),listOrdered:o("list-ordered",60182),listUnordered:o("list-unordered",60183),liveShare:o("live-share",60184),loading:o("loading",60185),location:o("location",60186),mailRead:o("mail-read",60187),mail:o("mail",60188),markdown:o("markdown",60189),megaphone:o("megaphone",60190),mention:o("mention",60191),milestone:o("milestone",60192),mortarBoard:o("mortar-board",60193),move:o("move",60194),multipleWindows:o("multiple-windows",60195),mute:o("mute",60196),noNewline:o("no-newline",60197),note:o("note",60198),octoface:o("octoface",60199),openPreview:o("open-preview",60200),package_:o("package",60201),paintcan:o("paintcan",60202),pin:o("pin",60203),play:o("play",60204),run:o("run",60204),plug:o("plug",60205),preserveCase:o("preserve-case",60206),preview:o("preview",60207),project:o("project",60208),pulse:o("pulse",60209),question:o("question",60210),quote:o("quote",60211),radioTower:o("radio-tower",60212),reactions:o("reactions",60213),references:o("references",60214),refresh:o("refresh",60215),regex:o("regex",60216),remoteExplorer:o("remote-explorer",60217),remote:o("remote",60218),remove:o("remove",60219),replaceAll:o("replace-all",60220),replace:o("replace",60221),repoClone:o("repo-clone",60222),repoForcePush:o("repo-force-push",60223),repoPull:o("repo-pull",60224),repoPush:o("repo-push",60225),report:o("report",60226),requestChanges:o("request-changes",60227),rocket:o("rocket",60228),rootFolderOpened:o("root-folder-opened",60229),rootFolder:o("root-folder",60230),rss:o("rss",60231),ruby:o("ruby",60232),saveAll:o("save-all",60233),saveAs:o("save-as",60234),save:o("save",60235),screenFull:o("screen-full",60236),screenNormal:o("screen-normal",60237),searchStop:o("search-stop",60238),server:o("server",60240),settingsGear:o("settings-gear",60241),settings:o("settings",60242),shield:o("shield",60243),smiley:o("smiley",60244),sortPrecedence:o("sort-precedence",60245),splitHorizontal:o("split-horizontal",60246),splitVertical:o("split-vertical",60247),squirrel:o("squirrel",60248),starFull:o("star-full",60249),starHalf:o("star-half",60250),symbolClass:o("symbol-class",60251),symbolColor:o("symbol-color",60252),symbolCustomColor:o("symbol-customcolor",60252),symbolConstant:o("symbol-constant",60253),symbolEnumMember:o("symbol-enum-member",60254),symbolField:o("symbol-field",60255),symbolFile:o("symbol-file",60256),symbolInterface:o("symbol-interface",60257),symbolKeyword:o("symbol-keyword",60258),symbolMisc:o("symbol-misc",60259),symbolOperator:o("symbol-operator",60260),symbolProperty:o("symbol-property",60261),wrench:o("wrench",60261),wrenchSubaction:o("wrench-subaction",60261),symbolSnippet:o("symbol-snippet",60262),tasklist:o("tasklist",60263),telescope:o("telescope",60264),textSize:o("text-size",60265),threeBars:o("three-bars",60266),thumbsdown:o("thumbsdown",60267),thumbsup:o("thumbsup",60268),tools:o("tools",60269),triangleDown:o("triangle-down",60270),triangleLeft:o("triangle-left",60271),triangleRight:o("triangle-right",60272),triangleUp:o("triangle-up",60273),twitter:o("twitter",60274),unfold:o("unfold",60275),unlock:o("unlock",60276),unmute:o("unmute",60277),unverified:o("unverified",60278),verified:o("verified",60279),versions:o("versions",60280),vmActive:o("vm-active",60281),vmOutline:o("vm-outline",60282),vmRunning:o("vm-running",60283),watch:o("watch",60284),whitespace:o("whitespace",60285),wholeWord:o("whole-word",60286),window:o("window",60287),wordWrap:o("word-wrap",60288),zoomIn:o("zoom-in",60289),zoomOut:o("zoom-out",60290),listFilter:o("list-filter",60291),listFlat:o("list-flat",60292),listSelection:o("list-selection",60293),selection:o("selection",60293),listTree:o("list-tree",60294),debugBreakpointFunctionUnverified:o("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:o("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:o("debug-breakpoint-function-disabled",60296),debugStackframeActive:o("debug-stackframe-active",60297),circleSmallFilled:o("circle-small-filled",60298),debugStackframeDot:o("debug-stackframe-dot",60298),debugStackframe:o("debug-stackframe",60299),debugStackframeFocused:o("debug-stackframe-focused",60299),debugBreakpointUnsupported:o("debug-breakpoint-unsupported",60300),symbolString:o("symbol-string",60301),debugReverseContinue:o("debug-reverse-continue",60302),debugStepBack:o("debug-step-back",60303),debugRestartFrame:o("debug-restart-frame",60304),callIncoming:o("call-incoming",60306),callOutgoing:o("call-outgoing",60307),menu:o("menu",60308),expandAll:o("expand-all",60309),feedback:o("feedback",60310),groupByRefType:o("group-by-ref-type",60311),ungroupByRefType:o("ungroup-by-ref-type",60312),account:o("account",60313),bellDot:o("bell-dot",60314),debugConsole:o("debug-console",60315),library:o("library",60316),output:o("output",60317),runAll:o("run-all",60318),syncIgnored:o("sync-ignored",60319),pinned:o("pinned",60320),githubInverted:o("github-inverted",60321),debugAlt:o("debug-alt",60305),serverProcess:o("server-process",60322),serverEnvironment:o("server-environment",60323),pass:o("pass",60324),stopCircle:o("stop-circle",60325),playCircle:o("play-circle",60326),record:o("record",60327),debugAltSmall:o("debug-alt-small",60328),vmConnect:o("vm-connect",60329),cloud:o("cloud",60330),merge:o("merge",60331),exportIcon:o("export",60332),graphLeft:o("graph-left",60333),magnet:o("magnet",60334),notebook:o("notebook",60335),redo:o("redo",60336),checkAll:o("check-all",60337),pinnedDirty:o("pinned-dirty",60338),passFilled:o("pass-filled",60339),circleLargeFilled:o("circle-large-filled",60340),circleLarge:o("circle-large",60341),circleLargeOutline:o("circle-large-outline",60341),combine:o("combine",60342),gather:o("gather",60342),table:o("table",60343),variableGroup:o("variable-group",60344),typeHierarchy:o("type-hierarchy",60345),typeHierarchySub:o("type-hierarchy-sub",60346),typeHierarchySuper:o("type-hierarchy-super",60347),gitPullRequestCreate:o("git-pull-request-create",60348),runAbove:o("run-above",60349),runBelow:o("run-below",60350),notebookTemplate:o("notebook-template",60351),debugRerun:o("debug-rerun",60352),workspaceTrusted:o("workspace-trusted",60353),workspaceUntrusted:o("workspace-untrusted",60354),workspaceUnspecified:o("workspace-unspecified",60355),terminalCmd:o("terminal-cmd",60356),terminalDebian:o("terminal-debian",60357),terminalLinux:o("terminal-linux",60358),terminalPowershell:o("terminal-powershell",60359),terminalTmux:o("terminal-tmux",60360),terminalUbuntu:o("terminal-ubuntu",60361),terminalBash:o("terminal-bash",60362),arrowSwap:o("arrow-swap",60363),copy:o("copy",60364),personAdd:o("person-add",60365),filterFilled:o("filter-filled",60366),wand:o("wand",60367),debugLineByLine:o("debug-line-by-line",60368),inspect:o("inspect",60369),layers:o("layers",60370),layersDot:o("layers-dot",60371),layersActive:o("layers-active",60372),compass:o("compass",60373),compassDot:o("compass-dot",60374),compassActive:o("compass-active",60375),azure:o("azure",60376),issueDraft:o("issue-draft",60377),gitPullRequestClosed:o("git-pull-request-closed",60378),gitPullRequestDraft:o("git-pull-request-draft",60379),debugAll:o("debug-all",60380),debugCoverage:o("debug-coverage",60381),runErrors:o("run-errors",60382),folderLibrary:o("folder-library",60383),debugContinueSmall:o("debug-continue-small",60384),beakerStop:o("beaker-stop",60385),graphLine:o("graph-line",60386),graphScatter:o("graph-scatter",60387),pieChart:o("pie-chart",60388),bracketDot:o("bracket-dot",60389),bracketError:o("bracket-error",60390),lockSmall:o("lock-small",60391),azureDevops:o("azure-devops",60392),verifiedFilled:o("verified-filled",60393),newLine:o("newline",60394),layout:o("layout",60395),layoutActivitybarLeft:o("layout-activitybar-left",60396),layoutActivitybarRight:o("layout-activitybar-right",60397),layoutPanelLeft:o("layout-panel-left",60398),layoutPanelCenter:o("layout-panel-center",60399),layoutPanelJustify:o("layout-panel-justify",60400),layoutPanelRight:o("layout-panel-right",60401),layoutPanel:o("layout-panel",60402),layoutSidebarLeft:o("layout-sidebar-left",60403),layoutSidebarRight:o("layout-sidebar-right",60404),layoutStatusbar:o("layout-statusbar",60405),layoutMenubar:o("layout-menubar",60406),layoutCentered:o("layout-centered",60407),layoutSidebarRightOff:o("layout-sidebar-right-off",60416),layoutPanelOff:o("layout-panel-off",60417),layoutSidebarLeftOff:o("layout-sidebar-left-off",60418),target:o("target",60408),indent:o("indent",60409),recordSmall:o("record-small",60410),errorSmall:o("error-small",60411),arrowCircleDown:o("arrow-circle-down",60412),arrowCircleLeft:o("arrow-circle-left",60413),arrowCircleRight:o("arrow-circle-right",60414),arrowCircleUp:o("arrow-circle-up",60415),heartFilled:o("heart-filled",60420),map:o("map",60421),mapFilled:o("map-filled",60422),circleSmall:o("circle-small",60423),bellSlash:o("bell-slash",60424),bellSlashDot:o("bell-slash-dot",60425),commentUnresolved:o("comment-unresolved",60426),gitPullRequestGoToChanges:o("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:o("git-pull-request-new-changes",60428),searchFuzzy:o("search-fuzzy",60429),commentDraft:o("comment-draft",60430),dialogError:o("dialog-error","error"),dialogWarning:o("dialog-warning","warning"),dialogInfo:o("dialog-info","info"),dialogClose:o("dialog-close","close"),treeItemExpanded:o("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:o("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:o("tree-filter-on-type-off","list-selection"),treeFilterClear:o("tree-filter-clear","close"),treeItemLoading:o("tree-item-loading","loading"),menuSelection:o("menu-selection","check"),menuSubmenu:o("menu-submenu","chevron-right"),menuBarMore:o("menubar-more","more"),scrollbarButtonLeft:o("scrollbar-button-left","triangle-left"),scrollbarButtonRight:o("scrollbar-button-right","triangle-right"),scrollbarButtonUp:o("scrollbar-button-up","triangle-up"),scrollbarButtonDown:o("scrollbar-button-down","triangle-down"),toolBarMore:o("toolbar-more","more"),quickInputBack:o("quick-input-back","arrow-left")}}),define(ee[37],te([0,1,11]),function(G,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const g=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([p,y])=>{g[p]=y&&typeof y=="object"?L(y):y}),g}e.deepClone=L;function o(u){if(!u||typeof u!="object")return u;const g=[u];for(;g.length>0;){const p=g.shift();Object.freeze(p);for(const y in p)if(A.call(p,y)){const D=p[y];typeof D=="object"&&!Object.isFrozen(D)&&!(0,P.isTypedArray)(D)&&g.push(D)}}return u}e.deepFreeze=o;const A=Object.prototype.hasOwnProperty;function M(u,g){return k(u,g,new Set)}e.cloneAndChange=M;function k(u,g,p){if((0,P.isUndefinedOrNull)(u))return u;const y=g(u);if(typeof y<"u")return y;if(Array.isArray(u)){const D=[];for(const t of u)D.push(k(t,g,p));return D}if((0,P.isObject)(u)){if(p.has(u))throw new Error("Cannot clone recursive data-structure");p.add(u);const D={};for(const t in u)A.call(u,t)&&(D[t]=k(u[t],g,p));return p.delete(u),D}return u}function f(u,g,p=!0){return(0,P.isObject)(u)?((0,P.isObject)(g)&&Object.keys(g).forEach(y=>{y in u?p&&((0,P.isObject)(u[y])&&(0,P.isObject)(g[y])?f(u[y],g[y],p):u[y]=g[y]):u[y]=g[y]}),u):g}e.mixin=f;function c(u,g){if(u===g)return!0;if(u==null||g===null||g===void 0||typeof u!=typeof g||typeof u!="object"||Array.isArray(u)!==Array.isArray(g))return!1;let p,y;if(Array.isArray(u)){if(u.length!==g.length)return!1;for(p=0;p<u.length;p++)if(!c(u[p],g[p]))return!1}else{const D=[];for(y in u)D.push(y);D.sort();const t=[];for(y in g)t.push(y);if(t.sort(),!c(D,t))return!1;for(p=0;p<D.length;p++)if(!c(u[D[p]],g[D[p]]))return!1}return!0}e.equals=c;function m(u){const g=new Set;return JSON.stringify(u,(p,y)=>{if((0,P.isObject)(y)||Array.isArray(y)){if(g.has(y))return"[Circular]";g.add(y)}return y})}e.safeStringify=m;function v(u,g){const p=Object.create(null);return!u||!g||Object.keys(g).forEach(D=>{const t=u[D],a=g[D];c(t,a)||(p[D]=a)}),p}e.distinct=v;function b(u,g){const p=g.toLowerCase(),y=Object.keys(u).find(D=>D.toLowerCase()===p);return y?u[y]:u[g]}e.getCaseInsensitive=b;function d(u,g){const p=Object.create(null);for(const[y,D]of Object.entries(u))g(y,D)&&(p[y]=D);return p}e.filter=d;function S(u){let g=[],p=Object.getPrototypeOf(u);for(;Object.prototype!==p;)g=g.concat(Object.getOwnPropertyNames(p)),p=Object.getPrototypeOf(p);return g}e.getAllPropertyNames=S;function w(u){const g=[];for(const p of S(u))typeof u[p]=="function"&&g.push(p);return g}e.getAllMethodNames=w;function r(u,g){const p=D=>function(){const t=Array.prototype.slice.call(arguments,0);return g(D,t)},y={};for(const D of u)y[D]=p(D);return y}e.createProxyObject=r}),define(ee[135],te([0,1,134]),function(G,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var L;(function(M){function k(f){return f&&typeof f=="object"&&typeof f.id=="string"}M.isThemeColor=k})(L=e.ThemeColor||(e.ThemeColor={}));function o(M){return{id:M}}e.themeColorFromId=o;var A;(function(M){M.iconNameSegment="[A-Za-z0-9]+",M.iconNameExpression="[A-Za-z0-9-]+",M.iconModifierExpression="~[A-Za-z]+",M.iconNameCharacter="[A-Za-z0-9~-]";const k=new RegExp(`^(${M.iconNameExpression})(${M.iconModifierExpression})?$`);function f(g){const p=k.exec(g.id);if(!p)return f(P.Codicon.error);const[,y,D]=p,t=["codicon","codicon-"+y];return D&&t.push("codicon-modifier-"+D.substring(1)),t}M.asClassNameArray=f;function c(g){return f(g).join(" ")}M.asClassName=c;function m(g){return"."+f(g).join(".")}M.asCSSSelector=m;function v(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(typeof g.color>"u"||L.isThemeColor(g.color))}M.isThemeIcon=v;const b=new RegExp(`^\\$\\((${M.iconNameExpression}(?:${M.iconModifierExpression})?)\\)$`);function d(g){const p=b.exec(g);if(!p)return;const[,y]=p;return{id:y}}M.fromString=d;function S(g){return{id:g}}M.fromId=S;function w(g,p){let y=g.id;const D=y.lastIndexOf("~");return D!==-1&&(y=y.substring(0,D)),p&&(y=`${y}~${p}`),{id:y}}M.modify=w;function r(g){const p=g.id.lastIndexOf("~");if(p!==-1)return g.id.substring(p+1)}M.getModifier=r;function u(g,p){return g.id===p.id&&g.color?.id===p.color?.id}M.isEqual=u})(A=e.ThemeIcon||(e.ThemeIcon={}))}),define(ee[31],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const P=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(o){return P.test(o)}e.isUUID=L,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let o;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?o=crypto.getRandomValues.bind(crypto):o=function(k){for(let f=0;f<k.length;f++)k[f]=Math.floor(Math.random()*256);return k};const A=new Uint8Array(16),M=[];for(let k=0;k<256;k++)M.push(k.toString(16).padStart(2,"0"));return function(){o(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let f=0,c="";return c+=M[A[f++]],c+=M[A[f++]],c+=M[A[f++]],c+=M[A[f++]],c+="-",c+=M[A[f++]],c+=M[A[f++]],c+="-",c+=M[A[f++]],c+=M[A[f++]],c+="-",c+=M[A[f++]],c+=M[A[f++]],c+="-",c+=M[A[f++]],c+=M[A[f++]],c+=M[A[f++]],c+=M[A[f++]],c+=M[A[f++]],c+=M[A[f++]],c}}()}),define(ee[136],te([0,1,72,41,50]),function(G,e,P,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function A(M,k){if(await new Promise((m,v)=>{const b=L.createReadStream(M),d=P.createHash("sha1");b.pipe(d);const S=(0,o.once)((w,r)=>{b.removeAllListeners(),d.removeAllListeners(),w?v(w):m(r)});b.once("error",S),b.once("end",S),d.once("error",S),d.once("data",w=>S(void 0,w.toString("hex")))})!==k)throw new Error("Hash mismatch")}e.checksum=A}),define(ee[137],te([0,1,25]),function(G,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function o(M){const k=M.replace(/\-/g,":").toLowerCase();return!L.has(k)}function A(){const M=(0,P.networkInterfaces)();for(const k in M){const f=M[k];if(f){for(const{mac:c}of f)if(o(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=A}),define(ee[100],te([0,1,73]),function(G,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function L(k,f,c,m=1){let v=!1;return new Promise(b=>{const d=setTimeout(()=>{if(!v)return v=!0,b(0)},c);o(k,f,m,S=>{if(!v)return v=!0,clearTimeout(d),b(S)})})}e.findFreePort=L;function o(k,f,c,m){if(f===0)return m(0);const v=new P.Socket;v.once("connect",()=>(M(v),o(k+c,f-1,c,m))),v.once("data",()=>{}),v.once("error",b=>(M(v),b.code!=="ECONNREFUSED"?o(k+c,f-1,c,m):m(k))),v.connect(k,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(k,f,c,m="127.0.0.1"){let v=!1,b,d=1;const S=P.createServer({pauseOnConnect:!0});function w(r,u){v||(v=!0,S.removeAllListeners(),S.close(),b&&clearTimeout(b),u(r))}return new Promise(r=>{b=setTimeout(()=>{w(0,r)},c),S.on("listening",()=>{w(k,r)}),S.on("error",u=>{u&&(u.code==="EADDRINUSE"||u.code==="EACCES")&&d<f?(k++,d++,S.listen(k,m)):w(0,r)}),S.on("close",()=>{w(0,r)}),S.listen(k,m)})}e.findFreePortFaster=A;function M(k){try{k.removeAllListeners("connect"),k.removeAllListeners("error"),k.end(),k.destroy(),k.unref()}catch(f){console.error(f)}}}),define(ee[138],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(ee[139],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class P{constructor(o,A){this.a=o,this.onMessage=A}send(o){try{this.a.send("vscode:message",o.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.Protocol=P}),define(ee[42],te([0,1,15,13]),function(G,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class o{constructor(){this.a=new WeakMap}on(M,k){const f=(c,...m)=>{this.b(M,c)&&k(c,...m)};return this.a.set(k,f),P.ipcMain.on(M,f),this}once(M,k){return P.ipcMain.once(M,(f,...c)=>{this.b(M,f)&&k(f,...c)}),this}handle(M,k){return P.ipcMain.handle(M,(f,...c)=>this.b(M,f)?k(f,...c):Promise.reject(`Invalid channel '${M}' or sender for ipcMain.handle() usage.`)),this}removeHandler(M){return P.ipcMain.removeHandler(M),this}removeListener(M,k){const f=this.a.get(k);return f&&(P.ipcMain.removeListener(M,f),this.a.delete(k)),this}b(M,k){if(!M||!M.startsWith("vscode:"))return(0,L.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because the channel is unknown.`),!1;const f=k.senderFrame,c=f.url;if(!c)return!0;let m="unknown";try{m=new URL(c).host}catch{return(0,L.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because of a malformed URL '${c}'.`),!1}return m!=="vscode-app"?((0,L.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because of a bad origin of '${m}'.`),!1):f.parent!==null?((0,L.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because sender of origin '${m}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new o}),define(ee[140],te([0,1,15,42,11,138]),function(G,e,P,L,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function M(){L.validatedIpcMain.on(A.CONTEXT_MENU_CHANNEL,(f,c,m,v,b)=>{const d=k(f,v,m);d.popup({window:(0,o.withNullAsUndefined)(P.BrowserWindow.fromWebContents(f.sender)),x:b?b.x:void 0,y:b?b.y:void 0,positioningItem:b?b.positioningItem:void 0,callback:()=>{d&&f.sender.send(A.CONTEXT_MENU_CLOSE_CHANNEL,c)}})})}e.registerContextMenuListener=M;function k(f,c,m){const v=new P.Menu;return m.forEach(b=>{let d;b.type==="separator"?d=new P.MenuItem({type:b.type}):Array.isArray(b.submenu)?d=new P.MenuItem({submenu:k(f,c,b.submenu),label:b.label}):d=new P.MenuItem({label:b.label,type:b.type,accelerator:b.accelerator,checked:b.checked,enabled:b.enabled,visible:b.visible,click:(S,w,r)=>f.sender.send(c,b.id,r)}),v.append(d)}),v}}),define(ee[141],te([12,10]),function(G,e){return G.create("vs/base/common/date",e)}),define(ee[142],te([0,1,141]),function(G,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,o=L*60,A=o*24,M=A*7,k=A*30,f=A*365;function c(v,b,d,S){typeof v!="number"&&(v=v.getTime());const w=Math.round((new Date().getTime()-v)/1e3);if(w<-30)return(0,P.localize)(0,null,c(new Date().getTime()+w*1e3,!1));if(!S&&w<30)return(0,P.localize)(1,null);let r;return w<L?(r=w,b?r===1?d?(0,P.localize)(2,null,r):(0,P.localize)(3,null,r):d?(0,P.localize)(4,null,r):(0,P.localize)(5,null,r):r===1?d?(0,P.localize)(6,null,r):(0,P.localize)(7,null,r):d?(0,P.localize)(8,null,r):(0,P.localize)(9,null,r)):w<o?(r=Math.floor(w/L),b?r===1?d?(0,P.localize)(10,null,r):(0,P.localize)(11,null,r):d?(0,P.localize)(12,null,r):(0,P.localize)(13,null,r):r===1?d?(0,P.localize)(14,null,r):(0,P.localize)(15,null,r):d?(0,P.localize)(16,null,r):(0,P.localize)(17,null,r)):w<A?(r=Math.floor(w/o),b?r===1?d?(0,P.localize)(18,null,r):(0,P.localize)(19,null,r):d?(0,P.localize)(20,null,r):(0,P.localize)(21,null,r):r===1?d?(0,P.localize)(22,null,r):(0,P.localize)(23,null,r):d?(0,P.localize)(24,null,r):(0,P.localize)(25,null,r)):w<M?(r=Math.floor(w/A),b?r===1?(0,P.localize)(26,null,r):(0,P.localize)(27,null,r):r===1?(0,P.localize)(28,null,r):(0,P.localize)(29,null,r)):w<k?(r=Math.floor(w/M),b?r===1?d?(0,P.localize)(30,null,r):(0,P.localize)(31,null,r):d?(0,P.localize)(32,null,r):(0,P.localize)(33,null,r):r===1?d?(0,P.localize)(34,null,r):(0,P.localize)(35,null,r):d?(0,P.localize)(36,null,r):(0,P.localize)(37,null,r)):w<f?(r=Math.floor(w/k),b?r===1?d?(0,P.localize)(38,null,r):(0,P.localize)(39,null,r):d?(0,P.localize)(40,null,r):(0,P.localize)(41,null,r):r===1?d?(0,P.localize)(42,null,r):(0,P.localize)(43,null,r):d?(0,P.localize)(44,null,r):(0,P.localize)(45,null,r)):(r=Math.floor(w/f),b?r===1?d?(0,P.localize)(46,null,r):(0,P.localize)(47,null,r):d?(0,P.localize)(48,null,r):(0,P.localize)(49,null,r):r===1?d?(0,P.localize)(50,null,r):(0,P.localize)(51,null,r):d?(0,P.localize)(52,null,r):(0,P.localize)(53,null,r))}e.fromNow=c;function m(v){return v.getFullYear()+"-"+String(v.getMonth()+1).padStart(2,"0")+"-"+String(v.getDate()).padStart(2,"0")+"T"+String(v.getHours()).padStart(2,"0")+":"+String(v.getMinutes()).padStart(2,"0")+":"+String(v.getSeconds()).padStart(2,"0")+"."+(v.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=m}),define(ee[143],te([12,10]),function(G,e){return G.create("vs/base/common/errorMessage",e)}),define(ee[44],te([0,1,27,11,143]),function(G,e,P,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function A(v,b){return b&&(v.stack||v.stacktrace)?o.localize(0,null,k(v),M(v.stack)||M(v.stacktrace)):k(v)}function M(v){return Array.isArray(v)?v.join(`
`):v}function k(v){return typeof v.code=="string"&&typeof v.errno=="number"&&typeof v.syscall=="string"?o.localize(1,null,v.message):v.message||o.localize(2,null)}function f(v=null,b=!1){if(!v)return o.localize(3,null);if(Array.isArray(v)){const d=P.coalesce(v),S=f(d[0],b);return d.length>1?o.localize(4,null,S,d.length):S}if(L.isString(v))return v;if(v.detail){const d=v.detail;if(d.error)return A(d.error,b);if(d.exception)return A(d.exception,b)}return v.stack?A(v,b):v.message?v.message:o.localize(5,null)}e.toErrorMessage=f;function c(v){const b=v;return b instanceof Error&&Array.isArray(b.actions)}e.isErrorWithActions=c;function m(v,b){let d;return typeof v=="string"?d=new Error(v):d=v,d.actions=b,d}e.createErrorWithActions=m}),define(ee[144],te([12,10]),function(G,e){return G.create("vs/base/common/jsonErrorMessages",e)}),define(ee[145],te([0,1,144]),function(G,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function L(o){switch(o){case 1:return(0,P.localize)(0,null);case 2:return(0,P.localize)(1,null);case 3:return(0,P.localize)(2,null);case 4:return(0,P.localize)(3,null);case 5:return(0,P.localize)(4,null);case 6:return(0,P.localize)(5,null);case 7:return(0,P.localize)(6,null);case 8:return(0,P.localize)(7,null);case 9:return(0,P.localize)(8,null);default:return""}}e.getParseErrorMessage=L}),define(ee[146],te([12,10]),function(G,e){return G.create("vs/base/common/platform",e)}),define(ee[4],te([0,1,146]),function(G,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let L=!1,o=!1,A=!1,M=!1,k=!1,f=!1,c=!1,m=!1,v=!1,b=!1,d,S=e.LANGUAGE_DEFAULT,w,r;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?u=e.globals.vscode.process:typeof process<"u"&&(u=process);const g=typeof u?.versions?.electron=="string",p=g&&u?.type==="renderer";if(typeof navigator=="object"&&!p)r=navigator.userAgent,L=r.indexOf("Windows")>=0,o=r.indexOf("Macintosh")>=0,m=(r.indexOf("Macintosh")>=0||r.indexOf("iPad")>=0||r.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=r.indexOf("Linux")>=0,b=r?.indexOf("Mobi")>=0,f=!0,d=P.getConfiguredDefaultLocale(P.localize(0,null))||e.LANGUAGE_DEFAULT,S=d;else if(typeof u=="object"){L=u.platform==="win32",o=u.platform==="darwin",A=u.platform==="linux",M=A&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,c=g,v=!!u.env.CI||!!u.env.BUILD_ARTIFACTSTAGINGDIRECTORY,d=e.LANGUAGE_DEFAULT,S=e.LANGUAGE_DEFAULT;const l=u.env.VSCODE_NLS_CONFIG;if(l)try{const E=JSON.parse(l),R=E.availableLanguages["*"];d=E.locale,S=R||e.LANGUAGE_DEFAULT,w=E._translationsConfigFile}catch{}k=!0}else console.error("Unable to resolve platform.");var y;(function(l){l[l.Web=0]="Web",l[l.Mac=1]="Mac",l[l.Linux=2]="Linux",l[l.Windows=3]="Windows"})(y=e.Platform||(e.Platform={}));function D(l){switch(l){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=D;let t=0;o?t=1:L?t=3:A&&(t=2),e.isWindows=L,e.isMacintosh=o,e.isLinux=A,e.isLinuxSnap=M,e.isNative=k,e.isElectron=c,e.isWeb=f,e.isWebWorker=f&&typeof e.globals.importScripts=="function",e.isIOS=m,e.isMobile=b,e.isCI=v,e.platform=t,e.userAgent=r,e.language=S;var a;(function(l){function E(){return e.language}l.value=E;function R(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}l.isDefaultVariant=R;function C(){return e.language==="en"}l.isDefault=C})(a=e.Language||(e.Language={})),e.locale=d,e.translationsConfigFile=w,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const l=[];e.globals.addEventListener("message",R=>{if(R.data&&R.data.vscodeScheduleAsyncWork)for(let C=0,T=l.length;C<T;C++){const N=l[C];if(N.id===R.data.vscodeScheduleAsyncWork){l.splice(C,1),N.callback();return}}});let E=0;return R=>{const C=++E;l.push({id:C,callback:R}),e.globals.postMessage({vscodeScheduleAsyncWork:C},"*")}}return l=>setTimeout(l)})();var i;(function(l){l[l.Windows=1]="Windows",l[l.Macintosh=2]="Macintosh",l[l.Linux=3]="Linux"})(i=e.OperatingSystem||(e.OperatingSystem={})),e.OS=o||m?2:L?1:3;let s=!0,n=!1;function h(){if(!n){n=!0;const l=new Uint8Array(2);l[0]=1,l[1]=2,s=new Uint16Array(l.buffer)[0]===(2<<8)+1}return s}e.isLittleEndian=h,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ee[36],te([0,1,4]),function(G,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let L;if(typeof P.globals.vscode<"u"&&typeof P.globals.vscode.process<"u"){const o=P.globals.vscode.process;L={get platform(){return o.platform},get arch(){return o.arch},get env(){return o.env},cwd(){return o.cwd()}}}else typeof process<"u"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:L={get platform(){return P.isWindows?"win32":P.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.arch=L.arch}),define(ee[9],te([0,1,36]),function(G,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,o=97,A=90,M=122,k=46,f=47,c=92,m=58,v=63;class b extends Error{constructor(a,i,s){let n;typeof i=="string"&&i.indexOf("not ")===0?(n="must not be",i=i.replace(/^not /,"")):n="must be";const h=a.indexOf(".")!==-1?"property":"argument";let l=`The "${a}" ${h} ${n} of type ${i}`;l+=`. Received type ${typeof s}`,super(l),this.code="ERR_INVALID_ARG_TYPE"}}function d(t,a){if(t===null||typeof t!="object")throw new b(a,"Object",t)}function S(t,a){if(typeof t!="string")throw new b(a,"string",t)}const w=P.platform==="win32";function r(t){return t===f||t===c}function u(t){return t===f}function g(t){return t>=L&&t<=A||t>=o&&t<=M}function p(t,a,i,s){let n="",h=0,l=-1,E=0,R=0;for(let C=0;C<=t.length;++C){if(C<t.length)R=t.charCodeAt(C);else{if(s(R))break;R=f}if(s(R)){if(!(l===C-1||E===1))if(E===2){if(n.length<2||h!==2||n.charCodeAt(n.length-1)!==k||n.charCodeAt(n.length-2)!==k){if(n.length>2){const T=n.lastIndexOf(i);T===-1?(n="",h=0):(n=n.slice(0,T),h=n.length-1-n.lastIndexOf(i)),l=C,E=0;continue}else if(n.length!==0){n="",h=0,l=C,E=0;continue}}a&&(n+=n.length>0?`${i}..`:"..",h=2)}else n.length>0?n+=`${i}${t.slice(l+1,C)}`:n=t.slice(l+1,C),h=C-l-1;l=C,E=0}else R===k&&E!==-1?++E:E=-1}return n}function y(t,a){d(a,"pathObject");const i=a.dir||a.root,s=a.base||`${a.name||""}${a.ext||""}`;return i?i===a.root?`${i}${s}`:`${i}${t}${s}`:s}e.win32={resolve(...t){let a="",i="",s=!1;for(let n=t.length-1;n>=-1;n--){let h;if(n>=0){if(h=t[n],S(h,"path"),h.length===0)continue}else a.length===0?h=P.cwd():(h=P.env[`=${a}`]||P.cwd(),(h===void 0||h.slice(0,2).toLowerCase()!==a.toLowerCase()&&h.charCodeAt(2)===c)&&(h=`${a}\\`));const l=h.length;let E=0,R="",C=!1;const T=h.charCodeAt(0);if(l===1)r(T)&&(E=1,C=!0);else if(r(T))if(C=!0,r(h.charCodeAt(1))){let N=2,z=N;for(;N<l&&!r(h.charCodeAt(N));)N++;if(N<l&&N!==z){const B=h.slice(z,N);for(z=N;N<l&&r(h.charCodeAt(N));)N++;if(N<l&&N!==z){for(z=N;N<l&&!r(h.charCodeAt(N));)N++;(N===l||N!==z)&&(R=`\\\\${B}\\${h.slice(z,N)}`,E=N)}}}else E=1;else g(T)&&h.charCodeAt(1)===m&&(R=h.slice(0,2),E=2,l>2&&r(h.charCodeAt(2))&&(C=!0,E=3));if(R.length>0)if(a.length>0){if(R.toLowerCase()!==a.toLowerCase())continue}else a=R;if(s){if(a.length>0)break}else if(i=`${h.slice(E)}\\${i}`,s=C,C&&a.length>0)break}return i=p(i,!s,"\\",r),s?`${a}\\${i}`:`${a}${i}`||"."},normalize(t){S(t,"path");const a=t.length;if(a===0)return".";let i=0,s,n=!1;const h=t.charCodeAt(0);if(a===1)return u(h)?"\\":t;if(r(h))if(n=!0,r(t.charCodeAt(1))){let E=2,R=E;for(;E<a&&!r(t.charCodeAt(E));)E++;if(E<a&&E!==R){const C=t.slice(R,E);for(R=E;E<a&&r(t.charCodeAt(E));)E++;if(E<a&&E!==R){for(R=E;E<a&&!r(t.charCodeAt(E));)E++;if(E===a)return`\\\\${C}\\${t.slice(R)}\\`;E!==R&&(s=`\\\\${C}\\${t.slice(R,E)}`,i=E)}}}else i=1;else g(h)&&t.charCodeAt(1)===m&&(s=t.slice(0,2),i=2,a>2&&r(t.charCodeAt(2))&&(n=!0,i=3));let l=i<a?p(t.slice(i),!n,"\\",r):"";return l.length===0&&!n&&(l="."),l.length>0&&r(t.charCodeAt(a-1))&&(l+="\\"),s===void 0?n?`\\${l}`:l:n?`${s}\\${l}`:`${s}${l}`},isAbsolute(t){S(t,"path");const a=t.length;if(a===0)return!1;const i=t.charCodeAt(0);return r(i)||a>2&&g(i)&&t.charCodeAt(1)===m&&r(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let a,i;for(let h=0;h<t.length;++h){const l=t[h];S(l,"path"),l.length>0&&(a===void 0?a=i=l:a+=`\\${l}`)}if(a===void 0)return".";let s=!0,n=0;if(typeof i=="string"&&r(i.charCodeAt(0))){++n;const h=i.length;h>1&&r(i.charCodeAt(1))&&(++n,h>2&&(r(i.charCodeAt(2))?++n:s=!1))}if(s){for(;n<a.length&&r(a.charCodeAt(n));)n++;n>=2&&(a=`\\${a.slice(n)}`)}return e.win32.normalize(a)},relative(t,a){if(S(t,"from"),S(a,"to"),t===a)return"";const i=e.win32.resolve(t),s=e.win32.resolve(a);if(i===s||(t=i.toLowerCase(),a=s.toLowerCase(),t===a))return"";let n=0;for(;n<t.length&&t.charCodeAt(n)===c;)n++;let h=t.length;for(;h-1>n&&t.charCodeAt(h-1)===c;)h--;const l=h-n;let E=0;for(;E<a.length&&a.charCodeAt(E)===c;)E++;let R=a.length;for(;R-1>E&&a.charCodeAt(R-1)===c;)R--;const C=R-E,T=l<C?l:C;let N=-1,z=0;for(;z<T;z++){const _=t.charCodeAt(n+z);if(_!==a.charCodeAt(E+z))break;_===c&&(N=z)}if(z!==T){if(N===-1)return s}else{if(C>T){if(a.charCodeAt(E+z)===c)return s.slice(E+z+1);if(z===2)return s.slice(E+z)}l>T&&(t.charCodeAt(n+z)===c?N=z:z===2&&(N=3)),N===-1&&(N=0)}let B="";for(z=n+N+1;z<=h;++z)(z===h||t.charCodeAt(z)===c)&&(B+=B.length===0?"..":"\\..");return E+=N,B.length>0?`${B}${s.slice(E,R)}`:(s.charCodeAt(E)===c&&++E,s.slice(E,R))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const a=e.win32.resolve(t);if(a.length<=2)return t;if(a.charCodeAt(0)===c){if(a.charCodeAt(1)===c){const i=a.charCodeAt(2);if(i!==v&&i!==k)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(g(a.charCodeAt(0))&&a.charCodeAt(1)===m&&a.charCodeAt(2)===c)return`\\\\?\\${a}`;return t},dirname(t){S(t,"path");const a=t.length;if(a===0)return".";let i=-1,s=0;const n=t.charCodeAt(0);if(a===1)return r(n)?t:".";if(r(n)){if(i=s=1,r(t.charCodeAt(1))){let E=2,R=E;for(;E<a&&!r(t.charCodeAt(E));)E++;if(E<a&&E!==R){for(R=E;E<a&&r(t.charCodeAt(E));)E++;if(E<a&&E!==R){for(R=E;E<a&&!r(t.charCodeAt(E));)E++;if(E===a)return t;E!==R&&(i=s=E+1)}}}}else g(n)&&t.charCodeAt(1)===m&&(i=a>2&&r(t.charCodeAt(2))?3:2,s=i);let h=-1,l=!0;for(let E=a-1;E>=s;--E)if(r(t.charCodeAt(E))){if(!l){h=E;break}}else l=!1;if(h===-1){if(i===-1)return".";h=i}return t.slice(0,h)},basename(t,a){a!==void 0&&S(a,"ext"),S(t,"path");let i=0,s=-1,n=!0,h;if(t.length>=2&&g(t.charCodeAt(0))&&t.charCodeAt(1)===m&&(i=2),a!==void 0&&a.length>0&&a.length<=t.length){if(a===t)return"";let l=a.length-1,E=-1;for(h=t.length-1;h>=i;--h){const R=t.charCodeAt(h);if(r(R)){if(!n){i=h+1;break}}else E===-1&&(n=!1,E=h+1),l>=0&&(R===a.charCodeAt(l)?--l===-1&&(s=h):(l=-1,s=E))}return i===s?s=E:s===-1&&(s=t.length),t.slice(i,s)}for(h=t.length-1;h>=i;--h)if(r(t.charCodeAt(h))){if(!n){i=h+1;break}}else s===-1&&(n=!1,s=h+1);return s===-1?"":t.slice(i,s)},extname(t){S(t,"path");let a=0,i=-1,s=0,n=-1,h=!0,l=0;t.length>=2&&t.charCodeAt(1)===m&&g(t.charCodeAt(0))&&(a=s=2);for(let E=t.length-1;E>=a;--E){const R=t.charCodeAt(E);if(r(R)){if(!h){s=E+1;break}continue}n===-1&&(h=!1,n=E+1),R===k?i===-1?i=E:l!==1&&(l=1):i!==-1&&(l=-1)}return i===-1||n===-1||l===0||l===1&&i===n-1&&i===s+1?"":t.slice(i,n)},format:y.bind(null,"\\"),parse(t){S(t,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return a;const i=t.length;let s=0,n=t.charCodeAt(0);if(i===1)return r(n)?(a.root=a.dir=t,a):(a.base=a.name=t,a);if(r(n)){if(s=1,r(t.charCodeAt(1))){let N=2,z=N;for(;N<i&&!r(t.charCodeAt(N));)N++;if(N<i&&N!==z){for(z=N;N<i&&r(t.charCodeAt(N));)N++;if(N<i&&N!==z){for(z=N;N<i&&!r(t.charCodeAt(N));)N++;N===i?s=N:N!==z&&(s=N+1)}}}}else if(g(n)&&t.charCodeAt(1)===m){if(i<=2)return a.root=a.dir=t,a;if(s=2,r(t.charCodeAt(2))){if(i===3)return a.root=a.dir=t,a;s=3}}s>0&&(a.root=t.slice(0,s));let h=-1,l=s,E=-1,R=!0,C=t.length-1,T=0;for(;C>=s;--C){if(n=t.charCodeAt(C),r(n)){if(!R){l=C+1;break}continue}E===-1&&(R=!1,E=C+1),n===k?h===-1?h=C:T!==1&&(T=1):h!==-1&&(T=-1)}return E!==-1&&(h===-1||T===0||T===1&&h===E-1&&h===l+1?a.base=a.name=t.slice(l,E):(a.name=t.slice(l,h),a.base=t.slice(l,E),a.ext=t.slice(h,E))),l>0&&l!==s?a.dir=t.slice(0,l-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null};const D=(()=>{if(w){const t=/\\/g;return()=>{const a=P.cwd().replace(t,"/");return a.slice(a.indexOf("/"))}}return()=>P.cwd()})();e.posix={resolve(...t){let a="",i=!1;for(let s=t.length-1;s>=-1&&!i;s--){const n=s>=0?t[s]:D();S(n,"path"),n.length!==0&&(a=`${n}/${a}`,i=n.charCodeAt(0)===f)}return a=p(a,!i,"/",u),i?`/${a}`:a.length>0?a:"."},normalize(t){if(S(t,"path"),t.length===0)return".";const a=t.charCodeAt(0)===f,i=t.charCodeAt(t.length-1)===f;return t=p(t,!a,"/",u),t.length===0?a?"/":i?"./":".":(i&&(t+="/"),a?`/${t}`:t)},isAbsolute(t){return S(t,"path"),t.length>0&&t.charCodeAt(0)===f},join(...t){if(t.length===0)return".";let a;for(let i=0;i<t.length;++i){const s=t[i];S(s,"path"),s.length>0&&(a===void 0?a=s:a+=`/${s}`)}return a===void 0?".":e.posix.normalize(a)},relative(t,a){if(S(t,"from"),S(a,"to"),t===a||(t=e.posix.resolve(t),a=e.posix.resolve(a),t===a))return"";const i=1,s=t.length,n=s-i,h=1,l=a.length-h,E=n<l?n:l;let R=-1,C=0;for(;C<E;C++){const N=t.charCodeAt(i+C);if(N!==a.charCodeAt(h+C))break;N===f&&(R=C)}if(C===E)if(l>E){if(a.charCodeAt(h+C)===f)return a.slice(h+C+1);if(C===0)return a.slice(h+C)}else n>E&&(t.charCodeAt(i+C)===f?R=C:C===0&&(R=0));let T="";for(C=i+R+1;C<=s;++C)(C===s||t.charCodeAt(C)===f)&&(T+=T.length===0?"..":"/..");return`${T}${a.slice(h+R)}`},toNamespacedPath(t){return t},dirname(t){if(S(t,"path"),t.length===0)return".";const a=t.charCodeAt(0)===f;let i=-1,s=!0;for(let n=t.length-1;n>=1;--n)if(t.charCodeAt(n)===f){if(!s){i=n;break}}else s=!1;return i===-1?a?"/":".":a&&i===1?"//":t.slice(0,i)},basename(t,a){a!==void 0&&S(a,"ext"),S(t,"path");let i=0,s=-1,n=!0,h;if(a!==void 0&&a.length>0&&a.length<=t.length){if(a===t)return"";let l=a.length-1,E=-1;for(h=t.length-1;h>=0;--h){const R=t.charCodeAt(h);if(R===f){if(!n){i=h+1;break}}else E===-1&&(n=!1,E=h+1),l>=0&&(R===a.charCodeAt(l)?--l===-1&&(s=h):(l=-1,s=E))}return i===s?s=E:s===-1&&(s=t.length),t.slice(i,s)}for(h=t.length-1;h>=0;--h)if(t.charCodeAt(h)===f){if(!n){i=h+1;break}}else s===-1&&(n=!1,s=h+1);return s===-1?"":t.slice(i,s)},extname(t){S(t,"path");let a=-1,i=0,s=-1,n=!0,h=0;for(let l=t.length-1;l>=0;--l){const E=t.charCodeAt(l);if(E===f){if(!n){i=l+1;break}continue}s===-1&&(n=!1,s=l+1),E===k?a===-1?a=l:h!==1&&(h=1):a!==-1&&(h=-1)}return a===-1||s===-1||h===0||h===1&&a===s-1&&a===i+1?"":t.slice(a,s)},format:y.bind(null,"/"),parse(t){S(t,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return a;const i=t.charCodeAt(0)===f;let s;i?(a.root="/",s=1):s=0;let n=-1,h=0,l=-1,E=!0,R=t.length-1,C=0;for(;R>=s;--R){const T=t.charCodeAt(R);if(T===f){if(!E){h=R+1;break}continue}l===-1&&(E=!1,l=R+1),T===k?n===-1?n=R:C!==1&&(C=1):n!==-1&&(C=-1)}if(l!==-1){const T=h===0&&i?1:h;n===-1||C===0||C===1&&n===l-1&&n===h+1?a.base=a.name=t.slice(T,l):(a.name=t.slice(T,n),a.base=t.slice(T,l),a.ext=t.slice(n,l))}return h>0?a.dir=t.slice(0,h-1):i&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=w?e.win32.normalize:e.posix.normalize,e.isAbsolute=w?e.win32.isAbsolute:e.posix.isAbsolute,e.join=w?e.win32.join:e.posix.join,e.resolve=w?e.win32.resolve:e.posix.resolve,e.relative=w?e.win32.relative:e.posix.relative,e.dirname=w?e.win32.dirname:e.posix.dirname,e.basename=w?e.win32.basename:e.posix.basename,e.extname=w?e.win32.extname:e.posix.extname,e.format=w?e.win32.format:e.posix.format,e.parse=w?e.win32.parse:e.posix.parse,e.toNamespacedPath=w?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=w?e.win32.sep:e.posix.sep,e.delimiter=w?e.win32.delimiter:e.posix.delimiter}),define(ee[74],te([0,1,4]),function(G,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var L;(function(k){k[k.stdout=0]="stdout",k[k.stderr=1]="stderr"})(L=e.Source||(e.Source={}));var o;(function(k){k[k.Success=0]="Success",k[k.Unknown=1]="Unknown",k[k.AccessDenied=2]="AccessDenied",k[k.ProcessNotFound=3]="ProcessNotFound"})(o=e.TerminateResponseCode||(e.TerminateResponseCode={}));function A(k,...f){const c=f.reduce((b,d)=>(b[d]=!0,b),{}),m=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(k).filter(b=>!c[b]).forEach(b=>{for(let d=0;d<m.length;d++)if(b.search(m[d])!==-1){delete k[b];break}})}e.sanitizeProcessEnvironment=A;function M(k){!k||(delete k.DEBUG,P.isMacintosh&&delete k.DYLD_LIBRARY_PATH,P.isLinux&&delete k.LD_PRELOAD)}e.removeDangerousEnvVariables=M}),define(ee[75],te([0,1,4]),function(G,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=P.globals.performance&&typeof P.globals.performance.now=="function";class o{static create(M=!0){return new o(M)}constructor(M){this.a=L&&M,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?P.globals.performance.now():Date.now()}}e.StopWatch=o}),define(ee[3],te([0,1,13,50,2,99,75]),function(G,e,P,L,o,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const k=!1,f=!1;var c;(function(h){h.None=()=>o.Disposable.None;function l(U){if(f){const{onDidAddListener:j}=U,x=S.create();let $=0;U.onDidAddListener=()=>{++$===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),x.print()),j?.()}}}function E(U,j){return ae(U,()=>{},0,void 0,!0,void 0,j)}h.defer=E;function R(U){return(j,x=null,$)=>{let V=!1,K;return K=U(oe=>{if(!V)return K?K.dispose():V=!0,j.call(x,oe)},null,$),V&&K.dispose(),K}}h.once=R;function C(U,j,x){return ne(($,V=null,K)=>U(oe=>$.call(V,j(oe)),null,K),x)}h.map=C;function T(U,j,x){return ne(($,V=null,K)=>U(oe=>{j(oe),$.call(V,oe)},null,K),x)}h.forEach=T;function N(U,j,x){return ne(($,V=null,K)=>U(oe=>j(oe)&&$.call(V,oe),null,K),x)}h.filter=N;function z(U){return U}h.signal=z;function B(...U){return(j,x=null,$)=>(0,o.combinedDisposable)(...U.map(V=>V(K=>j.call(x,K),null,$)))}h.any=B;function _(U,j,x,$){let V=x;return C(U,K=>(V=j(V,K),V),$)}h.reduce=_;function ne(U,j){let x;const $={onWillAddFirstListener(){x=U(V.fire,V)},onDidRemoveLastListener(){x?.dispose()}};j||l($);const V=new r($);return j?.add(V),V.event}function ae(U,j,x=100,$=!1,V=!1,K,oe){let fe,Ce,Ee,Re=0,Oe;const ze={leakWarningThreshold:K,onWillAddFirstListener(){fe=U(pe=>{Re++,Ce=j(Ce,pe),$&&!Ee&&(ge.fire(Ce),Ce=void 0),Oe=()=>{const Le=Ce;Ce=void 0,Ee=void 0,(!$||Re>1)&&ge.fire(Le),Re=0},typeof x=="number"?(clearTimeout(Ee),Ee=setTimeout(Oe,x)):Ee===void 0&&(Ee=0,queueMicrotask(Oe))})},onWillRemoveListener(){V&&Re>0&&Oe?.()},onDidRemoveLastListener(){Oe=void 0,fe.dispose()}};oe||l(ze);const ge=new r(ze);return oe?.add(ge),ge.event}h.debounce=ae;function he(U,j=0,x){return h.debounce(U,($,V)=>$?($.push(V),$):[V],j,void 0,!0,void 0,x)}h.accumulate=he;function ce(U,j=($,V)=>$===V,x){let $=!0,V;return N(U,K=>{const oe=$||!j(K,V);return $=!1,V=K,oe},x)}h.latch=ce;function J(U,j,x){return[h.filter(U,j,x),h.filter(U,$=>!j($),x)]}h.split=J;function Y(U,j=!1,x=[]){let $=x.slice(),V=U(fe=>{$?$.push(fe):oe.fire(fe)});const K=()=>{$?.forEach(fe=>oe.fire(fe)),$=null},oe=new r({onWillAddFirstListener(){V||(V=U(fe=>oe.fire(fe)))},onDidAddFirstListener(){$&&(j?setTimeout(K):K())},onDidRemoveLastListener(){V&&V.dispose(),V=null}});return oe.event}h.buffer=Y;class q{constructor(j){this.event=j,this.c=new o.DisposableStore}map(j){return new q(C(this.event,j,this.c))}forEach(j){return new q(T(this.event,j,this.c))}filter(j){return new q(N(this.event,j,this.c))}reduce(j,x){return new q(_(this.event,j,x,this.c))}latch(){return new q(ce(this.event,void 0,this.c))}debounce(j,x=100,$=!1,V=!1,K){return new q(ae(this.event,j,x,$,V,K,this.c))}on(j,x,$){return this.event(j,x,$)}once(j,x,$){return R(this.event)(j,x,$)}dispose(){this.c.dispose()}}function W(U){return new q(U)}h.chain=W;function H(U,j,x=$=>$){const $=(...fe)=>oe.fire(x(...fe)),V=()=>U.on(j,$),K=()=>U.removeListener(j,$),oe=new r({onWillAddFirstListener:V,onDidRemoveLastListener:K});return oe.event}h.fromNodeEventEmitter=H;function Q(U,j,x=$=>$){const $=(...fe)=>oe.fire(x(...fe)),V=()=>U.addEventListener(j,$),K=()=>U.removeEventListener(j,$),oe=new r({onWillAddFirstListener:V,onDidRemoveLastListener:K});return oe.event}h.fromDOMEventEmitter=Q;function se(U){return new Promise(j=>R(U)(j))}h.toPromise=se;function re(U,j){return j(void 0),U(x=>j(x))}h.runAndSubscribe=re;function F(U,j){let x=null;function $(K){x?.dispose(),x=new o.DisposableStore,j(K,x)}$(void 0);const V=U(K=>$(K));return(0,o.toDisposable)(()=>{V.dispose(),x?.dispose()})}h.runAndSubscribeWithStore=F;class I{constructor(j,x){this.obs=j,this.c=0,this.d=!1;const $={onWillAddFirstListener:()=>{j.addObserver(this)},onDidRemoveLastListener:()=>{j.removeObserver(this)}};x||l($),this.emitter=new r($),x&&x.add(this.emitter)}beginUpdate(j){this.c++}handleChange(j,x){this.d=!0}endUpdate(j){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function O(U,j){return new I(U,j).emitter.event}h.fromObservable=O})(c=e.Event||(e.Event={}));class m{constructor(l){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${l}_${m.c++}`,m.all.add(this)}start(l){this.d=new M.StopWatch(!0),this.listenerCount=l}stop(){if(this.d){const l=this.d.elapsed();this.durations.push(l),this.elapsedOverall+=l,this.invocationCount+=1,this.d=void 0}}}m.all=new Set,m.c=0,e.EventProfiling=m;let v=-1;function b(h){const l=v;return v=h,{dispose(){v=l}}}e.setGlobalLeakWarningThreshold=b;class d{constructor(l,E=Math.random().toString(18).slice(2,5)){this.threshold=l,this.name=E,this.d=0}dispose(){this.c?.clear()}check(l,E){const R=this.threshold;if(R<=0||E<R)return;this.c||(this.c=new Map);const C=this.c.get(l.value)||0;if(this.c.set(l.value,C+1),this.d-=1,this.d<=0){this.d=R*.5;let T,N=0;for(const[z,B]of this.c)(!T||N<B)&&(T=z,N=B);console.warn(`[${this.name}] potential listener LEAK detected, having ${E} listeners already. MOST frequent listener (${N}):`),console.warn(T)}return()=>{const T=this.c.get(l.value)||0;this.c.set(l.value,T-1)}}}class S{static create(){return new S(new Error().stack??"")}constructor(l){this.value=l}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class w{constructor(l,E,R){this.callback=l,this.callbackThis=E,this.stack=R,this.subscription=new o.SafeDisposable}invoke(l){this.callback.call(this.callbackThis,l)}}class r{constructor(l){this.j=!1,this.d=l,this.f=v>0||this.d?.leakWarningThreshold?new d(this.d?.leakWarningThreshold??v):void 0,this.g=this.d?._profName?new m(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(k){const l=Array.from(this.q);queueMicrotask(()=>{for(const E of l)E.subscription.isset()&&(E.subscription.unset(),E.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(l,E,R)=>{if(this.q||(this.q=new A.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),o.Disposable.None;const C=this.q.isEmpty();C&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let T,N;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(N=S.create(),T=this.f.check(N,this.q.size+1)),k&&(N=N??S.create());const z=new w(l,E,N),B=this.q.push(z);C&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,l,E);const _=z.subscription.set(()=>{T?.(),this.j||(this.d?.onWillRemoveListener?.(this),B(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return R instanceof o.DisposableStore?R.add(_):Array.isArray(R)&&R.push(_),_}),this.l}fire(l){if(this.q){this.m||(this.m=new g(this.d?.onListenerError));for(const E of this.q)this.m.push(this,E,l);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=r;class u{constructor(l=P.onUnexpectedError){this.d=l,this.c=new A.LinkedList}get size(){return this.c.size}push(l,E,R){this.c.push(new p(l,E,R))}clear(l){const E=new A.LinkedList;for(const R of this.c)R.emitter!==l&&E.push(R);this.c=E}deliver(){for(;this.c.size>0;){const l=this.c.shift();try{l.listener.invoke(l.event)}catch(E){this.d(E)}}}}e.EventDeliveryQueue=u;class g extends u{clear(l){this.c.clear()}}class p{constructor(l,E,R){this.emitter=l,this.listener=E,this.event=R}}class y extends r{async fireAsync(l,E,R){if(!!this.q){this.c||(this.c=new A.LinkedList);for(const C of this.q)this.c.push([C,l]);for(;this.c.size>0&&!E.isCancellationRequested;){const[C,T]=this.c.shift(),N=[],z={...T,token:E,waitUntil:B=>{if(Object.isFrozen(N))throw new Error("waitUntil can NOT be called asynchronous");R&&(B=R(B,C.callback)),N.push(B)}};try{C.invoke(z)}catch(B){(0,P.onUnexpectedError)(B);continue}Object.freeze(N),await Promise.allSettled(N).then(B=>{for(const _ of B)_.status==="rejected"&&(0,P.onUnexpectedError)(_.reason)})}}}}e.AsyncEmitter=y;class D extends r{constructor(l){super(l),this.h=0,this.s=new A.LinkedList,this.t=l?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const l=Array.from(this.s);this.s.clear(),super.fire(this.t(l))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(l){this.q&&(this.h!==0?this.s.push(l):super.fire(l))}}e.PauseableEmitter=D;class t extends D{constructor(l){super(l),this.c=l.delay??100}fire(l){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(l)}}e.DebounceEmitter=t;class a extends r{constructor(l){super(l),this.c=[],this.h=l?.merge}fire(l){!this.hasListeners()||(this.c.push(l),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(E=>super.fire(E)),this.c=[]}))}}e.MicrotaskEmitter=a;class i{constructor(){this.d=!1,this.f=[],this.c=new r({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(l){const E={event:l,listener:null};this.f.push(E),this.d&&this.j(E);const R=()=>{this.d&&this.k(E);const C=this.f.indexOf(E);this.f.splice(C,1)};return(0,o.toDisposable)((0,L.once)(R))}g(){this.d=!0,this.f.forEach(l=>this.j(l))}h(){this.d=!1,this.f.forEach(l=>this.k(l))}j(l){l.listener=l.event(E=>this.c.fire(E))}k(l){l.listener&&l.listener.dispose(),l.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=i;class s{constructor(){this.c=[]}wrapEvent(l){return(E,R,C)=>l(T=>{const N=this.c[this.c.length-1];N?N.push(()=>E.call(R,T)):E.call(R,T)},void 0,C)}bufferEvents(l){const E=[];this.c.push(E);const R=l();return this.c.pop(),E.forEach(C=>C()),R}}e.EventBufferer=s;class n{constructor(){this.c=!1,this.d=c.None,this.f=o.Disposable.None,this.g=new r({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(l){this.d=l,this.c&&(this.f.dispose(),this.f=l(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=n}),define(ee[22],te([0,1,3]),function(G,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(k,f){const c=setTimeout(k.bind(f),0);return{dispose(){clearTimeout(c)}}});var o;(function(k){function f(c){return c===k.None||c===k.Cancelled||c instanceof A?!0:!c||typeof c!="object"?!1:typeof c.isCancellationRequested=="boolean"&&typeof c.onCancellationRequested=="function"}k.isCancellationToken=f,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:P.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(o=e.CancellationToken||(e.CancellationToken={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?L:(this.b||(this.b=new P.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class M{constructor(f){this.a=void 0,this.b=void 0,this.b=f&&f.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new A),this.a}cancel(){this.a?this.a instanceof A&&this.a.cancel():this.a=o.Cancelled}dispose(f=!1){f&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof A&&this.a.dispose():this.a=o.None}}e.CancellationTokenSource=M}),define(ee[147],te([0,1,22]),function(G,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class L{constructor(k){this.b=k,this.a=null}get(){if(this.a)return this.a;const k=new P.CancellationTokenSource,f=this.b(k.token);return this.a={promise:f,dispose:()=>{this.a=null,k.cancel(),k.dispose()}},this.a}}e.Cache=L;class o{constructor(k){this.c=k,this.a=void 0,this.b=void 0}get(k){const f=JSON.stringify(k);return this.b!==f&&(this.b=f,this.a=this.c(k)),this.a}}e.LRUCachedFunction=o;class A{get cachedValues(){return this.a}constructor(k){this.b=k,this.a=new Map}get(k){if(this.a.has(k))return this.a.get(k);const f=this.b(k);return this.a.set(k,f),f}}e.CachedFunction=A}),define(ee[26],te([0,1,147,130]),function(G,e,P,L){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function A(X){return!X||typeof X!="string"?!0:X.trim().length===0}e.isFalsyOrWhitespace=A;const M=/{(\d+)}/g;function k(X,...le){return le.length===0?X:X.replace(M,function(me,ve){const we=parseInt(ve,10);return isNaN(we)||we<0||we>=le.length?me:le[we]})}e.format=k;const f=/{([^}]+)}/g;function c(X,le){return X.replace(f,(me,ve)=>le[ve]??me)}e.format2=c;function m(X){return X.replace(/[<>&]/g,function(le){switch(le){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return le}})}e.escape=m;function v(X){return X.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=v;function b(X,le){let me=0;const ve=le.charCodeAt(0);for(let we=X.length-1;we>=0;we--)X.charCodeAt(we)===ve&&me++;return me}e.count=b;function d(X,le,me="\u2026"){return X.length<=le?X:`${X.substr(0,le)}${me}`}e.truncate=d;function S(X,le=" "){const me=w(X,le);return r(me,le)}e.trim=S;function w(X,le){if(!X||!le)return X;const me=le.length;if(me===0||X.length===0)return X;let ve=0;for(;X.indexOf(le,ve)===ve;)ve=ve+me;return X.substring(ve)}e.ltrim=w;function r(X,le){if(!X||!le)return X;const me=le.length,ve=X.length;if(me===0||ve===0)return X;let we=ve,Ae=-1;for(;Ae=X.lastIndexOf(le,we-1),!(Ae===-1||Ae+me!==we);){if(Ae===0)return"";we=Ae}return X.substring(0,we)}e.rtrim=r;function u(X){return X.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=u;function g(X){return X.replace(/\*/g,"")}e.stripWildcards=g;function p(X,le,me={}){if(!X)throw new Error("Cannot create regex from empty string");le||(X=v(X)),me.wholeWord&&(/\B/.test(X.charAt(0))||(X="\\b"+X),/\B/.test(X.charAt(X.length-1))||(X=X+"\\b"));let ve="";return me.global&&(ve+="g"),me.matchCase||(ve+="i"),me.multiline&&(ve+="m"),me.unicode&&(ve+="u"),new RegExp(X,ve)}e.createRegExp=p;function y(X){return X.source==="^"||X.source==="^$"||X.source==="$"||X.source==="^\\s*$"?!1:!!(X.exec("")&&X.lastIndex===0)}e.regExpLeadsToEndlessLoop=y;function D(X){return!!X.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=D;function t(X){return(X.global?"g":"")+(X.ignoreCase?"i":"")+(X.multiline?"m":"")+(X.unicode?"u":"")}e.regExpFlags=t;function a(X){return X.split(/\r\n|\r|\n/)}e.splitLines=a;function i(X){for(let le=0,me=X.length;le<me;le++){const ve=X.charCodeAt(le);if(ve!==32&&ve!==9)return le}return-1}e.firstNonWhitespaceIndex=i;function s(X,le=0,me=X.length){for(let ve=le;ve<me;ve++){const we=X.charCodeAt(ve);if(we!==32&&we!==9)return X.substring(le,ve)}return X.substring(le,me)}e.getLeadingWhitespace=s;function n(X,le=X.length-1){for(let me=le;me>=0;me--){const ve=X.charCodeAt(me);if(ve!==32&&ve!==9)return me}return-1}e.lastNonWhitespaceIndex=n;function h(X,le,me){const ve=[];let we=0;for(const Ae of X.matchAll(le)){if(ve.push(X.slice(we,Ae.index)),Ae.index===void 0)throw new Error("match.index should be defined");we=Ae.index+Ae[0].length,ve.push(me(Ae[0],...Ae.slice(1),Ae.index,X,Ae.groups))}return ve.push(X.slice(we)),Promise.all(ve).then(Ae=>Ae.join(""))}e.replaceAsync=h;function l(X,le){return X<le?-1:X>le?1:0}e.compare=l;function E(X,le,me=0,ve=X.length,we=0,Ae=le.length){for(;me<ve&&we<Ae;me++,we++){const Ge=X.charCodeAt(me),Ke=le.charCodeAt(we);if(Ge<Ke)return-1;if(Ge>Ke)return 1}const Ue=ve-me,xe=Ae-we;return Ue<xe?-1:Ue>xe?1:0}e.compareSubstring=E;function R(X,le){return C(X,le,0,X.length,0,le.length)}e.compareIgnoreCase=R;function C(X,le,me=0,ve=X.length,we=0,Ae=le.length){for(;me<ve&&we<Ae;me++,we++){let Ge=X.charCodeAt(me),Ke=le.charCodeAt(we);if(Ge===Ke)continue;if(Ge>=128||Ke>=128)return E(X.toLowerCase(),le.toLowerCase(),me,ve,we,Ae);N(Ge)&&(Ge-=32),N(Ke)&&(Ke-=32);const Ye=Ge-Ke;if(Ye!==0)return Ye}const Ue=ve-me,xe=Ae-we;return Ue<xe?-1:Ue>xe?1:0}e.compareSubstringIgnoreCase=C;function T(X){return X>=48&&X<=57}e.isAsciiDigit=T;function N(X){return X>=97&&X<=122}e.isLowerAsciiLetter=N;function z(X){return X>=65&&X<=90}e.isUpperAsciiLetter=z;function B(X,le){return X.length===le.length&&C(X,le)===0}e.equalsIgnoreCase=B;function _(X,le){const me=le.length;return le.length>X.length?!1:C(X,le,0,me)===0}e.startsWithIgnoreCase=_;function ne(X,le){const me=Math.min(X.length,le.length);let ve;for(ve=0;ve<me;ve++)if(X.charCodeAt(ve)!==le.charCodeAt(ve))return ve;return me}e.commonPrefixLength=ne;function ae(X,le){const me=Math.min(X.length,le.length);let ve;const we=X.length-1,Ae=le.length-1;for(ve=0;ve<me;ve++)if(X.charCodeAt(we-ve)!==le.charCodeAt(Ae-ve))return ve;return me}e.commonSuffixLength=ae;function he(X){return 55296<=X&&X<=56319}e.isHighSurrogate=he;function ce(X){return 56320<=X&&X<=57343}e.isLowSurrogate=ce;function J(X,le){return(X-55296<<10)+(le-56320)+65536}e.computeCodePoint=J;function Y(X,le,me){const ve=X.charCodeAt(me);if(he(ve)&&me+1<le){const we=X.charCodeAt(me+1);if(ce(we))return J(ve,we)}return ve}e.getNextCodePoint=Y;function q(X,le){const me=X.charCodeAt(le-1);if(ce(me)&&le>1){const ve=X.charCodeAt(le-2);if(he(ve))return J(ve,me)}return me}class W{get offset(){return this.e}constructor(le,me=0){this.c=le,this.d=le.length,this.e=me}setOffset(le){this.e=le}prevCodePoint(){const le=q(this.c,this.e);return this.e-=le>=65536?2:1,le}nextCodePoint(){const le=Y(this.c,this.d,this.e);return this.e+=le>=65536?2:1,le}eol(){return this.e>=this.d}}e.CodePointIterator=W;class H{get offset(){return this.c.offset}constructor(le,me=0){this.c=new W(le,me)}nextGraphemeLength(){const le=Pe.getInstance(),me=this.c,ve=me.offset;let we=le.getGraphemeBreakType(me.nextCodePoint());for(;!me.eol();){const Ae=me.offset,Ue=le.getGraphemeBreakType(me.nextCodePoint());if(ue(we,Ue)){me.setOffset(Ae);break}we=Ue}return me.offset-ve}prevGraphemeLength(){const le=Pe.getInstance(),me=this.c,ve=me.offset;let we=le.getGraphemeBreakType(me.prevCodePoint());for(;me.offset>0;){const Ae=me.offset,Ue=le.getGraphemeBreakType(me.prevCodePoint());if(ue(Ue,we)){me.setOffset(Ae);break}we=Ue}return ve-me.offset}eol(){return this.c.eol()}}e.GraphemeIterator=H;function Q(X,le){return new H(X,le).nextGraphemeLength()}e.nextCharLength=Q;function se(X,le){return new H(X,le).prevGraphemeLength()}e.prevCharLength=se;function re(X,le){le>0&&ce(X.charCodeAt(le))&&le--;const me=le+Q(X,le);return[me-se(X,me),me]}e.getCharContainingOffset=re;function F(X){const le=new H(X);let me=0;for(;!le.eol();)me++,le.nextGraphemeLength();return me}e.charCount=F;let I;function O(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function U(X){return I||(I=O()),I.test(X)}e.containsRTL=U;const j=/^[\t\n\r\x20-\x7E]*$/;function x(X){return j.test(X)}e.isBasicASCII=x,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function $(X){return e.UNUSUAL_LINE_TERMINATORS.test(X)}e.containsUnusualLineTerminators=$;function V(X){return X>=11904&&X<=55215||X>=63744&&X<=64255||X>=65281&&X<=65374}e.isFullWidthCharacter=V;function K(X){return X>=127462&&X<=127487||X===8986||X===8987||X===9200||X===9203||X>=9728&&X<=10175||X===11088||X===11093||X>=127744&&X<=128591||X>=128640&&X<=128764||X>=128992&&X<=129008||X>=129280&&X<=129535||X>=129648&&X<=129782}e.isEmojiImprecise=K;function oe(X,le){if(X.length<le)return X;const me=/\b/g;let ve=0;for(;me.test(X)&&!(X.length-me.lastIndex<le);)ve=me.lastIndex,me.lastIndex+=1;return X.substring(ve).replace(/^\s/,"")}e.lcut=oe;const fe=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g;function Ce(X){return X&&(X=X.replace(fe,"")),X}e.removeAnsiEscapeCodes=Ce,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ee(X){return!!(X&&X.length>0&&X.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ee;function Re(X){return Ee(X)?X.substr(1):X}e.stripUTF8BOM=Re;function Oe(X,le){if(!X||!le||X.length<le.length)return!1;const me=le.length,ve=X.toLowerCase();let we=0,Ae=-1;for(;we<me;){const Ue=ve.indexOf(le[we],Ae+1);if(Ue<0)return!1;Ae=Ue,we++}return!0}e.fuzzyContains=Oe;function ze(X,le=!1){return X?(le&&(X=X.replace(/\\./g,"")),X.toLowerCase()!==X):!1}e.containsUppercaseCharacter=ze;function ge(X){return X.charAt(0).toUpperCase()+X.slice(1)}e.uppercaseFirstLetter=ge;function pe(X,le=1){if(le===0)return"";let me=-1;do me=X.indexOf(`
`,me+1),le--;while(le>0&&me>=0);return me===-1?X:(X[me-1]==="\r"&&me--,X.substr(0,me))}e.getNLines=pe;function Le(X){return X=X%(2*26),X<26?String.fromCharCode(97+X):String.fromCharCode(65+X-26)}e.singleLetterHash=Le;function ie(X){return Pe.getInstance().getGraphemeBreakType(X)}e.getGraphemeBreakType=ie;function ue(X,le){return X===0?le!==5&&le!==7:X===2&&le===3?!1:X===4||X===2||X===3||le===4||le===2||le===3?!0:!(X===8&&(le===8||le===9||le===11||le===12)||(X===11||X===9)&&(le===9||le===10)||(X===12||X===10)&&le===10||le===5||le===13||le===7||X===1||X===13&&le===14||X===6&&le===6)}var de;(function(X){X[X.Other=0]="Other",X[X.Prepend=1]="Prepend",X[X.CR=2]="CR",X[X.LF=3]="LF",X[X.Control=4]="Control",X[X.Extend=5]="Extend",X[X.Regional_Indicator=6]="Regional_Indicator",X[X.SpacingMark=7]="SpacingMark",X[X.L=8]="L",X[X.V=9]="V",X[X.T=10]="T",X[X.LV=11]="LV",X[X.LVT=12]="LVT",X[X.ZWJ=13]="ZWJ",X[X.Extended_Pictographic=14]="Extended_Pictographic"})(de=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Pe{static getInstance(){return Pe.c||(Pe.c=new Pe),Pe.c}constructor(){this.d=Me()}getGraphemeBreakType(le){if(le<32)return le===10?3:le===13?2:4;if(le<127)return 0;const me=this.d,ve=me.length/3;let we=1;for(;we<=ve;)if(le<me[3*we])we=2*we;else if(le>me[3*we+1])we=2*we+1;else return me[3*we+2];return 0}}Pe.c=null;function Me(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Te(X,le){if(X===0)return 0;const me=Fe(X,le);if(me!==void 0)return me;const ve=new W(le,X);return ve.prevCodePoint(),ve.offset}e.getLeftDeleteOffset=Te;function Fe(X,le){const me=new W(le,X);let ve=me.prevCodePoint();for(;je(ve)||ve===65039||ve===8419;){if(me.offset===0)return;ve=me.prevCodePoint()}if(!K(ve))return;let we=me.offset;return we>0&&me.prevCodePoint()===8205&&(we=me.offset),we}function je(X){return 127995<=X&&X<=127999}var Be;(function(X){X[X.zwj=8205]="zwj",X[X.emojiVariantSelector=65039]="emojiVariantSelector",X[X.enclosingKeyCap=8419]="enclosingKeyCap"})(Be||(Be={})),e.noBreakWhitespace="\xA0";class We{static getInstance(le){return We.d.get(Array.from(le))}static getLocales(){return We.e.value}constructor(le){this.f=le}isAmbiguous(le){return this.f.has(le)}getPrimaryConfusable(le){return this.f.get(le)}getConfusableCodePoints(){return new Set(this.f.keys())}}o=We,We.c=new L.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),We.d=new P.LRUCachedFunction(X=>{function le(Ke){const Ye=new Map;for(let Ze=0;Ze<Ke.length;Ze+=2)Ye.set(Ke[Ze],Ke[Ze+1]);return Ye}function me(Ke,Ye){const Ze=new Map(Ke);for(const[rt,ct]of Ye)Ze.set(rt,ct);return Ze}function ve(Ke,Ye){if(!Ke)return Ye;const Ze=new Map;for(const[rt,ct]of Ke)Ye.has(rt)&&Ze.set(rt,ct);return Ze}const we=o.c.value;let Ae=X.filter(Ke=>!Ke.startsWith("_")&&Ke in we);Ae.length===0&&(Ae=["_default"]);let Ue;for(const Ke of Ae){const Ye=le(we[Ke]);Ue=ve(Ue,Ye)}const xe=le(we._common),Ge=me(xe,Ue);return new We(Ge)}),We.e=new L.Lazy(()=>Object.keys(We.c.value).filter(X=>!X.startsWith("_"))),e.AmbiguousCharacters=We;class He{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(He.c())),this.d}static isInvisibleCharacter(le){return He.e().has(le)}static get codePoints(){return He.e()}}He.d=void 0,e.InvisibleCharacters=He}),define(ee[32],te([0,1,9,4,26,11]),function(G,e,P,L,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function M(n){return n===47||n===92}e.isPathSeparator=M;function k(n){return n.replace(/[\\/]/g,P.posix.sep)}e.toSlashes=k;function f(n){return n.indexOf("/")===-1&&(n=k(n)),/^[a-zA-Z]:(\/|$)/.test(n)&&(n="/"+n),n}e.toPosixPath=f;function c(n,h=P.posix.sep){if(!n)return"";const l=n.length,E=n.charCodeAt(0);if(M(E)){if(M(n.charCodeAt(1))&&!M(n.charCodeAt(2))){let C=3;const T=C;for(;C<l&&!M(n.charCodeAt(C));C++);if(T!==C&&!M(n.charCodeAt(C+1))){for(C+=1;C<l;C++)if(M(n.charCodeAt(C)))return n.slice(0,C+1).replace(/[\\/]/g,h)}}return h}else if(u(E)&&n.charCodeAt(1)===58)return M(n.charCodeAt(2))?n.slice(0,2)+h:n.slice(0,2);let R=n.indexOf("://");if(R!==-1){for(R+=3;R<l;R++)if(M(n.charCodeAt(R)))return n.slice(0,R+1)}return""}e.getRoot=c;function m(n){if(!L.isWindows||!n||n.length<5)return!1;let h=n.charCodeAt(0);if(h!==92||(h=n.charCodeAt(1),h!==92))return!1;let l=2;const E=l;for(;l<n.length&&(h=n.charCodeAt(l),h!==92);l++);return!(E===l||(h=n.charCodeAt(l+1),isNaN(h)||h===92))}e.isUNC=m;const v=/[\\/:\*\?"<>\|]/g,b=/[\\/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function S(n,h=L.isWindows){const l=h?v:b;return!(!n||n.length===0||/^\s+$/.test(n)||(l.lastIndex=0,l.test(n))||h&&d.test(n)||n==="."||n===".."||h&&n[n.length-1]==="."||h&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=S;function w(n,h,l){const E=n===h;return!l||E?E:!n||!h?!1:(0,o.equalsIgnoreCase)(n,h)}e.isEqual=w;function r(n,h,l,E=P.sep){if(n===h)return!0;if(!n||!h||h.length>n.length)return!1;if(l){if(!(0,o.startsWithIgnoreCase)(n,h))return!1;if(h.length===n.length)return!0;let C=h.length;return h.charAt(h.length-1)===E&&C--,n.charAt(C)===E}return h.charAt(h.length-1)!==E&&(h+=E),n.indexOf(h)===0}e.isEqualOrParent=r;function u(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=u;function g(n,h){return L.isWindows&&n.endsWith(":")&&(n+=P.sep),(0,P.isAbsolute)(n)||(n=(0,P.join)(h,n)),n=(0,P.normalize)(n),L.isWindows?(n=(0,o.rtrim)(n,P.sep),n.endsWith(":")&&(n+=P.sep)):(n=(0,o.rtrim)(n,P.sep),n||(n=P.sep)),n}e.sanitizeFilePath=g;function p(n){const h=(0,P.normalize)(n);return L.isWindows?n.length>3?!1:y(h)&&(n.length===2||h.charCodeAt(2)===92):h===P.posix.sep}e.isRootOrDriveLetter=p;function y(n,h=L.isWindows){return h?u(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=y;function D(n){return y(n)?n[0]:void 0}e.getDriveLetter=D;function t(n,h,l){return h.length>n.length?-1:n===h?0:(l&&(n=n.toLowerCase(),h=h.toLowerCase()),n.indexOf(h))}e.indexOfPath=t;function a(n){const h=n.split(":");let l,E,R;for(const C of h){const T=Number(C);(0,A.isNumber)(T)?E===void 0?E=T:R===void 0&&(R=T):l=l?[l,C].join(":"):C}if(!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:E!==void 0?E:void 0,column:R!==void 0?R:E!==void 0?1:void 0}}e.parseLineAndColumnAware=a;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function s(n,h,l=8){let E="";for(let C=0;C<l;C++)E+=i.charAt(Math.floor(Math.random()*i.length));let R;return h?R=`${h}-${E}`:R=E,n?(0,P.join)(n,R):R}e.randomPath=s}),define(ee[56],te([0,1,26]),function(G,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function L(u){return o(u,0)}e.hash=L;function o(u,g){switch(typeof u){case"object":return u===null?A(349,g):Array.isArray(u)?f(u,g):c(u,g);case"string":return k(u,g);case"boolean":return M(u,g);case"number":return A(u,g);case"undefined":return A(937,g);default:return A(617,g)}}e.doHash=o;function A(u,g){return(g<<5)-g+u|0}e.numberHash=A;function M(u,g){return A(u?433:863,g)}function k(u,g){g=A(149417,g);for(let p=0,y=u.length;p<y;p++)g=A(u.charCodeAt(p),g);return g}e.stringHash=k;function f(u,g){return g=A(104579,g),u.reduce((p,y)=>o(y,p),g)}function c(u,g){return g=A(181387,g),Object.keys(u).sort().reduce((p,y)=>(p=k(y,p),o(u[y],p)),g)}class m{constructor(){this.g=0}get value(){return this.g}hash(g){return this.g=o(g,this.g),this.g}}e.Hasher=m;var v;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(v||(v={}));function b(u,g,p=32){const y=p-g,D=~((1<<y)-1);return(u<<g|(D&u)>>>y)>>>0}function d(u,g=0,p=u.byteLength,y=0){for(let D=0;D<p;D++)u[g+D]=y}function S(u,g,p="0"){for(;u.length<g;)u=p+u;return u}function w(u,g=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(p=>p.toString(16).padStart(2,"0")).join(""):S((u>>>0).toString(16),g/4)}e.toHexString=w;class r{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(g){const p=g.length;if(p===0)return;const y=this.p;let D=this.r,t=this.u,a,i;for(t!==0?(a=t,i=-1,t=0):(a=g.charCodeAt(0),i=0);;){let s=a;if(P.isHighSurrogate(a))if(i+1<p){const n=g.charCodeAt(i+1);P.isLowSurrogate(n)?(i++,s=P.computeCodePoint(a,n)):s=65533}else{t=a;break}else P.isLowSurrogate(a)&&(s=65533);if(D=this.w(y,D,s),i++,i<p)a=g.charCodeAt(i);else break}this.r=D,this.u=t}w(g,p,y){return y<128?g[p++]=y:y<2048?(g[p++]=192|(y&1984)>>>6,g[p++]=128|(y&63)>>>0):y<65536?(g[p++]=224|(y&61440)>>>12,g[p++]=128|(y&4032)>>>6,g[p++]=128|(y&63)>>>0):(g[p++]=240|(y&1835008)>>>18,g[p++]=128|(y&258048)>>>12,g[p++]=128|(y&4032)>>>6,g[p++]=128|(y&63)>>>0),p>=64&&(this.y(),p-=64,this.t+=64,g[0]=g[64+0],g[1]=g[64+1],g[2]=g[64+2]),p}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),w(this.h)+w(this.l)+w(this.m)+w(this.n)+w(this.o)}x(){this.p[this.r++]=128,d(this.p,this.r),this.r>56&&(this.y(),d(this.p));const g=8*this.t;this.q.setUint32(56,Math.floor(g/4294967296),!1),this.q.setUint32(60,g%4294967296,!1),this.y()}y(){const g=r.g,p=this.q;for(let l=0;l<64;l+=4)g.setUint32(l,p.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)g.setUint32(l,b(g.getUint32(l-12,!1)^g.getUint32(l-32,!1)^g.getUint32(l-56,!1)^g.getUint32(l-64,!1),1),!1);let y=this.h,D=this.l,t=this.m,a=this.n,i=this.o,s,n,h;for(let l=0;l<80;l++)l<20?(s=D&t|~D&a,n=1518500249):l<40?(s=D^t^a,n=1859775393):l<60?(s=D&t|D&a|t&a,n=2400959708):(s=D^t^a,n=3395469782),h=b(y,5)+s+i+n+g.getUint32(l*4,!1)&4294967295,i=a,a=t,t=b(D,30),D=y,y=h;this.h=this.h+y&4294967295,this.l=this.l+D&4294967295,this.m=this.m+t&4294967295,this.n=this.n+a&4294967295,this.o=this.o+i&4294967295}}r.g=new DataView(new ArrayBuffer(320)),e.StringSHA1=r}),define(ee[76],te([0,1,26]),function(G,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(o){o[o.Ignore=0]="Ignore",o[o.Info=1]="Info",o[o.Warning=2]="Warning",o[o.Error=3]="Error"})(L||(L={})),function(o){const A="error",M="warning",k="warn",f="info",c="ignore";function m(b){return b?P.equalsIgnoreCase(A,b)?o.Error:P.equalsIgnoreCase(M,b)||P.equalsIgnoreCase(k,b)?o.Warning:P.equalsIgnoreCase(f,b)?o.Info:o.Ignore:o.Ignore}o.fromValue=m;function v(b){switch(b){case o.Error:return A;case o.Warning:return M;case o.Info:return f;default:return c}}o.toString=v}(L||(L={})),e.default=L}),define(ee[61],te([0,1,27,26]),function(G,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class o{constructor(){this.b="",this.c=0}reset(d){return this.b=d,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(d){const S=d.charCodeAt(0),w=this.b.charCodeAt(this.c);return S-w}value(){return this.b[this.c]}}e.StringIterator=o;class A{constructor(d=!0){this.e=d}reset(d){return this.b=d,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let d=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(d)this.c++;else break;else d=!1;return this}cmp(d){return this.e?(0,L.compareSubstring)(d,this.b,0,d.length,this.c,this.d):(0,L.compareSubstringIgnoreCase)(d,this.b,0,d.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=A;class M{constructor(d=!0,S=!0){this.f=d,this.g=S}reset(d){this.d=0,this.e=0,this.b=d,this.c=d.length;for(let S=d.length-1;S>=0;S--,this.c--){const w=this.b.charCodeAt(S);if(!(w===47||this.f&&w===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let d=!0;for(;this.e<this.c;this.e++){const S=this.b.charCodeAt(this.e);if(S===47||this.f&&S===92)if(d)this.d++;else break;else d=!1}return this}cmp(d){return this.g?(0,L.compareSubstring)(d,this.b,0,d.length,this.d,this.e):(0,L.compareSubstringIgnoreCase)(d,this.b,0,d.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=M;var k;(function(b){b[b.Scheme=1]="Scheme",b[b.Authority=2]="Authority",b[b.Path=3]="Path",b[b.Query=4]="Query",b[b.Fragment=5]="Fragment"})(k||(k={}));class f{constructor(d,S){this.f=d,this.g=S,this.d=[],this.e=0}reset(d){return this.c=d,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new M(!1,!this.f(d)),this.b.reset(d.path),this.b.value()&&this.d.push(3)),this.g(d)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(d){if(this.d[this.e]===1)return(0,L.compareIgnoreCase)(d,this.c.scheme);if(this.d[this.e]===2)return(0,L.compareIgnoreCase)(d,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(d);if(this.d[this.e]===4)return(0,L.compare)(d,this.c.query);if(this.d[this.e]===5)return(0,L.compare)(d,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=f;class c{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const d=this.right;return this.right=d.left,d.left=this,this.updateHeight(),d.updateHeight(),d}rotateRight(){const d=this.left;return this.left=d.right,d.right=this,this.updateHeight(),d.updateHeight(),d}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var m;(function(b){b[b.Left=-1]="Left",b[b.Mid=0]="Mid",b[b.Right=1]="Right"})(m||(m={}));class v{static forUris(d=()=>!1,S=()=>!1){return new v(new f(d,S))}static forPaths(d=!1){return new v(new M(void 0,!d))}static forStrings(){return new v(new o)}static forConfigKeys(){return new v(new A)}constructor(d){this.b=d}clear(){this.c=void 0}fill(d,S){if(S){const w=S.slice(0);(0,P.shuffle)(w);for(const r of w)this.set(r,d)}else{const w=d.slice(0);(0,P.shuffle)(w);for(const r of w)this.set(r[0],r[1])}}set(d,S){const w=this.b.reset(d);let r;this.c||(this.c=new c,this.c.segment=w.value());const u=[];for(r=this.c;;){const p=w.cmp(r.segment);if(p>0)r.left||(r.left=new c,r.left.segment=w.value()),u.push([-1,r]),r=r.left;else if(p<0)r.right||(r.right=new c,r.right.segment=w.value()),u.push([1,r]),r=r.right;else if(w.hasNext())w.next(),r.mid||(r.mid=new c,r.mid.segment=w.value()),u.push([0,r]),r=r.mid;else break}const g=r.value;r.value=S,r.key=d;for(let p=u.length-1;p>=0;p--){const y=u[p][1];y.updateHeight();const D=y.balanceFactor();if(D<-1||D>1){const t=u[p][0],a=u[p+1][0];if(t===1&&a===1)u[p][1]=y.rotateLeft();else if(t===-1&&a===-1)u[p][1]=y.rotateRight();else if(t===1&&a===-1)y.right=u[p+1][1]=u[p+1][1].rotateRight(),u[p][1]=y.rotateLeft();else if(t===-1&&a===1)y.left=u[p+1][1]=u[p+1][1].rotateLeft(),u[p][1]=y.rotateRight();else throw new Error;if(p>0)switch(u[p-1][0]){case-1:u[p-1][1].left=u[p][1];break;case 1:u[p-1][1].right=u[p][1];break;case 0:u[p-1][1].mid=u[p][1];break}else this.c=u[0][1]}}return g}get(d){return this.d(d)?.value}d(d){const S=this.b.reset(d);let w=this.c;for(;w;){const r=S.cmp(w.segment);if(r>0)w=w.left;else if(r<0)w=w.right;else if(S.hasNext())S.next(),w=w.mid;else break}return w}has(d){const S=this.d(d);return!(S?.value===void 0&&S?.mid===void 0)}delete(d){return this.e(d,!1)}deleteSuperstr(d){return this.e(d,!0)}e(d,S){const w=this.b.reset(d),r=[];let u=this.c;for(;u;){const g=w.cmp(u.segment);if(g>0)r.push([-1,u]),u=u.left;else if(g<0)r.push([1,u]),u=u.right;else if(w.hasNext())w.next(),r.push([0,u]),u=u.mid;else break}if(!!u){if(S?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const g=this.f(u.right);if(g.key){const{key:p,value:y,segment:D}=g;this.e(g.key,!1),u.key=p,u.value=y,u.segment=D}}else{const g=u.left??u.right;if(r.length>0){const[p,y]=r[r.length-1];switch(p){case-1:y.left=g;break;case 0:y.mid=g;break;case 1:y.right=g;break}}else this.c=g}for(let g=r.length-1;g>=0;g--){const p=r[g][1];p.updateHeight();const y=p.balanceFactor();if(y>1?(p.right.balanceFactor()>=0||(p.right=p.right.rotateRight()),r[g][1]=p.rotateLeft()):y<-1&&(p.left.balanceFactor()<=0||(p.left=p.left.rotateLeft()),r[g][1]=p.rotateRight()),g>0)switch(r[g-1][0]){case-1:r[g-1][1].left=r[g][1];break;case 1:r[g-1][1].right=r[g][1];break;case 0:r[g-1][1].mid=r[g][1];break}else this.c=r[0][1]}}}f(d){for(;d.left;)d=d.left;return d}findSubstr(d){const S=this.b.reset(d);let w=this.c,r;for(;w;){const u=S.cmp(w.segment);if(u>0)w=w.left;else if(u<0)w=w.right;else if(S.hasNext())S.next(),r=w.value||r,w=w.mid;else break}return w&&w.value||r}findSuperstr(d){return this.g(d,!1)}g(d,S){const w=this.b.reset(d);let r=this.c;for(;r;){const u=w.cmp(r.segment);if(u>0)r=r.left;else if(u<0)r=r.right;else if(w.hasNext())w.next(),r=r.mid;else return r.mid?this.h(r.mid):S?r.value:void 0}}hasElementOrSubtree(d){return this.g(d,!0)!==void 0}forEach(d){for(const[S,w]of this)d(w,S)}*[Symbol.iterator](){yield*this.h(this.c)}h(d){const S=[];return this.j(d,S),S[Symbol.iterator]()}j(d,S){!d||(d.left&&this.j(d.left,S),d.value&&S.push([d.key,d.value]),d.mid&&this.j(d.mid,S),d.right&&this.j(d.right,S))}_isBalanced(){const d=S=>{if(!S)return!0;const w=S.balanceFactor();return w<-1||w>1?!1:d(S.left)&&d(S.right)};return d(this.c)}}e.TernarySearchTree=v}),define(ee[8],te([0,1,9,4]),function(G,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const o=/^\w[\w\d+.-]*$/,A=/^\//,M=/^\/\//;function k(i,s){if(!i.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!o.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!A.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(M.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(i,s){return!i&&!s?"file":i}function c(i,s){switch(i){case"https":case"http":case"file":s?s[0]!==v&&(s=v+s):s=v;break}return s}const m="",v="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{static isUri(s){return s instanceof d?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}constructor(s,n,h,l,E,R=!1){typeof s=="object"?(this.scheme=s.scheme||m,this.authority=s.authority||m,this.path=s.path||m,this.query=s.query||m,this.fragment=s.fragment||m):(this.scheme=f(s,R),this.authority=n||m,this.path=c(this.scheme,h||m),this.query=l||m,this.fragment=E||m,k(this,R))}get fsPath(){return p(this,!1)}with(s){if(!s)return this;let{scheme:n,authority:h,path:l,query:E,fragment:R}=s;return n===void 0?n=this.scheme:n===null&&(n=m),h===void 0?h=this.authority:h===null&&(h=m),l===void 0?l=this.path:l===null&&(l=m),E===void 0?E=this.query:E===null&&(E=m),R===void 0?R=this.fragment:R===null&&(R=m),n===this.scheme&&h===this.authority&&l===this.path&&E===this.query&&R===this.fragment?this:new w(n,h,l,E,R)}static parse(s,n=!1){const h=b.exec(s);return h?new w(h[2]||m,a(h[4]||m),a(h[5]||m),a(h[7]||m),a(h[9]||m),n):new w(m,m,m,m,m)}static file(s){let n=m;if(L.isWindows&&(s=s.replace(/\\/g,v)),s[0]===v&&s[1]===v){const h=s.indexOf(v,2);h===-1?(n=s.substring(2),s=v):(n=s.substring(2,h),s=s.substring(h)||v)}return new w("file",n,s,m,m)}static from(s){const n=new w(s.scheme,s.authority,s.path,s.query,s.fragment);return k(n,!0),n}static joinPath(s,...n){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let h;return L.isWindows&&s.scheme==="file"?h=d.file(P.win32.join(p(s,!0),...n)).path:h=P.posix.join(s.path,...n),s.with({path:h})}toString(s=!1){return y(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof d)return s;{const n=new w(s);return n._formatted=s.external,n._fsPath=s._sep===S?s.fsPath:null,n}}else return s}}e.URI=d;const S=L.isWindows?1:void 0;class w extends d{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=p(this,!1)),this._fsPath}toString(s=!1){return s?y(this,!0):(this._formatted||(this._formatted=y(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=S),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const r={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function u(i,s,n){let h,l=-1;for(let E=0;E<i.length;E++){const R=i.charCodeAt(E);if(R>=97&&R<=122||R>=65&&R<=90||R>=48&&R<=57||R===45||R===46||R===95||R===126||s&&R===47||n&&R===91||n&&R===93||n&&R===58)l!==-1&&(h+=encodeURIComponent(i.substring(l,E)),l=-1),h!==void 0&&(h+=i.charAt(E));else{h===void 0&&(h=i.substr(0,E));const C=r[R];C!==void 0?(l!==-1&&(h+=encodeURIComponent(i.substring(l,E)),l=-1),h+=C):l===-1&&(l=E)}}return l!==-1&&(h+=encodeURIComponent(i.substring(l))),h!==void 0?h:i}function g(i){let s;for(let n=0;n<i.length;n++){const h=i.charCodeAt(n);h===35||h===63?(s===void 0&&(s=i.substr(0,n)),s+=r[h]):s!==void 0&&(s+=i[n])}return s!==void 0?s:i}function p(i,s){let n;return i.authority&&i.path.length>1&&i.scheme==="file"?n=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?s?n=i.path.substr(1):n=i.path[1].toLowerCase()+i.path.substr(2):n=i.path,L.isWindows&&(n=n.replace(/\//g,"\\")),n}e.uriToFsPath=p;function y(i,s){const n=s?g:u;let h="",{scheme:l,authority:E,path:R,query:C,fragment:T}=i;if(l&&(h+=l,h+=":"),(E||l==="file")&&(h+=v,h+=v),E){let N=E.indexOf("@");if(N!==-1){const z=E.substr(0,N);E=E.substr(N+1),N=z.lastIndexOf(":"),N===-1?h+=n(z,!1,!1):(h+=n(z.substr(0,N),!1,!1),h+=":",h+=n(z.substr(N+1),!1,!0)),h+="@"}E=E.toLowerCase(),N=E.lastIndexOf(":"),N===-1?h+=n(E,!1,!0):(h+=n(E.substr(0,N),!1,!0),h+=E.substr(N))}if(R){if(R.length>=3&&R.charCodeAt(0)===47&&R.charCodeAt(2)===58){const N=R.charCodeAt(1);N>=65&&N<=90&&(R=`/${String.fromCharCode(N+32)}:${R.substr(3)}`)}else if(R.length>=2&&R.charCodeAt(1)===58){const N=R.charCodeAt(0);N>=65&&N<=90&&(R=`${String.fromCharCode(N+32)}:${R.substr(2)}`)}h+=n(R,!0,!1)}return C&&(h+="?",h+=n(C,!1,!1)),T&&(h+="#",h+=s?T:u(T,!1,!1)),h}function D(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+D(i.substr(3)):i}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(i){return i.match(t)?i.replace(t,s=>D(s)):i}}),define(ee[148],te([0,1,8]),function(G,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(c){const m=c;return m&&typeof m.type=="string"&&typeof m.severity=="string"}e.isRemoteConsoleLog=L;function o(c){const m=[];let v;try{const b=JSON.parse(c.arguments),d=b[b.length-1];d&&d.__$stack&&(b.pop(),v=d.__$stack),m.push(...b)}catch{m.push("Unable to log remote console arguments",c.arguments)}return{args:m,stack:v}}e.parse=o;function A(c){if(typeof c!="string")return A(o(c).stack);const m=c;if(m){const v=M(m),b=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(v||"");if(b&&b.length===4)return{uri:P.URI.file(b[1]),line:Number(b[2]),column:Number(b[3])}}}e.getFirstFrame=A;function M(c){if(!c)return c;const m=c.indexOf(`
`);return m===-1?c:c.substring(0,m)}function k(c,m){const{args:v,stack:b}=o(c),d=typeof v[0]=="string"&&v.length===1;let S=M(b);S&&(S=`(${S.trim()})`);let w=[];if(typeof v[0]=="string"?S&&d?w=[`%c[${m}] %c${v[0]} %c${S}`,f("blue"),f(""),f("grey")]:w=[`%c[${m}] %c${v[0]}`,f("blue"),f(""),...v.slice(1)]:w=[`%c[${m}]%`,f("blue"),...v],S&&!d&&w.push(S),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,w)}e.log=k;function f(c){return`color: ${c}`}}),define(ee[84],te([0,1,17,26,8]),function(G,e,P,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function A(c){return JSON.stringify(c,k)}e.stringify=A;function M(c){let m=JSON.parse(c);return m=f(m),m}e.parse=M;function k(c,m){return m instanceof RegExp?{$mid:2,source:m.source,flags:(0,L.regExpFlags)(m)}:m}function f(c,m=0){if(!c||m>200)return c;if(typeof c=="object"){switch(c.$mid){case 1:return o.URI.revive(c);case 2:return new RegExp(c.source,c.flags);case 16:return new Date(c.source)}if(c instanceof P.VSBuffer||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let v=0;v<c.length;++v)c[v]=f(c[v],m+1);else for(const v in c)Object.hasOwnProperty.call(c,v)&&(c[v]=f(c[v],m+1))}return c}e.revive=f}),define(ee[14],te([0,1,13,4,8]),function(G,e,P,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var A;(function(c){c.inMemory="inmemory",c.vscode="vscode",c.internal="private",c.walkThrough="walkThrough",c.walkThroughSnippet="walkThroughSnippet",c.http="http",c.https="https",c.file="file",c.mailto="mailto",c.untitled="untitled",c.data="data",c.command="command",c.vscodeRemote="vscode-remote",c.vscodeRemoteResource="vscode-remote-resource",c.vscodeUserData="vscode-userdata",c.vscodeCustomEditor="vscode-custom-editor",c.vscodeNotebookCell="vscode-notebook-cell",c.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",c.vscodeNotebookCellOutput="vscode-notebook-cell-output",c.vscodeInteractive="vscode-interactive",c.vscodeInteractiveInput="vscode-interactive-input",c.vscodeSettings="vscode-settings",c.vscodeWorkspaceTrust="vscode-workspace-trust",c.vscodeTerminal="vscode-terminal",c.webviewPanel="webview-panel",c.vscodeWebview="vscode-webview",c.extension="extension",c.vscodeFileResource="vscode-file",c.tmp="tmp",c.vsls="vsls",c.vscodeSourceControl="vscode-scm"})(A=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class M{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${A.vscodeRemoteResource}`}setPreferredWebSchema(m){this.d=m}setDelegate(m){this.e=m}setServerRootPath(m){this.f=`${m}/${A.vscodeRemoteResource}`}set(m,v,b){this.a[m]=v,this.b[m]=b}setConnectionToken(m,v){this.c[m]=v}getPreferredWebSchema(){return this.d}rewrite(m){if(this.e)try{return this.e(m)}catch(r){return P.onUnexpectedError(r),m}const v=m.authority;let b=this.a[v];b&&b.indexOf(":")!==-1&&b.indexOf("[")===-1&&(b=`[${b}]`);const d=this.b[v],S=this.c[v];let w=`path=${encodeURIComponent(m.path)}`;return typeof S=="string"&&(w+=`&${e.connectionTokenQueryName}=${encodeURIComponent(S)}`),o.URI.from({scheme:L.isWeb?this.d:A.vscodeRemoteResource,authority:`${b}:${d}`,path:this.f,query:w})}}e.RemoteAuthorities=new M,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class k{asBrowserUri(m){const v=this.b(m,G);return this.uriToBrowserUri(v)}uriToBrowserUri(m){return m.scheme===A.vscodeRemote?e.RemoteAuthorities.rewrite(m):m.scheme===A.file&&(L.isNative||L.isWebWorker&&L.globals.origin===`${A.vscodeFileResource}://${k.a}`)?m.with({scheme:A.vscodeFileResource,authority:m.authority||k.a,query:null,fragment:null}):m}asFileUri(m){const v=this.b(m,G);return this.uriToFileUri(v)}uriToFileUri(m){return m.scheme===A.vscodeFileResource?m.with({scheme:A.file,authority:m.authority!==k.a?m.authority:null,query:null,fragment:null}):m}b(m,v){return o.URI.isUri(m)?m:o.URI.parse(v.toUrl(m))}}k.a="vscode-app",e.FileAccess=new k;var f;(function(c){const m=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);c.CoopAndCoep=Object.freeze(m.get("3"));const v="vscode-coi";function b(S){let w;typeof S=="string"?w=new URL(S).searchParams:S instanceof URL?w=S.searchParams:o.URI.isUri(S)&&(w=new URL(S.toString(!0)).searchParams);const r=w?.get(v);if(!!r)return m.get(r)}c.getHeadersFromQuery=b;function d(S,w,r){if(!globalThis.crossOriginIsolated)return;const u=w&&r?"3":r?"2":"1";S instanceof URLSearchParams?S.set(v,u):S[v]=u}c.addSearchParam=d})(f=e.COI||(e.COI={}))}),define(ee[18],te([0,1,32,14,9,4,26,8]),function(G,e,P,L,o,A,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function f(d){return(0,k.uriToFsPath)(d,!0)}e.originalFSPath=f;class c{constructor(S){this.a=S}compare(S,w,r=!1){return S===w?0:(0,M.compare)(this.getComparisonKey(S,r),this.getComparisonKey(w,r))}isEqual(S,w,r=!1){return S===w?!0:!S||!w?!1:this.getComparisonKey(S,r)===this.getComparisonKey(w,r)}getComparisonKey(S,w=!1){return S.with({path:this.a(S)?S.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(S){return this.a(S)}isEqualOrParent(S,w,r=!1){if(S.scheme===w.scheme){if(S.scheme===L.Schemas.file)return P.isEqualOrParent(f(S),f(w),this.a(S))&&S.query===w.query&&(r||S.fragment===w.fragment);if((0,e.isEqualAuthority)(S.authority,w.authority))return P.isEqualOrParent(S.path,w.path,this.a(S),"/")&&S.query===w.query&&(r||S.fragment===w.fragment)}return!1}joinPath(S,...w){return k.URI.joinPath(S,...w)}basenameOrAuthority(S){return(0,e.basename)(S)||S.authority}basename(S){return o.posix.basename(S.path)}extname(S){return o.posix.extname(S.path)}dirname(S){if(S.path.length===0)return S;let w;return S.scheme===L.Schemas.file?w=k.URI.file(o.dirname(f(S))).path:(w=o.posix.dirname(S.path),S.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${S.toString})) resulted in a relative path`),w="/")),S.with({path:w})}normalizePath(S){if(!S.path.length)return S;let w;return S.scheme===L.Schemas.file?w=k.URI.file(o.normalize(f(S))).path:w=o.posix.normalize(S.path),S.with({path:w})}relativePath(S,w){if(S.scheme!==w.scheme||!(0,e.isEqualAuthority)(S.authority,w.authority))return;if(S.scheme===L.Schemas.file){const g=o.relative(f(S),f(w));return A.isWindows?P.toSlashes(g):g}let r=S.path||"/";const u=w.path||"/";if(this.a(S)){let g=0;for(const p=Math.min(r.length,u.length);g<p&&!(r.charCodeAt(g)!==u.charCodeAt(g)&&r.charAt(g).toLowerCase()!==u.charAt(g).toLowerCase());g++);r=u.substr(0,g)+r.substr(g)}return o.posix.relative(r,u)}resolvePath(S,w){if(S.scheme===L.Schemas.file){const r=k.URI.file(o.resolve(f(S),w));return S.with({authority:r.authority,path:r.path})}return w=P.toPosixPath(w),S.with({path:o.posix.resolve(S.path,w)})}isAbsolutePath(S){return!!S.path&&S.path[0]==="/"}isEqualAuthority(S,w){return S===w||S!==void 0&&w!==void 0&&(0,M.equalsIgnoreCase)(S,w)}hasTrailingPathSeparator(S,w=o.sep){if(S.scheme===L.Schemas.file){const r=f(S);return r.length>P.getRoot(r).length&&r[r.length-1]===w}else{const r=S.path;return r.length>1&&r.charCodeAt(r.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(S.fsPath)}}removeTrailingPathSeparator(S,w=o.sep){return(0,e.hasTrailingPathSeparator)(S,w)?S.with({path:S.path.substr(0,S.path.length-1)}):S}addTrailingPathSeparator(S,w=o.sep){let r=!1;if(S.scheme===L.Schemas.file){const u=f(S);r=u!==void 0&&u.length===P.getRoot(u).length&&u[u.length-1]===w}else{w="/";const u=S.path;r=u.length===1&&u.charCodeAt(u.length-1)===47}return!r&&!(0,e.hasTrailingPathSeparator)(S,w)?S.with({path:S.path+"/"}):S}}e.ExtUri=c,e.extUri=new c(()=>!1),e.extUriBiasedIgnorePathCase=new c(d=>d.scheme===L.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new c(d=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function m(d,S){const w=[];for(let r=0;r<d.length;r++){const u=S(d[r]);d.some((g,p)=>p===r?!1:(0,e.isEqualOrParent)(u,S(g)))||w.push(d[r])}return w}e.distinctParents=m;var v;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function S(w){const r=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(p=>{const[y,D]=p.split(":");y&&D&&r.set(y,D)});const g=w.path.substring(0,w.path.indexOf(";"));return g&&r.set(d.META_DATA_MIME,g),r}d.parseMetaData=S})(v=e.DataUri||(e.DataUri={}));function b(d,S,w){if(S){let r=d.path;return r&&r[0]!==o.posix.sep&&(r=o.posix.sep+r),d.with({scheme:w,authority:S,path:r})}return d.with({scheme:w})}e.toLocalResource=b}),define(ee[7],te([0,1,22,13,3,2,18,4,133]),function(G,e,P,L,o,A,M,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function c(F){return!!F&&typeof F.then=="function"}e.isThenable=c;function m(F){const I=new P.CancellationTokenSource,O=F(I.token),U=new Promise((j,x)=>{const $=I.token.onCancellationRequested(()=>{$.dispose(),I.dispose(),x(new L.CancellationError)});Promise.resolve(O).then(V=>{$.dispose(),I.dispose(),j(V)},V=>{$.dispose(),I.dispose(),x(V)})});return new class{cancel(){I.cancel()}then(j,x){return U.then(j,x)}catch(j){return this.then(void 0,j)}finally(j){return U.finally(j)}}}e.createCancelablePromise=m;function v(F,I,O){return new Promise((U,j)=>{const x=I.onCancellationRequested(()=>{x.dispose(),U(O)});F.then(U,j).finally(()=>x.dispose())})}e.raceCancellation=v;function b(F,I){return new Promise((O,U)=>{const j=I.onCancellationRequested(()=>{j.dispose(),U(new L.CancellationError)});F.then(O,U).finally(()=>j.dispose())})}e.raceCancellationError=b;async function d(F){let I=-1;const O=F.map((j,x)=>j.then($=>(I=x,$))),U=await Promise.race(O);return F.forEach((j,x)=>{x!==I&&j.cancel()}),U}e.raceCancellablePromises=d;function S(F,I,O){let U;const j=setTimeout(()=>{U?.(void 0),O?.()},I);return Promise.race([F.finally(()=>clearTimeout(j)),new Promise(x=>U=x)])}e.raceTimeout=S;function w(F){return new Promise((I,O)=>{const U=F();c(U)?U.then(I,O):I(U)})}e.asPromise=w;class r{constructor(){this.a=null,this.b=null,this.d=null}queue(I){if(this.a){if(this.d=I,!this.b){const O=()=>{this.b=null;const U=this.queue(this.d);return this.d=null,U};this.b=new Promise(U=>{this.a.then(O,O).then(U)})}return new Promise((O,U)=>{this.b.then(O,U)})}return this.a=I(),new Promise((O,U)=>{this.a.then(j=>{this.a=null,O(j)},j=>{this.a=null,U(j)})})}}e.Throttler=r;class u{constructor(){this.a=Promise.resolve(null)}queue(I){return this.a=this.a.then(()=>I(),()=>I())}}e.Sequencer=u;class g{constructor(){this.a=new Map}queue(I,O){const j=(this.a.get(I)??Promise.resolve()).catch(()=>{}).then(O).finally(()=>{this.a.get(I)===j&&this.a.delete(I)});return this.a.set(I,j),j}}e.SequencerByKey=g;const p=(F,I)=>{let O=!0;const U=setTimeout(()=>{O=!1,I()},F);return{isTriggered:()=>O,dispose:()=>{clearTimeout(U),O=!1}}},y=F=>{let I=!0;return queueMicrotask(()=>{I&&(I=!1,F())}),{isTriggered:()=>I,dispose:()=>{I=!1}}};class D{constructor(I){this.defaultDelay=I,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(I,O=this.defaultDelay){this.g=I,this.h(),this.b||(this.b=new Promise((j,x)=>{this.d=j,this.f=x}).then(()=>{if(this.b=null,this.d=null,this.g){const j=this.g;return this.g=null,j()}}));const U=()=>{this.a=null,this.d?.(null)};return this.a=O===f.MicrotaskDelay?y(U):p(O,U),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new L.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=D;class t{constructor(I){this.a=new D(I),this.b=new r}trigger(I,O){return this.a.trigger(()=>this.b.queue(I),O)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=t;class a{constructor(){this.a=!1,this.b=new Promise((I,O)=>{this.d=I})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=a;class i extends a{constructor(I){super(),this.f=setTimeout(()=>this.open(),I)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=i;function s(F,I){return I?new Promise((O,U)=>{const j=setTimeout(()=>{x.dispose(),O()},F),x=I.onCancellationRequested(()=>{clearTimeout(j),x.dispose(),U(new L.CancellationError)})}):m(O=>s(F,O))}e.timeout=s;function n(F,I=0){const O=setTimeout(F,I);return(0,A.toDisposable)(()=>clearTimeout(O))}e.disposableTimeout=n;function h(F){const I=[];let O=0;const U=F.length;function j(){return O<U?F[O++]():null}function x($){$!=null&&I.push($);const V=j();return V?V.then(x):Promise.resolve(I)}return Promise.resolve(null).then(x)}e.sequence=h;function l(F,I=U=>!!U,O=null){let U=0;const j=F.length,x=()=>{if(U>=j)return Promise.resolve(O);const $=F[U++];return Promise.resolve($()).then(K=>I(K)?Promise.resolve(K):x())};return x()}e.first=l;function E(F,I=U=>!!U,O=null){if(F.length===0)return Promise.resolve(O);let U=F.length;const j=()=>{U=-1;for(const x of F)x.cancel?.()};return new Promise((x,$)=>{for(const V of F)V.then(K=>{--U>=0&&I(K)?(j(),x(K)):U===0&&x(O)}).catch(K=>{--U>=0&&(j(),$(K))})})}e.firstParallel=E;class R{constructor(I){this.a=0,this.d=I,this.f=[],this.b=0,this.g=new o.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(I){return this.a++,new Promise((O,U)=>{this.f.push({factory:I,c:O,e:U}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const I=this.f.shift();this.b++;const O=I.factory();O.then(I.c,I.e),O.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=R;class C extends R{constructor(){super(1)}}e.Queue=C;class T{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const I=new q;return this.b.add(I),I.p}d(){for(const[,I]of this.a)if(I.size>0)return!1;return!0}queueFor(I,O=M.extUri){const U=O.getComparisonKey(I);let j=this.a.get(U);return j||(j=new C,o.Event.once(j.onDrained)(()=>{j?.dispose(),this.a.delete(U),this.f()}),this.a.set(U,j)),j}f(){!this.d()||this.g()}g(){for(const I of this.b)I.complete();this.b.clear()}dispose(){for(const[,I]of this.a)I.dispose();this.a.clear(),this.g()}}e.ResourceQueue=T;class N{constructor(I,O){this.a=-1,typeof I=="function"&&typeof O=="number"&&this.setIfNotSet(I,O)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(I,O){this.cancel(),this.a=setTimeout(()=>{this.a=-1,I()},O)}setIfNotSet(I,O){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,I()},O))}}e.TimeoutTimer=N;class z{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(I,O){this.cancel(),this.a=setInterval(()=>{I()},O)}}e.IntervalTimer=z;class B{constructor(I,O){this.b=-1,this.a=I,this.d=O,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(I=this.d){this.cancel(),this.b=setTimeout(this.f,I)}get delay(){return this.d}set delay(I){this.d=I}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=B;class _{constructor(I,O){O%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.a=I,this.b=O,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(I=this.b){I%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${I}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(I/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=_;class ne extends B{constructor(I,O){super(I,O),this.j=[]}work(I){this.j.push(I),this.isScheduled()||this.schedule()}h(){const I=this.j;this.j=[],this.a?.(I)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=ne;class ae extends A.Disposable{constructor(I,O){super(),this.g=I,this.h=O,this.a=[],this.b=this.D(new A.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(I){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+I.length>this.g.maxBufferedWork)return!1}else if(this.pending+I.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const O of I)this.a.push(O);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new B(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=ae,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=F=>{(0,k.setTimeout0)(()=>{if(I)return;const O=Date.now()+15;F(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,O-Date.now())}}))});let I=!1;return{dispose(){I||(I=!0)}}}:e.runWhenIdle=(F,I)=>{const O=requestIdleCallback(F,typeof I=="number"?{timeout:I}:void 0);let U=!1;return{dispose(){U||(U=!0,cancelIdleCallback(O))}}}}();class he{constructor(I){this.d=!1,this.a=()=>{try{this.f=I()}catch(O){this.g=O}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=he;async function ce(F,I,O){let U;for(let j=0;j<O;j++)try{return await F()}catch(x){U=x,await s(I)}throw U}e.retry=ce;class J{hasPending(I){return this.a?typeof I=="number"?this.a.taskId===I:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(I,O,U){return this.a={taskId:I,cancel:()=>U?.(),promise:O},O.then(()=>this.d(I),()=>this.d(I)),O}d(I){this.a&&I===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const I=this.b;this.b=void 0,I.run().then(I.promiseResolve,I.promiseReject)}}setNext(I){if(this.b)this.b.run=I;else{let O,U;const j=new Promise((x,$)=>{O=x,U=$});this.b={run:I,promise:j,promiseResolve:O,promiseReject:U}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=J;class Y{constructor(I,O=()=>Date.now()){this.d=I,this.f=O,this.a=0,this.b=0}increment(){const I=this.f();return I-this.a>this.d&&(this.a=I,this.b=0),this.b++,this.b}}e.IntervalCounter=Y;class q{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((I,O)=>{this.a=I,this.b=O})}complete(I){return new Promise(O=>{this.a(I),this.f=!0,O()})}error(I){return new Promise(O=>{this.b(I),this.d=!0,O()})}cancel(){new Promise(I=>{this.b(new L.CancellationError),this.d=!0,I()})}}e.DeferredPromise=q;var W;(function(F){async function I(U){let j;const x=await Promise.all(U.map($=>$.then(V=>V,V=>{j||(j=V)})));if(typeof j<"u")throw j;return x}F.settled=I;function O(U){return new Promise(async(j,x)=>{try{await U(j,x)}catch($){x($)}})}F.withAsyncBody=O})(W=e.Promises||(e.Promises={}));var H;(function(F){F[F.Initial=0]="Initial",F[F.DoneOK=1]="DoneOK",F[F.DoneError=2]="DoneError"})(H||(H={}));class Q{static fromArray(I){return new Q(O=>{O.emitMany(I)})}static fromPromise(I){return new Q(async O=>{O.emitMany(await I)})}static fromPromises(I){return new Q(async O=>{await Promise.all(I.map(async U=>O.emitOne(await U)))})}static merge(I){return new Q(async O=>{await Promise.all(I.map(async U=>{for await(const j of U)O.emitOne(j)}))})}constructor(I){this.a=0,this.b=[],this.d=null,this.f=new o.Emitter,queueMicrotask(async()=>{const O={emitOne:U=>this.g(U),emitMany:U=>this.h(U),reject:U=>this.k(U)};try{await Promise.resolve(I(O)),this.j()}catch(U){this.k(U)}finally{O.emitOne=void 0,O.emitMany=void 0,O.reject=void 0}})}[Symbol.asyncIterator](){let I=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(I<this.b.length)return{done:!1,value:this.b[I++]};if(this.a===1)return{done:!0,value:void 0};await o.Event.toPromise(this.f.event)}while(!0)}}}static map(I,O){return new Q(async U=>{for await(const j of I)U.emitOne(O(j))})}map(I){return Q.map(this,I)}static filter(I,O){return new Q(async U=>{for await(const j of I)O(j)&&U.emitOne(j)})}filter(I){return Q.filter(this,I)}static coalesce(I){return Q.filter(I,O=>!!O)}coalesce(){return Q.coalesce(this)}static async toPromise(I){const O=[];for await(const U of I)O.push(U);return O}toPromise(){return Q.toPromise(this)}g(I){this.a===0&&(this.b.push(I),this.f.fire())}h(I){this.a===0&&(this.b=this.b.concat(I),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(I){this.a===0&&(this.a=2,this.d=I,this.f.fire())}}Q.EMPTY=Q.fromArray([]),e.AsyncIterableObject=Q;class se extends Q{constructor(I,O){super(O),this.l=I}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=se;function re(F){const I=new P.CancellationTokenSource,O=F(I.token);return new se(I,async U=>{const j=I.token.onCancellationRequested(()=>{j.dispose(),I.dispose(),U.reject(new L.CancellationError)});try{for await(const x of O){if(I.token.isCancellationRequested)return;U.emitOne(x)}j.dispose(),I.dispose()}catch(x){j.dispose(),I.dispose(),U.reject(x)}})}e.createCancelableAsyncIterable=re}),define(ee[101],te([0,1,27,7,32,35,9,4,26]),function(G,e,P,L,o,A,M,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function c(){return Object.create(null)}e.getEmptyExpression=c,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const m="[/\\\\]",v="[^/\\\\]",b=/\//g;function d(Y,q){switch(Y){case 0:return"";case 1:return`${v}*?`;default:return`(?:${m}|${v}+${m}${q?`|${m}${v}+`:""})*?`}}function S(Y,q){if(!Y)return[];const W=[];let H=!1,Q=!1,se="";for(const re of Y){switch(re){case q:if(!H&&!Q){W.push(se),se="";continue}break;case"{":H=!0;break;case"}":H=!1;break;case"[":Q=!0;break;case"]":Q=!1;break}se+=re}return se&&W.push(se),W}e.splitGlobAware=S;function w(Y){if(!Y)return"";let q="";const W=S(Y,e.GLOB_SPLIT);if(W.every(H=>H===e.GLOBSTAR))q=".*";else{let H=!1;W.forEach((Q,se)=>{if(Q===e.GLOBSTAR){if(H)return;q+=d(2,se===W.length-1)}else{let re=!1,F="",I=!1,O="";for(const U of Q){if(U!=="}"&&re){F+=U;continue}if(I&&(U!=="]"||!O)){let j;U==="-"?j=U:(U==="^"||U==="!")&&!O?j="^":U===e.GLOB_SPLIT?j="":j=(0,f.escapeRegExpCharacters)(U),O+=j;continue}switch(U){case"{":re=!0;continue;case"[":I=!0;continue;case"}":{q+=`(?:${S(F,",").map($=>w($)).join("|")})`,re=!1,F="";break}case"]":{q+="["+O+"]",I=!1,O="";break}case"?":q+=v;continue;case"*":q+=d(1);continue;default:q+=(0,f.escapeRegExpCharacters)(U)}}se<W.length-1&&(W[se+1]!==e.GLOBSTAR||se+2<W.length)&&(q+=m)}H=Q===e.GLOBSTAR})}return q}const r=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,g=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,p=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,y=/^\*\*((\/[\w\.-]+)+)\/?$/,D=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new A.LRUCache(1e4),a=function(){return!1},i=function(){return null};function s(Y,q){if(!Y)return i;let W;typeof Y!="string"?W=Y.pattern:W=Y,W=W.trim();const H=`${W}_${!!q.trimForExclusions}`;let Q=t.get(H);if(Q)return n(Q,Y);let se;return r.test(W)?Q=l(W.substr(4),W):(se=u.exec(h(W,q)))?Q=E(se[1],W):(q.trimForExclusions?p:g).test(W)?Q=R(W,q):(se=y.exec(h(W,q)))?Q=C(se[1].substr(1),W,!0):(se=D.exec(h(W,q)))?Q=C(se[1],W,!1):Q=T(W),t.set(H,Q),n(Q,Y)}function n(Y,q){if(typeof q=="string")return Y;const W=function(H,Q){return(0,o.isEqualOrParent)(H,q.base,!k.isLinux)?Y((0,f.ltrim)(H.substr(q.base.length),M.sep),Q):null};return W.allBasenames=Y.allBasenames,W.allPaths=Y.allPaths,W.basenames=Y.basenames,W.patterns=Y.patterns,W}function h(Y,q){return q.trimForExclusions&&Y.endsWith("/**")?Y.substr(0,Y.length-2):Y}function l(Y,q){return function(W,H){return typeof W=="string"&&W.endsWith(Y)?q:null}}function E(Y,q){const W=`/${Y}`,H=`\\${Y}`,Q=function(re,F){return typeof re!="string"?null:F?F===Y?q:null:re===Y||re.endsWith(W)||re.endsWith(H)?q:null},se=[Y];return Q.basenames=se,Q.patterns=[q],Q.allBasenames=se,Q}function R(Y,q){const W=ce(Y.slice(1,-1).split(",").map(F=>s(F,q)).filter(F=>F!==i),Y),H=W.length;if(!H)return i;if(H===1)return W[0];const Q=function(F,I){for(let O=0,U=W.length;O<U;O++)if(W[O](F,I))return Y;return null},se=W.find(F=>!!F.allBasenames);se&&(Q.allBasenames=se.allBasenames);const re=W.reduce((F,I)=>I.allPaths?F.concat(I.allPaths):F,[]);return re.length&&(Q.allPaths=re),Q}function C(Y,q,W){const H=M.sep===M.posix.sep,Q=H?Y:Y.replace(b,M.sep),se=M.sep+Q,re=M.posix.sep+Y;let F;return W?F=function(I,O){return typeof I=="string"&&(I===Q||I.endsWith(se)||!H&&(I===Y||I.endsWith(re)))?q:null}:F=function(I,O){return typeof I=="string"&&(I===Q||!H&&I===Y)?q:null},F.allPaths=[(W?"*/":"./")+Y],F}function T(Y){try{const q=new RegExp(`^${w(Y)}$`);return function(W){return q.lastIndex=0,typeof W=="string"&&q.test(W)?Y:null}}catch{return i}}function N(Y,q,W){return!Y||typeof q!="string"?!1:z(Y)(q,void 0,W)}e.match=N;function z(Y,q={}){if(!Y)return a;if(typeof Y=="string"||B(Y)){const W=s(Y,q);if(W===i)return a;const H=function(Q,se){return!!W(Q,se)};return W.allBasenames&&(H.allBasenames=W.allBasenames),W.allPaths&&(H.allPaths=W.allPaths),H}return ae(Y,q)}e.parse=z;function B(Y){const q=Y;return q?typeof q.base=="string"&&typeof q.pattern=="string":!1}e.isRelativePattern=B;function _(Y){return Y.allBasenames||[]}e.getBasenameTerms=_;function ne(Y){return Y.allPaths||[]}e.getPathTerms=ne;function ae(Y,q){const W=ce(Object.getOwnPropertyNames(Y).map(F=>he(F,Y[F],q)).filter(F=>F!==i)),H=W.length;if(!H)return i;if(!W.some(F=>!!F.requiresSiblings)){if(H===1)return W[0];const F=function(U,j){let x;for(let $=0,V=W.length;$<V;$++){const K=W[$](U,j);if(typeof K=="string")return K;(0,L.isThenable)(K)&&(x||(x=[]),x.push(K))}return x?(async()=>{for(const $ of x){const V=await $;if(typeof V=="string")return V}return null})():null},I=W.find(U=>!!U.allBasenames);I&&(F.allBasenames=I.allBasenames);const O=W.reduce((U,j)=>j.allPaths?U.concat(j.allPaths):U,[]);return O.length&&(F.allPaths=O),F}const Q=function(F,I,O){let U,j;for(let x=0,$=W.length;x<$;x++){const V=W[x];V.requiresSiblings&&O&&(I||(I=(0,M.basename)(F)),U||(U=I.substr(0,I.length-(0,M.extname)(F).length)));const K=V(F,I,U,O);if(typeof K=="string")return K;(0,L.isThenable)(K)&&(j||(j=[]),j.push(K))}return j?(async()=>{for(const x of j){const $=await x;if(typeof $=="string")return $}return null})():null},se=W.find(F=>!!F.allBasenames);se&&(Q.allBasenames=se.allBasenames);const re=W.reduce((F,I)=>I.allPaths?F.concat(I.allPaths):F,[]);return re.length&&(Q.allPaths=re),Q}function he(Y,q,W){if(q===!1)return i;const H=s(Y,W);if(H===i)return i;if(typeof q=="boolean")return H;if(q){const Q=q.when;if(typeof Q=="string"){const se=(re,F,I,O)=>{if(!O||!H(re,F))return null;const U=Q.replace("$(basename)",()=>I),j=O(U);return(0,L.isThenable)(j)?j.then(x=>x?Y:null):j?Y:null};return se.requiresSiblings=!0,se}}return H}function ce(Y,q){const W=Y.filter(F=>!!F.basenames);if(W.length<2)return Y;const H=W.reduce((F,I)=>{const O=I.basenames;return O?F.concat(O):F},[]);let Q;if(q){Q=[];for(let F=0,I=H.length;F<I;F++)Q.push(q)}else Q=W.reduce((F,I)=>{const O=I.patterns;return O?F.concat(O):F},[]);const se=function(F,I){if(typeof F!="string")return null;if(!I){let U;for(U=F.length;U>0;U--){const j=F.charCodeAt(U-1);if(j===47||j===92)break}I=F.substr(U)}const O=H.indexOf(I);return O!==-1?Q[O]:null};se.basenames=H,se.patterns=Q,se.allBasenames=H;const re=Y.filter(F=>!F.basenames);return re.push(se),re}function J(Y,q){return(0,P.equals)(Y,q,(W,H)=>typeof W=="string"&&typeof H=="string"?W===H:typeof W!="string"&&typeof H!="string"?W.base===H.base&&W.pattern===H.pattern:!1)}e.patternsEquals=J}),define(ee[45],te([0,1,27,32,9,4,18,26]),function(G,e,P,L,o,A,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function f(i,s){const{os:n,tildify:h,relative:l}=s;if(l){const C=c(i,l,n);if(typeof C=="string")return C}let E=i.fsPath;if(n===1&&!A.isWindows?E=E.replace(/\//g,"\\"):n!==1&&A.isWindows&&(E=E.replace(/\\/g,"/")),n!==1&&h?.userHome){const C=h.userHome.fsPath;let T;i.scheme!==h.userHome.scheme&&i.path.startsWith(o.posix.sep)?T=h.userHome.with({path:i.path}).fsPath:T=i.fsPath,E=b(T,C,n)}return(n===1?o.win32:o.posix).normalize(m(E,n===1))}e.getPathLabel=f;function c(i,s,n){const h=n===1?o.win32:o.posix,l=n===3?M.extUri:M.extUriIgnorePathCase,E=s.getWorkspace(),R=(0,P.firstOrDefault)(E.folders);if(!R)return;i.scheme!==R.uri.scheme&&i.path.startsWith(o.posix.sep)&&(i=R.uri.with({path:i.path}));const C=s.getWorkspaceFolder(i);if(!C)return;let T;if(l.isEqual(C.uri,i)?T="":T=l.relativePath(C.uri,i)??"",T&&(T=h.normalize(T)),E.folders.length>1&&!s.noPrefix){const N=C.name?C.name:l.basenameOrAuthority(C.uri);T=T?`${N} \u2022 ${T}`:N}return T}function m(i,s=A.isWindows){return(0,L.hasDriveLetter)(i,s)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=m;let v=Object.create(null);function b(i,s,n=A.OS){if(n===1||!i||!s)return i;let h=v.original===s?v.normalized:void 0;h||(h=s,A.isWindows&&(h=(0,L.toSlashes)(h)),h=`${(0,k.rtrim)(h,o.posix.sep)}${o.posix.sep}`,v={original:s,normalized:h});let l=i;return A.isWindows&&(l=(0,L.toSlashes)(l)),(n===3?l.startsWith(h):(0,k.startsWithIgnoreCase)(l,h))?`~/${l.substr(h.length)}`:i}e.tildify=b;function d(i,s){return i.replace(/^~($|\/|\\)/,`${s}$1`)}e.untildify=d;const S="\u2026",w="\\\\",r="~";function u(i,s=o.sep){const n=new Array(i.length);let h=!1;for(let l=0;l<i.length;l++){const E=i[l];if(E===""){n[l]=`.${s}`;continue}if(!E){n[l]=E;continue}h=!0;let R="",C=E;C.indexOf(w)===0?(R=C.substr(0,C.indexOf(w)+w.length),C=C.substr(C.indexOf(w)+w.length)):C.indexOf(s)===0?(R=C.substr(0,C.indexOf(s)+s.length),C=C.substr(C.indexOf(s)+s.length)):C.indexOf(r)===0&&(R=C.substr(0,C.indexOf(r)+r.length),C=C.substr(C.indexOf(r)+r.length));const T=C.split(s);for(let N=1;h&&N<=T.length;N++)for(let z=T.length-N;h&&z>=0;z--){h=!1;let B=T.slice(z,z+N).join(s);for(let _=0;!h&&_<i.length;_++)if(_!==l&&i[_]&&i[_].indexOf(B)>-1){const ne=z+N===T.length,ae=z>0&&i[_].indexOf(s)>-1?s+B:B,he=i[_].endsWith(ae);h=!ne||he}if(!h){let _="";(T[0].endsWith(":")||R!=="")&&(z===1&&(z=0,N++,B=T[0]+s+B),z>0&&(_=T[0]+s),_=R+_),z>0&&(_=_+S+s),_=_+B,z+N<T.length&&(_=_+s+S),n[l]=_}}h&&(n[l]=E)}return n}e.shorten=u;var g;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(g||(g={}));function p(i,s=Object.create(null)){const n=[];let h=!1,l="";for(const E of i)if(E==="$"||h&&E==="{")l&&n.push({value:l,type:g.TEXT}),l="",h=!0;else if(E==="}"&&h){const R=s[l];if(typeof R=="string")R.length&&n.push({value:R,type:g.VARIABLE});else if(R){const C=n[n.length-1];(!C||C.type!==g.SEPARATOR)&&n.push({value:R.label,type:g.SEPARATOR})}l="",h=!1}else l+=E;return l&&!h&&n.push({value:l,type:g.TEXT}),n.filter((E,R)=>{if(E.type===g.SEPARATOR){const C=n[R-1],T=n[R+1];return[C,T].every(N=>N&&(N.type===g.VARIABLE||N.type===g.TEXT)&&N.value.length>0)}return!0}).map(E=>E.value).join("")}e.template=p;function y(i,s){return A.isMacintosh||s?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):i.replace(/&&|&/g,n=>n==="&"?"&&":"&")}e.mnemonicMenuLabel=y;function D(i,s){return A.isMacintosh||s?i.replace(/\(&&\w\)|&&/g,""):A.isWindows?i.replace(/&&|&/g,n=>n==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=D;function t(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=t;function a(i){const s=i.indexOf("/")!==-1?o.posix:o.win32,n=s.basename(i),h=s.dirname(i);return n.length?{name:n,parentPath:h}:{name:h,parentPath:""}}e.splitName=a}),define(ee[149],te([0,1,17,8]),function(G,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function o(v){return v.toJSON()}class A{constructor(b){this.a=b}transformIncoming(b){const d=this.a.transformIncoming(b);return d===b?b:o(L.URI.from(d))}transformOutgoing(b){const d=this.a.transformOutgoing(b);return d===b?b:o(L.URI.from(d))}transformOutgoingURI(b){const d=this.a.transformOutgoing(b);return d===b?b:L.URI.from(d)}transformOutgoingScheme(b){return this.a.transformOutgoingScheme(b)}}e.URITransformer=A,e.DefaultURITransformer=new class{transformIncoming(v){return v}transformOutgoing(v){return v}transformOutgoingURI(v){return v}transformOutgoingScheme(v){return v}};function M(v,b,d){if(!v||d>200)return null;if(typeof v=="object"){if(v instanceof L.URI)return b.transformOutgoing(v);for(const S in v)if(Object.hasOwnProperty.call(v,S)){const w=M(v[S],b,d+1);w!==null&&(v[S]=w)}}return null}function k(v,b){const d=M(v,b,0);return d===null?v:d}e.transformOutgoingURIs=k;function f(v,b,d,S){if(!v||S>200)return null;if(typeof v=="object"){if(v.$mid===1)return d?L.URI.revive(b.transformIncoming(v)):b.transformIncoming(v);if(v instanceof P.VSBuffer)return null;for(const w in v)if(Object.hasOwnProperty.call(v,w)){const r=f(v[w],b,d,S+1);r!==null&&(v[w]=r)}}return null}function c(v,b){const d=f(v,b,!1,0);return d===null?v:d}e.transformIncomingURIs=c;function m(v,b){const d=f(v,b,!0,0);return d===null?v:d}e.transformAndReviveIncomingURIs=m}),define(ee[85],te([0,1,25,13,61,31,137]),function(G,e,P,L,o,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(m){return this.a||(this.a=o.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(m)}value(){if(this.b===void 0){let m=0,v=0;const b=(0,P.networkInterfaces)();for(const d in b){const S=b[d];if(S)for(const{mac:w,internal:r}of S)r||(v+=1,this.c(w.toUpperCase())&&(m+=1))}this.b=v>0?m/v:0}return this.b}};let k;async function f(){return k||(k=(async()=>await c()||A.generateUuid())()),k}e.getMachineId=f;async function c(){try{const m=await new Promise((b,d)=>{G(["crypto"],b,d)}),v=(0,M.getMac)();return m.createHash("sha256").update(v,"utf8").digest("hex")}catch(m){L.onUnexpectedError(m);return}}}),define(ee[23],te([0,1,41,25,150,7,32,83,9,4,18,8]),function(G,e,P,L,o,A,M,k,f,c,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var b;(function(ae){ae[ae.UNLINK=0]="UNLINK",ae[ae.MOVE=1]="MOVE"})(b=e.RimRafMode||(e.RimRafMode={}));async function d(ae,he=b.UNLINK){if((0,M.isRootOrDriveLetter)(ae))throw new Error("rimraf - will refuse to recursively delete root");return he===b.UNLINK?w(ae):S(ae)}async function S(ae){try{const he=(0,M.randomPath)((0,L.tmpdir)());try{await P.promises.rename(ae,he)}catch(ce){return ce.code==="ENOENT"?void 0:w(ae)}w(he).catch(ce=>{})}catch(he){if(he.code!=="ENOENT")throw he}}async function w(ae){return(0,o.promisify)(P.rm)(ae,{recursive:!0,force:!0,maxRetries:3})}function r(ae){if((0,M.isRootOrDriveLetter)(ae))throw new Error("rimraf - will refuse to recursively delete root");P.rmSync(ae,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=r;async function u(ae,he){return y(await(he?g(ae):(0,o.promisify)(P.readdir)(ae)))}async function g(ae){try{return await(0,o.promisify)(P.readdir)(ae,{withFileTypes:!0})}catch(J){console.warn("[node.js fs] readdir with filetypes failed with error: ",J)}const he=[],ce=await u(ae);for(const J of ce){let Y=!1,q=!1,W=!1;try{const H=await e.Promises.lstat((0,f.join)(ae,J));Y=H.isFile(),q=H.isDirectory(),W=H.isSymbolicLink()}catch(H){console.warn("[node.js fs] unexpected error from lstat after readdir: ",H)}he.push({name:J,isFile:()=>Y,isDirectory:()=>q,isSymbolicLink:()=>W})}return he}function p(ae){return y(P.readdirSync(ae))}e.readdirSync=p;function y(ae){return ae.map(he=>typeof he=="string"?c.isMacintosh?(0,k.normalizeNFC)(he):he:(he.name=c.isMacintosh?(0,k.normalizeNFC)(he.name):he.name,he))}async function D(ae){const he=await u(ae),ce=[];for(const J of he)await a.existsDirectory((0,f.join)(ae,J))&&ce.push(J);return ce}function t(ae,he=1e3){return new Promise(ce=>{let J=!1;const Y=setInterval(()=>{J||(J=!0,P.access(ae,q=>{J=!1,q&&(clearInterval(Y),ce(void 0))}))},he)})}e.whenDeleted=t;var a;(function(ae){async function he(Y){let q;try{if(q=await e.Promises.lstat(Y),!q.isSymbolicLink())return{stat:q}}catch{}try{return{stat:await e.Promises.stat(Y),symbolicLink:q?.isSymbolicLink()?{dangling:!1}:void 0}}catch(W){if(W.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};if(c.isWindows&&W.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(Y)),symbolicLink:{dangling:!1}}}catch(H){if(H.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};throw H}throw W}}ae.stat=he;async function ce(Y){try{const{stat:q,symbolicLink:W}=await ae.stat(Y);return q.isFile()&&W?.dangling!==!0}catch{}return!1}ae.existsFile=ce;async function J(Y){try{const{stat:q,symbolicLink:W}=await ae.stat(Y);return q.isDirectory()&&W?.dangling!==!0}catch{}return!1}ae.existsDirectory=J})(a=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new A.ResourceQueue;function s(ae,he,ce){return i.queueFor(v.URI.file(ae),m.extUriBiasedIgnorePathCase).queue(()=>{const J=R(ce);return new Promise((Y,q)=>l(ae,he,J,W=>W?q(W):Y()))})}let n=!0;function h(ae){n=ae}e.configureFlushOnWrite=h;function l(ae,he,ce,J){if(!n)return P.writeFile(ae,he,{mode:ce.mode,flag:ce.flag},J);P.open(ae,ce.flag,ce.mode,(Y,q)=>{if(Y)return J(Y);P.writeFile(q,he,W=>{if(W)return P.close(q,()=>J(W));P.fdatasync(q,H=>(H&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",H),h(!1)),P.close(q,Q=>J(Q))))})})}function E(ae,he,ce){const J=R(ce);if(!n)return P.writeFileSync(ae,he,{mode:J.mode,flag:J.flag});const Y=P.openSync(ae,J.flag,J.mode);try{P.writeFileSync(Y,he);try{P.fdatasyncSync(Y)}catch(q){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",q),h(!1)}}finally{P.closeSync(Y)}}e.writeFileSync=E;function R(ae){return ae?{mode:typeof ae.mode=="number"?ae.mode:438,flag:typeof ae.flag=="string"?ae.flag:"w"}:{mode:438,flag:"w"}}async function C(ae,he){if(ae!==he)try{await e.Promises.rename(ae,he)}catch(ce){if(ae.toLowerCase()!==he.toLowerCase()&&ce.code==="EXDEV"||ae.endsWith("."))await T(ae,he,{preserveSymlinks:!1}),await d(ae,b.MOVE);else throw ce}}async function T(ae,he,ce){return z(ae,he,{root:{source:ae,target:he},options:ce,handledSourcePaths:new Set})}const N=511;async function z(ae,he,ce){if(ce.handledSourcePaths.has(ae))return;ce.handledSourcePaths.add(ae);const{stat:J,symbolicLink:Y}=await a.stat(ae);if(Y){if(ce.options.preserveSymlinks)try{return await ne(ae,he,ce)}catch(q){console.warn("[node.js fs] copy of symlink failed: ",q)}if(Y.dangling)return}return J.isDirectory()?B(ae,he,J.mode&N,ce):_(ae,he,J.mode&N)}async function B(ae,he,ce,J){await e.Promises.mkdir(he,{recursive:!0,mode:ce});const Y=await u(ae);for(const q of Y)await z((0,f.join)(ae,q),(0,f.join)(he,q),J)}async function _(ae,he,ce){await e.Promises.copyFile(ae,he),await e.Promises.chmod(he,ce)}async function ne(ae,he,ce){let J=await e.Promises.readlink(ae);(0,M.isEqualOrParent)(J,ce.root.source,!c.isLinux)&&(J=(0,f.join)(ce.root.target,J.substr(ce.root.source.length+1))),await e.Promises.symlink(J,he)}e.Promises=new class{get access(){return(0,o.promisify)(P.access)}get stat(){return(0,o.promisify)(P.stat)}get lstat(){return(0,o.promisify)(P.lstat)}get utimes(){return(0,o.promisify)(P.utimes)}get read(){return(ae,he,ce,J,Y)=>new Promise((q,W)=>{P.read(ae,he,ce,J,Y,(H,Q,se)=>H?W(H):q({bytesRead:Q,buffer:se}))})}get readFile(){return(0,o.promisify)(P.readFile)}get write(){return(ae,he,ce,J,Y)=>new Promise((q,W)=>{P.write(ae,he,ce,J,Y,(H,Q,se)=>H?W(H):q({bytesWritten:Q,buffer:se}))})}get appendFile(){return(0,o.promisify)(P.appendFile)}get fdatasync(){return(0,o.promisify)(P.fdatasync)}get truncate(){return(0,o.promisify)(P.truncate)}get rename(){return(0,o.promisify)(P.rename)}get copyFile(){return(0,o.promisify)(P.copyFile)}get open(){return(0,o.promisify)(P.open)}get close(){return(0,o.promisify)(P.close)}get symlink(){return(0,o.promisify)(P.symlink)}get readlink(){return(0,o.promisify)(P.readlink)}get chmod(){return(0,o.promisify)(P.chmod)}get mkdir(){return(0,o.promisify)(P.mkdir)}get unlink(){return(0,o.promisify)(P.unlink)}get rmdir(){return(0,o.promisify)(P.rmdir)}get realpath(){return(0,o.promisify)(P.realpath)}async exists(ae){try{return await e.Promises.access(ae),!0}catch{return!1}}get readdir(){return u}get readDirsInDir(){return D}get writeFile(){return s}get rm(){return d}get move(){return C}get copy(){return T}}}),define(ee[102],te([0,1,41,9,4,26,23]),function(G,e,P,L,o,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function k(b){if(o.isLinux)return b;const d=(0,L.dirname)(b);if(b===d)return b;const S=((0,L.basename)(b)||b).toLowerCase();try{const r=(0,M.readdirSync)(d).filter(u=>u.toLowerCase()===S);if(r.length===1){const u=k(d);if(u)return(0,L.join)(u,r[0])}else if(r.length>1){const u=r.indexOf(S);if(u>=0){const g=k(d);if(g)return(0,L.join)(g,r[u])}}}catch{}return null}e.realcaseSync=k;async function f(b){if(o.isLinux)return b;const d=(0,L.dirname)(b);if(b===d)return b;const S=((0,L.basename)(b)||b).toLowerCase();try{const r=(await M.Promises.readdir(d)).filter(u=>u.toLowerCase()===S);if(r.length===1){const u=await f(d);if(u)return(0,L.join)(u,r[0])}else if(r.length>1){const u=r.indexOf(S);if(u>=0){const g=await f(d);if(g)return(0,L.join)(g,r[u])}}}catch{}return null}e.realcase=f;async function c(b){try{return await M.Promises.realpath(b)}catch{const S=v(b);return await M.Promises.access(S,P.constants.R_OK),S}}e.realpath=c;function m(b){try{return P.realpathSync(b)}catch{const S=v(b);return P.accessSync(S,P.constants.R_OK),S}}e.realpathSync=m;function v(b){return(0,A.rtrim)((0,L.normalize)(b),L.sep)}}),define(ee[151],te([0,1,25,9,23]),function(G,e,P,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const A=/^\d+$/,M=/^Microsoft.PowerShell_.*/,k=/^Microsoft.PowerShellPreview_.*/;var f;(function(y){y[y.x64=0]="x64",y[y.x86=1]="x86",y[y.ARM=2]="ARM"})(f||(f={}));let c;switch(process.arch){case"ia32":case"x32":c=1;break;case"arm":case"arm64":c=2;break;default:c=0;break}let m;process.env.PROCESSOR_ARCHITEW6432?m=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?m=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?m=1:m=0;class v{constructor(D,t,a){this.exePath=D,this.displayName=t,this.a=a}async exists(){return this.a===void 0&&(this.a=await o.SymlinkSupport.existsFile(this.exePath)),this.a}}function b({useAlternateBitness:y=!1}={}){return y?c===0?process.env["ProgramFiles(x86)"]||null:m===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function d({useAlternateBitness:y=!1,findPreview:D=!1}={}){const t=b({useAlternateBitness:y});if(!t)return null;const a=L.join(t,"PowerShell");if(!await o.SymlinkSupport.existsDirectory(a))return null;let i=-1,s=null;for(const l of await o.Promises.readdir(a)){let E=-1;if(D){const C=l.indexOf("-");if(C<0)continue;const T=l.substring(0,C);if(!A.test(T)||l.substring(C+1)!=="preview")continue;E=parseInt(T,10)}else{if(!A.test(l))continue;E=parseInt(l,10)}if(E<=i)continue;const R=L.join(a,l,"pwsh.exe");!await o.SymlinkSupport.existsFile(R)||(s=R,i=E)}if(!s)return null;const n=t.includes("x86")?" (x86)":"",h=D?" Preview":"";return new v(s,`PowerShell${h}${n}`,!0)}async function S({findPreview:y}={}){if(!process.env.LOCALAPPDATA)return null;const D=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await o.SymlinkSupport.existsDirectory(D))return null;const{pwshMsixDirRegex:t,pwshMsixName:a}=y?{pwshMsixDirRegex:k,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:M,pwshMsixName:"PowerShell (Store)"};for(const i of await o.Promises.readdir(D))if(t.test(i)){const s=L.join(D,i,"pwsh.exe");return new v(s,a)}return null}function w(){const y=L.join(P.homedir(),".dotnet","tools","pwsh.exe");return new v(y,".NET Core PowerShell Global Tool")}function r(){const y=L.join(process.env.windir,c===1&&m!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new v(y,"Windows PowerShell",!0)}async function*u(){let y=await d();y&&(yield y),y=await d({useAlternateBitness:!0}),y&&(yield y),y=await S(),y&&(yield y),y=w(),y&&(yield y),y=await d({findPreview:!0}),y&&(yield y),y=await S({findPreview:!0}),y&&(yield y),y=await d({useAlternateBitness:!0,findPreview:!0}),y&&(yield y),y=r(),y&&(yield y)}async function*g(){for await(const y of u())await y.exists()&&(yield y)}e.enumeratePowerShellInstallations=g;async function p(){for await(const y of g())return y;return null}e.getFirstAvailablePowerShellInstallation=p}),define(ee[86],te([0,1,9,4,36,74,11,23]),function(G,e,P,L,o,A,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function f(v=o.env){return v.comspec||"cmd.exe"}e.getWindowsShell=f;function c(v){let b=[],d=!1;const S=function(w){if(d){b.push(w);return}(!v.send(w,u=>{if(u&&console.error(u),d=!1,b.length>0){const g=b.slice(0);b=[],g.forEach(p=>S(p))}})||L.isWindows)&&(d=!0)};return{send:S}}e.createQueuedSender=c;var m;(function(v){async function b(d,S,w){if(P.isAbsolute(d))return d;if(S===void 0&&(S=o.cwd()),P.dirname(d)!=="."||(w===void 0&&M.isString(o.env.PATH)&&(w=o.env.PATH.split(P.delimiter)),w===void 0||w.length===0))return P.join(S,d);async function u(g){if(await k.Promises.exists(g)){let p;try{p=await k.Promises.stat(g)}catch(y){y.message.startsWith("EACCES")&&(p=await k.Promises.lstat(g))}return p?!p.isDirectory():!1}return!1}for(const g of w){let p;if(P.isAbsolute(g)?p=P.join(g,d):p=P.join(S,g,d),await u(p))return p;let y=p+".com";if(await u(y)||(y=p+".exe",await u(y)))return y}return P.join(S,d)}v.findExecutable=b})(m=e.win32||(e.win32={}))}),define(ee[103],te([0,1,46,14]),function(G,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function o(M){return new Promise((k,f)=>{let c;const m=new Map;function v(d,S,w,r,u){const g=m.get(S);if(d===M||g){const p={name:b(w),cmd:w,pid:d,ppid:S,load:r,mem:u};m.set(d,p),d===M&&(c=p),g&&(g.children||(g.children=[]),g.children.push(p),g.children.length>1&&(g.children=g.children.sort((y,D)=>y.pid-D.pid)))}}function b(d){const S=/--utility-sub-type=network/i,w=/--ms-enable-electron-run-as-node/i,r=/--crashes-directory/i,u=/\\pipe\\winpty-control/i,g=/conhost\.exe/i,p=/--type=([a-zA-Z-]+)/;if(r.exec(d))return"electron-crash-reporter";if(u.exec(d))return"winpty-process";if(g.exec(d))return"console-window-host (Windows internal process)";let y=p.exec(d);if(y&&y.length===2)return y[1]==="renderer"?"window":y[1]==="utility"?S.exec(d)?"utility-network-service":"utility-process":y[1]==="extensionHost"?"extension-host":y[1];const D=/[a-zA-Z-]+\.js/g;let t="";do y=D.exec(d),y&&(t+=y+" ");while(y);return t&&d.indexOf("node ")<0&&d.indexOf("node.exe")<0?`electron-nodejs (${t})`:w.exec(d)?`electron-nodejs (${d})`:d}if(process.platform==="win32"){const d=S=>S.indexOf("\\\\?\\")===0||S.indexOf("\\??\\")===0?S.substr(4):S.indexOf('"\\\\?\\')===0||S.indexOf('"\\??\\')===0?'"'+S.substr(5):S;new Promise((S,w)=>{G(["windows-process-tree"],S,w)}).then(S=>{S.getProcessList(M,w=>{if(!w){f(new Error(`Root process ${M} not found`));return}S.getProcessCpuUsage(w,r=>{const u=new Map;r.forEach(g=>{const p=d(g.commandLine||"");u.set(g.pid,{name:b(p),cmd:p,pid:g.pid,ppid:g.ppid,load:g.cpu||0,mem:g.memory||0})}),c=u.get(M),c?(u.forEach(g=>{const p=u.get(g.ppid);p&&(p.children||(p.children=[]),p.children.push(g))}),u.forEach(g=>{g.children&&(g.children=g.children.sort((p,y)=>p.pid-y.pid))}),k(c)):f(new Error(`Root process ${M} not found`))})},S.ProcessDataFlag.CommandLine|S.ProcessDataFlag.Memory)})}else{let d=function(){let S=[c];const w=[];for(;S.length;){const u=S.shift();u&&(w.push(u.pid),u.children&&(S=S.concat(u.children)))}let r=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);r+=" "+w.join(" "),(0,P.exec)(r,{},(u,g,p)=>{if(u||p)f(u||new Error(p.toString()));else{const y=g.toString().split(`
`);for(let D=0;D<w.length;D++){const t=m.get(w[D]);t.load=parseFloat(y[D])}if(!c){f(new Error(`Root process ${M} not found`));return}k(c)}})};(0,P.exec)("which ps",{},(S,w,r)=>{if(S||r)if(process.platform!=="linux")f(S||new Error(r.toString()));else{const u=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,P.exec)(u,{},(g,p,y)=>{g||y?f(g||new Error(y.toString())):(A(p,v),d())})}else{const u=w.toString().trim(),g="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,P.exec)(`${u} ${g}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(p,y,D)=>{p||D&&!D.includes("screen size is bogus")?f(p||new Error(D.toString())):(A(y,v),process.platform==="linux"?d():c?k(c):f(new Error(`Root process ${M} not found`)))})}})}})}e.listProcesses=o;function A(M,k){const f=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,c=M.toString().split(`
`);for(const m of c){const v=f.exec(m.trim());v&&v.length===6&&k(parseInt(v[1]),parseInt(v[2]),v[5],parseFloat(v[3]),parseFloat(v[4]))}}}),define(ee[152],te([0,1,25,4,151,86]),function(G,e,P,L,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function M(v,b){return v===1?L.isWindows?m():A.getWindowsShell(b):f(v,b)}e.getSystemShell=M;let k=null;function f(v,b){if(L.isLinux&&v===2||L.isMacintosh&&v===3)return"/bin/bash";if(!k){let d;if(L.isWindows)d="/bin/bash";else{if(d=b.SHELL,!d)try{d=(0,P.userInfo)().shell}catch{}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}k=d}return k}let c=null;async function m(){return c||(c=(await(0,o.getFirstAvailablePowerShellInstallation)()).exePath),c}});var ye=this&&this.__decorate||function(G,e,P,L){var o=arguments.length,A=o<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,P):L,M;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(G,e,P,L);else for(var k=G.length-1;k>=0;k--)(M=G[k])&&(A=(o<3?M(A):o>3?M(e,P,A):M(e,P))||A);return o>3&&A&&Object.defineProperty(e,P,A),A};define(ee[47],te([0,1,27,7,17,22,55,13,3,2,84,26,11]),function(G,e,P,L,o,A,M,k,f,c,m,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var d;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})(d||(d={}));function S(q){switch(q){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(w||(w={}));function r(q){switch(q){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})(u||(u={}));function g(q){let W=0;for(let H=0;;H+=7){const Q=q.read(1);if(W|=(Q.buffer[0]&127)<<H,!(Q.buffer[0]&128))return W}}const p=i(0);function y(q,W){if(W===0){q.write(p);return}let H=0;for(let se=W;se!==0;se=se>>>7)H++;const Q=o.VSBuffer.alloc(H);for(let se=0;W!==0;se++)Q.buffer[se]=W&127,W=W>>>7,W>0&&(Q.buffer[se]|=128);q.write(Q)}class D{constructor(W){this.b=W,this.a=0}read(W){const H=this.b.slice(this.a,this.a+W);return this.a+=H.byteLength,H}}e.BufferReader=D;class t{constructor(){this.a=[]}get buffer(){return o.VSBuffer.concat(this.a)}write(W){this.a.push(W)}}e.BufferWriter=t;var a;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object",q[q.Int=6]="Int"})(a||(a={}));function i(q){const W=o.VSBuffer.alloc(1);return W.writeUInt8(q,0),W}const s={Undefined:i(a.Undefined),String:i(a.String),Buffer:i(a.Buffer),VSBuffer:i(a.VSBuffer),Array:i(a.Array),Object:i(a.Object),Uint:i(a.Int)},n=typeof Buffer<"u";function h(q,W){if(typeof W>"u")q.write(s.Undefined);else if(typeof W=="string"){const H=o.VSBuffer.fromString(W);q.write(s.String),y(q,H.byteLength),q.write(H)}else if(n&&Buffer.isBuffer(W)){const H=o.VSBuffer.wrap(W);q.write(s.Buffer),y(q,H.byteLength),q.write(H)}else if(W instanceof o.VSBuffer)q.write(s.VSBuffer),y(q,W.byteLength),q.write(W);else if(Array.isArray(W)){q.write(s.Array),y(q,W.length);for(const H of W)h(q,H)}else if(typeof W=="number"&&(W|0)===W)q.write(s.Uint),y(q,W);else{const H=o.VSBuffer.fromString(JSON.stringify(W));q.write(s.Object),y(q,H.byteLength),q.write(H)}}e.serialize=h;function l(q){switch(q.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return q.read(g(q)).toString();case a.Buffer:return q.read(g(q)).buffer;case a.VSBuffer:return q.read(g(q));case a.Array:{const H=g(q),Q=[];for(let se=0;se<H;se++)Q.push(l(q));return Q}case a.Object:return JSON.parse(q.read(g(q)).toString());case a.Int:return g(q)}}e.deserialize=l;class E{constructor(W,H,Q=null,se=1e3){this.h=W,this.j=H,this.k=Q,this.l=se,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(re=>this.q(re)),this.m({type:200})}registerChannel(W,H){this.b.set(W,H),setTimeout(()=>this.w(W),0)}m(W){switch(W.type){case 200:{const H=this.o([W.type]);this.k?.logOutgoing(H,0,1,r(W.type));return}case 201:case 202:case 204:case 203:{const H=this.o([W.type,W.id],W.data);this.k?.logOutgoing(H,W.id,1,r(W.type),W.data);return}}}o(W,H=void 0){const Q=new t;return h(Q,W),h(Q,H),this.p(Q.buffer)}p(W){try{return this.h.send(W),W.byteLength}catch{return 0}}q(W){const H=new D(W),Q=l(H),se=l(H),re=Q[0];switch(re){case 100:return this.k?.logIncoming(W.byteLength,Q[1],1,`${S(re)}: ${Q[2]}.${Q[3]}`,se),this.s({type:re,id:Q[1],channelName:Q[2],name:Q[3],arg:se});case 102:return this.k?.logIncoming(W.byteLength,Q[1],1,`${S(re)}: ${Q[2]}.${Q[3]}`,se),this.t({type:re,id:Q[1],channelName:Q[2],name:Q[3],arg:se});case 101:return this.k?.logIncoming(W.byteLength,Q[1],1,`${S(re)}`),this.u({type:re,id:Q[1]});case 103:return this.k?.logIncoming(W.byteLength,Q[1],1,`${S(re)}`),this.u({type:re,id:Q[1]})}}s(W){const H=this.b.get(W.channelName);if(!H){this.v(W);return}const Q=new A.CancellationTokenSource;let se;try{se=H.call(this.j,W.name,W.arg,Q.token)}catch(I){se=Promise.reject(I)}const re=W.id;se.then(I=>{this.m({id:re,data:I,type:201}),this.d.delete(W.id)},I=>{I instanceof Error?this.m({id:re,data:{message:I.message,name:I.name,stack:I.stack?I.stack.split?I.stack.split(`
`):I.stack:void 0},type:202}):this.m({id:re,data:I,type:203}),this.d.delete(W.id)});const F=(0,c.toDisposable)(()=>Q.cancel());this.d.set(W.id,F)}t(W){const H=this.b.get(W.channelName);if(!H){this.v(W);return}const Q=W.id,re=H.listen(this.j,W.name,W.arg)(F=>this.m({id:Q,data:F,type:204}));this.d.set(W.id,re)}u(W){const H=this.d.get(W.id);H&&(H.dispose(),this.d.delete(W.id))}v(W){let H=this.g.get(W.channelName);H||(H=[],this.g.set(W.channelName,H));const Q=setTimeout(()=>{console.error(`Unknown channel: ${W.channelName}`),W.type===100&&this.m({id:W.id,data:{name:"Unknown channel",message:`Channel name '${W.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);H.push({request:W,timeoutTimer:Q})}w(W){const H=this.g.get(W);if(H){for(const Q of H)switch(clearTimeout(Q.timeoutTimer),Q.request.type){case 100:this.s(Q.request);break;case 102:this.t(Q.request);break}this.g.delete(W)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=E;var R;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(R=e.RequestInitiator||(e.RequestInitiator={}));class C{constructor(W,H=null){this.l=W,this.a=!1,this.b=u.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new f.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(Q=>this.s(Q)),this.j=H}getChannel(W){const H=this;return{call(Q,se,re){return H.a?Promise.reject(new k.CancellationError):H.m(W,Q,se,re)},listen(Q,se){return H.a?f.Event.None:H.o(W,Q,se)}}}m(W,H,Q,se=A.CancellationToken.None){const re=this.g++,I={id:re,type:100,channelName:W,name:H,arg:Q};if(se.isCancellationRequested)return Promise.reject(new k.CancellationError);let O;return new Promise((j,x)=>{if(se.isCancellationRequested)return x(new k.CancellationError);const $=()=>{const fe=Ce=>{switch(Ce.type){case 201:this.f.delete(re),j(Ce.data);break;case 202:{this.f.delete(re);const Ee=new Error(Ce.data.message);Ee.stack=Array.isArray(Ce.data.stack)?Ce.data.stack.join(`
`):Ce.data.stack,Ee.name=Ce.data.name,x(Ee);break}case 203:this.f.delete(re),x(Ce.data);break}};this.f.set(re,fe),this.p(I)};let V=null;this.b===u.Idle?$():(V=(0,L.createCancelablePromise)(fe=>this.u()),V.then(()=>{V=null,$()}));const K=()=>{V?(V.cancel(),V=null):this.p({id:re,type:101}),x(new k.CancellationError)},oe=se.onCancellationRequested(K);O=(0,c.combinedDisposable)((0,c.toDisposable)(K),oe),this.d.add(O)}).finally(()=>{this.d.delete(O)})}o(W,H,Q){const se=this.g++,F={id:se,type:102,channelName:W,name:H,arg:Q};let I=null;const O=new f.Emitter({onWillAddFirstListener:()=>{I=(0,L.createCancelablePromise)(j=>this.u()),I.then(()=>{I=null,this.d.add(O),this.p(F)})},onDidRemoveLastListener:()=>{I?(I.cancel(),I=null):(this.d.delete(O),this.p({id:se,type:103}))}}),U=j=>O.fire(j.data);return this.f.set(se,U),O.event}p(W){switch(W.type){case 100:case 102:{const H=this.q([W.type,W.id,W.channelName,W.name],W.arg);this.j?.logOutgoing(H,W.id,0,`${S(W.type)}: ${W.channelName}.${W.name}`,W.arg);return}case 101:case 103:{const H=this.q([W.type,W.id]);this.j?.logOutgoing(H,W.id,0,S(W.type));return}}}q(W,H=void 0){const Q=new t;return h(Q,W),h(Q,H),this.r(Q.buffer)}r(W){try{return this.l.send(W),W.byteLength}catch{return 0}}s(W){const H=new D(W),Q=l(H),se=l(H),re=Q[0];switch(re){case 200:return this.j?.logIncoming(W.byteLength,0,0,r(re)),this.t({type:Q[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(W.byteLength,Q[1],0,r(re),se),this.t({type:Q[0],id:Q[1],data:se})}}t(W){if(W.type===200){this.b=u.Idle,this.k.fire();return}this.f.get(W.id)?.(W)}get onDidInitializePromise(){return f.Event.toPromise(this.onDidInitialize)}u(){return this.b===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.dispose)(this.d.values()),this.d.clear()}}ye([M.memoize],C.prototype,"onDidInitializePromise",null),e.ChannelClient=C;class T{get connections(){const W=[];return this.f.forEach(H=>W.push(H)),W}constructor(W){this.a=new Map,this.f=new Set,this.g=new f.Emitter,this.onDidAddConnection=this.g.event,this.h=new f.Emitter,this.onDidRemoveConnection=this.h.event,W(({protocol:H,onDidClientDisconnect:Q})=>{f.Event.once(H.onMessage)(re=>{const F=new D(re),I=l(F),O=new E(H,I),U=new C(H);this.a.forEach((x,$)=>O.registerChannel($,x));const j={channelServer:O,channelClient:U,ctx:I};this.f.add(j),this.g.fire(j),Q(()=>{O.dispose(),U.dispose(),this.f.delete(j),this.h.fire(j)})})})}getChannel(W,H){const Q=this;return{call(se,re,F){let I;if((0,b.isFunction)(H)){const U=(0,P.getRandomElement)(Q.connections.filter(H));I=U?Promise.resolve(U):f.Event.toPromise(f.Event.filter(Q.onDidAddConnection,H))}else I=H.routeCall(Q,se,re);const O=I.then(U=>U.channelClient.getChannel(W));return z(O).call(se,re,F)},listen(se,re){if((0,b.isFunction)(H))return Q.j(W,H,se,re);const F=H.routeEvent(Q,se,re).then(I=>I.channelClient.getChannel(W));return z(F).listen(se,re)}}}j(W,H,Q,se){const re=this;let F=new c.DisposableStore;const I=new f.Emitter({onWillAddFirstListener:()=>{F=new c.DisposableStore;const O=new f.EventMultiplexer,U=new Map,j=$=>{const K=$.channelClient.getChannel(W).listen(Q,se),oe=O.add(K);U.set($,oe)},x=$=>{const V=U.get($);!V||(V.dispose(),U.delete($))};re.connections.filter(H).forEach(j),f.Event.filter(re.onDidAddConnection,H)(j,void 0,F),re.onDidRemoveConnection(x,void 0,F),O.event(I.fire,I,F),F.add(O)},onDidRemoveLastListener:()=>{F.dispose()}});return I.event}registerChannel(W,H){this.a.set(W,H),this.f.forEach(Q=>{Q.channelServer.registerChannel(W,H)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=T;class N{constructor(W,H,Q=null){const se=new t;h(se,H),W.send(se.buffer),this.a=new C(W,Q),this.d=new E(W,H,Q)}getChannel(W){return this.a.getChannel(W)}registerChannel(W,H){this.d.registerChannel(W,H)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=N;function z(q){return{call(W,H,Q){return q.then(se=>se.call(W,H,Q))},listen(W,H){const Q=new f.Relay;return q.then(se=>Q.input=se.listen(W,H)),Q.event}}}e.getDelayedChannel=z;function B(q){let W=!1;return{call(H,Q,se){return W?q.call(H,Q,se):(0,L.timeout)(0).then(()=>W=!0).then(()=>q.call(H,Q,se))},listen(H,Q){if(W)return q.listen(H,Q);const se=new f.Relay;return(0,L.timeout)(0).then(()=>W=!0).then(()=>se.input=q.listen(H,Q)),se.event}}}e.getNextTickChannel=B;class _{constructor(W){this.a=W}routeCall(W){return this.b(W)}routeEvent(W){return this.b(W)}async b(W){for(const H of W.connections)if(await Promise.resolve(this.a(H.ctx)))return Promise.resolve(H);return await f.Event.toPromise(W.onDidAddConnection),await this.b(W)}}e.StaticRouter=_;var ne;(function(q){function W(re,F){const I=re,O=F&&F.disableMarshalling,U=new Map;for(const j in I)Q(j)&&U.set(j,f.Event.buffer(I[j],!0));return new class{listen(j,x,$){const V=U.get(x);if(V)return V;if(se(x)){const K=I[x];if(typeof K=="function")return K.call(I,$)}throw new Error(`Event not found: ${x}`)}call(j,x,$){const V=I[x];if(typeof V=="function"){if(!O&&Array.isArray($))for(let K=0;K<$.length;K++)$[K]=(0,m.revive)($[K]);return V.apply(I,$)}throw new Error(`Method not found: ${x}`)}}}q.fromService=W;function H(re,F){const I=F&&F.disableMarshalling;return new Proxy({},{get(O,U){if(typeof U=="string")return F?.properties?.has(U)?F.properties.get(U):se(U)?function(j){return re.listen(U,j)}:Q(U)?re.listen(U):async function(...j){let x;F&&!(0,b.isUndefinedOrNull)(F.context)?x=[F.context,...j]:x=j;const $=await re.call(U,x);return I?$:(0,m.revive)($)};throw new Error(`Property not found: ${String(U)}`)}})}q.toService=H;function Q(re){return re[0]==="o"&&re[1]==="n"&&v.isUpperAsciiLetter(re.charCodeAt(2))}function se(re){return/^onDynamic/.test(re)&&v.isUpperAsciiLetter(re.charCodeAt(9))}})(ne=e.ProxyChannel||(e.ProxyChannel={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function he(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){const W=q.toString();if(W!=="[object Object]")return W}return q}function ce(q){return Array.isArray(q)?q.map(he):he(q)}function J(q,W,H,Q,se,re,F){F=ce(F);const I=ae[se],O=I[Q%I.length];let U=[`%c[${q}]%c[${String(W).padStart(7," ")}]%c[len: ${String(H).padStart(5," ")}]%c${String(Q).padStart(5," ")} - ${re}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(re)?(U=U.concat(F),U.push(")")):U.push(F),console.log.apply(console,U)}class Y{constructor(W,H){this.d=W,this.f=H,this.a=0,this.b=0}logOutgoing(W,H,Q,se,re){this.b+=W,J(this.d,this.b,W,H,Q,se,re)}logIncoming(W,H,Q,se,re){this.a+=W,J(this.f,this.a,W,H,Q,se,re)}}e.IPCLogger=Y}),define(ee[153],te([0,1,17,3,47]),function(G,e,P,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class A{constructor(f){this.a=f,this.onMessage=L.Event.fromDOMEventEmitter(this.a,"message",c=>P.VSBuffer.wrap(c.data)),f.start()}send(f){this.a.postMessage(f.buffer)}disconnect(){this.a.close()}}e.Protocol=A;class M extends o.IPCClient{constructor(f,c){const m=new A(f);super(m,c),this.b=m}dispose(){this.b.disconnect()}}e.Client=M}),define(ee[104],te([0,1,7,17,3,2,47]),function(G,e,P,L,o,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var k;(function(C){C.Created="created",C.Read="read",C.Write="write",C.Open="open",C.Error="error",C.Close="close",C.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",C.NodeEndReceived="nodeEndReceived",C.NodeEndSent="nodeEndSent",C.NodeDrainBegin="nodeDrainBegin",C.NodeDrainEnd="nodeDrainEnd",C.zlibInflateError="zlibInflateError",C.zlibInflateData="zlibInflateData",C.zlibInflateInitialWrite="zlibInflateInitialWrite",C.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",C.zlibInflateWrite="zlibInflateWrite",C.zlibInflateFlushFired="zlibInflateFlushFired",C.zlibDeflateError="zlibDeflateError",C.zlibDeflateData="zlibDeflateData",C.zlibDeflateWrite="zlibDeflateWrite",C.zlibDeflateFlushFired="zlibDeflateFlushFired",C.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",C.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",C.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",C.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",C.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",C.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",C.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",C.ProtocolHeaderRead="protocolHeaderRead",C.ProtocolMessageRead="protocolMessageRead",C.ProtocolHeaderWrite="protocolHeaderWrite",C.ProtocolMessageWrite="protocolMessageWrite",C.ProtocolWrite="protocolWrite"})(k=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var f;(function(C){C.enableDiagnostics=!1,C.records=[];const T=new WeakMap;let N=0;function z(_,ne){if(!T.has(_)){const ae=String(++N);T.set(_,ae)}return T.get(_)}function B(_,ne,ae,he){if(!C.enableDiagnostics)return;const ce=z(_,ne);if(he instanceof L.VSBuffer||he instanceof Uint8Array||he instanceof ArrayBuffer||ArrayBuffer.isView(he)){const J=L.VSBuffer.alloc(he.byteLength);J.set(he),C.records.push({timestamp:Date.now(),id:ce,label:ne,type:ae,buff:J})}else C.records.push({timestamp:Date.now(),id:ce,label:ne,type:ae,data:he})}C.traceSocketEvent=B})(f=e.SocketDiagnostics||(e.SocketDiagnostics={}));var c;(function(C){C[C.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",C[C.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(c=e.SocketCloseEventType||(e.SocketCloseEventType={}));let m=null;function v(){return m||(m=L.VSBuffer.alloc(0)),m}class b{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(T){this.a.push(T),this.b+=T.byteLength}read(T){return this.c(T,!0)}peek(T){return this.c(T,!1)}c(T,N){if(T===0)return v();if(T>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===T){const ne=this.a[0];return N&&(this.a.shift(),this.b-=T),ne}if(this.a[0].byteLength>T){const ne=this.a[0].slice(0,T);return N&&(this.a[0]=this.a[0].slice(T),this.b-=T),ne}const z=L.VSBuffer.alloc(T);let B=0,_=0;for(;T>0;){const ne=this.a[_];if(ne.byteLength>T){const ae=ne.slice(0,T);z.set(ae,B),B+=T,N&&(this.a[_]=ne.slice(T),this.b-=T),T-=T}else z.set(ne,B),B+=ne.byteLength,N?(this.a.shift(),this.b-=ne.byteLength):_++,T-=ne.byteLength}return z}}e.ChunkStream=b;var d;(function(C){C[C.None=0]="None",C[C.Regular=1]="Regular",C[C.Control=2]="Control",C[C.Ack=3]="Ack",C[C.Disconnect=5]="Disconnect",C[C.ReplayRequest=6]="ReplayRequest",C[C.Pause=7]="Pause",C[C.Resume=8]="Resume",C[C.KeepAlive=9]="KeepAlive",C[C.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",C[C.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(d||(d={}));function S(C){switch(C){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var w;(function(C){C[C.HeaderLength=13]="HeaderLength",C[C.AcknowledgeTime=2e3]="AcknowledgeTime",C[C.TimeoutTime=2e4]="TimeoutTime",C[C.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",C[C.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",C[C.KeepAliveSendTime=5e3]="KeepAliveSendTime",C[C.LatencySampleTime=6e4]="LatencySampleTime",C[C.LatencySampleCount=5]="LatencySampleCount",C[C.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",C[C.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(w=e.ProtocolConstants||(e.ProtocolConstants={}));class r{constructor(T,N,z,B){this.type=T,this.id=N,this.ack=z,this.data=B,this.writtenTime=0}get size(){return this.data.byteLength}}class u extends A.Disposable{constructor(T){super(),this.f=this.D(new o.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=T,this.b=!1,this.c=new b,this.D(this.a.onData(N=>this.acceptChunk(N))),this.lastReadTime=Date.now()}acceptChunk(T){if(!(!T||T.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(T);this.c.byteLength>=this.g.readLen;){const N=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=N.readUInt32BE(9),this.g.messageType=N.readUInt8(0),this.g.id=N.readUInt32BE(1),this.g.ack=N.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:S(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const z=this.g.messageType,B=this.g.id,_=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",N),this.f.fire(new r(z,B,_,N)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class g{constructor(T){this.k=null,this.a=!1,this.b=!1,this.c=T,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(T){if(this.a)return;T.writtenTime=Date.now(),this.lastWriteTime=Date.now();const N=L.VSBuffer.alloc(13);N.writeUInt8(T.type,0),N.writeUInt32BE(T.id,1),N.writeUInt32BE(T.ack,5),N.writeUInt32BE(T.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:S(T.type),id:T.id,ack:T.ack,messageSize:T.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",T.data),this.j(N,T.data)}g(T,N){const z=this.f===0;return this.d.push(T,N),this.f+=T.byteLength+N.byteLength,z}h(){const T=L.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,T}j(T,N){this.g(T,N)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const T=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:T.byteLength}),this.c.write(T)}}class p extends A.Disposable{constructor(T){super(),this.f=new o.Emitter,this.onMessage=this.f.event,this.g=new o.Emitter,this.onDidDispose=this.g.event,this.a=T,this.b=this.D(new g(this.a)),this.c=this.D(new u(this.a)),this.D(this.c.onMessage(N=>{N.type===1&&this.f.fire(N.data)})),this.D(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(T){this.b.write(new r(1,0,0,T))}}e.Protocol=p;class y extends M.IPCClient{static fromSocket(T,N){return new y(new p(T),N)}get onDidDispose(){return this.b.onDidDispose}constructor(T,N,z=null){super(T,N,z),this.b=T}dispose(){super.dispose();const T=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),T.end()}}e.Client=y;class D{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new o.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(T){this.b?this.d.length>0?this.d.push(T):this.a.fire(T):this.d.push(T)}flushBuffer(){this.d=[]}}e.BufferedEmitter=D;class t{constructor(T){this.data=T,this.next=null}}class a{constructor(){this.a=null,this.b=null}length(){let T=0,N=this.a;for(;N;)N=N.next,T++;return T}peek(){return this.a?this.a.data:null}toArray(){const T=[];let N=0,z=this.a;for(;z;)T[N++]=z.data,z=z.next;return T}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(T){const N=new t(T);if(!this.a){this.a=N,this.b=N;return}this.b.next=N,this.b=N}}class i{static getInstance(){return i.b||(i.b=new i),i.b}constructor(){this.c=[];const T=Date.now();for(let N=0;N<i.a;N++)this.c[N]=T-1e3*N;setInterval(()=>{for(let N=i.a;N>=1;N--)this.c[N]=this.c[N-1];this.c[0]=Date.now()},1e3)}d(){const T=Date.now(),N=(1+i.a)*1e3;let z=0;for(let B=0;B<i.a;B++)T-this.c[B]<=N&&z++;return 1-z/i.a}hasHighLoad(){return this.d()>=.5}}i.a=10,i.b=null;var s;(function(C){C[C.Good=0]="Good",C[C.Poor=1]="Poor"})(s=e.ConnectionHealth||(e.ConnectionHealth={}));function n(C){switch(C){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=n;class h{constructor(T){this.connectionHealth=T}}e.ConnectionHealthChangedEvent=h;class l{constructor(T,N){this.roundTripTime=T,this.recentHighRoundTripCount=N}}e.HighRoundTripTimeEvent=l;class E{get unacknowledgedCount(){return this.c-this.d}constructor(T){this.x=new D,this.onControlMessage=this.x.event,this.y=new D,this.onMessage=this.y.event,this.z=new D,this.onDidDispose=this.z.event,this.A=new D,this.onSocketClose=this.A.event,this.B=new D,this.onSocketTimeout=this.B.event,this.C=new D,this.onHighRoundTripTime=this.C.event,this.D=new D,this.onDidChangeConnectionHealth=this.D.event,this.u=T.loadEstimator??i.getInstance(),this.v=T.measureRoundTripTime??!1,this.w=T.sendKeepAlive??!0,this.a=!1,this.b=new a,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new A.DisposableStore,this.o=T.socket,this.p=this.t.add(new g(this.o)),this.q=this.t.add(new u(this.o)),this.t.add(this.q.onMessage(N=>this.E(N))),this.t.add(this.o.onClose(N=>this.A.fire(N))),this.r=this.t.add(new R),this.t.add(this.r.onSendLatencyRequest(N=>this.J(N))),this.t.add(this.r.onHighRoundTripTime(N=>this.C.fire(N))),this.t.add(this.r.onDidChangeConnectionHealth(N=>this.D.fire(N))),this.v&&this.r.start(),T.initialChunk&&this.q.acceptChunk(T.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const T=new r(5,0,0,v());this.p.write(T),this.p.flush()}sendPause(){const T=new r(7,0,0,v());this.p.write(T)}sendResume(){const T=new r(8,0,0,v());this.p.write(T)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(T,N){this.a=!0,this.t.dispose(),this.t=new A.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=T,this.p=this.t.add(new g(this.o)),this.q=this.t.add(new u(this.o)),this.t.add(this.q.onMessage(z=>this.E(z))),this.t.add(this.o.onClose(z=>this.A.fire(z))),this.r=this.t.add(new R),this.t.add(this.r.onSendLatencyRequest(z=>this.J(z))),this.t.add(this.r.onHighRoundTripTime(z=>this.C.fire(z))),this.t.add(this.r.onDidChangeConnectionHealth(z=>this.D.fire(z))),this.q.acceptChunk(N)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const T=new r(3,0,this.h,v());this.p.write(T);const N=this.b.toArray();for(let z=0,B=N.length;z<B;z++)this.p.write(N[z]);this.G()}acceptDisconnect(){this.z.fire()}E(T){if(T.ack>this.d){this.d=T.ack;do{const N=this.b.peek();if(N&&N.id<=T.ack)this.b.pop();else break}while(!0)}switch(T.type){case 0:break;case 1:{if(T.id>this.g)if(T.id!==this.g+1){const N=Date.now();N-this.m>1e4&&(this.m=N,this.p.write(new r(6,0,0,v())))}else this.g=T.id,this.j=Date.now(),this.F(),this.y.fire(T.data);break}case 2:{this.x.fire(T.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const N=this.b.toArray();for(let z=0,B=N.length;z<B;z++)this.p.write(N[z]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(T.data);break}case 11:{this.r.handleResponse(T.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(T){const N=++this.c;this.h=this.g;const z=new r(1,N,this.h,T);this.b.push(z),this.a||(this.p.write(z),this.G())}sendControl(T){const N=new r(2,0,0,T);this.p.write(N)}F(){if(this.g<=this.h||this.k)return;const T=Date.now()-this.j;if(T>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-T+5)}G(){if(this.c<=this.d||this.f||this.a)return;const T=this.b.peek(),N=Date.now()-T.writtenTime,z=Date.now()-this.q.lastReadTime,B=Date.now()-this.n;if(N>=2e4&&z>=2e4&&B>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:N,timeSinceLastReceivedSomeData:z});return}const _=Math.max(2e4-N,2e4-z,2e4-B,500);this.f=setTimeout(()=>{this.f=null,this.G()},_)}H(){if(this.g<=this.h)return;this.h=this.g;const T=new r(3,0,this.h,v());this.p.write(T)}I(){this.h=this.g;const T=new r(9,0,this.h,v());this.p.write(T)}J(T){this.h=this.g;const N=new r(10,0,this.h,T);this.p.write(N)}K(T){this.h=this.g;const N=new r(11,0,this.h,T);this.p.write(N)}}e.PersistentProtocol=E;class R extends A.Disposable{constructor(){super(),this.a=this.D(new o.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.D(new o.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.D(new o.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.D(new P.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},T=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const T=++this.h,N=L.VSBuffer.alloc(4);N.writeUInt32BE(T,0),this.a.fire(N)},6e4)}handleResponse(T){if(T.byteLength!==4)return;const N=T.readUInt32BE(0);if(this.g<=0||N!==this.h)return;const z=Date.now()-this.g,B=this.k++;this.j[B%this.j.length]=z;const _=this.l,ne=this.j.filter(ae=>ae>=1e3).length;this.l=ne>=3?1:0,z>1e3&&this.b.fire(new l(z,ne)),_!==this.l&&this.c.fire(this.l)}}}),define(ee[154],te([0,1,42,17,3,2,47,139]),function(G,e,P,L,o,A,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function f(m,v){const b=o.Event.fromNodeEventEmitter(P.validatedIpcMain,v,(S,w)=>({event:S,message:w})),d=o.Event.filter(b,({event:S})=>S.sender.id===m);return o.Event.map(d,({message:S})=>S&&L.VSBuffer.wrap(S))}class c extends M.IPCServer{static d(){const v=o.Event.fromNodeEventEmitter(P.validatedIpcMain,"vscode:hello",({sender:b})=>b);return o.Event.map(v,b=>{const d=b.id;c.b.get(d)?.dispose();const w=new o.Emitter;c.b.set(d,(0,A.toDisposable)(()=>w.fire()));const r=f(d,"vscode:message"),u=o.Event.any(o.Event.signal(f(d,"vscode:disconnect")),w.event);return{protocol:new k.Protocol(b,r),onDidClientDisconnect:u}})}constructor(){super(c.d())}}c.b=new Map,e.Server=c}),define(ee[105],te([0,1,42,3,31,153]),function(G,e,P,L,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class M extends A.Client{constructor(c,m){super({addEventListener:(v,b)=>c.addListener(v,b),removeEventListener:(v,b)=>c.removeListener(v,b),postMessage:v=>c.postMessage(v),start:()=>c.start(),close:()=>c.close()},m)}}e.Client=M;async function k(f){if(f.isDestroyed()||f.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const c=(0,o.generateUuid)();f.webContents.send("vscode:createMessageChannel",c);const m=L.Event.fromNodeEventEmitter(P.validatedIpcMain,"vscode:createMessageChannelResult",(b,d)=>({nonce:d,port:b.ports[0]})),{port:v}=await L.Event.toPromise(L.Event.once(L.Event.filter(m,b=>b.nonce===c)));return v}e.connect=k}),define(ee[155],te([0,1,46,7,17,22,148,13,3,2,37,86,74,47]),function(G,e,P,L,o,A,M,k,f,c,m,v,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class S extends d.ChannelServer{constructor(u){super({send:g=>{try{process.send?.(g.buffer.toString("base64"))}catch{}},onMessage:f.Event.fromNodeEventEmitter(process,"message",g=>o.VSBuffer.wrap(Buffer.from(g,"base64")))},u),process.once("disconnect",()=>this.dispose())}}e.Server=S;class w{constructor(u,g){this.i=u,this.j=g,this.c=new Set,this.g=new Map,this.h=new f.Emitter,this.onDidProcessExit=this.h.event;const p=g&&g.timeout?g.timeout:6e4;this.b=new L.Delayer(p),this.d=null,this.f=null}getChannel(u){const g=this;return{call(p,y,D){return g.k(u,p,y,D)},listen(p,y){return g.l(u,p,y)}}}k(u,g,p,y=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(y.isCancellationRequested)return Promise.reject(k.canceled());this.b.cancel();const D=this.n(u),t=(0,L.createCancelablePromise)(s=>D.call(g,p,s)),a=y.onCancellationRequested(()=>t.cancel()),i=(0,c.toDisposable)(()=>t.cancel());return this.c.add(i),t.finally(()=>{a.dispose(),this.c.delete(i),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(u,g,p){if(!this.b)return f.Event.None;this.b.cancel();let y;const D=new f.Emitter({onWillAddFirstListener:()=>{y=this.n(u).listen(g,p)(D.fire,D),this.c.add(y)},onDidRemoveLastListener:()=>{this.c.delete(y),y.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return D.event}get m(){if(!this.f){const u=this.j&&this.j.args?this.j.args:[],g=Object.create(null);g.env={...(0,m.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(g.env={...g.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(g.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(g.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(g.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),g.execArgv===void 0&&(g.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,b.removeDangerousEnvVariables)(g.env),this.d=(0,P.fork)(this.i,u,g);const p=new f.Emitter;f.Event.fromNodeEventEmitter(this.d,"message",n=>n)(n=>{if((0,M.isRemoteConsoleLog)(n)){(0,M.log)(n,`IPC Library: ${this.j.serverName}`);return}p.fire(o.VSBuffer.wrap(Buffer.from(n,"base64")))});const D=this.j.useQueue?(0,v.createQueuedSender)(this.d):this.d,t=n=>this.d&&this.d.connected&&D.send(n.buffer.toString("base64")),a=p.event,i={send:t,onMessage:a};this.f=new d.ChannelClient(i);const s=()=>this.o();process.once("exit",s),this.d.on("error",n=>console.warn('IPC "'+this.j.serverName+'" errored with '+n)),this.d.on("exit",(n,h)=>{process.removeListener("exit",s),this.c.forEach(l=>(0,c.dispose)(l)),this.c.clear(),n!==0&&h!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+n+" and signal "+h),this.b?.cancel(),this.o(),this.h.fire({code:n,signal:h})})}return this.f}n(u){let g=this.g.get(u);return g||(g=this.m.getChannel(u),this.g.set(u,g)),g}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=w}),define(ee[106],te([0,1,7,3,2,11]),function(G,e,P,L,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var M;(function(v){v[v.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",v[v.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(M=e.StorageHint||(e.StorageHint={}));function k(v){const b=v;return b?.changed instanceof Map||b?.deleted instanceof Set}e.isStorageItemsChangeEvent=k;var f;(function(v){v[v.None=0]="None",v[v.Initialized=1]="Initialized",v[v.Closed=2]="Closed"})(f=e.StorageState||(e.StorageState={}));class c extends o.Disposable{constructor(b,d=Object.create(null)){super(),this.m=b,this.n=d,this.b=this.D(new L.Emitter),this.onDidChangeStorage=this.b.event,this.c=f.None,this.f=new Map,this.g=new P.ThrottledDelayer(c.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.D(this.m.onDidChangeItemsExternal(b=>this.q(b)))}q(b){b.changed?.forEach((d,S)=>this.r(S,d)),b.deleted?.forEach(d=>this.r(d,void 0))}r(b,d){if(this.c===f.Closed)return;let S=!1;(0,A.isUndefinedOrNull)(d)?S=this.f.delete(b):this.f.get(b)!==d&&(this.f.set(b,d),S=!0),S&&this.b.fire(b)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===f.None&&(this.c=f.Initialized,this.n.hint!==M.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(b,d){const S=this.f.get(b);return(0,A.isUndefinedOrNull)(S)?d:S}getBoolean(b,d){const S=this.get(b);return(0,A.isUndefinedOrNull)(S)?d:S==="true"}getNumber(b,d){const S=this.get(b);return(0,A.isUndefinedOrNull)(S)?d:parseInt(S,10)}async set(b,d){if(this.c===f.Closed)return;if((0,A.isUndefinedOrNull)(d))return this.delete(b);const S=String(d);if(this.f.get(b)!==S)return this.f.set(b,S),this.j.set(b,S),this.h.delete(b),this.b.fire(b),this.v()}async delete(b){if(!(this.c===f.Closed||!this.f.delete(b)))return this.h.has(b)||this.h.add(b),this.j.delete(b),this.b.fire(b),this.v()}async close(){return this.k||(this.k=this.s()),this.k}async s(){this.c=f.Closed;try{await this.v(0)}catch{}await this.m.close(()=>this.f)}get t(){return this.j.size>0||this.h.size>0}async u(){if(!this.t)return;const b={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(b).finally(()=>{if(!this.t)for(;this.l.length;)this.l.pop()?.()})}async flush(b){if(!!this.t)return this.v(b)}async v(b){return this.g.trigger(()=>this.u(),b)}async whenFlushed(){if(!!this.t)return new Promise(b=>this.l.push(b))}isInMemory(){return this.n.hint===M.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}c.a=100,e.Storage=c;class m{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(b){b.insert?.forEach((d,S)=>this.a.set(S,d)),b.delete?.forEach(d=>this.a.delete(d))}async close(){}}e.InMemoryStorageDatabase=m}),define(ee[156],te([0,1,7,3,35,9,23]),function(G,e,P,L,o,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class k{get onDidChangeItemsExternal(){return L.Event.None}constructor(m,v=Object.create(null)){this.g=m,this.h=v,this.c=(0,A.basename)(this.g),this.d=new f(this.h.logging),this.f=this.n(this.g)}async getItems(){const m=await this.f,v=new Map;return(await this.s(m,"SELECT * FROM ItemTable")).forEach(d=>v.set(d.key,d.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${v.size} rows`),v}async updateItems(m){const v=await this.f;return this.j(v,m)}j(m,v){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${v.insert?(0,o.mapToString)(v.insert):"0"}), delete(${v.delete?(0,o.setToString)(v.delete):"0"})`),this.t(m,()=>{const b=v.insert,d=v.delete;if(b&&b.size>0){const S=[];S.push([]);let w=0;b.forEach((r,u)=>{let g=S[w];g.length>k.b&&(w++,g=[],S.push(g)),g.push(u,r)}),S.forEach(r=>{this.u(m,`INSERT INTO ItemTable VALUES ${new Array(r.length/2).fill("(?,?)").join(",")}`,u=>u.run(r),()=>{const u=[];let g=0;return b.forEach((p,y)=>{u.push(y),g+=p.length}),`Keys: ${u.join(", ")} Length: ${g}`})})}if(d&&d.size){const S=[];S.push([]);let w=0;d.forEach(r=>{let u=S[w];u.length>k.b&&(w++,u=[],S.push(u)),u.push(r)}),S.forEach(r=>{this.u(m,`DELETE FROM ItemTable WHERE key IN (${new Array(r.length).fill("?").join(",")})`,u=>u.run(r),()=>{const u=[];return d.forEach(g=>{u.push(g)}),`Keys: ${u.join(", ")}`})})}})}async close(m){this.d.trace(`[storage ${this.c}] close()`);const v=await this.f;return this.k(v,m)}k(m,v){return new Promise((b,d)=>{m.db.close(S=>(S&&this.o(m,`[storage ${this.c}] close(): ${S}`),this.g===k.IN_MEMORY_PATH?b():!m.isErroneous&&!m.isInMemory?this.l().then(b,w=>(this.d.error(`[storage ${this.c}] backup(): ${w}`),b())):typeof v=="function"?M.Promises.unlink(this.g).then(()=>this.p(this.g).then(w=>{const r=()=>this.k(w,void 0);return this.j(w,{insert:v()}).then(()=>r(),u=>(r(),Promise.reject(u)))})).then(b,d):d(S||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const m=this.m(this.g);return M.Promises.copy(this.g,m,{preserveSymlinks:!1})}m(m){return`${m}.backup`}async checkIntegrity(m){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${m})`);const v=await this.f,b=await this.r(v,m?"PRAGMA integrity_check":"PRAGMA quick_check"),d=m?b.integrity_check:b.quick_check;return v.isErroneous?`${d} (last error: ${v.lastError})`:v.isInMemory?`${d} (in-memory!)`:d}async n(m,v=!0){this.d.trace(`[storage ${this.c}] open(${m}, retryOnBusy: ${v})`);try{return await this.p(m)}catch(b){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${b}`),b.code==="SQLITE_BUSY"&&v)return await(0,P.timeout)(k.a),this.n(m,!1);try{await M.Promises.unlink(m);try{await M.Promises.rename(this.m(m),m)}catch{}return await this.p(m)}catch(d){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${d}`),this.p(k.IN_MEMORY_PATH)}}}o(m,v){m.isErroneous=!0,m.lastError=v,this.d.error(v)}p(m){return new Promise((v,b)=>{new Promise((d,S)=>{G(["@vscode/sqlite3"],d,S)}).then(d=>{const S={db:new(this.d.isTracing?d.verbose().Database:d.Database)(m,w=>w?S.db&&w.code!=="SQLITE_CANTOPEN"?S.db.close(()=>b(w)):b(w):this.q(S,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>v(S),r=>S.db.close(()=>b(r)))),isInMemory:m===k.IN_MEMORY_PATH};S.db.on("error",w=>this.o(S,`[storage ${this.c}] Error (event): ${w}`)),this.d.isTracing&&S.db.on("trace",w=>this.d.trace(`[storage ${this.c}] Trace (event): ${w}`))},b)})}q(m,v){return new Promise((b,d)=>{m.db.exec(v,S=>S?(this.o(m,`[storage ${this.c}] exec(): ${S}`),d(S)):b())})}r(m,v){return new Promise((b,d)=>{m.db.get(v,(S,w)=>S?(this.o(m,`[storage ${this.c}] get(): ${S}`),d(S)):b(w))})}s(m,v){return new Promise((b,d)=>{m.db.all(v,(S,w)=>S?(this.o(m,`[storage ${this.c}] all(): ${S}`),d(S)):b(w))})}t(m,v){return new Promise((b,d)=>{m.db.serialize(()=>{m.db.run("BEGIN TRANSACTION"),v(),m.db.run("END TRANSACTION",S=>S?(this.o(m,`[storage ${this.c}] transaction(): ${S}`),d(S)):b())})})}u(m,v,b,d){const S=m.db.prepare(v),w=r=>{this.o(m,`[storage ${this.c}] prepare(): ${r} (${v}). Details: ${d()}`)};S.on("error",w),b(S),S.finalize(r=>{r&&w(r),S.removeListener("error",w)})}}k.IN_MEMORY_PATH=":memory:",k.a=2e3,k.b=256,e.SQLiteStorageDatabase=k;class f{constructor(m){m&&typeof m.logTrace=="function"&&process.env[f.VSCODE_TRACE_STORAGE]&&(this.a=m.logTrace),m&&typeof m.logError=="function"&&(this.b=m.logError)}get isTracing(){return!!this.a}trace(m){this.a?.(m)}error(m){this.b?.(m)}}f.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(ee[157],te([12,10]),function(G,e){return G.create("vs/code/electron-main/app",e)}),define(ee[158],te([12,10]),function(G,e){return G.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ee[159],te([12,10]),function(G,e){return G.create("vs/platform/contextkey/common/contextkey",e)}),define(ee[160],te([12,10]),function(G,e){return G.create("vs/platform/contextkey/common/scanner",e)}),define(ee[161],te([12,10]),function(G,e){return G.create("vs/platform/dialogs/common/dialogs",e)}),define(ee[162],te([12,10]),function(G,e){return G.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(ee[163],te([12,10]),function(G,e){return G.create("vs/platform/environment/node/argv",e)}),define(ee[164],te([12,10]),function(G,e){return G.create("vs/platform/environment/node/argvHelper",e)}),define(ee[165],te([12,10]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ee[166],te([12,10]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ee[167],te([12,10]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ee[168],te([12,10]),function(G,e){return G.create("vs/platform/extensions/common/extensionValidator",e)}),define(ee[169],te([12,10]),function(G,e){return G.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ee[170],te([12,10]),function(G,e){return G.create("vs/platform/files/common/fileService",e)}),define(ee[171],te([12,10]),function(G,e){return G.create("vs/platform/files/common/files",e)}),define(ee[172],te([12,10]),function(G,e){return G.create("vs/platform/files/common/io",e)}),define(ee[173],te([12,10]),function(G,e){return G.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(ee[174],te([12,10]),function(G,e){return G.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ee[175],te([12,10]),function(G,e){return G.create("vs/platform/issue/electron-main/issueMainService",e)}),define(ee[176],te([12,10]),function(G,e){return G.create("vs/platform/menubar/electron-main/menubar",e)}),define(ee[177],te([12,10]),function(G,e){return G.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(ee[178],te([12,10]),function(G,e){return G.create("vs/platform/request/common/request",e)}),define(ee[179],te([12,10]),function(G,e){return G.create("vs/platform/shell/node/shellEnv",e)}),define(ee[180],te([12,10]),function(G,e){return G.create("vs/platform/telemetry/common/telemetryService",e)}),define(ee[181],te([12,10]),function(G,e){return G.create("vs/platform/update/common/update.config.contribution",e)}),define(ee[182],te([12,10]),function(G,e){return G.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ee[183],te([12,10]),function(G,e){return G.create("vs/platform/windows/electron-main/windowImpl",e)}),define(ee[184],te([12,10]),function(G,e){return G.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(ee[185],te([12,10]),function(G,e){return G.create("vs/platform/workspace/common/workspace",e)}),define(ee[186],te([12,10]),function(G,e){return G.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(ee[187],te([12,10]),function(G,e){return G.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(ee[188],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function P(o){return o&&o.hasOwnProperty("folderUri")}e.isFolderBackupInfo=P;function L(o){return o&&o.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=L}),define(ee[189],te([0,1,8]),function(G,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeFolderInfos=e.deserializeWorkspaceInfos=e.isEmptyWindowBackupInfo=void 0;function L(M){return typeof M?.backupFolder=="string"}e.isEmptyWindowBackupInfo=L;function o(M){let k=[];try{Array.isArray(M.workspaces)&&(k=M.workspaces.map(f=>({workspace:{id:f.id,configPath:P.URI.parse(f.configURIPath)},remoteAuthority:f.remoteAuthority})))}catch{}return k}e.deserializeWorkspaceInfos=o;function A(M){let k=[];try{Array.isArray(M.folders)&&(k=M.folders.map(f=>({folderUri:P.URI.parse(f.folderUri),remoteAuthority:f.remoteAuthority})))}catch{}return k}e.deserializeFolderInfos=A}),define(ee[190],te([0,1,13,160]),function(G,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var o;(function(c){c[c.LParen=0]="LParen",c[c.RParen=1]="RParen",c[c.Neg=2]="Neg",c[c.Eq=3]="Eq",c[c.NotEq=4]="NotEq",c[c.Lt=5]="Lt",c[c.LtEq=6]="LtEq",c[c.Gt=7]="Gt",c[c.GtEq=8]="GtEq",c[c.RegexOp=9]="RegexOp",c[c.RegexStr=10]="RegexStr",c[c.True=11]="True",c[c.False=12]="False",c[c.In=13]="In",c[c.Not=14]="Not",c[c.And=15]="And",c[c.Or=16]="Or",c[c.Str=17]="Str",c[c.QuotedStr=18]="QuotedStr",c[c.Error=19]="Error",c[c.EOF=20]="EOF"})(o=e.TokenType||(e.TokenType={}));function A(...c){switch(c.length){case 1:return(0,L.localize)(0,null,c[0]);case 2:return(0,L.localize)(1,null,c[0],c[1]);case 3:return(0,L.localize)(2,null,c[0],c[1],c[2]);default:return}}const M=(0,L.localize)(3,null),k=(0,L.localize)(4,null);class f{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(m){switch(m.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return m.isTripleEq?"===":"==";case 4:return m.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return m.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return m.lexeme;case 18:return m.lexeme;case 19:return m.lexeme;case 20:return"EOF";default:throw(0,P.illegalState)(`unhandled token type: ${JSON.stringify(m)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(m){return this.c=m,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const v=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:v})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const v=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:v})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(m){return this.r()||this.c.charCodeAt(this.e)!==m?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(m){this.f.push({type:m,offset:this.d})}l(m){const v=this.d,b=this.c.substring(this.d,this.e),d={type:19,offset:this.d,lexeme:b};this.g.push({offset:v,lexeme:b,additionalInfo:m}),this.f.push(d)}n(){this.m.lastIndex=this.d;const m=this.m.exec(this.c);if(m){this.e=this.d+m[0].length;const v=this.c.substring(this.d,this.e),b=f.b.get(v);b?this.k(b):this.f.push({type:17,lexeme:v,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(M);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let m=this.e,v=!1,b=!1;for(;;){if(m>=this.c.length){this.e=m,this.l(k);return}const S=this.c.charCodeAt(m);if(v)v=!1;else if(S===47&&!b){m++;break}else S===91?b=!0:S===92?v=!0:S===93&&(b=!1);m++}for(;m<this.c.length&&f.a.has(this.c.charCodeAt(m));)m++;this.e=m;const d=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:d,offset:this.d})}r(){return this.e>=this.c.length}}f.a=new Set(["i","g","s","m","y","u"].map(c=>c.charCodeAt(0))),f.b=new Map([["not",14],["in",13],["false",12],["true",11]]),e.Scanner=f}),define(ee[191],te([0,1,3,2]),function(G,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class o{constructor(){this.a=new P.Emitter,this.b=new P.Emitter,this.c=new P.Emitter,this.d=new P.Emitter}call(k,f,c){switch(f){case"close":return Promise.resolve(this.a.fire({sessionId:c[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:c[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:c[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:c[0],port:c[1],subId:c[2]}))}throw new Error("Method not implemented.")}listen(k,f,c){switch(f){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}o.ChannelName="extensionhostdebugservice",e.ExtensionHostDebugBroadcastChannel=o;class A extends L.Disposable{constructor(k){super(),this.b=k}reload(k){this.b.call("reload",[k])}get onReload(){return this.b.listen("reload")}close(k){this.b.call("close",[k])}get onClose(){return this.b.listen("close")}attachSession(k,f,c){this.b.call("attach",[k,f,c])}get onAttachSession(){return this.b.listen("attach")}terminateSession(k,f){this.b.call("terminate",[k,f])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(k,f){return this.b.call("openExtensionDevelopmentHostWindow",[k,f])}}e.ExtensionHostDebugChannelClient=A}),define(ee[192],te([0,1,142,55,14,9,36,18,8]),function(G,e,P,L,o,A,M,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class c{get appRoot(){return(0,A.dirname)(o.FileAccess.asFileUri("").fsPath)}get userHome(){return f.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return f.URI.file((0,A.join)(this.userDataPath,"User"))}get tmpDir(){return f.URI.file(this.b.tmpDir)}get cacheHome(){return f.URI.file(this.userDataPath)}get stateResource(){return(0,k.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,k.joinPath)(this.userRoamingDataHome,"sync")}get logsHome(){if(!this.args.logsPath){const d=(0,P.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.join)(this.userDataPath,"logs",d)}return f.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,k.joinPath)(f.URI.file((0,A.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,k.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,k.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,k.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=M.env.VSCODE_PORTABLE;return d?f.URI.file((0,A.join)(d,"argv.json")):(0,k.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return f.URI.file((0,A.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,A.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,A.resolve)(d):(0,A.normalize)((0,A.join)(o.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const d=this.args["extensions-download-dir"];return d?f.URI.file((0,A.resolve)(d)):f.URI.file((0,A.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,A.resolve)(d);const S=M.env.VSCODE_EXTENSIONS;if(S)return S;const w=M.env.VSCODE_PORTABLE;return w?(0,A.join)(w,"extensions"):(0,k.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(S=>/^[^:/?#]+?:\/\//.test(S)?f.URI.parse(S):f.URI.file((0,A.normalize)(S)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?f.URI.parse(d):f.URI.file((0,A.normalize)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return m(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!M.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(d=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(d))}get extensionLogLevel(){const d=[];for(const S of this.args.log||[]){const w=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(S);w&&w[1]&&w[2]&&d.push([w[1],w[2]])}return d.length?d:void 0}get serviceMachineIdResource(){return(0,k.joinPath)(f.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const d=M.env.VSCODE_PORTABLE;return d?f.URI.file((0,A.join)(d,"policy.json")):(0,k.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(d){this.args.continueOn=d}get args(){return this.a}constructor(d,S,w){this.a=d,this.b=S,this.c=w,this.editSessionId=this.args.editSessionId}}ye([L.memoize],c.prototype,"appRoot",null),ye([L.memoize],c.prototype,"userHome",null),ye([L.memoize],c.prototype,"userDataPath",null),ye([L.memoize],c.prototype,"appSettingsHome",null),ye([L.memoize],c.prototype,"tmpDir",null),ye([L.memoize],c.prototype,"cacheHome",null),ye([L.memoize],c.prototype,"stateResource",null),ye([L.memoize],c.prototype,"userRoamingDataHome",null),ye([L.memoize],c.prototype,"userDataSyncHome",null),ye([L.memoize],c.prototype,"sync",null),ye([L.memoize],c.prototype,"machineSettingsResource",null),ye([L.memoize],c.prototype,"workspaceStorageHome",null),ye([L.memoize],c.prototype,"localHistoryHome",null),ye([L.memoize],c.prototype,"keyboardLayoutResource",null),ye([L.memoize],c.prototype,"argvResource",null),ye([L.memoize],c.prototype,"isExtensionDevelopment",null),ye([L.memoize],c.prototype,"untitledWorkspacesHome",null),ye([L.memoize],c.prototype,"installSourcePath",null),ye([L.memoize],c.prototype,"builtinExtensionsPath",null),ye([L.memoize],c.prototype,"extensionsPath",null),ye([L.memoize],c.prototype,"extensionDevelopmentLocationURI",null),ye([L.memoize],c.prototype,"extensionDevelopmentKind",null),ye([L.memoize],c.prototype,"extensionTestsLocationURI",null),ye([L.memoize],c.prototype,"debugExtensionHost",null),ye([L.memoize],c.prototype,"logLevel",null),ye([L.memoize],c.prototype,"extensionLogLevel",null),ye([L.memoize],c.prototype,"serviceMachineIdResource",null),ye([L.memoize],c.prototype,"disableTelemetry",null),ye([L.memoize],c.prototype,"disableWorkspaceTrust",null),ye([L.memoize],c.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=c;function m(b,d){return v(b["inspect-extensions"],b["inspect-brk-extensions"],5870,d,b.debugId,b.extensionEnvironment)}e.parseExtensionHostDebugPort=m;function v(b,d,S,w,r,u){const p=Number(d||b)||(w?null:S),y=p?Boolean(!!d):!1;let D;if(u)try{D=JSON.parse(u)}catch{}return{port:p,break:y,debugId:r,env:D}}e.parseDebugParams=v}),define(ee[107],te([0,1,291,4,163]),function(G,e,P,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const A={o:(0,o.localize)(0,null),e:(0,o.localize)(1,null),t:(0,o.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,o.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,o.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,o.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,o.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,o.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,o.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,o.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,o.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,o.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,o.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,o.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,o.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,o.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,o.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,o.localize)(17,null)},category:{type:"string",cat:"e",description:(0,o.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,o.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,o.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,o.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,o.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,o.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,o.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,o.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,o.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,o.localize)(27,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,o.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,o.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,o.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,o.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,o.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,o.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,o.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,o.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const M={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function k(w,r,u=M){const g=w.find(h=>h.length>0&&h[0]!=="-"),p={},y=["_"],D=[],t={};let a;for(const h in r){const l=r[h];l.type==="subcommand"?h===g&&(a=l):(l.alias&&(p[h]=l.alias),l.type==="string"||l.type==="string[]"?(y.push(h),l.deprecates&&y.push(...l.deprecates)):l.type==="boolean"&&(D.push(h),l.deprecates&&D.push(...l.deprecates)),l.global&&(t[h]=l))}if(a&&g){const h=t;for(const C in a.options)h[C]=a.options[C];const l=w.filter(C=>C!==g),E=u.getSubcommandReporter?u.getSubcommandReporter(g):void 0,R=k(l,h,E);return{[g]:R,_:[]}}const i=P(w,{string:y,boolean:D,alias:p}),s={},n=i;s._=i._.map(h=>String(h)).filter(h=>h.length>0),delete n._;for(const h in r){const l=r[h];if(l.type==="subcommand")continue;l.alias&&delete n[l.alias];let E=n[h];if(l.deprecates)for(const R of l.deprecates)n.hasOwnProperty(R)&&(E||(E=n[R],E&&u.onDeprecatedOption(R,l.deprecationMessage||(0,o.localize)(36,null,h))),delete n[R]);if(typeof E<"u"){if(l.type==="string[]"){if(Array.isArray(E)||(E=[E]),!l.allowEmptyValue){const R=E.filter(C=>C.length>0);R.length!==E.length&&(u.onEmptyValue(h),E=R.length>0?R:void 0)}}else l.type==="string"&&(Array.isArray(E)?(E=E.pop(),u.onMultipleValues(h,E)):!E&&!l.allowEmptyValue&&(u.onEmptyValue(h),E=void 0));s[h]=E,l.deprecationMessage&&u.onDeprecatedOption(h,l.deprecationMessage)}delete n[h]}for(const h in n)u.onUnknownOption(h);return s}e.parseArgs=k;function f(w,r){let u="";return r.args&&(Array.isArray(r.args)?u=` <${r.args.join("> <")}>`:u=` <${r.args}>`),r.alias?`-${r.alias} --${w}${u}`:`--${w}${u}`}function c(w,r){const u=[];for(const g in w){const p=w[g],y=f(g,p);u.push([y,p.description])}return m(u,r)}e.formatOptions=c;function m(w,r){const g=w.reduce((D,t)=>Math.max(D,t[0].length),12)+2+1;if(r-g<25)return w.reduce((D,t)=>D.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const p=r-g-1,y=[];for(const D of w){const t=D[0],a=b(D[1],p),i=v(g-t.length-2);y.push("  "+t+i+a[0]);for(let s=1;s<a.length;s++)y.push(v(g)+a[s])}return y}function v(w){return" ".repeat(w)}function b(w,r){const u=[];for(;w.length;){const g=w.length<r?w.length:w.lastIndexOf(" ",r),p=w.slice(0,g).trim();w=w.slice(g),u.push(p)}return u}function d(w,r,u,g,p){const y=process.stdout.isTTY&&process.stdout.columns||80,D=p?.noInputFiles!==!0?`[${(0,o.localize)(37,null)}...]`:"",t=[`${w} ${u}`];t.push(""),t.push(`${(0,o.localize)(38,null)}: ${r} [${(0,o.localize)(39,null)}]${D}`),t.push(""),p?.noPipe!==!0&&(L.isWindows?t.push((0,o.localize)(40,null,r)):t.push((0,o.localize)(41,null,r)),t.push(""));const a={},i=[];for(const s in g){const n=g[s];if(n.type==="subcommand")n.description&&i.push({command:s,description:n.description});else if(n.description&&n.cat){let h=a[n.cat];h||(a[n.cat]=h={}),h[s]=n}}for(const s in a){const n=s,h=a[n];h&&(t.push(A[n]),t.push(...c(h,y)),t.push(""))}return i.length&&(t.push((0,o.localize)(42,null)),t.push(...m(i.map(s=>[s.command,s.description]),y)),t.push("")),t.join(`
`)}e.buildHelpMessage=d;function S(w,r){return`${w||(0,o.localize)(43,null)}
${r||(0,o.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=S}),define(ee[193],te([0,1,73,191,107]),function(G,e,P,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class A extends L.ExtensionHostDebugBroadcastChannel{constructor(k){super(),this.f=k}call(k,f,c){return f==="openExtensionDevelopmentHostWindow"?this.g(c[0],c[1]):super.call(k,f,c)}async g(k,f){const c=(0,o.parseArgs)(k,o.OPTIONS);c.debugRenderer=f;const m=c.extensionDevelopmentPath;if(!m)return{success:!1};const[v]=await this.f.openExtensionDevelopmentHostWindow(m,{context:5,cli:c,forceProfile:c.profile,forceTempProfile:c["profile-temp"]});if(!f)return{success:!0};const b=v.win;if(!b)return{success:!0};const d=b.webContents.debugger;let S=d.isAttached()?1/0:0;const w=(0,P.createServer)(r=>{S++===0&&d.attach();let u=!1;const g=D=>{u||r.write(JSON.stringify(D)+"\0")},p=(D,t,a,i)=>g({method:t,params:a,sessionId:i});b.on("close",()=>{d.removeListener("message",p),r.end(),u=!0}),d.addListener("message",p);let y=Buffer.alloc(0);r.on("data",D=>{y=Buffer.concat([y,D]);for(let t=y.indexOf(0);t!==-1;t=y.indexOf(0)){let a;try{const i=y.slice(0,t).toString("utf8");y=y.slice(t+1),a=JSON.parse(i)}catch(i){console.error("error reading cdp line",i)}d.sendCommand(a.method,a.params,a.sessionId).then(i=>g({id:a.id,sessionId:a.sessionId,result:i})).catch(i=>g({id:a.id,sessionId:a.sessionId,error:{code:0,message:i.message}}))}}),r.on("error",D=>{console.error("error on cdp pipe:",D)}),r.on("close",()=>{u=!0,--S===0&&d.detach()})});return await new Promise(r=>w.listen(0,r)),b.on("close",()=>w.close()),{rendererDebugPort:w.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=A}),define(ee[62],te([0,1,292,164,107]),function(G,e,P,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const A=2048;function M(b,d){const S=(y,D)=>{console.warn((0,L.localize)(0,null,y,D))},w=y=>{console.warn((0,L.localize)(1,null,y))},r=(y,D)=>{console.warn((0,L.localize)(2,null,y,D))},u=y=>({onUnknownOption:D=>{y!=="tunnel"&&console.warn((0,L.localize)(3,null,D,y))},onMultipleValues:S,onEmptyValue:w,onDeprecatedOption:r,getSubcommandReporter:y!=="tunnel"?u:void 0}),g={onUnknownOption:y=>{console.warn((0,L.localize)(4,null,y))},onMultipleValues:S,onEmptyValue:w,onDeprecatedOption:r,getSubcommandReporter:u},p=(0,o.parseArgs)(b,o.OPTIONS,d?g:void 0);return p.goto&&p._.forEach(y=>P(/^(\w:)?[^:]+(:\d*){0,2}$/.test(y),(0,L.localize)(5,null))),p["max-memory"]&&P(parseInt(p["max-memory"])>=A,`The max-memory argument cannot be specified lower than ${A} MB.`),p}function k(b){const d=b.findIndex(S=>!/^-/.test(S));if(d>-1)return[...b.slice(0,d),...b.slice(d+1)]}function f(b){let[,...d]=b;process.env.VSCODE_DEV&&(d=k(d)||[]);const S=!v(process.env);return M(d,S)}e.parseMainProcessArgv=f;function c(b){let[,,...d]=b;return process.env.VSCODE_DEV&&(d=k(d)||[]),M(d,!0)}e.parseCLIProcessArgv=c;function m(b,...d){const S=b.indexOf("--");return S===-1?b.push(...d):b.splice(S,0,...d),b}e.addArg=m;function v(b){return b.VSCODE_CLI==="1"}e.isLaunchedFromCli=v}),function(){"use strict";function G(e,P,L){function o(M,k){const f=A(M,k),c=[f];return e.isAbsolute(f)||c.unshift(L),e.resolve(...c)}function A(M,k){process.env.VSCODE_DEV&&(k="code-oss-dev");const f=process.env.VSCODE_PORTABLE;if(f)return e.join(f,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return e.join(c,k);const m=M["user-data-dir"];if(m)return m;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const v=process.env.USERPROFILE;if(typeof v!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=e.join(v,"AppData","Roaming")}break;case"darwin":c=e.join(P.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||e.join(P.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(c,k)}return{getUserDataPath:o}}if(typeof define=="function")define(ee[194],te([195,25,36]),function(e,P,L){return G(e,P,L.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),P=require("os");module.exports=G(e,P,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ee[108],te([0,1,25,192,194]),function(G,e,P,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class A extends L.AbstractNativeEnvironmentService{constructor(c,m){super(c,{homeDir:(0,P.homedir)(),tmpDir:(0,P.tmpdir)(),userDataDir:(0,o.getUserDataPath)(c,m.nameShort)},m)}}e.NativeEnvironmentService=A;function M(f,c){return(0,L.parseDebugParams)(f["inspect-ptyhost"],f["inspect-brk-ptyhost"],5877,c,f.extensionEnvironment)}e.parsePtyHostDebugPort=M;function k(f,c){return(0,L.parseDebugParams)(f["inspect-sharedprocess"],f["inspect-brk-sharedprocess"],5879,c,f.extensionEnvironment)}e.parseSharedProcessDebugPort=k}),define(ee[196],te([0,1,41,25,32]),function(G,e,P,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFileSync=void 0;function A(M){const k=(0,o.randomPath)((0,L.tmpdir)());try{return(0,P.writeFileSync)(k,""),M&&console.log(`Marker file for --wait created: ${k}`),k}catch(f){M&&console.error(`Failed to create marker file for --wait: ${f}`);return}}e.createWaitMarkerFileSync=A}),define(ee[197],te([0,1,11,166]),function(G,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function o(M,k,f){try{A(M,k,f)}catch(c){console.error(c?.message??c)}return M}e.localizeManifest=o;function A(M,k,f){const c=(m,v,b)=>{const d=m[v];if((0,P.isString)(d)){const S=d,w=S.length;if(w>1&&S[0]==="%"&&S[w-1]==="%"){const r=S.substr(1,w-2);let u=k[r];u===void 0&&f&&(u=f[r]);const g=typeof u=="string"?u:u?.message,p=f?.[r],y=typeof p=="string"?p:p?.message;if(!g){y||console.warn(`[${M.name}]: ${(0,L.localize)(0,null,r)}`);return}if(b&&(v==="title"||v==="category")&&y&&y!==g){const D={value:g,original:y};m[v]=D}else m[v]=g}}else if((0,P.isObject)(d))for(const S in d)d.hasOwnProperty(S)&&(S==="commands"?c(d,S,!0):c(d,S,b));else if(Array.isArray(d))for(let S=0;S<d.length;S++)c(d,S,b)};for(const m in M)M.hasOwnProperty(m)&&c(M,m)}}),define(ee[198],te([0,1,18,76,168,199]),function(G,e,P,L,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function f(u){return u=u.trim(),u==="*"||M.test(u)}e.isValidVersionStr=f;function c(u){if(!f(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const g=u.match(M);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=c;function m(u){if(!u)return null;const g=u.majorBase,p=u.majorMustEqual,y=u.minorBase;let D=u.minorMustEqual;const t=u.patchBase;let a=u.patchMustEqual;u.hasCaret&&(g===0||(D=!1),a=!1);let i=0;if(u.preRelease){const s=k.exec(u.preRelease);if(s){const[,n,h,l]=s;i=Date.UTC(Number(n),Number(h)-1,Number(l))}}return{majorBase:g,majorMustEqual:p,minorBase:y,minorMustEqual:D,patchBase:t,patchMustEqual:a,isMinimum:u.hasGreaterEquals,notBefore:i}}e.normalizeVersion=m;function v(u,g,p){let y;typeof u=="string"?y=m(c(u)):y=u;let D;g instanceof Date?D=g.getTime():typeof g=="string"&&(D=new Date(g).getTime());let t;if(typeof p=="string"?t=m(c(p)):t=p,!y||!t)return!1;const a=y.majorBase,i=y.minorBase,s=y.patchBase;let n=t.majorBase,h=t.minorBase,l=t.patchBase;const E=t.notBefore;let R=t.majorMustEqual,C=t.minorMustEqual,T=t.patchMustEqual;return t.isMinimum?a>n?!0:a<n?!1:i>h?!0:i<h||D&&D<E?!1:s>=l:(a===1&&n===0&&(!R||!C||!T)&&(n=1,h=0,l=0,R=!0,C=!1,T=!1),a<n?!1:a>n?!R:i<h?!1:i>h?!C:s<l?!1:s>l?!T:!(D&&D<E))}e.isValidVersion=v;function b(u,g,p,y,D){const t=[];if(typeof y.publisher<"u"&&typeof y.publisher!="string")return t.push([L.default.Error,o.localize(0,null)]),t;if(typeof y.name!="string")return t.push([L.default.Error,o.localize(1,null,"name")]),t;if(typeof y.version!="string")return t.push([L.default.Error,o.localize(2,null,"version")]),t;if(!y.engines)return t.push([L.default.Error,o.localize(3,null,"engines")]),t;if(typeof y.engines.vscode!="string")return t.push([L.default.Error,o.localize(4,null,"engines.vscode")]),t;if(typeof y.extensionDependencies<"u"&&!r(y.extensionDependencies))return t.push([L.default.Error,o.localize(5,null,"extensionDependencies")]),t;if(typeof y.activationEvents<"u"){if(!r(y.activationEvents))return t.push([L.default.Error,o.localize(6,null,"activationEvents")]),t;if(typeof y.main>"u"&&typeof y.browser>"u")return t.push([L.default.Error,o.localize(7,null,"activationEvents","main")]),t}if(typeof y.extensionKind<"u"&&typeof y.main>"u"&&t.push([L.default.Warning,o.localize(8,null,"extensionKind")]),typeof y.main<"u"){if(typeof y.main!="string")return t.push([L.default.Error,o.localize(9,null,"main")]),t;{const s=(0,P.joinPath)(p,y.main);(0,P.isEqualOrParent)(s,p)||t.push([L.default.Warning,o.localize(10,null,s.path,p.path)])}if(typeof y.activationEvents>"u")return t.push([L.default.Error,o.localize(11,null,"activationEvents","main")]),t}if(typeof y.browser<"u"){if(typeof y.browser!="string")return t.push([L.default.Error,o.localize(12,null,"browser")]),t;{const s=(0,P.joinPath)(p,y.browser);(0,P.isEqualOrParent)(s,p)||t.push([L.default.Warning,o.localize(13,null,s.path,p.path)])}if(typeof y.activationEvents>"u")return t.push([L.default.Error,o.localize(14,null,"activationEvents","browser")]),t}if(!A.valid(y.version))return t.push([L.default.Error,o.localize(15,null)]),t;const a=[];if(!d(u,g,y,D,a))for(const s of a)t.push([L.default.Error,s]);return t}e.validateExtensionManifest=b;function d(u,g,p,y,D){return y||typeof p.main>"u"&&typeof p.browser>"u"?!0:w(u,g,p.engines.vscode,D)}e.isValidExtensionVersion=d;function S(u,g,p){return u==="*"||w(g,p,u)}e.isEngineValid=S;function w(u,g,p,y=[]){const D=m(c(p));if(!D)return y.push(o.localize(16,null,p)),!1;if(D.majorBase===0){if(!D.majorMustEqual||!D.minorMustEqual)return y.push(o.localize(17,null,p)),!1}else if(!D.majorMustEqual)return y.push(o.localize(18,null,p)),!1;return v(u,g,D)?!0:(y.push(o.localize(19,null,u,p)),!1)}function r(u){if(!Array.isArray(u))return!1;for(let g=0,p=u.length;g<p;g++)if(typeof u[g]!="string")return!1;return!0}}),define(ee[200],te([0,1,17,31]),function(G,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function o(A,M,k){let f=k&&k.get("storage.serviceMachineId",-1)||null;if(f)return f;try{const m=(await M.readFile(A.serviceMachineIdResource)).value.toString();f=(0,L.isUUID)(m)?m:null}catch{f=null}if(!f){f=(0,L.generateUuid)();try{await M.writeFile(A.serviceMachineIdResource,P.VSBuffer.fromString(f))}catch{}}return k?.store("storage.serviceMachineId",f,-1,1),f}e.getServiceMachineId=o}),define(ee[77],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class P{constructor(o,A=[],M=!1){this.ctor=o,this.staticArguments=A,this.supportsDelayedInstantiation=M}}e.SyncDescriptor=P}),define(ee[201],te([0,1,77]),function(G,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const L=[];var o;(function(k){k[k.Eager=0]="Eager",k[k.Delayed=1]="Delayed"})(o=e.InstantiationType||(e.InstantiationType={}));function A(k,f,c){f instanceof P.SyncDescriptor||(f=new P.SyncDescriptor(f,[],Boolean(c))),L.push([k,f])}e.registerSingleton=A;function M(){return L}e.getSingletonServiceDescriptors=M}),define(ee[202],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class P{constructor(A,M){this.key=A,this.data=M,this.incoming=new Map,this.outgoing=new Map}}e.Node=P;class L{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const M of this.a.values())M.outgoing.size===0&&A.push(M);return A}insertEdge(A,M){const k=this.lookupOrInsertNode(A),f=this.lookupOrInsertNode(M);k.outgoing.set(f.key,f),f.incoming.set(k.key,k)}removeNode(A){const M=this.b(A);this.a.delete(M);for(const k of this.a.values())k.outgoing.delete(M),k.incoming.delete(M)}lookupOrInsertNode(A){const M=this.b(A);let k=this.a.get(M);return k||(k=new P(M,A),this.a.set(M,k)),k}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[M,k]of this.a)A.push(`${M}
	(-> incoming)[${[...k.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...k.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,M]of this.a){const k=new Set([A]),f=this.c(M,k);if(f)return f}}c(A,M){for(const[k,f]of A.outgoing){if(M.has(k))return[...M,k].join(" -> ");M.add(k);const c=this.c(f,M);if(c)return c;M.delete(k)}}}e.Graph=L}),define(ee[6],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var P;(function(M){M.serviceIds=new Map,M.DI_TARGET="$di$target",M.DI_DEPENDENCIES="$di$dependencies";function k(f){return f[M.DI_DEPENDENCIES]||[]}M.getServiceDependencies=k})(P=e._util||(e._util={})),e.IInstantiationService=o("instantiationService");function L(M,k,f){k[P.DI_TARGET]===k?k[P.DI_DEPENDENCIES].push({id:M,index:f}):(k[P.DI_DEPENDENCIES]=[{id:M,index:f}],k[P.DI_TARGET]=k)}function o(M){if(P.serviceIds.has(M))return P.serviceIds.get(M);const k=function(f,c,m){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(k,f,m)};return k.toString=()=>M,P.serviceIds.set(M,k),k}e.createDecorator=o;function A(M){return M}e.refineServiceDecorator=A}),define(ee[63],te([0,1,6]),function(G,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,P.createDecorator)("backupMainService")}),define(ee[19],te([0,1,11,8,6]),function(G,e,P,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,o.createDecorator)("configurationService");function A(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof L.URI)}e.isConfigurationOverrides=A;function M(r){return r&&typeof r=="object"&&(!r.overrideIdentifiers||Array.isArray(r.overrideIdentifiers))&&!r.overrideIdentifier&&(!r.resource||r.resource instanceof L.URI)}e.isConfigurationUpdateOverrides=M;var k;(function(r){r[r.APPLICATION=1]="APPLICATION",r[r.USER=2]="USER",r[r.USER_LOCAL=3]="USER_LOCAL",r[r.USER_REMOTE=4]="USER_REMOTE",r[r.WORKSPACE=5]="WORKSPACE",r[r.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",r[r.DEFAULT=7]="DEFAULT",r[r.MEMORY=8]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function f(r){switch(r){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=f;function c(r,u){const g=Object.create(null);for(const p in r)m(g,p,r[p],u);return g}e.toValuesTree=c;function m(r,u,g,p){const y=u.split("."),D=y.pop();let t=r;for(let a=0;a<y.length;a++){const i=y[a];let s=t[i];switch(typeof s){case"undefined":s=t[i]=Object.create(null);break;case"object":break;default:p(`Ignoring ${u} as ${y.slice(0,a+1).join(".")} is ${JSON.stringify(s)}`);return}t=s}if(typeof t=="object"&&t!==null)try{t[D]=g}catch{p(`Ignoring ${u} as ${y.join(".")} is ${JSON.stringify(t)}`)}else p(`Ignoring ${u} as ${y.join(".")} is ${JSON.stringify(t)}`)}e.addToValueTree=m;function v(r,u){const g=u.split(".");b(r,g)}e.removeFromValueTree=v;function b(r,u){const g=u.shift();if(u.length===0){delete r[g];return}if(Object.keys(r).indexOf(g)!==-1){const p=r[g];typeof p=="object"&&!Array.isArray(p)&&(b(p,u),Object.keys(p).length===0&&delete r[g])}}function d(r,u,g){function p(t,a){let i=t;for(const s of a){if(typeof i!="object"||i===null)return;i=i[s]}return i}const y=u.split("."),D=p(r,y);return typeof D>"u"?g:D}e.getConfigurationValue=d;function S(r,u,g){Object.keys(u).forEach(p=>{p!=="__proto__"&&(p in r?P.isObject(r[p])&&P.isObject(u[p])?S(r[p],u[p],g):g&&(r[p]=u[p]):r[p]=u[p])})}e.merge=S;function w(r){return r.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=w}),define(ee[203],te([0,1,4,26,190,6,159]),function(G,e,P,L,o,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.Parser=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",P.isMacintosh),k.set("isLinux",P.isLinux),k.set("isWindows",P.isWindows),k.set("isWeb",P.isWeb),k.set("isMacNative",P.isMacintosh&&!P.isWeb),k.set("isEdge",P.isEdge),k.set("isFirefox",P.isFirefox),k.set("isChrome",P.isChrome),k.set("isSafari",P.isSafari);const f=Object.prototype.hasOwnProperty;var c;(function(F){F[F.False=0]="False",F[F.True=1]="True",F[F.Defined=2]="Defined",F[F.Not=3]="Not",F[F.Equals=4]="Equals",F[F.NotEquals=5]="NotEquals",F[F.And=6]="And",F[F.Regex=7]="Regex",F[F.NotRegex=8]="NotRegex",F[F.Or=9]="Or",F[F.In=10]="In",F[F.NotIn=11]="NotIn",F[F.Greater=12]="Greater",F[F.GreaterEquals=13]="GreaterEquals",F[F.Smaller=14]="Smaller",F[F.SmallerEquals=15]="SmallerEquals"})(c=e.ContextKeyExprType||(e.ContextKeyExprType={}));class m{static false(){return s.INSTANCE}static true(){return n.INSTANCE}static has(I){return h.create(I)}static equals(I,O){return l.create(I,O)}static notEquals(I,O){return C.create(I,O)}static regex(I,O){return ae.create(I,O)}static in(I,O){return E.create(I,O)}static notIn(I,O){return R.create(I,O)}static not(I){return T.create(I)}static and(...I){return J.create(I,null,!0)}static or(...I){return Y.create(I,null,!0)}static greater(I,O){return z.create(I,O)}static greaterEquals(I,O){return B.create(I,O)}static smaller(I,O){return _.create(I,O)}static smallerEquals(I,O){return ne.create(I,O)}static deserialize(I){if(!!I)return this.c(I)}static c(I){const O=I.split("||");return Y.create(O.map(U=>this.d(U)),null,!0)}static d(I){const O=I.split("&&");return J.create(O.map(U=>this.f(U)),null,!0)}static f(I){if(I=I.trim(),I.indexOf("!=")>=0){const O=I.split("!=");return C.create(O[0].trim(),this.g(O[1]))}if(I.indexOf("==")>=0){const O=I.split("==");return l.create(O[0].trim(),this.g(O[1]))}if(I.indexOf("=~")>=0){const O=I.split("=~");return ae.create(O[0].trim(),this.h(O[1]))}if(I.indexOf(" not in ")>=0){const O=I.split(" not in ");return R.create(O[0].trim(),this.g(O[1]))}if(I.indexOf(" in ")>=0){const O=I.split(" in ");return E.create(O[0].trim(),this.g(O[1]))}if(/^[^<=>]+>=[^<=>]+$/.test(I)){const O=I.split(">=");return B.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(I)){const O=I.split(">");return z.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(I)){const O=I.split("<=");return ne.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(I)){const O=I.split("<");return _.create(O[0].trim(),O[1].trim())}return/^\!\s*/.test(I)?T.create(I.substr(1).trim()):h.create(I)}static g(I){if(I=I.trim(),I==="true")return!0;if(I==="false")return!1;const O=/^'([^']*)'$/.exec(I);return O?O[1].trim():I}static h(I){if((0,L.isFalsyOrWhitespace)(I))return null;const O=I.indexOf("/"),U=I.lastIndexOf("/");if(O===U||O<0)return null;const j=I.slice(O+1,U),x=I[U+1]==="i"?"i":"";try{return new RegExp(j,x)}catch{return null}}}e.ContextKeyExpr=m;const v={regexParsingWithErrorRecovery:!0};class b extends Error{}const d=(0,M.localize)(0,null),S=(0,M.localize)(1,null),w=(0,M.localize)(2,null),r=(0,M.localize)(3,null),u=(0,M.localize)(4,null),g=(0,M.localize)(5,null),p=(0,M.localize)(6,null),y=(0,M.localize)(7,null);class D{get lexingErrors(){return this.c.errors}get parsingErrors(){return this.g}constructor(I=v){this.h=I,this.c=new o.Scanner,this.d=[],this.f=0,this.g=[]}parse(I){if(I===""){this.g.push({message:d,offset:0,lexeme:"",additionalInfo:S});return}this.d=this.c.reset(I).scan(),this.f=0,this.g=[];try{const O=this.k();if(!this.C()){const U=this.B(),j=U.type===17?g:void 0;throw this.g.push({message:u,offset:U.offset,lexeme:o.Scanner.getLexeme(U),additionalInfo:j}),new b}return O}catch(O){if(!(O instanceof b))throw O;return}}k(){return this.l()}l(){const I=[this.o()];for(;this.w(16);){const O=this.o();I.push(O)}return I.length===1?I[0]:m.or(...I)}o(){const I=[this.s()];for(;this.w(15);){const O=this.s();I.push(O)}return I.length===1?I[0]:m.and(...I)}s(){if(this.w(2)){const I=this.B();switch(I.type){case 11:return this.x(),s.INSTANCE;case 12:return this.x(),n.INSTANCE;case 0:{this.x();const O=this.k();return this.y(1,r),O?.negate()}case 17:return this.x(),T.create(I.lexeme);default:throw this.z("KEY | true | false | '(' expression ')'",I)}}return this.t()}t(){const I=this.B();switch(I.type){case 11:return this.x(),m.true();case 12:return this.x(),m.false();case 0:{this.x();const O=this.k();return this.y(1,r),O}case 17:{const O=I.lexeme;if(this.x(),this.w(9)){const j=this.B();if(!this.h.regexParsingWithErrorRecovery){if(this.x(),j.type!==10)throw this.z("REGEX",j);const x=j.lexeme,$=x.lastIndexOf("/"),V=$===x.length-1?void 0:x.substring($+1);let K;try{K=new RegExp(x.substring(1,$),V)}catch{throw this.z("REGEX",j)}return ae.create(O,K)}switch(j.type){case 10:case 19:{const x=[j.lexeme];this.x();let $=this.B(),V=0;for(let Ee=0;Ee<j.lexeme.length;Ee++)j.lexeme.charCodeAt(Ee)===40?V++:j.lexeme.charCodeAt(Ee)===41&&V--;for(;!this.C()&&$.type!==15&&$.type!==16;){switch($.type){case 0:V++;break;case 1:V--;break;case 10:case 18:for(let Ee=0;Ee<$.lexeme.length;Ee++)$.lexeme.charCodeAt(Ee)===40?V++:j.lexeme.charCodeAt(Ee)===41&&V--}if(V<0)break;x.push(o.Scanner.getLexeme($)),this.x(),$=this.B()}const K=x.join(""),oe=K.lastIndexOf("/"),fe=oe===K.length-1?void 0:K.substring(oe+1);let Ce;try{Ce=new RegExp(K.substring(1,oe),fe)}catch{throw this.z("REGEX",j)}return m.regex(O,Ce)}case 18:{const x=j.lexeme;this.x();let $=null;if(!(0,L.isFalsyOrWhitespace)(x)){const V=x.indexOf("/"),K=x.lastIndexOf("/");if(V!==K&&V>=0){const oe=x.slice(V+1,K),fe=x[K+1]==="i"?"i":"";try{$=new RegExp(oe,fe)}catch{throw this.z("REGEX",j)}}}if($===null)throw this.z("REGEX",j);return ae.create(O,$)}default:throw this.z("REGEX",this.B())}}if(this.w(14)){this.y(13,w);const j=this.u();return m.notIn(O,j)}switch(this.B().type){case 3:{this.x();const j=this.u();if(this.v().type===18)return m.equals(O,j);switch(j){case"true":return m.has(O);case"false":return m.not(O);default:return m.equals(O,j)}}case 4:{this.x();const j=this.u();if(this.v().type===18)return m.notEquals(O,j);switch(j){case"true":return m.not(O);case"false":return m.has(O);default:return m.notEquals(O,j)}}case 5:return this.x(),_.create(O,this.u());case 6:return this.x(),ne.create(O,this.u());case 7:return this.x(),z.create(O,this.u());case 8:return this.x(),B.create(O,this.u());case 13:return this.x(),m.in(O,this.u());default:return m.has(O)}}case 20:throw this.g.push({message:p,offset:I.offset,lexeme:"",additionalInfo:y}),new b;default:throw this.z(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.B())}}u(){const I=this.B();switch(I.type){case 17:case 18:return this.x(),I.lexeme;case 11:return this.x(),"true";case 12:return this.x(),"false";case 13:return this.x(),"in";default:return""}}v(){return this.d[this.f-1]}w(I){return this.A(I)?(this.x(),!0):!1}x(){return this.C()||this.f++,this.v()}y(I,O){if(this.A(I))return this.x();throw this.z(O,this.B())}z(I,O,U){const j=(0,M.localize)(8,null,I,o.Scanner.getLexeme(O)),x=O.offset,$=o.Scanner.getLexeme(O);return this.g.push({message:j,offset:x,lexeme:$,additionalInfo:U}),new b}A(I){return this.B().type===I}B(){return this.d[this.f]}C(){return this.B().type===20}}e.Parser=D;function t(F){const I=new D({regexParsingWithErrorRecovery:!1});return F.map(O=>(I.parse(O),I.lexingErrors.length>0?I.lexingErrors.map(U=>({errorMessage:U.additionalInfo?(0,M.localize)(9,null,U.additionalInfo):(0,M.localize)(10,null),offset:U.offset,length:U.lexeme.length})):I.parsingErrors.length>0?I.parsingErrors.map(U=>({errorMessage:U.additionalInfo?`${U.message}. ${U.additionalInfo}`:U.message,offset:U.offset,length:U.lexeme.length})):[]))}e.validateWhenClauses=t;function a(F,I){const O=F?F.substituteConstants():void 0,U=I?I.substituteConstants():void 0;return!O&&!U?!0:!O||!U?!1:O.equals(U)}e.expressionsAreEqualWithConstantSubstitution=a;function i(F,I){return F.cmp(I)}class s{constructor(){this.type=0}cmp(I){return this.type-I.type}equals(I){return I.type===this.type}substituteConstants(){return this}evaluate(I){return!1}serialize(){return"false"}keys(){return[]}map(I){return this}negate(){return n.INSTANCE}}s.INSTANCE=new s,e.ContextKeyFalseExpr=s;class n{constructor(){this.type=1}cmp(I){return this.type-I.type}equals(I){return I.type===this.type}substituteConstants(){return this}evaluate(I){return!0}serialize(){return"true"}keys(){return[]}map(I){return this}negate(){return s.INSTANCE}}n.INSTANCE=new n,e.ContextKeyTrueExpr=n;class h{static create(I,O=null){const U=k.get(I);return typeof U=="boolean"?U?n.INSTANCE:s.INSTANCE:new h(I,O)}constructor(I,O){this.key=I,this.c=O,this.type=2}cmp(I){return I.type!==this.type?this.type-I.type:W(this.key,I.key)}equals(I){return I.type===this.type?this.key===I.key:!1}substituteConstants(){const I=k.get(this.key);return typeof I=="boolean"?I?n.INSTANCE:s.INSTANCE:this}evaluate(I){return!!I.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(I){return I.mapDefined(this.key)}negate(){return this.c||(this.c=T.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=h;class l{static create(I,O,U=null){if(typeof O=="boolean")return O?h.create(I,U):T.create(I,U);const j=k.get(I);return typeof j=="boolean"?O===(j?"true":"false")?n.INSTANCE:s.INSTANCE:new l(I,O,U)}constructor(I,O,U){this.c=I,this.d=O,this.f=U,this.type=4}cmp(I){return I.type!==this.type?this.type-I.type:H(this.c,this.d,I.c,I.d)}equals(I){return I.type===this.type?this.c===I.c&&this.d===I.d:!1}substituteConstants(){const I=k.get(this.c);if(typeof I=="boolean"){const O=I?"true":"false";return this.d===O?n.INSTANCE:s.INSTANCE}return this}evaluate(I){return I.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(I){return I.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=l;class E{static create(I,O){return new E(I,O)}constructor(I,O){this.d=I,this.f=O,this.type=10,this.c=null}cmp(I){return I.type!==this.type?this.type-I.type:H(this.d,this.f,I.d,I.f)}equals(I){return I.type===this.type?this.d===I.d&&this.f===I.f:!1}substituteConstants(){return this}evaluate(I){const O=I.getValue(this.f),U=I.getValue(this.d);return Array.isArray(O)?O.includes(U):typeof U=="string"&&typeof O=="object"&&O!==null?f.call(O,U):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(I){return I.mapIn(this.d,this.f)}negate(){return this.c||(this.c=R.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=E;class R{static create(I,O){return new R(I,O)}constructor(I,O){this.d=I,this.f=O,this.type=11,this.c=E.create(I,O)}cmp(I){return I.type!==this.type?this.type-I.type:this.c.cmp(I.c)}equals(I){return I.type===this.type?this.c.equals(I.c):!1}substituteConstants(){return this}evaluate(I){return!this.c.evaluate(I)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(I){return I.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=R;class C{static create(I,O,U=null){if(typeof O=="boolean")return O?T.create(I,U):h.create(I,U);const j=k.get(I);return typeof j=="boolean"?O===(j?"true":"false")?s.INSTANCE:n.INSTANCE:new C(I,O,U)}constructor(I,O,U){this.c=I,this.d=O,this.f=U,this.type=5}cmp(I){return I.type!==this.type?this.type-I.type:H(this.c,this.d,I.c,I.d)}equals(I){return I.type===this.type?this.c===I.c&&this.d===I.d:!1}substituteConstants(){const I=k.get(this.c);if(typeof I=="boolean"){const O=I?"true":"false";return this.d===O?s.INSTANCE:n.INSTANCE}return this}evaluate(I){return I.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(I){return I.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=l.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=C;class T{static create(I,O=null){const U=k.get(I);return typeof U=="boolean"?U?s.INSTANCE:n.INSTANCE:new T(I,O)}constructor(I,O){this.c=I,this.d=O,this.type=3}cmp(I){return I.type!==this.type?this.type-I.type:W(this.c,I.c)}equals(I){return I.type===this.type?this.c===I.c:!1}substituteConstants(){const I=k.get(this.c);return typeof I=="boolean"?I?s.INSTANCE:n.INSTANCE:this}evaluate(I){return!I.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(I){return I.mapNot(this.c)}negate(){return this.d||(this.d=h.create(this.c,this)),this.d}}e.ContextKeyNotExpr=T;function N(F,I){if(typeof F=="string"){const O=parseFloat(F);isNaN(O)||(F=O)}return typeof F=="string"||typeof F=="number"?I(F):s.INSTANCE}class z{static create(I,O,U=null){return N(O,j=>new z(I,j,U))}constructor(I,O,U){this.c=I,this.d=O,this.f=U,this.type=12}cmp(I){return I.type!==this.type?this.type-I.type:H(this.c,this.d,I.c,I.d)}equals(I){return I.type===this.type?this.c===I.c&&this.d===I.d:!1}substituteConstants(){return this}evaluate(I){return typeof this.d=="string"?!1:parseFloat(I.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(I){return I.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ne.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=z;class B{static create(I,O,U=null){return N(O,j=>new B(I,j,U))}constructor(I,O,U){this.c=I,this.d=O,this.f=U,this.type=13}cmp(I){return I.type!==this.type?this.type-I.type:H(this.c,this.d,I.c,I.d)}equals(I){return I.type===this.type?this.c===I.c&&this.d===I.d:!1}substituteConstants(){return this}evaluate(I){return typeof this.d=="string"?!1:parseFloat(I.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(I){return I.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=_.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=B;class _{static create(I,O,U=null){return N(O,j=>new _(I,j,U))}constructor(I,O,U){this.c=I,this.d=O,this.f=U,this.type=14}cmp(I){return I.type!==this.type?this.type-I.type:H(this.c,this.d,I.c,I.d)}equals(I){return I.type===this.type?this.c===I.c&&this.d===I.d:!1}substituteConstants(){return this}evaluate(I){return typeof this.d=="string"?!1:parseFloat(I.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(I){return I.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=B.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=_;class ne{static create(I,O,U=null){return N(O,j=>new ne(I,j,U))}constructor(I,O,U){this.c=I,this.d=O,this.f=U,this.type=15}cmp(I){return I.type!==this.type?this.type-I.type:H(this.c,this.d,I.c,I.d)}equals(I){return I.type===this.type?this.c===I.c&&this.d===I.d:!1}substituteConstants(){return this}evaluate(I){return typeof this.d=="string"?!1:parseFloat(I.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(I){return I.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=ne;class ae{static create(I,O){return new ae(I,O)}constructor(I,O){this.d=I,this.f=O,this.type=7,this.c=null}cmp(I){if(I.type!==this.type)return this.type-I.type;if(this.d<I.d)return-1;if(this.d>I.d)return 1;const O=this.f?this.f.source:"",U=I.f?I.f.source:"";return O<U?-1:O>U?1:0}equals(I){if(I.type===this.type){const O=this.f?this.f.source:"",U=I.f?I.f.source:"";return this.d===I.d&&O===U}return!1}substituteConstants(){return this}evaluate(I){const O=I.getValue(this.d);return this.f?this.f.test(O):!1}serialize(){const I=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${I}`}keys(){return[this.d]}map(I){return I.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=he.create(this)),this.c}}e.ContextKeyRegexExpr=ae;class he{static create(I){return new he(I)}constructor(I){this.c=I,this.type=8}cmp(I){return I.type!==this.type?this.type-I.type:this.c.cmp(I.c)}equals(I){return I.type===this.type?this.c.equals(I.c):!1}substituteConstants(){return this}evaluate(I){return!this.c.evaluate(I)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(I){return new he(this.c.map(I))}negate(){return this.c}}e.ContextKeyNotRegexExpr=he;function ce(F){let I=null;for(let O=0,U=F.length;O<U;O++){const j=F[O].substituteConstants();if(F[O]!==j&&I===null){I=[];for(let x=0;x<O;x++)I[x]=F[x]}I!==null&&(I[O]=j)}return I===null?F:I}class J{static create(I,O,U){return J.d(I,O,U)}constructor(I,O){this.expr=I,this.c=O,this.type=6}cmp(I){if(I.type!==this.type)return this.type-I.type;if(this.expr.length<I.expr.length)return-1;if(this.expr.length>I.expr.length)return 1;for(let O=0,U=this.expr.length;O<U;O++){const j=i(this.expr[O],I.expr[O]);if(j!==0)return j}return 0}equals(I){if(I.type===this.type){if(this.expr.length!==I.expr.length)return!1;for(let O=0,U=this.expr.length;O<U;O++)if(!this.expr[O].equals(I.expr[O]))return!1;return!0}return!1}substituteConstants(){const I=ce(this.expr);return I===this.expr?this:J.create(I,this.c,!1)}evaluate(I){for(let O=0,U=this.expr.length;O<U;O++)if(!this.expr[O].evaluate(I))return!1;return!0}static d(I,O,U){const j=[];let x=!1;for(const $ of I)if(!!$){if($.type===1){x=!0;continue}if($.type===0)return s.INSTANCE;if($.type===6){j.push(...$.expr);continue}j.push($)}if(j.length===0&&x)return n.INSTANCE;if(j.length!==0){if(j.length===1)return j[0];j.sort(i);for(let $=1;$<j.length;$++)j[$-1].equals(j[$])&&(j.splice($,1),$--);if(j.length===1)return j[0];for(;j.length>1;){const $=j[j.length-1];if($.type!==9)break;j.pop();const V=j.pop(),K=j.length===0,oe=Y.create($.expr.map(fe=>J.create([fe,V],null,U)),null,K);oe&&(j.push(oe),j.sort(i))}if(j.length===1)return j[0];if(U){for(let $=0;$<j.length;$++)for(let V=$+1;V<j.length;V++)if(j[$].negate().equals(j[V]))return s.INSTANCE;if(j.length===1)return j[0]}return new J(j,O)}}serialize(){return this.expr.map(I=>I.serialize()).join(" && ")}keys(){const I=[];for(const O of this.expr)I.push(...O.keys());return I}map(I){return new J(this.expr.map(O=>O.map(I)),null)}negate(){if(!this.c){const I=[];for(const O of this.expr)I.push(O.negate());this.c=Y.create(I,this,!0)}return this.c}}class Y{static create(I,O,U){return Y.d(I,O,U)}constructor(I,O){this.expr=I,this.c=O,this.type=9}cmp(I){if(I.type!==this.type)return this.type-I.type;if(this.expr.length<I.expr.length)return-1;if(this.expr.length>I.expr.length)return 1;for(let O=0,U=this.expr.length;O<U;O++){const j=i(this.expr[O],I.expr[O]);if(j!==0)return j}return 0}equals(I){if(I.type===this.type){if(this.expr.length!==I.expr.length)return!1;for(let O=0,U=this.expr.length;O<U;O++)if(!this.expr[O].equals(I.expr[O]))return!1;return!0}return!1}substituteConstants(){const I=ce(this.expr);return I===this.expr?this:Y.create(I,this.c,!1)}evaluate(I){for(let O=0,U=this.expr.length;O<U;O++)if(this.expr[O].evaluate(I))return!0;return!1}static d(I,O,U){let j=[],x=!1;if(I){for(let $=0,V=I.length;$<V;$++){const K=I[$];if(!!K){if(K.type===0){x=!0;continue}if(K.type===1)return n.INSTANCE;if(K.type===9){j=j.concat(K.expr);continue}j.push(K)}}if(j.length===0&&x)return s.INSTANCE;j.sort(i)}if(j.length!==0){if(j.length===1)return j[0];for(let $=1;$<j.length;$++)j[$-1].equals(j[$])&&(j.splice($,1),$--);if(j.length===1)return j[0];if(U){for(let $=0;$<j.length;$++)for(let V=$+1;V<j.length;V++)if(j[$].negate().equals(j[V]))return n.INSTANCE;if(j.length===1)return j[0]}return new Y(j,O)}}serialize(){return this.expr.map(I=>I.serialize()).join(" || ")}keys(){const I=[];for(const O of this.expr)I.push(...O.keys());return I}map(I){return new Y(this.expr.map(O=>O.map(I)),null)}negate(){if(!this.c){const I=[];for(const O of this.expr)I.push(O.negate());for(;I.length>1;){const O=I.shift(),U=I.shift(),j=[];for(const x of re(O))for(const $ of re(U))j.push(J.create([x,$],null,!1));I.unshift(Y.create(j,null,!1))}this.c=Y.create(I,this,!0)}return this.c}}class q extends h{static all(){return q.d.values()}constructor(I,O,U){super(I,null),this.f=O,typeof U=="object"?q.d.push({...U,key:I}):U!==!0&&q.d.push({key:I,description:U,type:O!=null?typeof O:void 0})}bindTo(I){return I.createKey(this.key,this.f)}getValue(I){return I.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(I){return l.create(this.key,I)}notEqualsTo(I){return C.create(this.key,I)}}q.d=[],e.RawContextKey=q,e.IContextKeyService=(0,A.createDecorator)("contextKeyService");function W(F,I){return F<I?-1:F>I?1:0}function H(F,I,O,U){return F<O?-1:F>O?1:I<U?-1:I>U?1:0}function Q(F,I){if(F.type===0||I.type===1)return!0;if(F.type===9)return I.type===9?se(F.expr,I.expr):!1;if(I.type===9){for(const O of I.expr)if(Q(F,O))return!0;return!1}if(F.type===6){if(I.type===6)return se(I.expr,F.expr);for(const O of F.expr)if(Q(O,I))return!0;return!1}return F.equals(I)}e.implies=Q;function se(F,I){let O=0,U=0;for(;O<F.length&&U<I.length;){const j=F[O].cmp(I[U]);if(j<0)return!1;j===0&&O++,U++}return O===F.length}function re(F){return F.type===9?F.expr:[F]}}),define(ee[78],te([0,1,6]),function(G,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,P.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,P.createDecorator)("credentialsMainService");class L{constructor(){this.a={}}async getPassword(A,M){return this.a[A]?.[M]??null}async setPassword(A,M,k){this.a[A]=this.a[A]??{},this.a[A][M]=k}async deletePassword(A,M){return this.a[A]?.[M]?(delete this.a[A][M],Object.keys(this.a[A]).length===0&&delete this.a[A],!0):!1}async findPassword(A){return JSON.stringify(this.a[A])??null}async findCredentials(A){const M=[];for(const k of Object.keys(this.a[A]||{}))M.push({account:k,password:this.a[A][k]});return M}async clear(){this.a={}}}e.InMemoryCredentialsProvider=L}),define(ee[87],te([0,1,6]),function(G,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,P.createDecorator)(e.ID);function L(A){return!!A.hostName&&!!A.errorMessage}e.isRemoteDiagnosticError=L;class o{async getPerformanceInfo(M,k){return{}}async getSystemInfo(M,k){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(M,k){return""}async getWorkspaceFileExtensions(M){return{extensions:[]}}async reportWorkspaceStats(M){}}e.NullDiagnosticsService=o}),define(ee[88],te([0,1,18,76,161,6,45,4,37]),function(G,e,P,L,o,A,M,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.massageMessageBoxOptions=e.getFileNamesMessage=e.ConfirmResult=e.IFileDialogService=e.AbstractDialogHandler=e.IDialogService=void 0,e.IDialogService=(0,A.createDecorator)("dialogService");var c;(function(w){w[w.Confirmation=1]="Confirmation",w[w.Prompt=2]="Prompt",w[w.Input=3]="Input"})(c||(c={}));class m{a(r){return this.d(r,c.Confirmation)}b(r){return this.d(r,c.Prompt)}c(r){return this.d(r,c.Input)}d(r,u){const g=[];switch(u){case c.Confirmation:{const p=r;p.primaryButton?g.push(p.primaryButton):g.push((0,o.localize)(0,null)),p.cancelButton?g.push(p.cancelButton):g.push((0,o.localize)(1,null));break}case c.Prompt:{const p=r;Array.isArray(p.buttons)&&p.buttons.length>0&&g.push(...p.buttons.map(y=>y.label)),p.cancelButton&&(p.cancelButton===!0?g.push((0,o.localize)(2,null)):typeof p.cancelButton=="string"?g.push(p.cancelButton):p.cancelButton.label?g.push(p.cancelButton.label):g.push((0,o.localize)(3,null))),g.length===0&&g.push((0,o.localize)(4,null));break}case c.Input:{const p=r;p.primaryButton?g.push(p.primaryButton):g.push((0,o.localize)(5,null)),p.cancelButton?g.push(p.cancelButton):g.push((0,o.localize)(6,null));break}}return g}e(r){if(typeof r=="string")return r;if(typeof r=="number")return r===L.default.Info?"info":r===L.default.Error?"error":r===L.default.Warning?"warning":"none"}async f(r,u,g){const p=[...r.buttons??[]];return r.cancelButton&&typeof r.cancelButton!="string"&&typeof r.cancelButton!="boolean"&&p.push(r.cancelButton),{result:await p[u]?.run({checkboxChecked:g}),checkboxChecked:g}}}e.AbstractDialogHandler=m,e.IFileDialogService=(0,A.createDecorator)("fileDialogService");var v;(function(w){w[w.SAVE=0]="SAVE",w[w.DONT_SAVE=1]="DONT_SAVE",w[w.CANCEL=2]="CANCEL"})(v=e.ConfirmResult||(e.ConfirmResult={}));const b=10;function d(w){const r=[];return r.push(...w.slice(0,b).map(u=>typeof u=="string"?u:(0,P.basename)(u))),w.length>b&&(w.length-b===1?r.push((0,o.localize)(7,null)):r.push((0,o.localize)(8,null,w.length-b))),r.push(""),r.join(`
`)}e.getFileNamesMessage=d;function S(w,r){const u=(0,f.deepClone)(w);let g=(u.buttons??[]).map(t=>(0,M.mnemonicButtonLabel)(t)),p=(w.buttons||[]).map((t,a)=>a),y=0,D=u.cancelId??g.length-1;if(g.length>1){const t=typeof D=="number"?g[D]:void 0;if(k.isLinux||k.isMacintosh){if(typeof t=="string"&&g.length>1&&D!==1){g.splice(D,1),g.splice(1,0,t);const a=p[D];p.splice(D,1),p.splice(1,0,a),D=1}k.isLinux&&g.length>1&&(g=g.reverse(),p=p.reverse(),y=g.length-1,typeof t=="string"&&(D=y-1))}else if(k.isWindows&&typeof t=="string"&&g.length>1&&D!==g.length-1){g.splice(D,1),g.push(t);const a=p[D];p.splice(D,1),p.push(a),D=g.length-1}}return u.buttons=g,u.defaultId=y,u.cancelId=D,u.noLink=!0,u.title=u.title||r.nameLong,{options:u,buttonIndeces:p}}e.massageMessageBoxOptions=S}),define(ee[109],te([0,1,6]),function(G,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,P.createDecorator)("encryptionMainService")}),define(ee[34],te([0,1,6]),function(G,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,P.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,P.refineServiceDecorator)(e.IEnvironmentService)}),define(ee[110],te([0,1,165,6]),function(G,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function o(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=o;function A(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=A;function M(u,g){switch(u){case 3:return g==="x64"?"win32-x64":g==="ia32"?"win32-ia32":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=M;function k(u,g){return g==="web"&&!u.includes("web")}e.isNotWebExtensionInWebTargetPlatform=k;function f(u,g,p){return k(g,p)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===p?!0:c(p).includes(u)}e.isTargetPlatformCompatible=f;function c(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=c;function m(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=m;var v;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(v=e.SortBy||(e.SortBy={}));var b;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(b=e.SortOrder||(e.SortOrder={}));var d;(function(u){u.Install="install",u.Uninstall="uninstall"})(d=e.StatisticType||(e.StatisticType={}));var S;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(S=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,L.createDecorator)("extensionGalleryService");var w;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Internal="Internal",u.Signature="Signature"})(w=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class r extends Error{constructor(g,p){super(g),this.code=p,this.name=p}}e.ExtensionManagementError=r,e.IExtensionManagementService=(0,L.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,L.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,L.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,P.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,P.localize)(1,null),original:"Preferences"}}),define(ee[204],te([0,1,6]),function(G,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,P.createDecorator)("extensionUrlTrustService")}),define(ee[205],te([0,1,6]),function(G,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,P.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(ee[111],te([0,1,6]),function(G,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,P.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,P.createDecorator)("externalTerminal")}),define(ee[206],te([0,1,46,14,9,4,74,23,86,169,111]),function(G,e,P,L,o,A,M,k,f,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const v=c.localize(0,null);class b{async getDefaultTerminalForPlatforms(){return{windows:d.getDefaultTerminalWindows(),linux:await w.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class d extends b{openTerminal(y,D){return this.spawnTerminal(P,y,f.getWindowsShell(),D)}spawnTerminal(y,D,t,a){const i=D.windowsExec||d.getDefaultTerminalWindows();a&&a[1]===":"&&(a=a[0].toUpperCase()+a.substr(1));const s=o.basename(i,".exe").toLowerCase();if(s==="cmder")return y.spawn(i,a?[a]:void 0),Promise.resolve(void 0);const n=["/c","start","/wait"];return i.indexOf(" ")>=0&&n.push('""'),n.push(i),s==="wt"&&n.push("-d ."),new Promise((h,l)=>{const E=r(process),R=y.spawn(t,n,{cwd:a,env:E});R.on("error",l),R.on("exit",()=>h())})}runInTerminal(y,D,t,a,i){const s="windowsExec"in i&&i.windowsExec?i.windowsExec:d.getDefaultTerminalWindows();return new Promise((n,h)=>{const l=`"${D} - ${v}"`,E=`""${t.join('" "')}" & pause"`,R=Object.assign({},r(process),a);Object.keys(R).filter(B=>R[B]===null).forEach(B=>delete R[B]);const C={cwd:D,env:R,windowsVerbatimArguments:!0};let T,N;o.basename(s,".exe")==="wt"?(T=s,N=["-d",".",d.b,"/c",E]):(T=d.b,N=["/c","start",l,"/wait",s,"/c",E]),P.spawn(T,N,C).on("error",B=>{h(u(B))}),n(void 0)})}static getDefaultTerminalWindows(){if(!d.d){const y=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");d.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${y?"Sysnative":"System32"}\\cmd.exe`}return d.d}}d.b="cmd.exe",e.WindowsExternalTerminalService=d;class S extends b{openTerminal(y,D){return this.spawnTerminal(P,y,D)}runInTerminal(y,D,t,a,i){const s=i.osxExec||m.DEFAULT_TERMINAL_OSX;return new Promise((n,h)=>{if(s===m.DEFAULT_TERMINAL_OSX||s==="iTerm.app"){const l=s===m.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",R=[L.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${l}.scpt`).fsPath,"-t",y||v,"-w",D];for(const N of t)R.push("-a"),R.push(N);if(a){const N=Object.assign({},r(process),a);for(const z in N){const B=N[z];B===null?(R.push("-u"),R.push(z)):(R.push("-e"),R.push(`${z}=${B}`))}}let C="";const T=P.spawn(S.b,R);T.on("error",N=>{h(u(N))}),T.stderr.on("data",N=>{C+=N.toString()}),T.on("exit",N=>{if(N===0)n(void 0);else if(C){const z=C.split(`
`,1);h(new Error(z[0]))}else h(new Error(c.localize(1,null,l,N)))})}else h(new Error(c.localize(2,null,s)))})}spawnTerminal(y,D,t){const a=D.osxExec||m.DEFAULT_TERMINAL_OSX;return new Promise((i,s)=>{const n=["-a",a];t&&n.push(t);const h=r(process),l=y.spawn("/usr/bin/open",n,{cwd:t,env:h});l.on("error",s),l.on("exit",()=>i())})}}S.b="/usr/bin/osascript",e.MacExternalTerminalService=S;class w extends b{openTerminal(y,D){return this.spawnTerminal(P,y,D)}runInTerminal(y,D,t,a,i){const s=i.linuxExec?Promise.resolve(i.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((n,h)=>{const l=[];s.then(E=>{E.indexOf("gnome-terminal")>=0?l.push("-x"):l.push("-e"),l.push("bash"),l.push("-c");const R=`${g(t)}; echo; read -p "${w.b}" -n1;`;l.push(`''${R}''`);const C=Object.assign({},r(process),a);Object.keys(C).filter(B=>C[B]===null).forEach(B=>delete C[B]);const T={cwd:D,env:C};let N="";const z=P.spawn(E,l,T);z.on("error",B=>{h(u(B))}),z.stderr.on("data",B=>{N+=B.toString()}),z.on("exit",B=>{if(B===0)n(void 0);else if(N){const _=N.split(`
`,1);h(new Error(_[0]))}else h(new Error(c.localize(4,null,E,B)))})})})}static async getDefaultTerminalLinuxReady(){if(!w.d)if(!A.isLinux)w.d=Promise.resolve("xterm");else{const y=await k.Promises.exists("/etc/debian_version");w.d=new Promise(D=>{y?D("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?D("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?D("konsole"):process.env.COLORTERM?D(process.env.COLORTERM):process.env.TERM?D(process.env.TERM):D("xterm")})}return w.d}spawnTerminal(y,D,t){const a=D.linuxExec?Promise.resolve(D.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((i,s)=>{a.then(n=>{const h=r(process),l=y.spawn(n,[],{cwd:t,env:h});l.on("error",s),l.on("exit",()=>i())})})}}w.b=c.localize(3,null),e.LinuxExternalTerminalService=w;function r(p){const y={...p.env};return(0,M.sanitizeProcessEnvironment)(y),y}function u(p){return"errno"in p&&p.errno==="ENOENT"&&"path"in p&&typeof p.path=="string"?new Error(c.localize(5,null,p.path)):p}function g(p){let y="";for(const D of p)D.indexOf(" ")>=0?y+='"'+D+'"':y+=D,y+=" ";return y}}),define(ee[16],te([0,1,61,9,26,11,8,171,6,4,14]),function(G,e,P,L,o,A,M,k,f,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,f.createDecorator)("fileService");function v(W){return W.create===!0}e.isFileOpenForWriteOptions=v;var b;(function(W){W[W.Unknown=0]="Unknown",W[W.File=1]="File",W[W.Directory=2]="Directory",W[W.SymbolicLink=64]="SymbolicLink"})(b=e.FileType||(e.FileType={}));var d;(function(W){W[W.Readonly=1]="Readonly"})(d=e.FilePermission||(e.FilePermission={}));var S;(function(W){W[W.None=0]="None",W[W.FileReadWrite=2]="FileReadWrite",W[W.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",W[W.FileReadStream=16]="FileReadStream",W[W.FileFolderCopy=8]="FileFolderCopy",W[W.PathCaseSensitive=1024]="PathCaseSensitive",W[W.Readonly=2048]="Readonly",W[W.Trash=4096]="Trash",W[W.FileWriteUnlock=8192]="FileWriteUnlock",W[W.FileAtomicRead=16384]="FileAtomicRead",W[W.FileClone=32768]="FileClone"})(S=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function w(W){return!!(W.capabilities&2)}e.hasReadWriteCapability=w;function r(W){return!!(W.capabilities&8)}e.hasFileFolderCopyCapability=r;function u(W){return!!(W.capabilities&32768)}e.hasFileCloneCapability=u;function g(W){return!!(W.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function p(W){return!!(W.capabilities&16)}e.hasFileReadStreamCapability=p;function y(W){return w(W)?!!(W.capabilities&16384):!1}e.hasFileAtomicReadCapability=y;var D;(function(W){W.FileExists="EntryExists",W.FileNotFound="EntryNotFound",W.FileNotADirectory="EntryNotADirectory",W.FileIsADirectory="EntryIsADirectory",W.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",W.FileTooLarge="EntryTooLarge",W.FileWriteLocked="EntryWriteLocked",W.NoPermissions="NoPermissions",W.Unavailable="Unavailable",W.Unknown="Unknown"})(D=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class t extends Error{static create(H,Q){const se=new t(H.toString(),Q);return s(se,Q),se}constructor(H,Q){super(H),this.code=Q}}e.FileSystemProviderError=t;function a(W,H){return t.create(W,H)}e.createFileSystemProviderError=a;function i(W){return W||a((0,k.localize)(0,null),D.Unknown)}e.ensureFileSystemProviderError=i;function s(W,H){return W.name=H?`${H} (FileSystemError)`:"FileSystemError",W}e.markAsFileSystemProviderError=s;function n(W){if(!W)return D.Unknown;if(W instanceof t)return W.code;const H=/^(.+) \(FileSystemError\)$/.exec(W.name);if(!H)return D.Unknown;switch(H[1]){case D.FileExists:return D.FileExists;case D.FileIsADirectory:return D.FileIsADirectory;case D.FileNotADirectory:return D.FileNotADirectory;case D.FileNotFound:return D.FileNotFound;case D.FileExceedsMemoryLimit:return D.FileExceedsMemoryLimit;case D.FileTooLarge:return D.FileTooLarge;case D.FileWriteLocked:return D.FileWriteLocked;case D.NoPermissions:return D.NoPermissions;case D.Unavailable:return D.Unavailable}return D.Unknown}e.toFileSystemProviderErrorCode=n;function h(W){if(W instanceof N)return W.fileOperationResult;switch(n(W)){case D.FileNotFound:return 1;case D.FileIsADirectory:return 0;case D.FileNotADirectory:return 10;case D.FileWriteLocked:return 5;case D.NoPermissions:return 6;case D.FileExists:return 4;case D.FileExceedsMemoryLimit:return 9;case D.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=h;var l;(function(W){W[W.CREATE=0]="CREATE",W[W.DELETE=1]="DELETE",W[W.MOVE=2]="MOVE",W[W.COPY=3]="COPY",W[W.WRITE=4]="WRITE"})(l=e.FileOperation||(e.FileOperation={}));class E{constructor(H,Q,se){this.resource=H,this.operation=Q,this.target=se}isOperation(H){return this.operation===H}}e.FileOperationEvent=E;var R;(function(W){W[W.UPDATED=0]="UPDATED",W[W.ADDED=1]="ADDED",W[W.DELETED=2]="DELETED"})(R=e.FileChangeType||(e.FileChangeType={}));class C{constructor(H,Q){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const se=new Map;for(const re of H){const F=se.get(re.type);switch(F?F.push([re.resource,re]):se.set(re.type,[[re.resource,re]]),re.type){case 1:this.rawAdded.push(re.resource);break;case 0:this.rawUpdated.push(re.resource);break;case 2:this.rawDeleted.push(re.resource);break}}for(const[re,F]of se)switch(re){case 1:this.a=P.TernarySearchTree.forUris(()=>Q),this.a.fill(F);break;case 0:this.b=P.TernarySearchTree.forUris(()=>Q),this.b.fill(F);break;case 2:this.c=P.TernarySearchTree.forUris(()=>Q),this.c.fill(F);break}}contains(H,...Q){return this.d(H,{includeChildren:!1},...Q)}affects(H,...Q){return this.d(H,{includeChildren:!0},...Q)}d(H,Q,...se){if(!H)return!1;const re=se.length>0;return!!((!re||se.includes(1))&&(this.a?.get(H)||Q.includeChildren&&this.a?.findSuperstr(H))||(!re||se.includes(0))&&(this.b?.get(H)||Q.includeChildren&&this.b?.findSuperstr(H))||(!re||se.includes(2))&&(this.c?.findSubstr(H)||Q.includeChildren&&this.c?.findSuperstr(H)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=C;function T(W,H,Q){return!W||!H||W===H||H.length>W.length?!1:(H.charAt(H.length-1)!==L.sep&&(H+=L.sep),Q?(0,o.startsWithIgnoreCase)(W,H):W.indexOf(H)===0)}e.isParent=T;class N extends Error{constructor(H,Q,se){super(H),this.fileOperationResult=Q,this.options=se}}e.FileOperationError=N;class z extends N{constructor(H,Q,se,re){super(H,Q,re),this.fileOperationResult=Q,this.size=se}}e.TooLargeFileOperationError=z;class B extends N{constructor(H,Q,se){super(H,2,se),this.stat=Q}}e.NotModifiedSinceFileOperationError=B;var _;(function(W){W[W.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",W[W.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",W[W.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",W[W.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",W[W.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",W[W.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",W[W.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",W[W.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",W[W.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",W[W.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",W[W.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",W[W.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(_=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var ne;(function(W){W[W.FILE=0]="FILE",W[W.FOLDER=1]="FOLDER",W[W.ROOT_FOLDER=2]="ROOT_FOLDER"})(ne=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function ae(W){if(!(typeof W.size!="number"||typeof W.mtime!="number"))return W.mtime.toString(29)+W.size.toString(31)}e.etag=ae;async function he(W,H){if(!H.hasProvider(M.URI.from({scheme:W.scheme})))return new Promise(Q=>{const se=H.onDidChangeFileSystemProviderRegistrations(re=>{re.scheme===W.scheme&&re.added&&(se.dispose(),Q())})})}e.whenProviderRegistered=he,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ce{static formatSize(H){return(0,A.isNumber)(H)||(H=0),H<ce.KB?(0,k.localize)(1,null,H.toFixed(0)):H<ce.MB?(0,k.localize)(2,null,(H/ce.KB).toFixed(2)):H<ce.GB?(0,k.localize)(3,null,(H/ce.MB).toFixed(2)):H<ce.TB?(0,k.localize)(4,null,(H/ce.GB).toFixed(2)):(0,k.localize)(5,null,(H/ce.TB).toFixed(2))}}ce.KB=1024,ce.MB=ce.KB*ce.KB,ce.GB=ce.MB*ce.KB,ce.TB=ce.GB*ce.KB,e.ByteSize=ce;var J;(function(W){W[W.IA32=0]="IA32",W[W.OTHER=1]="OTHER"})(J=e.Arch||(e.Arch={}));function Y(W){return{maxFileSize:W===0?300*ce.MB:16*ce.GB,maxHeapSize:W===0?700*ce.MB:2*700*ce.MB}}e.getPlatformFileLimits=Y;function q(W){const H=typeof W=="string"||W?.scheme===m.Schemas.vscodeRemote;return typeof W!="string"&&W?.scheme===m.Schemas.file?1024*ce.MB:H?10*ce.MB:c.isWeb?50*ce.MB:1024*ce.MB}e.getLargeFileConfirmationLimit=q}),define(ee[207],te([0,1,17,44,13,3,2,60,8,31,16]),function(G,e,P,L,o,A,M,k,f,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class v extends M.Disposable{constructor(d,S){super(),this.a=d,this.b=S,this.onDidChangeCapabilities=A.Event.None,this.f=this.D(new A.Emitter),this.onDidChangeFile=this.f.event,this.g=this.D(new A.Emitter),this.onDidWatchError=this.g.event,this.h=(0,c.generateUuid)(),this.i()}get capabilities(){return this.c||(this.c=57374,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(d){return this.a.call("stat",[d])}readdir(d){return this.a.call("readdir",[d])}async readFile(d,S){const{buffer:w}=await this.a.call("readFile",[d,S]);return w}readFileStream(d,S,w){const r=(0,k.newWriteableStream)(g=>P.VSBuffer.concat(g.map(p=>P.VSBuffer.wrap(p))).buffer),u=this.a.listen("readFileStream",[d,S])(g=>{if(g instanceof P.VSBuffer)r.write(g.buffer);else{if(g==="end")r.end();else{let p;if(g instanceof Error)p=g;else{const y=g;p=(0,m.createFileSystemProviderError)(y.message??(0,L.toErrorMessage)(y),y.code??m.FileSystemProviderErrorCode.Unknown)}r.error(p),r.end()}u.dispose()}});return w.onCancellationRequested(()=>{r.error((0,o.canceled)()),r.end(),u.dispose()}),r}writeFile(d,S,w){return this.a.call("writeFile",[d,P.VSBuffer.wrap(S),w])}open(d,S){return this.a.call("open",[d,S])}close(d){return this.a.call("close",[d])}async read(d,S,w,r,u){const[g,p]=await this.a.call("read",[d,S,u]);return w.set(g.buffer.slice(0,p),r),p}write(d,S,w,r,u){return this.a.call("write",[d,S,P.VSBuffer.wrap(w),r,u])}mkdir(d){return this.a.call("mkdir",[d])}delete(d,S){return this.a.call("delete",[d,S])}rename(d,S,w){return this.a.call("rename",[d,S,w])}copy(d,S,w){return this.a.call("copy",[d,S,w])}cloneFile(d,S){return this.a.call("cloneFile",[d,S])}i(){this.D(this.a.listen("fileChange",[this.h])(d=>{if(Array.isArray(d)){const S=d;this.f.fire(S.map(w=>({resource:f.URI.revive(w.resource),type:w.type})))}else{const S=d;this.g.fire(S)}}))}watch(d,S){const w=(0,c.generateUuid)();return this.a.call("watch",[this.h,w,d,S]),(0,M.toDisposable)(()=>this.a.call("unwatch",[this.h,w]))}}e.DiskFileSystemProviderClient=v}),define(ee[112],te([0,1,17,13,172,16]),function(G,e,P,L,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function M(m,v,b,d,S,w){let r;try{await k(m,v,b,d,S,w)}catch(u){r=u}finally{r&&S.errorTransformer&&(r=S.errorTransformer(r)),typeof r<"u"&&b.error(r),b.end()}}e.readFileIntoStream=M;async function k(m,v,b,d,S,w){f(w);const r=await m.open(v,{create:!1});try{f(w);let u=0,g=0,p=S&&typeof S.length=="number"?S.length:void 0,y=P.VSBuffer.alloc(Math.min(S.bufferSize,typeof p=="number"?p:S.bufferSize)),D=S&&typeof S.position=="number"?S.position:0,t=0;do g=await m.read(r,D,y.buffer,t,y.byteLength-t),D+=g,t+=g,u+=g,typeof p=="number"&&(p-=g),t===y.byteLength&&(await b.write(d(y)),y=P.VSBuffer.alloc(Math.min(S.bufferSize,typeof p=="number"?p:S.bufferSize)),t=0);while(g>0&&(typeof p!="number"||p>0)&&f(w)&&c(u,S));if(t>0){let a=t;typeof p=="number"&&(a=Math.min(t,p)),b.write(d(y.slice(0,a)))}}catch(u){throw(0,A.ensureFileSystemProviderError)(u)}finally{await m.close(r)}}function f(m){if(m.isCancellationRequested)throw(0,L.canceled)();return!0}function c(m,v){if(v?.limits){if(typeof v.limits.memory=="number"&&m>v.limits.memory)throw(0,A.createFileSystemProviderError)((0,o.localize)(0,null),A.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof v.limits.size=="number"&&m>v.limits.size)throw(0,A.createFileSystemProviderError)((0,o.localize)(1,null),A.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ee[79],te([0,1,101,2,9,4,8,16]),function(G,e,P,L,o,A,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function f(u){return u.recursive===!0}e.isRecursiveWatchRequest=f;class c extends L.Disposable{constructor(g,p,y,D){super(),this.h=g,this.i=p,this.j=y,this.k=D,this.c=this.D(new L.MutableDisposable),this.f=void 0,this.g=0}m(){const g=new L.DisposableStore;this.c.value=g,this.b=this.l(g),this.b.setVerboseLogging(this.j),g.add(this.b.onDidChangeFile(p=>this.h(p))),g.add(this.b.onDidLogMessage(p=>this.i(p))),g.add(this.b.onDidError(p=>this.n(p)))}n(g){this.k.restartOnError?this.g<c.a&&this.f?(this.q(`restarting watcher after error: ${g}`),this.p(this.f)):this.q(`gave up attempting to restart watcher after error: ${g}`):this.q(g)}p(g){this.g++,this.m(),this.watch(g)}async watch(g){this.f=g,await this.b?.watch(g)}async setVerboseLogging(g){this.j=g,await this.b?.setVerboseLogging(g)}q(g){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${g}`})}r(g){this.i({type:"trace",message:`[File Watcher (${this.k.type})] ${g}`})}dispose(){return this.b=void 0,super.dispose()}}c.a=5,e.AbstractWatcherClient=c;class m extends c{constructor(g,p,y){super(g,p,y,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=m;class v extends c{constructor(g,p,y){super(g,p,y,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=v;function b(u){return u.map(g=>({type:g.type,resource:M.URI.file(g.path)}))}e.toFileChanges=b;function d(u){const g=new r;for(const p of u)g.processEvent(p);return g.coalesce()}e.coalesceEvents=d;function S(u,g){return typeof g=="string"&&!g.startsWith(P.GLOBSTAR)&&!(0,o.isAbsolute)(g)?{base:u,pattern:g}:g}e.normalizeWatcherPattern=S;function w(u,g){const p=[];for(const y of g)p.push((0,P.parse)(S(u,y)));return p}e.parseWatcherPatterns=w;class r{constructor(){this.a=new Set,this.b=new Map}c(g){return A.isLinux?g.path:g.path.toLowerCase()}processEvent(g){const p=this.b.get(this.c(g));let y=!1;if(p){const D=p.type,t=g.type;p.path!==g.path&&(g.type===2||g.type===1)?y=!0:D===1&&t===2?(this.b.delete(this.c(g)),this.a.delete(p)):D===2&&t===1?p.type=0:D===1&&t===0||(p.type=t)}else y=!0;y&&(this.a.add(g),this.b.set(this.c(g),g))}coalesce(){const g=[],p=[];return Array.from(this.a).filter(y=>y.type!==2?(g.push(y),!1):!0).sort((y,D)=>y.path.length-D.path.length).filter(y=>p.some(D=>(0,k.isParent)(y.path,D,!A.isLinux))?!1:(p.push(y.path),!0)).concat(g)}}}),define(ee[208],te([0,1,41,7,22,32,2,83,9,4,102,23,79]),function(G,e,P,L,o,A,M,k,f,c,m,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class d extends M.Disposable{constructor(r,u,g,p){super(),this.j=r,this.k=u,this.l=g,this.m=p,this.c=this.D(new L.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},y=>this.k(y))),this.f=this.D(new L.RunOnceWorker(y=>this.t(y),d.b)),this.g=(0,b.parseWatcherPatterns)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,b.parseWatcherPatterns)(this.j.path,this.j.includes):void 0,this.i=new o.CancellationTokenSource,this.ready=this.n()}async n(){try{const r=await this.q(this.j);if(this.i.token.isCancellationRequested)return;const u=await v.Promises.stat(r);this.D(await this.r(r,u.isDirectory()))}catch(r){r.code!=="ENOENT"?this.v(r):this.y(r)}}async q(r){let u=r.path;try{u=await v.Promises.realpath(r.path),r.path===u&&(u=await(0,m.realcase)(r.path)??r.path),r.path!==u&&this.y(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${r.path}, real: ${u})`)}catch{}return u}async r(r,u){if(c.isMacintosh&&(0,A.isEqualOrParent)(r,"/Volumes/",!0))return this.v(`Refusing to watch ${r} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),M.Disposable.None;const g=new o.CancellationTokenSource(this.i.token),p=new M.DisposableStore;try{const y=(0,f.basename)(r),D=(0,P.watch)(r);p.add((0,M.toDisposable)(()=>{D.removeAllListeners(),D.close()})),this.y(`Started watching: '${r}'`);const t=new Set;if(u)try{for(const i of await v.Promises.readdir(r))t.add(i)}catch(i){this.v(i)}const a=new Map;p.add((0,M.toDisposable)(()=>{for(const[,i]of a)i.dispose();a.clear()})),D.on("error",(i,s)=>{this.v(`Failed to watch ${r} for changes using fs.watch() (${i}, ${s})`),this.dispose()}),D.on("change",(i,s)=>{if(g.token.isCancellationRequested)return;this.y(`[raw] ["${i}"] ${s}`);let n="";if(s&&(n=s.toString(),c.isMacintosh&&(n=(0,k.normalizeNFC)(n))),!(!n||i!=="change"&&i!=="rename"))if(u)if(i==="rename"){a.get(n)?.dispose();const h=setTimeout(async()=>{if(a.delete(n),n===y&&!await v.Promises.exists(r)){this.w("Watcher shutdown because watched path got deleted"),this.dispose();return}const l=await this.u((0,f.join)(r,n));if(g.token.isCancellationRequested)return;let E;l?t.has(n)?E=0:(E=1,t.add(n)):(t.delete(n),E=2),this.s({path:(0,f.join)(this.j.path,n),type:E})},d.a);a.set(n,(0,M.toDisposable)(()=>clearTimeout(h)))}else{let h;t.has(n)?h=0:(h=1,t.add(n)),this.s({path:(0,f.join)(this.j.path,n),type:h})}else if(i==="rename"||n!==y){const h=setTimeout(async()=>{const l=await v.Promises.exists(r);g.token.isCancellationRequested||(l?(this.s({path:this.j.path,type:0},!0),p.add(await this.r(r,!1))):(this.s({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},d.a);p.clear(),p.add((0,M.toDisposable)(()=>clearTimeout(h)))}else this.s({path:this.j.path,type:0},!0)})}catch(y){await v.Promises.exists(r)&&!g.token.isCancellationRequested&&this.v(`Failed to watch ${r} for changes using fs.watch() (${y.toString()})`)}return(0,M.toDisposable)(()=>{g.dispose(!0),p.dispose()})}s(r,u=!1){this.i.token.isCancellationRequested||(this.m&&this.y(`${r.type===1?"[ADDED]":r.type===2?"[DELETED]":"[CHANGED]"} ${r.path}`),!u&&this.g.some(g=>g(r.path))?this.m&&this.y(` >> ignored (excluded) ${r.path}`):!u&&this.h&&this.h.length>0&&!this.h.some(g=>g(r.path))?this.m&&this.y(` >> ignored (not included) ${r.path}`):this.f.work(r))}t(r){const u=(0,b.coalesceEvents)(r);if(u.length>0){if(this.m)for(const p of u)this.y(`>> normalized ${p.type===1?"[ADDED]":p.type===2?"[DELETED]":"[CHANGED]"} ${p.path}`);this.c.work(u)?this.c.pending>0&&this.y(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.w(`started ignoring events due to too many file change events at once (incoming: ${u.length}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async u(r){if(c.isLinux)return v.Promises.exists(r);try{const u=(0,f.basename)(r);return(await v.Promises.readdir((0,f.dirname)(r))).some(p=>p===u)}catch(u){return this.y(u),!1}}setVerboseLogging(r){this.m=r}v(r){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${r}`})}w(r){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${r}`})}y(r){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${r}`})}dispose(){this.y(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}d.a=100,d.b=75,e.NodeJSFileWatcherLibrary=d;async function S(w,r,u,g,p=512){const y=await v.Promises.open(w,"r"),D=Buffer.allocUnsafe(p),t=new o.CancellationTokenSource(g);let a,i=!1;const s={path:w,excludes:[],recursive:!1},n=new d(s,h=>{(async()=>{for(const{type:l}of h)if(l===0){if(i)return;i=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:E}=await v.Promises.read(y,D,0,p,null);if(!E||t.token.isCancellationRequested)break;r(D.slice(0,E))}}catch(E){a=new Error(E),t.dispose(!0)}finally{i=!1}}})()});return await n.ready,u(),new Promise((h,l)=>{t.token.onCancellationRequested(async()=>{n.dispose();try{await v.Promises.close(y)}catch(E){a=new Error(E)}a?l(a):h()})})}e.watchFileContents=S}),define(ee[209],te([0,1,3,101,2,4,208]),function(G,e,P,L,o,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class k extends o.Disposable{constructor(){super(...arguments),this.a=this.D(new P.Emitter),this.onDidChangeFile=this.a.event,this.b=this.D(new P.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=P.Event.None,this.c=new Map,this.f=!1}async watch(c){const m=this.i(c),v=m.filter(d=>{const S=this.c.get(d.path);return S?!(0,L.patternsEquals)(S.request.excludes,d.excludes)||!(0,L.patternsEquals)(S.request.includes,d.includes):!0}),b=Array.from(this.c.values()).filter(({request:d})=>!m.find(S=>S.path===d.path&&(0,L.patternsEquals)(S.excludes,d.excludes)&&(0,L.patternsEquals)(S.includes,d.includes))).map(({request:d})=>d.path);v.length&&this.j(`Request to start watching: ${v.map(d=>`${d.path} (excludes: ${d.excludes.length>0?d.excludes:"<none>"}, includes: ${d.includes&&d.includes.length>0?JSON.stringify(d.includes):"<all>"})`).join(",")}`),b.length&&this.j(`Request to stop watching: ${b.join(",")}`);for(const d of b)this.h(d);for(const d of v)this.g(d)}g(c){const m=new M.NodeJSFileWatcherLibrary(c,b=>this.a.fire(b),b=>this.b.fire(b),this.f),v={request:c,instance:m};this.c.set(c.path,v)}async stop(){for(const[c]of this.c)this.h(c);this.c.clear()}h(c){const m=this.c.get(c);m&&(this.c.delete(c),m.instance.dispose())}i(c){const m=new Map;for(const v of c){const b=A.isLinux?v.path:v.path.toLowerCase();m.set(b,v)}return Array.from(m.values())}async setVerboseLogging(c){this.f=c;for(const[,m]of this.c)m.instance.setVerboseLogging(c)}j(c){this.f&&this.b.fire({type:"trace",message:this.k(c)})}k(c,m){return m?`[File Watcher (node.js)] ${c} (path: ${m.request.path})`:`[File Watcher (node.js)] ${c}`}}e.NodeJSWatcher=k}),define(ee[210],te([0,1,79,209]),function(G,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class o extends P.AbstractNonRecursiveWatcherClient{constructor(M,k,f){super(M,k,f),this.m()}l(){return new L.NodeJSWatcher}}e.NodeJSWatcherClient=o}),define(ee[211],te([0,1,14,47,155,79]),function(G,e,P,L,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class M extends A.AbstractUniversalWatcherClient{constructor(f,c,m){super(f,c,m),this.m()}l(f){const c=f.add(new o.Client(P.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return f.add(c.onDidProcessExit(({code:m,signal:v})=>this.n(`terminated by itself with code ${m}, signal: ${v}`))),L.ProxyChannel.toService((0,L.getNextTickChannel)(c.getChannel("watcher")))}}e.UniversalWatcherClient=M}),define(ee[89],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class P{constructor(...o){this.a=new Map;for(const[A,M]of o)this.set(A,M)}set(o,A){const M=this.a.get(o);return this.a.set(o,A),M}has(o){return this.a.has(o)}get(o){return this.a.get(o)}}e.ServiceCollection=P}),define(ee[212],te([0,1,7,13,2,77,202,6,89,99]),function(G,e,P,L,o,A,M,k,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const m=!1;class v extends Error{constructor(r){super("cyclic dependency between services"),this.message=r.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${r.toString()}`}}class b{constructor(r=new f.ServiceCollection,u=!1,g,p=m){this.f=r,this.g=u,this.h=g,this.i=p,this.o=new Set,this.f.set(k.IInstantiationService,this),this._globalGraph=p?g?._globalGraph??new M.Graph(y=>y):void 0}createChild(r){return new b(r,this.g,this,this.i)}invokeFunction(r,...u){const g=S.traceInvocation(this.i,r);let p=!1;try{return r({get:D=>{if(p)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const t=this.m(D,g);if(!t)throw new Error(`[invokeFunction] unknown service '${D}'`);return t}},...u)}finally{p=!0,g.stop()}}createInstance(r,...u){let g,p;return r instanceof A.SyncDescriptor?(g=S.traceCreation(this.i,r.ctor),p=this.j(r.ctor,r.staticArguments.concat(u),g)):(g=S.traceCreation(this.i,r),p=this.j(r,u,g)),g.stop(),p}j(r,u=[],g){const p=k._util.getServiceDependencies(r).sort((t,a)=>t.index-a.index),y=[];for(const t of p){const a=this.m(t.id,g);a||this.u(`[createInstance] ${r.name} depends on UNKNOWN service ${t.id}.`,!1),y.push(a)}const D=p.length>0?p[0].index:u.length;if(u.length!==D){console.trace(`[createInstance] First service dependency of ${r.name} at position ${D+1} conflicts with ${u.length} static arguments`);const t=D-u.length;t>0?u=u.concat(new Array(t)):u=u.slice(0,D)}return Reflect.construct(r,u.concat(y))}k(r,u){if(this.f.get(r)instanceof A.SyncDescriptor)this.f.set(r,u);else if(this.h)this.h.k(r,u);else throw new Error("illegalState - setting UNKNOWN service instance")}l(r){const u=this.f.get(r);return!u&&this.h?this.h.l(r):u}m(r,u){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(r));const g=this.l(r);return g instanceof A.SyncDescriptor?this.q(r,g,u.branch(r,!0)):(u.branch(r,!1),g)}q(r,u,g){if(this.o.has(r))throw new Error(`illegal state - RECURSIVELY instantiating service '${r}'`);this.o.add(r);try{return this.r(r,u,g)}finally{this.o.delete(r)}}r(r,u,g){const p=new M.Graph(t=>t.id.toString());let y=0;const D=[{id:r,desc:u,_trace:g}];for(;D.length;){const t=D.pop();if(p.lookupOrInsertNode(t),y++>1e3)throw new v(p);for(const a of k._util.getServiceDependencies(t.desc.ctor)){const i=this.l(a.id);if(i||this.u(`[createInstance] ${r} depends on ${a.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(a.id)),i instanceof A.SyncDescriptor){const s={id:a.id,desc:i,_trace:t._trace.branch(a.id,!0)};p.insertEdge(t,s),D.push(s)}}}for(;;){const t=p.roots();if(t.length===0){if(!p.isEmpty())throw new v(p);break}for(const{data:a}of t){if(this.l(a.id)instanceof A.SyncDescriptor){const s=this.s(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this.k(a.id,s)}p.removeNode(a)}}return this.l(r)}s(r,u,g=[],p,y){if(this.f.get(r)instanceof A.SyncDescriptor)return this.t(r,u,g,p,y);if(this.h)return this.h.s(r,u,g,p,y);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}t(r,u,g=[],p,y){if(p){const D=new b(void 0,this.g,this,this.i);D.c=String(r);const t=new Map,a=new P.IdleValue(()=>{const i=D.j(u,g,y);for(const[s,n]of t){const h=i[s];if(typeof h=="function")for(const l of n)h.apply(i,l)}return t.clear(),i});return new Proxy(Object.create(null),{get(i,s){if(!a.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let l=t.get(s);return l||(l=new c.LinkedList,t.set(s,l)),(R,C,T)=>{const N=l.push([R,C,T]);return(0,o.toDisposable)(N)}}if(s in i)return i[s];const n=a.value;let h=n[s];return typeof h!="function"||(h=h.bind(n),i[s]=h),h},set(i,s,n){return a.value[s]=n,!0},getPrototypeOf(i){return u.prototype}})}else return this.j(u,g,y)}u(r,u){if(u&&console.warn(r),this.g)throw new Error(r)}}e.InstantiationService=b;var d;(function(w){w[w.None=0]="None",w[w.Creation=1]="Creation",w[w.Invocation=2]="Invocation",w[w.Branch=3]="Branch"})(d||(d={}));class S{static traceInvocation(r,u){return r?new S(2,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):S.c}static traceCreation(r,u){return r?new S(1,u.name):S.c}constructor(r,u){this.type=r,this.name=u,this.g=Date.now(),this.h=[]}branch(r,u){const g=new S(3,r.toString());return this.h.push([r,u,g]),g}stop(){const r=Date.now()-this.g;S.f+=r;let u=!1;function g(y,D){const t=[],a=new Array(y+1).join("	");for(const[i,s,n]of D.h)if(s&&n){u=!0,t.push(`${a}CREATES -> ${i}`);const h=g(y+1,n);h&&t.push(h)}else t.push(`${a}uses -> ${i}`);return t.join(`
`)}const p=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${r.toFixed(2)}ms (grand total ${S.f.toFixed(2)}ms)`];(r>2||u)&&S.all.add(p.join(`
`))}}S.all=new Set,S.c=new class extends S{constructor(){super(0,null)}stop(){}branch(){return this}},S.f=0,e.Trace=S}),define(ee[5],te([0,1,44,3,56,2,35,4,18,11,8,203,6]),function(G,e,P,L,o,A,M,k,f,c,m,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,b.createDecorator)("logService"),e.ILoggerService=(0,b.createDecorator)("loggerService");function d(){return new Date().toISOString()}function S(R){return(0,c.isNumber)(R)}e.isLogLevel=S;var w;(function(R){R[R.Off=0]="Off",R[R.Trace=1]="Trace",R[R.Debug=2]="Debug",R[R.Info=3]="Info",R[R.Warning=4]="Warning",R[R.Error=5]="Error"})(w=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=w.Info;function r(R,C,T){switch(C){case w.Trace:R.trace(T);break;case w.Debug:R.debug(T);break;case w.Info:R.info(T);break;case w.Warning:R.warn(T);break;case w.Error:R.error(T);break;case w.Off:break;default:throw new Error(`Invalid log level ${C}`)}}e.log=r;function u(R,C=!1){let T="";for(let N=0;N<R.length;N++){let z=R[N];if(z instanceof Error&&(z=(0,P.toErrorMessage)(z,C)),typeof z=="object")try{z=JSON.stringify(z)}catch{}T+=(N>0?" ":"")+z}return T}class g extends A.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.D(new L.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(C){this.b!==C&&(this.b=C,this.c.fire(this.b))}getLevel(){return this.b}f(C){return this.b!==w.Off&&this.b<=C}}e.AbstractLogger=g;class p extends g{constructor(C){super(),this.h=C}f(C){return this.h||super.f(C)}trace(C,...T){this.f(w.Trace)&&this.g(w.Trace,u([C,...T],!0))}debug(C,...T){this.f(w.Debug)&&this.g(w.Debug,u([C,...T]))}info(C,...T){this.f(w.Info)&&this.g(w.Info,u([C,...T]))}warn(C,...T){this.f(w.Warning)&&this.g(w.Warning,u([C,...T]))}error(C,...T){if(this.f(w.Error))if(C instanceof Error){const N=Array.prototype.slice.call(arguments);N[0]=C.stack,this.g(w.Error,u(N))}else this.g(w.Error,u([C,...T]))}flush(){}}e.AbstractMessageLogger=p;class y extends g{constructor(C=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(C),this.g=!k.isWindows}trace(C,...T){this.f(w.Trace)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,C,...T):console.log(`[main ${d()}]`,C,...T))}debug(C,...T){this.f(w.Debug)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,C,...T):console.log(`[main ${d()}]`,C,...T))}info(C,...T){this.f(w.Info)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,C,...T):console.log(`[main ${d()}]`,C,...T))}warn(C,...T){this.f(w.Warning)&&(this.g?console.warn(`\x1B[93m[main ${d()}]\x1B[0m`,C,...T):console.warn(`[main ${d()}]`,C,...T))}error(C,...T){this.f(w.Error)&&(this.g?console.error(`\x1B[91m[main ${d()}]\x1B[0m`,C,...T):console.error(`[main ${d()}]`,C,...T))}dispose(){}flush(){}}e.ConsoleMainLogger=y;class D extends g{constructor(C=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(C)}trace(C,...T){this.f(w.Trace)&&console.log("%cTRACE","color: #888",C,...T)}debug(C,...T){this.f(w.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",C,...T)}info(C,...T){this.f(w.Info)&&console.log("%c INFO","color: #33f",C,...T)}warn(C,...T){this.f(w.Warning)&&console.log("%c WARN","color: #993",C,...T)}error(C,...T){this.f(w.Error)&&console.log("%c  ERR","color: #f33",C,...T)}dispose(){}flush(){}}e.ConsoleLogger=D;class t extends g{constructor(C,T=e.DEFAULT_LOG_LEVEL){super(),this.g=C,this.setLevel(T)}trace(C,...T){this.f(w.Trace)&&this.g.log(w.Trace,[this.h(C),...T])}debug(C,...T){this.f(w.Debug)&&this.g.log(w.Debug,[this.h(C),...T])}info(C,...T){this.f(w.Info)&&this.g.log(w.Info,[this.h(C),...T])}warn(C,...T){this.f(w.Warning)&&this.g.log(w.Warning,[this.h(C),...T])}error(C,...T){this.f(w.Error)&&this.g.log(w.Error,[this.h(C),...T])}h(C){return typeof C=="string"?C:(0,P.toErrorMessage)(C,this.f(w.Trace))}dispose(){}flush(){}}e.AdapterLogger=t;class a extends g{constructor(C){super(),this.g=C,C.length&&this.setLevel(C[0].getLevel())}setLevel(C){for(const T of this.g)T.setLevel(C);super.setLevel(C)}trace(C,...T){for(const N of this.g)N.trace(C,...T)}debug(C,...T){for(const N of this.g)N.debug(C,...T)}info(C,...T){for(const N of this.g)N.info(C,...T)}warn(C,...T){for(const N of this.g)N.warn(C,...T)}error(C,...T){for(const N of this.g)N.error(C,...T)}flush(){for(const C of this.g)C.flush()}dispose(){for(const C of this.g)C.dispose()}}e.MultiplexLogger=a;class i extends A.Disposable{constructor(C,T,N){if(super(),this.h=C,this.j=T,this.b=new M.ResourceMap,this.c=this.D(new L.Emitter),this.onDidChangeLoggers=this.c.event,this.f=this.D(new L.Emitter),this.onDidChangeLogLevel=this.f.event,this.g=this.D(new L.Emitter),this.onDidChangeVisibility=this.g.event,N)for(const z of N)this.b.set(z.resource,{logger:void 0,info:z})}k(C){return(0,c.isString)(C)?[...this.b.values()].find(T=>T.info.id===C):this.b.get(C)}getLogger(C){return this.k(C)?.logger}createLogger(C,T){const N=this.l(C),z=(0,c.isString)(C)?C:T?.id??(0,o.hash)(N.toString()).toString(16);let B=this.b.get(N)?.logger;const _=T?.logLevel==="always"?w.Trace:T?.logLevel;B||(B=this.m(N,_??this.getLogLevel(N)??this.h,{...T,id:z}));const ne={logger:B,info:{resource:N,id:z,logLevel:_,name:T?.name,hidden:T?.hidden,extensionId:T?.extensionId,when:T?.when}};return this.registerLogger(ne.info),this.b.set(N,ne),B}l(C){return(0,c.isString)(C)?(0,f.joinPath)(this.j,`${C}.log`):C}setLogLevel(C,T){if(m.URI.isUri(C)){const N=C,z=T,B=this.b.get(N);B&&z!==B.info.logLevel&&(B.info.logLevel=z===this.h?void 0:z,B.logger?.setLevel(z),this.b.set(B.info.resource,B),this.f.fire([N,z]))}else{this.h=C;for(const[N,z]of this.b.entries())this.b.get(N)?.info.logLevel===void 0&&z.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(C,T){const N=this.k(C);N&&T!==!N.info.hidden&&(N.info.hidden=!T,this.b.set(N.info.resource,N),this.g.fire([N.info.resource,T]))}getLogLevel(C){let T;return C&&(T=this.b.get(C)?.info.logLevel),T??this.h}registerLogger(C){const T=this.b.get(C.resource);T?T.info.hidden!==C.hidden&&this.setVisibility(C.resource,!C.hidden):(this.b.set(C.resource,{info:C,logger:void 0}),this.c.fire({added:[C],removed:[]}))}deregisterLogger(C){const T=this.b.get(C);T&&(T.logger&&T.logger.dispose(),this.b.delete(C),this.c.fire({added:[],removed:[T.info]}))}*getRegisteredLoggers(){for(const C of this.b.values())yield C.info}getRegisteredLogger(C){return this.b.get(C)?.info}dispose(){this.b.forEach(C=>C.logger?.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=i;class s{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(C){}getLevel(){return w.Info}trace(C,...T){}debug(C,...T){}info(C,...T){}warn(C,...T){}error(C,...T){}critical(C,...T){}dispose(){}flush(){}}e.NullLogger=s;class n extends s{}e.NullLogService=n;function h(R){if(R.verbose)return w.Trace;if(typeof R.logLevel=="string"){const C=E(R.logLevel.toLowerCase());if(C!==void 0)return C}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=h;function l(R){switch(R){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Off:return"off"}}e.LogLevelToString=l;function E(R){switch(R){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Error;case"off":return w.Off}}e.parseLogLevel=E,e.CONTEXT_LOG_LEVEL=new v.RawContextKey("logLevel",l(w.Info))});var Z=this&&this.__param||function(G,e){return function(P,L){e(P,L,G)}};define(ee[213],te([0,1,78,3,2,5,4,7]),function(G,e,P,L,o,A,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let f=class ht extends o.Disposable{constructor(m){super(),this.h=m,this.c=this.D(new L.Emitter),this.onDidChangePassword=this.c.event,this.g=new k.SequencerByKey}async getPassword(m,v){this.h.trace("Getting password from keytar:",m,v);let b;try{b=await this.i()}catch{return null}return await this.g.queue(m+v,()=>this.k(b,m,v))}async k(m,v,b){const d=await(0,k.retry)(()=>m.getPassword(v,b),50,3);if(!d)return this.h.trace("Did not get a password from keytar for account:",b),d;let S,w;try{const r=JSON.parse(d);S=r.content,w=r.hasNextChunk}catch{}if(!S||!w)return this.h.trace("Got password from keytar for account:",b),d;try{let r=1;for(;w;){const u=await(0,k.retry)(()=>m.getPassword(v,`${b}-${r}`),50,3),g=JSON.parse(u);S+=g.content,w=g.hasNextChunk,r++}return this.h.trace(`Got ${r}-chunked password from keytar for account:`,b),S}catch(r){return this.h.error(r),d}}async setPassword(m,v,b){this.h.trace("Setting password using keytar:",m,v);let d;try{d=await this.i()}catch(S){throw this.j?.(S),S}await this.g.queue(m+v,()=>this.l(d,m,v,b)),this.c.fire({service:m,account:v})}async l(m,v,b,d){if(!M.isWindows){await(0,k.retry)(()=>m.setPassword(v,b,d),50,3),this.h.trace("Set password from keytar for account:",b);return}if(await this.m(m,v,b),d.length<=ht.b){await(0,k.retry)(()=>m.setPassword(v,b,d),50,3),this.h.trace("Set password from keytar for account:",b);return}let S=0,w=0,r=!0;const u=[];for(;r;){const g=d.substring(S,S+ht.b);S+=ht.b,r=d.length-S>0;const p={content:g,hasNextChunk:r};u.push((0,k.retry)(()=>m.setPassword(v,w?`${b}-${w}`:b,JSON.stringify(p)),50,3)),w++}await Promise.all(u),this.h.trace(`Set${w?` ${w}-chunked`:""} password from keytar for account:`,b)}async deletePassword(m,v){this.h.trace("Deleting password using keytar:",m,v);let b;try{b=await this.i()}catch(S){throw this.j?.(S),S}const d=await this.g.queue(m+v,()=>this.m(b,m,v));return d&&this.c.fire({service:m,account:v}),d}async m(m,v,b){const d=await m.getPassword(v,b);if(!d)return this.h.trace("Did not get a password to delete from keytar for account:",b),!1;let S,w;try{const u=JSON.parse(d);S=u.content,w=u.hasNextChunk}catch{}let r=0;if(S&&w)try{for(r++;w;){const u=`${b}-${r}`,g=await m.getPassword(v,u);await m.deletePassword(v,u),w=JSON.parse(g).hasNextChunk,r++}}catch(u){this.h.error(u)}return await m.deletePassword(v,b)?(this.h.trace(`Deleted${r?` ${r}-chunked`:""} password from keytar for account:`,b),!0):(this.h.trace(`Keytar failed to delete${r?` ${r}-chunked`:""} password for account:`,b),!1)}async findPassword(m){let v;try{v=await this.i()}catch{return null}return await v.findPassword(m)}async findCredentials(m){let v;try{v=await this.i()}catch{return[]}return await v.findCredentials(m)}clear(){return this.f instanceof P.InMemoryCredentialsProvider?this.f.clear():Promise.resolve()}};f.a=2500,f.b=f.a-100,f=ye([Z(0,A.ILogService)],f),e.BaseCredentialsMainService=f}),define(ee[214],te([0,1,5]),function(G,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;let L=class{constructor(A,M){this.a=A,this.b=M}c(){return new Promise((A,M)=>G(["vscode-encrypt"],A,M))}async encrypt(A){let M;try{M=await this.c()}catch{return A}try{return M.encrypt(this.a,A)}catch(k){return this.b.error(k),A}}async decrypt(A){let M;try{M=await this.c()}catch{return A}try{return M.decrypt(this.a,A)}catch(k){return this.b.error(k),A}}};L=ye([Z(1,P.ILogService)],L),e.EncryptionMainService=L}),define(ee[215],te([0,1,27,7,13,3,2,9,79,5]),function(G,e,P,L,o,A,M,k,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class m extends M.Disposable{constructor(b,d){super(),this.a=b,this.b=d,this.c=this.D(new A.Emitter),this.onDidChangeFile=this.c.event,this.g=this.D(new A.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.D(new L.ThrottledDelayer(0)),this.r=[],this.s=this.D(new L.ThrottledDelayer(0))}watch(b,d){return d.recursive||this.b?.watcher?.forceUniversal?this.l(b,d):this.t(b,d)}l(b,d){const S={path:this.z(b),excludes:d.excludes,includes:d.includes,recursive:d.recursive},w=(0,P.insert)(this.j,S);return this.m(),(0,M.toDisposable)(()=>{w(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(b=>(0,o.onUnexpectedError)(b))}n(){this.h||(this.h=this.D(this.p(d=>this.c.fire((0,f.toFileChanges)(d)),d=>this.y(d),this.a.getLevel()===c.LogLevel.Trace)),this.D(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)})));const b=this.b?.watcher?.recursive?.usePolling;if(b===!0)for(const d of this.j)(0,f.isRecursiveWatchRequest)(d)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(b))for(const d of this.j)(0,f.isRecursiveWatchRequest)(d)&&b.includes(d.path)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}t(b,d){const S={path:this.z(b),excludes:d.excludes,includes:d.includes,recursive:!1},w=(0,P.insert)(this.r,S);return this.u(),(0,M.toDisposable)(()=>{w(),this.u()})}u(){this.s.trigger(()=>this.v()).catch(b=>(0,o.onUnexpectedError)(b))}v(){return this.q||(this.q=this.D(this.w(b=>this.c.fire((0,f.toFileChanges)(b)),b=>this.y(b),this.a.getLevel()===c.LogLevel.Trace)),this.D(this.a.onDidChangeLogLevel(()=>{this.q?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)}))),this.q.watch(this.r)}y(b){b.type==="error"&&this.g.fire(b.message),this.a[b.type](b.message)}z(b){return(0,k.normalize)(b.fsPath)}}e.AbstractDiskFileSystemProvider=m}),define(ee[216],te([0,1,27,7,17,22,3,56,71,2,61,14,64,18,60,170,16,112,5,13]),function(G,e,P,L,o,A,M,k,f,c,m,v,b,d,S,w,r,u,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let y=class extends c.Disposable{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.D(new M.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.D(new M.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.D(new M.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.D(new M.Emitter),this.onDidRunOperation=this.m.event,this.R=this.D(new M.Emitter),this.onDidFilesChange=this.R.event,this.S=this.D(new M.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.D(new L.ResourceQueue)}registerProvider(t,a){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,b.mark)(`code/registerFilesystem/${t}`);const i=new c.DisposableStore;return this.h.set(t,a),this.c.fire({added:!0,scheme:t,provider:a}),i.add(a.onDidChangeFile(s=>this.R.fire(new r.FileChangesEvent(s,!this.O(a))))),typeof a.onDidWatchError=="function"&&i.add(a.onDidWatchError(s=>this.S.fire(new Error(s)))),i.add(a.onDidChangeCapabilities(()=>this.g.fire({provider:a,scheme:t}))),(0,c.toDisposable)(()=>{this.c.fire({added:!1,scheme:t,provider:a}),this.h.delete(t),(0,c.dispose)(i)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const a=[];this.f.fire({scheme:t,join(i){a.push(i)}}),!this.h.has(t)&&await L.Promises.settled(a)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,a){const i=this.h.get(t.scheme);return!!(i&&i.capabilities&a)}listCapabilities(){return f.Iterable.map(this.h,([t,a])=>({scheme:t,capabilities:a.capabilities}))}async j(t){if(!(0,d.isAbsolutePath)(t))throw new r.FileOperationError((0,w.localize)(0,null,this.nb(t)),8);await this.activateProvider(t.scheme);const a=this.h.get(t.scheme);if(!a){const i=new p.ErrorNoTelemetry;throw i.message=(0,w.localize)(1,null,t.toString()),i}return a}async k(t){const a=await this.j(t);if((0,r.hasOpenReadWriteCloseCapability)(a)||(0,r.hasReadWriteCapability)(a)||(0,r.hasFileReadStreamCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(t){const a=await this.j(t);if((0,r.hasOpenReadWriteCloseCapability)(a)||(0,r.hasReadWriteCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,a){try{return await this.n(t,a)}catch(i){throw(0,r.toFileSystemProviderErrorCode)(i)===r.FileSystemProviderErrorCode.FileNotFound?new r.FileOperationError((0,w.localize)(2,null,this.nb(t)),1):(0,r.ensureFileSystemProviderError)(i)}}async n(t,a){const i=await this.j(t),s=this.O(i),n=a?.resolveTo,h=a?.resolveSingleChildDescendants,l=a?.resolveMetadata,E=await i.stat(t);let R;return this.p(i,t,E,void 0,!!l,(C,T)=>(R||(R=m.TernarySearchTree.forUris(()=>!s),R.set(t,!0),n&&R.fill(!0,n)),R.get(C.resource)||R.findSuperstr(C.resource.with({query:null,fragment:null}))?!0:C.isDirectory&&h?T===1:!1))}async p(t,a,i,s,n,h){const{providerExtUri:l}=this.N(t),E={resource:a,name:l.basename(a),isFile:(i.type&r.FileType.File)!==0,isDirectory:(i.type&r.FileType.Directory)!==0,isSymbolicLink:(i.type&r.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:Boolean((i.permissions??0)&r.FilePermission.Readonly)||Boolean(t.capabilities&2048),etag:(0,r.etag)({mtime:i.mtime,size:i.size}),children:void 0};if(E.isDirectory&&h(E,s)){try{const R=await t.readdir(a),C=await L.Promises.settled(R.map(async([T,N])=>{try{const z=l.joinPath(a,T),B=n?await t.stat(z):{type:N};return await this.p(t,z,B,R.length,n,h)}catch(z){return this.b.trace(z),null}}));E.children=(0,P.coalesce)(C)}catch(R){this.b.trace(R),E.children=[]}return E}return E}async resolveAll(t){return L.Promises.settled(t.map(async a=>{try{return{stat:await this.n(a.resource,a.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(t){const a=await this.j(t),i=await a.stat(t);return this.p(a,t,i,void 0,!0,()=>!1)}async exists(t){const a=await this.j(t);try{return!!await a.stat(t)}catch{return!1}}async canCreateFile(t,a){try{await this.q(t,a)}catch(i){return i}return!0}async q(t,a){if(!a?.overwrite&&await this.exists(t))throw new r.FileOperationError((0,w.localize)(3,null,this.nb(t)),3,a)}async createFile(t,a=o.VSBuffer.fromString(""),i){await this.q(t,i);const s=await this.writeFile(t,a);return this.m.fire(new r.FileOperationEvent(t,0,s)),s}async writeFile(t,a,i){const s=this.lb(await this.l(t),t),{providerExtUri:n}=this.N(s);try{await this.r(s,t,i)||await this.P(s,n.dirname(t));let l;if((0,r.hasReadWriteCapability)(s)&&!(a instanceof o.VSBuffer))if((0,S.isReadableStream)(a)){const E=await(0,S.peekStream)(a,3);E.ended?l=o.VSBuffer.concat(E.buffer):l=E}else l=(0,S.peekReadable)(a,E=>o.VSBuffer.concat(E),3);else l=a;!(0,r.hasOpenReadWriteCloseCapability)(s)||(0,r.hasReadWriteCapability)(s)&&l instanceof o.VSBuffer?await this.cb(s,t,i,l):await this.Y(s,t,i,l instanceof o.VSBuffer?(0,o.bufferToReadable)(l):l),this.m.fire(new r.FileOperationEvent(t,4))}catch(h){throw new r.FileOperationError((0,w.localize)(4,null,this.nb(t),(0,r.ensureFileSystemProviderError)(h).toString()),(0,r.toFileOperationResult)(h),i)}return this.resolve(t,{resolveMetadata:!0})}async r(t,a,i){if(!!i?.unlock&&!(t.capabilities&8192))throw new Error((0,w.localize)(5,null,this.nb(a)));let n;try{n=await t.stat(a)}catch{return}if((n.type&r.FileType.Directory)!==0)throw new r.FileOperationError((0,w.localize)(6,null,this.nb(a)),0,i);if(this.mb(a,n),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==r.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&i.mtime<n.mtime&&i.etag!==(0,r.etag)({mtime:i.mtime,size:n.size}))throw new r.FileOperationError((0,w.localize)(7,null),3,i);return n}async readFile(t,a,i){const s=await this.k(t);return a?.atomic?this.s(s,t,a,i):this.t(s,t,a,i)}async s(t,a,i,s){return new Promise((n,h)=>{this.X.queueFor(a,this.N(t).providerExtUri).queue(async()=>{try{const l=await this.t(t,a,i,s);n(l)}catch(l){h(l)}})})}async t(t,a,i,s){const n=await this.u(t,a,{...i,preferUnbuffered:!0},s);return{...n,value:await(0,o.streamToBuffer)(n.value)}}async readFileStream(t,a,i){const s=await this.k(t);return this.u(s,t,a,i)}async u(t,a,i,s){const n=new A.CancellationTokenSource(s),h=this.F(a,i).then(E=>E,E=>{throw n.cancel(),E});let l;try{return typeof i?.etag=="string"&&i.etag!==r.ETAG_DISABLED&&await h,i?.atomic&&(0,r.hasFileAtomicReadCapability)(t)||!((0,r.hasOpenReadWriteCloseCapability)(t)||(0,r.hasFileReadStreamCapability)(t))||(0,r.hasReadWriteCapability)(t)&&i?.preferUnbuffered?l=this.C(t,a,i):(0,r.hasFileReadStreamCapability)(t)?l=this.w(t,a,n.token,i):l=this.z(t,a,n.token,i),{...await h,value:l}}catch(E){throw l&&await(0,S.consumeStream)(l),this.v(E,a,i)}}v(t,a,i){const s=(0,w.localize)(8,null,this.nb(a),(0,r.ensureFileSystemProviderError)(t).toString());return t instanceof r.NotModifiedSinceFileOperationError?new r.NotModifiedSinceFileOperationError(s,t.stat,i):t instanceof r.TooLargeFileOperationError?new r.TooLargeFileOperationError(s,t.fileOperationResult,t.size,t.options):new r.FileOperationError(s,(0,r.toFileOperationResult)(t),i)}w(t,a,i,s=Object.create(null)){const n=t.readFileStream(a,s,i);return(0,S.transform)(n,{data:h=>h instanceof o.VSBuffer?h:o.VSBuffer.wrap(h),error:h=>this.v(h,a,s)},h=>o.VSBuffer.concat(h))}z(t,a,i,s=Object.create(null)){const n=(0,o.newWriteableBufferStream)();return(0,u.readFileIntoStream)(t,a,n,h=>h,{...s,bufferSize:this.a,errorTransformer:h=>this.v(h,a,s)},i),n}C(t,a,i){const s=(0,S.newWriteableStream)(n=>o.VSBuffer.concat(n));return(async()=>{try{let n;i?.atomic&&(0,r.hasFileAtomicReadCapability)(t)?n=await t.readFile(a,{atomic:!0}):n=await t.readFile(a),typeof i?.position=="number"&&(n=n.slice(i.position)),typeof i?.length=="number"&&(n=n.slice(0,i.length)),this.G(a,n.byteLength,i),s.end(o.VSBuffer.wrap(n))}catch(n){s.error(n),s.end()}})(),s}async F(t,a){const i=await this.resolve(t,{resolveMetadata:!0});if(i.isDirectory)throw new r.FileOperationError((0,w.localize)(9,null,this.nb(t)),0,a);if(typeof a?.etag=="string"&&a.etag!==r.ETAG_DISABLED&&a.etag===i.etag)throw new r.NotModifiedSinceFileOperationError((0,w.localize)(10,null),i,a);return this.G(t,i.size,a),i}G(t,a,i){if(i?.limits){let s;if(typeof i.limits.memory=="number"&&a>i.limits.memory&&(s=9),typeof i.limits.size=="number"&&a>i.limits.size&&(s=7),typeof s=="number")throw new r.TooLargeFileOperationError((0,w.localize)(11,null,this.nb(t)),s,a,i)}}async canMove(t,a,i){return this.H(t,a,"move",i)}async canCopy(t,a,i){return this.H(t,a,"copy",i)}async H(t,a,i,s){if(t.toString()!==a.toString())try{const n=i==="move"?this.lb(await this.l(t),t):await this.k(t),h=this.lb(await this.l(a),a);await this.M(n,t,h,a,i,s)}catch(n){return n}return!0}async move(t,a,i){const s=this.lb(await this.l(t),t),n=this.lb(await this.l(a),a),h=await this.I(s,t,n,a,"move",!!i),l=await this.resolve(a,{resolveMetadata:!0});return this.m.fire(new r.FileOperationEvent(t,h==="move"?2:3,l)),l}async copy(t,a,i){const s=await this.k(t),n=this.lb(await this.l(a),a),h=await this.I(s,t,n,a,"copy",!!i),l=await this.resolve(a,{resolveMetadata:!0});return this.m.fire(new r.FileOperationEvent(t,h==="copy"?3:2,l)),l}async I(t,a,i,s,n,h){if(a.toString()===s.toString())return n;const{exists:l,isSameResourceWithDifferentPathCase:E}=await this.M(t,a,i,s,n,h);if(l&&!E&&h&&await this.del(s,{recursive:!0}),await this.P(i,this.N(i).providerExtUri.dirname(s)),n==="copy"){if(t===i&&(0,r.hasFileFolderCopyCapability)(t))await t.copy(a,s,{overwrite:h});else{const R=await this.resolve(a);R.isDirectory?await this.L(t,R,i,s):await this.J(t,a,i,s)}return n}else return t===i?(await t.rename(a,s,{overwrite:h}),n):(await this.I(t,a,i,s,"copy",h),await this.del(a,{recursive:!0}),"copy")}async J(t,a,i,s){if((0,r.hasOpenReadWriteCloseCapability)(t)&&(0,r.hasOpenReadWriteCloseCapability)(i))return this.eb(t,a,i,s);if((0,r.hasOpenReadWriteCloseCapability)(t)&&(0,r.hasReadWriteCapability)(i))return this.kb(t,a,i,s);if((0,r.hasReadWriteCapability)(t)&&(0,r.hasOpenReadWriteCloseCapability)(i))return this.ib(t,a,i,s);if((0,r.hasReadWriteCapability)(t)&&(0,r.hasReadWriteCapability)(i))return this.gb(t,a,i,s)}async L(t,a,i,s){await i.mkdir(s),Array.isArray(a.children)&&await L.Promises.settled(a.children.map(async n=>{const h=this.N(i).providerExtUri.joinPath(s,n.name);return n.isDirectory?this.L(t,await this.resolve(n.resource),i,h):this.J(t,n.resource,i,h)}))}async M(t,a,i,s,n,h){let l=!1;if(t===i){const{providerExtUri:R,isPathCaseSensitive:C}=this.N(t);if(C||(l=R.isEqual(a,s)),l&&n==="copy")throw new Error((0,w.localize)(12,null,this.nb(a),this.nb(s)));if(!l&&R.isEqualOrParent(s,a))throw new Error((0,w.localize)(13,null,this.nb(a),this.nb(s)))}const E=await this.exists(s);if(E&&!l){if(!h)throw new r.FileOperationError((0,w.localize)(14,null,this.nb(a),this.nb(s)),4);if(t===i){const{providerExtUri:R}=this.N(t);if(R.isEqualOrParent(a,s))throw new Error((0,w.localize)(15,null,this.nb(a),this.nb(s)))}}return{exists:E,isSameResourceWithDifferentPathCase:l}}N(t){const a=this.O(t);return{providerExtUri:a?d.extUri:d.extUriIgnorePathCase,isPathCaseSensitive:a}}O(t){return!!(t.capabilities&1024)}async createFolder(t){const a=this.lb(await this.j(t),t);await this.P(a,t);const i=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new r.FileOperationEvent(t,0,i)),i}async P(t,a){const i=[],{providerExtUri:s}=this.N(t);for(;!s.isEqual(a,s.dirname(a));)try{if(((await t.stat(a)).type&r.FileType.Directory)===0)throw new Error((0,w.localize)(16,null,this.nb(a)));break}catch(n){if((0,r.toFileSystemProviderErrorCode)(n)!==r.FileSystemProviderErrorCode.FileNotFound)throw n;i.push(s.basename(a)),a=s.dirname(a)}for(let n=i.length-1;n>=0;n--){a=s.joinPath(a,i[n]);try{await t.mkdir(a)}catch(h){if((0,r.toFileSystemProviderErrorCode)(h)!==r.FileSystemProviderErrorCode.FileExists)throw h}}}async canDelete(t,a){try{await this.Q(t,a)}catch(i){return i}return!0}async Q(t,a){const i=this.lb(await this.j(t),t);if(!!a?.useTrash&&!(i.capabilities&4096))throw new Error((0,w.localize)(17,null,this.nb(t)));let n;try{n=await i.stat(t)}catch{}if(n)this.mb(t,n);else throw new r.FileOperationError((0,w.localize)(18,null,this.nb(t)),1);if(!!!a?.recursive){const l=await this.resolve(t);if(l.isDirectory&&Array.isArray(l.children)&&l.children.length>0)throw new Error((0,w.localize)(19,null,this.nb(t)))}return i}async del(t,a){const i=await this.Q(t,a),s=!!a?.useTrash,n=!!a?.recursive;await i.delete(t,{recursive:n,useTrash:s}),this.m.fire(new r.FileOperationEvent(t,1))}async cloneFile(t,a){const i=await this.j(t),s=this.lb(await this.l(a),a);if(i===s&&this.N(i).providerExtUri.isEqual(t,a))return;if(i===s&&(0,r.hasFileCloneCapability)(i))return i.cloneFile(t,a);await this.P(s,this.N(s).providerExtUri.dirname(a));const n=this.X.queueFor(t,this.N(i).providerExtUri);return i===s&&(0,r.hasFileFolderCopyCapability)(i)?n.queue(()=>i.copy(t,a,{overwrite:!0})):n.queue(()=>this.J(i,t,s,a))}watch(t,a={recursive:!1,excludes:[]}){const i=new c.DisposableStore;let s=!1,n=()=>{s=!0};return i.add((0,c.toDisposable)(()=>n())),(async()=>{try{const h=await this.W(t,a);s?(0,c.dispose)(h):n=()=>(0,c.dispose)(h)}catch(h){this.b.error(h)}})(),i}async W(t,a){const i=await this.j(t),s=(0,k.hash)([this.N(i).providerExtUri.getComparisonKey(t),a]);let n=this.U.get(s);return n||(n={count:0,disposable:i.watch(t,a)},this.U.set(s,n)),n.count+=1,(0,c.toDisposable)(()=>{n&&(n.count--,n.count===0&&((0,c.dispose)(n.disposable),this.U.delete(s)))})}dispose(){super.dispose();for(const[,t]of this.U)(0,c.dispose)(t.disposable);this.U.clear()}async Y(t,a,i,s){return this.X.queueFor(a,this.N(t).providerExtUri).queue(async()=>{const n=await t.open(a,{create:!0,unlock:i?.unlock??!1});try{(0,S.isReadableStream)(s)||(0,S.isReadableBufferedStream)(s)?await this.Z(t,n,s):await this.ab(t,n,s)}catch(h){throw(0,r.ensureFileSystemProviderError)(h)}finally{await t.close(n)}})}async Z(t,a,i){let s=0,n;if((0,S.isReadableBufferedStream)(i)){if(i.buffer.length>0){const h=o.VSBuffer.concat(i.buffer);await this.bb(t,a,h,h.byteLength,s,0),s+=h.byteLength}if(i.ended)return;n=i.stream}else n=i;return new Promise((h,l)=>{(0,S.listenStream)(n,{onData:async E=>{n.pause();try{await this.bb(t,a,E,E.byteLength,s,0)}catch(R){return l(R)}s+=E.byteLength,setTimeout(()=>n.resume())},onError:E=>l(E),onEnd:()=>h()})})}async ab(t,a,i){let s=0,n;for(;(n=i.read())!==null;)await this.bb(t,a,n,n.byteLength,s,0),s+=n.byteLength}async bb(t,a,i,s,n,h){let l=0;for(;l<s;)l+=await t.write(a,n+l,i.buffer,h+l,s-l)}async cb(t,a,i,s){return this.X.queueFor(a,this.N(t).providerExtUri).queue(()=>this.db(t,a,i,s))}async db(t,a,i,s){let n;s instanceof o.VSBuffer?n=s:(0,S.isReadableStream)(s)?n=await(0,o.streamToBuffer)(s):(0,S.isReadableBufferedStream)(s)?n=await(0,o.bufferedStreamToBuffer)(s):n=(0,o.readableToBuffer)(s),await t.writeFile(a,n.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1})}async eb(t,a,i,s){return this.X.queueFor(s,this.N(i).providerExtUri).queue(()=>this.fb(t,a,i,s))}async fb(t,a,i,s){let n,h;try{n=await t.open(a,{create:!1}),h=await i.open(s,{create:!0,unlock:!1});const l=o.VSBuffer.alloc(this.a);let E=0,R=0,C=0;do C=await t.read(n,E,l.buffer,R,l.byteLength-R),await this.bb(i,h,l,C,E,R),E+=C,R+=C,R===l.byteLength&&(R=0);while(C>0)}catch(l){throw(0,r.ensureFileSystemProviderError)(l)}finally{await L.Promises.settled([typeof n=="number"?t.close(n):Promise.resolve(),typeof h=="number"?i.close(h):Promise.resolve()])}}async gb(t,a,i,s){return this.X.queueFor(s,this.N(i).providerExtUri).queue(()=>this.hb(t,a,i,s))}async hb(t,a,i,s){return i.writeFile(s,await t.readFile(a),{create:!0,overwrite:!0,unlock:!1})}async ib(t,a,i,s){return this.X.queueFor(s,this.N(i).providerExtUri).queue(()=>this.jb(t,a,i,s))}async jb(t,a,i,s){const n=await i.open(s,{create:!0,unlock:!1});try{const h=await t.readFile(a);await this.bb(i,n,o.VSBuffer.wrap(h),h.byteLength,0,0)}catch(h){throw(0,r.ensureFileSystemProviderError)(h)}finally{await i.close(n)}}async kb(t,a,i,s){const n=await(0,o.streamToBuffer)(this.z(t,a,A.CancellationToken.None));await this.cb(i,s,void 0,n)}lb(t,a){if(t.capabilities&2048)throw new r.FileOperationError((0,w.localize)(20,null,this.nb(a)),6);return t}mb(t,a){if((a.permissions??0)&r.FilePermission.Readonly)throw new r.FileOperationError((0,w.localize)(21,null,this.nb(t)),6)}nb(t){return t.scheme===v.Schemas.file?t.fsPath:t.toString(!0)}};y=ye([Z(0,g.ILogService)],y),e.FileService=y}),define(ee[90],te([0,1,41,293,7,35,17,3,32,2,9,4,18,60,23,174,16,112,215,44,211,210]),function(G,e,P,L,o,A,M,k,f,c,m,v,b,d,S,w,r,u,g,p,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,L.gracefulify)(P)}catch(a){console.error(`Error enabling graceful-fs: ${(0,p.toErrorMessage)(a)}`)}})();class t extends g.AbstractDiskFileSystemProvider{constructor(i,s){super(i,s),this.onDidChangeCapabilities=k.Event.None,this.H=new A.ResourceMap(n=>b.extUriBiasedIgnorePathCase.getComparisonKey(n)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,v.isLinux&&(this.F|=1024)),this.F}async stat(i){try{const{stat:s,symbolicLink:n}=await S.SymlinkSupport.stat(this.z(i));return{type:this.G(s,n),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size}}catch(s){throw this.Y(s)}}async readdir(i){try{const s=await S.Promises.readdir(this.z(i),{withFileTypes:!0}),n=[];return await Promise.all(s.map(async h=>{try{let l;h.isSymbolicLink()?l=(await this.stat((0,b.joinPath)(i,h.name))).type:l=this.G(h),n.push([h.name,l])}catch(l){this.a.trace(l)}})),n}catch(s){throw this.Y(s)}}G(i,s){let n;return s?.dangling?n=r.FileType.Unknown:i.isFile()?n=r.FileType.File:i.isDirectory()?n=r.FileType.Directory:n=r.FileType.Unknown,s&&(n|=r.FileType.SymbolicLink),n}async I(i){const s=this.z(i);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let n;for(;n=this.H.get(i);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await n.wait();const h=new o.Barrier;return this.H.set(i,h),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,c.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.H.get(i)===h&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.H.delete(i)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),h.open()})}async readFile(i,s){let n;try{s?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.z(i)})`),n=await this.I(i));const h=this.z(i);return await S.Promises.readFile(h)}catch(h){throw this.Y(h)}finally{n?.dispose()}}J(i){t.C&&this.a.trace(i)}readFileStream(i,s,n){const h=(0,d.newWriteableStream)(l=>M.VSBuffer.concat(l.map(E=>M.VSBuffer.wrap(E))).buffer);return(0,u.readFileIntoStream)(this,i,h,l=>l.buffer,{...s,bufferSize:256*1024},n),h}async writeFile(i,s,n){let h;try{const l=this.z(i);if(!n.create||!n.overwrite){if(await S.Promises.exists(l)){if(!n.overwrite)throw(0,r.createFileSystemProviderError)((0,w.localize)(0,null),r.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,r.createFileSystemProviderError)((0,w.localize)(1,null),r.FileSystemProviderErrorCode.FileNotFound)}h=await this.open(i,{create:!0,unlock:n.unlock}),await this.write(h,0,s,0,s.byteLength)}catch(l){throw await this.Z(i,l)}finally{typeof h=="number"&&await this.close(h)}}static configureFlushOnWrite(i){t.O=i}async open(i,s){const n=this.z(i);let h;(0,r.isFileOpenForWriteOptions)(s)&&(h=await this.I(i));let l;try{if((0,r.isFileOpenForWriteOptions)(s)&&s.unlock)try{const{stat:R}=await S.SymlinkSupport.stat(n);R.mode&128||await S.Promises.chmod(n,R.mode|128)}catch(R){this.a.trace(R)}let E;if((0,r.isFileOpenForWriteOptions)(s)){if(v.isWindows)try{await S.Promises.truncate(n,0),E="r+"}catch(R){R.code!=="ENOENT"&&this.a.trace(R)}E||(E="w")}else E="r";l=await S.Promises.open(n,E)}catch(E){throw h?.dispose(),(0,r.isFileOpenForWriteOptions)(s)?await this.Z(i,E):this.Y(E)}if(this.L.set(l,0),(0,r.isFileOpenForWriteOptions)(s)&&this.N.set(l,i),h){const E=this.M.get(l);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${l} (${n})`),this.M.set(l,h),E&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${l} (${n})`),E.dispose())}return l}async close(i){const s=this.M.get(i);try{if(this.L.delete(i),this.N.delete(i)&&t.O)try{await S.Promises.fdatasync(i)}catch(n){t.configureFlushOnWrite(!1),this.a.error(n)}return await S.Promises.close(i)}catch(n){throw this.Y(n)}finally{s&&(this.M.get(i)===s&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.M.delete(i)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),s.dispose())}}async read(i,s,n,h,l){const E=this.P(i,s);let R=null;try{R=(await S.Promises.read(i,n,h,l,E)).bytesRead}catch(C){throw this.Y(C)}finally{this.Q(i,E,R)}return R}P(i,s){return s===this.L.get(i)?null:s}Q(i,s,n){const h=this.L.get(i);typeof h=="number"&&(typeof s=="number"||(typeof n=="number"?this.L.set(i,h+n):this.L.delete(i)))}async write(i,s,n,h,l){return(0,o.retry)(()=>this.R(i,s,n,h,l),100,3)}async R(i,s,n,h,l){const E=this.P(i,s);let R=null;try{R=(await S.Promises.write(i,n,h,l,E)).bytesWritten}catch(C){throw await this.Z(this.N.get(i),C)}finally{this.Q(i,E,R)}return R}async mkdir(i){try{await S.Promises.mkdir(this.z(i))}catch(s){throw this.Y(s)}}async delete(i,s){try{const n=this.z(i);s.recursive?await S.Promises.rm(n,S.RimRafMode.MOVE):await S.Promises.unlink(n)}catch(n){throw this.Y(n)}}async rename(i,s,n){const h=this.z(i),l=this.z(s);if(h!==l)try{await this.S(i,s,"move",n.overwrite),await S.Promises.move(h,l)}catch(E){throw(E.code==="EINVAL"||E.code==="EBUSY"||E.code==="ENAMETOOLONG")&&(E=new Error((0,w.localize)(2,null,(0,m.basename)(h),(0,m.basename)((0,m.dirname)(l)),E.toString()))),this.Y(E)}}async copy(i,s,n){const h=this.z(i),l=this.z(s);if(h!==l)try{await this.S(i,s,"copy",n.overwrite),await S.Promises.copy(h,l,{preserveSymlinks:!0})}catch(E){throw(E.code==="EINVAL"||E.code==="EBUSY"||E.code==="ENAMETOOLONG")&&(E=new Error((0,w.localize)(3,null,(0,m.basename)(h),(0,m.basename)((0,m.dirname)(l)),E.toString()))),this.Y(E)}}async S(i,s,n,h){const l=this.z(i),E=this.z(s);let R=!1;if(!!(this.capabilities&1024)||(R=(0,f.isEqual)(l,E,!0)),R&&n==="copy")throw(0,r.createFileSystemProviderError)((0,w.localize)(4,null),r.FileSystemProviderErrorCode.FileExists);if(!R&&await S.Promises.exists(E)){if(!h)throw(0,r.createFileSystemProviderError)((0,w.localize)(5,null),r.FileSystemProviderErrorCode.FileExists);await this.delete(s,{recursive:!0,useTrash:!1})}}async cloneFile(i,s){return this.U(i,s,!1)}async U(i,s,n){const h=this.z(i),l=this.z(s),E=!!(this.capabilities&1024);if((0,f.isEqual)(h,l,!E))return;const R=new c.DisposableStore;try{const[C,T]=await Promise.all([this.I(i),this.I(s)]);R.add(C),R.add(T),n&&await S.Promises.mkdir((0,m.dirname)(l),{recursive:!0}),await S.Promises.copyFile(h,l)}catch(C){if(C.code==="ENOENT"&&!n)return this.U(i,s,!0);throw this.Y(C)}finally{R.dispose()}}p(i,s,n){return new y.UniversalWatcherClient(h=>i(h),h=>s(h),n)}w(i,s,n){return new D.NodeJSWatcherClient(h=>i(h),h=>s(h),n)}Y(i){if(i instanceof r.FileSystemProviderError)return i;let s;switch(i.code){case"ENOENT":s=r.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=r.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=r.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=r.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=r.FileSystemProviderErrorCode.NoPermissions;break;default:s=r.FileSystemProviderErrorCode.Unknown}return(0,r.createFileSystemProviderError)(i,s)}async Z(i,s){let n=this.Y(s);if(i&&n.code===r.FileSystemProviderErrorCode.NoPermissions)try{const{stat:h}=await S.SymlinkSupport.stat(this.z(i));h.mode&128||(n=(0,r.createFileSystemProviderError)(s,r.FileSystemProviderErrorCode.FileWriteLocked))}catch(h){this.a.trace(h)}return n}}t.C=!1,t.O=!0,e.DiskFileSystemProvider=t}),define(ee[217],te([0,1,3,90,2,17,60,22]),function(G,e,P,L,o,A,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class f extends o.Disposable{constructor(v,b){super(),this.a=v,this.b=b,this.v=new Map,this.w=new Map}call(v,b,d){const S=this.c(v);switch(b){case"stat":return this.g(S,d[0]);case"readdir":return this.h(S,d[0]);case"open":return this.l(S,d[0],d[1]);case"close":return this.m(d[0]);case"read":return this.n(d[0],d[1],d[2]);case"readFile":return this.i(S,d[0],d[1]);case"write":return this.p(d[0],d[1],d[2],d[3],d[4]);case"writeFile":return this.k(S,d[0],d[1],d[2]);case"rename":return this.s(S,d[0],d[1],d[2]);case"copy":return this.t(S,d[0],d[1],d[2]);case"cloneFile":return this.u(S,d[0],d[1]);case"mkdir":return this.q(S,d[0]);case"delete":return this.r(S,d[0],d[1]);case"watch":return this.z(S,d[0],d[1],d[2],d[3]);case"unwatch":return this.C(d[0],d[1])}throw new Error(`IPC Command ${b} not found`)}listen(v,b,d){const S=this.c(v);switch(b){case"fileChange":return this.y(S,d[0]);case"readFileStream":return this.j(S,d[0],d[1])}throw new Error(`Unknown event ${b}`)}g(v,b){const d=this.f(v,b,!0);return this.a.stat(d)}h(v,b){const d=this.f(v,b);return this.a.readdir(d)}async i(v,b,d){const S=this.f(v,b,!0),w=await this.a.readFile(S,d);return A.VSBuffer.wrap(w)}j(v,b,d){const S=this.f(v,b,!0),w=new k.CancellationTokenSource,r=new P.Emitter({onDidRemoveLastListener:()=>{w.cancel()}}),u=this.a.readFileStream(S,d,w.token);return(0,M.listenStream)(u,{onData:g=>r.fire(A.VSBuffer.wrap(g)),onError:g=>r.fire(g),onEnd:()=>{r.fire("end"),r.dispose(),w.dispose()}}),r.event}k(v,b,d,S){const w=this.f(v,b);return this.a.writeFile(w,d.buffer,S)}l(v,b,d){const S=this.f(v,b,!0);return this.a.open(S,d)}m(v){return this.a.close(v)}async n(v,b,d){const S=A.VSBuffer.alloc(d),w=0,r=await this.a.read(v,b,S.buffer,w,d);return[S,r]}p(v,b,d,S,w){return this.a.write(v,b,d.buffer,S,w)}q(v,b){const d=this.f(v,b);return this.a.mkdir(d)}r(v,b,d){const S=this.f(v,b);return this.a.delete(S,d)}s(v,b,d,S){const w=this.f(v,b),r=this.f(v,d);return this.a.rename(w,r,S)}t(v,b,d,S){const w=this.f(v,b),r=this.f(v,d);return this.a.copy(w,r,S)}u(v,b,d){const S=this.f(v,b),w=this.f(v,d);return this.a.cloneFile(S,w)}y(v,b){const d=new P.Emitter({onWillAddFirstListener:()=>{this.v.set(b,this.F(v,d))},onDidRemoveLastListener:()=>{(0,o.dispose)(this.v.get(b)),this.v.delete(b)}});return d.event}async z(v,b,d,S,w){const r=this.v.get(b);if(r){const u=this.f(v,S),g=r.watch(d,u,w);this.w.set(b+d,g)}}async C(v,b){const d=v+b,S=this.w.get(d);S&&((0,o.dispose)(S),this.w.delete(d))}dispose(){super.dispose();for(const[,v]of this.w)v.dispose();this.w.clear();for(const[,v]of this.v)v.dispose();this.v.clear()}}e.AbstractDiskFileSystemProviderChannel=f;class c extends o.Disposable{constructor(v,b,d,S){super(),this.c=v,this.f=d,this.g=S,this.a=new Map,this.b=this.D(new L.DiskFileSystemProvider(this.f,{watcher:{recursive:this.i(this.g)}})),this.h(b)}h(v){const b=this.D(new P.Emitter);this.D(b.event(d=>{v.fire(d.map(S=>({resource:this.c.transformOutgoingURI(S.resource),type:S.type})))})),this.D(this.b.onDidChangeFile(d=>b.fire(d))),this.D(this.b.onDidWatchError(d=>v.fire(d)))}i(v){}j(v){}watch(v,b,d){const S=this.j(this.g);return Array.isArray(S)&&(d.excludes=[...d.excludes,...S]),this.a.set(v,this.b.watch(b,d)),(0,o.toDisposable)(()=>{(0,o.dispose)(this.a.get(v)),this.a.delete(v)})}dispose(){super.dispose();for(const[,v]of this.a)v.dispose();this.a.clear()}}e.AbstractSessionFileWatcher=c}),define(ee[218],te([0,1,15,173,4,8,16,9,217,149]),function(G,e,P,L,o,A,M,k,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class m extends f.AbstractDiskFileSystemProviderChannel{constructor(d,S,w){super(d,S),this.G=w}c(d){return c.DefaultURITransformer}f(d,S){return A.URI.revive(S)}async r(d,S,w){if(!w.useTrash)return super.r(d,S,w);const r=this.f(d,S),u=(0,k.normalize)(r.fsPath);try{await P.shell.trashItem(u)}catch{throw(0,M.createFileSystemProviderError)(o.isWindows?(0,L.localize)(0,null,(0,k.basename)(u)):(0,L.localize)(1,null,(0,k.basename)(u)),M.FileSystemProviderErrorCode.Unknown)}}F(d,S){return new v(d,S,this.b,this.G)}}e.DiskFileSystemProviderChannel=m;class v extends f.AbstractSessionFileWatcher{watch(d,S,w){if(w.recursive)throw(0,M.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",M.FileSystemProviderErrorCode.Unavailable);return super.watch(d,S,w)}}}),define(ee[219],te([0,1,5]),function(G,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogger=void 0;class L extends P.AbstractMessageLogger{constructor(A=P.DEFAULT_LOG_LEVEL){super(),this.k=[],this.l=void 0,this.setLevel(A),this.D(this.onDidChangeLogLevel(M=>{this.l?.setLevel(M)}))}set logger(A){this.l=A;for(const{level:M,message:k}of this.k)(0,P.log)(A,M,k);this.k=[]}g(A,M){this.l?(0,P.log)(this.l,A,M):this.getLevel()<=A&&this.k.push({level:A,message:M})}dispose(){this.l?.dispose()}flush(){this.l?.flush()}}e.BufferLogger=L}),define(ee[220],te([0,1,2,5]),function(G,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class o extends P.Disposable{constructor(M,k=[]){super(),this.a=new L.MultiplexLogger([M,...k]),this.D(M.onDidChangeLogLevel(f=>this.setLevel(f)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(M){this.a.setLevel(M)}getLevel(){return this.a.getLevel()}trace(M,...k){this.a.trace(M,...k)}debug(M,...k){this.a.debug(M,...k)}info(M,...k){this.a.info(M,...k)}warn(M,...k){this.a.warn(M,...k)}error(M,...k){this.a.error(M,...k)}flush(){this.a.flush()}}e.LogService=o}),define(ee[221],te([0,1,35,8,5]),function(G,e,P,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerChannel=void 0;class A{constructor(k){this.b=k,this.a=new P.ResourceMap}listen(k,f,c){switch(f){case"onDidChangeLoggers":return c?this.b.getOnDidChangeLoggersEvent(c):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return c?this.b.getOnDidChangeLogLevelEvent(c):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return c?this.b.getOnDidChangeVisibilityEvent(c):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${f}`)}async call(k,f,c){switch(f){case"createLogger":this.c(L.URI.revive(c[0]),c[1],c[2]);return;case"log":return this.e(L.URI.revive(c[0]),c[1]);case"consoleLog":return this.d(c[0],c[1]);case"setLogLevel":return(0,o.isLogLevel)(c[0])?this.b.setLogLevel(c[0]):this.b.setLogLevel(L.URI.revive(c[0]),c[1]);case"setVisibility":return this.b.setVisibility(L.URI.revive(c[0]),c[1]);case"registerLogger":return this.b.registerLogger({...c[0],resource:L.URI.revive(c[0].resource)},c[1]);case"deregisterLogger":return this.b.deregisterLogger(L.URI.revive(c[0]))}throw new Error(`Call not found: ${f}`)}c(k,f,c){this.a.set(k,this.b.createLogger(k,f,c))}d(k,f){let c=console.log;switch(k){case o.LogLevel.Error:c=console.error;break;case o.LogLevel.Warning:c=console.warn;break;case o.LogLevel.Info:c=console.info;break}c.call(console,...f)}e(k,f){const c=this.a.get(k);if(!c)throw new Error("Create the logger before logging");for(const[m,v]of f)(0,o.log)(c,m,v)}}e.LoggerChannel=A}),define(ee[222],te([0,1,16,5]),function(G,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var o;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(o||(o={}));async function A(c,m,v,b,d){try{const S=await new Promise((r,u)=>{G(["spdlog"],r,u)});S.setFlushOn(o.Trace);const w=await S.createAsyncRotatingLogger(c,m,v,b);return d?w.clearFormatters():w.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),w}catch(S){console.error(S)}return null}function M(c,m,v){switch(m){case L.LogLevel.Trace:c.trace(v);break;case L.LogLevel.Debug:c.debug(v);break;case L.LogLevel.Info:c.info(v);break;case L.LogLevel.Warning:c.warn(v);break;case L.LogLevel.Error:c.error(v);break;case L.LogLevel.Off:break;default:throw new Error(`Invalid log level ${m}`)}}function k(c,m){switch(m){case L.LogLevel.Trace:c.setLevel(o.Trace);break;case L.LogLevel.Debug:c.setLevel(o.Debug);break;case L.LogLevel.Info:c.setLevel(o.Info);break;case L.LogLevel.Warning:c.setLevel(o.Warning);break;case L.LogLevel.Error:c.setLevel(o.Error);break;case L.LogLevel.Off:c.setLevel(o.Off);break;default:throw new Error(`Invalid log level ${m}`)}}class f extends L.AbstractMessageLogger{constructor(m,v,b,d,S){super(),this.k=[],this.setLevel(S),this.l=this.n(m,v,b,d),this.D(this.onDidChangeLogLevel(w=>{this.m&&k(this.m,w)}))}async n(m,v,b,d){const S=b?6:1,w=30/S*P.ByteSize.MB,r=await A(m,v,w,S,d);if(r){this.m=r,k(this.m,this.getLevel());for(const{level:u,message:g}of this.k)M(this.m,u,g);this.k=[]}}g(m,v){this.m?M(this.m,m,v):this.getLevel()<=m&&this.k.push({level:m,message:v})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.q():this.l.then(()=>this.q())}q(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=f}),define(ee[223],te([0,1,31,5,222]),function(G,e,P,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class A extends L.AbstractLoggerService{m(k,f,c){return new o.SpdLogLogger((0,P.generateUuid)(),k.fsPath,!c?.donotRotate,!!c?.donotUseFormatters,f)}}e.LoggerService=A}),define(ee[65],te([0,1,35,3,6,5,223]),function(G,e,P,L,o,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerMainService=e.ILoggerMainService=void 0,e.ILoggerMainService=(0,o.refineServiceDecorator)(A.ILoggerService);class k extends M.LoggerService{constructor(){super(...arguments),this.p=new P.ResourceMap}createLogger(c,m,v){v!==void 0&&this.p.set(this.l(c),v);try{return super.createLogger(c,m)}catch(b){throw this.p.delete(this.l(c)),b}}registerLogger(c,m){m!==void 0&&this.p.set(c.resource,m),super.registerLogger(c)}deregisterLogger(c){this.p.delete(c),super.deregisterLogger(c)}getRegisteredLoggers(c){const m=[];for(const v of super.getRegisteredLoggers())c===this.p.get(v.resource)&&m.push(v);return m}getOnDidChangeLogLevelEvent(c){return L.Event.filter(this.onDidChangeLogLevel,m=>(0,A.isLogLevel)(m)||this.q(m[0],c))}getOnDidChangeVisibilityEvent(c){return L.Event.filter(this.onDidChangeVisibility,([m])=>this.q(m,c))}getOnDidChangeLoggersEvent(c){return L.Event.filter(L.Event.map(this.onDidChangeLoggers,m=>({added:[...m.added].filter(b=>this.q(b.resource,c)),removed:[...m.removed].filter(b=>this.q(b.resource,c))})),m=>m.added.length>0||m.removed.length>0)}deregisterLoggers(c){for(const[m,v]of this.p)v===c&&this.deregisterLogger(m)}q(c,m){const v=this.p.get(c);return v===void 0||v===m}dispose(){super.dispose(),this.p.clear()}}e.LoggerMainService=k}),define(ee[224],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function P(M){return M.submenu!==void 0}e.isMenubarMenuItemSubmenu=P;function L(M){return M.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=L;function o(M){return M.uri!==void 0}e.isMenubarMenuItemRecentAction=o;function A(M){return!P(M)&&!L(M)&&!o(M)}e.isMenubarMenuItemAction=A}),define(ee[38],te([0,1,3,71,2,6]),function(G,e,P,L,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,A.createDecorator)("policy");class M extends o.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.D(new P.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(c){const m=Object.keys(this.f).length;return this.f={...c,...this.f},m!==Object.keys(this.f).length&&await this.i(c),L.Iterable.reduce(this.g.entries(),(v,[b,d])=>({...v,[b]:d}),{})}getPolicyValue(c){return this.g.get(c)}serialize(){return L.Iterable.reduce(Object.entries(this.f),(c,[m,v])=>({...c,[m]:{definition:v,value:this.g.get(m)}}),{})}}e.AbstractPolicyService=M;class k{constructor(){this.onDidChange=P.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=k}),define(ee[225],te([0,1,7,3,71,11,16,5,38]),function(G,e,P,L,o,A,M,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function c(v,b){const d=[];for(const S of new Set(o.Iterable.concat(v.keys(),b.keys())))v.get(S)!==b.get(S)&&d.push(S);return d}let m=class extends f.AbstractPolicyService{constructor(b,d,S){super(),this.j=b,this.k=d,this.l=S,this.c=this.D(new P.ThrottledDelayer(500));const w=L.Event.filter(d.onDidFilesChange,r=>r.affects(b));this.D(d.watch(b)),this.D(w(()=>this.c.trigger(()=>this.p())))}async i(){await this.p()}async n(){const b=new Map;try{const d=await this.k.readFile(this.j),S=JSON.parse(d.value.toString());if(!(0,A.isObject)(S))throw new Error("Policy file isn't a JSON object");for(const w of Object.keys(S))this.f[w]&&b.set(w,S[w])}catch(d){d.fileOperationResult!==1&&this.l.error("[FilePolicyService] Failed to read policies",d)}return b}async p(){const b=await this.n(),d=c(this.g,b);this.g=b,d.length>0&&this.h.fire(d)}};m=ye([Z(1,M.IFileService),Z(2,k.ILogService)],m),e.FilePolicyService=m}),define(ee[226],te([0,1,3,2,38]),function(G,e,P,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class A{constructor(f){this.b=f,this.a=new L.DisposableStore}listen(f,c){switch(c){case"onDidChange":return P.Event.map(this.b.onDidChange,m=>m.reduce((v,b)=>({...v,[b]:this.b.getPolicyValue(b)??null}),{}),this.a)}throw new Error(`Event not found: ${c}`)}call(f,c,m){switch(c){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(m)}throw new Error(`Call not found: ${c}`)}dispose(){this.a.dispose()}}e.PolicyChannel=A;class M extends o.AbstractPolicyService{constructor(f,c){super(),this.a=c;for(const m in f){const{definition:v,value:b}=f[m];this.f[m]=v,b!==void 0&&this.g.set(m,b)}this.a.listen("onDidChange")(m=>{for(const v in m){const b=m[v];b===null?this.g.delete(v):this.g.set(v,b)}this.h.fire(Object.keys(m))})}async i(f){const c=await this.a.call("updatePolicyDefinitions",f);for(const m in c)this.g.set(m,c[m])}}e.PolicyChannelClient=M}),define(ee[227],te([0,1,38,7,294,2,5]),function(G,e,P,L,o,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let k=class extends P.AbstractPolicyService{constructor(c,m){super(),this.j=c,this.k=m,this.a=new L.Throttler,this.b=this.D(new A.MutableDisposable)}async i(c){this.j.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(c).length} policy definitions`),await this.a.queue(()=>new Promise((m,v)=>{try{this.b.value=(0,o.createWatcher)(this.k,c,b=>{this.m(b),m()})}catch(b){this.j.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",b),v(b)}}))}m(c){this.j.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(c)}`);for(const m in c){const v=c[m];v===void 0?this.g.delete(m):this.g.set(m,v)}this.h.fire(Object.keys(c))}};k=ye([Z(0,M.ILogService)],k),e.NativePolicyService=k}),define(ee[66],te([0,1,4,36]),function(G,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let o;if(typeof P.globals.vscode<"u"&&typeof P.globals.vscode.context<"u"){const A=P.globals.vscode.context.configuration();if(A)o=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(o=globalThis._VSCODE_PRODUCT_JSON,L.env.VSCODE_DEV&&Object.assign(o,{nameShort:`${o.nameShort} Dev`,nameLong:`${o.nameLong} Dev`,dataFolderName:`${o.dataFolderName}-dev`,serverDataFolderName:o.serverDataFolderName?`${o.serverDataFolderName}-dev`:void 0}),!o.version){const A=globalThis._VSCODE_PACKAGE_JSON;Object.assign(o,{version:A.version})}}else o={},Object.keys(o).length===0&&Object.assign(o,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=o}),define(ee[21],te([0,1,6]),function(G,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,P.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ee[228],te([0,1,72,5,21]),function(G,e,P,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let A=class{constructor(k,f){this.b=k,this.c=f,this.a=new Map}async isExtensionUrlTrusted(k,f){if(!this.b.trustedExtensionUrlPublicKeys)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const c=/^(.*)#([^#]+)$/.exec(f);if(!c)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",f),!1;const[,m,v]=c;let b=this.a.get(k);if(!b){if(b=this.b.trustedExtensionUrlPublicKeys[k],!b||b.length===0)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",k),!1;this.a.set(k,[...b])}const d=Buffer.from(decodeURIComponent(v),"base64");if(d.length<=6)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",f),!1;const S=d.slice(0,6),w=d.readUIntBE(0,6),r=Date.now()-w;if(r<0||r>36e5)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",f),!1;const u=d.slice(6),g=P.createVerify("SHA256");g.write(S),g.write(Buffer.from(m)),g.end();for(let p=0;p<b.length;p++){let y=b[p];if(y!==null){if(typeof y=="string")try{y=P.createPublicKey({key:Buffer.from(y,"base64"),format:"der",type:"spki"}),b[p]=y}catch(D){this.c.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${p+1} for ${k}:`,D),b[p]=null;continue}if(g.verify(y,u))return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",f),!0}}return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",f),!1}};A=ye([Z(0,o.IProductService),Z(1,L.ILogService)],A),e.ExtensionUrlTrustService=A}),define(ee[229],te([0,1,7,5]),function(G,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowProfiler=void 0;let o=class{constructor(M,k,f){this.a=M,this.b=k,this.c=f}async inspect(M){await this.d();const k=this.a.webContents.debugger;await k.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,P.timeout)(M);const f=await k.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),f.profile}async d(){const M=this.a.webContents.debugger;M.attach(),await M.sendCommand("Profiler.enable")}async e(){const M=this.a.webContents.debugger;await M.sendCommand("Profiler.disable"),M.detach()}};o=ye([Z(2,L.ILogService)],o),e.WindowProfiler=o}),define(ee[67],te([0,1,6]),function(G,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,P.createDecorator)("protocolMainService")}),define(ee[51],te([0,1,127,11]),function(G,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class o{constructor(){this.a=new Map}add(M,k){P.ok(L.isString(M)),P.ok(L.isObject(k)),P.ok(!this.a.has(M),"There is already an extension with this id"),this.a.set(M,k)}knows(M){return this.a.has(M)}as(M){return this.a.get(M)||null}}e.Registry=new o}),define(ee[230],te([0,1,3,51]),function(G,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function o(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class A{constructor(){this.b=new P.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(f,c){this.a[o(f)]=c,this.b.fire(f)}notifySchemaChanged(f){this.b.fire(f)}getSchemaContributions(){return{schemas:this.a}}}const M=new A;L.Registry.add(e.Extensions.JSONContribution,M)}),define(ee[68],te([0,1,27,3,11,158,19,230,51]),function(G,e,P,L,o,A,M,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var c;(function(D){D.Multiline="multilineText",D.Singleline="singlelineText"})(c=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var m;(function(D){D[D.APPLICATION=1]="APPLICATION",D[D.MACHINE=2]="MACHINE",D[D.WINDOW=3]="WINDOW",D[D.RESOURCE=4]="RESOURCE",D[D.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",D[D.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(m=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const v=f.Registry.as(k.Extensions.JSONContribution);class b{constructor(){this.h=new Set,this.i=new L.Emitter,this.onDidSchemaChange=this.i.event,this.j=new L.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},v.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(t,a=!0){this.registerConfigurations([t],a)}registerConfigurations(t,a=!0){const i=new Set;this.n(t,a,i),v.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}deregisterConfigurations(t){const a=new Set;this.o(t,a),v.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:a})}updateConfigurations({add:t,remove:a}){const i=new Set;this.o(a,i),this.n(t,!1,i),v.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}registerDefaultConfigurations(t){const a=new Set;this.k(t,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}k(t,a){const i=[];for(const{overrides:s,source:n}of t)for(const h in s)if(a.add(h),e.OVERRIDE_PROPERTY_REGEX.test(h)){const l=this.a.get(h),E=l?.valuesSources??new Map;if(n)for(const N of Object.keys(s[h]))E.set(N,n);const R={...l?.value||{},...s[h]};this.a.set(h,{source:n,value:R,valuesSources:E});const C=(0,M.getLanguageTagSettingPlainKey)(h),T={type:"object",default:R,description:A.localize(1,null,C),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:R,source:o.isString(n)?void 0:n,defaultValueSource:n};i.push(...w(h)),this.d[h]=T,this.b.properties[h]=T}else{this.a.set(h,{value:s[h],source:n});const l=this.d[h];l&&(this.w(h,l),this.r(h,l))}this.m(i)}deregisterDefaultConfigurations(t){const a=new Set;this.l(t,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}l(t,a){for(const{overrides:i,source:s}of t)for(const n in i){const h=this.a.get(n),l=o.isString(s)?s:s?.id,E=o.isString(h?.source)?h?.source:h?.source?.id;if(l===E)if(a.add(n),this.a.delete(n),e.OVERRIDE_PROPERTY_REGEX.test(n))delete this.d[n],delete this.b.properties[n];else{const R=this.d[n];R&&(this.w(n,R),this.r(n,R))}}this.u()}deltaConfiguration(t){let a=!1;const i=new Set;t.removedDefaults&&(this.l(t.removedDefaults,i),a=!0),t.addedDefaults&&(this.k(t.addedDefaults,i),a=!0),t.removedConfigurations&&this.o(t.removedConfigurations,i),t.addedConfigurations&&this.n(t.addedConfigurations,!1,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:a})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const a of t)this.h.add(a);this.u()}n(t,a,i){t.forEach(s=>{this.p(s,a,s.extensionInfo,s.restrictedProperties,void 0,i),this.c.push(s),this.q(s)})}o(t,a){const i=s=>{if(s.properties)for(const n in s.properties){a.add(n);const h=this.d[n];h?.policy?.name&&this.e.delete(h.policy.name),delete this.d[n],this.s(n,s.properties[n])}s.allOf?.forEach(n=>i(n))};for(const s of t){i(s);const n=this.c.indexOf(s);n!==-1&&this.c.splice(n,1)}}p(t,a=!0,i,s,n=3,h){n=o.isUndefinedOrNull(t.scope)?n:t.scope;const l=t.properties;if(l)for(const R in l){const C=l[R];if(a&&p(R,C)){delete l[R];continue}if(C.source=i,C.defaultDefaultValue=l[R].default,this.w(R,C),e.OVERRIDE_PROPERTY_REGEX.test(R)?C.scope=void 0:(C.scope=o.isUndefinedOrNull(C.scope)?n:C.scope,C.restricted=o.isUndefinedOrNull(C.restricted)?!!s?.includes(R):C.restricted),l[R].hasOwnProperty("included")&&!l[R].included){this.f[R]=l[R],delete l[R];continue}else this.d[R]=l[R],l[R].policy?.name&&this.e.set(l[R].policy.name,R);!l[R].deprecationMessage&&l[R].markdownDeprecationMessage&&(l[R].deprecationMessage=l[R].markdownDeprecationMessage),h.add(R)}const E=t.allOf;if(E)for(const R of E)this.p(R,a,i,s,n,h)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const a=i=>{const s=i.properties;if(s)for(const h in s)this.r(h,s[h]);i.allOf?.forEach(a)};a(t)}r(t,a){switch(e.allSettings.properties[t]=a,a.scope){case 1:e.applicationSettings.properties[t]=a;break;case 2:e.machineSettings.properties[t]=a;break;case 6:e.machineOverridableSettings.properties[t]=a;break;case 3:e.windowSettings.properties[t]=a;break;case 4:e.resourceSettings.properties[t]=a;break;case 5:e.resourceSettings.properties[t]=a,this.g.properties[t]=a;break}}s(t,a){switch(delete e.allSettings.properties[t],a.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const a=`[${t}]`,i={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(a,i),e.allSettings.properties[a]=i,e.applicationSettings.properties[a]=i,e.machineSettings.properties[a]=i,e.machineOverridableSettings.properties[a]=i,e.windowSettings.properties[a]=i,e.resourceSettings.properties[a]=i}}v(){const t={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this.i.fire()}w(t,a){const i=this.a.get(t);let s=i?.value,n=i?.source;o.isUndefined(s)&&(s=a.defaultDefaultValue,n=void 0),o.isUndefined(s)&&(s=u(a.type)),a.default=s,a.defaultValueSource=n}}const d="\\[([^\\]]+)\\]",S=new RegExp(d,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${d})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function w(D){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(D)){let a=S.exec(D);for(;a?.length;){const i=a[1].trim();i&&t.push(i),a=S.exec(D)}}return(0,P.distinct)(t)}e.overrideIdentifiersFromKey=w;function r(D){return D.reduce((t,a)=>`${t}[${a}]`,"")}e.keyFromOverrideIdentifiers=r;function u(D){switch(Array.isArray(D)?D[0]:D){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=u;const g=new b;f.Registry.add(e.Extensions.Configuration,g);function p(D,t){return D.trim()?e.OVERRIDE_PROPERTY_REGEX.test(D)?A.localize(7,null,D):g.getConfigurationProperties()[D]!==void 0?A.localize(8,null,D):t.policy?.name&&g.getPolicyConfigurations().get(t.policy?.name)!==void 0?A.localize(9,null,D,t.policy?.name,g.getPolicyConfigurations().get(t.policy?.name)):null:A.localize(6,null)}e.validateProperty=p;function y(){const D=[],t=g.getConfigurationProperties();for(const a of Object.keys(t))D.push([a,t[a].scope]);return D.push(["launch",4]),D.push(["task",4]),D}e.getScopes=y}),define(ee[113],te([0,1,27,3,43,2,35,37,11,8,19,68,51]),function(G,e,P,L,o,A,M,k,f,c,m,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function d(a){return Object.isFrozen(a)?a:k.deepFreeze(a)}class S{constructor(i={},s=[],n=[],h){this.b=i,this.c=s,this.d=n,this.raw=h,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const i=this.raw.map(s=>{if(s instanceof S)return s;const n=new w("");return n.parseRaw(s),n.configurationModel});this.f=i.reduce((s,n)=>n===s?n:s.merge(n),i[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(i){return i?(0,m.getConfigurationValue)(this.contents,i):this.contents}inspect(i,s){const n=this.rawConfiguration.getValue(i),h=s?this.rawConfiguration.getOverrideValue(i,s):void 0,l=s?this.rawConfiguration.override(s).getValue(i):n;return{value:n,override:h,merged:l}}getOverrideValue(i,s){const n=this.i(s);return n?i?(0,m.getConfigurationValue)(n,i):n:void 0}getKeysForOverrideIdentifier(i){const s=[];for(const n of this.overrides)n.identifiers.includes(i)&&s.push(...n.keys);return P.distinct(s)}getAllOverrideIdentifiers(){const i=[];for(const s of this.overrides)i.push(...s.identifiers);return P.distinct(i)}override(i){let s=this.a.get(i);return s||(s=this.g(i),this.a.set(i,s)),s}merge(...i){const s=k.deepClone(this.contents),n=k.deepClone(this.overrides),h=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const E of i)if(l.push(...E.raw?.length?E.raw:[E]),!E.isEmpty()){this.h(s,E.contents);for(const R of E.overrides){const[C]=n.filter(T=>P.equals(T.identifiers,R.identifiers));C?(this.h(C.contents,R.contents),C.keys.push(...R.keys),C.keys=P.distinct(C.keys)):n.push(k.deepClone(R))}for(const R of E.keys)h.indexOf(R)===-1&&h.push(R)}return new S(s,h,n,l.every(E=>E instanceof S)?void 0:l)}g(i){const s=this.i(i);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const n={};for(const h of P.distinct([...Object.keys(this.contents),...Object.keys(s)])){let l=this.contents[h];const E=s[h];E&&(typeof l=="object"&&typeof E=="object"?(l=k.deepClone(l),this.h(l,E)):l=E),n[h]=l}return new S(n,this.keys,this.overrides)}h(i,s){for(const n of Object.keys(s)){if(n in i&&f.isObject(i[n])&&f.isObject(s[n])){this.h(i[n],s[n]);continue}i[n]=k.deepClone(s[n])}}i(i){let s=null,n=null;const h=l=>{l&&(n?this.h(n,l):n=k.deepClone(l))};for(const l of this.overrides)P.equals(l.identifiers,[i])?s=l.contents:l.identifiers.includes(i)&&h(l.contents);return h(s),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,s){this.j(i,s,!0)}setValue(i,s){this.j(i,s,!1)}removeValue(i){const s=this.keys.indexOf(i);s!==-1&&(this.keys.splice(s,1),(0,m.removeFromValueTree)(this.contents,i),v.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.splice(this.overrides.findIndex(n=>P.equals(n.identifiers,(0,v.overrideIdentifiersFromKey)(i))),1))}j(i,s,n){(0,m.addToValueTree)(this.contents,i,s,h=>console.error(h)),n=n||this.keys.indexOf(i)===-1,n&&this.keys.push(i),v.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.push({identifiers:(0,v.overrideIdentifiersFromKey)(i),keys:Object.keys(this.contents[i]),contents:(0,m.toValuesTree)(this.contents[i],h=>console.error(h))})}}e.ConfigurationModel=S;class w{constructor(i){this.f=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new S}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,s){if(!f.isUndefinedOrNull(i)){const n=this.g(i);this.parseRaw(n,s)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,s){this.a=i;const{contents:n,keys:h,overrides:l,restricted:E,hasExcludedProperties:R}=this.h(i,s);this.b=new S(n,h,l,R?[i]:void 0),this.c=E||[]}g(i){let s={},n=null,h=[];const l=[],E=[];function R(T){Array.isArray(h)?h.push(T):n!==null&&(h[n]=T)}const C={onObjectBegin:()=>{const T={};R(T),l.push(h),h=T,n=null},onObjectProperty:T=>{n=T},onObjectEnd:()=>{h=l.pop()},onArrayBegin:()=>{const T=[];R(T),l.push(h),h=T,n=null},onArrayEnd:()=>{h=l.pop()},onLiteralValue:R,onError:(T,N,z)=>{E.push({error:T,offset:N,length:z})}};if(i)try{o.visit(i,C),s=h[0]||{}}catch(T){console.error(`Error while parsing settings file ${this.f}: ${T}`),this.d=[T]}return s}h(i,s){const n=b.Registry.as(v.Extensions.Configuration).getConfigurationProperties(),h=this.i(i,n,!0,s);i=h.raw;const l=(0,m.toValuesTree)(i,C=>console.error(`Conflict in settings file ${this.f}: ${C}`)),E=Object.keys(i),R=this.j(i,C=>console.error(`Conflict in settings file ${this.f}: ${C}`));return{contents:l,keys:E,overrides:R,restricted:h.restricted,hasExcludedProperties:h.hasExcludedProperties}}i(i,s,n,h){let l=!1;if(!h?.scopes&&!h?.skipRestricted)return{raw:i,restricted:[],hasExcludedProperties:l};const E={},R=[];for(const C in i)if(v.OVERRIDE_PROPERTY_REGEX.test(C)&&n){const T=this.i(i[C],s,!1,h);E[C]=T.raw,l=l||T.hasExcludedProperties,R.push(...T.restricted)}else{const T=s[C],N=T?typeof T.scope<"u"?T.scope:3:void 0;T?.restricted&&R.push(C),(N===void 0||h.scopes===void 0||h.scopes.includes(N))&&!(h.skipRestricted&&T?.restricted)?E[C]=i[C]:l=!0}return{raw:E,restricted:R,hasExcludedProperties:l}}j(i,s){const n=[];for(const h of Object.keys(i))if(v.OVERRIDE_PROPERTY_REGEX.test(h)){const l={};for(const E in i[h])l[E]=i[h][E];n.push({identifiers:(0,v.overrideIdentifiersFromKey)(h),keys:Object.keys(l),contents:(0,m.toValuesTree)(l,s)})}return n}}e.ConfigurationModelParser=w;class r extends A.Disposable{constructor(i,s,n,h){super(),this.f=i,this.g=s,this.h=h,this.c=this.D(new L.Emitter),this.onDidChange=this.c.event,this.a=new w(this.f.toString()),this.b={scopes:this.g},this.D(this.h.watch(n.dirname(this.f))),this.D(this.h.watch(this.f)),this.D(L.Event.any(L.Event.filter(this.h.onDidFilesChange,l=>l.contains(this.f)),L.Event.filter(this.h.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&n.isEqual(l.resource,i)))(()=>this.c.fire()))}async loadConfiguration(){try{const i=await this.h.readFile(this.f);return this.a.parse(i.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new S}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=r;class u{constructor(i,s,n,h,l,E,R,C,T,N,z,B,_){this.a=i,this.b=s,this.c=n,this.overrideIdentifiers=h,this.d=l,this.f=E,this.g=R,this.h=C,this.i=T,this.j=N,this.k=z,this.l=B,this.m=_}get value(){return d(this.c)}n(i,s,n){const h=i.inspect(s,n);return{get value(){return d(h.value)},get override(){return d(h.override)},get merged(){return d(h.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class g{constructor(i,s,n,h,l=new S,E=new S,R=new M.ResourceMap,C=new S,T=new M.ResourceMap){this.c=i,this.d=s,this.f=n,this.g=h,this.h=l,this.i=E,this.j=R,this.l=C,this.m=T,this.a=null,this.b=new M.ResourceMap,this.n=null}getValue(i,s,n){return this.q(i,s,n).getValue(i)}updateValue(i,s,n={}){let h;n.resource?(h=this.m.get(n.resource),h||(h=new S,this.m.set(n.resource,h))):h=this.l,s===void 0?h.removeValue(i):h.setValue(i,s),n.resource||(this.a=null)}inspect(i,s,n){const h=this.q(i,s,n),l=this.u(s.resource,n),E=s.resource?this.m.get(s.resource)||this.l:this.l,R=new Set;for(const C of h.overrides)for(const T of C.identifiers)h.getOverrideValue(i,T)!==void 0&&R.add(T);return new u(i,s,h.getValue(i),R.size?[...R]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this.i:void 0,l||void 0,E)}keys(i){const s=this.u(void 0,i);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(i){this.c=i,this.a=null,this.b.clear()}updatePolicyConfiguration(i){this.d=i}updateApplicationConfiguration(i){this.f=i,this.a=null,this.b.clear()}updateLocalUserConfiguration(i){this.g=i,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(i){this.h=i,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(i){this.i=i,this.a=null,this.b.clear()}updateFolderConfiguration(i,s){this.j.set(i,s),this.b.delete(i)}deleteFolderConfiguration(i){this.p.delete(i),this.b.delete(i)}compareAndUpdateDefaultConfiguration(i,s){const n=[];if(!s){const{added:h,updated:l,removed:E}=D(this.c,i);s=[...h,...l,...E]}for(const h of s)for(const l of(0,v.overrideIdentifiersFromKey)(h)){const E=this.c.getKeysForOverrideIdentifier(l),R=i.getKeysForOverrideIdentifier(l),C=[...R.filter(T=>E.indexOf(T)===-1),...E.filter(T=>R.indexOf(T)===-1),...E.filter(T=>!k.equals(this.c.override(l).getValue(T),i.override(l).getValue(T)))];n.push([l,C])}return this.updateDefaultConfiguration(i),{keys:s,overrides:n}}compareAndUpdatePolicyConfiguration(i){const{added:s,updated:n,removed:h}=D(this.d,i),l=[...s,...n,...h];return l.length&&this.updatePolicyConfiguration(i),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:s,updated:n,removed:h,overrides:l}=D(this.applicationConfiguration,i),E=[...s,...n,...h];return E.length&&this.updateApplicationConfiguration(i),{keys:E,overrides:l}}compareAndUpdateLocalUserConfiguration(i){const{added:s,updated:n,removed:h,overrides:l}=D(this.localUserConfiguration,i),E=[...s,...n,...h];return E.length&&this.updateLocalUserConfiguration(i),{keys:E,overrides:l}}compareAndUpdateRemoteUserConfiguration(i){const{added:s,updated:n,removed:h,overrides:l}=D(this.remoteUserConfiguration,i),E=[...s,...n,...h];return E.length&&this.updateRemoteUserConfiguration(i),{keys:E,overrides:l}}compareAndUpdateWorkspaceConfiguration(i){const{added:s,updated:n,removed:h,overrides:l}=D(this.workspaceConfiguration,i),E=[...s,...n,...h];return E.length&&this.updateWorkspaceConfiguration(i),{keys:E,overrides:l}}compareAndUpdateFolderConfiguration(i,s){const n=this.p.get(i),{added:h,updated:l,removed:E,overrides:R}=D(n,s),C=[...h,...l,...E];return(C.length||!n)&&this.updateFolderConfiguration(i,s),{keys:C,overrides:R}}compareAndDeleteFolderConfiguration(i){const s=this.p.get(i);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:n,updated:h,removed:l,overrides:E}=D(s,void 0);return{keys:[...n,...h,...l],overrides:E}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(i,s,n){let h=this.r(s,n);return s.overrideIdentifier&&(h=h.override(s.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(i)!==void 0&&(h=h.merge(this.d)),h}r({resource:i},s){let n=this.s();if(s&&i){const h=s.getFolder(i);h&&(n=this.t(h.uri)||n);const l=this.m.get(i);l&&(n=n.merge(l))}return n}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(i){let s=this.b.get(i);if(!s){const n=this.s(),h=this.j.get(i);h?(s=n.merge(h),this.b.set(i,s)):s=n}return s}u(i,s){if(s&&i){const n=s.getFolder(i);if(n)return this.j.get(n.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((i,s)=>{const{contents:n,overrides:h,keys:l}=this.j.get(s);return i.push([s,{contents:n,overrides:h,keys:l}]),i},[])}}allKeys(){const i=new Set;return this.c.keys.forEach(s=>i.add(s)),this.userConfiguration.keys.forEach(s=>i.add(s)),this.i.keys.forEach(s=>i.add(s)),this.j.forEach(s=>s.keys.forEach(n=>i.add(n))),[...i.values()]}v(){const i=new Set;return this.c.getAllOverrideIdentifiers().forEach(s=>i.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>i.add(s)),this.i.getAllOverrideIdentifiers().forEach(s=>i.add(s)),this.j.forEach(s=>s.getAllOverrideIdentifiers().forEach(n=>i.add(n))),[...i.values()]}w(i){const s=new Set;return this.c.getKeysForOverrideIdentifier(i).forEach(n=>s.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(n=>s.add(n)),this.i.getKeysForOverrideIdentifier(i).forEach(n=>s.add(n)),this.j.forEach(n=>n.getKeysForOverrideIdentifier(i).forEach(h=>s.add(h))),[...s.values()]}static parse(i){const s=this.x(i.defaults),n=this.x(i.policy),h=this.x(i.application),l=this.x(i.user),E=this.x(i.workspace),R=i.folders.reduce((C,T)=>(C.set(c.URI.revive(T[0]),this.x(T[1])),C),new M.ResourceMap);return new g(s,n,h,l,new S,E,R,new S,new M.ResourceMap)}static x(i){return new S(i.contents,i.keys,i.overrides)}}e.Configuration=g;function p(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const i=new Set,s=new Map;for(const h of a)h.keys.forEach(l=>i.add(l)),h.overrides.forEach(([l,E])=>{const R=(0,M.getOrSet)(s,l,new Set);E.forEach(C=>R.add(C))});const n=[];return s.forEach((h,l)=>n.push([l,[...h.values()]])),{keys:[...i.values()],overrides:n}}e.mergeChanges=p;class y{constructor(i,s,n,h){this.change=i,this.f=s,this.g=n,this.h=h,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const l of i.keys)this.affectedKeys.add(l);for(const[,l]of i.overrides)for(const E of l)this.affectedKeys.add(E);this.d=this.a;for(const l of this.affectedKeys)this.d+=l+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=g.parse(this.f.data)),this.i}affectsConfiguration(i,s){const n=this.a+i,h=this.d.indexOf(n);if(h<0)return!1;const l=h+n.length;if(l>=this.d.length)return!1;const E=this.d.charCodeAt(l);if(E!==this.b&&E!==this.c)return!1;if(s){const R=this.previousConfiguration?this.previousConfiguration.getValue(i,s,this.f?.workspace):void 0,C=this.g.getValue(i,s,this.h);return!k.equals(R,C)}return!0}}e.ConfigurationChangeEvent=y;function D(a,i){const{added:s,removed:n,updated:h}=t(i?.rawConfiguration,a?.rawConfiguration),l=[],E=a?.getAllOverrideIdentifiers()||[],R=i?.getAllOverrideIdentifiers()||[];if(i){const C=R.filter(T=>!E.includes(T));for(const T of C)l.push([T,i.getKeysForOverrideIdentifier(T)])}if(a){const C=E.filter(T=>!R.includes(T));for(const T of C)l.push([T,a.getKeysForOverrideIdentifier(T)])}if(i&&a){for(const C of E)if(R.includes(C)){const T=t({contents:a.getOverrideValue(void 0,C)||{},keys:a.getKeysForOverrideIdentifier(C)},{contents:i.getOverrideValue(void 0,C)||{},keys:i.getKeysForOverrideIdentifier(C)});l.push([C,[...T.added,...T.removed,...T.updated]])}}return{added:s,removed:n,updated:h,overrides:l}}function t(a,i){const s=a?i?a.keys.filter(l=>i.keys.indexOf(l)===-1):[...a.keys]:[],n=i?a?i.keys.filter(l=>a.keys.indexOf(l)===-1):[...i.keys]:[],h=[];if(a&&i){for(const l of i.keys)if(a.keys.indexOf(l)!==-1){const E=(0,m.getConfigurationValue)(i.contents,l),R=(0,m.getConfigurationValue)(a.contents,l);k.equals(E,R)||h.push(l)}}return{added:s,removed:n,updated:h}}}),define(ee[231],te([0,1,27,3,2,37,11,113,68,5,38,51]),function(G,e,P,L,o,A,M,k,f,c,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class b extends o.Disposable{constructor(){super(...arguments),this.a=this.D(new L.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new k.ConfigurationModel}get configurationModel(){return this.b}async initialize(){return this.g(),this.D(v.Registry.as(f.Extensions.Configuration).onDidUpdateConfiguration(({properties:r,defaultsOverrides:u})=>this.c(Array.from(r),u))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(r,u){this.h(r,v.Registry.as(f.Extensions.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:r})}f(){return{}}g(){this.b=new k.ConfigurationModel;const r=v.Registry.as(f.Extensions.Configuration).getConfigurationProperties();this.h(Object.keys(r),r)}h(r,u){const g=this.f();for(const p of r){const y=g[p],D=u[p];y!==void 0?this.b.addValue(p,y):D?this.b.addValue(p,D.default):this.b.removeValue(p)}}}e.DefaultConfiguration=b;class d{constructor(){this.onDidChangeConfiguration=L.Event.None,this.configurationModel=new k.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=d;let S=class extends o.Disposable{get configurationModel(){return this.b}constructor(r,u,g){super(),this.c=r,this.f=u,this.g=g,this.a=this.D(new L.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new k.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.D(this.f.onDidChange(r=>this.i(r))),this.D(this.c.onDidChangeConfiguration(async({properties:r})=>this.j(await this.h(r),!0))),this.b}async h(r){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",r);const u={},g=[],p=v.Registry.as(f.Extensions.Configuration).getConfigurationProperties();for(const y of r){const D=p[y];if(!D){g.push(y);continue}if(D.policy){if(D.type!=="string"&&D.type!=="number"){this.g.warn(`Policy ${D.policy.name} has unsupported type ${D.type}`);continue}g.push(y),u[D.policy.name]={type:D.type}}}return(0,M.isEmptyObject)(u)||await this.f.updatePolicyDefinitions(u),g}i(r){this.g.trace("PolicyConfiguration#onDidChangePolicies",r);const u=v.Registry.as(f.Extensions.Configuration).getPolicyConfigurations(),g=(0,P.coalesce)(r.map(p=>u.get(p)));this.j(g,!0)}j(r,u){this.g.trace("PolicyConfiguration#update",r);const g=v.Registry.as(f.Extensions.Configuration).getConfigurationProperties(),p=[],y=this.b.isEmpty();for(const D of r){const t=g[D]?.policy?.name;if(t){const a=this.f.getPolicyValue(t);(y?a!==void 0:!(0,A.equals)(this.b.getValue(D),a))&&p.push([D,a])}else this.b.getValue(D)!==void 0&&p.push([D,void 0])}if(p.length){this.g.trace("PolicyConfiguration#changed",p);const D=this.b;this.b=new k.ConfigurationModel;for(const t of D.keys)this.b.setValue(t,D.getValue(t));for(const[t,a]of p)a===void 0?this.b.removeValue(t):this.b.setValue(t,a);u&&this.a.fire(this.b)}}};S=ye([Z(1,m.IPolicyService),Z(2,c.ILogService)],S),e.PolicyConfiguration=S}),define(ee[232],te([0,1,7,3,2,18,19,113,231,38]),function(G,e,P,L,o,A,M,k,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class m extends o.Disposable{constructor(b,d,S,w){super(),this.i=b,this.h=this.D(new L.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.D(new f.DefaultConfiguration),this.c=S instanceof c.NullPolicyService?new f.NullPolicyConfiguration:this.D(new f.PolicyConfiguration(this.b,S,w)),this.f=this.D(new k.UserSettings(this.i,void 0,A.extUriBiasedIgnorePathCase,d)),this.a=new k.Configuration(this.b.configurationModel,this.c.configurationModel,new k.ConfigurationModel,new k.ConfigurationModel),this.g=this.D(new P.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.D(this.b.onDidChangeConfiguration(({defaults:r,properties:u})=>this.k(r,u))),this.D(this.c.onDidChangeConfiguration(r=>this.l(r))),this.D(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[b,d,S]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new k.Configuration(b,d,new k.ConfigurationModel,S)}getConfigurationData(){return this.a.toData()}getValue(b,d){const S=typeof b=="string"?b:void 0,w=(0,M.isConfigurationOverrides)(b)?b:(0,M.isConfigurationOverrides)(d)?d:{};return this.a.getValue(S,w,void 0)}updateValue(b,d,S,w){return Promise.reject(new Error("not supported"))}inspect(b){return this.a.inspect(b,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const b=await this.f.loadConfiguration();this.j(b)}j(b){const d=this.a.toData(),S=this.a.compareAndUpdateLocalUserConfiguration(b);this.m(S,d,2)}k(b,d){const S=this.a.toData(),w=this.a.compareAndUpdateDefaultConfiguration(b,d);this.m(w,S,7)}l(b){const d=this.a.toData(),S=this.a.compareAndUpdatePolicyConfiguration(b);this.m(S,d,7)}m(b,d,S){const w=new k.ConfigurationChangeEvent(b,{data:d},this.a);w.source=S,w.sourceConfig=this.n(S),this.h.fire(w)}n(b){switch(b){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=m}),define(ee[233],te([0,1,13,6]),function(G,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,L.createDecorator)("remoteAuthorityResolverService");var o;(function(k){k.Unknown="Unknown",k.NotAvailable="NotAvailable",k.TemporarilyNotAvailable="TemporarilyNotAvailable",k.NoResolverFound="NoResolverFound"})(o=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class A extends P.ErrorNoTelemetry{static isNotAvailable(f){return f instanceof A&&f._code===o.NotAvailable}static isTemporarilyNotAvailable(f){return f instanceof A&&f._code===o.TemporarilyNotAvailable}static isNoResolverFound(f){return f instanceof A&&f._code===o.NoResolverFound}static isHandled(f){return f instanceof A&&f.isHandled}constructor(f,c=o.Unknown,m){super(f),this._message=f,this._code=c,this._detail=m,this.isHandled=c===o.NotAvailable&&m===!0,Object.setPrototypeOf(this,A.prototype)}}e.RemoteAuthorityResolverError=A;function M(k){const f=k.indexOf("+");return f===-1?k:k.substring(0,f)}e.getRemoteAuthorityPrefix=M}),define(ee[57],te([0,1,14]),function(G,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function L(c){return c.scheme===P.Schemas.vscodeRemote?c.authority:void 0}e.getRemoteAuthority=L;function o(c){if(!c)return;const m=c.indexOf("+");return m<0?c:c.substr(0,m)}e.getRemoteName=o;function A(c){return`/${c.quality??"oss"}-${c.commit??"dev"}`}e.getRemoteServerRootPath=A;function M(c){const{host:m,port:v}=f(c);if(typeof v>"u")throw new Error("Remote authority doesn't contain a port!");return{host:m,port:v}}e.parseAuthorityWithPort=M;function k(c,m){let{host:v,port:b}=f(c);return typeof b>"u"&&(b=m),{host:v,port:b}}e.parseAuthorityWithOptionalPort=k;function f(c){const m=c.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(m)return{host:m[1],port:parseInt(m[2],10)};const v=c.match(/^(\[[0-9a-z:]+\])$/);if(v)return{host:v[1],port:void 0};const b=c.match(/(.*):(\d+)$/);return b?{host:b[1],port:parseInt(b[2],10)}:{host:c,port:void 0}}}),define(ee[114],te([0,1,26,6,57]),function(G,e,P,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.getWorkspaceSupportTypeMessage=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var M;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(M=e.ExtensionType||(e.ExtensionType={}));var k;(function(w){w.WIN32_X64="win32-x64",w.WIN32_IA32="win32-ia32",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(k=e.TargetPlatform||(e.TargetPlatform={}));class f{constructor(r){this.value=r,this.c=r.toLowerCase()}static equals(r,u){if(typeof r>"u"||r===null)return typeof u>"u"||u===null;if(typeof u>"u"||u===null)return!1;if(typeof r=="string"||typeof u=="string"){const g=typeof r=="string"?r:r.value,p=typeof u=="string"?u:u.value;return P.equalsIgnoreCase(g,p)}return r.c===u.c}static toKey(r){return typeof r=="string"?r.toLowerCase():r.c}}e.ExtensionIdentifier=f;class c{get size(){return this.c.size}constructor(r){if(this.c=new Set,r)for(const u of r)this.add(u)}add(r){this.c.add(f.toKey(r))}delete(r){return this.c.delete(f.toKey(r))}has(r){return this.c.has(f.toKey(r))}}e.ExtensionIdentifierSet=c;class m{constructor(){this.c=new Map}clear(){this.c.clear()}delete(r){this.c.delete(f.toKey(r))}get(r){return this.c.get(f.toKey(r))}has(r){return this.c.has(f.toKey(r))}set(r,u){this.c.set(f.toKey(r),u)}values(){return this.c.values()}forEach(r){this.c.forEach(r)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.ExtensionIdentifierMap=m;function v(w){return b(w)}e.isApplicationScopedExtension=v;function b(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}e.isLanguagePackExtension=b;function d(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=d;function S(w,r){if(r){const u=`onResolveRemoteAuthority:${(0,o.getRemoteName)(r)}`;return!!w.activationEvents?.includes(u)}return!1}e.isResolverExtension=S,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(ee[234],te([0,1,7,17,22,13,3,2,64,75,31,104,233,57]),function(G,e,P,L,o,A,M,k,f,c,m,v,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionHealthChangedEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const S=30*1e3;var w;(function(O){O[O.Management=1]="Management",O[O.ExtensionHost=2]="ExtensionHost",O[O.Tunnel=3]="Tunnel"})(w=e.ConnectionType||(e.ConnectionType={}));function r(O){switch(O){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function u(O){const U=new o.CancellationTokenSource;return setTimeout(()=>U.cancel(),O),U.token}function g(O,U){if(O.isCancellationRequested||U.isCancellationRequested)return o.CancellationToken.Cancelled;const j=new o.CancellationTokenSource;return O.onCancellationRequested(()=>j.cancel()),U.onCancellationRequested(()=>j.cancel()),j.token}class p{get didTimeout(){return this.c==="timedout"}constructor(U){this.c="pending",this.d=new k.DisposableStore,this.promise=new Promise((j,x)=>{this.f=j,this.g=x}),U.isCancellationRequested?this.h():this.d.add(U.onCancellationRequested(()=>this.h()))}registerDisposable(U){this.c==="pending"?this.d.add(U):U.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const U=new Error("Time limit reached");return U.code="ETIMEDOUT",U.syscall="connect",U}resolve(U){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(U))}reject(U){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(U))}}function y(O,U){const j=new p(U);return j.registerDisposable(O.onControlMessage(x=>{const $=JSON.parse(x.toString()),V=H($);V?j.reject(V):j.resolve($)})),j.promise}function D(O,U,j,x,$,V,K,oe,fe){const Ce=new p(fe),Ee=c.StopWatch.create(!1);return O.info(`Creating a socket (${oe})...`),f.mark(`code/willCreateSocket/${K}`),U.connect(j,x,$,V,oe,(Re,Oe)=>{Ce.didTimeout?(f.mark(`code/didCreateSocketError/${K}`),O.info(`Creating a socket (${oe}) finished after ${Ee.elapsed()} ms, but this is too late and has timed out already.`),Re&&O.error(Re),Oe?.dispose()):Re||!Oe?(f.mark(`code/didCreateSocketError/${K}`),O.info(`Creating a socket (${oe}) returned an error after ${Ee.elapsed()} ms.`),Ce.reject(Re)):(f.mark(`code/didCreateSocketOK/${K}`),O.info(`Creating a socket (${oe}) was successful after ${Ee.elapsed()} ms.`),Ce.resolve(Oe))}),Ce.promise}function t(O,U){const j=new p(U);return O.then(x=>{j.didTimeout||j.resolve(x)},x=>{j.didTimeout||j.reject(x)}),j.promise}async function a(O,U,j,x){const $=F(O,U);O.logService.trace(`${$} 1/6. invoking socketFactory.connect().`);let V;try{V=await D(O.logService,O.socketFactory,O.host,O.port,(0,d.getRemoteServerRootPath)(O),`reconnectionToken=${O.reconnectionToken}&reconnection=${O.reconnectionProtocol?"true":"false"}`,r(U),`renderer-${r(U)}-${O.reconnectionToken}`,x)}catch(Ee){throw O.logService.error(`${$} socketFactory.connect() failed or timed out. Error:`),O.logService.error(Ee),Ee}O.logService.trace(`${$} 2/6. socketFactory.connect() was successful.`);let K,oe;O.reconnectionProtocol?(O.reconnectionProtocol.beginAcceptReconnection(V,null),K=O.reconnectionProtocol,oe=!1):(K=new v.PersistentProtocol({socket:V,measureRoundTripTime:!0}),oe=!0),O.logService.trace(`${$} 3/6. sending AuthRequest control message.`);const fe=await t(O.signService.createNewMessage((0,m.generateUuid)()),x),Ce={type:"auth",auth:O.connectionToken||"00000000000000000000",data:fe.data};K.sendControl(L.VSBuffer.fromString(JSON.stringify(Ce)));try{const Ee=await y(K,g(x,u(1e4)));if(Ee.type!=="sign"||typeof Ee.data!="string"){const ge=new Error("Unexpected handshake message");throw ge.code="VSCODE_CONNECTION_ERROR",ge}if(O.logService.trace(`${$} 4/6. received SignRequest control message.`),!await t(O.signService.validate(fe,Ee.signedData),x)){const ge=new Error("Refused to connect to unsupported server");throw ge.code="VSCODE_CONNECTION_ERROR",ge}const Oe=await t(O.signService.sign(Ee.data),x),ze={type:"connectionType",commit:O.commit,signedData:Oe,desiredConnectionType:U};return j&&(ze.args=j),O.logService.trace(`${$} 5/6. sending ConnectionTypeRequest control message.`),K.sendControl(L.VSBuffer.fromString(JSON.stringify(ze))),{protocol:K,ownsProtocol:oe}}catch(Ee){throw Ee&&Ee.code==="ETIMEDOUT"&&(O.logService.error(`${$} the handshake timed out. Error:`),O.logService.error(Ee)),Ee&&Ee.code==="VSCODE_CONNECTION_ERROR"&&(O.logService.error(`${$} received error control message when negotiating connection. Error:`),O.logService.error(Ee)),oe&&W(K),Ee}}async function i(O,U,j,x){const $=Date.now(),V=F(O,U),{protocol:K,ownsProtocol:oe}=await a(O,U,j,x),fe=new p(x);return fe.registerDisposable(K.onControlMessage(Ce=>{const Ee=JSON.parse(Ce.toString()),Re=H(Ee);Re?(O.logService.error(`${V} received error control message when negotiating connection. Error:`),O.logService.error(Re),oe&&W(K),fe.reject(Re)):(O.reconnectionProtocol?.endAcceptReconnection(),O.logService.trace(`${V} 6/6. handshake finished, connection is up and running after ${I($)}!`),fe.resolve({protocol:K,firstMessage:Ee}))})),fe.promise}async function s(O,U){const{protocol:j}=await i(O,1,void 0,U);return{protocol:j}}async function n(O,U,j){const{protocol:x,firstMessage:$}=await i(O,2,U,j),V=$&&$.debugPort;return{protocol:x,debugPort:V}}async function h(O,U,j){const x=Date.now(),$=F(O,3),{protocol:V}=await a(O,3,U,j);return O.logService.trace(`${$} 6/6. handshake finished, connection is up and running after ${I(x)}!`),V}async function l(O,U,j){const{host:x,port:$,connectionToken:V}=await O.addressProvider.getAddress();return{commit:O.commit,quality:O.quality,host:x,port:$,connectionToken:V,reconnectionToken:U,reconnectionProtocol:j,socketFactory:O.socketFactory,signService:O.signService,logService:O.logService}}async function E(O,U,j){return C(O,async x=>{const{protocol:$}=await s(x,o.CancellationToken.None);return new Y(O,U,j,x.reconnectionToken,$)})}e.connectRemoteAgentManagement=E;async function R(O,U){return C(O,async j=>{const{protocol:x,debugPort:$}=await n(j,U,o.CancellationToken.None);return new q(O,U,j.reconnectionToken,x,$)})}e.connectRemoteAgentExtensionHost=R;async function C(O,U){for(let x=1;;x++)try{const $=(0,m.generateUuid)(),V=await l(O,$,null);return await U(V)}catch($){if(x<5)O.logService.error(`[remote-connection][attempt ${x}] An error occurred in initial connection! Will retry... Error:`),O.logService.error($);else throw O.logService.error(`[remote-connection][attempt ${x}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),O.logService.error($),J.triggerPermanentFailure(0,0,b.RemoteAuthorityResolverError.isHandled($)),$}}async function T(O,U,j){const x=await l(O,(0,m.generateUuid)(),null);return await h(x,{host:U,port:j},o.CancellationToken.None)}e.connectRemoteAgentTunnel=T;function N(O){return(0,P.createCancelablePromise)(U=>new Promise((j,x)=>{const $=setTimeout(j,O*1e3);U.onCancellationRequested(()=>{clearTimeout($),j()})}))}var z;(function(O){O[O.ConnectionLost=0]="ConnectionLost",O[O.ReconnectionWait=1]="ReconnectionWait",O[O.ReconnectionRunning=2]="ReconnectionRunning",O[O.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",O[O.ConnectionGain=4]="ConnectionGain",O[O.ConnectionHealthChanged=5]="ConnectionHealthChanged"})(z=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class B{constructor(U,j){this.reconnectionToken=U,this.millisSinceLastIncomingData=j,this.type=0}}e.ConnectionLostEvent=B;class _{constructor(U,j,x,$){this.reconnectionToken=U,this.millisSinceLastIncomingData=j,this.durationSeconds=x,this.c=$,this.type=1}skipWait(){this.c.cancel()}}e.ReconnectionWaitEvent=_;class ne{constructor(U,j,x){this.reconnectionToken=U,this.millisSinceLastIncomingData=j,this.attempt=x,this.type=2}}e.ReconnectionRunningEvent=ne;class ae{constructor(U,j,x){this.reconnectionToken=U,this.millisSinceLastIncomingData=j,this.attempt=x,this.type=4}}e.ConnectionGainEvent=ae;class he{constructor(U,j){this.reconnectionToken=U,this.connectionHealth=j,this.type=5}}e.ConnectionHealthChangedEvent=he;class ce{constructor(U,j,x,$){this.reconnectionToken=U,this.millisSinceLastIncomingData=j,this.attempt=x,this.handled=$,this.type=3}}e.ReconnectionPermanentFailureEvent=ce;class J extends k.Disposable{static triggerPermanentFailure(U,j,x){this._permanentFailure=!0,this.f=U,this.g=j,this.h=x,this.i.forEach($=>$.u(this.f,this.g,this.h))}static debugTriggerReconnection(){this.i.forEach(U=>U.r())}static debugPauseSocketWriting(){this.i.forEach(U=>U.v())}get k(){return this.c||J._permanentFailure}constructor(U,j,x,$,V){super(),this.n=U,this.p=j,this.reconnectionToken=x,this.protocol=$,this.q=V,this.j=this.D(new M.Emitter),this.onDidStateChange=this.j.event,this.c=!1,this.l=!1,this.m=!1,this.j.fire(new ae(this.reconnectionToken,0,0)),this.D($.onSocketClose(K=>{const oe=re(this.n,this.reconnectionToken,!0);K?K.type===0?(this.p.logService.info(`${oe} received socket close event (hadError: ${K.hadError}).`),K.error&&this.p.logService.error(K.error)):(this.p.logService.info(`${oe} received socket close event (wasClean: ${K.wasClean}, code: ${K.code}, reason: ${K.reason}).`),K.event&&this.p.logService.error(K.event)):this.p.logService.info(`${oe} received socket close event.`),this.r()})),this.D($.onSocketTimeout(K=>{const oe=re(this.n,this.reconnectionToken,!0);this.p.logService.info(`${oe} received socket timeout event (unacknowledgedMsgCount: ${K.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${K.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${K.timeSinceLastReceivedSomeData}).`),this.r()})),this.D($.onHighRoundTripTime(K=>{const oe=se(this.n,this.reconnectionToken);this.p.logService.info(`${oe} high roundtrip time: ${K.roundTripTime}ms (${K.recentHighRoundTripCount} of ${5} recent samples)`)})),this.D($.onDidChangeConnectionHealth(K=>{this.j.fire(new he(this.reconnectionToken,K))})),J.i.push(this),this.D((0,k.toDisposable)(()=>{const K=J.i.indexOf(this);K>=0&&J.i.splice(K,1)})),this.k&&this.u(J.f,J.g,J.h)}dispose(){super.dispose(),this.m=!0}async r(){if(!this.l)try{this.l=!0,await this.s()}finally{this.l=!1}}async s(){if(this.k||this.m)return;const U=re(this.n,this.reconnectionToken,!0);this.p.logService.info(`${U} starting reconnecting loop. You can get more information with the trace log level.`),this.j.fire(new B(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const j=[0,5,5,10,10,10,10,10,30];let x=-1;do{x++;const $=x<j.length?j[x]:j[j.length-1];try{if($>0){const K=N($);this.j.fire(new _(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),$,K)),this.p.logService.info(`${U} waiting for ${$} seconds before reconnecting...`);try{await K}catch{}}if(this.k){this.p.logService.error(`${U} permanent failure occurred while running the reconnecting loop.`);break}this.j.fire(new ne(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),x+1)),this.p.logService.info(`${U} resolving connection...`);const V=await l(this.p,this.reconnectionToken,this.protocol);this.p.logService.info(`${U} connecting to ${V.host}:${V.port}...`),await this.w(V,u(S)),this.p.logService.info(`${U} reconnected!`),this.j.fire(new ae(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),x+1));break}catch(V){if(V.code==="VSCODE_CONNECTION_ERROR"){this.p.logService.error(`${U} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.p.logService.error(V),this.t(this.protocol.getMillisSinceLastIncomingData(),x+1,!1);break}if(x>360){this.p.logService.error(`${U} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.p.logService.error(V),this.t(this.protocol.getMillisSinceLastIncomingData(),x+1,!1);break}if(b.RemoteAuthorityResolverError.isTemporarilyNotAvailable(V)){this.p.logService.info(`${U} A temporarily not available error occurred while trying to reconnect, will try again...`),this.p.logService.trace(V);continue}if((V.code==="ETIMEDOUT"||V.code==="ENETUNREACH"||V.code==="ECONNREFUSED"||V.code==="ECONNRESET")&&V.syscall==="connect"){this.p.logService.info(`${U} A network error occurred while trying to reconnect, will try again...`),this.p.logService.trace(V);continue}if((0,A.isCancellationError)(V)){this.p.logService.info(`${U} A promise cancelation error occurred while trying to reconnect, will try again...`),this.p.logService.trace(V);continue}if(V instanceof b.RemoteAuthorityResolverError){this.p.logService.error(`${U} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.p.logService.error(V),this.t(this.protocol.getMillisSinceLastIncomingData(),x+1,b.RemoteAuthorityResolverError.isHandled(V));break}this.p.logService.error(`${U} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.p.logService.error(V),this.t(this.protocol.getMillisSinceLastIncomingData(),x+1,!1);break}}while(!this.k&&!this.m)}t(U,j,x){this.q?J.triggerPermanentFailure(U,j,x):this.u(U,j,x)}u(U,j,x){this.j.fire(new ce(this.reconnectionToken,U,j,x)),W(this.protocol)}v(){this.protocol.pauseSocketWriting()}}J._permanentFailure=!1,J.f=0,J.g=0,J.h=!1,J.i=[],e.PersistentConnection=J;class Y extends J{constructor(U,j,x,$,V){super(1,U,$,V,!0),this.client=this.D(new v.Client(V,{remoteAuthority:j,clientId:x},U.ipcLogger))}async w(U,j){await s(U,j)}}e.ManagementPersistentConnection=Y;class q extends J{constructor(U,j,x,$,V){super(2,U,x,$,!1),this.y=j,this.debugPort=V}async w(U,j){await n(U,this.y,j)}}e.ExtensionHostPersistentConnection=q;function W(O){try{O.acceptDisconnect();const U=O.getSocket();O.dispose(),U.dispose()}catch(U){(0,A.onUnexpectedError)(U)}}function H(O){if(O&&O.type==="error"){const U=new Error(`Connection error: ${O.reason}`);return U.code="VSCODE_CONNECTION_ERROR",U}return null}function Q(O,U){for(;O.length<U;)O+=" ";return O}function se(O,U){return`[remote-connection][${Q(r(O),13)}][${U.substr(0,5)}\u2026]`}function re(O,U,j){return`${se(O,U)}[${j?"reconnect":"initial"}]`}function F(O,U){return`${re(U,O.reconnectionToken,!!O.reconnectionProtocol)}[${O.host}:${O.port}]`}function I(O){return`${Date.now()-O} ms`}}),define(ee[235],te([0,1,25,46,41,195]),function(G,e,P,L,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWSLFeatureInstalled=void 0;let M;async function k(d=!1){return(M===void 0||d)&&(M=f()),M}e.hasWSLFeatureInstalled=k;async function f(){const d=c();if(d===void 0)return!1;if(d>=22e3){const S=v();if(S)return new Promise(w=>{L.execFile(S,["--status"],r=>w(!r))})}else{const S=b();if(S)try{if((await o.promises.stat(S)).isFile())return!0}catch{}}return!1}function c(){const d=/(\d+)\.(\d+)\.(\d+)/g.exec(P.release());if(d)return parseInt(d[3])}function m(d){const S=process.env.SystemRoot;if(S){const w=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return A.join(S,w?"Sysnative":"System32",d)}}function v(){return m("wsl.exe")}function b(){return m("lxss\\LxssManager.dll")}}),define(ee[52],te([0,1,17,13,2,178,68,6,5,51]),function(G,e,P,L,o,A,M,k,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.AbstractRequestService=e.IRequestService=void 0,e.IRequestService=(0,k.createDecorator)("requestService");class m{constructor(D){this.b=D}toJSON(){if(!this.a){const D=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?D[t]="*****":D[t]=this.b[t];this.a=D}return this.a}}class v extends o.Disposable{constructor(D,t){super(),this.b=0,this.a=t.createLogger(D?"remotenetwork":"network",{name:D?(0,A.localize)(0,null):(0,A.localize)(1,null),when:f.CONTEXT_LOG_LEVEL.isEqualTo((0,f.LogLevelToString)(f.LogLevel.Trace)).serialize()})}async c(D,t,a){const i=`${D} #${++this.b}: ${t.url}`;this.a.trace(`${i} - begin`,t.type,new m(t.headers??{}));try{const s=await a();return this.a.trace(`${i} - end`,t.type,s.res.statusCode,s.res.headers),s}catch(s){throw this.a.error(`${i} - error`,t.type,(0,L.getErrorMessage)(s)),s}}}e.AbstractRequestService=v;function b(y){return y.res.statusCode&&y.res.statusCode>=200&&y.res.statusCode<300||y.res.statusCode===1223}e.isSuccess=b;function d(y){return y.res.statusCode===204}async function S(y){return d(y)?null:(await(0,P.streamToBuffer)(y.stream)).toString()}e.asText=S;async function w(y){if(!b(y))throw new Error("Server returned "+y.res.statusCode);return S(y)}e.asTextOrError=w;async function r(y){if(!b(y))throw new Error("Server returned "+y.res.statusCode);if(d(y))return null;const t=(await(0,P.streamToBuffer)(y.stream)).toString();try{return JSON.parse(t)}catch(a){throw a.message+=`:
`+t,a}}e.asJson=r;function u(y){p(y)}e.updateProxyConfigurationsScope=u;let g;function p(y){const D=c.Registry.as(M.Extensions.Configuration),t=g;g={id:"http",order:15,title:(0,A.localize)(2,null),type:"object",scope:y,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(3,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null),(0,A.localize)(9,null)],default:"override",description:(0,A.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11,null),restricted:!0}}},D.updateConfigurations({add:[g],remove:t?[t]:[]})}p(2)}),define(ee[236],te([0,1,17,22]),function(G,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class o{constructor(k){this.a=k}listen(k,f){throw new Error("Invalid listen")}call(k,f,c,m=L.CancellationToken.None){switch(f){case"request":return this.a.request(c[0],m).then(async({res:v,stream:b})=>{const d=await(0,P.streamToBuffer)(b);return[{statusCode:v.statusCode,headers:v.headers},d]});case"resolveProxy":return this.a.resolveProxy(c[0])}throw new Error("Invalid call")}}e.RequestChannel=o;class A{constructor(k){this.a=k}async request(k,f){const[c,m]=await this.a.call("request",[k],f);return{res:c,stream:(0,P.bufferToStream)(m)}}async resolveProxy(k){return this.a.call("resolveProxy",[k])}}e.RequestChannelClient=A}),define(ee[237],te([0,1,238,11]),function(G,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function o(M,k){return M.protocol==="http:"?k.HTTP_PROXY||k.http_proxy||null:M.protocol==="https:"&&(k.HTTPS_PROXY||k.https_proxy||k.HTTP_PROXY||k.http_proxy)||null}async function A(M,k,f={}){const c=(0,P.parse)(M),m=f.proxyUrl||o(c,k);if(!m)return null;const v=(0,P.parse)(m);if(!/^https?:$/.test(v.protocol||""))return null;const b={host:v.hostname||"",port:v.port||(v.protocol==="https"?"443":"80"),auth:v.auth,rejectUnauthorized:(0,L.isBoolean)(f.strictSSL)?f.strictSSL:!0};return c.protocol==="http:"?new(await new Promise((d,S)=>{G(["http-proxy-agent"],d,S)}))(b):new(await new Promise((d,S)=>{G(["https-proxy-agent"],d,S)}))(b)}e.getProxyAgent=A}),define(ee[115],te([0,1,46,9,179,22,44,13,4,31,152,62,7,131]),function(G,e,P,L,o,A,M,k,f,c,m,v,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let S;async function w(u,g,p,y){return p["force-disable-user-env"]?(g.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):f.isWindows?(g.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,v.isLaunchedFromCli)(y)&&!p["force-user-env"]?(g.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,v.isLaunchedFromCli)(y)?g.trace("resolveShellEnv(): running (--force-user-env)"):g.trace("resolveShellEnv(): running (macOS/Linux)"),S||(S=b.Promises.withAsyncBody(async(D,t)=>{const a=new A.CancellationTokenSource;let i=1e4;const s=u.getValue("application.shellEnvironmentResolutionTimeout");typeof s=="number"&&(i=(0,d.clamp)(s,1,120)*1e3);const n=setTimeout(()=>{a.dispose(!0),t(new Error((0,o.localize)(0,null)))},i);try{D(await r(g,a.token))}catch(h){!(0,k.isCancellationError)(h)&&!a.token.isCancellationRequested?t(new Error((0,o.localize)(1,null,(0,M.toErrorMessage)(h)))):D({})}finally{clearTimeout(n),a.dispose()}})),S)}e.getResolvedShellEnv=w;async function r(u,g){const p=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",p);const y=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",y);const D=(0,c.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(D+"({.*})"+D),a={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};u.trace("getUnixShellEnvironment#env",a);const i=await(0,m.getSystemShell)(f.OS,a);return u.trace("getUnixShellEnvironment#shell",i),new Promise((s,n)=>{if(g.isCancellationRequested)return n(new k.CancellationError);const h=(0,L.basename)(i);let l,E;const R=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(h)?(l=`& '${process.execPath}' ${R} -p '''${D}'' + JSON.stringify(process.env) + ''${D}'''`,E=["-Login","-Command"]):(l=`'${process.execPath}' ${R} -p '"${D}" + JSON.stringify(process.env) + "${D}"'`,h==="tcsh"||h==="csh"?E=["-ic"]:E=["-i","-l","-c"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(E),l);const C=(0,P.spawn)(i,[...E,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});g.onCancellationRequested(()=>(C.kill(),n(new k.CancellationError))),C.on("error",z=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,M.toErrorMessage)(z)),n(z)});const T=[];C.stdout.on("data",z=>T.push(z));const N=[];C.stderr.on("data",z=>N.push(z)),C.on("close",(z,B)=>{const _=Buffer.concat(T).toString("utf8");u.trace("getUnixShellEnvironment#raw",_);const ne=Buffer.concat(N).toString("utf8");if(ne.trim()&&u.trace("getUnixShellEnvironment#stderr",ne),z||B)return n(new Error((0,o.localize)(2,null,z,B)));const ae=t.exec(_),he=ae?ae[1]:"{}";try{const ce=JSON.parse(he);p?ce.ELECTRON_RUN_AS_NODE=p:delete ce.ELECTRON_RUN_AS_NODE,y?ce.ELECTRON_NO_ATTACH_CONSOLE=y:delete ce.ELECTRON_NO_ATTACH_CONSOLE,delete ce.VSCODE_RESOLVING_ENVIRONMENT,delete ce.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",ce),s(ce)}catch(ce){u.error("getUnixShellEnvironment#errorCaught",(0,M.toErrorMessage)(ce)),n(ce)}})})}}),define(ee[91],te([0,1,6]),function(G,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,P.createDecorator)(e.SIGN_SERVICE_ID)}),define(ee[239],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class P{constructor(){this.b=new Map}c(){return new Promise((o,A)=>G(["vsda"],o,A))}async createNewMessage(o){try{const A=await this.c(),M=new A.validator;if(M){const k=String(P.a++);return this.b.set(k,M),{id:k,data:M.createNewMessage(o)}}}catch{}return{id:"",data:o}}async validate(o,A){if(!o.id)return!0;const M=this.b.get(o.id);if(!M)return!1;this.b.delete(o.id);try{return M.validate(A)==="ok"}catch{return!1}}async sign(o){try{const A=await this.c(),M=new A.signer;if(M)return M.sign(o)}catch{}return o}}P.a=1,e.SignService=P}),define(ee[33],te([0,1,6]),function(G,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=e.IStateReadService=void 0,e.IStateReadService=(0,P.createDecorator)("stateReadService"),e.IStateService=(0,P.createDecorator)("stateService")}),define(ee[116],te([0,1,7,17,11,34,16,5]),function(G,e,P,L,o,A,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.StateReadonlyService=e.FileStorage=e.SaveStrategy=void 0;var f;(function(b){b[b.IMMEDIATE=0]="IMMEDIATE",b[b.DELAYED=1]="DELAYED"})(f=e.SaveStrategy||(e.SaveStrategy={}));class c{constructor(d,S,w,r){this.f=d,this.g=w,this.h=r,this.a=Object.create(null),this.b="",this.d=void 0,this.e=void 0,this.c=S===0?void 0:new P.ThrottledDelayer(100)}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(d){d.fileOperationResult!==1&&this.g.error(d)}}getItem(d,S){const w=this.a[d];return(0,o.isUndefinedOrNull)(w)?S:w}setItem(d,S){this.setItems([{key:d,data:S}])}setItems(d){let S=!1;for(const{key:w,data:r}of d)this.a[w]!==r&&((0,o.isUndefinedOrNull)(r)?(0,o.isUndefined)(this.a[w])||(this.a[w]=void 0,S=!0):(this.a[w]=r,S=!0));S&&this.j()}removeItem(d){(0,o.isUndefined)(this.a[d])||(this.a[d]=void 0,this.j())}async j(){if(!this.e)return this.c?this.c.trigger(()=>this.k()):this.k()}async k(){if(!this.d)return;await this.d;const d=JSON.stringify(this.a,null,4);if(d!==this.b)try{await this.h.writeFile(this.f,L.VSBuffer.fromString(d)),this.b=d}catch(S){this.g.error(S)}}async close(){return this.e||(this.e=this.c?this.c.trigger(()=>this.k(),0):this.k()),this.e}}e.FileStorage=c;let m=class{constructor(d,S,w,r){this.a=new c(S.stateResource,d,w,r)}async init(){await this.a.init()}getItem(d,S){return this.a.getItem(d,S)}};m=ye([Z(1,A.IEnvironmentService),Z(2,k.ILogService),Z(3,M.IFileService)],m),e.StateReadonlyService=m;class v extends m{setItem(d,S){this.a.setItem(d,S)}setItems(d){this.a.setItems(d)}removeItem(d){this.a.removeItem(d)}close(){return this.a.close()}}e.StateService=v}),define(ee[92],te([0,1,4,36,8,31]),function(G,e,P,L,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function M(c){if(P.platform===2&&/^penguin(\.|$)/i.test(c))return"chromebook"}async function k(c,m,v,b,d,S,w,r,u,g){const p=Object.create(null);p["common.machineId"]=w,p.sessionID=(0,A.generateUuid)()+Date.now(),p.commitHash=d,p.version=S,p["common.platformVersion"]=(m||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),p["common.platform"]=(0,P.PlatformToString)(P.platform),p["common.nodePlatform"]=L.platform,p["common.nodeArch"]=b,p["common.product"]=g||"desktop",r&&(p["common.msftInternal"]=r);let y=0;const D=Date.now();Object.defineProperties(p,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-D,enumerable:!0},"common.sequence":{get:()=>y++,enumerable:!0}}),P.isLinuxSnap&&(p["common.snap"]="true");const t=M(v);t&&(p["common.platformDetail"]=t);try{const a=await c.readFile(o.URI.file(u));p["common.source"]=a.value.toString().slice(0,30)}catch{}return p}e.resolveCommonProperties=k;function f(c){const m=L.env.USERDNSDOMAIN;if(!m)return!1;const v=m.toLowerCase();return c.some(b=>v===b)}e.verifyMicrosoftInternalDomain=f}),define(ee[24],te([0,1,6]),function(G,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,P.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,P.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var L;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(L=e.TelemetryLevel||(e.TelemetryLevel={}));var o;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(o=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ee[240],te([0,1,25,7,43,14,9,4,8,85,23,103,87,16,21,24]),function(G,e,P,L,o,A,M,k,f,c,m,v,b,d,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const r=new Map;async function u(t,a){const i=`${t}::${a.join(":")}`,s=r.get(i);if(s)return s;const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],h=new Map,l=new Map,E=2e4;function R(T,N,z,B){const _=N.substring(T.length+1);return L.Promises.withAsyncBody(async ne=>{let ae;try{ae=await m.Promises.readdir(N,{withFileTypes:!0})}catch{ne();return}if(B.count>=E){B.count+=ae.length,B.maxReached=!0,ne();return}let he=ae.length;if(he===0){ne();return}let ce=ae;B.count+ae.length>E&&(B.maxReached=!0,he=E-B.count,ce=ae.slice(0,he)),B.count+=ae.length;for(const J of ce)if(J.isDirectory()){if(z.includes(J.name)||await R(T,(0,M.join)(N,J.name),z,B),--he===0){ne();return}}else{const Y=J.name.lastIndexOf(".");if(Y>=0){const q=J.name.substring(Y+1);q&&h.set(q,(h.get(q)??0)+1)}for(const q of n)q.relativePathPattern?.test(_)!==!1&&q.filePattern.test(J.name)&&l.set(q.tag,(l.get(q.tag)??0)+1);if(--he===0){ne();return}}})}const C=L.Promises.withAsyncBody(async T=>{const N={count:0,maxReached:!1};await R(t,t,a,N);const z=await y(t);T({configFiles:g(l),fileTypes:g(h),fileCount:N.count,maxFilesReached:N.maxReached,launchConfigFiles:z})});return r.set(i,C),C}e.collectWorkspaceStats=u;function g(t){return Array.from(t.entries(),([a,i])=>({name:a,count:i})).sort((a,i)=>i.count-a.count)}function p(){const t={os:`${P.type()} ${P.arch()} ${P.release()}`,memory:`${(P.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(P.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(c.virtualMachineHint.value()*100)}%`},a=P.cpus();return a&&a.length>0&&(t.cpus=`${a[0].model} (${a.length} x ${a[0].speed})`),t}e.getMachineInfo=p;async function y(t){try{const a=new Map,i=(0,M.join)(t,".vscode","launch.json"),s=await m.Promises.readFile(i),n=[],h=(0,o.parse)(s.toString(),n);if(n.length)return console.log(`Unable to parse ${i}`),[];if((0,o.getNodeType)(h)==="object"&&h.configurations)for(const l of h.configurations){const E=l.type;E&&(a.has(E)?a.set(E,a.get(E)+1):a.set(E,1))}return g(a)}catch{return[]}}e.collectLaunchConfigs=y;let D=class{constructor(a,i){this.c=a,this.d=i}f(a){const i=[];return i.push(`OS Version:       ${a.os}`),i.push(`CPUs:             ${a.cpus}`),i.push(`Memory (System):  ${a.memory}`),i.push(`VM:               ${a.vmHint}`),i.join(`
`)}g(a){const i=[];i.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),i.push(`OS Version:       ${P.type()} ${P.arch()} ${P.release()}`);const s=P.cpus();return s&&s.length>0&&i.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),i.push(`Memory (System):  ${(P.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(P.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`),k.isWindows||i.push(`Load (avg):       ${P.loadavg().map(n=>Math.round(n)).join(", ")}`),i.push(`VM:               ${Math.round(c.virtualMachineHint.value()*100)}%`),i.push(`Screen Reader:    ${a.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${a.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.j(a.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(a,i){return Promise.all([(0,v.listProcesses)(a.mainPID),this.k(a)]).then(async s=>{let[n,h]=s,l=this.m(a,n);return i.forEach(E=>{if((0,b.isRemoteDiagnosticError)(E))l+=`
${E.errorMessage}`,h+=`
${E.errorMessage}`;else if(l+=`

Remote: ${E.hostName}`,E.processes&&(l+=`
${this.m(a,E.processes)}`),E.workspaceMetadata){h+=`
|  Remote: ${E.hostName}`;for(const R of Object.keys(E.workspaceMetadata)){const C=E.workspaceMetadata[R];let T=`${C.fileCount} files`;C.maxFilesReached&&(T=`more than ${T}`),h+=`|    Folder (${R}): ${T}`,h+=this.h(C)}}}),{processInfo:l,workspaceInfo:h}})}async getSystemInfo(a,i){const{memory:s,vmHint:n,os:h,cpus:l}=p(),E={os:h,memory:s,cpus:l,vmHint:n,processArgs:`${a.mainArguments.join(" ")}`,gpuStatus:a.gpuFeatureStatus,screenReader:`${a.screenReader?"yes":"no"}`,remoteData:i};return k.isWindows||(E.load=`${P.loadavg().map(R=>Math.round(R)).join(", ")}`),k.isLinux&&(E.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(E)}async getDiagnostics(a,i){const s=[];return(0,v.listProcesses)(a.mainPID).then(async n=>(s.push(""),s.push(this.g(a)),s.push(""),s.push(this.m(a,n)),a.windows.some(h=>h.folderURIs&&h.folderURIs.length>0&&!h.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.k(a))),i.forEach(h=>{if((0,b.isRemoteDiagnosticError)(h))s.push(`
${h.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${h.hostName}`),s.push(this.f(h.machineInfo)),h.processes&&s.push(this.m(a,h.processes)),h.workspaceMetadata)for(const l of Object.keys(h.workspaceMetadata)){const E=h.workspaceMetadata[l];let R=`${E.fileCount} files`;E.maxFilesReached&&(R=`more than ${R}`),s.push(`Folder (${l}): ${R}`),s.push(this.h(E))}}),s.push(""),s.push(""),s.join(`
`)))}h(a){const i=[];let n=0;const h=(C,T)=>{const N=` ${C}(${T})`;n+N.length>60?(i.push(l),l="|                 ",n=l.length):n+=N.length,l+=N};let l="|      File types:";const E=10,R=a.fileTypes.length>E?E:a.fileTypes.length;for(let C=0;C<R;C++){const T=a.fileTypes[C];h(T.name,T.count)}if(i.push(l),a.configFiles.length>=0&&(l="|      Conf files:",n=0,a.configFiles.forEach(C=>{h(C.name,C.count)}),i.push(l)),a.launchConfigFiles.length>0){let C="|      Launch Configs:";a.launchConfigFiles.forEach(T=>{C+=T.count>1?` ${T.name}(${T.count})`:` ${T.name}`}),i.push(C)}return i.join(`
`)}j(a){const i=Math.max(...Object.keys(a).map(s=>s.length));return Object.keys(a).map(s=>`${s}:  ${" ".repeat(i-s.length)}  ${a[s]}`).join(`
                  `)}k(a){const i=[],s=[];return a.windows.forEach(n=>{n.folderURIs.length===0||!!n.remoteAuthority||(i.push(`|  Window (${n.title})`),n.folderURIs.forEach(h=>{const l=f.URI.revive(h);if(l.scheme===A.Schemas.file){const E=l.fsPath;s.push(u(E,["node_modules",".git"]).then(R=>{let C=`${R.fileCount} files`;R.maxFilesReached&&(C=`more than ${C}`),i.push(`|    Folder (${(0,M.basename)(E)}): ${C}`),i.push(this.h(R))}).catch(R=>{i.push(`|      Error: Unable to collect workspace stats for folder ${E} (${R.toString()})`)}))}else i.push(`|    Folder (${l.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(n=>i.join(`
`)).catch(n=>`Unable to collect workspace stats: ${n}`)}m(a,i){const s=new Map;a.windows.forEach(h=>s.set(h.pid,`window [${h.id}] (${h.title})`)),a.pidToNames.forEach(({pid:h,name:l})=>s.set(h,l));const n=[];return n.push("CPU %	Mem MB	   PID	Process"),i&&this.n(a.mainPID,s,n,i,0),n.join(`
`)}n(a,i,s,n,h){const l=h===0;let E;l?E=n.pid===a?`${this.d.applicationName} main`:"remote agent":i.has(n.pid)?E=i.get(n.pid):E=`${"  ".repeat(h)} ${n.name}`;const R=process.platform==="win32"?n.mem:P.totalmem()*(n.mem/100);s.push(`${n.load.toFixed(0).padStart(5," ")}	${(R/d.ByteSize.MB).toFixed(0).padStart(6," ")}	${n.pid.toFixed(0).padStart(6," ")}	${E}`),Array.isArray(n.children)&&n.children.forEach(C=>this.n(a,i,s,C,h+1))}async getWorkspaceFileExtensions(a){const i=new Set;for(const{uri:s}of a.folders){const n=f.URI.revive(s);if(n.scheme!==A.Schemas.file)continue;const h=n.fsPath;try{(await u(h,["node_modules",".git"])).fileTypes.forEach(E=>i.add(E.name))}catch{}}return{extensions:[...i]}}async reportWorkspaceStats(a){for(const{uri:i}of a.folders){const s=f.URI.revive(i);if(s.scheme!==A.Schemas.file)continue;const n=s.fsPath;try{const h=await u(n,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":a.telemetryId,rendererSessionId:a.rendererSessionId}),h.fileTypes.forEach(l=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:a.rendererSessionId,type:l.name,count:l.count})}),h.launchConfigFiles.forEach(l=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:a.rendererSessionId,type:l.name,count:l.count})}),h.configFiles.forEach(l=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:a.rendererSessionId,type:l.name,count:l.count})})}catch{}}}};D=ye([Z(0,w.ITelemetryService),Z(1,S.IProductService)],D),e.DiagnosticsService=D}),define(ee[241],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class P{constructor(A){this.b=A}listen(A,M){throw new Error(`Event not found: ${M}`)}call(A,M,{eventName:k,data:f}){return this.b.forEach(c=>c.log(k,f)),Promise.resolve(null)}}e.TelemetryAppenderChannel=P;class L{constructor(A){this.b=A}log(A,M){return this.b.call("log",{eventName:A,data:M}).then(void 0,k=>`Failed to log telemetry: ${console.warn(k)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=L}),define(ee[48],te([0,1,37,11,3,19,57,92,24]),function(G,e,P,L,o,A,M,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class c{constructor(n){this.value=n}}e.TelemetryTrustedValue=c;class m{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(n,h){return Promise.resolve(void 0)}publicLog2(n,h){return this.publicLog(n,h)}publicLogError(n,h){return Promise.resolve(void 0)}publicLogError2(n,h){return this.publicLogError(n,h)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=m,e.NullTelemetryService=new m;class v{async publicLog(n,h,l){}async publicLogError(n,h,l){}}e.NullEndpointTelemetryService=v,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function b(s,n){return o.Event.debounce(n.onDidChangeConfiguration,(l,E)=>{const R=l?new Set([...l.affectedKeys,...E.affectedKeys]):E.affectedKeys;return{...E,affectedKeys:R}},1e3,!0)(l=>{l.source!==7&&s.publicLog2("updateConfiguration",{configurationSource:(0,A.ConfigurationTargetToString)(l.source),configurationKeys:Array.from(l.affectedKeys)})})}e.configurationTelemetry=b;function d(s,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!s.enableTelemetry||n.extensionTestsLocationURI)}e.supportsTelemetry=d;function S(s,n){return!(n.isBuilt||n.disableTelemetry||s.enableTelemetry&&s.aiConfig?.ariaKey)}e.isLoggingOnly=S;function w(s){const n=s.getValue(f.TELEMETRY_SETTING_ID),h=s.getValue(f.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(s.getValue(f.TELEMETRY_OLD_SETTING_ID)===!1||h===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=w;function r(s){const n={},h={},l={};p(s,l);for(let E in l){E=E.length>150?E.substr(E.length-149):E;const R=l[E];typeof R=="number"?h[E]=R:typeof R=="boolean"?h[E]=R?1:0:typeof R=="string"?(R.length>8192&&console.warn(`Telemetry property: ${E} has been trimmed to 8192, the original length is ${R.length}`),n[E]=R.substring(0,8191)):typeof R<"u"&&R!==null&&(n[E]=R)}return{properties:n,measurements:h}}e.validateTelemetryData=r;const u=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function g(s){if(!s)return"none";const n=(0,M.getRemoteName)(s);return u.has(n)?n:"other"}e.cleanRemoteAuthority=g;function p(s,n,h=0,l){if(!!s)for(const E of Object.getOwnPropertyNames(s)){const R=s[E],C=l?l+E:E;Array.isArray(R)?n[C]=(0,P.safeStringify)(R):R instanceof Date?n[C]=R.toISOString():(0,L.isObject)(R)?h<2?p(R,n,h+1,C+"."):n[C]=(0,P.safeStringify)(R):n[C]=R}}function y(s,n){const h=s.msftInternalDomains||[],l=n.getValue("telemetry.internalTesting");return(0,k.verifyMicrosoftInternalDomain)(h)||l}e.isInternalTelemetry=y;function D(s){return[s.appRoot,s.extensionsPath,s.userHome.fsPath,s.tmpDir.fsPath,s.userDataPath]}e.getPiiPathsFromEnvironment=D;function t(s,n){if(!s||!s.includes("/")&&!s.includes("\\"))return s;let h=s;const l=[];for(const T of n)for(;;){const N=T.exec(s);if(!N)break;l.push([N.index,T.lastIndex])}const E=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,R=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let C=0;for(h="";;){const T=R.exec(s);if(!T)break;const N=l.some(([z,B])=>T.index<B&&z<R.lastIndex);!E.test(T[0])&&!N&&(h+=s.substring(C,T.index)+"<REDACTED: user-file-path>",C=R.lastIndex)}return C<s.length&&(h+=s.substr(C)),h}function a(s){if(!s)return s;const n=s.toLowerCase(),h=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const l of h)if(l.regex.test(n))return`<REDACTED: ${l.label}>`;return s}function i(s,n){return(0,P.cloneAndChange)(s,h=>{if(h instanceof c)return h.value;if(typeof h=="string"){let l=h.replaceAll("%20"," ");l=t(l,n);for(const E of n)l=l.replace(E,"");return l=a(l),l}})}e.cleanData=i}),define(ee[117],te([0,1,26,110,114,4,8,13,36,48]),function(G,e,P,L,o,A,M,k,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function m(i,s){return i.uuid&&s.uuid?i.uuid===s.uuid:i.id===s.id?!0:(0,P.compareIgnoreCase)(i.id,s.id)===0}e.areSameExtensions=m;const v=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class b{static create(s){const n=s.manifest?s.manifest.version:s.version,h=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new b(s.identifier,n,h)}static parse(s){const n=v.exec(s);return n&&n[1]&&n[2]?new b({id:n[1]},n[2],n[4]||void 0):null}constructor(s,n,h="undefined"){this.version=n,this.targetPlatform=h,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof b?m(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.ExtensionKey=b;const d=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function S(i){const s=d.exec(i);return s&&s[1]?[r(s[1]),s[2]]:[r(i),void 0]}e.getIdAndVersion=S;function w(i,s){return`${i}.${s}`}e.getExtensionId=w;function r(i){return i.toLocaleLowerCase()}e.adoptToGalleryExtensionId=r;function u(i,s){return r(w(i??o.UNDEFINED_PUBLISHER,s))}e.getGalleryExtensionId=u;function g(i,s){const n=[],h=l=>{for(const E of n)if(E.some(R=>m(s(R),s(l))))return E;return null};for(const l of i){const E=h(l);E?E.push(l):n.push([l])}return n}e.groupByExtension=g;function p(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=p;function y(i){return{id:new c.TelemetryTrustedValue(i.identifier.id),name:new c.TelemetryTrustedValue(i.name),galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.getGalleryExtensionTelemetryData=y,e.BetterMergeId=new o.ExtensionIdentifier("pprice.better-merge");function D(i,s){const n=[],h=s.manifest.extensionDependencies?.slice(0)??[];for(;h.length;){const l=h.shift();if(l&&n.every(E=>!m(E.identifier,{id:l}))){const E=i.filter(R=>m(R.identifier,{id:l}));E.length===1&&(n.push(E[0]),h.push(...E[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.getExtensionDependencies=D;async function t(i,s){if(!A.isLinux)return!1;let n;try{n=(await i.readFile(M.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await i.readFile(M.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){s.debug("Error while getting the os-release file.",(0,k.getErrorMessage)(l))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function a(i,s){const n=await t(i,s),h=(0,L.getTargetPlatform)(n?"alpine":A.platform,f.arch);return s.debug("ComputeTargetPlatform:",h),h}e.computeTargetPlatform=a}),define(ee[242],te([0,1,200,48]),function(G,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function o(A,M,k,f,c,m,v){const b={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${M.nameShort})`};if((0,L.supportsTelemetry)(M,k)&&(0,L.getTelemetryLevel)(f)===3){const d=await(0,P.getServiceMachineId)(k,c,m),{machineId:S}=await v.getTelemetryInfo();b["X-Market-User-Id"]=d,b["VSCode-SessionId"]=S||d}return b}e.resolveMarketplaceHeaders=o}),define(ee[243],te([0,1,13,37,48]),function(G,e,P,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const A="https://mobile.events.data.microsoft.com/OneCollector/1.0",M="https://mobile.events.data.microsoft.com/ping";async function k(c,m,v){const b=await new Promise((u,g)=>{G(["@microsoft/1ds-core-js"],u,g)}),d=await new Promise((u,g)=>{G(["@microsoft/1ds-post-js"],u,g)}),S=new b.AppInsightsCore,w=new d.PostChannel,r={instrumentationKey:c,endpointUrl:A,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[w]]};if(v){r.extensionConfig={};const u={alwaysUseXhrOverride:!0,httpXHROverride:v};r.extensionConfig[w.identifier]=u}return S.initialize(r,[]),S.addTelemetryInitializer(u=>{m&&(u.ext=u.ext??{},u.ext.utc=u.ext.utc??{},u.ext.utc.flags=8462029)}),S}class f{constructor(m,v,b,d,S){this.e=m,this.f=v,this.g=b,this.h=S,this.c=A,this.d=M,this.g||(this.g={}),typeof d=="function"?this.a=d():this.a=d,this.b=null}i(m){if(!!this.a){if(typeof this.a!="string"){m(this.a);return}this.b||(this.b=k(this.a,this.e,this.h)),this.b.then(v=>{m(v)},v=>{(0,P.onUnexpectedError)(v),console.error(v)})}}log(m,v){if(!this.a)return;v=(0,L.mixin)(v,this.g),v=(0,o.validateTelemetryData)(v);const b=this.f+"/"+m;try{this.i(d=>{d.pluginVersionString=v?.properties.version??"Unknown",d.track({name:b,baseData:{name:b,properties:v?.properties,measurements:v?.measurements}})})}catch{}}flush(){return this.a?new Promise(m=>{this.i(v=>{v.unload(!0,()=>{this.a=void 0,m(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=f}),define(ee[118],te([0,1,2,37,4,26,180,19,68,66,21,51,24,48]),function(G,e,P,L,o,A,M,k,f,c,m,v,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let S=class{constructor(u,g,p){this.k=g,this.l=p,this.d={},this.i=new P.DisposableStore,this.j=[],this.b=u.appenders,this.c=u.commonProperties||Promise.resolve({}),this.f=u.piiPaths||[],this.g=3,this.h=!!u.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const y of this.f)this.j.push(new RegExp((0,A.escapeRegExpCharacters)(y),"gi")),y.indexOf("\\")>=0&&this.j.push(new RegExp((0,A.escapeRegExpCharacters)(y.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(y=>{(y.affectsConfiguration(b.TELEMETRY_SETTING_ID)||y.affectsConfiguration(b.TELEMETRY_OLD_SETTING_ID)||y.affectsConfiguration(b.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this.m()}))}setExperimentProperty(u,g){this.d[u]=g}m(){let u=(0,d.getTelemetryLevel)(this.k);const g=this.l.enabledTelemetryLevels;if(g){this.h=this.sendErrorTelemetry?g.error:!1;const p=g.usage?3:g.error?2:0;u=Math.min(u,p)}this.g=u}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}async getTelemetryInfo(){const u=await this.c,g=u.sessionID,p=u["common.machineId"],y=u["common.firstSessionDate"],D=u["common.msftInternal"];return{sessionId:g,machineId:p,firstSessionDate:y,msftInternal:D}}dispose(){this.i.dispose()}n(u,g,p){return this.g<g?Promise.resolve(void 0):this.c.then(y=>{p=(0,L.mixin)(p,this.d),p=(0,d.cleanData)(p,this.j),p=(0,L.mixin)(p,y),this.b.forEach(D=>D.log(u,p))},y=>{console.error(y)})}publicLog(u,g){return this.n(u,3,g)}publicLog2(u,g){return this.publicLog(u,g)}publicLogError(u,g){return this.h?this.n(u,2,g):Promise.resolve(void 0)}publicLogError2(u,g){return this.publicLogError(u,g)}};S.IDLE_START_EVENT_NAME="UserIdleStart",S.IDLE_STOP_EVENT_NAME="UserIdleStop",S=ye([Z(1,k.IConfigurationService),Z(2,m.IProductService)],S),e.TelemetryService=S;function w(){const r=(0,M.localize)(0,null,c.default.nameLong),u=c.default.privacyStatementUrl?(0,M.localize)(2,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,M.localize)(1,null,"https://aka.ms/vscode-telemetry"),g=o.isWeb?"":(0,M.localize)(3,null),p=(0,M.localize)(4,null),y=(0,M.localize)(5,null),D=(0,M.localize)(6,null),t=(0,M.localize)(7,null),a=`
|       | ${p} | ${y} | ${D} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,M.localize)(8,null);return`
${r} ${u} ${g}

&nbsp;

${t}
${a}

&nbsp;

${i}
`}v.Registry.as(f.Extensions.Configuration).registerConfiguration({id:b.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,M.localize)(9,null),properties:{[b.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,M.localize)(10,null),(0,M.localize)(11,null),(0,M.localize)(12,null),(0,M.localize)(13,null)],markdownDescription:w(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),v.Registry.as(f.Extensions.Configuration).registerConfiguration({id:b.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,M.localize)(14,null),properties:{[b.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,M.localize)(16,null,c.default.nameLong,c.default.privacyStatementUrl):(0,M.localize)(15,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,M.localize)(17,null,`\`#${b.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ee[244],te([0,1,295,243]),function(G,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class o extends L.AbstractOneDataSystemAppender{constructor(M,k,f,c){const m={sendPOST:(v,b)=>{const d={method:"POST",headers:{...v.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(v.data)}};try{const S=P.request(v.urlString,d,w=>{w.on("data",function(r){b(w.statusCode??200,w.headers,r.toString())}),w.on("error",function(r){b(0,{})})});S.write(v.data),S.end()}catch{b(0,{})}}};super(M,k,f,c,m)}}e.OneDataSystemAppender=o}),define(ee[245],te([0,1,4,85,24]),function(G,e,P,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function A(M){let k=M.getItem(o.machineIdKey);return(typeof k!="string"||P.isMacintosh&&k==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(k=await(0,L.getMachineId)()),k}e.resolveMachineId=A}),define(ee[119],te([0,1,24,245]),function(G,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function o(A){const M=await(0,L.resolveMachineId)(A);return A.setItem(P.machineIdKey,M),M}e.resolveMachineId=o}),define(ee[69],te([0,1,15,3,2,4,19,6,33]),function(G,e,P,L,o,A,M,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const c="#FFFFFF",m="#1E1E1E",v="#000000",b="#FFFFFF",d="theme",S="themeBackground",w="windowSplash";e.IThemeMainService=(0,k.createDecorator)("themeMainService");let r=class extends o.Disposable{constructor(g,p){super(),this.b=g,this.c=p,this.a=this.D(new L.Emitter),this.onDidChangeColorScheme=this.a.event,P.nativeTheme.on("updated",()=>{this.a.fire(this.getColorScheme())})}getColorScheme(){if(A.isWindows){if(P.nativeTheme.shouldUseHighContrastColors)return{dark:P.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(A.isMacintosh){if(P.nativeTheme.shouldUseInvertedColorScheme||P.nativeTheme.shouldUseHighContrastColors)return{dark:P.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(A.isLinux&&P.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:P.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const g=this.getColorScheme();if(g.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return g.dark?v:b;let p=this.b.getItem(S,null);if(!p)switch(this.b.getItem(d,"vs-dark").split(" ")[0]){case"vs":p=c;break;case"hc-black":p=v;break;case"hc-light":p=b;break;default:p=m}return A.isMacintosh&&p.toUpperCase()===m&&(p="#171717"),p}saveWindowSplash(g,p){this.b.setItems([{key:d,data:p.baseTheme},{key:S,data:p.colorInfo.background},{key:w,data:p}]),typeof g=="number"&&this.f(g,p)}f(g,p){for(const y of P.BrowserWindow.getAllWindows())if(y.id===g){y.setBackgroundColor(p.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(w)}};r=ye([Z(0,f.IStateService),Z(1,M.IConfigurationService)],r),e.ThemeMainService=r}),define(ee[120],te([0,1,3,19,6,5]),function(G,e,P,L,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,o.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,o.createDecorator)("sharedTunnelsService");var M;(function(w){w.Http="http",w.Https="https"})(M=e.TunnelProtocol||(e.TunnelProtocol={}));var k;(function(w){w.ConstantPrivate="constantPrivate",w.Private="private",w.Public="public"})(k=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var f;(function(w){w[w.Notify=1]="Notify",w[w.OpenBrowser=2]="OpenBrowser",w[w.OpenPreview=3]="OpenPreview",w[w.Silent=4]="Silent",w[w.Ignore=5]="Ignore",w[w.OpenBrowserOnce=6]="OpenBrowserOnce"})(f=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function c(w){if(w.scheme!=="http"&&w.scheme!=="https")return;const r=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(w.authority);if(!!r)return{address:r[1],port:+r[2]}}e.extractLocalHostUriMetaDataForPortMapping=c,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function m(w){return e.LOCALHOST_ADDRESSES.indexOf(w)>=0}e.isLocalhost=m,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function v(w){return e.ALL_INTERFACES_ADDRESSES.indexOf(w)>=0}e.isAllInterfaces=v;function b(w,r,u,g){if(u===1)return!1;if(u===2&&v(r)){const p=/(\d+)\.(\d+)\.(\d+)/g.exec(g);if(p?.length===4&&parseInt(p[1])>=18)return!1}return w<1024}e.isPortPrivileged=b;class d{constructor(r,u,g){this.remoteAddress=r,this.localAddress=u,this.b=g,this.a=new P.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=d;let S=class{constructor(r,u){this.i=r,this.j=u,this.a=new P.Emitter,this.onTunnelOpened=this.a.event,this.b=new P.Emitter,this.onTunnelClosed=this.b.event,this.c=new P.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const r=this.j.getValue("remote.localPortHost");return!r||r==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(r){return this.e=r,r?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(r){this.f=r.elevation,this.g=r.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const r=[],u=Array.from(this.d.values());for(const g of u){const p=Array.from(g.values());for(const y of p){const D=await y.value;D&&r.push(D)}}return r}async dispose(){for(const r of this.d.values()){for(const{value:u}of r.values())await u.then(g=>g?.dispose());r.clear()}this.d.clear()}setEnvironmentTunnel(r,u,g,p,y){this.o(r,u,Promise.resolve({tunnelRemoteHost:r,tunnelRemotePort:u,localAddress:g,privacy:p,protocol:y,dispose:()=>Promise.resolve()}))}async getExistingTunnel(r,u){(v(r)||m(r))&&(r=e.LOCALHOST_ADDRESSES[0]);const g=this.q(r,u);if(g)return++g.refcount,g.value}openTunnel(r,u,g,p,y,D=!1,t,a){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${g} on local port ${y}.`),!r)return;if(u||(u="localhost"),p||(p=this.k),this.e&&this.h.has(g)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const i=this.r(r,u,g,p,y,D,t,a);return i?i.then(s=>{if(!s){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(u,g);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const n=this.m(s);return(s.tunnelRemoteHost!==u||s.tunnelRemotePort!==g)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(n),n}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),i)}m(r){return{tunnelRemotePort:r.tunnelRemotePort,tunnelRemoteHost:r.tunnelRemoteHost,tunnelLocalPort:r.tunnelLocalPort,localAddress:r.localAddress,privacy:r.privacy,protocol:r.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${r.tunnelRemoteHost}:${r.tunnelRemotePort} `);const u=this.d.get(r.tunnelRemoteHost);if(u){const g=u.get(r.tunnelRemotePort);g&&(g.refcount--,await this.n(r.tunnelRemoteHost,r.tunnelRemotePort,g))}}}}async n(r,u,g){if(g.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${r}:${u}.`);const p=g.value.then(async y=>{y&&(await y.dispose(!0),this.b.fire({host:y.tunnelRemoteHost,port:y.tunnelRemotePort}))});return this.d.has(r)&&this.d.get(r).delete(u),p}}async closeTunnel(r,u){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${r}:${u} `);const g=this.d.get(r);if(g&&g.has(u)){const p=g.get(u);p.refcount=0,await this.n(r,u,p)}}o(r,u,g){this.d.has(r)||this.d.set(r,new Map),this.d.get(r).set(u,{refcount:1,value:g})}async p(r,u){const g=this.d.get(r);g&&(await g.get(u)||g.delete(u),g.size===0&&this.d.delete(r))}q(r,u){const g=[r];m(r)?(g.push(...e.LOCALHOST_ADDRESSES),g.push(...e.ALL_INTERFACES_ADDRESSES)):v(r)&&g.push(...e.ALL_INTERFACES_ADDRESSES);const p=g.map(y=>this.d.get(y));for(const y of p){const D=y?.get(u);if(D)return D}}canTunnel(r){return!!c(r)}s(r,u,g,p,y,D,t){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${g} on local port ${p}.`);const a=g;this.h.add(a);const i=p===void 0?g:p,s={elevationRequired:y?this.isPortPrivileged(i):!1},n={remoteAddress:{host:u,port:g},localAddressPort:p,privacy:D,public:D?D!==k.Private:void 0,protocol:t},h=r.forwardPort(n,s);return h?(this.o(u,g,h),h.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(a)})):this.h.delete(a),h}};S=ye([Z(0,A.ILogService),Z(1,L.IConfigurationService)],S),e.AbstractTunnelService=S}),define(ee[49],te([0,1,6]),function(G,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var L;(function(A){A.Uninitialized="uninitialized",A.Idle="idle",A.CheckingForUpdates="checking for updates",A.AvailableForDownload="available for download",A.Downloading="downloading",A.Downloaded="downloaded",A.Updating="updating",A.Ready="ready"})(L=e.StateType||(e.StateType={}));var o;(function(A){A[A.Setup=0]="Setup",A[A.Archive=1]="Archive",A[A.Snap=2]="Snap"})(o=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(A,M)=>({type:"idle",updateType:A,error:M}),CheckingForUpdates:A=>({type:"checking for updates",explicit:A}),AvailableForDownload:A=>({type:"available for download",update:A}),Downloading:A=>({type:"downloading",update:A}),Downloaded:A=>({type:"downloaded",update:A}),Updating:A=>({type:"updating",update:A}),Ready:A=>({type:"ready",update:A})},e.IUpdateService=(0,P.createDecorator)("updateService")}),define(ee[246],te([0,1,4,181,68,51]),function(G,e,P,L,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),A.Registry.as(o.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,L.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,L.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,L.localize)(2,null),(0,L.localize)(3,null),(0,L.localize)(4,null),(0,L.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,L.localize)(6,null),deprecationMessage:(0,L.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,L.localize)(8,null),description:(0,L.localize)(9,null),included:P.isWindows&&!P.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,L.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(ee[247],te([0,1,3,49]),function(G,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class o{constructor(k){this.a=k}listen(k,f){switch(f){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${f}`)}call(k,f,c){switch(f){case"checkForUpdates":return this.a.checkForUpdates(c);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(c)}throw new Error(`Call not found: ${f}`)}}e.UpdateChannel=o;class A{get state(){return this.b}set state(k){this.b=k,this.a.fire(k)}constructor(k){this.c=k,this.a=new P.Emitter,this.onStateChange=this.a.event,this.b=L.State.Uninitialized,this.c.listen("onStateChange")(f=>this.state=f),this.c.call("_getInitialState").then(f=>this.state=f)}checkForUpdates(k){return this.c.call("checkForUpdates",k)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(k){return this.c.call("_applySpecificUpdate",k)}}e.UpdateChannelClient=A}),define(ee[39],te([0,1,6]),function(G,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,P.createDecorator)("IUriIdentityService")}),define(ee[248],te([0,1,39,201,16,18,132,3,2]),function(G,e,P,L,o,A,M,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class c{constructor(b){this.uri=b,this.time=c._clock++}touch(){return this.time=c._clock++,this}}c._clock=0;let m=class{constructor(b){this.g=b,this.c=new f.DisposableStore,this.f=2**16;const d=new Map,S=w=>{let r=d.get(w.scheme);return r===void 0&&(r=b.hasProvider(w)&&!this.g.hasCapability(w,1024),d.set(w.scheme,r)),r};this.c.add(k.Event.any(b.onDidChangeFileSystemProviderRegistrations,b.onDidChangeFileSystemProviderCapabilities)(w=>{d.delete(w.scheme)})),this.extUri=new A.ExtUri(S),this.d=new M.SkipList((w,r)=>this.extUri.compare(w,r,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(b){this.g.hasProvider(b)&&(b=(0,A.normalizePath)(b));const d=this.d.get(b);return d?d.touch().uri.with({fragment:b.fragment}):(this.d.set(b,new c(b)),this.h(),b)}h(){if(this.d.size<this.f)return;const b=[...this.d.entries()].sort((S,w)=>S[1].time<w[1].time?1:S[1].time>w[1].time?-1:0);c._clock=0,this.d.clear();const d=this.f*.5;for(let S=0;S<d;S++)this.d.set(b[S][0],b[S][1].touch())}};m=ye([Z(0,o.IFileService)],m),e.UriIdentityService=m,(0,L.registerSingleton)(P.IUriIdentityService,m,1)}),define(ee[121],te([0,1,6]),function(G,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,P.createDecorator)("urlService")}),define(ee[249],te([0,1,8]),function(G,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class L{constructor(k){this.a=k}listen(k,f){throw new Error(`Event not found: ${f}`)}call(k,f,c){switch(f){case"handleURL":return this.a.handleURL(P.URI.revive(c[0]),c[1])}throw new Error(`Call not found: ${f}`)}}e.URLHandlerChannel=L;class o{constructor(k){this.a=k}handleURL(k,f){return this.a.call("handleURL",[k.toJSON(),f])}}e.URLHandlerChannelClient=o;class A{constructor(k,f){this.a=k,this.b=f}async routeCall(k,f,c,m){if(f!=="handleURL")throw new Error(`Call not found: ${f}`);if(Array.isArray(c)&&c.length>0){const v=P.URI.revive(c[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",v.toString(!0)),v.query){const b=/\bwindowId=(\d+)/.exec(v.query);if(b){const d=b[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${d}"`,v.toString(!0));const S=new RegExp(`window:${d}`),w=k.connections.find(r=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",r.ctx),S.test(r.ctx)));if(w)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",v.toString(!0)),w;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",v.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",v.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(k,f,c,m)}routeEvent(k,f){throw new Error(`Event not found: ${f}`)}}e.URLHandlerRouter=A}),define(ee[250],te([0,1,7,2,8,21]),function(G,e,P,L,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class M extends L.Disposable{constructor(){super(...arguments),this.a=new Set}open(c,m){const v=[...this.a.values()];return(0,P.first)(v.map(b=>()=>b.handleURL(c,m)),void 0,!1).then(b=>b||!1)}registerHandler(c){return this.a.add(c),(0,L.toDisposable)(()=>this.a.delete(c))}}e.AbstractURLService=M;let k=class extends M{constructor(c){super(),this.b=c}create(c){let{authority:m,path:v,query:b,fragment:d}=c||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return m&&v&&v.indexOf("/")!==0&&(v=`/${v}`),o.URI.from({scheme:this.b.urlProtocol,authority:m,path:v,query:b,fragment:d})}};k=ye([Z(0,A.IProductService)],k),e.NativeURLService=k}),define(ee[251],te([0,1,15,7,3,2,4,8]),function(G,e,P,L,o,A,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;class f{constructor(m,v,b,d,S,w){if(this.f=v,this.g=w,this.a=[],this.b=0,this.c=A.Disposable.None,this.d=new A.DisposableStore,m&&(w.trace("ElectronURLListener initialUrisToHandle:",m.map(g=>g.originalUrl)),this.a=m),M.isWindows){const g=d.isBuilt?[]:[`"${d.appRoot}"`];g.push("--open-url","--"),P.app.setAsDefaultProtocolClient(S.urlProtocol,process.execPath,g)}const r=o.Event.map(o.Event.fromNodeEventEmitter(P.app,"open-url",(g,p)=>({event:g,url:p})),({event:g,url:p})=>(g.preventDefault(),p));this.d.add(r(g=>{const p=this.h(g);!p||this.f.open(p,{originalUrl:g})})),b.getWindows().filter(g=>g.isReady).length>0?(w.trace("ElectronURLListener: window is ready to handle URLs"),this.i()):(w.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),o.Event.once(b.onDidSignalReadyWindow)(this.i,this,this.d))}h(m){try{return k.URI.parse(m)}catch{return}}async i(){if(this.b++>10){this.g.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.g.trace("ElectronURLListener#flush(): flushing URLs");const m=[];for(const v of this.a)await this.f.open(v.uri,{originalUrl:v.originalUrl})?this.g.trace("ElectronURLListener#flush(): URL was handled",v.originalUrl):(this.g.trace("ElectronURLListener#flush(): URL was not yet handled",v.originalUrl),m.push(v));m.length!==0&&(this.a=m,this.c=(0,L.disposableTimeout)(()=>this.i(),500))}dispose(){this.d.dispose(),this.c.dispose()}}e.ElectronURLListener=f}),define(ee[252],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcUtilityProcessWorkerChannelName=void 0,e.ipcUtilityProcessWorkerChannelName="utilityProcessWorker"}),define(ee[253],te([0,1,6]),function(G,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,P.createDecorator)("webviewManagerService")}),define(ee[254],te([0,1,15,2,14,8]),function(G,e,P,L,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class M extends L.Disposable{constructor(){super();const f=this.b.bind(this);P.protocol.registerFileProtocol(o.Schemas.vscodeWebview,f)}b(f,c){try{const m=A.URI.parse(f.url),v=M.a.get(m.path);if(typeof v=="string"){const b=`vs/workbench/contrib/webview/browser/pre/${v}`,d=o.FileAccess.asFileUri(b);return c({path:decodeURIComponent(d.fsPath),headers:{...o.COI.getHeadersFromQuery(f.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return c({error:-10})}catch{}return c({error:-2})}}M.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]]),e.WebviewProtocolProvider=M}),define(ee[80],te([0,1,4]),function(G,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useWindowControlsOverlay=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function L(m){return!!m.workspaceUri}e.isWorkspaceToOpen=L;function o(m){return!!m.folderUri}e.isFolderToOpen=o;function A(m){return!!m.fileUri}e.isFileToOpen=A;function M(m){const v=k(m),b=m.getValue("window.menuBarVisibility");return b==="default"||v==="native"&&b==="compact"||P.isMacintosh&&P.isNative?"classic":b}e.getMenuBarVisibility=M;function k(m){if(P.isWeb)return"custom";const v=m.getValue("window");if(v){if(P.isMacintosh&&v.nativeTabs===!0||P.isMacintosh&&v.nativeFullScreen===!1)return"native";const S=v.titleBarStyle;if(S==="native"||S==="custom")return S}return P.isLinux?"native":"custom"}e.getTitleBarStyle=k;function f(m){if(!P.isWindows||P.isWeb||k(m)==="native")return!1;const v=m.getValue("window.experimental.windowControlsOverlay.enabled");return typeof v=="boolean"?v:!0}e.useWindowControlsOverlay=f;function c(m=0){return Math.pow(1.2,m)}e.zoomLevelToZoomFactor=c}),define(ee[122],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var P;(function(k){k[k.INITIAL=1]="INITIAL",k[k.LOAD=2]="LOAD",k[k.RELOAD=3]="RELOAD"})(P=e.LoadReason||(e.LoadReason={}));var L;(function(k){k[k.CLOSE=1]="CLOSE",k[k.QUIT=2]="QUIT",k[k.RELOAD=3]="RELOAD",k[k.LOAD=4]="LOAD"})(L=e.UnloadReason||(e.UnloadReason={}));const o=function(k=1){return{width:1024,height:768,mode:k}};e.defaultWindowState=o;var A;(function(k){k[k.Maximized=0]="Maximized",k[k.Normal=1]="Normal",k[k.Minimized=2]="Minimized",k[k.Fullscreen=3]="Fullscreen"})(A=e.WindowMode||(e.WindowMode={}));var M;(function(k){k[k.UNRESPONSIVE=1]="UNRESPONSIVE",k[k.PROCESS_GONE=2]="PROCESS_GONE",k[k.LOAD=3]="LOAD"})(M=e.WindowError||(e.WindowError={}))}),define(ee[30],te([0,1,6]),function(G,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,P.createDecorator)("windowsMainService");var L;(function(o){o[o.CLI=0]="CLI",o[o.DOCK=1]="DOCK",o[o.MENU=2]="MENU",o[o.DIALOG=3]="DIALOG",o[o.DESKTOP=4]="DESKTOP",o[o.API=5]="API"})(L=e.OpenContext||(e.OpenContext={}))}),define(ee[255],te([0,1,15,22,3,56,2,31,78,109,5,21,30]),function(G,e,P,L,o,A,M,k,f,c,m,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var d;(function(w){w[w.Initial=1]="Initial",w[w.StoredCredentialsUsed=2]="StoredCredentialsUsed",w[w.LoginDialogShown=3]="LoginDialogShown"})(d||(d={}));let S=class extends M.Disposable{constructor(r,u,g,p,y){super(),this.g=r,this.h=u,this.i=g,this.j=p,this.k=y,this.a=`${this.k.urlProtocol}.proxy-credentials`,this.b=void 0,this.c=d.Initial,this.f=void 0,this.l()}l(){const r=o.Event.fromNodeEventEmitter(P.app,"login",(u,g,p,y,D)=>({event:u,webContents:g,req:p,authInfo:y,callback:D}));this.D(r(this.m,this))}async m({event:r,authInfo:u,req:g,callback:p}){if(!u.isProxy)return;if(!this.b&&this.c===d.LoginDialogShown&&g.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}r.preventDefault();let y;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),y=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.n(u);try{y=await this.b}finally{this.b=void 0}}p(y?.username,y?.password)}async n(r){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const u=await this.p(r);if(u)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),u;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async p(r){this.g.trace("auth#doResolveProxyCredentials - enter",r);const u=String((0,A.hash)({scheme:r.scheme,host:r.host,port:r.port}));let g,p;try{const a=await this.i.getPassword(this.a,u);if(a){const i=JSON.parse(await this.j.decrypt(a));g=i.username,p=i.password}}catch(a){this.g.error(a)}if(this.c!==d.StoredCredentialsUsed&&typeof g=="string"&&typeof p=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=d.StoredCredentialsUsed,{username:g,password:p};const y=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!y){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${y.id} to handle proxy login`);const D={authInfo:r,username:this.f?.username??g,password:this.f?.password??p,replyChannel:`vscode:proxyAuthResponse:${(0,k.generateUuid)()}`};y.sendWhenReady("vscode:openProxyAuthenticationDialog",L.CancellationToken.None,D),this.c=d.LoginDialogShown;const t=await new Promise(a=>{const i=async(s,n,h)=>{if(n===D.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${y.id}`),y.win?.webContents.off("ipc-message",i),h){const l={username:h.username,password:h.password};try{if(h.remember){const E=await this.j.encrypt(JSON.stringify(l));await this.i.setPassword(this.a,u,E)}else await this.i.deletePassword(this.a,u)}catch(E){this.g.error(E)}a({username:l.username,password:l.password})}else a(void 0)};y.win?.webContents.on("ipc-message",i)});return this.f=t,t}};S=ye([Z(0,m.ILogService),Z(1,b.IWindowsMainService),Z(2,f.ICredentialsMainService),Z(3,c.IEncryptionMainService),Z(4,v.IProductService)],S),e.ProxyAuthHandler=S}),define(ee[256],te([0,1,78,5,34,21,30,213]),function(G,e,P,L,o,A,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsNativeMainService=void 0;let f=class extends k.BaseCredentialsMainService{constructor(m,v,b,d){super(m),this.n=v,this.p=b,this.q=d,this.j=S=>{this.q.sendToFocused("vscode:showCredentialsError",S.message??S)}}async getSecretStoragePrefix(){return Promise.resolve(this.p.urlProtocol)}async i(){if(this.f)return this.f;if(this.n.disableKeytar)return this.h.info("Keytar is disabled. Using in-memory credential store instead."),this.f=new P.InMemoryCredentialsProvider,this.f;const m=await new Promise((v,b)=>{G(["keytar"],v,b)});return await m.findCredentials("test-keytar-loads"),this.f=m,this.f}};f=ye([Z(0,L.ILogService),Z(1,o.INativeEnvironmentService),Z(2,A.IProductService),Z(3,M.IWindowsMainService)],f),e.CredentialsNativeMainService=f}),define(ee[257],te([0,1,15,27,4,8,23,19,62,6,5,121,30]),function(G,e,P,L,o,A,M,k,f,c,m,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,c.createDecorator)(e.ID);let d=class{constructor(w,r,u,g){this.a=w,this.b=r,this.c=u,this.d=g}async start(w,r){this.a.trace("Received data from other instance: ",w,r),o.isMacintosh&&P.app.focus({steal:!0});const u=this.e(w);if(u.length){let g=Promise.resolve();if(this.b.getWindowCount()===0){const p=(0,L.firstOrDefault)(await this.b.openEmptyWindow({context:4}));p&&(g=p.ready())}g.then(()=>{for(const{uri:p,originalUrl:y}of u)this.c.open(p,{originalUrl:y})})}else return this.f(w,r)}e(w){return w["open-url"]&&w._urls&&w._urls.length>0?(0,L.coalesce)(w._urls.map(r=>{try{return{uri:A.URI.parse(r),originalUrl:r}}catch{return null}})):[]}async f(w,r){const u=(0,f.isLaunchedFromCli)(r)?0:4;let g=[];const p=w.wait&&w.waitMarkerFilePath?A.URI.file(w.waitMarkerFilePath):void 0,y=w.remote||void 0,D={context:u,cli:w,userEnv:r,waitMarkerFileURI:p,remoteAuthority:y,forceProfile:w.profile,forceTempProfile:w["profile-temp"]};if(w.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(w.extensionDevelopmentPath,D);else if(!w._.length&&!w["folder-uri"]&&!w["file-uri"]){let t=!1;if(w["new-window"]||w["unity-launch"]||D.forceProfile||D.forceTempProfile)t=!0;else if(w["reuse-window"])t=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!o.isMacintosh}if(t)g=await this.b.open({...D,forceNewWindow:!0,forceEmpty:!0});else{const a=this.b.getLastActiveWindow();a?(this.b.openExistingWindow(a,D),g=[a]):g=await this.b.open({...D,forceEmpty:!0})}}else g=await this.b.open({...D,forceNewWindow:w["new-window"],preferNewWindow:!w["reuse-window"]&&!w.wait,forceReuseWindow:w["reuse-window"],diffMode:w.diff,mergeMode:w.merge,addMode:w.add,noRecentEntry:!!w["skip-add-to-recently-opened"],gotoLineMode:w.goto});if(p&&g.length===1&&g[0])return Promise.race([g[0].whenClosedOrLoaded,(0,M.whenDeleted)(p.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};d=ye([Z(0,m.ILogService),Z(1,b.IWindowsMainService),Z(2,v.IURLService),Z(3,k.IConfigurationService)],d),e.LaunchMainService=d}),define(ee[258],te([0,1,15,3,2,254,30]),function(G,e,P,L,o,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let k=class extends o.Disposable{constructor(c){super(),this.b=c,this.a=this.D(new L.Emitter),this.onFoundInFrame=this.a.event,this.D(new A.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(c,m){let v;if(typeof c.windowId=="number"){const{windowId:b}=c,d=this.b.getWindowById(b);if(!d?.win)throw new Error(`Invalid windowId: ${b}`);v=d.win.webContents}else{const{webContentsId:b}=c;if(v=P.webContents.fromId(b),!v)throw new Error(`Invalid webContentsId: ${b}`)}v.isDestroyed()||v.setIgnoreMenuShortcuts(m)}async findInFrame(c,m,v,b){const S=this.c(c,m);if(typeof S.findInFrame=="function"){S.findInFrame(v,{findNext:b.findNext,forward:b.forward});const w=(r,u)=>{u.finalUpdate&&(this.a.fire(u),S.removeListener("found-in-frame",w))};S.on("found-in-frame",w)}}async stopFindInFrame(c,m,v){const d=this.c(c,m);typeof d.stopFindInFrame=="function"&&d.stopFindInFrame(v.keepSelection?"keepSelection":"clearSelection")}c(c,m){const v=this.b.getWindowById(c.windowId);if(!v?.win)throw new Error(`Invalid windowId: ${c}`);const b=v.win.webContents.mainFrame.framesInSubtree.find(d=>d.name===m);if(!b)throw new Error(`Unknown frame: ${m}`);return b}};k=ye([Z(0,M.IWindowsMainService)],k),e.WebviewMainService=k}),define(ee[259],te([0,1,7,3,2]),function(G,e,P,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class A extends o.Disposable{constructor({onDidOpenWindow:k,onDidFocusWindow:f,getActiveWindowId:c}){super(),this.a=this.D(new o.DisposableStore),L.Event.latch(L.Event.any(k,f))(this.f,this,this.a),this.b=(0,P.createCancelablePromise)(()=>c()),(async()=>{try{const v=await this.b;this.c=typeof this.c=="number"?this.c:v}catch{}finally{this.b=void 0}})()}f(k){this.b&&(this.b.cancel(),this.b=void 0),this.c=k}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.ActiveWindowManager=A}),define(ee[28],te([0,1,185,9,61,18,8,6,14]),function(G,e,P,L,o,A,M,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,k.createDecorator)("contextService");function c(s){const n=s;return typeof n?.id=="string"&&M.URI.isUri(n.uri)}e.isSingleFolderWorkspaceIdentifier=c;function m(s){return typeof s?.id=="string"&&!c(s)&&!b(s)}e.isEmptyWorkspaceIdentifier=m,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function v(s,n){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,L.basename)(s)}:n?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const h=s;return h.configuration?{id:h.id,configPath:h.configuration}:h.folders.length===1?{id:h.id,uri:h.folders[0].uri}:{id:h.id}}e.toWorkspaceIdentifier=v;function b(s){const n=s;return typeof n?.id=="string"&&M.URI.isUri(n.configPath)}e.isWorkspaceIdentifier=b;function d(s){const n=s;if(n?.uri)return{id:n.id,uri:M.URI.revive(n.uri)};const h=s;if(h?.configPath)return{id:h.id,configPath:M.URI.revive(h.configPath)};if(s?.id)return{id:s.id}}e.reviveIdentifier=d;var S;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(S=e.WorkbenchState||(e.WorkbenchState={}));function w(s){const n=s;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.isWorkspace=w;function r(s){const n=s;return!!(n&&typeof n=="object"&&M.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.isWorkspaceFolder=r;class u{constructor(n,h,l,E,R){this.h=n,this.j=l,this.k=E,this.l=R,this.c=o.TernarySearchTree.forUris(this.l,()=>!0),this.folders=h}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=o.TernarySearchTree.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=u;class g{constructor(n,h){this.raw=h,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,A.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=g;function p(s){return new g({uri:s,index:0,name:(0,A.basenameOrAuthority)(s)},{uri:s.toString()})}e.toWorkspaceFolder=p,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,P.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function y(s,n){return A.extUriBiasedIgnorePathCase.isEqualOrParent(s,n.untitledWorkspacesHome)}e.isUntitledWorkspace=y;function D(s){let n;return M.URI.isUri(s)?n=s:n=s.configuration,n?.scheme===f.Schemas.tmp}e.isTemporaryWorkspace=D,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(s){return s.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=t;function a(s,n){return!y(s,n)&&!D(s)}e.isSavedWorkspace=a;function i(s){return(typeof s=="string"?(0,L.extname)(s):(0,A.extname)(s))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=i}),define(ee[58],te([0,1,15,7,56,45,2,83,4,11,23,162,88,6,5,21,28]),function(G,e,P,L,o,A,M,k,f,c,m,v,b,d,S,w,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,d.createDecorator)("dialogMainService");let u=class{constructor(p,y){this.d=p,this.e=y,this.a=new Map,this.b=new Map,this.c=new L.Queue}pickFileFolder(p,y){return this.f({...p,pickFolders:!0,pickFiles:!0,title:(0,v.localize)(0,null)},y)}pickFolder(p,y){return this.f({...p,pickFolders:!0,title:(0,v.localize)(1,null)},y)}pickFile(p,y){return this.f({...p,pickFiles:!0,title:(0,v.localize)(2,null)},y)}pickWorkspace(p,y){const D=(0,v.localize)(3,null),t=(0,A.mnemonicButtonLabel)((0,v.localize)(4,null)),a=r.WORKSPACE_FILTER;return this.f({...p,pickFiles:!0,title:D,filters:a,buttonLabel:t},y)}async f(p,y){const D={title:p.title,buttonLabel:p.buttonLabel,filters:p.filters,defaultPath:p.defaultPath};(typeof p.pickFiles=="boolean"||typeof p.pickFolders=="boolean")&&(D.properties=void 0,p.pickFiles&&p.pickFolders&&(D.properties=["multiSelections","openDirectory","openFile","createDirectory"])),D.properties||(D.properties=["multiSelections",p.pickFolders?"openDirectory":"openFile","createDirectory"]),f.isMacintosh&&D.properties.push("treatPackageAsDirectory");const t=await this.showOpenDialog(D,(0,c.withNullAsUndefined)(y||P.BrowserWindow.getFocusedWindow()));if(t&&t.filePaths&&t.filePaths.length>0)return t.filePaths}g(p){if(p){let y=this.b.get(p.id);return y||(y=new L.Queue,this.b.set(p.id,y)),y}else return this.c}showMessageBox(p,y){return this.g(y).queue(async()=>{const{options:D,buttonIndeces:t}=(0,b.massageMessageBoxOptions)(p,this.e);let a;return y?a=await P.dialog.showMessageBox(y,D):a=await P.dialog.showMessageBox(D),{response:t[a.response],checkboxChecked:a.checkboxChecked}})}async showSaveDialog(p,y){const D=this.j(p,y);if(!D)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.g(y).queue(async()=>{let t;return y?t=await P.dialog.showSaveDialog(y,p):t=await P.dialog.showSaveDialog(p),t.filePath=this.h(t.filePath),t})}finally{(0,M.dispose)(D)}}h(p){return p&&f.isMacintosh&&(p=(0,k.normalizeNFC)(p)),p}i(p){return p.map(y=>this.h(y))}async showOpenDialog(p,y){p.defaultPath&&(await m.Promises.exists(p.defaultPath)||(p.defaultPath=void 0));const D=this.j(p,y);if(!D)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(y).queue(async()=>{let t;return y?t=await P.dialog.showOpenDialog(y,p):t=await P.dialog.showOpenDialog(p),t.filePaths=this.i(t.filePaths),t})}finally{(0,M.dispose)(D)}}j(p,y){if(!y)return M.Disposable.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",p);let D=this.a.get(y.id);D||(D=new Set,this.a.set(y.id,D));const t=(0,o.hash)(p);if(!D.has(t))return this.d.trace("[DialogMainService]: new file dialog lock created",p),D.add(t),(0,M.toDisposable)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",p),D?.delete(t),D?.size===0&&this.a.delete(y.id)})}};u=ye([Z(0,S.ILogService),Z(1,w.IProductService)],u),e.DialogMainService=u}),define(ee[260],te([0,1,3,2,84,28]),function(G,e,P,L,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class M extends L.Disposable{constructor(f,c){super(),this.f=f,this.g=c,this.b=this.D(new P.Emitter),this.c=new Map,this.h(c.applicationStorage,this.b)}h(f,c){this.D(P.Event.debounce(f.onDidChangeStorage,(m,v)=>(m?m.push(v):m=[v],m),M.a)(m=>{m.length&&c.fire(this.i(m,f))}))}i(f,c){const m=new Map,v=new Set;return f.forEach(b=>{const d=c.get(b.key);typeof d=="string"?m.set(b.key,d):v.add(b.key)}),{changed:Array.from(m.entries()),deleted:Array.from(v.values())}}listen(f,c,m){switch(c){case"onDidChangeStorage":{const v=m.profile?(0,o.revive)(m.profile):void 0;if(!v)return this.b.event;let b=this.c.get(v.id);return b||(b=this.D(new P.Emitter),this.h(this.g.profileStorage(v),b),this.c.set(v.id,b)),b.event}}throw new Error(`Event not found: ${c}`)}async call(f,c,m){const v=m.profile?(0,o.revive)(m.profile):void 0,b=(0,A.reviveIdentifier)(m.workspace),d=await this.j(v,b);switch(c){case"getItems":return Array.from(d.items.entries());case"updateItems":{const S=m;if(S.insert)for(const[w,r]of S.insert)d.set(w,r);S.delete?.forEach(w=>d.delete(w));break}case"isUsed":{const S=m.payload;if(typeof S=="string")return this.g.isUsed(S)}default:throw new Error(`Call not found: ${c}`)}}async j(f,c){let m;c?m=this.g.workspaceStorage(c):f?m=this.g.profileStorage(f):m=this.g.applicationStorage;try{await m.init()}catch(v){this.f.error(`StorageIPC#init: Unable to init ${c?"workspace":f?"profile":"application"} storage due to ${v}`)}return m}}M.a=100,e.StorageDatabaseChannel=M}),define(ee[40],te([0,1,56,3,2,18,8,182,34,16,6,5,28,35,39,7,31,26,11]),function(G,e,P,L,o,A,M,k,f,c,m,v,b,d,S,w,r,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=void 0;function p(i){const s=i;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&M.URI.isUri(s.location)&&M.URI.isUri(s.globalStorageHome)&&M.URI.isUri(s.settingsResource)&&M.URI.isUri(s.keybindingsResource)&&M.URI.isUri(s.tasksResource)&&M.URI.isUri(s.snippetsHome)&&M.URI.isUri(s.extensionsResource))}e.isUserDataProfile=p,e.IUserDataProfilesService=(0,m.createDecorator)("IUserDataProfilesService");function y(i,s){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,location:M.URI.revive(i.location).with({scheme:s}),globalStorageHome:M.URI.revive(i.globalStorageHome).with({scheme:s}),settingsResource:M.URI.revive(i.settingsResource).with({scheme:s}),keybindingsResource:M.URI.revive(i.keybindingsResource).with({scheme:s}),tasksResource:M.URI.revive(i.tasksResource).with({scheme:s}),snippetsHome:M.URI.revive(i.snippetsHome).with({scheme:s}),extensionsResource:M.URI.revive(i.extensionsResource)?.with({scheme:s}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.reviveProfile=y;function D(i,s,n,h){return{id:i,name:s,location:n,isDefault:!1,shortName:h?.shortName,globalStorageHome:(0,A.joinPath)(n,"globalStorage"),settingsResource:(0,A.joinPath)(n,"settings.json"),keybindingsResource:(0,A.joinPath)(n,"keybindings.json"),tasksResource:(0,A.joinPath)(n,"tasks.json"),snippetsHome:(0,A.joinPath)(n,"snippets"),extensionsResource:(0,A.joinPath)(n,"extensions.json"),useDefaultFlags:h?.useDefaultFlags,isTransient:h?.transient}}e.toUserDataProfile=D;let t=class extends o.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.t.profiles,...this.l.profiles]}constructor(s,n,h,l){super(),this.m=s,this.n=n,this.q=h,this.r=l,this.f=!0,this.g=this.D(new L.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.D(new L.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.D(new L.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.D(new L.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new d.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,A.joinPath)(this.m.userRoamingDataHome,"profiles")}init(){this.s=void 0}setEnablement(s){this.f!==s&&(this.s=void 0,this.f=s)}isEnabled(){return this.f}get t(){if(!this.s){const s=[];if(this.f)try{for(const E of this.I()){if(!E.name||!(0,g.isString)(E.name)||!E.location){this.r.warn("Skipping the invalid stored profile",E.location||E.name);continue}s.push(D((0,A.basename)(E.location),E.name,E.location,{shortName:E.shortName,useDefaultFlags:E.useDefaultFlags}))}}catch(E){this.r.error(E)}const n=new d.ResourceMap,h=new Map,l=this.u();if(s.unshift({...l,extensionsResource:this.N()??l.extensionsResource,isDefault:!0}),s.length)try{const E=this.L();if(E.workspaces)for(const[R,C]of Object.entries(E.workspaces)){const T=M.URI.parse(R),N=s.find(z=>z.id===C);N&&n.set(T,N)}if(E.emptyWindows)for(const[R,C]of Object.entries(E.emptyWindows)){const T=s.find(N=>N.id===C);T&&h.set(R,T)}}catch(E){this.r.error(E)}this.s={profiles:s,workspaces:n,emptyWindows:h}}return this.s}u(){return D("__default__profile__",(0,k.localize)(0,null),this.m.userRoamingDataHome)}async createTransientProfile(s){const n="Temp",h=new RegExp(`${(0,u.escapeRegExpCharacters)(n)}\\s(\\d+)`);let l=0;for(const R of this.profiles){const C=h.exec(R.name),T=C?parseInt(C[1]):0;l=T>l?T:l}const E=`${n} ${l+1}`;return this.createProfile((0,P.hash)((0,r.generateUuid)()).toString(16),E,{transient:!0},s)}async createNamedProfile(s,n,h){return this.createProfile((0,P.hash)((0,r.generateUuid)()).toString(16),s,n,h)}async createProfile(s,n,h,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const E=await this.v(s,n,h);return l&&await this.setProfileForWorkspace(l,E),E}async v(s,n,h){if(!(0,g.isString)(n)||!n)throw new Error("Name of the profile is mandatory and must be of type `string`");let l=this.k.get(n);return l||(l=(async()=>{try{const E=this.profiles.find(T=>T.name===n||T.id===s);if(E)return E;const R=D(s,n,(0,A.joinPath)(this.profilesHome,s),h);await this.n.createFolder(R.location);const C=[];return this.h.fire({profile:R,join(T){C.push(T)}}),await w.Promises.settled(C),this.z([R],[],[]),R}finally{this.k.delete(n)}})(),this.k.set(n,l)),l}async updateProfile(s,n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let h=this.profiles.find(l=>l.id===s.id);if(!h)throw new Error(`Profile '${s.name}' does not exist`);return h=D(h.id,n.name??h.name,h.location,{shortName:n.shortName??h.shortName,transient:n.transient??h.isTransient,useDefaultFlags:n.useDefaultFlags??h.useDefaultFlags}),this.z([],[],[h]),h}async removeProfile(s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const n=this.profiles.find(l=>l.id===s.id);if(!n)throw new Error(`Profile '${s.name}' does not exist`);const h=[];this.i.fire({profile:n,join(l){h.push(l)}});try{await Promise.allSettled(h)}catch(l){this.r.error(l)}for(const l of[...this.t.emptyWindows.keys()])n.id===this.t.emptyWindows.get(l)?.id&&this.t.emptyWindows.delete(l);for(const l of[...this.t.workspaces.keys()])n.id===this.t.workspaces.get(l)?.id&&this.t.workspaces.delete(l);this.G(),this.z([],[n],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(n.location,{recursive:!0})}catch(l){this.r.error(l)}}async setProfileForWorkspace(s,n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const h=this.profiles.find(l=>l.id===n.id);if(!h)throw new Error(`Profile '${n.name}' does not exist`);this.F(s,h)}unsetWorkspace(s,n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.F(s,void 0,n)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindows.clear(),this.t.workspaces.clear(),this.t.emptyWindows.clear(),this.G(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const s=await this.n.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(n=>n.isDirectory&&this.profiles.every(h=>!this.q.extUri.isEqual(h.location,n.resource))).map(n=>this.n.del(n.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.l.profiles.filter(n=>!this.y(n));await Promise.allSettled(s.map(n=>this.removeProfile(n)))}getProfileForWorkspace(s){const n=this.w(s);return M.URI.isUri(n)?this.l.workspaces.get(n)??this.t.workspaces.get(n):this.l.emptyWindows.get(n)??this.t.emptyWindows.get(n)}w(s){return(0,b.isSingleFolderWorkspaceIdentifier)(s)?s.uri:(0,b.isWorkspaceIdentifier)(s)?s.configPath:s.id}y(s){return!!([...this.l.emptyWindows.values()].some(n=>this.q.extUri.isEqual(n.location,s.location))||[...this.l.workspaces.values()].some(n=>this.q.extUri.isEqual(n.location,s.location))||[...this.t.emptyWindows.values()].some(n=>this.q.extUri.isEqual(n.location,s.location))||[...this.t.workspaces.values()].some(n=>this.q.extUri.isEqual(n.location,s.location)))}z(s,n,h){const l=[...this.profiles,...s],E=[];this.l.profiles=[];for(let R of l)R.isDefault||n.some(C=>R.id===C.id)||(R=h.find(C=>R.id===C.id)??R,R.isTransient?this.l.profiles.push(R):E.push({location:R.location,name:R.name,shortName:R.shortName,useDefaultFlags:R.useDefaultFlags}));this.J(E),this.s=void 0,this.C(s,n,h)}C(s,n,h){this.g.fire({added:s,removed:n,updated:h,all:this.profiles})}F(s,n,h){h=n?.isTransient?!0:h,h||this.F(s,void 0,!0);const l=this.w(s),E=h?this.l:this.t;M.URI.isUri(l)?(E.workspaces.delete(l),n&&E.workspaces.set(l,n)):(E.emptyWindows.delete(l),n&&E.emptyWindows.set(l,n)),h||this.G()}G(){const s={};for(const[h,l]of this.t.workspaces.entries())s[h.toString()]=l.id;const n={};for(const[h,l]of this.t.emptyWindows.entries())n[h.toString()]=l.id;this.M({workspaces:s,emptyWindows:n}),this.s=void 0}H(s){const n={},h=this.u();if(s.workspaces)for(const[E,R]of Object.entries(s.workspaces)){const C=M.URI.parse(R);n[E]=this.q.extUri.isEqual(C,h.location)?h.id:this.q.extUri.basename(C)}const l={};if(s.emptyWindows)for(const[E,R]of Object.entries(s.emptyWindows)){const C=M.URI.parse(R);l[E]=this.q.extUri.isEqual(C,h.location)?h.id:this.q.extUri.basename(C)}return{workspaces:n,emptyWindows:l}}I(){return[]}J(s){throw new Error("not implemented")}L(){return{}}M(s){throw new Error("not implemented")}N(){}};t.b="userDataProfiles",t.c="profileAssociations",t=ye([Z(0,f.IEnvironmentService),Z(1,c.IFileService),Z(2,S.IUriIdentityService),Z(3,v.ILogService)],t),e.UserDataProfilesService=t;class a extends t{constructor(){super(...arguments),this.a=[],this.Q={}}I(){return this.a}J(s){this.a=s}L(){return this.Q}M(s){this.Q=s}}e.InMemoryUserDataProfilesService=a}),define(ee[81],te([0,1,7,17,2,3,35,8,110,117,16,6,5,40,39,11,13,24]),function(G,e,P,L,o,A,M,k,f,c,m,v,b,d,S,w,r,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var g;(function(a){a.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",a.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(g=e.ExtensionsProfileScanningErrorCode||(e.ExtensionsProfileScanningErrorCode={}));class p extends Error{constructor(i,s){super(i),this.code=s}}e.ExtensionsProfileScanningError=p,e.IExtensionsProfileScannerService=(0,v.createDecorator)("IExtensionsProfileScannerService");let y=class extends o.Disposable{constructor(i,s,n,h,l,E){super(),this.i=i,this.j=s,this.k=n,this.l=h,this.m=l,this.n=E,this.b=this.D(new A.Emitter),this.onAddExtensions=this.b.event,this.c=this.D(new A.Emitter),this.onDidAddExtensions=this.c.event,this.f=this.D(new A.Emitter),this.onRemoveExtensions=this.f.event,this.g=this.D(new A.Emitter),this.onDidRemoveExtensions=this.g.event,this.h=new M.ResourceMap}scanProfileExtensions(i,s){return this.p(i,void 0,s)}async addExtensionsToProfile(i,s){const n=[],h=[];try{return await this.p(s,l=>{const E=[];for(const R of l)i.some(([C])=>(0,c.areSameExtensions)(C.identifier,R.identifier)&&C.manifest.version!==R.version)?n.push(R):E.push(R);for(const[R,C]of i)if(!E.some(T=>(0,c.areSameExtensions)(T.identifier,R.identifier)&&T.version===R.manifest.version)){const T={identifier:R.identifier,version:R.manifest.version,location:R.location,metadata:C};h.push(T),E.push(T)}return h.length&&this.b.fire({extensions:h,profileLocation:s}),n.length&&this.f.fire({extensions:n,profileLocation:s}),E}),h.length&&this.c.fire({extensions:h,profileLocation:s}),n.length&&this.g.fire({extensions:n,profileLocation:s}),h}catch(l){throw h.length&&this.c.fire({extensions:h,error:l,profileLocation:s}),n.length&&this.g.fire({extensions:n,error:l,profileLocation:s}),l}}async updateMetadata(i,s){const n=[];return await this.p(s,h=>{const l=[];for(const E of h){const R=i.find(([C])=>(0,c.areSameExtensions)(C.identifier,E.identifier)&&C.manifest.version===E.version);R&&(E.metadata={...E.metadata,...R[1]},n.push(E)),l.push(E)}return l}),n}async removeExtensionFromProfile(i,s){const n=[];this.f.fire({extensions:n,profileLocation:s});try{await this.p(s,h=>{const l=[];for(const E of h)(0,c.areSameExtensions)(E.identifier,i.identifier)?n.push(E):l.push(E);return n.length&&this.f.fire({extensions:n,profileLocation:s}),l}),n.length&&this.g.fire({extensions:n,profileLocation:s})}catch(h){throw n.length&&this.g.fire({extensions:n,error:h,profileLocation:s}),h}}async p(i,s,n){return this.v(i).queue(async()=>{let h=[],l;try{const E=await this.j.readFile(i);l=JSON.parse(E.value.toString().trim()||"[]")}catch(E){if((0,m.toFileOperationResult)(E)!==1)throw E;if(this.l.extUri.isEqual(i,this.k.defaultProfile.extensionsResource)&&(l=await this.u()),!l&&n?.bailOutWhenFileNotFound)throw new p((0,r.getErrorMessage)(E),"ERROR_PROFILE_NOT_FOUND")}if(l){Array.isArray(l)||this.q(i);let E=!1;for(const R of l){D(R)||this.q(i);let C;if((0,w.isString)(R.relativeLocation)&&R.relativeLocation)C=this.s(R.relativeLocation);else if((0,w.isString)(R.location))C=this.s(R.location),E=!0,R.relativeLocation=R.location,R.location=C.toJSON();else{C=k.URI.revive(R.location);const T=this.r(C);T&&(E=!0,R.relativeLocation=T)}h.push({identifier:R.identifier,location:C,version:R.version,metadata:R.metadata})}E&&await this.j.writeFile(i,L.VSBuffer.fromString(JSON.stringify(l)))}if(s){h=s(h);const E=h.map(R=>({identifier:R.identifier,version:R.version,location:R.location.toJSON(),relativeLocation:this.r(R.location),metadata:R.metadata}));await this.j.writeFile(i,L.VSBuffer.fromString(JSON.stringify(E)))}return h})}q(i){const s=new p(`Invalid extensions content in ${i.toString()}`,"ERROR_INVALID_CONTENT");throw this.m.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}r(i){return this.l.extUri.isEqual(this.l.extUri.dirname(i),this.i)?this.l.extUri.basename(i):void 0}s(i){return this.l.extUri.joinPath(this.i,i)}async u(){return this.t||(this.t=(async()=>{const i=this.l.extUri.joinPath(this.k.defaultProfile.location,"extensions.json"),s=this.l.extUri.joinPath(this.i,".init-default-profile-extensions");let n;try{n=(await this.j.readFile(i)).value.toString()}catch(l){if((0,m.toFileOperationResult)(l)===1)return;throw l}this.n.info("Migrating extensions from old default profile location",i.toString());let h;try{const l=JSON.parse(n);Array.isArray(l)&&l.every(E=>D(E))?h=l:this.n.warn("Skipping migrating from old default profile locaiton: Found invalid data",l)}catch(l){this.n.error(l)}if(h)try{await this.j.createFile(this.k.defaultProfile.extensionsResource,L.VSBuffer.fromString(JSON.stringify(h)),{overwrite:!1}),this.n.info("Migrated extensions from old default profile location to new location",i.toString(),this.k.defaultProfile.extensionsResource.toString())}catch(l){if((0,m.toFileOperationResult)(l)===3)this.n.info("Migration from old default profile location to new location is done by another window",i.toString(),this.k.defaultProfile.extensionsResource.toString());else throw l}try{await this.j.del(i)}catch(l){(0,m.toFileOperationResult)(l)!==1&&this.n.error(l)}try{await this.j.del(s)}catch(l){(0,m.toFileOperationResult)(l)!==1&&this.n.error(l)}return h})()),this.t}v(i){let s=this.h.get(i);return s||(s=new P.Queue,this.h.set(i,s)),s}};y=ye([Z(1,m.IFileService),Z(2,d.IUserDataProfilesService),Z(3,S.IUriIdentityService),Z(4,u.ITelemetryService),Z(5,b.ILogService)],y),e.AbstractExtensionsProfileScannerService=y;function D(a){return(0,w.isObject)(a)&&(0,f.isIExtensionIdentifier)(a.identifier)&&(t(a.location)||(0,w.isString)(a.location)&&a.location)&&((0,w.isUndefined)(a.relativeLocation)||(0,w.isString)(a.relativeLocation))&&a.version&&(0,w.isString)(a.version)}function t(a){return a?(0,w.isString)(a.path)&&(0,w.isString)(a.scheme):!1}}),define(ee[123],te([0,1,27,7,37,17,13,43,145,2,14,9,4,18,199,76,11,8,167,34,117,114,198,16,6,5,21,3,84,81,40,39,197]),function(G,e,P,L,o,A,M,k,f,c,m,v,b,d,S,w,r,u,g,p,y,D,t,a,i,s,n,h,l,E,R,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var N;(function(ce){function J(Y,q){if(Y===q)return!0;const W=Object.keys(Y),H=new Set;for(const Q of Object.keys(q))H.add(Q);if(W.length!==H.size)return!1;for(const Q of W){if(Y[Q]!==q[Q])return!1;H.delete(Q)}return H.size===0}ce.equals=J})(N=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let z=class extends c.Disposable{constructor(J,Y,q,W,H,Q,se,re,F,I,O,U){super(),this.systemExtensionsLocation=J,this.userExtensionsLocation=Y,this.l=q,this.m=W,this.n=H,this.p=Q,this.q=se,this.r=re,this.s=F,this.t=I,this.u=O,this.v=U,this.g=this.D(new h.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,d.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.D(this.v.createInstance(ne,(0,d.joinPath)(this.m,D.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.D(this.v.createInstance(ne,(0,d.joinPath)(this.m,D.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.D(this.v.createInstance(_,this.h)),this.y=void 0,this.D(this.i.onDidChangeCache(()=>this.g.fire(0))),this.D(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.w||(this.w=(0,y.computeTargetPlatform)(this.q,this.r)),this.w}async scanAllExtensions(J,Y,q){const[W,H]=await Promise.all([this.scanSystemExtensions(J),this.scanUserExtensions(Y)]),Q=q?await this.scanExtensionsUnderDevelopment(J,[...W,...H]):[];return this.F(W,H,Q,await this.getTargetPlatform(),!0)}async scanSystemExtensions(J){const Y=[];Y.push(this.G(!!J.useCache,J.language)),Y.push(this.H(J.language,!!J.checkControlFile));const[q,W]=await Promise.all(Y);return this.C([...q,...W],0,J,!1)}async scanUserExtensions(J){const Y=J.profileLocation??this.userExtensionsLocation;this.r.trace("Started scanning user extensions",Y);const q=this.u.extUri.isEqual(J.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,W=await this.J(Y,!!J.profileLocation,1,!J.includeUninstalled,J.language,!0,q),H=J.useCache&&!W.devMode&&W.excludeObsolete?this.j:this.k;let Q;try{Q=await H.scanExtensions(W)}catch(se){if(se instanceof E.ExtensionsProfileScanningError&&se.code==="ERROR_PROFILE_NOT_FOUND")await this.z(),Q=await H.scanExtensions(W);else throw se}return Q=await this.C(Q,1,J,!0),this.r.trace("Scanned user extensions:",Q.length),Q}async scanExtensionsUnderDevelopment(J,Y){if(this.s.isExtensionDevelopment&&this.s.extensionDevelopmentLocationURI){const q=(await Promise.all(this.s.extensionDevelopmentLocationURI.filter(W=>W.scheme===m.Schemas.file).map(async W=>{const H=await this.J(W,!1,1,!0,J.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(H)).map(se=>(se.type=Y.find(re=>(0,y.areSameExtensions)(re.identifier,se.identifier))?.type??se.type,this.k.validate(se,H)))}))).flat();return this.C(q,"development",J,!0)}return[]}async scanExistingExtension(J,Y,q){const W=await this.J(J,!1,Y,!0,q.language,!0,void 0),H=await this.k.scanExtension(W);return!H||!q.includeInvalid&&!H.isValid?null:H}async scanOneOrMultipleExtensions(J,Y,q){const W=await this.J(J,!1,Y,!0,q.language,!0,void 0),H=await this.k.scanOneOrMultipleExtensions(W);return this.C(H,Y,q,!0)}async scanMetadata(J){const Y=(0,d.joinPath)(J,"package.json"),q=(await this.q.readFile(Y)).value.toString();return JSON.parse(q).__metadata}async updateMetadata(J,Y){const q=(0,d.joinPath)(J,"package.json"),W=(await this.q.readFile(q)).value.toString(),H=JSON.parse(W);Y.isMachineScoped=Y.isMachineScoped||void 0,Y.isBuiltin=Y.isBuiltin||void 0,H.__metadata={...H.__metadata,...Y},await this.q.writeFile((0,d.joinPath)(J,"package.json"),A.VSBuffer.fromString(JSON.stringify(H,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.p.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(J){if(J instanceof E.ExtensionsProfileScanningError&&J.code==="ERROR_PROFILE_NOT_FOUND")await this.z();else throw J}}async z(){return this.y||(this.y=(async()=>{try{this.r.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const J=await this.scanUserExtensions({includeInvalid:!0});if(J.length)await this.p.addExtensionsToProfile(J.map(Y=>[Y,Y.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.q.createFile(this.n.defaultProfile.extensionsResource,A.VSBuffer.fromString(JSON.stringify([])))}catch(Y){(0,a.toFileOperationResult)(Y)!==1&&this.r.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,M.getErrorMessage)(Y))}this.r.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(J){this.r.error(J)}finally{this.y=void 0}})()),this.y}async C(J,Y,q,W){return q.includeAllVersions||(J=this.F(Y===0?J:void 0,Y===1?J:void 0,Y==="development"?J:void 0,await this.getTargetPlatform(),W)),q.includeInvalid||(J=J.filter(H=>H.isValid)),J.sort((H,Q)=>{const se=v.basename(H.location.fsPath),re=v.basename(Q.location.fsPath);return se<re?-1:se>re?1:0})}F(J,Y,q,W,H){const Q=(re,F,I)=>{if(re.isValid&&!F.isValid)return!1;if(re.isValid===F.isValid){if(H&&S.gt(re.manifest.version,F.manifest.version))return this.r.debug(`Skipping extension ${F.location.path} with lower version ${F.manifest.version} in favour of ${re.location.path} with version ${re.manifest.version}`),!1;if(S.eq(re.manifest.version,F.manifest.version)){if(re.type===0)return this.r.debug(`Skipping extension ${F.location.path} in favour of system extension ${re.location.path} with same version`),!1;if(re.targetPlatform===W)return this.r.debug(`Skipping extension ${F.location.path} from different target platform ${F.targetPlatform}`),!1}}return I?this.r.warn(`Overwriting user extension ${re.location.path} with ${F.location.path}.`):this.r.debug(`Overwriting user extension ${re.location.path} with ${F.location.path}.`),!0},se=new D.ExtensionIdentifierMap;return J?.forEach(re=>{const F=se.get(re.identifier.id);(!F||Q(F,re,!1))&&se.set(re.identifier.id,re)}),Y?.forEach(re=>{const F=se.get(re.identifier.id);if(!F&&J&&re.type===0){this.r.debug(`Skipping obsolete system extension ${re.location.path}.`);return}(!F||Q(F,re,!1))&&se.set(re.identifier.id,re)}),q?.forEach(re=>{const F=se.get(re.identifier.id);(!F||Q(F,re,!0))&&se.set(re.identifier.id,re),se.set(re.identifier.id,re)}),[...se.values()]}async G(J,Y){this.r.trace("Started scanning system extensions");const q=await this.J(this.systemExtensionsLocation,!1,0,!0,Y,!0,void 0),H=await(J&&!q.devMode?this.i:this.k).scanExtensions(q);return this.r.trace("Scanned system extensions:",H.length),H}async H(J,Y){const q=this.s.isBuilt?[]:this.t.builtInExtensions;if(!q?.length)return[];this.r.trace("Started scanning dev system extensions");const W=Y?await this.I():{},H=[],Q=u.URI.file(v.normalize(v.join(m.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const re of q){const F=W[re.name]||"marketplace";switch(F){case"disabled":break;case"marketplace":H.push((0,d.joinPath)(Q,re.name));break;default:H.push(u.URI.file(F));break}}const se=await Promise.all(H.map(async re=>this.k.scanExtension(await this.J(re,!1,0,!0,J,!0,void 0))));return this.r.trace("Scanned dev system extensions:",se.length),(0,P.coalesce)(se)}async I(){try{const J=await this.q.readFile(this.l);return JSON.parse(J.value.toString())}catch{return{}}}async J(J,Y,q,W,H,Q,se){const re=await this.f(H??b.language),F=await this.L(J),I=Y&&!this.u.extUri.isEqual(J,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,O=I?await this.L(I):void 0;return new B(J,F,I,O,Y,se,q,W,Q,this.t.version,this.t.date,this.t.commit,!this.s.isBuilt,H,re)}async L(J){try{const Y=await this.q.stat(J);if(typeof Y.mtime=="number")return Y.mtime}catch{}}};z=ye([Z(4,R.IUserDataProfilesService),Z(5,E.IExtensionsProfileScannerService),Z(6,a.IFileService),Z(7,s.ILogService),Z(8,p.IEnvironmentService),Z(9,n.IProductService),Z(10,C.IUriIdentityService),Z(11,i.IInstantiationService)],z),e.AbstractExtensionsScannerService=z;class B{constructor(J,Y,q,W,H,Q,se,re,F,I,O,U,j,x,$){this.location=J,this.mtime=Y,this.applicationExtensionslocation=q,this.applicationExtensionslocationMtime=W,this.profile=H,this.profileScanOptions=Q,this.type=se,this.excludeObsolete=re,this.validate=F,this.productVersion=I,this.productDate=O,this.productCommit=U,this.devMode=j,this.language=x,this.translations=$}static createNlsConfiguration(J){return{language:J.language,pseudo:J.language==="pseudo",devMode:J.devMode,translations:J.translations}}static equals(J,Y){return(0,d.isEqual)(J.location,Y.location)&&J.mtime===Y.mtime&&(0,d.isEqual)(J.applicationExtensionslocation,Y.applicationExtensionslocation)&&J.applicationExtensionslocationMtime===Y.applicationExtensionslocationMtime&&J.profile===Y.profile&&o.equals(J.profileScanOptions,Y.profileScanOptions)&&J.type===Y.type&&J.excludeObsolete===Y.excludeObsolete&&J.validate===Y.validate&&J.productVersion===Y.productVersion&&J.productDate===Y.productDate&&J.productCommit===Y.productCommit&&J.devMode===Y.devMode&&J.language===Y.language&&N.equals(J.translations,Y.translations)}}e.ExtensionScannerInput=B;let _=class extends c.Disposable{constructor(J,Y,q,W,H){super(),this.f=J,this.g=Y,this.h=q,this.i=W,this.j=H}async scanExtensions(J){const Y=J.profile?await this.l(J):await this.k(J);let q={};if(J.excludeObsolete&&J.type===1)try{const W=(await this.i.readFile(this.f)).value.toString();q=JSON.parse(W)}catch{}return(0,r.isEmptyObject)(q)?Y:Y.filter(W=>!q[y.ExtensionKey.create(W).toString()])}async k(J){const Y=await this.i.resolve(J.location);if(!Y.children?.length)return[];const q=await Promise.all(Y.children.map(async W=>{if(!W.isDirectory||J.type===1&&(0,d.basename)(W.resource).indexOf(".")===0)return null;const H=new B(W.resource,J.mtime,J.applicationExtensionslocation,J.applicationExtensionslocationMtime,J.profile,J.profileScanOptions,J.type,J.excludeObsolete,J.validate,J.productVersion,J.productDate,J.productCommit,J.devMode,J.language,J.translations);return this.scanExtension(H)}));return(0,P.coalesce)(q).sort((W,H)=>W.location.path<H.location.path?-1:1)}async l(J){let Y=await this.m(J.location,()=>!0,J);if(J.applicationExtensionslocation&&!this.h.extUri.isEqual(J.location,J.applicationExtensionslocation)){Y=Y.filter(W=>!W.metadata?.isApplicationScoped);const q=await this.m(J.applicationExtensionslocation,W=>!!W.metadata?.isApplicationScoped,J);Y.push(...q)}return Y}async m(J,Y,q){const W=await this.g.scanProfileExtensions(J,q.profileScanOptions);if(!W.length)return[];const H=await Promise.all(W.map(async Q=>{if(Y(Q)){const se=new B(Q.location,q.mtime,q.applicationExtensionslocation,q.applicationExtensionslocationMtime,q.profile,q.profileScanOptions,q.type,q.excludeObsolete,q.validate,q.productVersion,q.productDate,q.productCommit,q.devMode,q.language,q.translations);return this.scanExtension(se,Q.metadata)}return null}));return(0,P.coalesce)(H)}async scanOneOrMultipleExtensions(J){try{if(await this.i.exists((0,d.joinPath)(J.location,"package.json"))){const Y=await this.scanExtension(J);return Y?[Y]:[]}else return await this.scanExtensions(J)}catch(Y){return this.j.error(`Error scanning extensions at ${J.location.path}:`,(0,M.getErrorMessage)(Y)),[]}}async scanExtension(J,Y){try{let q=await this.scanExtensionManifest(J.location);if(q){q.publisher||(q.publisher=D.UNDEFINED_PUBLISHER),Y=Y??q.__metadata,delete q.__metadata;const W=(0,y.getGalleryExtensionId)(q.publisher,q.name),H=Y?.id?{id:W,uuid:Y.id}:{id:W},Q=Y?.isSystem?0:J.type,se=Q===0||!!Y?.isBuiltin;q=await this.n(J.location,q,B.createNlsConfiguration(J));const re={type:Q,identifier:H,manifest:q,location:J.location,isBuiltin:se,targetPlatform:Y?.targetPlatform??"undefined",metadata:Y,isValid:!0,validations:[]};return J.validate?this.validate(re,J):re}}catch(q){J.type!==0&&this.j.error(q)}return null}validate(J,Y){let q=!0;const W=(0,t.validateExtensionManifest)(Y.productVersion,Y.productDate,Y.location,J.manifest,J.isBuiltin);for(const[H,Q]of W)H===w.default.Error&&(q=!1,this.j.error(this.s(Y.location,Q)));return J.isValid=q,J.validations=W,J}async scanExtensionManifest(J){const Y=(0,d.joinPath)(J,"package.json");let q;try{q=(await this.i.readFile(Y)).value.toString()}catch(H){return(0,a.toFileOperationResult)(H)!==1&&this.j.error(this.s(J,(0,g.localize)(0,null,Y.path,H.message))),null}let W;try{W=JSON.parse(q)}catch{const Q=[];(0,k.parse)(q,Q);for(const se of Q)this.j.error(this.s(J,(0,g.localize)(1,null,Y.path,se.offset,se.length,(0,f.getParseErrorMessage)(se.error))));return null}return(0,k.getNodeType)(W)!=="object"?(this.j.error(this.s(J,(0,g.localize)(2,null,Y.path))),null):W}async n(J,Y,q){const W=await this.p(J,Y,q);if(W)try{const H=[],Q=await this.q(W.default,H);if(H.length>0)return H.forEach(re=>{this.j.error(this.s(J,(0,g.localize)(3,null,W.default?.path,(0,f.getParseErrorMessage)(re.error))))}),Y;if((0,k.getNodeType)(W)!=="object")return this.j.error(this.s(J,(0,g.localize)(4,null,W.default?.path))),Y;const se=W.values||Object.create(null);return(0,T.localizeManifest)(Y,se,Q)}catch{}return Y}async p(J,Y,q){const W=(0,d.joinPath)(J,"package.nls.json"),H=(F,I)=>{I.forEach(O=>{this.j.error(this.s(J,(0,g.localize)(5,null,F?.path,(0,f.getParseErrorMessage)(O.error))))})},Q=F=>{this.j.error(this.s(J,(0,g.localize)(6,null,F?.path)))},se=`${Y.publisher}.${Y.name}`,re=q.translations[se];if(re)try{const F=u.URI.file(re),I=(await this.i.readFile(F)).value.toString(),O=[],U=(0,k.parse)(I,O);return O.length>0?(H(F,O),{values:void 0,default:W}):(0,k.getNodeType)(U)!=="object"?(Q(F),{values:void 0,default:W}):{values:U.contents?U.contents.package:void 0,default:W}}catch{return{values:void 0,default:W}}else{if(!await this.i.exists(W))return;let I;try{I=await this.r(J,q)}catch{return}if(!I.localized)return{values:void 0,default:I.original};try{const O=(await this.i.readFile(I.localized)).value.toString(),U=[],j=(0,k.parse)(O,U);return U.length>0?(H(I.localized,U),{values:void 0,default:I.original}):(0,k.getNodeType)(j)!=="object"?(Q(I.localized),{values:void 0,default:I.original}):{values:j,default:I.original}}catch{return{values:void 0,default:I.original}}}}async q(J,Y){if(J)try{const q=(await this.i.readFile(J)).value.toString();return(0,k.parse)(q,Y)}catch{}}r(J,Y){return new Promise((q,W)=>{const H=Q=>{const se=(0,d.joinPath)(J,`package.nls.${Q}.json`);this.i.exists(se).then(re=>{re&&q({localized:se,original:(0,d.joinPath)(J,"package.nls.json")});const F=Q.lastIndexOf("-");F===-1?q({localized:(0,d.joinPath)(J,"package.nls.json"),original:null}):(Q=Q.substring(0,F),H(Q))})};if(Y.devMode||Y.pseudo||!Y.language)return q({localized:(0,d.joinPath)(J,"package.nls.json"),original:null});H(Y.language)})}s(J,Y){return`[${J.path}]: ${Y}`}};_=ye([Z(1,E.IExtensionsProfileScannerService),Z(2,C.IUriIdentityService),Z(3,a.IFileService),Z(4,s.ILogService)],_);let ne=class extends _{constructor(J,Y,q,W,H,Q){super(Y,q,W,H,Q),this.w=J,this.u=this.D(new L.ThrottledDelayer(3e3)),this.v=this.D(new h.Emitter),this.onDidChangeCache=this.v.event}async scanExtensions(J){const Y=await this.y();if(this.t=J,Y&&Y.input&&B.equals(Y.input,this.t))return this.j.debug("Using cached extensions scan result",J.location.toString()),this.u.trigger(()=>this.C()),Y.result.map(W=>(W.location=u.URI.revive(W.location),W));const q=await super.scanExtensions(J);return await this.z({input:J,result:q}),q}async y(){try{const J=await this.i.readFile(this.w),Y=JSON.parse(J.value.toString());return{result:Y.result,input:(0,l.revive)(Y.input)}}catch(J){this.j.debug("Error while reading the extension cache file:",this.w.path,(0,M.getErrorMessage)(J))}return null}async z(J){try{await this.i.writeFile(this.w,A.VSBuffer.fromString(JSON.stringify(J)))}catch(Y){this.j.debug("Error while writing the extension cache file:",this.w.path,(0,M.getErrorMessage)(Y))}}async C(){if(!this.t)return;const J=await this.y();if(!J)return;const Y=J.result,q=JSON.parse(JSON.stringify(await super.scanExtensions(this.t)));if(!o.equals(q,Y))try{this.j.info("Invalidating Cache",Y,q),await this.i.del(this.w),this.v.fire()}catch(W){this.j.error(W)}}};ne=ye([Z(2,E.IExtensionsProfileScannerService),Z(3,C.IUriIdentityService),Z(4,a.IFileService),Z(5,s.ILogService)],ne);function ae(ce,J){const Y=(0,y.getExtensionId)(ce.manifest.publisher,ce.manifest.name);return{id:Y,identifier:new D.ExtensionIdentifier(Y),isBuiltin:ce.type===0,isUserBuiltin:ce.type===1&&ce.isBuiltin,isUnderDevelopment:J,extensionLocation:ce.location,uuid:ce.identifier.uuid,targetPlatform:ce.targetPlatform,...ce.manifest}}e.toExtensionDescription=ae;class he extends z{constructor(J,Y,q,W,H,Q,se,re,F,I,O,U){super(J,Y,(0,d.joinPath)(q,".vscode-oss-dev","extensions","control.json"),(0,d.joinPath)(W,D.MANIFEST_CACHE_FOLDER),H,Q,se,re,F,I,O,U),this.M=(async()=>{if(b.translationsConfigFile)try{const j=await this.q.readFile(u.URI.file(b.translationsConfigFile));return JSON.parse(j.value.toString())}catch{}return Object.create(null)})()}f(J){return this.M}}e.NativeExtensionsScannerService=he}),define(ee[261],te([0,1,5,40,39,24,81,16,34,8]),function(G,e,P,L,o,A,M,k,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let m=class extends M.AbstractExtensionsProfileScannerService{constructor(b,d,S,w,r,u){super(c.URI.file(b.extensionsPath),d,S,w,r,u)}};m=ye([Z(0,f.INativeEnvironmentService),Z(1,k.IFileService),Z(2,L.IUserDataProfilesService),Z(3,o.IUriIdentityService),Z(4,A.ITelemetryService),Z(5,P.ILogService)],m),e.ExtensionsProfileScannerService=m}),define(ee[262],te([0,1,8,34,81,123,16,6,5,21,39,40]),function(G,e,P,L,o,A,M,k,f,c,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let b=class extends A.NativeExtensionsScannerService{constructor(S,w,r,u,g,p,y,D){super(P.URI.file(g.builtinExtensionsPath),P.URI.file(g.extensionsPath),g.userHome,P.URI.file(g.userDataPath),S,w,r,u,g,p,y,D)}};b=ye([Z(0,v.IUserDataProfilesService),Z(1,o.IExtensionsProfileScannerService),Z(2,M.IFileService),Z(3,f.ILogService),Z(4,L.INativeEnvironmentService),Z(5,c.IProductService),Z(6,m.IUriIdentityService),Z(7,k.IInstantiationService)],b),e.ExtensionsScannerService=b}),define(ee[263],te([0,1,15,2,14,9,4,61,8,31,42,34,5,40]),function(G,e,P,L,o,A,M,k,f,c,m,v,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let S=class extends L.Disposable{constructor(r,u,g){super(),this.c=r,this.f=g,this.a=k.TernarySearchTree.forPaths(!M.isLinux),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(r.appRoot),this.addValidFileRoot(r.extensionsPath),this.addValidFileRoot(u.defaultProfile.globalStorageHome.fsPath),this.addValidFileRoot(r.workspaceStorageHome.fsPath),this.g()}g(){const{defaultSession:r}=P.session;r.protocol.registerFileProtocol(o.Schemas.vscodeFileResource,(u,g)=>this.i(u,g)),r.protocol.interceptFileProtocol(o.Schemas.file,(u,g)=>this.h(u,g)),this.D((0,L.toDisposable)(()=>{r.protocol.unregisterProtocol(o.Schemas.vscodeFileResource),r.protocol.uninterceptProtocol(o.Schemas.file)}))}addValidFileRoot(r){const u=(0,A.normalize)(r);return this.a.get(u)?L.Disposable.None:(this.a.set(u,!0),(0,L.toDisposable)(()=>this.a.delete(u)))}h(r,u){const g=f.URI.parse(r.url);return this.f.error(`Refused to load resource ${g.fsPath} from ${o.Schemas.file}: protocol (original URL: ${r.url})`),u({error:-3})}i(r,u){const g=this.j(r);let p;return this.c.crossOriginIsolated&&((0,A.basename)(g)==="workbench.html"||(0,A.basename)(g)==="workbench-dev.html"?p=o.COI.CoopAndCoep:p=o.COI.getHeadersFromQuery(r.url)),this.a.findSubstr(g)?u({path:g,headers:p}):this.b.has((0,A.extname)(g).toLowerCase())?u({path:g}):(this.f.error(`${o.Schemas.vscodeFileResource}: Refused to load resource ${g} from ${o.Schemas.vscodeFileResource}: protocol (original URL: ${r.url})`),u({error:-3}))}j(r){const u=f.URI.parse(r.url),g=o.FileAccess.uriToFileUri(u);return(0,A.normalize)(g.fsPath)}createIPCObjectUrl(){let r;const u=f.URI.from({scheme:"vscode",path:(0,c.generateUuid)()}),g=u.toString(),p=async()=>r;return m.validatedIpcMain.handle(g,p),this.f.trace(`IPC Object URL: Registered new channel ${g}.`),{resource:u,update:y=>r=y,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${g}.`),m.validatedIpcMain.removeHandler(g)}}}};S=ye([Z(0,v.INativeEnvironmentService),Z(1,d.IUserDataProfilesService),Z(2,b.ILogService)],S),e.ProtocolMainService=S}),define(ee[93],te([0,1,7,3,2,64,11,106,6,40]),function(G,e,P,L,o,A,M,k,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,f.createDecorator)("storageService");var m;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(m=e.WillSaveStateReason||(e.WillSaveStateReason={}));var v;(function(g){g[g.APPLICATION=-1]="APPLICATION",g[g.PROFILE=0]="PROFILE",g[g.WORKSPACE=1]="WORKSPACE"})(v=e.StorageScope||(e.StorageScope={}));var b;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(b=e.StorageTarget||(e.StorageTarget={}));function d(g){const p=g.get(e.TARGET_KEY);if(p)try{return JSON.parse(p)}catch{}return Object.create(null)}e.loadKeyTargets=d;class S extends o.Disposable{constructor(p={flushInterval:S.a}){super(),this.j=p,this.b=this.D(new L.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.D(new L.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.D(new L.Emitter),this.onWillSaveState=this.f.event,this.h=this.D(new P.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.D(new o.MutableDisposable),this.u=void 0,this.w=void 0,this.z=void 0}k(){this.i.value=(0,P.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,o.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.J()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(p,y){if(y===e.TARGET_KEY){switch(p){case-1:this.z=void 0;break;case 0:this.w=void 0;break;case 1:this.u=void 0;break}this.c.fire({scope:p})}else this.b.fire({scope:p,key:y,target:this.F(p)[y]})}q(p){this.f.fire({reason:p})}get(p,y,D){return this.L(y)?.get(p,D)}getBoolean(p,y,D){return this.L(y)?.getBoolean(p,D)}getNumber(p,y,D){return this.L(y)?.getNumber(p,D)}store(p,y,D,t){if((0,M.isUndefinedOrNull)(y)){this.remove(p,D);return}this.r(()=>{this.t(p,D,t),this.L(D)?.set(p,y)})}remove(p,y){this.r(()=>{this.t(p,y,void 0),this.L(y)?.delete(p)})}r(p){this.b.pause(),this.c.pause();try{p()}finally{this.b.resume(),this.c.resume()}}keys(p,y){const D=[],t=this.F(p);for(const a of Object.keys(t))t[a]===y&&D.push(a);return D}t(p,y,D){const t=this.F(y);typeof D=="number"?t[p]!==D&&(t[p]=D,this.L(y)?.set(e.TARGET_KEY,JSON.stringify(t))):typeof t[p]=="number"&&(delete t[p],this.L(y)?.set(e.TARGET_KEY,JSON.stringify(t)))}get v(){return this.u||(this.u=this.G(1)),this.u}get y(){return this.w||(this.w=this.G(0)),this.w}get C(){return this.z||(this.z=this.G(-1)),this.z}F(p){switch(p){case-1:return this.C;case 0:return this.y;default:return this.v}}G(p){const y=this.L(p);return y?d(y):Object.create(null)}isNew(p){return this.getBoolean(e.IS_NEW_KEY,p)===!0}async flush(p=m.NONE){this.f.fire({reason:p});const y=this.L(-1),D=this.L(0),t=this.L(1);switch(p){case m.NONE:await P.Promises.settled([y?.whenFlushed()??Promise.resolve(),D?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case m.SHUTDOWN:await P.Promises.settled([y?.flush(0)??Promise.resolve(),D?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const p=this.L(-1)?.items??new Map,y=this.L(0)?.items??new Map,D=this.L(1)?.items??new Map;return u(p,y,D,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(p,y){return this.q(m.NONE),(0,c.isUserDataProfile)(p)?this.N(p,y):this.O(p,y)}H(p,y){return!(p.id===y.id||w(y)&&w(p))}I(p,y,D,t){this.r(()=>{if(t)for(const[a,i]of p)y.set(a,i);else{const a=new Set;for(const[i,s]of p)a.add(i),y.get(i)!==s&&this.n(D,i);for(const[i]of y.items)a.has(i)||this.n(D,i)}})}}S.a=60*1e3,e.AbstractStorageService=S;function w(g){return g.isDefault||!!g.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=w;class r extends S{constructor(){super(),this.p=this.D(new k.Storage(new k.InMemoryStorageDatabase,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.P=this.D(new k.Storage(new k.InMemoryStorageDatabase,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.D(new k.Storage(new k.InMemoryStorageDatabase,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.D(this.Q.onDidChangeStorage(p=>this.n(1,p))),this.D(this.P.onDidChangeStorage(p=>this.n(0,p))),this.D(this.p.onDidChangeStorage(p=>this.n(-1,p)))}L(p){switch(p){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(p){switch(p){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(p){return!1}}e.InMemoryStorageService=r;async function u(g,p,y,D,t,a){const i=N=>{try{return JSON.parse(N)}catch{return N}},s=new Map,n=new Map;g.forEach((N,z)=>{s.set(z,N),n.set(z,i(N))});const h=new Map,l=new Map;p.forEach((N,z)=>{h.set(z,N),l.set(z,i(N))});const E=new Map,R=new Map;y.forEach((N,z)=>{E.set(z,N),R.set(z,i(N))}),console.group(D!==t?`Storage: Application (path: ${D})`:`Storage: Application & Profile (path: ${D}, default profile)`);const C=[];if(s.forEach((N,z)=>{C.push({key:z,value:N})}),console.table(C),console.groupEnd(),console.log(n),D!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const N=[];h.forEach((z,B)=>{N.push({key:B,value:z})}),console.table(N),console.groupEnd(),console.log(l)}console.group(`Storage: Workspace (path: ${a})`);const T=[];E.forEach((N,z)=>{T.push({key:z,value:N})}),console.table(T),console.groupEnd(),console.log(R)}e.logStorage=u}),define(ee[264],te([0,1,27,7,3,2,9,75,8,23,106,156,5,93,24,28]),function(G,e,P,L,o,A,M,k,f,c,m,v,b,d,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class r extends A.Disposable{get storage(){return this.f}constructor(a,i){super(),this.j=a,this.k=i,this.b=this.D(new o.Emitter),this.onDidChangeStorage=this.b.event,this.c=this.D(new o.Emitter),this.onDidCloseStorage=this.c.event,this.f=new m.Storage(new m.InMemoryStorageDatabase,{hint:m.StorageHint.STORAGE_IN_MEMORY}),this.g=void 0,this.h=new L.DeferredPromise,this.whenInit=this.h.p,this.i=m.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.i===m.StorageState.None)try{const a=await this.n();this.f.dispose(),this.f=a,this.D(a.onDidChangeStorage(s=>this.b.fire({key:s}))),await this.m(a);const i=a.getBoolean(d.IS_NEW_KEY);i===void 0?a.set(d.IS_NEW_KEY,!0):i&&a.set(d.IS_NEW_KEY,!1)}catch(a){this.j.error(`[storage main] initialize(): Unable to init storage due to ${a}`)}finally{this.i=m.StorageState.Initialized,this.h.complete()}})()),this.g}l(){return{logTrace:this.j.getLevel()===b.LogLevel.Trace?a=>this.j.trace(a):void 0,logError:a=>this.j.error(a)}}m(a){return a.init()}get items(){return this.f.items}get(a,i){return this.f.get(a,i)}set(a,i){return this.f.set(a,i)}delete(a){return this.f.delete(a)}async close(){const a=new k.StopWatch(!1);await this.r(),a.stop(),a.elapsed()>r.a&&await this.q(a),this.c.fire()}async q(a){if(!!this.path)try{const i=(0,P.top)(Array.from(this.f.items.entries()).map(([n,h])=>({key:n,length:h.length})),(n,h)=>h.length-n.length,5).map(n=>`${n.key}:${n.length}`).join(", "),s=(await this.k.stat(f.URI.file(this.path))).size;this.j.warn(`[storage main] detected slow close() operation: Time: ${a.elapsed()}ms, DB size: ${s}b, Large Keys: ${i}`)}catch(i){this.j.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async r(){this.g&&await this.g,this.i=m.StorageState.Closed,await this.f.close()}}r.a=2e3;class u extends r{get path(){if(!this.u.useInMemoryStorage)return(0,M.join)(this.t.globalStorageHome.fsPath,u.s)}constructor(a,i,s,n){super(s,n),this.t=a,this.u=i}async n(){return new m.Storage(new v.SQLiteStorageDatabase(this.path??v.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.l()}),this.path?void 0:{hint:m.StorageHint.STORAGE_IN_MEMORY})}}u.s="state.vscdb";class g extends u{constructor(a,i,s,n){super(a,i,s,n)}}e.ProfileStorageMain=g;class p extends u{constructor(a,i,s,n){super(i.defaultProfile,a,s,n)}async m(a){await super.m(a),this.y(a)}y(a){a.get(S.firstSessionDateStorageKey,void 0)===void 0&&a.set(S.firstSessionDateStorageKey,new Date().toUTCString());const s=a.get(S.currentSessionDateStorageKey,void 0),n=new Date().toUTCString();a.set(S.lastSessionDateStorageKey,typeof s>"u"?null:s),a.set(S.currentSessionDateStorageKey,n)}}e.ApplicationStorageMain=p;class y extends r{get path(){if(!this.v.useInMemoryStorage)return(0,M.join)(this.w.workspaceStorageHome.fsPath,this.u.id,y.s)}constructor(a,i,s,n,h){super(s,h),this.u=a,this.v=i,this.w=n}async n(){const{storageFilePath:a,wasCreated:i}=await this.z();return new m.Storage(new v.SQLiteStorageDatabase(a,{logging:this.l()}),{hint:this.v.useInMemoryStorage?m.StorageHint.STORAGE_IN_MEMORY:i?m.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async z(){if(this.v.useInMemoryStorage)return{storageFilePath:v.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const a=(0,M.join)(this.w.workspaceStorageHome.fsPath,this.u.id),i=(0,M.join)(a,y.s);return await c.Promises.exists(a)?{storageFilePath:i,wasCreated:!1}:(await c.Promises.mkdir(a,{recursive:!0}),this.C(a),{storageFilePath:i,wasCreated:!0})}async C(a){let i;if((0,w.isSingleFolderWorkspaceIdentifier)(this.u)?i={folder:this.u.uri.toString()}:(0,w.isWorkspaceIdentifier)(this.u)&&(i={workspace:this.u.configPath.toString()}),i)try{const s=(0,M.join)(a,y.t);await c.Promises.exists(s)||await c.Promises.writeFile(s,JSON.stringify(i,void 0,2))}catch(s){this.j.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${s}`)}}}y.s="state.vscdb",y.t="workspace.json",e.WorkspaceStorageMain=y;class D extends r{get path(){}async n(){return new m.Storage(new m.InMemoryStorageDatabase,{hint:m.StorageHint.STORAGE_IN_MEMORY})}}e.InMemoryStorageMain=D}),define(ee[265],te([0,1,3,2,93]),function(G,e,P,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileStorageChangesListenerChannel=void 0;class A extends L.Disposable{constructor(k,f,c){super(),this.b=k,this.c=f,this.f=c;const m=this.D(new L.MutableDisposable);this.a=this.D(new P.Emitter({onWillAddFirstListener:()=>m.value=this.g(),onDidRemoveLastListener:()=>m.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const k=new L.DisposableStore;return k.add(P.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(f,c)=>(f?f.push(c.key):f=[c.key],f),100)(f=>this.h(f))),k.add(P.Event.debounce(this.b.onDidChangeProfileStorage,(f,c)=>{f||(f=new Map);let m=f.get(c.profile.id);return m||f.set(c.profile.id,m={profile:c.profile,keys:[],storage:c.storage}),m.keys.push(c.key),f},100)(f=>this.i(f))),k}h(k){const f=k.includes(o.TARGET_KEY)?[this.c.defaultProfile]:[],c=[];if(k=k.filter(m=>m!==o.TARGET_KEY),k.length){const m=(0,o.loadKeyTargets)(this.b.applicationStorage.storage);c.push({profile:this.c.defaultProfile,changes:k.map(v=>({key:v,scope:0,target:m[v]}))})}this.j(f,c)}i(k){const f=[],c=new Map;for(const[m,v]of k.entries()){v.keys.includes(o.TARGET_KEY)&&f.push(v.profile);const b=v.keys.filter(d=>d!==o.TARGET_KEY);if(b.length){const d=(0,o.loadKeyTargets)(v.storage.storage);c.set(m,{profile:v.profile,changes:b.map(S=>({key:S,scope:0,target:d[S]}))})}}this.j(f,[...c.values()])}j(k,f){(k.length||f.length)&&this.a.fire({valueChanges:f,targetChanges:k})}listen(k,f,c){switch(f){case"onDidChange":return this.a.event}throw new Error(`Event not found: ${f}`)}async call(k,f){throw new Error(`Call not found: ${f}`)}}e.ProfileStorageChangesListenerChannel=A}),define(ee[266],te([0,1,8,34,16,5,33,39,40,11,116]),function(G,e,P,L,o,A,M,k,f,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerUserDataProfilesService=e.UserDataProfilesService=e.UserDataProfilesReadonlyService=void 0;let v=class dt extends f.UserDataProfilesService{constructor(w,r,u,g,p){super(u,g,r,p),this.O=w,this.P=u}I(){return this.O.getItem(dt.b,[]).map(r=>({...r,location:(0,c.isString)(r.location)?this.q.extUri.joinPath(this.profilesHome,r.location):P.URI.revive(r.location)}))}L(){const w=this.O.getItem(dt.c,{});return this.O.getItem(dt.a,!1)?w:this.H(w)}N(){return this.q.extUri.joinPath(P.URI.file(this.P.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};v.a="profileAssociationsMigration",v=ye([Z(0,M.IStateReadService),Z(1,k.IUriIdentityService),Z(2,L.INativeEnvironmentService),Z(3,o.IFileService),Z(4,A.ILogService)],v),e.UserDataProfilesReadonlyService=v;let b=class st extends v{constructor(w,r,u,g,p){super(w,r,u,g,p),this.U=w}J(w){w.length?this.U.setItem(st.b,w.map(r=>({...r,location:this.q.extUri.basename(r.location)}))):this.U.removeItem(st.b)}I(){const w=super.I();return this.U.getItem("userDataProfilesMigration",!1)||(this.J(w),this.U.setItem("userDataProfilesMigration",!0)),w}M(w){w.emptyWindows||w.workspaces?this.U.setItem(st.c,w):this.U.removeItem(st.c)}L(){const w="workspaceAndProfileInfo",r=this.U.getItem(w,void 0);if(r){this.U.removeItem(w);const g=r.reduce((p,{workspace:y,profile:D})=>(p[P.URI.revive(y).toString()]=P.URI.revive(D).toString(),p),{});this.U.setItem(st.c,{workspaces:g})}const u=super.L();return this.U.getItem(st.a,!1)||(this.M(u),this.U.setItem(st.a,!0)),u}};b=ye([Z(0,M.IStateService),Z(1,k.IUriIdentityService),Z(2,L.INativeEnvironmentService),Z(3,o.IFileService),Z(4,A.ILogService)],b),e.UserDataProfilesService=b;let d=class extends b{constructor(w,r,u,g){super(new m.StateService(0,r,g,u),w,r,u,g)}async init(){return await this.U.init(),super.init()}};d=ye([Z(0,k.IUriIdentityService),Z(1,L.INativeEnvironmentService),Z(2,o.IFileService),Z(3,A.ILogService)],d),e.ServerUserDataProfilesService=d}),define(ee[53],te([0,1,34,16,6,5,39,40,266,33]),function(G,e,P,L,o,A,M,k,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,o.refineServiceDecorator)(k.IUserDataProfilesService);let m=class extends f.UserDataProfilesService{constructor(b,d,S,w,r){super(b,d,S,w,r)}getAssociatedEmptyWindows(){const b=[];for(const d of this.t.emptyWindows.keys())b.push({id:d});return b}};m=ye([Z(0,c.IStateService),Z(1,M.IUriIdentityService),Z(2,P.INativeEnvironmentService),Z(3,L.IFileService),Z(4,A.ILogService)],m),e.UserDataProfilesMainService=m}),define(ee[124],te([0,1,18,8,28]),function(G,e,P,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;async function A(f,c,m){for(const b of f){const d=b.openedWorkspace;if((0,o.isWorkspaceIdentifier)(d)){const S=await m(d);if(S){if(S.folders.some(w=>P.extUriBiasedIgnorePathCase.isEqualOrParent(c,w.uri)))return b}else if(P.extUriBiasedIgnorePathCase.isEqualOrParent(c,d.configPath))return b}}const v=f.filter(b=>(0,o.isSingleFolderWorkspaceIdentifier)(b.openedWorkspace)&&P.extUriBiasedIgnorePathCase.isEqualOrParent(c,b.openedWorkspace.uri));if(v.length)return v.sort((b,d)=>-(b.openedWorkspace.uri.path.length-d.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=A;function M(f,c){for(const m of f)if((0,o.isWorkspaceIdentifier)(m.openedWorkspace)&&P.extUriBiasedIgnorePathCase.isEqual(m.openedWorkspace.configPath,c)||(0,o.isSingleFolderWorkspaceIdentifier)(m.openedWorkspace)&&P.extUriBiasedIgnorePathCase.isEqual(m.openedWorkspace.uri,c))return m}e.findWindowOnWorkspaceOrFolder=M;function k(f,c){const m=v=>c.some(b=>P.extUriBiasedIgnorePathCase.isEqual(L.URI.file(b),L.URI.file(v)));for(const v of f)if(v.config?.extensionDevelopmentPath?.some(b=>m(b)))return v}e.findWindowOnExtensionDevelopmentPath=k}),define(ee[94],te([0,1,32,43,129,45,14,9,4,18,8,6,57,28]),function(G,e,P,L,o,A,M,k,f,c,m,v,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,v.createDecorator)("workspacesService");function S(R){return R.hasOwnProperty("workspace")}e.isRecentWorkspace=S;function w(R){return R.hasOwnProperty("folderUri")}e.isRecentFolder=w;function r(R){return R.hasOwnProperty("fileUri")}e.isRecentFile=r;function u(R){return g(R)||p(R)}e.isStoredWorkspaceFolder=u;function g(R){const C=R;return typeof C?.path=="string"&&(!C.name||typeof C.name=="string")}function p(R){const C=R;return typeof C?.uri=="string"&&(!C.name||typeof C.name=="string")}function y(R,C,T,N,z){if(R.scheme!==N.scheme)return{name:T,uri:R.toString(!0)};let B=C?void 0:z.relativePath(N,R);if(B!==void 0)B.length===0?B=".":f.isWindows&&(B=D(B));else if(R.scheme===M.Schemas.file)B=R.fsPath,f.isWindows&&(B=D(B));else if(z.isEqualAuthority(R.authority,N.authority))B=R.path;else return{name:T,uri:R.toString(!0)};return{name:T,path:B}}e.getStoredWorkspaceFolder=y;function D(R){return R=(0,A.normalizeDriveLetter)(R),(0,P.isUNC)(R)||(R=(0,P.toSlashes)(R)),R}function t(R,C,T){const N=[],z=new Set,B=T.dirname(C);for(const _ of R){let ne;if(g(_))_.path&&(ne=T.resolvePath(B,_.path));else if(p(_))try{ne=m.URI.parse(_.uri),ne.path[0]!==k.posix.sep&&(ne=ne.with({path:k.posix.sep+ne.path}))}catch(ae){console.warn(ae)}if(ne){const ae=T.getComparisonKey(ne);if(!z.has(ae)){z.add(ae);const he=_.name||T.basenameOrAuthority(ne);N.push(new d.WorkspaceFolder({uri:ne,name:he,index:N.length},_))}}}return N}e.toWorkspaceFolders=t;function a(R,C,T,N,z){const B=i(C,R),_=z.dirname(C),ne=z.dirname(N),ae=[];for(const Y of B.folders){const q=g(Y)?z.resolvePath(_,Y.path):m.URI.parse(Y.uri);let W;T?W=!1:W=!g(Y)||(0,k.isAbsolute)(Y.path),ae.push(y(q,W,Y.name,ne,z))}const he={insertSpaces:!1,tabSize:4,eol:f.isLinux||f.isMacintosh?`
`:`\r
`},ce=o.setProperty(R,["folders"],ae,he);let J=o.applyEdits(R,ce);return(0,c.isEqualAuthority)(B.remoteAuthority,(0,b.getRemoteAuthority)(N))&&(J=o.applyEdits(J,o.removeProperty(J,["remoteAuthority"],he))),J}e.rewriteWorkspaceFileForNewLocation=a;function i(R,C){const T=L.parse(C);if(T&&Array.isArray(T.folders))T.folders=T.folders.filter(N=>u(N));else throw new Error(`${R} looks like an invalid workspace file.`);return T}function s(R){return R.workspace&&typeof R.workspace=="object"&&typeof R.workspace.id=="string"&&typeof R.workspace.configPath=="string"}function n(R){return typeof R.folderUri=="string"}function h(R){return typeof R.fileUri=="string"}function l(R,C){const T={workspaces:[],files:[]};if(R){const N=function(B,_){for(let ne=0;ne<B.length;ne++)try{_(B[ne],ne)}catch(ae){C.warn(`Error restoring recent entry ${JSON.stringify(B[ne])}: ${ae.toString()}. Skip entry.`)}},z=R;Array.isArray(z.entries)&&N(z.entries,B=>{const _=B.label,ne=B.remoteAuthority;s(B)?T.workspaces.push({label:_,remoteAuthority:ne,workspace:{id:B.workspace.id,configPath:m.URI.parse(B.workspace.configPath)}}):n(B)?T.workspaces.push({label:_,remoteAuthority:ne,folderUri:m.URI.parse(B.folderUri)}):h(B)&&T.files.push({label:_,remoteAuthority:ne,fileUri:m.URI.parse(B.fileUri)})})}return T}e.restoreRecentlyOpened=l;function E(R){const C={entries:[]};for(const T of R.workspaces)w(T)?C.entries.push({folderUri:T.folderUri.toString(),label:T.label,remoteAuthority:T.remoteAuthority}):C.entries.push({workspace:{id:T.workspace.id,configPath:T.workspace.configPath.toString()},label:T.label,remoteAuthority:T.remoteAuthority});for(const T of R.files)C.entries.push({fileUri:T.fileUri.toString(),label:T.label,remoteAuthority:T.remoteAuthority});return C}e.toStoreData=E}),define(ee[95],te([0,1,72,14,4,18]),function(G,e,P,L,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function M(c){function m(){let v=c.scheme===L.Schemas.file?(0,A.originalFSPath)(c):c.toString();return o.isLinux||(v=v.toLowerCase()),(0,P.createHash)("md5").update(v).digest("hex")}return{id:m(),configPath:c}}e.getWorkspaceIdentifier=M;function k(c,m){function v(){if(c.scheme!==L.Schemas.file)return(0,P.createHash)("md5").update(c.toString()).digest("hex");if(!m)return;let d;return o.isLinux?d=m.ino:o.isMacintosh?d=m.birthtime.getTime():o.isWindows&&(typeof m.birthtimeMs=="number"?d=Math.floor(m.birthtimeMs):d=m.birthtime.getTime()),(0,P.createHash)("md5").update(c.fsPath).update(d?String(d):"").digest("hex")}const b=v();if(typeof b=="string")return{id:b,uri:c}}e.getSingleFolderWorkspaceIdentifier=k;function f(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=f}),define(ee[96],te([0,1,72,73,25,267,17,13,3,2,9,4,31,47,104]),function(G,e,P,L,o,A,M,k,f,c,m,v,b,d,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class w{traceSocketEvent(C,T){S.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,C,T)}constructor(C,T=""){this.f=!0,this.debugLabel=T,this.socket=C,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=N=>{if(this.traceSocketEvent("error",{code:N?.code,message:N?.message}),N){if(N.code==="EPIPE")return;(0,k.onUnexpectedError)(N)}},this.socket.on("error",this.a),this.b=N=>{this.traceSocketEvent("close",{hadError:N}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(C){const T=N=>{this.traceSocketEvent("read",N),C(M.VSBuffer.wrap(N))};return this.socket.on("data",T),{dispose:()=>this.socket.off("data",T)}}onClose(C){const T=N=>{C({type:0,hadError:N,error:void 0})};return this.socket.on("close",T),{dispose:()=>this.socket.off("close",T)}}onEnd(C){const T=()=>{C()};return this.socket.on("end",T),{dispose:()=>this.socket.off("end",T)}}write(C){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",C),this.socket.write(C.buffer,T=>{if(T){if(T.code==="EPIPE")return;(0,k.onUnexpectedError)(T)}})}catch(T){if(T.code==="EPIPE")return;(0,k.onUnexpectedError)(T)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((C,T)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),C();return}const N=()=>{this.socket.off("close",N),this.socket.off("end",N),this.socket.off("error",N),this.socket.off("timeout",N),this.socket.off("drain",N),this.traceSocketEvent("nodeDrainEnd"),C()};this.socket.on("close",N),this.socket.on("end",N),this.socket.on("error",N),this.socket.on("timeout",N),this.socket.on("drain",N)})}}e.NodeSocket=w;var r;(function(R){R[R.MinHeaderByteSize=2]="MinHeaderByteSize",R[R.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(r||(r={}));var u;(function(R){R[R.PeekHeader=1]="PeekHeader",R[R.ReadHeader=2]="ReadHeader",R[R.ReadBody=3]="ReadBody",R[R.Fin=4]="Fin"})(u||(u={}));class g extends c.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(C,T){this.socket.traceSocketEvent(C,T)}constructor(C,T,N,z){super(),this.f=this.D(new f.Emitter),this.g=this.D(new f.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=C,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:T,inflateBytesLength:N?.byteLength||0,recordInflateBytes:z}),this.a=this.D(new p(this,T,N,z,this.f,(B,_)=>this.k(B,_))),this.D(this.a.onError(B=>{console.error(B),(0,k.onUnexpectedError)(B),this.g.fire({type:0,hadError:!0,error:B})})),this.b=new S.ChunkStream,this.D(this.socket.onData(B=>this.l(B))),this.D(this.socket.onClose(async B=>{this.a.isProcessingReadQueue()&&await f.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(B)}))}dispose(){this.a.isProcessingWriteQueue()?this.D(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(C){return this.f.event(C)}onClose(C){return this.g.event(C)}onEnd(C){return this.socket.onEnd(C)}write(C){let T=0;for(;T<C.byteLength;)this.a.writeMessage(C.slice(T,Math.min(T+262144,C.byteLength))),T+=262144}k(C,T){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",C);let N=2;C.byteLength<126?N+=0:C.byteLength<2**16?N+=2:N+=8;const z=M.VSBuffer.alloc(N);if(T?z.writeUInt8(194,0):z.writeUInt8(130,0),C.byteLength<126)z.writeUInt8(C.byteLength,1);else if(C.byteLength<2**16){z.writeUInt8(126,1);let B=1;z.writeUInt8(C.byteLength>>>8&255,++B),z.writeUInt8(C.byteLength>>>0&255,++B)}else{z.writeUInt8(127,1);let B=1;z.writeUInt8(0,++B),z.writeUInt8(0,++B),z.writeUInt8(0,++B),z.writeUInt8(0,++B),z.writeUInt8(C.byteLength>>>24&255,++B),z.writeUInt8(C.byteLength>>>16&255,++B),z.writeUInt8(C.byteLength>>>8&255,++B),z.writeUInt8(C.byteLength>>>0&255,++B)}this.socket.write(M.VSBuffer.concat([z,C]))}end(){this.h=!0,this.socket.end()}l(C){if(C.byteLength!==0){for(this.b.acceptChunk(C);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const T=this.b.peek(this.j.readLen),N=T.readUInt8(0),z=(N&128)>>>7,B=(N&64)>>>6,_=T.readUInt8(1),ne=(_&128)>>>7,ae=_&127;this.j.state=2,this.j.readLen=2+(ne?4:0)+(ae===126?2:0)+(ae===127?8:0),this.j.fin=z,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(B)),this.j.firstFrameOfMessage=Boolean(z),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const T=this.b.read(this.j.readLen),N=T.readUInt8(1),z=(N&128)>>>7;let B=N&127,_=1;B===126?B=T.readUInt8(++_)*2**8+T.readUInt8(++_):B===127&&(B=T.readUInt8(++_)*0+T.readUInt8(++_)*0+T.readUInt8(++_)*0+T.readUInt8(++_)*0+T.readUInt8(++_)*2**24+T.readUInt8(++_)*2**16+T.readUInt8(++_)*2**8+T.readUInt8(++_));let ne=0;z&&(ne=T.readUInt8(++_)*2**24+T.readUInt8(++_)*2**16+T.readUInt8(++_)*2**8+T.readUInt8(++_)),this.j.state=3,this.j.readLen=B,this.j.mask=ne,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const T=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",T),t(T,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",T),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(T,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await f.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=g;class p extends c.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:M.VSBuffer.alloc(0)}constructor(C,T,N,z,B,_){super(),this.l=C,this.m=B,this.n=_,this.a=this.D(new f.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.D(new f.Emitter),this.onDidFinishProcessingReadQueue=this.j.event,this.k=this.D(new f.Emitter),this.onDidFinishProcessingWriteQueue=this.k.event,this.p=!1,this.s=!1,T?(this.b=this.D(new y(this.l,z,N,{windowBits:15})),this.f=this.D(new D(this.l,{windowBits:15})),this.D(this.b.onError(ne=>this.a.fire(ne))),this.D(this.f.onError(ne=>this.a.fire(ne)))):(this.b=null,this.f=null)}writeMessage(C){this.g.push(C),this.q()}async q(){if(!this.p){for(this.p=!0;this.g.length>0;){const C=this.g.shift();if(this.f){const T=await this.r(this.f,C);this.n(T,!0)}else this.n(C,!1)}this.p=!1,this.k.fire()}}isProcessingWriteQueue(){return this.p}r(C,T){return new Promise((N,z)=>{C.write(T),C.flush(B=>N(B))})}acceptFrame(C,T,N){this.h.push({data:C,isCompressed:T,isLastFrameOfMessage:N}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const C=this.h.shift();if(this.b&&C.isCompressed){const T=await this.u(this.b,C.data,C.isLastFrameOfMessage);this.m.fire(T)}else this.m.fire(C.data)}this.s=!1,this.j.fire()}}isProcessingReadQueue(){return this.s}u(C,T,N){return new Promise((z,B)=>{C.write(T),N&&C.write(M.VSBuffer.fromByteArray([0,0,255,255])),C.flush(_=>z(_))})}}class y extends c.Disposable{get recordedInflateBytes(){return this.j?M.VSBuffer.concat(this.f):M.VSBuffer.alloc(0)}constructor(C,T,N,z){super(),this.h=C,this.j=T,this.a=this.D(new f.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,A.createInflateRaw)(z),this.b.on("error",B=>{this.h.traceSocketEvent("zlibInflateError",{message:B?.message,code:B?.code}),this.a.fire(B)}),this.b.on("data",B=>{this.h.traceSocketEvent("zlibInflateData",B),this.g.push(M.VSBuffer.wrap(B))}),N&&(this.h.traceSocketEvent("zlibInflateInitialWrite",N.buffer),this.b.write(N.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(C){this.j&&this.f.push(C.clone()),this.h.traceSocketEvent("zlibInflateWrite",C),this.b.write(C.buffer)}flush(C){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const T=M.VSBuffer.concat(this.g);this.g.length=0,C(T)})}}class D extends c.Disposable{constructor(C,T){super(),this.g=C,this.a=this.D(new f.Emitter),this.onError=this.a.event,this.f=[],this.b=(0,A.createDeflateRaw)({windowBits:15}),this.b.on("error",N=>{this.g.traceSocketEvent("zlibDeflateError",{message:N?.message,code:N?.code}),this.a.fire(N)}),this.b.on("data",N=>{this.g.traceSocketEvent("zlibDeflateData",N),this.f.push(M.VSBuffer.wrap(N))})}write(C){this.g.traceSocketEvent("zlibDeflateWrite",C.buffer),this.b.write(C.buffer)}flush(C){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let T=M.VSBuffer.concat(this.f);this.f.length=0,T=T.slice(0,T.byteLength-4),C(T)})}}function t(R,C){if(C===0)return;const T=R.byteLength>>>2;for(let ae=0;ae<T;ae++){const he=R.readUInt32BE(ae*4);R.writeUInt32BE(he^C,ae*4)}const N=T*4,z=R.byteLength-N,B=C>>>24&255,_=C>>>16&255,ne=C>>>8&255;z>=1&&R.writeUInt8(R.readUInt8(N)^B,N),z>=2&&R.writeUInt8(R.readUInt8(N+1)^_,N+1),z>=3&&R.writeUInt8(R.readUInt8(N+2)^ne,N+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function i(){const R=(0,b.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${R}-sock`;const C=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,o.tmpdir)(),T=(0,m.join)(C,`vscode-ipc-${R}.sock`);return n(T),T}e.createRandomIPCHandle=i;function s(R,C,T){const N=(0,P.createHash)("md5").update(R).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${N}-${T}-${C}-sock`;const z=T.substr(0,4),B=C.substr(0,6),_=N.substr(0,8);let ne;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?ne=(0,m.join)(e.XDG_RUNTIME_DIR,`vscode-${_}-${z}-${B}.sock`):ne=(0,m.join)(R,`${z}-${B}.sock`),n(ne),ne}e.createStaticIPCHandle=s;function n(R){const C=a[v.platform];typeof C=="number"&&R.length>=C&&console.warn(`WARNING: IPC handle "${R}" is longer than ${C} chars, try a shorter --user-data-dir`)}class h extends d.IPCServer{static b(C){const T=f.Event.fromNodeEventEmitter(C,"connection");return f.Event.map(T,N=>({protocol:new S.Protocol(new w(N,"ipc-server-connection")),onDidClientDisconnect:f.Event.once(f.Event.fromNodeEventEmitter(N,"close"))}))}constructor(C){super(h.b(C)),this.d=C}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=h;function l(R){return new Promise((C,T)=>{const N=(0,L.createServer)();N.on("error",T),N.listen(R,()=>{N.removeListener("error",T),C(new h(N))})})}e.serve=l;function E(R,C){return new Promise((T,N)=>{const z=(0,L.createConnection)(R,()=>{z.removeListener("error",N),T(S.Client.fromSocket(new w(z,`ipc-client${C}`),C))});z.once("error",N)})}e.connect=E}),define(ee[29],te([0,1,55,9,96,34,108,6]),function(G,e,P,L,o,A,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,k.refineServiceDecorator)(A.IEnvironmentService);class f extends M.NativeEnvironmentService{get cachedLanguagesPath(){return(0,L.join)(this.userDataPath,"clp")}get backupHome(){return(0,L.join)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,o.createStaticIPCHandle)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,L.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}ye([P.memoize],f.prototype,"cachedLanguagesPath",null),ye([P.memoize],f.prototype,"backupHome",null),ye([P.memoize],f.prototype,"mainIPCHandle",null),ye([P.memoize],f.prototype,"mainLockfile",null),ye([P.memoize],f.prototype,"disableUpdates",null),ye([P.memoize],f.prototype,"disableKeytar",null),ye([P.memoize],f.prototype,"crossOriginIsolated",null),ye([P.memoize],f.prototype,"codeCachePath",null),ye([P.memoize],f.prototype,"useCodeCache",null),e.EnvironmentMainService=f}),define(ee[268],te([0,1,72,32,14,9,4,18,23,189,19,29,33,16,5,188,28,95]),function(G,e,P,L,o,A,M,k,f,c,m,v,b,d,S,w,r,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let g=class yt{constructor(y,D,t,a){this.j=y,this.k=D,this.l=t,this.m=a,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=k.extUriBiasedIgnorePathCase,this.i={isEqual:(i,s)=>(0,L.isEqual)(i,s,!M.isLinux)}}async initialize(){const y=this.m.getItem(yt.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(y.emptyWindows),this.d=await this.u((0,c.deserializeWorkspaceInfos)(y)),this.e=await this.v((0,c.deserializeFolderInfos)(y)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==d.HotExitConfiguration.OFF}q(){return this.s()===d.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||d.HotExitConfiguration.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(y,D){this.d.some(a=>y.workspace.id===a.workspace.id)||(this.d.push(y),this.C());const t=(0,A.join)(this.c,y.workspace.id);return D?this.t(t,D).then(()=>t):t}async t(y,D){if(await f.Promises.exists(y)&&await this.z(y),await f.Promises.exists(D))try{await f.Promises.rename(D,y)}catch(t){this.l.error(`Backup: Could not move backup folder to new location: ${t.toString()}`)}}registerFolderBackup(y){return this.e.some(D=>this.h.isEqual(y.folderUri,D.folderUri))||(this.e.push(y),this.C()),(0,A.join)(this.c,this.D(y))}registerEmptyWindowBackup(y){return this.g.some(D=>!!D.backupFolder&&this.i.isEqual(D.backupFolder,y.backupFolder))||(this.g.push(y),this.C()),(0,A.join)(this.c,y.backupFolder)}async u(y){if(!Array.isArray(y))return[];const D=new Set,t=[];for(const a of y){const i=a.workspace;if(!(0,r.isWorkspaceIdentifier)(i))return[];if(!D.has(i.id)){D.add(i.id);const s=(0,A.join)(this.c,i.id);await this.B(s)?i.configPath.scheme!==o.Schemas.file||await f.Promises.exists(i.configPath.fsPath)?t.push(a):await this.z(s):await this.x(s)}}return t}async v(y){if(!Array.isArray(y))return[];const D=[],t=new Set;for(const a of y){const i=a.folderUri,s=this.h.getComparisonKey(i);if(!t.has(s)){t.add(s);const n=(0,A.join)(this.c,this.D(a));await this.B(n)?i.scheme!==o.Schemas.file||await f.Promises.exists(i.fsPath)?D.push(a):await this.z(n):await this.x(n)}}return D}async w(y){if(!Array.isArray(y))return[];const D=[],t=new Set;for(const a of y){const i=a.backupFolder;if(typeof i!="string")return[];if(!t.has(i)){t.add(i);const s=(0,A.join)(this.c,i);await this.B(s)?D.push(a):await this.x(s)}}return D}async x(y){try{await f.Promises.rm(y,f.RimRafMode.MOVE)}catch(D){this.l.error(`Backup: Could not delete stale backup: ${D.toString()}`)}}y(){let y=(0,u.createEmptyWorkspaceIdentifier)();for(;this.g.some(D=>!!D.backupFolder&&this.i.isEqual(D.backupFolder,y.id));)y=(0,u.createEmptyWorkspaceIdentifier)();return{backupFolder:y.id}}async z(y){const D=this.y(),t=(0,A.join)(this.c,D.backupFolder);try{await f.Promises.rename(y,t)}catch(a){return this.l.error(`Backup: Could not rename backup folder: ${a.toString()}`),!1}return this.g.push(D),!0}async getDirtyWorkspaces(){const y=[];for(const D of this.d)await this.A(D)&&y.push(D);for(const D of this.e)await this.A(D)&&y.push(D);return y}A(y){let D;return(0,c.isEmptyWindowBackupInfo)(y)?D=(0,A.join)(this.c,y.backupFolder):(0,w.isFolderBackupInfo)(y)?D=(0,A.join)(this.c,this.D(y)):D=(0,A.join)(this.c,y.workspace.id),this.B(D)}async B(y){try{const D=await f.Promises.readdir(y);for(const t of D)try{if((await f.Promises.readdir((0,A.join)(y,t))).length>0)return!0}catch{}}catch{}return!1}C(){const y={workspaces:this.d.map(({workspace:D,remoteAuthority:t})=>{const a={id:D.id,configURIPath:D.configPath.toString()};return t&&(a.remoteAuthority=t),a}),folders:this.e.map(({folderUri:D,remoteAuthority:t})=>{const a={folderUri:D.toString()};return t&&(a.remoteAuthority=t),a}),emptyWindows:this.g.map(({backupFolder:D,remoteAuthority:t})=>{const a={backupFolder:D};return t&&(a.remoteAuthority=t),a})};this.m.setItem(yt.a,y)}D(y){const D=y.folderUri;let t;return D.scheme===o.Schemas.file?t=M.isLinux?D.fsPath:D.fsPath.toLowerCase():t=D.toString().toLowerCase(),(0,P.createHash)("md5").update(t).digest("hex")}};g.a="backupWorkspaces",g=ye([Z(0,v.IEnvironmentMainService),Z(1,m.IConfigurationService),Z(2,S.ILogService),Z(3,b.IStateService)],g),e.BackupMainService=g}),define(ee[20],te([0,1,15,42,7,3,2,4,36,11,6,5,33,29]),function(G,e,P,L,o,A,M,k,f,c,m,v,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,m.createDecorator)("lifecycleMainService");var S;(function(u){u[u.QUIT=1]="QUIT",u[u.KILL=2]="KILL"})(S=e.ShutdownReason||(e.ShutdownReason={}));var w;(function(u){u[u.Starting=1]="Starting",u[u.Ready=2]="Ready",u[u.AfterWindowOpen=3]="AfterWindowOpen",u[u.Eventually=4]="Eventually"})(w=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let r=class ft extends M.Disposable{get quitRequested(){return this.i}get wasRestarted(){return this.j}get phase(){return this.k}constructor(g,p,y){super(),this.u=g,this.v=p,this.w=y,this.c=this.D(new A.Emitter),this.onBeforeShutdown=this.c.event,this.f=this.D(new A.Emitter),this.onWillShutdown=this.f.event,this.g=this.D(new A.Emitter),this.onWillLoadWindow=this.g.event,this.h=this.D(new A.Emitter),this.onBeforeCloseWindow=this.h.event,this.i=!1,this.j=!1,this.k=1,this.l=new Set,this.m=0,this.n=0,this.p=void 0,this.q=void 0,this.r=void 0,this.s=new Map,this.t=new Map,this.y(),this.when(2).then(()=>this.z())}y(){this.j=!!this.v.getItem(ft.b),this.j&&this.v.removeItem(ft.b)}z(){const g=()=>{this.i||(this.L("Lifecycle#app.on(before-quit)"),this.i=!0,this.L("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),k.isMacintosh&&this.n===0&&this.C(1))};P.app.addListener("before-quit",g);const p=()=>{this.L("Lifecycle#app.on(window-all-closed)"),(this.i||!k.isMacintosh)&&P.app.quit()};P.app.addListener("window-all-closed",p),P.app.once("will-quit",y=>{this.L("Lifecycle#app.on(will-quit) - begin"),y.preventDefault(),this.C(1).finally(()=>{this.L("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.H(!1),P.app.removeListener("before-quit",g),P.app.removeListener("window-all-closed",p),this.L("Lifecycle#app.on(will-quit) - calling app.quit()"),P.app.quit()})})}C(g){if(this.r)return this.r;const p=this.u;this.L("Lifecycle#onWillShutdown.fire()");const y=[];return this.f.fire({reason:g,join(D,t){p.trace(`Lifecycle#onWillShutdown - begin '${D}'`),y.push(t.finally(()=>{p.trace(`Lifecycle#onWillShutdown - end '${D}'`)}))}}),this.r=(async()=>{try{await o.Promises.settled(y)}catch(D){this.u.error(D)}try{await this.v.close()}catch(D){this.u.error(D)}})(),this.r}set phase(g){if(g<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.k===g)return;this.L(`lifecycle (main): phase changed (value: ${g})`),this.k=g;const p=this.t.get(this.k);p&&(p.open(),this.t.delete(this.k))}async when(g){if(g<=this.k)return;let p=this.t.get(g);p||(p=new o.Barrier,this.t.set(g,p)),await p.wait()}registerWindow(g){const p=new M.DisposableStore;this.n++,p.add(g.onWillLoad(D=>this.g.fire({window:g,workspace:D.workspace,reason:D.reason})));const y=(0,c.assertIsDefined)(g.win);y.on("close",D=>{const t=g.id;if(this.l.has(t)){this.l.delete(t);return}this.L(`Lifecycle#window.on('close') - window ID ${g.id}`),D.preventDefault(),this.unload(g,1).then(a=>{if(a){this.l.delete(t);return}this.l.add(t),this.L(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${t}`),this.h.fire(g),g.close()})}),y.on("closed",()=>{this.L(`Lifecycle#window.on('closed') - window ID ${g.id}`),this.n--,p.dispose(),this.n===0&&(!k.isMacintosh||this.i)&&this.C(1)})}async reload(g,p){await this.unload(g,3)||g.reload(p)}unload(g,p){const y=this.s.get(g.id);if(y)return y;const D=this.F(g,p).finally(()=>{this.s.delete(g.id)});return this.s.set(g.id,D),D}async F(g,p){if(!g.isReady)return!1;this.L(`Lifecycle#unload() - window ID ${g.id}`);const y=this.i?2:p,D=await this.I(g,y);return D?(this.L(`Lifecycle#unload() - veto in renderer (window ID ${g.id})`),this.G(D)):(await this.J(g,y),!1)}G(g){return g?(this.H(!0),this.i=!1,!0):!1}H(g){this.q&&(this.q(g),this.q=void 0,this.p=void 0)}I(g,p){return new Promise(y=>{const D=this.m++,t=`vscode:ok${D}`,a=`vscode:cancel${D}`;L.validatedIpcMain.once(t,()=>{y(!1)}),L.validatedIpcMain.once(a,()=>{y(!0)}),g.send("vscode:onBeforeUnload",{okChannel:t,cancelChannel:a,reason:p})})}J(g,p){return new Promise(y=>{const t=`vscode:reply${this.m++}`;L.validatedIpcMain.once(t,()=>y()),g.send("vscode:onWillUnload",{replyChannel:t,reason:p})})}quit(g){return this.L(`Lifecycle#quit() - begin (willRestart: ${g})`),this.p?(this.L("Lifecycle#quit() - returning pending quit promise"),this.p):(g&&this.v.setItem(ft.b,!0),this.p=new Promise(p=>{this.q=p,this.L("Lifecycle#quit() - calling app.quit()"),P.app.quit()}),this.p)}L(g){this.w.args["enable-smoke-test-driver"]?this.u.info(g):this.u.trace(g)}async relaunch(g){this.L("Lifecycle#relaunch()");const p=process.argv.slice(1);if(g?.addArgs&&p.push(...g.addArgs),g?.removeArgs)for(const t of g.removeArgs){const a=p.indexOf(t);a>=0&&p.splice(a,1)}const y=()=>{try{if(k.isWindows){const t=(0,f.cwd)();t!==process.cwd()&&process.chdir(t)}}catch(t){this.u.error(t)}this.L("Lifecycle#relaunch() - calling app.relaunch()"),P.app.relaunch({args:p})};P.app.once("quit",y),await this.quit(!0)&&P.app.removeListener("quit",y)}async kill(g){this.L("Lifecycle#kill()"),await this.C(2),await Promise.race([(0,o.timeout)(1e3),(async()=>{for(const p of P.BrowserWindow.getAllWindows())if(p&&!p.isDestroyed()){let y;p.webContents&&!p.webContents.isDestroyed()?y=new Promise(D=>p.once("closed",D)):y=Promise.resolve(),p.destroy(),await y}})()]),P.app.exit(g)}};r.b="lifecycle.quitAndRestart",r=ye([Z(0,v.ILogService),Z(1,b.IStateService),Z(2,d.IEnvironmentMainService)],r),e.LifecycleMainService=r}),define(ee[269],te([0,1,4,3,2,6,20]),function(G,e,P,L,o,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,A.createDecorator)("keyboardLayoutMainService");let k=class extends o.Disposable{constructor(m){super(),this.a=this.D(new L.Emitter),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,m.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const m=await new Promise((v,b)=>{G(["native-keymap"],v,b)});this.c=f(m),P.isCI||m.onDidChangeKeyboardLayout(()=>{this.c=f(m),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};k=ye([Z(0,M.ILifecycleMainService)],k),e.KeyboardLayoutMainService=k;function f(c){const m=c.getKeyMap(),v=c.getCurrentKeyboardLayout();return{keyboardMapping:m,keyboardLayoutInfo:v}}}),define(ee[270],te([0,1,73,96]),function(G,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(o,A,M,k,f,c){const m=b=>c(b,void 0),v=P.createConnection({host:o,port:A},()=>{v.removeListener("error",m);const b=Buffer.alloc(16);for(let r=0;r<16;r++)b[r]=Math.round(Math.random()*256);const d=b.toString("base64"),S=[`GET ws://${/:/.test(o)?`[${o}]`:o}:${A}${M}?${k}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${d}`];v.write(S.join(`\r
`)+`\r
\r
`);const w=r=>{r.toString().indexOf(`\r
\r
`)>=0&&(v.off("data",w),c(void 0,new L.NodeSocket(v,f)))};v.on("data",w)});v.setNoDelay(!0),v.once("error",m)}}}),define(ee[271],te([0,1,238,7,17,13,11,19,34,115,5,52,237,267]),function(G,e,P,L,o,A,M,k,f,c,m,v,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let S=class extends v.AbstractRequestService{constructor(r,u,g,p){super(!!u.isRemoteServer,p),this.j=r,this.k=u,this.l=g,this.m(),this.D(r.onDidChangeConfiguration(y=>{y.affectsConfiguration("http")&&this.m()}))}m(){const r=this.j.getValue("http");this.f=r?.proxy,this.g=!!r?.proxyStrictSSL,this.h=r?.proxyAuthorization}async request(r,u){const{f:g,g:p}=this;let y;try{y=await(0,c.getResolvedShellEnv)(this.j,this.l,this.k.args,process.env)}catch(a){this.i||(this.i=!0,this.l.error("resolving shell environment failed",(0,A.getErrorMessage)(a)))}const D={...process.env,...y},t=r.agent?r.agent:await(0,b.getProxyAgent)(r.url||"",D,{proxyUrl:g,strictSSL:p});return r.agent=t,r.strictSSL=p,this.h&&(r.headers={...r.headers||{},"Proxy-Authorization":this.h}),this.p(r,u)}async n(r){return((0,P.parse)(r.url).protocol==="https:"?await new Promise((p,y)=>{G(["https"],p,y)}):await new Promise((p,y)=>{G(["http"],p,y)})).request}p(r,u){return this.c(r.isChromiumNetwork?"electron":"node",r,()=>L.Promises.withAsyncBody(async(g,p)=>{const y=(0,P.parse)(r.url),D=r.getRawRequest?r.getRawRequest(r):await this.n(r),t={hostname:y.hostname,port:y.port?parseInt(y.port):y.protocol==="https:"?443:80,protocol:y.protocol,path:y.path,method:r.type||"GET",headers:r.headers,agent:r.agent,rejectUnauthorized:(0,M.isBoolean)(r.strictSSL)?r.strictSSL:!0};r.user&&r.password&&(t.auth=r.user+":"+r.password);const a=D(t,i=>{const s=(0,M.isNumber)(r.followRedirects)?r.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&s>0&&i.headers.location)this.p({...r,url:i.headers.location,followRedirects:s-1},u).then(g,p);else{let n=i;!r.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(n=i.pipe((0,d.createGunzip)())),g({res:i,stream:(0,o.streamToBufferReadableStream)(n)})}});a.on("error",p),r.timeout&&a.setTimeout(r.timeout),r.isChromiumNetwork&&a.removeHeader("Content-Length"),r.data&&typeof r.data=="string"&&a.write(r.data),a.end(),u.onCancellationRequested(()=>{a.abort(),p(new A.CancellationError)})}))}async resolveProxy(r){}};S=ye([Z(0,k.IConfigurationService),Z(1,f.INativeEnvironmentService),Z(2,m.ILogService),Z(3,m.ILoggerService)],S),e.RequestService=S}),define(ee[272],te([0,1,15,271]),function(G,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function o(M){return P.net.request}class A extends L.RequestService{request(k,f){return super.request({...k||{},getRawRequest:o,isChromiumNetwork:!0},f)}}e.RequestMainService=A}),define(ee[97],te([0,1,8,50,3,2,34,16,6,20,5,93,264,40,53,39]),function(G,e,P,L,o,A,M,k,f,c,m,v,b,d,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,f.createDecorator)("storageMainService");let r=class extends A.Disposable{constructor(p,y,D,t,a,i){super(),this.c=p,this.f=y,this.g=D,this.h=t,this.i=a,this.j=i,this.a=void 0,this.b=this.D(new o.Emitter),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.m(),this.n=new Map,this.q=new Map,this.l()}k(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}l(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.D(this.h.onWillLoadWindow(p=>{p.window.profile&&this.profileStorage(p.window.profile).init(),p.workspace&&this.workspaceStorage(p.workspace).init()})),this.D(this.h.onWillShutdown(p=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=p.reason,p.join("applicationStorage",this.applicationStorage.close());for(const[,y]of this.n)p.join("profileStorage",y.close());for(const[,y]of this.q)p.join("workspaceStorage",y.close())})),this.D(this.g.onWillCreateProfile(p=>{p.join((async()=>{await this.i.exists(p.profile.globalStorageHome)||await this.i.createFolder(p.profile.globalStorageHome)})())})),this.D(this.g.onWillRemoveProfile(p=>{const y=this.n.get(p.profile.id);y&&p.join(y.close())}))}m(){this.c.trace("StorageMainService: creating application storage");const p=new b.ApplicationStorageMain(this.k(),this.g,this.c,this.i);return(0,L.once)(p.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")}),p}profileStorage(p){if((0,v.isProfileUsingDefaultStorage)(p))return this.applicationStorage;let y=this.n.get(p.id);if(!y){this.c.trace(`StorageMainService: creating profile storage (${p.name})`),y=this.p(p),this.n.set(p.id,y);const D=this.D(y.onDidChangeStorage(t=>this.b.fire({...t,storage:y,profile:p})));(0,L.once)(y.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${p.name})`),this.n.delete(p.id),D.dispose()})}return y}p(p){return this.a===2?new b.InMemoryStorageMain(this.c,this.i):new b.ProfileStorageMain(p,this.k(),this.c,this.i)}workspaceStorage(p){let y=this.q.get(p.id);return y||(this.c.trace(`StorageMainService: creating workspace storage (${p.id})`),y=this.r(p),this.q.set(p.id,y),(0,L.once)(y.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${p.id})`),this.q.delete(p.id)})),y}r(p){return this.a===2?new b.InMemoryStorageMain(this.c,this.i):new b.WorkspaceStorageMain(p,this.k(),this.c,this.f,this.i)}isUsed(p){const y=P.URI.file(p);for(const D of[this.applicationStorage,...this.n.values(),...this.q.values()])if(!!D.path&&this.j.extUri.isEqualOrParent(P.URI.file(D.path),y))return!0;return!1}};r=ye([Z(0,m.ILogService),Z(1,M.IEnvironmentService),Z(2,S.IUserDataProfilesMainService),Z(3,c.ILifecycleMainService),Z(4,k.IFileService),Z(5,w.IUriIdentityService)],r),e.StorageMainService=r,e.IApplicationStorageMainService=(0,f.createDecorator)("applicationStorageMainService");let u=class extends v.AbstractStorageService{constructor(p,y){super(),this.p=p,this.s=y,this.whenReady=this.s.applicationStorage.whenInit}J(){return this.s.applicationStorage.whenInit}L(p){if(p===-1)return this.s.applicationStorage.storage}M(p){if(p===-1)return this.p.defaultProfile.globalStorageHome.fsPath}l(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}N(){throw new Error("Switching storage profile is unsupported from main process")}O(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};u=ye([Z(0,d.IUserDataProfilesService),Z(1,e.IStorageMainService)],u),e.ApplicationStorageMainService=u}),define(ee[273],te([0,1,73,25,100,270,7,2,19,5,21,234,120,91,4]),function(G,e,P,L,o,A,M,k,f,c,m,v,b,d,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function w(y,D,t,a,i){let s;for(let n=3;n&&(s?.dispose(),s=await new r(y,D,t,a,i).waitForReady(),!(i&&o.BROWSER_RESTRICTED_PORTS[i]||!o.BROWSER_RESTRICTED_PORTS[s.tunnelLocalPort]));n--);return s}class r extends k.Disposable{constructor(D,t,a,i,s){super(),this.j=t,this.k=s,this.privacy=b.TunnelPrivacyId.Private,this.i=new Map,this.a=D,this.b=P.createServer(),this.c=new M.Barrier,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=n=>this.l(n),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=i,this.tunnelRemoteHost=a}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.i.values()).forEach(t=>{t()})}async waitForReady(){const D=this.k??this.tunnelRemotePort,t=(0,b.isAllInterfaces)(this.j)?"0.0.0.0":"127.0.0.1";let a=await(0,o.findFreePortFaster)(D,2,1e3,t),i=null;return this.b.listen(a,this.j),await this.c.wait(),i=this.b.address(),i||(a=0,this.b.listen(a,this.j),await this.c.wait(),i=this.b.address()),this.tunnelLocalPort=i.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${i.port}`,this}async l(D){D.pause();const t=(0,b.isLocalhost)(this.tunnelRemoteHost)||(0,b.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,a=await(0,v.connectRemoteAgentTunnel)(this.a,t,this.tunnelRemotePort),i=a.getSocket().socket,s=a.readEntireBuffer();a.dispose(),s.byteLength>0&&D.write(s.buffer),D.on("end",()=>{D.localAddress&&this.i.delete(D.localAddress),i.end()}),D.on("close",()=>i.end()),D.on("error",()=>{D.localAddress&&this.i.delete(D.localAddress),i.destroy()}),i.on("end",()=>D.end()),i.on("close",()=>D.end()),i.on("error",()=>{D.destroy()}),D.pipe(i),i.pipe(D),D.localAddress&&this.i.set(D.localAddress,()=>{D.end(),i.end()})}}let u=class extends b.AbstractTunnelService{constructor(D,t,a,i,s){super(t,s),this.t=D,this.u=a,this.v=i}isPortPrivileged(D){return(0,b.isPortPrivileged)(D,this.k,S.OS,L.release())}r(D,t,a,i,s,n,h,l){const E=this.q(t,a);if(E)return++E.refcount,E.value;if(this.e)return this.s(this.e,t,a,s,n,h,l);{this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${t}:${a} on local port ${s}.`);const R={commit:this.v.commit,quality:this.v.quality,socketFactory:this.t,addressProvider:D,signService:this.u,logService:this.i,ipcLogger:null},C=w(R,i,t,a,s);return this.i.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.o(t,a,C),C}}};u=ye([Z(1,c.ILogService),Z(2,d.ISignService),Z(3,m.IProductService),Z(4,f.IConfigurationService)],u),e.BaseTunnelService=u;let g=class extends u{constructor(D,t,a,i){super(A.nodeSocketFactory,D,t,a,i)}};g=ye([Z(0,c.ILogService),Z(1,d.ISignService),Z(2,m.IProductService),Z(3,f.IConfigurationService)],g),e.TunnelService=g;let p=class extends k.Disposable{constructor(D,t,a,i){super(),this.b=D,this.c=t,this.f=a,this.g=i,this.a=new Map}async openTunnel(D,t,a,i,s,n,h,l,E){if(this.b.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${a}:${i} on local port ${n}.`),!this.a.has(D)){const R=new g(this.b,this.f,this.c,this.g);this.D(R),this.a.set(D,R),R.onTunnelClosed(async()=>{(await R.tunnels).length===0&&(R.dispose(),this.a.delete(D))})}return this.a.get(D).openTunnel(t,a,i,s,n,h,l,E)}};p=ye([Z(0,c.ILogService),Z(1,m.IProductService),Z(2,d.ISignService),Z(3,f.IConfigurationService)],p),e.SharedTunnelsService=p}),define(ee[98],te([0,1,7,22,3,19,29,20,5,21,52,49]),function(G,e,P,L,o,A,M,k,f,c,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function b(S,w,r){return`${r.updateUrl}/api/update/${S}/${w}/${r.commit}`}e.createUpdateURL=b;let d=class{get state(){return this.b}d(w){this.j.info("update#setState",w.type),this.b=w,this.c.fire(w)}constructor(w,r,u,g,p,y){this.f=w,this.g=r,this.h=u,this.i=g,this.j=p,this.k=y,this.b=v.State.Uninitialized,this.c=new o.Emitter,this.onStateChange=this.c.event}async initialize(){if(!this.h.isBuilt)return;if(this.h.disableUpdates){this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.j.info("update#ctor - updates are disabled as there is no update URL");return}const w=this.g.getValue("update.mode"),r=this.l(w);if(!r){this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.r(r),!this.a){this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.d(v.State.Idle(this.p())),w==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}w==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.m(30*1e3).then(void 0,u=>this.j.error(u))}l(w){return w==="none"?void 0:this.k.quality}m(w=60*60*1e3){return(0,P.timeout)(w).then(()=>this.checkForUpdates(!1)).then(()=>this.m(60*60*1e3))}async checkForUpdates(w){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.s(w)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.n(this.state)}async n(w){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.o()}async o(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(w=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${w}`),!w&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.q())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},L.CancellationToken.None)).res.statusCode===204}catch(r){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(r);return}}async _applySpecificUpdate(w){}p(){return 1}q(){}};d=ye([Z(0,k.ILifecycleMainService),Z(1,A.IConfigurationService),Z(2,M.IEnvironmentMainService),Z(3,m.IRequestService),Z(4,f.ILogService),Z(5,c.IProductService)],d),e.AbstractUpdateService=d}),define(ee[274],te([0,1,15,55,3,2,19,29,20,5,21,52,24,49,98]),function(G,e,P,L,o,A,M,k,f,c,m,v,b,d,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let w=class extends S.AbstractUpdateService{get u(){return o.Event.fromNodeEventEmitter(P.autoUpdater,"error",(u,g)=>g)}get v(){return o.Event.fromNodeEventEmitter(P.autoUpdater,"update-not-available")}get w(){return o.Event.fromNodeEventEmitter(P.autoUpdater,"update-available",(u,g,p)=>({url:g,version:p,productVersion:p}))}get x(){return o.Event.fromNodeEventEmitter(P.autoUpdater,"update-downloaded",(u,g,p,y)=>({releaseNotes:g,version:p,productVersion:p,date:y}))}constructor(u,g,p,y,D,t,a){super(u,g,y,D,t,a),this.y=p,this.t=new A.DisposableStore}async initialize(){await super.initialize(),this.u(this.z,this,this.t),this.w(this.C,this,this.t),this.x(this.D,this,this.t),this.v(this.E,this,this.t)}z(u){this.j.error("UpdateService error:",u);const p=(this.state.type==="checking for updates"?this.state.explicit:!0)?u:void 0;this.d(d.State.Idle(1,p))}r(u){let g;this.k.darwinUniversalAssetId?g=this.k.darwinUniversalAssetId:g=process.arch==="x64"?"darwin":"darwin-arm64";const p=(0,S.createUpdateURL)(g,u,this.k);try{P.autoUpdater.setFeedURL({url:p})}catch(y){this.j.error("Failed to set update feed URL",y);return}return p}s(u){this.d(d.State.CheckingForUpdates(u)),P.autoUpdater.checkForUpdates()}C(u){this.state.type==="checking for updates"&&this.d(d.State.Downloading(u))}D(u){this.state.type==="downloading"&&(this.y.publicLog2("update:downloaded",{version:u.version}),this.d(d.State.Ready(u)))}E(){this.state.type==="checking for updates"&&(this.y.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(d.State.Idle(1)))}q(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),P.autoUpdater.quitAndInstall()}dispose(){this.t.dispose()}};ye([L.memoize],w.prototype,"u",null),ye([L.memoize],w.prototype,"v",null),ye([L.memoize],w.prototype,"w",null),ye([L.memoize],w.prototype,"x",null),w=ye([Z(0,f.ILifecycleMainService),Z(1,M.IConfigurationService),Z(2,b.ITelemetryService),Z(3,k.IEnvironmentMainService),Z(4,v.IRequestService),Z(5,c.ILogService),Z(6,m.IProductService)],w),e.DarwinUpdateService=w}),define(ee[275],te([0,1,46,41,7,3,9,29,20,5,24,49]),function(G,e,P,L,o,A,M,k,f,c,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let b=class{get state(){return this.a}d(w){this.g.info("update#setState",w.type),this.a=w,this.b.fire(w)}constructor(w,r,u){if(this.f=w,this.g=u,this.a=v.State.Uninitialized,this.b=new A.Emitter,this.onStateChange=this.b.event,r.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(v.State.Idle(this.k())),this.h(30*1e3).then(void 0,g=>this.g.error(g))}h(w=60*60*1e3){return(0,o.timeout)(w).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(w){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(w)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(w){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(w=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${w}`),!w&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(w){}};b=ye([Z(0,f.ILifecycleMainService),Z(1,k.IEnvironmentMainService),Z(2,c.ILogService)],b);let d=class extends b{constructor(w,r,u,g,p,y){super(u,g,p),this.o=w,this.p=r,this.q=y;const D=(0,L.watch)(M.dirname(this.o)),t=A.Event.fromNodeEventEmitter(D,"change",(n,h)=>h),a=A.Event.filter(t,n=>n==="current"),s=A.Event.debounce(a,(n,h)=>h,2e3)(()=>this.checkForUpdates(!1));u.onWillShutdown(()=>{s.dispose(),D.close()})}m(){this.d(v.State.CheckingForUpdates(!1)),this.u().then(w=>{w?this.d(v.State.Ready({version:"something",productVersion:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(v.State.Idle(2)))},w=>{this.g.error(w),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(v.State.Idle(2,w.message||w))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,P.spawn)("sleep 3 && "+M.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const w=await new Promise((u,g)=>(0,L.realpath)(`${M.dirname(this.o)}/current`,(p,y)=>p?g(p):u(y))),r=M.basename(w);return this.p!==r}isLatestVersion(){return this.u().then(void 0,w=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};d=ye([Z(2,f.ILifecycleMainService),Z(3,k.IEnvironmentMainService),Z(4,c.ILogService),Z(5,m.ITelemetryService)],d),e.SnapUpdateService=d}),define(ee[276],te([0,1,2,20,53,28,7,30]),function(G,e,P,L,o,A,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesHandler=void 0;let f=class extends P.Disposable{constructor(m,v,b){super(),this.a=v,this.b=b,this.D(m.onWillLoadWindow(d=>{d.reason===2&&this.c(d.window)})),this.D(m.onBeforeCloseWindow(d=>this.c(d))),this.D(new M.RunOnceScheduler(()=>this.g(),30*1e3)).schedule()}async c(m){const v=this.f(m),b=this.a.getProfileForWorkspace(v);b?.isTransient&&(this.a.unsetWorkspace(v,b.isTransient),b.isTransient&&await this.a.cleanUpTransientProfiles())}f(m){return m.openedWorkspace??(0,A.toWorkspaceIdentifier)(m.backupPath,m.isExtensionDevelopmentHost)}g(){const m=this.a.getAssociatedEmptyWindows();if(m.length===0)return;const v=this.b.getWindows().map(b=>this.f(b));for(const b of m)v.some(d=>d.id===b.id)||this.a.unsetWorkspace(b,!1)}};f=ye([Z(0,L.ILifecycleMainService),Z(1,o.IUserDataProfilesMainService),Z(2,k.IWindowsMainService)],f),e.UserDataProfilesHandler=f}),define(ee[70],te([0,1,15,2,3,5,277,7,14,30,76,24,20,74,37]),function(G,e,P,L,o,A,M,k,f,c,m,v,b,d,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowUtilityProcess=e.UtilityProcess=void 0;function w(g){return typeof g.responseWindowId=="number"}let r=class ut extends L.Disposable{static getAll(){return Array.from(ut.b.values())}constructor(p,y,D){super(),this.n=p,this.p=y,this.q=D,this.c=String(++ut.a),this.f=this.D(new o.Emitter),this.onStdout=this.f.event,this.g=this.D(new o.Emitter),this.onStderr=this.g.event,this.h=this.D(new o.Emitter),this.onMessage=this.h.event,this.i=this.D(new o.Emitter),this.onExit=this.i.event,this.j=this.D(new o.Emitter),this.onCrash=this.j.event,this.k=void 0,this.l=void 0,this.m=void 0}r(p,y){let D;switch(this.m?.correlationId?D=`[UtilityProcess id: ${this.m?.correlationId}, type: ${this.m?.type}, pid: ${this.l??"<none>"}]: ${p}`:D=`[UtilityProcess type: ${this.m?.type}, pid: ${this.l??"<none>"}]: ${p}`,y){case m.default.Error:this.n.error(D);break;case m.default.Warning:this.n.warn(D);break;case m.default.Info:this.n.info(D);break}}s(){return this.k?(this.r("Cannot start utility process because it is already running...",m.default.Error),!1):!0}start(p){const y=this.t(p,!1);return y&&p.payload&&this.postMessage(p.payload),y}t(p,y){if(!this.s())return!1;this.m=p;const D=`${this.m.type}-${this.c}`,t=f.FileAccess.asFileUri("bootstrap-fork.js").fsPath,a=this.m.args??[],i=this.m.execArgv??[],s=this.m.allowLoadingUnsignedLibraries,n="pipe",h=this.u(p,y);return this.r("creating new...",m.default.Info),this.k=P.utilityProcess.fork(t,a,{serviceName:D,env:h,execArgv:i,allowLoadingUnsignedLibraries:s,stdio:n}),this.v(this.k,this.m,D,y),!0}u(p,y){const D=p.env?{...p.env}:{...(0,S.deepClone)(process.env)};D.VSCODE_AMD_ENTRYPOINT=p.entryPoint,typeof p.parentLifecycleBound=="number"&&(D.VSCODE_PARENT_PID=String(p.parentLifecycleBound)),y&&(D.VSCODE_CRASH_REPORTER_SANDBOXED_HINT="1"),D.VSCODE_CRASH_REPORTER_PROCESS_TYPE=p.type,(0,d.removeDangerousEnvVariables)(D);for(const t of Object.keys(D))D[t]=String(D[t]);return D}v(p,y,D,t){if(p.stdout){const a=new M.StringDecoder("utf-8");this.D(o.Event.fromNodeEventEmitter(p.stdout,"data")(i=>this.f.fire(typeof i=="string"?i:a.write(i))))}if(p.stderr){const a=new M.StringDecoder("utf-8");this.D(o.Event.fromNodeEventEmitter(p.stderr,"data")(i=>this.g.fire(typeof i=="string"?i:a.write(i))))}this.D(o.Event.fromNodeEventEmitter(p,"message")(a=>this.h.fire(a))),this.D(o.Event.fromNodeEventEmitter(p,"spawn")(()=>{this.l=p.pid,typeof p.pid=="number"&&ut.b.set(p.pid,{pid:p.pid,name:w(y)?`${y.type} [${y.responseWindowId}]`:y.type}),this.r("successfully created",m.default.Info)})),this.D(o.Event.fromNodeEventEmitter(p,"exit")(a=>{this.r(`received exit event with code ${a}`,m.default.Info),this.i.fire({pid:this.l,code:a,signal:"unknown"}),this.w()})),this.D(o.Event.fromNodeEventEmitter(P.app,"child-process-gone",(a,i)=>({event:a,details:i}))(({details:a})=>{a.type==="Utility"&&a.name===D&&(this.r(`crashed with code ${a.exitCode} and reason '${a.reason}'`,m.default.Error),this.p.publicLog2("utilityprocesscrash",{type:y.type,reason:a.reason,code:a.exitCode,sandboxed:t?"1":"0"}),this.j.fire({pid:this.l,code:a.exitCode,reason:a.reason}),this.w())}))}once(p,y){const D=this.D(this.h.event(t=>{t===p&&(D.dispose(),y())}))}postMessage(p,y){!this.k||this.k.postMessage(p,y)}connect(p){const{port1:y,port2:D}=new P.MessageChannelMain;return this.postMessage(p,[D]),y}enableInspectPort(){if(!this.k||typeof this.l!="number")return!1;this.r("enabling inspect port",m.default.Info);const p=process;return typeof p._debugProcess=="function"?(p._debugProcess(this.l),!0):!1}kill(){if(!this.k)return;this.r("attempting to kill the process...",m.default.Info),this.k.kill()?(this.r("successfully killed the process",m.default.Info),this.w()):this.r("unable to kill the process",m.default.Warning)}w(){typeof this.l=="number"&&ut.b.delete(this.l),this.k=void 0}async waitForExit(p){!this.k||(this.r("waiting to exit...",m.default.Info),await Promise.race([o.Event.toPromise(this.onExit),(0,k.timeout)(p)]),this.k&&(this.r(`did not exit within ${p}ms, will kill it now...`,m.default.Info),this.kill()))}};r.a=0,r.b=new Map,r=ye([Z(0,A.ILogService),Z(1,v.ITelemetryService),Z(2,b.ILifecycleMainService)],r),e.UtilityProcess=r;let u=class extends r{constructor(p,y,D,t){super(p,D,t),this.y=y}start(p){const y=this.y.getWindowById(p.responseWindowId);if(!y?.win||y.win.isDestroyed()||y.win.webContents.isDestroyed())return this.r("Refusing to start utility process because requesting window cannot be found or is destroyed...",m.default.Error),!0;if(!super.t(p,y.isSandboxed))return!1;this.z(y.win,p);const t=this.connect(p.payload);return y.win.webContents.postMessage(p.responseChannel,p.responseNonce,[t]),!0}z(p,y){y.windowLifecycleBound&&(this.D(o.Event.filter(this.q.onWillLoadWindow,D=>D.window.win===p)(()=>this.kill())),this.D(o.Event.fromNodeEventEmitter(p,"closed")(()=>this.kill())))}};u=ye([Z(0,A.ILogService),Z(1,c.IWindowsMainService),Z(2,v.ITelemetryService),Z(3,b.ILifecycleMainService)],u),e.WindowUtilityProcess=u}),define(ee[278],te([0,1,13,2,3,5,20,75,46,277,7,14,37,4,36,70,30,24]),function(G,e,P,L,o,A,M,k,f,c,m,v,b,d,S,w,r,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;let g=class Pt{constructor(D,t,a,i){this.d=D,this.f=t,this.g=a,this.h=i,this.c=!1,this.b=new Map,this.f.onWillShutdown(s=>{this.c=!0,s.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}i(D){const t=this.b.get(D);if(!t)throw new Error("Unknown extension host!");return t}onDynamicStdout(D){return this.i(D).onStdout}onDynamicStderr(D){return this.i(D).onStderr}onDynamicMessage(D){return this.i(D).onMessage}onDynamicError(D){const t=this.i(D);return t instanceof w.WindowUtilityProcess?o.Event.None:t.onError}onDynamicExit(D){return this.i(D).onExit}async createExtensionHost(D){if(this.c)throw(0,P.canceled)();const t=String(++Pt.a);let a;return D?a=new w.WindowUtilityProcess(this.d,this.g,this.h,this.f):a=new p(t,this.d),this.b.set(t,a),a.onExit(({pid:i,code:s,signal:n})=>{this.d.info(`Extension host with pid ${i} exited with code: ${s}, signal: ${n}.`),setTimeout(()=>{a.dispose(),this.b.delete(t)})}),{id:t}}async start(D,t){if(this.c)throw(0,P.canceled)();this.i(D).start({...t,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:t.execArgv,allowLoadingUnsignedLibraries:!0,correlationId:D})}async enableInspectPort(D){if(this.c)throw(0,P.canceled)();const t=this.b.get(D);return t?t.enableInspectPort():!1}async kill(D){if(this.c)throw(0,P.canceled)();const t=this.b.get(D);!t||t.kill()}async _killAllNow(){for(const[,D]of this.b)D.kill()}async _waitForAllExit(D){const t=[];for(const[,a]of this.b)t.push(a.waitForExit(D));return m.Promises.settled(t).then(()=>{})}};g.a=0,g=ye([Z(0,A.ILogService),Z(1,M.ILifecycleMainService),Z(2,r.IWindowsMainService),Z(3,u.ITelemetryService)],g),e.ExtensionHostStarter=g;let p=class extends L.Disposable{constructor(D,t){super(),this.id=D,this.c=t,this._onStdout=this.D(new o.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this.D(new o.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this.D(new o.Emitter),this.onMessage=this._onMessage.event,this._onError=this.D(new o.Emitter),this.onError=this._onError.event,this._onExit=this.D(new o.Emitter),this.onExit=this._onExit.event,this.a=null,this.b=!1}start(D){d.isCI&&this.c.info("Calling fork to start extension host...");const t=k.StopWatch.create(!1);this.a=(0,f.fork)(v.FileAccess.asFileUri("bootstrap-fork").fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],(0,b.mixin)({cwd:(0,S.cwd)()},D));const a=t.elapsed(),i=this.a.pid;this.c.info(`Starting extension host with pid ${i} (fork() took ${a} ms).`);const s=new c.StringDecoder("utf-8");this.a.stdout?.on("data",h=>{const l=typeof h=="string"?h:s.write(h);this._onStdout.fire(l)});const n=new c.StringDecoder("utf-8");this.a.stderr?.on("data",h=>{const l=typeof h=="string"?h:n.write(h);this._onStderr.fire(l)}),this.a.on("message",h=>{this._onMessage.fire(h)}),this.a.on("error",h=>{this._onError.fire({error:(0,P.transformErrorForSerialization)(h)})}),this.a.on("exit",(h,l)=>{this.b=!0,this._onExit.fire({pid:i,code:h,signal:l})})}enableInspectPort(){return this.a?(this.c.info(`Enabling inspect port on extension host with pid ${this.a.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this.a.pid),!0):d.isWindows?!1:(this.a.kill("SIGUSR1"),!0)):!1}kill(){!this.a||(this.c.info(`Killing extension host with pid ${this.a.pid}.`),this.a.kill())}async waitForExit(D){if(!this.a)return;const t=this.a.pid;this.c.info(`Waiting for extension host with pid ${t} to exit.`),await Promise.race([o.Event.toPromise(this.onExit),(0,m.timeout)(D)]),this.b||(this.c.info(`Extension host with pid ${t} did not exit within ${D}ms.`),this.a.kill())}};p=ye([Z(1,A.ILogService)],p)}),define(ee[279],te([0,1,15,42,7,3,2,14,11,105,29,20,5,66,67,69,44,40,38,65,70,19,48,108]),function(G,e,P,L,o,A,M,k,f,c,m,v,b,d,S,w,r,u,g,p,y,D,t,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let i=class extends M.Disposable{constructor(n,h,l,E,R,C,T,N,z,B,_){super(),this.i=n,this.j=h,this.k=l,this.l=E,this.m=R,this.n=C,this.q=T,this.r=N,this.s=z,this.t=B,this.u=_,this.a=this.D(new A.Emitter),this.onDidError=A.Event.buffer(this.a.event),this.b=new o.Barrier,this.c=void 0,this.f=void 0,this.g=void 0,this.h=(()=>{let ne=!1;const ae=this.u.getValue("window.experimental.sharedProcessUseUtilityProcess");return typeof ae=="boolean"?ne=ae:ne=d.default.quality!=="stable",ne})(),this.F=void 0,this.G=void 0,this.v(),this.h&&this.n.info("[SharedProcess] using utility process")}v(){L.validatedIpcMain.on("vscode:createSharedProcessMessageChannel",(n,h)=>this.w(n,h)),L.validatedIpcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(n,h)=>this.y(n,h)),this.D(this.m.onWillShutdown(()=>this.z()))}async w(n,h){this.n.trace("[SharedProcess] on vscode:createSharedProcessMessageChannel"),this.b.isOpen()||this.b.open(),await this.whenReady();const l=await this.connect();if(n.sender.isDestroyed())return l.close();n.sender.postMessage("vscode:createSharedProcessMessageChannelResult",h,[l])}y(n,h){this.n.trace("[SharedProcess] onWorkerConnection",h);const l=new M.DisposableStore,E=C=>{!this.O()||(this.n.trace(`[SharedProcess] disposing worker (reason: '${C}')`,h),l.dispose(),this.C("vscode:electron-main->shared-process=disposeWorker",h))},R=P.BrowserWindow.fromId(h.reply.windowId);if(!R||R.isDestroyed()||R.webContents.isDestroyed()||!h.reply.channel){E("unavailable");return}l.add(A.Event.filter(this.m.onWillLoadWindow,C=>C.window.win===R)(()=>E("load"))),l.add(A.Event.fromNodeEventEmitter(R,"closed")(()=>E("closed"))),R.webContents.postMessage(h.reply.channel,h.reply.nonce,n.ports)}z(){if(this.n.trace("[SharedProcess] onWillShutdown"),this.g)this.g.postMessage("vscode:electron-main->shared-process=exit"),this.g=void 0;else{const n=this.c;if(!n)return;this.C("vscode:electron-main->shared-process=exit"),this.f&&(n.removeListener("close",this.f),this.f=void 0),setTimeout(()=>{try{this.n.trace("[SharedProcess] onWillShutdown window.close()"),n.close()}catch(h){this.n.trace(`[SharedProcess] onWillShutdown window.close() error: ${h}`)}this.c=void 0},0)}}C(n,...h){if(!this.O()){this.n.warn(`Sending IPC message to channel '${n}' for shared process that is destroyed`);return}try{this.c?.webContents.send(n,...h)}catch(l){this.n.warn(`Error sending IPC message to channel '${n}' of shared process: ${(0,r.toErrorMessage)(l)}`)}}whenReady(){return this.F||(this.F=(async()=>{await this.H;const n=new o.DeferredPromise;this.g?this.g.once("vscode:shared-process->electron-main=init-done",()=>n.complete()):L.validatedIpcMain.once("vscode:shared-process->electron-main=init-done",()=>n.complete()),await n.p,this.n.trace("[SharedProcess] Overall ready")})()),this.F}get H(){return this.G||(this.G=(async()=>{await this.b.wait(),this.I();const n=new o.DeferredPromise;this.g?this.g.once("vscode:shared-process->electron-main=ipc-ready",()=>n.complete()):L.validatedIpcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>n.complete()),await n.p,this.n.trace("[SharedProcess] IPC ready")})()),this.G}I(){this.h?this.J():this.L(),this.N()}J(){this.g=this.D(new y.UtilityProcess(this.n,t.NullTelemetryService,this.m));const n=(0,a.parseSharedProcessDebugPort)(this.k.args,this.k.isBuilt);let h;n.port&&(h=["--nolazy"],n.break?h.push(`--inspect-brk=${n.port}`):h.push(`--inspect=${n.port}`)),this.g.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.M(),execArgv:h})}L(){const n=this.D(this.t.createIPCObjectUrl());this.c=new P.BrowserWindow({show:!1,backgroundColor:this.s.getBackgroundColor(),title:"shared-process",webPreferences:{preload:k.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${n.resource.toString()}`],v8CacheOptions:this.k.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,images:!1,webgl:!1}}),n.update(this.M()),this.c.loadURL(k.FileAccess.asBrowserUri(`vs/code/node/sharedProcess/sharedProcess${this.k.isBuilt?"":"-dev"}.html`).toString(!0))}M(){return{machineId:this.i,windowId:this.c?.id??-1,appRoot:this.k.appRoot,codeCachePath:this.k.codeCachePath,profiles:{home:this.l.profilesHome,all:this.l.profiles},userEnv:this.j,args:this.k.args,logLevel:this.q.getLogLevel(),loggers:this.q.getRegisteredLoggers(),product:d.default,policiesData:this.r.serialize()}}N(){this.c?(this.f=n=>{this.n.trace("SharedProcess#close prevented"),n.preventDefault(),this.c?.isVisible()&&this.c.hide()},this.c.on("close",this.f),this.c.webContents.on("render-process-gone",(n,h)=>this.a.fire({type:2,details:h})),this.c.on("unresponsive",()=>this.a.fire({type:1})),this.c.webContents.on("did-fail-load",(n,h,l)=>this.a.fire({type:3,details:{reason:l,exitCode:h}}))):this.g&&this.D(this.g.onCrash(n=>this.a.fire({type:2,details:{reason:n.reason,exitCode:n.code}})))}async connect(){return await this.H,this.g?this.g.connect():(0,c.connect)((0,f.assertIsDefined)(this.c))}async toggle(){await this.H,this.c&&(this.c.isVisible()?(this.c.webContents.closeDevTools(),this.c.hide()):(this.c.show(),this.c.webContents.openDevTools()))}isVisible(){return this.c?.isVisible()??!1}usingUtilityProcess(){return!!this.g}O(){const n=this.c;return n?!n.isDestroyed()&&!n.webContents.isDestroyed():!1}};i=ye([Z(2,m.IEnvironmentMainService),Z(3,u.IUserDataProfilesService),Z(4,v.ILifecycleMainService),Z(5,b.ILogService),Z(6,p.ILoggerMainService),Z(7,g.IPolicyService),Z(8,w.IThemeMainService),Z(9,S.IProtocolMainService),Z(10,D.IConfigurationService)],i),e.SharedProcess=i}),define(ee[280],te([0,1,2,6,5,30,70,24,56,3,7,20]),function(G,e,P,L,o,A,M,k,f,c,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UtilityProcessWorkerMainService=e.IUtilityProcessWorkerMainService=void 0,e.IUtilityProcessWorkerMainService=(0,L.createDecorator)("utilityProcessWorker");let b=class extends P.Disposable{constructor(w,r,u,g){super(),this.b=w,this.c=r,this.f=u,this.g=g,this.a=new Map}async createWorker(w){const r=`window: ${w.reply.windowId}, moduleId: ${w.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${r})`);const u=this.h(w);this.a.has(u)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${r})`),this.disposeWorker(w));const g=new d(this.b,this.c,this.f,this.g,w);if(!g.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set(u,g);const p=new m.DeferredPromise;return c.Event.once(g.onDidTerminate)(y=>{y.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${y.code}, signal: ${y.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${y.code}, signal: ${y.signal}`),this.a.delete(u),p.complete({reason:y})}),p.p}h(w){return(0,f.hash)({moduleId:w.process.moduleId,windowId:w.reply.windowId})}async disposeWorker(w){const r=this.h(w),u=this.a.get(r);!u||(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${w.reply.windowId}, moduleId: ${w.process.moduleId})`),u.kill(),this.a.delete(r))}};b=ye([Z(0,o.ILogService),Z(1,A.IWindowsMainService),Z(2,k.ITelemetryService),Z(3,v.ILifecycleMainService)],b),e.UtilityProcessWorkerMainService=b;let d=class extends P.Disposable{constructor(w,r,u,g,p){super(),this.c=w,this.f=r,this.g=u,this.h=g,this.i=p,this.a=this.D(new c.Emitter),this.onDidTerminate=this.a.event,this.b=new M.WindowUtilityProcess(this.c,this.f,this.g,this.h),this.j()}j(){this.D(this.b.onExit(w=>this.a.fire({code:w.code,signal:w.signal}))),this.D(this.b.onCrash(w=>this.a.fire({code:w.code,signal:"ECRASH"})))}spawn(){const r=this.f.getWindowById(this.i.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.i.process.type,entryPoint:this.i.process.moduleId,parentLifecycleBound:r,windowLifecycleBound:!0,correlationId:`${this.i.reply.windowId}`,responseWindowId:this.i.reply.windowId,responseChannel:this.i.reply.channel,responseNonce:this.i.reply.nonce})}kill(){this.b.kill()}};d=ye([Z(0,o.ILogService),Z(1,A.IWindowsMainService),Z(2,k.ITelemetryService),Z(3,v.ILifecycleMainService)],d)}),define(ee[281],te([0,1,15,2,4,18,8,19,20,5,33,30,122,28]),function(G,e,P,L,o,A,M,k,f,c,m,v,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let S=class vt extends L.Disposable{get state(){return this.b}constructor(y,D,t,a,i){super(),this.g=y,this.h=D,this.i=t,this.j=a,this.k=i,this.b=w(this.h.getItem(vt.a)),this.c=void 0,this.f=!1,this.l()}l(){P.app.on("browser-window-blur",()=>{this.f||this.n()}),this.i.onBeforeCloseWindow(y=>this.p(y)),this.i.onBeforeShutdown(()=>this.m()),this.g.onDidChangeWindowsCount(y=>{y.newCount-y.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(y=>this.p(y))}m(){this.f=!0,this.n()}n(){const y=new Set,D={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!D.lastActiveWindow){let i=this.g.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.g.getWindows().find(s=>!s.isExtensionDevelopmentHost)),i&&(D.lastActiveWindow=this.q(i),D.lastActiveWindow.uiState.mode===3&&y.add(D.lastActiveWindow.uiState.display))}const t=this.g.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);t&&(D.lastPluginDevelopmentHostWindow=this.q(t),D.lastPluginDevelopmentHostWindow.uiState.mode===3&&(y.has(D.lastPluginDevelopmentHostWindow.uiState.display)?o.isMacintosh&&!t.win?.isSimpleFullScreen()&&(D.lastPluginDevelopmentHostWindow.uiState.mode=1):y.add(D.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(D.openedWindows=this.g.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const s=this.q(i);return s.uiState.mode===3&&(y.has(s.uiState.display)?o.isMacintosh&&s.windowId!==D.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(s.uiState.mode=1):y.add(s.uiState.display)),s}));const a=u(D);this.h.setItem(vt.a,a),this.f&&this.j.trace("[WindowsStateHandler] onBeforeShutdown",a)}p(y){if(this.i.quitRequested)return;const D=this.q(y);y.isExtensionDevelopmentHost&&!y.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=D:!y.isExtensionDevelopmentHost&&y.openedWorkspace&&this.b.openedWindows.forEach(t=>{const a=(0,d.isWorkspaceIdentifier)(y.openedWorkspace)&&t.workspace?.id===y.openedWorkspace.id,i=(0,d.isSingleFolderWorkspaceIdentifier)(y.openedWorkspace)&&t.folderUri&&A.extUriBiasedIgnorePathCase.isEqual(t.folderUri,y.openedWorkspace.uri);(a||i)&&(t.uiState=D.uiState)}),this.g.getWindowCount()===1&&(this.c=D)}q(y){return{windowId:y.id,workspace:(0,d.isWorkspaceIdentifier)(y.openedWorkspace)?y.openedWorkspace:void 0,folderUri:(0,d.isSingleFolderWorkspaceIdentifier)(y.openedWorkspace)?y.openedWorkspace.uri:void 0,backupPath:y.backupPath,remoteAuthority:y.remoteAuthority,uiState:y.serializeWindowState()}}getNewWindowState(y){const D=this.r(y),t=this.k.getValue("window");if(D.mode===3){let a;D.hasDefaultState?a=!!(t?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(t.newWindowDimensions)>=0):a=!!(this.i.wasRestarted||t?.restoreFullscreen),a||(D.mode=1)}return D}r(y){const D=this.g.getLastActiveWindow();if(!y.extensionTestsPath){if(!!y.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const h=y.workspace;if((0,d.isWorkspaceIdentifier)(h)){const E=this.state.openedWindows.filter(R=>R.workspace&&R.workspace.id===h.id).map(R=>R.uiState);if(E.length)return E[0]}if((0,d.isSingleFolderWorkspaceIdentifier)(h)){const E=this.state.openedWindows.filter(R=>R.folderUri&&A.extUriBiasedIgnorePathCase.isEqual(R.folderUri,h.uri)).map(R=>R.uiState);if(E.length)return E[0]}else if(y.backupPath){const E=this.state.openedWindows.filter(R=>R.backupPath===y.backupPath).map(R=>R.uiState);if(E.length)return E[0]}const l=this.c||this.state.lastActiveWindow;if(!D&&l)return l.uiState}let t;const a=P.screen.getAllDisplays();if(a.length===1)t=a[0];else{if(o.isMacintosh){const h=P.screen.getCursorScreenPoint();t=P.screen.getDisplayNearestPoint(h)}!t&&D&&(t=P.screen.getDisplayMatching(D.getBounds())),t||(t=P.screen.getPrimaryDisplay()||a[0])}let i=(0,b.defaultWindowState)();i.x=Math.round(t.bounds.x+t.bounds.width/2-i.width/2),i.y=Math.round(t.bounds.y+t.bounds.height/2-i.height/2);const s=this.k.getValue("window");let n=!0;if(s?.newWindowDimensions){if(s.newWindowDimensions==="maximized")i.mode=0,n=!1;else if(s.newWindowDimensions==="fullscreen")i.mode=3,n=!1;else if((s.newWindowDimensions==="inherit"||s.newWindowDimensions==="offset")&&D){const h=D.serializeWindowState();h.mode===3?i.mode=3:i=h,n=i.mode!==3&&s.newWindowDimensions==="offset"}}return n&&(i=this.s(i)),i.hasDefaultState=!0,i}s(y){if(this.g.getWindows().length===0)return y;y.x=typeof y.x=="number"?y.x:0,y.y=typeof y.y=="number"?y.y:0;const D=this.g.getWindows().map(t=>t.getBounds());for(;D.some(t=>t.x===y.x||t.y===y.y);)y.x+=30,y.y+=30;return y}};S.a="windowsState",S=ye([Z(0,v.IWindowsMainService),Z(1,m.IStateService),Z(2,f.ILifecycleMainService),Z(3,c.ILogService),Z(4,k.IConfigurationService)],S),e.WindowsStateHandler=S;function w(p){const y={openedWindows:[]},D=p||{openedWindows:[]};return D.lastActiveWindow&&(y.lastActiveWindow=r(D.lastActiveWindow)),D.lastPluginDevelopmentHostWindow&&(y.lastPluginDevelopmentHostWindow=r(D.lastPluginDevelopmentHostWindow)),Array.isArray(D.openedWindows)&&(y.openedWindows=D.openedWindows.map(t=>r(t))),y}e.restoreWindowsState=w;function r(p){const y={uiState:p.uiState};return p.backupPath&&(y.backupPath=p.backupPath),p.remoteAuthority&&(y.remoteAuthority=p.remoteAuthority),p.folder&&(y.folderUri=M.URI.parse(p.folder)),p.workspaceIdentifier&&(y.workspace={id:p.workspaceIdentifier.id,configPath:M.URI.parse(p.workspaceIdentifier.configURIPath)}),y}function u(p){return{lastActiveWindow:p.lastActiveWindow&&g(p.lastActiveWindow),lastPluginDevelopmentHostWindow:p.lastPluginDevelopmentHostWindow&&g(p.lastPluginDevelopmentHostWindow),openedWindows:p.openedWindows.map(y=>g(y))}}e.getWindowsStateStoreData=u;function g(p){return{workspaceIdentifier:p.workspace&&{id:p.workspace.id,configURIPath:p.workspace.configPath.toString()},folder:p.folderUri&&p.folderUri.toString(),backupPath:p.backupPath,remoteAuthority:p.remoteAuthority,uiState:p.uiState}}}),define(ee[54],te([0,1,15,3,43,2,14,9,18,11,23,187,63,58,29,6,5,53,124,28,94,95]),function(G,e,P,L,o,A,M,k,f,c,m,v,b,d,S,w,r,u,g,p,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,w.createDecorator)("workspacesManagementMainService");let t=class extends A.Disposable{constructor(i,s,n,h,l){super(),this.g=i,this.h=s,this.i=n,this.j=h,this.k=l,this.a=this.D(new L.Emitter),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.D(new L.Emitter),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const i=(await m.Promises.readdir(this.c.fsPath)).map(s=>(0,f.joinPath)(this.c,s,p.UNTITLED_WORKSPACE_NAME));for(const s of i){const n=(0,D.getWorkspaceIdentifier)(s),h=await this.resolveLocalWorkspace(s);h?this.f.push({workspace:n,remoteAuthority:h.remoteAuthority}):await this.deleteUntitledWorkspace(n)}}catch(i){i.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${i}).`)}}resolveLocalWorkspace(i){return this.l(i,s=>m.Promises.readFile(s,"utf8"))}l(i,s){if(!!this.m(i)&&i.scheme===M.Schemas.file)try{const n=s(i.fsPath);return n instanceof Promise?n.then(h=>this.n(i,h),h=>{}):this.n(i,n)}catch{return}}m(i){return(0,p.isUntitledWorkspace)(i,this.g)||(0,p.hasWorkspaceFileExtension)(i)}n(i,s){try{const n=this.p(i,s),h=(0,D.getWorkspaceIdentifier)(i);return{id:h.id,configPath:h.configPath,folders:(0,y.toWorkspaceFolders)(n.folders,h.configPath,f.extUriBiasedIgnorePathCase),remoteAuthority:n.remoteAuthority,transient:n.transient}}catch(n){this.h.warn(n.toString())}}p(i,s){const n=(0,o.parse)(s);if(n&&Array.isArray(n.folders))n.folders=n.folders.filter(h=>(0,y.isStoredWorkspaceFolder)(h));else throw new Error(`${i.toString(!0)} looks like an invalid workspace file.`);return n}async createUntitledWorkspace(i,s){const{workspace:n,storedWorkspace:h}=this.q(i,s),l=n.configPath.fsPath;return await m.Promises.mkdir((0,k.dirname)(l),{recursive:!0}),await m.Promises.writeFile(l,JSON.stringify(h,null,"	")),this.f.push({workspace:n,remoteAuthority:s}),n}q(i=[],s){const n=(Date.now()+Math.round(Math.random()*1e3)).toString(),h=(0,f.joinPath)(this.c,n),l=(0,f.joinPath)(h,p.UNTITLED_WORKSPACE_NAME),E=[];for(const R of i)E.push((0,y.getStoredWorkspaceFolder)(R.uri,!0,R.name,h,f.extUriBiasedIgnorePathCase));return{workspace:(0,D.getWorkspaceIdentifier)(l),storedWorkspace:{folders:E,remoteAuthority:s}}}async getWorkspaceIdentifier(i){return(0,D.getWorkspaceIdentifier)(i)}isUntitledWorkspace(i){return(0,p.isUntitledWorkspace)(i.configPath,this.g)}async deleteUntitledWorkspace(i){!this.isUntitledWorkspace(i)||(await this.r(i),this.i.isEnabled()&&this.i.unsetWorkspace(i),this.a.fire(i))}async r(i){const s=(0,f.originalFSPath)(i.configPath);try{await m.Promises.rm((0,k.dirname)(s));const n=(0,k.join)(this.g.workspaceStorageHome.fsPath,i.id);await m.Promises.exists(n)&&await m.Promises.writeFile((0,k.join)(n,"obsolete"),""),this.f=this.f.filter(h=>h.workspace.id!==i.id)}catch(n){this.h.warn(`Unable to delete untitled workspace ${s} (${n}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(i,s,n){if(!i||!i.win||!i.isReady||!await this.s(i,s,n))return;const l=await this.t(i,(0,D.getWorkspaceIdentifier)(n));if(!!l)return this.b.fire({window:i,workspace:l.workspace}),l}async s(i,s,n){return n?(0,p.isWorkspaceIdentifier)(i.openedWorkspace)&&f.extUriBiasedIgnorePathCase.isEqual(i.openedWorkspace.configPath,n)?!1:(0,g.findWindowOnWorkspaceOrFolder)(s,n)?(await this.k.showMessageBox({type:"info",buttons:[(0,v.localize)(0,null)],message:(0,v.localize)(1,null,(0,f.basename)(n)),detail:(0,v.localize)(2,null)},(0,c.withNullAsUndefined)(P.BrowserWindow.getFocusedWindow())),!1):!0:!0}async t(i,s){if(!i.config)return;i.focus();let n;return i.config.extensionDevelopmentPath||(i.config.backupPath?n=await this.j.registerWorkspaceBackup({workspace:s,remoteAuthority:i.remoteAuthority},i.config.backupPath):n=this.j.registerWorkspaceBackup({workspace:s,remoteAuthority:i.remoteAuthority})),(0,p.isWorkspaceIdentifier)(i.openedWorkspace)&&this.isUntitledWorkspace(i.openedWorkspace)&&await this.deleteUntitledWorkspace(i.openedWorkspace),i.config.workspace=s,i.config.backupPath=n,{workspace:s,backupPath:n}}};t=ye([Z(0,S.IEnvironmentMainService),Z(1,r.ILogService),Z(2,u.IUserDataProfilesMainService),Z(3,b.IBackupMainService),Z(4,d.IDialogMainService)],t),e.WorkspacesManagementMainService=t}),define(ee[125],te([0,1,15,42,22,6,30,28,54,11,5,70]),function(G,e,P,L,o,A,M,k,f,c,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,A.createDecorator)(e.ID);let b=class{constructor(S,w,r){this.a=S,this.b=w,this.c=r}async getRemoteDiagnostics(S){const w=this.a.getWindows();return(await Promise.all(w.map(async u=>{const g=u.remoteAuthority;if(!g)return;const p=`vscode:getDiagnosticInfoResponse${u.id}`,y={includeProcesses:S.includeProcesses,folders:S.includeWorkspaceMetadata?await this.f(u):void 0};return new Promise(D=>{u.sendWhenReady("vscode:getDiagnosticInfo",o.CancellationToken.None,{replyChannel:p,args:y}),L.validatedIpcMain.once(p,(t,a)=>{a||D({hostName:g,errorMessage:`Unable to resolve connection to '${g}'.`}),D(a)}),setTimeout(()=>{D({hostName:g,errorMessage:`Connection to '${g}' could not be established`})},5e3)})}))).filter(u=>!!u)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const S=[];for(const r of P.BrowserWindow.getAllWindows()){const u=this.a.getWindowById(r.id);u?S.push(await this.d(u)):S.push(this.e(r))}const w=[];for(const{pid:r,name:u}of v.UtilityProcess.getAll())w.push({pid:r,name:u});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:S,pidToNames:w,screenReader:!!P.app.accessibilitySupportEnabled,gpuFeatureStatus:P.app.getGPUFeatureStatus()}}async d(S){const w=await this.f(S),r=(0,c.assertIsDefined)(S.win);return this.e(r,w,S.remoteAuthority)}e(S,w=[],r){return{id:S.id,pid:S.webContents.getOSProcessId(),title:S.getTitle(),folderURIs:w,remoteAuthority:r}}async f(S){const w=[],r=S.openedWorkspace;if((0,k.isSingleFolderWorkspaceIdentifier)(r))w.push(r.uri);else if((0,k.isWorkspaceIdentifier)(r)){const u=await this.b.resolveLocalWorkspace(r.configPath);u&&u.folders.forEach(p=>{w.push(p.uri)})}return w}};b=ye([Z(0,M.IWindowsMainService),Z(1,f.IWorkspacesManagementMainService),Z(2,m.ILogService)],b),e.DiagnosticsMainService=b}),define(ee[59],te([0,1,46,15,25,150,55,3,2,14,9,4,8,102,85,23,100,177,58,29,6,20,5,21,69,30,28,54,17,235,229,33]),function(G,e,P,L,o,A,M,k,f,c,m,v,b,d,S,w,r,u,g,p,y,D,t,a,i,s,n,h,l,E,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,y.createDecorator)("nativeHostMainService");let T=class extends f.Disposable{constructor(z,B,_,ne,ae,he,ce,J,Y,q){super(),this.a=z,this.b=B,this.c=_,this.f=ne,this.g=ae,this.h=he,this.i=ce,this.j=J,this.k=Y,this.l=q,this.onDidOpenWindow=k.Event.map(this.b.onDidOpenWindow,W=>W.id),this.onDidTriggerSystemContextMenu=k.Event.filter(k.Event.map(this.b.onDidTriggerSystemContextMenu,({window:W,x:H,y:Q})=>({windowId:W.id,x:H,y:Q})),({windowId:W})=>!!this.b.getWindowById(W)),this.onDidMaximizeWindow=k.Event.filter(k.Event.fromNodeEventEmitter(L.app,"browser-window-maximize",(W,H)=>H.id),W=>!!this.b.getWindowById(W)),this.onDidUnmaximizeWindow=k.Event.filter(k.Event.fromNodeEventEmitter(L.app,"browser-window-unmaximize",(W,H)=>H.id),W=>!!this.b.getWindowById(W)),this.onDidBlurWindow=k.Event.filter(k.Event.fromNodeEventEmitter(L.app,"browser-window-blur",(W,H)=>H.id),W=>!!this.b.getWindowById(W)),this.onDidFocusWindow=k.Event.any(k.Event.map(k.Event.filter(k.Event.map(this.b.onDidChangeWindowsCount,()=>this.b.getLastActiveWindow()),W=>!!W),W=>W.id),k.Event.filter(k.Event.fromNodeEventEmitter(L.app,"browser-window-focus",(W,H)=>H.id),W=>!!this.b.getWindowById(W))),this.onDidResumeOS=k.Event.fromNodeEventEmitter(L.powerMonitor,"resume"),this.onDidChangeColorScheme=this.j.onDidChangeColorScheme,this.m=this.D(new k.Emitter),this.onDidChangePassword=this.m.event,this.onDidChangeDisplay=k.Event.debounce(k.Event.any(k.Event.filter(k.Event.fromNodeEventEmitter(L.screen,"display-metrics-changed",(W,H,Q)=>Q),W=>!(Array.isArray(W)&&W.length===1&&W[0]==="workArea")),k.Event.fromNodeEventEmitter(L.screen,"display-added"),k.Event.fromNodeEventEmitter(L.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.b.getWindows().map(B=>({id:B.id,workspace:B.openedWorkspace??(0,n.toWorkspaceIdentifier)(B.backupPath,B.isExtensionDevelopmentHost),title:B.win?.getTitle()??"",filename:B.getRepresentedFilename(),dirty:B.isDocumentEdited()}))}async getWindowCount(z){return this.b.getWindowCount()}async getActiveWindowId(z){const B=L.BrowserWindow.getFocusedWindow()||this.b.getLastActiveWindow();if(B)return B.id}openWindow(z,B,_){return Array.isArray(B)?this.n(z,B,_):this.p(z,B)}async n(z,B,_=Object.create(null)){B.length>0&&await this.b.open({context:5,contextWindowId:z,urisToOpen:B,cli:this.g.args,forceNewWindow:_.forceNewWindow,forceReuseWindow:_.forceReuseWindow,preferNewWindow:_.preferNewWindow,diffMode:_.diffMode,mergeMode:_.mergeMode,addMode:_.addMode,gotoLineMode:_.gotoLineMode,noRecentEntry:_.noRecentEntry,waitMarkerFileURI:_.waitMarkerFileURI,remoteAuthority:_.remoteAuthority||void 0,forceProfile:_.forceProfile,forceTempProfile:_.forceTempProfile})}async p(z,B){await this.b.openEmptyWindow({context:5,contextWindowId:z},B)}async toggleFullScreen(z){this.v(z)?.toggleFullScreen()}async handleTitleDoubleClick(z){this.v(z)?.handleTitleDoubleClick()}async isMaximized(z){const B=this.v(z);return B?.win?B.win.isMaximized():!1}async maximizeWindow(z){const B=this.v(z);B?.win&&B.win.maximize()}async unmaximizeWindow(z){const B=this.v(z);B?.win&&B.win.unmaximize()}async minimizeWindow(z){const B=this.v(z);B?.win&&B.win.minimize()}async updateWindowControls(z,B){const _=this.v(z);_&&_.updateWindowControls(B)}async focusWindow(z,B){B&&typeof B.windowId=="number"&&(z=B.windowId),this.v(z)?.focus({force:B?.force??!1})}async setMinimumSize(z,B,_){const ne=this.v(z);if(ne?.win){const[ae,he]=ne.win.getSize(),[ce,J]=ne.win.getMinimumSize(),[Y,q]=[B??ce,_??J],[W,H]=[Math.max(ae,Y),Math.max(he,q)];(ce!==Y||J!==q)&&ne.win.setMinimumSize(Y,q),(ae!==W||he!==H)&&ne.win.setSize(W,H)}}async saveWindowSplash(z,B){this.j.saveWindowSplash(z,B)}async installShellCommand(z){const{source:B,target:_}=await this.q();try{const{symbolicLink:ne}=await w.SymlinkSupport.stat(B);if(ne&&!ne.dangling){const ae=await(0,d.realpath)(B);if(_===ae)return}await w.Promises.unlink(B)}catch(ne){if(ne.code!=="ENOENT")throw ne}try{await w.Promises.symlink(_,B)}catch(ne){if(ne.code!=="EACCES"&&ne.code!=="ENOENT")throw ne;const{response:ae}=await this.showMessageBox(z,{type:"info",message:(0,u.localize)(0,null,this.i.nameShort),buttons:[(0,u.localize)(1,null),(0,u.localize)(2,null)]});if(ae===0)try{const he=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${_}' '${B}'\\" with administrator privileges"`;await(0,A.promisify)(P.exec)(he)}catch{throw new Error((0,u.localize)(3,null,B))}}}async uninstallShellCommand(z){const{source:B}=await this.q();try{await w.Promises.unlink(B)}catch(_){switch(_.code){case"EACCES":{const{response:ne}=await this.showMessageBox(z,{type:"info",message:(0,u.localize)(4,null,this.i.nameShort),buttons:[(0,u.localize)(5,null),(0,u.localize)(6,null)]});if(ne===0)try{const ae=`osascript -e "do shell script \\"rm '${B}'\\" with administrator privileges"`;await(0,A.promisify)(P.exec)(ae)}catch{throw new Error((0,u.localize)(7,null,B))}break}case"ENOENT":break;default:throw _}}}async q(){const z=(0,m.resolve)(this.g.appRoot,"bin","code"),B=`/usr/local/bin/${this.i.applicationName}`;if(!await w.Promises.exists(z))throw new Error((0,u.localize)(8,null,z));return{source:B,target:z}}async showMessageBox(z,B){return this.c.showMessageBox(B,this.r(z))}async showSaveDialog(z,B){return this.c.showSaveDialog(B,this.r(z))}async showOpenDialog(z,B){return this.c.showOpenDialog(B,this.r(z))}r(z){const B=this.v(z);if(B?.win)return B.win}async pickFileFolderAndOpen(z,B){const _=await this.c.pickFileFolder(B);_&&await this.s(await Promise.all(_.map(async ne=>await w.SymlinkSupport.existsDirectory(ne)?{folderUri:b.URI.file(ne)}:{fileUri:b.URI.file(ne)})),B,z)}async pickFolderAndOpen(z,B){const _=await this.c.pickFolder(B);_&&await this.s(_.map(ne=>({folderUri:b.URI.file(ne)})),B,z)}async pickFileAndOpen(z,B){const _=await this.c.pickFile(B);_&&await this.s(_.map(ne=>({fileUri:b.URI.file(ne)})),B,z)}async pickWorkspaceAndOpen(z,B){const _=await this.c.pickWorkspace(B);_&&await this.s(_.map(ne=>({workspaceUri:b.URI.file(ne)})),B,z)}async s(z,B,_){await this.b.open({context:3,contextWindowId:_,cli:this.g.args,urisToOpen:z,forceNewWindow:B.forceNewWindow})}async showItemInFolder(z,B){L.shell.showItemInFolder(B)}async setRepresentedFilename(z,B){this.v(z)?.setRepresentedFilename(B)}async setDocumentEdited(z,B){this.v(z)?.setDocumentEdited(B)}async openExternal(z,B){return v.isLinuxSnap?this.t(B):L.shell.openExternal(B),!0}t(z){const B=process.env.GDK_PIXBUF_MODULE_FILE,_=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,L.shell.openExternal(z),process.env.GDK_PIXBUF_MODULE_FILE=B,process.env.GDK_PIXBUF_MODULEDIR=_}moveItemToTrash(z,B){return L.shell.trashItem(B)}async isAdmin(){let z;return v.isWindows?z=(await new Promise((B,_)=>{G(["native-is-elevated"],B,_)}))():z=process.getuid()===0,z}async writeElevated(z,B,_,ne){const ae=await new Promise((he,ce)=>{G(["@vscode/sudo-prompt"],he,ce)});return new Promise((he,ce)=>{const J=[`"${this.u}"`];ne?.unlock&&J.push("--file-chmod"),J.push("--file-write",`"${B.fsPath}"`,`"${_.fsPath}"`);const Y={name:this.i.nameLong.replace("-",""),icns:v.isMacintosh&&this.g.isBuilt?(0,m.join)((0,m.dirname)(this.g.appRoot),`${this.i.nameShort}.icns`):void 0};ae.exec(J.join(" "),Y,(q,W,H)=>{W&&this.h.trace(`[sudo-prompt] received stdout: ${W}`),H&&this.h.trace(`[sudo-prompt] received stderr: ${H}`),q?ce(q):he(void 0)})})}get u(){return v.isWindows?this.g.isBuilt?(0,m.join)((0,m.dirname)(process.execPath),"bin",`${this.i.applicationName}.cmd`):(0,m.join)(this.g.appRoot,"scripts","code-cli.bat"):v.isLinux?this.g.isBuilt?(0,m.join)((0,m.dirname)(process.execPath),"bin",`${this.i.applicationName}`):(0,m.join)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,m.join)(this.g.appRoot,"bin","code"):(0,m.join)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,o.totalmem)(),freemem:(0,o.freemem)(),loadavg:(0,o.loadavg)()}}async getOSProperties(){return{arch:(0,o.arch)(),platform:(0,o.platform)(),release:(0,o.release)(),type:(0,o.type)(),cpus:(0,o.cpus)()}}async getOSVirtualMachineHint(){return S.virtualMachineHint.value()}async getOSColorScheme(){return this.j.getColorScheme()}async hasWSLFeatureInstalled(){return v.isWindows&&(0,E.hasWSLFeatureInstalled)()}async killProcess(z,B,_){process.kill(B,_)}async readClipboardText(z,B){return L.clipboard.readText(B)}async writeClipboardText(z,B,_){return L.clipboard.writeText(B,_)}async readClipboardFindText(z){return L.clipboard.readFindText()}async writeClipboardFindText(z,B){return L.clipboard.writeFindText(B)}async writeClipboardBuffer(z,B,_,ne){return L.clipboard.writeBuffer(B,Buffer.from(_.buffer),ne)}async readClipboardBuffer(z,B){return l.VSBuffer.wrap(L.clipboard.readBuffer(B))}async hasClipboard(z,B,_){return L.clipboard.has(B,_)}async newWindowTab(){await this.b.open({context:5,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){L.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){L.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){L.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){L.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){L.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(z,B){this.v(z)?.updateTouchBar(B)}async notifyReady(z){this.v(z)?.setReady()}async relaunch(z,B){return this.f.relaunch(B)}async reload(z,B){const _=this.v(z);if(_){if((0,n.isWorkspaceIdentifier)(_.openedWorkspace)){const ne=_.openedWorkspace.configPath;if(ne.scheme===c.Schemas.file&&(await this.l.resolveLocalWorkspace(ne))?.transient)return this.openWindow(_.id,{forceReuseWindow:!0})}return this.f.reload(_,B?.disableExtensions!==void 0?{_:[],"disable-extensions":B.disableExtensions}:void 0)}}async closeWindow(z){this.closeWindowById(z,z)}async closeWindowById(z,B){const _=this.v(B);if(_?.win)return _.win.close()}async quit(z){const B=this.b.getLastActiveWindow();B?.isExtensionDevelopmentHost&&this.b.getWindowCount()>1&&B.win?B.win.close():this.f.quit()}async exit(z,B){await this.f.kill(B)}async resolveProxy(z,B){return this.v(z)?.win?.webContents?.session?.resolveProxy(B)}findFreePort(z,B,_,ne,ae=1){return(0,r.findFreePort)(B,_,ne,ae)}async openDevTools(z,B){const _=this.v(z);_?.win&&_.win.webContents.openDevTools(B)}async toggleDevTools(z){const B=this.v(z);B?.win&&B.win.webContents.toggleDevTools()}async sendInputEvent(z,B){const _=this.v(z);_?.win&&(B.type==="mouseDown"||B.type==="mouseUp")&&_.win.webContents.sendInputEvent(B)}async enableSandbox(z,B){B?this.k.setItem("window.experimental.useSandbox",!0):this.k.removeItem("window.experimental.useSandbox")}async toggleSharedProcessWindow(){return this.a.toggle()}async profileRenderer(z,B,_){const ne=this.v(z);if(!ne||!ne.win)throw new Error;return await new R.WindowProfiler(ne.win,B,this.h).inspect(_)}async windowsGetStringRegKey(z,B,_,ne){if(!v.isWindows)return;const ae=await new Promise((he,ce)=>{G(["@vscode/windows-registry"],he,ce)});try{return ae.GetStringRegKey(B,_,ne)}catch{return}}v(z){if(typeof z=="number")return this.b.getWindowById(z)}};ye([M.memoize],T.prototype,"u",null),T=ye([Z(1,s.IWindowsMainService),Z(2,g.IDialogMainService),Z(3,D.ILifecycleMainService),Z(4,p.IEnvironmentMainService),Z(5,t.ILogService),Z(6,a.IProductService),Z(7,i.IThemeMainService),Z(8,C.IStateService),Z(9,h.IWorkspacesManagementMainService)],T),e.NativeHostMainService=T}),define(ee[282],te([0,1,15,42,25,2,14,4,103,175,87,125,58,29,6,5,59,66,21,67,80,32,11,33,70]),function(G,e,P,L,o,A,M,k,f,c,m,v,b,d,S,w,r,u,g,p,y,D,t,a,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,S.createDecorator)("issueMainService");const s="issue.processExplorerWindowState";let n=class kt{constructor(E,R,C,T,N,z,B,_,ne,ae){this.g=E,this.h=R,this.i=C,this.j=T,this.k=N,this.l=z,this.m=B,this.n=_,this.o=ne,this.p=ae,this.b=null,this.c=null,this.d=null,this.f=null,this.q()}q(){L.validatedIpcMain.on("vscode:issueSystemInfoRequest",async E=>{const[R,C]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),T=await this.j.getSystemInfo(R,C);this.r(E,"vscode:issueSystemInfoResponse",T)}),L.validatedIpcMain.on("vscode:listProcesses",async E=>{const R=[];try{R.push({name:(0,c.localize)(0,null),rootProcess:await(0,f.listProcesses)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(T=>{(0,m.isRemoteDiagnosticError)(T)?R.push({name:T.hostName,rootProcess:T}):T.processes&&R.push({name:T.hostName,rootProcess:T.processes})})}catch(C){this.i.error(`Listing processes failed: ${C}`)}this.r(E,"vscode:listProcessesResponse",R)}),L.validatedIpcMain.on("vscode:issueReporterClipboard",async E=>{if(this.b){const{response:R}=await this.l.showMessageBox({type:"warning",message:(0,c.localize)(1,null),buttons:[(0,c.localize)(2,null),(0,c.localize)(3,null)]},this.b);this.r(E,"vscode:issueReporterClipboardResponse",R===0)}}),L.validatedIpcMain.on("vscode:issuePerformanceInfoRequest",async E=>{const R=await this.v();this.r(E,"vscode:issuePerformanceInfoResponse",R)}),L.validatedIpcMain.on("vscode:issueReporterConfirmClose",async()=>{if(this.b){const{response:E}=await this.l.showMessageBox({type:"warning",message:(0,c.localize)(4,null),buttons:[(0,c.localize)(5,null),(0,c.localize)(6,null)]},this.b);E===0&&this.b&&(this.b.destroy(),this.b=null)}}),L.validatedIpcMain.on("vscode:workbenchCommand",(E,R)=>{const{id:C,from:T,args:N}=R;let z;switch(T){case"issueReporter":z=this.c;break;case"processExplorer":z=this.f;break;default:throw new Error(`Unexpected command source: ${T}`)}z?.webContents.send("vscode:runAction",{id:C,from:T,args:N})}),L.validatedIpcMain.on("vscode:openExternal",(E,R)=>{this.m.openExternal(void 0,R)}),L.validatedIpcMain.on("vscode:closeIssueReporter",E=>{this.b?.close()}),L.validatedIpcMain.on("vscode:closeProcessExplorer",E=>{this.d?.close()}),L.validatedIpcMain.on("vscode:pidToNameRequest",async E=>{const R=await this.k.getMainDiagnostics(),C=[];for(const T of R.windows)C.push([T.pid,`window [${T.id}] (${T.title})`]);for(const{pid:T,name:N}of i.UtilityProcess.getAll())C.push([T,N]);this.r(E,"vscode:pidToNameResponse",C)})}r(E,R,...C){E.sender.isDestroyed()||E.sender.send(R,...C)}async openReporter(E){if(!this.b&&(this.c=P.BrowserWindow.getFocusedWindow(),this.c)){const R=new A.DisposableStore,C=R.add(this.n.createIPCObjectUrl()),T=this.u(this.c,700,800);this.b=this.t(T,C,{backgroundColor:E.styles.backgroundColor,title:(0,c.localize)(7,null),zoomLevel:E.zoomLevel,alwaysOnTop:!1},"issue-reporter"),C.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:E,disableExtensions:!!this.h.disableExtensions,os:{type:(0,o.type)(),arch:(0,o.arch)(),release:(0,o.release)()},product:u.default}),this.b.loadURL(M.FileAccess.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,R.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,R.dispose())})}this.b&&this.s(this.b)}async openProcessExplorer(E){if(!this.d&&(this.f=P.BrowserWindow.getFocusedWindow(),this.f)){const R=new A.DisposableStore,C=R.add(this.n.createIPCObjectUrl()),T=this.p.getItem(s,void 0),N=h(T)?T:this.u(this.f,800,500);this.d=this.t(N,C,{backgroundColor:E.styles.backgroundColor,title:(0,c.localize)(8,null),zoomLevel:E.zoomLevel,alwaysOnTop:!0},"process-explorer"),C.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:E,product:u.default}),this.d.loadURL(M.FileAccess.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,R.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,R.dispose())});const z=()=>{if(!this.d)return;const B=this.d.getSize(),_=this.d.getPosition();if(!B||!_)return;const ne={width:B[0],height:B[1],x:_[0],y:_[1]};this.p.setItem(s,ne)};this.d.on("moved",z),this.d.on("resized",z)}this.d&&this.s(this.d)}s(E){E.isMinimized()&&E.restore(),E.focus()}t(E,R,C,T){const N=new P.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:E.width,height:E.height,minWidth:300,minHeight:200,x:E.x,y:E.y,title:C.title,backgroundColor:C.backgroundColor||kt.a,webPreferences:{preload:M.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${R.resource.toString()}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,y.zoomLevelToZoomFactor)(C.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:C.alwaysOnTop,experimentalDarkMode:!0});return N.setMenuBarVisibility(!1),N}async getSystemStatus(){const[E,R]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(E,R)}u(E,R,C){let T;const N=P.screen.getAllDisplays();if(N.length===1)T=N[0];else{if(k.isMacintosh){const _=P.screen.getCursorScreenPoint();T=P.screen.getDisplayNearestPoint(_)}!T&&E&&(T=P.screen.getDisplayMatching(E.getBounds())),T||(T=P.screen.getPrimaryDisplay()||N[0])}const z=T.bounds,B={width:R,height:C,x:z.x+z.width/2-R/2,y:z.y+z.height/2-C/2};return z.width>0&&z.height>0&&(B.x<z.x&&(B.x=z.x),B.y<z.y&&(B.y=z.y),B.x>z.x+z.width&&(B.x=z.x),B.y>z.y+z.height&&(B.y=z.y),B.width>z.width&&(B.width=z.width),B.height>z.height&&(B.height=z.height)),B}async v(){try{const[E,R]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(E,R)}catch(E){throw this.i.warn("issueService#getPerformanceInfo ",E.message),E}}async stopTracing(){if(!this.h.args.trace)return;const E=await P.contentTracing.stopRecording(`${(0,D.randomPath)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({type:"info",message:(0,c.localize)(9,null),detail:(0,c.localize)(10,null,E),buttons:[(0,c.localize)(11,null)]},(0,t.withNullAsUndefined)(P.BrowserWindow.getFocusedWindow())),this.m.showItemInFolder(void 0,E)}};n.a="#1E1E1E",n=ye([Z(1,d.IEnvironmentMainService),Z(2,w.ILogService),Z(3,m.IDiagnosticsService),Z(4,v.IDiagnosticsMainService),Z(5,b.IDialogMainService),Z(6,r.INativeHostMainService),Z(7,p.IProtocolMainService),Z(8,g.IProductService),Z(9,a.IStateService)],n),e.IssueMainService=n;function h(l){return typeof l!="object"||l===null?!1:"x"in l&&"y"in l&&"width"in l&&"height"in l}}),define(ee[283],te([0,1,22,19,29,20,5,59,21,52,24,49,98]),function(G,e,P,L,o,A,M,k,f,c,m,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let d=class extends b.AbstractUpdateService{constructor(w,r,u,g,p,y,D,t){super(w,r,g,p,y,t),this.e=u,this.t=D}r(w){return(0,b.createUpdateURL)(`linux-${process.arch}`,w,this.k)}s(w){!this.a||(this.d(v.State.CheckingForUpdates(w)),this.i.request({url:this.a},P.CancellationToken.None).then(c.asJson).then(r=>{!r||!r.url||!r.version||!r.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!w}),this.d(v.State.Idle(1))):this.d(v.State.AvailableForDownload(r))}).then(void 0,r=>{this.j.error(r),this.e.publicLog2("update:notAvailable",{explicit:!!w});const u=w?r.message||r:void 0;this.d(v.State.Idle(1,u))}))}async n(w){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.t.openExternal(void 0,this.k.downloadUrl):w.update.url&&this.t.openExternal(void 0,w.update.url),this.d(v.State.Idle(1))}};d=ye([Z(0,A.ILifecycleMainService),Z(1,L.IConfigurationService),Z(2,m.ITelemetryService),Z(3,o.IEnvironmentMainService),Z(4,c.IRequestService),Z(5,M.ILogService),Z(6,k.INativeHostMainService),Z(7,f.IProductService)],d),e.LinuxUpdateService=d}),define(ee[284],te([0,1,46,41,25,7,22,55,9,8,136,23,19,29,16,20,5,59,21,52,24,49,98]),function(G,e,P,L,o,A,M,k,f,c,m,v,b,d,S,w,r,u,g,p,y,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function a(h,l=1e3){for(;!h();)await(0,A.timeout)(l)}let i;function s(){return typeof i>"u"&&(i=L.existsSync(f.join(f.dirname(process.execPath),"unins000.exe"))?0:1),i}let n=class extends t.AbstractUpdateService{get cachePath(){const l=f.join((0,o.tmpdir)(),`vscode-update-${this.k.target}-${process.arch}`);return v.Promises.mkdir(l,{recursive:!0}).then(()=>l)}constructor(l,E,R,C,T,N,z,B,_){super(l,E,C,T,N,_),this.t=R,this.u=z,this.v=B}async initialize(){if(this.k.target==="user"&&await this.v.isAdmin(void 0)){this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}super.initialize()}r(l){let E="win32";return process.arch!=="ia32"&&(E+=`-${process.arch}`),s()===1?E+="-archive":this.k.target==="user"&&(E+="-user"),(0,t.createUpdateURL)(E,l,this.k)}s(l){!this.a||(this.d(D.State.CheckingForUpdates(l)),this.i.request({url:this.a},M.CancellationToken.None).then(p.asJson).then(E=>{const R=s();return!E||!E.url||!E.version||!E.productVersion?(this.t.publicLog2("update:notAvailable",{explicit:!!l}),this.d(D.State.Idle(R)),Promise.resolve(null)):R===1?(this.d(D.State.AvailableForDownload(E)),Promise.resolve(null)):(this.d(D.State.Downloading(E)),this.A(E.version).then(()=>this.z(E.version).then(C=>v.Promises.exists(C).then(T=>{if(T)return Promise.resolve(C);const N=E.url,z=E.hash,B=`${C}.tmp`;return this.i.request({url:N},M.CancellationToken.None).then(_=>this.u.writeFile(c.URI.file(B),_.stream)).then(z?()=>(0,m.checksum)(B,E.hash):()=>{}).then(()=>v.Promises.rename(B,C)).then(()=>C)})).then(C=>{const T=this.g.getValue("update.enableWindowsBackgroundUpdates");this.e={packagePath:C},T&&E.supportsFastUpdate?this.k.target==="user"?this.o():this.d(D.State.Downloaded(E)):this.d(D.State.Ready(E))})))}).then(void 0,E=>{this.j.error(E),this.t.publicLog2("update:notAvailable",{explicit:!!l});const R=l?E.message||E:void 0;this.d(D.State.Idle(s(),R))}))}async n(l){l.update.url&&this.v.openExternal(void 0,l.update.url),this.d(D.State.Idle(s()))}async z(l){const E=await this.cachePath;return f.join(E,`CodeSetup-${this.k.quality}-${l}.exe`)}async A(l=null){const E=l?N=>!new RegExp(`${this.k.quality}-${l}\\.exe$`).test(N):()=>!0,R=await this.cachePath,T=(await v.Promises.readdir(R)).filter(E).map(async N=>{try{await v.Promises.unlink(f.join(R,N))}catch{}});await Promise.all(T)}async o(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.e)return Promise.resolve(void 0);const l=this.state.update;this.d(D.State.Updating(l));const E=await this.cachePath;this.e.updateFilePath=f.join(E,`CodeSetup-${this.k.quality}-${l.version}.flag`),await v.Promises.writeFile(this.e.updateFilePath,"flag"),(0,P.spawn)(this.e.packagePath,["/verysilent",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(D.State.Idle(s()))});const C=`${this.k.win32MutexName}-ready`,T=await new Promise((N,z)=>{G(["windows-mutex"],N,z)});a(()=>T.isActive(C)).then(()=>this.d(D.State.Ready(l)))}q(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.e.updateFilePath?L.unlinkSync(this.e.updateFilePath):(0,P.spawn)(this.e.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}p(){return s()}async _applySpecificUpdate(l){if(this.state.type!=="idle")return;const E=this.g.getValue("update.enableWindowsBackgroundUpdates"),R={version:"unknown",productVersion:"unknown",supportsFastUpdate:!!E};this.d(D.State.Downloading(R)),this.e={packagePath:l},E?this.k.target==="user"?this.o():this.d(D.State.Downloaded(R)):this.d(D.State.Ready(R))}};ye([k.memoize],n.prototype,"cachePath",null),n=ye([Z(0,w.ILifecycleMainService),Z(1,b.IConfigurationService),Z(2,y.ITelemetryService),Z(3,d.IEnvironmentMainService),Z(4,p.IRequestService),Z(5,r.ILogService),Z(6,S.IFileService),Z(7,u.INativeHostMainService),Z(8,g.IProductService)],n),e.Win32UpdateService=n}),define(ee[285],te([0,1,15,7,22,44,3,2,14,9,64,4,8,183,63,19,58,29,62,16,20,5,21,67,242,97,24,135,69,80,30,28,54,122,126,38,33,53,59,244,118,48,92,25,119,65]),function(G,e,P,L,o,A,M,k,f,c,m,v,b,d,S,w,r,u,g,p,y,D,t,a,i,s,n,h,l,E,R,C,T,N,z,B,_,ne,ae,he,ce,J,Y,q,W,H){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var Q;(function(re){re[re.NONE=0]="NONE",re[re.NAVIGATING=1]="NAVIGATING",re[re.READY=2]="READY"})(Q||(Q={}));let se=class ot extends k.Disposable{get id(){return this.k}get win(){return this.l}get lastFocusTime(){return this.m}get isSandboxed(){return this.n}get backupPath(){return this.q?.backupPath}get openedWorkspace(){return this.q?.workspace}get profile(){if(!this.config)return;const F=this.Q.profiles.find(I=>I.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&F?F:this.Q.getProfileForWorkspace(this.config.workspace??(0,C.toWorkspaceIdentifier)(this.backupPath,this.isExtensionDevelopmentHost))??this.Q.defaultProfile}get remoteAuthority(){return this.q?.remoteAuthority}get config(){return this.q}get isExtensionDevelopmentHost(){return!!this.q?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.q?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.q?.debugId}constructor(F,I,O,U,j,x,$,V,K,oe,fe,Ce,Ee,Re,Oe,ze,ge,pe,Le,ie,ue){super(),this.M=I,this.N=O,this.O=U,this.P=j,this.Q=x,this.R=$,this.S=V,this.U=K,this.W=oe,this.X=fe,this.Y=Ce,this.Z=Ee,this.ab=Re,this.bb=Oe,this.db=ze,this.eb=ge,this.fb=pe,this.gb=Le,this.hb=ie,this.ib=ue,this.c=this.D(new M.Emitter),this.onWillLoad=this.c.event,this.f=this.D(new M.Emitter),this.onDidSignalReady=this.f.event,this.g=this.D(new M.Emitter),this.onDidTriggerSystemContextMenu=this.g.event,this.h=this.D(new M.Emitter),this.onDidClose=this.h.event,this.j=this.D(new M.Emitter),this.onDidDestroy=this.j.event,this.m=-1,this.n=!1,this.t=void 0,this.u=void 0,this.z=!1,this.C=[],this.F=[],this.G=void 0,this.H=void 0,this.I=this.D(this.fb.createIPCObjectUrl()),this.L=!1,this.jb=0;let de=!1;{const[Pe,Me]=this.ub(F.state);this.r=Pe,this.M.trace("window#ctor: using window state",Pe);const Te=this.r.mode===0||this.r.mode===3;typeof ot.b>"u"&&(ot.b=this.hb.getItem("window.experimental.useSandbox",!1));const Fe=this.W.getValue("window");typeof Fe?.experimental?.useSandbox=="boolean"?de=Fe.experimental.useSandbox:this.eb.quality==="stable"&&ot.b?de=!0:de=typeof this.eb.quality=="string"&&this.eb.quality!=="stable",this.n=de;const je={width:this.r.width,height:this.r.height,x:this.r.x,y:this.r.y,backgroundColor:this.X.getBackgroundColor(),minWidth:E.WindowMinimumSize.WIDTH,minHeight:E.WindowMinimumSize.HEIGHT,show:!Te,title:this.eb.nameLong,webPreferences:{preload:f.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.I.resource.toString()}`],v8CacheOptions:this.O.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,E.zoomLevelToZoomFactor)(Fe?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",...de?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}},experimentalDarkMode:!0};v.isLinux?je.icon=(0,c.join)(this.O.appRoot,"resources/linux/code.png"):v.isWindows&&!this.O.isBuilt&&(je.icon=(0,c.join)(this.O.appRoot,"resources/win32/code_150x150.png")),v.isMacintosh&&!this.Bb()&&(je.fullscreenable=!1),v.isMacintosh&&(je.acceptFirstMouse=!0,Fe?.clickThroughInactive===!1&&(je.acceptFirstMouse=!1));const Be=v.isMacintosh&&Fe?.nativeTabs===!0;Be&&(je.tabbingIdentifier=this.eb.nameShort);const We=(0,E.getTitleBarStyle)(this.W)==="custom";if(We&&(je.titleBarStyle="hidden",v.isMacintosh||(je.frame=!1),(0,E.useWindowControlsOverlay)(this.W))){const He=this.X.getWindowSplash()?.colorInfo.titleBarBackground??this.X.getBackgroundColor(),X=z.Color.fromHex(He).isDarker()?"#FFFFFF":"#000000";je.titleBarOverlay={height:29,color:He,symbolColor:X},this.z=!0}if((0,m.mark)("code/willCreateCodeBrowserWindow"),this.l=new P.BrowserWindow(je),(0,m.mark)("code/didCreateCodeBrowserWindow"),this.k=this.l.id,v.isMacintosh&&We&&this.l.setSheetOffset(22),We&&(v.isWindows&&(0,E.useWindowControlsOverlay)(this.W)||v.isMacintosh)){const He=this.hb.getItem(ot.a);He&&this.updateWindowControls({height:He})}v.isWindows&&We&&this.l.hookWindowMessage(278,()=>{const[X,le]=this.l.getPosition(),me=P.screen.getCursorScreenPoint(),ve=me.x-X,we=me.y-le;return(()=>!(ve>30&&we>=0&&we<=Math.max(this.l.getBounds().height*.15,35)))()||(this.l.setEnabled(!1),this.l.setEnabled(!0),this.g.fire({x:ve,y:we})),0}),(v.isMacintosh||v.isWindows)&&Me&&(!Be||P.BrowserWindow.getAllWindows().length===1)&&[this.r.width,this.r.height,this.r.x,this.r.y].every(He=>typeof He=="number")&&this.l.setBounds({width:this.r.width,height:this.r.height,x:this.r.x,y:this.r.y}),Te&&((0,m.mark)("code/willMaximizeCodeWindow"),this.l.maximize(),this.r.mode===3&&this.xb(!0),this.l.show(),(0,m.mark)("code/didMaximizeCodeWindow")),this.m=Date.now()}this.O.args["open-devtools"]===!0&&this.l.webContents.openDevTools(),this.rb(),this.Fb(),this.kb(de)}setRepresentedFilename(F){v.isMacintosh?this.l.setRepresentedFilename(F):this.v=F}getRepresentedFilename(){return v.isMacintosh?this.l.getRepresentedFilename():this.v}setDocumentEdited(F){v.isMacintosh&&this.l.setDocumentEdited(F),this.w=F}isDocumentEdited(){return v.isMacintosh?this.l.isDocumentEdited():!!this.w}focus(F){v.isMacintosh&&F?.force&&P.app.focus({steal:!0}),this.l&&(this.l.isMinimized()&&this.l.restore(),this.l.focus())}setReady(){for(this.M.trace(`window#load: window reported ready (id: ${this.k})`),this.jb=2;this.C.length;)this.C.pop()(this);this.f.fire()}ready(){return new Promise(F=>{if(this.isReady)return F(this);this.C.push(F)})}get isReady(){return this.jb===2}get whenClosedOrLoaded(){return new Promise(F=>{function I(){O.dispose(),U.dispose(),F()}const O=this.onDidClose(()=>I()),U=this.onWillLoad(()=>I())})}kb(F){this.l.on("unresponsive",()=>this.nb(1,{sandboxed:F})),this.l.webContents.on("render-process-gone",(O,U)=>this.nb(2,{...U,sandboxed:F})),this.l.webContents.on("did-fail-load",(O,U,j)=>this.nb(3,{reason:j,exitCode:U,sandboxed:F})),this.l.webContents.on("will-prevent-unload",O=>{O.preventDefault()}),this.l.on("closed",()=>{this.h.fire(),this.dispose()}),this.l.webContents.on("did-finish-load",()=>{this.J&&(this.q=this.J,this.J=void 0)}),this.l.on("focus",()=>{this.m=Date.now()}),this.l.on("maximize",O=>{this.q&&(this.q.maximized=!0),P.app.emit("browser-window-maximize",O,this.l)}),this.l.on("unmaximize",O=>{this.q&&(this.q.maximized=!1),P.app.emit("browser-window-unmaximize",O,this.l)}),this.l.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",o.CancellationToken.None),this.u?.complete(),this.u=void 0}),this.l.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",o.CancellationToken.None),this.u?.complete(),this.u=void 0}),this.D(this.W.onDidChangeConfiguration(O=>this.rb(O))),this.D(this.Y.onDidDeleteUntitledWorkspace(O=>this.qb(O)));const I=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.l.webContents.session.webRequest.onBeforeSendHeaders({urls:I},async(O,U)=>{const j=await this.mb();U({cancel:!1,requestHeaders:Object.assign(O.requestHeaders,j)})})}mb(){return this.lb||(this.lb=(0,i.resolveMarketplaceHeaders)(this.eb.version,this.eb,this.O,this.W,this.R,this.S,this.ab)),this.lb}async nb(F,I){switch(F){case 2:this.M.error(`CodeWindow: renderer process gone (reason: ${I?.reason||"<unknown>"}, code: ${I?.exitCode||"<unknown>"})`);break;case 1:this.M.error("CodeWindow: detected unresponsive");break;case 3:this.M.error(`CodeWindow: failed to load (reason: ${I?.reason||"<unknown>"}, code: ${I?.exitCode||"<unknown>"})`);break}switch(this.ab.publicLog2("windowerror",{type:F,reason:I?.reason,code:I?.exitCode,sandboxed:I?.sandboxed?"1":"0"}),F){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.db.kill(1);return}if(this.O.args["enable-smoke-test-driver"]){await this.pb(!1,!1),this.db.quit();return}if(F===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.l&&this.l.webContents&&this.l.webContents.isDevToolsOpened())return;const{response:O,checkboxChecked:U}=await this.bb.showMessageBox({type:"warning",buttons:[(0,d.localize)(0,null),(0,d.localize)(1,null),(0,d.localize)(2,null)],message:(0,d.localize)(3,null),detail:(0,d.localize)(4,null),checkboxLabel:this.q?.workspace?(0,d.localize)(5,null):void 0},this.l);if(O!==2){const j=O===0;await this.pb(j,U)}}else if(F===2)if(v.isWindows&&I?.reason==="launch-failed"&&I.exitCode===18&&await this.ib.isAdmin(void 0))await this.ob(I);else{let O;I?O=(0,d.localize)(7,null,I.reason,I.exitCode??"<unknown>"):O=(0,d.localize)(6,null);const{response:U,checkboxChecked:j}=await this.bb.showMessageBox({type:"warning",buttons:[this.q?.workspace?(0,d.localize)(8,null):(0,d.localize)(9,null),(0,d.localize)(10,null)],message:O,detail:this.q?.workspace?(0,d.localize)(11,null):(0,d.localize)(12,null),checkboxLabel:this.q?.workspace?(0,d.localize)(13,null):void 0},this.l),x=U===0;await this.pb(x,j)}break}}async ob(F){const I=[],O=(0,J.isInternalTelemetry)(this.eb,this.W);if((0,J.supportsTelemetry)(this.eb,this.O)){this.eb.aiConfig&&this.eb.aiConfig.ariaKey&&I.push(new he.OneDataSystemAppender(O,"monacoworkbench",null,this.eb.aiConfig.ariaKey));const{installSourcePath:j}=this.O,x=await(0,W.resolveMachineId)(this.hb),$={appenders:I,sendErrorTelemetry:!1,commonProperties:(0,Y.resolveCommonProperties)(this.R,(0,q.release)(),(0,q.hostname)(),process.arch,this.eb.commit,this.eb.version,x,O,j),piiPaths:(0,J.getPiiPathsFromEnvironment)(this.O)};await new ce.TelemetryService($,this.W,this.eb).publicLog2("windowadminerror",{reason:F.reason,code:F.exitCode})}const{response:U}=await this.bb.showMessageBox({type:"error",buttons:[(0,d.localize)(14,null),(0,d.localize)(15,null)],message:(0,d.localize)(16,null),detail:(0,d.localize)(17,null,this.eb.nameLong)},this.l);U===0&&await this.ib.openExternal(void 0,"https://go.microsoft.com/fwlink/?linkid=2220179"),await Promise.all(I.map(j=>j.flush())),await this.pb(!1,!1)}async pb(F,I){const O=this.q?.workspace;if(I&&O)try{const U=this.U.workspaceStorage(O);await U.init(),U.delete("memento/workbench.parts.editor"),await U.close()}catch(U){this.M.error(U)}if(this.j.fire(),this.l?.destroy(),F&&this.q){let U,j;(0,C.isSingleFolderWorkspaceIdentifier)(O)?U={folderUri:O.uri}:(0,C.isWorkspaceIdentifier)(O)?U={workspaceUri:O.configPath}:j=!0;const[x]=await this.gb.open({context:5,userEnv:this.q.userEnv,cli:{...this.O.args,_:[]},urisToOpen:U?[U]:void 0,forceEmpty:j,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});x.focus()}}qb(F){this.q?.workspace?.id===F.id&&(this.q.workspace=void 0)}rb(F){if(!F||F.affectsConfiguration("window.menuBarVisibility")){const I=this.Cb();I!==this.s&&(this.s=I,this.Db(I))}if(!F||F.affectsConfiguration("http.proxy")){let I=(this.W.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;I?.endsWith("/")&&(I=I.substr(0,I.length-1));const O=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((I||"").indexOf("@")===-1&&(I!==this.G||O!==this.H)){this.G=I,this.H=O;const U=I||"",j=O?`${O},<local>`:"<local>";this.M.trace(`Setting proxy to '${U}', bypassing '${j}'`),this.l.webContents.session.setProxy({proxyRules:U,proxyBypassRules:j,pacScript:""})}}}addTabbedWindow(F){v.isMacintosh&&F.win&&this.l.addTabbedWindow(F.win)}load(F,I=Object.create(null)){this.M.trace(`window#load: attempt to load window (id: ${this.k})`),this.isDocumentEdited()&&(!I.isReload||!this.Z.isHotExitEnabled())&&this.setDocumentEdited(!1),I.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.l.setTitle(this.eb.nameLong)),this.sb(F,I),this.jb===0?this.q=F:this.J=F,this.jb=1,this.l.loadURL(f.FileAccess.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.O.isBuilt?"":"-dev"}.html`).toString(!0));const O=this.L;this.L=!0,!this.O.isBuilt&&!this.O.extensionTestsLocationURI&&this.D(new L.RunOnceScheduler(()=>{this.l&&!this.l.isVisible()&&!this.l.isMinimized()&&(this.l.show(),this.focus({force:!0}),this.l.webContents.openDevTools())},1e4)).schedule(),this.c.fire({workspace:F.workspace,reason:I.isReload?3:O?2:1})}sb(F,I){const O=(this.q??this.J)?.userEnv;if(O){const U=(0,g.isLaunchedFromCli)(O)&&!(0,g.isLaunchedFromCli)(F.userEnv),j=this.isExtensionDevelopmentHost;(U||j)&&(F.userEnv={...O,...F.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(F.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),I.disableExtensions!==void 0&&(F["disable-extensions"]=I.disableExtensions),F.fullscreen=this.isFullScreen,F.maximized=this.l.isMaximized(),F.partsSplash=this.X.getWindowSplash(),(0,m.mark)("code/willOpenNewWindow"),F.perfMarks=(0,m.getMarks)(),this.I.update(F)}async reload(F){const I=Object.assign({},this.q);I.workspace=await this.tb(I),delete I.filesToOpenOrCreate,delete I.filesToDiff,delete I.filesToMerge,delete I.filesToWait,this.isExtensionDevelopmentHost&&F&&(I.verbose=F.verbose,I.debugId=F.debugId,I.extensionEnvironment=F.extensionEnvironment,I["inspect-extensions"]=F["inspect-extensions"],I["inspect-brk-extensions"]=F["inspect-brk-extensions"],I["extensions-dir"]=F["extensions-dir"]),I.accessibilitySupport=P.app.isAccessibilitySupportEnabled(),I.isInitialStartup=!1,I.policiesData=this.P.serialize(),I.continueOn=this.O.continueOn,I.profiles={all:this.Q.profiles,profile:this.profile||this.Q.defaultProfile,home:this.Q.profilesHome},I.logLevel=this.N.getLogLevel(),I.loggers={window:this.N.getRegisteredLoggers(this.id),global:this.N.getRegisteredLoggers()},this.load(I,{isReload:!0,disableExtensions:F?.["disable-extensions"]})}async tb(F){if((0,C.isWorkspaceIdentifier)(F.workspace)){const I=F.workspace.configPath;if(I.scheme===f.Schemas.file&&!await this.R.exists(I))return}else if((0,C.isSingleFolderWorkspaceIdentifier)(F.workspace)){const I=F.workspace.uri;if(I.scheme===f.Schemas.file&&!await this.R.exists(I))return}return F.workspace}serializeWindowState(){if(!this.l)return(0,N.defaultWindowState)();if(this.isFullScreen){let O;try{O=P.screen.getDisplayMatching(this.getBounds())}catch{}const U=(0,N.defaultWindowState)();return{mode:3,display:O?O.id:void 0,width:this.r.width||U.width,height:this.r.height||U.height,x:this.r.x||0,y:this.r.y||0}}const F=Object.create(null);let I;if(!v.isMacintosh&&this.l.isMaximized()?I=0:I=1,I===0?F.mode=0:F.mode=1,I===1||I===0){let O;I===1?O=this.getBounds():O=this.l.getNormalBounds(),F.x=O.x,F.y=O.y,F.width=O.width,F.height=O.height}return F}updateWindowControls(F){if(F.height&&this.hb.setItem(ot.a,F.height),v.isWindows&&this.z)this.l.setTitleBarOverlay({color:F.backgroundColor?.trim()===""?void 0:F.backgroundColor,symbolColor:F.foregroundColor?.trim()===""?void 0:F.foregroundColor,height:F.height?F.height-1:void 0});else if(v.isMacintosh&&F.height!==void 0){const I=(F.height-15)/2;this.l.setTrafficLightPosition({x:I,y:I})}}ub(F){(0,m.mark)("code/willRestoreCodeWindowState");let I=!1;if(F)try{const O=P.screen.getAllDisplays();I=O.length>1,F=this.vb(F,O)}catch(O){this.M.warn(`Unexpected error validating window state: ${O}
${O.stack}`)}return(0,m.mark)("code/didRestoreCodeWindowState"),[F||(0,N.defaultWindowState)(),I]}vb(F,I){if(this.M.trace(`window#validateWindowState: validating window state on ${I.length} display(s)`,F),typeof F.x!="number"||typeof F.y!="number"||typeof F.width!="number"||typeof F.height!="number"){this.M.trace("window#validateWindowState: unexpected type of state values");return}if(F.width<=0||F.height<=0){this.M.trace("window#validateWindowState: unexpected negative values");return}if(I.length===1){const j=this.wb(I[0]);if(j){let x=function(){!F||typeof F.x!="number"||typeof F.y!="number"||!j||(F.x<j.x&&(F.x=j.x),F.y<j.y&&(F.y=j.y))};this.M.trace("window#validateWindowState: 1 monitor working area",j),x(),F.width>j.width&&(F.width=j.width),F.height>j.height&&(F.height=j.height),F.x>j.x+j.width-128&&(F.x=j.x+j.width-F.width),F.y>j.y+j.height-128&&(F.y=j.y+j.height-F.height),x()}return F}if(F.display&&F.mode===3){const j=I.find(x=>x.id===F.display);if(j&&typeof j.bounds?.x=="number"&&typeof j.bounds?.y=="number"){this.M.trace("window#validateWindowState: restoring fullscreen to previous display");const x=(0,N.defaultWindowState)(3);return x.x=j.bounds.x,x.y=j.bounds.y,x}}let O,U;try{O=P.screen.getDisplayMatching({x:F.x,y:F.y,width:F.width,height:F.height}),U=this.wb(O)}catch{}if(O&&U&&F.x+F.width>U.x&&F.y+F.height>U.y&&F.x<U.x+U.width&&F.y<U.y+U.height)return this.M.trace("window#validateWindowState: multi-monitor working area",U),F}wb(F){if(F.workArea.width>0&&F.workArea.height>0)return F.workArea;if(F.bounds.width>0&&F.bounds.height>0)return F.bounds}getBounds(){const[F,I]=this.l.getPosition(),[O,U]=this.l.getSize();return{x:F,y:I,width:O,height:U}}toggleFullScreen(){this.xb(!this.isFullScreen)}xb(F){this.Bb()?this.yb(F):this.Ab(F),this.sendWhenReady(F?"vscode:enterFullScreen":"vscode:leaveFullScreen",o.CancellationToken.None),this.s&&this.Db(this.s,!1)}get isFullScreen(){return v.isMacintosh&&typeof this.t=="boolean"?this.t:this.l.isFullScreen()||this.l.isSimpleFullScreen()}yb(F){this.l.isSimpleFullScreen()&&this.l.setSimpleFullScreen(!1),this.zb(F)}zb(F){v.isMacintosh&&(this.t=F,this.u=new L.DeferredPromise,Promise.race([this.u.p,(0,L.timeout)(1e3)]).finally(()=>this.t=void 0)),this.l.setFullScreen(F)}Ab(F){this.l.isFullScreen()&&this.zb(!1),this.l.setSimpleFullScreen(F),this.l.webContents.focus()}Bb(){const F=this.W.getValue("window");return!F||typeof F.nativeFullScreen!="boolean"||F.nativeTabs?!0:F.nativeFullScreen!==!1}isMinimized(){return this.l.isMinimized()}Cb(){let F=(0,E.getMenuBarVisibility)(this.W);return["visible","toggle","hidden"].indexOf(F)<0&&(F="classic"),F}Db(F,I=!0){v.isMacintosh||(F==="toggle"&&I&&this.send("vscode:showInfoMessage",(0,d.localize)(18,null)),F==="hidden"?setTimeout(()=>{this.Eb(F)}):this.Eb(F))}Eb(F){const I=this.isFullScreen;switch(F){case"classic":this.l.setMenuBarVisibility(!I),this.l.autoHideMenuBar=I;break;case"visible":this.l.setMenuBarVisibility(!0),this.l.autoHideMenuBar=!1;break;case"toggle":this.l.setMenuBarVisibility(!1),this.l.autoHideMenuBar=!0;break;case"hidden":this.l.setMenuBarVisibility(!1),this.l.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(v.isMacintosh)switch(P.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this.l.minimize();break;case"None":break;case"Maximize":default:this.l.isMaximized()?this.l.unmaximize():this.l.maximize()}else this.l.isMaximized()?this.l.unmaximize():this.l.maximize()}close(){this.l?.close()}sendWhenReady(F,I,...O){this.isReady?this.send(F,...O):this.ready().then(()=>{I.isCancellationRequested||this.send(F,...O)})}send(F,...I){if(this.l){if(this.l.isDestroyed()||this.l.webContents.isDestroyed()){this.M.warn(`Sending IPC message to channel '${F}' for window that is destroyed`);return}try{this.l.webContents.send(F,...I)}catch(O){this.M.warn(`Error sending IPC message to channel '${F}' of window ${this.k}: ${(0,A.toErrorMessage)(O)}`)}}}updateTouchBar(F){!v.isMacintosh||this.F.forEach((I,O)=>{const U=F[O];I.segments=this.Hb(U)})}Fb(){if(!!v.isMacintosh){for(let F=0;F<10;F++){const I=this.Gb();this.F.push(I)}this.l.setTouchBar(new P.TouchBar({items:this.F}))}}Gb(F=[]){const I=this.Hb(F),O=new P.TouchBar.TouchBarSegmentedControl({segments:I,mode:"buttons",segmentStyle:"automatic",change:U=>{this.sendWhenReady("vscode:runAction",o.CancellationToken.None,{id:O.segments[U].id,from:"touchbar"})}});return O}Hb(F=[]){return F.map(O=>{let U;O.icon&&!h.ThemeIcon.isThemeIcon(O.icon)&&O.icon?.dark?.scheme===f.Schemas.file&&(U=P.nativeImage.createFromPath(b.URI.revive(O.icon.dark).fsPath),U.isEmpty()&&(U=void 0));let j;return typeof O.title=="string"?j=O.title:j=O.title.value,{id:O.id,label:U?void 0:j,icon:U}})}dispose(){super.dispose(),this.N.deregisterLoggers(this.id),this.l=null}};se.a="windowControlHeight",se.b=void 0,se=ye([Z(1,D.ILogService),Z(2,H.ILoggerMainService),Z(3,u.IEnvironmentMainService),Z(4,B.IPolicyService),Z(5,ne.IUserDataProfilesMainService),Z(6,p.IFileService),Z(7,s.IApplicationStorageMainService),Z(8,s.IStorageMainService),Z(9,w.IConfigurationService),Z(10,l.IThemeMainService),Z(11,T.IWorkspacesManagementMainService),Z(12,S.IBackupMainService),Z(13,n.ITelemetryService),Z(14,r.IDialogMainService),Z(15,y.ILifecycleMainService),Z(16,t.IProductService),Z(17,a.IProtocolMainService),Z(18,R.IWindowsMainService),Z(19,_.IStateService),Z(20,ae.INativeHostMainService)],se),e.CodeWindow=se}),define(ee[82],te([0,1,15,27,7,3,45,2,14,4,18,8,23,186,6,20,5,97,94,28,54,35]),function(G,e,P,L,o,A,M,k,f,c,m,v,b,d,S,w,r,u,g,p,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,S.createDecorator)("workspacesHistoryMainService");let t=class tt extends k.Disposable{constructor(i,s,n,h){super(),this.f=i,this.g=s,this.h=n,this.j=h,this.c=this.D(new A.Emitter),this.onDidChangeRecentlyOpened=this.c.event,this.y=this.D(new o.ThrottledDelayer(800)),this.k()}k(){this.h.when(4).then(()=>this.z()),this.D(this.g.onDidEnterWorkspace(i=>this.addRecentlyOpened([{workspace:i.workspace,remoteAuthority:i.window.remoteAuthority}])))}async addRecentlyOpened(i){let s=[],n=[];for(const l of i)if((0,g.isRecentWorkspace)(l))!this.g.isUntitledWorkspace(l.workspace)&&!this.q(s,l.workspace)&&s.push(l);else if((0,g.isRecentFolder)(l))this.r(s,l.folderUri)||s.push(l);else{const E=this.s(n,l.fileUri),R=l.fileUri.scheme===f.Schemas.file&&tt.w.indexOf((0,m.basename)(l.fileUri))>=0;!E&&!R&&(n.push(l),c.isWindows&&l.fileUri.scheme===f.Schemas.file&&P.app.addRecentDocument(l.fileUri.fsPath))}const h=await this.l({workspaces:s,files:n});s=h.workspaces,n=h.files,s.length>tt.a&&(s.length=tt.a),n.length>tt.a&&(n.length=tt.a),await this.n({workspaces:s,files:n}),this.c.fire(),c.isMacintosh&&this.y.trigger(()=>this.H())}async removeRecentlyOpened(i){const s=E=>{const R=this.p(E);for(const C of i)if(m.extUriBiasedIgnorePathCase.isEqual(C,R))return!1;return!0},n=await this.getRecentlyOpened(),h=n.workspaces.filter(s),l=n.files.filter(s);(h.length!==n.workspaces.length||l.length!==n.files.length)&&(await this.n({files:l,workspaces:h}),this.c.fire(),c.isMacintosh&&this.y.trigger(()=>this.H()))}async clearRecentlyOpened(){await this.n({workspaces:[],files:[]}),P.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.l()}async l(i){const s=new D.ResourceMap(l=>m.extUriBiasedIgnorePathCase.getComparisonKey(l));if(i?.workspaces)for(const l of i.workspaces)s.set(this.p(l),l);const n=new D.ResourceMap(l=>m.extUriBiasedIgnorePathCase.getComparisonKey(l));if(i?.files)for(const l of i.files)n.set(this.p(l),l);const h=await this.m();for(const l of h.workspaces){const E=s.get(this.p(l));E?E.label=E.label??l.label:s.set(this.p(l),l)}for(const l of h.files){const E=n.get(this.p(l));E?E.label=E.label??l.label:n.set(this.p(l),l)}return{workspaces:[...s.values()],files:[...n.values()]}}async m(){await this.j.whenReady;let i;const s=this.j.get(tt.b,-1);if(typeof s=="string")try{i=JSON.parse(s)}catch(n){this.f.error("Unexpected error parsing opened paths list",n)}return(0,g.restoreRecentlyOpened)(i,this.f)}async n(i){await this.j.whenReady,this.j.store(tt.b,JSON.stringify((0,g.toStoreData)(i)),-1,1)}p(i){return(0,g.isRecentFolder)(i)?i.folderUri:(0,g.isRecentFile)(i)?i.fileUri:i.workspace.configPath}q(i,s){return!!i.find(n=>(0,g.isRecentWorkspace)(n)&&n.workspace.id===s.id)}r(i,s){return!!i.find(n=>(0,g.isRecentFolder)(n)&&m.extUriBiasedIgnorePathCase.isEqual(n.folderUri,s))}s(i,s){return!!i.find(n=>m.extUriBiasedIgnorePathCase.isEqual(n.fileUri,s))}async z(){!c.isWindows||(await this.C(),this.D(this.onDidChangeRecentlyOpened(()=>this.C())))}async C(){if(!c.isWindows)return;const i=[];if(i.push({type:"tasks",items:[{type:"task",title:(0,d.localize)(0,null),description:(0,d.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const s=[];for(const l of P.app.getJumpListSettings().removedItems){const E=l.args;if(E){const R=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(E);R&&s.push(v.URI.parse(R[2]))}}await this.removeRecentlyOpened(s);let n=!1;const h=(0,L.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,tt.v).map(l=>{const E=(0,g.isRecentWorkspace)(l)?l.workspace:l.folderUri,{title:R,description:C}=this.F(E,l.label);let T;return v.URI.isUri(E)?T=`--folder-uri "${E.toString()}"`:(n=!0,T=`--file-uri "${E.configPath.toString()}"`),{type:"task",title:R.substr(0,255),description:C.substr(0,255),program:process.execPath,args:T,iconPath:"explorer.exe",iconIndex:0}}));h.length>0&&i.push({type:"custom",name:n?(0,d.localize)(2,null):(0,d.localize)(3,null),items:h})}i.push({type:"recent"});try{const s=P.app.setJumpList(i);s&&s!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${s}`)}catch(s){this.f.warn("updateWindowsJumpList#setJumpList",s)}}F(i,s){if(s)return{title:(0,M.splitName)(s).name,description:s};if(v.URI.isUri(i))return{title:(0,m.basename)(i),description:this.G(i)};if(this.g.isUntitledWorkspace(i))return{title:(0,d.localize)(4,null),description:""};let n=(0,m.basename)(i.configPath);return n.endsWith(p.WORKSPACE_EXTENSION)&&(n=n.substr(0,n.length-p.WORKSPACE_EXTENSION.length-1)),{title:(0,d.localize)(5,null,n),description:this.G(i.configPath)}}G(i){return i.scheme==="file"?(0,M.normalizeDriveLetter)(i.fsPath):i.toString()}async H(){if(!c.isMacintosh)return;P.app.clearRecentDocuments();const i=await this.getRecentlyOpened(),s=[];let n=0;for(let l=0;l<i.workspaces.length&&n<tt.t;l++){const E=this.p(i.workspaces[l]);if(E.scheme===f.Schemas.file){const R=(0,m.originalFSPath)(E);await b.Promises.exists(R)&&(s.push(R),n++)}}const h=[];for(let l=0;l<i.files.length&&n<tt.u;l++){const E=this.p(i.files[l]);if(E.scheme===f.Schemas.file){const R=(0,m.originalFSPath)(E);if(tt.w.includes((0,m.basename)(E))||s.includes(R))continue;await b.Promises.exists(R)&&(h.push(R),n++)}}h.reverse().forEach(l=>P.app.addRecentDocument(l)),s.reverse().forEach(l=>P.app.addRecentDocument(l))}};t.a=500,t.b="history.recentlyOpenedPathsList",t.t=7,t.u=10,t.v=7,t.w=["COMMIT_EDITMSG","MERGE_MSG"],t=ye([Z(0,r.ILogService),Z(1,y.IWorkspacesManagementMainService),Z(2,w.ILifecycleMainService),Z(3,u.IApplicationStorageMainService)],t),e.WorkspacesHistoryMainService=t}),define(ee[286],te([0,1,15,7,22,45,4,8,176,19,29,20,5,224,59,21,33,24,49,80,30,82]),function(G,e,P,L,o,A,M,k,f,c,m,v,b,d,S,w,r,u,g,p,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const t="menu";let a=class bt{constructor(n,h,l,E,R,C,T,N,z,B,_){this.n=n,this.o=h,this.p=l,this.q=E,this.r=R,this.s=C,this.t=T,this.u=N,this.v=z,this.w=B,this.x=_,this.m=Object.create(null),this.g=new L.RunOnceScheduler(()=>this.E(),0),this.h=new L.RunOnceScheduler(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(M.isMacintosh||(0,p.getTitleBarStyle)(this.o)==="native")&&this.y(),this.z(),this.d=!1,this.f=!1,this.j=[],this.H(),this.A()}y(){const n=this.t.getItem(bt.a);n&&(n.menus&&(this.k=n.menus),n.keybindings&&(this.l=n.keybindings))}z(){this.m["workbench.action.files.newUntitledFile"]=(C,T,N)=>this.p.openEmptyWindow({context:2,contextWindowId:T?.id}),this.m["workbench.action.newWindow"]=(C,T,N)=>this.p.openEmptyWindow({context:2,contextWindowId:T?.id}),this.m["workbench.action.files.openFileFolder"]=(C,T,N)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.P(N),telemetryExtraData:{from:t}}),this.m["workbench.action.files.openFolder"]=(C,T,N)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.P(N),telemetryExtraData:{from:t}}),this.m["workbench.action.openWorkspace"]=(C,T,N)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.P(N),telemetryExtraData:{from:t}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened();const n=this.x.twitterUrl;n&&(this.m["workbench.action.openTwitterUrl"]=()=>this.Z(n,"openTwitterUrl"));const h=this.x.requestFeatureUrl;h&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.Z(h,"openUserVoiceUrl"));const l=this.x.reportIssueUrl;l&&(this.m["workbench.action.openIssueReporter"]=()=>this.Z(l,"openReportIssues"));const E=this.x.licenseUrl;E&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(M.language){const C=E.indexOf("?")>0?"&":"?";this.Z(`${E}${C}lang=${M.language}`,"openLicenseUrl")}else this.Z(E,"openLicenseUrl")});const R=this.x.privacyStatementUrl;R&&E&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.Z(R,"openPrivacyStatement")})}A(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(n=>this.F(n)),this.w.onDidBlurWindow(()=>this.G()),this.w.onDidFocusWindow(()=>this.G())}get B(){const n=this.o.getValue("window.enableMenuBarMnemonics");return typeof n!="boolean"?!0:n}get C(){if(!M.isMacintosh)return!1;const n=this.o.getValue("window.nativeTabs");return typeof n!="boolean"?!1:n}updateMenu(n,h){this.k=n.menus,this.l=n.keybindings,this.t.setItem(bt.a,n),this.D()}D(){this.g.schedule()}E(){this.b||setTimeout(()=>{this.b||this.H()},10)}F(n){!M.isMacintosh||(n.oldCount===0&&n.newCount>0||n.oldCount>0&&n.newCount===0)&&(this.d=n.newCount===0,this.D())}G(){!M.isMacintosh||(this.f=!P.BrowserWindow.getFocusedWindow(),this.D())}H(){const n=P.Menu.getApplicationMenu();if(n&&this.j.push(n),Object.keys(this.k).length===0){P.Menu.setApplicationMenu(M.isMacintosh?new P.Menu:null);return}const h=new P.Menu;let l;if(M.isMacintosh){const R=new P.Menu;l=new P.MenuItem({label:this.x.nameShort,submenu:R}),this.I(R),h.append(l)}if(M.isMacintosh&&!this.c){this.c=!0;const R=new P.Menu;R.append(new P.MenuItem({label:this.bb(f.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),P.app.dock.setMenu(R)}if(this.K("File")){const R=new P.Menu,C=new P.MenuItem({label:this.bb(f.localize(1,null)),submenu:R});this.M(R,"File"),h.append(C)}if(this.K("Edit")){const R=new P.Menu,C=new P.MenuItem({label:this.bb(f.localize(2,null)),submenu:R});this.M(R,"Edit"),h.append(C)}if(this.K("Selection")){const R=new P.Menu,C=new P.MenuItem({label:this.bb(f.localize(3,null)),submenu:R});this.M(R,"Selection"),h.append(C)}if(this.K("View")){const R=new P.Menu,C=new P.MenuItem({label:this.bb(f.localize(4,null)),submenu:R});this.M(R,"View"),h.append(C)}if(this.K("Go")){const R=new P.Menu,C=new P.MenuItem({label:this.bb(f.localize(5,null)),submenu:R});this.M(R,"Go"),h.append(C)}if(this.K("Run")){const R=new P.Menu,C=new P.MenuItem({label:this.bb(f.localize(6,null)),submenu:R});this.M(R,"Run"),h.append(C)}if(this.K("Terminal")){const R=new P.Menu,C=new P.MenuItem({label:this.bb(f.localize(7,null)),submenu:R});this.M(R,"Terminal"),h.append(C)}let E;if(this.K("Window")){const R=new P.Menu;E=new P.MenuItem({label:this.bb(f.localize(8,null)),submenu:R,role:"window"}),this.S(R)}if(E&&h.append(E),this.K("Help")){const R=new P.Menu,C=new P.MenuItem({label:this.bb(f.localize(9,null)),submenu:R,role:"help"});this.M(R,"Help"),h.append(C)}h.items&&h.items.length>0?P.Menu.setApplicationMenu(h):P.Menu.setApplicationMenu(null),this.h.schedule()}I(n){const h=this.U(f.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),l=this.T();let E;if(this.K("Preferences")){const ne=new P.Menu;this.M(ne,"Preferences"),E=new P.MenuItem({label:this.bb(f.localize(11,null)),submenu:ne})}const R=new P.Menu,C=new P.MenuItem({label:f.localize(12,null),role:"services",submenu:R}),T=new P.MenuItem({label:f.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),N=new P.MenuItem({label:f.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),z=new P.MenuItem({label:f.localize(15,null),role:"unhide"}),B=new P.MenuItem(this.Y("workbench.action.quit",{label:f.localize(16,null,this.x.nameLong),click:async(ne,ae,he)=>{const ce=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||!!P.BrowserWindow.getFocusedWindow()||ce?.isMinimized())&&await this.J(he)&&this.w.quit(void 0)}})),_=[h];_.push(...l),E&&_.push(i(),E),_.push(i(),C,i(),T,N,z,i(),B),_.forEach(ne=>n.append(ne))}async J(n){if(this.p.getWindowCount()===0)return!0;const h=this.o.getValue("window.confirmBeforeClose");if(h==="always"||h==="keyboardOnly"&&this.Q(n)){const{response:l}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,{type:"question",buttons:[f.localize(17,null),f.localize(18,null)],message:f.localize(19,null)});return l===0}return!0}K(n){if(!M.isMacintosh&&(0,p.getTitleBarStyle)(this.o)==="custom")return!1;switch(n){case"File":case"Help":if(M.isMacintosh)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[n];case"Window":if(M.isMacintosh)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[n]}}L(n,h){h.forEach(l=>{if((0,d.isMenubarMenuItemSeparator)(l))n.append(i());else if((0,d.isMenubarMenuItemSubmenu)(l)){const E=new P.Menu,R=new P.MenuItem({label:this.bb(l.label),submenu:E});this.L(E,l.submenu.items),n.append(R)}else(0,d.isMenubarMenuItemRecentAction)(l)?n.append(this.O(l)):(0,d.isMenubarMenuItemAction)(l)&&(l.id==="workbench.action.showAboutDialog"&&this.N(n),M.isMacintosh?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[l.id]?n.append(new P.MenuItem(this.Y(l.id,{label:this.bb(l.label),click:this.m[l.id]}))):n.append(this.U(l.label,l.id,!1,l.checked)):n.append(this.U(l.label,l.id,l.enabled!==!1,!!l.checked)):n.append(this.U(l.label,l.id,l.enabled!==!1,!!l.checked)))})}M(n,h){this.k&&this.k[h]&&this.L(n,this.k[h].items)}N(n){const h=this.T();h.length&&(h.forEach(l=>n.append(l)),n.append(i()))}O(n){const h=k.URI.revive(n.uri),l=n.id,E=l==="openRecentFile"?{fileUri:h}:l==="openRecentWorkspace"?{workspaceUri:h}:{folderUri:h};return new P.MenuItem(this.Y(l,{label:n.label,click:async(R,C,T)=>{const N=this.P(T);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[E],forceNewWindow:N,gotoLineMode:!1,remoteAuthority:n.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([h])}},!1))}P(n){return!!(n&&(!M.isMacintosh&&(n.ctrlKey||n.shiftKey)||M.isMacintosh&&(n.metaKey||n.altKey)))}Q(n){return!!(n.triggeredByAccelerator||n.altKey||n.ctrlKey||n.metaKey||n.shiftKey)}R(n,h,l){const E={label:this.bb(n),role:l,enabled:!0};return new P.MenuItem(this.X(h,E))}S(n){const h=new P.MenuItem({label:f.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),l=new P.MenuItem({label:f.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),E=new P.MenuItem({label:f.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),R=this.U(f.localize(23,null),"workbench.action.switchWindow"),C=[];this.C&&(C.push(i()),C.push(this.U(f.localize(24,null),"workbench.action.newWindowTab")),C.push(this.R(f.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),C.push(this.R(f.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),C.push(this.R(f.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),C.push(this.R(f.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[h,l,i(),R,...C,i(),E].forEach(T=>n.append(T))}T(){switch(this.n.state.type){case"uninitialized":return[];case"idle":return[new P.MenuItem({label:this.bb(f.localize(29,null)),click:()=>setTimeout(()=>{this.ab("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new P.MenuItem({label:f.localize(30,null),enabled:!1})];case"available for download":return[new P.MenuItem({label:this.bb(f.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new P.MenuItem({label:f.localize(32,null),enabled:!1})];case"downloaded":return[new P.MenuItem({label:this.bb(f.localize(33,null)),click:()=>{this.ab("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new P.MenuItem({label:f.localize(34,null),enabled:!1})];case"ready":return[new P.MenuItem({label:this.bb(f.localize(35,null)),click:()=>{this.ab("RestartToUpdate"),this.n.quitAndInstall()}})]}}U(n,h,l,E){const R=this.bb(n),C=typeof h=="function"?h:(_,ne,ae)=>{const he=_?_.userSettingsLabel:null;let ce=h;Array.isArray(h)&&(ce=this.P(ae)?h[1]:h[0]),he&&ae.triggeredByAccelerator?this.W({type:"keybinding",userSettingsLabel:he}):this.W({type:"commandId",commandId:ce})},T=typeof l=="boolean"?l:this.p.getWindowCount()>0,N=typeof E=="boolean"?E:!1,z={label:R,click:C,enabled:T};N&&(z.type="checkbox",z.checked=N);let B;return typeof h=="string"?B=h:Array.isArray(h)&&(B=h[0]),M.isMacintosh&&(B==="editor.action.clipboardCutAction"?z.role="cut":B==="editor.action.clipboardCopyAction"?z.role="copy":B==="editor.action.clipboardPasteAction"&&(z.role="paste"),B==="undo"?z.click=this.V(C,{inDevTools:_=>_.undo(),inNoWindow:()=>P.Menu.sendActionToFirstResponder("undo:")}):B==="redo"?z.click=this.V(C,{inDevTools:_=>_.redo(),inNoWindow:()=>P.Menu.sendActionToFirstResponder("redo:")}):B==="editor.action.selectAll"&&(z.click=this.V(C,{inDevTools:_=>_.selectAll(),inNoWindow:()=>P.Menu.sendActionToFirstResponder("selectAll:")}))),new P.MenuItem(this.X(B,z))}V(n,h){return(l,E,R)=>{const C=P.BrowserWindow.getFocusedWindow();if(!C)return h.inNoWindow();if(C.webContents.isDevToolsFocused()&&C.webContents.devToolsWebContents)return h.inDevTools(C.webContents.devToolsWebContents);n(l,E||C,R)}}W(n){let h=P.BrowserWindow.getFocusedWindow();if(!h){const E=this.p.getLastActiveWindow();E?.isMinimized()&&(h=E.win)}const l=h?this.p.getWindowById(h.id):void 0;if(l){if(this.v.trace("menubar#runActionInRenderer",n),M.isMacintosh&&!this.q.isBuilt&&!l.isReady&&(n.type==="commandId"&&n.commandId==="workbench.action.toggleDevTools"||n.type!=="commandId"&&n.userSettingsLabel==="alt+cmd+i"))return;if(n.type==="commandId"){const E={id:n.commandId,from:"menu"};l.sendWhenReady("vscode:runAction",o.CancellationToken.None,E)}else{const E={userSettingsLabel:n.userSettingsLabel};l.sendWhenReady("vscode:runKeybinding",o.CancellationToken.None,E)}}else this.v.trace("menubar#runActionInRenderer: no active window found",n)}X(n,h){const l=typeof n=="string"?this.l[n]:void 0;if(l?.label){if(l.isNative!==!1)h.accelerator=l.label,h.userSettingsLabel=l.userSettingsLabel;else if(typeof h.label=="string"){const E=h.label.indexOf("[");E>=0?h.label=`${h.label.substr(0,E)} [${l.label}]`:h.label=`${h.label} [${l.label}]`}}else h.accelerator=void 0;return h}Y(n,h,l=!h.accelerator){l&&(h=this.X(n,h));const E=h.click;return h.click=(R,C,T)=>{this.ab(n),E?.(R,C,T)},h}Z(n,h){this.w.openExternal(void 0,n),this.ab(h)}ab(n){this.r.publicLog2("workbenchActionExecuted",{id:n,from:t})}bb(n){return(0,A.mnemonicMenuLabel)(n,!this.B)}};a.a="lastKnownMenubarData",a=ye([Z(0,g.IUpdateService),Z(1,c.IConfigurationService),Z(2,y.IWindowsMainService),Z(3,m.IEnvironmentMainService),Z(4,u.ITelemetryService),Z(5,D.IWorkspacesHistoryMainService),Z(6,r.IStateService),Z(7,v.ILifecycleMainService),Z(8,b.ILogService),Z(9,S.INativeHostMainService),Z(10,w.IProductService)],a),e.Menubar=a;function i(){return new P.MenuItem({type:"separator"})}}),define(ee[287],te([0,1,6,20,5,286]),function(G,e,P,L,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,P.createDecorator)("menubarMainService");let M=class{constructor(f,c,m){this.b=f,this.c=c,this.d=m,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(A.Menubar)}async updateMenubar(f,c){this.d.trace("menubarService#updateMenubar",f),(await this.a).updateMenu(c,f)}};M=ye([Z(0,P.IInstantiationService),Z(1,L.ILifecycleMainService),Z(2,o.ILogService)],M),e.MenubarMainService=M}),define(ee[288],te([0,1,15,23,25,27,22,3,32,50,45,2,14,9,64,4,36,18,11,8,184,63,19,58,29,16,6,20,5,66,67,57,33,80,285,124,281,28,95,82,54,69,38,53,65]),function(G,e,P,L,o,A,M,k,f,c,m,v,b,d,S,w,r,u,g,p,y,D,t,a,i,s,n,h,l,E,R,C,T,N,z,B,_,ne,ae,he,ce,J,Y,q,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function H(re){return(0,ne.isWorkspaceIdentifier)(re?.workspace)}function Q(re){return(0,ne.isSingleFolderWorkspaceIdentifier)(re?.workspace)}let se=class at extends v.Disposable{constructor(F,I,O,U,j,x,$,V,K,oe,fe,Ce,Ee,Re,Oe,ze,ge,pe){super(),this.k=F,this.l=I,this.m=O,this.n=U,this.q=j,this.r=x,this.s=$,this.t=V,this.u=K,this.v=oe,this.w=fe,this.z=Ce,this.C=Ee,this.F=Re,this.G=Oe,this.H=ze,this.I=ge,this.J=pe,this.b=this.D(new k.Emitter),this.onDidOpenWindow=this.b.event,this.c=this.D(new k.Emitter),this.onDidSignalReadyWindow=this.c.event,this.f=this.D(new k.Emitter),this.onDidDestroyWindow=this.f.event,this.g=this.D(new k.Emitter),this.onDidChangeWindowsCount=this.g.event,this.h=this.D(new k.Emitter),this.onDidTriggerSystemContextMenu=this.h.event,this.j=this.D(new _.WindowsStateHandler(this,this.q,this.u,this.m,this.w)),this.L()}L(){this.D(this.C.onDidEnterWorkspace(F=>this.c.fire(F.window))),this.D(this.onDidSignalReadyWindow(F=>{if(F.config?.extensionDevelopmentPath||F.config?.extensionTestsPath){const I=new v.DisposableStore;if(I.add(k.Event.any(F.onDidClose,F.onDidDestroy)(()=>I.dispose())),F.config.extensionDevelopmentPath)for(const O of F.config.extensionDevelopmentPath)I.add(this.I.addValidFileRoot(O));F.config.extensionTestsPath&&I.add(this.I.addValidFileRoot(F.config.extensionTestsPath))}}))}openEmptyWindow(F,I){const O=this.s.args,U=I?.remoteAuthority||void 0,j=!0,x=I?.forceReuseWindow,$=!x;return this.open({...F,cli:O,forceEmpty:j,forceNewWindow:$,forceReuseWindow:x,remoteAuthority:U})}openExistingWindow(F,I){F.focus(),this.M(I,[F])}async open(F){this.m.trace("windowsManager#open"),F.addMode&&(F.initialStartup||!this.getLastActiveWindow())&&(F.addMode=!1);const I=[],O=[],U=[],j=[],x=[];let $,V=0;const K=await this.S(F);this.m.trace("windowsManager#open pathsToOpen",K);for(const Re of K)Q(Re)?F.addMode?I.push(Re):O.push(Re):H(Re)?U.push(Re):Re.fileUri?($||($={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Re.remoteAuthority}),$.filesToOpenOrCreate.push(Re)):Re.backupPath?x.push({backupFolder:(0,d.basename)(Re.backupPath),remoteAuthority:Re.remoteAuthority}):V++;F.diffMode&&$&&$.filesToOpenOrCreate.length>=2&&($.filesToDiff=$.filesToOpenOrCreate.slice(0,2),$.filesToOpenOrCreate=[]),F.mergeMode&&$&&$.filesToOpenOrCreate.length===4&&($.filesToMerge=$.filesToOpenOrCreate.slice(0,4),$.filesToOpenOrCreate=[],$.filesToDiff=[]),$&&F.waitMarkerFileURI&&($.filesToWait={paths:(0,A.coalesce)([...$.filesToDiff,$.filesToMerge[3],...$.filesToOpenOrCreate]),waitMarkerFileUri:F.waitMarkerFileURI}),F.initialStartup?(j.push(...this.C.getUntitledWorkspaces()),U.push(...j),x.push(...this.v.getEmptyWindowBackups())):x.length=0;const{windows:oe,filesOpenedInWindow:fe}=await this.N(F,U,O,x,V,$,I);if(this.m.trace(`windowsManager#open used window count ${oe.length} (workspacesToOpen: ${U.length}, foldersToOpen: ${O.length}, emptyToRestore: ${x.length}, emptyToOpen: ${V})`),oe.length>1)if(fe)fe.focus();else{const Re=this.j.state.lastActiveWindow&&!F.forceEmpty&&!F.cli._.length&&!F.cli["file-uri"]&&!F.cli["folder-uri"]&&!(F.urisToOpen&&F.urisToOpen.length);let Oe=!0,ze=!0;if(Re){const ge=oe.filter(pe=>this.j.state.lastActiveWindow&&pe.backupPath===this.j.state.lastActiveWindow.backupPath);ge.length&&(ge[0].focus(),Oe=!1,ze=!1)}if(Oe)for(let ge=oe.length-1;ge>=0;ge--){const pe=oe[ge];if(!(pe.openedWorkspace&&j.some(Le=>pe.openedWorkspace&&Le.workspace.id===pe.openedWorkspace.id)||pe.backupPath&&x.some(Le=>pe.backupPath&&Le.backupFolder===(0,d.basename)(pe.backupPath)))){pe.focus(),ze=!1;break}}ze&&oe[oe.length-1].focus()}const Ce=$&&$.filesToDiff.length>0,Ee=$&&$.filesToMerge.length>0;if(!oe.some(Re=>Re.isExtensionDevelopmentHost)&&!Ce&&!Ee&&!F.noRecentEntry){const Re=[];for(const Oe of K)H(Oe)&&!Oe.transient?Re.push({label:Oe.label,workspace:Oe.workspace,remoteAuthority:Oe.remoteAuthority}):Q(Oe)?Re.push({label:Oe.label,folderUri:Oe.workspace.uri,remoteAuthority:Oe.remoteAuthority}):Oe.fileUri&&Re.push({label:Oe.label,fileUri:Oe.fileUri,remoteAuthority:Oe.remoteAuthority});this.z.addRecentlyOpened(Re)}return this.M(F,oe),oe}M(F,I){const O=F.waitMarkerFileURI;F.context===0&&O&&I.length===1&&I[0]&&(async()=>{await I[0].whenClosedOrLoaded;try{await this.H.del(O)}catch{}})()}async N(F,I,O,U,j,x,$){const V=[];let K;function oe(ge,pe){V.push(ge),pe&&(K=ge,x=void 0)}let{openFolderInNewWindow:fe,openFilesInNewWindow:Ce}=this.fb(F);if(!F.initialStartup&&$.length>0){const ge=$[0].remoteAuthority,pe=this.kb(ge);pe&&oe(this.P(pe,$.map(Le=>Le.workspace.uri)))}const Ee=O.length+I.length+U.length;if(x&&Ee===0){const ge=x.filesToOpenOrCreate[0]||x.filesToDiff[0]||x.filesToMerge[3],pe=this.getWindows().filter(ie=>x&&(0,u.isEqualAuthority)(ie.remoteAuthority,x.remoteAuthority));let Le;ge?.fileUri&&!Ce&&((F.context===4||F.context===0||F.context===1)&&(Le=await(0,B.findWindowOnFile)(pe,ge.fileUri,async ie=>ie.configPath.scheme===b.Schemas.file?this.C.resolveLocalWorkspace(ie.configPath):void 0)),Le||(Le=this.lb(pe))),Le?(0,ne.isWorkspaceIdentifier)(Le.openedWorkspace)?I.push({workspace:Le.openedWorkspace,remoteAuthority:Le.remoteAuthority}):(0,ne.isSingleFolderWorkspaceIdentifier)(Le.openedWorkspace)?O.push({workspace:Le.openedWorkspace,remoteAuthority:Le.remoteAuthority}):oe(this.O(F,Le,x),!0):oe(await this.gb({userEnv:F.userEnv,cli:F.cli,initialStartup:F.initialStartup,filesToOpen:x,forceNewWindow:!0,remoteAuthority:x.remoteAuthority,forceNewTabbedWindow:F.forceNewTabbedWindow,forceProfile:F.forceProfile,forceTempProfile:F.forceTempProfile}),!0)}const Re=(0,A.distinct)(I,ge=>ge.workspace.id);if(Re.length>0){const ge=(0,A.coalesce)(Re.map(pe=>(0,B.findWindowOnWorkspaceOrFolder)(this.getWindows(),pe.workspace.configPath)));if(ge.length>0){const pe=ge[0],Le=(0,u.isEqualAuthority)(x?.remoteAuthority,pe.remoteAuthority)?x:void 0;oe(this.O(F,pe,Le),!!Le),fe=!0}for(const pe of Re){if(ge.some(ue=>ue.openedWorkspace&&ue.openedWorkspace.id===pe.workspace.id))continue;const Le=pe.remoteAuthority,ie=(0,u.isEqualAuthority)(x?.remoteAuthority,Le)?x:void 0;oe(await this.R(F,pe,fe,ie),!!ie),fe=!0}}const Oe=(0,A.distinct)(O,ge=>u.extUriBiasedIgnorePathCase.getComparisonKey(ge.workspace.uri));if(Oe.length>0){const ge=(0,A.coalesce)(Oe.map(pe=>(0,B.findWindowOnWorkspaceOrFolder)(this.getWindows(),pe.workspace.uri)));if(ge.length>0){const pe=ge[0],Le=(0,u.isEqualAuthority)(x?.remoteAuthority,pe.remoteAuthority)?x:void 0;oe(this.O(F,pe,Le),!!Le),fe=!0}for(const pe of Oe){if(ge.some(ue=>(0,ne.isSingleFolderWorkspaceIdentifier)(ue.openedWorkspace)&&u.extUriBiasedIgnorePathCase.isEqual(ue.openedWorkspace.uri,pe.workspace.uri)))continue;const Le=pe.remoteAuthority,ie=(0,u.isEqualAuthority)(x?.remoteAuthority,Le)?x:void 0;oe(await this.R(F,pe,fe,ie),!!ie),fe=!0}}const ze=(0,A.distinct)(U,ge=>ge.backupFolder);if(ze.length>0)for(const ge of ze){const pe=ge.remoteAuthority,Le=(0,u.isEqualAuthority)(x?.remoteAuthority,pe)?x:void 0;oe(await this.Q(F,!0,pe,Le,ge),!!Le),fe=!0}if(V.length===0||x){x&&!j&&j++;const ge=x?x.remoteAuthority:F.remoteAuthority;for(let pe=0;pe<j;pe++)oe(await this.Q(F,fe,ge,x),!!x),fe=!0}return{windows:(0,A.distinct)(V),filesOpenedInWindow:K}}O(F,I,O){this.m.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:O}),I.focus();const U={filesToOpenOrCreate:O?.filesToOpenOrCreate,filesToDiff:O?.filesToDiff,filesToMerge:O?.filesToMerge,filesToWait:O?.filesToWait,termProgram:F?.userEnv?.TERM_PROGRAM};return I.sendWhenReady("vscode:openFiles",M.CancellationToken.None,U),I}P(F,I){this.m.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:I}),F.focus();const O={foldersToAdd:I};return F.sendWhenReady("vscode:addFolders",M.CancellationToken.None,O),F}Q(F,I,O,U,j){this.m.trace("windowsManager#doOpenEmpty",{restore:!!j,remoteAuthority:O,filesToOpen:U,forceNewWindow:I});let x;return!I&&typeof F.contextWindowId=="number"&&(x=this.getWindowById(F.contextWindowId)),this.gb({userEnv:F.userEnv,cli:F.cli,initialStartup:F.initialStartup,remoteAuthority:O,forceNewWindow:I,forceNewTabbedWindow:F.forceNewTabbedWindow,filesToOpen:U,windowToUse:x,emptyWindowBackupInfo:j,forceProfile:F.forceProfile,forceTempProfile:F.forceTempProfile})}R(F,I,O,U,j){return this.m.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:I,filesToOpen:U}),!O&&!j&&typeof F.contextWindowId=="number"&&(j=this.getWindowById(F.contextWindowId)),this.gb({workspace:I.workspace,userEnv:F.userEnv,cli:F.cli,initialStartup:F.initialStartup,remoteAuthority:I.remoteAuthority,forceNewWindow:O,forceNewTabbedWindow:F.forceNewTabbedWindow,filesToOpen:U,windowToUse:j,forceProfile:F.forceProfile,forceTempProfile:F.forceTempProfile})}async S(F){let I,O=!1,U=!1;if(F.urisToOpen&&F.urisToOpen.length>0?(I=await this.U(F),O=!0):F.forceEmpty?I=[Object.create(null)]:F.cli._.length||F.cli["folder-uri"]||F.cli["file-uri"]?(I=await this.W(F.cli),I.length===0&&I.push(Object.create(null)),O=!0):(I=await this.Y(),I.length===0&&I.push(Object.create(null)),U=!0),!F.addMode&&O){const j=I.filter(x=>Q(x));if(j.length>1){const x=j[0].remoteAuthority;if(j.every($=>(0,u.isEqualAuthority)($.remoteAuthority,x))){const $=await this.C.createUntitledWorkspace(j.map(V=>({uri:V.workspace.uri})));I.push({workspace:$,remoteAuthority:x}),I=I.filter(V=>!Q(V))}}}if(F.initialStartup&&!U&&this.w.getValue("window")?.restoreWindows==="preserve"){const j=await this.Y();I.unshift(...j.filter(x=>H(x)||Q(x)||x.backupPath))}return I}async U(F){const I={gotoLineMode:F.gotoLineMode,remoteAuthority:F.remoteAuthority},O=await Promise.all((0,A.coalesce)(F.urisToOpen||[]).map(async U=>{const j=await this.ab(U,I);if(j)return j.label=U.label,j;const x=this.cb(U);this.G.showMessageBox({type:"info",buttons:[(0,y.localize)(0,null)],message:x.scheme===b.Schemas.file?(0,y.localize)(1,null):(0,y.localize)(2,null),detail:x.scheme===b.Schemas.file?(0,y.localize)(3,null,(0,m.getPathLabel)(x,{os:w.OS,tildify:this.s})):(0,y.localize)(4,null,x.toString(!0))},(0,g.withNullAsUndefined)(P.BrowserWindow.getFocusedWindow()))}));return(0,A.coalesce)(O)}async W(F){const I=[],O={ignoreFileNotFound:!0,gotoLineMode:F.goto,remoteAuthority:F.remote||void 0,forceOpenWorkspaceAsFile:F.diff&&F._.length===2||F.merge&&F._.length===4},U=F["folder-uri"];if(U){const $=await Promise.all(U.map(V=>{const K=this.X(V);if(!!K)return this.ab({folderUri:K},O)}));I.push(...(0,A.coalesce)($))}const j=F["file-uri"];if(j){const $=await Promise.all(j.map(V=>{const K=this.X(V);if(!!K)return this.ab((0,ne.hasWorkspaceFileExtension)(V)?{workspaceUri:K}:{fileUri:K},O)}));I.push(...(0,A.coalesce)($))}const x=await Promise.all(F._.map($=>O.remoteAuthority?this.eb($,O):this.db($,O)));return I.push(...(0,A.coalesce)(x)),I}X(F){try{const I=p.URI.parse(F);if(!I.scheme){this.m.error(`Invalid URI input string, scheme missing: ${F}`);return}return I}catch(I){this.m.error(`Invalid URI input string: ${F}, ${I.message}`)}}async Y(){const F=this.Z();switch(F){case"none":return[];case"one":case"all":case"preserve":case"folders":{const I=[];F!=="one"&&I.push(...this.j.state.openedWindows),this.j.state.lastActiveWindow&&I.push(this.j.state.lastActiveWindow);const O=await Promise.all(I.map(async U=>{if(U.workspace){const j=await this.ab({workspaceUri:U.workspace.configPath},{remoteAuthority:U.remoteAuthority,rejectTransientWorkspaces:!0});if(H(j))return j}else if(U.folderUri){const j=await this.ab({folderUri:U.folderUri},{remoteAuthority:U.remoteAuthority});if(Q(j))return j}else if(F!=="folders"&&U.backupPath)return{backupPath:U.backupPath,remoteAuthority:U.remoteAuthority}}));return(0,A.coalesce)(O)}}}Z(){let F;return this.u.wasRestarted?F="all":(F=this.w.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(F)||(F="all")),F}async ab(F,I=Object.create(null)){const O=this.cb(F);return O.scheme===b.Schemas.file?((0,N.isFileToOpen)(F)&&(I={...I,forceOpenWorkspaceAsFile:!0}),this.db(O.fsPath,I)):this.bb(F,I)}bb(F,I){let O=this.cb(F);const U=(0,C.getRemoteAuthority)(O)||I.remoteAuthority;if(O=(0,u.removeTrailingPathSeparator)((0,u.normalizePath)(O)),(0,N.isFileToOpen)(F)){if(I.gotoLineMode){const{path:j,line:x,column:$}=(0,f.parseLineAndColumnAware)(O.path);return{fileUri:O.with({path:j}),options:{selection:x?{startLineNumber:x,startColumn:$||1}:void 0},remoteAuthority:U}}return{fileUri:O,remoteAuthority:U}}else if((0,N.isWorkspaceToOpen)(F))return{workspace:(0,ae.getWorkspaceIdentifier)(O),remoteAuthority:U};return{workspace:(0,ae.getSingleFolderWorkspaceIdentifier)(O),remoteAuthority:U}}cb(F){return(0,N.isWorkspaceToOpen)(F)?F.workspaceUri:(0,N.isFolderToOpen)(F)?F.folderUri:F.fileUri}async db(F,I){let O,U;I.gotoLineMode&&({path:F,line:O,column:U}=(0,f.parseLineAndColumnAware)(F)),F=(0,f.sanitizeFilePath)((0,d.normalize)(F),(0,r.cwd)());try{const j=await L.Promises.stat(F);if(j.isFile()){if(!I.forceOpenWorkspaceAsFile){const x=await this.C.resolveLocalWorkspace(p.URI.file(F));if(x)return x.transient&&I.rejectTransientWorkspaces?void 0:{workspace:{id:x.id,configPath:x.configPath},type:s.FileType.File,exists:!0,remoteAuthority:x.remoteAuthority,transient:x.transient}}return{fileUri:p.URI.file(F),type:s.FileType.File,exists:!0,options:{selection:O?{startLineNumber:O,startColumn:U||1}:void 0}}}else{if(j.isDirectory())return{workspace:(0,ae.getSingleFolderWorkspaceIdentifier)(p.URI.file(F),j),type:s.FileType.Directory,exists:!0};if(!w.isWindows&&F==="/dev/null")return{fileUri:p.URI.file(F),type:s.FileType.File,exists:!0}}}catch{const x=p.URI.file(F);if(this.z.removeRecentlyOpened([x]),I.ignoreFileNotFound)return{fileUri:x,type:s.FileType.File,exists:!1}}}eb(F,I){const O=F.charCodeAt(0),U=I.remoteAuthority;let j,x;I.gotoLineMode&&({path:F,line:j,column:x}=(0,f.parseLineAndColumnAware)(F)),O!==47&&((0,f.isWindowsDriveLetter)(O)&&F.charCodeAt(F.charCodeAt(1))===58&&(F=(0,f.toSlashes)(F)),F=`/${F}`);const $=p.URI.from({scheme:b.Schemas.vscodeRemote,authority:U,path:F});if(F.charCodeAt(F.length-1)!==47){if((0,ne.hasWorkspaceFileExtension)(F))return I.forceOpenWorkspaceAsFile?{fileUri:$,options:{selection:j?{startLineNumber:j,startColumn:x||1}:void 0},remoteAuthority:I.remoteAuthority}:{workspace:(0,ae.getWorkspaceIdentifier)($),remoteAuthority:U};if(I.gotoLineMode||d.posix.basename(F).indexOf(".")!==-1)return{fileUri:$,options:{selection:j?{startLineNumber:j,startColumn:x||1}:void 0},remoteAuthority:U}}return{workspace:(0,ae.getSingleFolderWorkspaceIdentifier)($),remoteAuthority:U}}fb(F){const I=this.w.getValue("window"),O=I?.openFoldersInNewWindow||"default",U=I?.openFilesInNewWindow||"off";let j=(F.preferNewWindow||F.forceNewWindow)&&!F.forceReuseWindow;!F.forceNewWindow&&!F.forceReuseWindow&&(O==="on"||O==="off")&&(j=O==="on");let x=!1;return F.forceNewWindow||F.forceReuseWindow?x=!!F.forceNewWindow&&!F.forceReuseWindow:(w.isMacintosh?F.context===1&&(x=!0):F.context!==3&&F.context!==2&&!(F.userEnv&&F.userEnv.TERM_PROGRAM==="vscode")&&(x=!0),!F.cli.extensionDevelopmentPath&&(U==="on"||U==="off")&&(x=U==="on")),{openFolderInNewWindow:!!j,openFilesInNewWindow:x}}async openExtensionDevelopmentHostWindow(F,I){const O=(0,B.findWindowOnExtensionDevelopmentPath)(this.getWindows(),F);if(O)return this.u.reload(O,I.cli),O.focus(),[O];let U=I.cli["folder-uri"]||[],j=I.cli["file-uri"]||[],x=I.cli._;if(!x.length&&!U.length&&!j.length&&!I.cli.extensionTestsPath){const K=this.j.state.lastPluginDevelopmentHostWindow,oe=K?.workspace??K?.folderUri;oe&&(p.URI.isUri(oe)?oe.scheme===b.Schemas.file?x=[oe.fsPath]:U=[oe.toString()]:oe.configPath.scheme===b.Schemas.file?x=[(0,u.originalFSPath)(oe.configPath)]:j=[oe.configPath.toString()])}let $=I.remoteAuthority;for(const K of F)if(K.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const oe=p.URI.parse(K),fe=(0,C.getRemoteAuthority)(oe);fe&&($?(0,u.isEqualAuthority)(fe,$)||this.m.error("more than one extension development path authority"):$=fe)}x=x.filter(K=>{const oe=p.URI.file(K);return(0,B.findWindowOnWorkspaceOrFolder)(this.getWindows(),oe)?!1:(0,u.isEqualAuthority)((0,C.getRemoteAuthority)(oe),$)}),U=U.filter(K=>{const oe=this.X(K);return oe&&!!(0,B.findWindowOnWorkspaceOrFolder)(this.getWindows(),oe)?!1:oe?(0,u.isEqualAuthority)((0,C.getRemoteAuthority)(oe),$):!1}),j=j.filter(K=>{const oe=this.X(K);return oe&&!!(0,B.findWindowOnWorkspaceOrFolder)(this.getWindows(),oe)?!1:oe?(0,u.isEqualAuthority)((0,C.getRemoteAuthority)(oe),$):!1}),I.cli._=x,I.cli["folder-uri"]=U,I.cli["file-uri"]=j;const V={context:I.context,cli:I.cli,forceNewWindow:!0,forceEmpty:!x.length&&!U.length&&!j.length,userEnv:I.userEnv,noRecentEntry:!0,waitMarkerFileURI:I.waitMarkerFileURI,remoteAuthority:$,forceProfile:I.forceProfile,forceTempProfile:I.forceTempProfile};return this.open(V)}async gb(F){const I=this.w.getValue("window"),O=this.getLastActiveWindow(),U=O?.profile??this.t.defaultProfile;let j;!F.forceNewWindow&&!F.forceNewTabbedWindow&&(j=F.windowToUse||O,j&&j.focus());let x=!1;typeof I?.experimental?.sharedProcessUseUtilityProcess=="boolean"?x=I.experimental.sharedProcessUseUtilityProcess:x=E.default.quality!=="stable";const $={...this.s.args,...F.cli,machineId:this.k,windowId:-1,mainPid:process.pid,appRoot:this.s.appRoot,execPath:process.execPath,codeCachePath:this.s.codeCachePath,backupPath:F.emptyWindowBackupInfo?(0,d.join)(this.s.backupHome,F.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.t.profilesHome,all:this.t.profiles,profile:U},homeDir:this.s.userHome.fsPath,tmpDir:this.s.tmpDir.fsPath,userDataDir:this.s.userDataPath,remoteAuthority:F.remoteAuthority,workspace:F.workspace,userEnv:{...this.l,...F.userEnv},filesToOpenOrCreate:F.filesToOpen?.filesToOpenOrCreate,filesToDiff:F.filesToOpen?.filesToDiff,filesToMerge:F.filesToOpen?.filesToMerge,filesToWait:F.filesToOpen?.filesToWait,logLevel:this.n.getLogLevel(),loggers:{window:[],global:this.n.getRegisteredLoggers()},logsPath:this.s.logsHome.fsPath,product:E.default,isInitialStartup:F.initialStartup,perfMarks:(0,S.getMarks)(),os:{release:(0,o.release)(),hostname:(0,o.hostname)()},zoomLevel:typeof I?.zoomLevel=="number"?I.zoomLevel:void 0,autoDetectHighContrast:I?.autoDetectHighContrast??!0,autoDetectColorScheme:I?.autoDetectColorScheme??!1,accessibilitySupport:P.app.accessibilitySupportEnabled,colorScheme:this.J.getColorScheme(),policiesData:this.r.serialize(),continueOn:this.s.continueOn,preferUtilityProcess:x};if(j){const V=j.config;!$.extensionDevelopmentPath&&V?.extensionDevelopmentPath&&($.extensionDevelopmentPath=V.extensionDevelopmentPath,$.extensionDevelopmentKind=V.extensionDevelopmentKind,$["enable-proposed-api"]=V["enable-proposed-api"],$.verbose=V.verbose,$["inspect-extensions"]=V["inspect-extensions"],$["inspect-brk-extensions"]=V["inspect-brk-extensions"],$.debugId=V.debugId,$.extensionEnvironment=V.extensionEnvironment,$["extensions-dir"]=V["extensions-dir"],$["disable-extensions"]=V["disable-extensions"]),$.loggers=V?.loggers??$.loggers}else{const V=this.j.getNewWindowState($);(0,S.mark)("code/willCreateCodeWindow");const K=j=this.F.createInstance(z.CodeWindow,{state:V,extensionDevelopmentPath:$.extensionDevelopmentPath,isExtensionTestHost:!!$.extensionTestsPath});(0,S.mark)("code/didCreateCodeWindow"),F.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(K),at.a.push(K),this.b.fire(K),this.g.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,c.once)(K.onDidSignalReady)(()=>this.c.fire(K)),(0,c.once)(K.onDidClose)(()=>this.jb(K)),(0,c.once)(K.onDidDestroy)(()=>this.f.fire(K)),K.onDidTriggerSystemContextMenu(({x:fe,y:Ce})=>this.h.fire({window:K,x:fe,y:Ce}));const oe=(0,g.assertIsDefined)(K.win?.webContents);oe.removeAllListeners("devtools-reload-page"),oe.on("devtools-reload-page",()=>this.u.reload(K)),this.u.registerWindow(K)}return $.windowId=j.id,j.isReady?this.u.unload(j,4).then(async V=>{V||await this.hb(j,$,F,U)}):await this.hb(j,$,F,U),j}async hb(F,I,O,U){if(I.extensionDevelopmentPath||((0,ne.isWorkspaceIdentifier)(I.workspace)?I.backupPath=this.v.registerWorkspaceBackup({workspace:I.workspace,remoteAuthority:I.remoteAuthority}):(0,ne.isSingleFolderWorkspaceIdentifier)(I.workspace)?I.backupPath=this.v.registerFolderBackup({folderUri:I.workspace.uri,remoteAuthority:I.remoteAuthority}):I.backupPath=this.v.registerEmptyWindowBackup({backupFolder:O.emptyWindowBackupInfo?.backupFolder??(0,ae.createEmptyWorkspaceIdentifier)().id,remoteAuthority:I.remoteAuthority})),this.t.isEnabled()){const j=I.workspace??(0,ne.toWorkspaceIdentifier)(I.backupPath,!1),x=this.ib(O,j,U),$=x instanceof Promise?await x:x;I.profiles.profile=$,I.extensionDevelopmentPath||await this.t.setProfileForWorkspace(j,$)}F.load(I)}ib(F,I,O){return F.forceProfile?this.t.profiles.find(U=>U.name===F.forceProfile)??this.t.createNamedProfile(F.forceProfile):F.forceTempProfile?this.t.createTransientProfile():this.t.getProfileForWorkspace(I)??O}jb(F){const I=at.a.indexOf(F);at.a.splice(I,1),this.g.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const F=P.BrowserWindow.getFocusedWindow();if(F)return this.getWindowById(F.id)}getLastActiveWindow(){return this.lb(this.getWindows())}kb(F){return this.lb(this.getWindows().filter(I=>(0,u.isEqualAuthority)(I.remoteAuthority,F)))}lb(F){const I=Math.max.apply(Math,F.map(O=>O.lastFocusTime));return F.find(O=>O.lastFocusTime===I)}sendToFocused(F,...I){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(F,M.CancellationToken.None,...I)}sendToAll(F,I,O){for(const U of this.getWindows())O&&O.indexOf(U.id)>=0||U.sendWhenReady(F,M.CancellationToken.None,I)}getWindows(){return at.a}getWindowCount(){return at.a.length}getWindowById(F){const I=this.getWindows().filter(O=>O.id===F);return(0,A.firstOrDefault)(I)}getWindowByWebContents(F){const I=P.BrowserWindow.fromWebContents(F);if(!!I)return this.getWindowById(I.id)}};se.a=[],se=ye([Z(2,l.ILogService),Z(3,W.ILoggerMainService),Z(4,T.IStateService),Z(5,Y.IPolicyService),Z(6,i.IEnvironmentMainService),Z(7,q.IUserDataProfilesMainService),Z(8,h.ILifecycleMainService),Z(9,D.IBackupMainService),Z(10,t.IConfigurationService),Z(11,he.IWorkspacesHistoryMainService),Z(12,ce.IWorkspacesManagementMainService),Z(13,n.IInstantiationService),Z(14,a.IDialogMainService),Z(15,s.IFileService),Z(16,R.IProtocolMainService),Z(17,J.IThemeMainService)],se),e.WindowsMainService=se}),define(ee[289],te([0,1,63,30,82,54]),function(G,e,P,L,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let M=class{constructor(f,c,m,v){this.a=f,this.b=c,this.c=m,this.d=v,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(f,c){const m=this.b.getWindowById(f);if(m)return this.a.enterWorkspace(m,this.b.getWindows(),c)}createUntitledWorkspace(f,c,m){return this.a.createUntitledWorkspace(c,m)}deleteUntitledWorkspace(f,c){return this.a.deleteUntitledWorkspace(c)}getWorkspaceIdentifier(f,c){return this.a.getWorkspaceIdentifier(c)}getRecentlyOpened(f){return this.c.getRecentlyOpened()}addRecentlyOpened(f,c){return this.c.addRecentlyOpened(c)}removeRecentlyOpened(f,c){return this.c.removeRecentlyOpened(c)}clearRecentlyOpened(f){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};M=ye([Z(0,A.IWorkspacesManagementMainService),Z(1,L.IWindowsMainService),Z(2,o.IWorkspacesHistoryMainService),Z(3,P.IBackupMainService)],M),e.WorkspacesMainService=M}),define(ee[290],te([0,1,15,42,25,17,44,13,32,50,43,45,2,14,9,4,11,8,31,140,47,154,105,255,157,63,268,19,78,193,87,125,58,109,214,29,62,115,204,228,205,278,111,206,207,16,218,90,77,6,89,282,269,257,20,5,287,59,21,57,279,91,33,260,97,92,24,241,118,48,49,247,274,283,275,284,121,249,250,251,253,258,30,288,259,28,94,82,289,54,256,38,226,53,236,52,81,123,262,276,265,7,119,261,221,65,88,280,252]),function(G,e,P,L,o,A,M,k,f,c,m,v,b,d,S,w,r,u,g,p,y,D,t,a,i,s,n,h,l,E,R,C,T,N,z,B,_,ne,ae,he,ce,J,Y,q,W,H,Q,se,re,F,I,O,U,j,x,$,V,K,oe,fe,Ce,Ee,Re,Oe,ze,ge,pe,Le,ie,ue,de,Pe,Me,Te,Fe,je,Be,We,He,X,le,me,ve,we,Ae,Ue,xe,Ge,Ke,Ye,Ze,rt,ct,gt,Dt,Ct,Rt,Mt,At,Lt,Ot,mt,Tt,Ft,Wt,Ut,Nt,pt,jt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let wt=class extends b.Disposable{constructor(ke,Ie,be,Se,De,$e,Xe,Qe,qe,Ne,Ve){super(),this.c=ke,this.f=Ie,this.g=be,this.h=Se,this.i=De,this.j=$e,this.k=Xe,this.l=Qe,this.m=qe,this.n=Ne,this.p=Ve,this.q(),this.r()}q(){const ke=qe=>qe?.startsWith(`${d.Schemas.vscodeWebview}://`),Ie=new Set(["clipboard-read","clipboard-sanitized-write"]);P.session.defaultSession.setPermissionRequestHandler((qe,Ne,Ve,Je)=>ke(Je.requestingUrl)?Ve(Ie.has(Ne)):Ve(!1)),P.session.defaultSession.setPermissionCheckHandler((qe,Ne,Ve,Je)=>ke(Je.requestingUrl)?Ie.has(Ne):!1);const be=new Set([d.Schemas.file,d.Schemas.vscodeFileResource,d.Schemas.vscodeRemoteResource,"devtools"]),Se=qe=>{for(let Ne=qe;Ne;Ne=Ne.parent)if(Ne.url.startsWith(`${d.Schemas.vscodeWebview}://`))return!0;return!1},De=qe=>qe.resourceType==="xhr"||Se(qe.frame),$e=qe=>{const Ne=qe.frame;if(!Ne||!this.a)return!1;const Ve=P.BrowserWindow.getAllWindows();for(const Je of Ve)if(Ne.processId===Je.webContents.mainFrame.processId)return!0;return!1},Xe=(qe,Ne)=>{if(qe.path!=="/index.html")return!0;const Ve=Ne.frame;if(!Ve||!this.a)return!1;for(const Je of this.a.getWindows())if(Je.win&&Ve.processId===Je.win.webContents.mainFrame.processId)return!0;return!1};P.session.defaultSession.webRequest.onBeforeRequest((qe,Ne)=>{const Ve=u.URI.parse(qe.url);return Ve.scheme===d.Schemas.vscodeWebview&&!Xe(Ve,qe)?(this.h.error("Blocked vscode-webview request",qe.url),Ne({cancel:!0})):Ve.scheme===d.Schemas.vscodeFileResource&&!$e(qe)?(this.h.error("Blocked vscode-file request",qe.url),Ne({cancel:!0})):Ve.path.endsWith(".svg")&&!be.has(Ve.scheme)?Ne({cancel:!De(qe)}):Ne({cancel:!1})}),P.session.defaultSession.webRequest.onHeadersReceived((qe,Ne)=>{const Ve=qe.responseHeaders,Je=Ve["content-type"]||Ve["Content-Type"];if(Je&&Array.isArray(Je)){const _e=u.URI.parse(qe.url);if(_e.path.endsWith(".svg")&&be.has(_e.scheme))return Ve["Content-Type"]=["image/svg+xml"],Ne({cancel:!1,responseHeaders:Ve});if(!_e.path.endsWith(d.Schemas.vscodeRemoteResource)&&Je.some(nt=>nt.toLowerCase().includes("image/svg")))return Ne({cancel:!De(qe)})}return Ne({cancel:!1})});const Qe=P.session.defaultSession;typeof Qe.setCodeCachePath=="function"&&this.i.codeCachePath&&Qe.setCodeCachePath((0,S.join)(this.i.codeCachePath,"chrome"))}r(){(0,k.setUnexpectedErrorHandler)(be=>this.t(be)),process.on("uncaughtException",be=>(0,k.onUnexpectedError)(be)),process.on("unhandledRejection",be=>(0,k.onUnexpectedError)(be)),this.j.onWillShutdown(()=>this.dispose()),(0,p.registerContextMenuListener)(),P.app.on("accessibility-support-changed",(be,Se)=>{this.a?.sendToAll("vscode:accessibilitySupportChanged",Se)}),P.app.on("activate",async(be,Se)=>{this.h.trace("app#activate"),Se||await this.a?.openEmptyWindow({context:1})}),P.app.on("web-contents-created",(be,Se)=>{Se.on("will-navigate",De=>{this.h.error("webContents#will-navigate: Prevented webcontent navigation"),De.preventDefault()}),Se.setWindowOpenHandler(({url:De})=>(this.b?.openExternal(void 0,De),{action:"deny"}))});let ke=[],Ie;P.app.on("open-file",(be,Se)=>{this.h.trace("app#open-file: ",Se),be.preventDefault(),ke.push((0,Ue.hasWorkspaceFileExtension)(Se)?{workspaceUri:u.URI.file(Se)}:{fileUri:u.URI.file(Se)}),Ie!==void 0&&(clearTimeout(Ie),Ie=void 0),Ie=setTimeout(async()=>{await this.a?.open({context:1,cli:this.i.args,urisToOpen:ke,gotoLineMode:!1,preferNewWindow:!0}),ke=[],Ie=void 0},100)}),P.app.on("new-window-for-tab",async()=>{await this.a?.openEmptyWindow({context:4})}),L.validatedIpcMain.handle("vscode:fetchShellEnv",be=>{const Se=this.a?.getWindowByWebContents(be.sender);let De,$e;return Se?.config?(De=Se.config,$e={...process.env,...Se.config.userEnv}):(De=this.i.args,$e=process.env),this.M(De,$e,!1)}),L.validatedIpcMain.handle("vscode:writeNlsFile",(be,Se,De)=>{const $e=this.s([Se]);if(!$e||typeof De!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.m.writeFile($e,A.VSBuffer.fromString(De))}),L.validatedIpcMain.handle("vscode:readNlsFile",async(be,...Se)=>{const De=this.s(Se);if(!De)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.m.readFile(De)).value.toString()}),L.validatedIpcMain.on("vscode:toggleDevTools",be=>be.sender.toggleDevTools()),L.validatedIpcMain.on("vscode:openDevTools",be=>be.sender.openDevTools()),L.validatedIpcMain.on("vscode:reloadWindow",be=>be.sender.reload())}s(ke){let Ie;for(const be of ke)typeof be=="string"&&(typeof Ie!="string"?Ie=be:Ie=(0,S.join)(Ie,be));if(!(typeof Ie!="string"||!(0,S.isAbsolute)(Ie)||!(0,f.isEqualOrParent)(Ie,this.i.cachedLanguagesPath,!w.isLinux)))return u.URI.file(Ie)}t(ke){if(ke){const Ie={message:`[uncaught exception in main]: ${ke.message}`,stack:ke.stack};this.a?.sendToFocused("vscode:reportError",JSON.stringify(Ie))}this.h.error(`[uncaught exception in main]: ${ke}`),ke.stack&&this.h.error(ke.stack)}async startup(){this.h.debug("Starting VS Code"),this.h.debug(`from: ${this.i.appRoot}`),this.h.debug("args:",this.i.args);const ke=this.n.win32AppUserModelId;w.isWindows&&ke&&P.app.setAppUserModelId(ke);try{w.isMacintosh&&this.k.getValue("window.nativeTabs")===!0&&!P.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&P.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ne){this.h.error(Ne)}const Ie=new D.Server;this.j.onWillShutdown(Ne=>{Ne.reason===2&&Ie.dispose()}),this.h.trace("Resolving machine identifier...");const be=await(0,Tt.resolveMachineId)(this.l);this.h.trace(`Resolved machine identifier: ${be}`);const{sharedProcess:Se,sharedProcessReady:De,sharedProcessClient:$e}=this.C(be),Xe=await this.F(be,Se,De);this.D(Xe.createInstance(a.ProxyAuthHandler)),this.D(Xe.createInstance(Lt.UserDataProfilesHandler)),Xe.invokeFunction(Ne=>this.G(Ne,Ie,$e));const Qe=Xe.invokeFunction(Ne=>this.u(Ne,Ie));this.j.phase=2,await Xe.invokeFunction(Ne=>this.H(Ne,Qe)),this.j.phase=3,Xe.invokeFunction(Ne=>this.I(Ne,Se)),this.D(new mt.RunOnceScheduler(()=>{this.D((0,mt.runWhenIdle)(()=>this.j.phase=4,2500))},2500)).schedule()}u(ke,Ie){const be=this.a=ke.get(ve.IWindowsMainService),Se=ke.get(Be.IURLService),De=this.b=ke.get(K.INativeHostMainService),$e=this;Se.registerHandler({async handleURL(Je,_e){return $e.z(be,Se,Je,_e)}});const Xe=this.D(new Ae.ActiveWindowManager({onDidOpenWindow:De.onDidOpenWindow,onDidFocusWindow:De.onDidFocusWindow,getActiveWindowId:()=>De.getActiveWindowId(-1)})),Qe=new y.StaticRouter(Je=>Xe.getActiveClientId().then(_e=>Je===_e)),qe=new We.URLHandlerRouter(Qe,this.h),Ne=Ie.getChannel("urlHandler",qe);Se.registerHandler(new We.URLHandlerChannelClient(Ne));const Ve=this.v();return this.D(new X.ElectronURLListener(Ve?.urls,Se,be,this.i,this.n,this.h)),Ve}v(){const ke=this.i.args["open-url"]?this.i.args._urls||[]:[];ke.length>0&&this.h.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",ke);const Ie=global.getOpenUrls()||[];if(Ie.length>0&&this.h.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",Ie),ke.length+Ie.length===0)return;const be=[];return{urls:[...ke,...Ie].map(De=>{try{return{uri:u.URI.parse(De),originalUrl:De}}catch{this.h.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",De);return}}).filter(De=>{if(!De)return!1;if(this.w(De.uri))return this.h.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",De.uri.toString(!0)),!1;const $e=this.y(De.uri);return $e?(this.h.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",De.uri.toString(!0),$e),be.push($e),!1):(this.h.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",De.uri.toString(!0)),!0)}),openables:be}}w(ke){if(ke.authority===d.Schemas.file&&w.isWindows){const{options:Ie,buttonIndeces:be}=(0,Nt.massageMessageBoxOptions)({type:"question",buttons:[(0,i.localize)(0,null),(0,i.localize)(1,null)],message:(0,i.localize)(2,null,(0,v.getPathLabel)(ke,{os:w.OS,tildify:this.i}),this.n.nameShort),detail:(0,i.localize)(3,null)},this.n);if(be[P.dialog.showMessageBoxSync(Ie)]===1)return!0}return!1}y(ke){if(!!ke.path){if(ke.authority===d.Schemas.file){const Ie=u.URI.file(ke.fsPath);return(0,Ue.hasWorkspaceFileExtension)(Ie)?{workspaceUri:Ie}:{fileUri:Ie}}else if(ke.authority===d.Schemas.vscodeRemote){const Ie=ke.path.indexOf(S.posix.sep,1);if(Ie!==-1){const be=ke.path.substring(1,Ie),Se=ke.path.substring(Ie),De=u.URI.from({scheme:d.Schemas.vscodeRemote,authority:be,path:Se,query:ke.query,fragment:ke.fragment});return(0,Ue.hasWorkspaceFileExtension)(Se)?{workspaceUri:De}:/:[\d]+$/.test(Se)?{fileUri:De}:{folderUri:De}}}}}async z(ke,Ie,be,Se){if(this.h.trace("app#handleProtocolUrl():",be.toString(!0),Se),be.scheme===this.n.urlProtocol&&be.path==="workspace"&&(be=be.with({authority:"file",path:u.URI.parse(be.query).path,query:""})),this.w(be))return this.h.trace("app#handleProtocolUrl() protocol url was blocked:",be.toString(!0)),!0;let De=!1;const $e=new URLSearchParams(be.query);$e.get("windowId")==="_blank"?(this.h.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",be.toString(!0)),$e.delete("windowId"),be=be.with({query:$e.toString()}),De=!0):w.isMacintosh&&ke.getWindowCount()===0&&(this.h.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",be.toString(!0)),De=!0);const Xe=$e.get("continueOn");Xe!==null&&(this.h.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",be.toString(!0)),$e.delete("continueOn"),be=be.with({query:$e.toString()}),this.i.continueOn=Xe??void 0);const Qe=this.y(be);if(Qe){this.h.trace("app#handleProtocolUrl() opening protocol url as window:",Qe,be.toString(!0));const[qe]=await ke.open({context:5,cli:{...this.i.args},urisToOpen:[Qe],forceNewWindow:De,gotoLineMode:!0});return qe.focus(),!0}if(De){this.h.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",be.toString(!0));const[qe]=await ke.open({context:5,cli:{...this.i.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,fe.getRemoteAuthority)(be)});return await qe.ready(),Ie.open(be,Se)}return this.h.trace("app#handleProtocolUrl(): not handled",be.toString(!0),Se),!1}C(ke){const Ie=this.D(this.g.createInstance(Ce.SharedProcess,ke,this.f)),be=(async()=>{this.h.trace("Main->SharedProcess#connect");const De=await Ie.connect();return this.h.trace("Main->SharedProcess#connect: connection established"),new t.Client(De,"main")})(),Se=(async()=>(await Ie.whenReady(),be))();return{sharedProcess:Ie,sharedProcessReady:Se,sharedProcessClient:be}}async F(ke,Ie,be){const Se=new I.ServiceCollection;switch(process.platform){case"win32":Se.set(de.IUpdateService,new re.SyncDescriptor(je.Win32UpdateService));break;case"linux":w.isLinuxSnap?Se.set(de.IUpdateService,new re.SyncDescriptor(Fe.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):Se.set(de.IUpdateService,new re.SyncDescriptor(Te.LinuxUpdateService));break;case"darwin":Se.set(de.IUpdateService,new re.SyncDescriptor(Me.DarwinUpdateService));break}Se.set(ve.IWindowsMainService,new re.SyncDescriptor(we.WindowsMainService,[ke,this.f],!1));const De=new T.DialogMainService(this.h,this.n);Se.set(T.IDialogMainService,De),Se.set(j.ILaunchMainService,new re.SyncDescriptor(j.LaunchMainService,void 0,!1)),Se.set(C.IDiagnosticsMainService,new re.SyncDescriptor(C.DiagnosticsMainService,void 0,!1)),Se.set(R.IDiagnosticsService,y.ProxyChannel.toService((0,y.getDelayedChannel)(be.then(Qe=>Qe.getChannel("diagnostics"))))),Se.set(O.IIssueMainService,new re.SyncDescriptor(O.IssueMainService,[this.f])),Se.set(N.IEncryptionMainService,new re.SyncDescriptor(z.EncryptionMainService,[ke])),Se.set(U.IKeyboardLayoutMainService,new re.SyncDescriptor(U.KeyboardLayoutMainService)),Se.set(K.INativeHostMainService,new re.SyncDescriptor(K.NativeHostMainService,[Ie],!1)),Se.set(l.ICredentialsMainService,new re.SyncDescriptor(Ze.CredentialsNativeMainService)),Se.set(le.IWebviewManagerService,new re.SyncDescriptor(me.WebviewMainService)),Se.set(V.IMenubarMainService,new re.SyncDescriptor(V.MenubarMainService)),Se.set(ae.IExtensionUrlTrustService,new re.SyncDescriptor(he.ExtensionUrlTrustService)),Se.set(ce.IExtensionHostStarter,new re.SyncDescriptor(J.ExtensionHostStarter)),Se.set(ze.IStorageMainService,new re.SyncDescriptor(ze.StorageMainService)),Se.set(ze.IApplicationStorageMainService,new re.SyncDescriptor(ze.ApplicationStorageMainService)),w.isWindows?Se.set(Y.IExternalTerminalMainService,new re.SyncDescriptor(q.WindowsExternalTerminalService)):w.isMacintosh?Se.set(Y.IExternalTerminalMainService,new re.SyncDescriptor(q.MacExternalTerminalService)):w.isLinux&&Se.set(Y.IExternalTerminalMainService,new re.SyncDescriptor(q.LinuxExternalTerminalService));const $e=new n.BackupMainService(this.i,this.k,this.h,this.l);Se.set(s.IBackupMainService,$e);const Xe=new Ye.WorkspacesManagementMainService(this.i,this.h,this.p,$e,De);if(Se.set(Ye.IWorkspacesManagementMainService,Xe),Se.set(xe.IWorkspacesService,new re.SyncDescriptor(Ke.WorkspacesMainService,void 0,!1)),Se.set(Ge.IWorkspacesHistoryMainService,new re.SyncDescriptor(Ge.WorkspacesHistoryMainService,void 0,!1)),Se.set(Be.IURLService,new re.SyncDescriptor(He.NativeURLService,void 0,!1)),(0,ue.supportsTelemetry)(this.n,this.i)){const Qe=(0,ue.isInternalTelemetry)(this.n,this.k),qe=(0,y.getDelayedChannel)(be.then(nt=>nt.getChannel("telemetryAppender"))),Ne=new Le.TelemetryAppenderClient(qe),Ve=(0,ge.resolveCommonProperties)(this.m,(0,o.release)(),(0,o.hostname)(),process.arch,this.n.commit,this.n.version,ke,Qe,this.i.installSourcePath),Je=(0,ue.getPiiPathsFromEnvironment)(this.i),_e={appenders:[Ne],commonProperties:Ve,piiPaths:Je,sendErrorTelemetry:!0};Se.set(pe.ITelemetryService,new re.SyncDescriptor(ie.TelemetryService,[_e],!1))}else Se.set(pe.ITelemetryService,ue.NullTelemetryService);return Se.set(Rt.IExtensionsProfileScannerService,new re.SyncDescriptor(Ft.ExtensionsProfileScannerService,void 0,!0)),Se.set(Mt.IExtensionsScannerService,new re.SyncDescriptor(At.ExtensionsScannerService,void 0,!0)),Se.set(pt.IUtilityProcessWorkerMainService,new re.SyncDescriptor(pt.UtilityProcessWorkerMainService,void 0,!0)),await mt.Promises.settled([$e.initialize(),Xe.initialize()]),this.g.createChild(Se)}G(ke,Ie,be){const Se=y.ProxyChannel.fromService(ke.get(j.ILaunchMainService),{disableMarshalling:!0});this.c.registerChannel("launch",Se);const De=y.ProxyChannel.fromService(ke.get(C.IDiagnosticsMainService),{disableMarshalling:!0});this.c.registerChannel("diagnostics",De);const $e=new ct.PolicyChannel(ke.get(rt.IPolicyService));Ie.registerChannel("policy",$e),be.then(et=>et.registerChannel("policy",$e));const Xe=this.m.getProvider(d.Schemas.file);(0,r.assertType)(Xe instanceof se.DiskFileSystemProvider);const Qe=new Q.DiskFileSystemProviderChannel(Xe,this.h,this.i);Ie.registerChannel(W.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Qe),be.then(et=>et.registerChannel(W.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Qe));const qe=y.ProxyChannel.fromService(ke.get(gt.IUserDataProfilesMainService));Ie.registerChannel("userDataProfiles",qe),be.then(et=>et.registerChannel("userDataProfiles",qe));const Ne=new Dt.RequestChannel(ke.get(Ct.IRequestService));be.then(et=>et.registerChannel("request",Ne));const Ve=new Pe.UpdateChannel(ke.get(de.IUpdateService));Ie.registerChannel("update",Ve);const Je=y.ProxyChannel.fromService(ke.get(O.IIssueMainService));Ie.registerChannel("issue",Je);const _e=y.ProxyChannel.fromService(ke.get(N.IEncryptionMainService));Ie.registerChannel("encryption",_e);const nt=y.ProxyChannel.fromService(ke.get(l.ICredentialsMainService));Ie.registerChannel("credentials",nt);const it=y.ProxyChannel.fromService(ke.get(Ee.ISignService));Ie.registerChannel("sign",it);const lt=y.ProxyChannel.fromService(ke.get(U.IKeyboardLayoutMainService));Ie.registerChannel("keyboardLayout",lt),this.b=ke.get(K.INativeHostMainService);const St=y.ProxyChannel.fromService(this.b);Ie.registerChannel("nativeHost",St),be.then(et=>et.registerChannel("nativeHost",St));const $t=y.ProxyChannel.fromService(ke.get(xe.IWorkspacesService));Ie.registerChannel("workspaces",$t);const zt=y.ProxyChannel.fromService(ke.get(V.IMenubarMainService));Ie.registerChannel("menubar",zt);const Bt=y.ProxyChannel.fromService(ke.get(Be.IURLService));Ie.registerChannel("url",Bt);const qt=y.ProxyChannel.fromService(ke.get(ae.IExtensionUrlTrustService));Ie.registerChannel("extensionUrlTrust",qt);const Ht=y.ProxyChannel.fromService(ke.get(le.IWebviewManagerService));Ie.registerChannel("webview",Ht);const Et=this.D(new Oe.StorageDatabaseChannel(this.h,ke.get(ze.IStorageMainService)));Ie.registerChannel("storage",Et),be.then(et=>et.registerChannel("storage",Et));const xt=this.D(new Ot.ProfileStorageChangesListenerChannel(ke.get(ze.IStorageMainService),ke.get(gt.IUserDataProfilesMainService),this.h));be.then(et=>et.registerChannel("profileStorageListener",xt));const Vt=y.ProxyChannel.fromService(ke.get(Y.IExternalTerminalMainService));Ie.registerChannel("externalTerminal",Vt);const It=new Wt.LoggerChannel(ke.get(Ut.ILoggerMainService));Ie.registerChannel("logger",It),be.then(et=>et.registerChannel("logger",It));const Gt=new E.ElectronExtensionHostDebugBroadcastChannel(ke.get(ve.IWindowsMainService));Ie.registerChannel("extensionhostdebugservice",Gt);const Kt=y.ProxyChannel.fromService(ke.get(ce.IExtensionHostStarter));Ie.registerChannel(ce.ipcExtensionHostStarterChannelName,Kt);const Xt=y.ProxyChannel.fromService(ke.get(pt.IUtilityProcessWorkerMainService));Ie.registerChannel(jt.ipcUtilityProcessWorkerChannelName,Xt)}async H(ke,Ie){const be=this.a=ke.get(ve.IWindowsMainService),Se=(0,_.isLaunchedFromCli)(process.env)?0:4,De=this.i.args;if(Ie){if(Ie.openables.length>0)return be.open({context:Se,cli:De,urisToOpen:Ie.openables,gotoLineMode:!0,initialStartup:!0});if(Ie.urls.length>0)for(const it of Ie.urls){const lt=new URLSearchParams(it.uri.query);if(lt.get("windowId")==="_blank")return lt.delete("windowId"),it.originalUrl=it.uri.toString(!0),it.uri=it.uri.with({query:lt.toString()}),be.open({context:Se,cli:De,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const $e=global.macOpenFiles,Xe=De._.length,Qe=!!De["folder-uri"],qe=!!De["file-uri"],Ne=De["skip-add-to-recently-opened"]===!0,Ve=De.wait&&De.waitMarkerFilePath?u.URI.file(De.waitMarkerFilePath):void 0,Je=De.remote||void 0,_e=De.profile,nt=De["profile-temp"];if(!Xe&&!Qe&&!qe){if(De["new-window"]||_e||nt)return be.open({context:Se,cli:De,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Ne,waitMarkerFileURI:Ve,initialStartup:!0,remoteAuthority:Je,forceProfile:_e,forceTempProfile:nt});if($e.length)return be.open({context:1,cli:De,urisToOpen:$e.map(it=>(0,Ue.hasWorkspaceFileExtension)(it)?{workspaceUri:u.URI.file(it)}:{fileUri:u.URI.file(it)}),noRecentEntry:Ne,waitMarkerFileURI:Ve,initialStartup:!0})}return be.open({context:Se,cli:De,forceNewWindow:De["new-window"]||!Xe&&De["unity-launch"],diffMode:De.diff,mergeMode:De.merge,noRecentEntry:Ne,waitMarkerFileURI:Ve,gotoLineMode:De.goto,initialStartup:!0,remoteAuthority:Je,forceProfile:_e,forceTempProfile:nt})}I(ke,Ie){const be=ke.get(pe.ITelemetryService),Se=ke.get(de.IUpdateService);this.L(be,Ie),this.J(),P.protocol.registerHttpProtocol(d.Schemas.vscodeRemoteResource,(De,$e)=>{$e({url:De.url.replace(/^vscode-remote-resource:/,"http:"),method:De.method})}),(Se instanceof je.Win32UpdateService||Se instanceof Te.LinuxUpdateService||Se instanceof Me.DarwinUpdateService)&&Se.initialize(),this.M(this.i.args,process.env,!0),this.N()}async J(){const ke=this.n.win32MutexName;if(w.isWindows&&ke)try{const Ie=await new Promise((Se,De)=>{G(["windows-mutex"],Se,De)}),be=new Ie.Mutex(ke);(0,c.once)(this.j.onWillShutdown)(()=>be.release())}catch(Ie){this.h.error(Ie)}}L(ke,Ie){let be=!1;(0,c.once)(this.j.onWillShutdown)(()=>be=!0),this.D(Ie.onDidError(({type:Se,details:De})=>{switch(Se){case 2:this.h.error(`[SharedProcess] renderer process gone (reason: ${De?.reason||"<unknown>"}, code: ${De?.exitCode||"<unknown>"})`);break;case 1:this.h.error("[SharedProcess]  detected unresponsive");break;case 3:this.h.error(`[SharedProcess]  failed to load (reason: ${De?.reason||"<unknown>"}, code: ${De?.exitCode||"<unknown>"})`);break}ke.publicLog2("sharedprocesserror",{type:Se,reason:De?.reason,code:De?.exitCode,visible:Ie.isVisible(),utilityprocess:Ie.usingUtilityProcess()?"1":"0",shuttingdown:be})}))}async M(ke,Ie,be){try{return await(0,ne.getResolvedShellEnv)(this.k,this.h,ke,Ie)}catch(Se){const De=(0,M.toErrorMessage)(Se);be?this.a?.sendToFocused("vscode:showResolveShellEnvError",De):this.h.error(De)}return{}}async N(){try{const Ie=(await this.m.readFile(this.i.argvResource)).value.toString(),be=JSON.parse((0,m.stripComments)(Ie)),De=(0,ue.getTelemetryLevel)(this.k)>=1;if(be["enable-crash-reporter"]===void 0){const $e=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${De},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,g.generateUuid)()}"`,"}"],Xe=Ie.substring(0,Ie.length-2).concat(`,
`,$e.join(`
`));await this.m.writeFile(this.i.argvResource,A.VSBuffer.fromString(Xe))}else{const $e=Ie.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${De},`);$e!==Ie&&await this.m.writeFile(this.i.argvResource,A.VSBuffer.fromString($e))}}catch(ke){this.h.error(ke)}}};wt=ye([Z(2,F.IInstantiationService),Z(3,$.ILogService),Z(4,B.IEnvironmentMainService),Z(5,x.ILifecycleMainService),Z(6,h.IConfigurationService),Z(7,Re.IStateService),Z(8,H.IFileService),Z(9,oe.IProductService),Z(10,gt.IUserDataProfilesMainService)],wt),e.CodeApplication=wt}),define(ee[296],te([0,1,15,41,8,27,7,44,13,32,50,45,14,9,64,4,36,26,23,47,96,290,10,19,232,240,29,62,196,16,216,90,77,212,89,20,219,5,66,21,67,263,120,273,52,272,91,239,33,48,69,53,38,227,225,2,39,248,65,220,88,116,246]),function(G,e,P,L,o,A,M,k,f,c,m,v,b,d,S,w,r,u,g,p,y,D,t,a,i,s,n,h,l,E,R,C,T,N,z,B,_,ne,ae,he,ce,J,Y,q,W,H,Q,se,re,F,I,O,U,j,x,$,V,K,oe,fe,Ce,Ee){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Re{main(){try{this.a()}catch(ge){console.error(ge.message),P.app.exit(1)}}async a(){(0,f.setUnexpectedErrorHandler)(Te=>console.error(Te));const[ge,pe,Le,ie,ue,de,Pe,Me]=this.b();try{try{await this.d(Le,Me,ie,ue,Pe)}catch(Te){throw this.f(Le,Pe,Te),Te}await ge.invokeFunction(async Te=>{const Fe=Te.get(ne.ILogService),je=Te.get(B.ILifecycleMainService),Be=Te.get(E.IFileService),We=Te.get(ne.ILoggerService),He=await this.e(Fe,Le,je,ge,Pe,!0);return g.Promises.writeFile(Le.mainLockfile,String(process.pid)).catch(X=>{Fe.warn(`app#startup(): Error writing main lockfile: ${X.stack}`)}),de.logger=We.createLogger("main",{name:(0,t.localize)(0,null)}),(0,m.once)(je.onWillShutdown)(X=>{Be.dispose(),ie.dispose(),X.join("instanceLockfile",g.Promises.unlink(Le.mainLockfile).catch(()=>{}))}),ge.createInstance(D.CodeApplication,He,pe).startup()})}catch(Te){ge.invokeFunction(this.i,Te)}}b(){const ge=new z.ServiceCollection,pe=new $.DisposableStore;process.once("exit",()=>pe.dispose());const Le={_serviceBrand:void 0,...ae.default};ge.set(he.IProductService,Le);const ie=new n.EnvironmentMainService(this.j(),Le),ue=this.c(ie);ge.set(n.IEnvironmentMainService,ie);const de=new oe.LoggerMainService((0,ne.getLogLevel)(ie),ie.logsHome);ge.set(oe.ILoggerMainService,de);const Pe=new _.BufferLogger(de.getLogLevel()),Me=pe.add(new fe.LogService(Pe,[new ne.ConsoleMainLogger(de.getLogLevel())]));ge.set(ne.ILogService,Me);const Te=new R.FileService(Me);ge.set(E.IFileService,Te);const Fe=new C.DiskFileSystemProvider(Me);Te.registerProvider(b.Schemas.file,Fe);const je=new K.UriIdentityService(Te);ge.set(V.IUriIdentityService,je);const Be=new Ee.StateService(1,ie,Me,Te);ge.set(re.IStateReadService,Be),ge.set(re.IStateService,Be);const We=new O.UserDataProfilesMainService(Be,je,ie,Te,Me);ge.set(O.IUserDataProfilesMainService,We);const He=w.isWindows&&Le.win32RegValueName?pe.add(new j.NativePolicyService(Me,Le.win32RegValueName)):ie.policyFile?pe.add(new x.FilePolicyService(ie.policyFile,Te,Me)):new U.NullPolicyService;ge.set(U.IPolicyService,He);const X=new i.ConfigurationService(We.defaultProfile.settingsResource,Te,He,Me);return ge.set(a.IConfigurationService,X),ge.set(B.ILifecycleMainService,new T.SyncDescriptor(B.LifecycleMainService,void 0,!1)),ge.set(W.IRequestService,new T.SyncDescriptor(H.RequestMainService,void 0,!0)),ge.set(I.IThemeMainService,new T.SyncDescriptor(I.ThemeMainService)),ge.set(Q.ISignService,new T.SyncDescriptor(se.SignService,void 0,!1)),ge.set(Y.ITunnelService,new T.SyncDescriptor(q.TunnelService)),ge.set(ce.IProtocolMainService,new J.ProtocolMainService(ie,We,Me)),[new N.InstantiationService(ge,!0),ue,ie,X,Be,Pe,Le,We]}c(ge){const pe={VSCODE_IPC_HOOK:ge.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(Le=>{const ie=process.env[Le];typeof ie=="string"&&(pe[Le]=ie)}),Object.assign(process.env,pe),pe}async d(ge,pe,Le,ie,ue){await M.Promises.settled([Promise.all([ge.extensionsPath,ge.codeCachePath,ge.logsHome.fsPath,pe.defaultProfile.globalStorageHome.fsPath,ge.workspaceStorageHome.fsPath,ge.localHistoryHome.fsPath,ge.backupHome].map(de=>de?g.Promises.mkdir(de,{recursive:!0}):void 0)),ie.init(),Le.initialize()]),pe.init()}async e(ge,pe,Le,ie,ue,de){let Pe;try{(0,S.mark)("code/willStartMainServer"),Pe=await(0,y.serve)(pe.mainIPCHandle),(0,S.mark)("code/didStartMainServer"),(0,m.once)(Le.onWillShutdown)(()=>Pe.dispose())}catch(Me){if(Me.code!=="EADDRINUSE")throw this.f(pe,ue,Me),Me;let Te;try{Te=await(0,y.connect)(pe.mainIPCHandle,"main")}catch(We){if(!de||w.isWindows||We.code!=="ECONNREFUSED")throw We.code==="EPERM"&&this.g((0,t.localize)(1,null,ue.nameShort),(0,t.localize)(2,null),ue),We;try{(0,L.unlinkSync)(pe.mainIPCHandle)}catch(He){throw ge.warn("Could not delete obsolete instance handle",He),He}return this.e(ge,pe,Le,ie,ue,!1)}if(pe.extensionTestsLocationURI&&!pe.debugExtensionHost.break){const We=`Running extension tests from the command line is currently only supported if no other instance of ${ue.nameShort} is running.`;throw ge.error(We),Te.dispose(),new Error(We)}let Fe;!pe.args.wait&&!pe.args.status&&(Fe=setTimeout(()=>{this.g((0,t.localize)(3,null,ue.nameShort),(0,t.localize)(4,null),ue)},1e4));const je=p.ProxyChannel.toService(Te.getChannel("launch"),{disableMarshalling:!0}),Be=p.ProxyChannel.toService(Te.getChannel("diagnostics"),{disableMarshalling:!0});if(pe.args.status)return ie.invokeFunction(async()=>{const We=new s.DiagnosticsService(F.NullTelemetryService,ue),He=await Be.getMainDiagnostics(),X=await Be.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),le=await We.getDiagnostics(He,X);throw console.log(le),new f.ExpectedError});throw w.isWindows&&await this.h(je,ge),ge.trace("Sending env to running instance..."),await je.start(pe.args,process.env),Te.dispose(),Fe&&clearTimeout(Fe),new f.ExpectedError("Sent env to running instance. Terminating...")}if(pe.args.status)throw ge.warn(`Warning: The --status argument can only be used if ${ue.nameShort} is already running. Please run it again after {0} has started.`),new f.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),Pe}f(ge,pe,Le){if(Le.code==="EACCES"||Le.code==="EPERM"){const ie=(0,A.coalesce)([ge.userDataPath,ge.extensionsPath,y.XDG_RUNTIME_DIR]).map(ue=>(0,v.getPathLabel)(o.URI.file(ue),{os:w.OS,tildify:ge}));this.g((0,t.localize)(5,null),(0,t.localize)(6,null,(0,k.toErrorMessage)(Le),ie.join(`
`)),pe)}}g(ge,pe,Le){P.dialog.showMessageBoxSync((0,Ce.massageMessageBoxOptions)({type:"warning",buttons:[(0,t.localize)(7,null)],message:ge,detail:pe},Le).options)}async h(ge,pe){if(w.isWindows){const Le=await ge.getMainProcessId();pe.trace("Sending some foreground love to the running instance:",Le);try{(await new Promise((ie,ue)=>{G(["windows-foreground-love"],ie,ue)})).allowSetForegroundWindow(Le)}catch(ie){pe.error(ie)}}}i(ge,pe){const Le=ge.get(ne.ILogService),ie=ge.get(B.ILifecycleMainService);let ue=0;pe&&(pe.isExpected?pe.message&&Le.trace(pe.message):(ue=1,pe.stack?Le.error(pe.stack):Le.error(`Startup error: ${pe.toString()}`))),ie.kill(ue)}j(){const ge=this.k((0,h.parseMainProcessArgv)(process.argv));if(ge.wait&&!ge.waitMarkerFilePath){const pe=(0,l.createWaitMarkerFileSync)(ge.verbose);pe&&((0,h.addArg)(process.argv,"--waitMarkerFilePath",pe),ge.waitMarkerFilePath=pe)}return ge}k(ge){if(ge["open-url"]&&(ge._urls=ge._,ge._=[]),!ge.remote){const pe=this.l(ge._,ge.goto);ge._=pe}return ge}l(ge,pe){const Le=(0,r.cwd)(),ie=ge.map(Pe=>{let Me=String(Pe),Te;pe&&(Te=(0,c.parseLineAndColumnAware)(Me),Me=Te.path),Me&&(Me=this.m(Le,Me));const Fe=(0,c.sanitizeFilePath)(Me,Le),je=(0,d.basename)(Fe);return je&&!(0,c.isValidBasename)(je)?null:pe&&Te?(Te.path=Fe,this.n(Te)):Fe}),ue=w.isWindows||w.isMacintosh,de=(0,A.distinct)(ie,Pe=>Pe&&ue?Pe.toLowerCase():Pe||"");return(0,A.coalesce)(de)}m(ge,pe){return w.isWindows&&(pe=(0,u.rtrim)(pe,'"')),pe=(0,u.trim)((0,u.trim)(pe," "),"	"),w.isWindows&&(pe=(0,d.resolve)(ge,pe),pe=(0,u.rtrim)(pe,".")),pe}n(ge){const pe=[ge.path];return typeof ge.line=="number"&&pe.push(String(ge.line)),typeof ge.column=="number"&&pe.push(String(ge.column)),pe.join(":")}}new Re().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/3a168b2d1ec767eea02b46d6ed38c755805b43a7/core/vs/code/electron-main/main.js.map
