/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var re=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/nls","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/uri","vs/base/common/types","vs/base/common/path","vs/platform/files/common/files","vs/platform/environment/common/environment","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/platform/userDataProfile/common/userDataProfile","vs/platform/telemetry/common/telemetry","vs/platform/storage/common/storage","vs/base/common/arrays","vs/base/common/network","vs/base/common/resources","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/platform/product/common/productService","vs/base/common/strings","vs/base/node/pfs","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/uuid","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagementUtil","os","vs/base/common/json","vs/base/common/process","vs/base/common/map","vs/base/common/errorMessage","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/stream","vs/platform/externalServices/common/serviceMachineId","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/extpath","vs/base/common/ternarySearchTree","child_process","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/codicons","vs/base/common/hash","fs","vs/base/common/semver/semver","vs/platform/files/common/watcher","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataSync/common/content","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/decorators","vs/base/common/iterator","net","vs/base/common/date","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/contextkey/common/contextkey","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/ipc/common/mainProcessService","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/normalization","vs/base/parts/sandbox/node/electronTypes","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/uriIpc","vs/base/node/powershell","vs/base/node/processes","vs/base/parts/ipc/common/ipc.net","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/extensionManagement/node/extensionManagementService","vs/base/common/assert","vs/base/common/lazy","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/symbols","vs/base/common/themables","vs/base/node/macAddress","vs/base/node/ports","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/cache","vs/base/common/console","vs/base/node/id","vs/base/node/extpath","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","electron","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionTipsService","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/argv","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/shell/node/shellEnv","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/node/sharedProcess/contrib/extensions","vs/base/parts/ipc/node/ipc.net","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","util","minimist","assert","path","graceful-fs","https","yauzl","yazl","zlib","vs/code/node/sharedProcess/sharedProcessMain"],oe=function(te){for(var e=[],O=0,U=te.length;O<U;O++)e[O]=re[te[O]];return e};define(re[62],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function O(N){return(R,I,w)=>{let P=null,S=null;if(typeof w.value=="function"?(P="value",S=w.value):typeof w.get=="function"&&(P="get",S=w.get),!S)throw new Error("not supported");w[P]=N(S,I)}}function U(N,R,I){let w=null,P=null;if(typeof I.value=="function"?(w="value",P=I.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof I.get=="function"&&(w="get",P=I.get),!P)throw new Error("not supported");const S=`$memoize$${R}`;I[w]=function(...p){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,p)}),this[S]}}e.memoize=U;function l(N,R,I){return O((w,P)=>{const S=`$debounce$${P}`,p=`$debounce$result$${P}`;return function(...f){this[p]||(this[p]=I?I():void 0),clearTimeout(this[S]),R&&(this[p]=R(this[p],...f),f=[this[p]]),this[S]=setTimeout(()=>{w.apply(this,f),this[p]=I?I():void 0},N)}})}e.debounce=l;function T(N,R,I){return O((w,P)=>{const S=`$throttle$timer$${P}`,p=`$throttle$result$${P}`,f=`$throttle$lastRun$${P}`,m=`$throttle$pending$${P}`;return function(...E){if(this[p]||(this[p]=I?I():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),R&&(this[p]=R(this[p],...E)),this[m])return;const a=this[f]+N;a<=Date.now()?(this[f]=Date.now(),w.apply(this,[this[p]]),this[p]=I?I():void 0):(this[m]=!0,this[S]=setTimeout(()=>{this[m]=!1,this[f]=Date.now(),w.apply(this,[this[p]]),this[p]=I?I():void 0},a-Date.now()))}})}e.throttle=T}),define(re[10],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class O{constructor(){this.b=[],this.a=function(r){setTimeout(()=>{throw r.stack?v.isErrorNoTelemetry(r)?new v(r.message+`

`+r.stack):new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.b.push(r),()=>{this.d(r)}}c(r){this.b.forEach(t=>{t(r)})}d(r){this.b.splice(this.b.indexOf(r),1)}setUnexpectedErrorHandler(r){this.a=r}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(r){this.a(r),this.c(r)}onUnexpectedExternalError(r){this.a(r)}}e.ErrorHandler=O,e.errorHandler=new O;function U(n){e.errorHandler.setUnexpectedErrorHandler(n)}e.setUnexpectedErrorHandler=U;function l(n){if(!n||typeof n!="object")return!1;const r=n;return r.code==="EPIPE"&&r.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=l;function T(n){w(n)||e.errorHandler.onUnexpectedError(n)}e.onUnexpectedError=T;function N(n){w(n)||e.errorHandler.onUnexpectedExternalError(n)}e.onUnexpectedExternalError=N;function R(n){if(n instanceof Error){const{name:r,message:t}=n,i=n.stacktrace||n.stack;return{$isError:!0,name:r,message:t,stack:i,noTelemetry:v.isErrorNoTelemetry(n)}}return n}e.transformErrorForSerialization=R;const I="Canceled";function w(n){return n instanceof P?!0:n instanceof Error&&n.name===I&&n.message===I}e.isCancellationError=w;class P extends Error{constructor(){super(I),this.name=this.message}}e.CancellationError=P;function S(){const n=new Error(I);return n.name=n.message,n}e.canceled=S;function p(n){return n?new Error(`Illegal argument: ${n}`):new Error("Illegal argument")}e.illegalArgument=p;function f(n){return n?new Error(`Illegal state: ${n}`):new Error("Illegal state")}e.illegalState=f;function m(n){return n?new Error(`readonly property '${n} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=m;function E(n){const r=new Error(`${n} has been disposed`);return r.name="DISPOSED",r}e.disposed=E;function a(n){return n?n.message?n.message:n.stack?n.stack.split(`
`)[0]:String(n):"Error"}e.getErrorMessage=a;class u extends Error{constructor(r){super("NotImplemented"),r&&(this.message=r)}}e.NotImplementedError=u;class h extends Error{constructor(r){super("NotSupported"),r&&(this.message=r)}}e.NotSupportedError=h;class d extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=d;class v extends Error{constructor(r){super(r),this.name="CodeExpectedError"}static fromError(r){if(r instanceof v)return r;const t=new v;return t.message=r.message,t.stack=r.stack,t}static isErrorNoTelemetry(r){return r.name==="CodeExpectedError"}}e.ErrorNoTelemetry=v;class L extends Error{constructor(r){super(r||"An unexpected bug occurred."),Object.setPrototypeOf(this,L.prototype);debugger}}e.BugIndicatingError=L}),define(re[21],oe([0,1,10]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function U(W,Q=0){return W[W.length-(1+Q)]}e.tail=U;function l(W){if(W.length===0)throw new Error("Invalid tail call");return[W.slice(0,W.length-1),W[W.length-1]]}e.tail2=l;function T(W,Q,ee=(le,he)=>le===he){if(W===Q)return!0;if(!W||!Q||W.length!==Q.length)return!1;for(let le=0,he=W.length;le<he;le++)if(!ee(W[le],Q[le]))return!1;return!0}e.equals=T;function N(W,Q){const ee=W.length-1;Q<ee&&(W[Q]=W[ee]),W.pop()}e.removeFastWithoutKeepingOrder=N;function R(W,Q,ee){return I(W.length,le=>ee(W[le],Q))}e.binarySearch=R;function I(W,Q){let ee=0,le=W-1;for(;ee<=le;){const he=(ee+le)/2|0,pe=Q(he);if(pe<0)ee=he+1;else if(pe>0)le=he-1;else return he}return-(ee+1)}e.binarySearch2=I;function w(W,Q){let ee=0,le=W.length;if(le===0)return 0;for(;ee<le;){const he=Math.floor((ee+le)/2);Q(W[he])?le=he:ee=he+1}return ee}e.findFirstInSorted=w;function P(W,Q,ee){if(W=W|0,W>=Q.length)throw new TypeError("invalid index");const le=Q[Math.floor(Q.length*Math.random())],he=[],pe=[],de=[];for(const be of Q){const Ce=ee(be,le);Ce<0?he.push(be):Ce>0?pe.push(be):de.push(be)}return W<he.length?P(W,he,ee):W<he.length+de.length?de[0]:P(W-(he.length+de.length),pe,ee)}e.quickSelect=P;function S(W,Q){const ee=[];let le;for(const he of W.slice(0).sort(Q))!le||Q(le[0],he)!==0?(le=[he],ee.push(le)):le.push(he);return ee}e.groupBy=S;function p(W,Q,ee){const le=[];function he(be,Ce,Re){if(Ce===0&&Re.length===0)return;const ke=le[le.length-1];ke&&ke.start+ke.deleteCount===be?(ke.deleteCount+=Ce,ke.toInsert.push(...Re)):le.push({start:be,deleteCount:Ce,toInsert:Re})}let pe=0,de=0;for(;;){if(pe===W.length){he(pe,0,Q.slice(de));break}if(de===Q.length){he(pe,W.length-pe,[]);break}const be=W[pe],Ce=Q[de],Re=ee(be,Ce);Re===0?(pe+=1,de+=1):Re<0?(he(pe,1,[]),pe+=1):Re>0&&(he(pe,0,[Ce]),de+=1)}return le}e.sortedDiff=p;function f(W,Q,ee){const le=p(W,Q,ee),he=[],pe=[];for(const de of le)he.push(...W.slice(de.start,de.start+de.deleteCount)),pe.push(...de.toInsert);return{removed:he,added:pe}}e.delta=f;function m(W,Q,ee){if(ee===0)return[];const le=W.slice(0,ee).sort(Q);return a(W,Q,le,ee,W.length),le}e.top=m;function E(W,Q,ee,le,he){return ee===0?Promise.resolve([]):new Promise((pe,de)=>{(async()=>{const be=W.length,Ce=W.slice(0,ee).sort(Q);for(let Re=ee,ke=Math.min(ee+le,be);Re<be;Re=ke,ke=Math.min(ke+le,be)){if(Re>ee&&await new Promise(We=>setTimeout(We)),he&&he.isCancellationRequested)throw new O.CancellationError;a(W,Q,Ce,Re,ke)}return Ce})().then(pe,de)})}e.topAsync=E;function a(W,Q,ee,le,he){for(const pe=ee.length;le<he;le++){const de=W[le];if(Q(de,ee[pe-1])<0){ee.pop();const be=w(ee,Ce=>Q(de,Ce)<0);ee.splice(be,0,de)}}}function u(W){return W.filter(Q=>!!Q)}e.coalesce=u;function h(W){let Q=0;for(let ee=0;ee<W.length;ee++)W[ee]&&(W[Q]=W[ee],Q+=1);W.length=Q}e.coalesceInPlace=h;function d(W,Q,ee){W.splice(ee,0,W.splice(Q,1)[0])}e.move=d;function v(W){return!Array.isArray(W)||W.length===0}e.isFalsyOrEmpty=v;function L(W){return Array.isArray(W)&&W.length>0}e.isNonEmptyArray=L;function n(W,Q=ee=>ee){const ee=new Set;return W.filter(le=>{const he=Q(le);return ee.has(he)?!1:(ee.add(he),!0)})}e.distinct=n;function r(W){const Q=new Set;return ee=>{const le=W(ee);return Q.has(le)?!1:(Q.add(le),!0)}}e.uniqueFilter=r;function t(W,Q){const ee=i(W,Q);if(ee!==-1)return W[ee]}e.findLast=t;function i(W,Q){for(let ee=W.length-1;ee>=0;ee--){const le=W[ee];if(Q(le))return ee}return-1}e.lastIndex=i;function s(W,Q){return W.length>0?W[0]:Q}e.firstOrDefault=s;function o(W,Q){return W.length>0?W[W.length-1]:Q}e.lastOrDefault=o;function c(W,Q,ee=(le,he)=>le===he){let le=0;for(let he=0,pe=Math.min(W.length,Q.length);he<pe&&ee(W[he],Q[he]);he++)le++;return le}e.commonPrefixLength=c;function y(W){return[].concat(...W)}e.flatten=y;function b(W,Q){let ee=typeof Q=="number"?W:0;typeof Q=="number"?ee=W:(ee=0,Q=W);const le=[];if(ee<=Q)for(let he=ee;he<Q;he++)le.push(he);else for(let he=ee;he>Q;he--)le.push(he);return le}e.range=b;function g(W,Q,ee){return W.reduce((le,he)=>(le[Q(he)]=ee?ee(he):he,le),Object.create(null))}e.index=g;function D(W,Q){return W.push(Q),()=>A(W,Q)}e.insert=D;function A(W,Q){const ee=W.indexOf(Q);if(ee>-1)return W.splice(ee,1),Q}e.remove=A;function F(W,Q,ee){const le=W.slice(0,Q),he=W.slice(Q);return le.concat(ee,he)}e.arrayInsert=F;function j(W,Q){let ee;if(typeof Q=="number"){let le=Q;ee=()=>{const he=Math.sin(le++)*179426549;return he-Math.floor(he)}}else ee=Math.random;for(let le=W.length-1;le>0;le-=1){const he=Math.floor(ee()*(le+1)),pe=W[le];W[le]=W[he],W[he]=pe}}e.shuffle=j;function x(W,Q){const ee=W.indexOf(Q);ee>-1&&(W.splice(ee,1),W.unshift(Q))}e.pushToStart=x;function V(W,Q){const ee=W.indexOf(Q);ee>-1&&(W.splice(ee,1),W.push(Q))}e.pushToEnd=V;function B(W,Q){for(const ee of Q)W.push(ee)}e.pushMany=B;function Z(W,Q){return Array.isArray(W)?W.map(Q):Q(W)}e.mapArrayOrNot=Z;function J(W){return Array.isArray(W)?W:[W]}e.asArray=J;function K(W){return W[Math.floor(Math.random()*W.length)]}e.getRandomElement=K;function Y(W,Q){for(const ee of W){const le=Q(ee);if(le!==void 0)return le}}e.mapFind=Y;function H(W,Q,ee){const le=X(W,Q),he=W.length,pe=ee.length;W.length=he+pe;for(let de=he-1;de>=le;de--)W[de+pe]=W[de];for(let de=0;de<pe;de++)W[de+le]=ee[de]}e.insertInto=H;function $(W,Q,ee,le){const he=X(W,Q),pe=W.splice(he,ee);return H(W,he,le),pe}e.splice=$;function X(W,Q){return Q<0?Math.max(Q+W.length,0):Math.min(Q,W.length)}var ie;(function(W){function Q(he){return he<0}W.isLessThan=Q;function ee(he){return he>0}W.isGreaterThan=ee;function le(he){return he===0}W.isNeitherLessOrGreaterThan=le,W.greaterThan=1,W.lessThan=-1,W.neitherLessOrGreaterThan=0})(ie=e.CompareResult||(e.CompareResult={}));function se(W,Q){return(ee,le)=>Q(W(ee),W(le))}e.compareBy=se;function ae(...W){return(Q,ee)=>{for(const le of W){const he=le(Q,ee);if(!ie.isNeitherLessOrGreaterThan(he))return he}return ie.neitherLessOrGreaterThan}}e.tieBreakComparators=ae;const q=(W,Q)=>W-Q;e.numberComparator=q;function C(W,Q){if(W.length===0)return;let ee=W[0];for(let le=1;le<W.length;le++){const he=W[le];Q(he,ee)>0&&(ee=he)}return ee}e.findMaxBy=C;function k(W,Q){if(W.length===0)return;let ee=W[0];for(let le=1;le<W.length;le++){const he=W[le];Q(he,ee)>=0&&(ee=he)}return ee}e.findLastMaxBy=k;function M(W,Q){return C(W,(ee,le)=>-Q(ee,le))}e.findMinBy=M;class z{constructor(Q){this.f=Q,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(Q){let ee=this.c;for(;ee<this.f.length&&Q(this.f[ee]);)ee++;const le=ee===this.c?null:this.f.slice(this.c,ee);return this.c=ee,le}takeFromEndWhile(Q){let ee=this.d;for(;ee>=0&&Q(this.f[ee]);)ee--;const le=ee===this.d?null:this.f.slice(ee+1,this.d+1);return this.d=ee,le}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const Q=this.f[this.c];return this.c++,Q}removeLast(){const Q=this.f[this.d];return this.d--,Q}takeCount(Q){const ee=this.f.slice(this.c,this.c+Q);return this.c+=Q,ee}}e.ArrayQueue=z;class _{constructor(Q){this.iterate=Q}forEach(Q){this.iterate(ee=>(Q(ee),!0))}toArray(){const Q=[];return this.iterate(ee=>(Q.push(ee),!0)),Q}filter(Q){return new _(ee=>this.iterate(le=>Q(le)?ee(le):!0))}map(Q){return new _(ee=>this.iterate(le=>ee(Q(le))))}some(Q){let ee=!1;return this.iterate(le=>(ee=Q(le),!ee)),ee}findFirst(Q){let ee;return this.iterate(le=>Q(le)?(ee=le,!1):!0),ee}findLast(Q){let ee;return this.iterate(le=>(Q(le)&&(ee=le),!0)),ee}findLastMaxBy(Q){let ee,le=!0;return this.iterate(he=>((le||ie.isGreaterThan(Q(he,ee)))&&(le=!1,ee=he),!0)),ee}}_.empty=new _(W=>{}),e.CallbackIterable=_}),define(re[129],oe([0,1,10]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function U(I,w){if(!I)throw new Error(w?`Assertion failed (${w})`:"Assertion Failed")}e.ok=U;function l(I,w="Unreachable"){throw new Error(w)}e.assertNever=l;function T(I){if(!I)throw new O.BugIndicatingError("Assertion Failed")}e.assert=T;function N(I){if(!I()){debugger;I(),(0,O.onUnexpectedError)(new O.BugIndicatingError("Assertion Failed"))}}e.assertFn=N;function R(I,w){let P=0;for(;P<I.length-1;){const S=I[P],p=I[P+1];if(!w(S,p))return!1;P++}return!0}e.checkAdjacentItems=R}),define(re[84],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function O(U){const l=this;let T=!1,N;return function(){return T||(T=!0,N=U.apply(l,arguments)),N}}e.once=O}),define(re[63],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var O;(function(U){function l(v){return v&&typeof v=="object"&&typeof v[Symbol.iterator]=="function"}U.is=l;const T=Object.freeze([]);function N(){return T}U.empty=N;function*R(v){yield v}U.single=R;function I(v){return l(v)?v:R(v)}U.wrap=I;function w(v){return v||T}U.from=w;function P(v){return!v||v[Symbol.iterator]().next().done===!0}U.isEmpty=P;function S(v){return v[Symbol.iterator]().next().value}U.first=S;function p(v,L){for(const n of v)if(L(n))return!0;return!1}U.some=p;function f(v,L){for(const n of v)if(L(n))return n}U.find=f;function*m(v,L){for(const n of v)L(n)&&(yield n)}U.filter=m;function*E(v,L){let n=0;for(const r of v)yield L(r,n++)}U.map=E;function*a(...v){for(const L of v)for(const n of L)yield n}U.concat=a;function u(v,L,n){let r=n;for(const t of v)r=L(r,t);return r}U.reduce=u;function*h(v,L,n=v.length){for(L<0&&(L+=v.length),n<0?n+=v.length:n>v.length&&(n=v.length);L<n;L++)yield v[L]}U.slice=h;function d(v,L=Number.POSITIVE_INFINITY){const n=[];if(L===0)return[n,v];const r=v[Symbol.iterator]();for(let t=0;t<L;t++){const i=r.next();if(i.done)return[n,U.empty()];n.push(i.value)}return[n,{[Symbol.iterator](){return r}}]}U.consume=d})(O=e.Iterable||(e.Iterable={}))}),define(re[35],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var O;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(O=e.ScanError||(e.ScanError={}));var U;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(U=e.SyntaxKind||(e.SyntaxKind={}));var l;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(l=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(n){n.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function N(n,r=!1){let t=0;const i=n.length;let s="",o=0,c=16,y=0;function b(V){let B=0,Z=0;for(;B<V;){const J=n.charCodeAt(t);if(J>=48&&J<=57)Z=Z*16+J-48;else if(J>=65&&J<=70)Z=Z*16+J-65+10;else if(J>=97&&J<=102)Z=Z*16+J-97+10;else break;t++,B++}return B<V&&(Z=-1),Z}function g(V){t=V,s="",o=0,c=16,y=0}function D(){const V=t;if(n.charCodeAt(t)===48)t++;else for(t++;t<n.length&&w(n.charCodeAt(t));)t++;if(t<n.length&&n.charCodeAt(t)===46)if(t++,t<n.length&&w(n.charCodeAt(t)))for(t++;t<n.length&&w(n.charCodeAt(t));)t++;else return y=3,n.substring(V,t);let B=t;if(t<n.length&&(n.charCodeAt(t)===69||n.charCodeAt(t)===101))if(t++,(t<n.length&&n.charCodeAt(t)===43||n.charCodeAt(t)===45)&&t++,t<n.length&&w(n.charCodeAt(t))){for(t++;t<n.length&&w(n.charCodeAt(t));)t++;B=t}else y=3;return n.substring(V,B)}function A(){let V="",B=t;for(;;){if(t>=i){V+=n.substring(B,t),y=2;break}const Z=n.charCodeAt(t);if(Z===34){V+=n.substring(B,t),t++;break}if(Z===92){if(V+=n.substring(B,t),t++,t>=i){y=2;break}switch(n.charCodeAt(t++)){case 34:V+='"';break;case 92:V+="\\";break;case 47:V+="/";break;case 98:V+="\b";break;case 102:V+="\f";break;case 110:V+=`
`;break;case 114:V+="\r";break;case 116:V+="	";break;case 117:{const K=b(4);K>=0?V+=String.fromCharCode(K):y=4;break}default:y=5}B=t;continue}if(Z>=0&&Z<=31)if(I(Z)){V+=n.substring(B,t),y=2;break}else y=6;t++}return V}function F(){if(s="",y=0,o=t,t>=i)return o=i,c=17;let V=n.charCodeAt(t);if(R(V)){do t++,s+=String.fromCharCode(V),V=n.charCodeAt(t);while(R(V));return c=15}if(I(V))return t++,s+=String.fromCharCode(V),V===13&&n.charCodeAt(t)===10&&(t++,s+=`
`),c=14;switch(V){case 123:return t++,c=1;case 125:return t++,c=2;case 91:return t++,c=3;case 93:return t++,c=4;case 58:return t++,c=6;case 44:return t++,c=5;case 34:return t++,s=A(),c=10;case 47:{const B=t-1;if(n.charCodeAt(t+1)===47){for(t+=2;t<i&&!I(n.charCodeAt(t));)t++;return s=n.substring(B,t),c=12}if(n.charCodeAt(t+1)===42){t+=2;const Z=i-1;let J=!1;for(;t<Z;){if(n.charCodeAt(t)===42&&n.charCodeAt(t+1)===47){t+=2,J=!0;break}t++}return J||(t++,y=1),s=n.substring(B,t),c=13}return s+=String.fromCharCode(V),t++,c=16}case 45:if(s+=String.fromCharCode(V),t++,t===i||!w(n.charCodeAt(t)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=D(),c=11;default:for(;t<i&&j(V);)t++,V=n.charCodeAt(t);if(o!==t){switch(s=n.substring(o,t),s){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return s+=String.fromCharCode(V),t++,c=16}}function j(V){if(R(V)||I(V))return!1;switch(V){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function x(){let V;do V=F();while(V>=12&&V<=15);return V}return{setPosition:g,getPosition:()=>t,scan:r?x:F,getToken:()=>c,getTokenValue:()=>s,getTokenOffset:()=>o,getTokenLength:()=>t-o,getTokenError:()=>y}}e.createScanner=N;function R(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function I(n){return n===10||n===13||n===8232||n===8233}function w(n){return n>=48&&n<=57}var P;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(P||(P={}));function S(n,r){const t=[],i=new Object;let s;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function y(b,g,D,A){o.value=b,o.offset=g,o.length=D,o.type=A,o.colonOffset=void 0,s=o}try{d(n,{onObjectBegin:(b,g)=>{if(r<=b)throw i;s=void 0,c=r>b,t.push("")},onObjectProperty:(b,g,D)=>{if(r<g||(y(b,g,D,"property"),t[t.length-1]=b,r<=g+D))throw i},onObjectEnd:(b,g)=>{if(r<=b)throw i;s=void 0,t.pop()},onArrayBegin:(b,g)=>{if(r<=b)throw i;s=void 0,t.push(0)},onArrayEnd:(b,g)=>{if(r<=b)throw i;s=void 0,t.pop()},onLiteralValue:(b,g,D)=>{if(r<g||(y(b,g,D,L(b)),r<=g+D))throw i},onSeparator:(b,g,D)=>{if(r<=g)throw i;if(b===":"&&s&&s.type==="property")s.colonOffset=g,c=!1,s=void 0;else if(b===","){const A=t[t.length-1];typeof A=="number"?t[t.length-1]=A+1:(c=!0,t[t.length-1]=""),s=void 0}}})}catch(b){if(b!==i)throw b}return{path:t,previousNode:s,isAtPropertyKey:c,matches:b=>{let g=0;for(let D=0;g<b.length&&D<t.length;D++)if(b[g]===t[D]||b[g]==="*")g++;else if(b[g]!=="**")return!1;return g===b.length}}}e.getLocation=S;function p(n,r=[],t=T.DEFAULT){let i=null,s=[];const o=[];function c(b){Array.isArray(s)?s.push(b):i!==null&&(s[i]=b)}return d(n,{onObjectBegin:()=>{const b={};c(b),o.push(s),s=b,i=null},onObjectProperty:b=>{i=b},onObjectEnd:()=>{s=o.pop()},onArrayBegin:()=>{const b=[];c(b),o.push(s),s=b,i=null},onArrayEnd:()=>{s=o.pop()},onLiteralValue:c,onError:(b,g,D)=>{r.push({error:b,offset:g,length:D})}},t),s[0]}e.parse=p;function f(n,r=[],t=T.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(b){i.type==="property"&&(i.length=b-i.offset,i=i.parent)}function o(b){return i.children.push(b),b}d(n,{onObjectBegin:b=>{i=o({type:"object",offset:b,length:-1,parent:i,children:[]})},onObjectProperty:(b,g,D)=>{i=o({type:"property",offset:g,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:b,offset:g,length:D,parent:i})},onObjectEnd:(b,g)=>{i.length=b+g-i.offset,i=i.parent,s(b+g)},onArrayBegin:(b,g)=>{i=o({type:"array",offset:b,length:-1,parent:i,children:[]})},onArrayEnd:(b,g)=>{i.length=b+g-i.offset,i=i.parent,s(b+g)},onLiteralValue:(b,g,D)=>{o({type:L(b),offset:g,length:D,parent:i,value:b}),s(g+D)},onSeparator:(b,g,D)=>{i.type==="property"&&(b===":"?i.colonOffset=g:b===","&&s(g))},onError:(b,g,D)=>{r.push({error:b,offset:g,length:D})}},t);const y=i.children[0];return y&&delete y.parent,y}e.parseTree=f;function m(n,r){if(!n)return;let t=n;for(const i of r)if(typeof i=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let s=!1;for(const o of t.children)if(Array.isArray(o.children)&&o.children[0].value===i){t=o.children[1],s=!0;break}if(!s)return}else{const s=i;if(t.type!=="array"||s<0||!Array.isArray(t.children)||s>=t.children.length)return;t=t.children[s]}return t}e.findNodeAtLocation=m;function E(n){if(!n.parent||!n.parent.children)return[];const r=E(n.parent);if(n.parent.type==="property"){const t=n.parent.children[0].value;r.push(t)}else if(n.parent.type==="array"){const t=n.parent.children.indexOf(n);t!==-1&&r.push(t)}return r}e.getNodePath=E;function a(n){switch(n.type){case"array":return n.children.map(a);case"object":{const r=Object.create(null);for(const t of n.children){const i=t.children[1];i&&(r[t.children[0].value]=a(i))}return r}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=a;function u(n,r,t=!1){return r>=n.offset&&r<n.offset+n.length||t&&r===n.offset+n.length}e.contains=u;function h(n,r,t=!1){if(u(n,r,t)){const i=n.children;if(Array.isArray(i))for(let s=0;s<i.length&&i[s].offset<=r;s++){const o=h(i[s],r,t);if(o)return o}return n}}e.findNodeAtOffset=h;function d(n,r,t=T.DEFAULT){const i=N(n,!1);function s(se){return se?()=>se(i.getTokenOffset(),i.getTokenLength()):()=>!0}function o(se){return se?ae=>se(ae,i.getTokenOffset(),i.getTokenLength()):()=>!0}const c=s(r.onObjectBegin),y=o(r.onObjectProperty),b=s(r.onObjectEnd),g=s(r.onArrayBegin),D=s(r.onArrayEnd),A=o(r.onLiteralValue),F=o(r.onSeparator),j=s(r.onComment),x=o(r.onError),V=t&&t.disallowComments,B=t&&t.allowTrailingComma;function Z(){for(;;){const se=i.scan();switch(i.getTokenError()){case 4:J(14);break;case 5:J(15);break;case 3:J(13);break;case 1:V||J(11);break;case 2:J(12);break;case 6:J(16);break}switch(se){case 12:case 13:V?J(10):j();break;case 16:J(1);break;case 15:case 14:break;default:return se}}}function J(se,ae=[],q=[]){if(x(se),ae.length+q.length>0){let C=i.getToken();for(;C!==17;){if(ae.indexOf(C)!==-1){Z();break}else if(q.indexOf(C)!==-1)break;C=Z()}}}function K(se){const ae=i.getTokenValue();return se?A(ae):y(ae),Z(),!0}function Y(){switch(i.getToken()){case 11:{let se=0;try{se=JSON.parse(i.getTokenValue()),typeof se!="number"&&(J(2),se=0)}catch{J(2)}A(se);break}case 7:A(null);break;case 8:A(!0);break;case 9:A(!1);break;default:return!1}return Z(),!0}function H(){return i.getToken()!==10?(J(3,[],[2,5]),!1):(K(!1),i.getToken()===6?(F(":"),Z(),ie()||J(4,[],[2,5])):J(5,[],[2,5]),!0)}function $(){c(),Z();let se=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(se||J(4,[],[]),F(","),Z(),i.getToken()===2&&B)break}else se&&J(6,[],[]);H()||J(4,[],[2,5]),se=!0}return b(),i.getToken()!==2?J(7,[2],[]):Z(),!0}function X(){g(),Z();let se=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(se||J(4,[],[]),F(","),Z(),i.getToken()===4&&B)break}else se&&J(6,[],[]);ie()||J(4,[],[4,5]),se=!0}return D(),i.getToken()!==4?J(8,[4],[]):Z(),!0}function ie(){switch(i.getToken()){case 3:return X();case 1:return $();case 10:return K(!0);default:return Y()}}return Z(),i.getToken()===17?t.allowEmptyContent?!0:(J(4,[],[]),!1):ie()?(i.getToken()!==17&&J(9,[],[]),!0):(J(4,[],[]),!1)}e.visit=d;function v(n,r){const t=N(n),i=[];let s,o=0,c;do switch(c=t.getPosition(),s=t.scan(),s){case 12:case 13:case 17:o!==c&&i.push(n.substring(o,c)),r!==void 0&&i.push(t.getTokenValue().replace(/[^\r\n]/g,r)),o=t.getPosition();break}while(s!==17);return i.join("")}e.stripComments=v;function L(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=L}),define(re[42],oe([0,1,35]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function U(w,P,S){let p,f,m,E,a;if(P){for(E=P.offset,a=E+P.length,m=E;m>0&&!I(w,m-1);)m--;let c=a;for(;c<w.length&&!I(w,c);)c++;f=w.substring(m,c),p=N(f,S)}else f=w,p=0,m=0,E=0,a=w.length;const u=R(S,w);let h=!1,d=0,v;S.insertSpaces?v=T(" ",S.tabSize||4):v="	";const L=(0,O.createScanner)(f,!1);let n=!1;function r(){return u+T(v,p+d)}function t(){let c=L.scan();for(h=!1;c===15||c===14;)h=h||c===14,c=L.scan();return n=c===16||L.getTokenError()!==0,c}const i=[];function s(c,y,b){!n&&y<a&&b>E&&w.substring(y,b)!==c&&i.push({offset:y,length:b-y,content:c})}let o=t();if(o!==17){const c=L.getTokenOffset()+m,y=T(v,p);s(y,m,c)}for(;o!==17;){let c=L.getTokenOffset()+L.getTokenLength()+m,y=t(),b="";for(;!h&&(y===12||y===13);){const D=L.getTokenOffset()+m;s(" ",c,D),c=L.getTokenOffset()+L.getTokenLength()+m,b=y===12?r():"",y=t()}if(y===2)o!==1&&(d--,b=r());else if(y===4)o!==3&&(d--,b=r());else{switch(o){case 3:case 1:d++,b=r();break;case 5:case 12:b=r();break;case 13:h?b=r():b=" ";break;case 6:b=" ";break;case 10:if(y===6){b="";break}case 7:case 8:case 9:case 11:case 2:case 4:y===12||y===13?b=" ":y!==5&&y!==17&&(n=!0);break;case 16:n=!0;break}h&&(y===12||y===13)&&(b=r())}const g=L.getTokenOffset()+m;s(b,c,g),o=y}return i}e.format=U;function l(w,P){const S=JSON.stringify(w,void 0,P.insertSpaces?P.tabSize||4:"	");return P.eol!==void 0?S.replace(/\r\n|\r|\n/g,P.eol):S}e.toFormattedString=l;function T(w,P){let S="";for(let p=0;p<P;p++)S+=w;return S}function N(w,P){let S=0,p=0;const f=P.tabSize||4;for(;S<w.length;){const m=w.charAt(S);if(m===" ")p++;else if(m==="	")p+=f;else break;S++}return Math.floor(p/f)}function R(w,P){for(let S=0;S<P.length;S++){const p=P.charAt(S);if(p==="\r")return S+1<P.length&&P.charAt(S+1)===`
`?`\r
`:"\r";if(p===`
`)return`
`}return w&&w.eol||`
`}e.getEOL=R;function I(w,P){return`\r
`.indexOf(w.charAt(P))!==-1}e.isEOL=I}),define(re[85],oe([0,1,35,42]),function(te,e,O,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function l(w,P,S){return T(w,P,void 0,S)}e.removeProperty=l;function T(w,P,S,p,f){const m=P.slice(),E=[],a=(0,O.parseTree)(w,E);let u,h;for(;m.length>0&&(h=m.pop(),u=(0,O.findNodeAtLocation)(a,m),u===void 0&&S!==void 0);)typeof h=="string"?S={[h]:S}:S=[S];if(u)if(u.type==="object"&&typeof h=="string"&&Array.isArray(u.children)){const d=(0,O.findNodeAtLocation)(u,[h]);if(d!==void 0)if(S===void 0){if(!d.parent)throw new Error("Malformed AST");const v=u.children.indexOf(d.parent);let L,n=d.parent.offset+d.parent.length;if(v>0){const r=u.children[v-1];L=r.offset+r.length}else L=u.offset+1,u.children.length>1&&(n=u.children[1].offset);return N(w,{offset:L,length:n-L,content:""},p)}else return N(w,{offset:d.offset,length:d.length,content:JSON.stringify(S)},p);else{if(S===void 0)return[];const v=`${JSON.stringify(h)}: ${JSON.stringify(S)}`,L=f?f(u.children.map(r=>r.children[0].value)):u.children.length;let n;if(L>0){const r=u.children[L-1];n={offset:r.offset+r.length,length:0,content:","+v}}else u.children.length===0?n={offset:u.offset+1,length:0,content:v}:n={offset:u.offset+1,length:0,content:v+","};return N(w,n,p)}}else if(u.type==="array"&&typeof h=="number"&&Array.isArray(u.children))if(S!==void 0){const d=`${JSON.stringify(S)}`;let v;if(u.children.length===0||h===0)v={offset:u.offset+1,length:0,content:u.children.length===0?d:d+","};else{const L=h===-1||h>u.children.length?u.children.length:h,n=u.children[L-1];v={offset:n.offset+n.length,length:0,content:","+d}}return N(w,v,p)}else{const d=h,v=u.children[d];let L;if(u.children.length===1)L={offset:u.offset+1,length:u.length-2,content:""};else if(u.children.length-1===d){const n=u.children[d-1],r=n.offset+n.length,t=u.offset+u.length;L={offset:r,length:t-2-r,content:""}}else L={offset:v.offset,length:u.children[d+1].offset-v.offset,content:""};return N(w,L,p)}else throw new Error(`Can not add ${typeof h!="number"?"index":"property"} to parent of type ${u.type}`);else{if(S===void 0)throw new Error("Can not delete in empty document");return N(w,{offset:a?a.offset:0,length:a?a.length:0,content:JSON.stringify(S)},p)}}e.setProperty=T;function N(w,P,S){let p=R(w,P),f=P.offset,m=P.offset+P.content.length;if(P.length===0||P.content.length===0){for(;f>0&&!(0,U.isEOL)(p,f-1);)f--;for(;m<p.length&&!(0,U.isEOL)(p,m);)m++}const E=(0,U.format)(p,{offset:f,length:m-f},S);for(let u=E.length-1;u>=0;u--){const h=E[u];p=R(p,h),f=Math.min(f,h.offset),m=Math.max(m,h.offset+h.length),m+=h.content.length-h.length}const a=w.length-(p.length-m)-f;return[{offset:f,length:a,content:p.substring(f,m)}]}e.withFormatting=N;function R(w,P){return w.substring(0,P.offset)+P.content+w.substring(P.offset+P.length)}e.applyEdit=R;function I(w,P){const S=P.slice(0).sort((f,m)=>{const E=f.offset-m.offset;return E===0?f.length-m.length:E});let p=w.length;for(let f=S.length-1;f>=0;f--){const m=S[f];if(m.offset+m.length<=p)w=R(w,m);else throw new Error("Overlapping edit");p=m.offset}return w}e.applyEdits=I}),define(re[130],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class O{constructor(l){this.d=l,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(l){this.c=l}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.Lazy=O}),define(re[2],oe([0,1,84,63]),function(te,e,O,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const l=!1;let T=null;function N(o){T=o}if(e.setDisposableTracker=N,l){const o="__is_disposable_tracked__";N(new class{trackDisposable(c){const y=new Error("Potentially leaked disposable").stack;setTimeout(()=>{c[o]||console.log(y)},3e3)}setParent(c,y){if(c&&c!==h.None)try{c[o]=!0}catch{}}markAsDisposed(c){if(c&&c!==h.None)try{c[o]=!0}catch{}}markAsSingleton(c){}})}function R(o){return T?.trackDisposable(o),o}function I(o){T?.markAsDisposed(o)}function w(o,c){T?.setParent(o,c)}function P(o,c){if(!!T)for(const y of o)T.setParent(y,c)}function S(o){return T?.markAsSingleton(o),o}e.markAsSingleton=S;function p(o){return typeof o.dispose=="function"&&o.dispose.length===0}e.isDisposable=p;function f(o){if(U.Iterable.is(o)){const c=[];for(const y of o)if(y)try{y.dispose()}catch(b){c.push(b)}if(c.length===1)throw c[0];if(c.length>1)throw new AggregateError(c,"Encountered errors while disposing of store");return Array.isArray(o)?[]:o}else if(o)return o.dispose(),o}e.dispose=f;function m(o){for(const c of o)p(c)&&c.dispose();return[]}e.disposeIfDisposable=m;function E(...o){const c=a(()=>f(o));return P(o,c),c}e.combinedDisposable=E;function a(o){const c=R({dispose:(0,O.once)(()=>{I(c),o()})});return c}e.toDisposable=a;class u{constructor(){this.c=new Set,this.f=!1,R(this)}dispose(){this.f||(I(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{f(this.c)}finally{this.c.clear()}}add(c){if(!c)return c;if(c===this)throw new Error("Cannot register a disposable on itself!");return w(c,this),this.f?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(c),c}}u.DISABLE_DISPOSED_WARNING=!1,e.DisposableStore=u;class h{constructor(){this.B=new u,R(this),w(this.B,this)}dispose(){I(this),this.B.dispose()}D(c){if(c===this)throw new Error("Cannot register a disposable on itself!");return this.B.add(c)}}h.None=Object.freeze({dispose(){}}),e.Disposable=h;class d{constructor(){this.b=!1,R(this)}get value(){return this.b?void 0:this.a}set value(c){this.b||c===this.a||(this.a?.dispose(),c&&w(c,this),this.a=c)}clear(){this.value=void 0}dispose(){this.b=!0,I(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const c=this.a;return this.a=void 0,c&&w(c,null),c}}e.MutableDisposable=d;class v{constructor(c){this.b=c,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=v;class L{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,R(this)}set(c){let y=c;return this.unset=()=>y=void 0,this.isset=()=>y!==void 0,this.dispose=()=>{y&&(y(),y=void 0,I(this))},this}}e.SafeDisposable=L;class n{constructor(){this.a=new Map}acquire(c,...y){let b=this.a.get(c);b||(b={counter:0,object:this.b(c,...y)},this.a.set(c,b));const{object:g}=b,D=(0,O.once)(()=>{--b.counter===0&&(this.c(c,b.object),this.a.delete(c))});return b.counter++,{object:g,dispose:D}}}e.ReferenceCollection=n;class r{constructor(c){this.a=c}async acquire(c,...y){const b=this.a.acquire(c,...y);try{return{object:await b.object,dispose:()=>b.dispose()}}catch(g){throw b.dispose(),g}}}e.AsyncReferenceCollection=r;class t{constructor(c){this.object=c}dispose(){}}e.ImmortalReference=t;function i(o){const c=new u;try{o(c)}finally{c.dispose()}}e.disposeOnReturn=i;class s{constructor(){this.a=new Map,this.b=!1,R(this)}dispose(){I(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{f(this.a.values())}finally{this.a.clear()}}has(c){return this.a.has(c)}get(c){return this.a.get(c)}set(c,y,b=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),b||this.a.get(c)?.dispose(),this.a.set(c,y)}deleteAndDispose(c){this.a.get(c)?.dispose(),this.a.delete(c)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=s}),define(re[86],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class O{constructor(T){this.element=T,this.next=O.Undefined,this.prev=O.Undefined}}O.Undefined=new O(void 0);class U{constructor(){this.a=O.Undefined,this.b=O.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===O.Undefined}clear(){let T=this.a;for(;T!==O.Undefined;){const N=T.next;T.prev=O.Undefined,T.next=O.Undefined,T=N}this.a=O.Undefined,this.b=O.Undefined,this.c=0}unshift(T){return this.d(T,!1)}push(T){return this.d(T,!0)}d(T,N){const R=new O(T);if(this.a===O.Undefined)this.a=R,this.b=R;else if(N){const w=this.b;this.b=R,R.prev=w,w.next=R}else{const w=this.a;this.a=R,R.next=w,w.prev=R}this.c+=1;let I=!1;return()=>{I||(I=!0,this.e(R))}}shift(){if(this.a!==O.Undefined){const T=this.a.element;return this.e(this.a),T}}pop(){if(this.b!==O.Undefined){const T=this.b.element;return this.e(this.b),T}}e(T){if(T.prev!==O.Undefined&&T.next!==O.Undefined){const N=T.prev;N.next=T.next,T.next.prev=N}else T.prev===O.Undefined&&T.next===O.Undefined?(this.a=O.Undefined,this.b=O.Undefined):T.next===O.Undefined?(this.b=this.b.prev,this.b.next=O.Undefined):T.prev===O.Undefined&&(this.a=this.a.next,this.a.prev=O.Undefined);this.c-=1}*[Symbol.iterator](){let T=this.a;for(;T!==O.Undefined;)yield T.element,T=T.next}}e.LinkedList=U}),define(re[37],oe([0,1]),function(te,e){"use strict";var O,U,l;Object.defineProperty(e,"__esModule",{value:!0}),e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function T(E,a,u){let h=E.get(a);return h===void 0&&(h=u,E.set(a,h)),h}e.getOrSet=T;function N(E){const a=[];return E.forEach((u,h)=>{a.push(`${h} => ${u}`)}),`Map(${E.size}) {${a.join(", ")}}`}e.mapToString=N;function R(E){const a=[];return E.forEach(u=>{a.push(u)}),`Set(${E.size}) {${a.join(", ")}}`}e.setToString=R;class I{constructor(a,u){this.uri=a,this.value=u}}class w{constructor(a,u){this[O]="ResourceMap",a instanceof w?(this.b=new Map(a.b),this.c=u??w.a):(this.b=new Map,this.c=a??w.a)}set(a,u){return this.b.set(this.c(a),new I(a,u)),this}get(a){return this.b.get(this.c(a))?.value}has(a){return this.b.has(this.c(a))}get size(){return this.b.size}clear(){this.b.clear()}delete(a){return this.b.delete(this.c(a))}forEach(a,u){typeof u<"u"&&(a=a.bind(u));for(const[h,d]of this.b)a(d.value,d.uri,this)}*values(){for(const a of this.b.values())yield a.value}*keys(){for(const a of this.b.values())yield a.uri}*entries(){for(const a of this.b.values())yield[a.uri,a.value]}*[(O=Symbol.toStringTag,Symbol.iterator)](){for(const[,a]of this.b)yield[a.uri,a.value]}}w.a=E=>E.toString(),e.ResourceMap=w;class P{constructor(a,u){this[U]="ResourceSet",!a||typeof a=="function"?this.a=new w(a):(this.a=new w(u),a.forEach(this.add,this))}get size(){return this.a.size}add(a){return this.a.set(a,a),this}clear(){this.a.clear()}delete(a){return this.a.delete(a)}forEach(a,u){this.a.forEach((h,d)=>a.call(u,d,d,this))}has(a){return this.a.has(a)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(U=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=P;var S;(function(E){E[E.None=0]="None",E[E.AsOld=1]="AsOld",E[E.AsNew=2]="AsNew"})(S=e.Touch||(e.Touch={}));class p{constructor(){this[l]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(a){return this.a.has(a)}get(a,u=0){const h=this.a.get(a);if(!!h)return u!==0&&this.j(h,u),h.value}set(a,u,h=0){let d=this.a.get(a);if(d)d.value=u,h!==0&&this.j(d,h);else{switch(d={key:a,value:u,next:void 0,previous:void 0},h){case 0:this.h(d);break;case 1:this.g(d);break;case 2:this.h(d);break;default:this.h(d);break}this.a.set(a,d),this.d++}return this}delete(a){return!!this.remove(a)}remove(a){const u=this.a.get(a);if(!!u)return this.a.delete(a),this.i(u),this.d--,u.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const a=this.b;return this.a.delete(a.key),this.i(a),this.d--,a.value}forEach(a,u){const h=this.e;let d=this.b;for(;d;){if(u?a.bind(u)(d.value,d.key,this):a(d.value,d.key,this),this.e!==h)throw new Error("LinkedMap got modified during iteration.");d=d.next}}keys(){const a=this,u=this.e;let h=this.b;const d={[Symbol.iterator](){return d},next(){if(a.e!==u)throw new Error("LinkedMap got modified during iteration.");if(h){const v={value:h.key,done:!1};return h=h.next,v}else return{value:void 0,done:!0}}};return d}values(){const a=this,u=this.e;let h=this.b;const d={[Symbol.iterator](){return d},next(){if(a.e!==u)throw new Error("LinkedMap got modified during iteration.");if(h){const v={value:h.value,done:!1};return h=h.next,v}else return{value:void 0,done:!0}}};return d}entries(){const a=this,u=this.e;let h=this.b;const d={[Symbol.iterator](){return d},next(){if(a.e!==u)throw new Error("LinkedMap got modified during iteration.");if(h){const v={value:[h.key,h.value],done:!1};return h=h.next,v}else return{value:void 0,done:!0}}};return d}[(l=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(a){if(a>=this.size)return;if(a===0){this.clear();return}let u=this.b,h=this.size;for(;u&&h>a;)this.a.delete(u.key),u=u.next,h--;this.b=u,this.d=h,u&&(u.previous=void 0),this.e++}g(a){if(!this.b&&!this.c)this.c=a;else if(this.b)a.next=this.b,this.b.previous=a;else throw new Error("Invalid list");this.b=a,this.e++}h(a){if(!this.b&&!this.c)this.b=a;else if(this.c)a.previous=this.c,this.c.next=a;else throw new Error("Invalid list");this.c=a,this.e++}i(a){if(a===this.b&&a===this.c)this.b=void 0,this.c=void 0;else if(a===this.b){if(!a.next)throw new Error("Invalid list");a.next.previous=void 0,this.b=a.next}else if(a===this.c){if(!a.previous)throw new Error("Invalid list");a.previous.next=void 0,this.c=a.previous}else{const u=a.next,h=a.previous;if(!u||!h)throw new Error("Invalid list");u.previous=h,h.next=u}a.next=void 0,a.previous=void 0,this.e++}j(a,u){if(!this.b||!this.c)throw new Error("Invalid list");if(!(u!==1&&u!==2)){if(u===1){if(a===this.b)return;const h=a.next,d=a.previous;a===this.c?(d.next=void 0,this.c=d):(h.previous=d,d.next=h),a.previous=void 0,a.next=this.b,this.b.previous=a,this.b=a,this.e++}else if(u===2){if(a===this.c)return;const h=a.next,d=a.previous;a===this.b?(h.previous=void 0,this.b=h):(h.previous=d,d.next=h),a.next=void 0,a.previous=this.c,this.c.next=a,this.c=a,this.e++}}}toJSON(){const a=[];return this.forEach((u,h)=>{a.push([h,u])}),a}fromJSON(a){this.clear();for(const[u,h]of a)this.set(u,h)}}e.LinkedMap=p;class f extends p{constructor(a,u=1){super(),this.k=a,this.l=Math.min(Math.max(0,u),1)}get limit(){return this.k}set limit(a){this.k=a,this.m()}get ratio(){return this.l}set ratio(a){this.l=Math.min(Math.max(0,a),1),this.m()}get(a,u=2){return super.get(a,u)}peek(a){return super.get(a,0)}set(a,u){return super.set(a,u,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=f;class m{constructor(){this.a=new Map}add(a){return this.a.set(a,(this.a.get(a)||0)+1),this}delete(a){let u=this.a.get(a)||0;return u===0?!1:(u--,u===0?this.a.delete(a):this.a.set(a,u),!0)}has(a){return this.a.has(a)}}e.CounterSet=m}),define(re[87],oe([0,1,37]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const U=new O.LRUCache(1e4);function l(w){return I(w,"NFC",U)}e.normalizeNFC=l;const T=new O.LRUCache(1e4);function N(w){return I(w,"NFD",T)}e.normalizeNFD=N;const R=/[^\u0000-\u0080]/;function I(w,P,S){if(!w)return w;const p=S.get(w);if(p)return p;let f;return R.test(w)?f=w.normalize(P):f=w,S.set(w,f),f}e.removeAccents=function(){const w=/[\u0300-\u036f]/g;return function(P){return N(P).replace(w,"")}}()}),define(re[131],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function O(R,I,w){return Math.min(Math.max(R,I),w)}e.clamp=O;function U(R,I){return(I+R%I)%I}e.rot=U;class l{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=l;class T{constructor(){this.a=1,this.b=0}update(I){return this.b=this.b+(I-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=T;class N{constructor(I){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(I),this.c.fill(0,0,I)}update(I){const w=this.c[this.d];return this.c[this.d]=I,this.d=(this.d+1)%this.c.length,this.e-=w,this.e+=I,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=N}),function(){function te(l){const T=[];typeof l=="number"&&T.push("code/timeOrigin",l);function N(I){T.push(I,Date.now())}function R(){const I=[];for(let w=0;w<T.length;w+=2)I.push({name:T[w],startTime:T[w+1]});return I}return{mark:N,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?te():{mark(l){performance.mark(l)},getMarks(){let l=performance.timeOrigin;typeof l!="number"&&(l=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(l)}];for(const N of performance.getEntriesByType("mark"))T.push({name:N.name,startTime:Math.round(l+N.startTime)});return T}};if(typeof process=="object"){const l=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return te(l)}else return console.trace("perf-util loaded in UNKNOWN environment"),te()}function O(l){return l.MonacoPerformanceMarks||(l.MonacoPerformanceMarks=e()),l.MonacoPerformanceMarks}var U;typeof global=="object"?U=global:typeof self=="object"?U=self:U={},typeof define=="function"?define("vs/base/common/performance",[],function(){return O(U)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=O(U):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),U.perf=O(U))}(),function(te,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var O=e();for(var U in O)(typeof exports=="object"?exports:te)[U]=O[U]}}(typeof self<"u"?self:this,function(){return function(te){var e={};function O(U){if(e[U])return e[U].exports;var l=e[U]={i:U,l:!1,exports:{}};return te[U].call(l.exports,l,l.exports,O),l.l=!0,l.exports}return O.m=te,O.c=e,O.d=function(U,l,T){O.o(U,l)||Object.defineProperty(U,l,{enumerable:!0,get:T})},O.r=function(U){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(U,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(U,"__esModule",{value:!0})},O.t=function(U,l){if(1&l&&(U=O(U)),8&l||4&l&&typeof U=="object"&&U&&U.__esModule)return U;var T=Object.create(null);if(O.r(T),Object.defineProperty(T,"default",{enumerable:!0,value:U}),2&l&&typeof U!="string")for(var N in U)O.d(T,N,function(R){return U[R]}.bind(null,N));return T},O.n=function(U){var l=U&&U.__esModule?function(){return U.default}:function(){return U};return O.d(l,"a",l),l},O.o=function(U,l){return Object.prototype.hasOwnProperty.call(U,l)},O.p="",O(O.s=0)}([function(te,e,O){(function(U){var l;e=te.exports=q,l=typeof U=="object"&&U.env&&U.env.NODE_DEBUG&&/\bsemver\b/i.test(U.env.NODE_DEBUG)?function(){var ce=Array.prototype.slice.call(arguments,0);ce.unshift("SEMVER"),console.log.apply(console,ce)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var T=256,N=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],I=e.src=[],w=0,P=w++;I[P]="0|[1-9]\\d*";var S=w++;I[S]="[0-9]+";var p=w++;I[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var f=w++;I[f]="("+I[P]+")\\.("+I[P]+")\\.("+I[P]+")";var m=w++;I[m]="("+I[S]+")\\.("+I[S]+")\\.("+I[S]+")";var E=w++;I[E]="(?:"+I[P]+"|"+I[p]+")";var a=w++;I[a]="(?:"+I[S]+"|"+I[p]+")";var u=w++;I[u]="(?:-("+I[E]+"(?:\\."+I[E]+")*))";var h=w++;I[h]="(?:-?("+I[a]+"(?:\\."+I[a]+")*))";var d=w++;I[d]="[0-9A-Za-z-]+";var v=w++;I[v]="(?:\\+("+I[d]+"(?:\\."+I[d]+")*))";var L=w++,n="v?"+I[f]+I[u]+"?"+I[v]+"?";I[L]="^"+n+"$";var r="[v=\\s]*"+I[m]+I[h]+"?"+I[v]+"?",t=w++;I[t]="^"+r+"$";var i=w++;I[i]="((?:<|>)?=?)";var s=w++;I[s]=I[S]+"|x|X|\\*";var o=w++;I[o]=I[P]+"|x|X|\\*";var c=w++;I[c]="[v=\\s]*("+I[o]+")(?:\\.("+I[o]+")(?:\\.("+I[o]+")(?:"+I[u]+")?"+I[v]+"?)?)?";var y=w++;I[y]="[v=\\s]*("+I[s]+")(?:\\.("+I[s]+")(?:\\.("+I[s]+")(?:"+I[h]+")?"+I[v]+"?)?)?";var b=w++;I[b]="^"+I[i]+"\\s*"+I[c]+"$";var g=w++;I[g]="^"+I[i]+"\\s*"+I[y]+"$";var D=w++;I[D]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var A=w++;I[A]="(?:~>?)";var F=w++;I[F]="(\\s*)"+I[A]+"\\s+",R[F]=new RegExp(I[F],"g");var j=w++;I[j]="^"+I[A]+I[c]+"$";var x=w++;I[x]="^"+I[A]+I[y]+"$";var V=w++;I[V]="(?:\\^)";var B=w++;I[B]="(\\s*)"+I[V]+"\\s+",R[B]=new RegExp(I[B],"g");var Z=w++;I[Z]="^"+I[V]+I[c]+"$";var J=w++;I[J]="^"+I[V]+I[y]+"$";var K=w++;I[K]="^"+I[i]+"\\s*("+r+")$|^$";var Y=w++;I[Y]="^"+I[i]+"\\s*("+n+")$|^$";var H=w++;I[H]="(\\s*)"+I[i]+"\\s*("+r+"|"+I[c]+")",R[H]=new RegExp(I[H],"g");var $=w++;I[$]="^\\s*("+I[c]+")\\s+-\\s+("+I[c]+")\\s*$";var X=w++;I[X]="^\\s*("+I[y]+")\\s+-\\s+("+I[y]+")\\s*$";var ie=w++;I[ie]="(<|>)?=?\\s*\\*";for(var se=0;se<35;se++)l(se,I[se]),R[se]||(R[se]=new RegExp(I[se]));function ae(ce,fe){if(ce instanceof q)return ce;if(typeof ce!="string"||ce.length>T||!(fe?R[t]:R[L]).test(ce))return null;try{return new q(ce,fe)}catch{return null}}function q(ce,fe){if(ce instanceof q){if(ce.loose===fe)return ce;ce=ce.version}else if(typeof ce!="string")throw new TypeError("Invalid Version: "+ce);if(ce.length>T)throw new TypeError("version is longer than "+T+" characters");if(!(this instanceof q))return new q(ce,fe);l("SemVer",ce,fe),this.loose=fe;var ge=ce.trim().match(fe?R[t]:R[L]);if(!ge)throw new TypeError("Invalid Version: "+ce);if(this.raw=ce,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>N||this.major<0)throw new TypeError("Invalid major version");if(this.minor>N||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>N||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(Ie){if(/^[0-9]+$/.test(Ie)){var Pe=+Ie;if(Pe>=0&&Pe<N)return Pe}return Ie}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=ae,e.valid=function(ce,fe){var ge=ae(ce,fe);return ge?ge.version:null},e.clean=function(ce,fe){var ge=ae(ce.trim().replace(/^[=v]+/,""),fe);return ge?ge.version:null},e.SemVer=q,q.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},q.prototype.toString=function(){return this.version},q.prototype.compare=function(ce){return l("SemVer.compare",this.version,this.loose,ce),ce instanceof q||(ce=new q(ce,this.loose)),this.compareMain(ce)||this.comparePre(ce)},q.prototype.compareMain=function(ce){return ce instanceof q||(ce=new q(ce,this.loose)),k(this.major,ce.major)||k(this.minor,ce.minor)||k(this.patch,ce.patch)},q.prototype.comparePre=function(ce){if(ce instanceof q||(ce=new q(ce,this.loose)),this.prerelease.length&&!ce.prerelease.length)return-1;if(!this.prerelease.length&&ce.prerelease.length)return 1;if(!this.prerelease.length&&!ce.prerelease.length)return 0;var fe=0;do{var ge=this.prerelease[fe],Ie=ce.prerelease[fe];if(l("prerelease compare",fe,ge,Ie),ge===void 0&&Ie===void 0)return 0;if(Ie===void 0)return 1;if(ge===void 0)return-1;if(ge!==Ie)return k(ge,Ie)}while(++fe)},q.prototype.inc=function(ce,fe){switch(ce){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",fe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",fe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",fe),this.inc("pre",fe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",fe),this.inc("pre",fe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}fe&&(this.prerelease[0]===fe?isNaN(this.prerelease[1])&&(this.prerelease=[fe,0]):this.prerelease=[fe,0]);break;default:throw new Error("invalid increment argument: "+ce)}return this.format(),this.raw=this.version,this},e.inc=function(ce,fe,ge,Ie){typeof ge=="string"&&(Ie=ge,ge=void 0);try{return new q(ce,ge).inc(fe,Ie).version}catch{return null}},e.diff=function(ce,fe){if(W(ce,fe))return null;var ge=ae(ce),Ie=ae(fe);if(ge.prerelease.length||Ie.prerelease.length){for(var Pe in ge)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&ge[Pe]!==Ie[Pe])return"pre"+Pe;return"prerelease"}for(var Pe in ge)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&ge[Pe]!==Ie[Pe])return Pe},e.compareIdentifiers=k;var C=/^[0-9]+$/;function k(ce,fe){var ge=C.test(ce),Ie=C.test(fe);return ge&&Ie&&(ce=+ce,fe=+fe),ge&&!Ie?-1:Ie&&!ge?1:ce<fe?-1:ce>fe?1:0}function M(ce,fe,ge){return new q(ce,ge).compare(new q(fe,ge))}function z(ce,fe,ge){return M(ce,fe,ge)>0}function _(ce,fe,ge){return M(ce,fe,ge)<0}function W(ce,fe,ge){return M(ce,fe,ge)===0}function Q(ce,fe,ge){return M(ce,fe,ge)!==0}function ee(ce,fe,ge){return M(ce,fe,ge)>=0}function le(ce,fe,ge){return M(ce,fe,ge)<=0}function he(ce,fe,ge,Ie){var Pe;switch(fe){case"===":typeof ce=="object"&&(ce=ce.version),typeof ge=="object"&&(ge=ge.version),Pe=ce===ge;break;case"!==":typeof ce=="object"&&(ce=ce.version),typeof ge=="object"&&(ge=ge.version),Pe=ce!==ge;break;case"":case"=":case"==":Pe=W(ce,ge,Ie);break;case"!=":Pe=Q(ce,ge,Ie);break;case">":Pe=z(ce,ge,Ie);break;case">=":Pe=ee(ce,ge,Ie);break;case"<":Pe=_(ce,ge,Ie);break;case"<=":Pe=le(ce,ge,Ie);break;default:throw new TypeError("Invalid operator: "+fe)}return Pe}function pe(ce,fe){if(ce instanceof pe){if(ce.loose===fe)return ce;ce=ce.value}if(!(this instanceof pe))return new pe(ce,fe);l("comparator",ce,fe),this.loose=fe,this.parse(ce),this.semver===de?this.value="":this.value=this.operator+this.semver.version,l("comp",this)}e.rcompareIdentifiers=function(ce,fe){return k(fe,ce)},e.major=function(ce,fe){return new q(ce,fe).major},e.minor=function(ce,fe){return new q(ce,fe).minor},e.patch=function(ce,fe){return new q(ce,fe).patch},e.compare=M,e.compareLoose=function(ce,fe){return M(ce,fe,!0)},e.rcompare=function(ce,fe,ge){return M(fe,ce,ge)},e.sort=function(ce,fe){return ce.sort(function(ge,Ie){return e.compare(ge,Ie,fe)})},e.rsort=function(ce,fe){return ce.sort(function(ge,Ie){return e.rcompare(ge,Ie,fe)})},e.gt=z,e.lt=_,e.eq=W,e.neq=Q,e.gte=ee,e.lte=le,e.cmp=he,e.Comparator=pe;var de={};function be(ce,fe){if(ce instanceof be)return ce.loose===fe?ce:new be(ce.raw,fe);if(ce instanceof pe)return new be(ce.value,fe);if(!(this instanceof be))return new be(ce,fe);if(this.loose=fe,this.raw=ce,this.set=ce.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ce);this.format()}function Ce(ce){return!ce||ce.toLowerCase()==="x"||ce==="*"}function Re(ce,fe,ge,Ie,Pe,Fe,Le,qe,Me,Ne,je,ne,ue){return((fe=Ce(ge)?"":Ce(Ie)?">="+ge+".0.0":Ce(Pe)?">="+ge+"."+Ie+".0":">="+fe)+" "+(qe=Ce(Me)?"":Ce(Ne)?"<"+(+Me+1)+".0.0":Ce(je)?"<"+Me+"."+(+Ne+1)+".0":ne?"<="+Me+"."+Ne+"."+je+"-"+ne:"<="+qe)).trim()}function ke(ce,fe){for(var ge=0;ge<ce.length;ge++)if(!ce[ge].test(fe))return!1;if(fe.prerelease.length){for(ge=0;ge<ce.length;ge++)if(l(ce[ge].semver),ce[ge].semver!==de&&ce[ge].semver.prerelease.length>0){var Ie=ce[ge].semver;if(Ie.major===fe.major&&Ie.minor===fe.minor&&Ie.patch===fe.patch)return!0}return!1}return!0}function We(ce,fe,ge){try{fe=new be(fe,ge)}catch{return!1}return fe.test(ce)}function Ye(ce,fe,ge,Ie){var Pe,Fe,Le,qe,Me;switch(ce=new q(ce,Ie),fe=new be(fe,Ie),ge){case">":Pe=z,Fe=le,Le=_,qe=">",Me=">=";break;case"<":Pe=_,Fe=ee,Le=z,qe="<",Me="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(We(ce,fe,Ie))return!1;for(var Ne=0;Ne<fe.set.length;++Ne){var je=fe.set[Ne],ne=null,ue=null;if(je.forEach(function(me){me.semver===de&&(me=new pe(">=0.0.0")),ne=ne||me,ue=ue||me,Pe(me.semver,ne.semver,Ie)?ne=me:Le(me.semver,ue.semver,Ie)&&(ue=me)}),ne.operator===qe||ne.operator===Me||(!ue.operator||ue.operator===qe)&&Fe(ce,ue.semver)||ue.operator===Me&&Le(ce,ue.semver))return!1}return!0}pe.prototype.parse=function(ce){var fe=this.loose?R[K]:R[Y],ge=ce.match(fe);if(!ge)throw new TypeError("Invalid comparator: "+ce);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new q(ge[2],this.loose):this.semver=de},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(ce){return l("Comparator.test",ce,this.loose),this.semver===de||(typeof ce=="string"&&(ce=new q(ce,this.loose)),he(ce,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(ce,fe){if(!(ce instanceof pe))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new be(ce.value,fe),We(this.value,ge,fe);if(ce.operator==="")return ge=new be(this.value,fe),We(ce.semver,ge,fe);var Ie=!(this.operator!==">="&&this.operator!==">"||ce.operator!==">="&&ce.operator!==">"),Pe=!(this.operator!=="<="&&this.operator!=="<"||ce.operator!=="<="&&ce.operator!=="<"),Fe=this.semver.version===ce.semver.version,Le=!(this.operator!==">="&&this.operator!=="<="||ce.operator!==">="&&ce.operator!=="<="),qe=he(this.semver,"<",ce.semver,fe)&&(this.operator===">="||this.operator===">")&&(ce.operator==="<="||ce.operator==="<"),Me=he(this.semver,">",ce.semver,fe)&&(this.operator==="<="||this.operator==="<")&&(ce.operator===">="||ce.operator===">");return Ie||Pe||Fe&&Le||qe||Me},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(ce){return ce.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(ce){var fe=this.loose;ce=ce.trim(),l("range",ce,fe);var ge=fe?R[X]:R[$];ce=ce.replace(ge,Re),l("hyphen replace",ce),ce=ce.replace(R[H],"$1$2$3"),l("comparator trim",ce,R[H]),ce=(ce=(ce=ce.replace(R[F],"$1~")).replace(R[B],"$1^")).split(/\s+/).join(" ");var Ie=fe?R[K]:R[Y],Pe=ce.split(" ").map(function(Fe){return function(Le,qe){return l("comp",Le),Le=function(Me,Ne){return Me.trim().split(/\s+/).map(function(je){return function(ne,ue){l("caret",ne,ue);var me=ue?R[J]:R[Z];return ne.replace(me,function(we,ve,Ee,De,Ae){var Te;return l("caret",ne,we,ve,Ee,De,Ae),Ce(ve)?Te="":Ce(Ee)?Te=">="+ve+".0.0 <"+(+ve+1)+".0.0":Ce(De)?Te=ve==="0"?">="+ve+"."+Ee+".0 <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+".0 <"+(+ve+1)+".0.0":Ae?(l("replaceCaret pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Te=ve==="0"?Ee==="0"?">="+ve+"."+Ee+"."+De+Ae+" <"+ve+"."+Ee+"."+(+De+1):">="+ve+"."+Ee+"."+De+Ae+" <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+"."+De+Ae+" <"+(+ve+1)+".0.0"):(l("no pr"),Te=ve==="0"?Ee==="0"?">="+ve+"."+Ee+"."+De+" <"+ve+"."+Ee+"."+(+De+1):">="+ve+"."+Ee+"."+De+" <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+"."+De+" <"+(+ve+1)+".0.0"),l("caret return",Te),Te})}(je,Ne)}).join(" ")}(Le,qe),l("caret",Le),Le=function(Me,Ne){return Me.trim().split(/\s+/).map(function(je){return function(ne,ue){var me=ue?R[x]:R[j];return ne.replace(me,function(we,ve,Ee,De,Ae){var Te;return l("tilde",ne,we,ve,Ee,De,Ae),Ce(ve)?Te="":Ce(Ee)?Te=">="+ve+".0.0 <"+(+ve+1)+".0.0":Ce(De)?Te=">="+ve+"."+Ee+".0 <"+ve+"."+(+Ee+1)+".0":Ae?(l("replaceTilde pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Te=">="+ve+"."+Ee+"."+De+Ae+" <"+ve+"."+(+Ee+1)+".0"):Te=">="+ve+"."+Ee+"."+De+" <"+ve+"."+(+Ee+1)+".0",l("tilde return",Te),Te})}(je,Ne)}).join(" ")}(Le,qe),l("tildes",Le),Le=function(Me,Ne){return l("replaceXRanges",Me,Ne),Me.split(/\s+/).map(function(je){return function(ne,ue){ne=ne.trim();var me=ue?R[g]:R[b];return ne.replace(me,function(we,ve,Ee,De,Ae,Te){l("xRange",ne,we,ve,Ee,De,Ae,Te);var Ue=Ce(Ee),$e=Ue||Ce(De),ze=$e||Ce(Ae);return ve==="="&&ze&&(ve=""),Ue?we=ve===">"||ve==="<"?"<0.0.0":"*":ve&&ze?($e&&(De=0),ze&&(Ae=0),ve===">"?(ve=">=",$e?(Ee=+Ee+1,De=0,Ae=0):ze&&(De=+De+1,Ae=0)):ve==="<="&&(ve="<",$e?Ee=+Ee+1:De=+De+1),we=ve+Ee+"."+De+"."+Ae):$e?we=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":ze&&(we=">="+Ee+"."+De+".0 <"+Ee+"."+(+De+1)+".0"),l("xRange return",we),we})}(je,Ne)}).join(" ")}(Le,qe),l("xrange",Le),Le=function(Me,Ne){return l("replaceStars",Me,Ne),Me.trim().replace(R[ie],"")}(Le,qe),l("stars",Le),Le}(Fe,fe)}).join(" ").split(/\s+/);return this.loose&&(Pe=Pe.filter(function(Fe){return!!Fe.match(Ie)})),Pe=Pe.map(function(Fe){return new pe(Fe,fe)})},be.prototype.intersects=function(ce,fe){if(!(ce instanceof be))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(Ie){return ce.set.some(function(Pe){return Pe.every(function(Fe){return Ie.intersects(Fe,fe)})})})})},e.toComparators=function(ce,fe){return new be(ce,fe).set.map(function(ge){return ge.map(function(Ie){return Ie.value}).join(" ").trim().split(" ")})},be.prototype.test=function(ce){if(!ce)return!1;typeof ce=="string"&&(ce=new q(ce,this.loose));for(var fe=0;fe<this.set.length;fe++)if(ke(this.set[fe],ce))return!0;return!1},e.satisfies=We,e.maxSatisfying=function(ce,fe,ge){var Ie=null,Pe=null;try{var Fe=new be(fe,ge)}catch{return null}return ce.forEach(function(Le){Fe.test(Le)&&(Ie&&Pe.compare(Le)!==-1||(Pe=new q(Ie=Le,ge)))}),Ie},e.minSatisfying=function(ce,fe,ge){var Ie=null,Pe=null;try{var Fe=new be(fe,ge)}catch{return null}return ce.forEach(function(Le){Fe.test(Le)&&(Ie&&Pe.compare(Le)!==1||(Pe=new q(Ie=Le,ge)))}),Ie},e.validRange=function(ce,fe){try{return new be(ce,fe).range||"*"}catch{return null}},e.ltr=function(ce,fe,ge){return Ye(ce,fe,"<",ge)},e.gtr=function(ce,fe,ge){return Ye(ce,fe,">",ge)},e.outside=Ye,e.prerelease=function(ce,fe){var ge=ae(ce,fe);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(ce,fe,ge){return ce=new be(ce,ge),fe=new be(fe,ge),ce.intersects(fe)},e.coerce=function(ce){if(ce instanceof q)return ce;if(typeof ce!="string")return null;var fe=ce.match(R[D]);return fe==null?null:ae((fe[1]||"0")+"."+(fe[2]||"0")+"."+(fe[3]||"0"))}}).call(this,O(1))},function(te,e){var O,U,l=te.exports={};function T(){throw new Error("setTimeout has not been defined")}function N(){throw new Error("clearTimeout has not been defined")}function R(a){if(O===setTimeout)return setTimeout(a,0);if((O===T||!O)&&setTimeout)return O=setTimeout,setTimeout(a,0);try{return O(a,0)}catch{try{return O.call(null,a,0)}catch{return O.call(this,a,0)}}}(function(){try{O=typeof setTimeout=="function"?setTimeout:T}catch{O=T}try{U=typeof clearTimeout=="function"?clearTimeout:N}catch{U=N}})();var I,w=[],P=!1,S=-1;function p(){P&&I&&(P=!1,I.length?w=I.concat(w):S=-1,w.length&&f())}function f(){if(!P){var a=R(p);P=!0;for(var u=w.length;u;){for(I=w,w=[];++S<u;)I&&I[S].run();S=-1,u=w.length}I=null,P=!1,function(h){if(U===clearTimeout)return clearTimeout(h);if((U===N||!U)&&clearTimeout)return U=clearTimeout,clearTimeout(h);try{U(h)}catch{try{return U.call(null,h)}catch{return U.call(this,h)}}}(a)}}function m(a,u){this.fun=a,this.array=u}function E(){}l.nextTick=function(a){var u=new Array(arguments.length-1);if(arguments.length>1)for(var h=1;h<arguments.length;h++)u[h-1]=arguments[h];w.push(new m(a,u)),w.length!==1||P||R(f)},m.prototype.run=function(){this.fun.apply(null,this.array)},l.title="browser",l.browser=!0,l.env={},l.argv=[],l.version="",l.versions={},l.on=E,l.addListener=E,l.once=E,l.off=E,l.removeListener=E,l.removeAllListeners=E,l.emit=E,l.prependListener=E,l.prependOnceListener=E,l.listeners=function(a){return[]},l.binding=function(a){throw new Error("process.binding is not supported")},l.cwd=function(){return"/"},l.chdir=function(a){throw new Error("process.chdir is not supported")},l.umask=function(){return 0}}])}),define(re[132],oe([0,1]),function(te,e){"use strict";var O;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class U{constructor(R,I,w){this.level=R,this.key=I,this.value=w,this.forward=[]}}const l=void 0;class T{constructor(R,I=2**16){this.comparator=R,this[O]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(I)|0),this.e=new U(this.c,l,l)}get size(){return this.f}clear(){this.e=new U(this.c,l,l)}has(R){return Boolean(T.g(this,R,this.comparator))}get(R){return T.g(this,R,this.comparator)?.value}set(R,I){return T.h(this,R,I,this.comparator)&&(this.f+=1),this}delete(R){const I=T.k(this,R,this.comparator);return I&&(this.f-=1),I}forEach(R,I){let w=this.e.forward[0];for(;w;)R.call(I,w.value,w.key,this),w=w.forward[0]}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this.e.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this.e.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this.e.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",I=this.e.forward[0];for(;I;)R+=`node(${I.key}, ${I.value}, lvl:${I.level})`,I=I.forward[0];return R}static g(R,I,w){let P=R.e;for(let S=R.d-1;S>=0;S--)for(;P.forward[S]&&w(P.forward[S].key,I)<0;)P=P.forward[S];if(P=P.forward[0],P&&w(P.key,I)===0)return P}static h(R,I,w,P){const S=[];let p=R.e;for(let f=R.d-1;f>=0;f--){for(;p.forward[f]&&P(p.forward[f].key,I)<0;)p=p.forward[f];S[f]=p}if(p=p.forward[0],p&&P(p.key,I)===0)return p.value=w,!1;{const f=T.j(R);if(f>R.d){for(let m=R.d;m<f;m++)S[m]=R.e;R.d=f}p=new U(f,I,w);for(let m=0;m<f;m++)p.forward[m]=S[m].forward[m],S[m].forward[m]=p;return!0}}static j(R,I=.5){let w=1;for(;Math.random()<I&&w<R.c;)w+=1;return w}static k(R,I,w){const P=[];let S=R.e;for(let p=R.d-1;p>=0;p--){for(;S.forward[p]&&w(S.forward[p].key,I)<0;)S=S.forward[p];P[p]=S}if(S=S.forward[0],!S||w(S.key,I)!==0)return!1;for(let p=0;p<R.d&&P[p].forward[p]===S;p++)P[p].forward[p]=S.forward[p];for(;R.d>0&&R.e.forward[R.d-1]===l;)R.d-=1;return!0}}e.SkipList=T}),define(re[43],oe([0,1,10,2]),function(te,e,O,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function l(v){const L=v;return L?typeof L.read=="function":!1}e.isReadable=l;function T(v){const L=v;return L?[L.on,L.pause,L.resume,L.destroy].every(n=>typeof n=="function"):!1}e.isReadableStream=T;function N(v){const L=v;return L?T(L.stream)&&Array.isArray(L.buffer)&&typeof L.ended=="boolean":!1}e.isReadableBufferedStream=N;function R(v,L){return new I(v,L)}e.newWriteableStream=R;class I{constructor(L,n){this.e=L,this.f=n,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(L){if(!this.a.destroyed){if(this.a.flowing)this.g(L);else if(this.b.data.push(L),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(n=>this.d.push(n))}}error(L){this.a.destroyed||(this.a.flowing?this.h(L):this.b.error.push(L))}end(L){this.a.destroyed||(typeof L<"u"&&this.write(L),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(L){this.c.data.slice(0).forEach(n=>n(L))}h(L){this.c.error.length===0?(0,O.onUnexpectedError)(L):this.c.error.slice(0).forEach(n=>n(L))}i(){this.c.end.slice(0).forEach(L=>L())}on(L,n){if(!this.a.destroyed)switch(L){case"data":this.c.data.push(n),this.resume();break;case"end":this.c.end.push(n),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(n),this.a.flowing&&this.k();break}}removeListener(L,n){if(this.a.destroyed)return;let r;switch(L){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const t=r.indexOf(n);t>=0&&r.splice(t,1)}}j(){if(this.b.data.length>0){const L=this.e(this.b.data);this.g(L),this.b.data.length=0;const n=[...this.d];this.d.length=0,n.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const L of this.b.error)this.h(L);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function w(v,L){const n=[];let r;for(;(r=v.read())!==null;)n.push(r);return L(n)}e.consumeReadable=w;function P(v,L,n){const r=[];let t;for(;(t=v.read())!==null&&r.length<n;)r.push(t);return t===null&&r.length>0?L(r):{read:()=>{if(r.length>0)return r.shift();if(typeof t<"u"){const i=t;return t=void 0,i}return v.read()}}}e.peekReadable=P;function S(v,L){return new Promise((n,r)=>{const t=[];p(v,{onData:i=>{L&&t.push(i)},onError:i=>{L?r(i):n(void 0)},onEnd:()=>{n(L?L(t):void 0)}})})}e.consumeStream=S;function p(v,L){let n=!1;return v.on("error",r=>{n||L.onError(r)}),v.on("end",()=>{n||L.onEnd()}),v.on("data",r=>{n||L.onData(r)}),(0,U.toDisposable)(()=>n=!0)}e.listenStream=p;function f(v,L){return new Promise((n,r)=>{const t=new U.DisposableStore,i=[],s=y=>{if(i.push(y),i.length>L)return t.dispose(),v.pause(),n({stream:v,buffer:i,ended:!1})},o=y=>r(y),c=()=>n({stream:v,buffer:i,ended:!0});t.add((0,U.toDisposable)(()=>v.removeListener("error",o))),v.on("error",o),t.add((0,U.toDisposable)(()=>v.removeListener("end",c))),v.on("end",c),t.add((0,U.toDisposable)(()=>v.removeListener("data",s))),v.on("data",s)})}e.peekStream=f;function m(v,L){const n=R(L);return n.end(v),n}e.toStream=m;function E(){const v=R(()=>{throw new Error("not supported")});return v.end(),v}e.emptyStream=E;function a(v){let L=!1;return{read:()=>L?null:(L=!0,v)}}e.toReadable=a;function u(v,L,n){const r=R(n);return p(v,{onData:t=>r.write(L.data(t)),onError:t=>r.error(L.error?L.error(t):t),onEnd:()=>r.end()}),r}e.transform=u;function h(v,L,n){let r=!1;return{read:()=>{const t=L.read();return r?t:(r=!0,t!==null?n([v,t]):v)}}}e.prefixedReadable=h;function d(v,L,n){let r=!1;const t=R(n);return p(L,{onData:i=>r?t.write(i):(r=!0,t.write(n([v,i]))),onError:i=>t.error(i),onEnd:()=>{r||(r=!0,t.write(v)),t.end()}}),t}e.prefixedStream=d}),define(re[16],oe([0,1,43]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const U=typeof Buffer<"u";let l,T;class N{static alloc(y){return U?new N(Buffer.allocUnsafe(y)):new N(new Uint8Array(y))}static wrap(y){return U&&!Buffer.isBuffer(y)&&(y=Buffer.from(y.buffer,y.byteOffset,y.byteLength)),new N(y)}static fromString(y,b){return!(b?.dontUseNodeBuffer||!1)&&U?new N(Buffer.from(y)):(l||(l=new TextEncoder),new N(l.encode(y)))}static fromByteArray(y){const b=N.alloc(y.length);for(let g=0,D=y.length;g<D;g++)b.buffer[g]=y[g];return b}static concat(y,b){if(typeof b>"u"){b=0;for(let A=0,F=y.length;A<F;A++)b+=y[A].byteLength}const g=N.alloc(b);let D=0;for(let A=0,F=y.length;A<F;A++){const j=y[A];g.set(j,D),D+=j.byteLength}return g}constructor(y){this.buffer=y,this.byteLength=this.buffer.byteLength}clone(){const y=N.alloc(this.byteLength);return y.set(this),y}toString(){return U?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(y,b){return new N(this.buffer.subarray(y,b))}set(y,b){if(y instanceof N)this.buffer.set(y.buffer,b);else if(y instanceof Uint8Array)this.buffer.set(y,b);else if(y instanceof ArrayBuffer)this.buffer.set(new Uint8Array(y),b);else if(ArrayBuffer.isView(y))this.buffer.set(new Uint8Array(y.buffer,y.byteOffset,y.byteLength),b);else throw new Error("Unknown argument 'array'")}readUInt32BE(y){return w(this.buffer,y)}writeUInt32BE(y,b){P(this.buffer,y,b)}readUInt32LE(y){return S(this.buffer,y)}writeUInt32LE(y,b){p(this.buffer,y,b)}readUInt8(y){return f(this.buffer,y)}writeUInt8(y,b){m(this.buffer,y,b)}}e.VSBuffer=N;function R(c,y){return c[y+0]<<0>>>0|c[y+1]<<8>>>0}e.readUInt16LE=R;function I(c,y,b){c[b+0]=y&255,y=y>>>8,c[b+1]=y&255}e.writeUInt16LE=I;function w(c,y){return c[y]*2**24+c[y+1]*2**16+c[y+2]*2**8+c[y+3]}e.readUInt32BE=w;function P(c,y,b){c[b+3]=y,y=y>>>8,c[b+2]=y,y=y>>>8,c[b+1]=y,y=y>>>8,c[b]=y}e.writeUInt32BE=P;function S(c,y){return c[y+0]<<0>>>0|c[y+1]<<8>>>0|c[y+2]<<16>>>0|c[y+3]<<24>>>0}e.readUInt32LE=S;function p(c,y,b){c[b+0]=y&255,y=y>>>8,c[b+1]=y&255,y=y>>>8,c[b+2]=y&255,y=y>>>8,c[b+3]=y&255}e.writeUInt32LE=p;function f(c,y){return c[y]}e.readUInt8=f;function m(c,y,b){c[b]=y}e.writeUInt8=m;function E(c){return O.consumeReadable(c,y=>N.concat(y))}e.readableToBuffer=E;function a(c){return O.toReadable(c)}e.bufferToReadable=a;function u(c){return O.consumeStream(c,y=>N.concat(y))}e.streamToBuffer=u;async function h(c){return c.ended?N.concat(c.buffer):N.concat([...c.buffer,await u(c.stream)])}e.bufferedStreamToBuffer=h;function d(c){return O.toStream(c,y=>N.concat(y))}e.bufferToStream=d;function v(c){return O.transform(c,{data:y=>typeof y=="string"?N.fromString(y):N.wrap(y)},y=>N.concat(y))}e.streamToBufferReadableStream=v;function L(c){return O.newWriteableStream(y=>N.concat(y),c)}e.newWriteableBufferStream=L;function n(c,y){return O.prefixedReadable(c,y,b=>N.concat(b))}e.prefixedBufferReadable=n;function r(c,y){return O.prefixedStream(c,y,b=>N.concat(b))}e.prefixedBufferStream=r;function t(c){let y=0,b=0,g=0;const D=new Uint8Array(Math.floor(c.length/4*3)),A=j=>{switch(b){case 3:D[g++]=y|j,b=0;break;case 2:D[g++]=y|j>>>2,y=j<<6,b=3;break;case 1:D[g++]=y|j>>>4,y=j<<4,b=2;break;default:y=j<<2,b=1}};for(let j=0;j<c.length;j++){const x=c.charCodeAt(j);if(x>=65&&x<=90)A(x-65);else if(x>=97&&x<=122)A(x-97+26);else if(x>=48&&x<=57)A(x-48+52);else if(x===43||x===45)A(62);else if(x===47||x===95)A(63);else{if(x===61)break;throw new SyntaxError(`Unexpected base64 character ${c[j]}`)}}const F=g;for(;b>0;)A(0);return N.wrap(D).slice(0,F)}e.decodeBase64=t;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function o({buffer:c},y=!0,b=!1){const g=b?s:i;let D="";const A=c.byteLength%3;let F=0;for(;F<c.byteLength-A;F+=3){const j=c[F+0],x=c[F+1],V=c[F+2];D+=g[j>>>2],D+=g[(j<<4|x>>>4)&63],D+=g[(x<<2|V>>>6)&63],D+=g[V&63]}if(A===1){const j=c[F+0];D+=g[j>>>2],D+=g[j<<4&63],y&&(D+="==")}else if(A===2){const j=c[F+0],x=c[F+1];D+=g[j>>>2],D+=g[(j<<4|x>>>4)&63],D+=g[x<<2&63],y&&(D+="=")}return D}e.encodeBase64=o}),define(re[133],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(re[12],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function O(r){return typeof r=="string"}e.isString=O;function U(r){return Array.isArray(r)&&r.every(t=>O(t))}e.isStringArray=U;function l(r){return typeof r=="object"&&r!==null&&!Array.isArray(r)&&!(r instanceof RegExp)&&!(r instanceof Date)}e.isObject=l;function T(r){const t=Object.getPrototypeOf(Uint8Array);return typeof r=="object"&&r instanceof t}e.isTypedArray=T;function N(r){return typeof r=="number"&&!isNaN(r)}e.isNumber=N;function R(r){return!!r&&typeof r[Symbol.iterator]=="function"}e.isIterable=R;function I(r){return r===!0||r===!1}e.isBoolean=I;function w(r){return typeof r>"u"}e.isUndefined=w;function P(r){return!S(r)}e.isDefined=P;function S(r){return w(r)||r===null}e.isUndefinedOrNull=S;function p(r,t){if(!r)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.assertType=p;function f(r){if(S(r))throw new Error("Assertion Failed: argument is undefined or null");return r}e.assertIsDefined=f;function m(...r){const t=[];for(let i=0;i<r.length;i++){const s=r[i];if(S(s))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);t.push(s)}return t}e.assertAllDefined=m;const E=Object.prototype.hasOwnProperty;function a(r){if(!l(r))return!1;for(const t in r)if(E.call(r,t))return!1;return!0}e.isEmptyObject=a;function u(r){return typeof r=="function"}e.isFunction=u;function h(...r){return r.length>0&&r.every(u)}e.areFunctions=h;function d(r,t){const i=Math.min(r.length,t.length);for(let s=0;s<i;s++)v(r[s],t[s])}e.validateConstraints=d;function v(r,t){if(O(t)){if(typeof r!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(u(t)){try{if(r instanceof t)return}catch{}if(!S(r)&&r.constructor===t||t.length===1&&t.call(void 0,r)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=v;function L(r){return r===null?void 0:r}e.withNullAsUndefined=L;function n(r){return typeof r>"u"?null:r}e.withUndefinedAsNull=n}),define(re[52],oe([0,1,12]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const U=Object.create(null);function l(R,I){if((0,O.isString)(I)){const w=U[I];if(w===void 0)throw new Error(`${R} references an unknown codicon: ${I}`);I=w}return U[R]=I,{id:R}}function T(){return U}e.getCodiconFontCharacters=T;function N(){return Object.values(e.Codicon)}e.getAllCodicons=N,e.Codicon={add:l("add",6e4),plus:l("plus",6e4),gistNew:l("gist-new",6e4),repoCreate:l("repo-create",6e4),lightbulb:l("lightbulb",60001),lightBulb:l("light-bulb",60001),repo:l("repo",60002),repoDelete:l("repo-delete",60002),gistFork:l("gist-fork",60003),repoForked:l("repo-forked",60003),gitPullRequest:l("git-pull-request",60004),gitPullRequestAbandoned:l("git-pull-request-abandoned",60004),recordKeys:l("record-keys",60005),keyboard:l("keyboard",60005),tag:l("tag",60006),tagAdd:l("tag-add",60006),tagRemove:l("tag-remove",60006),person:l("person",60007),personFollow:l("person-follow",60007),personOutline:l("person-outline",60007),personFilled:l("person-filled",60007),gitBranch:l("git-branch",60008),gitBranchCreate:l("git-branch-create",60008),gitBranchDelete:l("git-branch-delete",60008),sourceControl:l("source-control",60008),mirror:l("mirror",60009),mirrorPublic:l("mirror-public",60009),star:l("star",60010),starAdd:l("star-add",60010),starDelete:l("star-delete",60010),starEmpty:l("star-empty",60010),comment:l("comment",60011),commentAdd:l("comment-add",60011),alert:l("alert",60012),warning:l("warning",60012),search:l("search",60013),searchSave:l("search-save",60013),logOut:l("log-out",60014),signOut:l("sign-out",60014),logIn:l("log-in",60015),signIn:l("sign-in",60015),eye:l("eye",60016),eyeUnwatch:l("eye-unwatch",60016),eyeWatch:l("eye-watch",60016),circleFilled:l("circle-filled",60017),primitiveDot:l("primitive-dot",60017),closeDirty:l("close-dirty",60017),debugBreakpoint:l("debug-breakpoint",60017),debugBreakpointDisabled:l("debug-breakpoint-disabled",60017),debugHint:l("debug-hint",60017),primitiveSquare:l("primitive-square",60018),edit:l("edit",60019),pencil:l("pencil",60019),info:l("info",60020),issueOpened:l("issue-opened",60020),gistPrivate:l("gist-private",60021),gitForkPrivate:l("git-fork-private",60021),lock:l("lock",60021),mirrorPrivate:l("mirror-private",60021),close:l("close",60022),removeClose:l("remove-close",60022),x:l("x",60022),repoSync:l("repo-sync",60023),sync:l("sync",60023),clone:l("clone",60024),desktopDownload:l("desktop-download",60024),beaker:l("beaker",60025),microscope:l("microscope",60025),vm:l("vm",60026),deviceDesktop:l("device-desktop",60026),file:l("file",60027),fileText:l("file-text",60027),more:l("more",60028),ellipsis:l("ellipsis",60028),kebabHorizontal:l("kebab-horizontal",60028),mailReply:l("mail-reply",60029),reply:l("reply",60029),organization:l("organization",60030),organizationFilled:l("organization-filled",60030),organizationOutline:l("organization-outline",60030),newFile:l("new-file",60031),fileAdd:l("file-add",60031),newFolder:l("new-folder",60032),fileDirectoryCreate:l("file-directory-create",60032),trash:l("trash",60033),trashcan:l("trashcan",60033),history:l("history",60034),clock:l("clock",60034),folder:l("folder",60035),fileDirectory:l("file-directory",60035),symbolFolder:l("symbol-folder",60035),logoGithub:l("logo-github",60036),markGithub:l("mark-github",60036),github:l("github",60036),terminal:l("terminal",60037),console:l("console",60037),repl:l("repl",60037),zap:l("zap",60038),symbolEvent:l("symbol-event",60038),error:l("error",60039),stop:l("stop",60039),variable:l("variable",60040),symbolVariable:l("symbol-variable",60040),array:l("array",60042),symbolArray:l("symbol-array",60042),symbolModule:l("symbol-module",60043),symbolPackage:l("symbol-package",60043),symbolNamespace:l("symbol-namespace",60043),symbolObject:l("symbol-object",60043),symbolMethod:l("symbol-method",60044),symbolFunction:l("symbol-function",60044),symbolConstructor:l("symbol-constructor",60044),symbolBoolean:l("symbol-boolean",60047),symbolNull:l("symbol-null",60047),symbolNumeric:l("symbol-numeric",60048),symbolNumber:l("symbol-number",60048),symbolStructure:l("symbol-structure",60049),symbolStruct:l("symbol-struct",60049),symbolParameter:l("symbol-parameter",60050),symbolTypeParameter:l("symbol-type-parameter",60050),symbolKey:l("symbol-key",60051),symbolText:l("symbol-text",60051),symbolReference:l("symbol-reference",60052),goToFile:l("go-to-file",60052),symbolEnum:l("symbol-enum",60053),symbolValue:l("symbol-value",60053),symbolRuler:l("symbol-ruler",60054),symbolUnit:l("symbol-unit",60054),activateBreakpoints:l("activate-breakpoints",60055),archive:l("archive",60056),arrowBoth:l("arrow-both",60057),arrowDown:l("arrow-down",60058),arrowLeft:l("arrow-left",60059),arrowRight:l("arrow-right",60060),arrowSmallDown:l("arrow-small-down",60061),arrowSmallLeft:l("arrow-small-left",60062),arrowSmallRight:l("arrow-small-right",60063),arrowSmallUp:l("arrow-small-up",60064),arrowUp:l("arrow-up",60065),bell:l("bell",60066),bold:l("bold",60067),book:l("book",60068),bookmark:l("bookmark",60069),debugBreakpointConditionalUnverified:l("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:l("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:l("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:l("debug-breakpoint-data-unverified",60072),debugBreakpointData:l("debug-breakpoint-data",60073),debugBreakpointDataDisabled:l("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:l("debug-breakpoint-log-unverified",60074),debugBreakpointLog:l("debug-breakpoint-log",60075),debugBreakpointLogDisabled:l("debug-breakpoint-log-disabled",60075),briefcase:l("briefcase",60076),broadcast:l("broadcast",60077),browser:l("browser",60078),bug:l("bug",60079),calendar:l("calendar",60080),caseSensitive:l("case-sensitive",60081),check:l("check",60082),checklist:l("checklist",60083),chevronDown:l("chevron-down",60084),dropDownButton:l("drop-down-button",60084),chevronLeft:l("chevron-left",60085),chevronRight:l("chevron-right",60086),chevronUp:l("chevron-up",60087),chromeClose:l("chrome-close",60088),chromeMaximize:l("chrome-maximize",60089),chromeMinimize:l("chrome-minimize",60090),chromeRestore:l("chrome-restore",60091),circle:l("circle",60092),circleOutline:l("circle-outline",60092),debugBreakpointUnverified:l("debug-breakpoint-unverified",60092),circleSlash:l("circle-slash",60093),circuitBoard:l("circuit-board",60094),clearAll:l("clear-all",60095),clippy:l("clippy",60096),closeAll:l("close-all",60097),cloudDownload:l("cloud-download",60098),cloudUpload:l("cloud-upload",60099),code:l("code",60100),collapseAll:l("collapse-all",60101),colorMode:l("color-mode",60102),commentDiscussion:l("comment-discussion",60103),compareChanges:l("compare-changes",60157),creditCard:l("credit-card",60105),dash:l("dash",60108),dashboard:l("dashboard",60109),database:l("database",60110),debugContinue:l("debug-continue",60111),debugDisconnect:l("debug-disconnect",60112),debugPause:l("debug-pause",60113),debugRestart:l("debug-restart",60114),debugStart:l("debug-start",60115),debugStepInto:l("debug-step-into",60116),debugStepOut:l("debug-step-out",60117),debugStepOver:l("debug-step-over",60118),debugStop:l("debug-stop",60119),debug:l("debug",60120),deviceCameraVideo:l("device-camera-video",60121),deviceCamera:l("device-camera",60122),deviceMobile:l("device-mobile",60123),diffAdded:l("diff-added",60124),diffIgnored:l("diff-ignored",60125),diffModified:l("diff-modified",60126),diffRemoved:l("diff-removed",60127),diffRenamed:l("diff-renamed",60128),diff:l("diff",60129),discard:l("discard",60130),editorLayout:l("editor-layout",60131),emptyWindow:l("empty-window",60132),exclude:l("exclude",60133),extensions:l("extensions",60134),eyeClosed:l("eye-closed",60135),fileBinary:l("file-binary",60136),fileCode:l("file-code",60137),fileMedia:l("file-media",60138),filePdf:l("file-pdf",60139),fileSubmodule:l("file-submodule",60140),fileSymlinkDirectory:l("file-symlink-directory",60141),fileSymlinkFile:l("file-symlink-file",60142),fileZip:l("file-zip",60143),files:l("files",60144),filter:l("filter",60145),flame:l("flame",60146),foldDown:l("fold-down",60147),foldUp:l("fold-up",60148),fold:l("fold",60149),folderActive:l("folder-active",60150),folderOpened:l("folder-opened",60151),gear:l("gear",60152),gift:l("gift",60153),gistSecret:l("gist-secret",60154),gist:l("gist",60155),gitCommit:l("git-commit",60156),gitCompare:l("git-compare",60157),gitMerge:l("git-merge",60158),githubAction:l("github-action",60159),githubAlt:l("github-alt",60160),globe:l("globe",60161),grabber:l("grabber",60162),graph:l("graph",60163),gripper:l("gripper",60164),heart:l("heart",60165),home:l("home",60166),horizontalRule:l("horizontal-rule",60167),hubot:l("hubot",60168),inbox:l("inbox",60169),issueClosed:l("issue-closed",60324),issueReopened:l("issue-reopened",60171),issues:l("issues",60172),italic:l("italic",60173),jersey:l("jersey",60174),json:l("json",60175),bracket:l("bracket",60175),kebabVertical:l("kebab-vertical",60176),key:l("key",60177),law:l("law",60178),lightbulbAutofix:l("lightbulb-autofix",60179),linkExternal:l("link-external",60180),link:l("link",60181),listOrdered:l("list-ordered",60182),listUnordered:l("list-unordered",60183),liveShare:l("live-share",60184),loading:l("loading",60185),location:l("location",60186),mailRead:l("mail-read",60187),mail:l("mail",60188),markdown:l("markdown",60189),megaphone:l("megaphone",60190),mention:l("mention",60191),milestone:l("milestone",60192),mortarBoard:l("mortar-board",60193),move:l("move",60194),multipleWindows:l("multiple-windows",60195),mute:l("mute",60196),noNewline:l("no-newline",60197),note:l("note",60198),octoface:l("octoface",60199),openPreview:l("open-preview",60200),package_:l("package",60201),paintcan:l("paintcan",60202),pin:l("pin",60203),play:l("play",60204),run:l("run",60204),plug:l("plug",60205),preserveCase:l("preserve-case",60206),preview:l("preview",60207),project:l("project",60208),pulse:l("pulse",60209),question:l("question",60210),quote:l("quote",60211),radioTower:l("radio-tower",60212),reactions:l("reactions",60213),references:l("references",60214),refresh:l("refresh",60215),regex:l("regex",60216),remoteExplorer:l("remote-explorer",60217),remote:l("remote",60218),remove:l("remove",60219),replaceAll:l("replace-all",60220),replace:l("replace",60221),repoClone:l("repo-clone",60222),repoForcePush:l("repo-force-push",60223),repoPull:l("repo-pull",60224),repoPush:l("repo-push",60225),report:l("report",60226),requestChanges:l("request-changes",60227),rocket:l("rocket",60228),rootFolderOpened:l("root-folder-opened",60229),rootFolder:l("root-folder",60230),rss:l("rss",60231),ruby:l("ruby",60232),saveAll:l("save-all",60233),saveAs:l("save-as",60234),save:l("save",60235),screenFull:l("screen-full",60236),screenNormal:l("screen-normal",60237),searchStop:l("search-stop",60238),server:l("server",60240),settingsGear:l("settings-gear",60241),settings:l("settings",60242),shield:l("shield",60243),smiley:l("smiley",60244),sortPrecedence:l("sort-precedence",60245),splitHorizontal:l("split-horizontal",60246),splitVertical:l("split-vertical",60247),squirrel:l("squirrel",60248),starFull:l("star-full",60249),starHalf:l("star-half",60250),symbolClass:l("symbol-class",60251),symbolColor:l("symbol-color",60252),symbolCustomColor:l("symbol-customcolor",60252),symbolConstant:l("symbol-constant",60253),symbolEnumMember:l("symbol-enum-member",60254),symbolField:l("symbol-field",60255),symbolFile:l("symbol-file",60256),symbolInterface:l("symbol-interface",60257),symbolKeyword:l("symbol-keyword",60258),symbolMisc:l("symbol-misc",60259),symbolOperator:l("symbol-operator",60260),symbolProperty:l("symbol-property",60261),wrench:l("wrench",60261),wrenchSubaction:l("wrench-subaction",60261),symbolSnippet:l("symbol-snippet",60262),tasklist:l("tasklist",60263),telescope:l("telescope",60264),textSize:l("text-size",60265),threeBars:l("three-bars",60266),thumbsdown:l("thumbsdown",60267),thumbsup:l("thumbsup",60268),tools:l("tools",60269),triangleDown:l("triangle-down",60270),triangleLeft:l("triangle-left",60271),triangleRight:l("triangle-right",60272),triangleUp:l("triangle-up",60273),twitter:l("twitter",60274),unfold:l("unfold",60275),unlock:l("unlock",60276),unmute:l("unmute",60277),unverified:l("unverified",60278),verified:l("verified",60279),versions:l("versions",60280),vmActive:l("vm-active",60281),vmOutline:l("vm-outline",60282),vmRunning:l("vm-running",60283),watch:l("watch",60284),whitespace:l("whitespace",60285),wholeWord:l("whole-word",60286),window:l("window",60287),wordWrap:l("word-wrap",60288),zoomIn:l("zoom-in",60289),zoomOut:l("zoom-out",60290),listFilter:l("list-filter",60291),listFlat:l("list-flat",60292),listSelection:l("list-selection",60293),selection:l("selection",60293),listTree:l("list-tree",60294),debugBreakpointFunctionUnverified:l("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:l("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:l("debug-breakpoint-function-disabled",60296),debugStackframeActive:l("debug-stackframe-active",60297),circleSmallFilled:l("circle-small-filled",60298),debugStackframeDot:l("debug-stackframe-dot",60298),debugStackframe:l("debug-stackframe",60299),debugStackframeFocused:l("debug-stackframe-focused",60299),debugBreakpointUnsupported:l("debug-breakpoint-unsupported",60300),symbolString:l("symbol-string",60301),debugReverseContinue:l("debug-reverse-continue",60302),debugStepBack:l("debug-step-back",60303),debugRestartFrame:l("debug-restart-frame",60304),callIncoming:l("call-incoming",60306),callOutgoing:l("call-outgoing",60307),menu:l("menu",60308),expandAll:l("expand-all",60309),feedback:l("feedback",60310),groupByRefType:l("group-by-ref-type",60311),ungroupByRefType:l("ungroup-by-ref-type",60312),account:l("account",60313),bellDot:l("bell-dot",60314),debugConsole:l("debug-console",60315),library:l("library",60316),output:l("output",60317),runAll:l("run-all",60318),syncIgnored:l("sync-ignored",60319),pinned:l("pinned",60320),githubInverted:l("github-inverted",60321),debugAlt:l("debug-alt",60305),serverProcess:l("server-process",60322),serverEnvironment:l("server-environment",60323),pass:l("pass",60324),stopCircle:l("stop-circle",60325),playCircle:l("play-circle",60326),record:l("record",60327),debugAltSmall:l("debug-alt-small",60328),vmConnect:l("vm-connect",60329),cloud:l("cloud",60330),merge:l("merge",60331),exportIcon:l("export",60332),graphLeft:l("graph-left",60333),magnet:l("magnet",60334),notebook:l("notebook",60335),redo:l("redo",60336),checkAll:l("check-all",60337),pinnedDirty:l("pinned-dirty",60338),passFilled:l("pass-filled",60339),circleLargeFilled:l("circle-large-filled",60340),circleLarge:l("circle-large",60341),circleLargeOutline:l("circle-large-outline",60341),combine:l("combine",60342),gather:l("gather",60342),table:l("table",60343),variableGroup:l("variable-group",60344),typeHierarchy:l("type-hierarchy",60345),typeHierarchySub:l("type-hierarchy-sub",60346),typeHierarchySuper:l("type-hierarchy-super",60347),gitPullRequestCreate:l("git-pull-request-create",60348),runAbove:l("run-above",60349),runBelow:l("run-below",60350),notebookTemplate:l("notebook-template",60351),debugRerun:l("debug-rerun",60352),workspaceTrusted:l("workspace-trusted",60353),workspaceUntrusted:l("workspace-untrusted",60354),workspaceUnspecified:l("workspace-unspecified",60355),terminalCmd:l("terminal-cmd",60356),terminalDebian:l("terminal-debian",60357),terminalLinux:l("terminal-linux",60358),terminalPowershell:l("terminal-powershell",60359),terminalTmux:l("terminal-tmux",60360),terminalUbuntu:l("terminal-ubuntu",60361),terminalBash:l("terminal-bash",60362),arrowSwap:l("arrow-swap",60363),copy:l("copy",60364),personAdd:l("person-add",60365),filterFilled:l("filter-filled",60366),wand:l("wand",60367),debugLineByLine:l("debug-line-by-line",60368),inspect:l("inspect",60369),layers:l("layers",60370),layersDot:l("layers-dot",60371),layersActive:l("layers-active",60372),compass:l("compass",60373),compassDot:l("compass-dot",60374),compassActive:l("compass-active",60375),azure:l("azure",60376),issueDraft:l("issue-draft",60377),gitPullRequestClosed:l("git-pull-request-closed",60378),gitPullRequestDraft:l("git-pull-request-draft",60379),debugAll:l("debug-all",60380),debugCoverage:l("debug-coverage",60381),runErrors:l("run-errors",60382),folderLibrary:l("folder-library",60383),debugContinueSmall:l("debug-continue-small",60384),beakerStop:l("beaker-stop",60385),graphLine:l("graph-line",60386),graphScatter:l("graph-scatter",60387),pieChart:l("pie-chart",60388),bracketDot:l("bracket-dot",60389),bracketError:l("bracket-error",60390),lockSmall:l("lock-small",60391),azureDevops:l("azure-devops",60392),verifiedFilled:l("verified-filled",60393),newLine:l("newline",60394),layout:l("layout",60395),layoutActivitybarLeft:l("layout-activitybar-left",60396),layoutActivitybarRight:l("layout-activitybar-right",60397),layoutPanelLeft:l("layout-panel-left",60398),layoutPanelCenter:l("layout-panel-center",60399),layoutPanelJustify:l("layout-panel-justify",60400),layoutPanelRight:l("layout-panel-right",60401),layoutPanel:l("layout-panel",60402),layoutSidebarLeft:l("layout-sidebar-left",60403),layoutSidebarRight:l("layout-sidebar-right",60404),layoutStatusbar:l("layout-statusbar",60405),layoutMenubar:l("layout-menubar",60406),layoutCentered:l("layout-centered",60407),layoutSidebarRightOff:l("layout-sidebar-right-off",60416),layoutPanelOff:l("layout-panel-off",60417),layoutSidebarLeftOff:l("layout-sidebar-left-off",60418),target:l("target",60408),indent:l("indent",60409),recordSmall:l("record-small",60410),errorSmall:l("error-small",60411),arrowCircleDown:l("arrow-circle-down",60412),arrowCircleLeft:l("arrow-circle-left",60413),arrowCircleRight:l("arrow-circle-right",60414),arrowCircleUp:l("arrow-circle-up",60415),heartFilled:l("heart-filled",60420),map:l("map",60421),mapFilled:l("map-filled",60422),circleSmall:l("circle-small",60423),bellSlash:l("bell-slash",60424),bellSlashDot:l("bell-slash-dot",60425),commentUnresolved:l("comment-unresolved",60426),gitPullRequestGoToChanges:l("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:l("git-pull-request-new-changes",60428),searchFuzzy:l("search-fuzzy",60429),commentDraft:l("comment-draft",60430),dialogError:l("dialog-error","error"),dialogWarning:l("dialog-warning","warning"),dialogInfo:l("dialog-info","info"),dialogClose:l("dialog-close","close"),treeItemExpanded:l("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:l("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:l("tree-filter-on-type-off","list-selection"),treeFilterClear:l("tree-filter-clear","close"),treeItemLoading:l("tree-item-loading","loading"),menuSelection:l("menu-selection","check"),menuSubmenu:l("menu-submenu","chevron-right"),menuBarMore:l("menubar-more","more"),scrollbarButtonLeft:l("scrollbar-button-left","triangle-left"),scrollbarButtonRight:l("scrollbar-button-right","triangle-right"),scrollbarButtonUp:l("scrollbar-button-up","triangle-up"),scrollbarButtonDown:l("scrollbar-button-down","triangle-down"),toolBarMore:l("toolbar-more","more"),quickInputBack:l("quick-input-back","arrow-left")}}),define(re[32],oe([0,1,12]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function U(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const h=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([d,v])=>{h[d]=v&&typeof v=="object"?U(v):v}),h}e.deepClone=U;function l(u){if(!u||typeof u!="object")return u;const h=[u];for(;h.length>0;){const d=h.shift();Object.freeze(d);for(const v in d)if(T.call(d,v)){const L=d[v];typeof L=="object"&&!Object.isFrozen(L)&&!(0,O.isTypedArray)(L)&&h.push(L)}}return u}e.deepFreeze=l;const T=Object.prototype.hasOwnProperty;function N(u,h){return R(u,h,new Set)}e.cloneAndChange=N;function R(u,h,d){if((0,O.isUndefinedOrNull)(u))return u;const v=h(u);if(typeof v<"u")return v;if(Array.isArray(u)){const L=[];for(const n of u)L.push(R(n,h,d));return L}if((0,O.isObject)(u)){if(d.has(u))throw new Error("Cannot clone recursive data-structure");d.add(u);const L={};for(const n in u)T.call(u,n)&&(L[n]=R(u[n],h,d));return d.delete(u),L}return u}function I(u,h,d=!0){return(0,O.isObject)(u)?((0,O.isObject)(h)&&Object.keys(h).forEach(v=>{v in u?d&&((0,O.isObject)(u[v])&&(0,O.isObject)(h[v])?I(u[v],h[v],d):u[v]=h[v]):u[v]=h[v]}),u):h}e.mixin=I;function w(u,h){if(u===h)return!0;if(u==null||h===null||h===void 0||typeof u!=typeof h||typeof u!="object"||Array.isArray(u)!==Array.isArray(h))return!1;let d,v;if(Array.isArray(u)){if(u.length!==h.length)return!1;for(d=0;d<u.length;d++)if(!w(u[d],h[d]))return!1}else{const L=[];for(v in u)L.push(v);L.sort();const n=[];for(v in h)n.push(v);if(n.sort(),!w(L,n))return!1;for(d=0;d<L.length;d++)if(!w(u[L[d]],h[L[d]]))return!1}return!0}e.equals=w;function P(u){const h=new Set;return JSON.stringify(u,(d,v)=>{if((0,O.isObject)(v)||Array.isArray(v)){if(h.has(v))return"[Circular]";h.add(v)}return v})}e.safeStringify=P;function S(u,h){const d=Object.create(null);return!u||!h||Object.keys(h).forEach(L=>{const n=u[L],r=h[L];w(n,r)||(d[L]=r)}),d}e.distinct=S;function p(u,h){const d=h.toLowerCase(),v=Object.keys(u).find(L=>L.toLowerCase()===d);return v?u[v]:u[h]}e.getCaseInsensitive=p;function f(u,h){const d=Object.create(null);for(const[v,L]of Object.entries(u))h(v,L)&&(d[v]=L);return d}e.filter=f;function m(u){let h=[],d=Object.getPrototypeOf(u);for(;Object.prototype!==d;)h=h.concat(Object.getOwnPropertyNames(d)),d=Object.getPrototypeOf(d);return h}e.getAllPropertyNames=m;function E(u){const h=[];for(const d of m(u))typeof u[d]=="function"&&h.push(d);return h}e.getAllMethodNames=E;function a(u,h){const d=L=>function(){const n=Array.prototype.slice.call(arguments,0);return h(L,n)},v={};for(const L of u)v[L]=d(L);return v}e.createProxyObject=a}),define(re[134],oe([0,1,52]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var U;(function(N){function R(I){return I&&typeof I=="object"&&typeof I.id=="string"}N.isThemeColor=R})(U=e.ThemeColor||(e.ThemeColor={}));function l(N){return{id:N}}e.themeColorFromId=l;var T;(function(N){N.iconNameSegment="[A-Za-z0-9]+",N.iconNameExpression="[A-Za-z0-9-]+",N.iconModifierExpression="~[A-Za-z]+",N.iconNameCharacter="[A-Za-z0-9~-]";const R=new RegExp(`^(${N.iconNameExpression})(${N.iconModifierExpression})?$`);function I(h){const d=R.exec(h.id);if(!d)return I(O.Codicon.error);const[,v,L]=d,n=["codicon","codicon-"+v];return L&&n.push("codicon-modifier-"+L.substring(1)),n}N.asClassNameArray=I;function w(h){return I(h).join(" ")}N.asClassName=w;function P(h){return"."+I(h).join(".")}N.asCSSSelector=P;function S(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(typeof h.color>"u"||U.isThemeColor(h.color))}N.isThemeIcon=S;const p=new RegExp(`^\\$\\((${N.iconNameExpression}(?:${N.iconModifierExpression})?)\\)$`);function f(h){const d=p.exec(h);if(!d)return;const[,v]=d;return{id:v}}N.fromString=f;function m(h){return{id:h}}N.fromId=m;function E(h,d){let v=h.id;const L=v.lastIndexOf("~");return L!==-1&&(v=v.substring(0,L)),d&&(v=`${v}~${d}`),{id:v}}N.modify=E;function a(h){const d=h.id.lastIndexOf("~");if(d!==-1)return h.id.substring(d+1)}N.getModifier=a;function u(h,d){return h.id===d.id&&h.color?.id===d.color?.id}N.isEqual=u})(T=e.ThemeIcon||(e.ThemeIcon={}))}),define(re[31],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const O=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function U(l){return O.test(l)}e.isUUID=U,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let l;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?l=crypto.getRandomValues.bind(crypto):l=function(R){for(let I=0;I<R.length;I++)R[I]=Math.floor(Math.random()*256);return R};const T=new Uint8Array(16),N=[];for(let R=0;R<256;R++)N.push(R.toString(16).padStart(2,"0"));return function(){l(T),T[6]=T[6]&15|64,T[8]=T[8]&63|128;let I=0,w="";return w+=N[T[I++]],w+=N[T[I++]],w+=N[T[I++]],w+=N[T[I++]],w+="-",w+=N[T[I++]],w+=N[T[I++]],w+="-",w+=N[T[I++]],w+=N[T[I++]],w+="-",w+=N[T[I++]],w+=N[T[I++]],w+="-",w+=N[T[I++]],w+=N[T[I++]],w+=N[T[I++]],w+=N[T[I++]],w+=N[T[I++]],w+=N[T[I++]],w}}()}),define(re[135],oe([0,1,34]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const U=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function l(N){const R=N.replace(/\-/g,":").toLowerCase();return!U.has(R)}function T(){const N=(0,O.networkInterfaces)();for(const R in N){const I=N[R];if(I){for(const{mac:w}of I)if(l(w))return w}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=T}),define(re[136],oe([0,1,64]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function U(R,I,w,P=1){let S=!1;return new Promise(p=>{const f=setTimeout(()=>{if(!S)return S=!0,p(0)},w);l(R,I,P,m=>{if(!S)return S=!0,clearTimeout(f),p(m)})})}e.findFreePort=U;function l(R,I,w,P){if(I===0)return P(0);const S=new O.Socket;S.once("connect",()=>(N(S),l(R+w,I-1,w,P))),S.once("data",()=>{}),S.once("error",p=>(N(S),p.code!=="ECONNREFUSED"?l(R+w,I-1,w,P):P(R))),S.connect(R,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function T(R,I,w,P="127.0.0.1"){let S=!1,p,f=1;const m=O.createServer({pauseOnConnect:!0});function E(a,u){S||(S=!0,m.removeAllListeners(),m.close(),p&&clearTimeout(p),u(a))}return new Promise(a=>{p=setTimeout(()=>{E(0,a)},w),m.on("listening",()=>{E(R,a)}),m.on("error",u=>{u&&(u.code==="EADDRINUSE"||u.code==="EACCES")&&f<I?(R++,f++,m.listen(R,P)):E(0,a)}),m.on("close",()=>{E(0,a)}),m.listen(R,P)})}e.findFreePortFaster=T;function N(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(I){console.error(I)}}}),define(re[88],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUtilityProcess=void 0;function O(U){return!!U.parentPort}e.isUtilityProcess=O}),define(re[137],oe([8,7]),function(te,e){return te.create("vs/base/common/date",e)}),define(re[65],oe([0,1,137]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const U=60,l=U*60,T=l*24,N=T*7,R=T*30,I=T*365;function w(S,p,f,m){typeof S!="number"&&(S=S.getTime());const E=Math.round((new Date().getTime()-S)/1e3);if(E<-30)return(0,O.localize)(0,null,w(new Date().getTime()+E*1e3,!1));if(!m&&E<30)return(0,O.localize)(1,null);let a;return E<U?(a=E,p?a===1?f?(0,O.localize)(2,null,a):(0,O.localize)(3,null,a):f?(0,O.localize)(4,null,a):(0,O.localize)(5,null,a):a===1?f?(0,O.localize)(6,null,a):(0,O.localize)(7,null,a):f?(0,O.localize)(8,null,a):(0,O.localize)(9,null,a)):E<l?(a=Math.floor(E/U),p?a===1?f?(0,O.localize)(10,null,a):(0,O.localize)(11,null,a):f?(0,O.localize)(12,null,a):(0,O.localize)(13,null,a):a===1?f?(0,O.localize)(14,null,a):(0,O.localize)(15,null,a):f?(0,O.localize)(16,null,a):(0,O.localize)(17,null,a)):E<T?(a=Math.floor(E/l),p?a===1?f?(0,O.localize)(18,null,a):(0,O.localize)(19,null,a):f?(0,O.localize)(20,null,a):(0,O.localize)(21,null,a):a===1?f?(0,O.localize)(22,null,a):(0,O.localize)(23,null,a):f?(0,O.localize)(24,null,a):(0,O.localize)(25,null,a)):E<N?(a=Math.floor(E/T),p?a===1?(0,O.localize)(26,null,a):(0,O.localize)(27,null,a):a===1?(0,O.localize)(28,null,a):(0,O.localize)(29,null,a)):E<R?(a=Math.floor(E/N),p?a===1?f?(0,O.localize)(30,null,a):(0,O.localize)(31,null,a):f?(0,O.localize)(32,null,a):(0,O.localize)(33,null,a):a===1?f?(0,O.localize)(34,null,a):(0,O.localize)(35,null,a):f?(0,O.localize)(36,null,a):(0,O.localize)(37,null,a)):E<I?(a=Math.floor(E/R),p?a===1?f?(0,O.localize)(38,null,a):(0,O.localize)(39,null,a):f?(0,O.localize)(40,null,a):(0,O.localize)(41,null,a):a===1?f?(0,O.localize)(42,null,a):(0,O.localize)(43,null,a):f?(0,O.localize)(44,null,a):(0,O.localize)(45,null,a)):(a=Math.floor(E/I),p?a===1?f?(0,O.localize)(46,null,a):(0,O.localize)(47,null,a):f?(0,O.localize)(48,null,a):(0,O.localize)(49,null,a):a===1?f?(0,O.localize)(50,null,a):(0,O.localize)(51,null,a):f?(0,O.localize)(52,null,a):(0,O.localize)(53,null,a))}e.fromNow=w;function P(S){return S.getFullYear()+"-"+String(S.getMonth()+1).padStart(2,"0")+"-"+String(S.getDate()).padStart(2,"0")+"T"+String(S.getHours()).padStart(2,"0")+":"+String(S.getMinutes()).padStart(2,"0")+":"+String(S.getSeconds()).padStart(2,"0")+"."+(S.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=P}),define(re[138],oe([8,7]),function(te,e){return te.create("vs/base/common/errorMessage",e)}),define(re[38],oe([0,1,21,12,138]),function(te,e,O,U,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function T(S,p){return p&&(S.stack||S.stacktrace)?l.localize(0,null,R(S),N(S.stack)||N(S.stacktrace)):R(S)}function N(S){return Array.isArray(S)?S.join(`
`):S}function R(S){return typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?l.localize(1,null,S.message):S.message||l.localize(2,null)}function I(S=null,p=!1){if(!S)return l.localize(3,null);if(Array.isArray(S)){const f=O.coalesce(S),m=I(f[0],p);return f.length>1?l.localize(4,null,m,f.length):m}if(U.isString(S))return S;if(S.detail){const f=S.detail;if(f.error)return T(f.error,p);if(f.exception)return T(f.exception,p)}return S.stack?T(S,p):S.message?S.message:l.localize(5,null)}e.toErrorMessage=I;function w(S){const p=S;return p instanceof Error&&Array.isArray(p.actions)}e.isErrorWithActions=w;function P(S,p){let f;return typeof S=="string"?f=new Error(S):f=S,f.actions=p,f}e.createErrorWithActions=P}),define(re[139],oe([8,7]),function(te,e){return te.create("vs/base/common/jsonErrorMessages",e)}),define(re[140],oe([0,1,139]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function U(l){switch(l){case 1:return(0,O.localize)(0,null);case 2:return(0,O.localize)(1,null);case 3:return(0,O.localize)(2,null);case 4:return(0,O.localize)(3,null);case 5:return(0,O.localize)(4,null);case 6:return(0,O.localize)(5,null);case 7:return(0,O.localize)(6,null);case 8:return(0,O.localize)(7,null);case 9:return(0,O.localize)(8,null);default:return""}}e.getParseErrorMessage=U}),define(re[141],oe([8,7]),function(te,e){return te.create("vs/base/common/platform",e)}),define(re[4],oe([0,1,141]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let U=!1,l=!1,T=!1,N=!1,R=!1,I=!1,w=!1,P=!1,S=!1,p=!1,f,m=e.LANGUAGE_DEFAULT,E,a;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?u=e.globals.vscode.process:typeof process<"u"&&(u=process);const h=typeof u?.versions?.electron=="string",d=h&&u?.type==="renderer";if(typeof navigator=="object"&&!d)a=navigator.userAgent,U=a.indexOf("Windows")>=0,l=a.indexOf("Macintosh")>=0,P=(a.indexOf("Macintosh")>=0||a.indexOf("iPad")>=0||a.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,T=a.indexOf("Linux")>=0,p=a?.indexOf("Mobi")>=0,I=!0,f=O.getConfiguredDefaultLocale(O.localize(0,null))||e.LANGUAGE_DEFAULT,m=f;else if(typeof u=="object"){U=u.platform==="win32",l=u.platform==="darwin",T=u.platform==="linux",N=T&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,w=h,S=!!u.env.CI||!!u.env.BUILD_ARTIFACTSTAGINGDIRECTORY,f=e.LANGUAGE_DEFAULT,m=e.LANGUAGE_DEFAULT;const c=u.env.VSCODE_NLS_CONFIG;if(c)try{const y=JSON.parse(c),b=y.availableLanguages["*"];f=y.locale,m=b||e.LANGUAGE_DEFAULT,E=y._translationsConfigFile}catch{}R=!0}else console.error("Unable to resolve platform.");var v;(function(c){c[c.Web=0]="Web",c[c.Mac=1]="Mac",c[c.Linux=2]="Linux",c[c.Windows=3]="Windows"})(v=e.Platform||(e.Platform={}));function L(c){switch(c){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=L;let n=0;l?n=1:U?n=3:T&&(n=2),e.isWindows=U,e.isMacintosh=l,e.isLinux=T,e.isLinuxSnap=N,e.isNative=R,e.isElectron=w,e.isWeb=I,e.isWebWorker=I&&typeof e.globals.importScripts=="function",e.isIOS=P,e.isMobile=p,e.isCI=S,e.platform=n,e.userAgent=a,e.language=m;var r;(function(c){function y(){return e.language}c.value=y;function b(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}c.isDefaultVariant=b;function g(){return e.language==="en"}c.isDefault=g})(r=e.Language||(e.Language={})),e.locale=f,e.translationsConfigFile=E,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const c=[];e.globals.addEventListener("message",b=>{if(b.data&&b.data.vscodeScheduleAsyncWork)for(let g=0,D=c.length;g<D;g++){const A=c[g];if(A.id===b.data.vscodeScheduleAsyncWork){c.splice(g,1),A.callback();return}}});let y=0;return b=>{const g=++y;c.push({id:g,callback:b}),e.globals.postMessage({vscodeScheduleAsyncWork:g},"*")}}return c=>setTimeout(c)})();var t;(function(c){c[c.Windows=1]="Windows",c[c.Macintosh=2]="Macintosh",c[c.Linux=3]="Linux"})(t=e.OperatingSystem||(e.OperatingSystem={})),e.OS=l||P?2:U?1:3;let i=!0,s=!1;function o(){if(!s){s=!0;const c=new Uint8Array(2);c[0]=1,c[1]=2,i=new Uint16Array(c.buffer)[0]===(2<<8)+1}return i}e.isLittleEndian=o,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(re[36],oe([0,1,4]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let U;if(typeof O.globals.vscode<"u"&&typeof O.globals.vscode.process<"u"){const l=O.globals.vscode.process;U={get platform(){return l.platform},get arch(){return l.arch},get env(){return l.env},cwd(){return l.cwd()}}}else typeof process<"u"?U={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:U={get platform(){return O.isWindows?"win32":O.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=U.cwd,e.env=U.env,e.platform=U.platform,e.arch=U.arch}),define(re[13],oe([0,1,36]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const U=65,l=97,T=90,N=122,R=46,I=47,w=92,P=58,S=63;class p extends Error{constructor(r,t,i){let s;typeof t=="string"&&t.indexOf("not ")===0?(s="must not be",t=t.replace(/^not /,"")):s="must be";const o=r.indexOf(".")!==-1?"property":"argument";let c=`The "${r}" ${o} ${s} of type ${t}`;c+=`. Received type ${typeof i}`,super(c),this.code="ERR_INVALID_ARG_TYPE"}}function f(n,r){if(n===null||typeof n!="object")throw new p(r,"Object",n)}function m(n,r){if(typeof n!="string")throw new p(r,"string",n)}const E=O.platform==="win32";function a(n){return n===I||n===w}function u(n){return n===I}function h(n){return n>=U&&n<=T||n>=l&&n<=N}function d(n,r,t,i){let s="",o=0,c=-1,y=0,b=0;for(let g=0;g<=n.length;++g){if(g<n.length)b=n.charCodeAt(g);else{if(i(b))break;b=I}if(i(b)){if(!(c===g-1||y===1))if(y===2){if(s.length<2||o!==2||s.charCodeAt(s.length-1)!==R||s.charCodeAt(s.length-2)!==R){if(s.length>2){const D=s.lastIndexOf(t);D===-1?(s="",o=0):(s=s.slice(0,D),o=s.length-1-s.lastIndexOf(t)),c=g,y=0;continue}else if(s.length!==0){s="",o=0,c=g,y=0;continue}}r&&(s+=s.length>0?`${t}..`:"..",o=2)}else s.length>0?s+=`${t}${n.slice(c+1,g)}`:s=n.slice(c+1,g),o=g-c-1;c=g,y=0}else b===R&&y!==-1?++y:y=-1}return s}function v(n,r){f(r,"pathObject");const t=r.dir||r.root,i=r.base||`${r.name||""}${r.ext||""}`;return t?t===r.root?`${t}${i}`:`${t}${n}${i}`:i}e.win32={resolve(...n){let r="",t="",i=!1;for(let s=n.length-1;s>=-1;s--){let o;if(s>=0){if(o=n[s],m(o,"path"),o.length===0)continue}else r.length===0?o=O.cwd():(o=O.env[`=${r}`]||O.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==r.toLowerCase()&&o.charCodeAt(2)===w)&&(o=`${r}\\`));const c=o.length;let y=0,b="",g=!1;const D=o.charCodeAt(0);if(c===1)a(D)&&(y=1,g=!0);else if(a(D))if(g=!0,a(o.charCodeAt(1))){let A=2,F=A;for(;A<c&&!a(o.charCodeAt(A));)A++;if(A<c&&A!==F){const j=o.slice(F,A);for(F=A;A<c&&a(o.charCodeAt(A));)A++;if(A<c&&A!==F){for(F=A;A<c&&!a(o.charCodeAt(A));)A++;(A===c||A!==F)&&(b=`\\\\${j}\\${o.slice(F,A)}`,y=A)}}}else y=1;else h(D)&&o.charCodeAt(1)===P&&(b=o.slice(0,2),y=2,c>2&&a(o.charCodeAt(2))&&(g=!0,y=3));if(b.length>0)if(r.length>0){if(b.toLowerCase()!==r.toLowerCase())continue}else r=b;if(i){if(r.length>0)break}else if(t=`${o.slice(y)}\\${t}`,i=g,g&&r.length>0)break}return t=d(t,!i,"\\",a),i?`${r}\\${t}`:`${r}${t}`||"."},normalize(n){m(n,"path");const r=n.length;if(r===0)return".";let t=0,i,s=!1;const o=n.charCodeAt(0);if(r===1)return u(o)?"\\":n;if(a(o))if(s=!0,a(n.charCodeAt(1))){let y=2,b=y;for(;y<r&&!a(n.charCodeAt(y));)y++;if(y<r&&y!==b){const g=n.slice(b,y);for(b=y;y<r&&a(n.charCodeAt(y));)y++;if(y<r&&y!==b){for(b=y;y<r&&!a(n.charCodeAt(y));)y++;if(y===r)return`\\\\${g}\\${n.slice(b)}\\`;y!==b&&(i=`\\\\${g}\\${n.slice(b,y)}`,t=y)}}}else t=1;else h(o)&&n.charCodeAt(1)===P&&(i=n.slice(0,2),t=2,r>2&&a(n.charCodeAt(2))&&(s=!0,t=3));let c=t<r?d(n.slice(t),!s,"\\",a):"";return c.length===0&&!s&&(c="."),c.length>0&&a(n.charCodeAt(r-1))&&(c+="\\"),i===void 0?s?`\\${c}`:c:s?`${i}\\${c}`:`${i}${c}`},isAbsolute(n){m(n,"path");const r=n.length;if(r===0)return!1;const t=n.charCodeAt(0);return a(t)||r>2&&h(t)&&n.charCodeAt(1)===P&&a(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let r,t;for(let o=0;o<n.length;++o){const c=n[o];m(c,"path"),c.length>0&&(r===void 0?r=t=c:r+=`\\${c}`)}if(r===void 0)return".";let i=!0,s=0;if(typeof t=="string"&&a(t.charCodeAt(0))){++s;const o=t.length;o>1&&a(t.charCodeAt(1))&&(++s,o>2&&(a(t.charCodeAt(2))?++s:i=!1))}if(i){for(;s<r.length&&a(r.charCodeAt(s));)s++;s>=2&&(r=`\\${r.slice(s)}`)}return e.win32.normalize(r)},relative(n,r){if(m(n,"from"),m(r,"to"),n===r)return"";const t=e.win32.resolve(n),i=e.win32.resolve(r);if(t===i||(n=t.toLowerCase(),r=i.toLowerCase(),n===r))return"";let s=0;for(;s<n.length&&n.charCodeAt(s)===w;)s++;let o=n.length;for(;o-1>s&&n.charCodeAt(o-1)===w;)o--;const c=o-s;let y=0;for(;y<r.length&&r.charCodeAt(y)===w;)y++;let b=r.length;for(;b-1>y&&r.charCodeAt(b-1)===w;)b--;const g=b-y,D=c<g?c:g;let A=-1,F=0;for(;F<D;F++){const x=n.charCodeAt(s+F);if(x!==r.charCodeAt(y+F))break;x===w&&(A=F)}if(F!==D){if(A===-1)return i}else{if(g>D){if(r.charCodeAt(y+F)===w)return i.slice(y+F+1);if(F===2)return i.slice(y+F)}c>D&&(n.charCodeAt(s+F)===w?A=F:F===2&&(A=3)),A===-1&&(A=0)}let j="";for(F=s+A+1;F<=o;++F)(F===o||n.charCodeAt(F)===w)&&(j+=j.length===0?"..":"\\..");return y+=A,j.length>0?`${j}${i.slice(y,b)}`:(i.charCodeAt(y)===w&&++y,i.slice(y,b))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const r=e.win32.resolve(n);if(r.length<=2)return n;if(r.charCodeAt(0)===w){if(r.charCodeAt(1)===w){const t=r.charCodeAt(2);if(t!==S&&t!==R)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(h(r.charCodeAt(0))&&r.charCodeAt(1)===P&&r.charCodeAt(2)===w)return`\\\\?\\${r}`;return n},dirname(n){m(n,"path");const r=n.length;if(r===0)return".";let t=-1,i=0;const s=n.charCodeAt(0);if(r===1)return a(s)?n:".";if(a(s)){if(t=i=1,a(n.charCodeAt(1))){let y=2,b=y;for(;y<r&&!a(n.charCodeAt(y));)y++;if(y<r&&y!==b){for(b=y;y<r&&a(n.charCodeAt(y));)y++;if(y<r&&y!==b){for(b=y;y<r&&!a(n.charCodeAt(y));)y++;if(y===r)return n;y!==b&&(t=i=y+1)}}}}else h(s)&&n.charCodeAt(1)===P&&(t=r>2&&a(n.charCodeAt(2))?3:2,i=t);let o=-1,c=!0;for(let y=r-1;y>=i;--y)if(a(n.charCodeAt(y))){if(!c){o=y;break}}else c=!1;if(o===-1){if(t===-1)return".";o=t}return n.slice(0,o)},basename(n,r){r!==void 0&&m(r,"ext"),m(n,"path");let t=0,i=-1,s=!0,o;if(n.length>=2&&h(n.charCodeAt(0))&&n.charCodeAt(1)===P&&(t=2),r!==void 0&&r.length>0&&r.length<=n.length){if(r===n)return"";let c=r.length-1,y=-1;for(o=n.length-1;o>=t;--o){const b=n.charCodeAt(o);if(a(b)){if(!s){t=o+1;break}}else y===-1&&(s=!1,y=o+1),c>=0&&(b===r.charCodeAt(c)?--c===-1&&(i=o):(c=-1,i=y))}return t===i?i=y:i===-1&&(i=n.length),n.slice(t,i)}for(o=n.length-1;o>=t;--o)if(a(n.charCodeAt(o))){if(!s){t=o+1;break}}else i===-1&&(s=!1,i=o+1);return i===-1?"":n.slice(t,i)},extname(n){m(n,"path");let r=0,t=-1,i=0,s=-1,o=!0,c=0;n.length>=2&&n.charCodeAt(1)===P&&h(n.charCodeAt(0))&&(r=i=2);for(let y=n.length-1;y>=r;--y){const b=n.charCodeAt(y);if(a(b)){if(!o){i=y+1;break}continue}s===-1&&(o=!1,s=y+1),b===R?t===-1?t=y:c!==1&&(c=1):t!==-1&&(c=-1)}return t===-1||s===-1||c===0||c===1&&t===s-1&&t===i+1?"":n.slice(t,s)},format:v.bind(null,"\\"),parse(n){m(n,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return r;const t=n.length;let i=0,s=n.charCodeAt(0);if(t===1)return a(s)?(r.root=r.dir=n,r):(r.base=r.name=n,r);if(a(s)){if(i=1,a(n.charCodeAt(1))){let A=2,F=A;for(;A<t&&!a(n.charCodeAt(A));)A++;if(A<t&&A!==F){for(F=A;A<t&&a(n.charCodeAt(A));)A++;if(A<t&&A!==F){for(F=A;A<t&&!a(n.charCodeAt(A));)A++;A===t?i=A:A!==F&&(i=A+1)}}}}else if(h(s)&&n.charCodeAt(1)===P){if(t<=2)return r.root=r.dir=n,r;if(i=2,a(n.charCodeAt(2))){if(t===3)return r.root=r.dir=n,r;i=3}}i>0&&(r.root=n.slice(0,i));let o=-1,c=i,y=-1,b=!0,g=n.length-1,D=0;for(;g>=i;--g){if(s=n.charCodeAt(g),a(s)){if(!b){c=g+1;break}continue}y===-1&&(b=!1,y=g+1),s===R?o===-1?o=g:D!==1&&(D=1):o!==-1&&(D=-1)}return y!==-1&&(o===-1||D===0||D===1&&o===y-1&&o===c+1?r.base=r.name=n.slice(c,y):(r.name=n.slice(c,o),r.base=n.slice(c,y),r.ext=n.slice(o,y))),c>0&&c!==i?r.dir=n.slice(0,c-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null};const L=(()=>{if(E){const n=/\\/g;return()=>{const r=O.cwd().replace(n,"/");return r.slice(r.indexOf("/"))}}return()=>O.cwd()})();e.posix={resolve(...n){let r="",t=!1;for(let i=n.length-1;i>=-1&&!t;i--){const s=i>=0?n[i]:L();m(s,"path"),s.length!==0&&(r=`${s}/${r}`,t=s.charCodeAt(0)===I)}return r=d(r,!t,"/",u),t?`/${r}`:r.length>0?r:"."},normalize(n){if(m(n,"path"),n.length===0)return".";const r=n.charCodeAt(0)===I,t=n.charCodeAt(n.length-1)===I;return n=d(n,!r,"/",u),n.length===0?r?"/":t?"./":".":(t&&(n+="/"),r?`/${n}`:n)},isAbsolute(n){return m(n,"path"),n.length>0&&n.charCodeAt(0)===I},join(...n){if(n.length===0)return".";let r;for(let t=0;t<n.length;++t){const i=n[t];m(i,"path"),i.length>0&&(r===void 0?r=i:r+=`/${i}`)}return r===void 0?".":e.posix.normalize(r)},relative(n,r){if(m(n,"from"),m(r,"to"),n===r||(n=e.posix.resolve(n),r=e.posix.resolve(r),n===r))return"";const t=1,i=n.length,s=i-t,o=1,c=r.length-o,y=s<c?s:c;let b=-1,g=0;for(;g<y;g++){const A=n.charCodeAt(t+g);if(A!==r.charCodeAt(o+g))break;A===I&&(b=g)}if(g===y)if(c>y){if(r.charCodeAt(o+g)===I)return r.slice(o+g+1);if(g===0)return r.slice(o+g)}else s>y&&(n.charCodeAt(t+g)===I?b=g:g===0&&(b=0));let D="";for(g=t+b+1;g<=i;++g)(g===i||n.charCodeAt(g)===I)&&(D+=D.length===0?"..":"/..");return`${D}${r.slice(o+b)}`},toNamespacedPath(n){return n},dirname(n){if(m(n,"path"),n.length===0)return".";const r=n.charCodeAt(0)===I;let t=-1,i=!0;for(let s=n.length-1;s>=1;--s)if(n.charCodeAt(s)===I){if(!i){t=s;break}}else i=!1;return t===-1?r?"/":".":r&&t===1?"//":n.slice(0,t)},basename(n,r){r!==void 0&&m(r,"ext"),m(n,"path");let t=0,i=-1,s=!0,o;if(r!==void 0&&r.length>0&&r.length<=n.length){if(r===n)return"";let c=r.length-1,y=-1;for(o=n.length-1;o>=0;--o){const b=n.charCodeAt(o);if(b===I){if(!s){t=o+1;break}}else y===-1&&(s=!1,y=o+1),c>=0&&(b===r.charCodeAt(c)?--c===-1&&(i=o):(c=-1,i=y))}return t===i?i=y:i===-1&&(i=n.length),n.slice(t,i)}for(o=n.length-1;o>=0;--o)if(n.charCodeAt(o)===I){if(!s){t=o+1;break}}else i===-1&&(s=!1,i=o+1);return i===-1?"":n.slice(t,i)},extname(n){m(n,"path");let r=-1,t=0,i=-1,s=!0,o=0;for(let c=n.length-1;c>=0;--c){const y=n.charCodeAt(c);if(y===I){if(!s){t=c+1;break}continue}i===-1&&(s=!1,i=c+1),y===R?r===-1?r=c:o!==1&&(o=1):r!==-1&&(o=-1)}return r===-1||i===-1||o===0||o===1&&r===i-1&&r===t+1?"":n.slice(r,i)},format:v.bind(null,"/"),parse(n){m(n,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return r;const t=n.charCodeAt(0)===I;let i;t?(r.root="/",i=1):i=0;let s=-1,o=0,c=-1,y=!0,b=n.length-1,g=0;for(;b>=i;--b){const D=n.charCodeAt(b);if(D===I){if(!y){o=b+1;break}continue}c===-1&&(y=!1,c=b+1),D===R?s===-1?s=b:g!==1&&(g=1):s!==-1&&(g=-1)}if(c!==-1){const D=o===0&&t?1:o;s===-1||g===0||g===1&&s===c-1&&s===o+1?r.base=r.name=n.slice(D,c):(r.name=n.slice(D,s),r.base=n.slice(D,c),r.ext=n.slice(s,c))}return o>0?r.dir=n.slice(0,o-1):t&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=E?e.win32.normalize:e.posix.normalize,e.isAbsolute=E?e.win32.isAbsolute:e.posix.isAbsolute,e.join=E?e.win32.join:e.posix.join,e.resolve=E?e.win32.resolve:e.posix.resolve,e.relative=E?e.win32.relative:e.posix.relative,e.dirname=E?e.win32.dirname:e.posix.dirname,e.basename=E?e.win32.basename:e.posix.basename,e.extname=E?e.win32.extname:e.posix.extname,e.format=E?e.win32.format:e.posix.format,e.parse=E?e.win32.parse:e.posix.parse,e.toNamespacedPath=E?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=E?e.win32.sep:e.posix.sep,e.delimiter=E?e.win32.delimiter:e.posix.delimiter}),define(re[142],oe([0,1,13]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const U={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},l={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function T(P){const S=(0,O.extname)(P),p=U[S.toLowerCase()];return p!==void 0?p:N(P)}e.getMediaOrTextMime=T;function N(P){const S=(0,O.extname)(P);return l[S.toLowerCase()]}e.getMediaMime=N;function R(P){for(const S in l)if(l[S]===P)return S}e.getExtensionForMimeType=R;const I=/^(.+)\/(.+?)(;.+)?$/;function w(P,S){const p=I.exec(P);return p?`${p[1].toLowerCase()}/${p[2].toLowerCase()}${p[3]??""}`:S?void 0:P}e.normalizeMimeType=w}),define(re[89],oe([0,1,4]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var U;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(U=e.Source||(e.Source={}));var l;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(l=e.TerminateResponseCode||(e.TerminateResponseCode={}));function T(R,...I){const w=I.reduce((p,f)=>(p[f]=!0,p),{}),P=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter(p=>!w[p]).forEach(p=>{for(let f=0;f<P.length;f++)if(p.search(P[f])!==-1){delete R[p];break}})}e.sanitizeProcessEnvironment=T;function N(R){!R||(delete R.DEBUG,O.isMacintosh&&delete R.DYLD_LIBRARY_PATH,O.isLinux&&delete R.LD_PRELOAD)}e.removeDangerousEnvVariables=N}),define(re[90],oe([0,1,4]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const U=O.globals.performance&&typeof O.globals.performance.now=="function";class l{static create(N=!0){return new l(N)}constructor(N){this.a=U&&N,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?O.globals.performance.now():Date.now()}}e.StopWatch=l}),define(re[3],oe([0,1,10,84,2,86,90]),function(te,e,O,U,l,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const R=!1,I=!1;var w;(function(o){o.None=()=>l.Disposable.None;function c(M){if(I){const{onDidAddListener:z}=M,_=m.create();let W=0;M.onDidAddListener=()=>{++W===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),_.print()),z?.()}}}function y(M,z){return B(M,()=>{},0,void 0,!0,void 0,z)}o.defer=y;function b(M){return(z,_=null,W)=>{let Q=!1,ee;return ee=M(le=>{if(!Q)return ee?ee.dispose():Q=!0,z.call(_,le)},null,W),Q&&ee.dispose(),ee}}o.once=b;function g(M,z,_){return V((W,Q=null,ee)=>M(le=>W.call(Q,z(le)),null,ee),_)}o.map=g;function D(M,z,_){return V((W,Q=null,ee)=>M(le=>{z(le),W.call(Q,le)},null,ee),_)}o.forEach=D;function A(M,z,_){return V((W,Q=null,ee)=>M(le=>z(le)&&W.call(Q,le),null,ee),_)}o.filter=A;function F(M){return M}o.signal=F;function j(...M){return(z,_=null,W)=>(0,l.combinedDisposable)(...M.map(Q=>Q(ee=>z.call(_,ee),null,W)))}o.any=j;function x(M,z,_,W){let Q=_;return g(M,ee=>(Q=z(Q,ee),Q),W)}o.reduce=x;function V(M,z){let _;const W={onWillAddFirstListener(){_=M(Q.fire,Q)},onDidRemoveLastListener(){_?.dispose()}};z||c(W);const Q=new a(W);return z?.add(Q),Q.event}function B(M,z,_=100,W=!1,Q=!1,ee,le){let he,pe,de,be=0,Ce;const Re={leakWarningThreshold:ee,onWillAddFirstListener(){he=M(We=>{be++,pe=z(pe,We),W&&!de&&(ke.fire(pe),pe=void 0),Ce=()=>{const Ye=pe;pe=void 0,de=void 0,(!W||be>1)&&ke.fire(Ye),be=0},typeof _=="number"?(clearTimeout(de),de=setTimeout(Ce,_)):de===void 0&&(de=0,queueMicrotask(Ce))})},onWillRemoveListener(){Q&&be>0&&Ce?.()},onDidRemoveLastListener(){Ce=void 0,he.dispose()}};le||c(Re);const ke=new a(Re);return le?.add(ke),ke.event}o.debounce=B;function Z(M,z=0,_){return o.debounce(M,(W,Q)=>W?(W.push(Q),W):[Q],z,void 0,!0,void 0,_)}o.accumulate=Z;function J(M,z=(W,Q)=>W===Q,_){let W=!0,Q;return A(M,ee=>{const le=W||!z(ee,Q);return W=!1,Q=ee,le},_)}o.latch=J;function K(M,z,_){return[o.filter(M,z,_),o.filter(M,W=>!z(W),_)]}o.split=K;function Y(M,z=!1,_=[]){let W=_.slice(),Q=M(he=>{W?W.push(he):le.fire(he)});const ee=()=>{W?.forEach(he=>le.fire(he)),W=null},le=new a({onWillAddFirstListener(){Q||(Q=M(he=>le.fire(he)))},onDidAddFirstListener(){W&&(z?setTimeout(ee):ee())},onDidRemoveLastListener(){Q&&Q.dispose(),Q=null}});return le.event}o.buffer=Y;class H{constructor(z){this.event=z,this.c=new l.DisposableStore}map(z){return new H(g(this.event,z,this.c))}forEach(z){return new H(D(this.event,z,this.c))}filter(z){return new H(A(this.event,z,this.c))}reduce(z,_){return new H(x(this.event,z,_,this.c))}latch(){return new H(J(this.event,void 0,this.c))}debounce(z,_=100,W=!1,Q=!1,ee){return new H(B(this.event,z,_,W,Q,ee,this.c))}on(z,_,W){return this.event(z,_,W)}once(z,_,W){return b(this.event)(z,_,W)}dispose(){this.c.dispose()}}function $(M){return new H(M)}o.chain=$;function X(M,z,_=W=>W){const W=(...he)=>le.fire(_(...he)),Q=()=>M.on(z,W),ee=()=>M.removeListener(z,W),le=new a({onWillAddFirstListener:Q,onDidRemoveLastListener:ee});return le.event}o.fromNodeEventEmitter=X;function ie(M,z,_=W=>W){const W=(...he)=>le.fire(_(...he)),Q=()=>M.addEventListener(z,W),ee=()=>M.removeEventListener(z,W),le=new a({onWillAddFirstListener:Q,onDidRemoveLastListener:ee});return le.event}o.fromDOMEventEmitter=ie;function se(M){return new Promise(z=>b(M)(z))}o.toPromise=se;function ae(M,z){return z(void 0),M(_=>z(_))}o.runAndSubscribe=ae;function q(M,z){let _=null;function W(ee){_?.dispose(),_=new l.DisposableStore,z(ee,_)}W(void 0);const Q=M(ee=>W(ee));return(0,l.toDisposable)(()=>{Q.dispose(),_?.dispose()})}o.runAndSubscribeWithStore=q;class C{constructor(z,_){this.obs=z,this.c=0,this.d=!1;const W={onWillAddFirstListener:()=>{z.addObserver(this)},onDidRemoveLastListener:()=>{z.removeObserver(this)}};_||c(W),this.emitter=new a(W),_&&_.add(this.emitter)}beginUpdate(z){this.c++}handleChange(z,_){this.d=!0}endUpdate(z){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function k(M,z){return new C(M,z).emitter.event}o.fromObservable=k})(w=e.Event||(e.Event={}));class P{constructor(c){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${c}_${P.c++}`,P.all.add(this)}start(c){this.d=new N.StopWatch(!0),this.listenerCount=c}stop(){if(this.d){const c=this.d.elapsed();this.durations.push(c),this.elapsedOverall+=c,this.invocationCount+=1,this.d=void 0}}}P.all=new Set,P.c=0,e.EventProfiling=P;let S=-1;function p(o){const c=S;return S=o,{dispose(){S=c}}}e.setGlobalLeakWarningThreshold=p;class f{constructor(c,y=Math.random().toString(18).slice(2,5)){this.threshold=c,this.name=y,this.d=0}dispose(){this.c?.clear()}check(c,y){const b=this.threshold;if(b<=0||y<b)return;this.c||(this.c=new Map);const g=this.c.get(c.value)||0;if(this.c.set(c.value,g+1),this.d-=1,this.d<=0){this.d=b*.5;let D,A=0;for(const[F,j]of this.c)(!D||A<j)&&(D=F,A=j);console.warn(`[${this.name}] potential listener LEAK detected, having ${y} listeners already. MOST frequent listener (${A}):`),console.warn(D)}return()=>{const D=this.c.get(c.value)||0;this.c.set(c.value,D-1)}}}class m{static create(){return new m(new Error().stack??"")}constructor(c){this.value=c}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class E{constructor(c,y,b){this.callback=c,this.callbackThis=y,this.stack=b,this.subscription=new l.SafeDisposable}invoke(c){this.callback.call(this.callbackThis,c)}}class a{constructor(c){this.j=!1,this.d=c,this.f=S>0||this.d?.leakWarningThreshold?new f(this.d?.leakWarningThreshold??S):void 0,this.g=this.d?._profName?new P(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(R){const c=Array.from(this.q);queueMicrotask(()=>{for(const y of c)y.subscription.isset()&&(y.subscription.unset(),y.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(c,y,b)=>{if(this.q||(this.q=new T.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),l.Disposable.None;const g=this.q.isEmpty();g&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let D,A;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(A=m.create(),D=this.f.check(A,this.q.size+1)),R&&(A=A??m.create());const F=new E(c,y,A),j=this.q.push(F);g&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,c,y);const x=F.subscription.set(()=>{D?.(),this.j||(this.d?.onWillRemoveListener?.(this),j(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return b instanceof l.DisposableStore?b.add(x):Array.isArray(b)&&b.push(x),x}),this.l}fire(c){if(this.q){this.m||(this.m=new h(this.d?.onListenerError));for(const y of this.q)this.m.push(this,y,c);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=a;class u{constructor(c=O.onUnexpectedError){this.d=c,this.c=new T.LinkedList}get size(){return this.c.size}push(c,y,b){this.c.push(new d(c,y,b))}clear(c){const y=new T.LinkedList;for(const b of this.c)b.emitter!==c&&y.push(b);this.c=y}deliver(){for(;this.c.size>0;){const c=this.c.shift();try{c.listener.invoke(c.event)}catch(y){this.d(y)}}}}e.EventDeliveryQueue=u;class h extends u{clear(c){this.c.clear()}}class d{constructor(c,y,b){this.emitter=c,this.listener=y,this.event=b}}class v extends a{async fireAsync(c,y,b){if(!!this.q){this.c||(this.c=new T.LinkedList);for(const g of this.q)this.c.push([g,c]);for(;this.c.size>0&&!y.isCancellationRequested;){const[g,D]=this.c.shift(),A=[],F={...D,token:y,waitUntil:j=>{if(Object.isFrozen(A))throw new Error("waitUntil can NOT be called asynchronous");b&&(j=b(j,g.callback)),A.push(j)}};try{g.invoke(F)}catch(j){(0,O.onUnexpectedError)(j);continue}Object.freeze(A),await Promise.allSettled(A).then(j=>{for(const x of j)x.status==="rejected"&&(0,O.onUnexpectedError)(x.reason)})}}}}e.AsyncEmitter=v;class L extends a{constructor(c){super(c),this.h=0,this.s=new T.LinkedList,this.t=c?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const c=Array.from(this.s);this.s.clear(),super.fire(this.t(c))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(c){this.q&&(this.h!==0?this.s.push(c):super.fire(c))}}e.PauseableEmitter=L;class n extends L{constructor(c){super(c),this.c=c.delay??100}fire(c){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(c)}}e.DebounceEmitter=n;class r extends a{constructor(c){super(c),this.c=[],this.h=c?.merge}fire(c){!this.hasListeners()||(this.c.push(c),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(y=>super.fire(y)),this.c=[]}))}}e.MicrotaskEmitter=r;class t{constructor(){this.d=!1,this.f=[],this.c=new a({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(c){const y={event:c,listener:null};this.f.push(y),this.d&&this.j(y);const b=()=>{this.d&&this.k(y);const g=this.f.indexOf(y);this.f.splice(g,1)};return(0,l.toDisposable)((0,U.once)(b))}g(){this.d=!0,this.f.forEach(c=>this.j(c))}h(){this.d=!1,this.f.forEach(c=>this.k(c))}j(c){c.listener=c.event(y=>this.c.fire(y))}k(c){c.listener&&c.listener.dispose(),c.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=t;class i{constructor(){this.c=[]}wrapEvent(c){return(y,b,g)=>c(D=>{const A=this.c[this.c.length-1];A?A.push(()=>y.call(b,D)):y.call(b,D)},void 0,g)}bufferEvents(c){const y=[];this.c.push(y);const b=c();return this.c.pop(),y.forEach(g=>g()),b}}e.EventBufferer=i;class s{constructor(){this.c=!1,this.d=w.None,this.f=l.Disposable.None,this.g=new a({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(c){this.d=c,this.c&&(this.f.dispose(),this.f=c(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=s}),define(re[25],oe([0,1,3]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const U=Object.freeze(function(R,I){const w=setTimeout(R.bind(I),0);return{dispose(){clearTimeout(w)}}});var l;(function(R){function I(w){return w===R.None||w===R.Cancelled||w instanceof T?!0:!w||typeof w!="object"?!1:typeof w.isCancellationRequested=="boolean"&&typeof w.onCancellationRequested=="function"}R.isCancellationToken=I,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:O.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:U})})(l=e.CancellationToken||(e.CancellationToken={}));class T{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?U:(this.b||(this.b=new O.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class N{constructor(I){this.a=void 0,this.b=void 0,this.b=I&&I.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new T),this.a}cancel(){this.a?this.a instanceof T&&this.a.cancel():this.a=l.Cancelled}dispose(I=!1){I&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof T&&this.a.dispose():this.a=l.None}}e.CancellationTokenSource=N}),define(re[143],oe([0,1,25]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class U{constructor(R){this.b=R,this.a=null}get(){if(this.a)return this.a;const R=new O.CancellationTokenSource,I=this.b(R.token);return this.a={promise:I,dispose:()=>{this.a=null,R.cancel(),R.dispose()}},this.a}}e.Cache=U;class l{constructor(R){this.c=R,this.a=void 0,this.b=void 0}get(R){const I=JSON.stringify(R);return this.b!==I&&(this.b=I,this.a=this.c(R)),this.a}}e.LRUCachedFunction=l;class T{get cachedValues(){return this.a}constructor(R){this.b=R,this.a=new Map}get(R){if(this.a.has(R))return this.a.get(R);const I=this.b(R);return this.a.set(R,I),I}}e.CachedFunction=T}),define(re[27],oe([0,1,143,130]),function(te,e,O,U){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function T(ne){return!ne||typeof ne!="string"?!0:ne.trim().length===0}e.isFalsyOrWhitespace=T;const N=/{(\d+)}/g;function R(ne,...ue){return ue.length===0?ne:ne.replace(N,function(me,we){const ve=parseInt(we,10);return isNaN(ve)||ve<0||ve>=ue.length?me:ue[ve]})}e.format=R;const I=/{([^}]+)}/g;function w(ne,ue){return ne.replace(I,(me,we)=>ue[we]??me)}e.format2=w;function P(ne){return ne.replace(/[<>&]/g,function(ue){switch(ue){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ue}})}e.escape=P;function S(ne){return ne.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=S;function p(ne,ue){let me=0;const we=ue.charCodeAt(0);for(let ve=ne.length-1;ve>=0;ve--)ne.charCodeAt(ve)===we&&me++;return me}e.count=p;function f(ne,ue,me="\u2026"){return ne.length<=ue?ne:`${ne.substr(0,ue)}${me}`}e.truncate=f;function m(ne,ue=" "){const me=E(ne,ue);return a(me,ue)}e.trim=m;function E(ne,ue){if(!ne||!ue)return ne;const me=ue.length;if(me===0||ne.length===0)return ne;let we=0;for(;ne.indexOf(ue,we)===we;)we=we+me;return ne.substring(we)}e.ltrim=E;function a(ne,ue){if(!ne||!ue)return ne;const me=ue.length,we=ne.length;if(me===0||we===0)return ne;let ve=we,Ee=-1;for(;Ee=ne.lastIndexOf(ue,ve-1),!(Ee===-1||Ee+me!==ve);){if(Ee===0)return"";ve=Ee}return ne.substring(0,ve)}e.rtrim=a;function u(ne){return ne.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=u;function h(ne){return ne.replace(/\*/g,"")}e.stripWildcards=h;function d(ne,ue,me={}){if(!ne)throw new Error("Cannot create regex from empty string");ue||(ne=S(ne)),me.wholeWord&&(/\B/.test(ne.charAt(0))||(ne="\\b"+ne),/\B/.test(ne.charAt(ne.length-1))||(ne=ne+"\\b"));let we="";return me.global&&(we+="g"),me.matchCase||(we+="i"),me.multiline&&(we+="m"),me.unicode&&(we+="u"),new RegExp(ne,we)}e.createRegExp=d;function v(ne){return ne.source==="^"||ne.source==="^$"||ne.source==="$"||ne.source==="^\\s*$"?!1:!!(ne.exec("")&&ne.lastIndex===0)}e.regExpLeadsToEndlessLoop=v;function L(ne){return!!ne.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=L;function n(ne){return(ne.global?"g":"")+(ne.ignoreCase?"i":"")+(ne.multiline?"m":"")+(ne.unicode?"u":"")}e.regExpFlags=n;function r(ne){return ne.split(/\r\n|\r|\n/)}e.splitLines=r;function t(ne){for(let ue=0,me=ne.length;ue<me;ue++){const we=ne.charCodeAt(ue);if(we!==32&&we!==9)return ue}return-1}e.firstNonWhitespaceIndex=t;function i(ne,ue=0,me=ne.length){for(let we=ue;we<me;we++){const ve=ne.charCodeAt(we);if(ve!==32&&ve!==9)return ne.substring(ue,we)}return ne.substring(ue,me)}e.getLeadingWhitespace=i;function s(ne,ue=ne.length-1){for(let me=ue;me>=0;me--){const we=ne.charCodeAt(me);if(we!==32&&we!==9)return me}return-1}e.lastNonWhitespaceIndex=s;function o(ne,ue,me){const we=[];let ve=0;for(const Ee of ne.matchAll(ue)){if(we.push(ne.slice(ve,Ee.index)),Ee.index===void 0)throw new Error("match.index should be defined");ve=Ee.index+Ee[0].length,we.push(me(Ee[0],...Ee.slice(1),Ee.index,ne,Ee.groups))}return we.push(ne.slice(ve)),Promise.all(we).then(Ee=>Ee.join(""))}e.replaceAsync=o;function c(ne,ue){return ne<ue?-1:ne>ue?1:0}e.compare=c;function y(ne,ue,me=0,we=ne.length,ve=0,Ee=ue.length){for(;me<we&&ve<Ee;me++,ve++){const Te=ne.charCodeAt(me),Ue=ue.charCodeAt(ve);if(Te<Ue)return-1;if(Te>Ue)return 1}const De=we-me,Ae=Ee-ve;return De<Ae?-1:De>Ae?1:0}e.compareSubstring=y;function b(ne,ue){return g(ne,ue,0,ne.length,0,ue.length)}e.compareIgnoreCase=b;function g(ne,ue,me=0,we=ne.length,ve=0,Ee=ue.length){for(;me<we&&ve<Ee;me++,ve++){let Te=ne.charCodeAt(me),Ue=ue.charCodeAt(ve);if(Te===Ue)continue;if(Te>=128||Ue>=128)return y(ne.toLowerCase(),ue.toLowerCase(),me,we,ve,Ee);A(Te)&&(Te-=32),A(Ue)&&(Ue-=32);const $e=Te-Ue;if($e!==0)return $e}const De=we-me,Ae=Ee-ve;return De<Ae?-1:De>Ae?1:0}e.compareSubstringIgnoreCase=g;function D(ne){return ne>=48&&ne<=57}e.isAsciiDigit=D;function A(ne){return ne>=97&&ne<=122}e.isLowerAsciiLetter=A;function F(ne){return ne>=65&&ne<=90}e.isUpperAsciiLetter=F;function j(ne,ue){return ne.length===ue.length&&g(ne,ue)===0}e.equalsIgnoreCase=j;function x(ne,ue){const me=ue.length;return ue.length>ne.length?!1:g(ne,ue,0,me)===0}e.startsWithIgnoreCase=x;function V(ne,ue){const me=Math.min(ne.length,ue.length);let we;for(we=0;we<me;we++)if(ne.charCodeAt(we)!==ue.charCodeAt(we))return we;return me}e.commonPrefixLength=V;function B(ne,ue){const me=Math.min(ne.length,ue.length);let we;const ve=ne.length-1,Ee=ue.length-1;for(we=0;we<me;we++)if(ne.charCodeAt(ve-we)!==ue.charCodeAt(Ee-we))return we;return me}e.commonSuffixLength=B;function Z(ne){return 55296<=ne&&ne<=56319}e.isHighSurrogate=Z;function J(ne){return 56320<=ne&&ne<=57343}e.isLowSurrogate=J;function K(ne,ue){return(ne-55296<<10)+(ue-56320)+65536}e.computeCodePoint=K;function Y(ne,ue,me){const we=ne.charCodeAt(me);if(Z(we)&&me+1<ue){const ve=ne.charCodeAt(me+1);if(J(ve))return K(we,ve)}return we}e.getNextCodePoint=Y;function H(ne,ue){const me=ne.charCodeAt(ue-1);if(J(me)&&ue>1){const we=ne.charCodeAt(ue-2);if(Z(we))return K(we,me)}return me}class ${get offset(){return this.e}constructor(ue,me=0){this.c=ue,this.d=ue.length,this.e=me}setOffset(ue){this.e=ue}prevCodePoint(){const ue=H(this.c,this.e);return this.e-=ue>=65536?2:1,ue}nextCodePoint(){const ue=Y(this.c,this.d,this.e);return this.e+=ue>=65536?2:1,ue}eol(){return this.e>=this.d}}e.CodePointIterator=$;class X{get offset(){return this.c.offset}constructor(ue,me=0){this.c=new $(ue,me)}nextGraphemeLength(){const ue=Ie.getInstance(),me=this.c,we=me.offset;let ve=ue.getGraphemeBreakType(me.nextCodePoint());for(;!me.eol();){const Ee=me.offset,De=ue.getGraphemeBreakType(me.nextCodePoint());if(fe(ve,De)){me.setOffset(Ee);break}ve=De}return me.offset-we}prevGraphemeLength(){const ue=Ie.getInstance(),me=this.c,we=me.offset;let ve=ue.getGraphemeBreakType(me.prevCodePoint());for(;me.offset>0;){const Ee=me.offset,De=ue.getGraphemeBreakType(me.prevCodePoint());if(fe(De,ve)){me.setOffset(Ee);break}ve=De}return we-me.offset}eol(){return this.c.eol()}}e.GraphemeIterator=X;function ie(ne,ue){return new X(ne,ue).nextGraphemeLength()}e.nextCharLength=ie;function se(ne,ue){return new X(ne,ue).prevGraphemeLength()}e.prevCharLength=se;function ae(ne,ue){ue>0&&J(ne.charCodeAt(ue))&&ue--;const me=ue+ie(ne,ue);return[me-se(ne,me),me]}e.getCharContainingOffset=ae;function q(ne){const ue=new X(ne);let me=0;for(;!ue.eol();)me++,ue.nextGraphemeLength();return me}e.charCount=q;let C;function k(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function M(ne){return C||(C=k()),C.test(ne)}e.containsRTL=M;const z=/^[\t\n\r\x20-\x7E]*$/;function _(ne){return z.test(ne)}e.isBasicASCII=_,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function W(ne){return e.UNUSUAL_LINE_TERMINATORS.test(ne)}e.containsUnusualLineTerminators=W;function Q(ne){return ne>=11904&&ne<=55215||ne>=63744&&ne<=64255||ne>=65281&&ne<=65374}e.isFullWidthCharacter=Q;function ee(ne){return ne>=127462&&ne<=127487||ne===8986||ne===8987||ne===9200||ne===9203||ne>=9728&&ne<=10175||ne===11088||ne===11093||ne>=127744&&ne<=128591||ne>=128640&&ne<=128764||ne>=128992&&ne<=129008||ne>=129280&&ne<=129535||ne>=129648&&ne<=129782}e.isEmojiImprecise=ee;function le(ne,ue){if(ne.length<ue)return ne;const me=/\b/g;let we=0;for(;me.test(ne)&&!(ne.length-me.lastIndex<ue);)we=me.lastIndex,me.lastIndex+=1;return ne.substring(we).replace(/^\s/,"")}e.lcut=le;const he=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g;function pe(ne){return ne&&(ne=ne.replace(he,"")),ne}e.removeAnsiEscapeCodes=pe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function de(ne){return!!(ne&&ne.length>0&&ne.charCodeAt(0)===65279)}e.startsWithUTF8BOM=de;function be(ne){return de(ne)?ne.substr(1):ne}e.stripUTF8BOM=be;function Ce(ne,ue){if(!ne||!ue||ne.length<ue.length)return!1;const me=ue.length,we=ne.toLowerCase();let ve=0,Ee=-1;for(;ve<me;){const De=we.indexOf(ue[ve],Ee+1);if(De<0)return!1;Ee=De,ve++}return!0}e.fuzzyContains=Ce;function Re(ne,ue=!1){return ne?(ue&&(ne=ne.replace(/\\./g,"")),ne.toLowerCase()!==ne):!1}e.containsUppercaseCharacter=Re;function ke(ne){return ne.charAt(0).toUpperCase()+ne.slice(1)}e.uppercaseFirstLetter=ke;function We(ne,ue=1){if(ue===0)return"";let me=-1;do me=ne.indexOf(`
`,me+1),ue--;while(ue>0&&me>=0);return me===-1?ne:(ne[me-1]==="\r"&&me--,ne.substr(0,me))}e.getNLines=We;function Ye(ne){return ne=ne%(2*26),ne<26?String.fromCharCode(97+ne):String.fromCharCode(65+ne-26)}e.singleLetterHash=Ye;function ce(ne){return Ie.getInstance().getGraphemeBreakType(ne)}e.getGraphemeBreakType=ce;function fe(ne,ue){return ne===0?ue!==5&&ue!==7:ne===2&&ue===3?!1:ne===4||ne===2||ne===3||ue===4||ue===2||ue===3?!0:!(ne===8&&(ue===8||ue===9||ue===11||ue===12)||(ne===11||ne===9)&&(ue===9||ue===10)||(ne===12||ne===10)&&ue===10||ue===5||ue===13||ue===7||ne===1||ne===13&&ue===14||ne===6&&ue===6)}var ge;(function(ne){ne[ne.Other=0]="Other",ne[ne.Prepend=1]="Prepend",ne[ne.CR=2]="CR",ne[ne.LF=3]="LF",ne[ne.Control=4]="Control",ne[ne.Extend=5]="Extend",ne[ne.Regional_Indicator=6]="Regional_Indicator",ne[ne.SpacingMark=7]="SpacingMark",ne[ne.L=8]="L",ne[ne.V=9]="V",ne[ne.T=10]="T",ne[ne.LV=11]="LV",ne[ne.LVT=12]="LVT",ne[ne.ZWJ=13]="ZWJ",ne[ne.Extended_Pictographic=14]="Extended_Pictographic"})(ge=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ie{static getInstance(){return Ie.c||(Ie.c=new Ie),Ie.c}constructor(){this.d=Pe()}getGraphemeBreakType(ue){if(ue<32)return ue===10?3:ue===13?2:4;if(ue<127)return 0;const me=this.d,we=me.length/3;let ve=1;for(;ve<=we;)if(ue<me[3*ve])ve=2*ve;else if(ue>me[3*ve+1])ve=2*ve+1;else return me[3*ve+2];return 0}}Ie.c=null;function Pe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Fe(ne,ue){if(ne===0)return 0;const me=Le(ne,ue);if(me!==void 0)return me;const we=new $(ue,ne);return we.prevCodePoint(),we.offset}e.getLeftDeleteOffset=Fe;function Le(ne,ue){const me=new $(ue,ne);let we=me.prevCodePoint();for(;qe(we)||we===65039||we===8419;){if(me.offset===0)return;we=me.prevCodePoint()}if(!ee(we))return;let ve=me.offset;return ve>0&&me.prevCodePoint()===8205&&(ve=me.offset),ve}function qe(ne){return 127995<=ne&&ne<=127999}var Me;(function(ne){ne[ne.zwj=8205]="zwj",ne[ne.emojiVariantSelector=65039]="emojiVariantSelector",ne[ne.enclosingKeyCap=8419]="enclosingKeyCap"})(Me||(Me={})),e.noBreakWhitespace="\xA0";class Ne{static getInstance(ue){return Ne.d.get(Array.from(ue))}static getLocales(){return Ne.e.value}constructor(ue){this.f=ue}isAmbiguous(ue){return this.f.has(ue)}getPrimaryConfusable(ue){return this.f.get(ue)}getConfusableCodePoints(){return new Set(this.f.keys())}}l=Ne,Ne.c=new U.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ne.d=new O.LRUCachedFunction(ne=>{function ue(Ue){const $e=new Map;for(let ze=0;ze<Ue.length;ze+=2)$e.set(Ue[ze],Ue[ze+1]);return $e}function me(Ue,$e){const ze=new Map(Ue);for(const[et,nt]of $e)ze.set(et,nt);return ze}function we(Ue,$e){if(!Ue)return $e;const ze=new Map;for(const[et,nt]of Ue)$e.has(et)&&ze.set(et,nt);return ze}const ve=l.c.value;let Ee=ne.filter(Ue=>!Ue.startsWith("_")&&Ue in ve);Ee.length===0&&(Ee=["_default"]);let De;for(const Ue of Ee){const $e=ue(ve[Ue]);De=we(De,$e)}const Ae=ue(ve._common),Te=me(Ae,De);return new Ne(Te)}),Ne.e=new U.Lazy(()=>Object.keys(Ne.c.value).filter(ne=>!ne.startsWith("_"))),e.AmbiguousCharacters=Ne;class je{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(je.c())),this.d}static isInvisibleCharacter(ue){return je.e().has(ue)}static get codePoints(){return je.e()}}je.d=void 0,e.InvisibleCharacters=je}),define(re[48],oe([0,1,13,4,27,12]),function(te,e,O,U,l,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function N(s){return s===47||s===92}e.isPathSeparator=N;function R(s){return s.replace(/[\\/]/g,O.posix.sep)}e.toSlashes=R;function I(s){return s.indexOf("/")===-1&&(s=R(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=I;function w(s,o=O.posix.sep){if(!s)return"";const c=s.length,y=s.charCodeAt(0);if(N(y)){if(N(s.charCodeAt(1))&&!N(s.charCodeAt(2))){let g=3;const D=g;for(;g<c&&!N(s.charCodeAt(g));g++);if(D!==g&&!N(s.charCodeAt(g+1))){for(g+=1;g<c;g++)if(N(s.charCodeAt(g)))return s.slice(0,g+1).replace(/[\\/]/g,o)}}return o}else if(u(y)&&s.charCodeAt(1)===58)return N(s.charCodeAt(2))?s.slice(0,2)+o:s.slice(0,2);let b=s.indexOf("://");if(b!==-1){for(b+=3;b<c;b++)if(N(s.charCodeAt(b)))return s.slice(0,b+1)}return""}e.getRoot=w;function P(s){if(!U.isWindows||!s||s.length<5)return!1;let o=s.charCodeAt(0);if(o!==92||(o=s.charCodeAt(1),o!==92))return!1;let c=2;const y=c;for(;c<s.length&&(o=s.charCodeAt(c),o!==92);c++);return!(y===c||(o=s.charCodeAt(c+1),isNaN(o)||o===92))}e.isUNC=P;const S=/[\\/:\*\?"<>\|]/g,p=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(s,o=U.isWindows){const c=o?S:p;return!(!s||s.length===0||/^\s+$/.test(s)||(c.lastIndex=0,c.test(s))||o&&f.test(s)||s==="."||s===".."||o&&s[s.length-1]==="."||o&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=m;function E(s,o,c){const y=s===o;return!c||y?y:!s||!o?!1:(0,l.equalsIgnoreCase)(s,o)}e.isEqual=E;function a(s,o,c,y=O.sep){if(s===o)return!0;if(!s||!o||o.length>s.length)return!1;if(c){if(!(0,l.startsWithIgnoreCase)(s,o))return!1;if(o.length===s.length)return!0;let g=o.length;return o.charAt(o.length-1)===y&&g--,s.charAt(g)===y}return o.charAt(o.length-1)!==y&&(o+=y),s.indexOf(o)===0}e.isEqualOrParent=a;function u(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=u;function h(s,o){return U.isWindows&&s.endsWith(":")&&(s+=O.sep),(0,O.isAbsolute)(s)||(s=(0,O.join)(o,s)),s=(0,O.normalize)(s),U.isWindows?(s=(0,l.rtrim)(s,O.sep),s.endsWith(":")&&(s+=O.sep)):(s=(0,l.rtrim)(s,O.sep),s||(s=O.sep)),s}e.sanitizeFilePath=h;function d(s){const o=(0,O.normalize)(s);return U.isWindows?s.length>3?!1:v(o)&&(s.length===2||o.charCodeAt(2)===92):o===O.posix.sep}e.isRootOrDriveLetter=d;function v(s,o=U.isWindows){return o?u(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=v;function L(s){return v(s)?s[0]:void 0}e.getDriveLetter=L;function n(s,o,c){return o.length>s.length?-1:s===o?0:(c&&(s=s.toLowerCase(),o=o.toLowerCase()),s.indexOf(o))}e.indexOfPath=n;function r(s){const o=s.split(":");let c,y,b;for(const g of o){const D=Number(g);(0,T.isNumber)(D)?y===void 0?y=D:b===void 0&&(b=D):c=c?[c,g].join(":"):g}if(!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:y!==void 0?y:void 0,column:b!==void 0?b:y!==void 0?1:void 0}}e.parseLineAndColumnAware=r;const t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function i(s,o,c=8){let y="";for(let g=0;g<c;g++)y+=t.charAt(Math.floor(Math.random()*t.length));let b;return o?b=`${o}-${y}`:b=y,s?(0,O.join)(s,b):b}e.randomPath=i}),define(re[53],oe([0,1,27]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function U(u){return l(u,0)}e.hash=U;function l(u,h){switch(typeof u){case"object":return u===null?T(349,h):Array.isArray(u)?I(u,h):w(u,h);case"string":return R(u,h);case"boolean":return N(u,h);case"number":return T(u,h);case"undefined":return T(937,h);default:return T(617,h)}}e.doHash=l;function T(u,h){return(h<<5)-h+u|0}e.numberHash=T;function N(u,h){return T(u?433:863,h)}function R(u,h){h=T(149417,h);for(let d=0,v=u.length;d<v;d++)h=T(u.charCodeAt(d),h);return h}e.stringHash=R;function I(u,h){return h=T(104579,h),u.reduce((d,v)=>l(v,d),h)}function w(u,h){return h=T(181387,h),Object.keys(u).sort().reduce((d,v)=>(d=R(v,d),l(u[v],d)),h)}class P{constructor(){this.g=0}get value(){return this.g}hash(h){return this.g=l(h,this.g),this.g}}e.Hasher=P;var S;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(S||(S={}));function p(u,h,d=32){const v=d-h,L=~((1<<v)-1);return(u<<h|(L&u)>>>v)>>>0}function f(u,h=0,d=u.byteLength,v=0){for(let L=0;L<d;L++)u[h+L]=v}function m(u,h,d="0"){for(;u.length<h;)u=d+u;return u}function E(u,h=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(d=>d.toString(16).padStart(2,"0")).join(""):m((u>>>0).toString(16),h/4)}e.toHexString=E;class a{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(h){const d=h.length;if(d===0)return;const v=this.p;let L=this.r,n=this.u,r,t;for(n!==0?(r=n,t=-1,n=0):(r=h.charCodeAt(0),t=0);;){let i=r;if(O.isHighSurrogate(r))if(t+1<d){const s=h.charCodeAt(t+1);O.isLowSurrogate(s)?(t++,i=O.computeCodePoint(r,s)):i=65533}else{n=r;break}else O.isLowSurrogate(r)&&(i=65533);if(L=this.w(v,L,i),t++,t<d)r=h.charCodeAt(t);else break}this.r=L,this.u=n}w(h,d,v){return v<128?h[d++]=v:v<2048?(h[d++]=192|(v&1984)>>>6,h[d++]=128|(v&63)>>>0):v<65536?(h[d++]=224|(v&61440)>>>12,h[d++]=128|(v&4032)>>>6,h[d++]=128|(v&63)>>>0):(h[d++]=240|(v&1835008)>>>18,h[d++]=128|(v&258048)>>>12,h[d++]=128|(v&4032)>>>6,h[d++]=128|(v&63)>>>0),d>=64&&(this.y(),d-=64,this.t+=64,h[0]=h[64+0],h[1]=h[64+1],h[2]=h[64+2]),d}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),E(this.h)+E(this.l)+E(this.m)+E(this.n)+E(this.o)}x(){this.p[this.r++]=128,f(this.p,this.r),this.r>56&&(this.y(),f(this.p));const h=8*this.t;this.q.setUint32(56,Math.floor(h/4294967296),!1),this.q.setUint32(60,h%4294967296,!1),this.y()}y(){const h=a.g,d=this.q;for(let c=0;c<64;c+=4)h.setUint32(c,d.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)h.setUint32(c,p(h.getUint32(c-12,!1)^h.getUint32(c-32,!1)^h.getUint32(c-56,!1)^h.getUint32(c-64,!1),1),!1);let v=this.h,L=this.l,n=this.m,r=this.n,t=this.o,i,s,o;for(let c=0;c<80;c++)c<20?(i=L&n|~L&r,s=1518500249):c<40?(i=L^n^r,s=1859775393):c<60?(i=L&n|L&r|n&r,s=2400959708):(i=L^n^r,s=3395469782),o=p(v,5)+i+t+s+h.getUint32(c*4,!1)&4294967295,t=r,r=n,n=p(L,30),L=v,v=o;this.h=this.h+v&4294967295,this.l=this.l+L&4294967295,this.m=this.m+n&4294967295,this.n=this.n+r&4294967295,this.o=this.o+t&4294967295}}a.g=new DataView(new ArrayBuffer(320)),e.StringSHA1=a}),define(re[91],oe([0,1,27]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var U;(function(l){l[l.Ignore=0]="Ignore",l[l.Info=1]="Info",l[l.Warning=2]="Warning",l[l.Error=3]="Error"})(U||(U={})),function(l){const T="error",N="warning",R="warn",I="info",w="ignore";function P(p){return p?O.equalsIgnoreCase(T,p)?l.Error:O.equalsIgnoreCase(N,p)||O.equalsIgnoreCase(R,p)?l.Warning:O.equalsIgnoreCase(I,p)?l.Info:l.Ignore:l.Ignore}l.fromValue=P;function S(p){switch(p){case l.Error:return T;case l.Warning:return N;case l.Info:return I;default:return w}}l.toString=S}(U||(U={})),e.default=U}),define(re[49],oe([0,1,21,27]),function(te,e,O,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class l{constructor(){this.b="",this.c=0}reset(f){return this.b=f,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(f){const m=f.charCodeAt(0),E=this.b.charCodeAt(this.c);return m-E}value(){return this.b[this.c]}}e.StringIterator=l;class T{constructor(f=!0){this.e=f}reset(f){return this.b=f,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let f=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(f)this.c++;else break;else f=!1;return this}cmp(f){return this.e?(0,U.compareSubstring)(f,this.b,0,f.length,this.c,this.d):(0,U.compareSubstringIgnoreCase)(f,this.b,0,f.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=T;class N{constructor(f=!0,m=!0){this.f=f,this.g=m}reset(f){this.d=0,this.e=0,this.b=f,this.c=f.length;for(let m=f.length-1;m>=0;m--,this.c--){const E=this.b.charCodeAt(m);if(!(E===47||this.f&&E===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let f=!0;for(;this.e<this.c;this.e++){const m=this.b.charCodeAt(this.e);if(m===47||this.f&&m===92)if(f)this.d++;else break;else f=!1}return this}cmp(f){return this.g?(0,U.compareSubstring)(f,this.b,0,f.length,this.d,this.e):(0,U.compareSubstringIgnoreCase)(f,this.b,0,f.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=N;var R;(function(p){p[p.Scheme=1]="Scheme",p[p.Authority=2]="Authority",p[p.Path=3]="Path",p[p.Query=4]="Query",p[p.Fragment=5]="Fragment"})(R||(R={}));class I{constructor(f,m){this.f=f,this.g=m,this.d=[],this.e=0}reset(f){return this.c=f,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new N(!1,!this.f(f)),this.b.reset(f.path),this.b.value()&&this.d.push(3)),this.g(f)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(f){if(this.d[this.e]===1)return(0,U.compareIgnoreCase)(f,this.c.scheme);if(this.d[this.e]===2)return(0,U.compareIgnoreCase)(f,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(f);if(this.d[this.e]===4)return(0,U.compare)(f,this.c.query);if(this.d[this.e]===5)return(0,U.compare)(f,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=I;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const f=this.right;return this.right=f.left,f.left=this,this.updateHeight(),f.updateHeight(),f}rotateRight(){const f=this.left;return this.left=f.right,f.right=this,this.updateHeight(),f.updateHeight(),f}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var P;(function(p){p[p.Left=-1]="Left",p[p.Mid=0]="Mid",p[p.Right=1]="Right"})(P||(P={}));class S{static forUris(f=()=>!1,m=()=>!1){return new S(new I(f,m))}static forPaths(f=!1){return new S(new N(void 0,!f))}static forStrings(){return new S(new l)}static forConfigKeys(){return new S(new T)}constructor(f){this.b=f}clear(){this.c=void 0}fill(f,m){if(m){const E=m.slice(0);(0,O.shuffle)(E);for(const a of E)this.set(a,f)}else{const E=f.slice(0);(0,O.shuffle)(E);for(const a of E)this.set(a[0],a[1])}}set(f,m){const E=this.b.reset(f);let a;this.c||(this.c=new w,this.c.segment=E.value());const u=[];for(a=this.c;;){const d=E.cmp(a.segment);if(d>0)a.left||(a.left=new w,a.left.segment=E.value()),u.push([-1,a]),a=a.left;else if(d<0)a.right||(a.right=new w,a.right.segment=E.value()),u.push([1,a]),a=a.right;else if(E.hasNext())E.next(),a.mid||(a.mid=new w,a.mid.segment=E.value()),u.push([0,a]),a=a.mid;else break}const h=a.value;a.value=m,a.key=f;for(let d=u.length-1;d>=0;d--){const v=u[d][1];v.updateHeight();const L=v.balanceFactor();if(L<-1||L>1){const n=u[d][0],r=u[d+1][0];if(n===1&&r===1)u[d][1]=v.rotateLeft();else if(n===-1&&r===-1)u[d][1]=v.rotateRight();else if(n===1&&r===-1)v.right=u[d+1][1]=u[d+1][1].rotateRight(),u[d][1]=v.rotateLeft();else if(n===-1&&r===1)v.left=u[d+1][1]=u[d+1][1].rotateLeft(),u[d][1]=v.rotateRight();else throw new Error;if(d>0)switch(u[d-1][0]){case-1:u[d-1][1].left=u[d][1];break;case 1:u[d-1][1].right=u[d][1];break;case 0:u[d-1][1].mid=u[d][1];break}else this.c=u[0][1]}}return h}get(f){return this.d(f)?.value}d(f){const m=this.b.reset(f);let E=this.c;for(;E;){const a=m.cmp(E.segment);if(a>0)E=E.left;else if(a<0)E=E.right;else if(m.hasNext())m.next(),E=E.mid;else break}return E}has(f){const m=this.d(f);return!(m?.value===void 0&&m?.mid===void 0)}delete(f){return this.e(f,!1)}deleteSuperstr(f){return this.e(f,!0)}e(f,m){const E=this.b.reset(f),a=[];let u=this.c;for(;u;){const h=E.cmp(u.segment);if(h>0)a.push([-1,u]),u=u.left;else if(h<0)a.push([1,u]),u=u.right;else if(E.hasNext())E.next(),a.push([0,u]),u=u.mid;else break}if(!!u){if(m?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const h=this.f(u.right);if(h.key){const{key:d,value:v,segment:L}=h;this.e(h.key,!1),u.key=d,u.value=v,u.segment=L}}else{const h=u.left??u.right;if(a.length>0){const[d,v]=a[a.length-1];switch(d){case-1:v.left=h;break;case 0:v.mid=h;break;case 1:v.right=h;break}}else this.c=h}for(let h=a.length-1;h>=0;h--){const d=a[h][1];d.updateHeight();const v=d.balanceFactor();if(v>1?(d.right.balanceFactor()>=0||(d.right=d.right.rotateRight()),a[h][1]=d.rotateLeft()):v<-1&&(d.left.balanceFactor()<=0||(d.left=d.left.rotateLeft()),a[h][1]=d.rotateRight()),h>0)switch(a[h-1][0]){case-1:a[h-1][1].left=a[h][1];break;case 1:a[h-1][1].right=a[h][1];break;case 0:a[h-1][1].mid=a[h][1];break}else this.c=a[0][1]}}}f(f){for(;f.left;)f=f.left;return f}findSubstr(f){const m=this.b.reset(f);let E=this.c,a;for(;E;){const u=m.cmp(E.segment);if(u>0)E=E.left;else if(u<0)E=E.right;else if(m.hasNext())m.next(),a=E.value||a,E=E.mid;else break}return E&&E.value||a}findSuperstr(f){return this.g(f,!1)}g(f,m){const E=this.b.reset(f);let a=this.c;for(;a;){const u=E.cmp(a.segment);if(u>0)a=a.left;else if(u<0)a=a.right;else if(E.hasNext())E.next(),a=a.mid;else return a.mid?this.h(a.mid):m?a.value:void 0}}hasElementOrSubtree(f){return this.g(f,!0)!==void 0}forEach(f){for(const[m,E]of this)f(E,m)}*[Symbol.iterator](){yield*this.h(this.c)}h(f){const m=[];return this.j(f,m),m[Symbol.iterator]()}j(f,m){!f||(f.left&&this.j(f.left,m),f.value&&m.push([f.key,f.value]),f.mid&&this.j(f.mid,m),f.right&&this.j(f.right,m))}_isBalanced(){const f=m=>{if(!m)return!0;const E=m.balanceFactor();return E<-1||E>1?!1:f(m.left)&&f(m.right)};return f(this.c)}}e.TernarySearchTree=S}),define(re[11],oe([0,1,13,4]),function(te,e,O,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const l=/^\w[\w\d+.-]*$/,T=/^\//,N=/^\/\//;function R(t,i){if(!t.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${t.authority}", path: "${t.path}", query: "${t.query}", fragment: "${t.fragment}"}`);if(t.scheme&&!l.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path){if(t.authority){if(!T.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(N.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function I(t,i){return!t&&!i?"file":t}function w(t,i){switch(t){case"https":case"http":case"file":i?i[0]!==S&&(i=S+i):i=S;break}return i}const P="",S="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{static isUri(i){return i instanceof f?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}constructor(i,s,o,c,y,b=!1){typeof i=="object"?(this.scheme=i.scheme||P,this.authority=i.authority||P,this.path=i.path||P,this.query=i.query||P,this.fragment=i.fragment||P):(this.scheme=I(i,b),this.authority=s||P,this.path=w(this.scheme,o||P),this.query=c||P,this.fragment=y||P,R(this,b))}get fsPath(){return d(this,!1)}with(i){if(!i)return this;let{scheme:s,authority:o,path:c,query:y,fragment:b}=i;return s===void 0?s=this.scheme:s===null&&(s=P),o===void 0?o=this.authority:o===null&&(o=P),c===void 0?c=this.path:c===null&&(c=P),y===void 0?y=this.query:y===null&&(y=P),b===void 0?b=this.fragment:b===null&&(b=P),s===this.scheme&&o===this.authority&&c===this.path&&y===this.query&&b===this.fragment?this:new E(s,o,c,y,b)}static parse(i,s=!1){const o=p.exec(i);return o?new E(o[2]||P,r(o[4]||P),r(o[5]||P),r(o[7]||P),r(o[9]||P),s):new E(P,P,P,P,P)}static file(i){let s=P;if(U.isWindows&&(i=i.replace(/\\/g,S)),i[0]===S&&i[1]===S){const o=i.indexOf(S,2);o===-1?(s=i.substring(2),i=S):(s=i.substring(2,o),i=i.substring(o)||S)}return new E("file",s,i,P,P)}static from(i){const s=new E(i.scheme,i.authority,i.path,i.query,i.fragment);return R(s,!0),s}static joinPath(i,...s){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let o;return U.isWindows&&i.scheme==="file"?o=f.file(O.win32.join(d(i,!0),...s)).path:o=O.posix.join(i.path,...s),i.with({path:o})}toString(i=!1){return v(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof f)return i;{const s=new E(i);return s._formatted=i.external,s._fsPath=i._sep===m?i.fsPath:null,s}}else return i}}e.URI=f;const m=U.isWindows?1:void 0;class E extends f{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(i=!1){return i?v(this,!0):(this._formatted||(this._formatted=v(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=m),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const a={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function u(t,i,s){let o,c=-1;for(let y=0;y<t.length;y++){const b=t.charCodeAt(y);if(b>=97&&b<=122||b>=65&&b<=90||b>=48&&b<=57||b===45||b===46||b===95||b===126||i&&b===47||s&&b===91||s&&b===93||s&&b===58)c!==-1&&(o+=encodeURIComponent(t.substring(c,y)),c=-1),o!==void 0&&(o+=t.charAt(y));else{o===void 0&&(o=t.substr(0,y));const g=a[b];g!==void 0?(c!==-1&&(o+=encodeURIComponent(t.substring(c,y)),c=-1),o+=g):c===-1&&(c=y)}}return c!==-1&&(o+=encodeURIComponent(t.substring(c))),o!==void 0?o:t}function h(t){let i;for(let s=0;s<t.length;s++){const o=t.charCodeAt(s);o===35||o===63?(i===void 0&&(i=t.substr(0,s)),i+=a[o]):i!==void 0&&(i+=t[s])}return i!==void 0?i:t}function d(t,i){let s;return t.authority&&t.path.length>1&&t.scheme==="file"?s=`//${t.authority}${t.path}`:t.path.charCodeAt(0)===47&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&t.path.charCodeAt(2)===58?i?s=t.path.substr(1):s=t.path[1].toLowerCase()+t.path.substr(2):s=t.path,U.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=d;function v(t,i){const s=i?h:u;let o="",{scheme:c,authority:y,path:b,query:g,fragment:D}=t;if(c&&(o+=c,o+=":"),(y||c==="file")&&(o+=S,o+=S),y){let A=y.indexOf("@");if(A!==-1){const F=y.substr(0,A);y=y.substr(A+1),A=F.lastIndexOf(":"),A===-1?o+=s(F,!1,!1):(o+=s(F.substr(0,A),!1,!1),o+=":",o+=s(F.substr(A+1),!1,!0)),o+="@"}y=y.toLowerCase(),A=y.lastIndexOf(":"),A===-1?o+=s(y,!1,!0):(o+=s(y.substr(0,A),!1,!0),o+=y.substr(A))}if(b){if(b.length>=3&&b.charCodeAt(0)===47&&b.charCodeAt(2)===58){const A=b.charCodeAt(1);A>=65&&A<=90&&(b=`/${String.fromCharCode(A+32)}:${b.substr(3)}`)}else if(b.length>=2&&b.charCodeAt(1)===58){const A=b.charCodeAt(0);A>=65&&A<=90&&(b=`${String.fromCharCode(A+32)}:${b.substr(2)}`)}o+=s(b,!0,!1)}return g&&(o+="?",o+=s(g,!1,!1)),D&&(o+="#",o+=i?D:u(D,!1,!1)),o}function L(t){try{return decodeURIComponent(t)}catch{return t.length>3?t.substr(0,3)+L(t.substr(3)):t}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(t){return t.match(n)?t.replace(n,i=>L(i)):t}}),define(re[144],oe([0,1,11]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function U(w){const P=w;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.isRemoteConsoleLog=U;function l(w){const P=[];let S;try{const p=JSON.parse(w.arguments),f=p[p.length-1];f&&f.__$stack&&(p.pop(),S=f.__$stack),P.push(...p)}catch{P.push("Unable to log remote console arguments",w.arguments)}return{args:P,stack:S}}e.parse=l;function T(w){if(typeof w!="string")return T(l(w).stack);const P=w;if(P){const S=N(P),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(S||"");if(p&&p.length===4)return{uri:O.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}e.getFirstFrame=T;function N(w){if(!w)return w;const P=w.indexOf(`
`);return P===-1?w:w.substring(0,P)}function R(w,P){const{args:S,stack:p}=l(w),f=typeof S[0]=="string"&&S.length===1;let m=N(p);m&&(m=`(${m.trim()})`);let E=[];if(typeof S[0]=="string"?m&&f?E=[`%c[${P}] %c${S[0]} %c${m}`,I("blue"),I(""),I("grey")]:E=[`%c[${P}] %c${S[0]}`,I("blue"),I(""),...S.slice(1)]:E=[`%c[${P}]%`,I("blue"),...S],m&&!f&&E.push(m),typeof console[w.severity]!="function")throw new Error("Unknown console method");console[w.severity].apply(console,E)}e.log=R;function I(w){return`color: ${w}`}}),define(re[92],oe([0,1,16,27,11]),function(te,e,O,U,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function T(w){return JSON.stringify(w,R)}e.stringify=T;function N(w){let P=JSON.parse(w);return P=I(P),P}e.parse=N;function R(w,P){return P instanceof RegExp?{$mid:2,source:P.source,flags:(0,U.regExpFlags)(P)}:P}function I(w,P=0){if(!w||P>200)return w;if(typeof w=="object"){switch(w.$mid){case 1:return l.URI.revive(w);case 2:return new RegExp(w.source,w.flags);case 16:return new Date(w.source)}if(w instanceof O.VSBuffer||w instanceof Uint8Array)return w;if(Array.isArray(w))for(let S=0;S<w.length;++S)w[S]=I(w[S],P+1);else for(const S in w)Object.hasOwnProperty.call(w,S)&&(w[S]=I(w[S],P+1))}return w}e.revive=I}),define(re[22],oe([0,1,10,4,11]),function(te,e,O,U,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var T;(function(w){w.inMemory="inmemory",w.vscode="vscode",w.internal="private",w.walkThrough="walkThrough",w.walkThroughSnippet="walkThroughSnippet",w.http="http",w.https="https",w.file="file",w.mailto="mailto",w.untitled="untitled",w.data="data",w.command="command",w.vscodeRemote="vscode-remote",w.vscodeRemoteResource="vscode-remote-resource",w.vscodeUserData="vscode-userdata",w.vscodeCustomEditor="vscode-custom-editor",w.vscodeNotebookCell="vscode-notebook-cell",w.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",w.vscodeNotebookCellOutput="vscode-notebook-cell-output",w.vscodeInteractive="vscode-interactive",w.vscodeInteractiveInput="vscode-interactive-input",w.vscodeSettings="vscode-settings",w.vscodeWorkspaceTrust="vscode-workspace-trust",w.vscodeTerminal="vscode-terminal",w.webviewPanel="webview-panel",w.vscodeWebview="vscode-webview",w.extension="extension",w.vscodeFileResource="vscode-file",w.tmp="tmp",w.vsls="vsls",w.vscodeSourceControl="vscode-scm"})(T=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class N{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${T.vscodeRemoteResource}`}setPreferredWebSchema(P){this.d=P}setDelegate(P){this.e=P}setServerRootPath(P){this.f=`${P}/${T.vscodeRemoteResource}`}set(P,S,p){this.a[P]=S,this.b[P]=p}setConnectionToken(P,S){this.c[P]=S}getPreferredWebSchema(){return this.d}rewrite(P){if(this.e)try{return this.e(P)}catch(a){return O.onUnexpectedError(a),P}const S=P.authority;let p=this.a[S];p&&p.indexOf(":")!==-1&&p.indexOf("[")===-1&&(p=`[${p}]`);const f=this.b[S],m=this.c[S];let E=`path=${encodeURIComponent(P.path)}`;return typeof m=="string"&&(E+=`&${e.connectionTokenQueryName}=${encodeURIComponent(m)}`),l.URI.from({scheme:U.isWeb?this.d:T.vscodeRemoteResource,authority:`${p}:${f}`,path:this.f,query:E})}}e.RemoteAuthorities=new N,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class R{asBrowserUri(P){const S=this.b(P,te);return this.uriToBrowserUri(S)}uriToBrowserUri(P){return P.scheme===T.vscodeRemote?e.RemoteAuthorities.rewrite(P):P.scheme===T.file&&(U.isNative||U.isWebWorker&&U.globals.origin===`${T.vscodeFileResource}://${R.a}`)?P.with({scheme:T.vscodeFileResource,authority:P.authority||R.a,query:null,fragment:null}):P}asFileUri(P){const S=this.b(P,te);return this.uriToFileUri(S)}uriToFileUri(P){return P.scheme===T.vscodeFileResource?P.with({scheme:T.file,authority:P.authority!==R.a?P.authority:null,query:null,fragment:null}):P}b(P,S){return l.URI.isUri(P)?P:l.URI.parse(S.toUrl(P))}}R.a="vscode-app",e.FileAccess=new R;var I;(function(w){const P=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);w.CoopAndCoep=Object.freeze(P.get("3"));const S="vscode-coi";function p(m){let E;typeof m=="string"?E=new URL(m).searchParams:m instanceof URL?E=m.searchParams:l.URI.isUri(m)&&(E=new URL(m.toString(!0)).searchParams);const a=E?.get(S);if(!!a)return P.get(a)}w.getHeadersFromQuery=p;function f(m,E,a){if(!globalThis.crossOriginIsolated)return;const u=E&&a?"3":a?"2":"1";m instanceof URLSearchParams?m.set(S,u):m[S]=u}w.addSearchParam=f})(I=e.COI||(e.COI={}))}),define(re[23],oe([0,1,48,22,13,4,27,11]),function(te,e,O,U,l,T,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function I(f){return(0,R.uriToFsPath)(f,!0)}e.originalFSPath=I;class w{constructor(m){this.a=m}compare(m,E,a=!1){return m===E?0:(0,N.compare)(this.getComparisonKey(m,a),this.getComparisonKey(E,a))}isEqual(m,E,a=!1){return m===E?!0:!m||!E?!1:this.getComparisonKey(m,a)===this.getComparisonKey(E,a)}getComparisonKey(m,E=!1){return m.with({path:this.a(m)?m.path.toLowerCase():void 0,fragment:E?null:void 0}).toString()}ignorePathCasing(m){return this.a(m)}isEqualOrParent(m,E,a=!1){if(m.scheme===E.scheme){if(m.scheme===U.Schemas.file)return O.isEqualOrParent(I(m),I(E),this.a(m))&&m.query===E.query&&(a||m.fragment===E.fragment);if((0,e.isEqualAuthority)(m.authority,E.authority))return O.isEqualOrParent(m.path,E.path,this.a(m),"/")&&m.query===E.query&&(a||m.fragment===E.fragment)}return!1}joinPath(m,...E){return R.URI.joinPath(m,...E)}basenameOrAuthority(m){return(0,e.basename)(m)||m.authority}basename(m){return l.posix.basename(m.path)}extname(m){return l.posix.extname(m.path)}dirname(m){if(m.path.length===0)return m;let E;return m.scheme===U.Schemas.file?E=R.URI.file(l.dirname(I(m))).path:(E=l.posix.dirname(m.path),m.authority&&E.length&&E.charCodeAt(0)!==47&&(console.error(`dirname("${m.toString})) resulted in a relative path`),E="/")),m.with({path:E})}normalizePath(m){if(!m.path.length)return m;let E;return m.scheme===U.Schemas.file?E=R.URI.file(l.normalize(I(m))).path:E=l.posix.normalize(m.path),m.with({path:E})}relativePath(m,E){if(m.scheme!==E.scheme||!(0,e.isEqualAuthority)(m.authority,E.authority))return;if(m.scheme===U.Schemas.file){const h=l.relative(I(m),I(E));return T.isWindows?O.toSlashes(h):h}let a=m.path||"/";const u=E.path||"/";if(this.a(m)){let h=0;for(const d=Math.min(a.length,u.length);h<d&&!(a.charCodeAt(h)!==u.charCodeAt(h)&&a.charAt(h).toLowerCase()!==u.charAt(h).toLowerCase());h++);a=u.substr(0,h)+a.substr(h)}return l.posix.relative(a,u)}resolvePath(m,E){if(m.scheme===U.Schemas.file){const a=R.URI.file(l.resolve(I(m),E));return m.with({authority:a.authority,path:a.path})}return E=O.toPosixPath(E),m.with({path:l.posix.resolve(m.path,E)})}isAbsolutePath(m){return!!m.path&&m.path[0]==="/"}isEqualAuthority(m,E){return m===E||m!==void 0&&E!==void 0&&(0,N.equalsIgnoreCase)(m,E)}hasTrailingPathSeparator(m,E=l.sep){if(m.scheme===U.Schemas.file){const a=I(m);return a.length>O.getRoot(a).length&&a[a.length-1]===E}else{const a=m.path;return a.length>1&&a.charCodeAt(a.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(m.fsPath)}}removeTrailingPathSeparator(m,E=l.sep){return(0,e.hasTrailingPathSeparator)(m,E)?m.with({path:m.path.substr(0,m.path.length-1)}):m}addTrailingPathSeparator(m,E=l.sep){let a=!1;if(m.scheme===U.Schemas.file){const u=I(m);a=u!==void 0&&u.length===O.getRoot(u).length&&u[u.length-1]===E}else{E="/";const u=m.path;a=u.length===1&&u.charCodeAt(u.length-1)===47}return!a&&!(0,e.hasTrailingPathSeparator)(m,E)?m.with({path:m.path+"/"}):m}}e.ExtUri=w,e.extUri=new w(()=>!1),e.extUriBiasedIgnorePathCase=new w(f=>f.scheme===U.Schemas.file?!T.isLinux:!0),e.extUriIgnorePathCase=new w(f=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function P(f,m){const E=[];for(let a=0;a<f.length;a++){const u=m(f[a]);f.some((h,d)=>d===a?!1:(0,e.isEqualOrParent)(u,m(h)))||E.push(f[a])}return E}e.distinctParents=P;var S;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function m(E){const a=new Map;E.path.substring(E.path.indexOf(";")+1,E.path.lastIndexOf(";")).split(";").forEach(d=>{const[v,L]=d.split(":");v&&L&&a.set(v,L)});const h=E.path.substring(0,E.path.indexOf(";"));return h&&a.set(f.META_DATA_MIME,h),a}f.parseMetaData=m})(S=e.DataUri||(e.DataUri={}));function p(f,m,E){if(m){let a=f.path;return a&&a[0]!==l.posix.sep&&(a=l.posix.sep+a),f.with({scheme:E,authority:m,path:a})}return f.with({scheme:E})}e.toLocalResource=p}),define(re[6],oe([0,1,25,10,3,2,23,4,133]),function(te,e,O,U,l,T,N,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function w(q){return!!q&&typeof q.then=="function"}e.isThenable=w;function P(q){const C=new O.CancellationTokenSource,k=q(C.token),M=new Promise((z,_)=>{const W=C.token.onCancellationRequested(()=>{W.dispose(),C.dispose(),_(new U.CancellationError)});Promise.resolve(k).then(Q=>{W.dispose(),C.dispose(),z(Q)},Q=>{W.dispose(),C.dispose(),_(Q)})});return new class{cancel(){C.cancel()}then(z,_){return M.then(z,_)}catch(z){return this.then(void 0,z)}finally(z){return M.finally(z)}}}e.createCancelablePromise=P;function S(q,C,k){return new Promise((M,z)=>{const _=C.onCancellationRequested(()=>{_.dispose(),M(k)});q.then(M,z).finally(()=>_.dispose())})}e.raceCancellation=S;function p(q,C){return new Promise((k,M)=>{const z=C.onCancellationRequested(()=>{z.dispose(),M(new U.CancellationError)});q.then(k,M).finally(()=>z.dispose())})}e.raceCancellationError=p;async function f(q){let C=-1;const k=q.map((z,_)=>z.then(W=>(C=_,W))),M=await Promise.race(k);return q.forEach((z,_)=>{_!==C&&z.cancel()}),M}e.raceCancellablePromises=f;function m(q,C,k){let M;const z=setTimeout(()=>{M?.(void 0),k?.()},C);return Promise.race([q.finally(()=>clearTimeout(z)),new Promise(_=>M=_)])}e.raceTimeout=m;function E(q){return new Promise((C,k)=>{const M=q();w(M)?M.then(C,k):C(M)})}e.asPromise=E;class a{constructor(){this.a=null,this.b=null,this.d=null}queue(C){if(this.a){if(this.d=C,!this.b){const k=()=>{this.b=null;const M=this.queue(this.d);return this.d=null,M};this.b=new Promise(M=>{this.a.then(k,k).then(M)})}return new Promise((k,M)=>{this.b.then(k,M)})}return this.a=C(),new Promise((k,M)=>{this.a.then(z=>{this.a=null,k(z)},z=>{this.a=null,M(z)})})}}e.Throttler=a;class u{constructor(){this.a=Promise.resolve(null)}queue(C){return this.a=this.a.then(()=>C(),()=>C())}}e.Sequencer=u;class h{constructor(){this.a=new Map}queue(C,k){const z=(this.a.get(C)??Promise.resolve()).catch(()=>{}).then(k).finally(()=>{this.a.get(C)===z&&this.a.delete(C)});return this.a.set(C,z),z}}e.SequencerByKey=h;const d=(q,C)=>{let k=!0;const M=setTimeout(()=>{k=!1,C()},q);return{isTriggered:()=>k,dispose:()=>{clearTimeout(M),k=!1}}},v=q=>{let C=!0;return queueMicrotask(()=>{C&&(C=!1,q())}),{isTriggered:()=>C,dispose:()=>{C=!1}}};class L{constructor(C){this.defaultDelay=C,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(C,k=this.defaultDelay){this.g=C,this.h(),this.b||(this.b=new Promise((z,_)=>{this.d=z,this.f=_}).then(()=>{if(this.b=null,this.d=null,this.g){const z=this.g;return this.g=null,z()}}));const M=()=>{this.a=null,this.d?.(null)};return this.a=k===I.MicrotaskDelay?v(M):d(k,M),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new U.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=L;class n{constructor(C){this.a=new L(C),this.b=new a}trigger(C,k){return this.a.trigger(()=>this.b.queue(C),k)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=n;class r{constructor(){this.a=!1,this.b=new Promise((C,k)=>{this.d=C})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=r;class t extends r{constructor(C){super(),this.f=setTimeout(()=>this.open(),C)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=t;function i(q,C){return C?new Promise((k,M)=>{const z=setTimeout(()=>{_.dispose(),k()},q),_=C.onCancellationRequested(()=>{clearTimeout(z),_.dispose(),M(new U.CancellationError)})}):P(k=>i(q,k))}e.timeout=i;function s(q,C=0){const k=setTimeout(q,C);return(0,T.toDisposable)(()=>clearTimeout(k))}e.disposableTimeout=s;function o(q){const C=[];let k=0;const M=q.length;function z(){return k<M?q[k++]():null}function _(W){W!=null&&C.push(W);const Q=z();return Q?Q.then(_):Promise.resolve(C)}return Promise.resolve(null).then(_)}e.sequence=o;function c(q,C=M=>!!M,k=null){let M=0;const z=q.length,_=()=>{if(M>=z)return Promise.resolve(k);const W=q[M++];return Promise.resolve(W()).then(ee=>C(ee)?Promise.resolve(ee):_())};return _()}e.first=c;function y(q,C=M=>!!M,k=null){if(q.length===0)return Promise.resolve(k);let M=q.length;const z=()=>{M=-1;for(const _ of q)_.cancel?.()};return new Promise((_,W)=>{for(const Q of q)Q.then(ee=>{--M>=0&&C(ee)?(z(),_(ee)):M===0&&_(k)}).catch(ee=>{--M>=0&&(z(),W(ee))})})}e.firstParallel=y;class b{constructor(C){this.a=0,this.d=C,this.f=[],this.b=0,this.g=new l.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(C){return this.a++,new Promise((k,M)=>{this.f.push({factory:C,c:k,e:M}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const C=this.f.shift();this.b++;const k=C.factory();k.then(C.c,C.e),k.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=b;class g extends b{constructor(){super(1)}}e.Queue=g;class D{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const C=new H;return this.b.add(C),C.p}d(){for(const[,C]of this.a)if(C.size>0)return!1;return!0}queueFor(C,k=N.extUri){const M=k.getComparisonKey(C);let z=this.a.get(M);return z||(z=new g,l.Event.once(z.onDrained)(()=>{z?.dispose(),this.a.delete(M),this.f()}),this.a.set(M,z)),z}f(){!this.d()||this.g()}g(){for(const C of this.b)C.complete();this.b.clear()}dispose(){for(const[,C]of this.a)C.dispose();this.a.clear(),this.g()}}e.ResourceQueue=D;class A{constructor(C,k){this.a=-1,typeof C=="function"&&typeof k=="number"&&this.setIfNotSet(C,k)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(C,k){this.cancel(),this.a=setTimeout(()=>{this.a=-1,C()},k)}setIfNotSet(C,k){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,C()},k))}}e.TimeoutTimer=A;class F{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(C,k){this.cancel(),this.a=setInterval(()=>{C()},k)}}e.IntervalTimer=F;class j{constructor(C,k){this.b=-1,this.a=C,this.d=k,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(C=this.d){this.cancel(),this.b=setTimeout(this.f,C)}get delay(){return this.d}set delay(C){this.d=C}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=j;class x{constructor(C,k){k%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${k}ms is not a multiple of 1000ms.`),this.a=C,this.b=k,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(C=this.b){C%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${C}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(C/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=x;class V extends j{constructor(C,k){super(C,k),this.j=[]}work(C){this.j.push(C),this.isScheduled()||this.schedule()}h(){const C=this.j;this.j=[],this.a?.(C)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=V;class B extends T.Disposable{constructor(C,k){super(),this.g=C,this.h=k,this.a=[],this.b=this.D(new T.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(C){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+C.length>this.g.maxBufferedWork)return!1}else if(this.pending+C.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const k of C)this.a.push(k);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new j(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=B,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=q=>{(0,R.setTimeout0)(()=>{if(C)return;const k=Date.now()+15;q(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,k-Date.now())}}))});let C=!1;return{dispose(){C||(C=!0)}}}:e.runWhenIdle=(q,C)=>{const k=requestIdleCallback(q,typeof C=="number"?{timeout:C}:void 0);let M=!1;return{dispose(){M||(M=!0,cancelIdleCallback(k))}}}}();class Z{constructor(C){this.d=!1,this.a=()=>{try{this.f=C()}catch(k){this.g=k}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=Z;async function J(q,C,k){let M;for(let z=0;z<k;z++)try{return await q()}catch(_){M=_,await i(C)}throw M}e.retry=J;class K{hasPending(C){return this.a?typeof C=="number"?this.a.taskId===C:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(C,k,M){return this.a={taskId:C,cancel:()=>M?.(),promise:k},k.then(()=>this.d(C),()=>this.d(C)),k}d(C){this.a&&C===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const C=this.b;this.b=void 0,C.run().then(C.promiseResolve,C.promiseReject)}}setNext(C){if(this.b)this.b.run=C;else{let k,M;const z=new Promise((_,W)=>{k=_,M=W});this.b={run:C,promise:z,promiseResolve:k,promiseReject:M}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=K;class Y{constructor(C,k=()=>Date.now()){this.d=C,this.f=k,this.a=0,this.b=0}increment(){const C=this.f();return C-this.a>this.d&&(this.a=C,this.b=0),this.b++,this.b}}e.IntervalCounter=Y;class H{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((C,k)=>{this.a=C,this.b=k})}complete(C){return new Promise(k=>{this.a(C),this.f=!0,k()})}error(C){return new Promise(k=>{this.b(C),this.d=!0,k()})}cancel(){new Promise(C=>{this.b(new U.CancellationError),this.d=!0,C()})}}e.DeferredPromise=H;var $;(function(q){async function C(M){let z;const _=await Promise.all(M.map(W=>W.then(Q=>Q,Q=>{z||(z=Q)})));if(typeof z<"u")throw z;return _}q.settled=C;function k(M){return new Promise(async(z,_)=>{try{await M(z,_)}catch(W){_(W)}})}q.withAsyncBody=k})($=e.Promises||(e.Promises={}));var X;(function(q){q[q.Initial=0]="Initial",q[q.DoneOK=1]="DoneOK",q[q.DoneError=2]="DoneError"})(X||(X={}));class ie{static fromArray(C){return new ie(k=>{k.emitMany(C)})}static fromPromise(C){return new ie(async k=>{k.emitMany(await C)})}static fromPromises(C){return new ie(async k=>{await Promise.all(C.map(async M=>k.emitOne(await M)))})}static merge(C){return new ie(async k=>{await Promise.all(C.map(async M=>{for await(const z of M)k.emitOne(z)}))})}constructor(C){this.a=0,this.b=[],this.d=null,this.f=new l.Emitter,queueMicrotask(async()=>{const k={emitOne:M=>this.g(M),emitMany:M=>this.h(M),reject:M=>this.k(M)};try{await Promise.resolve(C(k)),this.j()}catch(M){this.k(M)}finally{k.emitOne=void 0,k.emitMany=void 0,k.reject=void 0}})}[Symbol.asyncIterator](){let C=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(C<this.b.length)return{done:!1,value:this.b[C++]};if(this.a===1)return{done:!0,value:void 0};await l.Event.toPromise(this.f.event)}while(!0)}}}static map(C,k){return new ie(async M=>{for await(const z of C)M.emitOne(k(z))})}map(C){return ie.map(this,C)}static filter(C,k){return new ie(async M=>{for await(const z of C)k(z)&&M.emitOne(z)})}filter(C){return ie.filter(this,C)}static coalesce(C){return ie.filter(C,k=>!!k)}coalesce(){return ie.coalesce(this)}static async toPromise(C){const k=[];for await(const M of C)k.push(M);return k}toPromise(){return ie.toPromise(this)}g(C){this.a===0&&(this.b.push(C),this.f.fire())}h(C){this.a===0&&(this.b=this.b.concat(C),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(C){this.a===0&&(this.a=2,this.d=C,this.f.fire())}}ie.EMPTY=ie.fromArray([]),e.AsyncIterableObject=ie;class se extends ie{constructor(C,k){super(k),this.l=C}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=se;function ae(q){const C=new O.CancellationTokenSource,k=q(C.token);return new se(C,async M=>{const z=C.token.onCancellationRequested(()=>{z.dispose(),C.dispose(),M.reject(new U.CancellationError)});try{for await(const _ of k){if(C.token.isCancellationRequested)return;M.emitOne(_)}z.dispose(),C.dispose()}catch(_){z.dispose(),C.dispose(),M.reject(_)}})}e.createCancelableAsyncIterable=ae}),define(re[93],oe([0,1,21,6,48,37,13,4,27]),function(te,e,O,U,l,T,N,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function w(){return Object.create(null)}e.getEmptyExpression=w,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const P="[/\\\\]",S="[^/\\\\]",p=/\//g;function f(Y,H){switch(Y){case 0:return"";case 1:return`${S}*?`;default:return`(?:${P}|${S}+${P}${H?`|${P}${S}+`:""})*?`}}function m(Y,H){if(!Y)return[];const $=[];let X=!1,ie=!1,se="";for(const ae of Y){switch(ae){case H:if(!X&&!ie){$.push(se),se="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":ie=!0;break;case"]":ie=!1;break}se+=ae}return se&&$.push(se),$}e.splitGlobAware=m;function E(Y){if(!Y)return"";let H="";const $=m(Y,e.GLOB_SPLIT);if($.every(X=>X===e.GLOBSTAR))H=".*";else{let X=!1;$.forEach((ie,se)=>{if(ie===e.GLOBSTAR){if(X)return;H+=f(2,se===$.length-1)}else{let ae=!1,q="",C=!1,k="";for(const M of ie){if(M!=="}"&&ae){q+=M;continue}if(C&&(M!=="]"||!k)){let z;M==="-"?z=M:(M==="^"||M==="!")&&!k?z="^":M===e.GLOB_SPLIT?z="":z=(0,I.escapeRegExpCharacters)(M),k+=z;continue}switch(M){case"{":ae=!0;continue;case"[":C=!0;continue;case"}":{H+=`(?:${m(q,",").map(W=>E(W)).join("|")})`,ae=!1,q="";break}case"]":{H+="["+k+"]",C=!1,k="";break}case"?":H+=S;continue;case"*":H+=f(1);continue;default:H+=(0,I.escapeRegExpCharacters)(M)}}se<$.length-1&&($[se+1]!==e.GLOBSTAR||se+2<$.length)&&(H+=P)}X=ie===e.GLOBSTAR})}return H}const a=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,h=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,d=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,v=/^\*\*((\/[\w\.-]+)+)\/?$/,L=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new T.LRUCache(1e4),r=function(){return!1},t=function(){return null};function i(Y,H){if(!Y)return t;let $;typeof Y!="string"?$=Y.pattern:$=Y,$=$.trim();const X=`${$}_${!!H.trimForExclusions}`;let ie=n.get(X);if(ie)return s(ie,Y);let se;return a.test($)?ie=c($.substr(4),$):(se=u.exec(o($,H)))?ie=y(se[1],$):(H.trimForExclusions?d:h).test($)?ie=b($,H):(se=v.exec(o($,H)))?ie=g(se[1].substr(1),$,!0):(se=L.exec(o($,H)))?ie=g(se[1],$,!1):ie=D($),n.set(X,ie),s(ie,Y)}function s(Y,H){if(typeof H=="string")return Y;const $=function(X,ie){return(0,l.isEqualOrParent)(X,H.base,!R.isLinux)?Y((0,I.ltrim)(X.substr(H.base.length),N.sep),ie):null};return $.allBasenames=Y.allBasenames,$.allPaths=Y.allPaths,$.basenames=Y.basenames,$.patterns=Y.patterns,$}function o(Y,H){return H.trimForExclusions&&Y.endsWith("/**")?Y.substr(0,Y.length-2):Y}function c(Y,H){return function($,X){return typeof $=="string"&&$.endsWith(Y)?H:null}}function y(Y,H){const $=`/${Y}`,X=`\\${Y}`,ie=function(ae,q){return typeof ae!="string"?null:q?q===Y?H:null:ae===Y||ae.endsWith($)||ae.endsWith(X)?H:null},se=[Y];return ie.basenames=se,ie.patterns=[H],ie.allBasenames=se,ie}function b(Y,H){const $=J(Y.slice(1,-1).split(",").map(q=>i(q,H)).filter(q=>q!==t),Y),X=$.length;if(!X)return t;if(X===1)return $[0];const ie=function(q,C){for(let k=0,M=$.length;k<M;k++)if($[k](q,C))return Y;return null},se=$.find(q=>!!q.allBasenames);se&&(ie.allBasenames=se.allBasenames);const ae=$.reduce((q,C)=>C.allPaths?q.concat(C.allPaths):q,[]);return ae.length&&(ie.allPaths=ae),ie}function g(Y,H,$){const X=N.sep===N.posix.sep,ie=X?Y:Y.replace(p,N.sep),se=N.sep+ie,ae=N.posix.sep+Y;let q;return $?q=function(C,k){return typeof C=="string"&&(C===ie||C.endsWith(se)||!X&&(C===Y||C.endsWith(ae)))?H:null}:q=function(C,k){return typeof C=="string"&&(C===ie||!X&&C===Y)?H:null},q.allPaths=[($?"*/":"./")+Y],q}function D(Y){try{const H=new RegExp(`^${E(Y)}$`);return function($){return H.lastIndex=0,typeof $=="string"&&H.test($)?Y:null}}catch{return t}}function A(Y,H,$){return!Y||typeof H!="string"?!1:F(Y)(H,void 0,$)}e.match=A;function F(Y,H={}){if(!Y)return r;if(typeof Y=="string"||j(Y)){const $=i(Y,H);if($===t)return r;const X=function(ie,se){return!!$(ie,se)};return $.allBasenames&&(X.allBasenames=$.allBasenames),$.allPaths&&(X.allPaths=$.allPaths),X}return B(Y,H)}e.parse=F;function j(Y){const H=Y;return H?typeof H.base=="string"&&typeof H.pattern=="string":!1}e.isRelativePattern=j;function x(Y){return Y.allBasenames||[]}e.getBasenameTerms=x;function V(Y){return Y.allPaths||[]}e.getPathTerms=V;function B(Y,H){const $=J(Object.getOwnPropertyNames(Y).map(q=>Z(q,Y[q],H)).filter(q=>q!==t)),X=$.length;if(!X)return t;if(!$.some(q=>!!q.requiresSiblings)){if(X===1)return $[0];const q=function(M,z){let _;for(let W=0,Q=$.length;W<Q;W++){const ee=$[W](M,z);if(typeof ee=="string")return ee;(0,U.isThenable)(ee)&&(_||(_=[]),_.push(ee))}return _?(async()=>{for(const W of _){const Q=await W;if(typeof Q=="string")return Q}return null})():null},C=$.find(M=>!!M.allBasenames);C&&(q.allBasenames=C.allBasenames);const k=$.reduce((M,z)=>z.allPaths?M.concat(z.allPaths):M,[]);return k.length&&(q.allPaths=k),q}const ie=function(q,C,k){let M,z;for(let _=0,W=$.length;_<W;_++){const Q=$[_];Q.requiresSiblings&&k&&(C||(C=(0,N.basename)(q)),M||(M=C.substr(0,C.length-(0,N.extname)(q).length)));const ee=Q(q,C,M,k);if(typeof ee=="string")return ee;(0,U.isThenable)(ee)&&(z||(z=[]),z.push(ee))}return z?(async()=>{for(const _ of z){const W=await _;if(typeof W=="string")return W}return null})():null},se=$.find(q=>!!q.allBasenames);se&&(ie.allBasenames=se.allBasenames);const ae=$.reduce((q,C)=>C.allPaths?q.concat(C.allPaths):q,[]);return ae.length&&(ie.allPaths=ae),ie}function Z(Y,H,$){if(H===!1)return t;const X=i(Y,$);if(X===t)return t;if(typeof H=="boolean")return X;if(H){const ie=H.when;if(typeof ie=="string"){const se=(ae,q,C,k)=>{if(!k||!X(ae,q))return null;const M=ie.replace("$(basename)",()=>C),z=k(M);return(0,U.isThenable)(z)?z.then(_=>_?Y:null):z?Y:null};return se.requiresSiblings=!0,se}}return X}function J(Y,H){const $=Y.filter(q=>!!q.basenames);if($.length<2)return Y;const X=$.reduce((q,C)=>{const k=C.basenames;return k?q.concat(k):q},[]);let ie;if(H){ie=[];for(let q=0,C=X.length;q<C;q++)ie.push(H)}else ie=$.reduce((q,C)=>{const k=C.patterns;return k?q.concat(k):q},[]);const se=function(q,C){if(typeof q!="string")return null;if(!C){let M;for(M=q.length;M>0;M--){const z=q.charCodeAt(M-1);if(z===47||z===92)break}C=q.substr(M)}const k=X.indexOf(C);return k!==-1?ie[k]:null};se.basenames=X,se.patterns=ie,se.allBasenames=X;const ae=Y.filter(q=>!q.basenames);return ae.push(se),ae}function K(Y,H){return(0,O.equals)(Y,H,($,X)=>typeof $=="string"&&typeof X=="string"?$===X:typeof $!="string"&&typeof X!="string"?$.base===X.base&&$.pattern===X.pattern:!1)}e.patternsEquals=K}),define(re[94],oe([0,1,16,11]),function(te,e,O,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function l(S){return S.toJSON()}class T{constructor(p){this.a=p}transformIncoming(p){const f=this.a.transformIncoming(p);return f===p?p:l(U.URI.from(f))}transformOutgoing(p){const f=this.a.transformOutgoing(p);return f===p?p:l(U.URI.from(f))}transformOutgoingURI(p){const f=this.a.transformOutgoing(p);return f===p?p:U.URI.from(f)}transformOutgoingScheme(p){return this.a.transformOutgoingScheme(p)}}e.URITransformer=T,e.DefaultURITransformer=new class{transformIncoming(S){return S}transformOutgoing(S){return S}transformOutgoingURI(S){return S}transformOutgoingScheme(S){return S}};function N(S,p,f){if(!S||f>200)return null;if(typeof S=="object"){if(S instanceof U.URI)return p.transformOutgoing(S);for(const m in S)if(Object.hasOwnProperty.call(S,m)){const E=N(S[m],p,f+1);E!==null&&(S[m]=E)}}return null}function R(S,p){const f=N(S,p,0);return f===null?S:f}e.transformOutgoingURIs=R;function I(S,p,f,m){if(!S||m>200)return null;if(typeof S=="object"){if(S.$mid===1)return f?U.URI.revive(p.transformIncoming(S)):p.transformIncoming(S);if(S instanceof O.VSBuffer)return null;for(const E in S)if(Object.hasOwnProperty.call(S,E)){const a=I(S[E],p,f,m+1);a!==null&&(S[E]=a)}}return null}function w(S,p){const f=I(S,p,!1,0);return f===null?S:f}e.transformIncomingURIs=w;function P(S,p){const f=I(S,p,!0,0);return f===null?S:f}e.transformAndReviveIncomingURIs=P}),define(re[145],oe([0,1,34,10,49,31,135]),function(te,e,O,U,l,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(P){return this.a||(this.a=l.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(P)}value(){if(this.b===void 0){let P=0,S=0;const p=(0,O.networkInterfaces)();for(const f in p){const m=p[f];if(m)for(const{mac:E,internal:a}of m)a||(S+=1,this.c(E.toUpperCase())&&(P+=1))}this.b=S>0?P/S:0}return this.b}};let R;async function I(){return R||(R=(async()=>await w()||T.generateUuid())()),R}e.getMachineId=I;async function w(){try{const P=await new Promise((p,f)=>{te(["crypto"],p,f)}),S=(0,N.getMac)();return P.createHash("sha256").update(S,"utf8").digest("hex")}catch(P){U.onUnexpectedError(P);return}}}),define(re[28],oe([0,1,54,34,291,6,48,87,13,4,23,11]),function(te,e,O,U,l,T,N,R,I,w,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(B){B[B.UNLINK=0]="UNLINK",B[B.MOVE=1]="MOVE"})(p=e.RimRafMode||(e.RimRafMode={}));async function f(B,Z=p.UNLINK){if((0,N.isRootOrDriveLetter)(B))throw new Error("rimraf - will refuse to recursively delete root");return Z===p.UNLINK?E(B):m(B)}async function m(B){try{const Z=(0,N.randomPath)((0,U.tmpdir)());try{await O.promises.rename(B,Z)}catch(J){return J.code==="ENOENT"?void 0:E(B)}E(Z).catch(J=>{})}catch(Z){if(Z.code!=="ENOENT")throw Z}}async function E(B){return(0,l.promisify)(O.rm)(B,{recursive:!0,force:!0,maxRetries:3})}function a(B){if((0,N.isRootOrDriveLetter)(B))throw new Error("rimraf - will refuse to recursively delete root");O.rmSync(B,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=a;async function u(B,Z){return v(await(Z?h(B):(0,l.promisify)(O.readdir)(B)))}async function h(B){try{return await(0,l.promisify)(O.readdir)(B,{withFileTypes:!0})}catch(K){console.warn("[node.js fs] readdir with filetypes failed with error: ",K)}const Z=[],J=await u(B);for(const K of J){let Y=!1,H=!1,$=!1;try{const X=await e.Promises.lstat((0,I.join)(B,K));Y=X.isFile(),H=X.isDirectory(),$=X.isSymbolicLink()}catch(X){console.warn("[node.js fs] unexpected error from lstat after readdir: ",X)}Z.push({name:K,isFile:()=>Y,isDirectory:()=>H,isSymbolicLink:()=>$})}return Z}function d(B){return v(O.readdirSync(B))}e.readdirSync=d;function v(B){return B.map(Z=>typeof Z=="string"?w.isMacintosh?(0,R.normalizeNFC)(Z):Z:(Z.name=w.isMacintosh?(0,R.normalizeNFC)(Z.name):Z.name,Z))}async function L(B){const Z=await u(B),J=[];for(const K of Z)await r.existsDirectory((0,I.join)(B,K))&&J.push(K);return J}function n(B,Z=1e3){return new Promise(J=>{let K=!1;const Y=setInterval(()=>{K||(K=!0,O.access(B,H=>{K=!1,H&&(clearInterval(Y),J(void 0))}))},Z)})}e.whenDeleted=n;var r;(function(B){async function Z(Y){let H;try{if(H=await e.Promises.lstat(Y),!H.isSymbolicLink())return{stat:H}}catch{}try{return{stat:await e.Promises.stat(Y),symbolicLink:H?.isSymbolicLink()?{dangling:!1}:void 0}}catch($){if($.code==="ENOENT"&&H)return{stat:H,symbolicLink:{dangling:!0}};if(w.isWindows&&$.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(Y)),symbolicLink:{dangling:!1}}}catch(X){if(X.code==="ENOENT"&&H)return{stat:H,symbolicLink:{dangling:!0}};throw X}throw $}}B.stat=Z;async function J(Y){try{const{stat:H,symbolicLink:$}=await B.stat(Y);return H.isFile()&&$?.dangling!==!0}catch{}return!1}B.existsFile=J;async function K(Y){try{const{stat:H,symbolicLink:$}=await B.stat(Y);return H.isDirectory()&&$?.dangling!==!0}catch{}return!1}B.existsDirectory=K})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const t=new T.ResourceQueue;function i(B,Z,J){return t.queueFor(S.URI.file(B),P.extUriBiasedIgnorePathCase).queue(()=>{const K=b(J);return new Promise((Y,H)=>c(B,Z,K,$=>$?H($):Y()))})}let s=!0;function o(B){s=B}e.configureFlushOnWrite=o;function c(B,Z,J,K){if(!s)return O.writeFile(B,Z,{mode:J.mode,flag:J.flag},K);O.open(B,J.flag,J.mode,(Y,H)=>{if(Y)return K(Y);O.writeFile(H,Z,$=>{if($)return O.close(H,()=>K($));O.fdatasync(H,X=>(X&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",X),o(!1)),O.close(H,ie=>K(ie))))})})}function y(B,Z,J){const K=b(J);if(!s)return O.writeFileSync(B,Z,{mode:K.mode,flag:K.flag});const Y=O.openSync(B,K.flag,K.mode);try{O.writeFileSync(Y,Z);try{O.fdatasyncSync(Y)}catch(H){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",H),o(!1)}}finally{O.closeSync(Y)}}e.writeFileSync=y;function b(B){return B?{mode:typeof B.mode=="number"?B.mode:438,flag:typeof B.flag=="string"?B.flag:"w"}:{mode:438,flag:"w"}}async function g(B,Z){if(B!==Z)try{await e.Promises.rename(B,Z)}catch(J){if(B.toLowerCase()!==Z.toLowerCase()&&J.code==="EXDEV"||B.endsWith("."))await D(B,Z,{preserveSymlinks:!1}),await f(B,p.MOVE);else throw J}}async function D(B,Z,J){return F(B,Z,{root:{source:B,target:Z},options:J,handledSourcePaths:new Set})}const A=511;async function F(B,Z,J){if(J.handledSourcePaths.has(B))return;J.handledSourcePaths.add(B);const{stat:K,symbolicLink:Y}=await r.stat(B);if(Y){if(J.options.preserveSymlinks)try{return await V(B,Z,J)}catch(H){console.warn("[node.js fs] copy of symlink failed: ",H)}if(Y.dangling)return}return K.isDirectory()?j(B,Z,K.mode&A,J):x(B,Z,K.mode&A)}async function j(B,Z,J,K){await e.Promises.mkdir(Z,{recursive:!0,mode:J});const Y=await u(B);for(const H of Y)await F((0,I.join)(B,H),(0,I.join)(Z,H),K)}async function x(B,Z,J){await e.Promises.copyFile(B,Z),await e.Promises.chmod(Z,J)}async function V(B,Z,J){let K=await e.Promises.readlink(B);(0,N.isEqualOrParent)(K,J.root.source,!w.isLinux)&&(K=(0,I.join)(J.root.target,K.substr(J.root.source.length+1))),await e.Promises.symlink(K,Z)}e.Promises=new class{get access(){return(0,l.promisify)(O.access)}get stat(){return(0,l.promisify)(O.stat)}get lstat(){return(0,l.promisify)(O.lstat)}get utimes(){return(0,l.promisify)(O.utimes)}get read(){return(B,Z,J,K,Y)=>new Promise((H,$)=>{O.read(B,Z,J,K,Y,(X,ie,se)=>X?$(X):H({bytesRead:ie,buffer:se}))})}get readFile(){return(0,l.promisify)(O.readFile)}get write(){return(B,Z,J,K,Y)=>new Promise((H,$)=>{O.write(B,Z,J,K,Y,(X,ie,se)=>X?$(X):H({bytesWritten:ie,buffer:se}))})}get appendFile(){return(0,l.promisify)(O.appendFile)}get fdatasync(){return(0,l.promisify)(O.fdatasync)}get truncate(){return(0,l.promisify)(O.truncate)}get rename(){return(0,l.promisify)(O.rename)}get copyFile(){return(0,l.promisify)(O.copyFile)}get open(){return(0,l.promisify)(O.open)}get close(){return(0,l.promisify)(O.close)}get symlink(){return(0,l.promisify)(O.symlink)}get readlink(){return(0,l.promisify)(O.readlink)}get chmod(){return(0,l.promisify)(O.chmod)}get mkdir(){return(0,l.promisify)(O.mkdir)}get unlink(){return(0,l.promisify)(O.unlink)}get rmdir(){return(0,l.promisify)(O.rmdir)}get realpath(){return(0,l.promisify)(O.realpath)}async exists(B){try{return await e.Promises.access(B),!0}catch{return!1}}get readdir(){return u}get readDirsInDir(){return L}get writeFile(){return i}get rm(){return f}get move(){return g}get copy(){return D}}}),define(re[146],oe([0,1,54,13,4,27,28]),function(te,e,O,U,l,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function R(p){if(l.isLinux)return p;const f=(0,U.dirname)(p);if(p===f)return p;const m=((0,U.basename)(p)||p).toLowerCase();try{const a=(0,N.readdirSync)(f).filter(u=>u.toLowerCase()===m);if(a.length===1){const u=R(f);if(u)return(0,U.join)(u,a[0])}else if(a.length>1){const u=a.indexOf(m);if(u>=0){const h=R(f);if(h)return(0,U.join)(h,a[u])}}}catch{}return null}e.realcaseSync=R;async function I(p){if(l.isLinux)return p;const f=(0,U.dirname)(p);if(p===f)return p;const m=((0,U.basename)(p)||p).toLowerCase();try{const a=(await N.Promises.readdir(f)).filter(u=>u.toLowerCase()===m);if(a.length===1){const u=await I(f);if(u)return(0,U.join)(u,a[0])}else if(a.length>1){const u=a.indexOf(m);if(u>=0){const h=await I(f);if(h)return(0,U.join)(h,a[u])}}}catch{}return null}e.realcase=I;async function w(p){try{return await N.Promises.realpath(p)}catch{const m=S(p);return await N.Promises.access(m,O.constants.R_OK),m}}e.realpath=w;function P(p){try{return O.realpathSync(p)}catch{const m=S(p);return O.accessSync(m,O.constants.R_OK),m}}e.realpathSync=P;function S(p){return(0,T.rtrim)((0,U.normalize)(p),U.sep)}}),define(re[95],oe([0,1,34,13,28]),function(te,e,O,U,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const T=/^\d+$/,N=/^Microsoft.PowerShell_.*/,R=/^Microsoft.PowerShellPreview_.*/;var I;(function(v){v[v.x64=0]="x64",v[v.x86=1]="x86",v[v.ARM=2]="ARM"})(I||(I={}));let w;switch(process.arch){case"ia32":case"x32":w=1;break;case"arm":case"arm64":w=2;break;default:w=0;break}let P;process.env.PROCESSOR_ARCHITEW6432?P=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?P=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?P=1:P=0;class S{constructor(L,n,r){this.exePath=L,this.displayName=n,this.a=r}async exists(){return this.a===void 0&&(this.a=await l.SymlinkSupport.existsFile(this.exePath)),this.a}}function p({useAlternateBitness:v=!1}={}){return v?w===0?process.env["ProgramFiles(x86)"]||null:P===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function f({useAlternateBitness:v=!1,findPreview:L=!1}={}){const n=p({useAlternateBitness:v});if(!n)return null;const r=U.join(n,"PowerShell");if(!await l.SymlinkSupport.existsDirectory(r))return null;let t=-1,i=null;for(const c of await l.Promises.readdir(r)){let y=-1;if(L){const g=c.indexOf("-");if(g<0)continue;const D=c.substring(0,g);if(!T.test(D)||c.substring(g+1)!=="preview")continue;y=parseInt(D,10)}else{if(!T.test(c))continue;y=parseInt(c,10)}if(y<=t)continue;const b=U.join(r,c,"pwsh.exe");!await l.SymlinkSupport.existsFile(b)||(i=b,t=y)}if(!i)return null;const s=n.includes("x86")?" (x86)":"",o=L?" Preview":"";return new S(i,`PowerShell${o}${s}`,!0)}async function m({findPreview:v}={}){if(!process.env.LOCALAPPDATA)return null;const L=U.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await l.SymlinkSupport.existsDirectory(L))return null;const{pwshMsixDirRegex:n,pwshMsixName:r}=v?{pwshMsixDirRegex:R,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:N,pwshMsixName:"PowerShell (Store)"};for(const t of await l.Promises.readdir(L))if(n.test(t)){const i=U.join(L,t,"pwsh.exe");return new S(i,r)}return null}function E(){const v=U.join(O.homedir(),".dotnet","tools","pwsh.exe");return new S(v,".NET Core PowerShell Global Tool")}function a(){const v=U.join(process.env.windir,w===1&&P!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new S(v,"Windows PowerShell",!0)}async function*u(){let v=await f();v&&(yield v),v=await f({useAlternateBitness:!0}),v&&(yield v),v=await m(),v&&(yield v),v=E(),v&&(yield v),v=await f({findPreview:!0}),v&&(yield v),v=await m({findPreview:!0}),v&&(yield v),v=await f({useAlternateBitness:!0,findPreview:!0}),v&&(yield v),v=a(),v&&(yield v)}async function*h(){for await(const v of u())await v.exists()&&(yield v)}e.enumeratePowerShellInstallations=h;async function d(){for await(const v of h())return v;return null}e.getFirstAvailablePowerShellInstallation=d}),define(re[96],oe([0,1,13,4,36,89,12,28]),function(te,e,O,U,l,T,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return T.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return T.TerminateResponseCode}});function I(S=l.env){return S.comspec||"cmd.exe"}e.getWindowsShell=I;function w(S){let p=[],f=!1;const m=function(E){if(f){p.push(E);return}(!S.send(E,u=>{if(u&&console.error(u),f=!1,p.length>0){const h=p.slice(0);p=[],h.forEach(d=>m(d))}})||U.isWindows)&&(f=!0)};return{send:m}}e.createQueuedSender=w;var P;(function(S){async function p(f,m,E){if(O.isAbsolute(f))return f;if(m===void 0&&(m=l.cwd()),O.dirname(f)!=="."||(E===void 0&&N.isString(l.env.PATH)&&(E=l.env.PATH.split(O.delimiter)),E===void 0||E.length===0))return O.join(m,f);async function u(h){if(await R.Promises.exists(h)){let d;try{d=await R.Promises.stat(h)}catch(v){v.message.startsWith("EACCES")&&(d=await R.Promises.lstat(h))}return d?!d.isDirectory():!1}return!1}for(const h of E){let d;if(O.isAbsolute(h)?d=O.join(h,f):d=O.join(m,h,f),await u(d))return d;let v=d+".com";if(await u(v)||(v=d+".exe",await u(v)))return v}return O.join(m,f)}S.findExecutable=p})(P=e.win32||(e.win32={}))}),define(re[147],oe([0,1,50,22]),function(te,e,O,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function l(N){return new Promise((R,I)=>{let w;const P=new Map;function S(f,m,E,a,u){const h=P.get(m);if(f===N||h){const d={name:p(E),cmd:E,pid:f,ppid:m,load:a,mem:u};P.set(f,d),f===N&&(w=d),h&&(h.children||(h.children=[]),h.children.push(d),h.children.length>1&&(h.children=h.children.sort((v,L)=>v.pid-L.pid)))}}function p(f){const m=/--utility-sub-type=network/i,E=/--ms-enable-electron-run-as-node/i,a=/--crashes-directory/i,u=/\\pipe\\winpty-control/i,h=/conhost\.exe/i,d=/--type=([a-zA-Z-]+)/;if(a.exec(f))return"electron-crash-reporter";if(u.exec(f))return"winpty-process";if(h.exec(f))return"console-window-host (Windows internal process)";let v=d.exec(f);if(v&&v.length===2)return v[1]==="renderer"?"window":v[1]==="utility"?m.exec(f)?"utility-network-service":"utility-process":v[1]==="extensionHost"?"extension-host":v[1];const L=/[a-zA-Z-]+\.js/g;let n="";do v=L.exec(f),v&&(n+=v+" ");while(v);return n&&f.indexOf("node ")<0&&f.indexOf("node.exe")<0?`electron-nodejs (${n})`:E.exec(f)?`electron-nodejs (${f})`:f}if(process.platform==="win32"){const f=m=>m.indexOf("\\\\?\\")===0||m.indexOf("\\??\\")===0?m.substr(4):m.indexOf('"\\\\?\\')===0||m.indexOf('"\\??\\')===0?'"'+m.substr(5):m;new Promise((m,E)=>{te(["windows-process-tree"],m,E)}).then(m=>{m.getProcessList(N,E=>{if(!E){I(new Error(`Root process ${N} not found`));return}m.getProcessCpuUsage(E,a=>{const u=new Map;a.forEach(h=>{const d=f(h.commandLine||"");u.set(h.pid,{name:p(d),cmd:d,pid:h.pid,ppid:h.ppid,load:h.cpu||0,mem:h.memory||0})}),w=u.get(N),w?(u.forEach(h=>{const d=u.get(h.ppid);d&&(d.children||(d.children=[]),d.children.push(h))}),u.forEach(h=>{h.children&&(h.children=h.children.sort((d,v)=>d.pid-v.pid))}),R(w)):I(new Error(`Root process ${N} not found`))})},m.ProcessDataFlag.CommandLine|m.ProcessDataFlag.Memory)})}else{let f=function(){let m=[w];const E=[];for(;m.length;){const u=m.shift();u&&(E.push(u.pid),u.children&&(m=m.concat(u.children)))}let a=JSON.stringify(U.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);a+=" "+E.join(" "),(0,O.exec)(a,{},(u,h,d)=>{if(u||d)I(u||new Error(d.toString()));else{const v=h.toString().split(`
`);for(let L=0;L<E.length;L++){const n=P.get(E[L]);n.load=parseFloat(v[L])}if(!w){I(new Error(`Root process ${N} not found`));return}R(w)}})};(0,O.exec)("which ps",{},(m,E,a)=>{if(m||a)if(process.platform!=="linux")I(m||new Error(a.toString()));else{const u=JSON.stringify(U.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,O.exec)(u,{},(h,d,v)=>{h||v?I(h||new Error(v.toString())):(T(d,S),f())})}else{const u=E.toString().trim(),h="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,O.exec)(`${u} ${h}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(d,v,L)=>{d||L&&!L.includes("screen size is bogus")?I(d||new Error(L.toString())):(T(v,S),process.platform==="linux"?f():w?R(w):I(new Error(`Root process ${N} not found`)))})}})}})}e.listProcesses=l;function T(N,R){const I=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,w=N.toString().split(`
`);for(const P of w){const S=I.exec(P.trim());S&&S.length===6&&R(parseInt(S[1]),parseInt(S[2]),S[5],parseFloat(S[3]),parseFloat(S[4]))}}}),define(re[148],oe([0,1,34,4,95,96]),function(te,e,O,U,l,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function N(S,p){return S===1?U.isWindows?P():T.getWindowsShell(p):I(S,p)}e.getSystemShell=N;let R=null;function I(S,p){if(U.isLinux&&S===2||U.isMacintosh&&S===3)return"/bin/bash";if(!R){let f;if(U.isWindows)f="/bin/bash";else{if(f=p.SHELL,!f)try{f=(0,O.userInfo)().shell}catch{}f||(f="sh"),f==="/bin/false"&&(f="/bin/bash")}R=f}return R}let w=null;async function P(){return w||(w=(await(0,l.getFirstAvailablePowerShellInstallation)()).exePath),w}});var ye=this&&this.__decorate||function(te,e,O,U){var l=arguments.length,T=l<3?e:U===null?U=Object.getOwnPropertyDescriptor(e,O):U,N;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(te,e,O,U);else for(var R=te.length-1;R>=0;R--)(N=te[R])&&(T=(l<3?N(T):l>3?N(e,O,T):N(e,O))||T);return l>3&&T&&Object.defineProperty(e,O,T),T};define(re[39],oe([0,1,21,6,16,25,62,10,3,2,92,27,12]),function(te,e,O,U,l,T,N,R,I,w,P,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var f;(function(H){H[H.Promise=100]="Promise",H[H.PromiseCancel=101]="PromiseCancel",H[H.EventListen=102]="EventListen",H[H.EventDispose=103]="EventDispose"})(f||(f={}));function m(H){switch(H){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var E;(function(H){H[H.Initialize=200]="Initialize",H[H.PromiseSuccess=201]="PromiseSuccess",H[H.PromiseError=202]="PromiseError",H[H.PromiseErrorObj=203]="PromiseErrorObj",H[H.EventFire=204]="EventFire"})(E||(E={}));function a(H){switch(H){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(H){H[H.Uninitialized=0]="Uninitialized",H[H.Idle=1]="Idle"})(u||(u={}));function h(H){let $=0;for(let X=0;;X+=7){const ie=H.read(1);if($|=(ie.buffer[0]&127)<<X,!(ie.buffer[0]&128))return $}}const d=t(0);function v(H,$){if($===0){H.write(d);return}let X=0;for(let se=$;se!==0;se=se>>>7)X++;const ie=l.VSBuffer.alloc(X);for(let se=0;$!==0;se++)ie.buffer[se]=$&127,$=$>>>7,$>0&&(ie.buffer[se]|=128);H.write(ie)}class L{constructor($){this.b=$,this.a=0}read($){const X=this.b.slice(this.a,this.a+$);return this.a+=X.byteLength,X}}e.BufferReader=L;class n{constructor(){this.a=[]}get buffer(){return l.VSBuffer.concat(this.a)}write($){this.a.push($)}}e.BufferWriter=n;var r;(function(H){H[H.Undefined=0]="Undefined",H[H.String=1]="String",H[H.Buffer=2]="Buffer",H[H.VSBuffer=3]="VSBuffer",H[H.Array=4]="Array",H[H.Object=5]="Object",H[H.Int=6]="Int"})(r||(r={}));function t(H){const $=l.VSBuffer.alloc(1);return $.writeUInt8(H,0),$}const i={Undefined:t(r.Undefined),String:t(r.String),Buffer:t(r.Buffer),VSBuffer:t(r.VSBuffer),Array:t(r.Array),Object:t(r.Object),Uint:t(r.Int)},s=typeof Buffer<"u";function o(H,$){if(typeof $>"u")H.write(i.Undefined);else if(typeof $=="string"){const X=l.VSBuffer.fromString($);H.write(i.String),v(H,X.byteLength),H.write(X)}else if(s&&Buffer.isBuffer($)){const X=l.VSBuffer.wrap($);H.write(i.Buffer),v(H,X.byteLength),H.write(X)}else if($ instanceof l.VSBuffer)H.write(i.VSBuffer),v(H,$.byteLength),H.write($);else if(Array.isArray($)){H.write(i.Array),v(H,$.length);for(const X of $)o(H,X)}else if(typeof $=="number"&&($|0)===$)H.write(i.Uint),v(H,$);else{const X=l.VSBuffer.fromString(JSON.stringify($));H.write(i.Object),v(H,X.byteLength),H.write(X)}}e.serialize=o;function c(H){switch(H.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return H.read(h(H)).toString();case r.Buffer:return H.read(h(H)).buffer;case r.VSBuffer:return H.read(h(H));case r.Array:{const X=h(H),ie=[];for(let se=0;se<X;se++)ie.push(c(H));return ie}case r.Object:return JSON.parse(H.read(h(H)).toString());case r.Int:return h(H)}}e.deserialize=c;class y{constructor($,X,ie=null,se=1e3){this.h=$,this.j=X,this.k=ie,this.l=se,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ae=>this.q(ae)),this.m({type:200})}registerChannel($,X){this.b.set($,X),setTimeout(()=>this.w($),0)}m($){switch($.type){case 200:{const X=this.o([$.type]);this.k?.logOutgoing(X,0,1,a($.type));return}case 201:case 202:case 204:case 203:{const X=this.o([$.type,$.id],$.data);this.k?.logOutgoing(X,$.id,1,a($.type),$.data);return}}}o($,X=void 0){const ie=new n;return o(ie,$),o(ie,X),this.p(ie.buffer)}p($){try{return this.h.send($),$.byteLength}catch{return 0}}q($){const X=new L($),ie=c(X),se=c(X),ae=ie[0];switch(ae){case 100:return this.k?.logIncoming($.byteLength,ie[1],1,`${m(ae)}: ${ie[2]}.${ie[3]}`,se),this.s({type:ae,id:ie[1],channelName:ie[2],name:ie[3],arg:se});case 102:return this.k?.logIncoming($.byteLength,ie[1],1,`${m(ae)}: ${ie[2]}.${ie[3]}`,se),this.t({type:ae,id:ie[1],channelName:ie[2],name:ie[3],arg:se});case 101:return this.k?.logIncoming($.byteLength,ie[1],1,`${m(ae)}`),this.u({type:ae,id:ie[1]});case 103:return this.k?.logIncoming($.byteLength,ie[1],1,`${m(ae)}`),this.u({type:ae,id:ie[1]})}}s($){const X=this.b.get($.channelName);if(!X){this.v($);return}const ie=new T.CancellationTokenSource;let se;try{se=X.call(this.j,$.name,$.arg,ie.token)}catch(C){se=Promise.reject(C)}const ae=$.id;se.then(C=>{this.m({id:ae,data:C,type:201}),this.d.delete($.id)},C=>{C instanceof Error?this.m({id:ae,data:{message:C.message,name:C.name,stack:C.stack?C.stack.split?C.stack.split(`
`):C.stack:void 0},type:202}):this.m({id:ae,data:C,type:203}),this.d.delete($.id)});const q=(0,w.toDisposable)(()=>ie.cancel());this.d.set($.id,q)}t($){const X=this.b.get($.channelName);if(!X){this.v($);return}const ie=$.id,ae=X.listen(this.j,$.name,$.arg)(q=>this.m({id:ie,data:q,type:204}));this.d.set($.id,ae)}u($){const X=this.d.get($.id);X&&(X.dispose(),this.d.delete($.id))}v($){let X=this.g.get($.channelName);X||(X=[],this.g.set($.channelName,X));const ie=setTimeout(()=>{console.error(`Unknown channel: ${$.channelName}`),$.type===100&&this.m({id:$.id,data:{name:"Unknown channel",message:`Channel name '${$.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);X.push({request:$,timeoutTimer:ie})}w($){const X=this.g.get($);if(X){for(const ie of X)switch(clearTimeout(ie.timeoutTimer),ie.request.type){case 100:this.s(ie.request);break;case 102:this.t(ie.request);break}this.g.delete($)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,w.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=y;var b;(function(H){H[H.LocalSide=0]="LocalSide",H[H.OtherSide=1]="OtherSide"})(b=e.RequestInitiator||(e.RequestInitiator={}));class g{constructor($,X=null){this.l=$,this.a=!1,this.b=u.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new I.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ie=>this.s(ie)),this.j=X}getChannel($){const X=this;return{call(ie,se,ae){return X.a?Promise.reject(new R.CancellationError):X.m($,ie,se,ae)},listen(ie,se){return X.a?I.Event.None:X.o($,ie,se)}}}m($,X,ie,se=T.CancellationToken.None){const ae=this.g++,C={id:ae,type:100,channelName:$,name:X,arg:ie};if(se.isCancellationRequested)return Promise.reject(new R.CancellationError);let k;return new Promise((z,_)=>{if(se.isCancellationRequested)return _(new R.CancellationError);const W=()=>{const he=pe=>{switch(pe.type){case 201:this.f.delete(ae),z(pe.data);break;case 202:{this.f.delete(ae);const de=new Error(pe.data.message);de.stack=Array.isArray(pe.data.stack)?pe.data.stack.join(`
`):pe.data.stack,de.name=pe.data.name,_(de);break}case 203:this.f.delete(ae),_(pe.data);break}};this.f.set(ae,he),this.p(C)};let Q=null;this.b===u.Idle?W():(Q=(0,U.createCancelablePromise)(he=>this.u()),Q.then(()=>{Q=null,W()}));const ee=()=>{Q?(Q.cancel(),Q=null):this.p({id:ae,type:101}),_(new R.CancellationError)},le=se.onCancellationRequested(ee);k=(0,w.combinedDisposable)((0,w.toDisposable)(ee),le),this.d.add(k)}).finally(()=>{this.d.delete(k)})}o($,X,ie){const se=this.g++,q={id:se,type:102,channelName:$,name:X,arg:ie};let C=null;const k=new I.Emitter({onWillAddFirstListener:()=>{C=(0,U.createCancelablePromise)(z=>this.u()),C.then(()=>{C=null,this.d.add(k),this.p(q)})},onDidRemoveLastListener:()=>{C?(C.cancel(),C=null):(this.d.delete(k),this.p({id:se,type:103}))}}),M=z=>k.fire(z.data);return this.f.set(se,M),k.event}p($){switch($.type){case 100:case 102:{const X=this.q([$.type,$.id,$.channelName,$.name],$.arg);this.j?.logOutgoing(X,$.id,0,`${m($.type)}: ${$.channelName}.${$.name}`,$.arg);return}case 101:case 103:{const X=this.q([$.type,$.id]);this.j?.logOutgoing(X,$.id,0,m($.type));return}}}q($,X=void 0){const ie=new n;return o(ie,$),o(ie,X),this.r(ie.buffer)}r($){try{return this.l.send($),$.byteLength}catch{return 0}}s($){const X=new L($),ie=c(X),se=c(X),ae=ie[0];switch(ae){case 200:return this.j?.logIncoming($.byteLength,0,0,a(ae)),this.t({type:ie[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming($.byteLength,ie[1],0,a(ae),se),this.t({type:ie[0],id:ie[1],data:se})}}t($){if($.type===200){this.b=u.Idle,this.k.fire();return}this.f.get($.id)?.($)}get onDidInitializePromise(){return I.Event.toPromise(this.onDidInitialize)}u(){return this.b===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,w.dispose)(this.d.values()),this.d.clear()}}ye([N.memoize],g.prototype,"onDidInitializePromise",null),e.ChannelClient=g;class D{get connections(){const $=[];return this.f.forEach(X=>$.push(X)),$}constructor($){this.a=new Map,this.f=new Set,this.g=new I.Emitter,this.onDidAddConnection=this.g.event,this.h=new I.Emitter,this.onDidRemoveConnection=this.h.event,$(({protocol:X,onDidClientDisconnect:ie})=>{I.Event.once(X.onMessage)(ae=>{const q=new L(ae),C=c(q),k=new y(X,C),M=new g(X);this.a.forEach((_,W)=>k.registerChannel(W,_));const z={channelServer:k,channelClient:M,ctx:C};this.f.add(z),this.g.fire(z),ie(()=>{k.dispose(),M.dispose(),this.f.delete(z),this.h.fire(z)})})})}getChannel($,X){const ie=this;return{call(se,ae,q){let C;if((0,p.isFunction)(X)){const M=(0,O.getRandomElement)(ie.connections.filter(X));C=M?Promise.resolve(M):I.Event.toPromise(I.Event.filter(ie.onDidAddConnection,X))}else C=X.routeCall(ie,se,ae);const k=C.then(M=>M.channelClient.getChannel($));return F(k).call(se,ae,q)},listen(se,ae){if((0,p.isFunction)(X))return ie.j($,X,se,ae);const q=X.routeEvent(ie,se,ae).then(C=>C.channelClient.getChannel($));return F(q).listen(se,ae)}}}j($,X,ie,se){const ae=this;let q=new w.DisposableStore;const C=new I.Emitter({onWillAddFirstListener:()=>{q=new w.DisposableStore;const k=new I.EventMultiplexer,M=new Map,z=W=>{const ee=W.channelClient.getChannel($).listen(ie,se),le=k.add(ee);M.set(W,le)},_=W=>{const Q=M.get(W);!Q||(Q.dispose(),M.delete(W))};ae.connections.filter(X).forEach(z),I.Event.filter(ae.onDidAddConnection,X)(z,void 0,q),ae.onDidRemoveConnection(_,void 0,q),k.event(C.fire,C,q),q.add(k)},onDidRemoveLastListener:()=>{q.dispose()}});return C.event}registerChannel($,X){this.a.set($,X),this.f.forEach(ie=>{ie.channelServer.registerChannel($,X)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=D;class A{constructor($,X,ie=null){const se=new n;o(se,X),$.send(se.buffer),this.a=new g($,ie),this.d=new y($,X,ie)}getChannel($){return this.a.getChannel($)}registerChannel($,X){this.d.registerChannel($,X)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=A;function F(H){return{call($,X,ie){return H.then(se=>se.call($,X,ie))},listen($,X){const ie=new I.Relay;return H.then(se=>ie.input=se.listen($,X)),ie.event}}}e.getDelayedChannel=F;function j(H){let $=!1;return{call(X,ie,se){return $?H.call(X,ie,se):(0,U.timeout)(0).then(()=>$=!0).then(()=>H.call(X,ie,se))},listen(X,ie){if($)return H.listen(X,ie);const se=new I.Relay;return(0,U.timeout)(0).then(()=>$=!0).then(()=>se.input=H.listen(X,ie)),se.event}}}e.getNextTickChannel=j;class x{constructor($){this.a=$}routeCall($){return this.b($)}routeEvent($){return this.b($)}async b($){for(const X of $.connections)if(await Promise.resolve(this.a(X.ctx)))return Promise.resolve(X);return await I.Event.toPromise($.onDidAddConnection),await this.b($)}}e.StaticRouter=x;var V;(function(H){function $(ae,q){const C=ae,k=q&&q.disableMarshalling,M=new Map;for(const z in C)ie(z)&&M.set(z,I.Event.buffer(C[z],!0));return new class{listen(z,_,W){const Q=M.get(_);if(Q)return Q;if(se(_)){const ee=C[_];if(typeof ee=="function")return ee.call(C,W)}throw new Error(`Event not found: ${_}`)}call(z,_,W){const Q=C[_];if(typeof Q=="function"){if(!k&&Array.isArray(W))for(let ee=0;ee<W.length;ee++)W[ee]=(0,P.revive)(W[ee]);return Q.apply(C,W)}throw new Error(`Method not found: ${_}`)}}}H.fromService=$;function X(ae,q){const C=q&&q.disableMarshalling;return new Proxy({},{get(k,M){if(typeof M=="string")return q?.properties?.has(M)?q.properties.get(M):se(M)?function(z){return ae.listen(M,z)}:ie(M)?ae.listen(M):async function(...z){let _;q&&!(0,p.isUndefinedOrNull)(q.context)?_=[q.context,...z]:_=z;const W=await ae.call(M,_);return C?W:(0,P.revive)(W)};throw new Error(`Property not found: ${String(M)}`)}})}H.toService=X;function ie(ae){return ae[0]==="o"&&ae[1]==="n"&&S.isUpperAsciiLetter(ae.charCodeAt(2))}function se(ae){return/^onDynamic/.test(ae)&&S.isUpperAsciiLetter(ae.charCodeAt(9))}})(V=e.ProxyChannel||(e.ProxyChannel={}));const B=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function Z(H){if(Array.isArray(H))return H;if(H&&typeof H=="object"&&typeof H.toString=="function"){const $=H.toString();if($!=="[object Object]")return $}return H}function J(H){return Array.isArray(H)?H.map(Z):Z(H)}function K(H,$,X,ie,se,ae,q){q=J(q);const C=B[se],k=C[ie%C.length];let M=[`%c[${H}]%c[${String($).padStart(7," ")}]%c[len: ${String(X).padStart(5," ")}]%c${String(ie).padStart(5," ")} - ${ae}`,"color: darkgreen","color: grey","color: grey",`color: ${k}`];/\($/.test(ae)?(M=M.concat(q),M.push(")")):M.push(q),console.log.apply(console,M)}class Y{constructor($,X){this.d=$,this.f=X,this.a=0,this.b=0}logOutgoing($,X,ie,se,ae){this.b+=$,K(this.d,this.b,$,X,ie,se,ae)}logIncoming($,X,ie,se,ae){this.a+=$,K(this.f,this.a,$,X,ie,se,ae)}}e.IPCLogger=Y}),define(re[149],oe([0,1,16,3,39]),function(te,e,O,U,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class T{constructor(I){this.a=I,this.onMessage=U.Event.fromDOMEventEmitter(this.a,"message",w=>O.VSBuffer.wrap(w.data)),I.start()}send(I){this.a.postMessage(I.buffer)}disconnect(){this.a.close()}}e.Protocol=T;class N extends l.IPCClient{constructor(I,w){const P=new T(I);super(P,w),this.b=P}dispose(){this.b.disconnect()}}e.Client=N}),define(re[97],oe([0,1,6,16,3,2,39]),function(te,e,O,U,l,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var R;(function(g){g.Created="created",g.Read="read",g.Write="write",g.Open="open",g.Error="error",g.Close="close",g.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",g.NodeEndReceived="nodeEndReceived",g.NodeEndSent="nodeEndSent",g.NodeDrainBegin="nodeDrainBegin",g.NodeDrainEnd="nodeDrainEnd",g.zlibInflateError="zlibInflateError",g.zlibInflateData="zlibInflateData",g.zlibInflateInitialWrite="zlibInflateInitialWrite",g.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",g.zlibInflateWrite="zlibInflateWrite",g.zlibInflateFlushFired="zlibInflateFlushFired",g.zlibDeflateError="zlibDeflateError",g.zlibDeflateData="zlibDeflateData",g.zlibDeflateWrite="zlibDeflateWrite",g.zlibDeflateFlushFired="zlibDeflateFlushFired",g.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",g.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",g.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",g.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",g.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",g.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",g.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",g.ProtocolHeaderRead="protocolHeaderRead",g.ProtocolMessageRead="protocolMessageRead",g.ProtocolHeaderWrite="protocolHeaderWrite",g.ProtocolMessageWrite="protocolMessageWrite",g.ProtocolWrite="protocolWrite"})(R=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var I;(function(g){g.enableDiagnostics=!1,g.records=[];const D=new WeakMap;let A=0;function F(x,V){if(!D.has(x)){const B=String(++A);D.set(x,B)}return D.get(x)}function j(x,V,B,Z){if(!g.enableDiagnostics)return;const J=F(x,V);if(Z instanceof U.VSBuffer||Z instanceof Uint8Array||Z instanceof ArrayBuffer||ArrayBuffer.isView(Z)){const K=U.VSBuffer.alloc(Z.byteLength);K.set(Z),g.records.push({timestamp:Date.now(),id:J,label:V,type:B,buff:K})}else g.records.push({timestamp:Date.now(),id:J,label:V,type:B,data:Z})}g.traceSocketEvent=j})(I=e.SocketDiagnostics||(e.SocketDiagnostics={}));var w;(function(g){g[g.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",g[g.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(w=e.SocketCloseEventType||(e.SocketCloseEventType={}));let P=null;function S(){return P||(P=U.VSBuffer.alloc(0)),P}class p{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(D){this.a.push(D),this.b+=D.byteLength}read(D){return this.c(D,!0)}peek(D){return this.c(D,!1)}c(D,A){if(D===0)return S();if(D>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===D){const V=this.a[0];return A&&(this.a.shift(),this.b-=D),V}if(this.a[0].byteLength>D){const V=this.a[0].slice(0,D);return A&&(this.a[0]=this.a[0].slice(D),this.b-=D),V}const F=U.VSBuffer.alloc(D);let j=0,x=0;for(;D>0;){const V=this.a[x];if(V.byteLength>D){const B=V.slice(0,D);F.set(B,j),j+=D,A&&(this.a[x]=V.slice(D),this.b-=D),D-=D}else F.set(V,j),j+=V.byteLength,A?(this.a.shift(),this.b-=V.byteLength):x++,D-=V.byteLength}return F}}e.ChunkStream=p;var f;(function(g){g[g.None=0]="None",g[g.Regular=1]="Regular",g[g.Control=2]="Control",g[g.Ack=3]="Ack",g[g.Disconnect=5]="Disconnect",g[g.ReplayRequest=6]="ReplayRequest",g[g.Pause=7]="Pause",g[g.Resume=8]="Resume",g[g.KeepAlive=9]="KeepAlive",g[g.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",g[g.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(f||(f={}));function m(g){switch(g){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var E;(function(g){g[g.HeaderLength=13]="HeaderLength",g[g.AcknowledgeTime=2e3]="AcknowledgeTime",g[g.TimeoutTime=2e4]="TimeoutTime",g[g.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",g[g.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",g[g.KeepAliveSendTime=5e3]="KeepAliveSendTime",g[g.LatencySampleTime=6e4]="LatencySampleTime",g[g.LatencySampleCount=5]="LatencySampleCount",g[g.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",g[g.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(E=e.ProtocolConstants||(e.ProtocolConstants={}));class a{constructor(D,A,F,j){this.type=D,this.id=A,this.ack=F,this.data=j,this.writtenTime=0}get size(){return this.data.byteLength}}class u extends T.Disposable{constructor(D){super(),this.f=this.D(new l.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=D,this.b=!1,this.c=new p,this.D(this.a.onData(A=>this.acceptChunk(A))),this.lastReadTime=Date.now()}acceptChunk(D){if(!(!D||D.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(D);this.c.byteLength>=this.g.readLen;){const A=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=A.readUInt32BE(9),this.g.messageType=A.readUInt8(0),this.g.id=A.readUInt32BE(1),this.g.ack=A.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:m(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const F=this.g.messageType,j=this.g.id,x=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",A),this.f.fire(new a(F,j,x,A)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class h{constructor(D){this.k=null,this.a=!1,this.b=!1,this.c=D,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(D){if(this.a)return;D.writtenTime=Date.now(),this.lastWriteTime=Date.now();const A=U.VSBuffer.alloc(13);A.writeUInt8(D.type,0),A.writeUInt32BE(D.id,1),A.writeUInt32BE(D.ack,5),A.writeUInt32BE(D.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:m(D.type),id:D.id,ack:D.ack,messageSize:D.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",D.data),this.j(A,D.data)}g(D,A){const F=this.f===0;return this.d.push(D,A),this.f+=D.byteLength+A.byteLength,F}h(){const D=U.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,D}j(D,A){this.g(D,A)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const D=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:D.byteLength}),this.c.write(D)}}class d extends T.Disposable{constructor(D){super(),this.f=new l.Emitter,this.onMessage=this.f.event,this.g=new l.Emitter,this.onDidDispose=this.g.event,this.a=D,this.b=this.D(new h(this.a)),this.c=this.D(new u(this.a)),this.D(this.c.onMessage(A=>{A.type===1&&this.f.fire(A.data)})),this.D(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(D){this.b.write(new a(1,0,0,D))}}e.Protocol=d;class v extends N.IPCClient{static fromSocket(D,A){return new v(new d(D),A)}get onDidDispose(){return this.b.onDidDispose}constructor(D,A,F=null){super(D,A,F),this.b=D}dispose(){super.dispose();const D=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),D.end()}}e.Client=v;class L{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new l.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(D){this.b?this.d.length>0?this.d.push(D):this.a.fire(D):this.d.push(D)}flushBuffer(){this.d=[]}}e.BufferedEmitter=L;class n{constructor(D){this.data=D,this.next=null}}class r{constructor(){this.a=null,this.b=null}length(){let D=0,A=this.a;for(;A;)A=A.next,D++;return D}peek(){return this.a?this.a.data:null}toArray(){const D=[];let A=0,F=this.a;for(;F;)D[A++]=F.data,F=F.next;return D}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(D){const A=new n(D);if(!this.a){this.a=A,this.b=A;return}this.b.next=A,this.b=A}}class t{static getInstance(){return t.b||(t.b=new t),t.b}constructor(){this.c=[];const D=Date.now();for(let A=0;A<t.a;A++)this.c[A]=D-1e3*A;setInterval(()=>{for(let A=t.a;A>=1;A--)this.c[A]=this.c[A-1];this.c[0]=Date.now()},1e3)}d(){const D=Date.now(),A=(1+t.a)*1e3;let F=0;for(let j=0;j<t.a;j++)D-this.c[j]<=A&&F++;return 1-F/t.a}hasHighLoad(){return this.d()>=.5}}t.a=10,t.b=null;var i;(function(g){g[g.Good=0]="Good",g[g.Poor=1]="Poor"})(i=e.ConnectionHealth||(e.ConnectionHealth={}));function s(g){switch(g){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=s;class o{constructor(D){this.connectionHealth=D}}e.ConnectionHealthChangedEvent=o;class c{constructor(D,A){this.roundTripTime=D,this.recentHighRoundTripCount=A}}e.HighRoundTripTimeEvent=c;class y{get unacknowledgedCount(){return this.c-this.d}constructor(D){this.x=new L,this.onControlMessage=this.x.event,this.y=new L,this.onMessage=this.y.event,this.z=new L,this.onDidDispose=this.z.event,this.A=new L,this.onSocketClose=this.A.event,this.B=new L,this.onSocketTimeout=this.B.event,this.C=new L,this.onHighRoundTripTime=this.C.event,this.D=new L,this.onDidChangeConnectionHealth=this.D.event,this.u=D.loadEstimator??t.getInstance(),this.v=D.measureRoundTripTime??!1,this.w=D.sendKeepAlive??!0,this.a=!1,this.b=new r,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new T.DisposableStore,this.o=D.socket,this.p=this.t.add(new h(this.o)),this.q=this.t.add(new u(this.o)),this.t.add(this.q.onMessage(A=>this.E(A))),this.t.add(this.o.onClose(A=>this.A.fire(A))),this.r=this.t.add(new b),this.t.add(this.r.onSendLatencyRequest(A=>this.J(A))),this.t.add(this.r.onHighRoundTripTime(A=>this.C.fire(A))),this.t.add(this.r.onDidChangeConnectionHealth(A=>this.D.fire(A))),this.v&&this.r.start(),D.initialChunk&&this.q.acceptChunk(D.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const D=new a(5,0,0,S());this.p.write(D),this.p.flush()}sendPause(){const D=new a(7,0,0,S());this.p.write(D)}sendResume(){const D=new a(8,0,0,S());this.p.write(D)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(D,A){this.a=!0,this.t.dispose(),this.t=new T.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=D,this.p=this.t.add(new h(this.o)),this.q=this.t.add(new u(this.o)),this.t.add(this.q.onMessage(F=>this.E(F))),this.t.add(this.o.onClose(F=>this.A.fire(F))),this.r=this.t.add(new b),this.t.add(this.r.onSendLatencyRequest(F=>this.J(F))),this.t.add(this.r.onHighRoundTripTime(F=>this.C.fire(F))),this.t.add(this.r.onDidChangeConnectionHealth(F=>this.D.fire(F))),this.q.acceptChunk(A)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const D=new a(3,0,this.h,S());this.p.write(D);const A=this.b.toArray();for(let F=0,j=A.length;F<j;F++)this.p.write(A[F]);this.G()}acceptDisconnect(){this.z.fire()}E(D){if(D.ack>this.d){this.d=D.ack;do{const A=this.b.peek();if(A&&A.id<=D.ack)this.b.pop();else break}while(!0)}switch(D.type){case 0:break;case 1:{if(D.id>this.g)if(D.id!==this.g+1){const A=Date.now();A-this.m>1e4&&(this.m=A,this.p.write(new a(6,0,0,S())))}else this.g=D.id,this.j=Date.now(),this.F(),this.y.fire(D.data);break}case 2:{this.x.fire(D.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const A=this.b.toArray();for(let F=0,j=A.length;F<j;F++)this.p.write(A[F]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(D.data);break}case 11:{this.r.handleResponse(D.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(D){const A=++this.c;this.h=this.g;const F=new a(1,A,this.h,D);this.b.push(F),this.a||(this.p.write(F),this.G())}sendControl(D){const A=new a(2,0,0,D);this.p.write(A)}F(){if(this.g<=this.h||this.k)return;const D=Date.now()-this.j;if(D>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-D+5)}G(){if(this.c<=this.d||this.f||this.a)return;const D=this.b.peek(),A=Date.now()-D.writtenTime,F=Date.now()-this.q.lastReadTime,j=Date.now()-this.n;if(A>=2e4&&F>=2e4&&j>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:A,timeSinceLastReceivedSomeData:F});return}const x=Math.max(2e4-A,2e4-F,2e4-j,500);this.f=setTimeout(()=>{this.f=null,this.G()},x)}H(){if(this.g<=this.h)return;this.h=this.g;const D=new a(3,0,this.h,S());this.p.write(D)}I(){this.h=this.g;const D=new a(9,0,this.h,S());this.p.write(D)}J(D){this.h=this.g;const A=new a(10,0,this.h,D);this.p.write(A)}K(D){this.h=this.g;const A=new a(11,0,this.h,D);this.p.write(A)}}e.PersistentProtocol=y;class b extends T.Disposable{constructor(){super(),this.a=this.D(new l.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.D(new l.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.D(new l.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.D(new O.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},D=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const D=++this.h,A=U.VSBuffer.alloc(4);A.writeUInt32BE(D,0),this.a.fire(A)},6e4)}handleResponse(D){if(D.byteLength!==4)return;const A=D.readUInt32BE(0);if(this.g<=0||A!==this.h)return;const F=Date.now()-this.g,j=this.k++;this.j[j%this.j.length]=F;const x=this.l,V=this.j.filter(B=>B>=1e3).length;this.l=V>=3?1:0,F>1e3&&this.b.fire(new c(F,V)),x!==this.l&&this.c.fire(this.l)}}}),define(re[150],oe([0,1,151,3,39,149]),function(te,e,O,U,l,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class N extends l.IPCServer{static b(){const I=U.Event.fromNodeEventEmitter(O.ipcRenderer,"vscode:createMessageChannel",(w,P)=>P);return U.Event.map(I,w=>{const{port1:P,port2:S}=new MessageChannel,f={protocol:new T.Protocol(P),onDidClientDisconnect:U.Event.fromDOMEventEmitter(P,"close")};return O.ipcRenderer.postMessage("vscode:createMessageChannelResult",w,[S]),f})}constructor(){super(N.b())}}e.Server=N}),define(re[66],oe([0,1,50,6,16,25,144,10,3,2,32,96,89,39]),function(te,e,O,U,l,T,N,R,I,w,P,S,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class m extends f.ChannelServer{constructor(u){super({send:h=>{try{process.send?.(h.buffer.toString("base64"))}catch{}},onMessage:I.Event.fromNodeEventEmitter(process,"message",h=>l.VSBuffer.wrap(Buffer.from(h,"base64")))},u),process.once("disconnect",()=>this.dispose())}}e.Server=m;class E{constructor(u,h){this.i=u,this.j=h,this.c=new Set,this.g=new Map,this.h=new I.Emitter,this.onDidProcessExit=this.h.event;const d=h&&h.timeout?h.timeout:6e4;this.b=new U.Delayer(d),this.d=null,this.f=null}getChannel(u){const h=this;return{call(d,v,L){return h.k(u,d,v,L)},listen(d,v){return h.l(u,d,v)}}}k(u,h,d,v=T.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(v.isCancellationRequested)return Promise.reject(R.canceled());this.b.cancel();const L=this.n(u),n=(0,U.createCancelablePromise)(i=>L.call(h,d,i)),r=v.onCancellationRequested(()=>n.cancel()),t=(0,w.toDisposable)(()=>n.cancel());return this.c.add(t),n.finally(()=>{r.dispose(),this.c.delete(t),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),n}l(u,h,d){if(!this.b)return I.Event.None;this.b.cancel();let v;const L=new I.Emitter({onWillAddFirstListener:()=>{v=this.n(u).listen(h,d)(L.fire,L),this.c.add(v)},onDidRemoveLastListener:()=>{this.c.delete(v),v.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return L.event}get m(){if(!this.f){const u=this.j&&this.j.args?this.j.args:[],h=Object.create(null);h.env={...(0,P.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(h.env={...h.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(h.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(h.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(h.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),h.execArgv===void 0&&(h.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s)).filter(s=>!s.startsWith("--vscode-"))),(0,p.removeDangerousEnvVariables)(h.env),this.d=(0,O.fork)(this.i,u,h);const d=new I.Emitter;I.Event.fromNodeEventEmitter(this.d,"message",s=>s)(s=>{if((0,N.isRemoteConsoleLog)(s)){(0,N.log)(s,`IPC Library: ${this.j.serverName}`);return}d.fire(l.VSBuffer.wrap(Buffer.from(s,"base64")))});const L=this.j.useQueue?(0,S.createQueuedSender)(this.d):this.d,n=s=>this.d&&this.d.connected&&L.send(s.buffer.toString("base64")),r=d.event,t={send:n,onMessage:r};this.f=new f.ChannelClient(t);const i=()=>this.o();process.once("exit",i),this.d.on("error",s=>console.warn('IPC "'+this.j.serverName+'" errored with '+s)),this.d.on("exit",(s,o)=>{process.removeListener("exit",i),this.c.forEach(c=>(0,w.dispose)(c)),this.c.clear(),s!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+s+" and signal "+o),this.b?.cancel(),this.o(),this.h.fire({code:s,signal:o})})}return this.f}n(u){let h=this.g.get(u);return h||(h=this.m.getChannel(u),this.g.set(u,h)),h}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=E}),define(re[152],oe([0,1,88,16,39,3,12,21]),function(te,e,O,U,l,T,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=e.Server=void 0;class I{constructor(p){this.a=p,this.onMessage=T.Event.fromNodeEventEmitter(this.a,"message",f=>U.VSBuffer.wrap(f.data)),p.start()}send(p){this.a.postMessage(p.buffer)}disconnect(){this.a.close()}}class w extends l.IPCServer{static b(){(0,N.assertType)((0,O.isUtilityProcess)(process),"Electron Utility Process");const p=new T.Emitter;return process.parentPort.on("message",f=>{const m=(0,R.firstOrDefault)(f.ports);m&&p.fire(m)}),T.Event.map(p.event,f=>({protocol:new I(f),onDidClientDisconnect:T.Event.fromNodeEventEmitter(f,"close")}))}constructor(){super(w.b())}}e.Server=w;function P(S,p,f){const m=E=>{E.data===p&&(S.removeListener("message",m),f())};S.on("message",m)}e.once=P}),define(re[67],oe([0,1,6,3,2,12]),function(te,e,O,U,l,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var N;(function(S){S[S.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",S[S.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(N=e.StorageHint||(e.StorageHint={}));function R(S){const p=S;return p?.changed instanceof Map||p?.deleted instanceof Set}e.isStorageItemsChangeEvent=R;var I;(function(S){S[S.None=0]="None",S[S.Initialized=1]="Initialized",S[S.Closed=2]="Closed"})(I=e.StorageState||(e.StorageState={}));class w extends l.Disposable{constructor(p,f=Object.create(null)){super(),this.m=p,this.n=f,this.b=this.D(new U.Emitter),this.onDidChangeStorage=this.b.event,this.c=I.None,this.f=new Map,this.g=new O.ThrottledDelayer(w.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.D(this.m.onDidChangeItemsExternal(p=>this.q(p)))}q(p){p.changed?.forEach((f,m)=>this.r(m,f)),p.deleted?.forEach(f=>this.r(f,void 0))}r(p,f){if(this.c===I.Closed)return;let m=!1;(0,T.isUndefinedOrNull)(f)?m=this.f.delete(p):this.f.get(p)!==f&&(this.f.set(p,f),m=!0),m&&this.b.fire(p)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===I.None&&(this.c=I.Initialized,this.n.hint!==N.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(p,f){const m=this.f.get(p);return(0,T.isUndefinedOrNull)(m)?f:m}getBoolean(p,f){const m=this.get(p);return(0,T.isUndefinedOrNull)(m)?f:m==="true"}getNumber(p,f){const m=this.get(p);return(0,T.isUndefinedOrNull)(m)?f:parseInt(m,10)}async set(p,f){if(this.c===I.Closed)return;if((0,T.isUndefinedOrNull)(f))return this.delete(p);const m=String(f);if(this.f.get(p)!==m)return this.f.set(p,m),this.j.set(p,m),this.h.delete(p),this.b.fire(p),this.v()}async delete(p){if(!(this.c===I.Closed||!this.f.delete(p)))return this.h.has(p)||this.h.add(p),this.j.delete(p),this.b.fire(p),this.v()}async close(){return this.k||(this.k=this.s()),this.k}async s(){this.c=I.Closed;try{await this.v(0)}catch{}await this.m.close(()=>this.f)}get t(){return this.j.size>0||this.h.size>0}async u(){if(!this.t)return;const p={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(p).finally(()=>{if(!this.t)for(;this.l.length;)this.l.pop()?.()})}async flush(p){if(!!this.t)return this.v(p)}async v(p){return this.g.trigger(()=>this.u(),p)}async whenFlushed(){if(!!this.t)return new Promise(p=>this.l.push(p))}isInMemory(){return this.n.hint===N.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}w.a=100,e.Storage=w;class P{constructor(){this.onDidChangeItemsExternal=U.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(p){p.insert?.forEach((f,m)=>this.a.set(m,f)),p.delete?.forEach(f=>this.a.delete(f))}async close(){}}e.InMemoryStorageDatabase=P}),define(re[153],oe([8,7]),function(te,e){return te.create("vs/base/node/zip",e)}),define(re[154],oe([8,7]),function(te,e){return te.create("vs/platform/configuration/common/configurationRegistry",e)}),define(re[155],oe([8,7]),function(te,e){return te.create("vs/platform/contextkey/common/contextkey",e)}),define(re[156],oe([8,7]),function(te,e){return te.create("vs/platform/contextkey/common/scanner",e)}),define(re[157],oe([8,7]),function(te,e){return te.create("vs/platform/environment/node/argv",e)}),define(re[158],oe([8,7]),function(te,e){return te.create("vs/platform/environment/node/argvHelper",e)}),define(re[159],oe([8,7]),function(te,e){return te.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(re[160],oe([8,7]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(re[161],oe([8,7]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(re[162],oe([8,7]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionTipsService",e)}),define(re[163],oe([8,7]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(re[164],oe([8,7]),function(te,e){return te.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(re[165],oe([8,7]),function(te,e){return te.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(re[166],oe([8,7]),function(te,e){return te.create("vs/platform/extensions/common/extensionValidator",e)}),define(re[167],oe([8,7]),function(te,e){return te.create("vs/platform/files/common/fileService",e)}),define(re[168],oe([8,7]),function(te,e){return te.create("vs/platform/files/common/files",e)}),define(re[169],oe([8,7]),function(te,e){return te.create("vs/platform/files/common/io",e)}),define(re[170],oe([8,7]),function(te,e){return te.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(re[171],oe([8,7]),function(te,e){return te.create("vs/platform/languagePacks/common/languagePacks",e)}),define(re[172],oe([8,7]),function(te,e){return te.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(re[173],oe([8,7]),function(te,e){return te.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(re[174],oe([8,7]),function(te,e){return te.create("vs/platform/request/common/request",e)}),define(re[175],oe([8,7]),function(te,e){return te.create("vs/platform/shell/node/shellEnv",e)}),define(re[176],oe([8,7]),function(te,e){return te.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(re[177],oe([8,7]),function(te,e){return te.create("vs/platform/telemetry/common/telemetryService",e)}),define(re[178],oe([8,7]),function(te,e){return te.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(re[179],oe([8,7]),function(te,e){return te.create("vs/platform/terminal/common/terminalProfiles",e)}),define(re[180],oe([8,7]),function(te,e){return te.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(re[181],oe([8,7]),function(te,e){return te.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(re[182],oe([8,7]),function(te,e){return te.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(re[183],oe([8,7]),function(te,e){return te.create("vs/platform/userDataSync/common/settingsSync",e)}),define(re[184],oe([8,7]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(re[185],oe([8,7]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSync",e)}),define(re[186],oe([8,7]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(re[187],oe([8,7]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(re[188],oe([8,7]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(re[189],oe([8,7]),function(te,e){return te.create("vs/platform/workspace/common/workspace",e)}),define(re[190],oe([0,1,10,156]),function(te,e,O,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var l;(function(w){w[w.LParen=0]="LParen",w[w.RParen=1]="RParen",w[w.Neg=2]="Neg",w[w.Eq=3]="Eq",w[w.NotEq=4]="NotEq",w[w.Lt=5]="Lt",w[w.LtEq=6]="LtEq",w[w.Gt=7]="Gt",w[w.GtEq=8]="GtEq",w[w.RegexOp=9]="RegexOp",w[w.RegexStr=10]="RegexStr",w[w.True=11]="True",w[w.False=12]="False",w[w.In=13]="In",w[w.Not=14]="Not",w[w.And=15]="And",w[w.Or=16]="Or",w[w.Str=17]="Str",w[w.QuotedStr=18]="QuotedStr",w[w.Error=19]="Error",w[w.EOF=20]="EOF"})(l=e.TokenType||(e.TokenType={}));function T(...w){switch(w.length){case 1:return(0,U.localize)(0,null,w[0]);case 2:return(0,U.localize)(1,null,w[0],w[1]);case 3:return(0,U.localize)(2,null,w[0],w[1],w[2]);default:return}}const N=(0,U.localize)(3,null),R=(0,U.localize)(4,null);class I{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(P){switch(P.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return P.isTripleEq?"===":"==";case 4:return P.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return P.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return P.lexeme;case 18:return P.lexeme;case 19:return P.lexeme;case 20:return"EOF";default:throw(0,O.illegalState)(`unhandled token type: ${JSON.stringify(P)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(P){return this.c=P,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const S=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:S})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const S=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:S})}else this.h(126)?this.k(9):this.l(T("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(T("&&"));break;case 124:this.h(124)?this.k(16):this.l(T("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(P){return this.r()||this.c.charCodeAt(this.e)!==P?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(P){this.f.push({type:P,offset:this.d})}l(P){const S=this.d,p=this.c.substring(this.d,this.e),f={type:19,offset:this.d,lexeme:p};this.g.push({offset:S,lexeme:p,additionalInfo:P}),this.f.push(f)}n(){this.m.lastIndex=this.d;const P=this.m.exec(this.c);if(P){this.e=this.d+P[0].length;const S=this.c.substring(this.d,this.e),p=I.b.get(S);p?this.k(p):this.f.push({type:17,lexeme:S,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(N);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let P=this.e,S=!1,p=!1;for(;;){if(P>=this.c.length){this.e=P,this.l(R);return}const m=this.c.charCodeAt(P);if(S)S=!1;else if(m===47&&!p){P++;break}else m===91?p=!0:m===92?S=!0:m===93&&(p=!1);P++}for(;P<this.c.length&&I.a.has(this.c.charCodeAt(P));)P++;this.e=P;const f=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:f,offset:this.d})}r(){return this.e>=this.c.length}}I.a=new Set(["i","g","s","m","y","u"].map(w=>w.charCodeAt(0))),I.b=new Map([["not",14],["in",13],["false",12],["true",11]]),e.Scanner=I}),define(re[191],oe([0,1,65,62,22,13,36,23,11]),function(te,e,O,U,l,T,N,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class w{get appRoot(){return(0,T.dirname)(l.FileAccess.asFileUri("").fsPath)}get userHome(){return I.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return I.URI.file((0,T.join)(this.userDataPath,"User"))}get tmpDir(){return I.URI.file(this.b.tmpDir)}get cacheHome(){return I.URI.file(this.userDataPath)}get stateResource(){return(0,R.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,R.joinPath)(this.userRoamingDataHome,"sync")}get logsHome(){if(!this.args.logsPath){const f=(0,O.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,T.join)(this.userDataPath,"logs",f)}return I.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.joinPath)(I.URI.file((0,T.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,R.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,R.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=N.env.VSCODE_PORTABLE;return f?I.URI.file((0,T.join)(f,"argv.json")):(0,R.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return I.URI.file((0,T.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,T.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?(0,T.resolve)(f):(0,T.normalize)((0,T.join)(l.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const f=this.args["extensions-download-dir"];return f?I.URI.file((0,T.resolve)(f)):I.URI.file((0,T.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return(0,T.resolve)(f);const m=N.env.VSCODE_EXTENSIONS;if(m)return m;const E=N.env.VSCODE_PORTABLE;return E?(0,T.join)(E,"extensions"):(0,R.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(m=>/^[^:/?#]+?:\/\//.test(m)?I.URI.parse(m):I.URI.file((0,T.normalize)(m)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(f=>f==="ui"||f==="workspace"||f==="web"?f:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?I.URI.parse(f):I.URI.file((0,T.normalize)(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return P(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!N.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(f=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(f))}get extensionLogLevel(){const f=[];for(const m of this.args.log||[]){const E=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(m);E&&E[1]&&E[2]&&f.push([E[1],E[2]])}return f.length?f:void 0}get serviceMachineIdResource(){return(0,R.joinPath)(I.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const f=N.env.VSCODE_PORTABLE;return f?I.URI.file((0,T.join)(f,"policy.json")):(0,R.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(f){this.args.continueOn=f}get args(){return this.a}constructor(f,m,E){this.a=f,this.b=m,this.c=E,this.editSessionId=this.args.editSessionId}}ye([U.memoize],w.prototype,"appRoot",null),ye([U.memoize],w.prototype,"userHome",null),ye([U.memoize],w.prototype,"userDataPath",null),ye([U.memoize],w.prototype,"appSettingsHome",null),ye([U.memoize],w.prototype,"tmpDir",null),ye([U.memoize],w.prototype,"cacheHome",null),ye([U.memoize],w.prototype,"stateResource",null),ye([U.memoize],w.prototype,"userRoamingDataHome",null),ye([U.memoize],w.prototype,"userDataSyncHome",null),ye([U.memoize],w.prototype,"sync",null),ye([U.memoize],w.prototype,"machineSettingsResource",null),ye([U.memoize],w.prototype,"workspaceStorageHome",null),ye([U.memoize],w.prototype,"localHistoryHome",null),ye([U.memoize],w.prototype,"keyboardLayoutResource",null),ye([U.memoize],w.prototype,"argvResource",null),ye([U.memoize],w.prototype,"isExtensionDevelopment",null),ye([U.memoize],w.prototype,"untitledWorkspacesHome",null),ye([U.memoize],w.prototype,"installSourcePath",null),ye([U.memoize],w.prototype,"builtinExtensionsPath",null),ye([U.memoize],w.prototype,"extensionsPath",null),ye([U.memoize],w.prototype,"extensionDevelopmentLocationURI",null),ye([U.memoize],w.prototype,"extensionDevelopmentKind",null),ye([U.memoize],w.prototype,"extensionTestsLocationURI",null),ye([U.memoize],w.prototype,"debugExtensionHost",null),ye([U.memoize],w.prototype,"logLevel",null),ye([U.memoize],w.prototype,"extensionLogLevel",null),ye([U.memoize],w.prototype,"serviceMachineIdResource",null),ye([U.memoize],w.prototype,"disableTelemetry",null),ye([U.memoize],w.prototype,"disableWorkspaceTrust",null),ye([U.memoize],w.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=w;function P(p,f){return S(p["inspect-extensions"],p["inspect-brk-extensions"],5870,f,p.debugId,p.extensionEnvironment)}e.parseExtensionHostDebugPort=P;function S(p,f,m,E,a,u){const d=Number(f||p)||(E?null:m),v=d?Boolean(!!f):!1;let L;if(u)try{L=JSON.parse(u)}catch{}return{port:d,break:v,debugId:a,env:L}}e.parseDebugParams=S}),define(re[192],oe([0,1,292,4,157]),function(te,e,O,U,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const T={o:(0,l.localize)(0,null),e:(0,l.localize)(1,null),t:(0,l.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,l.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,l.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,l.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,l.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,l.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,l.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,l.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,l.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,l.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,l.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,l.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,l.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,l.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,l.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,l.localize)(17,null)},category:{type:"string",cat:"e",description:(0,l.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,l.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,l.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,l.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,l.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,l.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,l.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,l.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,l.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,l.localize)(27,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,l.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,l.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,l.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,l.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,l.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,l.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,l.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,l.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const N={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function R(E,a,u=N){const h=E.find(o=>o.length>0&&o[0]!=="-"),d={},v=["_"],L=[],n={};let r;for(const o in a){const c=a[o];c.type==="subcommand"?o===h&&(r=c):(c.alias&&(d[o]=c.alias),c.type==="string"||c.type==="string[]"?(v.push(o),c.deprecates&&v.push(...c.deprecates)):c.type==="boolean"&&(L.push(o),c.deprecates&&L.push(...c.deprecates)),c.global&&(n[o]=c))}if(r&&h){const o=n;for(const g in r.options)o[g]=r.options[g];const c=E.filter(g=>g!==h),y=u.getSubcommandReporter?u.getSubcommandReporter(h):void 0,b=R(c,o,y);return{[h]:b,_:[]}}const t=O(E,{string:v,boolean:L,alias:d}),i={},s=t;i._=t._.map(o=>String(o)).filter(o=>o.length>0),delete s._;for(const o in a){const c=a[o];if(c.type==="subcommand")continue;c.alias&&delete s[c.alias];let y=s[o];if(c.deprecates)for(const b of c.deprecates)s.hasOwnProperty(b)&&(y||(y=s[b],y&&u.onDeprecatedOption(b,c.deprecationMessage||(0,l.localize)(36,null,o))),delete s[b]);if(typeof y<"u"){if(c.type==="string[]"){if(Array.isArray(y)||(y=[y]),!c.allowEmptyValue){const b=y.filter(g=>g.length>0);b.length!==y.length&&(u.onEmptyValue(o),y=b.length>0?b:void 0)}}else c.type==="string"&&(Array.isArray(y)?(y=y.pop(),u.onMultipleValues(o,y)):!y&&!c.allowEmptyValue&&(u.onEmptyValue(o),y=void 0));i[o]=y,c.deprecationMessage&&u.onDeprecatedOption(o,c.deprecationMessage)}delete s[o]}for(const o in s)u.onUnknownOption(o);return i}e.parseArgs=R;function I(E,a){let u="";return a.args&&(Array.isArray(a.args)?u=` <${a.args.join("> <")}>`:u=` <${a.args}>`),a.alias?`-${a.alias} --${E}${u}`:`--${E}${u}`}function w(E,a){const u=[];for(const h in E){const d=E[h],v=I(h,d);u.push([v,d.description])}return P(u,a)}e.formatOptions=w;function P(E,a){const h=E.reduce((L,n)=>Math.max(L,n[0].length),12)+2+1;if(a-h<25)return E.reduce((L,n)=>L.concat([`  ${n[0]}`,`      ${n[1]}`]),[]);const d=a-h-1,v=[];for(const L of E){const n=L[0],r=p(L[1],d),t=S(h-n.length-2);v.push("  "+n+t+r[0]);for(let i=1;i<r.length;i++)v.push(S(h)+r[i])}return v}function S(E){return" ".repeat(E)}function p(E,a){const u=[];for(;E.length;){const h=E.length<a?E.length:E.lastIndexOf(" ",a),d=E.slice(0,h).trim();E=E.slice(h),u.push(d)}return u}function f(E,a,u,h,d){const v=process.stdout.isTTY&&process.stdout.columns||80,L=d?.noInputFiles!==!0?`[${(0,l.localize)(37,null)}...]`:"",n=[`${E} ${u}`];n.push(""),n.push(`${(0,l.localize)(38,null)}: ${a} [${(0,l.localize)(39,null)}]${L}`),n.push(""),d?.noPipe!==!0&&(U.isWindows?n.push((0,l.localize)(40,null,a)):n.push((0,l.localize)(41,null,a)),n.push(""));const r={},t=[];for(const i in h){const s=h[i];if(s.type==="subcommand")s.description&&t.push({command:i,description:s.description});else if(s.description&&s.cat){let o=r[s.cat];o||(r[s.cat]=o={}),o[i]=s}}for(const i in r){const s=i,o=r[s];o&&(n.push(T[s]),n.push(...w(o,v)),n.push(""))}return t.length&&(n.push((0,l.localize)(42,null)),n.push(...P(t.map(i=>[i.command,i.description]),v)),n.push("")),n.join(`
`)}e.buildHelpMessage=f;function m(E,a){return`${E||(0,l.localize)(43,null)}
${a||(0,l.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=m}),define(re[193],oe([0,1,293,158,192]),function(te,e,O,U,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const T=2048;function N(p,f){const m=(v,L)=>{console.warn((0,U.localize)(0,null,v,L))},E=v=>{console.warn((0,U.localize)(1,null,v))},a=(v,L)=>{console.warn((0,U.localize)(2,null,v,L))},u=v=>({onUnknownOption:L=>{v!=="tunnel"&&console.warn((0,U.localize)(3,null,L,v))},onMultipleValues:m,onEmptyValue:E,onDeprecatedOption:a,getSubcommandReporter:v!=="tunnel"?u:void 0}),h={onUnknownOption:v=>{console.warn((0,U.localize)(4,null,v))},onMultipleValues:m,onEmptyValue:E,onDeprecatedOption:a,getSubcommandReporter:u},d=(0,l.parseArgs)(p,l.OPTIONS,f?h:void 0);return d.goto&&d._.forEach(v=>O(/^(\w:)?[^:]+(:\d*){0,2}$/.test(v),(0,U.localize)(5,null))),d["max-memory"]&&O(parseInt(d["max-memory"])>=T,`The max-memory argument cannot be specified lower than ${T} MB.`),d}function R(p){const f=p.findIndex(m=>!/^-/.test(m));if(f>-1)return[...p.slice(0,f),...p.slice(f+1)]}function I(p){let[,...f]=p;process.env.VSCODE_DEV&&(f=R(f)||[]);const m=!S(process.env);return N(f,m)}e.parseMainProcessArgv=I;function w(p){let[,,...f]=p;return process.env.VSCODE_DEV&&(f=R(f)||[]),N(f,!0)}e.parseCLIProcessArgv=w;function P(p,...f){const m=p.indexOf("--");return m===-1?p.push(...f):p.splice(m,0,...f),p}e.addArg=P;function S(p){return p.VSCODE_CLI==="1"}e.isLaunchedFromCli=S}),function(){"use strict";function te(e,O,U){function l(N,R){const I=T(N,R),w=[I];return e.isAbsolute(I)||w.unshift(U),e.resolve(...w)}function T(N,R){process.env.VSCODE_DEV&&(R="code-oss-dev");const I=process.env.VSCODE_PORTABLE;if(I)return e.join(I,"user-data");let w=process.env.VSCODE_APPDATA;if(w)return e.join(w,R);const P=N["user-data-dir"];if(P)return P;switch(process.platform){case"win32":if(w=process.env.APPDATA,!w){const S=process.env.USERPROFILE;if(typeof S!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");w=e.join(S,"AppData","Roaming")}break;case"darwin":w=e.join(O.homedir(),"Library","Application Support");break;case"linux":w=process.env.XDG_CONFIG_HOME||e.join(O.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(w,R)}return{getUserDataPath:l}}if(typeof define=="function")define(re[194],oe([294,34,36]),function(e,O,U){return te(e,O,U.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),O=require("os");module.exports=te(e,O,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(re[98],oe([0,1,34,191,194]),function(te,e,O,U,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class T extends U.AbstractNativeEnvironmentService{constructor(w,P){super(w,{homeDir:(0,O.homedir)(),tmpDir:(0,O.tmpdir)(),userDataDir:(0,l.getUserDataPath)(w,P.nameShort)},P)}}e.NativeEnvironmentService=T;function N(I,w){return(0,U.parseDebugParams)(I["inspect-ptyhost"],I["inspect-brk-ptyhost"],5877,w,I.extensionEnvironment)}e.parsePtyHostDebugPort=N;function R(I,w){return(0,U.parseDebugParams)(I["inspect-sharedprocess"],I["inspect-brk-sharedprocess"],5879,w,I.extensionEnvironment)}e.parseSharedProcessDebugPort=R}),define(re[195],oe([0,1,11]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const U=/^([^@:]+@)?([^:]+):/,l=/^([^@:]+@)?([^:]+):(.+)$/,T=/^([^@]+@)?([^:]+)(:\d+)?$/,N=/([^@:.]+\.[^@:.]+)(:\d+)?$/,R=/^\s*url\s*=\s*(.+\S)\s*$/mg,I=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function w(a){const u=a.match(N);return u?u[1]:null}function P(a){if(a.indexOf("://")===-1){const u=a.match(U);return u?w(u[2]):null}try{const u=O.URI.parse(a);if(u.authority)return w(u.authority)}catch{}return null}function S(a,u){const h=new Set;let d;for(;d=R.exec(a);){const L=P(d[1]);L&&h.add(L)}const v=new Set(u);return Array.from(h).map(L=>v.has(L)?L:L.replace(I,"a"))}e.getDomainsOfRemotes=S;function p(a){const u=a.match(T);return u?u[2]:null}function f(a,u,h){return a&&u?(h&&u.endsWith(".git")&&(u=u.substr(0,u.length-4)),u.indexOf("/")===0?`${a}${u}`:`${a}/${u}`):null}function m(a,u){if(a.indexOf("://")===-1){const h=a.match(l);if(h)return f(h[2],h[3],u)}try{const h=O.URI.parse(a);if(h.authority)return f(p(h.authority),h.path,u)}catch{}return null}function E(a,u=!1){const h=[];let d;for(;d=R.exec(a);){const v=m(d[1],u);v&&h.push(v)}return h}e.getRemotes=E}),define(re[196],oe([0,1,12,161]),function(te,e,O,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function l(N,R,I){try{T(N,R,I)}catch(w){console.error(w?.message??w)}return N}e.localizeManifest=l;function T(N,R,I){const w=(P,S,p)=>{const f=P[S];if((0,O.isString)(f)){const m=f,E=m.length;if(E>1&&m[0]==="%"&&m[E-1]==="%"){const a=m.substr(1,E-2);let u=R[a];u===void 0&&I&&(u=I[a]);const h=typeof u=="string"?u:u?.message,d=I?.[a],v=typeof d=="string"?d:d?.message;if(!h){v||console.warn(`[${N.name}]: ${(0,U.localize)(0,null,a)}`);return}if(p&&(S==="title"||S==="category")&&v&&v!==h){const L={value:h,original:v};P[S]=L}else P[S]=h}}else if((0,O.isObject)(f))for(const m in f)f.hasOwnProperty(m)&&(m==="commands"?w(f,m,!0):w(f,m,p));else if(Array.isArray(f))for(let m=0;m<f.length;m++)w(f,m,p)};for(const P in N)N.hasOwnProperty(P)&&w(N,P)}}),define(re[197],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class O{constructor(T){this.a=T}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(T,N,R,I){return this.a.call("promptImportantExtensionsInstallNotification",[T,N,R,I])}promptWorkspaceRecommendations(T){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=O;class U{constructor(T){this.a=T}listen(T,N){throw new Error(`Event not found: ${N}`)}call(T,N,R){switch(N){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(R[0],R[1],R[2],R[3])}throw new Error(`Call not found: ${N}`)}}e.ExtensionRecommendationNotificationServiceChannel=U}),define(re[68],oe([0,1,23,91,166,55]),function(te,e,O,U,l,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const N=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function I(u){return u=u.trim(),u==="*"||N.test(u)}e.isValidVersionStr=I;function w(u){if(!I(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const h=u.match(N);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}e.parseVersion=w;function P(u){if(!u)return null;const h=u.majorBase,d=u.majorMustEqual,v=u.minorBase;let L=u.minorMustEqual;const n=u.patchBase;let r=u.patchMustEqual;u.hasCaret&&(h===0||(L=!1),r=!1);let t=0;if(u.preRelease){const i=R.exec(u.preRelease);if(i){const[,s,o,c]=i;t=Date.UTC(Number(s),Number(o)-1,Number(c))}}return{majorBase:h,majorMustEqual:d,minorBase:v,minorMustEqual:L,patchBase:n,patchMustEqual:r,isMinimum:u.hasGreaterEquals,notBefore:t}}e.normalizeVersion=P;function S(u,h,d){let v;typeof u=="string"?v=P(w(u)):v=u;let L;h instanceof Date?L=h.getTime():typeof h=="string"&&(L=new Date(h).getTime());let n;if(typeof d=="string"?n=P(w(d)):n=d,!v||!n)return!1;const r=v.majorBase,t=v.minorBase,i=v.patchBase;let s=n.majorBase,o=n.minorBase,c=n.patchBase;const y=n.notBefore;let b=n.majorMustEqual,g=n.minorMustEqual,D=n.patchMustEqual;return n.isMinimum?r>s?!0:r<s?!1:t>o?!0:t<o||L&&L<y?!1:i>=c:(r===1&&s===0&&(!b||!g||!D)&&(s=1,o=0,c=0,b=!0,g=!1,D=!1),r<s?!1:r>s?!b:t<o?!1:t>o?!g:i<c?!1:i>c?!D:!(L&&L<y))}e.isValidVersion=S;function p(u,h,d,v,L){const n=[];if(typeof v.publisher<"u"&&typeof v.publisher!="string")return n.push([U.default.Error,l.localize(0,null)]),n;if(typeof v.name!="string")return n.push([U.default.Error,l.localize(1,null,"name")]),n;if(typeof v.version!="string")return n.push([U.default.Error,l.localize(2,null,"version")]),n;if(!v.engines)return n.push([U.default.Error,l.localize(3,null,"engines")]),n;if(typeof v.engines.vscode!="string")return n.push([U.default.Error,l.localize(4,null,"engines.vscode")]),n;if(typeof v.extensionDependencies<"u"&&!a(v.extensionDependencies))return n.push([U.default.Error,l.localize(5,null,"extensionDependencies")]),n;if(typeof v.activationEvents<"u"){if(!a(v.activationEvents))return n.push([U.default.Error,l.localize(6,null,"activationEvents")]),n;if(typeof v.main>"u"&&typeof v.browser>"u")return n.push([U.default.Error,l.localize(7,null,"activationEvents","main")]),n}if(typeof v.extensionKind<"u"&&typeof v.main>"u"&&n.push([U.default.Warning,l.localize(8,null,"extensionKind")]),typeof v.main<"u"){if(typeof v.main!="string")return n.push([U.default.Error,l.localize(9,null,"main")]),n;{const i=(0,O.joinPath)(d,v.main);(0,O.isEqualOrParent)(i,d)||n.push([U.default.Warning,l.localize(10,null,i.path,d.path)])}if(typeof v.activationEvents>"u")return n.push([U.default.Error,l.localize(11,null,"activationEvents","main")]),n}if(typeof v.browser<"u"){if(typeof v.browser!="string")return n.push([U.default.Error,l.localize(12,null,"browser")]),n;{const i=(0,O.joinPath)(d,v.browser);(0,O.isEqualOrParent)(i,d)||n.push([U.default.Warning,l.localize(13,null,i.path,d.path)])}if(typeof v.activationEvents>"u")return n.push([U.default.Error,l.localize(14,null,"activationEvents","browser")]),n}if(!T.valid(v.version))return n.push([U.default.Error,l.localize(15,null)]),n;const r=[];if(!f(u,h,v,L,r))for(const i of r)n.push([U.default.Error,i]);return n}e.validateExtensionManifest=p;function f(u,h,d,v,L){return v||typeof d.main>"u"&&typeof d.browser>"u"?!0:E(u,h,d.engines.vscode,L)}e.isValidExtensionVersion=f;function m(u,h,d){return u==="*"||E(h,d,u)}e.isEngineValid=m;function E(u,h,d,v=[]){const L=P(w(d));if(!L)return v.push(l.localize(16,null,d)),!1;if(L.majorBase===0){if(!L.majorMustEqual||!L.minorMustEqual)return v.push(l.localize(17,null,d)),!1}else if(!L.majorMustEqual)return v.push(l.localize(18,null,d)),!1;return S(u,h,L)?!0:(v.push(l.localize(19,null,u,d)),!1)}function a(u){if(!Array.isArray(u))return!1;for(let h=0,d=u.length;h<d;h++)if(typeof u[h]!="string")return!1;return!0}}),define(re[44],oe([0,1,16,31]),function(te,e,O,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function l(T,N,R){let I=R&&R.get("storage.serviceMachineId",-1)||null;if(I)return I;try{const P=(await N.readFile(T.serviceMachineIdResource)).value.toString();I=(0,U.isUUID)(P)?P:null}catch{I=null}if(!I){I=(0,U.generateUuid)();try{await N.writeFile(T.serviceMachineIdResource,O.VSBuffer.fromString(I))}catch{}}return R?.store("storage.serviceMachineId",I,-1,1),I}e.getServiceMachineId=l}),define(re[69],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class O{constructor(l,T=[],N=!1){this.ctor=l,this.staticArguments=T,this.supportsDelayedInstantiation=N}}e.SyncDescriptor=O}),define(re[198],oe([0,1,69]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const U=[];var l;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(l=e.InstantiationType||(e.InstantiationType={}));function T(R,I,w){I instanceof O.SyncDescriptor||(I=new O.SyncDescriptor(I,[],Boolean(w))),U.push([R,I])}e.registerSingleton=T;function N(){return U}e.getSingletonServiceDescriptors=N}),define(re[199],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class O{constructor(T,N){this.key=T,this.data=N,this.incoming=new Map,this.outgoing=new Map}}e.Node=O;class U{constructor(T){this.b=T,this.a=new Map}roots(){const T=[];for(const N of this.a.values())N.outgoing.size===0&&T.push(N);return T}insertEdge(T,N){const R=this.lookupOrInsertNode(T),I=this.lookupOrInsertNode(N);R.outgoing.set(I.key,I),I.incoming.set(R.key,R)}removeNode(T){const N=this.b(T);this.a.delete(N);for(const R of this.a.values())R.outgoing.delete(N),R.incoming.delete(N)}lookupOrInsertNode(T){const N=this.b(T);let R=this.a.get(N);return R||(R=new O(N,T),this.a.set(N,R)),R}lookup(T){return this.a.get(this.b(T))}isEmpty(){return this.a.size===0}toString(){const T=[];for(const[N,R]of this.a)T.push(`${N}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return T.join(`
`)}findCycleSlow(){for(const[T,N]of this.a){const R=new Set([T]),I=this.c(N,R);if(I)return I}}c(T,N){for(const[R,I]of T.outgoing){if(N.has(R))return[...N,R].join(" -> ");N.add(R);const w=this.c(I,N);if(w)return w;N.delete(R)}}}e.Graph=U}),define(re[5],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var O;(function(N){N.serviceIds=new Map,N.DI_TARGET="$di$target",N.DI_DEPENDENCIES="$di$dependencies";function R(I){return I[N.DI_DEPENDENCIES]||[]}N.getServiceDependencies=R})(O=e._util||(e._util={})),e.IInstantiationService=l("instantiationService");function U(N,R,I){R[O.DI_TARGET]===R?R[O.DI_DEPENDENCIES].push({id:N,index:I}):(R[O.DI_DEPENDENCIES]=[{id:N,index:I}],R[O.DI_TARGET]=R)}function l(N){if(O.serviceIds.has(N))return O.serviceIds.get(N);const R=function(I,w,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");U(R,I,P)};return R.toString=()=>N,O.serviceIds.set(N,R),R}e.createDecorator=l;function T(N){return N}e.refineServiceDecorator=T}),define(re[200],oe([0,1,5]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,O.createDecorator)("checksumService")}),define(re[17],oe([0,1,12,11,5]),function(te,e,O,U,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,l.createDecorator)("configurationService");function T(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof U.URI)}e.isConfigurationOverrides=T;function N(a){return a&&typeof a=="object"&&(!a.overrideIdentifiers||Array.isArray(a.overrideIdentifiers))&&!a.overrideIdentifier&&(!a.resource||a.resource instanceof U.URI)}e.isConfigurationUpdateOverrides=N;var R;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.USER=2]="USER",a[a.USER_LOCAL=3]="USER_LOCAL",a[a.USER_REMOTE=4]="USER_REMOTE",a[a.WORKSPACE=5]="WORKSPACE",a[a.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",a[a.DEFAULT=7]="DEFAULT",a[a.MEMORY=8]="MEMORY"})(R=e.ConfigurationTarget||(e.ConfigurationTarget={}));function I(a){switch(a){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=I;function w(a,u){const h=Object.create(null);for(const d in a)P(h,d,a[d],u);return h}e.toValuesTree=w;function P(a,u,h,d){const v=u.split("."),L=v.pop();let n=a;for(let r=0;r<v.length;r++){const t=v[r];let i=n[t];switch(typeof i){case"undefined":i=n[t]=Object.create(null);break;case"object":break;default:d(`Ignoring ${u} as ${v.slice(0,r+1).join(".")} is ${JSON.stringify(i)}`);return}n=i}if(typeof n=="object"&&n!==null)try{n[L]=h}catch{d(`Ignoring ${u} as ${v.join(".")} is ${JSON.stringify(n)}`)}else d(`Ignoring ${u} as ${v.join(".")} is ${JSON.stringify(n)}`)}e.addToValueTree=P;function S(a,u){const h=u.split(".");p(a,h)}e.removeFromValueTree=S;function p(a,u){const h=u.shift();if(u.length===0){delete a[h];return}if(Object.keys(a).indexOf(h)!==-1){const d=a[h];typeof d=="object"&&!Array.isArray(d)&&(p(d,u),Object.keys(d).length===0&&delete a[h])}}function f(a,u,h){function d(n,r){let t=n;for(const i of r){if(typeof t!="object"||t===null)return;t=t[i]}return t}const v=u.split("."),L=d(a,v);return typeof L>"u"?h:L}e.getConfigurationValue=f;function m(a,u,h){Object.keys(u).forEach(d=>{d!=="__proto__"&&(d in a?O.isObject(a[d])&&O.isObject(u[d])?m(a[d],u[d],h):h&&(a[d]=u[d]):a[d]=u[d])})}e.merge=m;function E(a){return a.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=E}),define(re[70],oe([0,1,4,27,190,5,155]),function(te,e,O,U,l,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.Parser=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const R=new Map;R.set("false",!1),R.set("true",!0),R.set("isMac",O.isMacintosh),R.set("isLinux",O.isLinux),R.set("isWindows",O.isWindows),R.set("isWeb",O.isWeb),R.set("isMacNative",O.isMacintosh&&!O.isWeb),R.set("isEdge",O.isEdge),R.set("isFirefox",O.isFirefox),R.set("isChrome",O.isChrome),R.set("isSafari",O.isSafari);const I=Object.prototype.hasOwnProperty;var w;(function(q){q[q.False=0]="False",q[q.True=1]="True",q[q.Defined=2]="Defined",q[q.Not=3]="Not",q[q.Equals=4]="Equals",q[q.NotEquals=5]="NotEquals",q[q.And=6]="And",q[q.Regex=7]="Regex",q[q.NotRegex=8]="NotRegex",q[q.Or=9]="Or",q[q.In=10]="In",q[q.NotIn=11]="NotIn",q[q.Greater=12]="Greater",q[q.GreaterEquals=13]="GreaterEquals",q[q.Smaller=14]="Smaller",q[q.SmallerEquals=15]="SmallerEquals"})(w=e.ContextKeyExprType||(e.ContextKeyExprType={}));class P{static false(){return i.INSTANCE}static true(){return s.INSTANCE}static has(C){return o.create(C)}static equals(C,k){return c.create(C,k)}static notEquals(C,k){return g.create(C,k)}static regex(C,k){return B.create(C,k)}static in(C,k){return y.create(C,k)}static notIn(C,k){return b.create(C,k)}static not(C){return D.create(C)}static and(...C){return K.create(C,null,!0)}static or(...C){return Y.create(C,null,!0)}static greater(C,k){return F.create(C,k)}static greaterEquals(C,k){return j.create(C,k)}static smaller(C,k){return x.create(C,k)}static smallerEquals(C,k){return V.create(C,k)}static deserialize(C){if(!!C)return this.c(C)}static c(C){const k=C.split("||");return Y.create(k.map(M=>this.d(M)),null,!0)}static d(C){const k=C.split("&&");return K.create(k.map(M=>this.f(M)),null,!0)}static f(C){if(C=C.trim(),C.indexOf("!=")>=0){const k=C.split("!=");return g.create(k[0].trim(),this.g(k[1]))}if(C.indexOf("==")>=0){const k=C.split("==");return c.create(k[0].trim(),this.g(k[1]))}if(C.indexOf("=~")>=0){const k=C.split("=~");return B.create(k[0].trim(),this.h(k[1]))}if(C.indexOf(" not in ")>=0){const k=C.split(" not in ");return b.create(k[0].trim(),this.g(k[1]))}if(C.indexOf(" in ")>=0){const k=C.split(" in ");return y.create(k[0].trim(),this.g(k[1]))}if(/^[^<=>]+>=[^<=>]+$/.test(C)){const k=C.split(">=");return j.create(k[0].trim(),k[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(C)){const k=C.split(">");return F.create(k[0].trim(),k[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(C)){const k=C.split("<=");return V.create(k[0].trim(),k[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(C)){const k=C.split("<");return x.create(k[0].trim(),k[1].trim())}return/^\!\s*/.test(C)?D.create(C.substr(1).trim()):o.create(C)}static g(C){if(C=C.trim(),C==="true")return!0;if(C==="false")return!1;const k=/^'([^']*)'$/.exec(C);return k?k[1].trim():C}static h(C){if((0,U.isFalsyOrWhitespace)(C))return null;const k=C.indexOf("/"),M=C.lastIndexOf("/");if(k===M||k<0)return null;const z=C.slice(k+1,M),_=C[M+1]==="i"?"i":"";try{return new RegExp(z,_)}catch{return null}}}e.ContextKeyExpr=P;const S={regexParsingWithErrorRecovery:!0};class p extends Error{}const f=(0,N.localize)(0,null),m=(0,N.localize)(1,null),E=(0,N.localize)(2,null),a=(0,N.localize)(3,null),u=(0,N.localize)(4,null),h=(0,N.localize)(5,null),d=(0,N.localize)(6,null),v=(0,N.localize)(7,null);class L{get lexingErrors(){return this.c.errors}get parsingErrors(){return this.g}constructor(C=S){this.h=C,this.c=new l.Scanner,this.d=[],this.f=0,this.g=[]}parse(C){if(C===""){this.g.push({message:f,offset:0,lexeme:"",additionalInfo:m});return}this.d=this.c.reset(C).scan(),this.f=0,this.g=[];try{const k=this.k();if(!this.C()){const M=this.B(),z=M.type===17?h:void 0;throw this.g.push({message:u,offset:M.offset,lexeme:l.Scanner.getLexeme(M),additionalInfo:z}),new p}return k}catch(k){if(!(k instanceof p))throw k;return}}k(){return this.l()}l(){const C=[this.o()];for(;this.w(16);){const k=this.o();C.push(k)}return C.length===1?C[0]:P.or(...C)}o(){const C=[this.s()];for(;this.w(15);){const k=this.s();C.push(k)}return C.length===1?C[0]:P.and(...C)}s(){if(this.w(2)){const C=this.B();switch(C.type){case 11:return this.x(),i.INSTANCE;case 12:return this.x(),s.INSTANCE;case 0:{this.x();const k=this.k();return this.y(1,a),k?.negate()}case 17:return this.x(),D.create(C.lexeme);default:throw this.z("KEY | true | false | '(' expression ')'",C)}}return this.t()}t(){const C=this.B();switch(C.type){case 11:return this.x(),P.true();case 12:return this.x(),P.false();case 0:{this.x();const k=this.k();return this.y(1,a),k}case 17:{const k=C.lexeme;if(this.x(),this.w(9)){const z=this.B();if(!this.h.regexParsingWithErrorRecovery){if(this.x(),z.type!==10)throw this.z("REGEX",z);const _=z.lexeme,W=_.lastIndexOf("/"),Q=W===_.length-1?void 0:_.substring(W+1);let ee;try{ee=new RegExp(_.substring(1,W),Q)}catch{throw this.z("REGEX",z)}return B.create(k,ee)}switch(z.type){case 10:case 19:{const _=[z.lexeme];this.x();let W=this.B(),Q=0;for(let de=0;de<z.lexeme.length;de++)z.lexeme.charCodeAt(de)===40?Q++:z.lexeme.charCodeAt(de)===41&&Q--;for(;!this.C()&&W.type!==15&&W.type!==16;){switch(W.type){case 0:Q++;break;case 1:Q--;break;case 10:case 18:for(let de=0;de<W.lexeme.length;de++)W.lexeme.charCodeAt(de)===40?Q++:z.lexeme.charCodeAt(de)===41&&Q--}if(Q<0)break;_.push(l.Scanner.getLexeme(W)),this.x(),W=this.B()}const ee=_.join(""),le=ee.lastIndexOf("/"),he=le===ee.length-1?void 0:ee.substring(le+1);let pe;try{pe=new RegExp(ee.substring(1,le),he)}catch{throw this.z("REGEX",z)}return P.regex(k,pe)}case 18:{const _=z.lexeme;this.x();let W=null;if(!(0,U.isFalsyOrWhitespace)(_)){const Q=_.indexOf("/"),ee=_.lastIndexOf("/");if(Q!==ee&&Q>=0){const le=_.slice(Q+1,ee),he=_[ee+1]==="i"?"i":"";try{W=new RegExp(le,he)}catch{throw this.z("REGEX",z)}}}if(W===null)throw this.z("REGEX",z);return B.create(k,W)}default:throw this.z("REGEX",this.B())}}if(this.w(14)){this.y(13,E);const z=this.u();return P.notIn(k,z)}switch(this.B().type){case 3:{this.x();const z=this.u();if(this.v().type===18)return P.equals(k,z);switch(z){case"true":return P.has(k);case"false":return P.not(k);default:return P.equals(k,z)}}case 4:{this.x();const z=this.u();if(this.v().type===18)return P.notEquals(k,z);switch(z){case"true":return P.not(k);case"false":return P.has(k);default:return P.notEquals(k,z)}}case 5:return this.x(),x.create(k,this.u());case 6:return this.x(),V.create(k,this.u());case 7:return this.x(),F.create(k,this.u());case 8:return this.x(),j.create(k,this.u());case 13:return this.x(),P.in(k,this.u());default:return P.has(k)}}case 20:throw this.g.push({message:d,offset:C.offset,lexeme:"",additionalInfo:v}),new p;default:throw this.z(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.B())}}u(){const C=this.B();switch(C.type){case 17:case 18:return this.x(),C.lexeme;case 11:return this.x(),"true";case 12:return this.x(),"false";case 13:return this.x(),"in";default:return""}}v(){return this.d[this.f-1]}w(C){return this.A(C)?(this.x(),!0):!1}x(){return this.C()||this.f++,this.v()}y(C,k){if(this.A(C))return this.x();throw this.z(k,this.B())}z(C,k,M){const z=(0,N.localize)(8,null,C,l.Scanner.getLexeme(k)),_=k.offset,W=l.Scanner.getLexeme(k);return this.g.push({message:z,offset:_,lexeme:W,additionalInfo:M}),new p}A(C){return this.B().type===C}B(){return this.d[this.f]}C(){return this.B().type===20}}e.Parser=L;function n(q){const C=new L({regexParsingWithErrorRecovery:!1});return q.map(k=>(C.parse(k),C.lexingErrors.length>0?C.lexingErrors.map(M=>({errorMessage:M.additionalInfo?(0,N.localize)(9,null,M.additionalInfo):(0,N.localize)(10,null),offset:M.offset,length:M.lexeme.length})):C.parsingErrors.length>0?C.parsingErrors.map(M=>({errorMessage:M.additionalInfo?`${M.message}. ${M.additionalInfo}`:M.message,offset:M.offset,length:M.lexeme.length})):[]))}e.validateWhenClauses=n;function r(q,C){const k=q?q.substituteConstants():void 0,M=C?C.substituteConstants():void 0;return!k&&!M?!0:!k||!M?!1:k.equals(M)}e.expressionsAreEqualWithConstantSubstitution=r;function t(q,C){return q.cmp(C)}class i{constructor(){this.type=0}cmp(C){return this.type-C.type}equals(C){return C.type===this.type}substituteConstants(){return this}evaluate(C){return!1}serialize(){return"false"}keys(){return[]}map(C){return this}negate(){return s.INSTANCE}}i.INSTANCE=new i,e.ContextKeyFalseExpr=i;class s{constructor(){this.type=1}cmp(C){return this.type-C.type}equals(C){return C.type===this.type}substituteConstants(){return this}evaluate(C){return!0}serialize(){return"true"}keys(){return[]}map(C){return this}negate(){return i.INSTANCE}}s.INSTANCE=new s,e.ContextKeyTrueExpr=s;class o{static create(C,k=null){const M=R.get(C);return typeof M=="boolean"?M?s.INSTANCE:i.INSTANCE:new o(C,k)}constructor(C,k){this.key=C,this.c=k,this.type=2}cmp(C){return C.type!==this.type?this.type-C.type:$(this.key,C.key)}equals(C){return C.type===this.type?this.key===C.key:!1}substituteConstants(){const C=R.get(this.key);return typeof C=="boolean"?C?s.INSTANCE:i.INSTANCE:this}evaluate(C){return!!C.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(C){return C.mapDefined(this.key)}negate(){return this.c||(this.c=D.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=o;class c{static create(C,k,M=null){if(typeof k=="boolean")return k?o.create(C,M):D.create(C,M);const z=R.get(C);return typeof z=="boolean"?k===(z?"true":"false")?s.INSTANCE:i.INSTANCE:new c(C,k,M)}constructor(C,k,M){this.c=C,this.d=k,this.f=M,this.type=4}cmp(C){return C.type!==this.type?this.type-C.type:X(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){const C=R.get(this.c);if(typeof C=="boolean"){const k=C?"true":"false";return this.d===k?s.INSTANCE:i.INSTANCE}return this}evaluate(C){return C.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(C){return C.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=g.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=c;class y{static create(C,k){return new y(C,k)}constructor(C,k){this.d=C,this.f=k,this.type=10,this.c=null}cmp(C){return C.type!==this.type?this.type-C.type:X(this.d,this.f,C.d,C.f)}equals(C){return C.type===this.type?this.d===C.d&&this.f===C.f:!1}substituteConstants(){return this}evaluate(C){const k=C.getValue(this.f),M=C.getValue(this.d);return Array.isArray(k)?k.includes(M):typeof M=="string"&&typeof k=="object"&&k!==null?I.call(k,M):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(C){return C.mapIn(this.d,this.f)}negate(){return this.c||(this.c=b.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=y;class b{static create(C,k){return new b(C,k)}constructor(C,k){this.d=C,this.f=k,this.type=11,this.c=y.create(C,k)}cmp(C){return C.type!==this.type?this.type-C.type:this.c.cmp(C.c)}equals(C){return C.type===this.type?this.c.equals(C.c):!1}substituteConstants(){return this}evaluate(C){return!this.c.evaluate(C)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(C){return C.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=b;class g{static create(C,k,M=null){if(typeof k=="boolean")return k?D.create(C,M):o.create(C,M);const z=R.get(C);return typeof z=="boolean"?k===(z?"true":"false")?i.INSTANCE:s.INSTANCE:new g(C,k,M)}constructor(C,k,M){this.c=C,this.d=k,this.f=M,this.type=5}cmp(C){return C.type!==this.type?this.type-C.type:X(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){const C=R.get(this.c);if(typeof C=="boolean"){const k=C?"true":"false";return this.d===k?i.INSTANCE:s.INSTANCE}return this}evaluate(C){return C.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(C){return C.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=c.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=g;class D{static create(C,k=null){const M=R.get(C);return typeof M=="boolean"?M?i.INSTANCE:s.INSTANCE:new D(C,k)}constructor(C,k){this.c=C,this.d=k,this.type=3}cmp(C){return C.type!==this.type?this.type-C.type:$(this.c,C.c)}equals(C){return C.type===this.type?this.c===C.c:!1}substituteConstants(){const C=R.get(this.c);return typeof C=="boolean"?C?i.INSTANCE:s.INSTANCE:this}evaluate(C){return!C.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(C){return C.mapNot(this.c)}negate(){return this.d||(this.d=o.create(this.c,this)),this.d}}e.ContextKeyNotExpr=D;function A(q,C){if(typeof q=="string"){const k=parseFloat(q);isNaN(k)||(q=k)}return typeof q=="string"||typeof q=="number"?C(q):i.INSTANCE}class F{static create(C,k,M=null){return A(k,z=>new F(C,z,M))}constructor(C,k,M){this.c=C,this.d=k,this.f=M,this.type=12}cmp(C){return C.type!==this.type?this.type-C.type:X(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){return this}evaluate(C){return typeof this.d=="string"?!1:parseFloat(C.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(C){return C.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=F;class j{static create(C,k,M=null){return A(k,z=>new j(C,z,M))}constructor(C,k,M){this.c=C,this.d=k,this.f=M,this.type=13}cmp(C){return C.type!==this.type?this.type-C.type:X(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){return this}evaluate(C){return typeof this.d=="string"?!1:parseFloat(C.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(C){return C.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=x.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=j;class x{static create(C,k,M=null){return A(k,z=>new x(C,z,M))}constructor(C,k,M){this.c=C,this.d=k,this.f=M,this.type=14}cmp(C){return C.type!==this.type?this.type-C.type:X(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){return this}evaluate(C){return typeof this.d=="string"?!1:parseFloat(C.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(C){return C.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=x;class V{static create(C,k,M=null){return A(k,z=>new V(C,z,M))}constructor(C,k,M){this.c=C,this.d=k,this.f=M,this.type=15}cmp(C){return C.type!==this.type?this.type-C.type:X(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){return this}evaluate(C){return typeof this.d=="string"?!1:parseFloat(C.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(C){return C.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=V;class B{static create(C,k){return new B(C,k)}constructor(C,k){this.d=C,this.f=k,this.type=7,this.c=null}cmp(C){if(C.type!==this.type)return this.type-C.type;if(this.d<C.d)return-1;if(this.d>C.d)return 1;const k=this.f?this.f.source:"",M=C.f?C.f.source:"";return k<M?-1:k>M?1:0}equals(C){if(C.type===this.type){const k=this.f?this.f.source:"",M=C.f?C.f.source:"";return this.d===C.d&&k===M}return!1}substituteConstants(){return this}evaluate(C){const k=C.getValue(this.d);return this.f?this.f.test(k):!1}serialize(){const C=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${C}`}keys(){return[this.d]}map(C){return C.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=Z.create(this)),this.c}}e.ContextKeyRegexExpr=B;class Z{static create(C){return new Z(C)}constructor(C){this.c=C,this.type=8}cmp(C){return C.type!==this.type?this.type-C.type:this.c.cmp(C.c)}equals(C){return C.type===this.type?this.c.equals(C.c):!1}substituteConstants(){return this}evaluate(C){return!this.c.evaluate(C)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(C){return new Z(this.c.map(C))}negate(){return this.c}}e.ContextKeyNotRegexExpr=Z;function J(q){let C=null;for(let k=0,M=q.length;k<M;k++){const z=q[k].substituteConstants();if(q[k]!==z&&C===null){C=[];for(let _=0;_<k;_++)C[_]=q[_]}C!==null&&(C[k]=z)}return C===null?q:C}class K{static create(C,k,M){return K.d(C,k,M)}constructor(C,k){this.expr=C,this.c=k,this.type=6}cmp(C){if(C.type!==this.type)return this.type-C.type;if(this.expr.length<C.expr.length)return-1;if(this.expr.length>C.expr.length)return 1;for(let k=0,M=this.expr.length;k<M;k++){const z=t(this.expr[k],C.expr[k]);if(z!==0)return z}return 0}equals(C){if(C.type===this.type){if(this.expr.length!==C.expr.length)return!1;for(let k=0,M=this.expr.length;k<M;k++)if(!this.expr[k].equals(C.expr[k]))return!1;return!0}return!1}substituteConstants(){const C=J(this.expr);return C===this.expr?this:K.create(C,this.c,!1)}evaluate(C){for(let k=0,M=this.expr.length;k<M;k++)if(!this.expr[k].evaluate(C))return!1;return!0}static d(C,k,M){const z=[];let _=!1;for(const W of C)if(!!W){if(W.type===1){_=!0;continue}if(W.type===0)return i.INSTANCE;if(W.type===6){z.push(...W.expr);continue}z.push(W)}if(z.length===0&&_)return s.INSTANCE;if(z.length!==0){if(z.length===1)return z[0];z.sort(t);for(let W=1;W<z.length;W++)z[W-1].equals(z[W])&&(z.splice(W,1),W--);if(z.length===1)return z[0];for(;z.length>1;){const W=z[z.length-1];if(W.type!==9)break;z.pop();const Q=z.pop(),ee=z.length===0,le=Y.create(W.expr.map(he=>K.create([he,Q],null,M)),null,ee);le&&(z.push(le),z.sort(t))}if(z.length===1)return z[0];if(M){for(let W=0;W<z.length;W++)for(let Q=W+1;Q<z.length;Q++)if(z[W].negate().equals(z[Q]))return i.INSTANCE;if(z.length===1)return z[0]}return new K(z,k)}}serialize(){return this.expr.map(C=>C.serialize()).join(" && ")}keys(){const C=[];for(const k of this.expr)C.push(...k.keys());return C}map(C){return new K(this.expr.map(k=>k.map(C)),null)}negate(){if(!this.c){const C=[];for(const k of this.expr)C.push(k.negate());this.c=Y.create(C,this,!0)}return this.c}}class Y{static create(C,k,M){return Y.d(C,k,M)}constructor(C,k){this.expr=C,this.c=k,this.type=9}cmp(C){if(C.type!==this.type)return this.type-C.type;if(this.expr.length<C.expr.length)return-1;if(this.expr.length>C.expr.length)return 1;for(let k=0,M=this.expr.length;k<M;k++){const z=t(this.expr[k],C.expr[k]);if(z!==0)return z}return 0}equals(C){if(C.type===this.type){if(this.expr.length!==C.expr.length)return!1;for(let k=0,M=this.expr.length;k<M;k++)if(!this.expr[k].equals(C.expr[k]))return!1;return!0}return!1}substituteConstants(){const C=J(this.expr);return C===this.expr?this:Y.create(C,this.c,!1)}evaluate(C){for(let k=0,M=this.expr.length;k<M;k++)if(this.expr[k].evaluate(C))return!0;return!1}static d(C,k,M){let z=[],_=!1;if(C){for(let W=0,Q=C.length;W<Q;W++){const ee=C[W];if(!!ee){if(ee.type===0){_=!0;continue}if(ee.type===1)return s.INSTANCE;if(ee.type===9){z=z.concat(ee.expr);continue}z.push(ee)}}if(z.length===0&&_)return i.INSTANCE;z.sort(t)}if(z.length!==0){if(z.length===1)return z[0];for(let W=1;W<z.length;W++)z[W-1].equals(z[W])&&(z.splice(W,1),W--);if(z.length===1)return z[0];if(M){for(let W=0;W<z.length;W++)for(let Q=W+1;Q<z.length;Q++)if(z[W].negate().equals(z[Q]))return s.INSTANCE;if(z.length===1)return z[0]}return new Y(z,k)}}serialize(){return this.expr.map(C=>C.serialize()).join(" || ")}keys(){const C=[];for(const k of this.expr)C.push(...k.keys());return C}map(C){return new Y(this.expr.map(k=>k.map(C)),null)}negate(){if(!this.c){const C=[];for(const k of this.expr)C.push(k.negate());for(;C.length>1;){const k=C.shift(),M=C.shift(),z=[];for(const _ of ae(k))for(const W of ae(M))z.push(K.create([_,W],null,!1));C.unshift(Y.create(z,null,!1))}this.c=Y.create(C,this,!0)}return this.c}}class H extends o{static all(){return H.d.values()}constructor(C,k,M){super(C,null),this.f=k,typeof M=="object"?H.d.push({...M,key:C}):M!==!0&&H.d.push({key:C,description:M,type:k!=null?typeof k:void 0})}bindTo(C){return C.createKey(this.key,this.f)}getValue(C){return C.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(C){return c.create(this.key,C)}notEqualsTo(C){return g.create(this.key,C)}}H.d=[],e.RawContextKey=H,e.IContextKeyService=(0,T.createDecorator)("contextKeyService");function $(q,C){return q<C?-1:q>C?1:0}function X(q,C,k,M){return q<k?-1:q>k?1:C<M?-1:C>M?1:0}function ie(q,C){if(q.type===0||C.type===1)return!0;if(q.type===9)return C.type===9?se(q.expr,C.expr):!1;if(C.type===9){for(const k of C.expr)if(ie(q,k))return!0;return!1}if(q.type===6){if(C.type===6)return se(C.expr,q.expr);for(const k of q.expr)if(ie(k,C))return!0;return!1}return q.equals(C)}e.implies=ie;function se(q,C){let k=0,M=0;for(;k<q.length&&M<C.length;){const z=q[k].cmp(C[M]);if(z<0)return!1;z===0&&k++,M++}return k===q.length}function ae(q){return q.type===9?q.expr:[q]}}),define(re[99],oe([0,1,5]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,O.createDecorator)(e.ID);function U(T){return!!T.hostName&&!!T.errorMessage}e.isRemoteDiagnosticError=U;class l{async getPerformanceInfo(N,R){return{}}async getSystemInfo(N,R){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(N,R){return""}async getWorkspaceFileExtensions(N){return{extensions:[]}}async reportWorkspaceStats(N){}}e.NullDiagnosticsService=l}),define(re[100],oe([0,1,5]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,O.createDecorator)("downloadService")}),define(re[15],oe([0,1,5]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,O.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,O.refineServiceDecorator)(e.IEnvironmentService)}),define(re[29],oe([0,1,160,5]),function(te,e,O,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function l(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=l;function T(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=T;function N(u,h){switch(u){case 3:return h==="x64"?"win32-x64":h==="ia32"?"win32-ia32":h==="arm64"?"win32-arm64":"unknown";case 2:return h==="x64"?"linux-x64":h==="arm64"?"linux-arm64":h==="arm"?"linux-armhf":"unknown";case"alpine":return h==="x64"?"alpine-x64":h==="arm64"?"alpine-arm64":"unknown";case 1:return h==="x64"?"darwin-x64":h==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=N;function R(u,h){return h==="web"&&!u.includes("web")}e.isNotWebExtensionInWebTargetPlatform=R;function I(u,h,d){return R(h,d)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===d?!0:w(d).includes(u)}e.isTargetPlatformCompatible=I;function w(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=w;function P(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=P;var S;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(S=e.SortBy||(e.SortBy={}));var p;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(p=e.SortOrder||(e.SortOrder={}));var f;(function(u){u.Install="install",u.Uninstall="uninstall"})(f=e.StatisticType||(e.StatisticType={}));var m;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(m=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,U.createDecorator)("extensionGalleryService");var E;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Internal="Internal",u.Signature="Signature"})(E=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class a extends Error{constructor(h,d){super(h),this.code=d,this.name=d}}e.ExtensionManagementError=a,e.IExtensionManagementService=(0,U.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,U.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,U.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,O.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,O.localize)(1,null),original:"Preferences"}}),define(re[201],oe([0,1,3,2,32,11,94,29]),function(te,e,O,U,l,T,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function I(a,u){return a?T.URI.revive(u?u.transformIncoming(a):a):void 0}function w(a,u){return u?u.transformOutgoingURI(a):a}function P(a,u){u=u||N.DefaultURITransformer;const h=a.manifest;return{...(0,N.transformAndReviveIncomingURIs)({...a,manifest:void 0},u),manifest:h}}function S(a,u){return a?.profileLocation?(0,N.transformAndReviveIncomingURIs)(a,u??N.DefaultURITransformer):a}function p(a,u){return u?(0,l.cloneAndChange)(a,h=>h instanceof T.URI?u.transformOutgoingURI(h):void 0):a}class f{constructor(u,h){this.a=u,this.b=h,this.onInstallExtension=O.Event.buffer(u.onInstallExtension,!0),this.onDidInstallExtensions=O.Event.buffer(u.onDidInstallExtensions,!0),this.onUninstallExtension=O.Event.buffer(u.onUninstallExtension,!0),this.onDidUninstallExtension=O.Event.buffer(u.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=O.Event.buffer(u.onDidUpdateExtensionMetadata,!0)}listen(u,h){const d=this.b(u);switch(h){case"onInstallExtension":return O.Event.map(this.onInstallExtension,v=>({...v,profileLocation:v.profileLocation?w(v.profileLocation,d):v.profileLocation}));case"onDidInstallExtensions":return O.Event.map(this.onDidInstallExtensions,v=>v.map(L=>({...L,local:L.local?p(L.local,d):L.local,profileLocation:L.profileLocation?w(L.profileLocation,d):L.profileLocation})));case"onUninstallExtension":return O.Event.map(this.onUninstallExtension,v=>({...v,profileLocation:v.profileLocation?w(v.profileLocation,d):v.profileLocation}));case"onDidUninstallExtension":return O.Event.map(this.onDidUninstallExtension,v=>({...v,profileLocation:v.profileLocation?w(v.profileLocation,d):v.profileLocation}));case"onDidUpdateExtensionMetadata":return O.Event.map(this.onDidUpdateExtensionMetadata,v=>p(v,d))}throw new Error("Invalid listen")}async call(u,h,d){const v=this.b(u);switch(h){case"zip":{const L=P(d[0],v),n=await this.a.zip(L);return w(n,v)}case"unzip":return this.a.unzip(I(d[0],v));case"install":return this.a.install(I(d[0],v),S(d[1],v));case"installFromLocation":return this.a.installFromLocation(I(d[0],v),I(d[1],v));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(d[0],I(d[1],v),I(d[2],v));case"getManifest":return this.a.getManifest(I(d[0],v));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(d[0]);case"installFromGallery":return this.a.installFromGallery(d[0],S(d[1],v));case"uninstall":return this.a.uninstall(P(d[0],v),S(d[1],v));case"reinstallFromGallery":return this.a.reinstallFromGallery(P(d[0],v));case"getInstalled":return(await this.a.getInstalled(d[0],I(d[1],v))).map(n=>p(n,v));case"copyExtensions":return this.a.copyExtensions(I(d[0],v),I(d[1],v));case"updateMetadata":{const L=await this.a.updateMetadata(P(d[0],v),d[1],I(d[2],v));return p(L,v)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(d[0],d[1]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=f;class m extends U.Disposable{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(u){super(),this.k=u,this.c=this.D(new O.Emitter),this.f=this.D(new O.Emitter),this.g=this.D(new O.Emitter),this.h=this.D(new O.Emitter),this.j=this.D(new O.Emitter),this.D(this.k.listen("onInstallExtension")(h=>this.l(this.c,{...h,source:this.m(h.source)?T.URI.revive(h.source):h.source,profileLocation:T.URI.revive(h.profileLocation)}))),this.D(this.k.listen("onDidInstallExtensions")(h=>this.l(this.f,h.map(d=>({...d,local:d.local?P(d.local,null):d.local,source:this.m(d.source)?T.URI.revive(d.source):d.source,profileLocation:T.URI.revive(d.profileLocation)}))))),this.D(this.k.listen("onUninstallExtension")(h=>this.l(this.g,{...h,profileLocation:T.URI.revive(h.profileLocation)}))),this.D(this.k.listen("onDidUninstallExtension")(h=>this.l(this.h,{...h,profileLocation:T.URI.revive(h.profileLocation)}))),this.D(this.k.listen("onDidUpdateExtensionMetadata")(h=>this.j.fire(P(h,null))))}l(u,h){u.fire(h)}m(u){return u?typeof u.path=="string"&&typeof u.scheme=="string":!1}getTargetPlatform(){return this.n||(this.n=this.k.call("getTargetPlatform")),this.n}async canInstall(u){const h=await this.getTargetPlatform();return u.allTargetPlatforms.some(d=>(0,R.isTargetPlatformCompatible)(d,u.allTargetPlatforms,h))}zip(u){return Promise.resolve(this.k.call("zip",[u]).then(h=>T.URI.revive(h)))}unzip(u){return Promise.resolve(this.k.call("unzip",[u]))}install(u,h){return Promise.resolve(this.k.call("install",[u,h])).then(d=>P(d,null))}installFromLocation(u,h){return Promise.resolve(this.k.call("installFromLocation",[u,h])).then(d=>P(d,null))}async installExtensionsFromProfile(u,h,d){return(await this.k.call("installExtensionsFromProfile",[u,h,d])).map(L=>P(L,null))}getManifest(u){return Promise.resolve(this.k.call("getManifest",[u]))}installFromGallery(u,h){return Promise.resolve(this.k.call("installFromGallery",[u,h])).then(d=>P(d,null))}uninstall(u,h){return Promise.resolve(this.k.call("uninstall",[u,h]))}reinstallFromGallery(u){return Promise.resolve(this.k.call("reinstallFromGallery",[u])).then(h=>P(h,null))}getInstalled(u=null,h){return Promise.resolve(this.k.call("getInstalled",[u,h])).then(d=>d.map(v=>P(v,null)))}updateMetadata(u,h,d){return Promise.resolve(this.k.call("updateMetadata",[u,h,d])).then(v=>P(v,null))}copyExtensions(u,h){return this.k.call("copyExtensions",[u,h])}getExtensionsControlManifest(){return Promise.resolve(this.k.call("getExtensionsControlManifest"))}async download(u,h){const d=await this.k.call("download",[u,h]);return T.URI.revive(d)}async cleanUp(){return this.k.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=m;class E{constructor(u){this.a=u}listen(u,h){throw new Error("Invalid listen")}call(u,h,d){switch(h){case"getConfigBasedTips":return this.a.getConfigBasedTips(T.URI.revive(d[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=E}),define(re[101],oe([0,1,5]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,O.createDecorator)("IExtensionSignatureVerificationService");class U{b(){return this.a||(this.a=new Promise((T,N)=>te(["node-vsce-sign"],async R=>T(R),N))),this.a}async verify(T,N,R){let I;try{I=await this.b()}catch{return!1}return I.verify(T,N,R)}}e.ExtensionSignatureVerificationService=U}),define(re[102],oe([0,1,5]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var U;(function(N){N[N.FILE=1]="FILE",N[N.WORKSPACE=2]="WORKSPACE",N[N.EXE=3]="EXE"})(U=e.RecommendationSource||(e.RecommendationSource={}));function l(N){switch(N){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=l;var T;(function(N){N.Ignored="ignored",N.Cancelled="cancelled",N.TooMany="toomany",N.IncompatibleWindow="incompatibleWindow",N.Accepted="reacted"})(T=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,O.createDecorator)("IExtensionRecommendationNotificationService")}),define(re[14],oe([0,1,49,13,27,12,11,168,5,4,22]),function(te,e,O,U,l,T,N,R,I,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,I.createDecorator)("fileService");function S($){return $.create===!0}e.isFileOpenForWriteOptions=S;var p;(function($){$[$.Unknown=0]="Unknown",$[$.File=1]="File",$[$.Directory=2]="Directory",$[$.SymbolicLink=64]="SymbolicLink"})(p=e.FileType||(e.FileType={}));var f;(function($){$[$.Readonly=1]="Readonly"})(f=e.FilePermission||(e.FilePermission={}));var m;(function($){$[$.None=0]="None",$[$.FileReadWrite=2]="FileReadWrite",$[$.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",$[$.FileReadStream=16]="FileReadStream",$[$.FileFolderCopy=8]="FileFolderCopy",$[$.PathCaseSensitive=1024]="PathCaseSensitive",$[$.Readonly=2048]="Readonly",$[$.Trash=4096]="Trash",$[$.FileWriteUnlock=8192]="FileWriteUnlock",$[$.FileAtomicRead=16384]="FileAtomicRead",$[$.FileClone=32768]="FileClone"})(m=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function E($){return!!($.capabilities&2)}e.hasReadWriteCapability=E;function a($){return!!($.capabilities&8)}e.hasFileFolderCopyCapability=a;function u($){return!!($.capabilities&32768)}e.hasFileCloneCapability=u;function h($){return!!($.capabilities&4)}e.hasOpenReadWriteCloseCapability=h;function d($){return!!($.capabilities&16)}e.hasFileReadStreamCapability=d;function v($){return E($)?!!($.capabilities&16384):!1}e.hasFileAtomicReadCapability=v;var L;(function($){$.FileExists="EntryExists",$.FileNotFound="EntryNotFound",$.FileNotADirectory="EntryNotADirectory",$.FileIsADirectory="EntryIsADirectory",$.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",$.FileTooLarge="EntryTooLarge",$.FileWriteLocked="EntryWriteLocked",$.NoPermissions="NoPermissions",$.Unavailable="Unavailable",$.Unknown="Unknown"})(L=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class n extends Error{static create(X,ie){const se=new n(X.toString(),ie);return i(se,ie),se}constructor(X,ie){super(X),this.code=ie}}e.FileSystemProviderError=n;function r($,X){return n.create($,X)}e.createFileSystemProviderError=r;function t($){return $||r((0,R.localize)(0,null),L.Unknown)}e.ensureFileSystemProviderError=t;function i($,X){return $.name=X?`${X} (FileSystemError)`:"FileSystemError",$}e.markAsFileSystemProviderError=i;function s($){if(!$)return L.Unknown;if($ instanceof n)return $.code;const X=/^(.+) \(FileSystemError\)$/.exec($.name);if(!X)return L.Unknown;switch(X[1]){case L.FileExists:return L.FileExists;case L.FileIsADirectory:return L.FileIsADirectory;case L.FileNotADirectory:return L.FileNotADirectory;case L.FileNotFound:return L.FileNotFound;case L.FileExceedsMemoryLimit:return L.FileExceedsMemoryLimit;case L.FileTooLarge:return L.FileTooLarge;case L.FileWriteLocked:return L.FileWriteLocked;case L.NoPermissions:return L.NoPermissions;case L.Unavailable:return L.Unavailable}return L.Unknown}e.toFileSystemProviderErrorCode=s;function o($){if($ instanceof A)return $.fileOperationResult;switch(s($)){case L.FileNotFound:return 1;case L.FileIsADirectory:return 0;case L.FileNotADirectory:return 10;case L.FileWriteLocked:return 5;case L.NoPermissions:return 6;case L.FileExists:return 4;case L.FileExceedsMemoryLimit:return 9;case L.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=o;var c;(function($){$[$.CREATE=0]="CREATE",$[$.DELETE=1]="DELETE",$[$.MOVE=2]="MOVE",$[$.COPY=3]="COPY",$[$.WRITE=4]="WRITE"})(c=e.FileOperation||(e.FileOperation={}));class y{constructor(X,ie,se){this.resource=X,this.operation=ie,this.target=se}isOperation(X){return this.operation===X}}e.FileOperationEvent=y;var b;(function($){$[$.UPDATED=0]="UPDATED",$[$.ADDED=1]="ADDED",$[$.DELETED=2]="DELETED"})(b=e.FileChangeType||(e.FileChangeType={}));class g{constructor(X,ie){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const se=new Map;for(const ae of X){const q=se.get(ae.type);switch(q?q.push([ae.resource,ae]):se.set(ae.type,[[ae.resource,ae]]),ae.type){case 1:this.rawAdded.push(ae.resource);break;case 0:this.rawUpdated.push(ae.resource);break;case 2:this.rawDeleted.push(ae.resource);break}}for(const[ae,q]of se)switch(ae){case 1:this.a=O.TernarySearchTree.forUris(()=>ie),this.a.fill(q);break;case 0:this.b=O.TernarySearchTree.forUris(()=>ie),this.b.fill(q);break;case 2:this.c=O.TernarySearchTree.forUris(()=>ie),this.c.fill(q);break}}contains(X,...ie){return this.d(X,{includeChildren:!1},...ie)}affects(X,...ie){return this.d(X,{includeChildren:!0},...ie)}d(X,ie,...se){if(!X)return!1;const ae=se.length>0;return!!((!ae||se.includes(1))&&(this.a?.get(X)||ie.includeChildren&&this.a?.findSuperstr(X))||(!ae||se.includes(0))&&(this.b?.get(X)||ie.includeChildren&&this.b?.findSuperstr(X))||(!ae||se.includes(2))&&(this.c?.findSubstr(X)||ie.includeChildren&&this.c?.findSuperstr(X)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=g;function D($,X,ie){return!$||!X||$===X||X.length>$.length?!1:(X.charAt(X.length-1)!==U.sep&&(X+=U.sep),ie?(0,l.startsWithIgnoreCase)($,X):$.indexOf(X)===0)}e.isParent=D;class A extends Error{constructor(X,ie,se){super(X),this.fileOperationResult=ie,this.options=se}}e.FileOperationError=A;class F extends A{constructor(X,ie,se,ae){super(X,ie,ae),this.fileOperationResult=ie,this.size=se}}e.TooLargeFileOperationError=F;class j extends A{constructor(X,ie,se){super(X,2,se),this.stat=ie}}e.NotModifiedSinceFileOperationError=j;var x;(function($){$[$.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",$[$.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",$[$.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",$[$.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",$[$.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",$[$.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",$[$.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",$[$.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",$[$.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",$[$.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",$[$.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",$[$.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(x=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var V;(function($){$[$.FILE=0]="FILE",$[$.FOLDER=1]="FOLDER",$[$.ROOT_FOLDER=2]="ROOT_FOLDER"})(V=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function B($){if(!(typeof $.size!="number"||typeof $.mtime!="number"))return $.mtime.toString(29)+$.size.toString(31)}e.etag=B;async function Z($,X){if(!X.hasProvider(N.URI.from({scheme:$.scheme})))return new Promise(ie=>{const se=X.onDidChangeFileSystemProviderRegistrations(ae=>{ae.scheme===$.scheme&&ae.added&&(se.dispose(),ie())})})}e.whenProviderRegistered=Z,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class J{static formatSize(X){return(0,T.isNumber)(X)||(X=0),X<J.KB?(0,R.localize)(1,null,X.toFixed(0)):X<J.MB?(0,R.localize)(2,null,(X/J.KB).toFixed(2)):X<J.GB?(0,R.localize)(3,null,(X/J.MB).toFixed(2)):X<J.TB?(0,R.localize)(4,null,(X/J.GB).toFixed(2)):(0,R.localize)(5,null,(X/J.TB).toFixed(2))}}J.KB=1024,J.MB=J.KB*J.KB,J.GB=J.MB*J.KB,J.TB=J.GB*J.KB,e.ByteSize=J;var K;(function($){$[$.IA32=0]="IA32",$[$.OTHER=1]="OTHER"})(K=e.Arch||(e.Arch={}));function Y($){return{maxFileSize:$===0?300*J.MB:16*J.GB,maxHeapSize:$===0?700*J.MB:2*700*J.MB}}e.getPlatformFileLimits=Y;function H($){const X=typeof $=="string"||$?.scheme===P.Schemas.vscodeRemote;return typeof $!="string"&&$?.scheme===P.Schemas.file?1024*J.MB:X?10*J.MB:w.isWeb?50*J.MB:1024*J.MB}e.getLargeFileConfirmationLimit=H});var G=this&&this.__param||function(te,e){return function(O,U){e(O,U,te)}};define(re[202],oe([0,1,71,43,14]),function(te,e,O,U,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let T=class{constructor(R){this.a=R}async checksum(R){const I=(await this.a.readFileStream(R)).value;return new Promise((w,P)=>{const S=(0,O.createHash)("md5");(0,U.listenStream)(I,{onData:p=>S.update(p.buffer),onError:p=>P(p),onEnd:()=>w(S.digest("base64").replace(/=+$/,""))})})}};T=ye([G(0,l.IFileService)],T),e.ChecksumService=T}),define(re[203],oe([0,1,16,38,10,3,2,43,11,31,14]),function(te,e,O,U,l,T,N,R,I,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class S extends N.Disposable{constructor(f,m){super(),this.a=f,this.b=m,this.onDidChangeCapabilities=T.Event.None,this.f=this.D(new T.Emitter),this.onDidChangeFile=this.f.event,this.g=this.D(new T.Emitter),this.onDidWatchError=this.g.event,this.h=(0,w.generateUuid)(),this.i()}get capabilities(){return this.c||(this.c=57374,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(f){return this.a.call("stat",[f])}readdir(f){return this.a.call("readdir",[f])}async readFile(f,m){const{buffer:E}=await this.a.call("readFile",[f,m]);return E}readFileStream(f,m,E){const a=(0,R.newWriteableStream)(h=>O.VSBuffer.concat(h.map(d=>O.VSBuffer.wrap(d))).buffer),u=this.a.listen("readFileStream",[f,m])(h=>{if(h instanceof O.VSBuffer)a.write(h.buffer);else{if(h==="end")a.end();else{let d;if(h instanceof Error)d=h;else{const v=h;d=(0,P.createFileSystemProviderError)(v.message??(0,U.toErrorMessage)(v),v.code??P.FileSystemProviderErrorCode.Unknown)}a.error(d),a.end()}u.dispose()}});return E.onCancellationRequested(()=>{a.error((0,l.canceled)()),a.end(),u.dispose()}),a}writeFile(f,m,E){return this.a.call("writeFile",[f,O.VSBuffer.wrap(m),E])}open(f,m){return this.a.call("open",[f,m])}close(f){return this.a.call("close",[f])}async read(f,m,E,a,u){const[h,d]=await this.a.call("read",[f,m,u]);return E.set(h.buffer.slice(0,d),a),d}write(f,m,E,a,u){return this.a.call("write",[f,m,O.VSBuffer.wrap(E),a,u])}mkdir(f){return this.a.call("mkdir",[f])}delete(f,m){return this.a.call("delete",[f,m])}rename(f,m,E){return this.a.call("rename",[f,m,E])}copy(f,m,E){return this.a.call("copy",[f,m,E])}cloneFile(f,m){return this.a.call("cloneFile",[f,m])}i(){this.D(this.a.listen("fileChange",[this.h])(f=>{if(Array.isArray(f)){const m=f;this.f.fire(m.map(E=>({resource:I.URI.revive(E.resource),type:E.type})))}else{const m=f;this.g.fire(m)}}))}watch(f,m){const E=(0,w.generateUuid)();return this.a.call("watch",[this.h,E,f,m]),(0,N.toDisposable)(()=>this.a.call("unwatch",[this.h,E]))}}e.DiskFileSystemProviderClient=S}),define(re[103],oe([0,1,16,10,169,14]),function(te,e,O,U,l,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function N(P,S,p,f,m,E){let a;try{await R(P,S,p,f,m,E)}catch(u){a=u}finally{a&&m.errorTransformer&&(a=m.errorTransformer(a)),typeof a<"u"&&p.error(a),p.end()}}e.readFileIntoStream=N;async function R(P,S,p,f,m,E){I(E);const a=await P.open(S,{create:!1});try{I(E);let u=0,h=0,d=m&&typeof m.length=="number"?m.length:void 0,v=O.VSBuffer.alloc(Math.min(m.bufferSize,typeof d=="number"?d:m.bufferSize)),L=m&&typeof m.position=="number"?m.position:0,n=0;do h=await P.read(a,L,v.buffer,n,v.byteLength-n),L+=h,n+=h,u+=h,typeof d=="number"&&(d-=h),n===v.byteLength&&(await p.write(f(v)),v=O.VSBuffer.alloc(Math.min(m.bufferSize,typeof d=="number"?d:m.bufferSize)),n=0);while(h>0&&(typeof d!="number"||d>0)&&I(E)&&w(u,m));if(n>0){let r=n;typeof d=="number"&&(r=Math.min(n,d)),p.write(f(v.slice(0,r)))}}catch(u){throw(0,T.ensureFileSystemProviderError)(u)}finally{await P.close(a)}}function I(P){if(P.isCancellationRequested)throw(0,U.canceled)();return!0}function w(P,S){if(S?.limits){if(typeof S.limits.memory=="number"&&P>S.limits.memory)throw(0,T.createFileSystemProviderError)((0,l.localize)(0,null),T.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof S.limits.size=="number"&&P>S.limits.size)throw(0,T.createFileSystemProviderError)((0,l.localize)(1,null),T.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(re[56],oe([0,1,93,2,13,4,11,14]),function(te,e,O,U,l,T,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function I(u){return u.recursive===!0}e.isRecursiveWatchRequest=I;class w extends U.Disposable{constructor(h,d,v,L){super(),this.h=h,this.i=d,this.j=v,this.k=L,this.c=this.D(new U.MutableDisposable),this.f=void 0,this.g=0}m(){const h=new U.DisposableStore;this.c.value=h,this.b=this.l(h),this.b.setVerboseLogging(this.j),h.add(this.b.onDidChangeFile(d=>this.h(d))),h.add(this.b.onDidLogMessage(d=>this.i(d))),h.add(this.b.onDidError(d=>this.n(d)))}n(h){this.k.restartOnError?this.g<w.a&&this.f?(this.q(`restarting watcher after error: ${h}`),this.p(this.f)):this.q(`gave up attempting to restart watcher after error: ${h}`):this.q(h)}p(h){this.g++,this.m(),this.watch(h)}async watch(h){this.f=h,await this.b?.watch(h)}async setVerboseLogging(h){this.j=h,await this.b?.setVerboseLogging(h)}q(h){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${h}`})}r(h){this.i({type:"trace",message:`[File Watcher (${this.k.type})] ${h}`})}dispose(){return this.b=void 0,super.dispose()}}w.a=5,e.AbstractWatcherClient=w;class P extends w{constructor(h,d,v){super(h,d,v,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=P;class S extends w{constructor(h,d,v){super(h,d,v,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=S;function p(u){return u.map(h=>({type:h.type,resource:N.URI.file(h.path)}))}e.toFileChanges=p;function f(u){const h=new a;for(const d of u)h.processEvent(d);return h.coalesce()}e.coalesceEvents=f;function m(u,h){return typeof h=="string"&&!h.startsWith(O.GLOBSTAR)&&!(0,l.isAbsolute)(h)?{base:u,pattern:h}:h}e.normalizeWatcherPattern=m;function E(u,h){const d=[];for(const v of h)d.push((0,O.parse)(m(u,v)));return d}e.parseWatcherPatterns=E;class a{constructor(){this.a=new Set,this.b=new Map}c(h){return T.isLinux?h.path:h.path.toLowerCase()}processEvent(h){const d=this.b.get(this.c(h));let v=!1;if(d){const L=d.type,n=h.type;d.path!==h.path&&(h.type===2||h.type===1)?v=!0:L===1&&n===2?(this.b.delete(this.c(h)),this.a.delete(d)):L===2&&n===1?d.type=0:L===1&&n===0||(d.type=n)}else v=!0;v&&(this.a.add(h),this.b.set(this.c(h),h))}coalesce(){const h=[],d=[];return Array.from(this.a).filter(v=>v.type!==2?(h.push(v),!1):!0).sort((v,L)=>v.path.length-L.path.length).filter(v=>d.some(L=>(0,R.isParent)(v.path,L,!T.isLinux))?!1:(d.push(v.path),!0)).concat(h)}}}),define(re[204],oe([0,1,54,6,25,48,2,87,13,4,146,28,56]),function(te,e,O,U,l,T,N,R,I,w,P,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class f extends N.Disposable{constructor(a,u,h,d){super(),this.j=a,this.k=u,this.l=h,this.m=d,this.c=this.D(new U.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},v=>this.k(v))),this.f=this.D(new U.RunOnceWorker(v=>this.t(v),f.b)),this.g=(0,p.parseWatcherPatterns)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,p.parseWatcherPatterns)(this.j.path,this.j.includes):void 0,this.i=new l.CancellationTokenSource,this.ready=this.n()}async n(){try{const a=await this.q(this.j);if(this.i.token.isCancellationRequested)return;const u=await S.Promises.stat(a);this.D(await this.r(a,u.isDirectory()))}catch(a){a.code!=="ENOENT"?this.v(a):this.y(a)}}async q(a){let u=a.path;try{u=await S.Promises.realpath(a.path),a.path===u&&(u=await(0,P.realcase)(a.path)??a.path),a.path!==u&&this.y(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${a.path}, real: ${u})`)}catch{}return u}async r(a,u){if(w.isMacintosh&&(0,T.isEqualOrParent)(a,"/Volumes/",!0))return this.v(`Refusing to watch ${a} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),N.Disposable.None;const h=new l.CancellationTokenSource(this.i.token),d=new N.DisposableStore;try{const v=(0,I.basename)(a),L=(0,O.watch)(a);d.add((0,N.toDisposable)(()=>{L.removeAllListeners(),L.close()})),this.y(`Started watching: '${a}'`);const n=new Set;if(u)try{for(const t of await S.Promises.readdir(a))n.add(t)}catch(t){this.v(t)}const r=new Map;d.add((0,N.toDisposable)(()=>{for(const[,t]of r)t.dispose();r.clear()})),L.on("error",(t,i)=>{this.v(`Failed to watch ${a} for changes using fs.watch() (${t}, ${i})`),this.dispose()}),L.on("change",(t,i)=>{if(h.token.isCancellationRequested)return;this.y(`[raw] ["${t}"] ${i}`);let s="";if(i&&(s=i.toString(),w.isMacintosh&&(s=(0,R.normalizeNFC)(s))),!(!s||t!=="change"&&t!=="rename"))if(u)if(t==="rename"){r.get(s)?.dispose();const o=setTimeout(async()=>{if(r.delete(s),s===v&&!await S.Promises.exists(a)){this.w("Watcher shutdown because watched path got deleted"),this.dispose();return}const c=await this.u((0,I.join)(a,s));if(h.token.isCancellationRequested)return;let y;c?n.has(s)?y=0:(y=1,n.add(s)):(n.delete(s),y=2),this.s({path:(0,I.join)(this.j.path,s),type:y})},f.a);r.set(s,(0,N.toDisposable)(()=>clearTimeout(o)))}else{let o;n.has(s)?o=0:(o=1,n.add(s)),this.s({path:(0,I.join)(this.j.path,s),type:o})}else if(t==="rename"||s!==v){const o=setTimeout(async()=>{const c=await S.Promises.exists(a);h.token.isCancellationRequested||(c?(this.s({path:this.j.path,type:0},!0),d.add(await this.r(a,!1))):(this.s({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},f.a);d.clear(),d.add((0,N.toDisposable)(()=>clearTimeout(o)))}else this.s({path:this.j.path,type:0},!0)})}catch(v){await S.Promises.exists(a)&&!h.token.isCancellationRequested&&this.v(`Failed to watch ${a} for changes using fs.watch() (${v.toString()})`)}return(0,N.toDisposable)(()=>{h.dispose(!0),d.dispose()})}s(a,u=!1){this.i.token.isCancellationRequested||(this.m&&this.y(`${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.path}`),!u&&this.g.some(h=>h(a.path))?this.m&&this.y(` >> ignored (excluded) ${a.path}`):!u&&this.h&&this.h.length>0&&!this.h.some(h=>h(a.path))?this.m&&this.y(` >> ignored (not included) ${a.path}`):this.f.work(a))}t(a){const u=(0,p.coalesceEvents)(a);if(u.length>0){if(this.m)for(const d of u)this.y(`>> normalized ${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.path}`);this.c.work(u)?this.c.pending>0&&this.y(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.w(`started ignoring events due to too many file change events at once (incoming: ${u.length}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async u(a){if(w.isLinux)return S.Promises.exists(a);try{const u=(0,I.basename)(a);return(await S.Promises.readdir((0,I.dirname)(a))).some(d=>d===u)}catch(u){return this.y(u),!1}}setVerboseLogging(a){this.m=a}v(a){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${a}`})}w(a){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${a}`})}y(a){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${a}`})}dispose(){this.y(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}f.a=100,f.b=75,e.NodeJSFileWatcherLibrary=f;async function m(E,a,u,h,d=512){const v=await S.Promises.open(E,"r"),L=Buffer.allocUnsafe(d),n=new l.CancellationTokenSource(h);let r,t=!1;const i={path:E,excludes:[],recursive:!1},s=new f(i,o=>{(async()=>{for(const{type:c}of o)if(c===0){if(t)return;t=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:y}=await S.Promises.read(v,L,0,d,null);if(!y||n.token.isCancellationRequested)break;a(L.slice(0,y))}}catch(y){r=new Error(y),n.dispose(!0)}finally{t=!1}}})()});return await s.ready,u(),new Promise((o,c)=>{n.token.onCancellationRequested(async()=>{s.dispose();try{await S.Promises.close(v)}catch(y){r=new Error(y)}r?c(r):o()})})}e.watchFileContents=m}),define(re[205],oe([0,1,3,93,2,4,204]),function(te,e,O,U,l,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class R extends l.Disposable{constructor(){super(...arguments),this.a=this.D(new O.Emitter),this.onDidChangeFile=this.a.event,this.b=this.D(new O.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=O.Event.None,this.c=new Map,this.f=!1}async watch(w){const P=this.i(w),S=P.filter(f=>{const m=this.c.get(f.path);return m?!(0,U.patternsEquals)(m.request.excludes,f.excludes)||!(0,U.patternsEquals)(m.request.includes,f.includes):!0}),p=Array.from(this.c.values()).filter(({request:f})=>!P.find(m=>m.path===f.path&&(0,U.patternsEquals)(m.excludes,f.excludes)&&(0,U.patternsEquals)(m.includes,f.includes))).map(({request:f})=>f.path);S.length&&this.j(`Request to start watching: ${S.map(f=>`${f.path} (excludes: ${f.excludes.length>0?f.excludes:"<none>"}, includes: ${f.includes&&f.includes.length>0?JSON.stringify(f.includes):"<all>"})`).join(",")}`),p.length&&this.j(`Request to stop watching: ${p.join(",")}`);for(const f of p)this.h(f);for(const f of S)this.g(f)}g(w){const P=new N.NodeJSFileWatcherLibrary(w,p=>this.a.fire(p),p=>this.b.fire(p),this.f),S={request:w,instance:P};this.c.set(w.path,S)}async stop(){for(const[w]of this.c)this.h(w);this.c.clear()}h(w){const P=this.c.get(w);P&&(this.c.delete(w),P.instance.dispose())}i(w){const P=new Map;for(const S of w){const p=T.isLinux?S.path:S.path.toLowerCase();P.set(p,S)}return Array.from(P.values())}async setVerboseLogging(w){this.f=w;for(const[,P]of this.c)P.instance.setVerboseLogging(w)}j(w){this.f&&this.b.fire({type:"trace",message:this.k(w)})}k(w,P){return P?`[File Watcher (node.js)] ${w} (path: ${P.request.path})`:`[File Watcher (node.js)] ${w}`}}e.NodeJSWatcher=R}),define(re[206],oe([0,1,56,205]),function(te,e,O,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class l extends O.AbstractNonRecursiveWatcherClient{constructor(N,R,I){super(N,R,I),this.m()}l(){return new U.NodeJSWatcher}}e.NodeJSWatcherClient=l}),define(re[207],oe([0,1,22,39,66,56]),function(te,e,O,U,l,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class N extends T.AbstractUniversalWatcherClient{constructor(I,w,P){super(I,w,P),this.m()}l(I){const w=I.add(new l.Client(O.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return I.add(w.onDidProcessExit(({code:P,signal:S})=>this.n(`terminated by itself with code ${P}, signal: ${S}`))),U.ProxyChannel.toService((0,U.getNextTickChannel)(w.getChannel("watcher")))}}e.UniversalWatcherClient=N}),define(re[72],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class O{constructor(...l){this.a=new Map;for(const[T,N]of l)this.set(T,N)}set(l,T){const N=this.a.get(l);return this.a.set(l,T),N}has(l){return this.a.has(l)}get(l){return this.a.get(l)}}e.ServiceCollection=O}),define(re[208],oe([0,1,6,10,2,69,199,5,72,86]),function(te,e,O,U,l,T,N,R,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const P=!1;class S extends Error{constructor(a){super("cyclic dependency between services"),this.message=a.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class p{constructor(a=new I.ServiceCollection,u=!1,h,d=P){this.f=a,this.g=u,this.h=h,this.i=d,this.o=new Set,this.f.set(R.IInstantiationService,this),this._globalGraph=d?h?._globalGraph??new N.Graph(v=>v):void 0}createChild(a){return new p(a,this.g,this,this.i)}invokeFunction(a,...u){const h=m.traceInvocation(this.i,a);let d=!1;try{return a({get:L=>{if(d)throw(0,U.illegalState)("service accessor is only valid during the invocation of its target method");const n=this.m(L,h);if(!n)throw new Error(`[invokeFunction] unknown service '${L}'`);return n}},...u)}finally{d=!0,h.stop()}}createInstance(a,...u){let h,d;return a instanceof T.SyncDescriptor?(h=m.traceCreation(this.i,a.ctor),d=this.j(a.ctor,a.staticArguments.concat(u),h)):(h=m.traceCreation(this.i,a),d=this.j(a,u,h)),h.stop(),d}j(a,u=[],h){const d=R._util.getServiceDependencies(a).sort((n,r)=>n.index-r.index),v=[];for(const n of d){const r=this.m(n.id,h);r||this.u(`[createInstance] ${a.name} depends on UNKNOWN service ${n.id}.`,!1),v.push(r)}const L=d.length>0?d[0].index:u.length;if(u.length!==L){console.trace(`[createInstance] First service dependency of ${a.name} at position ${L+1} conflicts with ${u.length} static arguments`);const n=L-u.length;n>0?u=u.concat(new Array(n)):u=u.slice(0,L)}return Reflect.construct(a,u.concat(v))}k(a,u){if(this.f.get(a)instanceof T.SyncDescriptor)this.f.set(a,u);else if(this.h)this.h.k(a,u);else throw new Error("illegalState - setting UNKNOWN service instance")}l(a){const u=this.f.get(a);return!u&&this.h?this.h.l(a):u}m(a,u){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(a));const h=this.l(a);return h instanceof T.SyncDescriptor?this.q(a,h,u.branch(a,!0)):(u.branch(a,!1),h)}q(a,u,h){if(this.o.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this.o.add(a);try{return this.r(a,u,h)}finally{this.o.delete(a)}}r(a,u,h){const d=new N.Graph(n=>n.id.toString());let v=0;const L=[{id:a,desc:u,_trace:h}];for(;L.length;){const n=L.pop();if(d.lookupOrInsertNode(n),v++>1e3)throw new S(d);for(const r of R._util.getServiceDependencies(n.desc.ctor)){const t=this.l(r.id);if(t||this.u(`[createInstance] ${a} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(r.id)),t instanceof T.SyncDescriptor){const i={id:r.id,desc:t,_trace:n._trace.branch(r.id,!0)};d.insertEdge(n,i),L.push(i)}}}for(;;){const n=d.roots();if(n.length===0){if(!d.isEmpty())throw new S(d);break}for(const{data:r}of n){if(this.l(r.id)instanceof T.SyncDescriptor){const i=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,i)}d.removeNode(r)}}return this.l(a)}s(a,u,h=[],d,v){if(this.f.get(a)instanceof T.SyncDescriptor)return this.t(a,u,h,d,v);if(this.h)return this.h.s(a,u,h,d,v);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}t(a,u,h=[],d,v){if(d){const L=new p(void 0,this.g,this,this.i);L.c=String(a);const n=new Map,r=new O.IdleValue(()=>{const t=L.j(u,h,v);for(const[i,s]of n){const o=t[i];if(typeof o=="function")for(const c of s)o.apply(t,c)}return n.clear(),t});return new Proxy(Object.create(null),{get(t,i){if(!r.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let c=n.get(i);return c||(c=new w.LinkedList,n.set(i,c)),(b,g,D)=>{const A=c.push([b,g,D]);return(0,l.toDisposable)(A)}}if(i in t)return t[i];const s=r.value;let o=s[i];return typeof o!="function"||(o=o.bind(s),t[i]=o),o},set(t,i,s){return r.value[i]=s,!0},getPrototypeOf(t){return u.prototype}})}else return this.j(u,h,v)}u(a,u){if(u&&console.warn(a),this.g)throw new Error(a)}}e.InstantiationService=p;var f;(function(E){E[E.None=0]="None",E[E.Creation=1]="Creation",E[E.Invocation=2]="Invocation",E[E.Branch=3]="Branch"})(f||(f={}));class m{static traceInvocation(a,u){return a?new m(2,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):m.c}static traceCreation(a,u){return a?new m(1,u.name):m.c}constructor(a,u){this.type=a,this.name=u,this.g=Date.now(),this.h=[]}branch(a,u){const h=new m(3,a.toString());return this.h.push([a,u,h]),h}stop(){const a=Date.now()-this.g;m.f+=a;let u=!1;function h(v,L){const n=[],r=new Array(v+1).join("	");for(const[t,i,s]of L.h)if(i&&s){u=!0,n.push(`${r}CREATES -> ${t}`);const o=h(v+1,s);o&&n.push(o)}else n.push(`${r}uses -> ${t}`);return n.join(`
`)}const d=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${h(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${m.f.toFixed(2)}ms)`];(a>2||u)&&m.all.add(d.join(`
`))}}m.all=new Set,m.c=new class extends m{constructor(){super(0,null)}stop(){}branch(){return this}},m.f=0,e.Trace=m}),define(re[73],oe([0,1,5]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MainProcessService=e.IMainProcessService=void 0,e.IMainProcessService=(0,O.createDecorator)("mainProcessService");class U{constructor(T,N){this.a=T,this.b=N}getChannel(T){return this.a.getChannel(T,this.b)}registerChannel(T,N){this.a.registerChannel(T,N)}}e.MainProcessService=U}),define(re[74],oe([0,1,25,2,4,171,29,5]),function(te,e,O,U,l,T,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function I(P){return P.tags.find(S=>S.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=I,e.ILanguagePackService=(0,R.createDecorator)("languagePackService");let w=class extends U.Disposable{constructor(S){super(),this.c=S}async getAvailableLanguages(){const S=new O.CancellationTokenSource;setTimeout(()=>S.cancel(),1e3);let p;try{p=await this.c.query({text:'category:"language packs"',pageSize:20},S.token)}catch{return[]}const m=p.firstPage.filter(E=>E.properties.localizedLanguages?.length&&E.tags.some(a=>a.startsWith("lp-"))).map(E=>{const a=E.properties.localizedLanguages?.[0],u=I(E);return{...this.f(u,a,E),extensionId:E.identifier.id,galleryExtension:E}});return m.push(this.f("en","English")),m}f(S,p,f){const m=p??S;let E;if(m!==S&&(E=`(${S})`),S.toLowerCase()===l.language.toLowerCase()&&(E??="",E+=(0,T.localize)(0,null)),f?.installCount){E??="";const a=f.installCount;let u;a>1e6?u=`${Math.floor(a/1e5)/10}M`:a>1e3?u=`${Math.floor(a/1e3)}K`:u=String(a),E+=` $(cloud-download) ${u}`}return{id:S,label:m,description:E}}};w=ye([G(0,N.IExtensionGalleryService)],w),e.LanguagePackBaseService=w}),define(re[209],oe([0,1,2,74]),function(te,e,O,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let l=class extends O.Disposable{constructor(N){super(),this.a=N,this.b()}b(){this.a.update()}};l=ye([G(0,U.ILanguagePackService)],l),e.LocalizationsUpdater=l}),define(re[9],oe([0,1,38,3,53,2,37,4,23,12,11,70,5]),function(te,e,O,U,l,T,N,R,I,w,P,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,p.createDecorator)("logService"),e.ILoggerService=(0,p.createDecorator)("loggerService");function f(){return new Date().toISOString()}function m(b){return(0,w.isNumber)(b)}e.isLogLevel=m;var E;(function(b){b[b.Off=0]="Off",b[b.Trace=1]="Trace",b[b.Debug=2]="Debug",b[b.Info=3]="Info",b[b.Warning=4]="Warning",b[b.Error=5]="Error"})(E=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=E.Info;function a(b,g,D){switch(g){case E.Trace:b.trace(D);break;case E.Debug:b.debug(D);break;case E.Info:b.info(D);break;case E.Warning:b.warn(D);break;case E.Error:b.error(D);break;case E.Off:break;default:throw new Error(`Invalid log level ${g}`)}}e.log=a;function u(b,g=!1){let D="";for(let A=0;A<b.length;A++){let F=b[A];if(F instanceof Error&&(F=(0,O.toErrorMessage)(F,g)),typeof F=="object")try{F=JSON.stringify(F)}catch{}D+=(A>0?" ":"")+F}return D}class h extends T.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.D(new U.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(g){this.b!==g&&(this.b=g,this.c.fire(this.b))}getLevel(){return this.b}f(g){return this.b!==E.Off&&this.b<=g}}e.AbstractLogger=h;class d extends h{constructor(g){super(),this.h=g}f(g){return this.h||super.f(g)}trace(g,...D){this.f(E.Trace)&&this.g(E.Trace,u([g,...D],!0))}debug(g,...D){this.f(E.Debug)&&this.g(E.Debug,u([g,...D]))}info(g,...D){this.f(E.Info)&&this.g(E.Info,u([g,...D]))}warn(g,...D){this.f(E.Warning)&&this.g(E.Warning,u([g,...D]))}error(g,...D){if(this.f(E.Error))if(g instanceof Error){const A=Array.prototype.slice.call(arguments);A[0]=g.stack,this.g(E.Error,u(A))}else this.g(E.Error,u([g,...D]))}flush(){}}e.AbstractMessageLogger=d;class v extends h{constructor(g=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(g),this.g=!R.isWindows}trace(g,...D){this.f(E.Trace)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,g,...D):console.log(`[main ${f()}]`,g,...D))}debug(g,...D){this.f(E.Debug)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,g,...D):console.log(`[main ${f()}]`,g,...D))}info(g,...D){this.f(E.Info)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,g,...D):console.log(`[main ${f()}]`,g,...D))}warn(g,...D){this.f(E.Warning)&&(this.g?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,g,...D):console.warn(`[main ${f()}]`,g,...D))}error(g,...D){this.f(E.Error)&&(this.g?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,g,...D):console.error(`[main ${f()}]`,g,...D))}dispose(){}flush(){}}e.ConsoleMainLogger=v;class L extends h{constructor(g=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(g)}trace(g,...D){this.f(E.Trace)&&console.log("%cTRACE","color: #888",g,...D)}debug(g,...D){this.f(E.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",g,...D)}info(g,...D){this.f(E.Info)&&console.log("%c INFO","color: #33f",g,...D)}warn(g,...D){this.f(E.Warning)&&console.log("%c WARN","color: #993",g,...D)}error(g,...D){this.f(E.Error)&&console.log("%c  ERR","color: #f33",g,...D)}dispose(){}flush(){}}e.ConsoleLogger=L;class n extends h{constructor(g,D=e.DEFAULT_LOG_LEVEL){super(),this.g=g,this.setLevel(D)}trace(g,...D){this.f(E.Trace)&&this.g.log(E.Trace,[this.h(g),...D])}debug(g,...D){this.f(E.Debug)&&this.g.log(E.Debug,[this.h(g),...D])}info(g,...D){this.f(E.Info)&&this.g.log(E.Info,[this.h(g),...D])}warn(g,...D){this.f(E.Warning)&&this.g.log(E.Warning,[this.h(g),...D])}error(g,...D){this.f(E.Error)&&this.g.log(E.Error,[this.h(g),...D])}h(g){return typeof g=="string"?g:(0,O.toErrorMessage)(g,this.f(E.Trace))}dispose(){}flush(){}}e.AdapterLogger=n;class r extends h{constructor(g){super(),this.g=g,g.length&&this.setLevel(g[0].getLevel())}setLevel(g){for(const D of this.g)D.setLevel(g);super.setLevel(g)}trace(g,...D){for(const A of this.g)A.trace(g,...D)}debug(g,...D){for(const A of this.g)A.debug(g,...D)}info(g,...D){for(const A of this.g)A.info(g,...D)}warn(g,...D){for(const A of this.g)A.warn(g,...D)}error(g,...D){for(const A of this.g)A.error(g,...D)}flush(){for(const g of this.g)g.flush()}dispose(){for(const g of this.g)g.dispose()}}e.MultiplexLogger=r;class t extends T.Disposable{constructor(g,D,A){if(super(),this.h=g,this.j=D,this.b=new N.ResourceMap,this.c=this.D(new U.Emitter),this.onDidChangeLoggers=this.c.event,this.f=this.D(new U.Emitter),this.onDidChangeLogLevel=this.f.event,this.g=this.D(new U.Emitter),this.onDidChangeVisibility=this.g.event,A)for(const F of A)this.b.set(F.resource,{logger:void 0,info:F})}k(g){return(0,w.isString)(g)?[...this.b.values()].find(D=>D.info.id===g):this.b.get(g)}getLogger(g){return this.k(g)?.logger}createLogger(g,D){const A=this.l(g),F=(0,w.isString)(g)?g:D?.id??(0,l.hash)(A.toString()).toString(16);let j=this.b.get(A)?.logger;const x=D?.logLevel==="always"?E.Trace:D?.logLevel;j||(j=this.m(A,x??this.getLogLevel(A)??this.h,{...D,id:F}));const V={logger:j,info:{resource:A,id:F,logLevel:x,name:D?.name,hidden:D?.hidden,extensionId:D?.extensionId,when:D?.when}};return this.registerLogger(V.info),this.b.set(A,V),j}l(g){return(0,w.isString)(g)?(0,I.joinPath)(this.j,`${g}.log`):g}setLogLevel(g,D){if(P.URI.isUri(g)){const A=g,F=D,j=this.b.get(A);j&&F!==j.info.logLevel&&(j.info.logLevel=F===this.h?void 0:F,j.logger?.setLevel(F),this.b.set(j.info.resource,j),this.f.fire([A,F]))}else{this.h=g;for(const[A,F]of this.b.entries())this.b.get(A)?.info.logLevel===void 0&&F.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(g,D){const A=this.k(g);A&&D!==!A.info.hidden&&(A.info.hidden=!D,this.b.set(A.info.resource,A),this.g.fire([A.info.resource,D]))}getLogLevel(g){let D;return g&&(D=this.b.get(g)?.info.logLevel),D??this.h}registerLogger(g){const D=this.b.get(g.resource);D?D.info.hidden!==g.hidden&&this.setVisibility(g.resource,!g.hidden):(this.b.set(g.resource,{info:g,logger:void 0}),this.c.fire({added:[g],removed:[]}))}deregisterLogger(g){const D=this.b.get(g);D&&(D.logger&&D.logger.dispose(),this.b.delete(g),this.c.fire({added:[],removed:[D.info]}))}*getRegisteredLoggers(){for(const g of this.b.values())yield g.info}getRegisteredLogger(g){return this.b.get(g)?.info}dispose(){this.b.forEach(g=>g.logger?.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=t;class i{constructor(){this.onDidChangeLogLevel=new U.Emitter().event}setLevel(g){}getLevel(){return E.Info}trace(g,...D){}debug(g,...D){}info(g,...D){}warn(g,...D){}error(g,...D){}critical(g,...D){}dispose(){}flush(){}}e.NullLogger=i;class s extends i{}e.NullLogService=s;function o(b){if(b.verbose)return E.Trace;if(typeof b.logLevel=="string"){const g=y(b.logLevel.toLowerCase());if(g!==void 0)return g}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=o;function c(b){switch(b){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Off:return"off"}}e.LogLevelToString=c;function y(b){switch(b){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Error;case"off":return E.Off}}e.parseLogLevel=y,e.CONTEXT_LOG_LEVEL=new S.RawContextKey("logLevel",c(E.Info))}),define(re[210],oe([0,1,6,10,2,23,28,15,9]),function(te,e,O,U,l,T,N,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let w=class extends l.Disposable{constructor(S,p){super(),this.a=S,this.b=p,this.D(new O.RunOnceScheduler(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const S=(0,T.basename)(this.a.logsHome),p=(0,T.dirname)(this.a.logsHome),E=(await N.Promises.readdir(p.fsPath)).filter(u=>/^\d{8}T\d{6}$/.test(u)).sort().filter(u=>u!==S),a=E.slice(0,Math.max(0,E.length-9));a.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${a.join(", ")}'`),await Promise.all(a.map(u=>N.Promises.rm((0,T.joinPath)(p,u).fsPath))))}catch(S){(0,U.onUnexpectedError)(S)}}};w=ye([G(0,R.IEnvironmentService),G(1,I.ILogService)],w),e.LogsDataCleaner=w}),define(re[211],oe([0,1,21,6,10,3,2,13,56,9]),function(te,e,O,U,l,T,N,R,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class P extends N.Disposable{constructor(p,f){super(),this.a=p,this.b=f,this.c=this.D(new T.Emitter),this.onDidChangeFile=this.c.event,this.g=this.D(new T.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.D(new U.ThrottledDelayer(0)),this.r=[],this.s=this.D(new U.ThrottledDelayer(0))}watch(p,f){return f.recursive||this.b?.watcher?.forceUniversal?this.l(p,f):this.t(p,f)}l(p,f){const m={path:this.z(p),excludes:f.excludes,includes:f.includes,recursive:f.recursive},E=(0,O.insert)(this.j,m);return this.m(),(0,N.toDisposable)(()=>{E(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(p=>(0,l.onUnexpectedError)(p))}n(){this.h||(this.h=this.D(this.p(f=>this.c.fire((0,I.toFileChanges)(f)),f=>this.y(f),this.a.getLevel()===w.LogLevel.Trace)),this.D(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===w.LogLevel.Trace)})));const p=this.b?.watcher?.recursive?.usePolling;if(p===!0)for(const f of this.j)(0,I.isRecursiveWatchRequest)(f)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(p))for(const f of this.j)(0,I.isRecursiveWatchRequest)(f)&&p.includes(f.path)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}t(p,f){const m={path:this.z(p),excludes:f.excludes,includes:f.includes,recursive:!1},E=(0,O.insert)(this.r,m);return this.u(),(0,N.toDisposable)(()=>{E(),this.u()})}u(){this.s.trigger(()=>this.v()).catch(p=>(0,l.onUnexpectedError)(p))}v(){return this.q||(this.q=this.D(this.w(p=>this.c.fire((0,I.toFileChanges)(p)),p=>this.y(p),this.a.getLevel()===w.LogLevel.Trace)),this.D(this.a.onDidChangeLogLevel(()=>{this.q?.setVerboseLogging(this.a.getLevel()===w.LogLevel.Trace)}))),this.q.watch(this.r)}y(p){p.type==="error"&&this.g.fire(p.message),this.a[p.type](p.message)}z(p){return(0,R.normalize)(p.fsPath)}}e.AbstractDiskFileSystemProvider=P}),define(re[212],oe([0,1,21,6,16,25,3,53,63,2,49,22,104,23,43,167,14,103,9,10]),function(te,e,O,U,l,T,N,R,I,w,P,S,p,f,m,E,a,u,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let v=class extends w.Disposable{constructor(n){super(),this.b=n,this.a=256*1024,this.c=this.D(new N.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.D(new N.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.D(new N.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.D(new N.Emitter),this.onDidRunOperation=this.m.event,this.R=this.D(new N.Emitter),this.onDidFilesChange=this.R.event,this.S=this.D(new N.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.D(new U.ResourceQueue)}registerProvider(n,r){if(this.h.has(n))throw new Error(`A filesystem provider for the scheme '${n}' is already registered.`);(0,p.mark)(`code/registerFilesystem/${n}`);const t=new w.DisposableStore;return this.h.set(n,r),this.c.fire({added:!0,scheme:n,provider:r}),t.add(r.onDidChangeFile(i=>this.R.fire(new a.FileChangesEvent(i,!this.O(r))))),typeof r.onDidWatchError=="function"&&t.add(r.onDidWatchError(i=>this.S.fire(new Error(i)))),t.add(r.onDidChangeCapabilities(()=>this.g.fire({provider:r,scheme:n}))),(0,w.toDisposable)(()=>{this.c.fire({added:!1,scheme:n,provider:r}),this.h.delete(n),(0,w.dispose)(t)})}getProvider(n){return this.h.get(n)}async activateProvider(n){const r=[];this.f.fire({scheme:n,join(t){r.push(t)}}),!this.h.has(n)&&await U.Promises.settled(r)}async canHandleResource(n){return await this.activateProvider(n.scheme),this.hasProvider(n)}hasProvider(n){return this.h.has(n.scheme)}hasCapability(n,r){const t=this.h.get(n.scheme);return!!(t&&t.capabilities&r)}listCapabilities(){return I.Iterable.map(this.h,([n,r])=>({scheme:n,capabilities:r.capabilities}))}async j(n){if(!(0,f.isAbsolutePath)(n))throw new a.FileOperationError((0,E.localize)(0,null,this.nb(n)),8);await this.activateProvider(n.scheme);const r=this.h.get(n.scheme);if(!r){const t=new d.ErrorNoTelemetry;throw t.message=(0,E.localize)(1,null,n.toString()),t}return r}async k(n){const r=await this.j(n);if((0,a.hasOpenReadWriteCloseCapability)(r)||(0,a.hasReadWriteCapability)(r)||(0,a.hasFileReadStreamCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${n.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(n){const r=await this.j(n);if((0,a.hasOpenReadWriteCloseCapability)(r)||(0,a.hasReadWriteCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${n.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(n,r){try{return await this.n(n,r)}catch(t){throw(0,a.toFileSystemProviderErrorCode)(t)===a.FileSystemProviderErrorCode.FileNotFound?new a.FileOperationError((0,E.localize)(2,null,this.nb(n)),1):(0,a.ensureFileSystemProviderError)(t)}}async n(n,r){const t=await this.j(n),i=this.O(t),s=r?.resolveTo,o=r?.resolveSingleChildDescendants,c=r?.resolveMetadata,y=await t.stat(n);let b;return this.p(t,n,y,void 0,!!c,(g,D)=>(b||(b=P.TernarySearchTree.forUris(()=>!i),b.set(n,!0),s&&b.fill(!0,s)),b.get(g.resource)||b.findSuperstr(g.resource.with({query:null,fragment:null}))?!0:g.isDirectory&&o?D===1:!1))}async p(n,r,t,i,s,o){const{providerExtUri:c}=this.N(n),y={resource:r,name:c.basename(r),isFile:(t.type&a.FileType.File)!==0,isDirectory:(t.type&a.FileType.Directory)!==0,isSymbolicLink:(t.type&a.FileType.SymbolicLink)!==0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean((t.permissions??0)&a.FilePermission.Readonly)||Boolean(n.capabilities&2048),etag:(0,a.etag)({mtime:t.mtime,size:t.size}),children:void 0};if(y.isDirectory&&o(y,i)){try{const b=await n.readdir(r),g=await U.Promises.settled(b.map(async([D,A])=>{try{const F=c.joinPath(r,D),j=s?await n.stat(F):{type:A};return await this.p(n,F,j,b.length,s,o)}catch(F){return this.b.trace(F),null}}));y.children=(0,O.coalesce)(g)}catch(b){this.b.trace(b),y.children=[]}return y}return y}async resolveAll(n){return U.Promises.settled(n.map(async r=>{try{return{stat:await this.n(r.resource,r.options),success:!0}}catch(t){return this.b.trace(t),{stat:void 0,success:!1}}}))}async stat(n){const r=await this.j(n),t=await r.stat(n);return this.p(r,n,t,void 0,!0,()=>!1)}async exists(n){const r=await this.j(n);try{return!!await r.stat(n)}catch{return!1}}async canCreateFile(n,r){try{await this.q(n,r)}catch(t){return t}return!0}async q(n,r){if(!r?.overwrite&&await this.exists(n))throw new a.FileOperationError((0,E.localize)(3,null,this.nb(n)),3,r)}async createFile(n,r=l.VSBuffer.fromString(""),t){await this.q(n,t);const i=await this.writeFile(n,r);return this.m.fire(new a.FileOperationEvent(n,0,i)),i}async writeFile(n,r,t){const i=this.lb(await this.l(n),n),{providerExtUri:s}=this.N(i);try{await this.r(i,n,t)||await this.P(i,s.dirname(n));let c;if((0,a.hasReadWriteCapability)(i)&&!(r instanceof l.VSBuffer))if((0,m.isReadableStream)(r)){const y=await(0,m.peekStream)(r,3);y.ended?c=l.VSBuffer.concat(y.buffer):c=y}else c=(0,m.peekReadable)(r,y=>l.VSBuffer.concat(y),3);else c=r;!(0,a.hasOpenReadWriteCloseCapability)(i)||(0,a.hasReadWriteCapability)(i)&&c instanceof l.VSBuffer?await this.cb(i,n,t,c):await this.Y(i,n,t,c instanceof l.VSBuffer?(0,l.bufferToReadable)(c):c),this.m.fire(new a.FileOperationEvent(n,4))}catch(o){throw new a.FileOperationError((0,E.localize)(4,null,this.nb(n),(0,a.ensureFileSystemProviderError)(o).toString()),(0,a.toFileOperationResult)(o),t)}return this.resolve(n,{resolveMetadata:!0})}async r(n,r,t){if(!!t?.unlock&&!(n.capabilities&8192))throw new Error((0,E.localize)(5,null,this.nb(r)));let s;try{s=await n.stat(r)}catch{return}if((s.type&a.FileType.Directory)!==0)throw new a.FileOperationError((0,E.localize)(6,null,this.nb(r)),0,t);if(this.mb(r,s),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==a.ETAG_DISABLED&&typeof s.mtime=="number"&&typeof s.size=="number"&&t.mtime<s.mtime&&t.etag!==(0,a.etag)({mtime:t.mtime,size:s.size}))throw new a.FileOperationError((0,E.localize)(7,null),3,t);return s}async readFile(n,r,t){const i=await this.k(n);return r?.atomic?this.s(i,n,r,t):this.t(i,n,r,t)}async s(n,r,t,i){return new Promise((s,o)=>{this.X.queueFor(r,this.N(n).providerExtUri).queue(async()=>{try{const c=await this.t(n,r,t,i);s(c)}catch(c){o(c)}})})}async t(n,r,t,i){const s=await this.u(n,r,{...t,preferUnbuffered:!0},i);return{...s,value:await(0,l.streamToBuffer)(s.value)}}async readFileStream(n,r,t){const i=await this.k(n);return this.u(i,n,r,t)}async u(n,r,t,i){const s=new T.CancellationTokenSource(i),o=this.F(r,t).then(y=>y,y=>{throw s.cancel(),y});let c;try{return typeof t?.etag=="string"&&t.etag!==a.ETAG_DISABLED&&await o,t?.atomic&&(0,a.hasFileAtomicReadCapability)(n)||!((0,a.hasOpenReadWriteCloseCapability)(n)||(0,a.hasFileReadStreamCapability)(n))||(0,a.hasReadWriteCapability)(n)&&t?.preferUnbuffered?c=this.C(n,r,t):(0,a.hasFileReadStreamCapability)(n)?c=this.w(n,r,s.token,t):c=this.z(n,r,s.token,t),{...await o,value:c}}catch(y){throw c&&await(0,m.consumeStream)(c),this.v(y,r,t)}}v(n,r,t){const i=(0,E.localize)(8,null,this.nb(r),(0,a.ensureFileSystemProviderError)(n).toString());return n instanceof a.NotModifiedSinceFileOperationError?new a.NotModifiedSinceFileOperationError(i,n.stat,t):n instanceof a.TooLargeFileOperationError?new a.TooLargeFileOperationError(i,n.fileOperationResult,n.size,n.options):new a.FileOperationError(i,(0,a.toFileOperationResult)(n),t)}w(n,r,t,i=Object.create(null)){const s=n.readFileStream(r,i,t);return(0,m.transform)(s,{data:o=>o instanceof l.VSBuffer?o:l.VSBuffer.wrap(o),error:o=>this.v(o,r,i)},o=>l.VSBuffer.concat(o))}z(n,r,t,i=Object.create(null)){const s=(0,l.newWriteableBufferStream)();return(0,u.readFileIntoStream)(n,r,s,o=>o,{...i,bufferSize:this.a,errorTransformer:o=>this.v(o,r,i)},t),s}C(n,r,t){const i=(0,m.newWriteableStream)(s=>l.VSBuffer.concat(s));return(async()=>{try{let s;t?.atomic&&(0,a.hasFileAtomicReadCapability)(n)?s=await n.readFile(r,{atomic:!0}):s=await n.readFile(r),typeof t?.position=="number"&&(s=s.slice(t.position)),typeof t?.length=="number"&&(s=s.slice(0,t.length)),this.G(r,s.byteLength,t),i.end(l.VSBuffer.wrap(s))}catch(s){i.error(s),i.end()}})(),i}async F(n,r){const t=await this.resolve(n,{resolveMetadata:!0});if(t.isDirectory)throw new a.FileOperationError((0,E.localize)(9,null,this.nb(n)),0,r);if(typeof r?.etag=="string"&&r.etag!==a.ETAG_DISABLED&&r.etag===t.etag)throw new a.NotModifiedSinceFileOperationError((0,E.localize)(10,null),t,r);return this.G(n,t.size,r),t}G(n,r,t){if(t?.limits){let i;if(typeof t.limits.memory=="number"&&r>t.limits.memory&&(i=9),typeof t.limits.size=="number"&&r>t.limits.size&&(i=7),typeof i=="number")throw new a.TooLargeFileOperationError((0,E.localize)(11,null,this.nb(n)),i,r,t)}}async canMove(n,r,t){return this.H(n,r,"move",t)}async canCopy(n,r,t){return this.H(n,r,"copy",t)}async H(n,r,t,i){if(n.toString()!==r.toString())try{const s=t==="move"?this.lb(await this.l(n),n):await this.k(n),o=this.lb(await this.l(r),r);await this.M(s,n,o,r,t,i)}catch(s){return s}return!0}async move(n,r,t){const i=this.lb(await this.l(n),n),s=this.lb(await this.l(r),r),o=await this.I(i,n,s,r,"move",!!t),c=await this.resolve(r,{resolveMetadata:!0});return this.m.fire(new a.FileOperationEvent(n,o==="move"?2:3,c)),c}async copy(n,r,t){const i=await this.k(n),s=this.lb(await this.l(r),r),o=await this.I(i,n,s,r,"copy",!!t),c=await this.resolve(r,{resolveMetadata:!0});return this.m.fire(new a.FileOperationEvent(n,o==="copy"?3:2,c)),c}async I(n,r,t,i,s,o){if(r.toString()===i.toString())return s;const{exists:c,isSameResourceWithDifferentPathCase:y}=await this.M(n,r,t,i,s,o);if(c&&!y&&o&&await this.del(i,{recursive:!0}),await this.P(t,this.N(t).providerExtUri.dirname(i)),s==="copy"){if(n===t&&(0,a.hasFileFolderCopyCapability)(n))await n.copy(r,i,{overwrite:o});else{const b=await this.resolve(r);b.isDirectory?await this.L(n,b,t,i):await this.J(n,r,t,i)}return s}else return n===t?(await n.rename(r,i,{overwrite:o}),s):(await this.I(n,r,t,i,"copy",o),await this.del(r,{recursive:!0}),"copy")}async J(n,r,t,i){if((0,a.hasOpenReadWriteCloseCapability)(n)&&(0,a.hasOpenReadWriteCloseCapability)(t))return this.eb(n,r,t,i);if((0,a.hasOpenReadWriteCloseCapability)(n)&&(0,a.hasReadWriteCapability)(t))return this.kb(n,r,t,i);if((0,a.hasReadWriteCapability)(n)&&(0,a.hasOpenReadWriteCloseCapability)(t))return this.ib(n,r,t,i);if((0,a.hasReadWriteCapability)(n)&&(0,a.hasReadWriteCapability)(t))return this.gb(n,r,t,i)}async L(n,r,t,i){await t.mkdir(i),Array.isArray(r.children)&&await U.Promises.settled(r.children.map(async s=>{const o=this.N(t).providerExtUri.joinPath(i,s.name);return s.isDirectory?this.L(n,await this.resolve(s.resource),t,o):this.J(n,s.resource,t,o)}))}async M(n,r,t,i,s,o){let c=!1;if(n===t){const{providerExtUri:b,isPathCaseSensitive:g}=this.N(n);if(g||(c=b.isEqual(r,i)),c&&s==="copy")throw new Error((0,E.localize)(12,null,this.nb(r),this.nb(i)));if(!c&&b.isEqualOrParent(i,r))throw new Error((0,E.localize)(13,null,this.nb(r),this.nb(i)))}const y=await this.exists(i);if(y&&!c){if(!o)throw new a.FileOperationError((0,E.localize)(14,null,this.nb(r),this.nb(i)),4);if(n===t){const{providerExtUri:b}=this.N(n);if(b.isEqualOrParent(r,i))throw new Error((0,E.localize)(15,null,this.nb(r),this.nb(i)))}}return{exists:y,isSameResourceWithDifferentPathCase:c}}N(n){const r=this.O(n);return{providerExtUri:r?f.extUri:f.extUriIgnorePathCase,isPathCaseSensitive:r}}O(n){return!!(n.capabilities&1024)}async createFolder(n){const r=this.lb(await this.j(n),n);await this.P(r,n);const t=await this.resolve(n,{resolveMetadata:!0});return this.m.fire(new a.FileOperationEvent(n,0,t)),t}async P(n,r){const t=[],{providerExtUri:i}=this.N(n);for(;!i.isEqual(r,i.dirname(r));)try{if(((await n.stat(r)).type&a.FileType.Directory)===0)throw new Error((0,E.localize)(16,null,this.nb(r)));break}catch(s){if((0,a.toFileSystemProviderErrorCode)(s)!==a.FileSystemProviderErrorCode.FileNotFound)throw s;t.push(i.basename(r)),r=i.dirname(r)}for(let s=t.length-1;s>=0;s--){r=i.joinPath(r,t[s]);try{await n.mkdir(r)}catch(o){if((0,a.toFileSystemProviderErrorCode)(o)!==a.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(n,r){try{await this.Q(n,r)}catch(t){return t}return!0}async Q(n,r){const t=this.lb(await this.j(n),n);if(!!r?.useTrash&&!(t.capabilities&4096))throw new Error((0,E.localize)(17,null,this.nb(n)));let s;try{s=await t.stat(n)}catch{}if(s)this.mb(n,s);else throw new a.FileOperationError((0,E.localize)(18,null,this.nb(n)),1);if(!!!r?.recursive){const c=await this.resolve(n);if(c.isDirectory&&Array.isArray(c.children)&&c.children.length>0)throw new Error((0,E.localize)(19,null,this.nb(n)))}return t}async del(n,r){const t=await this.Q(n,r),i=!!r?.useTrash,s=!!r?.recursive;await t.delete(n,{recursive:s,useTrash:i}),this.m.fire(new a.FileOperationEvent(n,1))}async cloneFile(n,r){const t=await this.j(n),i=this.lb(await this.l(r),r);if(t===i&&this.N(t).providerExtUri.isEqual(n,r))return;if(t===i&&(0,a.hasFileCloneCapability)(t))return t.cloneFile(n,r);await this.P(i,this.N(i).providerExtUri.dirname(r));const s=this.X.queueFor(n,this.N(t).providerExtUri);return t===i&&(0,a.hasFileFolderCopyCapability)(t)?s.queue(()=>t.copy(n,r,{overwrite:!0})):s.queue(()=>this.J(t,n,i,r))}watch(n,r={recursive:!1,excludes:[]}){const t=new w.DisposableStore;let i=!1,s=()=>{i=!0};return t.add((0,w.toDisposable)(()=>s())),(async()=>{try{const o=await this.W(n,r);i?(0,w.dispose)(o):s=()=>(0,w.dispose)(o)}catch(o){this.b.error(o)}})(),t}async W(n,r){const t=await this.j(n),i=(0,R.hash)([this.N(t).providerExtUri.getComparisonKey(n),r]);let s=this.U.get(i);return s||(s={count:0,disposable:t.watch(n,r)},this.U.set(i,s)),s.count+=1,(0,w.toDisposable)(()=>{s&&(s.count--,s.count===0&&((0,w.dispose)(s.disposable),this.U.delete(i)))})}dispose(){super.dispose();for(const[,n]of this.U)(0,w.dispose)(n.disposable);this.U.clear()}async Y(n,r,t,i){return this.X.queueFor(r,this.N(n).providerExtUri).queue(async()=>{const s=await n.open(r,{create:!0,unlock:t?.unlock??!1});try{(0,m.isReadableStream)(i)||(0,m.isReadableBufferedStream)(i)?await this.Z(n,s,i):await this.ab(n,s,i)}catch(o){throw(0,a.ensureFileSystemProviderError)(o)}finally{await n.close(s)}})}async Z(n,r,t){let i=0,s;if((0,m.isReadableBufferedStream)(t)){if(t.buffer.length>0){const o=l.VSBuffer.concat(t.buffer);await this.bb(n,r,o,o.byteLength,i,0),i+=o.byteLength}if(t.ended)return;s=t.stream}else s=t;return new Promise((o,c)=>{(0,m.listenStream)(s,{onData:async y=>{s.pause();try{await this.bb(n,r,y,y.byteLength,i,0)}catch(b){return c(b)}i+=y.byteLength,setTimeout(()=>s.resume())},onError:y=>c(y),onEnd:()=>o()})})}async ab(n,r,t){let i=0,s;for(;(s=t.read())!==null;)await this.bb(n,r,s,s.byteLength,i,0),i+=s.byteLength}async bb(n,r,t,i,s,o){let c=0;for(;c<i;)c+=await n.write(r,s+c,t.buffer,o+c,i-c)}async cb(n,r,t,i){return this.X.queueFor(r,this.N(n).providerExtUri).queue(()=>this.db(n,r,t,i))}async db(n,r,t,i){let s;i instanceof l.VSBuffer?s=i:(0,m.isReadableStream)(i)?s=await(0,l.streamToBuffer)(i):(0,m.isReadableBufferedStream)(i)?s=await(0,l.bufferedStreamToBuffer)(i):s=(0,l.readableToBuffer)(i),await n.writeFile(r,s.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1})}async eb(n,r,t,i){return this.X.queueFor(i,this.N(t).providerExtUri).queue(()=>this.fb(n,r,t,i))}async fb(n,r,t,i){let s,o;try{s=await n.open(r,{create:!1}),o=await t.open(i,{create:!0,unlock:!1});const c=l.VSBuffer.alloc(this.a);let y=0,b=0,g=0;do g=await n.read(s,y,c.buffer,b,c.byteLength-b),await this.bb(t,o,c,g,y,b),y+=g,b+=g,b===c.byteLength&&(b=0);while(g>0)}catch(c){throw(0,a.ensureFileSystemProviderError)(c)}finally{await U.Promises.settled([typeof s=="number"?n.close(s):Promise.resolve(),typeof o=="number"?t.close(o):Promise.resolve()])}}async gb(n,r,t,i){return this.X.queueFor(i,this.N(t).providerExtUri).queue(()=>this.hb(n,r,t,i))}async hb(n,r,t,i){return t.writeFile(i,await n.readFile(r),{create:!0,overwrite:!0,unlock:!1})}async ib(n,r,t,i){return this.X.queueFor(i,this.N(t).providerExtUri).queue(()=>this.jb(n,r,t,i))}async jb(n,r,t,i){const s=await t.open(i,{create:!0,unlock:!1});try{const o=await n.readFile(r);await this.bb(t,s,l.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,a.ensureFileSystemProviderError)(o)}finally{await t.close(s)}}async kb(n,r,t,i){const s=await(0,l.streamToBuffer)(this.z(n,r,T.CancellationToken.None));await this.cb(t,i,void 0,s)}lb(n,r){if(n.capabilities&2048)throw new a.FileOperationError((0,E.localize)(20,null,this.nb(r)),6);return n}mb(n,r){if((r.permissions??0)&a.FilePermission.Readonly)throw new a.FileOperationError((0,E.localize)(21,null,this.nb(n)),6)}nb(n){return n.scheme===S.Schemas.file?n.fsPath:n.toString(!0)}};v=ye([G(0,h.ILogService)],v),e.FileService=v}),define(re[213],oe([0,1,54,295,6,37,16,3,48,2,13,4,23,43,28,170,14,103,211,38,207,206]),function(te,e,O,U,l,T,N,R,I,w,P,S,p,f,m,E,a,u,h,d,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,U.gracefulify)(O)}catch(r){console.error(`Error enabling graceful-fs: ${(0,d.toErrorMessage)(r)}`)}})();class n extends h.AbstractDiskFileSystemProvider{constructor(t,i){super(t,i),this.onDidChangeCapabilities=R.Event.None,this.H=new T.ResourceMap(s=>p.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,S.isLinux&&(this.F|=1024)),this.F}async stat(t){try{const{stat:i,symbolicLink:s}=await m.SymlinkSupport.stat(this.z(t));return{type:this.G(i,s),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size}}catch(i){throw this.Y(i)}}async readdir(t){try{const i=await m.Promises.readdir(this.z(t),{withFileTypes:!0}),s=[];return await Promise.all(i.map(async o=>{try{let c;o.isSymbolicLink()?c=(await this.stat((0,p.joinPath)(t,o.name))).type:c=this.G(o),s.push([o.name,c])}catch(c){this.a.trace(c)}})),s}catch(i){throw this.Y(i)}}G(t,i){let s;return i?.dangling?s=a.FileType.Unknown:t.isFile()?s=a.FileType.File:t.isDirectory()?s=a.FileType.Directory:s=a.FileType.Unknown,i&&(s|=a.FileType.SymbolicLink),s}async I(t){const i=this.z(t);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let s;for(;s=this.H.get(t);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await s.wait();const o=new l.Barrier;return this.H.set(t,o),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,w.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.H.get(t)===o&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.H.delete(t)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),o.open()})}async readFile(t,i){let s;try{i?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.z(t)})`),s=await this.I(t));const o=this.z(t);return await m.Promises.readFile(o)}catch(o){throw this.Y(o)}finally{s?.dispose()}}J(t){n.C&&this.a.trace(t)}readFileStream(t,i,s){const o=(0,f.newWriteableStream)(c=>N.VSBuffer.concat(c.map(y=>N.VSBuffer.wrap(y))).buffer);return(0,u.readFileIntoStream)(this,t,o,c=>c.buffer,{...i,bufferSize:256*1024},s),o}async writeFile(t,i,s){let o;try{const c=this.z(t);if(!s.create||!s.overwrite){if(await m.Promises.exists(c)){if(!s.overwrite)throw(0,a.createFileSystemProviderError)((0,E.localize)(0,null),a.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,a.createFileSystemProviderError)((0,E.localize)(1,null),a.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(t,{create:!0,unlock:s.unlock}),await this.write(o,0,i,0,i.byteLength)}catch(c){throw await this.Z(t,c)}finally{typeof o=="number"&&await this.close(o)}}static configureFlushOnWrite(t){n.O=t}async open(t,i){const s=this.z(t);let o;(0,a.isFileOpenForWriteOptions)(i)&&(o=await this.I(t));let c;try{if((0,a.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:b}=await m.SymlinkSupport.stat(s);b.mode&128||await m.Promises.chmod(s,b.mode|128)}catch(b){this.a.trace(b)}let y;if((0,a.isFileOpenForWriteOptions)(i)){if(S.isWindows)try{await m.Promises.truncate(s,0),y="r+"}catch(b){b.code!=="ENOENT"&&this.a.trace(b)}y||(y="w")}else y="r";c=await m.Promises.open(s,y)}catch(y){throw o?.dispose(),(0,a.isFileOpenForWriteOptions)(i)?await this.Z(t,y):this.Y(y)}if(this.L.set(c,0),(0,a.isFileOpenForWriteOptions)(i)&&this.N.set(c,t),o){const y=this.M.get(c);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${c} (${s})`),this.M.set(c,o),y&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${c} (${s})`),y.dispose())}return c}async close(t){const i=this.M.get(t);try{if(this.L.delete(t),this.N.delete(t)&&n.O)try{await m.Promises.fdatasync(t)}catch(s){n.configureFlushOnWrite(!1),this.a.error(s)}return await m.Promises.close(t)}catch(s){throw this.Y(s)}finally{i&&(this.M.get(t)===i&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.M.delete(t)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),i.dispose())}}async read(t,i,s,o,c){const y=this.P(t,i);let b=null;try{b=(await m.Promises.read(t,s,o,c,y)).bytesRead}catch(g){throw this.Y(g)}finally{this.Q(t,y,b)}return b}P(t,i){return i===this.L.get(t)?null:i}Q(t,i,s){const o=this.L.get(t);typeof o=="number"&&(typeof i=="number"||(typeof s=="number"?this.L.set(t,o+s):this.L.delete(t)))}async write(t,i,s,o,c){return(0,l.retry)(()=>this.R(t,i,s,o,c),100,3)}async R(t,i,s,o,c){const y=this.P(t,i);let b=null;try{b=(await m.Promises.write(t,s,o,c,y)).bytesWritten}catch(g){throw await this.Z(this.N.get(t),g)}finally{this.Q(t,y,b)}return b}async mkdir(t){try{await m.Promises.mkdir(this.z(t))}catch(i){throw this.Y(i)}}async delete(t,i){try{const s=this.z(t);i.recursive?await m.Promises.rm(s,m.RimRafMode.MOVE):await m.Promises.unlink(s)}catch(s){throw this.Y(s)}}async rename(t,i,s){const o=this.z(t),c=this.z(i);if(o!==c)try{await this.S(t,i,"move",s.overwrite),await m.Promises.move(o,c)}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error((0,E.localize)(2,null,(0,P.basename)(o),(0,P.basename)((0,P.dirname)(c)),y.toString()))),this.Y(y)}}async copy(t,i,s){const o=this.z(t),c=this.z(i);if(o!==c)try{await this.S(t,i,"copy",s.overwrite),await m.Promises.copy(o,c,{preserveSymlinks:!0})}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error((0,E.localize)(3,null,(0,P.basename)(o),(0,P.basename)((0,P.dirname)(c)),y.toString()))),this.Y(y)}}async S(t,i,s,o){const c=this.z(t),y=this.z(i);let b=!1;if(!!(this.capabilities&1024)||(b=(0,I.isEqual)(c,y,!0)),b&&s==="copy")throw(0,a.createFileSystemProviderError)((0,E.localize)(4,null),a.FileSystemProviderErrorCode.FileExists);if(!b&&await m.Promises.exists(y)){if(!o)throw(0,a.createFileSystemProviderError)((0,E.localize)(5,null),a.FileSystemProviderErrorCode.FileExists);await this.delete(i,{recursive:!0,useTrash:!1})}}async cloneFile(t,i){return this.U(t,i,!1)}async U(t,i,s){const o=this.z(t),c=this.z(i),y=!!(this.capabilities&1024);if((0,I.isEqual)(o,c,!y))return;const b=new w.DisposableStore;try{const[g,D]=await Promise.all([this.I(t),this.I(i)]);b.add(g),b.add(D),s&&await m.Promises.mkdir((0,P.dirname)(c),{recursive:!0}),await m.Promises.copyFile(o,c)}catch(g){if(g.code==="ENOENT"&&!s)return this.U(t,i,!0);throw this.Y(g)}finally{b.dispose()}}p(t,i,s){return new v.UniversalWatcherClient(o=>t(o),o=>i(o),s)}w(t,i,s){return new L.NodeJSWatcherClient(o=>t(o),o=>i(o),s)}Y(t){if(t instanceof a.FileSystemProviderError)return t;let i;switch(t.code){case"ENOENT":i=a.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=a.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=a.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=a.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=a.FileSystemProviderErrorCode.NoPermissions;break;default:i=a.FileSystemProviderErrorCode.Unknown}return(0,a.createFileSystemProviderError)(t,i)}async Z(t,i){let s=this.Y(i);if(t&&s.code===a.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await m.SymlinkSupport.stat(this.z(t));o.mode&128||(s=(0,a.createFileSystemProviderError)(i,a.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.a.trace(o)}return s}}n.C=!1,n.O=!0,e.DiskFileSystemProvider=n}),define(re[105],oe([0,1,3,2,5,9]),function(te,e,O,U,l,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessLifecycleService=e.ISharedProcessLifecycleService=void 0,e.ISharedProcessLifecycleService=(0,l.createDecorator)("sharedProcessLifecycleService");let N=class extends U.Disposable{constructor(I){super(),this.b=I,this.a=this.D(new O.Emitter),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};N=ye([G(0,T.ILogService)],N),e.SharedProcessLifecycleService=N}),define(re[106],oe([0,1,11,3,9,2]),function(te,e,O,U,l,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class N extends l.AbstractLoggerService{constructor(S,p,f,m,E){super(p,f,m),this.n=S,this.p=E,this.D(E.listen("onDidChangeLogLevel",S)(a=>{(0,l.isLogLevel)(a)?super.setLogLevel(a):super.setLogLevel(O.URI.revive(a[0]),a[1])})),this.D(E.listen("onDidChangeVisibility",S)(([a,u])=>super.setVisibility(O.URI.revive(a),u))),this.D(E.listen("onDidChangeLoggers",S)(({added:a,removed:u})=>{for(const h of a)super.registerLogger({...h,resource:O.URI.revive(h.resource)});for(const h of u)super.deregisterLogger(h.resource)}))}createConsoleMainLogger(){return new l.AdapterLogger({log:(S,p)=>{this.p.call("consoleLog",[S,p])}})}registerLogger(S){super.registerLogger(S),this.p.call("registerLogger",[S,this.n])}deregisterLogger(S){super.deregisterLogger(S),this.p.call("deregisterLogger",[S,this.n])}setLogLevel(S,p){super.setLogLevel(S,p),this.p.call("setLogLevel",[S,p])}setVisibility(S,p){super.setVisibility(S,p),this.p.call("setVisibility",[S,p])}m(S,p,f){return new R(this.p,S,p,f,this.n)}static setLogLevel(S,p,f){return S.call("setLogLevel",[p,f])}}e.LoggerChannelClient=N;class R extends l.AbstractMessageLogger{constructor(S,p,f,m,E){super(m?.logLevel==="always"),this.m=S,this.n=p,this.k=!1,this.l=[],this.setLevel(f),this.m.call("createLogger",[p,m,E]).then(()=>{this.q(this.l),this.k=!0})}g(S,p){const f=[[S,p]];this.k?this.q(f):this.l.push(...f)}q(S){this.m.call("log",[this.n,S])}}class I{constructor(S,p){this.a=S,this.b=p}listen(S,p){const f=this.b(S);switch(p){case"onDidChangeLoggers":return U.Event.map(this.a.onDidChangeLoggers,m=>({added:[...m.added].map(E=>this.c(E,f)),removed:[...m.removed].map(E=>this.c(E,f))}));case"onDidChangeVisibility":return U.Event.map(this.a.onDidChangeVisibility,m=>[f.transformOutgoingURI(m[0]),m[1]]);case"onDidChangeLogLevel":return U.Event.map(this.a.onDidChangeLogLevel,m=>(0,l.isLogLevel)(m)?m:[f.transformOutgoingURI(m[0]),m[1]])}throw new Error(`Event not found: ${p}`)}async call(S,p,f){const m=this.b(S);switch(p){case"setLogLevel":return(0,l.isLogLevel)(f[0])?this.a.setLogLevel(f[0]):this.a.setLogLevel(O.URI.revive(m.transformIncoming(f[0][0])),f[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(E=>this.c(E,m)))}throw new Error(`Call not found: ${p}`)}c(S,p){return{...S,resource:p.transformOutgoingURI(S.resource)}}}e.LoggerChannel=I;class w extends T.Disposable{constructor(S,p){super(),p.call("setLogLevel",[S.getLogLevel()]),this.D(S.onDidChangeLogLevel(f=>p.call("setLogLevel",[f]))),p.call("getRegisteredLoggers").then(f=>{for(const m of f)S.registerLogger({...m,resource:O.URI.revive(m.resource)})}),this.D(p.listen("onDidChangeVisibility")(([f,m])=>S.setVisibility(O.URI.revive(f),m))),this.D(p.listen("onDidChangeLoggers")(({added:f,removed:m})=>{for(const E of f)S.registerLogger({...E,resource:O.URI.revive(E.resource)});for(const E of m)S.deregisterLogger(E.resource)}))}}e.RemoteLoggerChannelClient=w}),define(re[214],oe([0,1,2,9]),function(te,e,O,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class l extends O.Disposable{constructor(N,R=[]){super(),this.a=new U.MultiplexLogger([N,...R]),this.D(N.onDidChangeLogLevel(I=>this.setLevel(I)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(N){this.a.setLevel(N)}getLevel(){return this.a.getLevel()}trace(N,...R){this.a.trace(N,...R)}debug(N,...R){this.a.debug(N,...R)}info(N,...R){this.a.info(N,...R)}warn(N,...R){this.a.warn(N,...R)}error(N,...R){this.a.error(N,...R)}flush(){this.a.flush()}}e.LogService=l}),define(re[57],oe([0,1,5]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,O.createDecorator)("nativeHostService")}),define(re[58],oe([0,1,3,63,2,5]),function(te,e,O,U,l,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,T.createDecorator)("policy");class N extends l.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.D(new O.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(w){const P=Object.keys(this.f).length;return this.f={...w,...this.f},P!==Object.keys(this.f).length&&await this.i(w),U.Iterable.reduce(this.g.entries(),(S,[p,f])=>({...S,[p]:f}),{})}getPolicyValue(w){return this.g.get(w)}serialize(){return U.Iterable.reduce(Object.entries(this.f),(w,[P,S])=>({...w,[P]:{definition:S,value:this.g.get(P)}}),{})}}e.AbstractPolicyService=N;class R{constructor(){this.onDidChange=O.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=R}),define(re[215],oe([0,1,3,2,58]),function(te,e,O,U,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class T{constructor(I){this.b=I,this.a=new U.DisposableStore}listen(I,w){switch(w){case"onDidChange":return O.Event.map(this.b.onDidChange,P=>P.reduce((S,p)=>({...S,[p]:this.b.getPolicyValue(p)??null}),{}),this.a)}throw new Error(`Event not found: ${w}`)}call(I,w,P){switch(w){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(P)}throw new Error(`Call not found: ${w}`)}dispose(){this.a.dispose()}}e.PolicyChannel=T;class N extends l.AbstractPolicyService{constructor(I,w){super(),this.a=w;for(const P in I){const{definition:S,value:p}=I[P];this.f[P]=S,p!==void 0&&this.g.set(P,p)}this.a.listen("onDidChange")(P=>{for(const S in P){const p=P[S];p===null?this.g.delete(S):this.g.set(S,p)}this.h.fire(Object.keys(P))})}async i(I){const w=await this.a.call("updatePolicyDefinitions",I);for(const P in w)this.g.set(P,w[P])}}e.PolicyChannelClient=N}),define(re[107],oe([0,1,4,36]),function(te,e,O,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let l;if(typeof O.globals.vscode<"u"&&typeof O.globals.vscode.context<"u"){const T=O.globals.vscode.context.configuration();if(T)l=T.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(l=globalThis._VSCODE_PRODUCT_JSON,U.env.VSCODE_DEV&&Object.assign(l,{nameShort:`${l.nameShort} Dev`,nameLong:`${l.nameLong} Dev`,dataFolderName:`${l.dataFolderName}-dev`,serverDataFolderName:l.serverDataFolderName?`${l.serverDataFolderName}-dev`:void 0}),!l.version){const T=globalThis._VSCODE_PACKAGE_JSON;Object.assign(l,{version:T.version})}}else l={},Object.keys(l).length===0&&Object.assign(l,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=l}),define(re[26],oe([0,1,5]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,O.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(re[216],oe([0,1,6,10,2,13,28,9,26]),function(te,e,O,U,l,T,N,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let w=class extends l.Disposable{constructor(S,p,f){super(),this.b=p,this.c=f,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,S&&this.D(new O.RunOnceScheduler(()=>{this.f(S)},3e4)).schedule()}async f(S){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const p=Date.now(),f=(0,T.dirname)(S),m=(0,T.basename)(S),E=await N.Promises.readdir(f);await Promise.all(E.map(async a=>{if(a===m)return;const u=(0,T.join)(f,a),h=await N.Promises.stat(u);if(h.isDirectory()&&p-h.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${a}.`),N.Promises.rm(u)}))}catch(p){(0,U.onUnexpectedError)(p)}}};w=ye([G(1,I.IProductService),G(2,R.ILogService)],w),e.CodeCacheCleaner=w}),define(re[217],oe([0,1,6,10,2,13,28,15,9,26]),function(te,e,O,U,l,T,N,R,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let P=class extends l.Disposable{constructor(p,f,m){super(),this.b=p,this.c=f,this.f=m,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.D(new O.RunOnceScheduler(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const p=Object.create(null),f=JSON.parse(await N.Promises.readFile((0,T.join)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const h of Object.keys(f)){const d=f[h];p[`${d.hash}.${h}`]=!0}const m=(0,T.join)(this.b.userDataPath,"clp");if(!await N.Promises.exists(m))return;const a=await N.Promises.readdir(m);for(const h of a){if(p[h]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${h}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${h}`),await N.Promises.rm((0,T.join)(m,h))}const u=Date.now();for(const h of Object.keys(p)){const d=(0,T.join)(m,h),v=await N.Promises.readdir(d);for(const L of v){if(L==="tcf.json")continue;const n=(0,T.join)(d,L),r=await N.Promises.stat(n);r.isDirectory()&&u-r.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,T.join)(h,L)}`),await N.Promises.rm(n))}}}catch(p){(0,U.onUnexpectedError)(p)}}};P=ye([G(0,R.INativeEnvironmentService),G(1,I.ILogService),G(2,w.IProductService)],P),e.LanguagePackCachedDataCleaner=P}),define(re[218],oe([0,1,13,5]),function(te,e,O,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,U.createDecorator)("IV8InspectProfilingService");var l;(function(T){function N(I){return Boolean(I.samples&&I.timeDeltas)}T.isValidProfile=N;function R(I,w="noAbsolutePaths"){for(const P of I.nodes)P.callFrame&&P.callFrame.url&&((0,O.isAbsolute)(P.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(P.callFrame.url))&&(P.callFrame.url=(0,O.join)(w,(0,O.basename)(P.callFrame.url)));return I}T.rewriteAbsolutePaths=R})(l=e.Utils||(e.Utils={}))}),define(re[219],oe([0,1,31]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class U{constructor(){this.a=new Map}async startProfiling(T){const R=await(await new Promise((w,P)=>{te(["v8-inspect-profiler"],w,P)})).startProfiling({port:T.port,checkForPaused:!0}),I=(0,O.generateUuid)();return this.a.set(I,R),I}async stopProfiling(T){const N=this.a.get(T);if(!N)throw new Error(`UNKNOWN session '${T}'`);const R=await N.stop();return this.a.delete(T),R.profile}}e.InspectProfilingService=U}),define(re[40],oe([0,1,129,12]),function(te,e,O,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class l{constructor(){this.a=new Map}add(N,R){O.ok(U.isString(N)),O.ok(U.isObject(R)),O.ok(!this.a.has(N),"There is already an extension with this id"),this.a.set(N,R)}knows(N){return this.a.has(N)}as(N){return this.a.get(N)||null}}e.Registry=new l}),define(re[108],oe([0,1,3,40]),function(te,e,O,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function l(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class T{constructor(){this.b=new O.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(I,w){this.a[l(I)]=w,this.b.fire(I)}notifySchemaChanged(I){this.b.fire(I)}getSchemaContributions(){return{schemas:this.a}}}const N=new T;U.Registry.add(e.Extensions.JSONContribution,N)}),define(re[45],oe([0,1,21,3,12,154,17,108,40]),function(te,e,O,U,l,T,N,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var w;(function(L){L.Multiline="multilineText",L.Singleline="singlelineText"})(w=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var P;(function(L){L[L.APPLICATION=1]="APPLICATION",L[L.MACHINE=2]="MACHINE",L[L.WINDOW=3]="WINDOW",L[L.RESOURCE=4]="RESOURCE",L[L.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",L[L.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const S=I.Registry.as(R.Extensions.JSONContribution);class p{constructor(){this.h=new Set,this.i=new U.Emitter,this.onDidSchemaChange=this.i.event,this.j=new U.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},S.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(n,r=!0){this.registerConfigurations([n],r)}registerConfigurations(n,r=!0){const t=new Set;this.n(n,r,t),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:t})}deregisterConfigurations(n){const r=new Set;this.o(n,r),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:n,remove:r}){const t=new Set;this.o(r,t),this.n(n,!1,t),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:t})}registerDefaultConfigurations(n){const r=new Set;this.k(n,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(n,r){const t=[];for(const{overrides:i,source:s}of n)for(const o in i)if(r.add(o),e.OVERRIDE_PROPERTY_REGEX.test(o)){const c=this.a.get(o),y=c?.valuesSources??new Map;if(s)for(const A of Object.keys(i[o]))y.set(A,s);const b={...c?.value||{},...i[o]};this.a.set(o,{source:s,value:b,valuesSources:y});const g=(0,N.getLanguageTagSettingPlainKey)(o),D={type:"object",default:b,description:T.localize(1,null,g),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:b,source:l.isString(s)?void 0:s,defaultValueSource:s};t.push(...E(o)),this.d[o]=D,this.b.properties[o]=D}else{this.a.set(o,{value:i[o],source:s});const c=this.d[o];c&&(this.w(o,c),this.r(o,c))}this.m(t)}deregisterDefaultConfigurations(n){const r=new Set;this.l(n,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(n,r){for(const{overrides:t,source:i}of n)for(const s in t){const o=this.a.get(s),c=l.isString(i)?i:i?.id,y=l.isString(o?.source)?o?.source:o?.source?.id;if(c===y)if(r.add(s),this.a.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.d[s],delete this.b.properties[s];else{const b=this.d[s];b&&(this.w(s,b),this.r(s,b))}}this.u()}deltaConfiguration(n){let r=!1;const t=new Set;n.removedDefaults&&(this.l(n.removedDefaults,t),r=!0),n.addedDefaults&&(this.k(n.addedDefaults,t),r=!0),n.removedConfigurations&&this.o(n.removedConfigurations,t),n.addedConfigurations&&this.n(n.addedConfigurations,!1,t),this.i.fire(),this.j.fire({properties:t,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...n){this.i.fire()}registerOverrideIdentifiers(n){this.m(n),this.i.fire()}m(n){for(const r of n)this.h.add(r);this.u()}n(n,r,t){n.forEach(i=>{this.p(i,r,i.extensionInfo,i.restrictedProperties,void 0,t),this.c.push(i),this.q(i)})}o(n,r){const t=i=>{if(i.properties)for(const s in i.properties){r.add(s);const o=this.d[s];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[s],this.s(s,i.properties[s])}i.allOf?.forEach(s=>t(s))};for(const i of n){t(i);const s=this.c.indexOf(i);s!==-1&&this.c.splice(s,1)}}p(n,r=!0,t,i,s=3,o){s=l.isUndefinedOrNull(n.scope)?s:n.scope;const c=n.properties;if(c)for(const b in c){const g=c[b];if(r&&d(b,g)){delete c[b];continue}if(g.source=t,g.defaultDefaultValue=c[b].default,this.w(b,g),e.OVERRIDE_PROPERTY_REGEX.test(b)?g.scope=void 0:(g.scope=l.isUndefinedOrNull(g.scope)?s:g.scope,g.restricted=l.isUndefinedOrNull(g.restricted)?!!i?.includes(b):g.restricted),c[b].hasOwnProperty("included")&&!c[b].included){this.f[b]=c[b],delete c[b];continue}else this.d[b]=c[b],c[b].policy?.name&&this.e.set(c[b].policy.name,b);!c[b].deprecationMessage&&c[b].markdownDeprecationMessage&&(c[b].deprecationMessage=c[b].markdownDeprecationMessage),o.add(b)}const y=n.allOf;if(y)for(const b of y)this.p(b,r,t,i,s,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(n){const r=t=>{const i=t.properties;if(i)for(const o in i)this.r(o,i[o]);t.allOf?.forEach(r)};r(n)}r(n,r){switch(e.allSettings.properties[n]=r,r.scope){case 1:e.applicationSettings.properties[n]=r;break;case 2:e.machineSettings.properties[n]=r;break;case 6:e.machineOverridableSettings.properties[n]=r;break;case 3:e.windowSettings.properties[n]=r;break;case 4:e.resourceSettings.properties[n]=r;break;case 5:e.resourceSettings.properties[n]=r,this.g.properties[n]=r;break}}s(n,r){switch(delete e.allSettings.properties[n],r.scope){case 1:delete e.applicationSettings.properties[n];break;case 2:delete e.machineSettings.properties[n];break;case 6:delete e.machineOverridableSettings.properties[n];break;case 3:delete e.windowSettings.properties[n];break;case 4:case 5:delete e.resourceSettings.properties[n],delete this.g.properties[n];break}}u(){for(const n of this.h.values()){const r=`[${n}]`,t={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(r,t),e.allSettings.properties[r]=t,e.applicationSettings.properties[r]=t,e.machineSettings.properties[r]=t,e.machineOverridableSettings.properties[r]=t,e.windowSettings.properties[r]=t,e.resourceSettings.properties[r]=t}}v(){const n={type:"object",description:T.localize(4,null),errorMessage:T.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,this.i.fire()}w(n,r){const t=this.a.get(n);let i=t?.value,s=t?.source;l.isUndefined(i)&&(i=r.defaultDefaultValue,s=void 0),l.isUndefined(i)&&(i=u(r.type)),r.default=i,r.defaultValueSource=s}}const f="\\[([^\\]]+)\\]",m=new RegExp(f,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${f})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function E(L){const n=[];if(e.OVERRIDE_PROPERTY_REGEX.test(L)){let r=m.exec(L);for(;r?.length;){const t=r[1].trim();t&&n.push(t),r=m.exec(L)}}return(0,O.distinct)(n)}e.overrideIdentifiersFromKey=E;function a(L){return L.reduce((n,r)=>`${n}[${r}]`,"")}e.keyFromOverrideIdentifiers=a;function u(L){switch(Array.isArray(L)?L[0]:L){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=u;const h=new p;I.Registry.add(e.Extensions.Configuration,h);function d(L,n){return L.trim()?e.OVERRIDE_PROPERTY_REGEX.test(L)?T.localize(7,null,L):h.getConfigurationProperties()[L]!==void 0?T.localize(8,null,L):n.policy?.name&&h.getPolicyConfigurations().get(n.policy?.name)!==void 0?T.localize(9,null,L,n.policy?.name,h.getPolicyConfigurations().get(n.policy?.name)):null:T.localize(6,null)}e.validateProperty=d;function v(){const L=[],n=h.getConfigurationProperties();for(const r of Object.keys(n))L.push([r,n[r].scope]);return L.push(["launch",4]),L.push(["task",4]),L}e.getScopes=v}),define(re[75],oe([0,1,21,3,35,2,37,32,12,11,17,45,40]),function(te,e,O,U,l,T,N,R,I,w,P,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function f(r){return Object.isFrozen(r)?r:R.deepFreeze(r)}class m{constructor(t={},i=[],s=[],o){this.b=t,this.c=i,this.d=s,this.raw=o,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const t=this.raw.map(i=>{if(i instanceof m)return i;const s=new E("");return s.parseRaw(i),s.configurationModel});this.f=t.reduce((i,s)=>s===i?s:i.merge(s),t[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,P.getConfigurationValue)(this.contents,t):this.contents}inspect(t,i){const s=this.rawConfiguration.getValue(t),o=i?this.rawConfiguration.getOverrideValue(t,i):void 0,c=i?this.rawConfiguration.override(i).getValue(t):s;return{value:s,override:o,merged:c}}getOverrideValue(t,i){const s=this.i(i);return s?t?(0,P.getConfigurationValue)(s,t):s:void 0}getKeysForOverrideIdentifier(t){const i=[];for(const s of this.overrides)s.identifiers.includes(t)&&i.push(...s.keys);return O.distinct(i)}getAllOverrideIdentifiers(){const t=[];for(const i of this.overrides)t.push(...i.identifiers);return O.distinct(t)}override(t){let i=this.a.get(t);return i||(i=this.g(t),this.a.set(t,i)),i}merge(...t){const i=R.deepClone(this.contents),s=R.deepClone(this.overrides),o=[...this.keys],c=this.raw?.length?[...this.raw]:[this];for(const y of t)if(c.push(...y.raw?.length?y.raw:[y]),!y.isEmpty()){this.h(i,y.contents);for(const b of y.overrides){const[g]=s.filter(D=>O.equals(D.identifiers,b.identifiers));g?(this.h(g.contents,b.contents),g.keys.push(...b.keys),g.keys=O.distinct(g.keys)):s.push(R.deepClone(b))}for(const b of y.keys)o.indexOf(b)===-1&&o.push(b)}return new m(i,o,s,c.every(y=>y instanceof m)?void 0:c)}g(t){const i=this.i(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const s={};for(const o of O.distinct([...Object.keys(this.contents),...Object.keys(i)])){let c=this.contents[o];const y=i[o];y&&(typeof c=="object"&&typeof y=="object"?(c=R.deepClone(c),this.h(c,y)):c=y),s[o]=c}return new m(s,this.keys,this.overrides)}h(t,i){for(const s of Object.keys(i)){if(s in t&&I.isObject(t[s])&&I.isObject(i[s])){this.h(t[s],i[s]);continue}t[s]=R.deepClone(i[s])}}i(t){let i=null,s=null;const o=c=>{c&&(s?this.h(s,c):s=R.deepClone(c))};for(const c of this.overrides)O.equals(c.identifiers,[t])?i=c.contents:c.identifiers.includes(t)&&o(c.contents);return o(i),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,i){this.j(t,i,!0)}setValue(t,i){this.j(t,i,!1)}removeValue(t){const i=this.keys.indexOf(t);i!==-1&&(this.keys.splice(i,1),(0,P.removeFromValueTree)(this.contents,t),S.OVERRIDE_PROPERTY_REGEX.test(t)&&this.overrides.splice(this.overrides.findIndex(s=>O.equals(s.identifiers,(0,S.overrideIdentifiersFromKey)(t))),1))}j(t,i,s){(0,P.addToValueTree)(this.contents,t,i,o=>console.error(o)),s=s||this.keys.indexOf(t)===-1,s&&this.keys.push(t),S.OVERRIDE_PROPERTY_REGEX.test(t)&&this.overrides.push({identifiers:(0,S.overrideIdentifiersFromKey)(t),keys:Object.keys(this.contents[t]),contents:(0,P.toValuesTree)(this.contents[t],o=>console.error(o))})}}e.ConfigurationModel=m;class E{constructor(t){this.f=t,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new m}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,i){if(!I.isUndefinedOrNull(t)){const s=this.g(t);this.parseRaw(s,i)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,i){this.a=t;const{contents:s,keys:o,overrides:c,restricted:y,hasExcludedProperties:b}=this.h(t,i);this.b=new m(s,o,c,b?[t]:void 0),this.c=y||[]}g(t){let i={},s=null,o=[];const c=[],y=[];function b(D){Array.isArray(o)?o.push(D):s!==null&&(o[s]=D)}const g={onObjectBegin:()=>{const D={};b(D),c.push(o),o=D,s=null},onObjectProperty:D=>{s=D},onObjectEnd:()=>{o=c.pop()},onArrayBegin:()=>{const D=[];b(D),c.push(o),o=D,s=null},onArrayEnd:()=>{o=c.pop()},onLiteralValue:b,onError:(D,A,F)=>{y.push({error:D,offset:A,length:F})}};if(t)try{l.visit(t,g),i=o[0]||{}}catch(D){console.error(`Error while parsing settings file ${this.f}: ${D}`),this.d=[D]}return i}h(t,i){const s=p.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),o=this.i(t,s,!0,i);t=o.raw;const c=(0,P.toValuesTree)(t,g=>console.error(`Conflict in settings file ${this.f}: ${g}`)),y=Object.keys(t),b=this.j(t,g=>console.error(`Conflict in settings file ${this.f}: ${g}`));return{contents:c,keys:y,overrides:b,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}i(t,i,s,o){let c=!1;if(!o?.scopes&&!o?.skipRestricted)return{raw:t,restricted:[],hasExcludedProperties:c};const y={},b=[];for(const g in t)if(S.OVERRIDE_PROPERTY_REGEX.test(g)&&s){const D=this.i(t[g],i,!1,o);y[g]=D.raw,c=c||D.hasExcludedProperties,b.push(...D.restricted)}else{const D=i[g],A=D?typeof D.scope<"u"?D.scope:3:void 0;D?.restricted&&b.push(g),(A===void 0||o.scopes===void 0||o.scopes.includes(A))&&!(o.skipRestricted&&D?.restricted)?y[g]=t[g]:c=!0}return{raw:y,restricted:b,hasExcludedProperties:c}}j(t,i){const s=[];for(const o of Object.keys(t))if(S.OVERRIDE_PROPERTY_REGEX.test(o)){const c={};for(const y in t[o])c[y]=t[o][y];s.push({identifiers:(0,S.overrideIdentifiersFromKey)(o),keys:Object.keys(c),contents:(0,P.toValuesTree)(c,i)})}return s}}e.ConfigurationModelParser=E;class a extends T.Disposable{constructor(t,i,s,o){super(),this.f=t,this.g=i,this.h=o,this.c=this.D(new U.Emitter),this.onDidChange=this.c.event,this.a=new E(this.f.toString()),this.b={scopes:this.g},this.D(this.h.watch(s.dirname(this.f))),this.D(this.h.watch(this.f)),this.D(U.Event.any(U.Event.filter(this.h.onDidFilesChange,c=>c.contains(this.f)),U.Event.filter(this.h.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(3)||c.isOperation(1)||c.isOperation(4))&&s.isEqual(c.resource,t)))(()=>this.c.fire()))}async loadConfiguration(){try{const t=await this.h.readFile(this.f);return this.a.parse(t.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new m}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=a;class u{constructor(t,i,s,o,c,y,b,g,D,A,F,j,x){this.a=t,this.b=i,this.c=s,this.overrideIdentifiers=o,this.d=c,this.f=y,this.g=b,this.h=g,this.i=D,this.j=A,this.k=F,this.l=j,this.m=x}get value(){return f(this.c)}n(t,i,s){const o=t.inspect(i,s);return{get value(){return f(o.value)},get override(){return f(o.override)},get merged(){return f(o.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class h{constructor(t,i,s,o,c=new m,y=new m,b=new N.ResourceMap,g=new m,D=new N.ResourceMap){this.c=t,this.d=i,this.f=s,this.g=o,this.h=c,this.i=y,this.j=b,this.l=g,this.m=D,this.a=null,this.b=new N.ResourceMap,this.n=null}getValue(t,i,s){return this.q(t,i,s).getValue(t)}updateValue(t,i,s={}){let o;s.resource?(o=this.m.get(s.resource),o||(o=new m,this.m.set(s.resource,o))):o=this.l,i===void 0?o.removeValue(t):o.setValue(t,i),s.resource||(this.a=null)}inspect(t,i,s){const o=this.q(t,i,s),c=this.u(i.resource,s),y=i.resource?this.m.get(i.resource)||this.l:this.l,b=new Set;for(const g of o.overrides)for(const D of g.identifiers)o.getOverrideValue(t,D)!==void 0&&b.add(D);return new u(t,i,o.getValue(t),b.size?[...b]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,s?this.i:void 0,c||void 0,y)}keys(t){const i=this.u(void 0,t);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(t){this.c=t,this.a=null,this.b.clear()}updatePolicyConfiguration(t){this.d=t}updateApplicationConfiguration(t){this.f=t,this.a=null,this.b.clear()}updateLocalUserConfiguration(t){this.g=t,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(t){this.h=t,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(t){this.i=t,this.a=null,this.b.clear()}updateFolderConfiguration(t,i){this.j.set(t,i),this.b.delete(t)}deleteFolderConfiguration(t){this.p.delete(t),this.b.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const s=[];if(!i){const{added:o,updated:c,removed:y}=L(this.c,t);i=[...o,...c,...y]}for(const o of i)for(const c of(0,S.overrideIdentifiersFromKey)(o)){const y=this.c.getKeysForOverrideIdentifier(c),b=t.getKeysForOverrideIdentifier(c),g=[...b.filter(D=>y.indexOf(D)===-1),...y.filter(D=>b.indexOf(D)===-1),...y.filter(D=>!R.equals(this.c.override(c).getValue(D),t.override(c).getValue(D)))];s.push([c,g])}return this.updateDefaultConfiguration(t),{keys:i,overrides:s}}compareAndUpdatePolicyConfiguration(t){const{added:i,updated:s,removed:o}=L(this.d,t),c=[...i,...s,...o];return c.length&&this.updatePolicyConfiguration(t),{keys:c,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:i,updated:s,removed:o,overrides:c}=L(this.applicationConfiguration,t),y=[...i,...s,...o];return y.length&&this.updateApplicationConfiguration(t),{keys:y,overrides:c}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:s,removed:o,overrides:c}=L(this.localUserConfiguration,t),y=[...i,...s,...o];return y.length&&this.updateLocalUserConfiguration(t),{keys:y,overrides:c}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:s,removed:o,overrides:c}=L(this.remoteUserConfiguration,t),y=[...i,...s,...o];return y.length&&this.updateRemoteUserConfiguration(t),{keys:y,overrides:c}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:s,removed:o,overrides:c}=L(this.workspaceConfiguration,t),y=[...i,...s,...o];return y.length&&this.updateWorkspaceConfiguration(t),{keys:y,overrides:c}}compareAndUpdateFolderConfiguration(t,i){const s=this.p.get(t),{added:o,updated:c,removed:y,overrides:b}=L(s,i),g=[...o,...c,...y];return(g.length||!s)&&this.updateFolderConfiguration(t,i),{keys:g,overrides:b}}compareAndDeleteFolderConfiguration(t){const i=this.p.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:o,removed:c,overrides:y}=L(i,void 0);return{keys:[...s,...o,...c],overrides:y}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(t,i,s){let o=this.r(i,s);return i.overrideIdentifier&&(o=o.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(t)!==void 0&&(o=o.merge(this.d)),o}r({resource:t},i){let s=this.s();if(i&&t){const o=i.getFolder(t);o&&(s=this.t(o.uri)||s);const c=this.m.get(t);c&&(s=s.merge(c))}return s}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(t){let i=this.b.get(t);if(!i){const s=this.s(),o=this.j.get(t);o?(i=s.merge(o),this.b.set(t,i)):i=s}return i}u(t,i){if(i&&t){const s=i.getFolder(t);if(s)return this.j.get(s.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((t,i)=>{const{contents:s,overrides:o,keys:c}=this.j.get(i);return t.push([i,{contents:s,overrides:o,keys:c}]),t},[])}}allKeys(){const t=new Set;return this.c.keys.forEach(i=>t.add(i)),this.userConfiguration.keys.forEach(i=>t.add(i)),this.i.keys.forEach(i=>t.add(i)),this.j.forEach(i=>i.keys.forEach(s=>t.add(s))),[...t.values()]}v(){const t=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(s=>t.add(s))),[...t.values()]}w(t){const i=new Set;return this.c.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this.i.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this.j.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(o=>i.add(o))),[...i.values()]}static parse(t){const i=this.x(t.defaults),s=this.x(t.policy),o=this.x(t.application),c=this.x(t.user),y=this.x(t.workspace),b=t.folders.reduce((g,D)=>(g.set(w.URI.revive(D[0]),this.x(D[1])),g),new N.ResourceMap);return new h(i,s,o,c,new m,y,b,new m,new N.ResourceMap)}static x(t){return new m(t.contents,t.keys,t.overrides)}}e.Configuration=h;function d(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const t=new Set,i=new Map;for(const o of r)o.keys.forEach(c=>t.add(c)),o.overrides.forEach(([c,y])=>{const b=(0,N.getOrSet)(i,c,new Set);y.forEach(g=>b.add(g))});const s=[];return i.forEach((o,c)=>s.push([c,[...o.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=d;class v{constructor(t,i,s,o){this.change=t,this.f=i,this.g=s,this.h=o,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const c of t.keys)this.affectedKeys.add(c);for(const[,c]of t.overrides)for(const y of c)this.affectedKeys.add(y);this.d=this.a;for(const c of this.affectedKeys)this.d+=c+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=h.parse(this.f.data)),this.i}affectsConfiguration(t,i){const s=this.a+t,o=this.d.indexOf(s);if(o<0)return!1;const c=o+s.length;if(c>=this.d.length)return!1;const y=this.d.charCodeAt(c);if(y!==this.b&&y!==this.c)return!1;if(i){const b=this.previousConfiguration?this.previousConfiguration.getValue(t,i,this.f?.workspace):void 0,g=this.g.getValue(t,i,this.h);return!R.equals(b,g)}return!0}}e.ConfigurationChangeEvent=v;function L(r,t){const{added:i,removed:s,updated:o}=n(t?.rawConfiguration,r?.rawConfiguration),c=[],y=r?.getAllOverrideIdentifiers()||[],b=t?.getAllOverrideIdentifiers()||[];if(t){const g=b.filter(D=>!y.includes(D));for(const D of g)c.push([D,t.getKeysForOverrideIdentifier(D)])}if(r){const g=y.filter(D=>!b.includes(D));for(const D of g)c.push([D,r.getKeysForOverrideIdentifier(D)])}if(t&&r){for(const g of y)if(b.includes(g)){const D=n({contents:r.getOverrideValue(void 0,g)||{},keys:r.getKeysForOverrideIdentifier(g)},{contents:t.getOverrideValue(void 0,g)||{},keys:t.getKeysForOverrideIdentifier(g)});c.push([g,[...D.added,...D.removed,...D.updated]])}}return{added:i,removed:s,updated:o,overrides:c}}function n(r,t){const i=r?t?r.keys.filter(c=>t.keys.indexOf(c)===-1):[...r.keys]:[],s=t?r?t.keys.filter(c=>r.keys.indexOf(c)===-1):[...t.keys]:[],o=[];if(r&&t){for(const c of t.keys)if(r.keys.indexOf(c)!==-1){const y=(0,P.getConfigurationValue)(t.contents,c),b=(0,P.getConfigurationValue)(r.contents,c);R.equals(y,b)||o.push(c)}}return{added:i,removed:s,updated:o}}}),define(re[220],oe([0,1,21,3,2,32,12,75,45,9,58,40]),function(te,e,O,U,l,T,N,R,I,w,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class p extends l.Disposable{constructor(){super(...arguments),this.a=this.D(new U.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new R.ConfigurationModel}get configurationModel(){return this.b}async initialize(){return this.g(),this.D(S.Registry.as(I.Extensions.Configuration).onDidUpdateConfiguration(({properties:a,defaultsOverrides:u})=>this.c(Array.from(a),u))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(a,u){this.h(a,S.Registry.as(I.Extensions.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:a})}f(){return{}}g(){this.b=new R.ConfigurationModel;const a=S.Registry.as(I.Extensions.Configuration).getConfigurationProperties();this.h(Object.keys(a),a)}h(a,u){const h=this.f();for(const d of a){const v=h[d],L=u[d];v!==void 0?this.b.addValue(d,v):L?this.b.addValue(d,L.default):this.b.removeValue(d)}}}e.DefaultConfiguration=p;class f{constructor(){this.onDidChangeConfiguration=U.Event.None,this.configurationModel=new R.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=f;let m=class extends l.Disposable{get configurationModel(){return this.b}constructor(a,u,h){super(),this.c=a,this.f=u,this.g=h,this.a=this.D(new U.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new R.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.D(this.f.onDidChange(a=>this.i(a))),this.D(this.c.onDidChangeConfiguration(async({properties:a})=>this.j(await this.h(a),!0))),this.b}async h(a){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",a);const u={},h=[],d=S.Registry.as(I.Extensions.Configuration).getConfigurationProperties();for(const v of a){const L=d[v];if(!L){h.push(v);continue}if(L.policy){if(L.type!=="string"&&L.type!=="number"){this.g.warn(`Policy ${L.policy.name} has unsupported type ${L.type}`);continue}h.push(v),u[L.policy.name]={type:L.type}}}return(0,N.isEmptyObject)(u)||await this.f.updatePolicyDefinitions(u),h}i(a){this.g.trace("PolicyConfiguration#onDidChangePolicies",a);const u=S.Registry.as(I.Extensions.Configuration).getPolicyConfigurations(),h=(0,O.coalesce)(a.map(d=>u.get(d)));this.j(h,!0)}j(a,u){this.g.trace("PolicyConfiguration#update",a);const h=S.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),d=[],v=this.b.isEmpty();for(const L of a){const n=h[L]?.policy?.name;if(n){const r=this.f.getPolicyValue(n);(v?r!==void 0:!(0,T.equals)(this.b.getValue(L),r))&&d.push([L,r])}else this.b.getValue(L)!==void 0&&d.push([L,void 0])}if(d.length){this.g.trace("PolicyConfiguration#changed",d);const L=this.b;this.b=new R.ConfigurationModel;for(const n of L.keys)this.b.setValue(n,L.getValue(n));for(const[n,r]of d)r===void 0?this.b.removeValue(n):this.b.setValue(n,r);u&&this.a.fire(this.b)}}};m=ye([G(1,P.IPolicyService),G(2,w.ILogService)],m),e.PolicyConfiguration=m}),define(re[221],oe([0,1,6,3,2,23,17,75,220,58]),function(te,e,O,U,l,T,N,R,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class P extends l.Disposable{constructor(p,f,m,E){super(),this.i=p,this.h=this.D(new U.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.D(new I.DefaultConfiguration),this.c=m instanceof w.NullPolicyService?new I.NullPolicyConfiguration:this.D(new I.PolicyConfiguration(this.b,m,E)),this.f=this.D(new R.UserSettings(this.i,void 0,T.extUriBiasedIgnorePathCase,f)),this.a=new R.Configuration(this.b.configurationModel,this.c.configurationModel,new R.ConfigurationModel,new R.ConfigurationModel),this.g=this.D(new O.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.D(this.b.onDidChangeConfiguration(({defaults:a,properties:u})=>this.k(a,u))),this.D(this.c.onDidChangeConfiguration(a=>this.l(a))),this.D(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[p,f,m]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new R.Configuration(p,f,new R.ConfigurationModel,m)}getConfigurationData(){return this.a.toData()}getValue(p,f){const m=typeof p=="string"?p:void 0,E=(0,N.isConfigurationOverrides)(p)?p:(0,N.isConfigurationOverrides)(f)?f:{};return this.a.getValue(m,E,void 0)}updateValue(p,f,m,E){return Promise.reject(new Error("not supported"))}inspect(p){return this.a.inspect(p,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const p=await this.f.loadConfiguration();this.j(p)}j(p){const f=this.a.toData(),m=this.a.compareAndUpdateLocalUserConfiguration(p);this.m(m,f,2)}k(p,f){const m=this.a.toData(),E=this.a.compareAndUpdateDefaultConfiguration(p,f);this.m(E,m,7)}l(p){const f=this.a.toData(),m=this.a.compareAndUpdatePolicyConfiguration(p);this.m(m,f,7)}m(p,f,m){const E=new R.ConfigurationChangeEvent(p,{data:f},this.a);E.source=m,E.sourceConfig=this.n(m),this.h.fire(E)}n(p){switch(p){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=P}),define(re[222],oe([0,1,10,5]),function(te,e,O,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,U.createDecorator)("remoteAuthorityResolverService");var l;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound"})(l=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class T extends O.ErrorNoTelemetry{static isNotAvailable(I){return I instanceof T&&I._code===l.NotAvailable}static isTemporarilyNotAvailable(I){return I instanceof T&&I._code===l.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof T&&I._code===l.NoResolverFound}static isHandled(I){return I instanceof T&&I.isHandled}constructor(I,w=l.Unknown,P){super(I),this._message=I,this._code=w,this._detail=P,this.isHandled=w===l.NotAvailable&&P===!0,Object.setPrototypeOf(this,T.prototype)}}e.RemoteAuthorityResolverError=T;function N(R){const I=R.indexOf("+");return I===-1?R:R.substring(0,I)}e.getRemoteAuthorityPrefix=N}),define(re[76],oe([0,1,22]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function U(w){return w.scheme===O.Schemas.vscodeRemote?w.authority:void 0}e.getRemoteAuthority=U;function l(w){if(!w)return;const P=w.indexOf("+");return P<0?w:w.substr(0,P)}e.getRemoteName=l;function T(w){return`/${w.quality??"oss"}-${w.commit??"dev"}`}e.getRemoteServerRootPath=T;function N(w){const{host:P,port:S}=I(w);if(typeof S>"u")throw new Error("Remote authority doesn't contain a port!");return{host:P,port:S}}e.parseAuthorityWithPort=N;function R(w,P){let{host:S,port:p}=I(w);return typeof p>"u"&&(p=P),{host:S,port:p}}e.parseAuthorityWithOptionalPort=R;function I(w){const P=w.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(P)return{host:P[1],port:parseInt(P[2],10)};const S=w.match(/^(\[[0-9a-z:]+\])$/);if(S)return{host:S[1],port:void 0};const p=w.match(/(.*):(\d+)$/);return p?{host:p[1],port:parseInt(p[2],10)}:{host:w,port:void 0}}}),define(re[46],oe([0,1,27,5,76]),function(te,e,O,U,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function T(E){if(typeof E=="object"&&E!==null&&E.supported!==!0)return E.description}e.getWorkspaceSupportTypeMessage=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var N;(function(E){E[E.System=0]="System",E[E.User=1]="User"})(N=e.ExtensionType||(e.ExtensionType={}));var R;(function(E){E.WIN32_X64="win32-x64",E.WIN32_IA32="win32-ia32",E.WIN32_ARM64="win32-arm64",E.LINUX_X64="linux-x64",E.LINUX_ARM64="linux-arm64",E.LINUX_ARMHF="linux-armhf",E.ALPINE_X64="alpine-x64",E.ALPINE_ARM64="alpine-arm64",E.DARWIN_X64="darwin-x64",E.DARWIN_ARM64="darwin-arm64",E.WEB="web",E.UNIVERSAL="universal",E.UNKNOWN="unknown",E.UNDEFINED="undefined"})(R=e.TargetPlatform||(e.TargetPlatform={}));class I{constructor(a){this.value=a,this.c=a.toLowerCase()}static equals(a,u){if(typeof a>"u"||a===null)return typeof u>"u"||u===null;if(typeof u>"u"||u===null)return!1;if(typeof a=="string"||typeof u=="string"){const h=typeof a=="string"?a:a.value,d=typeof u=="string"?u:u.value;return O.equalsIgnoreCase(h,d)}return a.c===u.c}static toKey(a){return typeof a=="string"?a.toLowerCase():a.c}}e.ExtensionIdentifier=I;class w{get size(){return this.c.size}constructor(a){if(this.c=new Set,a)for(const u of a)this.add(u)}add(a){this.c.add(I.toKey(a))}delete(a){return this.c.delete(I.toKey(a))}has(a){return this.c.has(I.toKey(a))}}e.ExtensionIdentifierSet=w;class P{constructor(){this.c=new Map}clear(){this.c.clear()}delete(a){this.c.delete(I.toKey(a))}get(a){return this.c.get(I.toKey(a))}has(a){return this.c.has(I.toKey(a))}set(a,u){this.c.set(I.toKey(a),u)}values(){return this.c.values()}forEach(a){this.c.forEach(a)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.ExtensionIdentifierMap=P;function S(E){return p(E)}e.isApplicationScopedExtension=S;function p(E){return E.contributes&&E.contributes.localizations?E.contributes.localizations.length>0:!1}e.isLanguagePackExtension=p;function f(E){return E.contributes&&E.contributes.authentication?E.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=f;function m(E,a){if(a){const u=`onResolveRemoteAuthority:${(0,l.getRemoteName)(a)}`;return!!E.activationEvents?.includes(u)}return!1}e.isResolverExtension=m,e.IBuiltinExtensionsScannerService=(0,U.createDecorator)("IBuiltinExtensionsScannerService")}),define(re[223],oe([0,1,2,13,28,46]),function(te,e,O,U,l,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class N extends O.Disposable{constructor(I,w){super(),this.b=I,this.a=(0,U.join)(this.b.userDataPath,T.MANIFEST_CACHE_FOLDER,T.USER_MANIFEST_CACHE_FILE),this.D(w.onDidInstallExtensions(P=>this.c(P))),this.D(w.onDidUninstallExtension(P=>this.f(P)))}c(I){I.some(w=>!!w.local)&&this.invalidate()}f(I){I.error||this.invalidate()}invalidate(){l.Promises.rm(this.a,l.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=N}),define(re[224],oe([0,1,6,16,25,10,3,2,104,90,31,97,222,76]),function(te,e,O,U,l,T,N,R,I,w,P,S,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionHealthChangedEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const m=30*1e3;var E;(function(k){k[k.Management=1]="Management",k[k.ExtensionHost=2]="ExtensionHost",k[k.Tunnel=3]="Tunnel"})(E=e.ConnectionType||(e.ConnectionType={}));function a(k){switch(k){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function u(k){const M=new l.CancellationTokenSource;return setTimeout(()=>M.cancel(),k),M.token}function h(k,M){if(k.isCancellationRequested||M.isCancellationRequested)return l.CancellationToken.Cancelled;const z=new l.CancellationTokenSource;return k.onCancellationRequested(()=>z.cancel()),M.onCancellationRequested(()=>z.cancel()),z.token}class d{get didTimeout(){return this.c==="timedout"}constructor(M){this.c="pending",this.d=new R.DisposableStore,this.promise=new Promise((z,_)=>{this.f=z,this.g=_}),M.isCancellationRequested?this.h():this.d.add(M.onCancellationRequested(()=>this.h()))}registerDisposable(M){this.c==="pending"?this.d.add(M):M.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const M=new Error("Time limit reached");return M.code="ETIMEDOUT",M.syscall="connect",M}resolve(M){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(M))}reject(M){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(M))}}function v(k,M){const z=new d(M);return z.registerDisposable(k.onControlMessage(_=>{const W=JSON.parse(_.toString()),Q=X(W);Q?z.reject(Q):z.resolve(W)})),z.promise}function L(k,M,z,_,W,Q,ee,le,he){const pe=new d(he),de=w.StopWatch.create(!1);return k.info(`Creating a socket (${le})...`),I.mark(`code/willCreateSocket/${ee}`),M.connect(z,_,W,Q,le,(be,Ce)=>{pe.didTimeout?(I.mark(`code/didCreateSocketError/${ee}`),k.info(`Creating a socket (${le}) finished after ${de.elapsed()} ms, but this is too late and has timed out already.`),be&&k.error(be),Ce?.dispose()):be||!Ce?(I.mark(`code/didCreateSocketError/${ee}`),k.info(`Creating a socket (${le}) returned an error after ${de.elapsed()} ms.`),pe.reject(be)):(I.mark(`code/didCreateSocketOK/${ee}`),k.info(`Creating a socket (${le}) was successful after ${de.elapsed()} ms.`),pe.resolve(Ce))}),pe.promise}function n(k,M){const z=new d(M);return k.then(_=>{z.didTimeout||z.resolve(_)},_=>{z.didTimeout||z.reject(_)}),z.promise}async function r(k,M,z,_){const W=q(k,M);k.logService.trace(`${W} 1/6. invoking socketFactory.connect().`);let Q;try{Q=await L(k.logService,k.socketFactory,k.host,k.port,(0,f.getRemoteServerRootPath)(k),`reconnectionToken=${k.reconnectionToken}&reconnection=${k.reconnectionProtocol?"true":"false"}`,a(M),`renderer-${a(M)}-${k.reconnectionToken}`,_)}catch(de){throw k.logService.error(`${W} socketFactory.connect() failed or timed out. Error:`),k.logService.error(de),de}k.logService.trace(`${W} 2/6. socketFactory.connect() was successful.`);let ee,le;k.reconnectionProtocol?(k.reconnectionProtocol.beginAcceptReconnection(Q,null),ee=k.reconnectionProtocol,le=!1):(ee=new S.PersistentProtocol({socket:Q,measureRoundTripTime:!0}),le=!0),k.logService.trace(`${W} 3/6. sending AuthRequest control message.`);const he=await n(k.signService.createNewMessage((0,P.generateUuid)()),_),pe={type:"auth",auth:k.connectionToken||"00000000000000000000",data:he.data};ee.sendControl(U.VSBuffer.fromString(JSON.stringify(pe)));try{const de=await v(ee,h(_,u(1e4)));if(de.type!=="sign"||typeof de.data!="string"){const ke=new Error("Unexpected handshake message");throw ke.code="VSCODE_CONNECTION_ERROR",ke}if(k.logService.trace(`${W} 4/6. received SignRequest control message.`),!await n(k.signService.validate(he,de.signedData),_)){const ke=new Error("Refused to connect to unsupported server");throw ke.code="VSCODE_CONNECTION_ERROR",ke}const Ce=await n(k.signService.sign(de.data),_),Re={type:"connectionType",commit:k.commit,signedData:Ce,desiredConnectionType:M};return z&&(Re.args=z),k.logService.trace(`${W} 5/6. sending ConnectionTypeRequest control message.`),ee.sendControl(U.VSBuffer.fromString(JSON.stringify(Re))),{protocol:ee,ownsProtocol:le}}catch(de){throw de&&de.code==="ETIMEDOUT"&&(k.logService.error(`${W} the handshake timed out. Error:`),k.logService.error(de)),de&&de.code==="VSCODE_CONNECTION_ERROR"&&(k.logService.error(`${W} received error control message when negotiating connection. Error:`),k.logService.error(de)),le&&$(ee),de}}async function t(k,M,z,_){const W=Date.now(),Q=q(k,M),{protocol:ee,ownsProtocol:le}=await r(k,M,z,_),he=new d(_);return he.registerDisposable(ee.onControlMessage(pe=>{const de=JSON.parse(pe.toString()),be=X(de);be?(k.logService.error(`${Q} received error control message when negotiating connection. Error:`),k.logService.error(be),le&&$(ee),he.reject(be)):(k.reconnectionProtocol?.endAcceptReconnection(),k.logService.trace(`${Q} 6/6. handshake finished, connection is up and running after ${C(W)}!`),he.resolve({protocol:ee,firstMessage:de}))})),he.promise}async function i(k,M){const{protocol:z}=await t(k,1,void 0,M);return{protocol:z}}async function s(k,M,z){const{protocol:_,firstMessage:W}=await t(k,2,M,z),Q=W&&W.debugPort;return{protocol:_,debugPort:Q}}async function o(k,M,z){const _=Date.now(),W=q(k,3),{protocol:Q}=await r(k,3,M,z);return k.logService.trace(`${W} 6/6. handshake finished, connection is up and running after ${C(_)}!`),Q}async function c(k,M,z){const{host:_,port:W,connectionToken:Q}=await k.addressProvider.getAddress();return{commit:k.commit,quality:k.quality,host:_,port:W,connectionToken:Q,reconnectionToken:M,reconnectionProtocol:z,socketFactory:k.socketFactory,signService:k.signService,logService:k.logService}}async function y(k,M,z){return g(k,async _=>{const{protocol:W}=await i(_,l.CancellationToken.None);return new Y(k,M,z,_.reconnectionToken,W)})}e.connectRemoteAgentManagement=y;async function b(k,M){return g(k,async z=>{const{protocol:_,debugPort:W}=await s(z,M,l.CancellationToken.None);return new H(k,M,z.reconnectionToken,_,W)})}e.connectRemoteAgentExtensionHost=b;async function g(k,M){for(let _=1;;_++)try{const W=(0,P.generateUuid)(),Q=await c(k,W,null);return await M(Q)}catch(W){if(_<5)k.logService.error(`[remote-connection][attempt ${_}] An error occurred in initial connection! Will retry... Error:`),k.logService.error(W);else throw k.logService.error(`[remote-connection][attempt ${_}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),k.logService.error(W),K.triggerPermanentFailure(0,0,p.RemoteAuthorityResolverError.isHandled(W)),W}}async function D(k,M,z){const _=await c(k,(0,P.generateUuid)(),null);return await o(_,{host:M,port:z},l.CancellationToken.None)}e.connectRemoteAgentTunnel=D;function A(k){return(0,O.createCancelablePromise)(M=>new Promise((z,_)=>{const W=setTimeout(z,k*1e3);M.onCancellationRequested(()=>{clearTimeout(W),z()})}))}var F;(function(k){k[k.ConnectionLost=0]="ConnectionLost",k[k.ReconnectionWait=1]="ReconnectionWait",k[k.ReconnectionRunning=2]="ReconnectionRunning",k[k.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",k[k.ConnectionGain=4]="ConnectionGain",k[k.ConnectionHealthChanged=5]="ConnectionHealthChanged"})(F=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class j{constructor(M,z){this.reconnectionToken=M,this.millisSinceLastIncomingData=z,this.type=0}}e.ConnectionLostEvent=j;class x{constructor(M,z,_,W){this.reconnectionToken=M,this.millisSinceLastIncomingData=z,this.durationSeconds=_,this.c=W,this.type=1}skipWait(){this.c.cancel()}}e.ReconnectionWaitEvent=x;class V{constructor(M,z,_){this.reconnectionToken=M,this.millisSinceLastIncomingData=z,this.attempt=_,this.type=2}}e.ReconnectionRunningEvent=V;class B{constructor(M,z,_){this.reconnectionToken=M,this.millisSinceLastIncomingData=z,this.attempt=_,this.type=4}}e.ConnectionGainEvent=B;class Z{constructor(M,z){this.reconnectionToken=M,this.connectionHealth=z,this.type=5}}e.ConnectionHealthChangedEvent=Z;class J{constructor(M,z,_,W){this.reconnectionToken=M,this.millisSinceLastIncomingData=z,this.attempt=_,this.handled=W,this.type=3}}e.ReconnectionPermanentFailureEvent=J;class K extends R.Disposable{static triggerPermanentFailure(M,z,_){this._permanentFailure=!0,this.f=M,this.g=z,this.h=_,this.i.forEach(W=>W.u(this.f,this.g,this.h))}static debugTriggerReconnection(){this.i.forEach(M=>M.r())}static debugPauseSocketWriting(){this.i.forEach(M=>M.v())}get k(){return this.c||K._permanentFailure}constructor(M,z,_,W,Q){super(),this.n=M,this.p=z,this.reconnectionToken=_,this.protocol=W,this.q=Q,this.j=this.D(new N.Emitter),this.onDidStateChange=this.j.event,this.c=!1,this.l=!1,this.m=!1,this.j.fire(new B(this.reconnectionToken,0,0)),this.D(W.onSocketClose(ee=>{const le=ae(this.n,this.reconnectionToken,!0);ee?ee.type===0?(this.p.logService.info(`${le} received socket close event (hadError: ${ee.hadError}).`),ee.error&&this.p.logService.error(ee.error)):(this.p.logService.info(`${le} received socket close event (wasClean: ${ee.wasClean}, code: ${ee.code}, reason: ${ee.reason}).`),ee.event&&this.p.logService.error(ee.event)):this.p.logService.info(`${le} received socket close event.`),this.r()})),this.D(W.onSocketTimeout(ee=>{const le=ae(this.n,this.reconnectionToken,!0);this.p.logService.info(`${le} received socket timeout event (unacknowledgedMsgCount: ${ee.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ee.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ee.timeSinceLastReceivedSomeData}).`),this.r()})),this.D(W.onHighRoundTripTime(ee=>{const le=se(this.n,this.reconnectionToken);this.p.logService.info(`${le} high roundtrip time: ${ee.roundTripTime}ms (${ee.recentHighRoundTripCount} of ${5} recent samples)`)})),this.D(W.onDidChangeConnectionHealth(ee=>{this.j.fire(new Z(this.reconnectionToken,ee))})),K.i.push(this),this.D((0,R.toDisposable)(()=>{const ee=K.i.indexOf(this);ee>=0&&K.i.splice(ee,1)})),this.k&&this.u(K.f,K.g,K.h)}dispose(){super.dispose(),this.m=!0}async r(){if(!this.l)try{this.l=!0,await this.s()}finally{this.l=!1}}async s(){if(this.k||this.m)return;const M=ae(this.n,this.reconnectionToken,!0);this.p.logService.info(`${M} starting reconnecting loop. You can get more information with the trace log level.`),this.j.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const z=[0,5,5,10,10,10,10,10,30];let _=-1;do{_++;const W=_<z.length?z[_]:z[z.length-1];try{if(W>0){const ee=A(W);this.j.fire(new x(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),W,ee)),this.p.logService.info(`${M} waiting for ${W} seconds before reconnecting...`);try{await ee}catch{}}if(this.k){this.p.logService.error(`${M} permanent failure occurred while running the reconnecting loop.`);break}this.j.fire(new V(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),_+1)),this.p.logService.info(`${M} resolving connection...`);const Q=await c(this.p,this.reconnectionToken,this.protocol);this.p.logService.info(`${M} connecting to ${Q.host}:${Q.port}...`),await this.w(Q,u(m)),this.p.logService.info(`${M} reconnected!`),this.j.fire(new B(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),_+1));break}catch(Q){if(Q.code==="VSCODE_CONNECTION_ERROR"){this.p.logService.error(`${M} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.p.logService.error(Q),this.t(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}if(_>360){this.p.logService.error(`${M} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.p.logService.error(Q),this.t(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}if(p.RemoteAuthorityResolverError.isTemporarilyNotAvailable(Q)){this.p.logService.info(`${M} A temporarily not available error occurred while trying to reconnect, will try again...`),this.p.logService.trace(Q);continue}if((Q.code==="ETIMEDOUT"||Q.code==="ENETUNREACH"||Q.code==="ECONNREFUSED"||Q.code==="ECONNRESET")&&Q.syscall==="connect"){this.p.logService.info(`${M} A network error occurred while trying to reconnect, will try again...`),this.p.logService.trace(Q);continue}if((0,T.isCancellationError)(Q)){this.p.logService.info(`${M} A promise cancelation error occurred while trying to reconnect, will try again...`),this.p.logService.trace(Q);continue}if(Q instanceof p.RemoteAuthorityResolverError){this.p.logService.error(`${M} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.p.logService.error(Q),this.t(this.protocol.getMillisSinceLastIncomingData(),_+1,p.RemoteAuthorityResolverError.isHandled(Q));break}this.p.logService.error(`${M} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.p.logService.error(Q),this.t(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}}while(!this.k&&!this.m)}t(M,z,_){this.q?K.triggerPermanentFailure(M,z,_):this.u(M,z,_)}u(M,z,_){this.j.fire(new J(this.reconnectionToken,M,z,_)),$(this.protocol)}v(){this.protocol.pauseSocketWriting()}}K._permanentFailure=!1,K.f=0,K.g=0,K.h=!1,K.i=[],e.PersistentConnection=K;class Y extends K{constructor(M,z,_,W,Q){super(1,M,W,Q,!0),this.client=this.D(new S.Client(Q,{remoteAuthority:z,clientId:_},M.ipcLogger))}async w(M,z){await i(M,z)}}e.ManagementPersistentConnection=Y;class H extends K{constructor(M,z,_,W,Q){super(2,M,_,W,!1),this.y=z,this.debugPort=Q}async w(M,z){await s(M,this.y,z)}}e.ExtensionHostPersistentConnection=H;function $(k){try{k.acceptDisconnect();const M=k.getSocket();k.dispose(),M.dispose()}catch(M){(0,T.onUnexpectedError)(M)}}function X(k){if(k&&k.type==="error"){const M=new Error(`Connection error: ${k.reason}`);return M.code="VSCODE_CONNECTION_ERROR",M}return null}function ie(k,M){for(;k.length<M;)k+=" ";return k}function se(k,M){return`[remote-connection][${ie(a(k),13)}][${M.substr(0,5)}\u2026]`}function ae(k,M,z){return`${se(k,M)}[${z?"reconnect":"initial"}]`}function q(k,M){return`${ae(M,k.reconnectionToken,!!k.reconnectionProtocol)}[${k.host}:${k.port}]`}function C(k){return`${Date.now()-k} ms`}}),define(re[225],oe([0,1,5]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,O.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(re[109],oe([0,1,5,172]),function(te,e,O,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LOGGER_NAME=e.LOG_ID=e.CONFIGURATION_KEY_PREVENT_SLEEP=e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX=e.TunnelStates=e.IRemoteTunnelService=void 0,e.IRemoteTunnelService=(0,O.createDecorator)("IRemoteTunnelService");var l;(function(T){T.disconnected={type:"disconnected"},T.uninitialized={type:"uninitialized"},T.connected=N=>({type:"connected",info:N}),T.connecting=N=>({type:"connecting",progress:N})})(l=e.TunnelStates||(e.TunnelStates={})),e.CONFIGURATION_KEY_PREFIX="remote.tunnels.access",e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX+".hostNameOverride",e.CONFIGURATION_KEY_PREVENT_SLEEP=e.CONFIGURATION_KEY_PREFIX+".preventSleep",e.LOG_ID="remoteTunnelService",e.LOGGER_NAME=(0,U.localize)(0,null)}),define(re[59],oe([0,1,16,10,2,174,45,5,9,40]),function(te,e,O,U,l,T,N,R,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.AbstractRequestService=e.IRequestService=void 0,e.IRequestService=(0,R.createDecorator)("requestService");class P{constructor(L){this.b=L}toJSON(){if(!this.a){const L=Object.create(null);for(const n in this.b)n.toLowerCase()==="authorization"||n.toLowerCase()==="proxy-authorization"?L[n]="*****":L[n]=this.b[n];this.a=L}return this.a}}class S extends l.Disposable{constructor(L,n){super(),this.b=0,this.a=n.createLogger(L?"remotenetwork":"network",{name:L?(0,T.localize)(0,null):(0,T.localize)(1,null),when:I.CONTEXT_LOG_LEVEL.isEqualTo((0,I.LogLevelToString)(I.LogLevel.Trace)).serialize()})}async c(L,n,r){const t=`${L} #${++this.b}: ${n.url}`;this.a.trace(`${t} - begin`,n.type,new P(n.headers??{}));try{const i=await r();return this.a.trace(`${t} - end`,n.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${t} - error`,n.type,(0,U.getErrorMessage)(i)),i}}}e.AbstractRequestService=S;function p(v){return v.res.statusCode&&v.res.statusCode>=200&&v.res.statusCode<300||v.res.statusCode===1223}e.isSuccess=p;function f(v){return v.res.statusCode===204}async function m(v){return f(v)?null:(await(0,O.streamToBuffer)(v.stream)).toString()}e.asText=m;async function E(v){if(!p(v))throw new Error("Server returned "+v.res.statusCode);return m(v)}e.asTextOrError=E;async function a(v){if(!p(v))throw new Error("Server returned "+v.res.statusCode);if(f(v))return null;const n=(await(0,O.streamToBuffer)(v.stream)).toString();try{return JSON.parse(n)}catch(r){throw r.message+=`:
`+n,r}}e.asJson=a;function u(v){d(v)}e.updateProxyConfigurationsScope=u;let h;function d(v){const L=w.Registry.as(N.Extensions.Configuration),n=h;h={id:"http",order:15,title:(0,T.localize)(2,null),type:"object",scope:v,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,T.localize)(3,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,T.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,T.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,T.localize)(6,null),(0,T.localize)(7,null),(0,T.localize)(8,null),(0,T.localize)(9,null)],default:"override",description:(0,T.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,T.localize)(11,null),restricted:!0}}},L.updateConfigurations({add:[h],remove:n?[n]:[]})}d(2)}),define(re[226],oe([0,1,25,22,14,59]),function(te,e,O,U,l,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let N=class{constructor(I,w){this.a=I,this.b=w}async download(I,w,P=O.CancellationToken.None){if(I.scheme===U.Schemas.file||I.scheme===U.Schemas.vscodeRemote){await this.b.copy(I,w);return}const S={type:"GET",url:I.toString(!0)},p=await this.a.request(S,P);if(p.res.statusCode===200)await this.b.writeFile(w,p.stream);else{const f=await(0,T.asTextOrError)(p);throw new Error(`Expected 200, got back ${p.res.statusCode} instead.

${f}`)}}};N=ye([G(0,T.IRequestService),G(1,l.IFileService)],N),e.DownloadService=N}),define(re[227],oe([0,1,16,25]),function(te,e,O,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class l{constructor(R){this.a=R}listen(R,I){throw new Error("Invalid listen")}call(R,I,w,P=U.CancellationToken.None){switch(I){case"request":return this.a.request(w[0],P).then(async({res:S,stream:p})=>{const f=await(0,O.streamToBuffer)(p);return[{statusCode:S.statusCode,headers:S.headers},f]});case"resolveProxy":return this.a.resolveProxy(w[0])}throw new Error("Invalid call")}}e.RequestChannel=l;class T{constructor(R){this.a=R}async request(R,I){const[w,P]=await this.a.call("request",[R],I);return{res:w,stream:(0,O.bufferToStream)(P)}}async resolveProxy(R){return this.a.call("resolveProxy",[R])}}e.RequestChannelClient=T}),define(re[110],oe([0,1,53,5]),function(te,e,O,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISharedProcessWorkerService=e.hash=void 0;function l(T){return(0,O.hash)({moduleId:T.process.moduleId,windowId:T.reply.windowId})}e.hash=l,e.ISharedProcessWorkerService=(0,U.createDecorator)("sharedProcessWorkerService")}),define(re[228],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var O;(function(U){U.Spawn="vscode:shared-process->shared-process-worker=spawn",U.Terminate="vscode:shared-process->shared-process-worker=terminate",U.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",U.Ready="vscode:shared-process-worker->shared-process=ready",U.Ack="vscode:shared-process-worker->shared-process=ack",U.Trace="vscode:shared-process-worker->shared-process=trace",U.Info="vscode:shared-process-worker->shared-process=info",U.Warn="vscode:shared-process-worker->shared-process=warn",U.Error="vscode:shared-process-worker->shared-process=error"})(O=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(re[229],oe([0,1,151,6,25,3,2,22,31,9,110,228]),function(te,e,O,U,l,T,N,R,I,w,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let p=class{constructor(E){this.d=E,this.a=new Map,this.b=new Map,this.c=new Map}async createWorker(E){const a=`window: ${E.reply.windowId}, moduleId: ${E.process.moduleId}`;this.d.trace(`SharedProcess: createWorker (${a})`);const u=(0,P.hash)(E);this.b.has(u)&&(this.d.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${a})`),this.f(E));const h=new l.CancellationTokenSource;let d,v,L;this.b.set(u,i=>{h.dispose(!0),d?.terminate(E,l.CancellationToken.None),v?.close(),L?.close(),this.b.delete(u);const s=this.c.get(u);s&&(this.c.delete(u),s({reason:i}))}),d=await this.e(E);const n=new Promise(i=>{this.c.set(u,i)});if(h.token.isCancellationRequested)return n;const{port1:r,port2:t}=new MessageChannel;return v=r,L=t,await d.spawn(E,L,h.token),h.token.isCancellationRequested||(this.d.trace(`SharedProcess: createWorker sending message port back to window (${a})`),O.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",E,[v])),n}e(E){let a=this.a.get(E.process.moduleId);if(!a){this.d.trace(`SharedProcess: creating new web worker (${E.process.moduleId})`);const u=new f(E.process.type,this.d);a=u.init(),u.onDidProcessSelfTerminate(({configuration:h,reason:d})=>{this.f(h,d)}),this.a.set(E.process.moduleId,a)}return a}async disposeWorker(E){return this.f(E)}f(E,a){const u=this.b.get((0,P.hash)(E));u&&(this.d.trace(`SharedProcess: disposeWorker (window: ${E.reply.windowId}, moduleId: ${E.process.moduleId})`),u(a))}};p=ye([G(0,w.ILogService)],p),e.SharedProcessWorkerService=p;class f extends N.Disposable{constructor(E,a){super(),this.f=E,this.g=a,this.a=this.D(new T.Emitter),this.onDidProcessSelfTerminate=this.a.event,this.b=this.h(),this.c=new Map}async init(){return await this.b,this}h(){const E=new U.DeferredPromise,a=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.f})`});return a.onerror=u=>{this.g.error(`SharedProcess: worker error (${this.f})`,u.message)},a.onmessageerror=u=>{this.g.error(`SharedProcess: worker message error (${this.f})`,u)},a.onmessage=u=>{const{id:h,message:d,configuration:v,nonce:L}=u.data;switch(h){case S.SharedProcessWorkerMessages.Ready:E.complete(a);break;case S.SharedProcessWorkerMessages.Ack:if(L){const n=this.c.get(L);n&&(this.c.delete(L),n())}break;case S.SharedProcessWorkerMessages.SelfTerminated:v&&d&&this.a.fire({configuration:v,reason:JSON.parse(d)});break;case S.SharedProcessWorkerMessages.Trace:this.g.trace(`SharedProcess (worker, ${this.f}):`,d);break;case S.SharedProcessWorkerMessages.Info:d&&this.g.info(d);break;case S.SharedProcessWorkerMessages.Warn:this.g.warn(`SharedProcess (worker, ${this.f}):`,d);break;case S.SharedProcessWorkerMessages.Error:this.g.error(`SharedProcess (worker, ${this.f}):`,d);break;default:this.g.warn(`SharedProcess: unexpected worker message (${this.f})`,u)}},a.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),E.p}async i(E,a,u){const h=await this.b;if(!a.isCancellationRequested)return new Promise(d=>{const v=(0,I.generateUuid)();this.c.set(v,d);const L={...E,nonce:v};u?h.postMessage(L,[u]):h.postMessage(L),a.onCancellationRequested(()=>{this.c.delete(v)&&d()})})}spawn(E,a,u){const h={id:S.SharedProcessWorkerMessages.Spawn,configuration:E,environment:{bootstrapPath:R.FileAccess.asFileUri("bootstrap-fork").fsPath}};return this.i(h,u,a)}terminate(E,a){const u={id:S.SharedProcessWorkerMessages.Terminate,configuration:E};return this.i(u,a)}}}),define(re[230],oe([0,1,62,22,98]),function(te,e,O,U,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class T extends l.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:U.Schemas.vscodeUserData})}}ye([O.memoize],T.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=T}),define(re[231],oe([0,1,50,13,175,25,38,10,4,31,148,193,6,131]),function(te,e,O,U,l,T,N,R,I,w,P,S,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let m;async function E(u,h,d,v){return d["force-disable-user-env"]?(h.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):I.isWindows?(h.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,S.isLaunchedFromCli)(v)&&!d["force-user-env"]?(h.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,S.isLaunchedFromCli)(v)?h.trace("resolveShellEnv(): running (--force-user-env)"):h.trace("resolveShellEnv(): running (macOS/Linux)"),m||(m=p.Promises.withAsyncBody(async(L,n)=>{const r=new T.CancellationTokenSource;let t=1e4;const i=u.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(t=(0,f.clamp)(i,1,120)*1e3);const s=setTimeout(()=>{r.dispose(!0),n(new Error((0,l.localize)(0,null)))},t);try{L(await a(h,r.token))}catch(o){!(0,R.isCancellationError)(o)&&!r.token.isCancellationRequested?n(new Error((0,l.localize)(1,null,(0,N.toErrorMessage)(o)))):L({})}finally{clearTimeout(s),r.dispose()}})),m)}e.getResolvedShellEnv=E;async function a(u,h){const d=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",d);const v=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",v);const L=(0,w.generateUuid)().replace(/-/g,"").substr(0,12),n=new RegExp(L+"({.*})"+L),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};u.trace("getUnixShellEnvironment#env",r);const t=await(0,P.getSystemShell)(I.OS,r);return u.trace("getUnixShellEnvironment#shell",t),new Promise((i,s)=>{if(h.isCancellationRequested)return s(new R.CancellationError);const o=(0,U.basename)(t);let c,y;const b=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(o)?(c=`& '${process.execPath}' ${b} -p '''${L}'' + JSON.stringify(process.env) + ''${L}'''`,y=["-Login","-Command"]):(c=`'${process.execPath}' ${b} -p '"${L}" + JSON.stringify(process.env) + "${L}"'`,o==="tcsh"||o==="csh"?y=["-ic"]:y=["-i","-l","-c"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(y),c);const g=(0,O.spawn)(t,[...y,c],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});h.onCancellationRequested(()=>(g.kill(),s(new R.CancellationError))),g.on("error",F=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,N.toErrorMessage)(F)),s(F)});const D=[];g.stdout.on("data",F=>D.push(F));const A=[];g.stderr.on("data",F=>A.push(F)),g.on("close",(F,j)=>{const x=Buffer.concat(D).toString("utf8");u.trace("getUnixShellEnvironment#raw",x);const V=Buffer.concat(A).toString("utf8");if(V.trim()&&u.trace("getUnixShellEnvironment#stderr",V),F||j)return s(new Error((0,l.localize)(2,null,F,j)));const B=n.exec(x),Z=B?B[1]:"{}";try{const J=JSON.parse(Z);d?J.ELECTRON_RUN_AS_NODE=d:delete J.ELECTRON_RUN_AS_NODE,v?J.ELECTRON_NO_ATTACH_CONSOLE=v:delete J.ELECTRON_NO_ATTACH_CONSOLE,delete J.VSCODE_RESOLVING_ENVIRONMENT,delete J.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",J),i(J)}catch(J){u.error("getUnixShellEnvironment#errorCaught",(0,N.toErrorMessage)(J)),s(J)}})})}}),define(re[111],oe([0,1,5]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,O.createDecorator)(e.SIGN_SERVICE_ID)}),define(re[232],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class O{constructor(){this.b=new Map}c(){return new Promise((l,T)=>te(["vsda"],l,T))}async createNewMessage(l){try{const T=await this.c(),N=new T.validator;if(N){const R=String(O.a++);return this.b.set(R,N),{id:R,data:N.createNewMessage(l)}}}catch{}return{id:"",data:l}}async validate(l,T){if(!l.id)return!0;const N=this.b.get(l.id);if(!N)return!1;this.b.delete(l.id);try{return N.validate(T)==="ok"}catch{return!1}}async sign(l){try{const T=await this.c(),N=new T.signer;if(N)return N.sign(l)}catch{}return l}}O.a=1,e.SignService=O}),define(re[77],oe([0,1,3,2]),function(te,e,O,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageClient=e.WorkspaceStorageDatabaseClient=e.ProfileStorageDatabaseClient=e.ApplicationStorageDatabaseClient=void 0;class l extends U.Disposable{constructor(S,p,f){super(),this.a=S,this.b=p,this.c=f}async getItems(){const S={profile:this.b,workspace:this.c},p=await this.a.call("getItems",S);return new Map(p)}updateItems(S){const p={profile:this.b,workspace:this.c};return S.insert&&(p.insert=Array.from(S.insert.entries())),S.delete&&(p.delete=Array.from(S.delete.values())),this.a.call("updateItems",p)}}class T extends l{constructor(S,p){super(S,p,void 0),this.f=this.D(new O.Emitter),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.D(this.a.listen("onDidChangeStorage",{profile:this.b})(S=>this.h(S)))}h(S){(Array.isArray(S.changed)||Array.isArray(S.deleted))&&this.f.fire({changed:S.changed?new Map(S.changed):void 0,deleted:S.deleted?new Set(S.deleted):void 0})}}class N extends T{constructor(S){super(S,void 0)}async close(){this.dispose()}}e.ApplicationStorageDatabaseClient=N;class R extends T{constructor(S,p){super(S,p)}async close(){this.dispose()}}e.ProfileStorageDatabaseClient=R;class I extends l{constructor(S,p){super(S,void 0,p),this.onDidChangeItemsExternal=O.Event.None}async close(){this.dispose()}}e.WorkspaceStorageDatabaseClient=I;class w{constructor(S){this.a=S}isUsed(S){const p={payload:S,profile:void 0,workspace:void 0};return this.a.call("isUsed",p)}}e.StorageClient=w}),define(re[112],oe([0,1,4,36,11,31]),function(te,e,O,U,l,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function N(w){if(O.platform===2&&/^penguin(\.|$)/i.test(w))return"chromebook"}async function R(w,P,S,p,f,m,E,a,u,h){const d=Object.create(null);d["common.machineId"]=E,d.sessionID=(0,T.generateUuid)()+Date.now(),d.commitHash=f,d.version=m,d["common.platformVersion"]=(P||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),d["common.platform"]=(0,O.PlatformToString)(O.platform),d["common.nodePlatform"]=U.platform,d["common.nodeArch"]=p,d["common.product"]=h||"desktop",a&&(d["common.msftInternal"]=a);let v=0;const L=Date.now();Object.defineProperties(d,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-L,enumerable:!0},"common.sequence":{get:()=>v++,enumerable:!0}}),O.isLinuxSnap&&(d["common.snap"]="true");const n=N(S);n&&(d["common.platformDetail"]=n);try{const r=await w.readFile(l.URI.file(u));d["common.source"]=r.value.toString().slice(0,30)}catch{}return d}e.resolveCommonProperties=R;function I(w){const P=U.env.USERDNSDOMAIN;if(!P)return!1;const S=P.toLowerCase();return w.some(p=>S===p)}e.verifyMicrosoftInternalDomain=I}),define(re[19],oe([0,1,5]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,O.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,O.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var U;(function(T){T[T.NONE=0]="NONE",T[T.CRASH=1]="CRASH",T[T.ERROR=2]="ERROR",T[T.USAGE=3]="USAGE"})(U=e.TelemetryLevel||(e.TelemetryLevel={}));var l;(function(T){T.OFF="off",T.CRASH="crash",T.ERROR="error",T.ON="all"})(l=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(re[233],oe([0,1,34,6,35,22,13,4,11,145,28,147,99,14,26,19]),function(te,e,O,U,l,T,N,R,I,w,P,S,p,f,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const a=new Map;async function u(n,r){const t=`${n}::${r.join(":")}`,i=a.get(t);if(i)return i;const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],o=new Map,c=new Map,y=2e4;function b(D,A,F,j){const x=A.substring(D.length+1);return U.Promises.withAsyncBody(async V=>{let B;try{B=await P.Promises.readdir(A,{withFileTypes:!0})}catch{V();return}if(j.count>=y){j.count+=B.length,j.maxReached=!0,V();return}let Z=B.length;if(Z===0){V();return}let J=B;j.count+B.length>y&&(j.maxReached=!0,Z=y-j.count,J=B.slice(0,Z)),j.count+=B.length;for(const K of J)if(K.isDirectory()){if(F.includes(K.name)||await b(D,(0,N.join)(A,K.name),F,j),--Z===0){V();return}}else{const Y=K.name.lastIndexOf(".");if(Y>=0){const H=K.name.substring(Y+1);H&&o.set(H,(o.get(H)??0)+1)}for(const H of s)H.relativePathPattern?.test(x)!==!1&&H.filePattern.test(K.name)&&c.set(H.tag,(c.get(H.tag)??0)+1);if(--Z===0){V();return}}})}const g=U.Promises.withAsyncBody(async D=>{const A={count:0,maxReached:!1};await b(n,n,r,A);const F=await v(n);D({configFiles:h(c),fileTypes:h(o),fileCount:A.count,maxFilesReached:A.maxReached,launchConfigFiles:F})});return a.set(t,g),g}e.collectWorkspaceStats=u;function h(n){return Array.from(n.entries(),([r,t])=>({name:r,count:t})).sort((r,t)=>t.count-r.count)}function d(){const n={os:`${O.type()} ${O.arch()} ${O.release()}`,memory:`${(O.totalmem()/f.ByteSize.GB).toFixed(2)}GB (${(O.freemem()/f.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(w.virtualMachineHint.value()*100)}%`},r=O.cpus();return r&&r.length>0&&(n.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),n}e.getMachineInfo=d;async function v(n){try{const r=new Map,t=(0,N.join)(n,".vscode","launch.json"),i=await P.Promises.readFile(t),s=[],o=(0,l.parse)(i.toString(),s);if(s.length)return console.log(`Unable to parse ${t}`),[];if((0,l.getNodeType)(o)==="object"&&o.configurations)for(const c of o.configurations){const y=c.type;y&&(r.has(y)?r.set(y,r.get(y)+1):r.set(y,1))}return h(r)}catch{return[]}}e.collectLaunchConfigs=v;let L=class{constructor(r,t){this.c=r,this.d=t}f(r){const t=[];return t.push(`OS Version:       ${r.os}`),t.push(`CPUs:             ${r.cpus}`),t.push(`Memory (System):  ${r.memory}`),t.push(`VM:               ${r.vmHint}`),t.join(`
`)}g(r){const t=[];t.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),t.push(`OS Version:       ${O.type()} ${O.arch()} ${O.release()}`);const i=O.cpus();return i&&i.length>0&&t.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),t.push(`Memory (System):  ${(O.totalmem()/f.ByteSize.GB).toFixed(2)}GB (${(O.freemem()/f.ByteSize.GB).toFixed(2)}GB free)`),R.isWindows||t.push(`Load (avg):       ${O.loadavg().map(s=>Math.round(s)).join(", ")}`),t.push(`VM:               ${Math.round(w.virtualMachineHint.value()*100)}%`),t.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),t.push(`Process Argv:     ${r.mainArguments.join(" ")}`),t.push(`GPU Status:       ${this.j(r.gpuFeatureStatus)}`),t.join(`
`)}async getPerformanceInfo(r,t){return Promise.all([(0,S.listProcesses)(r.mainPID),this.k(r)]).then(async i=>{let[s,o]=i,c=this.m(r,s);return t.forEach(y=>{if((0,p.isRemoteDiagnosticError)(y))c+=`
${y.errorMessage}`,o+=`
${y.errorMessage}`;else if(c+=`

Remote: ${y.hostName}`,y.processes&&(c+=`
${this.m(r,y.processes)}`),y.workspaceMetadata){o+=`
|  Remote: ${y.hostName}`;for(const b of Object.keys(y.workspaceMetadata)){const g=y.workspaceMetadata[b];let D=`${g.fileCount} files`;g.maxFilesReached&&(D=`more than ${D}`),o+=`|    Folder (${b}): ${D}`,o+=this.h(g)}}}),{processInfo:c,workspaceInfo:o}})}async getSystemInfo(r,t){const{memory:i,vmHint:s,os:o,cpus:c}=d(),y={os:o,memory:i,cpus:c,vmHint:s,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:t};return R.isWindows||(y.load=`${O.loadavg().map(b=>Math.round(b)).join(", ")}`),R.isLinux&&(y.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(y)}async getDiagnostics(r,t){const i=[];return(0,S.listProcesses)(r.mainPID).then(async s=>(i.push(""),i.push(this.g(r)),i.push(""),i.push(this.m(r,s)),r.windows.some(o=>o.folderURIs&&o.folderURIs.length>0&&!o.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.k(r))),t.forEach(o=>{if((0,p.isRemoteDiagnosticError)(o))i.push(`
${o.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${o.hostName}`),i.push(this.f(o.machineInfo)),o.processes&&i.push(this.m(r,o.processes)),o.workspaceMetadata)for(const c of Object.keys(o.workspaceMetadata)){const y=o.workspaceMetadata[c];let b=`${y.fileCount} files`;y.maxFilesReached&&(b=`more than ${b}`),i.push(`Folder (${c}): ${b}`),i.push(this.h(y))}}),i.push(""),i.push(""),i.join(`
`)))}h(r){const t=[];let s=0;const o=(g,D)=>{const A=` ${g}(${D})`;s+A.length>60?(t.push(c),c="|                 ",s=c.length):s+=A.length,c+=A};let c="|      File types:";const y=10,b=r.fileTypes.length>y?y:r.fileTypes.length;for(let g=0;g<b;g++){const D=r.fileTypes[g];o(D.name,D.count)}if(t.push(c),r.configFiles.length>=0&&(c="|      Conf files:",s=0,r.configFiles.forEach(g=>{o(g.name,g.count)}),t.push(c)),r.launchConfigFiles.length>0){let g="|      Launch Configs:";r.launchConfigFiles.forEach(D=>{g+=D.count>1?` ${D.name}(${D.count})`:` ${D.name}`}),t.push(g)}return t.join(`
`)}j(r){const t=Math.max(...Object.keys(r).map(i=>i.length));return Object.keys(r).map(i=>`${i}:  ${" ".repeat(t-i.length)}  ${r[i]}`).join(`
                  `)}k(r){const t=[],i=[];return r.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(t.push(`|  Window (${s.title})`),s.folderURIs.forEach(o=>{const c=I.URI.revive(o);if(c.scheme===T.Schemas.file){const y=c.fsPath;i.push(u(y,["node_modules",".git"]).then(b=>{let g=`${b.fileCount} files`;b.maxFilesReached&&(g=`more than ${g}`),t.push(`|    Folder (${(0,N.basename)(y)}): ${g}`),t.push(this.h(b))}).catch(b=>{t.push(`|      Error: Unable to collect workspace stats for folder ${y} (${b.toString()})`)}))}else t.push(`|    Folder (${c.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(s=>t.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}m(r,t){const i=new Map;r.windows.forEach(o=>i.set(o.pid,`window [${o.id}] (${o.title})`)),r.pidToNames.forEach(({pid:o,name:c})=>i.set(o,c));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),t&&this.n(r.mainPID,i,s,t,0),s.join(`
`)}n(r,t,i,s,o){const c=o===0;let y;c?y=s.pid===r?`${this.d.applicationName} main`:"remote agent":t.has(s.pid)?y=t.get(s.pid):y=`${"  ".repeat(o)} ${s.name}`;const b=process.platform==="win32"?s.mem:O.totalmem()*(s.mem/100);i.push(`${s.load.toFixed(0).padStart(5," ")}	${(b/f.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${y}`),Array.isArray(s.children)&&s.children.forEach(g=>this.n(r,t,i,g,o+1))}async getWorkspaceFileExtensions(r){const t=new Set;for(const{uri:i}of r.folders){const s=I.URI.revive(i);if(s.scheme!==T.Schemas.file)continue;const o=s.fsPath;try{(await u(o,["node_modules",".git"])).fileTypes.forEach(y=>t.add(y.name))}catch{}}return{extensions:[...t]}}async reportWorkspaceStats(r){for(const{uri:t}of r.folders){const i=I.URI.revive(t);if(i.scheme!==T.Schemas.file)continue;const s=i.fsPath;try{const o=await u(s,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),o.fileTypes.forEach(c=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:c.name,count:c.count})}),o.launchConfigFiles.forEach(c=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:c.name,count:c.count})}),o.configFiles.forEach(c=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:c.name,count:c.count})})}catch{}}}};L=ye([G(0,E.ITelemetryService),G(1,m.IProductService)],L),e.DiagnosticsService=L}),define(re[234],oe([0,1,109,3,19,15,2,9,13,50,26,4,6,105,17,173,34]),function(te,e,O,U,l,T,N,R,I,w,P,S,p,f,m,E,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTunnelService=void 0;const u=[O.CONFIGURATION_KEY_HOST_NAME,O.CONFIGURATION_KEY_PREVENT_SLEEP];let h=class extends N.Disposable{constructor(v,L,n,r,t,i){super(),this.q=v,this.r=L,this.s=n,this.t=i,this.b=new U.Emitter,this.onDidTokenFailed=this.b.event,this.f=new U.Emitter,this.onDidChangeTunnelStatus=this.f.event,this.g=new U.Emitter,this.onDidChangeAccount=this.g.event,this.k=O.TunnelStates.disconnected,this.h=this.D(r.createLogger(O.LOG_ID,{name:O.LOGGER_NAME})),this.n=new p.Delayer(100),this.D(this.h.onDidChangeLogLevel(s=>this.h.info("Log level changed to "+(0,R.LogLevelToString)(s)))),this.D(t.onWillShutdown(()=>{this.j?.cancel(),this.j=void 0,this.dispose()})),this.D(i.onDidChangeConfiguration(s=>{u.some(o=>s.affectsConfiguration(o))&&this.n.trigger(()=>this.v())}))}async getAccount(){return this.i}async updateAccount(v){if(v&&this.i?v.token!==this.i.token||v.providerId!==this.i.providerId:v!==this.i){this.i=v,this.g.fire(v),v?this.h.info(`Account updated: ${v.accountLabel} (${v.providerId})`):this.h.info("Account reset"),this.q.publicLog2("remoteTunnel.enablement",{enabled:!!v});try{await this.n.trigger(()=>this.v())}catch(L){this.h.error(L)}}return this.k}u(){if(!this.p){let v;S.isMacintosh?v=this.s.appRoot:v=(0,I.dirname)((0,I.dirname)(this.s.appRoot)),this.p=(0,I.join)(v,"bin",`${this.r.tunnelApplicationName}${S.isWindows?".exe":""}`)}return this.p}async v(){if(this.j&&(this.j.cancel(),this.j=void 0),!this.i){this.w(O.TunnelStates.disconnected);return}const{token:v,providerId:L,accountLabel:n}=this.i;this.w(O.TunnelStates.connecting((0,E.localize)(0,null,n,L)));const r=(c,y)=>{c=c.replaceAll(v,"*".repeat(4)),y?this.h.error(c):this.h.info(c),!this.s.isBuilt&&c.startsWith("   Compiling")&&this.w(O.TunnelStates.connecting((0,E.localize)(1,null)))},t=this.y("login",["user","login","--provider",L,"--access-token",v,"--log",(0,R.LogLevelToString)(this.h.getLevel())],r);this.j=t;try{if(await t,this.j!==t)return}catch(c){this.h.error(c),this.j=void 0,this.b.fire(!0),this.w(O.TunnelStates.disconnected);return}const i=this.C();i?this.w(O.TunnelStates.connecting((0,E.localize)(2,null,i))):this.w(O.TunnelStates.connecting((0,E.localize)(3,null)));const s=["--parent-process-id",String(process.pid),"--accept-server-license-terms","--log",(0,R.LogLevelToString)(this.h.getLevel())];i?s.push("--name",i):s.push("--random-name"),this.z()&&s.push("--no-sleep");const o=this.y("tunnel",s,(c,y)=>{y?this.h.error(c):this.h.info(c);const b=c.match(/^\s*Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(b){const g={link:b[1],domain:b[2],hostName:b[4]};this.w(O.TunnelStates.connected(g))}else c.match(/error refreshing token/)&&(o.cancel(),this.b.fire(!0),this.w(O.TunnelStates.disconnected))});this.j=o,o.finally(()=>{o===this.j&&(this.h.info("tunnel process terminated"),this.j=void 0,this.i=void 0,this.w(O.TunnelStates.disconnected))})}async getTunnelStatus(){return this.k}w(v){this.k=v,this.f.fire(v)}y(v,L,n=()=>{}){return(0,p.createCancelablePromise)(r=>new Promise((t,i)=>{r.isCancellationRequested&&t();let s;if(r.onCancellationRequested(()=>{s&&(this.h.info(`${v} terminating(${s.pid})`),s.kill())}),!this.s.isBuilt)n("Building tunnel CLI from sources and run",!1),n(`${v} Spawning: cargo run -- tunnel ${L.join(" ")}`,!1),s=(0,w.spawn)("cargo",["run","--","tunnel",...L],{cwd:(0,I.join)(this.s.appRoot,"cli")});else{n("Running tunnel CLI",!1);const o=this.u();n(`${v} Spawning: ${o} tunnel ${L.join(" ")}`,!1),s=(0,w.spawn)(o,["tunnel",...L],{cwd:(0,a.homedir)()})}s.stdout.on("data",o=>{if(s){const c=o.toString();n(c,!1)}}),s.stderr.on("data",o=>{if(s){const c=o.toString();n(c,!0)}}),s.on("exit",o=>{s&&(n(`${v} exit(${s.pid}): + ${o} `,!1),s=void 0,o===0?t():i())}),s.on("error",o=>{s&&(n(`${v} error(${s.pid}): + ${o} `,!0),s=void 0,i())})}))}async getHostName(){return this.C()}z(){return!!this.t.getValue(O.CONFIGURATION_KEY_PREVENT_SLEEP)}C(){let v=this.t.getValue(O.CONFIGURATION_KEY_HOST_NAME)||(0,a.hostname)();return v=v.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),v||void 0}};h=ye([G(0,l.ITelemetryService),G(1,P.IProductService),G(2,T.INativeEnvironmentService),G(3,R.ILoggerService),G(4,f.ISharedProcessLifecycleService),G(5,m.IConfigurationService)],h),e.RemoteTunnelService=h}),define(re[113],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class O{constructor(T){this.b=T}listen(T,N){throw new Error(`Event not found: ${N}`)}call(T,N,{eventName:R,data:I}){return this.b.forEach(w=>w.log(R,I)),Promise.resolve(null)}}e.TelemetryAppenderChannel=O;class U{constructor(T){this.b=T}log(T,N){return this.b.call("log",{eventName:T,data:N}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=U}),define(re[47],oe([0,1,32,12,3,17,76,112,19]),function(te,e,O,U,l,T,N,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class w{constructor(s){this.value=s}}e.TelemetryTrustedValue=w;class P{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(s,o){return Promise.resolve(void 0)}publicLog2(s,o){return this.publicLog(s,o)}publicLogError(s,o){return Promise.resolve(void 0)}publicLogError2(s,o){return this.publicLogError(s,o)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=P,e.NullTelemetryService=new P;class S{async publicLog(s,o,c){}async publicLogError(s,o,c){}}e.NullEndpointTelemetryService=S,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function p(i,s){return l.Event.debounce(s.onDidChangeConfiguration,(c,y)=>{const b=c?new Set([...c.affectedKeys,...y.affectedKeys]):y.affectedKeys;return{...y,affectedKeys:b}},1e3,!0)(c=>{c.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,T.ConfigurationTargetToString)(c.source),configurationKeys:Array.from(c.affectedKeys)})})}e.configurationTelemetry=p;function f(i,s){return!s.isBuilt&&!s.disableTelemetry?!0:!(s.disableTelemetry||!i.enableTelemetry||s.extensionTestsLocationURI)}e.supportsTelemetry=f;function m(i,s){return!(s.isBuilt||s.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.isLoggingOnly=m;function E(i){const s=i.getValue(I.TELEMETRY_SETTING_ID),o=i.getValue(I.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(i.getValue(I.TELEMETRY_OLD_SETTING_ID)===!1||o===!1)return 0;switch(s??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=E;function a(i){const s={},o={},c={};d(i,c);for(let y in c){y=y.length>150?y.substr(y.length-149):y;const b=c[y];typeof b=="number"?o[y]=b:typeof b=="boolean"?o[y]=b?1:0:typeof b=="string"?(b.length>8192&&console.warn(`Telemetry property: ${y} has been trimmed to 8192, the original length is ${b.length}`),s[y]=b.substring(0,8191)):typeof b<"u"&&b!==null&&(s[y]=b)}return{properties:s,measurements:o}}e.validateTelemetryData=a;const u=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function h(i){if(!i)return"none";const s=(0,N.getRemoteName)(i);return u.has(s)?s:"other"}e.cleanRemoteAuthority=h;function d(i,s,o=0,c){if(!!i)for(const y of Object.getOwnPropertyNames(i)){const b=i[y],g=c?c+y:y;Array.isArray(b)?s[g]=(0,O.safeStringify)(b):b instanceof Date?s[g]=b.toISOString():(0,U.isObject)(b)?o<2?d(b,s,o+1,g+"."):s[g]=(0,O.safeStringify)(b):s[g]=b}}function v(i,s){const o=i.msftInternalDomains||[],c=s.getValue("telemetry.internalTesting");return(0,R.verifyMicrosoftInternalDomain)(o)||c}e.isInternalTelemetry=v;function L(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.getPiiPathsFromEnvironment=L;function n(i,s){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let o=i;const c=[];for(const D of s)for(;;){const A=D.exec(i);if(!A)break;c.push([A.index,D.lastIndex])}const y=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,b=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let g=0;for(o="";;){const D=b.exec(i);if(!D)break;const A=c.some(([F,j])=>D.index<j&&F<b.lastIndex);!y.test(D[0])&&!A&&(o+=i.substring(g,D.index)+"<REDACTED: user-file-path>",g=b.lastIndex)}return g<i.length&&(o+=i.substr(g)),o}function r(i){if(!i)return i;const s=i.toLowerCase(),o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const c of o)if(c.regex.test(s))return`<REDACTED: ${c.label}>`;return i}function t(i,s){return(0,O.cloneAndChange)(i,o=>{if(o instanceof w)return o.value;if(typeof o=="string"){let c=o.replaceAll("%20"," ");c=n(c,s);for(const y of s)c=c.replace(y,"");return c=r(c),c}})}e.cleanData=t}),define(re[33],oe([0,1,27,29,46,4,11,10,36,47]),function(te,e,O,U,l,T,N,R,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function P(t,i){return t.uuid&&i.uuid?t.uuid===i.uuid:t.id===i.id?!0:(0,O.compareIgnoreCase)(t.id,i.id)===0}e.areSameExtensions=P;const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class p{static create(i){const s=i.manifest?i.manifest.version:i.version,o=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new p(i.identifier,s,o)}static parse(i){const s=S.exec(i);return s&&s[1]&&s[2]?new p({id:s[1]},s[2],s[4]||void 0):null}constructor(i,s,o="undefined"){this.version=s,this.targetPlatform=o,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof p?P(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=p;const f=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function m(t){const i=f.exec(t);return i&&i[1]?[a(i[1]),i[2]]:[a(t),void 0]}e.getIdAndVersion=m;function E(t,i){return`${t}.${i}`}e.getExtensionId=E;function a(t){return t.toLocaleLowerCase()}e.adoptToGalleryExtensionId=a;function u(t,i){return a(E(t??l.UNDEFINED_PUBLISHER,i))}e.getGalleryExtensionId=u;function h(t,i){const s=[],o=c=>{for(const y of s)if(y.some(b=>P(i(b),i(c))))return y;return null};for(const c of t){const y=o(c);y?y.push(c):s.push([c])}return s}e.groupByExtension=h;function d(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=d;function v(t){return{id:new w.TelemetryTrustedValue(t.identifier.id),name:new w.TelemetryTrustedValue(t.name),galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),isSigned:t.isSigned,...t.telemetryData}}e.getGalleryExtensionTelemetryData=v,e.BetterMergeId=new l.ExtensionIdentifier("pprice.better-merge");function L(t,i){const s=[],o=i.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const c=o.shift();if(c&&s.every(y=>!P(y.identifier,{id:c}))){const y=t.filter(b=>P(b.identifier,{id:c}));y.length===1&&(s.push(y[0]),o.push(...y[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}e.getExtensionDependencies=L;async function n(t,i){if(!T.isLinux)return!1;let s;try{s=(await t.readFile(N.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await t.readFile(N.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){i.debug("Error while getting the os-release file.",(0,R.getErrorMessage)(c))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(t,i){const s=await n(t,i),o=(0,U.getTargetPlatform)(s?"alpine":T.platform,I.arch);return i.debug("ComputeTargetPlatform:",o),o}e.computeTargetPlatform=r}),define(re[235],oe([0,1,21,2,23,11,195,14,26,6,3,13,4,36,162,33]),function(te,e,O,U,l,T,N,R,I,w,P,S,p,f,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractNativeExtensionTipsService=e.ExtensionTipsService=void 0;let a=class extends U.Disposable{constructor(L,n){super(),this.b=L,this.c=n,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,r])=>this.a.set(r.configPath,r))}getConfigBasedTips(L){return this.f(L)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(L){const n=[];for(const[r,t]of this.a)if(!(t.configScheme&&t.configScheme!==L.scheme))try{const i=await this.b.readFile((0,l.joinPath)(L,r)),s=new Map;Object.entries(t.recommendations).forEach(([c,y])=>{if((0,O.isNonEmptyArray)(y.remotes))for(const b of y.remotes)s.set(b,{extensionId:c,extensionName:y.name,configName:t.configName,important:!!y.important,isExtensionPack:!!y.isExtensionPack,whenNotInstalled:y.whenNotInstalled});else n.push({extensionId:c,extensionName:y.name,configName:t.configName,important:!!y.important,isExtensionPack:!!y.isExtensionPack,whenNotInstalled:y.whenNotInstalled})});const o=(0,N.getDomainsOfRemotes)(i.value.toString(),[...s.keys()]);for(const c of o){const y=s.get(c);y&&n.push(y)}}catch{}return n}};a=ye([G(0,R.IFileService),G(1,I.IProductService)],a),e.ExtensionTipsService=a;const u="extensionTips/promptedExecutableTips",h="extensionTips/lastPromptedMediumImpExeTime";class d extends a{constructor(L,n,r,t,i,s,o,c){super(o,c),this.m=L,this.n=n,this.p=r,this.q=t,this.r=i,this.s=s,this.g=new Map,this.h=new Map,this.j=new Map,this.k=new Map,this.l=new Map,c.exeBasedExtensionTips&&Object.entries(c.exeBasedExtensionTips).forEach(([y,b])=>{const g=[],D=[],A=[];Object.entries(b.recommendations).forEach(([F,j])=>{j.important?b.important?g.push({extensionId:F,extensionName:j.name,isExtensionPack:!!j.isExtensionPack}):D.push({extensionId:F,extensionName:j.name,isExtensionPack:!!j.isExtensionPack}):A.push({extensionId:F,extensionName:j.name,isExtensionPack:!!j.isExtensionPack})}),g.length&&this.g.set(y,{exeFriendlyName:b.friendlyName,windowsPath:b.windowsPath,recommendations:g}),D.length&&this.h.set(y,{exeFriendlyName:b.friendlyName,windowsPath:b.windowsPath,recommendations:D}),A.length&&this.j.set(y,{exeFriendlyName:b.friendlyName,windowsPath:b.windowsPath,recommendations:A})}),(0,w.timeout)(3e3).then(async()=>{await this.t(),this.v(),this.w()})}async getImportantExecutableBasedTips(){const L=await this.J(this.g),n=await this.J(this.h);return[...L,...n]}getOtherExecutableBasedTips(){return this.J(this.j)}async t(){const L=await this.J(this.g),n=await this.J(this.h),r=await this.q.getInstalled();this.k=this.u(L,r),this.l=this.u(n,r)}u(L,n){const r=new Map;L.forEach(c=>r.set(c.extensionId.toLowerCase(),c));const{installed:t,uninstalled:i}=this.I([...r.keys()],n);for(const c of t){const y=r.get(c);y&&this.p.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:c,exeName:y.exeName})}for(const c of i){const y=r.get(c);y&&this.p.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:c,exeName:y.exeName})}const s=this.G(),o=new Map;for(const c of i){const y=r.get(c);if(y&&(!s[y.exeName]||!s[y.exeName].includes(y.extensionId))){let b=o.get(y.exeName);b||(b=[],o.set(y.exeName,b)),b.push(y)}}return o}v(){if(this.k.size===0)return;const[L,n]=[...this.k.entries()][0];this.z(n).then(r=>{switch(r){case"reacted":this.H(n[0].exeName,n);break;case"ignored":this.k.delete(L);break;case"incompatibleWindow":{const t=P.Event.once(P.Event.latch(P.Event.any(this.n.onDidOpenWindow,this.n.onDidFocusWindow)));this.D(t(()=>this.v()));break}case"toomany":{const t=this.D((0,w.disposableTimeout)(()=>{t.dispose(),this.v()},36e5));break}}})}w(){if(this.l.size===0)return;const L=this.C(),n=Date.now()-L,r=7*24*60*60*1e3;if(n<r){const s=this.D((0,w.disposableTimeout)(()=>{s.dispose(),this.w()},r-n));return}const[t,i]=[...this.l.entries()][0];this.z(i).then(s=>{switch(s){case"reacted":{this.F(Date.now()),this.l.delete(t),this.H(i[0].exeName,i);const o=this.D((0,w.disposableTimeout)(()=>{o.dispose(),this.w()},r));break}case"ignored":this.l.delete(t),this.w();break;case"incompatibleWindow":{const o=P.Event.once(P.Event.latch(P.Event.any(this.n.onDidOpenWindow,this.n.onDidFocusWindow)));this.D(o(()=>this.w()));break}case"toomany":{const o=this.D((0,w.disposableTimeout)(()=>{o.dispose(),this.w()},36e5));break}}})}async z(L){const n=await this.q.getInstalled(1),r=L.filter(i=>!i.whenNotInstalled||i.whenNotInstalled.every(s=>n.every(o=>!(0,E.areSameExtensions)(o.identifier,{id:s})))).map(({extensionId:i})=>i.toLowerCase()),t=(0,m.localize)(0,null,L[0].exeFriendlyName);return this.s.promptImportantExtensionsInstallNotification(r,t,`@exe:"${L[0].exeName}"`,3)}C(){let L=this.r.getNumber(h,-1);return L||(L=Date.now(),this.F(L)),L}F(L){this.r.store(h,L,-1,1)}G(){return JSON.parse(this.r.get(u,-1,"{}"))}H(L,n){const r=this.G();r[L]=n.map(({extensionId:t})=>t.toLowerCase()),this.r.store(u,JSON.stringify(r),-1,0)}I(L,n){const r=[],t=[],i=n.reduce((s,o)=>(s.add(o.identifier.id.toLowerCase()),s),new Set);return L.forEach(s=>{i.has(s.toLowerCase())?r.push(s):t.push(s)}),{installed:r,uninstalled:t}}async J(L){const n=[],r=new Map;for(const t of L.keys()){const i=L.get(t);if(!i||!(0,O.isNonEmptyArray)(i.recommendations))continue;const s=[];p.isWindows?i.windowsPath&&s.push(i.windowsPath.replace("%USERPROFILE%",()=>f.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>f.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>f.env.ProgramFiles).replace("%APPDATA%",()=>f.env.APPDATA).replace("%WINDIR%",()=>f.env.WINDIR)):(s.push((0,S.join)("/usr/local/bin",t)),s.push((0,S.join)("/usr/bin",t)),s.push((0,S.join)(this.m.fsPath,t)));for(const o of s){let c=r.get(o);if(c===void 0&&(c=await this.b.exists(T.URI.file(o)),r.set(o,c)),c)for(const{extensionId:y,extensionName:b,isExtensionPack:g,whenNotInstalled:D}of i.recommendations)n.push({extensionId:y,extensionName:b,isExtensionPack:g,exeName:t,exeFriendlyName:i.exeFriendlyName,windowsPath:i.windowsPath,whenNotInstalled:D})}}return n}}e.AbstractNativeExtensionTipsService=d}),define(re[236],oe([0,1,25,33]),function(te,e,O,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function l(T,N,R,I,w){try{const P=await T.getExtensionsControlManifest();if(!P.deprecated)return;const S=await T.getInstalled(1);for(const[p,f]of Object.entries(P.deprecated)){if(!f?.extension)continue;const{id:m,autoMigrate:E,preRelease:a}=f.extension;if(!E)continue;const u=S.find(d=>(0,U.areSameExtensions)(d.identifier,{id:p}));if(!u)continue;const h=(await N.getExtensions([{id:m,preRelease:a}],{targetPlatform:await T.getTargetPlatform(),compatible:!0},O.CancellationToken.None))[0];if(!h){w.info(`Skipping migrating '${u.identifier.id}' extension because, the comaptible target '${m}' extension is not found`);continue}try{w.info(`Migrating '${u.identifier.id}' extension to '${m}' extension...`);const d=!I.getDisabledExtensions().some(L=>(0,U.areSameExtensions)(L,u.identifier));await T.uninstall(u),w.info(`Uninstalled the unsupported extension '${u.identifier.id}'`);let v=S.find(L=>(0,U.areSameExtensions)(L.identifier,{id:m}));(!v||!v.isPreReleaseVersion&&d)&&(v=await T.installFromGallery(h,{installPreReleaseVersion:!0,isMachineScoped:u.isMachineScoped,operation:4}),w.info(`Installed the pre-release extension '${v.identifier.id}'`),d||(await I.disableExtension(v.identifier),w.info(`Disabled the pre-release extension '${v.identifier.id}' because the unsupported extension '${u.identifier.id}' is disabled`)),E.storage&&(R.addToMigrationList((0,U.getExtensionId)(u.manifest.publisher,u.manifest.name),(0,U.getExtensionId)(v.manifest.publisher,v.manifest.name)),w.info("Added pre-release extension to the storage migration list"))),w.info(`Migrated '${u.identifier.id}' extension to '${m}' extension.`)}catch(d){w.error(d)}}}catch(P){w.error(P)}}e.migrateUnsupportedExtensions=l}),define(re[237],oe([0,1,3,2,37,33,46]),function(te,e,O,U,l,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class R extends U.Disposable{constructor(w,P,S,p,f,m,E){super(),this.f=w,this.g=P,this.h=S,this.i=p,this.j=f,this.k=m,this.l=E,this.a=this.D(new O.Emitter),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.D(new U.DisposableMap),this.m().then(null,a=>E.error(a))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles,[]),this.n(),await this.z()}n(){this.D(this.h.onDidChangeProfiles(w=>this.p(w.added,w.removed))),this.D(this.i.onAddExtensions(w=>this.q(w))),this.D(this.i.onDidAddExtensions(w=>this.r(w))),this.D(this.i.onRemoveExtensions(w=>this.s(w))),this.D(this.i.onDidRemoveExtensions(w=>this.t(w))),this.D(this.k.onDidFilesChange(w=>this.u(w)))}async p(w,P){try{await Promise.all(P.map(S=>(this.c.deleteAndDispose(S.id),this.y(S.extensionsResource)))),w.length&&await Promise.all(w.map(S=>(this.c.set(S.id,(0,U.combinedDisposable)(this.k.watch(this.j.extUri.dirname(S.extensionsResource)),this.k.watch(S.extensionsResource))),this.w(S.extensionsResource))))}catch(S){throw this.l.error(S),S}}async q(w){for(const P of w.extensions)this.C(this.G(P.identifier,P.version),w.profileLocation)}async r(w){for(const P of w.extensions){const S=this.G(P.identifier,P.version);w.error?this.F(S,w.profileLocation):this.C(S,w.profileLocation)}}async s(w){for(const P of w.extensions)this.F(this.G(P.identifier,P.version),w.profileLocation)}async t(w){const P=[],S=[];for(const p of w.extensions){const f=this.G(p.identifier,p.version);w.error?this.C(f,w.profileLocation):(this.F(f,w.profileLocation),this.b.has(f)||(this.l.debug("Extension is removed from all profiles",p.identifier.id,p.version),S.push(this.f.scanInstalledExtensionAtLocation(p.location).then(m=>{m?P.push(m):this.l.info("Extension not found at the location",p.location.toString())},m=>this.l.error(m)))))}try{await Promise.all(S),P.length&&await this.z(P)}catch(p){this.l.error(p)}}u(w){for(const P of this.h.profiles)w.contains(P.extensionsResource,0,1)&&this.v(P.extensionsResource)}async v(w){const P=[],S=[],p=await this.i.scanProfileExtensions(w),f=new Set,m=new Set;for(const[E,a]of this.b)a.has(w)&&m.add(E);for(const E of p){const a=this.G(E.identifier,E.version);f.add(a),m.has(a)||(P.push(E.identifier),this.C(a,w))}for(const E of m)if(!f.has(E)){const a=this.H(E);a&&(S.push(a.identifier),this.F(E,w))}(P.length||S.length)&&this.a.fire({added:P.length?{extensions:P,profileLocation:w}:void 0,removed:S.length?{extensions:S,profileLocation:w}:void 0})}async w(w){const P=await this.i.scanProfileExtensions(w);for(const S of P)this.C(this.G(S.identifier,S.version),w)}async y(w){for(const P of[...this.b.keys()])this.F(P,w);await this.z()}async z(w){w||(w=(await this.f.scanAllUserInstalledExtensions()).filter(S=>!this.b.has(this.G(S.identifier,S.manifest.version)))),w.length&&await this.f.markAsUninstalled(...w)}C(w,P){let S=this.b.get(w);S||this.b.set(w,S=new l.ResourceSet(p=>this.j.extUri.getComparisonKey(p))),S.add(P)}F(w,P){const S=this.b.get(w);S&&S.delete(P),S?.size||this.b.delete(w)}G(w,P){return`${N.ExtensionIdentifier.toKey(w.id)}@${P}`}H(w){const[P,S]=(0,T.getIdAndVersion)(w);return S?{identifier:{id:P},version:S}:void 0}}e.ExtensionsWatcher=R}),define(re[238],oe([0,1,44,47]),function(te,e,O,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function l(T,N,R,I,w,P,S){const p={"X-Market-Client-Id":`VSCode ${T}`,"User-Agent":`VSCode ${T} (${N.nameShort})`};if((0,U.supportsTelemetry)(N,R)&&(0,U.getTelemetryLevel)(I)===3){const f=await(0,O.getServiceMachineId)(R,w,P),{machineId:m}=await S.getTelemetryInfo();p["X-Market-User-Id"]=f,p["VSCode-SessionId"]=m||f}return p}e.resolveMarketplaceHeaders=l}),define(re[239],oe([0,1,71,21,6,2,22,13,28,15,29,33,9,74,11]),function(te,e,O,U,l,T,N,R,I,w,P,S,p,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let E=class extends f.LanguagePackBaseService{constructor(d,v,L,n){super(L),this.h=d,this.i=n,this.g=this.D(new a(v,n)),this.h.registerParticipant({postInstall:async r=>this.j(r),postUninstall:async r=>this.k(r)})}async getBuiltInExtensionTranslationsUri(d,v){const n=(await this.g.getLanguagePacks())[v];if(!n){this.i.warn(`No language pack found for ${v}`);return}const r=n.translations[d];return r?m.URI.file(r):void 0}async getInstalledLanguages(){const d=await this.g.getLanguagePacks(),v=Object.keys(d).map(L=>{const n=d[L];return{...this.f(L,n.label),extensionId:n.extensions[0].extensionIdentifier.id}});return v.push(this.f("en","English")),v.sort((L,n)=>L.label.localeCompare(n.label)),v}async j(d){d&&d.manifest&&d.manifest.contributes&&d.manifest.contributes.localizations&&d.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",d.identifier.id),await this.update())}async k(d){const v=await this.g.getLanguagePacks();Object.keys(v).some(L=>v[L]&&v[L].extensions.some(n=>(0,S.areSameExtensions)(n.extensionIdentifier,d.identifier)))&&(this.i.info("Removing language packs from the extension",d.identifier.id),await this.update())}async update(){const[d,v]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),L=await this.g.update(v);return!(0,U.equals)(Object.keys(d),Object.keys(L))}};E=ye([G(0,P.IExtensionManagementService),G(1,w.INativeEnvironmentService),G(2,P.IExtensionGalleryService),G(3,p.ILogService)],E),e.NativeLanguagePackService=E;let a=class extends T.Disposable{constructor(d,v){super(),this.i=v,this.c={},this.f=(0,R.join)(d.userDataPath,"languagepacks.json"),this.g=new l.Queue}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(d){return this.m(v=>{Object.keys(v).forEach(L=>delete v[L]),this.j(v,...d)}).then(()=>this.c)}j(d,...v){for(const L of v)L&&L.manifest&&L.manifest.contributes&&L.manifest.contributes.localizations&&L.manifest.contributes.localizations.length&&this.k(d,L);Object.keys(d).forEach(L=>this.l(d[L]))}k(d,v){const L=v.identifier,n=v.manifest.contributes&&v.manifest.contributes.localizations?v.manifest.contributes.localizations:[];for(const r of n)if(v.location.scheme===N.Schemas.file&&u(r)){let t=d[r.languageId];t||(t={hash:"",extensions:[],translations:{},label:r.localizedLanguageName??r.languageName},d[r.languageId]=t);const i=t.extensions.filter(s=>(0,S.areSameExtensions)(s.extensionIdentifier,L))[0];i?i.version=v.manifest.version:t.extensions.push({extensionIdentifier:L,version:v.manifest.version});for(const s of r.translations)t.translations[s.id]=(0,R.join)(v.location.fsPath,s.path)}}l(d){if(d){const v=(0,O.createHash)("md5");for(const L of d.extensions)v.update(L.extensionIdentifier.uuid||L.extensionIdentifier.id).update(L.version);d.hash=v.digest("hex")}}m(d=()=>null){return this.g.queue(()=>{let v=null;return I.Promises.readFile(this.f,"utf8").then(void 0,L=>L.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(L)).then(L=>{try{return JSON.parse(L)}catch{return{}}}).then(L=>(v=d(L),L)).then(L=>{for(const r of Object.keys(L))L[r]||delete L[r];this.c=L,this.h=!0;const n=JSON.stringify(this.c);return this.i.debug("Writing language packs",n),I.Promises.writeFile(this.f,n)}).then(()=>v,L=>this.i.error(L))})}};a=ye([G(0,w.INativeEnvironmentService),G(1,p.ILogService)],a);function u(h){if(typeof h.languageId!="string"||!Array.isArray(h.translations)||h.translations.length===0)return!1;for(const d of h.translations)if(typeof d.id!="string"||typeof d.path!="string")return!1;return!(h.languageName&&typeof h.languageName!="string"||h.localizedLanguageName&&typeof h.localizedLanguageName!="string")}}),define(re[240],oe([0,1,10,32,47]),function(te,e,O,U,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const T="https://mobile.events.data.microsoft.com/OneCollector/1.0",N="https://mobile.events.data.microsoft.com/ping";async function R(w,P,S){const p=await new Promise((u,h)=>{te(["@microsoft/1ds-core-js"],u,h)}),f=await new Promise((u,h)=>{te(["@microsoft/1ds-post-js"],u,h)}),m=new p.AppInsightsCore,E=new f.PostChannel,a={instrumentationKey:w,endpointUrl:T,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[E]]};if(S){a.extensionConfig={};const u={alwaysUseXhrOverride:!0,httpXHROverride:S};a.extensionConfig[E.identifier]=u}return m.initialize(a,[]),m.addTelemetryInitializer(u=>{P&&(u.ext=u.ext??{},u.ext.utc=u.ext.utc??{},u.ext.utc.flags=8462029)}),m}class I{constructor(P,S,p,f,m){this.e=P,this.f=S,this.g=p,this.h=m,this.c=T,this.d=N,this.g||(this.g={}),typeof f=="function"?this.a=f():this.a=f,this.b=null}i(P){if(!!this.a){if(typeof this.a!="string"){P(this.a);return}this.b||(this.b=R(this.a,this.e,this.h)),this.b.then(S=>{P(S)},S=>{(0,O.onUnexpectedError)(S),console.error(S)})}}log(P,S){if(!this.a)return;S=(0,U.mixin)(S,this.g),S=(0,l.validateTelemetryData)(S);const p=this.f+"/"+P;try{this.i(f=>{f.pluginVersionString=S?.properties.version??"Unknown",f.track({name:p,baseData:{name:p,properties:S?.properties,measurements:S?.measurements}})})}catch{}}flush(){return this.a?new Promise(P=>{this.i(S=>{S.unload(!0,()=>{this.a=void 0,P(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=I}),define(re[114],oe([0,1,2,176,15,9,26,47]),function(te,e,O,U,l,T,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let I=class extends O.Disposable{constructor(P,S,p,f,m=""){super(),this.b=m;const E=S.getLogger(R.telemetryLogId);if(E)this.a=this.D(E);else{const u=(0,R.isLoggingOnly)(f,p)?" (Not Sent)":"",h=()=>(0,R.supportsTelemetry)(f,p)&&P.getLevel()===T.LogLevel.Trace;this.a=this.D(S.createLogger(R.telemetryLogId,{name:(0,U.localize)(0,null,u),hidden:!h()})),this.D(P.onDidChangeLogLevel(()=>S.setVisibility(R.telemetryLogId,h()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(P,S){this.a.trace(`${this.b}telemetry/${P}`,(0,R.validateTelemetryData)(S))}};I=ye([G(0,T.ILogService),G(1,T.ILoggerService),G(2,l.IEnvironmentService),G(3,N.IProductService)],I),e.TelemetryLogAppender=I}),define(re[115],oe([0,1,2,32,4,27,177,17,45,107,26,40,19,47]),function(te,e,O,U,l,T,N,R,I,w,P,S,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let m=class{constructor(u,h,d){this.k=h,this.l=d,this.d={},this.i=new O.DisposableStore,this.j=[],this.b=u.appenders,this.c=u.commonProperties||Promise.resolve({}),this.f=u.piiPaths||[],this.g=3,this.h=!!u.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const v of this.f)this.j.push(new RegExp((0,T.escapeRegExpCharacters)(v),"gi")),v.indexOf("\\")>=0&&this.j.push(new RegExp((0,T.escapeRegExpCharacters)(v.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(v=>{(v.affectsConfiguration(p.TELEMETRY_SETTING_ID)||v.affectsConfiguration(p.TELEMETRY_OLD_SETTING_ID)||v.affectsConfiguration(p.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this.m()}))}setExperimentProperty(u,h){this.d[u]=h}m(){let u=(0,f.getTelemetryLevel)(this.k);const h=this.l.enabledTelemetryLevels;if(h){this.h=this.sendErrorTelemetry?h.error:!1;const d=h.usage?3:h.error?2:0;u=Math.min(u,d)}this.g=u}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}async getTelemetryInfo(){const u=await this.c,h=u.sessionID,d=u["common.machineId"],v=u["common.firstSessionDate"],L=u["common.msftInternal"];return{sessionId:h,machineId:d,firstSessionDate:v,msftInternal:L}}dispose(){this.i.dispose()}n(u,h,d){return this.g<h?Promise.resolve(void 0):this.c.then(v=>{d=(0,U.mixin)(d,this.d),d=(0,f.cleanData)(d,this.j),d=(0,U.mixin)(d,v),this.b.forEach(L=>L.log(u,d))},v=>{console.error(v)})}publicLog(u,h){return this.n(u,3,h)}publicLog2(u,h){return this.publicLog(u,h)}publicLogError(u,h){return this.h?this.n(u,2,h):Promise.resolve(void 0)}publicLogError2(u,h){return this.publicLogError(u,h)}};m.IDLE_START_EVENT_NAME="UserIdleStart",m.IDLE_STOP_EVENT_NAME="UserIdleStop",m=ye([G(1,R.IConfigurationService),G(2,P.IProductService)],m),e.TelemetryService=m;function E(){const a=(0,N.localize)(0,null,w.default.nameLong),u=w.default.privacyStatementUrl?(0,N.localize)(2,null,"https://aka.ms/vscode-telemetry",w.default.privacyStatementUrl):(0,N.localize)(1,null,"https://aka.ms/vscode-telemetry"),h=l.isWeb?"":(0,N.localize)(3,null),d=(0,N.localize)(4,null),v=(0,N.localize)(5,null),L=(0,N.localize)(6,null),n=(0,N.localize)(7,null),r=`
|       | ${d} | ${v} | ${L} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,t=(0,N.localize)(8,null);return`
${a} ${u} ${h}

&nbsp;

${n}
${r}

&nbsp;

${t}
`}S.Registry.as(I.Extensions.Configuration).registerConfiguration({id:p.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,N.localize)(9,null),properties:{[p.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,N.localize)(10,null),(0,N.localize)(11,null),(0,N.localize)(12,null),(0,N.localize)(13,null)],markdownDescription:E(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),S.Registry.as(I.Extensions.Configuration).registerConfiguration({id:p.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,N.localize)(14,null),properties:{[p.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:w.default.privacyStatementUrl?(0,N.localize)(16,null,w.default.nameLong,w.default.privacyStatementUrl):(0,N.localize)(15,null,w.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,N.localize)(17,null,`\`#${p.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(re[241],oe([0,1,296,240]),function(te,e,O,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class l extends U.AbstractOneDataSystemAppender{constructor(N,R,I,w){const P={sendPOST:(S,p)=>{const f={method:"POST",headers:{...S.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(S.data)}};try{const m=O.request(S.urlString,f,E=>{E.on("data",function(a){p(E.statusCode??200,E.headers,a.toString())}),E.on("error",function(a){p(0,{})})});m.write(S.data),m.end()}catch{p(0,{})}}};super(N,R,I,w,P)}}e.OneDataSystemAppender=l}),define(re[242],oe([0,1,22,66,17,15,9,26,19,113,114,115]),function(te,e,O,U,l,T,N,R,I,w,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let p=class{constructor(m,E,a,u,h,d){this.b=m,this.c=E,this.d=a,this.e=u,this.f=h,this.g=d,this.a=new Map}async h(m){if(!this.a.has(m.id)){const{machineId:E,sessionId:a}=await this.c.getTelemetryInfo(),u=Object.create(null);u["common.vscodemachineid"]=E,u["common.vscodesessionid"]=a;const h=[m.id,JSON.stringify(u),m.aiKey],v=new U.Client(O.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:h,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),L=[new w.TelemetryAppenderClient(v),new P.TelemetryLogAppender(this.d,this.e,this.f,this.g,`[${m.id}] `)];this.a.set(m.id,new S.TelemetryService({appenders:L,sendErrorTelemetry:m.sendErrorTelemetry},this.b,this.g))}return this.a.get(m.id)}async publicLog(m,E,a){await(await this.h(m)).publicLog(E,a)}async publicLogError(m,E,a){await(await this.h(m)).publicLogError(E,a)}};p=ye([G(0,l.IConfigurationService),G(1,I.ITelemetryService),G(2,N.ILogService),G(3,N.ILoggerService),G(4,T.IEnvironmentService),G(5,R.IProductService)],p),e.CustomEndpointTelemetryService=p}),define(re[116],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var O;(function(U){U[U.Replace=1]="Replace",U[U.Append=2]="Append",U[U.Prepend=3]="Prepend"})(O=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}))}),define(re[243],oe([0,1,4,116]),function(te,e,O,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;class l{constructor(I){this.collections=I,this.map=new Map,I.forEach((w,P)=>{const S=w.map.entries();let p=S.next();for(;!p.done;){const f=p.value[0];let m=this.map.get(f);if(m||(m=[],this.map.set(f,m)),m.length>0&&m[0].type===U.EnvironmentVariableMutatorType.Replace){p=S.next();continue}const E=p.value[1];m.unshift({extensionIdentifier:P,value:E.value,type:E.type}),p=S.next()}})}async applyToProcessEnvironment(I,w){let P;O.isWindows&&(P={},Object.keys(I).forEach(S=>P[S.toLowerCase()]=S));for(const[S,p]of this.map){const f=O.isWindows&&P[S.toLowerCase()]||S;for(const m of p){const E=w?await w(m.value):m.value;switch(m.type){case U.EnvironmentVariableMutatorType.Append:I[f]=(I[f]||"")+E;break;case U.EnvironmentVariableMutatorType.Prepend:I[f]=E+(I[f]||"");break;case U.EnvironmentVariableMutatorType.Replace:I[f]=E;break}}}}diff(I){const w=new Map,P=new Map,S=new Map;if(I.map.forEach((p,f)=>{const m=this.map.get(f),E=T(p,m);E&&w.set(f,E)}),this.map.forEach((p,f)=>{const m=I.map.get(f),E=T(p,m);E&&S.set(f,E)}),this.map.forEach((p,f)=>{const m=I.map.get(f),E=N(p,m);E&&P.set(f,E)}),!(w.size===0&&P.size===0&&S.size===0))return{added:w,changed:P,removed:S}}}e.MergedEnvironmentVariableCollection=l;function T(R,I){if(!I)return R;const w=new Set;I.forEach(S=>w.add(S.extensionIdentifier));const P=[];return R.forEach(S=>{w.has(S.extensionIdentifier)||P.push(S)}),P.length===0?void 0:P}function N(R,I){if(!I)return;const w=new Map;I.forEach(S=>w.set(S.extensionIdentifier,S));const P=[];return R.forEach(S=>{const p=w.get(S.extensionIdentifier);p&&(S.type!==p.type||S.value!==p.value)&&P.push(p)}),P.length===0?void 0:P}}),define(re[244],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function O(N){return[...N.entries()]}e.serializeEnvironmentVariableCollection=O;function U(N){return new Map(N)}e.deserializeEnvironmentVariableCollection=U;function l(N){return Array.from(N.entries()).map(R=>[R[0],O(R[1].map)])}e.serializeEnvironmentVariableCollections=l;function T(N){return new Map(N.map(R=>[R[0],{map:U(R[1])}]))}e.deserializeEnvironmentVariableCollections=T}),define(re[245],oe([0,1,6,25,3,2,9]),function(te,e,O,U,l,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let R=class extends T.Disposable{constructor(w,P){super(),this.h=P,this.a=0,this.c=new Map,this.f=new Map,this.g=this.D(new l.Emitter),this.onCreateRequest=this.g.event,this.b=w===void 0?15e3:w}createRequest(w){return new Promise((P,S)=>{const p=++this.a;this.c.set(p,P),this.g.fire({requestId:p,...w});const f=new U.CancellationTokenSource;(0,O.timeout)(this.b,f.token).then(()=>S(`Request ${p} timed out (${this.b}ms)`)),this.f.set(p,[(0,T.toDisposable)(()=>f.cancel())])})}acceptReply(w,P){const S=this.c.get(w);S?(this.c.delete(w),(0,T.dispose)(this.f.get(w)||[]),this.f.delete(w),S(P)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${w}`)}};R=ye([G(1,N.ILogService)],R),e.RequestStore=R}),define(re[117],oe([0,1,5,70]),function(te,e,O,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.terminalTabFocusContextKey=void 0,e.terminalTabFocusContextKey=new U.RawContextKey("terminalTabFocusMode",!1,!0);var l;(function(d){d.Shell="terminal.integrated.shell.",d.ShellArgs="terminal.integrated.shellArgs.",d.DefaultProfile="terminal.integrated.defaultProfile.",d.Profiles="terminal.integrated.profiles."})(l=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var T;(function(d){d.ShellLinux="terminal.integrated.shell.linux",d.ShellMacOs="terminal.integrated.shell.osx",d.ShellWindows="terminal.integrated.shell.windows",d.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",d.AutomationShellLinux="terminal.integrated.automationShell.linux",d.AutomationShellMacOs="terminal.integrated.automationShell.osx",d.AutomationShellWindows="terminal.integrated.automationShell.windows",d.AutomationProfileLinux="terminal.integrated.automationProfile.linux",d.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",d.AutomationProfileWindows="terminal.integrated.automationProfile.windows",d.ShellArgsLinux="terminal.integrated.shellArgs.linux",d.ShellArgsMacOs="terminal.integrated.shellArgs.osx",d.ShellArgsWindows="terminal.integrated.shellArgs.windows",d.ProfilesWindows="terminal.integrated.profiles.windows",d.ProfilesMacOs="terminal.integrated.profiles.osx",d.ProfilesLinux="terminal.integrated.profiles.linux",d.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",d.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",d.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",d.UseWslProfiles="terminal.integrated.useWslProfiles",d.TabsDefaultColor="terminal.integrated.tabs.defaultColor",d.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",d.TabsEnabled="terminal.integrated.tabs.enabled",d.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",d.TabsHideCondition="terminal.integrated.tabs.hideCondition",d.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",d.TabsShowActions="terminal.integrated.tabs.showActions",d.TabsLocation="terminal.integrated.tabs.location",d.TabsFocusMode="terminal.integrated.tabs.focusMode",d.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",d.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",d.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",d.CopyOnSelection="terminal.integrated.copyOnSelection",d.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",d.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",d.FontFamily="terminal.integrated.fontFamily",d.FontSize="terminal.integrated.fontSize",d.LetterSpacing="terminal.integrated.letterSpacing",d.LineHeight="terminal.integrated.lineHeight",d.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",d.TabStopWidth="terminal.integrated.tabStopWidth",d.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",d.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",d.BellDuration="terminal.integrated.bellDuration",d.FontWeight="terminal.integrated.fontWeight",d.FontWeightBold="terminal.integrated.fontWeightBold",d.CursorBlinking="terminal.integrated.cursorBlinking",d.CursorStyle="terminal.integrated.cursorStyle",d.CursorWidth="terminal.integrated.cursorWidth",d.Scrollback="terminal.integrated.scrollback",d.DetectLocale="terminal.integrated.detectLocale",d.DefaultLocation="terminal.integrated.defaultLocation",d.GpuAcceleration="terminal.integrated.gpuAcceleration",d.TerminalTitleSeparator="terminal.integrated.tabs.separator",d.TerminalTitle="terminal.integrated.tabs.title",d.TerminalDescription="terminal.integrated.tabs.description",d.RightClickBehavior="terminal.integrated.rightClickBehavior",d.Cwd="terminal.integrated.cwd",d.ConfirmOnExit="terminal.integrated.confirmOnExit",d.ConfirmOnKill="terminal.integrated.confirmOnKill",d.EnableBell="terminal.integrated.enableBell",d.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",d.AllowChords="terminal.integrated.allowChords",d.AllowMnemonics="terminal.integrated.allowMnemonics",d.TabFocusMode="terminal.integrated.tabFocusMode",d.EnvMacOs="terminal.integrated.env.osx",d.EnvLinux="terminal.integrated.env.linux",d.EnvWindows="terminal.integrated.env.windows",d.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",d.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",d.ShowExitAlert="terminal.integrated.showExitAlert",d.SplitCwd="terminal.integrated.splitCwd",d.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",d.WordSeparators="terminal.integrated.wordSeparators",d.EnableFileLinks="terminal.integrated.enableFileLinks",d.UnicodeVersion="terminal.integrated.unicodeVersion",d.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",d.LocalEchoEnabled="terminal.integrated.localEchoEnabled",d.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",d.LocalEchoStyle="terminal.integrated.localEchoStyle",d.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",d.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",d.CustomGlyphs="terminal.integrated.customGlyphs",d.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",d.InheritEnv="terminal.integrated.inheritEnv",d.ShowLinkHover="terminal.integrated.showLinkHover",d.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",d.AutoReplies="terminal.integrated.autoReplies",d.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",d.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",d.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",d.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",d.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",d.SmoothScrolling="terminal.integrated.smoothScrolling"})(T=e.TerminalSettingId||(e.TerminalSettingId={}));var N;(function(d){d.PowerShell="pwsh",d.Bash="bash",d.Fish="fish",d.Sh="sh",d.Csh="csh",d.Ksh="ksh",d.Zsh="zsh"})(N=e.PosixShellType||(e.PosixShellType={}));var R;(function(d){d.CommandPrompt="cmd",d.PowerShell="pwsh",d.Wsl="wsl",d.GitBash="gitbash"})(R=e.WindowsShellType||(e.WindowsShellType={}));var I;(function(d){d[d.Api=0]="Api",d[d.Process=1]="Process",d[d.Sequence=2]="Sequence",d[d.Config=3]="Config"})(I=e.TitleEventSource||(e.TitleEventSource={}));var w;(function(d){d.LocalPty="localPty",d.PtyHost="ptyHost",d.Logger="logger",d.Heartbeat="heartbeat"})(w=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,O.createDecorator)("ptyService");var P;(function(d){d.Cwd="cwd",d.InitialCwd="initialCwd",d.FixedDimensions="fixedDimensions",d.Title="title",d.ShellType="shellType",d.HasChildProcesses="hasChildProcesses",d.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",d.OverrideDimensions="overrideDimensions",d.FailedShellIntegrationActivation="failedShellIntegrationActivation",d.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(P=e.ProcessPropertyType||(e.ProcessPropertyType={}));var S;(function(d){d[d.BeatInterval=5e3]="BeatInterval",d[d.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",d[d.SecondWaitMultiplier=1]="SecondWaitMultiplier",d[d.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(S=e.HeartbeatConstants||(e.HeartbeatConstants={}));var p;(function(d){d[d.Panel=1]="Panel",d[d.Editor=2]="Editor"})(p=e.TerminalLocation||(e.TerminalLocation={}));var f;(function(d){d.TerminalView="view",d.Editor="editor"})(f=e.TerminalLocationString||(e.TerminalLocationString={}));var m;(function(d){d[d.GraceTime=6e4]="GraceTime",d[d.ShortGraceTime=6e3]="ShortGraceTime"})(m=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var E;(function(d){d[d.HighWatermarkChars=1e5]="HighWatermarkChars",d[d.LowWatermarkChars=5e3]="LowWatermarkChars",d[d.CharCountAckSize=5e3]="CharCountAckSize"})(E=e.FlowControlConstants||(e.FlowControlConstants={}));var a;(function(d){d.GitBash="Git Bash",d.Pwsh="PowerShell"})(a=e.ProfileSource||(e.ProfileSource={}));var u;(function(d){d[d.Off=0]="Off",d[d.FinalTerm=1]="FinalTerm",d[d.VSCode=2]="VSCode"})(u=e.ShellIntegrationStatus||(e.ShellIntegrationStatus={}));var h;(function(d){d[d.Unknown=0]="Unknown",d[d.Shutdown=1]="Shutdown",d[d.Process=2]="Process",d[d.User=3]="User",d[d.Extension=4]="Extension"})(h=e.TerminalExitReason||(e.TerminalExitReason={}))}),define(re[246],oe([0,1,52,11,179,134]),function(te,e,O,U,l,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function N(p,f){const m=[{name:null,description:(0,l.localize)(0,null)}];return m.push(...p.map(E=>({name:E.profileName,description:R(E)}))),f&&m.push(...f.map(E=>({name:E.title,description:I(E)}))),{values:m.map(E=>E.name),markdownDescriptions:m.map(E=>E.description)}}e.createProfileSchemaEnums=N;function R(p){let f=`$(${T.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:O.Codicon.terminal.id}) ${p.profileName}
- path: ${p.path}`;return p.args&&(typeof p.args=="string"?f+=`
- args: "${p.args}"`:f+=`
- args: [${p.args.length===0?"":`'${p.args.join("','")}'`}]`),p.overrideName!==void 0&&(f+=`
- overrideName: ${p.overrideName}`),p.color&&(f+=`
- color: ${p.color}`),p.env&&(f+=`
- env: ${JSON.stringify(p.env)}`),f}function I(p){return`$(${T.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:O.Codicon.terminal.id}) ${p.title}
- extensionIdentifier: ${p.extensionIdentifier}`}function w(p,f){if(!p&&!f)return!0;if(typeof p=="string"&&typeof f=="string")return p===f;if(Array.isArray(p)&&Array.isArray(f)){if(p.length!==f.length)return!1;for(let m=0;m<p.length;m++)if(p[m]!==f[m])return!1;return!0}return!1}e.terminalProfileArgsMatch=w;function P(p,f){if(!p&&!f)return!0;if(!p||!f)return!1;if(T.ThemeIcon.isThemeIcon(p)&&T.ThemeIcon.isThemeIcon(f))return p.id===f.id&&p.color===f.color;if(typeof p=="object"&&"light"in p&&"dark"in p&&typeof f=="object"&&"light"in f&&"dark"in f){const m=p,E=f;if((U.URI.isUri(m.light)||S(m.light))&&(U.URI.isUri(m.dark)||S(m.dark))&&(U.URI.isUri(E.light)||S(E.light))&&(U.URI.isUri(E.dark)||S(E.dark)))return m.light.path===E.light.path&&m.dark.path===E.dark.path}if(U.URI.isUri(p)&&U.URI.isUri(f)||S(p)||S(f)){const m=p,E=f;return m.path===E.path&&m.scheme===E.scheme}return!1}e.terminalIconsEqual=P;function S(p){return p?typeof p.path=="string"&&typeof p.scheme=="string":!1}e.isUriComponents=S}),define(re[247],oe([0,1,52,178,45,40,246]),function(te,e,O,U,l,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from((0,O.getAllCodicons)(),v=>v.id),markdownEnumDescriptions:Array.from((0,O.getAllCodicons)(),v=>`$(${v.id})`)};const R={args:{description:(0,U.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,U.localize)(1,null),type:"boolean"},icon:{description:(0,U.localize)(2,null),...e.terminalIconSchema},color:{description:(0,U.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,U.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},I={type:"object",required:["path"],properties:{path:{description:(0,U.localize)(5,null),type:["string","array"],items:{type:"string"}},...R}},w={type:"object",required:["path"],properties:{path:{description:(0,U.localize)(6,null),type:["string"],items:{type:"string"}},...R}},P=(0,U.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),S=(0,U.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),p=(0,U.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),f=(0,U.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),m=(0,U.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),E=(0,U.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),a={id:"terminal",order:100,title:(0,U.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,U.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:f},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,U.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:m},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,U.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:E},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,U.localize)(17,null,"`terminal.integrated.automationShell.linux`"),type:["object","null"],default:null,anyOf:[{type:"null"},w],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,U.localize)(18,null,"`terminal.integrated.automationShell.osx`"),type:["object","null"],default:null,anyOf:[{type:"null"},w],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,U.localize)(19,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},w],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,U.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:P},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,U.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:S},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,U.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:p},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,U.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:P},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,U.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:S},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,U.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,U.localize)(26,null)}},{type:"string",markdownDescription:(0,U.localize)(27,null)}],default:[],markdownDeprecationMessage:p},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,U.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,U.localize)(29,null),enum:["PowerShell","Git Bash"]},...R}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,U.localize)(30,null),type:"string"},id:{description:(0,U.localize)(31,null),type:"string"},title:{description:(0,U.localize)(32,null),type:"string"},...R}},{type:"null"},I]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,U.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,U.localize)(34,null),type:"string"},id:{description:(0,U.localize)(35,null),type:"string"},title:{description:(0,U.localize)(36,null),type:"string"},...R}},{type:"null"},I]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,U.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,U.localize)(38,null),type:"string"},id:{description:(0,U.localize)(39,null),type:"string"},title:{description:(0,U.localize)(40,null),type:"string"},...R}},{type:"null"},I]}},["terminal.integrated.useWslProfiles"]:{description:(0,U.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,U.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,U.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,U.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,U.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function u(){T.Registry.as(l.Extensions.Configuration).registerConfiguration(a),d()}e.registerTerminalPlatformConfiguration=u;let h;function d(v,L){const n=T.Registry.as(l.Extensions.Configuration);let r;v&&(r=(0,N.createProfileSchemaEnums)(v?.profiles,L));const t=h;h={id:"terminal",order:100,title:(0,U.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,U.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:v?.os===3?r?.values:void 0,markdownEnumDescriptions:v?.os===3?r?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,U.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:v?.os===2?r?.values:void 0,markdownEnumDescriptions:v?.os===2?r?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,U.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:v?.os===1?r?.values:void 0,markdownEnumDescriptions:v?.os===1?r?.markdownDescriptions:void 0}}},n.updateConfigurations({add:[h],remove:t?[t]:[]})}e.registerTerminalDefaultProfileConfiguration=d}),define(re[248],oe([0,1,5]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,O.createDecorator)("localPtyService")}),define(re[249],oe([0,1,34,22,32,13,4,36,27,12,28,116,244,243]),function(te,e,O,U,l,T,N,R,I,w,P,S,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function m(){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(O.release());let s=0;return i&&i.length===4&&(s=parseInt(i[3])),s}e.getWindowsBuildNumber=m;async function E(i,s,o,c=R.env,y=P.Promises.exists){if(T.isAbsolute(i))return await y(i)?i:void 0;if(s===void 0&&(s=R.cwd()),T.dirname(i)!=="."){const A=T.join(s,i);return await y(A)?A:void 0}const g=(0,l.getCaseInsensitive)(c,"PATH");if(o===void 0&&(0,w.isString)(g)&&(o=g.split(T.delimiter)),o===void 0||o.length===0){const A=T.join(s,i);return await y(A)?A:void 0}for(const A of o){let F;if(T.isAbsolute(A)?F=T.join(A,i):F=T.join(s,A,i),await y(F))return F;if(N.isWindows){let j=F+".com";if(await y(j)||(j=F+".exe",await y(j)))return j}}const D=T.join(s,i);return await y(D)?D:void 0}e.findExecutable=E;function a(i,s,o,c,y){const b=N.isWindows&&(!s.windowsEnableConpty||m()<18309);if(!s.shellIntegration.enabled||!i.executable||i.isFeatureTerminal||i.hideFromUser||i.ignoreShellIntegration||b)return;const g=i.args,D=R.platform==="win32"?T.basename(i.executable).toLowerCase():T.basename(i.executable),A=T.dirname(U.FileAccess.asFileUri("").fsPath);let F;const j={VSCODE_INJECTION:"1"};if(N.isWindows){if(D==="pwsh.exe"||D==="powershell.exe")return!g||r(g)?F=d.get(h.WindowsPwsh):n(g)&&(F=d.get(h.WindowsPwshLogin)),F?(F=[...F],F[F.length-1]=(0,I.format)(F[F.length-1],A,""),s.shellIntegration.suggestEnabled&&(j.VSCODE_SUGGEST="1"),{newArgs:F,envMixin:j}):void 0;c.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args);return}switch(D){case"bash":return!g||g.length===0?F=d.get(h.Bash):t(g)&&(j.VSCODE_SHELL_LOGIN="1",u(s,j),F=d.get(h.Bash)),F?(F=[...F],F[F.length-1]=(0,I.format)(F[F.length-1],A),{newArgs:F,envMixin:j}):void 0;case"fish":{const x=o?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",V=T.join(A,"out/vs/workbench/contrib/xdg_data");return j.XDG_DATA_DIRS=`${x}:${V}`,u(s,j),{newArgs:void 0,envMixin:j}}case"pwsh":return!g||r(g)?F=d.get(h.Pwsh):n(g)&&(F=d.get(h.PwshLogin)),F?(s.shellIntegration.suggestEnabled&&(j.VSCODE_SUGGEST="1"),F=[...F],F[F.length-1]=(0,I.format)(F[F.length-1],A,""),{newArgs:F,envMixin:j}):void 0;case"zsh":{if(!g||g.length===0?F=d.get(h.Zsh):t(g)?(F=d.get(h.ZshLogin),u(s,j)):(g===d.get(h.Zsh)||g===d.get(h.ZshLogin))&&(F=g),!F)return;F=[...F],F[F.length-1]=(0,I.format)(F[F.length-1],A);let x;try{x=O.userInfo().username}catch{x="unknown"}const V=T.join(O.tmpdir(),`${x}-${y.applicationName}-zsh`);j.ZDOTDIR=V;const B=o?.ZDOTDIR??O.homedir()??"~";j.USER_ZDOTDIR=B;const Z=[];return Z.push({source:T.join(A,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:T.join(V,".zshrc")}),Z.push({source:T.join(A,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:T.join(V,".zprofile")}),Z.push({source:T.join(A,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:T.join(V,".zshenv")}),Z.push({source:T.join(A,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:T.join(V,".zlogin")}),{newArgs:F,envMixin:j,filesToCopy:Z}}}c.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args)}e.getShellIntegrationInjection=a;function u(i,s){if(N.isMacintosh&&i.environmentVariableCollections){const o=(0,p.deserializeEnvironmentVariableCollections)(i.environmentVariableCollections),y=new f.MergedEnvironmentVariableCollection(o).map.get("PATH"),b=[];if(y)for(const g of y)g.type===S.EnvironmentVariableMutatorType.Prepend&&b.push(g.value);b.length>0&&(s.VSCODE_PATH_PREFIX=b.join(""))}}var h;(function(i){i.WindowsPwsh="windows-pwsh",i.WindowsPwshLogin="windows-pwsh-login",i.Pwsh="pwsh",i.PwshLogin="pwsh-login",i.Zsh="zsh",i.ZshLogin="zsh-login",i.Bash="bash"})(h||(h={}));const d=new Map;d.set(h.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),d.set(h.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),d.set(h.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),d.set(h.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),d.set(h.Zsh,["-i"]),d.set(h.ZshLogin,["-il"]),d.set(h.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const v=["-login","-l"],L=["-nol","-nologo"];function n(i){return typeof i=="string"?v.includes(i.toLowerCase()):i.length===1&&v.includes(i[0].toLowerCase())||i.length===2&&(v.includes(i[0].toLowerCase())||v.includes(i[1].toLowerCase()))&&(L.includes(i[0].toLowerCase())||L.includes(i[1].toLowerCase()))}function r(i){return typeof i=="string"?L.includes(i.toLowerCase()):i.length===0||i?.length===1&&L.includes(i[0].toLowerCase())}function t(i){return i==="string"&&v.includes(i.toLowerCase())||typeof i!="string"&&i.length===1&&v.includes(i[0].toLowerCase())}}),define(re[250],oe([0,1,50,52,13,4,12,28,95,249]),function(te,e,O,U,l,T,N,R,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let P,S=!0;function p(r,t,i,s,o=process.env,c,y,b,g){return c=c||{existsFile:R.SymlinkSupport.existsFile,readFile:R.Promises.readFile},T.isWindows?f(i,c,o,y,s.getValue("terminal.integrated.useWslProfiles")!==!1,r&&typeof r=="object"?{...r}:s.getValue("terminal.integrated.profiles.windows"),typeof t=="string"?t:s.getValue("terminal.integrated.defaultProfile.windows"),g,b):v(c,y,i,r&&typeof r=="object"?{...r}:s.getValue(T.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof t=="string"?t:s.getValue(T.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),g,b,o)}e.detectAvailableProfiles=p;async function f(r,t,i,s,o,c,y,b,g){const D=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),A=`${process.env.windir}\\${D?"Sysnative":"System32"}`;let F=!1;(0,w.getWindowsBuildNumber)()>=16299&&(F=!0),await a(b);const j=new Map;if(r){j.set("PowerShell",{source:"PowerShell",icon:U.Codicon.terminalPowershell,isAutoDetected:!0}),j.set("Windows PowerShell",{path:`${A}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:U.Codicon.terminalPowershell,isAutoDetected:!0}),j.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),j.set("Command Prompt",{path:`${A}\\cmd.exe`,icon:U.Codicon.terminalCmd,isAutoDetected:!0}),j.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),j.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:U.Codicon.terminalBash,isAutoDetected:!0});const V=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;j.set("Cmder",{path:`${A}\\cmd.exe`,args:["/K",V],requiresPath:process.env.CMDER_ROOT?V:{path:V,isUnsafe:!0},isAutoDetected:!0})}L(c,j);const x=await m(j.entries(),y,t,i,s,g);if(r||o)try{const V=await h(`${A}\\${F?"wsl":"bash"}.exe`,y);for(const B of V)(!c||!(B.profileName in c))&&x.push(B)}catch{S&&(s?.info("WSL is not installed, so could not detect WSL profiles"),S=!1)}return x}async function m(r,t,i,s=process.env,o,c){const y=[];for(const[b,g]of r){if(g===null)continue;let D,A,F;if("source"in g){const B=P?.get(g.source);if(!B)continue;D=B.paths,A=g.args||B.args,g.icon?F=E(g.icon):B.icon&&(F=B.icon)}else D=Array.isArray(g.path)?g.path:[g.path],A=T.isWindows||Array.isArray(g.args)?g.args:void 0,F=E(g.icon);let j;if(c){const B=D.map(J=>typeof J=="string"?J:J.path),Z=await c(B);j=new Array(D.length);for(let J=0;J<D.length;J++)typeof D[J]=="string"?j[J]=Z[J]:j[J]={path:Z[J],isUnsafe:!0}}else j=D.slice();let x;if(g.requiresPath){let B;if((0,N.isString)(g.requiresPath)?B=g.requiresPath:(B=g.requiresPath.path,g.requiresPath.isUnsafe&&(x=B)),!await i.existsFile(B))continue}const V=await n(b,t,j,i,s,A,g.env,g.overrideName,g.isAutoDetected,x);V?(V.isAutoDetected=g.isAutoDetected,V.icon=F,V.color=g.color,y.push(V)):o?.debug("Terminal profile not validated",b,D)}return o?.debug("Validated terminal profiles",y),y}function E(r){return typeof r=="string"?{id:r}:r}async function a(r){P&&!r||(P=new Map,P.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login","-i"]}),P.set("PowerShell",{profileName:"PowerShell",paths:r||await u(),icon:U.Codicon.terminalPowershell}))}async function u(){const r=[];for await(const t of(0,I.enumeratePowerShellInstallations)())r.push(t.exePath);return r}async function h(r,t){const i=[],s=await new Promise((y,b)=>{O.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(g,D)=>{if(g)return b("Problem occurred when getting wsl distros");y(D)})});if(!s)return[];const o=new RegExp(/[\r?\n]/),c=s.split(o).filter(y=>y.trim().length>0&&y!=="");for(const y of c){if(y===""||y.startsWith("docker-desktop"))continue;const b=`${y} (WSL)`,g={profileName:b,path:r,args:["-d",`${y}`],isDefault:b===t,icon:d(y),isAutoDetected:!1};i.push(g)}return i}function d(r){return r.includes("Ubuntu")?U.Codicon.terminalUbuntu:r.includes("Debian")?U.Codicon.terminalDebian:U.Codicon.terminalLinux}async function v(r,t,i,s,o,c,y,b){const g=new Map;if(i){const D=(await r.readFile("/etc/shells")).toString(),A=c||D.split(`
`).filter(j=>j.trim().includes("#")&&j.trim().length>0),F=new Map;for(const j of A){let x=(0,l.basename)(j),V=F.get(x)||0;V++,V>1&&(x=`${x} (${V})`),F.set(x,V),g.set(x,{path:j,isAutoDetected:!0})}}return L(s,g),await m(g.entries(),o,r,b,t,y)}function L(r,t){if(!!r)for(const[i,s]of Object.entries(r))s===null||typeof s!="object"||!("path"in s)&&!("source"in s)?t.delete(i):(s.icon=s.icon||t.get(i)?.icon,t.set(i,s))}async function n(r,t,i,s,o,c,y,b,g,D){if(i.length===0)return Promise.resolve(void 0);const A=i.shift();if(A==="")return n(r,t,i,s,o,c,y,b,g);const F=typeof A!="string"&&A.isUnsafe,j=typeof A=="string"?A:A.path,x={profileName:r,path:j,args:c,env:y,overrideName:b,isAutoDetected:g,isDefault:r===t,isUnsafePath:F,requiresUnsafePath:D};if((0,l.basename)(j)===j){const B=o.PATH?o.PATH.split(l.delimiter):void 0,Z=await(0,w.findExecutable)(j,void 0,B,void 0,s.existsFile);return Z?(x.path=Z,x.isFromPath=!0,x):n(r,t,i,s,o,c)}return await s.existsFile((0,l.normalize)(j))?x:n(r,t,i,s,o,c,y,b,g)}}),define(re[251],oe([0,1,3,2,22,4,39,66,17,15,98,231,9,245,117,247,250,106]),function(te,e,O,U,l,T,N,R,I,w,P,S,p,f,m,E,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var h;(function(L){L[L.MaxRestarts=5]="MaxRestarts"})(h||(h={}));let d=0,v=class extends U.Disposable{constructor(n,r,t,i,s,o){super(),this.z=n,this.C=r,this.F=t,this.G=i,this.H=s,this.I=o,this.g=0,this.h=!0,this.i=!1,this.l=this.D(new O.Emitter),this.onPtyHostExit=this.l.event,this.m=this.D(new O.Emitter),this.onPtyHostStart=this.m.event,this.n=this.D(new O.Emitter),this.onPtyHostUnresponsive=this.n.event,this.p=this.D(new O.Emitter),this.onPtyHostResponsive=this.p.event,this.q=this.D(new O.Emitter),this.onPtyHostRequestResolveVariables=this.q.event,this.r=this.D(new O.Emitter),this.onProcessData=this.r.event,this.s=this.D(new O.Emitter),this.onProcessReady=this.s.event,this.t=this.D(new O.Emitter),this.onProcessReplay=this.t.event,this.u=this.D(new O.Emitter),this.onProcessOrphanQuestion=this.u.event,this.v=this.D(new O.Emitter),this.onDidRequestDetach=this.v.event,this.w=this.D(new O.Emitter),this.onDidChangeProperty=this.w.event,this.y=this.D(new O.Emitter),this.onProcessExit=this.y.event,(0,E.registerTerminalPlatformConfiguration)(),this.c=this.M(),this.D((0,U.toDisposable)(()=>this.O())),this.f=this.D(new f.RequestStore(void 0,this.H)),this.f.onCreateRequest(this.q.fire,this.q),[this.a,this.b]=this.N(),this.D(this.F.onDidChangeConfiguration(async c=>{c.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.L()}))}initialize(){this.L()}get J(){return this.F.getValue("terminal.integrated.ignoreProcessNames")}async L(){return this.b.refreshIgnoreProcessNames?.(this.J)}async M(){if(T.isWindows)return process.env;try{return await(0,S.getResolvedShellEnv)(this.F,this.H,{_:[]},process.env)}catch(n){return this.H.error("ptyHost was unable to resolve shell environment",n),{}}}N(){const n={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this.G.logsHome.fsPath],env:{VSCODE_LAST_PTY_ID:d,VSCODE_PTY_REMOTE:this.C,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this.z.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this.z.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this.z.scrollback}},r=(0,P.parsePtyHostDebugPort)(this.G.args,this.G.isBuilt);r&&(r.break&&r.port?n.debugBrk=r.port:!r.break&&r.port&&(n.debug=r.port));const t=new R.Client(l.FileAccess.asFileUri("bootstrap-fork").fsPath,n);this.m.fire(),N.ProxyChannel.toService(t.getChannel(m.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.P()),this.P(),this.D(t.onDidProcessExit(o=>{this.l.fire(o.code),this.i||(this.g<=h.MaxRestarts?(this.H.error(`ptyHost terminated unexpectedly with code ${o.code}`),this.g++,this.restartPtyHost()):this.H.error(`ptyHost terminated unexpectedly with code ${o.code}, giving up`))})),this.D(new u.RemoteLoggerChannelClient(this.I,t.getChannel(m.TerminalIpcChannels.Logger)));const s=N.ProxyChannel.toService(t.getChannel(m.TerminalIpcChannels.PtyHost));return this.D(s.onProcessData(o=>this.r.fire(o))),this.D(s.onProcessReady(o=>this.s.fire(o))),this.D(s.onProcessExit(o=>this.y.fire(o))),this.D(s.onDidChangeProperty(o=>this.w.fire(o))),this.D(s.onProcessReplay(o=>this.t.fire(o))),this.D(s.onProcessOrphanQuestion(o=>this.u.fire(o))),this.D(s.onDidRequestDetach(o=>this.v.fire(o))),[t,s]}dispose(){this.i=!0,super.dispose()}async createProcess(n,r,t,i,s,o,c,y,b,g,D){const A=setTimeout(()=>this.S(),m.HeartbeatConstants.CreateProcessTimeout),F=await this.b.createProcess(n,r,t,i,s,o,c,y,b,g,D);return clearTimeout(A),d=Math.max(d,F),F}updateTitle(n,r,t){return this.b.updateTitle(n,r,t)}updateIcon(n,r,t,i){return this.b.updateIcon(n,r,t,i)}attachToProcess(n){return this.b.attachToProcess(n)}detachFromProcess(n,r){return this.b.detachFromProcess(n,r)}listProcesses(){return this.b.listProcesses()}reduceConnectionGraceTime(){return this.b.reduceConnectionGraceTime()}start(n){return this.b.start(n)}shutdown(n,r){return this.b.shutdown(n,r)}input(n,r){return this.b.input(n,r)}processBinary(n,r){return this.b.processBinary(n,r)}resize(n,r,t){return this.b.resize(n,r,t)}acknowledgeDataEvent(n,r){return this.b.acknowledgeDataEvent(n,r)}setUnicodeVersion(n,r){return this.b.setUnicodeVersion(n,r)}getInitialCwd(n){return this.b.getInitialCwd(n)}getCwd(n){return this.b.getCwd(n)}getLatency(n){return this.b.getLatency(n)}orphanQuestionReply(n){return this.b.orphanQuestionReply(n)}installAutoReply(n,r){return this.b.installAutoReply(n,r)}uninstallAllAutoReplies(){return this.b.uninstallAllAutoReplies()}uninstallAutoReply(n){return this.b.uninstallAutoReply(n)}getDefaultSystemShell(n){return this.b.getDefaultSystemShell(n)}async getProfiles(n,r,t,i=!1){const s=await this.c;return(0,a.detectAvailableProfiles)(r,t,i,this.F,s,void 0,this.H,this.W.bind(this,n))}getEnvironment(){return this.b.getEnvironment()}getWslPath(n,r){return this.b.getWslPath(n,r)}getRevivedPtyNewId(n){return this.b.getRevivedPtyNewId(n)}setTerminalLayoutInfo(n){return this.b.setTerminalLayoutInfo(n)}async getTerminalLayoutInfo(n){return await this.b.getTerminalLayoutInfo(n)}async requestDetachInstance(n,r){return this.b.requestDetachInstance(n,r)}async acceptDetachInstanceReply(n,r){return this.b.acceptDetachInstanceReply(n,r)}async freePortKillProcess(n){if(!this.b.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.b.freePortKillProcess(n)}async serializeTerminalState(n){return this.b.serializeTerminalState(n)}async reviveTerminalProcesses(n,r){return this.b.reviveTerminalProcesses(n,r)}async refreshProperty(n,r){return this.b.refreshProperty(n,r)}async updateProperty(n,r,t){return this.b.updateProperty(n,r,t)}async restartPtyHost(){this.h=!0,this.O(),[this.a,this.b]=this.N()}O(){this.b.shutdownAll?.(),this.a.dispose()}P(){this.U(),this.j=setTimeout(()=>this.Q(),m.HeartbeatConstants.BeatInterval*m.HeartbeatConstants.FirstWaitMultiplier),this.h||(this.h=!0,this.p.fire())}Q(){this.H.warn(`No ptyHost heartbeat after ${m.HeartbeatConstants.BeatInterval*m.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.j=void 0,this.k=setTimeout(()=>this.R(),m.HeartbeatConstants.BeatInterval*m.HeartbeatConstants.SecondWaitMultiplier)}R(){this.H.error(`No ptyHost heartbeat after ${(m.HeartbeatConstants.BeatInterval*m.HeartbeatConstants.FirstWaitMultiplier+m.HeartbeatConstants.BeatInterval*m.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.k=void 0,this.h&&(this.h=!1,this.n.fire())}S(){this.U(),this.H.error(`No ptyHost response to createProcess after ${m.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.h&&(this.h=!1,this.n.fire())}U(){this.j&&(clearTimeout(this.j),this.j=void 0),this.k&&(clearTimeout(this.k),this.k=void 0)}W(n,r){return this.f.createRequest({workspaceId:n,originalText:r})}async acceptPtyHostResolvedVariables(n,r){this.f.acceptReply(n,r)}};v=ye([G(2,I.IConfigurationService),G(3,w.IEnvironmentService),G(4,p.ILogService),G(5,p.ILoggerService)],v),e.PtyHostService=v}),define(re[78],oe([0,1,3,17,5,9]),function(te,e,O,U,l,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,l.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,l.createDecorator)("sharedTunnelsService");var N;(function(E){E.Http="http",E.Https="https"})(N=e.TunnelProtocol||(e.TunnelProtocol={}));var R;(function(E){E.ConstantPrivate="constantPrivate",E.Private="private",E.Public="public"})(R=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var I;(function(E){E[E.Notify=1]="Notify",E[E.OpenBrowser=2]="OpenBrowser",E[E.OpenPreview=3]="OpenPreview",E[E.Silent=4]="Silent",E[E.Ignore=5]="Ignore",E[E.OpenBrowserOnce=6]="OpenBrowserOnce"})(I=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function w(E){if(E.scheme!=="http"&&E.scheme!=="https")return;const a=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(E.authority);if(!!a)return{address:a[1],port:+a[2]}}e.extractLocalHostUriMetaDataForPortMapping=w,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function P(E){return e.LOCALHOST_ADDRESSES.indexOf(E)>=0}e.isLocalhost=P,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function S(E){return e.ALL_INTERFACES_ADDRESSES.indexOf(E)>=0}e.isAllInterfaces=S;function p(E,a,u,h){if(u===1)return!1;if(u===2&&S(a)){const d=/(\d+)\.(\d+)\.(\d+)/g.exec(h);if(d?.length===4&&parseInt(d[1])>=18)return!1}return E<1024}e.isPortPrivileged=p;class f{constructor(a,u,h){this.remoteAddress=a,this.localAddress=u,this.b=h,this.a=new O.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=f;let m=class{constructor(a,u){this.i=a,this.j=u,this.a=new O.Emitter,this.onTunnelOpened=this.a.event,this.b=new O.Emitter,this.onTunnelClosed=this.b.event,this.c=new O.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const a=this.j.getValue("remote.localPortHost");return!a||a==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(a){return this.e=a,a?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(a){this.f=a.elevation,this.g=a.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const a=[],u=Array.from(this.d.values());for(const h of u){const d=Array.from(h.values());for(const v of d){const L=await v.value;L&&a.push(L)}}return a}async dispose(){for(const a of this.d.values()){for(const{value:u}of a.values())await u.then(h=>h?.dispose());a.clear()}this.d.clear()}setEnvironmentTunnel(a,u,h,d,v){this.o(a,u,Promise.resolve({tunnelRemoteHost:a,tunnelRemotePort:u,localAddress:h,privacy:d,protocol:v,dispose:()=>Promise.resolve()}))}async getExistingTunnel(a,u){(S(a)||P(a))&&(a=e.LOCALHOST_ADDRESSES[0]);const h=this.q(a,u);if(h)return++h.refcount,h.value}openTunnel(a,u,h,d,v,L=!1,n,r){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${h} on local port ${v}.`),!a)return;if(u||(u="localhost"),d||(d=this.k),this.e&&this.h.has(h)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const t=this.r(a,u,h,d,v,L,n,r);return t?t.then(i=>{if(!i){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(u,h);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.m(i);return(i.tunnelRemoteHost!==u||i.tunnelRemotePort!==h)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(s),s}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),t)}m(a){return{tunnelRemotePort:a.tunnelRemotePort,tunnelRemoteHost:a.tunnelRemoteHost,tunnelLocalPort:a.tunnelLocalPort,localAddress:a.localAddress,privacy:a.privacy,protocol:a.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${a.tunnelRemoteHost}:${a.tunnelRemotePort} `);const u=this.d.get(a.tunnelRemoteHost);if(u){const h=u.get(a.tunnelRemotePort);h&&(h.refcount--,await this.n(a.tunnelRemoteHost,a.tunnelRemotePort,h))}}}}async n(a,u,h){if(h.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${a}:${u}.`);const d=h.value.then(async v=>{v&&(await v.dispose(!0),this.b.fire({host:v.tunnelRemoteHost,port:v.tunnelRemotePort}))});return this.d.has(a)&&this.d.get(a).delete(u),d}}async closeTunnel(a,u){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${a}:${u} `);const h=this.d.get(a);if(h&&h.has(u)){const d=h.get(u);d.refcount=0,await this.n(a,u,d)}}o(a,u,h){this.d.has(a)||this.d.set(a,new Map),this.d.get(a).set(u,{refcount:1,value:h})}async p(a,u){const h=this.d.get(a);h&&(await h.get(u)||h.delete(u),h.size===0&&this.d.delete(a))}q(a,u){const h=[a];P(a)?(h.push(...e.LOCALHOST_ADDRESSES),h.push(...e.ALL_INTERFACES_ADDRESSES)):S(a)&&h.push(...e.ALL_INTERFACES_ADDRESSES);const d=h.map(v=>this.d.get(v));for(const v of d){const L=v?.get(u);if(L)return L}}canTunnel(a){return!!w(a)}s(a,u,h,d,v,L,n){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${h} on local port ${d}.`);const r=h;this.h.add(r);const t=d===void 0?h:d,i={elevationRequired:v?this.isPortPrivileged(t):!1},s={remoteAddress:{host:u,port:h},localAddressPort:d,privacy:L,public:L?L!==R.Private:void 0,protocol:n},o=a.forwardPort(s,i);return o?(this.o(u,h,o),o.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(r)})):this.h.delete(r),o}};m=ye([G(0,T.ILogService),G(1,U.IConfigurationService)],m),e.AbstractTunnelService=m}),define(re[252],oe([0,1,9,78,2,10,6]),function(te,e,O,U,l,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class R extends l.Disposable{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new N.DeferredPromise),this.b.p)}setAddress(P){this.a=P,this.b&&(this.b.complete(P),this.b=null)}setTunnel(P){this.D(P)}}let I=class Dt extends l.Disposable{constructor(P,S){super(),this.f=P,this.g=S,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(P=>P.dispose())}async createTunnel(){return{id:String(++Dt.a)}}async startTunnel(P,S,p,f,m,E,a){const u=new R,h=await Promise.resolve(this.f.openTunnel(P,u,p,f,m,E,a));if(!h)throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${p}:${f} (remote).`),u.dispose(),new Error("Could not create tunnel");if(this.c.has(S))throw this.c.delete(S),u.dispose(),await h.dispose(),(0,T.canceled)();return u.setTunnel(h),this.b.set(S,u),this.g.info(`[SharedProcessTunnelService] Created tunnel ${S}: ${h.localAddress} (local) to ${p}:${f} (remote).`),{tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress}}async setAddress(P,S){const p=this.b.get(P);!p||p.setAddress(S)}async destroyTunnel(P){const S=this.b.get(P);if(S){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${P}.`),this.b.delete(P),await S.dispose();return}this.c.add(P)}};I.a=0,I=ye([G(0,U.ISharedTunnelsService),G(1,O.ILogService)],I),e.SharedProcessTunnelService=I}),define(re[30],oe([0,1,5]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,O.createDecorator)("IUriIdentityService")}),define(re[253],oe([0,1,30,198,14,23,132,3,2]),function(te,e,O,U,l,T,N,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class w{constructor(p){this.uri=p,this.time=w._clock++}touch(){return this.time=w._clock++,this}}w._clock=0;let P=class{constructor(p){this.g=p,this.c=new I.DisposableStore,this.f=2**16;const f=new Map,m=E=>{let a=f.get(E.scheme);return a===void 0&&(a=p.hasProvider(E)&&!this.g.hasCapability(E,1024),f.set(E.scheme,a)),a};this.c.add(R.Event.any(p.onDidChangeFileSystemProviderRegistrations,p.onDidChangeFileSystemProviderCapabilities)(E=>{f.delete(E.scheme)})),this.extUri=new T.ExtUri(m),this.d=new N.SkipList((E,a)=>this.extUri.compare(E,a,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(p){this.g.hasProvider(p)&&(p=(0,T.normalizePath)(p));const f=this.d.get(p);return f?f.touch().uri.with({fragment:p.fragment}):(this.d.set(p,new w(p)),this.h(),p)}h(){if(this.d.size<this.f)return;const p=[...this.d.entries()].sort((m,E)=>m[1].time<E[1].time?1:m[1].time>E[1].time?-1:0);w._clock=0,this.d.clear();const f=this.f*.5;for(let m=0;m<f;m++)this.d.set(p[m][0],p[m][1].touch())}};P=ye([G(0,l.IFileService)],P),e.UriIdentityService=P,(0,U.registerSingleton)(O.IUriIdentityService,P,1)}),define(re[254],oe([0,1,3,2,14,43,49,16]),function(te,e,O,U,l,T,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class I extends U.Disposable{get capabilities(){return this.f.capabilities&-5}constructor(P,S,p,f){super(),this.c=P,this.f=S,this.g=p,this.h=f,this.onDidChangeCapabilities=this.f.onDidChangeCapabilities,this.a=this.D(new O.Emitter),this.onDidChangeFile=this.a.event,this.b=N.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this.D(this.f.onDidChangeFile(m=>this.i(m)))}watch(P,S){this.b.set(P,P);const p=this.f.watch(this.j(P),S);return(0,U.toDisposable)(()=>{this.b.delete(P),p.dispose()})}stat(P){return this.f.stat(this.j(P))}mkdir(P){return this.f.mkdir(this.j(P))}rename(P,S,p){return this.f.rename(this.j(P),this.j(S),p)}readFile(P){return this.f.readFile(this.j(P),{atomic:!0})}readFileStream(P,S,p){const f=(0,T.newWriteableStream)(m=>R.VSBuffer.concat(m.map(E=>R.VSBuffer.wrap(E))).buffer);return(async()=>{try{const m=await this.readFile(P);f.end(m)}catch(m){f.error(m),f.end()}})(),f}readdir(P){return this.f.readdir(this.j(P))}writeFile(P,S,p){return this.f.writeFile(this.j(P),S,p)}delete(P,S){return this.f.delete(this.j(P),S)}copy(P,S,p){if((0,l.hasFileFolderCopyCapability)(this.f))return this.f.copy(this.j(P),this.j(S),p);throw new Error("copy not supported")}i(P){const S=[];for(const p of P){if(p.resource.scheme!==this.c)continue;const f=this.k(p.resource);this.b.findSubstr(f)&&S.push({resource:f,type:p.type})}S.length&&(this.h.debug("User data changed"),this.a.fire(S))}j(P){return P.with({scheme:this.c})}k(P){return P.with({scheme:this.g})}}e.FileUserDataProvider=I}),define(re[60],oe([0,1,85]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function U(N,R,I,w){const P=(0,O.setProperty)(N,R,I,w)[0];return P&&(N=N.substring(0,P.offset)+P.content+N.substring(P.offset+P.length)),N}e.edit=U;function l(N,R,I){let w=I;for(;w>=0;){if(N.charAt(w)===R.charAt(R.length-1)&&R.length===1)return w+1;if(w--,R.length===2&&w>=0&&N.charAt(w)===R.charAt(0))return w+2}return 0}e.getLineStartOffset=l;function T(N,R,I){let w=I;for(;w>=0;)if(N.charAt(w)===R.charAt(R.length-1)&&R.length===1||(w++,R.length===2&&w>=0&&N.charAt(w)===R.charAt(1)))return w;return N.length-1}e.getLineEndOffset=T}),define(re[255],oe([0,1,32,55,12]),function(te,e,O,U,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function T(f,m,E,a,u,h){const d=[],v=[],L=[];if(!m){const V=f.filter(({identifier:B})=>u.every(Z=>Z.toLowerCase()!==B.id.toLowerCase()));return{local:{added:d,removed:v,updated:L},remote:V.length>0?{added:V,updated:[],removed:[],all:V}:null}}f=f.map(S),m=m.map(S),E=E?E.map(S):null;const n=new Map,r=V=>{V.uuid&&n.set(V.id.toLowerCase(),V.uuid)};f.forEach(({identifier:V})=>r(V)),m.forEach(({identifier:V})=>r(V)),E?.forEach(({identifier:V})=>r(V));const t=V=>{const B=V.identifier.uuid||n.get(V.identifier.id.toLowerCase());return B?`uuid:${B}`:`id:${V.identifier.id.toLowerCase()}`},i=(V,B)=>(V.set(t(B),B),V),s=f.reduce(i,new Map),o=m.reduce(i,new Map),c=m.reduce((V,B)=>i(V,(0,O.deepClone)(B)),new Map),y=E?E.reduce(i,new Map):null,b=a.reduce(i,new Map),g=u.reduce((V,B)=>{const Z=n.get(B.toLowerCase());return V.add(Z?`uuid:${Z}`:`id:${B.toLowerCase()}`)},new Set),D=h?h.reduce((V,{id:B,uuid:Z})=>(Z=Z??n.get(B.toLowerCase()),V.add(Z?`uuid:${Z}`:`id:${B.toLowerCase()}`)),new Set):null,A=N(s,o,g,!1);if(A.added.size>0||A.removed.size>0||A.updated.size>0){const V=N(y,s,g,!1),B=N(y,o,g,!0),Z=(J,K,Y,H)=>{let $,X,ie;return K.installed?($=H.pinned,ie=H.preRelease,$&&(X=H.version)):($=Y.pinned,ie=Y.preRelease,$&&(X=Y.version)),$===void 0&&($=K.pinned,$&&(X=K.version)),ie===void 0&&(ie=K.preRelease),{...H,installed:K.installed||Y.installed,pinned:$,preRelease:ie,version:X??(Y.version&&(!K.installed||U.gt(Y.version,K.version))?Y.version:K.version),state:I(K,Y,y?.get(J))}};for(const J of B.removed.values()){const K=s.get(J);if(!K)continue;const Y=(0,l.assertIsDefined)(y?.get(J)),H=D&&!D.has(J)&&Y.installed;K.installed&&H?v.push(K.identifier):c.set(J,K)}for(const J of B.added.values()){const K=(0,l.assertIsDefined)(o.get(J)),Y=s.get(J);if(Y){if(A.updated.has(J)){const H=Z(J,Y,K,K);R(Y,K,!1,!1)||L.push(p(H,J)),c.set(J,H)}}else K.installed&&d.push(p(K,J))}for(const J of B.updated.values()){const K=(0,l.assertIsDefined)(o.get(J)),Y=(0,l.assertIsDefined)(y?.get(J)),H=s.get(J);if(H)if(D&&!D.has(J)&&Y.installed&&H.installed&&!K.installed)v.push(H.identifier);else{const X=Z(J,H,K,K);L.push(p(X,J)),c.set(J,X)}else K.installed&&d.push(p(K,J))}for(const J of V.added.values())B.added.has(J)||c.set(J,(0,l.assertIsDefined)(s.get(J)));for(const J of V.updated.values()){if(B.removed.has(J)||B.updated.has(J))continue;const K=(0,l.assertIsDefined)(s.get(J)),Y=(0,l.assertIsDefined)(o.get(J));c.set(J,Z(J,K,Y,K))}for(const J of V.removed.values())B.updated.has(J)||B.removed.has(J)||b.has(J)||!(0,l.assertIsDefined)(o.get(J)).installed||!D||D.has(J)||!(0,l.assertIsDefined)(y?.get(J)).installed||c.delete(J)}const F=[],j=N(o,c,new Set,!0),x=j.added.size>0||j.updated.size>0||j.removed.size>0;return x&&c.forEach((V,B)=>F.push(p(V,B))),{local:{added:d,removed:v,updated:L},remote:x?{added:[...j.added].map(V=>c.get(V)),updated:[...j.updated].map(V=>c.get(V)),removed:[...j.removed].map(V=>o.get(V)),all:F}:null}}e.merge=T;function N(f,m,E,a){const u=f?[...f.keys()].filter(n=>!E.has(n)):[],h=[...m.keys()].filter(n=>!E.has(n)),d=h.filter(n=>u.indexOf(n)===-1).reduce((n,r)=>(n.add(r),n),new Set),v=u.filter(n=>h.indexOf(n)===-1).reduce((n,r)=>(n.add(r),n),new Set),L=new Set;for(const n of u){if(v.has(n))continue;const r=f.get(n),t=m.get(n);(!t||!R(r,t,a,!0))&&L.add(n)}return{added:d,removed:v,updated:L}}function R(f,m,E,a){return!(f.disabled!==m.disabled||a&&f.installed!==m.installed||f.installed&&m.installed&&(f.preRelease!==m.preRelease||f.pinned!==m.pinned||m.pinned&&f.version!==m.version)||!P(f.state,m.state)||E&&f.version!==m.version)}function I(f,m,E){const a=f.state,u=m.state,h=E?.state;if(!m.version||a&&U.gt(f.version,m.version))return a;if(u&&U.gt(m.version,f.version)||!a)return u;if(!u)return a;const d=(0,O.deepClone)(a),v=h?w(h,u):{added:Object.keys(u).reduce((n,r)=>(n.add(r),n),new Set),removed:new Set,updated:new Set},L=h?w(h,a):{added:Object.keys(a).reduce((n,r)=>(n.add(r),n),new Set),removed:new Set,updated:new Set};for(const n of[...v.added.values(),...v.updated.values()])d[n]=u[n];for(const n of v.removed.values())L.updated.has(n)||delete d[n];return d}function w(f,m){const E=Object.keys(f),a=Object.keys(m),u=a.filter(v=>E.indexOf(v)===-1).reduce((v,L)=>(v.add(L),v),new Set),h=E.filter(v=>a.indexOf(v)===-1).reduce((v,L)=>(v.add(L),v),new Set),d=new Set;for(const v of E){if(h.has(v))continue;const L=f[v],n=m[v];(0,O.equals)(L,n)||d.add(v)}return{added:u,removed:h,updated:d}}function P(f={},m={}){const{added:E,removed:a,updated:u}=w(f,m);return E.size===0&&a.size===0&&u.size===0}function S(f){return{...f,disabled:!!f.disabled,installed:!!f.installed}}function p(f,m){const E={identifier:{id:f.identifier.id,uuid:m.startsWith("uuid:")?m.substring(5):void 0},version:f.version,preRelease:!!f.preRelease,pinned:!!f.pinned};return f.disabled&&(E.disabled=!0),f.installed&&(E.installed=!0),f.state&&(E.state=f.state),E}}),define(re[118],oe([0,1,21,17,5]),function(te,e,O,U,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,l.createDecorator)("IIgnoredExtensionsManagementService");let T=class{constructor(R){this.a=R}hasToNeverSyncExtension(R){return this.b().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.b().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,I){let w=[...this.a.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return w=w.filter(P=>P!==R&&P!==`-${R}`),I&&w.push(R.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",w.length?w:void 0,2)}updateSynchronizedExtensions(R,I){let w=[...this.a.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return w=w.filter(P=>P!==R&&P!==`-${R}`),I&&w.push(`-${R.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",w.length?w:void 0,2)}getIgnoredExtensions(R){const I=R.filter(p=>p.isMachineScoped).map(p=>p.identifier.id.toLowerCase()),w=this.b().map(p=>p.toLowerCase()),P=[],S=[];if(Array.isArray(w))for(const p of w)p.startsWith("-")?S.push(p.substring(1)):P.push(p);return(0,O.distinct)([...I,...P].filter(p=>S.indexOf(p)===-1))}b(){let R=this.a.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.a.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(I=>I.toLowerCase())}};T=ye([G(0,U.IConfigurationService)],T),e.IgnoredExtensionsManagementService=T}),define(re[256],oe([0,1,21,35,32,70,60]),function(te,e,O,U,l,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function R(v){return(0,U.parse)(v)||[]}async function I(v,L,n,r,t){const i=R(v),s=R(L),o=n?R(n):null,c=[...i,...s,...o||[]].map(Z=>Z.key),y=await t.resolveUserBindings(c),b=P(i,s,o,y);if(!b.hasLocalForwarded&&!b.hasRemoteForwarded)return{mergeContent:v,hasChanges:!1,hasConflicts:!1};if(!b.hasLocalForwarded&&b.hasRemoteForwarded)return{mergeContent:L,hasChanges:!0,hasConflicts:!1};if(b.hasLocalForwarded&&!b.hasRemoteForwarded)return{mergeContent:v,hasChanges:!0,hasConflicts:!1};const g=p(i),D=p(s),A=o?p(o):null,F=m(g,D,y),j=A?m(A,g,y):{added:[...g.keys()].reduce((Z,J)=>(Z.add(J),Z),new Set),removed:new Set,updated:new Set},x=A?m(A,D,y):{added:[...D.keys()].reduce((Z,J)=>(Z.add(J),Z),new Set),removed:new Set,updated:new Set},V=w(F,j,x);let B=v;for(const Z of V.removed.values())V.conflicts.has(Z)||(B=h(B,Z,r));for(const Z of V.added.values()){if(V.conflicts.has(Z))continue;const J=D.get(Z);if(J.some(K=>K.command!==`-${Z}`&&b.conflicts.has(y[K.key]))){V.conflicts.add(Z);continue}B=u(B,J,r)}for(const Z of V.updated.values()){if(V.conflicts.has(Z))continue;const J=D.get(Z);if(J.some(K=>K.command!==`-${Z}`&&b.conflicts.has(y[K.key]))){V.conflicts.add(Z);continue}B=d(B,Z,J,r)}return{mergeContent:B,hasChanges:!0,hasConflicts:V.conflicts.size>0}}e.merge=I;function w(v,L,n){const r=new Set,t=new Set,i=new Set,s=new Set;for(const o of L.removed.values())n.updated.has(o)&&s.add(o);for(const o of n.removed.values())s.has(o)||(L.updated.has(o)?s.add(o):t.add(o));for(const o of L.added.values())s.has(o)||n.added.has(o)&&v.updated.has(o)&&s.add(o);for(const o of n.added.values())s.has(o)||(L.added.has(o)?v.updated.has(o)&&s.add(o):r.add(o));for(const o of L.updated.values())s.has(o)||n.updated.has(o)&&v.updated.has(o)&&s.add(o);for(const o of n.updated.values())s.has(o)||(L.updated.has(o)?v.updated.has(o)&&s.add(o):i.add(o));return{added:r,removed:t,updated:i,conflicts:s}}function P(v,L,n,r){const t=new Set,i=S(v,r),s=S(L,r),o=n?S(n,r):null,c=f(i,s);if(c.added.size===0&&c.removed.size===0&&c.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const y=o?f(o,i):{added:[...i.keys()].reduce((j,x)=>(j.add(x),j),new Set),removed:new Set,updated:new Set};if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:t,removed:t,updated:t,conflicts:t};const b=o?f(o,s):{added:[...s.keys()].reduce((j,x)=>(j.add(x),j),new Set),removed:new Set,updated:new Set};if(b.added.size===0&&b.removed.size===0&&b.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const{added:g,removed:D,updated:A,conflicts:F}=w(c,y,b);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:g,removed:D,updated:A,conflicts:F}}function S(v,L){const n=new Map;for(const r of v){const t=L[r.key];let i=n.get(t);i||(i=[],n.set(t,i)),i.push(r)}return n}function p(v){const L=new Map;for(const n of v){const r=n.command[0]==="-"?n.command.substring(1):n.command;let t=L.get(r);t||(t=[],L.set(r,t)),t.push(n)}return L}function f(v,L){const n=[...v.keys()],r=[...L.keys()],t=r.filter(o=>n.indexOf(o)===-1).reduce((o,c)=>(o.add(c),o),new Set),i=n.filter(o=>r.indexOf(o)===-1).reduce((o,c)=>(o.add(c),o),new Set),s=new Set;for(const o of n){if(i.has(o))continue;const c=v.get(o).map(b=>({...b,key:o})),y=L.get(o).map(b=>({...b,key:o}));(0,O.equals)(c,y,(b,g)=>a(b,g))||s.add(o)}return{added:t,removed:i,updated:s}}function m(v,L,n){const r=[...v.keys()],t=[...L.keys()],i=t.filter(c=>r.indexOf(c)===-1).reduce((c,y)=>(c.add(y),c),new Set),s=r.filter(c=>t.indexOf(c)===-1).reduce((c,y)=>(c.add(y),c),new Set),o=new Set;for(const c of r){if(s.has(c))continue;const y=v.get(c).map(g=>({...g,key:n[g.key]})),b=L.get(c).map(g=>({...g,key:n[g.key]}));E(y,b)||o.add(c)}return{added:i,removed:s,updated:o}}function E(v,L){return!(!(0,O.equals)(v.filter(({command:n})=>n[0]!=="-"),L.filter(({command:n})=>n[0]!=="-"),(n,r)=>a(n,r))||!(0,O.equals)(v.filter(({command:n})=>n[0]==="-"),L.filter(({command:n})=>n[0]==="-"),(n,r)=>a(n,r)))}function a(v,L){if(v.command!==L.command||v.key!==L.key)return!1;const n=T.ContextKeyExpr.deserialize(v.when),r=T.ContextKeyExpr.deserialize(L.when);return!(n&&!r||!n&&r||n&&r&&!n.equals(r)||!l.equals(v.args,L.args))}function u(v,L,n){for(const r of L)v=N.edit(v,[-1],r,n);return v}function h(v,L,n){const r=R(v);for(let t=r.length-1;t>=0;t--)(r[t].command===L||r[t].command===`-${L}`)&&(v=N.edit(v,[t],void 0,n));return v}function d(v,L,n,r){const t=R(v),i=t.findIndex(s=>s.command===L||s.command===`-${L}`);for(let s=t.length-1;s>=0;s--)(t[s].command===L||t[s].command===`-${L}`)&&(v=N.edit(v,[s],void 0,r));for(let s=n.length-1;s>=0;s--)v=N.edit(v,[i],n[s],r);return v}}),define(re[257],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function O(T,N,R){const I={},w={},P=new Set;if(!N)return{local:{added:I,updated:w,removed:[...P.values()]},remote:{added:T,updated:{},removed:[]},conflicts:[]};const S=U(T,N);if(S.added.size===0&&S.removed.size===0&&S.updated.size===0)return{local:{added:I,updated:w,removed:[...P.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const p=U(R,T),f=U(R,N),m={},E={},a=new Set,u=new Set;for(const h of p.removed.values())f.updated.has(h)?I[h]=N[h]:a.add(h);for(const h of f.removed.values())u.has(h)||(p.updated.has(h)?u.add(h):P.add(h));for(const h of p.updated.values())u.has(h)||(f.updated.has(h)?S.updated.has(h)&&u.add(h):E[h]=T[h]);for(const h of f.updated.values())u.has(h)||(p.updated.has(h)?S.updated.has(h)&&u.add(h):T[h]!==void 0&&(w[h]=N[h]));for(const h of p.added.values())u.has(h)||(f.added.has(h)?S.updated.has(h)&&u.add(h):m[h]=T[h]);for(const h of f.added.values())u.has(h)||(p.added.has(h)?S.updated.has(h)&&u.add(h):I[h]=N[h]);return{local:{added:I,removed:[...P.values()],updated:w},remote:{added:m,removed:[...a.values()],updated:E},conflicts:[...u.values()]}}e.merge=O;function U(T,N){const R=T?Object.keys(T):[],I=N?Object.keys(N):[],w=I.filter(p=>R.indexOf(p)===-1).reduce((p,f)=>(p.add(f),p),new Set),P=R.filter(p=>I.indexOf(p)===-1).reduce((p,f)=>(p.add(f),p),new Set),S=new Set;for(const p of R){if(P.has(p))continue;const f=T[p],m=N[p];f!==m&&S.add(p)}return{added:w,removed:P,updated:S}}function l(T,N){const{added:R,removed:I,updated:w}=U(T,N);return R.size===0&&I.size===0&&w.size===0}e.areSame=l}),define(re[258],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function O(l,T,N,R){const I={added:[],removed:[],updated:[]};let w={added:[],removed:[],updated:[]};if(!T){const S=l.filter(({id:p})=>!R.includes(p));return S.length?w.added=S:w=null,{local:I,remote:w}}const P=U(l,T,R);if(P.added.length>0||P.removed.length>0||P.updated.length>0){const S=U(N,l,R),p=U(N,T,R);for(const f of p.removed){const m=l.find(E=>E.id===f);m&&I.removed.push(m)}for(const f of p.added){const m=T.find(E=>E.id===f);S.added.includes(f)?P.updated.includes(f)&&I.updated.push(m):I.added.push(m)}for(const f of p.updated)I.updated.push(T.find(m=>m.id===f));for(const f of S.added)p.added.includes(f)||w.added.push(l.find(m=>m.id===f));for(const f of S.updated)p.removed.includes(f)||p.updated.includes(f)||w.updated.push(l.find(m=>m.id===f));for(const f of S.removed){const m=T.find(E=>E.id===f);m&&w.removed.push(m)}}return w.added.length===0&&w.removed.length===0&&w.updated.length===0&&(w=null),{local:I,remote:w}}e.merge=O;function U(l,T,N){l=l?l.filter(({id:p})=>!N.includes(p)):[],T=T.filter(({id:p})=>!N.includes(p));const R=l.map(({id:p})=>p),I=T.map(({id:p})=>p),w=I.filter(p=>R.indexOf(p)===-1),P=R.filter(p=>I.indexOf(p)===-1),S=[];for(const{id:p,name:f,shortName:m}of l){if(P.includes(p))continue;const E=T.find(a=>a.id===p);(!E||E.name!==f||E.shortName!==m)&&S.push(p)}return{added:w,removed:P,updated:S}}}),define(re[24],oe([0,1,21,12,185,45,29,5,108,40]),function(te,e,O,U,l,T,N,R,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.USER_DATA_SYNC_LOG_ID=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncResourceProviderService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.getPathSegments=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function P(){const s=w.Registry.as(T.Extensions.Configuration).getConfigurationProperties();return Object.keys(s).filter(o=>!!s[o].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=P;function S(){const s=w.Registry.as(T.Extensions.Configuration).getConfigurationProperties(),o=Object.keys(s).filter(b=>!!s[b].ignoreSync),c=Object.keys(s).filter(b=>s[b].scope===2||s[b].scope===6),y=P();return(0,O.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...o,...c,...y])}e.getDefaultIgnoredSettings=S,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync",e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM="settingsSync.keybindingsPerPlatform";function p(){const s="vscode://schemas/ignoredSettings",o=w.Registry.as(T.Extensions.Configuration);o.registerConfiguration({id:"settingsSync",order:30,title:(0,l.localize)(0,null),type:"object",properties:{[e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM]:{type:"boolean",description:(0,l.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,l.localize)(2,null),items:[{type:"string",pattern:N.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,l.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,l.localize)(4,null),default:[],scope:1,$ref:s,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const c=w.Registry.as(I.Extensions.JSONContribution),y=()=>{const b=P(),g=S().filter(j=>j!==e.CONFIGURATION_SYNC_STORE_KEY),D=Object.keys(T.allSettings.properties).filter(j=>g.indexOf(j)===-1),A=g.filter(j=>b.indexOf(j)===-1),F={items:{type:"string",enum:[...D,...A.map(j=>`-${j}`)]}};c.registerSchema(s,F)};return o.onDidUpdateConfiguration(()=>y())}e.registerConfiguration=p;function f(s){return s&&(0,U.isObject)(s)&&(0,U.isString)(s.id)&&Array.isArray(s.scopes)}e.isAuthenticationProvider=f;var m;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState",s.Profiles="profiles"})(m=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function E(s,...o){return s?[s,...o]:o}e.getPathSegments=E;function a(s,o,c,y){return y.joinPath(c.userDataSyncHome,...E(s,o,`lastSync${o}.json`))}e.getLastSyncResourceUri=a,e.IUserDataSyncStoreManagementService=(0,R.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,R.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,R.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function u(s){const o={};return o[e.HEADER_EXECUTION_ID]=s,o}e.createSyncHeaders=u;var h;(function(s){s.Unauthorized="Unauthorized",s.NotFound="NotFound",s.MethodNotFound="MethodNotFound",s.Conflict="Conflict",s.Gone="Gone",s.PreconditionFailed="PreconditionFailed",s.TooLarge="TooLarge",s.UpgradeRequired="UpgradeRequired",s.PreconditionRequired="PreconditionRequired",s.TooManyRequests="RemoteTooManyRequests",s.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",s.RequestFailed="RequestFailed",s.RequestCanceled="RequestCanceled",s.RequestTimeout="RequestTimeout",s.RequestProtocolNotSupported="RequestProtocolNotSupported",s.RequestPathNotEscaped="RequestPathNotEscaped",s.RequestHeadersNotObject="RequestHeadersNotObject",s.NoCollection="NoCollection",s.NoRef="NoRef",s.EmptyResponse="EmptyResponse",s.TurnedOff="TurnedOff",s.SessionExpired="SessionExpired",s.ServiceChanged="ServiceChanged",s.DefaultServiceChanged="DefaultServiceChanged",s.LocalTooManyProfiles="LocalTooManyProfiles",s.LocalTooManyRequests="LocalTooManyRequests",s.LocalPreconditionFailed="LocalPreconditionFailed",s.LocalInvalidContent="LocalInvalidContent",s.LocalError="LocalError",s.IncompatibleLocalContent="IncompatibleLocalContent",s.IncompatibleRemoteContent="IncompatibleRemoteContent",s.Unknown="Unknown"})(h=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class d extends Error{constructor(o,c,y,b){super(o),this.code=c,this.resource=y,this.operationId=b,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=d;class v extends d{constructor(o,c,y,b,g){super(o,y,void 0,g),this.url=c,this.serverCode=b}}e.UserDataSyncStoreError=v;class L extends d{constructor(o,c){super(o,c)}}e.UserDataAutoSyncError=L,function(s){function o(c){if(c instanceof s)return c;const y=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(c.name);if(y&&y[1]){const b=y[2]==="unknown"?void 0:y[2],g=y[3]==="unknown"?void 0:y[3];return new s(c.message,y[1],b,g)}return new s(c.message,"Unknown")}s.toUserDataSyncError=o}(d=e.UserDataSyncError||(e.UserDataSyncError={}));var n;(function(s){s.Uninitialized="uninitialized",s.Idle="idle",s.Syncing="syncing",s.HasConflicts="hasConflicts"})(n=e.SyncStatus||(e.SyncStatus={}));var r;(function(s){s[s.None=0]="None",s[s.Added=1]="Added",s[s.Modified=2]="Modified",s[s.Deleted=3]="Deleted"})(r=e.Change||(e.Change={}));var t;(function(s){s.Preview="preview",s.Conflict="conflict",s.Accepted="accepted"})(t=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function i(s){return`sync.enable.${s}`}e.getEnablementKey=i,e.IUserDataSyncEnablementService=(0,R.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,R.createDecorator)("IUserDataSyncService"),e.IUserDataSyncResourceProviderService=(0,R.createDecorator)("IUserDataSyncResourceProviderService"),e.IUserDataAutoSyncService=(0,R.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,R.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,R.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_LOG_ID="userDataSync",e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview"}),define(re[259],oe([0,1,32,24]),function(te,e,O,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function l(N,R,I,w,P){if(!R)return{remote:{added:Object.keys(N),removed:[],updated:[],all:Object.keys(N).length>0?N:null},local:{added:{},removed:[],updated:{}}};const S=T(N,R);if(S.added.size===0&&S.removed.size===0&&S.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const p=I?T(I,R):{added:Object.keys(R).reduce((h,d)=>(h.add(d),h),new Set),removed:new Set,updated:new Set},f=I?T(I,N):{added:Object.keys(N).reduce((h,d)=>(h.add(d),h),new Set),removed:new Set,updated:new Set},m={added:{},removed:[],updated:{}},E=O.deepClone(R),a=!I;for(const h of f.added.values())h!==U.SYNC_SERVICE_URL_TYPE&&a&&p.added.has(h)||(E[h]=N[h]);for(const h of f.updated.values())E[h]=N[h];for(const h of f.removed.values())w.unregistered.includes(h)||delete E[h];for(const h of p.added.values()){const d=R[h];if(w.machine.includes(h)){P.info(`GlobalState: Skipped adding ${h} in local storage because it is declared as machine scoped.`);continue}if(I&&f.added.has(h))continue;const v=N[h];v&&v.value===d.value||h===U.SYNC_SERVICE_URL_TYPE&&a&&f.added.has(h)||(v?m.updated[h]=d:m.added[h]=d)}for(const h of p.updated.values()){const d=R[h];if(w.machine.includes(h)){P.info(`GlobalState: Skipped updating ${h} in local storage because it is declared as machine scoped.`);continue}if(f.updated.has(h)||f.removed.has(h))continue;const v=N[h];v&&v.value===d.value||(m.updated[h]=d)}for(const h of p.removed.values()){if(w.machine.includes(h)){P.trace(`GlobalState: Skipped removing ${h} in local storage because it is declared as machine scoped.`);continue}f.updated.has(h)||f.removed.has(h)||m.removed.push(h)}const u=T(R,E);return{local:m,remote:{added:[...u.added],updated:[...u.updated],removed:[...u.removed],all:u.added.size===0&&u.removed.size===0&&u.updated.size===0?null:E}}}e.merge=l;function T(N,R){const I=Object.keys(N),w=Object.keys(R),P=w.filter(f=>I.indexOf(f)===-1).reduce((f,m)=>(f.add(m),f),new Set),S=I.filter(f=>w.indexOf(f)===-1).reduce((f,m)=>(f.add(m),f),new Set),p=new Set;for(const f of I){if(S.has(f))continue;const m=N[f],E=R[f];O.equals(m,E)||p.add(f)}return{added:P,removed:S,updated:p}}}),define(re[260],oe([0,1,21,35,85,42,32,60,24]),function(te,e,O,U,l,T,N,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.merge=e.updateIgnoredSettings=e.removeComments=e.getIgnoredSettings=void 0;function w(c,y,b){let g=[];b?g=S(b):g=P(y);const D=[],A=[...(0,I.getDisallowedIgnoredSettings)()];if(Array.isArray(g))for(const F of g)F.startsWith("-")?A.push(F.substring(1)):D.push(F);return(0,O.distinct)([...c,...D].filter(F=>A.indexOf(F)===-1))}e.getIgnoredSettings=w;function P(c){let y=c.inspect("settingsSync.ignoredSettings").userValue;return y!==void 0||(y=c.inspect("sync.ignoredSettings").userValue,y!==void 0)?y:c.getValue("settingsSync.ignoredSettings")||[]}function S(c){const y=(0,U.parse)(c);return y?y["settingsSync.ignoredSettings"]||y["sync.ignoredSettings"]||[]:[]}function p(c,y){const b=(0,U.parse)(c)||{};let g="{}";for(const D of Object.keys(b)){const A=(0,l.setProperty)(g,[D],b[D],y);g=(0,l.applyEdits)(g,A)}return g}e.removeComments=p;function f(c,y,b,g){if(b.length){const D=o(y),A=(0,U.parse)(y)||{},F=(0,U.parse)(c);if(!F)return c;const j=[];for(const x of b){const V=A[x],B=F[x];V===void 0?c=R.edit(c,[x],void 0,g):B!==void 0?c=R.edit(c,[x],V,g):j.push(n(x,D))}j.sort((x,V)=>x.startOffset-V.startOffset),j.forEach(x=>c=h(x.setting.key,y,c,g))}return c}e.updateIgnoredSettings=f;function m(c,y,b,g,D,A){const F=f(c,y,g,A),j=b!==F,x=b!==y;if(!j&&!x)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(j&&!x)return{conflictsSettings:[],localContent:null,remoteContent:F,hasConflicts:!1};if(x&&!j)return{conflictsSettings:[],localContent:f(y,c,g,A),remoteContent:null,hasConflicts:!1};if(b===null&&a(c)){const M=E(c,y,g)?null:f(y,c,g,A);return{conflictsSettings:[],localContent:M,remoteContent:null,hasConflicts:!1}}let V=c,B=y;const Z=(0,U.parse)(c),J=(0,U.parse)(y),K=b?(0,U.parse)(b):null,Y=g.reduce((M,z)=>(M.add(z),M),new Set),H=u(Z,J,Y),$=u(K,Z,Y),X=u(K,J,Y),ie=new Map,se=new Set,ae=M=>{se.add(M);const z=D.filter(({key:_})=>_===M)[0];z?(V=R.edit(V,[M],z.value,A),B=R.edit(B,[M],z.value,A)):ie.set(M,{key:M,localValue:Z[M],remoteValue:J[M]})};for(const M of $.removed.values())X.updated.has(M)?ae(M):B=R.edit(B,[M],void 0,A);for(const M of X.removed.values())se.has(M)||($.updated.has(M)?ae(M):V=R.edit(V,[M],void 0,A));for(const M of $.updated.values())se.has(M)||(X.updated.has(M)?H.updated.has(M)&&ae(M):B=R.edit(B,[M],Z[M],A));for(const M of X.updated.values())se.has(M)||($.updated.has(M)?H.updated.has(M)&&ae(M):V=R.edit(V,[M],J[M],A));for(const M of $.added.values())se.has(M)||(X.added.has(M)?H.updated.has(M)&&ae(M):B=h(M,V,B,A));for(const M of X.added.values())se.has(M)||($.added.has(M)?H.updated.has(M)&&ae(M):V=h(M,B,V,A));const q=ie.size>0||!E(V,B,g),C=q||!E(V,c,[]),k=q||!E(B,y,[]);return{localContent:C?V:null,remoteContent:k?B:null,conflictsSettings:[...ie.values()],hasConflicts:q}}e.merge=m;function E(c,y,b){if(c===y)return!0;const g=(0,U.parse)(c),D=(0,U.parse)(y),A=b.reduce((x,V)=>(x.add(V),x),new Set),F=o(c).filter(x=>!(x.setting&&A.has(x.setting.key))),j=o(y).filter(x=>!(x.setting&&A.has(x.setting.key)));if(F.length!==j.length)return!1;for(let x=0;x<F.length;x++){const V=F[x],B=j[x];if(V.setting&&B.setting){if(V.setting.key!==B.setting.key||!N.equals(g[V.setting.key],D[V.setting.key]))return!1}else if(!V.setting&&!B.setting){if(V.value!==B.value)return!1}else return!1}return!0}function a(c){return c?o(c).length===0:!0}e.isEmpty=a;function u(c,y,b){const g=c?Object.keys(c).filter(x=>!b.has(x)):[],D=Object.keys(y).filter(x=>!b.has(x)),A=D.filter(x=>g.indexOf(x)===-1).reduce((x,V)=>(x.add(V),x),new Set),F=g.filter(x=>D.indexOf(x)===-1).reduce((x,V)=>(x.add(V),x),new Set),j=new Set;if(c)for(const x of g){if(F.has(x))continue;const V=c[x],B=y[x];N.equals(V,B)||j.add(x)}return{added:A,removed:F,updated:j}}function h(c,y,b,g){const D=(0,U.parse)(y),A=o(y),F=o(b),j=d(c,A,F);return v(b,c,D[c],j,F,g)}e.addSetting=h;function d(c,y,b){const g=y.findIndex(A=>A.setting?.key===c),D=y[g-1];if(D){if(D.setting){const F=n(D.setting.key,b);if(F)return{index:b.indexOf(F),insertAfter:!0}}else{const F=r(g,y);if(F){const j=n(F.setting.key,b);if(j){const x=t(b.indexOf(j),b),V=i(y,F,y[g]);if(x){const B=i(b,j,x),Z=s(V,B);return Z?{index:b.indexOf(Z),insertAfter:!0}:{index:b.indexOf(x),insertAfter:!1}}else{const B=i(b,j,b[b.length-1]),Z=s(V,B);return Z?{index:b.indexOf(Z),insertAfter:!0}:{index:b.length-1,insertAfter:!0}}}}}const A=y[g+1];if(A)if(A.setting){const F=n(A.setting.key,b);if(F)return{index:b.indexOf(F),insertAfter:!1}}else{const F=t(g,y);if(F){const j=n(F.setting.key,b);if(j){const x=r(b.indexOf(j),b),V=i(y,y[g],F);if(x){const B=i(b,x,j),Z=s(V.reverse(),B.reverse());return Z?{index:b.indexOf(Z),insertAfter:!1}:{index:b.indexOf(x),insertAfter:!0}}else{const B=i(b,b[0],j),Z=s(V.reverse(),B.reverse());return Z?{index:b.indexOf(Z),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:b.length-1,insertAfter:!0}}function v(c,y,b,g,D,A){let F;return g.index===-1?F=(0,l.setProperty)(c,[y],b,A):F=L(c,y,b,g,D,A).map(j=>(0,l.withFormatting)(c,j,A)[0]),(0,l.applyEdits)(c,F)}function L(c,y,b,g,D,A){const F=`${JSON.stringify(y)}: ${JSON.stringify(b)}`,j=(0,T.getEOL)(A,c),x=D[g.index];if(g.insertAfter){const V=[];if(x.setting)V.push({offset:x.endOffset,length:0,content:","+F});else{const B=t(g.index,D),Z=r(g.index,D),J=Z?.setting?.commaOffset;Z&&J===void 0&&V.push({offset:Z.endOffset,length:0,content:","});const K=J!==void 0&&J>x.endOffset;V.push({offset:K?J+1:x.endOffset,length:0,content:B?j+F+",":j+F})}return V}else{if(x.setting)return[{offset:x.startOffset,length:0,content:F+","}];const V=(D[g.index-1]&&!D[g.index-1].setting?j:"")+F+(t(g.index,D)?",":"")+j;return[{offset:x.startOffset,length:0,content:V}]}}function n(c,y){return y.filter(b=>b.setting?.key===c)[0]}function r(c,y){for(let b=c-1;b>=0;b--)if(y[b].setting)return y[b]}function t(c,y){for(let b=c+1;b<y.length;b++)if(y[b].setting)return y[b]}function i(c,y,b){const g=c.indexOf(y),D=c.indexOf(b);return c.filter((A,F)=>g<F&&F<D)}function s(c,y){if(c.length&&y.length){let b=0;for(;b<y.length&&b<c.length;b++)if(c[b].value!==y[b].value)return y[b-1];return y[b-1]}}function o(c){const y=[];let b=-1,g,D;const A={onObjectBegin:F=>{b++},onObjectProperty:(F,j,x)=>{b===0&&(g=j,D=F)},onObjectEnd:(F,j)=>{b--,b===0&&y.push({startOffset:g,endOffset:F+j,value:c.substring(g,F+j),setting:{key:D,commaOffset:void 0}})},onArrayBegin:(F,j)=>{b++},onArrayEnd:(F,j)=>{b--,b===0&&y.push({startOffset:g,endOffset:F+j,value:c.substring(g,F+j),setting:{key:D,commaOffset:void 0}})},onLiteralValue:(F,j,x)=>{b===0&&y.push({startOffset:g,endOffset:j+x,value:c.substring(g,j+x),setting:{key:D,commaOffset:void 0}})},onSeparator:(F,j,x)=>{if(b===0&&F===","){let V=y.length-1;for(;V>=0&&!y[V].setting;V--);const B=y[V];B&&y.splice(V,1,{startOffset:B.startOffset,endOffset:B.endOffset,value:B.value,setting:{key:B.setting.key,commaOffset:j}})}},onComment:(F,j)=>{b===0&&y.push({startOffset:F,endOffset:F+j,value:c.substring(F,F+j)})}};return(0,U.visit)(c,A),y}}),define(re[79],oe([0,1,3,2,5,24]),function(te,e,O,U,l,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,l.createDecorator)("IUserDataSyncAccountService");let N=class extends U.Disposable{get account(){return this.a}constructor(I,w){super(),this.g=I,this.h=w,this.b=this.D(new O.Emitter),this.onDidChangeAccount=this.b.event,this.c=this.D(new O.Emitter),this.onTokenFailed=this.c.event,this.f=!1,this.D(I.onTokenFailed(()=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f),this.updateAccount(void 0),this.c.fire(this.f),this.f=!0})),this.D(I.onTokenSucceed(()=>this.f=!1))}async updateAccount(I){(I&&this.a?I.token!==this.a.token||I.authenticationProviderId!==this.a.authenticationProviderId:I!==this.a)&&(this.a=I,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(I))}};N=ye([G(0,T.IUserDataSyncStoreService),G(1,T.IUserDataSyncLogService)],N),e.UserDataSyncAccountService=N}),define(re[261],oe([0,1,2,11]),function(te,e,O,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class l{constructor(p){this.a=p}listen(p,f){switch(f){case"onError":return this.a.onError}throw new Error(`Event not found: ${f}`)}call(p,f,m){switch(f){case"triggerSync":return this.a.triggerSync(m[0],m[1],m[2]);case"turnOn":return this.a.turnOn();case"turnOff":return this.a.turnOff(m[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=l;class T{constructor(p){this.a=p}listen(p,f){throw new Error(`Event not found: ${f}`)}call(p,f,m){switch(f){case"resolveDefaultIgnoredSettings":return this.a.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.a.resolveUserBindings(m[0]);case"resolveFormattingOptions":return this.a.resolveFormattingOptions(U.URI.revive(m[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=T;class N{constructor(p){this.a=p}async resolveDefaultIgnoredSettings(){return this.a.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(p){return this.a.call("resolveUserKeybindings",[p])}async resolveFormattingOptions(p){return this.a.call("resolveFormattingOptions",[p])}}e.UserDataSyncUtilServiceClient=N;class R{constructor(p){this.a=p}listen(p,f){switch(f){case"onDidChange":return this.a.onDidChange}throw new Error(`Event not found: ${f}`)}async call(p,f,m){switch(f){case"getMachines":return this.a.getMachines();case"addCurrentMachine":return this.a.addCurrentMachine();case"removeCurrentMachine":return this.a.removeCurrentMachine();case"renameMachine":return this.a.renameMachine(m[0],m[1]);case"setEnablements":return this.a.setEnablements(m)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=R;class I{constructor(p){this.a=p}listen(p,f){switch(f){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`Event not found: ${f}`)}call(p,f,m){switch(f){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(m)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=I;class w{constructor(p){this.a=p}listen(p,f){switch(f){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${f}`)}call(p,f,m){switch(f){case"switch":return this.a.switch(m[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=w;class P extends O.Disposable{constructor(p){super(),this.a=p,this.onDidChangeUserDataSyncStore=this.a.listen("onDidChangeUserDataSyncStore")}async switch(p){return this.a.call("switch",[p])}async getPreviousUserDataSyncStore(){const p=await this.a.call("getPreviousUserDataSyncStore");return this.b(p)}b(p){return{url:U.URI.revive(p.url),type:p.type,defaultUrl:U.URI.revive(p.defaultUrl),insidersUrl:U.URI.revive(p.insidersUrl),stableUrl:U.URI.revive(p.stableUrl),canSwitch:p.canSwitch,authenticationProviders:p.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=P}),define(re[262],oe([0,1,186,9,24]),function(te,e,O,U,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let T=class extends U.AbstractLogger{constructor(R){super(),this.g=this.D(R.createLogger(l.USER_DATA_SYNC_LOG_ID,{name:(0,O.localize)(0,null)}))}trace(R,...I){this.g.trace(R,...I)}debug(R,...I){this.g.debug(R,...I)}info(R,...I){this.g.info(R,...I)}warn(R,...I){this.g.warn(R,...I)}error(R,...I){this.g.error(R,...I)}flush(){this.g.flush()}};T=ye([G(0,U.ILoggerService)],T),e.UserDataSyncLogService=T}),define(re[263],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcUtilityProcessWorkerChannelName=void 0,e.ipcUtilityProcessWorkerChannelName="utilityProcessWorker"}),define(re[264],oe([0,1,6,3,2]),function(te,e,O,U,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class T extends l.Disposable{constructor({onDidOpenWindow:R,onDidFocusWindow:I,getActiveWindowId:w}){super(),this.a=this.D(new l.DisposableStore),U.Event.latch(U.Event.any(R,I))(this.f,this,this.a),this.b=(0,O.createCancelablePromise)(()=>w()),(async()=>{try{const S=await this.b;this.c=typeof this.c=="number"?this.c:S}catch{}finally{this.b=void 0}})()}f(R){this.b&&(this.b.cancel(),this.b=void 0),this.c=R}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.ActiveWindowManager=T}),define(re[119],oe([0,1,189,13,49,23,11,5,22]),function(te,e,O,U,l,T,N,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,R.createDecorator)("contextService");function w(i){const s=i;return typeof s?.id=="string"&&N.URI.isUri(s.uri)}e.isSingleFolderWorkspaceIdentifier=w;function P(i){return typeof i?.id=="string"&&!w(i)&&!p(i)}e.isEmptyWorkspaceIdentifier=P,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function S(i,s){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,U.basename)(i)}:s?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const o=i;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}e.toWorkspaceIdentifier=S;function p(i){const s=i;return typeof s?.id=="string"&&N.URI.isUri(s.configPath)}e.isWorkspaceIdentifier=p;function f(i){const s=i;if(s?.uri)return{id:s.id,uri:N.URI.revive(s.uri)};const o=i;if(o?.configPath)return{id:o.id,configPath:N.URI.revive(o.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=f;var m;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(m=e.WorkbenchState||(e.WorkbenchState={}));function E(i){const s=i;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}e.isWorkspace=E;function a(i){const s=i;return!!(s&&typeof s=="object"&&N.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}e.isWorkspaceFolder=a;class u{constructor(s,o,c,y,b){this.h=s,this.j=c,this.k=y,this.l=b,this.c=l.TernarySearchTree.forUris(this.l,()=>!0),this.folders=o}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=l.TernarySearchTree.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=u;class h{constructor(s,o){this.raw=o,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,T.joinPath)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=h;function d(i){return new h({uri:i,index:0,name:(0,T.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=d,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,O.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function v(i,s){return T.extUriBiasedIgnorePathCase.isEqualOrParent(i,s.untitledWorkspacesHome)}e.isUntitledWorkspace=v;function L(i){let s;return N.URI.isUri(i)?s=i:s=i.configuration,s?.scheme===I.Schemas.tmp}e.isTemporaryWorkspace=L,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function n(i){return i.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=n;function r(i,s){return!v(i,s)&&!L(i)}e.isSavedWorkspace=r;function t(i){return(typeof i=="string"?(0,U.extname)(i):(0,T.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=t}),define(re[18],oe([0,1,53,3,2,23,11,180,15,14,5,9,119,37,30,6,31,27,12]),function(te,e,O,U,l,T,N,R,I,w,P,S,p,f,m,E,a,u,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=void 0;function d(t){const i=t;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&N.URI.isUri(i.location)&&N.URI.isUri(i.globalStorageHome)&&N.URI.isUri(i.settingsResource)&&N.URI.isUri(i.keybindingsResource)&&N.URI.isUri(i.tasksResource)&&N.URI.isUri(i.snippetsHome)&&N.URI.isUri(i.extensionsResource))}e.isUserDataProfile=d,e.IUserDataProfilesService=(0,P.createDecorator)("IUserDataProfilesService");function v(t,i){return{id:t.id,isDefault:t.isDefault,name:t.name,shortName:t.shortName,location:N.URI.revive(t.location).with({scheme:i}),globalStorageHome:N.URI.revive(t.globalStorageHome).with({scheme:i}),settingsResource:N.URI.revive(t.settingsResource).with({scheme:i}),keybindingsResource:N.URI.revive(t.keybindingsResource).with({scheme:i}),tasksResource:N.URI.revive(t.tasksResource).with({scheme:i}),snippetsHome:N.URI.revive(t.snippetsHome).with({scheme:i}),extensionsResource:N.URI.revive(t.extensionsResource)?.with({scheme:i}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}e.reviveProfile=v;function L(t,i,s,o){return{id:t,name:i,location:s,isDefault:!1,shortName:o?.shortName,globalStorageHome:(0,T.joinPath)(s,"globalStorage"),settingsResource:(0,T.joinPath)(s,"settings.json"),keybindingsResource:(0,T.joinPath)(s,"keybindings.json"),tasksResource:(0,T.joinPath)(s,"tasks.json"),snippetsHome:(0,T.joinPath)(s,"snippets"),extensionsResource:(0,T.joinPath)(s,"extensions.json"),useDefaultFlags:o?.useDefaultFlags,isTransient:o?.transient}}e.toUserDataProfile=L;let n=class extends l.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.t.profiles,...this.l.profiles]}constructor(i,s,o,c){super(),this.m=i,this.n=s,this.q=o,this.r=c,this.f=!0,this.g=this.D(new U.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.D(new U.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.D(new U.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.D(new U.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new f.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,T.joinPath)(this.m.userRoamingDataHome,"profiles")}init(){this.s=void 0}setEnablement(i){this.f!==i&&(this.s=void 0,this.f=i)}isEnabled(){return this.f}get t(){if(!this.s){const i=[];if(this.f)try{for(const y of this.I()){if(!y.name||!(0,h.isString)(y.name)||!y.location){this.r.warn("Skipping the invalid stored profile",y.location||y.name);continue}i.push(L((0,T.basename)(y.location),y.name,y.location,{shortName:y.shortName,useDefaultFlags:y.useDefaultFlags}))}}catch(y){this.r.error(y)}const s=new f.ResourceMap,o=new Map,c=this.u();if(i.unshift({...c,extensionsResource:this.N()??c.extensionsResource,isDefault:!0}),i.length)try{const y=this.L();if(y.workspaces)for(const[b,g]of Object.entries(y.workspaces)){const D=N.URI.parse(b),A=i.find(F=>F.id===g);A&&s.set(D,A)}if(y.emptyWindows)for(const[b,g]of Object.entries(y.emptyWindows)){const D=i.find(A=>A.id===g);D&&o.set(b,D)}}catch(y){this.r.error(y)}this.s={profiles:i,workspaces:s,emptyWindows:o}}return this.s}u(){return L("__default__profile__",(0,R.localize)(0,null),this.m.userRoamingDataHome)}async createTransientProfile(i){const s="Temp",o=new RegExp(`${(0,u.escapeRegExpCharacters)(s)}\\s(\\d+)`);let c=0;for(const b of this.profiles){const g=o.exec(b.name),D=g?parseInt(g[1]):0;c=D>c?D:c}const y=`${s} ${c+1}`;return this.createProfile((0,O.hash)((0,a.generateUuid)()).toString(16),y,{transient:!0},i)}async createNamedProfile(i,s,o){return this.createProfile((0,O.hash)((0,a.generateUuid)()).toString(16),i,s,o)}async createProfile(i,s,o,c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const y=await this.v(i,s,o);return c&&await this.setProfileForWorkspace(c,y),y}async v(i,s,o){if(!(0,h.isString)(s)||!s)throw new Error("Name of the profile is mandatory and must be of type `string`");let c=this.k.get(s);return c||(c=(async()=>{try{const y=this.profiles.find(D=>D.name===s||D.id===i);if(y)return y;const b=L(i,s,(0,T.joinPath)(this.profilesHome,i),o);await this.n.createFolder(b.location);const g=[];return this.h.fire({profile:b,join(D){g.push(D)}}),await E.Promises.settled(g),this.z([b],[],[]),b}finally{this.k.delete(s)}})(),this.k.set(s,c)),c}async updateProfile(i,s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let o=this.profiles.find(c=>c.id===i.id);if(!o)throw new Error(`Profile '${i.name}' does not exist`);return o=L(o.id,s.name??o.name,o.location,{shortName:s.shortName??o.shortName,transient:s.transient??o.isTransient,useDefaultFlags:s.useDefaultFlags??o.useDefaultFlags}),this.z([],[],[o]),o}async removeProfile(i){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(i.isDefault)throw new Error("Cannot remove default profile");const s=this.profiles.find(c=>c.id===i.id);if(!s)throw new Error(`Profile '${i.name}' does not exist`);const o=[];this.i.fire({profile:s,join(c){o.push(c)}});try{await Promise.allSettled(o)}catch(c){this.r.error(c)}for(const c of[...this.t.emptyWindows.keys()])s.id===this.t.emptyWindows.get(c)?.id&&this.t.emptyWindows.delete(c);for(const c of[...this.t.workspaces.keys()])s.id===this.t.workspaces.get(c)?.id&&this.t.workspaces.delete(c);this.G(),this.z([],[s],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(s.location,{recursive:!0})}catch(c){this.r.error(c)}}async setProfileForWorkspace(i,s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const o=this.profiles.find(c=>c.id===s.id);if(!o)throw new Error(`Profile '${s.name}' does not exist`);this.F(i,o)}unsetWorkspace(i,s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.F(i,void 0,s)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindows.clear(),this.t.workspaces.clear(),this.t.emptyWindows.clear(),this.G(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const i=await this.n.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(s=>s.isDirectory&&this.profiles.every(o=>!this.q.extUri.isEqual(o.location,s.resource))).map(s=>this.n.del(s.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const i=this.l.profiles.filter(s=>!this.y(s));await Promise.allSettled(i.map(s=>this.removeProfile(s)))}getProfileForWorkspace(i){const s=this.w(i);return N.URI.isUri(s)?this.l.workspaces.get(s)??this.t.workspaces.get(s):this.l.emptyWindows.get(s)??this.t.emptyWindows.get(s)}w(i){return(0,p.isSingleFolderWorkspaceIdentifier)(i)?i.uri:(0,p.isWorkspaceIdentifier)(i)?i.configPath:i.id}y(i){return!!([...this.l.emptyWindows.values()].some(s=>this.q.extUri.isEqual(s.location,i.location))||[...this.l.workspaces.values()].some(s=>this.q.extUri.isEqual(s.location,i.location))||[...this.t.emptyWindows.values()].some(s=>this.q.extUri.isEqual(s.location,i.location))||[...this.t.workspaces.values()].some(s=>this.q.extUri.isEqual(s.location,i.location)))}z(i,s,o){const c=[...this.profiles,...i],y=[];this.l.profiles=[];for(let b of c)b.isDefault||s.some(g=>b.id===g.id)||(b=o.find(g=>b.id===g.id)??b,b.isTransient?this.l.profiles.push(b):y.push({location:b.location,name:b.name,shortName:b.shortName,useDefaultFlags:b.useDefaultFlags}));this.J(y),this.s=void 0,this.C(i,s,o)}C(i,s,o){this.g.fire({added:i,removed:s,updated:o,all:this.profiles})}F(i,s,o){o=s?.isTransient?!0:o,o||this.F(i,void 0,!0);const c=this.w(i),y=o?this.l:this.t;N.URI.isUri(c)?(y.workspaces.delete(c),s&&y.workspaces.set(c,s)):(y.emptyWindows.delete(c),s&&y.emptyWindows.set(c,s)),o||this.G()}G(){const i={};for(const[o,c]of this.t.workspaces.entries())i[o.toString()]=c.id;const s={};for(const[o,c]of this.t.emptyWindows.entries())s[o.toString()]=c.id;this.M({workspaces:i,emptyWindows:s}),this.s=void 0}H(i){const s={},o=this.u();if(i.workspaces)for(const[y,b]of Object.entries(i.workspaces)){const g=N.URI.parse(b);s[y]=this.q.extUri.isEqual(g,o.location)?o.id:this.q.extUri.basename(g)}const c={};if(i.emptyWindows)for(const[y,b]of Object.entries(i.emptyWindows)){const g=N.URI.parse(b);c[y]=this.q.extUri.isEqual(g,o.location)?o.id:this.q.extUri.basename(g)}return{workspaces:s,emptyWindows:c}}I(){return[]}J(i){throw new Error("not implemented")}L(){return{}}M(i){throw new Error("not implemented")}N(){}};n.b="userDataProfiles",n.c="profileAssociations",n=ye([G(0,I.IEnvironmentService),G(1,w.IFileService),G(2,m.IUriIdentityService),G(3,S.ILogService)],n),e.UserDataProfilesService=n;class r extends n{constructor(){super(...arguments),this.a=[],this.Q={}}I(){return this.a}J(i){this.a=i}L(){return this.Q}M(i){this.Q=i}}e.InMemoryUserDataProfilesService=r}),define(re[265],oe([0,1,6,2,18]),function(te,e,O,U,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesCleaner=void 0;let T=class extends U.Disposable{constructor(R){super(),this.D(new O.RunOnceScheduler(()=>{R.cleanUp()},10*1e3)).schedule()}};T=ye([G(0,l.IUserDataProfilesService)],T),e.UserDataProfilesCleaner=T}),define(re[266],oe([0,1,21,6,25,10,3,2,4,11,159,29,33,46,9,26,19,18]),function(te,e,O,U,l,T,N,R,I,w,P,S,p,f,m,E,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.joinErrors=e.AbstractExtensionManagementService=e.ExtensionVerificationStatus=void 0;var h;(function(t){t.Verified="Verified",t.Unverified="Unverified",t.UnknownError="UnknownError"})(h=e.ExtensionVerificationStatus||(e.ExtensionVerificationStatus={}));let d=class extends R.Disposable{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}constructor(i,s,o,c,y){super(),this.s=i,this.t=s,this.u=o,this.v=c,this.w=y,this.h=0,this.j=new Map,this.k=new Map,this.l=this.D(new N.Emitter),this.m=this.D(new N.Emitter),this.n=this.D(new N.Emitter),this.p=this.D(new N.Emitter),this.q=[],this.D((0,R.toDisposable)(()=>{this.j.forEach(({task:b})=>b.cancel()),this.k.forEach(b=>b.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(i){const s=await this.getTargetPlatform();return i.allTargetPlatforms.some(o=>(0,S.isTargetPlatformCompatible)(o,i.allTargetPlatforms,s))}async installFromGallery(i,s={}){try{if(!this.s.isEnabled())throw new S.ExtensionManagementError(P.localize(0,null),S.ExtensionManagementErrorCode.Internal);const o=await this.G(i,!!s.installGivenVersion,!!s.installPreReleaseVersion);return await this.y(o.manifest,o.extension,s)}catch(o){throw n(this.t,"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(i),error:o}),this.u.error("Failed to install extension.",i.identifier.id),this.u.error(o),L(o)}}async uninstall(i,s={}){return this.u.trace("ExtensionManagementService#uninstall",i.identifier.id),this.I(i,s)}getExtensionsControlManifest(){const i=new Date().getTime();return(!this.g||i-this.h>1e3*60*5)&&(this.g=this.O(),this.h=i),this.g}registerParticipant(i){this.q.push(i)}async y(i,s,o){const c={...o,installOnlyNewlyAddedFromExtensionPack:w.URI.isUri(s)?o.installOnlyNewlyAddedFromExtensionPack:!0,profileLocation:(0,f.isApplicationScopedExtension)(i)?this.w.defaultProfile.extensionsResource:o.profileLocation??this.P()},y=j=>`${p.ExtensionKey.create(j).toString()}${c.profileLocation?`-${c.profileLocation.toString()}`:""}`;if(!w.URI.isUri(s)){const j=this.j.get(y(s));if(j)return this.u.info("Extensions is already requested to install",s.identifier.id),j.task.waitUntilTaskIsFinished()}const b=[],g=[],D=[],A=this.Q(i,s,c);w.URI.isUri(s)||this.j.set(y(s),{task:A,waitingTasks:[]}),this.l.fire({identifier:A.identifier,source:s,profileLocation:c.profileLocation}),this.u.info("Installing extension:",A.identifier.id),b.push({task:A,manifest:i});let F=!1;try{if(c.donotIncludePackAndDependencies)this.u.info("Installing the extension without checking dependencies and pack",A.identifier.id);else try{const x=await this.F(A.identifier,i,!!c.installOnlyNewlyAddedFromExtensionPack,!!c.installPreReleaseVersion,c.profileLocation),V=await this.getInstalled(void 0,c.profileLocation);for(const{gallery:B,manifest:Z}of(0,O.distinct)(x,({gallery:J})=>J.identifier.id)){F=F||!!Z.extensionDependencies?.some(Y=>(0,p.areSameExtensions)({id:Y},A.identifier));const J=y(B),K=this.j.get(J);if(K){if(this.z(A,K.task)){const Y=K.task.identifier;this.u.info("Waiting for already requested installing extension",Y.id,A.identifier.id),K.waitingTasks.push(A),g.push(N.Event.toPromise(N.Event.filter(this.onDidInstallExtensions,H=>H.some($=>(0,p.areSameExtensions)($.identifier,Y)))).then(H=>{if(this.u.info("Finished waiting for already requested installing extension",Y.id,A.identifier.id),!H.find(X=>(0,p.areSameExtensions)(X.identifier,Y))?.local)throw new Error(`Extension ${Y.id} is not installed`)}))}}else if(!V.some(({identifier:Y})=>(0,p.areSameExtensions)(Y,B.identifier))){const Y=this.Q(Z,B,{...c,donotIncludePackAndDependencies:!0});this.j.set(J,{task:Y,waitingTasks:[A]}),this.l.fire({identifier:Y.identifier,source:B,profileLocation:c.profileLocation}),this.u.info("Installing extension:",Y.identifier.id,A.identifier.id),b.push({task:Y,manifest:Z})}}}catch(x){if(w.URI.isUri(A.source))(0,O.isNonEmptyArray)(i.extensionDependencies)&&this.u.warn("Cannot install dependencies of extension:",A.identifier.id,x.message),(0,O.isNonEmptyArray)(i.extensionPack)&&this.u.warn("Cannot install packed extensions of extension:",A.identifier.id,x.message);else throw this.u.error("Error while preparing to install dependencies and extension packs of the extension:",A.identifier.id),x}const j=b.reduce((x,{task:V,manifest:B})=>(x.set(V.identifier.id.toLowerCase(),{task:V,manifest:B}),x),new Map);for(;j.size;){let x;const V=[...j.values()].filter(({manifest:B})=>!B.extensionDependencies?.some(Z=>j.has(Z.toLowerCase())));V.length?x=j.size===1?V:V.filter(({task:B})=>!(B===A&&!F)):(this.u.info("Found extensions with circular dependencies",V.map(({task:B})=>B.identifier.id)),x=[...j.values()]),await this.C(x.map(async({task:B})=>{const Z=new Date().getTime();try{const J=await B.run();if(await this.C(this.q.map(K=>K.postInstall(J,B.source,c,l.CancellationToken.None))),!w.URI.isUri(B.source)){const K=B.operation===3,Y=K?void 0:(new Date().getTime()-B.source.lastUpdated)/1e3;if(n(this.t,K?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(B.source),verificationStatus:B.verificationStatus,duration:new Date().getTime()-Z,durationSinceUpdate:Y}),I.isWeb&&B.operation!==3)try{await this.s.reportStatistic(J.manifest.publisher,J.manifest.name,J.manifest.version,"install")}catch{}}D.push({local:J,identifier:B.identifier,operation:B.operation,source:B.source,context:c.context,profileLocation:c.profileLocation,applicationScoped:J.isApplicationScoped})}catch(J){throw w.URI.isUri(B.source)||n(this.t,B.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(B.source),verificationStatus:B.verificationStatus,duration:new Date().getTime()-Z,error:J}),this.u.error("Error while installing the extension:",B.identifier.id),J}finally{j.delete(B.identifier.id.toLowerCase())}}))}return g.length&&await this.C(g),D.forEach(({identifier:x})=>this.u.info("Extension installed successfully:",x.id)),this.m.fire(D),D.filter(({identifier:x})=>(0,p.areSameExtensions)(x,A.identifier))[0].local}catch(j){if(b.forEach(({task:x})=>x.cancel()),D.length)try{const x=await Promise.allSettled(D.map(({local:V})=>this.R(V,{versionOnly:!0,profileLocation:c.profileLocation}).run()));for(let V=0;V<x.length;V++){const B=x[V],{identifier:Z}=D[V];B.status==="fulfilled"?this.u.info("Rollback: Uninstalled extension",Z.id):this.u.warn("Rollback: Error while uninstalling extension",Z.id,(0,T.getErrorMessage)(B.reason))}}catch(x){this.u.warn("Error while rolling back extensions",(0,T.getErrorMessage)(x),D.map(({identifier:V})=>V.id))}throw this.m.fire(b.map(({task:x})=>({identifier:x.identifier,operation:2,source:x.source,context:c.context,profileLocation:c.profileLocation}))),j}finally{for(const{task:j}of b)j.source&&!w.URI.isUri(j.source)&&this.j.delete(y(j.source))}}z(i,s){for(const[,{task:o,waitingTasks:c}]of this.j.entries())if(o===i&&(c.includes(s)||c.some(y=>this.z(y,s)))||o===s&&c[0]&&!this.z(i,c[0]))return!1;return!0}async C(i){const s=[],o=[],c=await Promise.allSettled(i);for(const y of c)y.status==="fulfilled"?s.push(y.value):o.push(y.reason);if(o.length)throw v(o);return s}async F(i,s,o,c,y){if(!this.s.isEnabled())return[];const b=await this.getInstalled(void 0,y),g=[],D=[],A=async(F,j)=>{g.push(F);const x=j.extensionDependencies||[],V=[...x];if(j.extensionPack){const B=o?b.find(Z=>(0,p.areSameExtensions)(Z.identifier,F)):void 0;for(const Z of j.extensionPack)B&&B.manifest.extensionPack&&B.manifest.extensionPack.some(J=>(0,p.areSameExtensions)({id:J},{id:Z}))||V.every(J=>!(0,p.areSameExtensions)({id:J},{id:Z}))&&V.push(Z)}if(V.length){const B=V.filter(Z=>g.every(J=>!(0,p.areSameExtensions)(J,{id:Z})));if(B.length){const Z=await this.s.getExtensions(B.map(J=>({id:J,preRelease:c})),l.CancellationToken.None);for(const J of Z){if(g.find(H=>(0,p.areSameExtensions)(H,J.identifier)))continue;const K=x.some(H=>(0,p.areSameExtensions)({id:H},J.identifier));let Y;try{Y=await this.G(J,!1,c)}catch(H){if(H instanceof S.ExtensionManagementError&&H.code===S.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!K){this.u.info("Skipping the packed extension as it cannot be installed",J.identifier.id);continue}else throw H}D.push({gallery:Y.extension,manifest:Y.manifest}),await A(Y.extension.identifier,Y.manifest)}}}};return await A(i,s),D}async G(i,s,o){if((await this.getExtensionsControlManifest()).malicious.some(g=>(0,p.areSameExtensions)(i.identifier,g)))throw new S.ExtensionManagementError(P.localize(1,null,i.identifier.id),S.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(i)){const g=await this.getTargetPlatform();throw new S.ExtensionManagementError(P.localize(2,null,i.identifier.id,this.v.nameLong,(0,S.TargetPlatformToString)(g)),S.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const y=await this.H(i,s,o);if(y){if(o&&!s&&i.hasPreReleaseVersion&&!y.properties.isPreReleaseVersion)throw new S.ExtensionManagementError(P.localize(3,null,i.identifier.id,this.v.nameLong,this.v.version),S.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!o&&i.properties.isPreReleaseVersion&&(await this.s.getExtensions([i.identifier],l.CancellationToken.None))[0]?new S.ExtensionManagementError(P.localize(4,null,i.identifier.id),S.ExtensionManagementErrorCode.ReleaseVersionNotFound):new S.ExtensionManagementError(P.localize(5,null,i.identifier.id,this.v.nameLong,this.v.version),S.ExtensionManagementErrorCode.Incompatible);this.u.info("Getting Manifest...",y.identifier.id);const b=await this.s.getManifest(y,l.CancellationToken.None);if(b===null)throw new S.ExtensionManagementError(`Missing manifest for extension ${i.identifier.id}`,S.ExtensionManagementErrorCode.Invalid);if(b.version!==y.version)throw new S.ExtensionManagementError(`Cannot install '${i.identifier.id}' extension because of version mismatch in Marketplace`,S.ExtensionManagementErrorCode.Invalid);return{extension:y,manifest:b}}async H(i,s,o){const c=await this.getTargetPlatform();let y=null;return!s&&i.hasPreReleaseVersion&&i.properties.isPreReleaseVersion!==o&&(y=(await this.s.getExtensions([{...i.identifier,preRelease:o}],{targetPlatform:c,compatible:!0},l.CancellationToken.None))[0]||null),!y&&await this.s.isExtensionCompatible(i,o,c)&&(y=i),y||(s?y=(await this.s.getExtensions([{...i.identifier,version:i.version}],{targetPlatform:c,compatible:!0},l.CancellationToken.None))[0]||null:y=await this.s.getCompatibleExtension(i,o,c)),y}async I(i,s){const o={...s,profileLocation:i.isApplicationScoped?this.w.defaultProfile.extensionsResource:s.profileLocation??this.P()},c=F=>`${F.id.toLowerCase()}${o.versionOnly?`-${i.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,y=this.k.get(c(i.identifier));if(y)return this.u.info("Extensions is already requested to uninstall",i.identifier.id),y.waitUntilTaskIsFinished();const b=F=>{const j=this.R(F,o);return this.k.set(c(j.extension.identifier),j),o.profileLocation?this.u.info("Uninstalling extension from the profile:",`${F.identifier.id}@${F.manifest.version}`,o.profileLocation.toString()):this.u.info("Uninstalling extension:",`${F.identifier.id}@${F.manifest.version}`),this.n.fire({identifier:F.identifier,profileLocation:o.profileLocation,applicationScoped:F.isApplicationScoped}),j},g=(F,j)=>{j?o.profileLocation?this.u.error("Failed to uninstall extension from the profile:",`${F.identifier.id}@${F.manifest.version}`,o.profileLocation.toString(),j.message):this.u.error("Failed to uninstall extension:",`${F.identifier.id}@${F.manifest.version}`,j.message):o.profileLocation?this.u.info("Successfully uninstalled extension from the profile",`${F.identifier.id}@${F.manifest.version}`,o.profileLocation.toString()):this.u.info("Successfully uninstalled extension:",`${F.identifier.id}@${F.manifest.version}`),n(this.t,"extensionGallery:uninstall",{extensionData:(0,p.getLocalExtensionTelemetryData)(F),error:j}),this.p.fire({identifier:F.identifier,error:j?.code,profileLocation:o.profileLocation,applicationScoped:F.isApplicationScoped})},D=[],A=[];try{D.push(b(i));const F=await this.getInstalled(1,o.profileLocation);if(o.donotIncludePack)this.u.info("Uninstalling the extension without including packed extension",`${i.identifier.id}@${i.manifest.version}`);else{const j=this.M(i,F);for(const x of j)this.k.has(c(x.identifier))?this.u.info("Extensions is already requested to uninstall",x.identifier.id):D.push(b(x))}o.donotCheckDependents?this.u.info("Uninstalling the extension without checking dependents",`${i.identifier.id}@${i.manifest.version}`):this.J(D.map(j=>j.extension),F,i),await this.C(D.map(async j=>{try{if(await j.run(),await this.C(this.q.map(x=>x.postUninstall(j.extension,o,l.CancellationToken.None))),j.extension.identifier.uuid)try{await this.s.reportStatistic(j.extension.manifest.publisher,j.extension.manifest.name,j.extension.manifest.version,"uninstall")}catch{}g(j.extension)}catch(x){const V=x instanceof S.ExtensionManagementError?x:new S.ExtensionManagementError((0,T.getErrorMessage)(x),S.ExtensionManagementErrorCode.Internal);throw g(j.extension,V),V}finally{A.push(j)}}))}catch(F){const j=F instanceof S.ExtensionManagementError?F:new S.ExtensionManagementError((0,T.getErrorMessage)(F),S.ExtensionManagementErrorCode.Internal);for(const x of D){try{x.cancel()}catch{}A.includes(x)||g(x.extension,j)}throw j}finally{for(const F of D)this.k.delete(c(F.extension.identifier))||this.u.warn("Uninstallation task is not found in the cache",F.extension.identifier.id)}}J(i,s,o){for(const c of i){const y=this.N(c,s);if(y.length){const b=y.filter(g=>!i.some(D=>(0,p.areSameExtensions)(D.identifier,g.identifier)));if(b.length)throw new Error(this.L(c,b,o))}}}L(i,s,o){return o===i?s.length===1?P.localize(6,null,o.manifest.displayName||o.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?P.localize(7,null,o.manifest.displayName||o.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):P.localize(8,null,o.manifest.displayName||o.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):s.length===1?P.localize(9,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?P.localize(10,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):P.localize(11,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name)}M(i,s,o=[]){if(o.indexOf(i)!==-1)return[];o.push(i);const c=i.manifest.extensionPack?i.manifest.extensionPack:[];if(c.length){const y=s.filter(g=>!g.isBuiltin&&c.some(D=>(0,p.areSameExtensions)({id:D},g.identifier))),b=[];for(const g of y)b.push(...this.M(g,s,o));return[...y,...b]}return[]}N(i,s){return s.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(c=>(0,p.areSameExtensions)({id:c},i.identifier)))}async O(){try{this.u.trace("ExtensionManagementService.refreshReportedCache");const i=await this.s.getExtensionsControlManifest();return this.u.trace("ExtensionManagementService.refreshControlCache",i),i}catch{return this.u.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};d=ye([G(0,S.IExtensionGalleryService),G(1,a.ITelemetryService),G(2,m.ILogService),G(3,E.IProductService),G(4,u.IUserDataProfilesService)],d),e.AbstractExtensionManagementService=d;function v(t){const i=Array.isArray(t)?t:[t];return i.length===1?i[0]instanceof Error?i[0]:new Error(i[0]):i.reduce((s,o)=>new Error(`${s.message}${s.message?",":""}${o instanceof Error?o.message:o}`),new Error(""))}e.joinErrors=v;function L(t){if(t instanceof S.ExtensionManagementError)return t;const i=new S.ExtensionManagementError(t.message,S.ExtensionManagementErrorCode.Internal);return i.stack=t.stack,i}function n(t,i,{extensionData:s,verificationStatus:o,duration:c,error:y,durationSinceUpdate:b}){let g,D;y&&(y instanceof S.ExtensionManagementError?(g=y.code,y.code===S.ExtensionManagementErrorCode.Signature&&(D=y.message)):g=S.ExtensionManagementErrorCode.Internal),t.publicLog(i,{...s,verificationStatus:o,success:!y,duration:c,errorcode:g,errorcodeDetail:D,durationSinceUpdate:b})}class r{constructor(){this.d=new U.Barrier}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,U.createCancelablePromise)(i=>this.h(i))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,U.createCancelablePromise)(i=>new Promise((s,o)=>{const c=i.onCancellationRequested(()=>{c.dispose(),o(new T.CancellationError)})})),this.d.open()),this.g.cancel()}}e.AbstractExtensionTask=r}),define(re[51],oe([0,1,6,16,2,3,37,11,29,33,14,5,9,18,30,12,10,19]),function(te,e,O,U,l,T,N,R,I,w,P,S,p,f,m,E,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var h;(function(r){r.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",r.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(h=e.ExtensionsProfileScanningErrorCode||(e.ExtensionsProfileScanningErrorCode={}));class d extends Error{constructor(t,i){super(t),this.code=i}}e.ExtensionsProfileScanningError=d,e.IExtensionsProfileScannerService=(0,S.createDecorator)("IExtensionsProfileScannerService");let v=class extends l.Disposable{constructor(t,i,s,o,c,y){super(),this.i=t,this.j=i,this.k=s,this.l=o,this.m=c,this.n=y,this.b=this.D(new T.Emitter),this.onAddExtensions=this.b.event,this.c=this.D(new T.Emitter),this.onDidAddExtensions=this.c.event,this.f=this.D(new T.Emitter),this.onRemoveExtensions=this.f.event,this.g=this.D(new T.Emitter),this.onDidRemoveExtensions=this.g.event,this.h=new N.ResourceMap}scanProfileExtensions(t,i){return this.p(t,void 0,i)}async addExtensionsToProfile(t,i){const s=[],o=[];try{return await this.p(i,c=>{const y=[];for(const b of c)t.some(([g])=>(0,w.areSameExtensions)(g.identifier,b.identifier)&&g.manifest.version!==b.version)?s.push(b):y.push(b);for(const[b,g]of t)if(!y.some(D=>(0,w.areSameExtensions)(D.identifier,b.identifier)&&D.version===b.manifest.version)){const D={identifier:b.identifier,version:b.manifest.version,location:b.location,metadata:g};o.push(D),y.push(D)}return o.length&&this.b.fire({extensions:o,profileLocation:i}),s.length&&this.f.fire({extensions:s,profileLocation:i}),y}),o.length&&this.c.fire({extensions:o,profileLocation:i}),s.length&&this.g.fire({extensions:s,profileLocation:i}),o}catch(c){throw o.length&&this.c.fire({extensions:o,error:c,profileLocation:i}),s.length&&this.g.fire({extensions:s,error:c,profileLocation:i}),c}}async updateMetadata(t,i){const s=[];return await this.p(i,o=>{const c=[];for(const y of o){const b=t.find(([g])=>(0,w.areSameExtensions)(g.identifier,y.identifier)&&g.manifest.version===y.version);b&&(y.metadata={...y.metadata,...b[1]},s.push(y)),c.push(y)}return c}),s}async removeExtensionFromProfile(t,i){const s=[];this.f.fire({extensions:s,profileLocation:i});try{await this.p(i,o=>{const c=[];for(const y of o)(0,w.areSameExtensions)(y.identifier,t.identifier)?s.push(y):c.push(y);return s.length&&this.f.fire({extensions:s,profileLocation:i}),c}),s.length&&this.g.fire({extensions:s,profileLocation:i})}catch(o){throw s.length&&this.g.fire({extensions:s,error:o,profileLocation:i}),o}}async p(t,i,s){return this.v(t).queue(async()=>{let o=[],c;try{const y=await this.j.readFile(t);c=JSON.parse(y.value.toString().trim()||"[]")}catch(y){if((0,P.toFileOperationResult)(y)!==1)throw y;if(this.l.extUri.isEqual(t,this.k.defaultProfile.extensionsResource)&&(c=await this.u()),!c&&s?.bailOutWhenFileNotFound)throw new d((0,a.getErrorMessage)(y),"ERROR_PROFILE_NOT_FOUND")}if(c){Array.isArray(c)||this.q(t);let y=!1;for(const b of c){L(b)||this.q(t);let g;if((0,E.isString)(b.relativeLocation)&&b.relativeLocation)g=this.s(b.relativeLocation);else if((0,E.isString)(b.location))g=this.s(b.location),y=!0,b.relativeLocation=b.location,b.location=g.toJSON();else{g=R.URI.revive(b.location);const D=this.r(g);D&&(y=!0,b.relativeLocation=D)}o.push({identifier:b.identifier,location:g,version:b.version,metadata:b.metadata})}y&&await this.j.writeFile(t,U.VSBuffer.fromString(JSON.stringify(c)))}if(i){o=i(o);const y=o.map(b=>({identifier:b.identifier,version:b.version,location:b.location.toJSON(),relativeLocation:this.r(b.location),metadata:b.metadata}));await this.j.writeFile(t,U.VSBuffer.fromString(JSON.stringify(y)))}return o})}q(t){const i=new d(`Invalid extensions content in ${t.toString()}`,"ERROR_INVALID_CONTENT");throw this.m.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}r(t){return this.l.extUri.isEqual(this.l.extUri.dirname(t),this.i)?this.l.extUri.basename(t):void 0}s(t){return this.l.extUri.joinPath(this.i,t)}async u(){return this.t||(this.t=(async()=>{const t=this.l.extUri.joinPath(this.k.defaultProfile.location,"extensions.json"),i=this.l.extUri.joinPath(this.i,".init-default-profile-extensions");let s;try{s=(await this.j.readFile(t)).value.toString()}catch(c){if((0,P.toFileOperationResult)(c)===1)return;throw c}this.n.info("Migrating extensions from old default profile location",t.toString());let o;try{const c=JSON.parse(s);Array.isArray(c)&&c.every(y=>L(y))?o=c:this.n.warn("Skipping migrating from old default profile locaiton: Found invalid data",c)}catch(c){this.n.error(c)}if(o)try{await this.j.createFile(this.k.defaultProfile.extensionsResource,U.VSBuffer.fromString(JSON.stringify(o)),{overwrite:!1}),this.n.info("Migrated extensions from old default profile location to new location",t.toString(),this.k.defaultProfile.extensionsResource.toString())}catch(c){if((0,P.toFileOperationResult)(c)===3)this.n.info("Migration from old default profile location to new location is done by another window",t.toString(),this.k.defaultProfile.extensionsResource.toString());else throw c}try{await this.j.del(t)}catch(c){(0,P.toFileOperationResult)(c)!==1&&this.n.error(c)}try{await this.j.del(i)}catch(c){(0,P.toFileOperationResult)(c)!==1&&this.n.error(c)}return o})()),this.t}v(t){let i=this.h.get(t);return i||(i=new O.Queue,this.h.set(t,i)),i}};v=ye([G(1,P.IFileService),G(2,f.IUserDataProfilesService),G(3,m.IUriIdentityService),G(4,u.ITelemetryService),G(5,p.ILogService)],v),e.AbstractExtensionsProfileScannerService=v;function L(r){return(0,E.isObject)(r)&&(0,I.isIExtensionIdentifier)(r.identifier)&&(n(r.location)||(0,E.isString)(r.location)&&r.location)&&((0,E.isUndefined)(r.relativeLocation)||(0,E.isString)(r.relativeLocation))&&r.version&&(0,E.isString)(r.version)}function n(r){return r?(0,E.isString)(r.path)&&(0,E.isString)(r.scheme):!1}}),define(re[80],oe([0,1,21,6,32,16,10,35,140,2,22,13,4,23,55,91,12,11,163,15,33,46,68,14,5,9,26,3,92,51,18,30,196]),function(te,e,O,U,l,T,N,R,I,w,P,S,p,f,m,E,a,u,h,d,v,L,n,r,t,i,s,o,c,y,b,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var A;(function(J){function K(Y,H){if(Y===H)return!0;const $=Object.keys(Y),X=new Set;for(const ie of Object.keys(H))X.add(ie);if($.length!==X.size)return!1;for(const ie of $){if(Y[ie]!==H[ie])return!1;X.delete(ie)}return X.size===0}J.equals=K})(A=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,t.createDecorator)("IExtensionsScannerService");let F=class extends w.Disposable{constructor(K,Y,H,$,X,ie,se,ae,q,C,k,M){super(),this.systemExtensionsLocation=K,this.userExtensionsLocation=Y,this.l=H,this.m=$,this.n=X,this.p=ie,this.q=se,this.r=ae,this.s=q,this.t=C,this.u=k,this.v=M,this.g=this.D(new o.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,f.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.D(this.v.createInstance(V,(0,f.joinPath)(this.m,L.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.D(this.v.createInstance(V,(0,f.joinPath)(this.m,L.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.D(this.v.createInstance(x,this.h)),this.y=void 0,this.D(this.i.onDidChangeCache(()=>this.g.fire(0))),this.D(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.w||(this.w=(0,v.computeTargetPlatform)(this.q,this.r)),this.w}async scanAllExtensions(K,Y,H){const[$,X]=await Promise.all([this.scanSystemExtensions(K),this.scanUserExtensions(Y)]),ie=H?await this.scanExtensionsUnderDevelopment(K,[...$,...X]):[];return this.F($,X,ie,await this.getTargetPlatform(),!0)}async scanSystemExtensions(K){const Y=[];Y.push(this.G(!!K.useCache,K.language)),Y.push(this.H(K.language,!!K.checkControlFile));const[H,$]=await Promise.all(Y);return this.C([...H,...$],0,K,!1)}async scanUserExtensions(K){const Y=K.profileLocation??this.userExtensionsLocation;this.r.trace("Started scanning user extensions",Y);const H=this.u.extUri.isEqual(K.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,$=await this.J(Y,!!K.profileLocation,1,!K.includeUninstalled,K.language,!0,H),X=K.useCache&&!$.devMode&&$.excludeObsolete?this.j:this.k;let ie;try{ie=await X.scanExtensions($)}catch(se){if(se instanceof y.ExtensionsProfileScanningError&&se.code==="ERROR_PROFILE_NOT_FOUND")await this.z(),ie=await X.scanExtensions($);else throw se}return ie=await this.C(ie,1,K,!0),this.r.trace("Scanned user extensions:",ie.length),ie}async scanExtensionsUnderDevelopment(K,Y){if(this.s.isExtensionDevelopment&&this.s.extensionDevelopmentLocationURI){const H=(await Promise.all(this.s.extensionDevelopmentLocationURI.filter($=>$.scheme===P.Schemas.file).map(async $=>{const X=await this.J($,!1,1,!0,K.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(X)).map(se=>(se.type=Y.find(ae=>(0,v.areSameExtensions)(ae.identifier,se.identifier))?.type??se.type,this.k.validate(se,X)))}))).flat();return this.C(H,"development",K,!0)}return[]}async scanExistingExtension(K,Y,H){const $=await this.J(K,!1,Y,!0,H.language,!0,void 0),X=await this.k.scanExtension($);return!X||!H.includeInvalid&&!X.isValid?null:X}async scanOneOrMultipleExtensions(K,Y,H){const $=await this.J(K,!1,Y,!0,H.language,!0,void 0),X=await this.k.scanOneOrMultipleExtensions($);return this.C(X,Y,H,!0)}async scanMetadata(K){const Y=(0,f.joinPath)(K,"package.json"),H=(await this.q.readFile(Y)).value.toString();return JSON.parse(H).__metadata}async updateMetadata(K,Y){const H=(0,f.joinPath)(K,"package.json"),$=(await this.q.readFile(H)).value.toString(),X=JSON.parse($);Y.isMachineScoped=Y.isMachineScoped||void 0,Y.isBuiltin=Y.isBuiltin||void 0,X.__metadata={...X.__metadata,...Y},await this.q.writeFile((0,f.joinPath)(K,"package.json"),T.VSBuffer.fromString(JSON.stringify(X,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.p.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(K){if(K instanceof y.ExtensionsProfileScanningError&&K.code==="ERROR_PROFILE_NOT_FOUND")await this.z();else throw K}}async z(){return this.y||(this.y=(async()=>{try{this.r.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const K=await this.scanUserExtensions({includeInvalid:!0});if(K.length)await this.p.addExtensionsToProfile(K.map(Y=>[Y,Y.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.q.createFile(this.n.defaultProfile.extensionsResource,T.VSBuffer.fromString(JSON.stringify([])))}catch(Y){(0,r.toFileOperationResult)(Y)!==1&&this.r.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,N.getErrorMessage)(Y))}this.r.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(K){this.r.error(K)}finally{this.y=void 0}})()),this.y}async C(K,Y,H,$){return H.includeAllVersions||(K=this.F(Y===0?K:void 0,Y===1?K:void 0,Y==="development"?K:void 0,await this.getTargetPlatform(),$)),H.includeInvalid||(K=K.filter(X=>X.isValid)),K.sort((X,ie)=>{const se=S.basename(X.location.fsPath),ae=S.basename(ie.location.fsPath);return se<ae?-1:se>ae?1:0})}F(K,Y,H,$,X){const ie=(ae,q,C)=>{if(ae.isValid&&!q.isValid)return!1;if(ae.isValid===q.isValid){if(X&&m.gt(ae.manifest.version,q.manifest.version))return this.r.debug(`Skipping extension ${q.location.path} with lower version ${q.manifest.version} in favour of ${ae.location.path} with version ${ae.manifest.version}`),!1;if(m.eq(ae.manifest.version,q.manifest.version)){if(ae.type===0)return this.r.debug(`Skipping extension ${q.location.path} in favour of system extension ${ae.location.path} with same version`),!1;if(ae.targetPlatform===$)return this.r.debug(`Skipping extension ${q.location.path} from different target platform ${q.targetPlatform}`),!1}}return C?this.r.warn(`Overwriting user extension ${ae.location.path} with ${q.location.path}.`):this.r.debug(`Overwriting user extension ${ae.location.path} with ${q.location.path}.`),!0},se=new L.ExtensionIdentifierMap;return K?.forEach(ae=>{const q=se.get(ae.identifier.id);(!q||ie(q,ae,!1))&&se.set(ae.identifier.id,ae)}),Y?.forEach(ae=>{const q=se.get(ae.identifier.id);if(!q&&K&&ae.type===0){this.r.debug(`Skipping obsolete system extension ${ae.location.path}.`);return}(!q||ie(q,ae,!1))&&se.set(ae.identifier.id,ae)}),H?.forEach(ae=>{const q=se.get(ae.identifier.id);(!q||ie(q,ae,!0))&&se.set(ae.identifier.id,ae),se.set(ae.identifier.id,ae)}),[...se.values()]}async G(K,Y){this.r.trace("Started scanning system extensions");const H=await this.J(this.systemExtensionsLocation,!1,0,!0,Y,!0,void 0),X=await(K&&!H.devMode?this.i:this.k).scanExtensions(H);return this.r.trace("Scanned system extensions:",X.length),X}async H(K,Y){const H=this.s.isBuilt?[]:this.t.builtInExtensions;if(!H?.length)return[];this.r.trace("Started scanning dev system extensions");const $=Y?await this.I():{},X=[],ie=u.URI.file(S.normalize(S.join(P.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ae of H){const q=$[ae.name]||"marketplace";switch(q){case"disabled":break;case"marketplace":X.push((0,f.joinPath)(ie,ae.name));break;default:X.push(u.URI.file(q));break}}const se=await Promise.all(X.map(async ae=>this.k.scanExtension(await this.J(ae,!1,0,!0,K,!0,void 0))));return this.r.trace("Scanned dev system extensions:",se.length),(0,O.coalesce)(se)}async I(){try{const K=await this.q.readFile(this.l);return JSON.parse(K.value.toString())}catch{return{}}}async J(K,Y,H,$,X,ie,se){const ae=await this.f(X??p.language),q=await this.L(K),C=Y&&!this.u.extUri.isEqual(K,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,k=C?await this.L(C):void 0;return new j(K,q,C,k,Y,se,H,$,ie,this.t.version,this.t.date,this.t.commit,!this.s.isBuilt,X,ae)}async L(K){try{const Y=await this.q.stat(K);if(typeof Y.mtime=="number")return Y.mtime}catch{}}};F=ye([G(4,b.IUserDataProfilesService),G(5,y.IExtensionsProfileScannerService),G(6,r.IFileService),G(7,i.ILogService),G(8,d.IEnvironmentService),G(9,s.IProductService),G(10,g.IUriIdentityService),G(11,t.IInstantiationService)],F),e.AbstractExtensionsScannerService=F;class j{constructor(K,Y,H,$,X,ie,se,ae,q,C,k,M,z,_,W){this.location=K,this.mtime=Y,this.applicationExtensionslocation=H,this.applicationExtensionslocationMtime=$,this.profile=X,this.profileScanOptions=ie,this.type=se,this.excludeObsolete=ae,this.validate=q,this.productVersion=C,this.productDate=k,this.productCommit=M,this.devMode=z,this.language=_,this.translations=W}static createNlsConfiguration(K){return{language:K.language,pseudo:K.language==="pseudo",devMode:K.devMode,translations:K.translations}}static equals(K,Y){return(0,f.isEqual)(K.location,Y.location)&&K.mtime===Y.mtime&&(0,f.isEqual)(K.applicationExtensionslocation,Y.applicationExtensionslocation)&&K.applicationExtensionslocationMtime===Y.applicationExtensionslocationMtime&&K.profile===Y.profile&&l.equals(K.profileScanOptions,Y.profileScanOptions)&&K.type===Y.type&&K.excludeObsolete===Y.excludeObsolete&&K.validate===Y.validate&&K.productVersion===Y.productVersion&&K.productDate===Y.productDate&&K.productCommit===Y.productCommit&&K.devMode===Y.devMode&&K.language===Y.language&&A.equals(K.translations,Y.translations)}}e.ExtensionScannerInput=j;let x=class extends w.Disposable{constructor(K,Y,H,$,X){super(),this.f=K,this.g=Y,this.h=H,this.i=$,this.j=X}async scanExtensions(K){const Y=K.profile?await this.l(K):await this.k(K);let H={};if(K.excludeObsolete&&K.type===1)try{const $=(await this.i.readFile(this.f)).value.toString();H=JSON.parse($)}catch{}return(0,a.isEmptyObject)(H)?Y:Y.filter($=>!H[v.ExtensionKey.create($).toString()])}async k(K){const Y=await this.i.resolve(K.location);if(!Y.children?.length)return[];const H=await Promise.all(Y.children.map(async $=>{if(!$.isDirectory||K.type===1&&(0,f.basename)($.resource).indexOf(".")===0)return null;const X=new j($.resource,K.mtime,K.applicationExtensionslocation,K.applicationExtensionslocationMtime,K.profile,K.profileScanOptions,K.type,K.excludeObsolete,K.validate,K.productVersion,K.productDate,K.productCommit,K.devMode,K.language,K.translations);return this.scanExtension(X)}));return(0,O.coalesce)(H).sort(($,X)=>$.location.path<X.location.path?-1:1)}async l(K){let Y=await this.m(K.location,()=>!0,K);if(K.applicationExtensionslocation&&!this.h.extUri.isEqual(K.location,K.applicationExtensionslocation)){Y=Y.filter($=>!$.metadata?.isApplicationScoped);const H=await this.m(K.applicationExtensionslocation,$=>!!$.metadata?.isApplicationScoped,K);Y.push(...H)}return Y}async m(K,Y,H){const $=await this.g.scanProfileExtensions(K,H.profileScanOptions);if(!$.length)return[];const X=await Promise.all($.map(async ie=>{if(Y(ie)){const se=new j(ie.location,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.profileScanOptions,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(se,ie.metadata)}return null}));return(0,O.coalesce)(X)}async scanOneOrMultipleExtensions(K){try{if(await this.i.exists((0,f.joinPath)(K.location,"package.json"))){const Y=await this.scanExtension(K);return Y?[Y]:[]}else return await this.scanExtensions(K)}catch(Y){return this.j.error(`Error scanning extensions at ${K.location.path}:`,(0,N.getErrorMessage)(Y)),[]}}async scanExtension(K,Y){try{let H=await this.scanExtensionManifest(K.location);if(H){H.publisher||(H.publisher=L.UNDEFINED_PUBLISHER),Y=Y??H.__metadata,delete H.__metadata;const $=(0,v.getGalleryExtensionId)(H.publisher,H.name),X=Y?.id?{id:$,uuid:Y.id}:{id:$},ie=Y?.isSystem?0:K.type,se=ie===0||!!Y?.isBuiltin;H=await this.n(K.location,H,j.createNlsConfiguration(K));const ae={type:ie,identifier:X,manifest:H,location:K.location,isBuiltin:se,targetPlatform:Y?.targetPlatform??"undefined",metadata:Y,isValid:!0,validations:[]};return K.validate?this.validate(ae,K):ae}}catch(H){K.type!==0&&this.j.error(H)}return null}validate(K,Y){let H=!0;const $=(0,n.validateExtensionManifest)(Y.productVersion,Y.productDate,Y.location,K.manifest,K.isBuiltin);for(const[X,ie]of $)X===E.default.Error&&(H=!1,this.j.error(this.s(Y.location,ie)));return K.isValid=H,K.validations=$,K}async scanExtensionManifest(K){const Y=(0,f.joinPath)(K,"package.json");let H;try{H=(await this.i.readFile(Y)).value.toString()}catch(X){return(0,r.toFileOperationResult)(X)!==1&&this.j.error(this.s(K,(0,h.localize)(0,null,Y.path,X.message))),null}let $;try{$=JSON.parse(H)}catch{const ie=[];(0,R.parse)(H,ie);for(const se of ie)this.j.error(this.s(K,(0,h.localize)(1,null,Y.path,se.offset,se.length,(0,I.getParseErrorMessage)(se.error))));return null}return(0,R.getNodeType)($)!=="object"?(this.j.error(this.s(K,(0,h.localize)(2,null,Y.path))),null):$}async n(K,Y,H){const $=await this.p(K,Y,H);if($)try{const X=[],ie=await this.q($.default,X);if(X.length>0)return X.forEach(ae=>{this.j.error(this.s(K,(0,h.localize)(3,null,$.default?.path,(0,I.getParseErrorMessage)(ae.error))))}),Y;if((0,R.getNodeType)($)!=="object")return this.j.error(this.s(K,(0,h.localize)(4,null,$.default?.path))),Y;const se=$.values||Object.create(null);return(0,D.localizeManifest)(Y,se,ie)}catch{}return Y}async p(K,Y,H){const $=(0,f.joinPath)(K,"package.nls.json"),X=(q,C)=>{C.forEach(k=>{this.j.error(this.s(K,(0,h.localize)(5,null,q?.path,(0,I.getParseErrorMessage)(k.error))))})},ie=q=>{this.j.error(this.s(K,(0,h.localize)(6,null,q?.path)))},se=`${Y.publisher}.${Y.name}`,ae=H.translations[se];if(ae)try{const q=u.URI.file(ae),C=(await this.i.readFile(q)).value.toString(),k=[],M=(0,R.parse)(C,k);return k.length>0?(X(q,k),{values:void 0,default:$}):(0,R.getNodeType)(M)!=="object"?(ie(q),{values:void 0,default:$}):{values:M.contents?M.contents.package:void 0,default:$}}catch{return{values:void 0,default:$}}else{if(!await this.i.exists($))return;let C;try{C=await this.r(K,H)}catch{return}if(!C.localized)return{values:void 0,default:C.original};try{const k=(await this.i.readFile(C.localized)).value.toString(),M=[],z=(0,R.parse)(k,M);return M.length>0?(X(C.localized,M),{values:void 0,default:C.original}):(0,R.getNodeType)(z)!=="object"?(ie(C.localized),{values:void 0,default:C.original}):{values:z,default:C.original}}catch{return{values:void 0,default:C.original}}}}async q(K,Y){if(K)try{const H=(await this.i.readFile(K)).value.toString();return(0,R.parse)(H,Y)}catch{}}r(K,Y){return new Promise((H,$)=>{const X=ie=>{const se=(0,f.joinPath)(K,`package.nls.${ie}.json`);this.i.exists(se).then(ae=>{ae&&H({localized:se,original:(0,f.joinPath)(K,"package.nls.json")});const q=ie.lastIndexOf("-");q===-1?H({localized:(0,f.joinPath)(K,"package.nls.json"),original:null}):(ie=ie.substring(0,q),X(ie))})};if(Y.devMode||Y.pseudo||!Y.language)return H({localized:(0,f.joinPath)(K,"package.nls.json"),original:null});X(Y.language)})}s(K,Y){return`[${K.path}]: ${Y}`}};x=ye([G(1,y.IExtensionsProfileScannerService),G(2,g.IUriIdentityService),G(3,r.IFileService),G(4,i.ILogService)],x);let V=class extends x{constructor(K,Y,H,$,X,ie){super(Y,H,$,X,ie),this.w=K,this.u=this.D(new U.ThrottledDelayer(3e3)),this.v=this.D(new o.Emitter),this.onDidChangeCache=this.v.event}async scanExtensions(K){const Y=await this.y();if(this.t=K,Y&&Y.input&&j.equals(Y.input,this.t))return this.j.debug("Using cached extensions scan result",K.location.toString()),this.u.trigger(()=>this.C()),Y.result.map($=>($.location=u.URI.revive($.location),$));const H=await super.scanExtensions(K);return await this.z({input:K,result:H}),H}async y(){try{const K=await this.i.readFile(this.w),Y=JSON.parse(K.value.toString());return{result:Y.result,input:(0,c.revive)(Y.input)}}catch(K){this.j.debug("Error while reading the extension cache file:",this.w.path,(0,N.getErrorMessage)(K))}return null}async z(K){try{await this.i.writeFile(this.w,T.VSBuffer.fromString(JSON.stringify(K)))}catch(Y){this.j.debug("Error while writing the extension cache file:",this.w.path,(0,N.getErrorMessage)(Y))}}async C(){if(!this.t)return;const K=await this.y();if(!K)return;const Y=K.result,H=JSON.parse(JSON.stringify(await super.scanExtensions(this.t)));if(!l.equals(H,Y))try{this.j.info("Invalidating Cache",Y,H),await this.i.del(this.w),this.v.fire()}catch($){this.j.error($)}}};V=ye([G(2,y.IExtensionsProfileScannerService),G(3,g.IUriIdentityService),G(4,r.IFileService),G(5,i.ILogService)],V);function B(J,K){const Y=(0,v.getExtensionId)(J.manifest.publisher,J.manifest.name);return{id:Y,identifier:new L.ExtensionIdentifier(Y),isBuiltin:J.type===0,isUserBuiltin:J.type===1&&J.isBuiltin,isUnderDevelopment:K,extensionLocation:J.location,uuid:J.identifier.uuid,targetPlatform:J.targetPlatform,...J.manifest}}e.toExtensionDescription=B;class Z extends F{constructor(K,Y,H,$,X,ie,se,ae,q,C,k,M){super(K,Y,(0,f.joinPath)(H,".vscode-oss-dev","extensions","control.json"),(0,f.joinPath)($,L.MANIFEST_CACHE_FOLDER),X,ie,se,ae,q,C,k,M),this.M=(async()=>{if(p.translationsConfigFile)try{const z=await this.q.readFile(u.URI.file(p.translationsConfigFile));return JSON.parse(z.value.toString())}catch{}return Object.create(null)})()}f(K){return this.M}}e.NativeExtensionsScannerService=Z}),define(re[267],oe([0,1,50,6,38,3,2,22,13,28,9,18]),function(te,e,O,U,l,T,N,R,I,w,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let p=class extends N.Disposable{constructor(m,E){super(),this.b=m,this.f=E,this.a=new U.Limiter(5)}async postUninstall(m){const E=this.g(m,"uninstall");E&&(this.f.info(m.identifier.id,m.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(E.script,"uninstall",E.args,!0,m),this.f.info("Finished running post uninstall script",m.identifier.id,m.manifest.version)}catch(a){this.f.error("Failed to run post uninstall script",m.identifier.id,m.manifest.version),this.f.error(a)}}));try{await w.Promises.rm(this.j(m))}catch(a){this.f.error("Error while removing extension storage path",m.identifier.id),this.f.error(a)}}g(m,E){const a=`vscode:${E}`;if(m.location.scheme===R.Schemas.file&&m.manifest&&m.manifest.scripts&&typeof m.manifest.scripts[a]=="string"){const u=m.manifest.scripts[a].split(" ");return u.length<2||u[0]!=="node"||!u[1]?(this.f.warn(m.identifier.id,m.manifest.version,`${a} should be a node script`),null):{script:(0,I.join)(m.location.fsPath,u[1]),args:u.slice(2)||[]}}return null}h(m,E,a,u,h){return new Promise((d,v)=>{const L=this.i(m,E,a,h);let n;const r=t=>{n&&(clearTimeout(n),n=null),t?v(t):d(void 0)};L.on("error",t=>{r((0,l.toErrorMessage)(t)||"Unknown")}),L.on("exit",(t,i)=>{r(t?`post-${E} process exited with code ${t}`:void 0)}),u&&(n=setTimeout(()=>{n=null,L.kill(),v("timed out")},5e3))})}i(m,E,a,u){const h={silent:!0,execArgv:void 0},d=(0,O.fork)(m,[`--type=extension-post-${E}`,...a],h);d.stdout.setEncoding("utf8"),d.stderr.setEncoding("utf8");const v=T.Event.fromNodeEventEmitter(d.stdout,"data"),L=T.Event.fromNodeEventEmitter(d.stderr,"data");v(t=>this.f.info(u.identifier.id,u.manifest.version,`post-${E}`,t)),L(t=>this.f.error(u.identifier.id,u.manifest.version,`post-${E}`,t));const n=T.Event.any(T.Event.map(v,t=>({data:`%c${t}`,format:[""]})),T.Event.map(L,t=>({data:`%c${t}`,format:["color: red"]})));return T.Event.debounce(n,(t,i)=>t?{data:t.data+i.data,format:[...t.format,...i.format]}:{data:i.data,format:i.format},100)(t=>{console.group(u.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),d}j(m){return(0,I.join)(this.b.defaultProfile.globalStorageHome.fsPath,m.identifier.id.toLowerCase())}};p=ye([G(0,S.IUserDataProfilesService),G(1,P.ILogService)],p),e.ExtensionsLifecycle=p}),define(re[268],oe([0,1,9,18,30,19,51,14,15,11]),function(te,e,O,U,l,T,N,R,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let P=class extends N.AbstractExtensionsProfileScannerService{constructor(p,f,m,E,a,u){super(w.URI.file(p.extensionsPath),f,m,E,a,u)}};P=ye([G(0,I.INativeEnvironmentService),G(1,R.IFileService),G(2,U.IUserDataProfilesService),G(3,l.IUriIdentityService),G(4,T.ITelemetryService),G(5,O.ILogService)],P),e.ExtensionsProfileScannerService=P}),define(re[269],oe([0,1,11,15,51,80,14,5,9,26,30,18]),function(te,e,O,U,l,T,N,R,I,w,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let p=class extends T.NativeExtensionsScannerService{constructor(m,E,a,u,h,d,v,L){super(O.URI.file(h.builtinExtensionsPath),O.URI.file(h.extensionsPath),h.userHome,O.URI.file(h.userDataPath),m,E,a,u,h,d,v,L)}};p=ye([G(0,S.IUserDataProfilesService),G(1,l.IExtensionsProfileScannerService),G(2,N.IFileService),G(3,I.ILogService),G(4,U.INativeEnvironmentService),G(5,w.IProductService),G(6,P.IUriIdentityService),G(7,R.IInstantiationService)],p),e.ExtensionsScannerService=p}),define(re[20],oe([0,1,6,3,2,104,12,67,5,18]),function(te,e,O,U,l,T,N,R,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,I.createDecorator)("storageService");var P;(function(h){h[h.NONE=0]="NONE",h[h.SHUTDOWN=1]="SHUTDOWN"})(P=e.WillSaveStateReason||(e.WillSaveStateReason={}));var S;(function(h){h[h.APPLICATION=-1]="APPLICATION",h[h.PROFILE=0]="PROFILE",h[h.WORKSPACE=1]="WORKSPACE"})(S=e.StorageScope||(e.StorageScope={}));var p;(function(h){h[h.USER=0]="USER",h[h.MACHINE=1]="MACHINE"})(p=e.StorageTarget||(e.StorageTarget={}));function f(h){const d=h.get(e.TARGET_KEY);if(d)try{return JSON.parse(d)}catch{}return Object.create(null)}e.loadKeyTargets=f;class m extends l.Disposable{constructor(d={flushInterval:m.a}){super(),this.j=d,this.b=this.D(new U.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.D(new U.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.D(new U.Emitter),this.onWillSaveState=this.f.event,this.h=this.D(new O.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.D(new l.MutableDisposable),this.u=void 0,this.w=void 0,this.z=void 0}k(){this.i.value=(0,O.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,l.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,T.mark)("code/willInitStorage");try{await this.J()}finally{(0,T.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(d,v){if(v===e.TARGET_KEY){switch(d){case-1:this.z=void 0;break;case 0:this.w=void 0;break;case 1:this.u=void 0;break}this.c.fire({scope:d})}else this.b.fire({scope:d,key:v,target:this.F(d)[v]})}q(d){this.f.fire({reason:d})}get(d,v,L){return this.L(v)?.get(d,L)}getBoolean(d,v,L){return this.L(v)?.getBoolean(d,L)}getNumber(d,v,L){return this.L(v)?.getNumber(d,L)}store(d,v,L,n){if((0,N.isUndefinedOrNull)(v)){this.remove(d,L);return}this.r(()=>{this.t(d,L,n),this.L(L)?.set(d,v)})}remove(d,v){this.r(()=>{this.t(d,v,void 0),this.L(v)?.delete(d)})}r(d){this.b.pause(),this.c.pause();try{d()}finally{this.b.resume(),this.c.resume()}}keys(d,v){const L=[],n=this.F(d);for(const r of Object.keys(n))n[r]===v&&L.push(r);return L}t(d,v,L){const n=this.F(v);typeof L=="number"?n[d]!==L&&(n[d]=L,this.L(v)?.set(e.TARGET_KEY,JSON.stringify(n))):typeof n[d]=="number"&&(delete n[d],this.L(v)?.set(e.TARGET_KEY,JSON.stringify(n)))}get v(){return this.u||(this.u=this.G(1)),this.u}get y(){return this.w||(this.w=this.G(0)),this.w}get C(){return this.z||(this.z=this.G(-1)),this.z}F(d){switch(d){case-1:return this.C;case 0:return this.y;default:return this.v}}G(d){const v=this.L(d);return v?f(v):Object.create(null)}isNew(d){return this.getBoolean(e.IS_NEW_KEY,d)===!0}async flush(d=P.NONE){this.f.fire({reason:d});const v=this.L(-1),L=this.L(0),n=this.L(1);switch(d){case P.NONE:await O.Promises.settled([v?.whenFlushed()??Promise.resolve(),L?.whenFlushed()??Promise.resolve(),n?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await O.Promises.settled([v?.flush(0)??Promise.resolve(),L?.flush(0)??Promise.resolve(),n?.flush(0)??Promise.resolve()]);break}}async log(){const d=this.L(-1)?.items??new Map,v=this.L(0)?.items??new Map,L=this.L(1)?.items??new Map;return u(d,v,L,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(d,v){return this.q(P.NONE),(0,w.isUserDataProfile)(d)?this.N(d,v):this.O(d,v)}H(d,v){return!(d.id===v.id||E(v)&&E(d))}I(d,v,L,n){this.r(()=>{if(n)for(const[r,t]of d)v.set(r,t);else{const r=new Set;for(const[t,i]of d)r.add(t),v.get(t)!==i&&this.n(L,t);for(const[t]of v.items)r.has(t)||this.n(L,t)}})}}m.a=60*1e3,e.AbstractStorageService=m;function E(h){return h.isDefault||!!h.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=E;class a extends m{constructor(){super(),this.p=this.D(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.P=this.D(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.D(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.D(this.Q.onDidChangeStorage(d=>this.n(1,d))),this.D(this.P.onDidChangeStorage(d=>this.n(0,d))),this.D(this.p.onDidChangeStorage(d=>this.n(-1,d)))}L(d){switch(d){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(d){switch(d){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(d){return!1}}e.InMemoryStorageService=a;async function u(h,d,v,L,n,r){const t=A=>{try{return JSON.parse(A)}catch{return A}},i=new Map,s=new Map;h.forEach((A,F)=>{i.set(F,A),s.set(F,t(A))});const o=new Map,c=new Map;d.forEach((A,F)=>{o.set(F,A),c.set(F,t(A))});const y=new Map,b=new Map;v.forEach((A,F)=>{y.set(F,A),b.set(F,t(A))}),console.group(L!==n?`Storage: Application (path: ${L})`:`Storage: Application & Profile (path: ${L}, default profile)`);const g=[];if(i.forEach((A,F)=>{g.push({key:F,value:A})}),console.table(g),console.groupEnd(),console.log(s),L!==n){console.group(`Storage: Profile (path: ${n}, profile specific)`);const A=[];o.forEach((F,j)=>{A.push({key:j,value:F})}),console.table(A),console.groupEnd(),console.log(c)}console.group(`Storage: Workspace (path: ${r})`);const D=[];y.forEach((A,F)=>{D.push({key:F,value:A})}),console.table(D),console.groupEnd(),console.log(b)}e.logStorage=u}),define(re[120],oe([0,1,3,2,12,29,33,20]),function(te,e,O,U,l,T,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let I=class extends U.Disposable{constructor(S,p){super(),this.a=new O.Emitter,this.onDidChangeEnablement=this.a.event,this.b=this.D(new w(S)),this.D(this.b.onDidChange(f=>this.a.fire({extensions:f,source:"storage"}))),this.D(p.onDidInstallExtensions(f=>f.forEach(({local:m,operation:E})=>{m&&E===4&&this.f(m.identifier)})))}async enableExtension(S,p){return this.f(S)?(this.a.fire({extensions:[S],source:p}),!0):!1}async disableExtension(S,p){return this.c(S)?(this.a.fire({extensions:[S],source:p}),!0):!1}getDisabledExtensions(){return this.h(T.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(S){const p=this.getDisabledExtensions();return p.every(f=>!(0,N.areSameExtensions)(f,S))?(p.push(S),this.g(p),!0):!1}f(S){const p=this.getDisabledExtensions();for(let f=0;f<p.length;f++){const m=p[f];if((0,N.areSameExtensions)(m,S))return p.splice(f,1),this.g(p),!0}return!1}g(S){this.i(T.DISABLED_EXTENSIONS_STORAGE_PATH,S)}h(S){return this.b.get(S,0)}i(S,p){this.b.set(S,p,0)}};I=ye([G(0,R.IStorageService),G(1,T.IExtensionManagementService)],I),e.GlobalExtensionEnablementService=I;class w extends U.Disposable{constructor(S){super(),this.c=S,this.a=Object.create(null),this.b=this.D(new O.Emitter),this.onDidChange=this.b.event,this.D(S.onDidChangeValue(p=>this.f(p)))}get(S,p){let f;return p===0?((0,l.isUndefinedOrNull)(this.a[S])&&(this.a[S]=this.g(S,p)),f=this.a[S]):f=this.g(S,p),JSON.parse(f)}set(S,p,f){const m=JSON.stringify(p.map(({id:a,uuid:u})=>({id:a,uuid:u})));this.g(S,f)!==m&&(f===0&&(p.length?this.a[S]=m:delete this.a[S]),this.h(S,p.length?m:void 0,f))}f(S){if(S.scope===0&&!(0,l.isUndefinedOrNull)(this.a[S.key])&&this.g(S.key,S.scope)!==this.a[S.key]){const f=this.get(S.key,S.scope);delete this.a[S.key];const m=this.get(S.key,S.scope),E=f.filter(u=>!m.some(h=>(0,N.areSameExtensions)(u,h))),a=m.filter(u=>!f.some(h=>(0,N.areSameExtensions)(h,u)));(E.length||a.length)&&this.b.fire([...E,...a])}}g(S,p){return this.c.get(S,p,"[]")}h(S,p,f){p?this.c.store(S,p,f,1):this.c.remove(S,f)}}e.StorageManager=w}),define(re[270],oe([0,1,21,25,10,4,36,12,11,17,15,29,33,68,14,9,26,59,238,20,19]),function(te,e,O,U,l,T,N,R,I,w,P,S,p,f,m,E,a,u,h,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const L=T.isWeb?"web":(0,S.getTargetPlatform)(T.platform,N.arch),n="X-Market-Search-Activity-Id";var r;(function(C){C[C.None=0]="None",C[C.IncludeVersions=1]="IncludeVersions",C[C.IncludeFiles=2]="IncludeFiles",C[C.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",C[C.IncludeSharedAccounts=8]="IncludeSharedAccounts",C[C.IncludeVersionProperties=16]="IncludeVersionProperties",C[C.ExcludeNonValidated=32]="ExcludeNonValidated",C[C.IncludeInstallationTargets=64]="IncludeInstallationTargets",C[C.IncludeAssetUri=128]="IncludeAssetUri",C[C.IncludeStatistics=256]="IncludeStatistics",C[C.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",C[C.Unpublished=4096]="Unpublished",C[C.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(r||(r={}));function t(...C){return String(C.reduce((k,M)=>k|M,0))}var i;(function(C){C[C.Tag=1]="Tag",C[C.ExtensionId=4]="ExtensionId",C[C.Category=5]="Category",C[C.ExtensionName=7]="ExtensionName",C[C.Target=8]="Target",C[C.Featured=9]="Featured",C[C.SearchText=10]="SearchText",C[C.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const s={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},y={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:r.None,criteria:[],assetTypes:[]};class b{constructor(k=y){this.d=k}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(k,M=this.d.pageSize){return new b({...this.d,pageNumber:k,pageSize:M})}withFilter(k,...M){const z=[...this.d.criteria,...M.length?M.map(_=>({filterType:k,value:_})):[{filterType:k}]];return new b({...this.d,criteria:z})}withSortBy(k){return new b({...this.d,sortBy:k})}withSortOrder(k){return new b({...this.d,sortOrder:k})}withFlags(...k){return new b({...this.d,flags:k.reduce((M,z)=>M|z,0)})}withAssetTypes(...k){return new b({...this.d,assetTypes:k})}withSource(k){return new b({...this.d,source:k})}get raw(){const{criteria:k,pageNumber:M,pageSize:z,sortBy:_,sortOrder:W,flags:Q,assetTypes:ee}=this.d;return{filters:[{criteria:k,pageNumber:M,pageSize:z,sortBy:_,sortOrder:W}],assetTypes:ee,flags:Q}}get searchText(){const k=this.d.criteria.filter(M=>M.filterType===i.SearchText)[0];return k&&k.value?k.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(k=>String(k.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function g(C,k){const M=(C||[]).filter(z=>z.statisticName===k)[0];return M?M.value:0}function D(C){const k="Microsoft.VisualStudio.Code.Translation.";return C.files.filter(z=>z.assetType.indexOf(k)===0).reduce((z,_)=>{const W=j(C,_.assetType);return W&&z.push([_.assetType.substring(k.length),W]),z},[])}function A(C){if(C.properties){const k=C.properties.filter(_=>_.key===s.Repository),M=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),z=k.filter(_=>M.test(_.value))[0];return z?{uri:z.value,fallbackUri:z.value}:null}return j(C,s.Repository)}function F(C){return{uri:`${C.fallbackAssetUri}/${s.VSIX}?redirect=true${C.targetPlatform?`&targetPlatform=${C.targetPlatform}`:""}`,fallbackUri:`${C.fallbackAssetUri}/${s.VSIX}${C.targetPlatform?`?targetPlatform=${C.targetPlatform}`:""}`}}function j(C,k){return C.files.filter(z=>z.assetType===k)[0]?{uri:`${C.assetUri}/${k}${C.targetPlatform?`?targetPlatform=${C.targetPlatform}`:""}`,fallbackUri:`${C.fallbackAssetUri}/${k}${C.targetPlatform?`?targetPlatform=${C.targetPlatform}`:""}`}:null}function x(C,k){const M=C.properties?C.properties.filter(_=>_.key===k):[],z=M.length>0&&M[0].value;return z?z.split(",").map(_=>(0,p.adoptToGalleryExtensionId)(_)):[]}function V(C){const k=C.properties?C.properties.filter(M=>M.key===o.Engine):[];return k.length>0&&k[0].value||""}function B(C){const k=C.properties?C.properties.filter(M=>M.key===o.PreRelease):[];return k.length>0&&k[0].value==="true"}function Z(C){const k=C.properties?C.properties.filter(z=>z.key===o.LocalizedLanguages):[],M=k.length>0&&k[0].value||"";return M?M.split(","):[]}function J(C){return C.properties?.find(k=>k.key===o.SponsorLink)?.value}function K(C){return C.indexOf("preview")!==-1}function Y(C){return C.targetPlatform?(0,S.toTargetPlatform)(C.targetPlatform):"undefined"}function H(C){const k=(0,O.distinct)(C.versions.map(Y)),M=!!C.tags?.includes(S.WEB_EXTENSION_TAG),z=k.indexOf("web");return M?z===-1&&k.push("web"):z!==-1&&k.splice(z,1),k}function $(C,k){const M=(0,S.getFallbackTargetPlarforms)(k);for(let z=0;z<C.length;z++){const _=C[z];if(_.version===C[z-1]?.version){let W=z;const Q=Y(_);if(Q===k)for(;W>0&&C[W-1].version===_.version;)W--;else if(M.includes(Q))for(;W>0&&C[W-1].version===_.version&&Y(C[W-1])!==k;)W--;W!==z&&(C.splice(z,1),C.splice(W,0,_))}}return C}e.sortExtensionVersions=$;function X(C,k,M){C.telemetryData={index:k,querySource:M,queryActivityId:C.queryContext?.[n]}}function ie(C,k,M,z){const _=C.versions[0],W={manifest:j(k,s.Manifest),readme:j(k,s.Details),changelog:j(k,s.Changelog),license:j(k,s.License),repository:A(k),download:F(k),icon:j(k,s.Icon),signature:j(k,s.Signature),coreTranslations:D(k)};return{identifier:{id:(0,p.getGalleryExtensionId)(C.publisher.publisherName,C.extensionName),uuid:C.extensionId},name:C.extensionName,version:k.version,displayName:C.displayName,publisherId:C.publisher.publisherId,publisher:C.publisher.publisherName,publisherDisplayName:C.publisher.displayName,publisherDomain:C.publisher.domain?{link:C.publisher.domain,verified:!!C.publisher.isDomainVerified}:void 0,publisherSponsorLink:J(_),description:C.shortDescription||"",installCount:g(C.statistics,"install"),rating:g(C.statistics,"averagerating"),ratingCount:g(C.statistics,"ratingcount"),categories:C.categories||[],tags:C.tags||[],releaseDate:Date.parse(C.releaseDate),lastUpdated:Date.parse(C.lastUpdated),allTargetPlatforms:M,assets:W,properties:{dependencies:x(k,o.Dependency),extensionPack:x(k,o.ExtensionPack),engine:V(k),localizedLanguages:Z(k),targetPlatform:Y(k),isPreReleaseVersion:B(k)},hasPreReleaseVersion:B(_),hasReleaseVersion:!0,preview:K(C.flags),isSigned:!!W.signature,queryContext:z}}let se=class{constructor(k,M,z,_,W,Q,ee,le){this.k=M,this.l=z,this.n=_,this.o=W,this.q=Q,this.u=ee,this.w=le;const he=ee.extensionsGallery,pe=he?.servicePPEUrl&&le.getValue("_extensionsGallery.enablePPE");this.d=pe?he.servicePPEUrl:he?.serviceUrl,this.g=pe?void 0:he?.searchUrl,this.h=he?.controlUrl,this.j=(0,h.resolveMarketplaceHeaders)(ee.version,ee,this.n,this.w,this.q,k,this.o)}x(k=""){return`${this.d}${k}`}isEnabled(){return!!this.d}async getExtensions(k,M,z){const _=U.CancellationToken.isCancellationToken(M)?{}:M,W=U.CancellationToken.isCancellationToken(M)?M:z,Q=[],ee=[],le=[],he=[];let pe=!0;for(const Ce of k){Ce.uuid?ee.push(Ce.uuid):Q.push(Ce.id);const Re=!!(Ce.version||Ce.preRelease);le.push({id:Ce.id,uuid:Ce.uuid,includePreRelease:Re}),Ce.version&&he.push({id:Ce.id,uuid:Ce.uuid,version:Ce.version}),pe=pe&&!!Ce.hasPreRelease&&!Re}if(!ee.length&&!Q.length)return[];let de=new b().withPage(1,k.length);ee.length&&(de=de.withFilter(i.ExtensionId,...ee)),Q.length&&(de=de.withFilter(i.ExtensionName,...Q)),(_.queryAllVersions||pe)&&(de=de.withFlags(de.flags,r.IncludeVersions)),_.source&&(de=de.withSource(_.source));const{extensions:be}=await this.z(de,{targetPlatform:_.targetPlatform??L,includePreRelease:le,versions:he,compatible:!!_.compatible},W);return _.source&&be.forEach((Ce,Re)=>X(Ce,Re,_.source)),be}async getCompatibleExtension(k,M,z){if((0,S.isNotWebExtensionInWebTargetPlatform)(k.allTargetPlatforms,z))return null;if(await this.isExtensionCompatible(k,M,z))return k;const _=new b().withFlags(r.IncludeVersions).withPage(1,1).withFilter(i.ExtensionId,k.identifier.uuid),{extensions:W}=await this.z(_,{targetPlatform:z,compatible:!0,includePreRelease:M},U.CancellationToken.None);return W[0]||null}async isExtensionCompatible(k,M,z){if(!(0,S.isTargetPlatformCompatible)(k.properties.targetPlatform,k.allTargetPlatforms,z)||!M&&k.properties.isPreReleaseVersion)return!1;let _=k.properties.engine;if(!_){const W=await this.getManifest(k,U.CancellationToken.None);if(!W)throw new Error("Manifest was not found");_=W.engines.vscode}return(0,f.isEngineValid)(_,this.u.version,this.u.date)}async y(k,M,z,_,W){if(!(0,S.isTargetPlatformCompatible)(Y(k),_,W)||M!=="any"&&B(k)!==(M==="prerelease"))return!1;if(z)try{const Q=await this.E(k);if(!(0,f.isEngineValid)(Q,this.u.version,this.u.date))return!1}catch(Q){return this.l.error(`Error while getting the engine for the version ${k.version}.`,(0,l.getErrorMessage)(Q)),!1}return!0}async query(k,M){let z=k.text||"";const _=k.pageSize??50;let W=new b().withPage(1,_);z?(z=z.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(pe,de,be)=>(W=W.withFilter(i.Category,be||de),"")),z=z.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(pe,de,be)=>(W=W.withFilter(i.Tag,be||de),"")),z=z.replace(/\bfeatured(\s+|\b|$)/g,()=>(W=W.withFilter(i.Featured),"")),z=z.trim(),z&&(z=z.length<200?z:z.substring(0,200),W=W.withFilter(i.SearchText,z)),W=W.withSortBy(0)):k.ids?W=W.withFilter(i.ExtensionId,...k.ids):k.names?W=W.withFilter(i.ExtensionName,...k.names):W=W.withSortBy(4),typeof k.sortBy=="number"&&(W=W.withSortBy(k.sortBy)),typeof k.sortOrder=="number"&&(W=W.withSortOrder(k.sortOrder)),k.source&&(W=W.withSource(k.source));const Q=async(pe,de)=>{const{extensions:be,total:Ce}=await this.z(pe,{targetPlatform:L,compatible:!1,includePreRelease:!!k.includePreRelease},de);return be.forEach((Re,ke)=>X(Re,(pe.pageNumber-1)*pe.pageSize+ke,k.source)),{extensions:be,total:Ce}},{extensions:ee,total:le}=await Q(W,M),he=async(pe,de)=>{if(de.isCancellationRequested)throw new l.CancellationError;const{extensions:be}=await Q(W.withPage(pe+1),de);return be};return{firstPage:ee,total:le,pageSize:W.pageSize,getPage:he}}async z(k,M,z){const _=k.flags;!!(k.flags&r.IncludeLatestVersionOnly)&&!!(k.flags&r.IncludeVersions)&&(k=k.withFlags(k.flags&~r.IncludeVersions,r.IncludeLatestVersionOnly)),!(k.flags&r.IncludeLatestVersionOnly)&&!(k.flags&r.IncludeVersions)&&(k=k.withFlags(k.flags,r.IncludeLatestVersionOnly)),M.versions?.length&&(k=k.withFlags(k.flags&~r.IncludeLatestVersionOnly,r.IncludeVersions)),k=k.withFlags(k.flags,r.IncludeAssetUri,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeStatistics,r.IncludeVersionProperties);const{galleryExtensions:W,total:Q,context:ee}=await this.B(k,z);if(!(k.flags&r.IncludeLatestVersionOnly)){const de=[];for(const be of W){const Ce=await this.A(be,M,ee);Ce&&de.push(Ce)}return{extensions:de,total:Q}}const he=[],pe=new Map;for(let de=0;de<W.length;de++){const be=W[de],Ce={id:(0,p.getGalleryExtensionId)(be.publisher.publisherName,be.extensionName),uuid:be.extensionId},Re=(0,R.isBoolean)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(We=>(0,p.areSameExtensions)(We,Ce))?.includePreRelease;if(M.compatible&&(0,S.isNotWebExtensionInWebTargetPlatform)(H(be),M.targetPlatform))continue;const ke=await this.A(be,M,ee);!ke||ke.properties.isPreReleaseVersion&&(!Re||!ke.hasReleaseVersion)||!ke.properties.isPreReleaseVersion&&ke.properties.targetPlatform!==M.targetPlatform&&ke.hasPreReleaseVersion?pe.set(be.extensionId,de):he.push([de,ke])}if(pe.size){const de=new Date().getTime(),be=new b().withFlags(_&~r.IncludeLatestVersionOnly,r.IncludeVersions).withPage(1,pe.size).withFilter(i.ExtensionId,...pe.keys()),{extensions:Ce}=await this.z(be,M,z);this.o.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-de,count:pe.size});for(const Re of Ce){const ke=pe.get(Re.identifier.uuid);he.push([ke,Re])}}return{extensions:he.sort((de,be)=>de[0]-be[0]).map(([,de])=>de),total:Q}}async A(k,M,z){const _={id:(0,p.getGalleryExtensionId)(k.publisher.publisherName,k.extensionName),uuid:k.extensionId},W=M.versions?.find(he=>(0,p.areSameExtensions)(he,_))?.version,Q=(0,R.isBoolean)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(he=>(0,p.areSameExtensions)(he,_))?.includePreRelease,ee=H(k),le=$(k.versions,M.targetPlatform);if(M.compatible&&(0,S.isNotWebExtensionInWebTargetPlatform)(ee,M.targetPlatform))return null;for(let he=0;he<le.length;he++){const pe=le[he];if(!(W&&pe.version!==W)){if(await this.y(pe,Q?"any":"release",M.compatible,ee,M.targetPlatform))return ie(k,pe,ee,z);if(W&&pe.version===W)return null}}return W||M.compatible?null:ie(k,k.versions[0],ee)}async B(k,M){if(!this.isEnabled())throw new Error("No extension gallery service configured.");k=k.withFlags(k.flags,r.ExcludeNonValidated).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExcludeWithFlags,t(r.Unpublished));const z=await this.j,_=JSON.stringify(k.raw),W={...z,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(_.length)},Q=new Date().getTime();let ee,le,he=0;try{if(ee=await this.k.request({type:"POST",url:this.g&&k.criteria.some(de=>de.filterType===i.SearchText)?this.g:this.x("/extensionquery"),data:_,headers:W},M),ee.res.statusCode&&ee.res.statusCode>=400&&ee.res.statusCode<500)return{galleryExtensions:[],total:he};const pe=await(0,u.asJson)(ee);if(pe){const de=pe.results[0],be=de.extensions,Ce=de.resultMetadata&&de.resultMetadata.filter(Re=>Re.metadataType==="ResultCount")[0];return he=Ce&&Ce.metadataItems.filter(Re=>Re.name==="TotalCount")[0].count||0,{galleryExtensions:be,total:he,context:{[n]:ee.res.headers.activityid}}}return{galleryExtensions:[],total:he}}catch(pe){throw le=pe,pe}finally{this.o.publicLog2("galleryService:query",{...k.telemetryData,requestBodySize:String(_.length),duration:new Date().getTime()-Q,success:!!ee&&(0,u.isSuccess)(ee),responseBodySize:ee?.res.headers["Content-Length"],statusCode:ee?String(ee.res.statusCode):void 0,errorCode:le?(0,l.isCancellationError)(le)?"canceled":(0,l.getErrorMessage)(le).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(he)})}}async reportStatistic(k,M,z,_){if(!this.isEnabled())return;const W=T.isWeb?this.x(`/itemName/${k}.${M}/version/${z}/statType/${_==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${k}/extensions/${M}/${z}/stats?statType=${_}`),Q=T.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",le={...await this.j,Accept:Q};try{await this.k.request({type:"POST",url:W,headers:le},U.CancellationToken.None)}catch{}}async download(k,M,z){this.l.trace("ExtensionGalleryService#download",k.identifier.id);const _=(0,p.getGalleryExtensionTelemetryData)(k),W=new Date().getTime(),Q=de=>this.o.publicLog("galleryService:downloadVSIX",{..._,duration:de}),ee=z===2?"install":z===3?"update":"",le=ee?{uri:`${k.assets.download.uri}${I.URI.parse(k.assets.download.uri).query?"&":"?"}${ee}=true`,fallbackUri:`${k.assets.download.fallbackUri}${I.URI.parse(k.assets.download.fallbackUri).query?"&":"?"}${ee}=true`}:k.assets.download,he=k.queryContext?.[n]?{[n]:k.queryContext[n]}:void 0,pe=await this.D(le,he?{headers:he}:void 0);await this.q.writeFile(M,pe.stream),Q(new Date().getTime()-W)}async downloadSignatureArchive(k,M){if(!k.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",k.identifier.id);const z=await this.D(k.assets.signature);await this.q.writeFile(M,z.stream)}async getReadme(k,M){if(k.assets.readme){const z=await this.D(k.assets.readme,{},M);return await(0,u.asTextOrError)(z)||""}return""}async getManifest(k,M){if(k.assets.manifest){const z=await this.D(k.assets.manifest,{},M),_=await(0,u.asTextOrError)(z);return _?JSON.parse(_):null}return null}async C(k,M){const z=j(k,s.Manifest);if(!z)throw new Error("Manifest was not found");const _={"Accept-Encoding":"gzip"},W=await this.D(z,{headers:_});return await(0,u.asJson)(W)}async getCoreTranslation(k,M){const z=k.assets.coreTranslations.filter(_=>_[0]===M.toUpperCase())[0];if(z){const _=await this.D(z[1]),W=await(0,u.asTextOrError)(_);return W?JSON.parse(W):null}return null}async getChangelog(k,M){if(k.assets.changelog){const z=await this.D(k.assets.changelog,{},M);return await(0,u.asTextOrError)(z)||""}return""}async getAllCompatibleVersions(k,M,z){let _=new b().withFlags(r.IncludeVersions,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,1);k.identifier.uuid?_=_.withFilter(i.ExtensionId,k.identifier.uuid):_=_.withFilter(i.ExtensionName,k.identifier.id);const{galleryExtensions:W}=await this.B(_,U.CancellationToken.None);if(!W.length)return[];const Q=H(W[0]);if((0,S.isNotWebExtensionInWebTargetPlatform)(Q,z))return[];const ee=[];await Promise.all(W[0].versions.map(async pe=>{try{await this.y(pe,M?"any":"release",!0,Q,z)&&ee.push(pe)}catch{}}));const le=[],he=new Set;for(const pe of $(ee,z))he.has(pe.version)||(he.add(pe.version),le.push({version:pe.version,date:pe.lastUpdated,isPreReleaseVersion:B(pe)}));return le}async D(k,M={},z=U.CancellationToken.None){const _=await this.j,W={type:"GET"},Q={..._,...M.headers||{}};M={...M,...W,headers:Q};const ee=k.uri,le=k.fallbackUri,he={...M,url:ee};try{const pe=await this.k.request(he,z);if(pe.res.statusCode===200)return pe;const de=await(0,u.asTextOrError)(pe);throw new Error(`Expected 200, got back ${pe.res.statusCode} instead.

${de}`)}catch(pe){if((0,l.isCancellationError)(pe))throw pe;const de=(0,l.getErrorMessage)(pe);this.o.publicLog2("galleryService:cdnFallback",{url:ee,message:de});const be={...M,url:le};return this.k.request(be,z)}}async E(k){let M=V(k);if(!M){const z=await this.C(k,U.CancellationToken.None);if(!z)throw new Error("Manifest was not found");M=z.engines.vscode}return M}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{}};const k=await this.k.request({type:"GET",url:this.h},U.CancellationToken.None);if(k.res.statusCode!==200)throw new Error("Could not get extensions report.");const M=await(0,u.asJson)(k),z=[],_={};if(M){for(const W of M.malicious)z.push({id:W});if(M.migrateToPreRelease)for(const[W,Q]of Object.entries(M.migrateToPreRelease))(!Q.engine||(0,f.isEngineValid)(Q.engine,this.u.version,this.u.date))&&(_[W.toLowerCase()]={disallowInstall:!0,extension:{id:Q.id,displayName:Q.displayName,autoMigrate:{storage:!!Q.migrateStorage},preRelease:!0}});if(M.deprecated)for(const[W,Q]of Object.entries(M.deprecated))Q&&(_[W.toLowerCase()]=(0,R.isBoolean)(Q)?{}:Q)}return{malicious:z,deprecated:_}}};se=ye([G(1,u.IRequestService),G(2,E.ILogService),G(3,P.IEnvironmentService),G(4,v.ITelemetryService),G(5,m.IFileService),G(6,a.IProductService),G(7,w.IConfigurationService)],se);let ae=class extends se{constructor(k,M,z,_,W,Q,ee,le){super(k,M,z,_,W,Q,ee,le)}};ae=ye([G(0,d.IStorageService),G(1,u.IRequestService),G(2,E.ILogService),G(3,P.IEnvironmentService),G(4,v.ITelemetryService),G(5,m.IFileService),G(6,a.IProductService),G(7,w.IConfigurationService)],ae),e.ExtensionGalleryService=ae;let q=class extends se{constructor(k,M,z,_,W,Q,ee){super(void 0,k,M,z,_,W,Q,ee)}};q=ye([G(0,u.IRequestService),G(1,E.ILogService),G(2,P.IEnvironmentService),G(3,v.ITelemetryService),G(4,m.IFileService),G(5,a.IProductService),G(6,w.IConfigurationService)],q),e.ExtensionGalleryServiceWithNoStorageService=q}),define(re[81],oe([0,1,5,3,2,20,33,26,21,9,12]),function(te,e,O,U,l,T,N,R,I,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,O.createDecorator)("IExtensionStorageService");const S=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let p=class Xe extends l.Disposable{static b(m){return`extensionKeys/${(0,N.adoptToGalleryExtensionId)(m.id)}@${m.version}`}static c(m){const E=S.exec(m);if(E&&E[1])return{id:E[1],version:E[2]}}static async removeOutdatedExtensionVersions(m,E){const a=await m.getInstalled(),u=[];for(const[h,d]of Xe.f(E)){const v=a.find(L=>(0,N.areSameExtensions)(L.identifier,{id:h}))?.manifest.version;for(const L of d)v!==L&&u.push(Xe.b({id:h,version:L}))}for(const h of u)E.remove(h,0)}static f(m){const E=new Map,a=m.keys(0,1);for(const u of a){const h=Xe.c(u);if(h){let d=E.get(h.id.toLowerCase());d||E.set(h.id.toLowerCase(),d=[]),d.push(h.version)}}return E}constructor(m,E,a){super(),this.i=m,this.j=E,this.k=a,this.g=this.D(new U.Emitter),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=Xe.f(m),this.D(this.i.onDidChangeValue(u=>this.l(u)))}l(m){if(m.scope!==0)return;if(this.h.has(m.key.toLowerCase())){this.g.fire();return}const E=Xe.c(m.key);if(E){if(this.i.get(m.key,0)===void 0)this.h.delete(E.id.toLowerCase());else{let a=this.h.get(E.id.toLowerCase());a||this.h.set(E.id.toLowerCase(),a=[]),a.push(E.version),this.g.fire()}return}}m(m){if((0,P.isString)(m))return m;const E=m.manifest?m.manifest.publisher:m.publisher,a=m.manifest?m.manifest.name:m.name;return(0,N.getExtensionId)(E,a)}getExtensionState(m,E){const a=this.m(m),u=this.getExtensionStateRaw(m,E);if(u)try{return JSON.parse(u)}catch(h){this.k.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${a}, global: ${E}): ${h}`)}}getExtensionStateRaw(m,E){const a=this.m(m),u=this.i.get(a,E?0:1);return u&&u?.length>Xe.a&&this.k.warn(`[mainThreadStorage] large extension state detected (extensionId: ${a}, global: ${E}): ${u.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),u}setExtensionState(m,E,a){const u=this.m(m);E===void 0?this.i.remove(u,a?0:1):this.i.store(u,JSON.stringify(E),a?0:1,1)}setKeysForSync(m,E){this.i.store(Xe.b(m),JSON.stringify(E),0,1)}getKeysForSync(m){const E=this.j.extensionSyncedKeys?.[m.id.toLowerCase()],a=this.i.get(Xe.b(m),0),u=a?JSON.parse(a):void 0;return u&&E?(0,I.distinct)([...u,...E]):u||E}addToMigrationList(m,E){if(m!==E){const a=this.n.filter(u=>!u.includes(m)&&!u.includes(E));a.push([m,E]),this.n=a}}getSourceExtensionToMigrate(m){const E=this.n.find(([,a])=>m===a);return E?E[0]:void 0}get n(){const m=this.i.get("extensionStorage.migrationList",-1,"[]");try{const E=JSON.parse(m);if(Array.isArray(E))return E}catch{}return[]}set n(m){m.length?this.i.store("extensionStorage.migrationList",JSON.stringify(m),-1,1):this.i.remove("extensionStorage.migrationList",-1)}};p.a=512*1024,p=ye([G(0,T.IStorageService),G(1,R.IProductService),G(2,w.ILogService)],p),e.ExtensionStorageService=p}),define(re[271],oe([0,1,29,14,26,15,102,57,20,19,235]),function(te,e,O,U,l,T,N,R,I,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let S=class extends P.AbstractNativeExtensionTipsService{constructor(f,m,E,a,u,h,d,v){super(f.userHome,u,m,E,a,h,d,v)}};S=ye([G(0,T.INativeEnvironmentService),G(1,w.ITelemetryService),G(2,O.IExtensionManagementService),G(3,I.IStorageService),G(4,R.INativeHostService),G(5,N.IExtensionRecommendationNotificationService),G(6,U.IFileService),G(7,l.IProductService)],S),e.ExtensionTipsService=S}),define(re[272],oe([0,1,6,2,23,67,20,77,18]),function(te,e,O,U,l,T,N,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteStorageService=void 0;class w extends N.AbstractStorageService{constructor(S,p,f,m){super(),this.X=S,this.Y=p,this.Z=f,this.ab=m,this.p=this.Y.defaultProfile,this.s=this.bb(),this.P=this.Y.currentProfile,this.Q=this.D(new U.DisposableStore),this.R=this.cb(this.P),this.S=this.X?.id,this.U=this.D(new U.DisposableStore),this.W=this.db(this.X)}bb(){const S=this.D(new R.ApplicationStorageDatabaseClient(this.Z.getChannel("storage"))),p=this.D(new T.Storage(S));return this.D(p.onDidChangeStorage(f=>this.n(-1,f))),p}cb(S){this.Q.clear(),this.P=S;let p;if((0,N.isProfileUsingDefaultStorage)(S))p=this.s;else{const f=this.Q.add(new R.ProfileStorageDatabaseClient(this.Z.getChannel("storage"),S));p=this.Q.add(new T.Storage(f))}return this.Q.add(p.onDidChangeStorage(f=>this.n(0,f))),p}db(S){this.U.clear(),this.S=S?.id;let p;if(S){const f=this.U.add(new R.WorkspaceStorageDatabaseClient(this.Z.getChannel("storage"),S));p=this.U.add(new T.Storage(f)),this.U.add(p.onDidChangeStorage(m=>this.n(1,m)))}return p}async J(){await O.Promises.settled([this.s.init(),this.R.init(),this.W?.init()??Promise.resolve()])}L(S){switch(S){case-1:return this.s;case 0:return this.R;default:return this.W}}M(S){switch(S){case-1:return this.p.globalStorageHome.fsPath;case 0:return this.P?.globalStorageHome.fsPath;default:return this.S?`${(0,l.joinPath)(this.ab.workspaceStorageHome,this.S,"state.vscdb").fsPath}`:void 0}}async close(){this.m(),this.q(N.WillSaveStateReason.SHUTDOWN),await O.Promises.settled([this.s.close(),this.R.close(),this.W?.close()??Promise.resolve()])}async N(S,p){if(!this.H(this.P,S))return;const f=this.R,m=f.items;f!==this.s&&await f.close(),this.R=this.cb(S),await this.R.init(),this.I(m,this.R,0,p)}async O(S,p){const f=this.W,m=f?.items??new Map;await f?.close(),this.W=this.db(S),await this.W.init(),this.I(m,this.W,1,p)}hasScope(S){return(0,I.isUserDataProfile)(S)?this.P.id===S.id:this.S===S.id}}e.RemoteStorageService=w}),define(re[273],oe([0,1,3,2,18,94]),function(te,e,O,U,l,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.RemoteUserDataProfilesServiceChannel=void 0;class N{constructor(w,P){this.a=w,this.b=P}listen(w,P){const S=this.b(w);switch(P){case"onDidChangeProfiles":return O.Event.map(this.a.onDidChangeProfiles,p=>({all:p.all.map(f=>(0,T.transformOutgoingURIs)({...f},S)),added:p.added.map(f=>(0,T.transformOutgoingURIs)({...f},S)),removed:p.removed.map(f=>(0,T.transformOutgoingURIs)({...f},S)),updated:p.updated.map(f=>(0,T.transformOutgoingURIs)({...f},S))}))}throw new Error(`Invalid listen ${P}`)}async call(w,P,S){const p=this.b(w);switch(P){case"createProfile":{const f=await this.a.createProfile(S[0],S[1],S[2]);return(0,T.transformOutgoingURIs)({...f},p)}case"updateProfile":{let f=(0,l.reviveProfile)((0,T.transformIncomingURIs)(S[0],p),this.a.profilesHome.scheme);return f=await this.a.updateProfile(f,S[1]),(0,T.transformOutgoingURIs)({...f},p)}case"removeProfile":{const f=(0,l.reviveProfile)((0,T.transformIncomingURIs)(S[0],p),this.a.profilesHome.scheme);return this.a.removeProfile(f)}}throw new Error(`Invalid call ${P}`)}}e.RemoteUserDataProfilesServiceChannel=N;class R extends U.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(w,P,S){super(),this.profilesHome=P,this.f=S,this.a=[],this.b=this.D(new O.Emitter),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=w.map(p=>(0,l.reviveProfile)(p,this.profilesHome.scheme)),this.D(this.f.listen("onDidChangeProfiles")(p=>{const f=p.added.map(a=>(0,l.reviveProfile)(a,this.profilesHome.scheme)),m=p.removed.map(a=>(0,l.reviveProfile)(a,this.profilesHome.scheme)),E=p.updated.map(a=>(0,l.reviveProfile)(a,this.profilesHome.scheme));this.a=p.all.map(a=>(0,l.reviveProfile)(a,this.profilesHome.scheme)),this.b.fire({added:f,removed:m,updated:E,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(w){this.c=w}isEnabled(){return this.c}async createNamedProfile(w,P,S){const p=await this.f.call("createNamedProfile",[w,P,S]);return(0,l.reviveProfile)(p,this.profilesHome.scheme)}async createProfile(w,P,S,p){const f=await this.f.call("createProfile",[w,P,S,p]);return(0,l.reviveProfile)(f,this.profilesHome.scheme)}async createTransientProfile(w){const P=await this.f.call("createTransientProfile",[w]);return(0,l.reviveProfile)(P,this.profilesHome.scheme)}async setProfileForWorkspace(w,P){await this.f.call("setProfileForWorkspace",[w,P])}removeProfile(w){return this.f.call("removeProfile",[w])}async updateProfile(w,P){const S=await this.f.call("updateProfile",[w,P]);return(0,l.reviveProfile)(S,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.UserDataProfilesService=R}),define(re[61],oe([0,1,2,67,5,20,3,77,18]),function(te,e,O,U,l,T,N,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteUserDataProfileStorageService=e.AbstractUserDataProfileStorageService=e.IUserDataProfileStorageService=void 0,e.IUserDataProfileStorageService=(0,l.createDecorator)("IUserDataProfileStorageService");let w=class extends O.Disposable{constructor(f){super(),this.a=f}async readStorageData(f){return this.withProfileScopedStorageService(f,async m=>this.b(m))}async updateStorageData(f,m,E){return this.withProfileScopedStorageService(f,async a=>this.c(a,m,E))}async withProfileScopedStorageService(f,m){if(this.a.hasScope(f))return m(this.a);const E=await this.g(f),a=new S(E);try{await a.initialize();const u=await m(a);return await a.flush(),u}finally{a.dispose(),await this.f(E)}}b(f){const m=new Map,E=a=>{for(const u of f.keys(0,a))m.set(u,{value:f.get(u,0),target:a})};return E(0),E(1),m}c(f,m,E){for(const[a,u]of m)f.store(a,u,0,E)}async f(f){try{await f.close()}finally{(0,O.isDisposable)(f)&&f.dispose()}}};w=ye([G(0,T.IStorageService)],w),e.AbstractUserDataProfileStorageService=w;class P extends w{constructor(f,m,E,a){super(E),this.i=f;const u=f.getChannel("profileStorageListener"),h=this.D(new O.MutableDisposable);this.h=this.D(new N.Emitter({onWillAddFirstListener:()=>{h.value=u.listen("onDidChange")(d=>{a.trace("profile storage changes",d),this.h.fire({targetChanges:d.targetChanges.map(v=>(0,I.reviveProfile)(v,m.profilesHome.scheme)),valueChanges:d.valueChanges.map(v=>({...v,profile:(0,I.reviveProfile)(v.profile,m.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>h.value=void 0})),this.onDidChange=this.h.event}async g(f){const m=this.i.getChannel("storage");return(0,T.isProfileUsingDefaultStorage)(f)?new R.ApplicationStorageDatabaseClient(m):new R.ProfileStorageDatabaseClient(m,f)}}e.RemoteUserDataProfileStorageService=P;class S extends T.AbstractStorageService{constructor(f){super({flushInterval:100}),this.p=this.D(new U.Storage(f))}J(){return this.p.init()}L(f){return f===0?this.p:void 0}M(){}async N(){}async O(){}hasScope(){return!1}}}),define(re[274],oe([0,1,20,9,18,73,61]),function(te,e,O,U,l,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeUserDataProfileStorageService=void 0;let R=class extends N.RemoteUserDataProfileStorageService{constructor(w,P,S,p){super(w,P,S,p)}};R=ye([G(0,T.IMainProcessService),G(1,l.IUserDataProfilesService),G(2,O.IStorageService),G(3,U.ILogService)],R),e.NativeUserDataProfileStorageService=R}),define(re[41],oe([0,1,21,6,16,25,3,35,2,27,12,181,17,15,14,9,44,20,19,30,24,18]),function(te,e,O,U,l,T,N,R,I,w,P,S,p,f,m,E,a,u,h,d,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.getSyncResourceLogLabel=e.isSyncData=e.isRemoteUserData=void 0;function n(y){return!!(y&&y.ref!==void 0&&typeof y.ref=="string"&&y.ref!==""&&y.syncData!==void 0&&(y.syncData===null||r(y.syncData)))}e.isRemoteUserData=n;function r(y){return!!(y&&y.version!==void 0&&typeof y.version=="number"&&y.content!==void 0&&typeof y.content=="string"&&(Object.keys(y).length===2||Object.keys(y).length===3&&y.machineId!==void 0&&typeof y.machineId=="string"))}e.isSyncData=r;function t(y,b){return`${(0,w.uppercaseFirstLetter)(y)}${b.isDefault?"":` (${b.name})`}`}e.getSyncResourceLogLabel=t;let i=class extends I.Disposable{get status(){return this.k}get conflicts(){return{...this.syncResource,conflicts:this.m}}constructor(b,g,D,A,F,j,x,V,B,Z,J,K){super(),this.syncResource=b,this.collection=g,this.z=D,this.C=A,this.F=F,this.G=j,this.H=x,this.I=V,this.J=B,this.L=Z,this.M=J,this.c=null,this.k="idle",this.l=this.D(new N.Emitter),this.onDidChangeStatus=this.l.event,this.m=[],this.n=this.D(new N.Emitter),this.onDidChangeConflicts=this.n.event,this.q=new U.ThrottledDelayer(50),this.s=this.D(new N.Emitter),this.onDidChangeLocal=this.s.event,this.u=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.v=!1,this.y={},this.resource=this.syncResource.syncResource,this.w=t(b.syncResource,b.profile),this.h=K.extUri,this.f=this.h.joinPath(A.userDataSyncHome,...(0,v.getPathSegments)(b.profile.isDefault?void 0:b.profile.id,b.syncResource)),this.g=this.h.joinPath(this.f,v.PREVIEW_DIR_NAME),this.t=(0,v.getLastSyncResourceUri)(b.profile.isDefault?void 0:b.profile.id,b.syncResource,A,this.h),this.j=(0,a.getServiceMachineId)(A,D,F)}N(){this.q.trigger(()=>this.O())}async O(){if(this.status==="hasConflicts"){this.L.info(`${this.w}: In conflicts state and local change detected. Syncing again...`);const b=await this.c;this.c=null;const g=await this.U(b.remoteUserData,b.lastSyncUserData,!0,this.mb());this.P(g)}else{this.L.trace(`${this.w}: Checking for local changes...`);const b=await this.getLastSyncUserData();(b?await this.sb(b):!0)&&this.s.fire()}}P(b){this.k!==b&&(this.k=b,this.l.fire(b))}async sync(b,g={}){await this.Q(b,!0,this.mb(),g)}async preview(b,g,D={}){return this.Q(b,!1,g,D)}async apply(b,g={}){try{this.y={...g};const D=await this.Y(b);return this.P(D),this.c}finally{this.y={}}}async Q(b,g,D,A){try{if(this.y={...A},this.status==="hasConflicts")return this.L.info(`${this.w}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.L.info(`${this.w}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.L.trace(`${this.w}: Started synchronizing ${this.resource.toLowerCase()}...`),this.P("syncing");let F="idle";try{const j=await this.getLastSyncUserData(),x=await this.S(b,j);return F=await this.U(x,j,g,D),F==="hasConflicts"?this.L.info(`${this.w}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):F==="idle"&&this.L.trace(`${this.w}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.P(F)}}finally{this.y={}}}async replace(b){const g=this.ib(b);if(!g)return!1;await this.stop();try{this.L.trace(`${this.w}: Started resetting ${this.resource.toLowerCase()}...`),this.P("syncing");const D=await this.getLastSyncUserData(),A=await this.S(null,D),F=await this.R(A),j=await this.ob({ref:A.ref,syncData:g},D,F,this.mb(),T.CancellationToken.None),x=[];for(const V of j){const B=await this.qb(V,V.remoteResource,void 0,T.CancellationToken.None),{remoteChange:Z}=await this.qb(V,V.previewResource,V.remoteContent,T.CancellationToken.None);x.push([V,{...B,remoteChange:Z!==0?Z:2}])}await this.rb(A,D,x,!1),this.L.info(`${this.w}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.P("idle")}return!0}async R(b){const g=await this.j;return!!b.syncData?.machineId&&b.syncData.machineId===g}async S(b,g){if(g){const D=b?b[this.resource]:void 0;if(g.ref===D||D===void 0&&g.syncData===null)return g}return this.getRemoteUserData(g)}async U(b,g,D,A){if(b.syncData&&b.syncData.version>this.nb)throw this.J.publicLog2("sync/incompatible",{source:this.resource}),new v.UserDataSyncError((0,S.localize)(0,null,this.resource,this.nb,b.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.W(b,g,D,A)}catch(F){if(F instanceof v.UserDataSyncError)switch(F.code){case"LocalPreconditionFailed":return this.L.info(`${this.w}: Failed to synchronize ${this.w} as there is a new local version available. Synchronizing again...`),this.U(b,g,D,A);case"Conflict":case"PreconditionFailed":return this.L.info(`${this.w}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),b=await this.getRemoteUserData(null),g=await this.getLastSyncUserData(),this.U(b,g,D,A)}throw F}}async W(b,g,D,A){try{const F=await this.R(b),j=!F&&g===null&&this.eb()!==void 0,x=D&&!j;this.c||(this.c=(0,U.createCancelablePromise)(B=>this.cb(b,g,F,x,A,B)));let V=await this.c;if(D&&j){this.L.info(`${this.w}: Accepting remote because it was synced before and the last sync data is not available.`);for(const B of V.resourcePreviews)V=await this.accept(B.remoteResource)||V}return this.ab(V.resourcePreviews),V.resourcePreviews.some(({mergeState:B})=>B==="conflict")?"hasConflicts":D?await this.Y(!1):"syncing"}catch(F){throw this.c=null,F}}async merge(b){return await this.X(b,async g=>{const D=await this.pb(g,T.CancellationToken.None);await this.z.writeFile(g.previewResource,l.VSBuffer.fromString(D?.content||""));const A=D&&!D.hasConflicts?await this.qb(g,g.previewResource,void 0,T.CancellationToken.None):void 0;return g.acceptResult=A,g.mergeState=D.hasConflicts?"conflict":A?"accepted":"preview",g.localChange=A?A.localChange:D.localChange,g.remoteChange=A?A.remoteChange:D.remoteChange,g}),this.c}async accept(b,g){return await this.X(b,async D=>{const A=await this.qb(D,b,g,T.CancellationToken.None);return D.acceptResult=A,D.mergeState="accepted",D.localChange=A.localChange,D.remoteChange=A.remoteChange,D}),this.c}async discard(b){return await this.X(b,async g=>{const D=await this.pb(g,T.CancellationToken.None);return await this.z.writeFile(g.previewResource,l.VSBuffer.fromString(D.content||"")),g.acceptResult=void 0,g.mergeState="preview",g.localChange=D.localChange,g.remoteChange=D.remoteChange,g}),this.c}async X(b,g){if(!this.c)return;let D=await this.c;const A=D.resourcePreviews.findIndex(({localResource:F,remoteResource:j,previewResource:x})=>this.h.isEqual(F,b)||this.h.isEqual(j,b)||this.h.isEqual(x,b));A!==-1&&(this.c=(0,U.createCancelablePromise)(async F=>{const j=[...D.resourcePreviews];return j[A]=await g(j[A]),{...D,resourcePreviews:j}}),D=await this.c,this.ab(D.resourcePreviews),D.resourcePreviews.some(({mergeState:F})=>F==="conflict")?this.P("hasConflicts"):this.P("syncing"))}async Y(b){if(!this.c)return"idle";const g=await this.c;return g.resourcePreviews.some(({mergeState:D})=>D==="conflict")?"hasConflicts":g.resourcePreviews.some(({mergeState:D})=>D!=="accepted")?"syncing":(await this.rb(g.remoteUserData,g.lastSyncUserData,g.resourcePreviews.map(D=>[D,D.acceptResult]),b),this.c=null,await this.Z(),"idle")}async Z(){try{await this.z.del(this.g,{recursive:!0})}catch{}}ab(b){const g=b.filter(({mergeState:D})=>D==="conflict");(0,O.equals)(this.m,g,(D,A)=>this.h.isEqual(D.previewResource,A.previewResource))||(this.m=g,this.n.fire(this.conflicts))}async hasPreviouslySynced(){const b=await this.getLastSyncUserData();return!!b&&b.syncData!==null}async bb(b){const g=this.c?await this.c:null;if(g)for(const D of g.resourcePreviews){if(this.h.isEqual(D.acceptedResource,b))return D.acceptResult?D.acceptResult.content:null;if(this.h.isEqual(D.remoteResource,b))return D.remoteContent;if(this.h.isEqual(D.localResource,b))return D.localContent;if(this.h.isEqual(D.baseResource,b))return D.baseContent}return null}async resetLocal(){this.F.remove(this.u,-1);try{await this.z.del(this.t)}catch(b){(0,m.toFileOperationResult)(b)!==1&&this.L.error(b)}}async cb(b,g,D,A,F,j){const x=await this.ob(b,g,D,F,j),V=[];for(const B of x){const Z=B.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(B.localChange===0&&B.remoteChange===0)V.push({...B,acceptedResource:Z,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const J=A?await this.pb(B,j):void 0;if(j.isCancellationRequested)break;await this.z.writeFile(B.previewResource,l.VSBuffer.fromString(J?.content||""));const K=J&&!J.hasConflicts?await this.qb(B,B.previewResource,void 0,j):void 0;V.push({...B,acceptResult:K,mergeState:J?.hasConflicts?"conflict":K?"accepted":"preview",localChange:K?K.localChange:J?J.localChange:B.localChange,remoteChange:K?K.remoteChange:J?J.remoteChange:B.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:b,lastSyncUserData:g,resourcePreviews:V,isLastSyncFromCurrentMachine:D}}async getLastSyncUserData(){let b=this.eb();if(b||(b=await this.hb()),!b)return this.L.info(`${this.w}: Last sync data state does not exist.`),null;const g=JSON.parse(b),D=this.I.getResourceSyncStateVersion(this.resource);if(this.v=!!g.version&&!!D&&g.version!==D,this.v)return this.L.info(`${this.w}: Reset last sync state because last sync state version ${g.version} is not compatible with current sync state version ${D}.`),await this.resetLocal(),null;let A,F=1;for(;A===void 0&&F++<6;)try{const j=await this.fb();j&&(j.ref===g.ref?A=j.syncData:this.L.info(`${this.w}: Last sync data stored locally is not same as the last sync state.`));break}catch(j){if(j instanceof m.FileOperationError&&j.fileOperationResult===1){this.L.info(`${this.w}: Last sync resource does not exist locally.`);break}else{if(j instanceof v.UserDataSyncError)throw j;this.L.error(j,F)}}if(A===void 0)try{const j=await this.G.resolveResourceContent(this.resource,g.ref,this.collection,this.y);A=j===null?null:this.ib(j),await this.gb({ref:g.ref,syncData:A})}catch(j){if(j instanceof v.UserDataSyncError&&j.code==="NotFound")this.L.info(`${this.w}: Last sync resource does not exist remotely.`);else throw j}return A===void 0?null:{...g,syncData:A}}async db(b,g={}){if(g.ref||g.version)throw new Error("Cannot have core properties as additional");const D=this.I.getResourceSyncStateVersion(this.resource),A={ref:b.ref,version:D,...g};this.F.store(this.u,JSON.stringify(A),-1,1),await this.gb(b)}eb(){return this.F.get(this.u,-1)}async fb(){const b=(await this.z.readFile(this.t)).value.toString();try{const g=b?JSON.parse(b):void 0;if(n(g))return g}catch(g){this.L.error(g)}}async gb(b){await this.z.writeFile(this.t,l.VSBuffer.fromString(JSON.stringify(b)))}async hb(){try{const b=await this.z.readFile(this.t),g=JSON.parse(b.value.toString());await this.z.del(this.t),g.ref&&g.content!==void 0?(this.F.store(this.u,JSON.stringify({...g,content:void 0}),-1,1),await this.gb({ref:g.ref,syncData:g.content===null?null:JSON.parse(g.content)})):this.L.info(`${this.w}: Migrating last sync user data. Invalid data.`,g)}catch(b){b instanceof m.FileOperationError&&b.fileOperationResult===1?this.L.info(`${this.w}: Migrating last sync user data. Resource does not exist.`):this.L.error(b)}return this.F.get(this.u,-1)}async getRemoteUserData(b){const{ref:g,content:D}=await this.jb(b);let A=null;return D!==null&&(A=this.ib(D)),{ref:g,syncData:A}}ib(b){try{const g=JSON.parse(b);if(r(g))return g}catch(g){this.L.error(g)}throw new v.UserDataSyncError((0,S.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async jb(b){const g=b?{ref:b.ref,content:b.syncData?JSON.stringify(b.syncData):null}:null;return this.G.readResource(this.resource,g,this.collection,this.y)}async kb(b,g){const D=await this.j,A={version:this.nb,machineId:D,content:b};try{return g=await this.G.writeResource(this.resource,JSON.stringify(A),g,this.collection,this.y),{ref:g,syncData:A}}catch(F){throw F instanceof v.UserDataSyncError&&F.code==="TooLarge"&&(F=new v.UserDataSyncError(F.message,F.code,this.resource)),F}}async lb(b){const g={version:this.nb,content:b};return this.H.backup(this.syncResource.profile,this.resource,JSON.stringify(g))}async stop(){this.status!=="idle"&&(this.L.trace(`${this.w}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.ab([]),await this.Z(),this.P("idle"),this.L.info(`${this.w}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}mb(){return this.M.getValue(v.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};i=ye([G(2,m.IFileService),G(3,f.IEnvironmentService),G(4,u.IStorageService),G(5,v.IUserDataSyncStoreService),G(6,v.IUserDataSyncBackupStoreService),G(7,v.IUserDataSyncEnablementService),G(8,h.ITelemetryService),G(9,v.IUserDataSyncLogService),G(10,p.IConfigurationService),G(11,d.IUriIdentityService)],i),e.AbstractSynchroniser=i;let s=class extends i{constructor(b,g,D,A,F,j,x,V,B,Z,J,K,Y){super(g,D,A,F,j,x,V,B,Z,J,K,Y),this.i=b,this.D(this.z.watch(this.h.dirname(b))),this.D(this.z.onDidFilesChange(H=>this.ub(H)))}async p(){try{return await this.z.readFile(this.i)}catch{return null}}async r(b,g,D){try{g?await this.z.writeFile(this.i,l.VSBuffer.fromString(b),D?void 0:g):await this.z.createFile(this.i,l.VSBuffer.fromString(b),{overwrite:D})}catch(A){throw A instanceof m.FileOperationError&&A.fileOperationResult===1||A instanceof m.FileOperationError&&A.fileOperationResult===3?new v.UserDataSyncError(A.message,"LocalPreconditionFailed"):A}}async tb(){try{await this.z.del(this.i)}catch(b){if(!(b instanceof m.FileOperationError&&b.fileOperationResult===1))throw b}}ub(b){!b.contains(this.i)||this.N()}};s=ye([G(3,m.IFileService),G(4,f.IEnvironmentService),G(5,u.IStorageService),G(6,v.IUserDataSyncStoreService),G(7,v.IUserDataSyncBackupStoreService),G(8,v.IUserDataSyncEnablementService),G(9,h.ITelemetryService),G(10,v.IUserDataSyncLogService),G(11,p.IConfigurationService),G(12,d.IUriIdentityService)],s),e.AbstractFileSynchroniser=s;let o=class extends s{constructor(b,g,D,A,F,j,x,V,B,Z,J,K,Y,H){super(b,g,D,A,F,j,x,V,B,Z,J,Y,H),this.vb=K,this.xb=void 0}wb(b,g){const D=[],A=(0,R.parse)(b,D,{allowEmptyContent:!0,allowTrailingComma:!0});return D.length>0||!(0,P.isUndefined)(A)&&g!==Array.isArray(A)}yb(){return this.xb||(this.xb=this.vb.resolveFormattingOptions(this.i)),this.xb}};o=ye([G(3,m.IFileService),G(4,f.IEnvironmentService),G(5,u.IStorageService),G(6,v.IUserDataSyncStoreService),G(7,v.IUserDataSyncBackupStoreService),G(8,v.IUserDataSyncEnablementService),G(9,h.ITelemetryService),G(10,v.IUserDataSyncLogService),G(11,v.IUserDataSyncUtilService),G(12,p.IConfigurationService),G(13,d.IUriIdentityService)],o),e.AbstractJsonFileSynchroniser=o;let c=class{constructor(b,g,D,A,F,j,x){this.resource=b,this.g=g,this.h=D,this.j=A,this.k=F,this.l=j,this.d=x.extUri,this.f=(0,v.getLastSyncResourceUri)(void 0,this.resource,D,this.d)}async initialize({ref:b,content:g}){if(!g){this.j.info("Remote content does not exist.",this.resource);return}const D=this.m(g);if(!!D)try{await this.o({ref:b,syncData:D})}catch(A){this.j.error(A)}}m(b){try{const g=JSON.parse(b);if(r(g))return g}catch(g){this.j.error(g)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(b,g={}){if(g.ref||g.version)throw new Error("Cannot have core properties as additional");const D={ref:b.ref,version:void 0,...g};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(D),-1,1),await this.k.writeFile(this.f,l.VSBuffer.fromString(JSON.stringify(b)))}};c=ye([G(1,L.IUserDataProfilesService),G(2,f.IEnvironmentService),G(3,E.ILogService),G(4,m.IFileService),G(5,u.IStorageService),G(6,d.IUriIdentityService)],c),e.AbstractInitializer=c}),define(re[121],oe([0,1,6,25,10,3,42,2,27,17,15,120,29,33,81,14,5,72,9,20,19,30,18,41,255,118,24,61]),function(te,e,O,U,l,T,N,R,I,w,P,S,p,f,m,E,a,u,h,d,v,L,n,r,t,i,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.LocalExtensionsProvider=e.ExtensionsSynchroniser=e.stringify=e.parseExtensions=void 0;async function c(F,j){const x=JSON.parse(F.content);if(F.version===1||F.version===2){const V=(await j.getInstalled(0)).filter(B=>B.isBuiltin);for(const B of x)F.version===1&&(B.enabled===!1&&(B.disabled=!0),delete B.enabled),F.version===2&&V.every(Z=>!(0,f.areSameExtensions)(Z.identifier,B.identifier))&&(B.installed=!0)}return x}function y(F){return JSON.parse(F.content)}e.parseExtensions=y;function b(F,j){return F.sort((x,V)=>!x.identifier.uuid&&V.identifier.uuid?-1:x.identifier.uuid&&!V.identifier.uuid?1:(0,I.compare)(x.identifier.id,V.identifier.id)),j?(0,N.toFormattedString)(F,{}):JSON.stringify(F)}e.stringify=b;let g=class extends r.AbstractSynchroniser{constructor(j,x,V,B,Z,J,K,Y,H,$,X,ie,se,ae,q,C,k){super({syncResource:"extensions",profile:j},x,B,V,Z,J,K,ie,se,$,X,q),this.zb=Y,this.Ab=H,this.Bb=k,this.nb=5,this.tb=this.h.joinPath(this.g,"extensions.json"),this.ub=this.tb.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"base"}),this.vb=this.tb.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"local"}),this.wb=this.tb.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.xb=this.tb.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.yb=this.Bb.createInstance(D),this.D(T.Event.any(T.Event.filter(this.zb.onDidInstallExtensions,M=>M.some(({local:z})=>!!z)),T.Event.filter(this.zb.onDidUninstallExtension,M=>!M.error),T.Event.filter(C.onDidChange,M=>M.valueChanges.some(({profile:z,changes:_})=>this.syncResource.profile.id===z.id&&_.some(W=>W.key===p.DISABLED_EXTENSIONS_STORAGE_PATH))),ae.onDidChangeExtensionStorageToSync)(()=>this.N()))}async ob(j,x){const V=j.syncData?await c(j.syncData,this.zb):null,B=x?.skippedExtensions??[],Z=x?.builtinExtensions??null,J=x?.syncData?await c(x.syncData,this.zb):null,{localExtensions:K,ignoredExtensions:Y}=await this.yb.getLocalExtensions(this.syncResource.profile);V?this.L.trace(`${this.w}: Merging remote extensions with local extensions...`):this.L.trace(`${this.w}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:H,remote:$}=(0,t.merge)(K,V,J,B,Y,Z),X={local:H,remote:$,content:this.Eb(K,H.added,H.updated,H.removed),localChange:H.added.length>0||H.removed.length>0||H.updated.length>0?2:0,remoteChange:$!==null?2:0},ie=this.Lb(K,!1);return[{skippedExtensions:B,builtinExtensions:Z,baseResource:this.ub,baseContent:J?this.Lb(J,!1):ie,localResource:this.vb,localContent:ie,localExtensions:K,remoteResource:this.wb,remoteExtensions:V,remoteContent:V?this.Lb(V,!1):null,previewResource:this.tb,previewResult:X,localChange:X.localChange,remoteChange:X.remoteChange,acceptedResource:this.xb}]}async sb(j){const x=j.syncData?await c(j.syncData,this.zb):null,{localExtensions:V,ignoredExtensions:B}=await this.yb.getLocalExtensions(this.syncResource.profile),{remote:Z}=(0,t.merge)(V,x,x,j.skippedExtensions||[],B,j.builtinExtensions||[]);return Z!==null}Eb(j,x,V,B){const Z=[...x,...V],J=new Set,K=Y=>{J.add(Y.id.toLowerCase()),Y.uuid&&J.add(Y.uuid)};Z.forEach(({identifier:Y})=>K(Y)),B.forEach(K);for(const Y of j)J.has(Y.identifier.id.toLowerCase())||Y.identifier.uuid&&J.has(Y.identifier.uuid)||Z.push(Y);return this.Lb(Z,!1)}async pb(j,x){return{...j.previewResult,hasConflicts:!1}}async qb(j,x,V,B){if(this.h.isEqual(x,this.vb))return this.Hb(j);if(this.h.isEqual(x,this.wb))return this.Ib(j);if(this.h.isEqual(x,this.tb))return j.previewResult;throw new Error(`Invalid Resource: ${x.toString()}`)}async Hb(j){const x=await this.zb.getInstalled(void 0,this.syncResource.profile.extensionsResource),V=this.Ab.getIgnoredExtensions(x),B=(0,t.merge)(j.localExtensions,null,null,j.skippedExtensions,V,j.builtinExtensions),{local:Z,remote:J}=B;return{content:j.localContent,local:Z,remote:J,localChange:Z.added.length>0||Z.removed.length>0||Z.updated.length>0?2:0,remoteChange:J!==null?2:0}}async Ib(j){const x=await this.zb.getInstalled(void 0,this.syncResource.profile.extensionsResource),V=this.Ab.getIgnoredExtensions(x),B=j.remoteContent?JSON.parse(j.remoteContent):null;if(B!==null){const Z=(0,t.merge)(j.localExtensions,B,j.localExtensions,[],V,j.builtinExtensions),{local:J,remote:K}=Z;return{content:j.remoteContent,local:J,remote:K,localChange:J.added.length>0||J.removed.length>0||J.updated.length>0?2:0,remoteChange:K!==null?2:0}}else return{content:j.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async rb(j,x,V,B){let{skippedExtensions:Z,builtinExtensions:J,localExtensions:K}=V[0][0];const{local:Y,remote:H,localChange:$,remoteChange:X}=V[0][1];if($===0&&X===0&&this.L.info(`${this.w}: No changes found during synchronizing extensions.`),$!==0&&(await this.lb(JSON.stringify(K)),Z=await this.yb.updateLocalExtensions(Y.added,Y.removed,Y.updated,Z,this.syncResource.profile)),H){this.L.trace(`${this.w}: Updating remote extensions...`);const ie=JSON.stringify(H.all);j=await this.kb(ie,B?null:j.ref),this.L.info(`${this.w}: Updated remote extensions.${H.added.length?` Added: ${JSON.stringify(H.added.map(se=>se.identifier.id))}.`:""}${H.updated.length?` Updated: ${JSON.stringify(H.updated.map(se=>se.identifier.id))}.`:""}${H.removed.length?` Removed: ${JSON.stringify(H.removed.map(se=>se.identifier.id))}.`:""}`)}x?.ref!==j.ref&&(this.L.trace(`${this.w}: Updating last synchronized extensions...`),J=this.Kb(K,J),await this.db(j,{skippedExtensions:Z,builtinExtensions:J}),this.L.info(`${this.w}: Updated last synchronized extensions.${Z.length?` Skipped: ${JSON.stringify(Z.map(ie=>ie.identifier.id))}.`:""}`))}Kb(j,x){const V=new Set,B=[];for(const Z of j)V.add(Z.identifier.id.toLowerCase()),Z.installed||B.push(Z.identifier);if(x)for(const Z of x)V.has(Z.id.toLowerCase())||B.push(Z);return B}async resolveContent(j){if(this.h.isEqual(this.wb,j)||this.h.isEqual(this.ub,j)||this.h.isEqual(this.vb,j)||this.h.isEqual(this.xb,j)){const x=await this.bb(j);return x&&this.Lb(JSON.parse(x),!0)}return null}Lb(j,x){return b(j,x)}async hasLocalData(){try{const{localExtensions:j}=await this.yb.getLocalExtensions(this.syncResource.profile);if(j.some(x=>x.installed||x.disabled))return!0}catch{}return!1}};g=ye([G(2,P.IEnvironmentService),G(3,E.IFileService),G(4,d.IStorageService),G(5,s.IUserDataSyncStoreService),G(6,s.IUserDataSyncBackupStoreService),G(7,p.IExtensionManagementService),G(8,i.IIgnoredExtensionsManagementService),G(9,s.IUserDataSyncLogService),G(10,w.IConfigurationService),G(11,s.IUserDataSyncEnablementService),G(12,v.ITelemetryService),G(13,m.IExtensionStorageService),G(14,L.IUriIdentityService),G(15,o.IUserDataProfileStorageService),G(16,a.IInstantiationService)],g),e.ExtensionsSynchroniser=g;let D=class{constructor(j,x,V,B,Z,J){this.a=j,this.b=x,this.c=V,this.d=B,this.f=Z,this.g=J}async getLocalExtensions(j){const x=await this.a.getInstalled(void 0,j.extensionsResource),V=this.d.getIgnoredExtensions(x);return{localExtensions:await this.j(j,async(Z,J)=>{const K=Z.getDisabledExtensions();return x.map(Y=>{const{identifier:H,isBuiltin:$,manifest:X,preRelease:ie,pinned:se}=Y,ae={identifier:H,preRelease:ie,version:X.version,pinned:!!se};K.some(q=>(0,f.areSameExtensions)(q,H))&&(ae.disabled=!0),$||(ae.installed=!0);try{const q=J.getKeysForSync({id:H.id,version:X.version});if(q){const C=J.getExtensionState(Y,!0)||{};ae.state=Object.keys(C).reduce((k,M)=>(q.includes(M)&&(k[M]=C[M]),k),{})}}catch(q){this.g.info(`${(0,r.getSyncResourceLogLabel)("extensions",j)}: Error while parsing extension state`,(0,l.getErrorMessage)(q))}return ae})}),ignoredExtensions:V}}async updateLocalExtensions(j,x,V,B,Z){const J=(0,r.getSyncResourceLogLabel)("extensions",Z),K=[],Y=[],H=[],$=await this.a.getInstalled(void 0,Z.extensionsResource);if((j.length||V.length)&&await this.j(Z,async(ie,se)=>{await O.Promises.settled([...j,...V].map(async ae=>{const q=$.find(M=>(0,f.areSameExtensions)(M.identifier,ae.identifier));if(q&&q.isBuiltin){ae.state&&q.manifest.version===ae.version&&this.h(ae.state,q,q.manifest.version,se),ie.getDisabledExtensions().some(z=>(0,f.areSameExtensions)(z,ae.identifier))!==!!ae.disabled&&(ae.disabled?(this.g.trace(`${J}: Disabling extension...`,ae.identifier.id),await ie.disableExtension(ae.identifier),this.g.info(`${J}: Disabled extension`,ae.identifier.id)):(this.g.trace(`${J}: Enabling extension...`,ae.identifier.id),await ie.enableExtension(ae.identifier),this.g.info(`${J}: Enabled extension`,ae.identifier.id))),Y.push(ae.identifier);return}const C=ae.pinned?ae.version:void 0,k=(await this.c.getExtensions([{...ae.identifier,version:C,preRelease:C?void 0:ae.preRelease}],U.CancellationToken.None))[0];if(ae.state&&(q?q.manifest.version===ae.version:!!k)&&this.h(ae.state,q||k,q?.manifest.version,se),k)try{ie.getDisabledExtensions().some(z=>(0,f.areSameExtensions)(z,ae.identifier))!==!!ae.disabled&&(ae.disabled?(this.g.trace(`${J}: Disabling extension...`,ae.identifier.id,k.version),await ie.disableExtension(k.identifier),this.g.info(`${J}: Disabled extension`,ae.identifier.id,k.version)):(this.g.trace(`${J}: Enabling extension...`,ae.identifier.id,k.version),await ie.enableExtension(k.identifier),this.g.info(`${J}: Enabled extension`,ae.identifier.id,k.version))),(!q||q.preRelease!==ae.preRelease||q.pinned!==ae.pinned||C&&q.manifest.version!==C)&&(await this.a.canInstall(k)?K.push([ae,k]):(this.g.info(`${J}: Skipped synchronizing extension because it cannot be installed.`,k.displayName||k.identifier.id),H.push(ae)))}catch(M){H.push(ae),this.g.error(M),this.g.info(`${J}: Skipped synchronizing extension`,k.displayName||k.identifier.id)}else H.push(ae),this.g.info(`${J}: Skipped synchronizing extension because the extension is not found.`,ae.identifier.id)}))}),x.length){const ie=$.filter(({identifier:se,isBuiltin:ae})=>!ae&&x.some(q=>(0,f.areSameExtensions)(se,q)));await O.Promises.settled(ie.map(async se=>{this.g.trace(`${J}: Uninstalling local extension...`,se.identifier.id),await this.a.uninstall(se,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:Z.extensionsResource}),this.g.info(`${J}: Uninstalled local extension.`,se.identifier.id),Y.push(se.identifier)}))}for(const[ie,se]of K)try{this.g.trace(`${J}: Installing extension...`,se.identifier.id,se.version),await this.a.installFromGallery(se,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:ie.pinned&&!!ie.version,installPreReleaseVersion:ie.preRelease,profileLocation:Z.extensionsResource,context:{[p.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT]:!0,[p.EXTENSION_INSTALL_SYNC_CONTEXT]:!0}}),this.g.info(`${J}: Installed extension.`,se.identifier.id,se.version),Y.push(se.identifier)}catch(ae){H.push(ie),ae instanceof p.ExtensionManagementError&&[p.ExtensionManagementErrorCode.Incompatible,p.ExtensionManagementErrorCode.IncompatiblePreRelease,p.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(ae.code)?this.g.info(`${J}: Skipped synchronizing extension because the compatible extension is not found.`,se.displayName||se.identifier.id):(this.g.error(ae),this.g.info(`${J}: Skipped synchronizing extension`,se.displayName||se.identifier.id))}const X=[];for(const ie of B)Y.some(se=>(0,f.areSameExtensions)(se,ie.identifier))||X.push(ie);for(const ie of H)X.some(se=>(0,f.areSameExtensions)(se.identifier,ie.identifier))||X.push(ie);return X}h(j,x,V,B){const Z=B.getExtensionState(x,!0)||{},J=V?B.getKeysForSync({id:x.identifier.id,version:V}):void 0;J?J.forEach(K=>{Z[K]=j[K]}):Object.keys(j).forEach(K=>Z[K]=j[K]),B.setExtensionState(x,Z,!0)}async j(j,x){return this.b.withProfileScopedStorageService(j,async V=>{const B=new R.DisposableStore,Z=this.f.createChild(new u.ServiceCollection([d.IStorageService,V])),J=B.add(Z.createInstance(S.GlobalExtensionEnablementService)),K=B.add(Z.createInstance(m.ExtensionStorageService));try{return await x(J,K)}finally{B.dispose()}})}};D=ye([G(0,p.IExtensionManagementService),G(1,o.IUserDataProfileStorageService),G(2,p.IExtensionGalleryService),G(3,i.IIgnoredExtensionsManagementService),G(4,a.IInstantiationService),G(5,s.IUserDataSyncLogService)],D),e.LocalExtensionsProvider=D;let A=class extends r.AbstractInitializer{constructor(j,x,V,B,Z,J,K,Y){super("extensions",B,Z,J,V,K,Y),this.p=j,this.q=x}async t(j){return j.syncData?await c(j.syncData,this.p):null}u(j,x){const V=[],B=[],Z=[];for(const J of j){if(this.q.hasToNeverSyncExtension(J.identifier.id))continue;const K=x.find(Y=>(0,f.areSameExtensions)(Y.identifier,J.identifier));K?(V.push(K),J.disabled&&Z.push(J.identifier)):J.installed&&(B.push({...J.identifier,preRelease:!!J.preRelease}),J.disabled&&Z.push(J.identifier))}return{installedExtensions:V,newExtensions:B,disabledExtensions:Z,remoteExtensions:j}}};A=ye([G(0,p.IExtensionManagementService),G(1,i.IIgnoredExtensionsManagementService),G(2,E.IFileService),G(3,n.IUserDataProfilesService),G(4,P.IEnvironmentService),G(5,h.ILogService),G(6,d.IStorageService),G(7,L.IUriIdentityService)],A),e.AbstractExtensionsInitializer=A}),define(re[122],oe([0,1,16,10,3,35,42,4,31,17,15,14,9,44,20,19,30,41,60,259,24,18,61,5]),function(te,e,O,U,l,T,N,R,I,w,P,S,p,f,m,E,a,u,h,d,v,L,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.LocalGlobalStateProvider=e.GlobalStateSynchroniser=e.stringify=void 0;const t="globalState.argv.",i=["locale"];function s(D,A){const F=D.storage?Object.keys(D.storage).sort():[],j={};return F.forEach(x=>j[x]=D.storage[x]),D.storage=j,A?(0,N.toFormattedString)(D,{}):JSON.stringify(D)}e.stringify=s;const o=1;let c=class extends u.AbstractSynchroniser{constructor(A,F,j,x,V,B,Z,J,K,Y,H,$,X,ie){super({syncResource:"globalState",profile:A},F,x,J,$,V,B,K,Y,Z,H,X),this.xb=j,this.nb=o,this.p=this.h.joinPath(this.g,"globalState.json"),this.r=this.p.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"base"}),this.tb=this.p.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),this.ub=this.p.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.vb=this.p.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.wb=ie.createInstance(y),this.D(x.watch(this.h.dirname(this.C.argvResource))),this.D(l.Event.any(l.Event.filter(x.onDidFilesChange,se=>se.contains(this.C.argvResource)),l.Event.filter(j.onDidChange,se=>!!(se.targetChanges.some(ae=>this.syncResource.profile.id===ae.id)||se.valueChanges.some(({profile:ae,changes:q})=>this.syncResource.profile.id===ae.id&&q.some(C=>C.target===0)))))(()=>this.N()))}async ob(A,F,j){const x=A.syncData?JSON.parse(A.syncData.content):null;F=F===null&&j?A:F;const V=F&&F.syncData?JSON.parse(F.syncData.content):null,B=await this.wb.getLocalGlobalState(this.syncResource.profile);x?this.L.trace(`${this.w}: Merging remote ui state with local ui state...`):this.L.trace(`${this.w}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const Z=await this.Fb(V),{local:J,remote:K}=(0,d.merge)(B.storage,x?x.storage:null,V?V.storage:null,Z,this.L),Y={content:null,local:J,remote:K,localChange:Object.keys(J.added).length>0||Object.keys(J.updated).length>0||J.removed.length>0?2:0,remoteChange:K.all!==null?2:0},H=s(B,!1);return[{baseResource:this.r,baseContent:V?s(V,!1):H,localResource:this.tb,localContent:H,localUserData:B,remoteResource:this.ub,remoteContent:x?s(x,!1):null,previewResource:this.p,previewResult:Y,localChange:Y.localChange,remoteChange:Y.remoteChange,acceptedResource:this.vb,storageKeys:Z}]}async sb(A){const F=A.syncData?JSON.parse(A.syncData.content):null;if(F===null)return!0;const j=await this.wb.getLocalGlobalState(this.syncResource.profile),x=await this.Fb(F),{remote:V}=(0,d.merge)(j.storage,F.storage,F.storage,x,this.L);return V.all!==null}async pb(A,F){return{...A.previewResult,hasConflicts:!1}}async qb(A,F,j,x){if(this.h.isEqual(F,this.tb))return this.Cb(A);if(this.h.isEqual(F,this.ub))return this.Db(A);if(this.h.isEqual(F,this.p))return A.previewResult;throw new Error(`Invalid Resource: ${F.toString()}`)}async Cb(A){return{content:A.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(A.localUserData.storage),removed:[],updated:[],all:A.localUserData.storage},localChange:0,remoteChange:2}}async Db(A){if(A.remoteContent!==null){const F=JSON.parse(A.remoteContent),{local:j,remote:x}=(0,d.merge)(A.localUserData.storage,F.storage,null,A.storageKeys,this.L);return{content:A.remoteContent,local:j,remote:x,localChange:Object.keys(j.added).length>0||Object.keys(j.updated).length>0||j.removed.length>0?2:0,remoteChange:x!==null?2:0}}else return{content:A.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async rb(A,F,j,x){const{localUserData:V}=j[0][0],{local:B,remote:Z,localChange:J,remoteChange:K}=j[0][1];if(J===0&&K===0&&this.L.info(`${this.w}: No changes found during synchronizing ui state.`),J!==0&&(this.L.trace(`${this.w}: Updating local ui state...`),await this.lb(JSON.stringify(V)),await this.wb.writeLocalGlobalState(B,this.syncResource.profile),this.L.info(`${this.w}: Updated local ui state`)),K!==0){this.L.trace(`${this.w}: Updating remote ui state...`);const Y=JSON.stringify({storage:Z.all});A=await this.kb(Y,x?null:A.ref),this.L.info(`${this.w}: Updated remote ui state.${Z.added.length?` Added: ${Z.added}.`:""}${Z.updated.length?` Updated: ${Z.updated}.`:""}${Z.removed.length?` Removed: ${Z.removed}.`:""}`)}F?.ref!==A.ref&&(this.L.trace(`${this.w}: Updating last synchronized ui state...`),await this.db(A),this.L.info(`${this.w}: Updated last synchronized ui state`))}async resolveContent(A){if(this.h.isEqual(this.ub,A)||this.h.isEqual(this.r,A)||this.h.isEqual(this.tb,A)||this.h.isEqual(this.vb,A)){const F=await this.bb(A);return F&&s(JSON.parse(F),!0)}return null}async hasLocalData(){try{const{storage:A}=await this.wb.getLocalGlobalState(this.syncResource.profile);if(Object.keys(A).length>1||A[`${t}.locale`]?.value!=="en")return!0}catch{}return!1}async Fb(A){const F=await this.xb.readStorageData(this.syncResource.profile),j=[],x=[];for(const[Z,J]of F)J.target===0?j.push(Z):J.target===1&&x.push(Z);const V=[...j,...x],B=A?.storage?Object.keys(A.storage).filter(Z=>!Z.startsWith(t)&&!V.includes(Z)&&F.get(Z)!==void 0):[];if(!R.isWeb){const Z=[...v.ALL_SYNC_RESOURCES.map(J=>(0,v.getEnablementKey)(J)),v.SYNC_SERVICE_URL_TYPE];B.push(...Z),x.push(...Z)}return{user:j,machine:x,unregistered:B}}};c=ye([G(2,n.IUserDataProfileStorageService),G(3,S.IFileService),G(4,v.IUserDataSyncStoreService),G(5,v.IUserDataSyncBackupStoreService),G(6,v.IUserDataSyncLogService),G(7,P.IEnvironmentService),G(8,v.IUserDataSyncEnablementService),G(9,E.ITelemetryService),G(10,w.IConfigurationService),G(11,m.IStorageService),G(12,a.IUriIdentityService),G(13,r.IInstantiationService)],c),e.GlobalStateSynchroniser=c;let y=class{constructor(A,F,j,x){this.a=A,this.b=F,this.c=j,this.d=x}async getLocalGlobalState(A){const F={};if(A.isDefault){const x=await this.f(),V=(0,T.parse)(x);for(const B of i)V[B]!==void 0&&(F[`${t}${B}`]={version:1,value:V[B]})}const j=await this.c.readStorageData(A);for(const[x,V]of j)V.value&&V.target===0&&(F[x]={version:1,value:V.value});return{storage:F}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const A=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),A.value.toString()}catch(A){this.d.debug((0,U.getErrorMessage)(A))}return"{}"}async writeLocalGlobalState({added:A,removed:F,updated:j},x){const V=(0,u.getSyncResourceLogLabel)("globalState",x),B={},Z=new Map,J=await this.c.readStorageData(x),K=(Y,H)=>{for(const $ of Y){if($.startsWith(t)){B[$.substring(t.length)]=H?H[$].value:void 0;continue}if(H){const X=H[$];X.value!==J.get($)?.value&&Z.set($,X.value)}else J.get($)!==void 0&&Z.set($,void 0)}};if(K(Object.keys(A),A),K(Object.keys(j),j),K(F),Object.keys(B).length){this.d.trace(`${V}: Updating locale...`);const Y=await this.f();let H=Y;for(const $ of Object.keys(B))H=(0,h.edit)(H,[$],B[$],{});Y!==H&&(this.d.trace(`${V}: Updating locale...`),await this.a.writeFile(this.b.argvResource,O.VSBuffer.fromString(H)),this.d.info(`${V}: Updated locale.`)),this.d.info(`${V}: Updated locale`)}Z.size&&(this.d.trace(`${V}: Updating global state...`),await this.c.updateStorageData(x,Z,0),this.d.info(`${V}: Updated global state`,[...Z.keys()]))}};y=ye([G(0,S.IFileService),G(1,P.IEnvironmentService),G(2,n.IUserDataProfileStorageService),G(3,v.IUserDataSyncLogService)],y),e.LocalGlobalStateProvider=y;let b=class extends u.AbstractInitializer{constructor(A,F,j,x,V,B){super("globalState",j,x,V,F,A,B)}async o(A){const F=A.syncData?JSON.parse(A.syncData.content):null;if(!F){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const j={},x={};for(const V of Object.keys(F.storage))V.startsWith(t)?j[V.substring(t.length)]=F.storage[V].value:this.l.get(V,0)===void 0&&(x[V]=F.storage[V].value);if(Object.keys(j).length){let V="{}";try{V=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const B of Object.keys(j))V=(0,h.edit)(V,[B],j[B],{});await this.k.writeFile(this.h.argvResource,O.VSBuffer.fromString(V))}if(Object.keys(x).length)for(const V of Object.keys(x))this.l.store(V,x[V],0,0)}};b=ye([G(0,m.IStorageService),G(1,S.IFileService),G(2,L.IUserDataProfilesService),G(3,P.IEnvironmentService),G(4,v.IUserDataSyncLogService),G(5,a.IUriIdentityService)],b),e.GlobalStateInitializer=b;let g=class{constructor(A,F,j,x,V){this.a=A,this.b=F,this.c=j,this.d=x,this.f=V}getSyncStoreType(A){return this.h(A)?.storage[v.SYNC_SERVICE_URL_TYPE]?.value}async sync(A){const F=(0,v.createSyncHeaders)((0,I.generateUuid)());try{return await this.g(A,F)}catch(j){if(j instanceof v.UserDataSyncError)switch(j.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(A,F)}throw j}}async g(A,F){const j=await this.a.readResource("globalState",null,void 0,F),x=this.h(j)||{storage:{}};x.storage[v.SYNC_SERVICE_URL_TYPE]={value:A,version:o};const V=await(0,f.getServiceMachineId)(this.c,this.d,this.b),B={version:o,machineId:V,content:s(x,!1)};await this.a.writeResource("globalState",JSON.stringify(B),j.ref,void 0,F)}h({content:A}){if(!A)return null;const F=JSON.parse(A);if((0,u.isSyncData)(F))return F?JSON.parse(F.content):null;throw new Error("Invalid remote data")}};g=ye([G(1,m.IStorageService),G(2,P.IEnvironmentService),G(3,S.IFileService),G(4,p.ILogService)],g),e.UserDataSyncStoreTypeSynchronizer=g}),define(re[123],oe([0,1,21,16,3,35,4,12,182,17,15,14,20,19,30,18,41,256,24]),function(te,e,O,U,l,T,N,R,I,w,P,S,p,f,m,E,a,u,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function d(n,r,t){try{const i=JSON.parse(n);if(!r)return(0,R.isUndefined)(i.all)?null:i.all;switch(N.OS){case 2:return(0,R.isUndefined)(i.mac)?null:i.mac;case 3:return(0,R.isUndefined)(i.linux)?null:i.linux;case 1:return(0,R.isUndefined)(i.windows)?null:i.windows}}catch(i){return t.error(i),null}}e.getKeybindingsContentFromSyncContent=d;let v=class extends a.AbstractJsonFileSynchroniser{constructor(r,t,i,s,o,c,y,b,g,D,A,F,j){super(r.keybindingsResource,{syncResource:"keybindings",profile:r},t,b,g,D,i,s,y,F,o,A,c,j),this.nb=2,this.Ab=this.h.joinPath(this.g,"keybindings.json"),this.Bb=this.Ab.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),this.Cb=this.Ab.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),this.Db=this.Ab.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.Eb=this.Ab.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.D(l.Event.filter(c.onDidChangeConfiguration,x=>x.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.N()))}async ob(r,t,i,s){const o=r.syncData?d(r.syncData.content,s.keybindingsPerPlatform??this.Mb(),this.L):null;t=t===null&&i?r:t;const c=t?this.Kb(t):null,y=await this.p(),b=await this.yb();let g=null,D=!1,A=!1,F=!1;if(o){let V=y?y.value.toString():"[]";if(V=V||"[]",this.wb(V,!0))throw new h.UserDataSyncError((0,I.localize)(0,null),"LocalInvalidContent",this.resource);if(!c||c!==V||c!==o){this.L.trace(`${this.w}: Merging remote keybindings with local keybindings...`);const B=await(0,u.merge)(V,o,c,b,this.vb);B.hasChanges&&(g=B.mergeContent,F=B.hasConflicts,D=F||B.mergeContent!==V,A=F||B.mergeContent!==o)}}else y&&(this.L.trace(`${this.w}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),g=y.value.toString(),A=!0);const j={content:F?c:g,localChange:D?y?2:1:0,remoteChange:A?2:0,hasConflicts:F},x=y?y.value.toString():null;return[{fileContent:y,baseResource:this.Bb,baseContent:c,localResource:this.Cb,localContent:x,localChange:j.localChange,remoteResource:this.Db,remoteContent:o,remoteChange:j.remoteChange,previewResource:this.Ab,previewResult:j,acceptedResource:this.Eb}]}async sb(r){const t=this.Kb(r);if(t===null)return!0;const i=await this.p(),s=i?i.value.toString():"",o=await this.yb(),c=await(0,u.merge)(s||"[]",t,t,o,this.vb);return c.hasConflicts||c.mergeContent!==t}async pb(r,t){return r.previewResult}async qb(r,t,i,s){if(this.h.isEqual(t,this.Cb))return{content:r.fileContent?r.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(t,this.Db))return{content:r.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(t,this.Ab))return i===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:i,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async rb(r,t,i,s){const{fileContent:o}=i[0][0];let{content:c,localChange:y,remoteChange:b}=i[0][1];if(y===0&&b===0&&this.L.info(`${this.w}: No changes found during synchronizing keybindings.`),c!==null&&(c=c.trim(),c=c||"[]",this.wb(c,!0)))throw new h.UserDataSyncError((0,I.localize)(1,null),"LocalInvalidContent",this.resource);if(y!==0&&(this.L.trace(`${this.w}: Updating local keybindings...`),o&&await this.lb(this.Lb(o.value.toString())),await this.r(c||"[]",o,s),this.L.info(`${this.w}: Updated local keybindings`)),b!==0){this.L.trace(`${this.w}: Updating remote keybindings...`);const g=this.Lb(c||"[]",r.syncData?.content);r=await this.kb(g,s?null:r.ref),this.L.info(`${this.w}: Updated remote keybindings`)}try{await this.z.del(this.Ab)}catch{}t?.ref!==r.ref&&(this.L.trace(`${this.w}: Updating last synchronized keybindings...`),await this.db(r,{platformSpecific:this.Mb()}),this.L.info(`${this.w}: Updated last synchronized keybindings`))}async hasLocalData(){try{const r=await this.p();if(r){const t=(0,T.parse)(r.value.toString());if((0,O.isNonEmptyArray)(t))return!0}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async resolveContent(r){return this.h.isEqual(this.Db,r)||this.h.isEqual(this.Bb,r)||this.h.isEqual(this.Cb,r)||this.h.isEqual(this.Eb,r)?this.bb(r):null}Kb(r){return!r.syncData||r.platformSpecific!==void 0&&r.platformSpecific!==this.Mb()?null:d(r.syncData.content,this.Mb(),this.L)}Lb(r,t){let i={};try{i=JSON.parse(t||"{}")}catch(s){this.L.error(s)}switch(this.Mb()?delete i.all:i.all=r,N.OS){case 2:i.mac=r;break;case 3:i.linux=r;break;case 1:i.windows=r;break}return JSON.stringify(i)}Mb(){return!!this.M.getValue(h.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM)}};v=ye([G(2,h.IUserDataSyncStoreService),G(3,h.IUserDataSyncBackupStoreService),G(4,h.IUserDataSyncLogService),G(5,w.IConfigurationService),G(6,h.IUserDataSyncEnablementService),G(7,S.IFileService),G(8,P.IEnvironmentService),G(9,p.IStorageService),G(10,h.IUserDataSyncUtilService),G(11,f.ITelemetryService),G(12,m.IUriIdentityService)],v),e.KeybindingsSynchroniser=v;let L=class extends a.AbstractInitializer{constructor(r,t,i,s,o,c){super("keybindings",t,i,s,r,o,c)}async o(r){const t=r.syncData?this.p(r.syncData.content):null;if(!t){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,U.VSBuffer.fromString(t)),await this.n(r)}async i(){try{const r=await this.k.readFile(this.g.defaultProfile.settingsResource),t=(0,T.parse)(r.value.toString());return!(0,O.isNonEmptyArray)(t)}catch(r){return r.fileOperationResult===1}}p(r){try{return d(r,!0,this.j)}catch(t){return this.j.error(t),null}}};L=ye([G(0,S.IFileService),G(1,E.IUserDataProfilesService),G(2,P.IEnvironmentService),G(3,h.IUserDataSyncLogService),G(4,p.IStorageService),G(5,m.IUriIdentityService)],L),e.KeybindingsInitializer=L}),define(re[124],oe([0,1,16,3,183,17,75,15,29,14,20,19,30,18,41,60,260,24]),function(te,e,O,U,l,T,N,R,I,w,P,S,p,f,m,E,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function h(n){return n&&n.settings&&typeof n.settings=="string"&&Object.keys(n).length===1}function d(n){const r=JSON.parse(n);return h(r)?r:{settings:n}}e.parseSettingsSyncContent=d;let v=class extends m.AbstractJsonFileSynchroniser{constructor(r,t,i,s,o,c,y,b,g,D,A,F,j,x){super(r.settingsResource,{syncResource:"settings",profile:r},t,i,s,o,c,y,A,F,b,g,D,x),this.Ab=j,this.nb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.Kb=void 0}async getRemoteUserDataSyncConfiguration(r){const t=await this.getLastSyncUserData(),i=await this.S(r,t),s=this.Hb(i),o=new N.ConfigurationModelParser(u.USER_DATA_SYNC_CONFIGURATION_SCOPE);return s?.settings&&o.parse(s.settings),o.configurationModel.getValue(u.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async ob(r,t,i){const s=await this.p(),o=await this.yb(),c=this.Hb(r);t=t===null&&i?r:t;const y=t?this.Hb(t):null,b=await this.Lb();let g=null,D=!1,A=!1,F=!1;if(c){let B=s?s.value.toString().trim():"{}";B=B||"{}",this.Mb(B),this.L.trace(`${this.w}: Merging remote settings with local settings...`);const Z=(0,a.merge)(B,c.settings,y?y.settings:null,b,[],o);g=Z.localContent||Z.remoteContent,D=Z.localContent!==null,A=Z.remoteContent!==null,F=Z.hasConflicts}else s&&(this.L.trace(`${this.w}: Remote settings does not exist. Synchronizing settings for the first time.`),g=s.value.toString().trim()||"{}",this.Mb(g),A=!0);const j=s?s.value.toString():null,x=y?.settings??null,V={content:F?x:g,localChange:D?2:0,remoteChange:A?2:0,hasConflicts:F};return[{fileContent:s,baseResource:this.baseResource,baseContent:x,localResource:this.localResource,localContent:j,localChange:V.localChange,remoteResource:this.remoteResource,remoteContent:c?c.settings:null,remoteChange:V.remoteChange,previewResource:this.previewResource,previewResult:V,acceptedResource:this.acceptedResource}]}async sb(r){const t=this.Hb(r);if(t===null)return!0;const i=await this.p(),s=i?i.value.toString().trim():"",o=await this.Lb(),c=await this.yb();return(0,a.merge)(s||"{}",t.settings,t.settings,o,[],c).remoteContent!==null}async pb(r,t){const i=await this.yb(),s=await this.Lb();return{...r.previewResult,content:r.previewResult.content?(0,a.updateIgnoredSettings)(r.previewResult.content,"{}",s,i):null}}async qb(r,t,i,s){const o=await this.yb(),c=await this.Lb();if(this.h.isEqual(t,this.localResource))return{content:r.fileContent?(0,a.updateIgnoredSettings)(r.fileContent.value.toString(),"{}",c,o):null,localChange:0,remoteChange:2};if(this.h.isEqual(t,this.remoteResource))return{content:r.remoteContent!==null?(0,a.updateIgnoredSettings)(r.remoteContent,r.fileContent?r.fileContent.value.toString():"{}",c,o):null,localChange:2,remoteChange:0};if(this.h.isEqual(t,this.previewResource))return i===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:i!==null?(0,a.updateIgnoredSettings)(i,r.fileContent?r.fileContent.value.toString():"{}",c,o):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async rb(r,t,i,s){const{fileContent:o}=i[0][0];let{content:c,localChange:y,remoteChange:b}=i[0][1];if(y===0&&b===0&&this.L.info(`${this.w}: No changes found during synchronizing settings.`),c=c?c.trim():"{}",c=c||"{}",this.Mb(c),y!==0&&(this.L.trace(`${this.w}: Updating local settings...`),o&&await this.lb(JSON.stringify(this.Jb(o.value.toString()))),await this.r(c,o,s),await this.M.reloadConfiguration(3),this.L.info(`${this.w}: Updated local settings`)),b!==0){const g=await this.yb(),D=this.Hb(r),A=await this.Lb(c);c=(0,a.updateIgnoredSettings)(c,D?D.settings:"{}",A,g),this.L.trace(`${this.w}: Updating remote settings...`),r=await this.kb(JSON.stringify(this.Jb(c)),s?null:r.ref),this.L.info(`${this.w}: Updated remote settings`)}try{await this.z.del(this.previewResource)}catch{}t?.ref!==r.ref&&(this.L.trace(`${this.w}: Updating last synchronized settings...`),await this.db(r),this.L.info(`${this.w}: Updated last synchronized settings`))}async hasLocalData(){try{const r=await this.p();if(r){const t=await this.yb(),i=(0,E.edit)(r.value.toString(),[u.CONFIGURATION_SYNC_STORE_KEY],void 0,t);return!(0,a.isEmpty)(i)}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async resolveContent(r){return this.h.isEqual(this.remoteResource,r)||this.h.isEqual(this.localResource,r)||this.h.isEqual(this.acceptedResource,r)||this.h.isEqual(this.baseResource,r)?this.bb(r):null}async bb(r){let t=await super.bb(r);if(t){const i=await this.yb(),s=await this.Lb();t=(0,a.updateIgnoredSettings)(t,"{}",s,i)}return t}Hb(r){return r.syncData?this.Ib(r.syncData.content):null}Ib(r){try{return d(r)}catch(t){this.L.error(t)}return null}Jb(r){return{settings:r}}async Lb(r){if(!this.Kb){this.Kb=this.vb.resolveDefaultIgnoredSettings();const i=U.Event.any(U.Event.filter(this.Ab.onDidInstallExtensions,s=>s.some(({local:o})=>!!o)),U.Event.filter(this.Ab.onDidUninstallExtension,s=>!s.error))(()=>{i.dispose(),this.Kb=void 0})}const t=await this.Kb;return(0,a.getIgnoredSettings)(t,this.M,r)}Mb(r){if(this.wb(r,!1))throw new u.UserDataSyncError((0,l.localize)(0,null),"LocalInvalidContent",this.resource)}};v=ye([G(2,w.IFileService),G(3,R.IEnvironmentService),G(4,P.IStorageService),G(5,u.IUserDataSyncStoreService),G(6,u.IUserDataSyncBackupStoreService),G(7,u.IUserDataSyncLogService),G(8,u.IUserDataSyncUtilService),G(9,T.IConfigurationService),G(10,u.IUserDataSyncEnablementService),G(11,S.ITelemetryService),G(12,I.IExtensionManagementService),G(13,p.IUriIdentityService)],v),e.SettingsSynchroniser=v;let L=class extends m.AbstractInitializer{constructor(r,t,i,s,o,c){super("settings",t,i,s,r,o,c)}async o(r){const t=r.syncData?this.p(r.syncData.content):null;if(!t){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,O.VSBuffer.fromString(t.settings)),await this.n(r)}async i(){try{const r=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,a.isEmpty)(r.value.toString().trim())}catch(r){return r.fileOperationResult===1}}p(r){try{return d(r)}catch(t){this.j.error(t)}return null}};L=ye([G(0,w.IFileService),G(1,f.IUserDataProfilesService),G(2,R.IEnvironmentService),G(3,u.IUserDataSyncLogService),G(4,P.IStorageService),G(5,p.IUriIdentityService)],L),e.SettingsInitializer=L}),define(re[125],oe([0,1,16,3,32,17,15,14,20,19,30,18,41,257,24]),function(te,e,O,U,l,T,N,R,I,w,P,S,p,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=e.parseSnippets=void 0;function E(h){return JSON.parse(h.content)}e.parseSnippets=E;let a=class extends p.AbstractSynchroniser{constructor(d,v,L,n,r,t,i,s,o,c,y,b){super({syncResource:"snippets",profile:d},v,n,L,r,t,i,c,y,s,o,b),this.nb=1,this.p=d.snippetsHome,this.D(this.z.watch(L.userRoamingDataHome)),this.D(this.z.watch(this.p)),this.D(U.Event.filter(this.z.onDidFilesChange,g=>g.affects(this.p))(()=>this.N()))}async ob(d,v,L){const n=await this.Db(),r=this.Cb(n),t=d.syncData?this.Bb(d.syncData):null;v=v===null&&L?d:v;const i=v&&v.syncData?this.Bb(v.syncData):null;t?this.L.trace(`${this.w}: Merging remote snippets with local snippets...`):this.L.trace(`${this.w}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const s=(0,f.merge)(r,t,i);return this.xb(s,n,t||{},i||{})}async sb(d){const v=d.syncData?this.Bb(d.syncData):null;if(v===null)return!0;const L=await this.Db(),n=this.Cb(L),r=(0,f.merge)(n,v,v);return Object.keys(r.remote.added).length>0||Object.keys(r.remote.updated).length>0||r.remote.removed.length>0||r.conflicts.length>0}async pb(d,v){return d.previewResult}async qb(d,v,L,n){if(this.h.isEqualOrParent(v,this.g.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:d.fileContent?d.fileContent.value.toString():null,localChange:0,remoteChange:d.fileContent?d.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(v,this.g.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:d.remoteContent,localChange:d.remoteContent!==null?d.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(v,this.g))return L===void 0?{content:d.previewResult.content,localChange:d.previewResult.localChange,remoteChange:d.previewResult.remoteChange}:{content:L,localChange:L===null?d.fileContent!==null?3:0:2,remoteChange:L===null?d.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${v.toString()}`)}async rb(d,v,L,n){const r=L.map(([t,i])=>({...t,acceptResult:i}));r.every(({localChange:t,remoteChange:i})=>t===0&&i===0)&&this.L.info(`${this.w}: No changes found during synchronizing snippets.`),r.some(({localChange:t})=>t!==0)&&(await this.yb(r),await this.zb(r,n)),r.some(({remoteChange:t})=>t!==0)&&(d=await this.Ab(r,d,n)),v?.ref!==d.ref&&(this.L.trace(`${this.w}: Updating last synchronized snippets...`),await this.db(d),this.L.info(`${this.w}: Updated last synchronized snippets`));for(const{previewResource:t}of r)try{await this.z.del(t)}catch{}}xb(d,v,L,n){const r=new Map;for(const t of Object.keys(d.local.added)){const i={content:d.local.added[t],hasConflicts:!1,localChange:1,remoteChange:0};r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:L[t],previewResource:this.h.joinPath(this.g,t),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(d.local.updated)){const i={content:d.local.updated[t],hasConflicts:!1,localChange:2,remoteChange:0},s=v[t]?v[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[t],localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:L[t],previewResource:this.h.joinPath(this.g,t),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of d.local.removed){const i={content:null,hasConflicts:!1,localChange:3,remoteChange:0},s=v[t]?v[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[t],localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,t),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(d.remote.added)){const i={content:d.remote.added[t],hasConflicts:!1,localChange:0,remoteChange:1},s=v[t]?v[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[t],localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,t),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(d.remote.updated)){const i={content:d.remote.updated[t],hasConflicts:!1,localChange:0,remoteChange:2},s=v[t]?v[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[t],localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:L[t],previewResource:this.h.joinPath(this.g,t),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of d.remote.removed){const i={content:null,hasConflicts:!1,localChange:0,remoteChange:3};r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:L[t],previewResource:this.h.joinPath(this.g,t),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of d.conflicts){const i={content:n[t]??null,hasConflicts:!0,localChange:v[t]?2:1,remoteChange:L[t]?2:1},s=v[t]?v[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[t]||null,localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:L[t]||null,previewResource:this.h.joinPath(this.g,t),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(v))if(!r.has(t)){const i={content:v[t]?v[t].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},s=v[t]?v[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[t]||null,localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:L[t]||null,previewResource:this.h.joinPath(this.g,t),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...r.values()]}async resolveContent(d){return this.h.isEqualOrParent(d,this.g.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.h.isEqualOrParent(d,this.g.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.h.isEqualOrParent(d,this.g.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}))||this.h.isEqualOrParent(d,this.g.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"}))?this.bb(d):null}async hasLocalData(){try{const d=await this.Db();if(Object.keys(d).length)return!0}catch{}return!1}async yb(d){const v={};for(const L of d)L.fileContent&&(v[this.h.basename(L.localResource)]=L.fileContent);await this.lb(JSON.stringify(this.Cb(v)))}async zb(d,v){for(const{fileContent:L,acceptResult:n,localResource:r,remoteResource:t,localChange:i}of d)if(i!==0){const s=t?this.h.basename(t):this.h.basename(r),o=this.h.joinPath(this.p,s);i===3?(this.L.trace(`${this.w}: Deleting snippet...`,this.h.basename(o)),await this.z.del(o),this.L.info(`${this.w}: Deleted snippet`,this.h.basename(o))):i===1?(this.L.trace(`${this.w}: Creating snippet...`,this.h.basename(o)),await this.z.createFile(o,O.VSBuffer.fromString(n.content),{overwrite:v}),this.L.info(`${this.w}: Created snippet`,this.h.basename(o))):(this.L.trace(`${this.w}: Updating snippet...`,this.h.basename(o)),await this.z.writeFile(o,O.VSBuffer.fromString(n.content),v?void 0:L),this.L.info(`${this.w}: Updated snippet`,this.h.basename(o)))}}async Ab(d,v,L){const n=v.syncData?this.Bb(v.syncData):{},r=(0,l.deepClone)(n);for(const{acceptResult:t,localResource:i,remoteResource:s,remoteChange:o}of d)if(o!==0){const c=i?this.h.basename(i):this.h.basename(s);o===3?delete r[c]:r[c]=t.content}return(0,f.areSame)(n,r)||(this.L.trace(`${this.w}: Updating remote snippets...`),v=await this.kb(JSON.stringify(r),L?null:v.ref),this.L.info(`${this.w}: Updated remote snippets`)),v}Bb(d){return E(d)}Cb(d){const v={};for(const L of Object.keys(d))v[L]=d[L].value.toString();return v}async Db(){const d={};let v;try{v=await this.z.resolve(this.p)}catch(L){if(L instanceof R.FileOperationError&&L.fileOperationResult===1)return d;throw L}for(const L of v.children||[]){const n=L.resource,r=this.h.extname(n);if(r===".json"||r===".code-snippets"){const t=this.h.relativePath(this.p,n),i=await this.z.readFile(n);d[t]=i}}return d}};a=ye([G(2,N.IEnvironmentService),G(3,R.IFileService),G(4,I.IStorageService),G(5,m.IUserDataSyncStoreService),G(6,m.IUserDataSyncBackupStoreService),G(7,m.IUserDataSyncLogService),G(8,T.IConfigurationService),G(9,m.IUserDataSyncEnablementService),G(10,w.ITelemetryService),G(11,P.IUriIdentityService)],a),e.SnippetsSynchroniser=a;let u=class extends p.AbstractInitializer{constructor(d,v,L,n,r,t){super("snippets",v,L,n,d,r,t)}async o(d){const v=d.syncData?JSON.parse(d.syncData.content):null;if(!v){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const n of Object.keys(v)){const r=v[n];if(r){const t=this.d.joinPath(this.g.defaultProfile.snippetsHome,n);await this.k.createFile(t,O.VSBuffer.fromString(r)),this.j.info("Created snippet",this.d.basename(t))}}await this.n(d)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(d){return d.fileOperationResult===1}}};u=ye([G(0,R.IFileService),G(1,S.IUserDataProfilesService),G(2,N.IEnvironmentService),G(3,m.IUserDataSyncLogService),G(4,I.IStorageService),G(5,P.IUriIdentityService)],u),e.SnippetsInitializer=u}),define(re[126],oe([0,1,16,17,15,14,20,19,30,18,41,24]),function(te,e,O,U,l,T,N,R,I,w,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function p(a,u){try{return JSON.parse(a).tasks??null}catch(h){return u.error(h),null}}e.getTasksContentFromSyncContent=p;let f=class extends P.AbstractFileSynchroniser{constructor(u,h,d,v,L,n,r,t,i,s,o,c){super(u.tasksResource,{syncResource:"tasks",profile:u},h,t,i,s,d,v,r,o,L,n,c),this.nb=1,this.wb=this.h.joinPath(this.g,"tasks.json"),this.xb=this.wb.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"base"}),this.yb=this.wb.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),this.zb=this.wb.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.Ab=this.wb.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async ob(u,h,d,v){const L=u.syncData?p(u.syncData.content,this.L):null;h=h===null&&d?u:h;const n=h?.syncData?p(h.syncData.content,this.L):null,r=await this.p();let t=null,i=!1,s=!1,o=!1;if(u.syncData){const b=r?r.value.toString():null;if(!n||n!==b||n!==L){this.L.trace(`${this.w}: Merging remote tasks with local tasks...`);const g=E(b,L,n);t=g.content,o=g.hasConflicts,i=g.hasLocalChanged,s=g.hasRemoteChanged}}else r&&(this.L.trace(`${this.w}: Remote tasks does not exist. Synchronizing tasks for the first time.`),t=r.value.toString(),s=!0);const c={content:o?n:t,localChange:i?r?2:1:0,remoteChange:s?2:0,hasConflicts:o},y=r?r.value.toString():null;return[{fileContent:r,baseResource:this.xb,baseContent:n,localResource:this.yb,localContent:y,localChange:c.localChange,remoteResource:this.zb,remoteContent:L,remoteChange:c.remoteChange,previewResource:this.wb,previewResult:c,acceptedResource:this.Ab}]}async sb(u){const h=u?.syncData?p(u.syncData.content,this.L):null;if(h===null)return!0;const d=await this.p(),v=d?d.value.toString():null,L=E(v,h,h);return L.hasLocalChanged||L.hasRemoteChanged}async pb(u,h){return u.previewResult}async qb(u,h,d,v){if(this.h.isEqual(h,this.yb))return{content:u.fileContent?u.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(h,this.zb))return{content:u.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(h,this.wb))return d===void 0?{content:u.previewResult.content,localChange:u.previewResult.localChange,remoteChange:u.previewResult.remoteChange}:{content:d,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${h.toString()}`)}async rb(u,h,d,v){const{fileContent:L}=d[0][0],{content:n,localChange:r,remoteChange:t}=d[0][1];if(r===0&&t===0&&this.L.info(`${this.w}: No changes found during synchronizing tasks.`),r!==0&&(this.L.trace(`${this.w}: Updating local tasks...`),L&&await this.lb(JSON.stringify(this.Gb(L.value.toString()))),n?await this.r(n,L,v):await this.tb(),this.L.info(`${this.w}: Updated local tasks`)),t!==0){this.L.trace(`${this.w}: Updating remote tasks...`);const i=JSON.stringify(this.Gb(n));u=await this.kb(i,v?null:u.ref),this.L.info(`${this.w}: Updated remote tasks`)}try{await this.z.del(this.wb)}catch{}h?.ref!==u.ref&&(this.L.trace(`${this.w}: Updating last synchronized tasks...`),await this.db(u),this.L.info(`${this.w}: Updated last synchronized tasks`))}async hasLocalData(){return this.z.exists(this.i)}async resolveContent(u){return this.h.isEqual(this.zb,u)||this.h.isEqual(this.xb,u)||this.h.isEqual(this.yb,u)||this.h.isEqual(this.Ab,u)?this.bb(u):null}Gb(u){return u?{tasks:u}:{}}};f=ye([G(2,S.IUserDataSyncStoreService),G(3,S.IUserDataSyncBackupStoreService),G(4,S.IUserDataSyncLogService),G(5,U.IConfigurationService),G(6,S.IUserDataSyncEnablementService),G(7,T.IFileService),G(8,l.IEnvironmentService),G(9,N.IStorageService),G(10,R.ITelemetryService),G(11,I.IUriIdentityService)],f),e.TasksSynchroniser=f;let m=class extends P.AbstractInitializer{constructor(u,h,d,v,L,n){super("tasks",h,d,v,u,L,n),this.c=this.g.defaultProfile.tasksResource}async o(u){const h=u.syncData?p(u.syncData.content,this.j):null;if(!h){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,O.VSBuffer.fromString(h)),await this.n(u)}async p(){return this.k.exists(this.c)}};m=ye([G(0,T.IFileService),G(1,w.IUserDataProfilesService),G(2,l.IEnvironmentService),G(3,S.IUserDataSyncLogService),G(4,N.IStorageService),G(5,I.IUriIdentityService)],m),e.TasksInitializer=m;function E(a,u,h){if(a===null&&u===null&&h===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(a===u)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const d=h!==a,v=h!==u;return!d&&!v?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:d&&!v?{content:a,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:v&&!d?{content:u,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:a,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(re[127],oe([0,1,42,17,15,14,20,19,30,18,41,258,24]),function(te,e,O,U,l,T,N,R,I,w,P,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseUserDataProfilesManifest=e.stringifyLocalProfiles=e.UserDataProfilesManifestSynchroniser=void 0;let f=class extends P.AbstractSynchroniser{constructor(u,h,d,v,L,n,r,t,i,s,o,c,y){super({syncResource:"profiles",profile:u},h,v,L,n,r,t,o,c,i,s,y),this.r=d,this.nb=1,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async getLastSyncedProfiles(){const u=await this.getLastSyncUserData();return u?.syncData?E(u.syncData):null}async getRemoteSyncedProfiles(u){const h=await this.getLastSyncUserData(),d=await this.S(u,h);return d?.syncData?E(d.syncData):null}async ob(u,h,d){if(!this.r.isEnabled())throw new p.UserDataSyncError("Cannot sync profiles because they are disabled","LocalError");const v=u.syncData?E(u.syncData):null,L=h?.syncData?E(h.syncData):null,n=this.Ab(),{local:r,remote:t}=(0,S.merge)(n,v,L,[]),i={local:r,remote:t,content:L?this.Bb(L):null,localChange:r.added.length>0||r.removed.length>0||r.updated.length>0?2:0,remoteChange:t!==null?2:0},s=m(n,!1);return[{baseResource:this.baseResource,baseContent:L?this.Bb(L):null,localResource:this.localResource,localContent:s,remoteResource:this.remoteResource,remoteContent:v?this.Bb(v):null,remoteProfiles:v,previewResource:this.previewResource,previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.acceptedResource}]}async sb(u){const h=u?.syncData?E(u.syncData):null,d=this.Ab(),{remote:v}=(0,S.merge)(d,h,h,[]);return!!v?.added.length||!!v?.removed.length||!!v?.updated.length}async pb(u,h){return{...u.previewResult,hasConflicts:!1}}async qb(u,h,d,v){if(this.h.isEqual(h,this.localResource))return this.xb(u);if(this.h.isEqual(h,this.remoteResource))return this.yb(u);if(this.h.isEqual(h,this.previewResource))return u.previewResult;throw new Error(`Invalid Resource: ${h.toString()}`)}async xb(u){const h=this.Ab(),d=(0,S.merge)(h,null,null,[]),{local:v,remote:L}=d;return{content:u.localContent,local:v,remote:L,localChange:v.added.length>0||v.removed.length>0||v.updated.length>0?2:0,remoteChange:L!==null?2:0}}async yb(u){const h=u.remoteContent?JSON.parse(u.remoteContent):null,d=[],v=[];for(const L of this.Ab()){const n=h?.find(r=>r.id===L.id);n&&(d.push({id:L.id,name:L.name,collection:n.collection}),v.push(L))}if(h!==null){const L=(0,S.merge)(v,h,d,[]),{local:n,remote:r}=L;return{content:u.remoteContent,local:n,remote:r,localChange:n.added.length>0||n.removed.length>0||n.updated.length>0?2:0,remoteChange:r!==null?2:0}}else return{content:u.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async rb(u,h,d,v){const{local:L,remote:n,localChange:r,remoteChange:t}=d[0][1];r===0&&t===0&&this.L.info(`${this.w}: No changes found during synchronizing profiles.`);const i=d[0][0].remoteProfiles||[];if(i.length+(n?.added.length??0)-(n?.removed.length??0)>20)throw new p.UserDataSyncError("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(r!==0){await this.lb(m(this.Ab(),!1));const s=[];for(const o of L.added)s.push((async()=>{this.L.trace(`${this.w}: Creating '${o.name}' profile...`),await this.r.createProfile(o.id,o.name,{shortName:o.shortName}),this.L.info(`${this.w}: Created profile '${o.name}'.`)})());for(const o of L.removed)s.push((async()=>{this.L.trace(`${this.w}: Removing '${o.name}' profile...`),await this.r.removeProfile(o),this.L.info(`${this.w}: Removed profile '${o.name}'.`)})());for(const o of L.updated){const c=this.r.profiles.find(y=>y.id===o.id);c?s.push((async()=>{this.L.trace(`${this.w}: Updating '${o.name}' profile...`),await this.r.updateProfile(c,{name:o.name,shortName:o.shortName}),this.L.info(`${this.w}: Updated profile '${o.name}'.`)})()):this.L.info(`${this.w}: Could not find profile with id '${o.id}' to update.`)}await Promise.all(s)}if(t!==0){this.L.trace(`${this.w}: Updating remote profiles...`);const s=[],o=i.length+(n?.added.length??0)<=20;if(o)for(const c of n?.added||[]){const y=await this.G.createCollection(this.y);s.push(y),i.push({id:c.id,name:c.name,collection:y,shortName:c.shortName})}else this.L.info(`${this.w}: Could not create remote profiles as there are too many profiles.`);for(const c of n?.removed||[])i.splice(i.findIndex(({id:y})=>c.id===y),1);for(const c of n?.updated||[]){const y=i.find(({id:b})=>c.id===b);y&&i.splice(i.indexOf(y),1,{id:c.id,name:c.name,collection:y.collection,shortName:c.shortName})}try{u=await this.updateRemoteProfiles(i,v?null:u.ref),this.L.info(`${this.w}: Updated remote profiles.${o&&n?.added.length?` Added: ${JSON.stringify(n.added.map(c=>c.name))}.`:""}${n?.updated.length?` Updated: ${JSON.stringify(n.updated.map(c=>c.name))}.`:""}${n?.removed.length?` Removed: ${JSON.stringify(n.removed.map(c=>c.name))}.`:""}`)}catch(c){if(s.length){this.L.info(`${this.w}: Failed to update remote profiles. Cleaning up added collections...`);for(const y of s)await this.G.deleteCollection(y,this.y)}throw c}for(const c of n?.removed||[])await this.G.deleteCollection(c.collection,this.y)}h?.ref!==u.ref&&(this.L.trace(`${this.w}: Updating last synchronized profiles...`),await this.db(u),this.L.info(`${this.w}: Updated last synchronized profiles.`))}async updateRemoteProfiles(u,h){return this.kb(this.Bb(u),h)}async hasLocalData(){return this.Ab().length>0}async resolveContent(u){if(this.h.isEqual(this.remoteResource,u)||this.h.isEqual(this.baseResource,u)||this.h.isEqual(this.localResource,u)||this.h.isEqual(this.acceptedResource,u)){const h=await this.bb(u);return h&&(0,O.toFormattedString)(JSON.parse(h),{})}return null}Ab(){return this.r.profiles.filter(u=>!u.isDefault&&!u.isTransient)}Bb(u){return JSON.stringify([...u].sort((h,d)=>h.name.localeCompare(d.name)))}};f=ye([G(2,w.IUserDataProfilesService),G(3,T.IFileService),G(4,l.IEnvironmentService),G(5,N.IStorageService),G(6,p.IUserDataSyncStoreService),G(7,p.IUserDataSyncBackupStoreService),G(8,p.IUserDataSyncLogService),G(9,U.IConfigurationService),G(10,p.IUserDataSyncEnablementService),G(11,R.ITelemetryService),G(12,I.IUriIdentityService)],f),e.UserDataProfilesManifestSynchroniser=f;function m(a,u){const h=[...a].sort((d,v)=>d.name.localeCompare(v.name)).map(d=>({id:d.id,name:d.name}));return u?(0,O.toFormattedString)(h,{}):JSON.stringify(h)}e.stringifyLocalProfiles=m;function E(a){return JSON.parse(a.content)}e.parseUserDataProfilesManifest=E}),define(re[275],oe([0,1,6,16,65,2,23,17,15,14,18,24]),function(te,e,O,U,l,T,N,R,I,w,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let p=class extends T.Disposable{constructor(m,E,a,u,h){super(),this.a=m,this.b=E,this.c=a,this.f=u,this.g=h,this.h()}async h(){for(const E of this.g.profiles)for(const a of S.ALL_SYNC_RESOURCES)try{await this.j(this.i(E,a))}catch(u){this.f.error(u)}let m;try{m=await this.b.resolve(this.a.userDataSyncHome)}catch(E){(0,w.toFileOperationResult)(E)!==1&&this.f.error(E);return}if(m.children){for(const E of m.children)if(E.isDirectory&&!this.g.profiles.some(a=>a.id===E.name))try{this.f.info("Deleting non existing profile from backup",E.resource.path),await this.b.del(E.resource,{recursive:!0})}catch(a){this.f.error(a)}}}async getAllRefs(m,E){const a=this.i(m,E);try{const u=await this.b.resolve(a);if(u.children)return u.children.filter(d=>d.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(d.name)).sort().reverse().map(d=>({ref:d.name,created:this.k(d)}))}catch(u){if((0,w.toFileOperationResult)(u)!==1)throw u}return[]}async resolveContent(m,E,a){const u=this.i(m,E),h=(0,N.joinPath)(u,a);try{return(await this.b.readFile(h)).value.toString()}catch(d){return this.f.error(d),null}}async backup(m,E,a){const u=this.i(m,E),h=(0,N.joinPath)(u,`${(0,l.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(h,U.VSBuffer.fromString(a))}catch(d){this.f.error(d)}try{this.j(u)}catch{}}i(m,E){return(0,N.joinPath)(this.a.userDataSyncHome,...m.isDefault?[E]:[m.id,E])}async j(m){try{try{if(!await this.b.exists(m))return}catch{return}const E=await this.b.resolve(m);if(E.children){const a=E.children.filter(v=>v.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(v.name)).sort(),u=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let h=a.filter(v=>Date.now()-this.k(v)>u);const d=a.length-h.length;d<10&&(h=h.slice(10-d)),await O.Promises.settled(h.map(async v=>{this.f.info("Deleting from backup",v.resource.path),await this.b.del(v.resource)}))}}catch(E){this.f.error(E)}}k(m){return m.ctime||new Date(parseInt(m.name.substring(0,4)),parseInt(m.name.substring(4,6))-1,parseInt(m.name.substring(6,8)),parseInt(m.name.substring(9,11)),parseInt(m.name.substring(11,13)),parseInt(m.name.substring(13,15))).getTime()}};p=ye([G(0,I.IEnvironmentService),G(1,w.IFileService),G(2,R.IConfigurationService),G(3,S.IUserDataSyncLogService),G(4,P.IUserDataProfilesService)],p),e.UserDataSyncBackupStoreService=p}),define(re[276],oe([0,1,3,2,4,15,20,19,24]),function(te,e,O,U,l,T,N,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const w="sync.enable";let P=class extends U.Disposable{constructor(p,f,m,E){super(),this.c=p,this.f=f,this.g=m,this.h=E,this.a=new O.Emitter,this.onDidChangeEnablement=this.a.event,this.b=new O.Emitter,this.onDidChangeResourceEnablement=this.b.event,this.D(p.onDidChangeValue(a=>this.j(a)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(w,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(p){p&&!this.canToggleEnablement()||(this.f.publicLog2(w,{enabled:p}),this.c.store(w,p,-1,1))}isResourceEnabled(p){return this.c.getBoolean((0,I.getEnablementKey)(p),-1,!0)}setResourceEnablement(p,f){if(this.isResourceEnabled(p)!==f){const m=(0,I.getEnablementKey)(p);this.i(m,f)}}getResourceSyncStateVersion(p){}i(p,f){this.c.store(p,f,-1,l.isWeb?0:1)}j(p){if(p.scope!==-1)return;if(w===p.key){this.a.fire(this.isEnabled());return}const f=I.ALL_SYNC_RESOURCES.filter(m=>(0,I.getEnablementKey)(m)===p.key)[0];if(f){this.b.fire([f,this.isResourceEnabled(f)]);return}}};P=ye([G(0,N.IStorageService),G(1,R.ITelemetryService),G(2,T.IEnvironmentService),G(3,I.IUserDataSyncStoreManagementService)],P),e.UserDataSyncEnablementService=P}),define(re[82],oe([0,1,3,2,4,27,187,15,14,5,26,44,20,24]),function(te,e,O,U,l,T,N,R,I,w,P,S,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,w.createDecorator)("IUserDataSyncMachinesService");const m="sync.currentMachineName",E="Safari",a="Chrome",u="Edge",h="Firefox",d="Android";function v(r){switch(r){case E:case a:case u:case h:case d:case(0,l.PlatformToString)(0):return!0}return!1}e.isWebPlatform=v;function L(){return l.isSafari?E:l.isChrome?a:l.isEdge?u:l.isFirefox?h:l.isAndroid?d:(0,l.PlatformToString)(l.isWeb?0:l.platform)}let n=class it extends U.Disposable{constructor(t,i,s,o,c,y){super(),this.h=s,this.i=o,this.j=c,this.k=y,this.c=this.D(new O.Emitter),this.onDidChange=this.c.event,this.g=null,this.f=(0,S.getServiceMachineId)(t,i,s)}async getMachines(t){const i=await this.f;return(await this.m(t)).machines.map(o=>({...o,isCurrent:o.id===i}))}async addCurrentMachine(t){const i=await this.f,s=await this.m(t);s.machines.some(({id:o})=>o===i)||(s.machines.push({id:i,name:this.l(s.machines),platform:L()}),await this.n(s))}async removeCurrentMachine(t){const i=await this.f,s=await this.m(t),o=s.machines.filter(({id:c})=>c!==i);o.length!==s.machines.length&&(s.machines=o,await this.n(s))}async renameMachine(t,i,s){const o=await this.m(s),c=o.machines.find(({id:y})=>y===t);if(c){c.name=i,await this.n(o);const y=await this.f;t===y&&this.h.store(m,i,-1,1)}}async setEnablements(t){const i=await this.m();for(const[s,o]of t){const c=i.machines.find(y=>y.id===s);c&&(c.disabled=o?void 0:!0)}await this.n(i)}l(t){const i=this.h.get(m,-1);if(i)return i;const s=`${this.k.embedderIdentifier?`${this.k.embedderIdentifier} - `:""}${L()} (${this.k.nameShort})`,o=new RegExp(`${(0,T.escapeRegExpCharacters)(s)}\\s#(\\d+)`);let c=0;for(const y of t){const b=o.exec(y.name),g=b?parseInt(b[1]):0;c=g>c?g:c}return`${s} #${c+1}`}async m(t){this.g=await this.p(t);const i=this.q(this.g);if(i.version!==it.a)throw new Error((0,N.localize)(0,null,this.k.nameLong));return i}async n(t){const i=JSON.stringify(t),s=await this.i.writeResource(it.b,i,this.g?.ref||null);this.g={ref:s,content:i},this.c.fire()}async p(t){if(this.g){const i=t&&t.latest?t.latest[it.b]:void 0;if(this.g.ref===i)return this.g;if(i===void 0&&this.g.content===null)return this.g}return this.i.readResource(it.b,this.g)}q(t){if(t.content!==null)try{return JSON.parse(t.content)}catch(i){this.j.error(i)}return{version:it.a,machines:[]}}};n.a=1,n.b="machines",n=ye([G(0,R.IEnvironmentService),G(1,I.IFileService),G(2,p.IStorageService),G(3,f.IUserDataSyncStoreService),G(4,f.IUserDataSyncLogService),G(5,P.IProductService)],n),e.UserDataSyncMachinesService=n}),define(re[277],oe([0,1,6,65,38,10,3,2,4,23,11,184,26,20,19,24,79,82]),function(te,e,O,U,l,T,N,R,I,w,P,S,p,f,m,E,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const h="sync.disableMachineEventually",d="sync.sessionId",v="sync.storeUrl",L="sync.productQuality";let n=class extends R.Disposable{get j(){const i=this.y.get(v,-1);return i?P.URI.parse(i):void 0}set j(i){i?this.y.store(v,i.toString(),-1,1):this.y.remove(v,-1)}get l(){return this.y.get(L,-1)}set l(i){i?this.y.store(L,i,-1,1):this.y.remove(L,-1)}constructor(i,s,o,c,y,b,g,D,A,F){super(),this.n=s,this.p=o,this.q=c,this.r=y,this.s=b,this.u=g,this.v=D,this.w=A,this.y=F,this.a=this.D(new R.MutableDisposable),this.b=0,this.c=void 0,this.g=!1,this.h=this.D(new N.Emitter),this.onError=this.h.event,this.N=[],this.f=this.D(new O.ThrottledDelayer(this.O())),this.i=this.j,this.j=s.userDataSyncStore?.url,this.k=this.l,this.l=i.quality,this.j&&(this.s.info("Using settings sync service",this.j.toString()),this.D(s.onDidChangeUserDataSyncStore(()=>{(0,w.isEqual)(this.j,s.userDataSyncStore?.url)||(this.i=this.j,this.j=s.userDataSyncStore?.url,this.j&&this.s.info("Using settings sync service",this.j.toString()))})),this.q.isEnabled()?this.s.info("Auto Sync is enabled."):this.s.info("Auto Sync is disabled."),this.z(),this.L()&&this.J(),this.D(g.onDidChangeAccount(()=>this.z())),this.D(o.onDidChangeDonotMakeRequestsUntil(()=>this.z())),this.D(y.onDidChangeLocal(j=>this.triggerSync([j],!1,!1))),this.D(N.Event.filter(this.q.onDidChangeResourceEnablement,([,j])=>j)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.D(this.n.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}z(){const{enabled:i,message:s}=this.F();i?this.a.value===void 0&&(this.a.value=new r(this.i,1e3*60*5,this.n,this.p,this.r,this.w,this.s,this.y),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(o=>this.I(o))),this.C()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(s&&this.s.info(s),this.a.clear()):s&&this.q.isEnabled()&&this.s.info(s))}C(){return!0}F(){return this.q.isEnabled()?this.u.account?this.p.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,U.toLocalISOString)(this.p.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.M(),this.i=this.j,this.G(!0)}async turnOff(i,s,o){try{this.u.account&&!o&&await this.w.removeCurrentMachine(),this.G(!1),this.y.remove(d,-1),i?(this.v.publicLog2("sync/turnOffEveryWhere"),await this.r.reset()):await this.r.resetLocal()}catch(c){if(this.s.error(c),s)this.G(!1);else throw c}}G(i){this.q.isEnabled()!==i&&(this.q.setEnablement(i),this.z())}H(){return!!this.k&&!!this.l&&this.k!==this.l}async I(i){if(!i){this.b=0;return}const s=E.UserDataSyncError.toUserDataSyncError(i);s instanceof E.UserDataAutoSyncError&&this.v.publicLog2("autosync/error",{code:s.code,service:this.n.userDataSyncStore.url.toString()}),s.code==="SessionExpired"?(await this.turnOff(!1,!0),this.s.info("Auto Sync: Turned off sync because current session is expired")):s.code==="TurnedOff"?(await this.turnOff(!1,!0),this.s.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):s.code==="LocalTooManyRequests"?(this.g=!0,this.s.info("Auto Sync: Suspended sync because of making too many requests to server"),this.z()):s.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.J(),this.s.info("Auto Sync: Turned off sync because of making too many requests to server")):s.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.s.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):s.code==="UpgradeRequired"||s.code==="Gone"?(await this.turnOff(!1,!0,!0),this.J(),this.s.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):s.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.s.info(`Auto Sync: Turned off sync because server has ${s.resource} content with newer version than of client. Requires client upgrade.`)):s.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.s.info(`Auto Sync: Turned off sync because server has ${s.resource} content with older version than of client. Requires server reset.`)):s.code==="ServiceChanged"||s.code==="DefaultServiceChanged"?I.isWeb&&s.code==="DefaultServiceChanged"&&!this.H()?(await this.turnOff(!1,!0),this.s.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.s.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.s.error(s),this.b++),this.h.fire(s)}async J(){this.y.store(h,!0,-1,1),await(0,O.timeout)(1e3*60*10),this.L()&&(this.M(),!this.q.isEnabled()&&this.u.account&&await this.w.removeCurrentMachine())}L(){return this.y.getBoolean(h,-1,!1)}M(){this.y.remove(h,-1)}async triggerSync(i,s,o){if(this.a.value===void 0)return this.f.cancel();if(s&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.s.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.N.push(...i),this.f.trigger(async()=>{this.s.trace("activity sources",...this.N);const c=this.u.account?.authenticationProviderId||"";this.v.publicLog2("sync/triggered",{sources:this.N,providerId:c}),this.N=[],this.a.value&&await this.a.value.sync("Activity",o)},this.b?this.O()*1*Math.min(Math.pow(2,this.b),60):this.O())}O(){return 2e3}};n=ye([G(0,p.IProductService),G(1,E.IUserDataSyncStoreManagementService),G(2,E.IUserDataSyncStoreService),G(3,E.IUserDataSyncEnablementService),G(4,E.IUserDataSyncService),G(5,E.IUserDataSyncLogService),G(6,a.IUserDataSyncAccountService),G(7,m.ITelemetryService),G(8,u.IUserDataSyncMachinesService),G(9,f.IStorageService)],n),e.UserDataAutoSyncService=n;class r extends R.Disposable{constructor(i,s,o,c,y,b,g,D){super(),this.j=i,this.k=s,this.l=o,this.m=c,this.n=y,this.p=b,this.q=g,this.r=D,this.b=this.D(new R.MutableDisposable),this.c=this.D(new N.Emitter),this.onDidStartSync=this.c.event,this.f=this.D(new N.Emitter),this.onDidFinishSync=this.f.event,this.g=null}start(){this.D(this.onDidFinishSync(()=>this.s())),this.D((0,R.toDisposable)(()=>{this.i&&(this.i.cancel(),this.q.info("Auto sync: Cancelled sync that is in progress"),this.i=void 0),this.h?.stop(),this.q.info("Auto Sync: Stopped")})),this.sync(r.a,!1)}s(){this.b.value=(0,O.disposableTimeout)(()=>this.sync(r.a,!1),this.k)}sync(i,s){const o=(0,O.createCancelablePromise)(async c=>{if(this.i)try{this.q.debug("Auto Sync: Waiting until sync is finished."),await this.i}catch(y){if((0,T.isCancellationError)(y))return}return this.w(i,s,c)});return this.i=o,this.i.finally(()=>this.i=void 0),this.i}u(){return this.j!==void 0&&!(0,w.isEqual)(this.j,this.l.userDataSyncStore?.url)}async v(){const i=await this.l.getPreviousUserDataSyncStore(),s=this.l.userDataSyncStore;return!!s&&!!i&&(!(0,w.isEqual)(s.defaultUrl,i.defaultUrl)||!(0,w.isEqual)(s.insidersUrl,i.insidersUrl)||!(0,w.isEqual)(s.stableUrl,i.stableUrl))}async w(i,s,o){this.q.info(`Auto Sync: Triggered by ${i}`),this.c.fire();let c;try{await this.y(s,o)}catch(y){if(this.q.error(y),c=y,E.UserDataSyncError.toUserDataSyncError(y).code==="MethodNotFound")try{this.q.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.n.cleanUpRemoteData(),this.q.info("Auto Sync: Retrying sync..."),await this.y(s,o),c=void 0}catch(b){this.q.error(b),c=b}}this.f.fire(c)}async y(i,s){if(this.h=await this.n.createSyncTask(this.g,i),s.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.n.hasPreviouslySynced())throw this.u()?await this.v()?new E.UserDataAutoSyncError((0,S.localize)(0,null),"DefaultServiceChanged"):new E.UserDataAutoSyncError((0,S.localize)(1,null),"ServiceChanged"):new E.UserDataAutoSyncError((0,S.localize)(2,null),"TurnedOff");const o=this.r.get(d,-1);if(o&&this.g&&o!==this.g.session)throw this.u()?await this.v()?new E.UserDataAutoSyncError((0,S.localize)(3,null),"DefaultServiceChanged"):new E.UserDataAutoSyncError((0,S.localize)(4,null),"ServiceChanged"):new E.UserDataAutoSyncError((0,S.localize)(5,null),"SessionExpired");const c=await this.p.getMachines(this.g||void 0);if(s.isCancellationRequested)return;const y=c.find(b=>b.isCurrent);if(y?.disabled)throw new E.UserDataAutoSyncError((0,S.localize)(6,null),"TurnedOff");if(await this.h.run(),this.g===null)try{this.g=await this.m.manifest(null)}catch(b){throw new E.UserDataAutoSyncError((0,l.toErrorMessage)(b),b instanceof E.UserDataSyncError?b.code:"Unknown")}this.g&&this.g.session!==o&&this.r.store(d,this.g.session,-1,1),!s.isCancellationRequested&&(y||await this.p.addCurrentMachine(this.g||void 0))}register(i){return super.D(i)}}r.a="Interval"}),define(re[278],oe([0,1,11,188,15,14,44,20,30,24,18,41,125,124,123,17,126,121,122,5,127,42]),function(te,e,O,U,l,T,N,R,I,w,P,S,p,f,m,E,a,u,h,d,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceProviderService=void 0;let n=class He{constructor(t,i,s,o,c,y,b,g,D,A){this.e=t,this.f=i,this.g=s,this.h=c,this.i=y,this.j=b,this.k=g,this.l=D,this.m=A,this.d=o.extUri}async getRemoteSyncedProfiles(){const t=await this.e.readResource("profiles",null,void 0);if(t.content){const i=this.K(t.content,"profiles");return(0,v.parseUserDataProfilesManifest)(i)}return[]}async getRemoteSyncResourceHandles(t,i){return(await this.e.getAllResourceRefs(t,i?.collection)).map(({created:o,ref:c})=>({created:o,uri:this.I({remote:!0,syncResource:t,profile:i?.id??this.k.defaultProfile.id,collection:i?.collection,ref:c,node:void 0})}))}async getLocalSyncResourceHandles(t,i){return(await this.f.getAllRefs(i,t)).map(({created:o,ref:c})=>({created:o,uri:this.I({remote:!1,syncResource:t,profile:i.id,collection:void 0,ref:c,node:void 0})}))}resolveUserDataSyncResource({uri:t}){const i=this.J(t),s=i?this.k.profiles.find(o=>o.id===i.profile):void 0;return i&&s?{profile:s,syncResource:i?.syncResource}:void 0}async getAssociatedResources({uri:t}){const i=this.J(t);if(!i)return[];const s=this.k.profiles.find(o=>o.id===i.profile);switch(i.syncResource){case"settings":return this.r(t,s);case"keybindings":return this.t(t,s);case"tasks":return this.v(t,s);case"snippets":return this.x(t,s);case"globalState":return this.C(t,s);case"extensions":return this.z(t,s);case"profiles":return this.F(t,s)}}async getMachineId({uri:t}){const i=this.J(t);if(!!i){if(i.remote){if(i.ref){const{content:s}=await this.L(i.syncResource,i.ref,i.collection);if(s)return this.K(s,i.syncResource)?.machineId}return}return(0,N.getServiceMachineId)(this.h,this.j,this.i)}}async resolveContent(t){const i=this.J(t);if(!i||i.node===He.a)return null;if(i.ref){const s=await this.n(i.remote,i.syncResource,i.profile,i.collection,i.ref);return i.node&&s?this.o(i.syncResource,s,i.node):s}return!i.remote&&!i.node?this.q(i.syncResource,i.profile):null}async n(t,i,s,o,c){if(t){const{content:b}=await this.L(i,c,o);return b}const y=this.k.profiles.find(b=>b.id===s);return y?this.f.resolveContent(y,i,c):null}o(t,i,s){const o=this.K(i,t);switch(t){case"settings":return this.s(o,s);case"keybindings":return this.u(o,s);case"tasks":return this.w(o,s);case"snippets":return this.y(o,s);case"globalState":return this.D(o,s);case"extensions":return this.A(o,s);case"profiles":return this.G(o,s)}}async q(t,i){const s=this.k.profiles.find(o=>o.id===i);if(!s)return null;switch(t){case"globalState":return this.E(s);case"extensions":return this.B(s);case"profiles":return this.H(s);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null}}r(t,i){const s=this.d.joinPath(t,"settings.json"),o=i?i.settingsResource:this.d.joinPath(t,He.a);return[{resource:s,comparableResource:o}]}s(t,i){switch(i){case"settings.json":return(0,f.parseSettingsSyncContent)(t.content).settings}return null}t(t,i){const s=this.d.joinPath(t,"keybindings.json"),o=i?i.keybindingsResource:this.d.joinPath(t,He.a);return[{resource:s,comparableResource:o}]}u(t,i){switch(i){case"keybindings.json":return(0,m.getKeybindingsContentFromSyncContent)(t.content,!!this.l.getValue(w.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM),this.g)}return null}v(t,i){const s=this.d.joinPath(t,"tasks.json"),o=i?i.tasksResource:this.d.joinPath(t,He.a);return[{resource:s,comparableResource:o}]}w(t,i){switch(i){case"tasks.json":return(0,a.getTasksContentFromSyncContent)(t.content,this.g)}return null}async x(t,i){const s=await this.resolveContent(t);if(s){const o=this.K(s,"snippets");if(o){const c=(0,p.parseSnippets)(o),y=[];for(const b of Object.keys(c)){const g=this.d.joinPath(t,b),D=i?this.d.joinPath(i.snippetsHome,b):this.d.joinPath(t,He.a);y.push({resource:g,comparableResource:D})}return y}}return[]}y(t,i){return(0,p.parseSnippets)(t)[i]||null}z(t,i){const s=this.d.joinPath(t,"extensions.json"),o=i?this.I({remote:!1,syncResource:"extensions",profile:i.id,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,He.a);return[{resource:s,comparableResource:o}]}A(t,i){switch(i){case"extensions.json":return(0,u.stringify)((0,u.parseExtensions)(t),!0)}return null}async B(t){const{localExtensions:i}=await this.m.createInstance(u.LocalExtensionsProvider).getLocalExtensions(t);return(0,u.stringify)(i,!0)}C(t,i){const s=this.d.joinPath(t,"globalState.json"),o=i?this.I({remote:!1,syncResource:"globalState",profile:i.id,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,He.a);return[{resource:s,comparableResource:o}]}D(t,i){switch(i){case"globalState.json":return(0,h.stringify)(JSON.parse(t.content),!0)}return null}async E(t){const i=await this.m.createInstance(h.LocalGlobalStateProvider).getLocalGlobalState(t);return(0,h.stringify)(i,!0)}F(t,i){const s=this.d.joinPath(t,"profiles.json"),o=this.I({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,collection:void 0,ref:void 0,node:void 0});return[{resource:s,comparableResource:o}]}G(t,i){switch(i){case"profiles.json":return(0,L.toFormattedString)(JSON.parse(t.content),{})}return null}async H(t){return(0,v.stringifyLocalProfiles)(this.k.profiles.filter(i=>!i.isDefault&&!i.isTransient),!0)}I(t){const i=t.remote?He.b:He.c,s=[t.syncResource,t.profile];return t.collection&&s.push(`collection:${t.collection}`),t.ref&&s.push(`ref:${t.ref}`),t.node&&s.push(t.node),this.d.joinPath(O.URI.from({scheme:w.USER_DATA_SYNC_SCHEME,authority:i,path:"/"}),...s)}J(t){if(t.scheme!==w.USER_DATA_SYNC_SCHEME||t.authority!==He.c&&t.authority!==He.b)return;const i=[];for(;t.path!=="/";)i.unshift(this.d.basename(t)),t=this.d.dirname(t);if(i.length<2)return;const s=t.authority===He.b,o=i.shift(),c=i.shift();let y,b,g;for(;i.length;){const D=i.shift();D.startsWith("collection:")?y=D.substring(11):D.startsWith("ref:")?b=D.substring(4):g=D}return{remote:s,syncResource:o,profile:c,collection:y,ref:b,node:g}}K(t,i){try{const s=JSON.parse(t);if((0,S.isSyncData)(s))return s}catch(s){this.g.error(s)}throw new w.UserDataSyncError((0,U.localize)(0,null),"IncompatibleRemoteContent",i)}async L(t,i,s){const o=await this.e.resolveResourceContent(t,i,s);return{ref:i,content:o}}};n.a="not-existing-resource",n.b="remote-backup",n.c="local-backup",n=ye([G(0,w.IUserDataSyncStoreService),G(1,w.IUserDataSyncBackupStoreService),G(2,w.IUserDataSyncLogService),G(3,I.IUriIdentityService),G(4,l.IEnvironmentService),G(5,R.IStorageService),G(6,T.IFileService),G(7,P.IUserDataProfilesService),G(8,E.IConfigurationService),G(9,d.IInstantiationService)],n),e.UserDataSyncResourceProviderService=n}),define(re[279],oe([0,1,21,6,25,38,3,2,23,12,31,17,29,5,20,19,18,121,122,123,124,125,126,127,24]),function(te,e,O,U,l,T,N,R,I,w,P,S,p,f,m,E,a,u,h,d,v,L,n,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const i="sync.lastSyncTime";let s=class extends R.Disposable{get status(){return this.f}get conflicts(){return this.i}get lastSyncTime(){return this.m}constructor(g,D,A,F,j,x,V,B,Z){super(),this.u=g,this.v=D,this.w=A,this.y=F,this.z=j,this.C=x,this.F=V,this.G=B,this.H=Z,this.f="uninitialized",this.g=this.D(new N.Emitter),this.onDidChangeStatus=this.g.event,this.h=this.D(new N.Emitter),this.onDidChangeLocal=this.h.event,this.i=[],this.j=this.D(new N.Emitter),this.onDidChangeConflicts=this.j.event,this.k=[],this.l=this.D(new N.Emitter),this.onSyncErrors=this.l.event,this.m=void 0,this.n=this.D(new N.Emitter),this.onDidChangeLastSyncTime=this.n.event,this.q=this.D(new N.Emitter),this.onDidResetLocal=this.q.event,this.r=this.D(new N.Emitter),this.onDidResetRemote=this.r.event,this.t=new Map,this.f=D.userDataSyncStore?"idle":"uninitialized",this.m=this.C.getNumber(i,-1,void 0),this.D((0,R.toDisposable)(()=>this.W()))}async createSyncTask(g,D){this.X(),this.y.info("Sync started.");const A=new Date().getTime(),F=(0,P.generateUuid)();try{const B=(0,t.createSyncHeaders)(F);D&&(B["Cache-Control"]="no-cache"),g=await this.u.manifest(g,B)}catch(B){const Z=t.UserDataSyncError.toUserDataSyncError(B);throw y(Z,F,this.v,this.z),Z}const j=!1,x=this;let V;return{manifest:g,async run(){if(j)throw new Error("Can run a task only once");V=(0,U.createCancelablePromise)(B=>x.I(g,!1,F,B)),await V.finally(()=>V=void 0),x.y.info(`Sync done. Took ${new Date().getTime()-A}ms`),x.S()},stop(){return V?.cancel(),x.N()}}}async createManualSyncTask(){if(this.X(),this.F.isEnabled())throw new t.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");this.y.info("Sync started.");const g=new Date().getTime(),D=(0,P.generateUuid)(),A=(0,t.createSyncHeaders)(D);let F;try{F=await this.u.manifest(null,A)}catch(V){const B=t.UserDataSyncError.toUserDataSyncError(V);throw y(B,D,this.v,this.z),B}await this.resetLocal();const j=this,x=new l.CancellationTokenSource;return{id:D,async merge(){return j.I(F,!0,D,x.token)},async apply(){try{try{await j.L(F,D,x.token)}catch(V){if(t.UserDataSyncError.toUserDataSyncError(V).code==="MethodNotFound")j.y.info("Client is making invalid requests. Cleaning up data..."),await j.cleanUpRemoteData(),j.y.info("Applying manual sync again..."),await j.L(F,D,x.token);else throw V}}catch(V){throw j.y.error(V),V}j.y.info(`Sync done. Took ${new Date().getTime()-g}ms`),j.S()},async stop(){x.cancel(),await j.N(),await j.resetLocal()}}}async I(g,D,A,F){this.k=[];try{this.status!=="hasConflicts"&&this.Q("syncing");const j=this.getOrCreateActiveProfileSynchronizer(this.G.defaultProfile,void 0);this.k.push(...await this.M(j,g,D,A,F));const x=j.enabled.find(V=>V.resource==="profiles");if(x){const V=await x.getLastSyncedProfiles()||[];if(F.isCancellationRequested)return;await this.J(V,g,D,A,F)}}finally{this.l.fire(this.k)}}async J(g,D,A,F,j){for(const x of g){if(j.isCancellationRequested)return;const V=this.G.profiles.find(Z=>Z.id===x.id);if(!V){this.y.error(`Profile with id:${x.id} and name: ${x.name} does not exist locally to sync.`);continue}this.y.info("Syncing profile.",x.name);const B=this.getOrCreateActiveProfileSynchronizer(V,x);this.k.push(...await this.M(B,D,A,F,j))}for(const[x,V]of this.t.entries())this.G.profiles.some(B=>B.id===V[0].profile.id)||(V[1].dispose(),this.t.delete(x))}async L(g,D,A){const F=this.U();for(const Z of F){if(A.isCancellationRequested)return;await Z.apply(D,A)}const j=F.find(Z=>Z.profile.isDefault);if(!j)return;const x=j.enabled.find(Z=>Z.resource==="profiles");if(!x)return;const B=(await x.getRemoteSyncedProfiles(g?.latest??null)||[]).filter(Z=>F.every(J=>J.profile.id!==Z.id));B.length&&await this.J(B,g,!1,D,A)}async M(g,D,A,F,j){return(await g.sync(D,A,F,j)).map(([V,B])=>({profile:g.profile,syncResource:V,error:B}))}async N(){this.status!=="idle"&&await Promise.allSettled(this.U().map(g=>g.stop()))}async resolveContent(g){const D=await this.H.resolveContent(g);if(D)return D;for(const A of this.U())for(const F of A.enabled){const j=await F.resolveContent(g);if(j)return j}return null}async replace(g){this.X();const D=this.H.resolveUserDataSyncResource(g);if(!D)return;const A=await this.resolveContent(g.uri);!A||await this.O(D.profile,async F=>{if(D.syncResource===F.resource)return await F.replace(A),!0})}async accept(g,D,A,F){this.X(),await this.O(g.profile,async j=>{if(g.syncResource===j.resource)return await j.accept(D,A),F&&await j.apply((0,w.isBoolean)(F)?!1:F.force,(0,t.createSyncHeaders)((0,P.generateUuid)())),!0})}getRemoteProfiles(){return this.H.getRemoteSyncedProfiles()}getRemoteSyncResourceHandles(g,D){return this.H.getRemoteSyncResourceHandles(g,D)}async getLocalSyncResourceHandles(g,D){return this.H.getLocalSyncResourceHandles(g,D??this.G.defaultProfile)}async getAssociatedResources(g){return this.H.getAssociatedResources(g)}async getMachineId(g){return this.H.getMachineId(g)}async hasLocalData(){return!!await this.O(this.G.defaultProfile,async D=>{if(D.resource!=="globalState"&&await D.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.O(this.G.defaultProfile,async D=>{if(await D.hasPreviouslySynced())return!0})}async reset(){this.X(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.X();try{await this.u.clear(),this.y.info("Cleared data on server")}catch(g){this.y.error(g)}this.r.fire()}async resetLocal(){this.X(),this.m=void 0,this.C.remove(i,-1);for(const[g]of this.t.values())try{await g.resetLocal()}catch(D){this.y.error(D)}this.W(),this.q.fire(),this.y.info("Did reset the local sync state.")}async cleanUpRemoteData(){const g=await this.H.getRemoteSyncedProfiles(),D=g.map(x=>x.collection),A=await this.u.getAllCollections(),F=A.filter(x=>!D.includes(x));F.length&&(this.y.info(`Deleting ${F.length} redundant collections on server`),await Promise.allSettled(F.map(x=>this.u.deleteCollection(x))),this.y.info("Deleted redundant collections on server"));const j=g.filter(x=>A.includes(x.collection));if(j.length!==g.length){this.y.info("Updating remote profiles with invalid collections on server");const x=this.w.createInstance(r.UserDataProfilesManifestSynchroniser,this.G.defaultProfile,void 0);try{await x.updateRemoteProfiles(j,null),this.y.info("Updated remote profiles on server")}finally{x.dispose()}}}async O(g,D){const A=new R.DisposableStore;try{const F=this.t.get(g.id);if(F){const Z=await this.P(F[0],D,A);return(0,w.isUndefined)(Z)?null:Z}if(g.isDefault){const Z=A.add(this.w.createInstance(o,g,void 0)),J=await this.P(Z,D,A);return(0,w.isUndefined)(J)?null:J}if(this.G.isEnabled())return null;const j=A.add(this.w.createInstance(r.UserDataProfilesManifestSynchroniser,g,void 0)),x=await this.u.manifest(null),B=(await j.getRemoteSyncedProfiles(x?.latest??null)||[]).find(Z=>Z.id===g.id);if(B){const Z=A.add(this.w.createInstance(o,g,B.collection)),J=await this.P(Z,D,A);return(0,w.isUndefined)(J)?null:J}return null}finally{A.dispose()}}async P(g,D,A){const F=[...g.enabled,...g.disabled.map(j=>A.add(g.createSynchronizer(j)))];for(const j of F){const x=await D(j);if(!(0,w.isUndefined)(x))return x}}Q(g){const D=this.f;this.f!==g&&(this.f=g,this.g.fire(g),D==="hasConflicts"&&this.S())}R(){const g=this.U().map(D=>D.conflicts).flat();(0,O.equals)(this.i,g,(D,A)=>D.profile.id===A.profile.id&&D.syncResource===A.syncResource&&(0,O.equals)(D.conflicts,A.conflicts,(F,j)=>(0,I.isEqual)(F.previewResource,j.previewResource)))||(this.i=g,this.j.fire(g))}S(){this.status==="idle"&&(this.m=new Date().getTime(),this.C.store(i,this.m,-1,1),this.n.fire(this.m))}getOrCreateActiveProfileSynchronizer(g,D){let A=this.t.get(g.id);if(A&&A[0].collection!==D?.collection&&(this.y.error("Profile synchronizer collection does not match with the remote sync profile collection"),A[1].dispose(),A=void 0,this.t.delete(g.id)),!A){const F=new R.DisposableStore,j=F.add(this.w.createInstance(o,g,D?.collection));F.add(j.onDidChangeStatus(x=>this.Q(x))),F.add(j.onDidChangeConflicts(x=>this.R())),F.add(j.onDidChangeLocal(x=>this.h.fire(x))),this.t.set(g.id,A=[j,F])}return A[0]}U(){const g=[];for(const[D]of this.t.values())g.push(D);return g}W(){this.t.forEach(([,g])=>g.dispose()),this.t.clear()}X(){if(!this.v.userDataSyncStore)throw new Error("Not enabled")}};s=ye([G(0,t.IUserDataSyncStoreService),G(1,t.IUserDataSyncStoreManagementService),G(2,f.IInstantiationService),G(3,t.IUserDataSyncLogService),G(4,E.ITelemetryService),G(5,m.IStorageService),G(6,t.IUserDataSyncEnablementService),G(7,a.IUserDataProfilesService),G(8,t.IUserDataSyncResourceProviderService)],s),e.UserDataSyncService=s;let o=class extends R.Disposable{get enabled(){return this.f.sort((g,D)=>g[1]-D[1]).map(([g])=>g)}get disabled(){return t.ALL_SYNC_RESOURCES.filter(g=>!this.l.isResourceEnabled(g))}get status(){return this.g}get conflicts(){return this.j}constructor(g,D,A,F,j,x,V,B,Z,J){super(),this.profile=g,this.collection=D,this.l=A,this.m=F,this.n=j,this.q=x,this.r=V,this.t=B,this.u=Z,this.v=J,this.f=[],this.g="idle",this.h=this.D(new N.Emitter),this.onDidChangeStatus=this.h.event,this.i=this.D(new N.Emitter),this.onDidChangeLocal=this.i.event,this.j=[],this.k=this.D(new N.Emitter),this.onDidChangeConflicts=this.k.event,this.D(A.onDidChangeResourceEnablement(([K,Y])=>this.w(K,Y))),this.D((0,R.toDisposable)(()=>this.f.splice(0,this.f.length).forEach(([,,K])=>K.dispose())));for(const K of t.ALL_SYNC_RESOURCES)A.isResourceEnabled(K)&&this.y(K)}w(g,D){D?this.y(g):this.z(g)}y(g){if(this.f.some(([j])=>j.resource===g))return;if(g==="extensions"&&!this.n.isEnabled()){this.t.info("Skipping extensions sync because gallery is not configured");return}if(g==="profiles"&&(!this.profile.isDefault||!this.u.isEnabled()))return;const D=new R.DisposableStore,A=D.add(this.createSynchronizer(g));D.add(A.onDidChangeStatus(()=>this.G())),D.add(A.onDidChangeConflicts(()=>this.H())),D.add(A.onDidChangeLocal(()=>this.i.fire(g)));const F=this.I(g);this.f.push([A,F,D])}z(g){const D=this.f.findIndex(([A])=>A.resource===g);if(D!==-1){const[[A,,F]]=this.f.splice(D,1);F.dispose(),this.G(),Promise.allSettled([A.stop(),A.resetLocal()]).then(null,j=>this.t.error(j))}}createSynchronizer(g){switch(g){case"settings":return this.m.createInstance(v.SettingsSynchroniser,this.profile,this.collection);case"keybindings":return this.m.createInstance(d.KeybindingsSynchroniser,this.profile,this.collection);case"snippets":return this.m.createInstance(L.SnippetsSynchroniser,this.profile,this.collection);case"tasks":return this.m.createInstance(n.TasksSynchroniser,this.profile,this.collection);case"globalState":return this.m.createInstance(h.GlobalStateSynchroniser,this.profile,this.collection);case"extensions":return this.m.createInstance(u.ExtensionsSynchroniser,this.profile,this.collection);case"profiles":return this.m.createInstance(r.UserDataProfilesManifestSynchroniser,this.profile,this.collection)}}async sync(g,D,A,F){if(F.isCancellationRequested)return[];const j=this.enabled;if(!j.length)return[];try{const x=[],V=(0,t.createSyncHeaders)(A),B=(this.collection?g?.collections?.[this.collection]?.latest:g?.latest)??null,Z=D?await this.C(B):{};for(const J of j){if(F.isCancellationRequested)return[];if(!this.l.isResourceEnabled(J.resource))return[];try{if(D){const K=await J.preview(B,Z,V);if(K)for(const Y of K.resourcePreviews)(Y.localChange!==0||Y.remoteChange!==0)&&Y.mergeState==="preview"&&await J.merge(Y.previewResource)}else await J.sync(B,V)}catch(K){const Y=t.UserDataSyncError.toUserDataSyncError(K);if(y(Y,A,this.q,this.r),c(K))throw Y;this.t.error(K),this.t.error(`${J.resource}: ${(0,T.toErrorMessage)(K)}`),x.push([J.resource,Y])}}return x}finally{this.G()}}async apply(g,D){const A=(0,t.createSyncHeaders)(g);for(const F of this.enabled){if(D.isCancellationRequested)return;try{await F.apply(!1,A)}catch(j){const x=t.UserDataSyncError.toUserDataSyncError(j);if(y(x,g,this.q,this.r),c(j))throw x;this.t.error(j),this.t.error(`${F.resource}: ${(0,T.toErrorMessage)(j)}`)}}}async stop(){for(const g of this.enabled)try{g.status!=="idle"&&await g.stop()}catch(D){this.t.error(D)}}async resetLocal(){for(const g of this.enabled)try{await g.resetLocal()}catch(D){this.t.error(`${g.resource}: ${(0,T.toErrorMessage)(D)}`),this.t.error(D)}}async C(g){if(!this.profile.isDefault)return{};const D=this.v.getValue(t.USER_DATA_SYNC_CONFIGURATION_SCOPE),A=this.enabled.find(F=>F instanceof v.SettingsSynchroniser);if(A){const F=await A.getRemoteUserDataSyncConfiguration(g);return{...D,...F}}return D}F(g){this.g!==g&&(this.g=g,this.h.fire(g))}G(){return this.H(),this.enabled.some(g=>g.status==="hasConflicts")?this.F("hasConflicts"):this.enabled.some(g=>g.status==="syncing")?this.F("syncing"):this.F("idle")}H(){const g=this.enabled.filter(D=>D.status==="hasConflicts").filter(D=>D.conflicts.conflicts.length>0).map(D=>D.conflicts);(0,O.equals)(this.j,g,(D,A)=>D.syncResource===A.syncResource&&(0,O.equals)(D.conflicts,A.conflicts,(F,j)=>(0,I.isEqual)(F.previewResource,j.previewResource)))||(this.j=g,this.k.fire(g))}I(g){switch(g){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6}}};o=ye([G(2,t.IUserDataSyncEnablementService),G(3,f.IInstantiationService),G(4,p.IExtensionGalleryService),G(5,t.IUserDataSyncStoreManagementService),G(6,E.ITelemetryService),G(7,t.IUserDataSyncLogService),G(8,a.IUserDataProfilesService),G(9,S.IConfigurationService)],o);function c(b){if(b instanceof t.UserDataSyncError)switch(b.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function y(b,g,D,A){A.publicLog2("sync/error",{code:b.code,serverCode:b instanceof t.UserDataSyncStoreError?String(b.serverCode):void 0,url:b instanceof t.UserDataSyncStoreError?b.url:void 0,resource:b.resource,executionId:g,service:D.userDataSyncStore.url.toString()})}}),define(re[280],oe([0,1,3,2,11,18,24]),function(te,e,O,U,l,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;function R(p,f){return{...p,profile:(0,T.reviveProfile)(p.profile,f.profilesHome.scheme)}}function I(p){return{created:p.created,uri:l.URI.revive(p.uri)}}class w{constructor(f,m,E){this.c=f,this.d=m,this.f=E,this.a=new Map,this.b=new O.Emitter}listen(f,m){switch(m){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`Event not found: ${m}`)}async call(f,m,E){try{return await this.g(f,m,E)}catch(a){throw this.f.error(a),a}}async g(f,m,E){switch(m){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(l.URI.revive(E[0]));case"accept":return this.c.accept(R(E[0],this.d),l.URI.revive(E[1]),E[2],E[3]);case"getRemoteProfiles":return this.c.getRemoteProfiles();case"getLocalSyncResourceHandles":return this.c.getLocalSyncResourceHandles(E[0],E[1]?(0,T.reviveProfile)(E[1],this.d.profilesHome.scheme):void 0);case"getRemoteSyncResourceHandles":return this.c.getRemoteSyncResourceHandles(E[0],E[1]);case"replace":return this.c.replace(I(E[0]));case"getAssociatedResources":return this.c.getAssociatedResources(I(E[0]));case"getMachineId":return this.c.getMachineId(I(E[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"createManualSyncTask":return this.i()}if(m.startsWith("manualSync/")){const a=m.substring(11),u=E[0],h=this.h(u);switch(E=E.slice(1),a){case"merge":return h.merge();case"apply":return h.apply().then(()=>this.a.delete(this.j(h.id)));case"stop":return h.stop().finally(()=>this.a.delete(this.j(h.id)))}}throw new Error("Invalid call")}h(f){const m=this.a.get(this.j(f));if(!m)throw new Error(`Manual sync taks not found: ${f}`);return m}async i(){const f=await this.c.createManualSyncTask();return this.a.set(this.j(f.id),f),f.id}j(f){return`manualSyncTask-${f}`}}e.UserDataSyncChannel=w;let P=class extends U.Disposable{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(f,m){super(),this.k=m,this.b="uninitialized",this.c=this.D(new O.Emitter),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.D(new O.Emitter),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.i=this.D(new O.Emitter),this.onDidChangeLastSyncTime=this.i.event,this.j=this.D(new O.Emitter),this.onSyncErrors=this.j.event,this.a={call(E,a,u){return f.call(E,a,u).then(null,h=>{throw N.UserDataSyncError.toUserDataSyncError(h)})},listen(E,a){return f.listen(E,a)}},this.a.call("_getInitialData").then(([E,a,u])=>{this.l(E),this.m(a),u&&this.n(u),this.D(this.a.listen("onDidChangeStatus")(h=>this.l(h))),this.D(this.a.listen("onDidChangeLastSyncTime")(h=>this.n(h)))}),this.D(this.a.listen("onDidChangeConflicts")(E=>this.m(E))),this.D(this.a.listen("onSyncErrors")(E=>this.j.fire(E.map(a=>({...a,error:N.UserDataSyncError.toUserDataSyncError(a.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const f=await this.a.call("createManualSyncTask"),m=this;return new S(f,{async call(a,u,h){return m.a.call(`manualSync/${a}`,[f,...Array.isArray(u)?u:[u]],h)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(f,m,E,a){return this.a.call("accept",[f,m,E,a])}resolveContent(f){return this.a.call("resolveContent",[f])}getRemoteProfiles(){return this.a.call("getRemoteProfiles")}async getLocalSyncResourceHandles(f,m){return(await this.a.call("getLocalSyncResourceHandles",[f,m])).map(({created:a,uri:u})=>({created:a,uri:l.URI.revive(u)}))}async getRemoteSyncResourceHandles(f,m){return(await this.a.call("getRemoteSyncResourceHandles",[f,m])).map(({created:a,uri:u})=>({created:a,uri:l.URI.revive(u)}))}async getAssociatedResources(f){return(await this.a.call("getAssociatedResources",[f])).map(({resource:E,comparableResource:a})=>({resource:l.URI.revive(E),comparableResource:l.URI.revive(a)}))}getMachineId(f){return this.a.call("getMachineId",[f])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(f){return this.a.call("replace",[f])}async l(f){this.b=f,this.c.fire(f)}async m(f){this.f=f.map(m=>({syncResource:m.syncResource,profile:(0,T.reviveProfile)(m.profile,this.k.profilesHome.scheme),conflicts:m.conflicts.map(E=>({...E,baseResource:l.URI.revive(E.baseResource),localResource:l.URI.revive(E.localResource),remoteResource:l.URI.revive(E.remoteResource),previewResource:l.URI.revive(E.previewResource)}))})),this.g.fire(this.f)}n(f){this.h!==f&&(this.h=f,this.i.fire(f))}};P=ye([G(1,T.IUserDataProfilesService)],P),e.UserDataSyncChannelClient=P;class S extends U.Disposable{constructor(f,m){super(),this.id=f,this.a=m}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose")}}}),define(re[281],oe([0,1,6,25,10,3,2,142,4,23,12,11,31,17,15,14,26,59,44,20,24]),function(te,e,O,U,l,T,N,R,I,w,P,S,p,f,m,E,a,u,h,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const L="sync.previous.store",n="sync.donot-make-requests-until",r="sync.user-session-id",t="sync.machine-session-id",i=100,s=1e3*60*5;let o=class extends N.Disposable{get userDataSyncStore(){return this.b}get c(){return this.h.get(v.SYNC_SERVICE_URL_TYPE,-1)}set c(A){this.h.store(v.SYNC_SERVICE_URL_TYPE,A,-1,I.isWeb?0:1)}constructor(A,F,j){super(),this.f=A,this.g=F,this.h=j,this.a=this.D(new T.Emitter),this.onDidChangeUserDataSyncStore=this.a.event,this.i(),this.D(T.Event.filter(j.onDidChangeValue,x=>x.key===v.SYNC_SERVICE_URL_TYPE&&x.scope===-1&&this.c!==this.userDataSyncStore?.type)(()=>this.i()))}i(){this.b=this.j(this.f[v.CONFIGURATION_SYNC_STORE_KEY],this.g.getValue(v.CONFIGURATION_SYNC_STORE_KEY)),this.a.fire()}j(A,F){A=I.isWeb&&A?.web?{...A,...A.web}:A;const j={...A||{},...F||{}};if(j&&(0,P.isString)(j.url)&&(0,P.isObject)(j.authenticationProviders)&&Object.keys(j.authenticationProviders).every(x=>Array.isArray(j.authenticationProviders[x].scopes))){const x=j,V=!!x.canSwitch&&!F?.url,B=x.url===x.insidersUrl?"insiders":"stable",Z=(V?this.c:void 0)||B,J=F?.url||(Z==="insiders"?x.insidersUrl:Z==="stable"?x.stableUrl:x.url);return{url:S.URI.parse(J),type:Z,defaultType:B,defaultUrl:S.URI.parse(x.url),stableUrl:S.URI.parse(x.stableUrl),insidersUrl:S.URI.parse(x.insidersUrl),canSwitch:V,authenticationProviders:Object.keys(x.authenticationProviders).reduce((K,Y)=>(K.push({id:Y,scopes:x.authenticationProviders[Y].scopes}),K),[])}}}};o=ye([G(0,a.IProductService),G(1,f.IConfigurationService),G(2,d.IStorageService)],o),e.AbstractUserDataSyncStoreManagementService=o;let c=class extends o{constructor(A,F,j){super(A,F,j);const x=this.h.get(L,-1);x&&(this.k=JSON.parse(x));const V=this.f[v.CONFIGURATION_SYNC_STORE_KEY];V?this.h.store(L,JSON.stringify(V),-1,1):this.h.remove(L,-1)}async switch(A){A!==this.c&&(this.c=A,this.i())}async getPreviousUserDataSyncStore(){return this.j(this.k)}};c=ye([G(0,a.IProductService),G(1,f.IConfigurationService),G(2,d.IStorageService)],c),e.UserDataSyncStoreManagementService=c;let y=class extends N.Disposable{get donotMakeRequestsUntil(){return this.i}constructor(A,F,j,x,V,B,Z){super(),this.k=j,this.l=x,this.n=Z,this.g=this.D(new T.Emitter),this.onTokenFailed=this.g.event,this.h=this.D(new T.Emitter),this.onTokenSucceed=this.h.event,this.i=void 0,this.j=this.D(new T.Emitter),this.onDidChangeDonotMakeRequestsUntil=this.j.event,this.r=void 0,this.p(A),this.c=(0,h.getServiceMachineId)(V,B,Z).then(J=>{const K={"X-Client-Name":`${F.applicationName}${I.isWeb?"-web":""}`,"X-Client-Version":F.version};return F.commit&&(K["X-Client-Commit"]=F.commit),K}),this.f=new g(i,s,this.k,this.l),this.q(),this.D((0,N.toDisposable)(()=>{this.r&&(this.r.cancel(),this.r=void 0)}))}setAuthToken(A,F){this.b={token:A,type:F}}p(A){this.a=A?(0,w.joinPath)(A,"v1"):void 0}q(){const A=this.n.getNumber(n,-1);A&&Date.now()<A&&this.s(new Date(A))}s(A){this.i?.getTime()!==A?.getTime()&&(this.i=A,this.r&&(this.r.cancel(),this.r=void 0),this.i?(this.n.store(n,this.i.getTime(),-1,1),this.r=(0,O.createCancelablePromise)(F=>(0,O.timeout)(this.i.getTime()-Date.now(),F).then(()=>this.s(void 0))),this.r.then(null,F=>null)):this.n.remove(n,-1),this.j.fire())}async getAllCollections(A={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,w.joinPath)(this.a,"collection").toString();A={...A},A["Content-Type"]="application/json";const j=await this.v(F,{type:"GET",headers:A},[],U.CancellationToken.None);return(await(0,u.asJson)(j))?.map(({id:x})=>x)||[]}async createCollection(A={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,w.joinPath)(this.a,"collection").toString();A={...A},A["Content-Type"]=R.Mimes.text;const j=await this.v(F,{type:"POST",headers:A},[],U.CancellationToken.None),x=await(0,u.asTextOrError)(j);if(!x)throw new v.UserDataSyncStoreError("Server did not return the collection id",F,"NoCollection",j.res.statusCode,j.res.headers[v.HEADER_OPERATION_ID]);return x}async deleteCollection(A,F={}){if(!this.a)throw new Error("No settings sync store url configured.");const j=A?(0,w.joinPath)(this.a,"collection",A).toString():(0,w.joinPath)(this.a,"collection").toString();F={...F},await this.v(j,{type:"DELETE",headers:F},[],U.CancellationToken.None)}async getAllResourceRefs(A,F){if(!this.a)throw new Error("No settings sync store url configured.");const j=this.t(this.a,F,A),x={},V=await this.v(j.toString(),{type:"GET",headers:x},[],U.CancellationToken.None);return(await(0,u.asJson)(V)||[]).map(({url:Z,created:J})=>({ref:(0,w.relativePath)(j,j.with({path:Z})),created:J*1e3}))}async resolveResourceContent(A,F,j,x={}){if(!this.a)throw new Error("No settings sync store url configured.");const V=(0,w.joinPath)(this.t(this.a,j,A),F).toString();x={...x},x["Cache-Control"]="no-cache";const B=await this.v(V,{type:"GET",headers:x},[],U.CancellationToken.None);return await(0,u.asTextOrError)(B)}async deleteResource(A,F,j){if(!this.a)throw new Error("No settings sync store url configured.");const x=F!==null?(0,w.joinPath)(this.t(this.a,j,A),F).toString():this.t(this.a,j,A).toString(),V={};await this.v(x,{type:"DELETE",headers:V},[],U.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const A=(0,w.joinPath)(this.a,"resource").toString(),F={"Content-Type":R.Mimes.text};await this.v(A,{type:"DELETE",headers:F},[],U.CancellationToken.None)}async readResource(A,F,j,x={}){if(!this.a)throw new Error("No settings sync store url configured.");const V=(0,w.joinPath)(this.t(this.a,j,A),"latest").toString();x={...x},x["Cache-Control"]="no-cache",F&&(x["If-None-Match"]=F.ref);const B=await this.v(V,{type:"GET",headers:x},[304],U.CancellationToken.None);let Z=null;if(B.res.statusCode===304&&(Z=F),Z===null){const J=B.res.headers.etag;if(!J)throw new v.UserDataSyncStoreError("Server did not return the ref",V,"NoRef",B.res.statusCode,B.res.headers[v.HEADER_OPERATION_ID]);const K=await(0,u.asTextOrError)(B);if(!K&&B.res.statusCode===304)throw new v.UserDataSyncStoreError("Empty response",V,"EmptyResponse",B.res.statusCode,B.res.headers[v.HEADER_OPERATION_ID]);Z={ref:J,content:K}}return Z}async writeResource(A,F,j,x,V={}){if(!this.a)throw new Error("No settings sync store url configured.");const B=this.t(this.a,x,A).toString();V={...V},V["Content-Type"]=R.Mimes.text,j&&(V["If-Match"]=j);const Z=await this.v(B,{type:"POST",data:F,headers:V},[],U.CancellationToken.None),J=Z.res.headers.etag;if(!J)throw new v.UserDataSyncStoreError("Server did not return the ref",B,"NoRef",Z.res.statusCode,Z.res.headers[v.HEADER_OPERATION_ID]);return J}async manifest(A,F={}){if(!this.a)throw new Error("No settings sync store url configured.");const j=(0,w.joinPath)(this.a,"manifest").toString();F={...F},F["Content-Type"]="application/json",A&&(F["If-None-Match"]=A.ref);const x=await this.v(j,{type:"GET",headers:F},[304],U.CancellationToken.None);let V=null;if(x.res.statusCode===304&&(V=A),!V){const Z=x.res.headers.etag;if(!Z)throw new v.UserDataSyncStoreError("Server did not return the ref",j,"NoRef",x.res.statusCode,x.res.headers[v.HEADER_OPERATION_ID]);const J=await(0,u.asTextOrError)(x);if(!J&&x.res.statusCode===304)throw new v.UserDataSyncStoreError("Empty response",j,"EmptyResponse",x.res.statusCode,x.res.headers[v.HEADER_OPERATION_ID]);J&&(V={...JSON.parse(J),ref:Z})}const B=this.n.get(r,-1);return B&&V&&B!==V.session&&this.u(),V===null&&B&&this.u(),V&&this.n.store(r,V.session,-1,1),V}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.u()}t(A,F,j){return F?(0,w.joinPath)(A,"collection",F,"resource",j):(0,w.joinPath)(A,"resource",j)}u(){this.n.remove(r,-1),this.n.remove(t,-1)}async v(A,F,j,x){if(!this.b)throw new v.UserDataSyncStoreError("No Auth Token Available",A,"Unauthorized",void 0,void 0);if(this.i&&Date.now()<this.i.getTime())throw new v.UserDataSyncStoreError(`${F.type} request '${A}' failed because of too many requests (429).`,A,"TooManyRequestsAndRetryAfter",void 0,void 0);this.s(void 0);const V=await this.c;F.headers={...F.headers||{},...V,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.w(F.headers),this.l.trace("Sending request to server",{url:A,type:F.type,headers:{...F.headers,authorization:void 0}});let B;try{B=await this.f.request(A,F,x)}catch(H){if(!(H instanceof v.UserDataSyncStoreError)){let $="RequestFailed";const X=(0,l.getErrorMessage)(H).toLowerCase();X.includes("xhr timeout")?$="RequestTimeout":X.includes("protocol")&&X.includes("not supported")?$="RequestProtocolNotSupported":X.includes("request path contains unescaped characters")?$="RequestPathNotEscaped":X.includes("headers must be an object")?$="RequestHeadersNotObject":(0,l.isCancellationError)(H)&&($="RequestCanceled"),H=new v.UserDataSyncStoreError(`Connection refused for the request '${A}'.`,A,$,void 0,void 0)}throw this.l.info("Request failed",A),H}const Z=B.res.headers[v.HEADER_OPERATION_ID],J={url:A,status:B.res.statusCode,"execution-id":F.headers[v.HEADER_EXECUTION_ID],"operation-id":Z},K=(0,u.isSuccess)(B)||B.res.statusCode&&j.indexOf(B.res.statusCode)!==-1;let Y="";if(K?this.l.trace("Request succeeded",J):(this.l.info("Request failed",J),Y=await(0,u.asText)(B)||""),B.res.statusCode===401)throw this.b=void 0,this.g.fire(),new v.UserDataSyncStoreError(`Request '${A}' failed because of Unauthorized (401).`,A,"Unauthorized",B.res.statusCode,Z);if(this.h.fire(),B.res.statusCode===404)throw new v.UserDataSyncStoreError(`${F.type} request '${A}' failed because the requested resource is not found (404).`,A,"NotFound",B.res.statusCode,Z);if(B.res.statusCode===405)throw new v.UserDataSyncStoreError(`${F.type} request '${A}' failed because the requested endpoint is not found (405). ${Y}`,A,"MethodNotFound",B.res.statusCode,Z);if(B.res.statusCode===409)throw new v.UserDataSyncStoreError(`${F.type} request '${A}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,A,"Conflict",B.res.statusCode,Z);if(B.res.statusCode===410)throw new v.UserDataSyncStoreError(`${F.type} request '${A}' failed because the requested resource is not longer available (410).`,A,"Gone",B.res.statusCode,Z);if(B.res.statusCode===412)throw new v.UserDataSyncStoreError(`${F.type} request '${A}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,A,"PreconditionFailed",B.res.statusCode,Z);if(B.res.statusCode===413)throw new v.UserDataSyncStoreError(`${F.type} request '${A}' failed because of too large payload (413).`,A,"TooLarge",B.res.statusCode,Z);if(B.res.statusCode===426)throw new v.UserDataSyncStoreError(`${F.type} request '${A}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,A,"UpgradeRequired",B.res.statusCode,Z);if(B.res.statusCode===429){const H=B.res.headers["retry-after"];throw H?(this.s(new Date(Date.now()+parseInt(H)*1e3)),new v.UserDataSyncStoreError(`${F.type} request '${A}' failed because of too many requests (429).`,A,"TooManyRequestsAndRetryAfter",B.res.statusCode,Z)):new v.UserDataSyncStoreError(`${F.type} request '${A}' failed because of too many requests (429).`,A,"RemoteTooManyRequests",B.res.statusCode,Z)}if(!K)throw new v.UserDataSyncStoreError("Server returned "+B.res.statusCode,A,"Unknown",B.res.statusCode,Z);return B}w(A){let F=this.n.get(t,-1);F===void 0&&(F=(0,p.generateUuid)(),this.n.store(t,F,-1,1)),A["X-Machine-Session-Id"]=F;const j=this.n.get(r,-1);j!==void 0&&(A["X-User-Session-Id"]=j)}};y=ye([G(1,a.IProductService),G(2,u.IRequestService),G(3,v.IUserDataSyncLogService),G(4,m.IEnvironmentService),G(5,E.IFileService),G(6,d.IStorageService)],y),e.UserDataSyncStoreClient=y;let b=class extends y{constructor(A,F,j,x,V,B,Z){super(A.userDataSyncStore?.url,F,j,x,V,B,Z),this.D(A.onDidChangeUserDataSyncStore(()=>this.p(A.userDataSyncStore?.url)))}};b=ye([G(0,v.IUserDataSyncStoreManagementService),G(1,a.IProductService),G(2,u.IRequestService),G(3,v.IUserDataSyncLogService),G(4,m.IEnvironmentService),G(5,E.IFileService),G(6,d.IStorageService)],b),e.UserDataSyncStoreService=b;class g{constructor(A,F,j,x){this.c=A,this.d=F,this.f=j,this.g=x,this.a=[],this.b=void 0}request(A,F,j){if(this.h()&&this.i(),F.url=A,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new v.UserDataSyncStoreError(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,A,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(A),this.f.request(F,j)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.RequestsSession=g}),define(re[282],oe([0,1,3,57,26,20,19,277,24,79,82]),function(te,e,O,U,l,T,N,R,I,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let S=class extends R.UserDataAutoSyncService{constructor(f,m,E,a,u,h,d,v,L,n,r){super(f,m,E,a,u,d,v,L,n,r),this.D(O.Event.debounce(O.Event.any(O.Event.map(h.onDidFocusWindow,()=>"windowFocus"),O.Event.map(h.onDidOpenWindow,()=>"windowOpen")),(t,i)=>t?[...t,i]:[i],1e3)(t=>this.triggerSync(t,!0,!1)))}};S=ye([G(0,l.IProductService),G(1,I.IUserDataSyncStoreManagementService),G(2,I.IUserDataSyncStoreService),G(3,I.IUserDataSyncEnablementService),G(4,I.IUserDataSyncService),G(5,U.INativeHostService),G(6,I.IUserDataSyncLogService),G(7,w.IUserDataSyncAccountService),G(8,N.ITelemetryService),G(9,P.IUserDataSyncMachinesService),G(10,T.IStorageService)],S),e.UserDataAutoSyncService=S}),define(re[283],oe([0,1,71,22,4,23]),function(te,e,O,U,l,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function N(w){function P(){let S=w.scheme===U.Schemas.file?(0,T.originalFSPath)(w):w.toString();return l.isLinux||(S=S.toLowerCase()),(0,O.createHash)("md5").update(S).digest("hex")}return{id:P(),configPath:w}}e.getWorkspaceIdentifier=N;function R(w,P){function S(){if(w.scheme!==U.Schemas.file)return(0,O.createHash)("md5").update(w.toString()).digest("hex");if(!P)return;let f;return l.isLinux?f=P.ino:l.isMacintosh?f=P.birthtime.getTime():l.isWindows&&(typeof P.birthtimeMs=="number"?f=Math.floor(P.birthtimeMs):f=P.birthtime.getTime()),(0,O.createHash)("md5").update(w.fsPath).update(f?String(f):"").digest("hex")}const p=S();if(typeof p=="string")return{id:p,uri:w}}e.getSingleFolderWorkspaceIdentifier=R;function I(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=I}),define(re[284],oe([0,1,6,10,2,13,28,15,9,77,119,283,57,73]),function(te,e,O,U,l,T,N,R,I,w,P,S,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UnusedWorkspaceStorageDataCleaner=void 0;let m=class extends l.Disposable{constructor(a,u,h,d){super(),this.a=a,this.b=u,this.c=h,this.f=d,this.D(new O.RunOnceScheduler(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const a=await N.Promises.readdir(this.a.workspaceStorageHome.fsPath),u=new w.StorageClient(this.f.getChannel("storage"));await Promise.all(a.map(async h=>{const d=(0,T.join)(this.a.workspaceStorageHome.fsPath,h);h.length===S.NON_EMPTY_WORKSPACE_ID_LENGTH||h===P.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE.id||(await this.c.getWindows()).some(n=>n.workspace?.id===h)||await u.isUsed(d)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${h} as it seems to be an unused empty workspace.`),await N.Promises.rm(d))}))}catch(a){(0,U.onUnexpectedError)(a)}}};m=ye([G(0,R.INativeEnvironmentService),G(1,I.ILogService),G(2,p.INativeHostService),G(3,f.IMainProcessService)],m),e.UnusedWorkspaceStorageDataCleaner=m}),define(re[83],oe([0,1,54,6,13,12,28,153,297,298]),function(te,e,O,U,l,T,N,R,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=e.CorruptZipMessage=void 0,e.CorruptZipMessage="end of central directory record signature not found";const P=new RegExp(e.CorruptZipMessage);class S extends Error{constructor(r,t){let i=t.message;switch(r){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=r,this.cause=t}}e.ExtractError=S;function p(n){const r=n.externalFileAttributes>>16||33188;return[448,56,7].map(t=>r&t).reduce((t,i)=>t+i,r&61440)}function f(n){if(n instanceof S)return n;let r;return P.test(n.message)&&(r="CorruptZip"),new S(r,n)}function m(n,r,t,i,s,o){const c=l.dirname(r),y=l.join(i,c);if(!y.startsWith(i))return Promise.reject(new Error(R.localize(0,null,r)));const b=l.join(i,r);let g;return o.onCancellationRequested(()=>{g?.destroy()}),Promise.resolve(N.Promises.mkdir(y,{recursive:!0})).then(()=>new Promise((D,A)=>{if(!o.isCancellationRequested)try{g=(0,O.createWriteStream)(b,{mode:t}),g.once("close",()=>D()),g.once("error",A),n.once("error",A),n.pipe(g)}catch(F){A(F)}}))}function E(n,r,t,i){let s=(0,U.createCancelablePromise)(()=>Promise.resolve()),o=0;return i.onCancellationRequested(()=>{s.cancel(),n.close()}),new Promise((c,y)=>{const b=new U.Sequencer,g=D=>{D.isCancellationRequested||(o++,n.readEntry())};n.once("error",y),n.once("close",()=>s.then(()=>{i.isCancellationRequested||n.entryCount===o?c():y(new S("Incomplete",new Error(R.localize(1,null,o,n.entryCount))))},y)),n.readEntry(),n.on("entry",D=>{if(i.isCancellationRequested)return;if(!t.sourcePathRegex.test(D.fileName)){g(i);return}const A=D.fileName.replace(t.sourcePathRegex,"");if(/\/$/.test(A)){const x=l.join(r,A);s=(0,U.createCancelablePromise)(V=>N.Promises.mkdir(x,{recursive:!0}).then(()=>g(V)).then(void 0,y));return}const F=u(n,D),j=p(D);s=(0,U.createCancelablePromise)(x=>b.queue(()=>F.then(V=>m(V,A,j,r,t,x).then(()=>g(x)))).then(null,y))})})}function a(n,r=!1){return new Promise((t,i)=>{(0,I.open)(n,r?{lazyEntries:!0}:void 0,(s,o)=>{s?i(f(s)):t((0,T.assertIsDefined)(o))})})}function u(n,r){return new Promise((t,i)=>{n.openReadStream(r,(s,o)=>{s?i(f(s)):t((0,T.assertIsDefined)(o))})})}function h(n,r){return new Promise((t,i)=>{const s=new w.ZipFile;r.forEach(c=>{c.contents?s.addBuffer(typeof c.contents=="string"?Buffer.from(c.contents,"utf8"):c.contents,c.path):c.localPath&&s.addFile(c.localPath,c.path)}),s.end();const o=(0,O.createWriteStream)(n);s.outputStream.pipe(o),s.outputStream.once("error",i),o.once("error",i),o.once("finish",()=>t(n))})}e.zip=h;function d(n,r,t={},i){const s=new RegExp(t.sourcePath?`^${t.sourcePath}`:"");let o=a(n,!0);return t.overwrite&&(o=o.then(c=>N.Promises.rm(r).then(()=>c))),o.then(c=>E(c,r,{sourcePathRegex:s},i))}e.extract=d;function v(n,r){return a(n).then(t=>new Promise((i,s)=>{t.on("entry",o=>{o.fileName===r&&u(t,o).then(c=>i(c),c=>s(c))}),t.once("close",()=>s(new Error(R.localize(2,null,r))))}))}function L(n,r){return v(n,r).then(t=>new Promise((i,s)=>{const o=[];t.once("error",s),t.on("data",c=>o.push(c)),t.on("end",()=>i(Buffer.concat(o)))}))}e.buffer=L}),define(re[285],oe([0,1,6,10,2,22,4,23,55,12,31,28,83,17,15,29,33,101,14,9]),function(te,e,O,U,l,T,N,R,I,w,P,S,p,f,m,E,a,u,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let v=class yt extends l.Disposable{constructor(n,r,t,i,s,o){super(),this.h=r,this.i=t,this.j=i,this.k=s,this.l=o,this.extensionsDownloadDir=n.extensionsDownloadLocation,this.f=20,this.g=this.t()}async download(n,r){await this.g;const t=(0,R.joinPath)(this.extensionsDownloadDir,this.u(n));try{await this.q(n,t,s=>this.i.download(n,s,r))}catch(s){throw new E.ExtensionManagementError(s.message,E.ExtensionManagementErrorCode.Download)}let i="Unverified";if(this.m(n)){const s=await this.n(n);try{await this.k.verify(t.fsPath,s.fsPath,this.l.getLevel()===d.LogLevel.Trace)&&(i="Verified"),this.l.info(`Extension signature verification: ${n.identifier.id}. Verification status: ${i}.`)}catch(o){const c=o,y=c.code;if(c.output&&this.l.trace(`Extension signature verification details for ${n.identifier.id} ${n.version}:
${c.output}`),y==="UnknownError")i="UnknownError",this.l.warn(`Extension signature verification: ${n.identifier.id}. Verification status: ${i}.`);else{if(y==="PackageIsInvalidZip"||y==="SignatureArchiveIsInvalidZip")throw new E.ExtensionManagementError(p.CorruptZipMessage,E.ExtensionManagementErrorCode.CorruptZip);if(!c.didExecute)this.l.warn(`Extension signature verification: ${n.identifier.id}. Verification status: ${i} (${y})`);else throw await this.delete(t),new E.ExtensionManagementError(y,E.ExtensionManagementErrorCode.Signature)}}finally{try{await this.delete(s)}catch(o){this.l.error(o)}}}return{location:t,verificationStatus:i}}m(n){if(!n.isSigned)return!1;const r=this.j.getValue("extensions.verifySignature");return(0,w.isBoolean)(r)?r:!0}async n(n){await this.g;const r=(0,R.joinPath)(this.extensionsDownloadDir,`${this.u(n)}${yt.c}`);return await this.q(n,r,t=>this.i.downloadSignatureArchive(n,t)),r}async q(n,r,t){if(await this.h.exists(r))return;if(r.scheme!==T.Schemas.file){await t(r);return}const i=(0,R.joinPath)(this.extensionsDownloadDir,`.${(0,P.generateUuid)()}`);await this.h.exists(i)||await t(i);try{await this.r(i,r,Date.now()+2*60*1e3)}catch(s){try{await this.h.del(i)}catch{}if(s.code==="ENOTEMPTY")this.l.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",n.identifier.id,r.path);else throw this.l.info(`Rename failed because of ${(0,U.getErrorMessage)(s)}. Deleted the file from downloaded location`,i.path),s}}async delete(n){await this.g,await this.h.del(n)}async r(n,r,t){try{await S.Promises.rename(n.fsPath,r.fsPath)}catch(i){if(N.isWindows&&i&&i.code==="EPERM"&&Date.now()<t)return this.l.info(`Failed renaming ${n} to ${r} with 'EPERM' error. Trying again...`),this.r(n,r,t);throw i}}async t(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.l.trace("Extension VSIX downloads cache dir does not exist");return}const n=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(n.children){const r=[],t=[],i=[];for(const c of n.children)if(c.name.endsWith(yt.c))i.push(c.resource);else{const y=a.ExtensionKey.parse(c.name);y&&t.push([y,c])}const s=(0,a.groupByExtension)(t,([c])=>c),o=[];for(const c of s)c.sort((y,b)=>I.rcompare(y[0].version,b[0].version)),r.push(...c.slice(1).map(y=>y[1].resource)),o.push(c[0][1]);o.sort((c,y)=>c.mtime-y.mtime),r.push(...o.slice(0,Math.max(0,o.length-this.f)).map(c=>c.resource)),r.push(...i),await O.Promises.settled(r.map(c=>(this.l.trace("Deleting from cache",c.path),this.h.del(c))))}}catch(n){this.l.error(n)}}u(n){return this.f?a.ExtensionKey.create(n).toString().toLowerCase():(0,P.generateUuid)()}};v.c=".sigzip",v=ye([G(0,m.INativeEnvironmentService),G(1,h.IFileService),G(2,E.IExtensionGalleryService),G(3,f.IConfigurationService),G(4,u.IExtensionSignatureVerificationService),G(5,d.ILogService)],v),e.ExtensionsDownloader=v}),define(re[286],oe([0,1,83,165]),function(te,e,O,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function l(T){return(0,O.buffer)(T,"extension/package.json").then(N=>{try{return JSON.parse(N.toString("utf8"))}catch{throw new Error((0,U.localize)(0,null))}})}e.getManifest=l}),define(re[128],oe([0,1,6,16,25,38,10,3,2,37,22,13,4,23,55,12,11,31,28,83,164,100,15,266,29,33,51,80,285,267,286,223,237,46,68,14,5,9,26,19,30,18]),function(te,e,O,U,l,T,N,R,I,w,P,S,p,f,m,E,a,u,h,d,v,L,n,r,t,i,s,o,c,y,b,g,D,A,F,j,x,V,B,Z,J,K){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,x.refineServiceDecorator)(t.IExtensionManagementService);let Y=class extends r.AbstractExtensionManagementService{constructor(q,C,k,M,z,_,W,Q,ee,le,he,pe){super(q,C,k,le,pe),this.Z=z,this.ab=_,this.bb=W,this.cb=ee,this.db=he,this.X=this.D(new R.Emitter),this.onDidUpdateExtensionMetadata=this.X.event,this.Y=new Map,this.lb=new w.ResourceSet;const de=this.D(Q.createInstance(y.ExtensionsLifecycle));this.S=this.D(Q.createInstance(H,Ce=>de.postUninstall(Ce))),this.U=this.D(new g.ExtensionsManifestCache(M,this)),this.W=this.D(Q.createInstance(c.ExtensionsDownloader));const be=this.D(new D.ExtensionsWatcher(this,this.Z,pe,_,he,ee,k));this.D(be.onDidChangeExtensionsByAnotherSource(Ce=>this.kb(Ce))),this.mb()}getTargetPlatform(){return this.eb||(this.eb=(0,i.computeTargetPlatform)(this.cb,this.u)),this.eb}async zip(q){this.u.trace("ExtensionManagementService#zip",q.identifier.id);const C=await this.jb(q),k=await(0,d.zip)((0,f.joinPath)(this.W.extensionsDownloadDir,(0,u.generateUuid)()).fsPath,C);return a.URI.file(k)}async unzip(q){return this.u.trace("ExtensionManagementService#unzip",q.toString()),(await this.install(q)).identifier}async getManifest(q){const{location:C,cleanup:k}=await this.fb(q),M=S.resolve(C.fsPath);try{return await(0,b.getManifest)(M)}finally{await k()}}getInstalled(q,C=this.w.defaultProfile.extensionsResource){return this.S.scanExtensions(q??null,C)}scanAllUserInstalledExtensions(){return this.S.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(q){return this.S.scanUserExtensionAtLocation(q)}async install(q,C={}){this.u.trace("ExtensionManagementService#install",q.toString());const{location:k,cleanup:M}=await this.fb(q);try{const z=await(0,b.getManifest)(S.resolve(k.fsPath));if(z.engines&&z.engines.vscode&&!(0,F.isEngineValid)(z.engines.vscode,this.v.version,this.v.date))throw new Error(v.localize(0,null,(0,i.getGalleryExtensionId)(z.publisher,z.name),this.v.version));return await this.y(z,k,C)}finally{await M()}}async installFromLocation(q,C){this.u.trace("ExtensionManagementService#installFromLocation",q.toString());const k=await this.S.scanUserExtensionAtLocation(q);if(!k)throw new Error(`Cannot find a valid extension from the location ${q.toString()}`);return await this.ob([[k,void 0]],C),this.u.info("Successfully installed extension",k.identifier.id,C.toString()),k}async installExtensionsFromProfile(q,C,k){this.u.trace("ExtensionManagementService#installExtensionsFromProfile",q,C.toString(),k.toString());const M=(await this.S.scanExtensions(1,C)).filter(z=>q.some(_=>(0,i.areSameExtensions)(_,z.identifier)));if(M.length){const z=await Promise.all(M.map(_=>this.S.scanMetadata(_,C)));await this.ob(M.map((_,W)=>[_,z[W]]),k),this.u.info("Successfully installed extensions",M.map(_=>_.identifier.id),k.toString())}return M}async updateMetadata(q,C,k=this.w.defaultProfile.extensionsResource){return this.u.trace("ExtensionManagementService#updateMetadata",q.identifier.id),C.isPreReleaseVersion&&(C.preRelease=!0),C.isMachineScoped=C.isMachineScoped||void 0,C.isBuiltin=C.isBuiltin||void 0,C.pinned=C.pinned||void 0,q=await this.S.updateMetadata(q,C,k),this.U.invalidate(),this.X.fire(q),q}async reinstallFromGallery(q){if(this.u.trace("ExtensionManagementService#reinstallFromGallery",q.identifier.id),!this.s.isEnabled())throw new Error(v.localize(1,null));const C=await this.getTargetPlatform(),[k]=await this.s.getExtensions([{...q.identifier,preRelease:q.preRelease}],{targetPlatform:C,compatible:!0},l.CancellationToken.None);if(!k)throw new Error(v.localize(2,null));await this.S.setUninstalled(q);try{await this.S.removeUninstalledExtension(q)}catch(M){throw new Error(v.localize(3,null,(0,T.toErrorMessage)(M)))}return this.installFromGallery(k)}copyExtensions(q,C){return this.S.copyExtensions(q,C)}markAsUninstalled(...q){return this.S.setUninstalled(...q)}async cleanUp(){this.u.trace("ExtensionManagementService#cleanUp");try{await this.S.cleanUp()}catch(q){this.u.error(q)}}async download(q,C){const{location:k}=await this.W.download(q,C);return k}async fb(q){if(q.scheme===P.Schemas.file)return{location:q,async cleanup(){}};this.u.trace("Downloading extension from",q.toString());const C=(0,f.joinPath)(this.W.extensionsDownloadDir,(0,u.generateUuid)());return await this.bb.download(q,C),this.u.info("Downloaded extension to",C.toString()),{location:C,cleanup:async()=>{try{await this.cb.del(C)}catch(M){this.u.error(M)}}}}P(){return this.w.defaultProfile.extensionsResource}Q(q,C,k){if(a.URI.isUri(C))return new ie(q,C,k,this.s,this.S,this.db,this.w,this.Z,this.ab,this.u);const M=i.ExtensionKey.create(C).toString();let z=this.Y.get(M);return z||(this.Y.set(M,z=new X(q,C,k,this.W,this.S,this.db,this.w,this.Z,this.ab,this.u)),z.waitUntilTaskIsFinished().then(()=>this.Y.delete(M))),z}R(q,C){return new se(q,C.profileLocation,this.ab)}async jb(q){const C=async M=>{let z=await h.Promises.readdir(M);z=z.map(Q=>S.join(M,Q));const _=await Promise.all(z.map(Q=>h.Promises.stat(Q)));let W=Promise.resolve([]);return _.forEach((Q,ee)=>{const le=z[ee];Q.isFile()&&(W=W.then(he=>[...he,le])),Q.isDirectory()&&(W=W.then(he=>C(le).then(pe=>[...he,...pe])))}),W};return(await C(q.location.fsPath)).map(M=>({path:`extension/${S.relative(q.location.fsPath,M)}`,localPath:M}))}async kb({added:q,removed:C}){if(C)for(const k of C.extensions)this.u.info("Extensions removed from another source",k.id,C.profileLocation.toString()),this.p.fire({identifier:k,profileLocation:C.profileLocation});if(q){const M=(await this.S.scanExtensions(1,q.profileLocation)).filter(z=>q.extensions.some(_=>(0,i.areSameExtensions)(_,z.identifier)));this.m.fire(M.map(z=>(this.u.info("Extensions added from another source",z.identifier.id,q.profileLocation.toString()),{identifier:z.identifier,local:z,profileLocation:q.profileLocation,operation:1})))}}async mb(){this.D(this.S.onExtract(C=>this.lb.add(C)));const q=await this.cb.resolve(this.Z.userExtensionsLocation);for(const C of q.children??[])C.isDirectory&&this.lb.add(C.resource);this.D(this.cb.watch(this.Z.userExtensionsLocation)),this.D(this.cb.onDidFilesChange(C=>this.nb(C)))}async nb(q){if(!q.affects(this.Z.userExtensionsLocation,1))return;const C=[];for(const k of q.rawAdded){if(this.lb.has(k)||!this.db.extUri.isEqual(this.db.extUri.dirname(k),this.Z.userExtensionsLocation)||this.db.extUri.isEqual(k,this.db.extUri.joinPath(this.Z.userExtensionsLocation,".obsolete"))||this.db.extUri.basename(k).startsWith(".")||!(await this.cb.stat(k)).isDirectory)continue;const M=await this.S.scanUserExtensionAtLocation(k);M&&M.installedTimestamp===void 0&&(this.lb.add(k),C.push(M))}C.length&&(await this.ob(C.map(k=>[k,void 0]),this.w.defaultProfile.extensionsResource),this.u.info("Added extensions to default profile from external source",C.map(k=>k.identifier.id)))}async ob(q,C){const k=q.map(M=>M[0]);await this.pb(k),await this.ab.addExtensionsToProfile(q,C),this.m.fire(k.map(M=>({local:M,identifier:M.identifier,operation:1,profileLocation:C})))}async pb(q){const C=await this.S.getUninstalledExtensions();for(const k of q){const M=i.ExtensionKey.create(k);!C[M.toString()]||(this.u.trace("Removing the extension from uninstalled list:",M.id),await this.S.setInstalled(M),this.u.info("Removed the extension from uninstalled list:",M.id))}}};Y=ye([G(0,t.IExtensionGalleryService),G(1,Z.ITelemetryService),G(2,V.ILogService),G(3,n.INativeEnvironmentService),G(4,o.IExtensionsScannerService),G(5,s.IExtensionsProfileScannerService),G(6,L.IDownloadService),G(7,x.IInstantiationService),G(8,j.IFileService),G(9,B.IProductService),G(10,J.IUriIdentityService),G(11,K.IUserDataProfilesService)],Y),e.ExtensionManagementService=Y;let H=class extends I.Disposable{constructor(q,C,k,M,z,_){super(),this.k=q,this.l=C,this.m=k,this.n=M,this.p=z,this.q=_,this.h=this.D(new R.Emitter),this.onExtract=this.h.event,this.j=Promise.resolve(),this.c=(0,f.joinPath)(this.m.userExtensionsLocation,".obsolete"),this.g=new O.Queue}async cleanUp(){await this.y(),this.j=this.j.then(()=>this.z()),await this.j}async scanExtensions(q,C){const k={includeInvalid:!0,profileLocation:C};let M=[];return q===null||q===0?M.push(...await this.m.scanAllExtensions({includeInvalid:!0},k,!1)):q===1&&M.push(...await this.m.scanUserExtensions(k)),M=q!==null?M.filter(z=>z.type===q):M,Promise.all(M.map(z=>this.w(z)))}async scanAllUserExtensions(q){const C=await this.m.scanUserExtensions({includeAllVersions:!q,includeInvalid:!0});return Promise.all(C.map(k=>this.w(k)))}async scanUserExtensionAtLocation(q){try{const C=await this.m.scanExistingExtension(q,1,{includeInvalid:!0});if(C)return await this.w(C)}catch(C){this.q.error(C)}return null}async extractUserExtension(q,C,k,M){await this.j.catch(()=>{});const z=q.toString(),_=S.join(this.m.userExtensionsLocation.fsPath,`.${(0,u.generateUuid)()}`),W=S.join(this.m.userExtensionsLocation.fsPath,z);try{await h.Promises.rm(W)}catch{throw new t.ExtensionManagementError(v.localize(4,null,W,q.id),t.ExtensionManagementErrorCode.Delete)}await this.t(q,C,_,M),await this.m.updateMetadata(a.URI.file(_),k);try{this.h.fire(a.URI.file(W)),await this.u(q,_,W,Date.now()+2*60*1e3),this.q.info("Renamed to",W)}catch(Q){try{await h.Promises.rm(_)}catch{}if(Q.code==="ENOTEMPTY")this.q.info("Rename failed because extension was installed by another source. So ignoring renaming.",q.id);else throw this.q.info(`Rename failed because of ${(0,N.getErrorMessage)(Q)}. Deleted from extracted location`,_),Q}return this.v(a.URI.file(W),1)}async scanMetadata(q,C){return C?(await this.n.scanProfileExtensions(C)).find(M=>(0,i.areSameExtensions)(M.identifier,q.identifier))?.metadata:this.m.scanMetadata(q.location)}async updateMetadata(q,C,k){return k?await this.n.updateMetadata([[q,C]],k):await this.m.updateMetadata(q.location,C),this.v(q.location,q.type)}getUninstalledExtensions(){return this.s()}async setUninstalled(...q){const C=q.map(k=>i.ExtensionKey.create(k));await this.s(k=>C.forEach(M=>{k[M.toString()]=!0,this.q.info("Marked extension as uninstalled",M.toString())}))}async setInstalled(q){await this.s(C=>delete C[q.toString()])}async removeExtension(q,C){this.q.trace(`Deleting ${C} extension from disk`,q.identifier.id,q.location.fsPath);const k=this.p.extUri.joinPath(this.p.extUri.dirname(q.location),`.${(0,u.generateUuid)()}`);await this.u(q.identifier,q.location.fsPath,k.fsPath,Date.now()+2*60*1e3),await this.l.del(k,{recursive:!0}),this.q.info("Deleted from disk",q.identifier.id,q.location.fsPath)}async removeUninstalledExtension(q){await this.removeExtension(q,"uninstalled"),await this.s(C=>delete C[i.ExtensionKey.create(q).toString()])}async copyExtensions(q,C){const k=await this.scanExtensions(1,q),M=await Promise.all(k.filter(z=>!z.isApplicationScoped).map(async z=>[z,await this.scanMetadata(z,q)]));await this.n.addExtensionsToProfile(M,C)}async s(q){return this.g.queue(async()=>{let C;try{C=(await this.l.readFile(this.c,"utf8")).value.toString()}catch(M){if((0,j.toFileOperationResult)(M)!==1)throw M}let k={};if(C)try{k=JSON.parse(C)}catch{}return q&&(q(k),Object.keys(k).length?await this.l.writeFile(this.c,U.VSBuffer.fromString(JSON.stringify(k))):await this.l.del(this.c)),k})}async t(q,C,k,M){this.q.trace(`Started extracting the extension from ${C} to ${k}`);try{await h.Promises.rm(k)}catch(z){throw new t.ExtensionManagementError(this.C(z).message,t.ExtensionManagementErrorCode.Delete)}try{await(0,d.extract)(C,k,{sourcePath:"extension",overwrite:!0},M),this.q.info(`Extracted extension to ${k}:`,q.id)}catch(z){try{await h.Promises.rm(k)}catch{}let _=t.ExtensionManagementErrorCode.Extract;throw z instanceof d.ExtractError&&(z.type==="CorruptZip"?_=t.ExtensionManagementErrorCode.CorruptZip:z.type==="Incomplete"&&(_=t.ExtensionManagementErrorCode.IncompleteZip)),new t.ExtensionManagementError(z.message,_)}}async u(q,C,k,M){try{await h.Promises.rename(C,k)}catch(z){if(p.isWindows&&z&&z.code==="EPERM"&&Date.now()<M)return this.q.info(`Failed renaming ${C} to ${k} with 'EPERM' error. Trying again...`,q.id),this.u(q,C,k,M);throw new t.ExtensionManagementError(z.message||v.localize(5,null,C,k),z.code||t.ExtensionManagementErrorCode.Rename)}}async v(q,C){const k=await this.m.scanExistingExtension(q,C,{includeInvalid:!0});if(k)return this.w(k);throw new Error(v.localize(6,null,q.path))}async w(q){const C=await this.l.resolve(q.location);let k,M;return C.children&&(k=C.children.find(({name:z})=>/^readme(\.txt|\.md|)$/i.test(z))?.resource,M=C.children.find(({name:z})=>/^changelog(\.txt|\.md|)$/i.test(z))?.resource),{identifier:q.identifier,type:q.type,isBuiltin:q.isBuiltin||!!q.metadata?.isBuiltin,location:q.location,manifest:q.manifest,targetPlatform:q.targetPlatform,validations:q.validations,isValid:q.isValid,readmeUrl:k,changelogUrl:M,publisherDisplayName:q.metadata?.publisherDisplayName||null,publisherId:q.metadata?.publisherId||null,isApplicationScoped:!!q.metadata?.isApplicationScoped,isMachineScoped:!!q.metadata?.isMachineScoped,isPreReleaseVersion:!!q.metadata?.isPreReleaseVersion,preRelease:!!q.metadata?.preRelease,installedTimestamp:q.metadata?.installedTimestamp,updated:!!q.metadata?.updated,pinned:!!q.metadata?.pinned}}async y(){const q=await this.getUninstalledExtensions();this.q.debug("Removing uninstalled extensions:",Object.keys(q));const C=await this.m.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),k=new Set;for(const z of C)q[i.ExtensionKey.create(z).toString()]||k.add(z.identifier.id.toLowerCase());try{const z=(0,i.groupByExtension)(C,_=>_.identifier);await O.Promises.settled(z.map(async _=>{const W=_.sort((Q,ee)=>m.rcompare(Q.manifest.version,ee.manifest.version))[0];k.has(W.identifier.id.toLowerCase())||await this.k(await this.w(W))}))}catch(z){this.q.error(z)}const M=C.filter(z=>z.metadata&&q[i.ExtensionKey.create(z).toString()]);await Promise.allSettled(M.map(z=>this.removeUninstalledExtension(z)))}async z(){this.q.trace("ExtensionManagementService#removeGeneratedFolders");const q=[];let C;try{C=await this.l.resolve(this.m.userExtensionsLocation)}catch(k){(0,j.toFileOperationResult)(k)!==1&&this.q.error(k)}for(const k of C?.children??[])k.isDirectory&&k.name.startsWith(".")&&(0,u.isUUID)(k.name.substring(1))&&q.push((async()=>{this.q.trace("Deleting the generated extension folder",k.resource.toString());try{await this.l.del(k.resource,{recursive:!0}),this.q.info("Deleted the generated extension folder",k.resource.toString())}catch(M){this.q.error(M)}})());await Promise.allSettled(q)}C(q){const C=Array.isArray(q)?q:[q];return C.length===1?C[0]instanceof Error?C[0]:new Error(C[0]):C.reduce((k,M)=>new Error(`${k.message}${k.message?",":""}${M instanceof Error?M.message:M}`),new Error(""))}};H=ye([G(1,j.IFileService),G(2,o.IExtensionsScannerService),G(3,s.IExtensionsProfileScannerService),G(4,J.IUriIdentityService),G(5,V.ILogService)],H),e.ExtensionsScanner=H;class $ extends r.AbstractExtensionTask{get verificationStatus(){return this.j}get operation(){return(0,E.isUndefined)(this.l.operation)?this.k:this.l.operation}constructor(q,C,k,M,z,_,W,Q,ee){super(),this.identifier=q,this.source=C,this.l=k,this.m=M,this.n=z,this.o=_,this.p=W,this.q=Q,this.s=ee,this.j="Unverified",this.k=2}async h(q){const[C,k]=await this.x(q);return this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.l.profileLocation)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[C,k]],this.l.profileLocation),C}async u({zipPath:q,key:C,metadata:k},M){let z=await this.v(C);return z||(this.s.trace("Extracting extension...",C.id),z=await this.m.extractUserExtension(C,q,k,M),this.s.info("Extracting extension completed.",C.id)),z}async v(q){return await this.w(q)?(this.s.trace("Removing the extension from uninstalled list:",q.id),await this.m.setInstalled(q),this.s.info("Removed the extension from uninstalled list:",q.id),(await this.m.scanAllUserExtensions(!0)).find(M=>i.ExtensionKey.create(M).equals(q))):void 0}async w(q){return!!(await this.m.getUninstalledExtensions())[q.toString()]}}class X extends ${constructor(q,C,k,M,z,_,W,Q,ee,le){super(C.identifier,C,k,z,_,W,Q,ee,le),this.y=q,this.z=C,this.A=M}async x(q){const k=(await this.m.scanExtensions(null,this.l.profileLocation)).find(W=>(0,i.areSameExtensions)(W.identifier,this.z.identifier));k&&(this.k=3);const M={id:this.z.identifier.uuid,publisherId:this.z.publisherId,publisherDisplayName:this.z.publisherDisplayName,targetPlatform:this.z.properties.targetPlatform,isApplicationScoped:(0,A.isApplicationScopedExtension)(this.y),isMachineScoped:this.l.isMachineScoped||k?.isMachineScoped,isBuiltin:this.l.isBuiltin||k?.isBuiltin,isSystem:k?.type===0?!0:void 0,updated:!!k,isPreReleaseVersion:this.z.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.l.installGivenVersion?!0:void 0,preRelease:this.z.properties.isPreReleaseVersion||((0,E.isBoolean)(this.l.installPreReleaseVersion)?this.l.installPreReleaseVersion:k?.preRelease)};if(k?.manifest.version===this.z.version)return[await this.m.updateMetadata(k,M),M];const{location:z,verificationStatus:_}=await this.A.download(this.z,this.k);try{return this.j=_,this.C(z.fsPath),[await this.u({zipPath:z.fsPath,key:i.ExtensionKey.create(this.z),metadata:M},q),M]}catch(W){try{await this.A.delete(z)}catch(Q){this.s.warn("Error while deleting the downloaded file",z.toString(),(0,N.getErrorMessage)(Q))}throw W}}async C(q){try{await(0,b.getManifest)(q)}catch(C){throw new t.ExtensionManagementError((0,r.joinErrors)(C).message,t.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=X;class ie extends ${constructor(q,C,k,M,z,_,W,Q,ee,le){super({id:(0,i.getGalleryExtensionId)(q.publisher,q.name)},C,k,z,_,W,Q,ee,le),this.y=q,this.z=C,this.A=M}async h(q){const C=await super.h(q);return this.D(C,q),C}async x(q){const C=new i.ExtensionKey(this.identifier,this.y.version),M=(await this.m.scanExtensions(1,this.l.profileLocation)).find(W=>(0,i.areSameExtensions)(this.identifier,W.identifier)),z={isApplicationScoped:(0,A.isApplicationScopedExtension)(this.y),isMachineScoped:this.l.isMachineScoped||M?.isMachineScoped,isBuiltin:this.l.isBuiltin||M?.isBuiltin,installedTimestamp:Date.now(),pinned:this.l.installGivenVersion?!0:void 0};if(M)if(this.k=3,C.equals(new i.ExtensionKey(M.identifier,M.manifest.version)))try{await this.m.removeExtension(M,"existing")}catch{throw new Error(v.localize(7,null,this.y.displayName||this.y.name))}else!this.l.profileLocation&&m.gt(M.manifest.version,this.y.version)&&await this.m.setUninstalled(M);else{const W=await this.v(C);if(W)try{await this.m.removeExtension(W,"existing")}catch{throw new Error(v.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:S.resolve(this.z.fsPath),key:C,metadata:z},q),z]}async D(q,C){try{let[k]=await this.A.getExtensions([{id:q.identifier.id,version:q.manifest.version}],C);if(k||([k]=await this.A.getExtensions([{id:q.identifier.id}],C)),k){const M={id:k.identifier.uuid,publisherDisplayName:k.publisherDisplayName,publisherId:k.publisherId,isPreReleaseVersion:k.properties.isPreReleaseVersion,preRelease:k.properties.isPreReleaseVersion||this.l.installPreReleaseVersion};await this.m.updateMetadata(q,M,this.l.profileLocation)}}catch{}}}class se extends r.AbstractExtensionTask{constructor(q,C,k){super(),this.extension=q,this.j=C,this.k=k}async h(q){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(re[287],oe([0,1,2,29,81,236,128,9,20]),function(te,e,O,U,l,T,N,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsContributions=void 0;let w=class extends O.Disposable{constructor(S,p,f,m,E,a){super(),S.cleanUp(),(0,T.migrateUnsupportedExtensions)(S,p,f,m,a),l.ExtensionStorageService.removeOutdatedExtensionVersions(S,E)}};w=ye([G(0,N.INativeServerExtensionManagementService),G(1,U.IExtensionGalleryService),G(2,l.IExtensionStorageService),G(3,U.IGlobalExtensionEnablementService),G(4,I.IStorageService),G(5,R.ILogService)],w),e.ExtensionsContributions=w}),define(re[288],oe([0,1,71,64,34,299,16,10,3,2,13,4,31,39,97]),function(te,e,O,U,l,T,N,R,I,w,P,S,p,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class E{traceSocketEvent(g,D){m.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,g,D)}constructor(g,D=""){this.f=!0,this.debugLabel=D,this.socket=g,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=A=>{if(this.traceSocketEvent("error",{code:A?.code,message:A?.message}),A){if(A.code==="EPIPE")return;(0,R.onUnexpectedError)(A)}},this.socket.on("error",this.a),this.b=A=>{this.traceSocketEvent("close",{hadError:A}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(g){const D=A=>{this.traceSocketEvent("read",A),g(N.VSBuffer.wrap(A))};return this.socket.on("data",D),{dispose:()=>this.socket.off("data",D)}}onClose(g){const D=A=>{g({type:0,hadError:A,error:void 0})};return this.socket.on("close",D),{dispose:()=>this.socket.off("close",D)}}onEnd(g){const D=()=>{g()};return this.socket.on("end",D),{dispose:()=>this.socket.off("end",D)}}write(g){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",g),this.socket.write(g.buffer,D=>{if(D){if(D.code==="EPIPE")return;(0,R.onUnexpectedError)(D)}})}catch(D){if(D.code==="EPIPE")return;(0,R.onUnexpectedError)(D)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((g,D)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),g();return}const A=()=>{this.socket.off("close",A),this.socket.off("end",A),this.socket.off("error",A),this.socket.off("timeout",A),this.socket.off("drain",A),this.traceSocketEvent("nodeDrainEnd"),g()};this.socket.on("close",A),this.socket.on("end",A),this.socket.on("error",A),this.socket.on("timeout",A),this.socket.on("drain",A)})}}e.NodeSocket=E;var a;(function(b){b[b.MinHeaderByteSize=2]="MinHeaderByteSize",b[b.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(a||(a={}));var u;(function(b){b[b.PeekHeader=1]="PeekHeader",b[b.ReadHeader=2]="ReadHeader",b[b.ReadBody=3]="ReadBody",b[b.Fin=4]="Fin"})(u||(u={}));class h extends w.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(g,D){this.socket.traceSocketEvent(g,D)}constructor(g,D,A,F){super(),this.f=this.D(new I.Emitter),this.g=this.D(new I.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=g,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:D,inflateBytesLength:A?.byteLength||0,recordInflateBytes:F}),this.a=this.D(new d(this,D,A,F,this.f,(j,x)=>this.k(j,x))),this.D(this.a.onError(j=>{console.error(j),(0,R.onUnexpectedError)(j),this.g.fire({type:0,hadError:!0,error:j})})),this.b=new m.ChunkStream,this.D(this.socket.onData(j=>this.l(j))),this.D(this.socket.onClose(async j=>{this.a.isProcessingReadQueue()&&await I.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(j)}))}dispose(){this.a.isProcessingWriteQueue()?this.D(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(g){return this.f.event(g)}onClose(g){return this.g.event(g)}onEnd(g){return this.socket.onEnd(g)}write(g){let D=0;for(;D<g.byteLength;)this.a.writeMessage(g.slice(D,Math.min(D+262144,g.byteLength))),D+=262144}k(g,D){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",g);let A=2;g.byteLength<126?A+=0:g.byteLength<2**16?A+=2:A+=8;const F=N.VSBuffer.alloc(A);if(D?F.writeUInt8(194,0):F.writeUInt8(130,0),g.byteLength<126)F.writeUInt8(g.byteLength,1);else if(g.byteLength<2**16){F.writeUInt8(126,1);let j=1;F.writeUInt8(g.byteLength>>>8&255,++j),F.writeUInt8(g.byteLength>>>0&255,++j)}else{F.writeUInt8(127,1);let j=1;F.writeUInt8(0,++j),F.writeUInt8(0,++j),F.writeUInt8(0,++j),F.writeUInt8(0,++j),F.writeUInt8(g.byteLength>>>24&255,++j),F.writeUInt8(g.byteLength>>>16&255,++j),F.writeUInt8(g.byteLength>>>8&255,++j),F.writeUInt8(g.byteLength>>>0&255,++j)}this.socket.write(N.VSBuffer.concat([F,g]))}end(){this.h=!0,this.socket.end()}l(g){if(g.byteLength!==0){for(this.b.acceptChunk(g);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const D=this.b.peek(this.j.readLen),A=D.readUInt8(0),F=(A&128)>>>7,j=(A&64)>>>6,x=D.readUInt8(1),V=(x&128)>>>7,B=x&127;this.j.state=2,this.j.readLen=2+(V?4:0)+(B===126?2:0)+(B===127?8:0),this.j.fin=F,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(j)),this.j.firstFrameOfMessage=Boolean(F),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const D=this.b.read(this.j.readLen),A=D.readUInt8(1),F=(A&128)>>>7;let j=A&127,x=1;j===126?j=D.readUInt8(++x)*2**8+D.readUInt8(++x):j===127&&(j=D.readUInt8(++x)*0+D.readUInt8(++x)*0+D.readUInt8(++x)*0+D.readUInt8(++x)*0+D.readUInt8(++x)*2**24+D.readUInt8(++x)*2**16+D.readUInt8(++x)*2**8+D.readUInt8(++x));let V=0;F&&(V=D.readUInt8(++x)*2**24+D.readUInt8(++x)*2**16+D.readUInt8(++x)*2**8+D.readUInt8(++x)),this.j.state=3,this.j.readLen=j,this.j.mask=V,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const D=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",D),n(D,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",D),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(D,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await I.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=h;class d extends w.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:N.VSBuffer.alloc(0)}constructor(g,D,A,F,j,x){super(),this.l=g,this.m=j,this.n=x,this.a=this.D(new I.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.D(new I.Emitter),this.onDidFinishProcessingReadQueue=this.j.event,this.k=this.D(new I.Emitter),this.onDidFinishProcessingWriteQueue=this.k.event,this.p=!1,this.s=!1,D?(this.b=this.D(new v(this.l,F,A,{windowBits:15})),this.f=this.D(new L(this.l,{windowBits:15})),this.D(this.b.onError(V=>this.a.fire(V))),this.D(this.f.onError(V=>this.a.fire(V)))):(this.b=null,this.f=null)}writeMessage(g){this.g.push(g),this.q()}async q(){if(!this.p){for(this.p=!0;this.g.length>0;){const g=this.g.shift();if(this.f){const D=await this.r(this.f,g);this.n(D,!0)}else this.n(g,!1)}this.p=!1,this.k.fire()}}isProcessingWriteQueue(){return this.p}r(g,D){return new Promise((A,F)=>{g.write(D),g.flush(j=>A(j))})}acceptFrame(g,D,A){this.h.push({data:g,isCompressed:D,isLastFrameOfMessage:A}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const g=this.h.shift();if(this.b&&g.isCompressed){const D=await this.u(this.b,g.data,g.isLastFrameOfMessage);this.m.fire(D)}else this.m.fire(g.data)}this.s=!1,this.j.fire()}}isProcessingReadQueue(){return this.s}u(g,D,A){return new Promise((F,j)=>{g.write(D),A&&g.write(N.VSBuffer.fromByteArray([0,0,255,255])),g.flush(x=>F(x))})}}class v extends w.Disposable{get recordedInflateBytes(){return this.j?N.VSBuffer.concat(this.f):N.VSBuffer.alloc(0)}constructor(g,D,A,F){super(),this.h=g,this.j=D,this.a=this.D(new I.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,T.createInflateRaw)(F),this.b.on("error",j=>{this.h.traceSocketEvent("zlibInflateError",{message:j?.message,code:j?.code}),this.a.fire(j)}),this.b.on("data",j=>{this.h.traceSocketEvent("zlibInflateData",j),this.g.push(N.VSBuffer.wrap(j))}),A&&(this.h.traceSocketEvent("zlibInflateInitialWrite",A.buffer),this.b.write(A.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(g){this.j&&this.f.push(g.clone()),this.h.traceSocketEvent("zlibInflateWrite",g),this.b.write(g.buffer)}flush(g){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const D=N.VSBuffer.concat(this.g);this.g.length=0,g(D)})}}class L extends w.Disposable{constructor(g,D){super(),this.g=g,this.a=this.D(new I.Emitter),this.onError=this.a.event,this.f=[],this.b=(0,T.createDeflateRaw)({windowBits:15}),this.b.on("error",A=>{this.g.traceSocketEvent("zlibDeflateError",{message:A?.message,code:A?.code}),this.a.fire(A)}),this.b.on("data",A=>{this.g.traceSocketEvent("zlibDeflateData",A),this.f.push(N.VSBuffer.wrap(A))})}write(g){this.g.traceSocketEvent("zlibDeflateWrite",g.buffer),this.b.write(g.buffer)}flush(g){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let D=N.VSBuffer.concat(this.f);this.f.length=0,D=D.slice(0,D.byteLength-4),g(D)})}}function n(b,g){if(g===0)return;const D=b.byteLength>>>2;for(let B=0;B<D;B++){const Z=b.readUInt32BE(B*4);b.writeUInt32BE(Z^g,B*4)}const A=D*4,F=b.byteLength-A,j=g>>>24&255,x=g>>>16&255,V=g>>>8&255;F>=1&&b.writeUInt8(b.readUInt8(A)^j,A),F>=2&&b.writeUInt8(b.readUInt8(A+1)^x,A+1),F>=3&&b.writeUInt8(b.readUInt8(A+2)^V,A+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const r={[2]:107,[1]:103};function t(){const b=(0,p.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${b}-sock`;const g=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,l.tmpdir)(),D=(0,P.join)(g,`vscode-ipc-${b}.sock`);return s(D),D}e.createRandomIPCHandle=t;function i(b,g,D){const A=(0,O.createHash)("md5").update(b).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${A}-${D}-${g}-sock`;const F=D.substr(0,4),j=g.substr(0,6),x=A.substr(0,8);let V;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?V=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-${x}-${F}-${j}.sock`):V=(0,P.join)(b,`${F}-${j}.sock`),s(V),V}e.createStaticIPCHandle=i;function s(b){const g=r[S.platform];typeof g=="number"&&b.length>=g&&console.warn(`WARNING: IPC handle "${b}" is longer than ${g} chars, try a shorter --user-data-dir`)}class o extends f.IPCServer{static b(g){const D=I.Event.fromNodeEventEmitter(g,"connection");return I.Event.map(D,A=>({protocol:new m.Protocol(new E(A,"ipc-server-connection")),onDidClientDisconnect:I.Event.once(I.Event.fromNodeEventEmitter(A,"close"))}))}constructor(g){super(o.b(g)),this.d=g}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=o;function c(b){return new Promise((g,D)=>{const A=(0,U.createServer)();A.on("error",D),A.listen(b,()=>{A.removeListener("error",D),g(new o(A))})})}e.serve=c;function y(b,g){return new Promise((D,A)=>{const F=(0,U.createConnection)(b,()=>{F.removeListener("error",A),D(m.Client.fromSocket(new E(F,`ipc-client${g}`),g))});F.once("error",A)})}e.connect=y}),define(re[289],oe([0,1,64,288]),function(te,e,O,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(l,T,N,R,I,w){const P=p=>w(p,void 0),S=O.createConnection({host:l,port:T},()=>{S.removeListener("error",P);const p=Buffer.alloc(16);for(let a=0;a<16;a++)p[a]=Math.round(Math.random()*256);const f=p.toString("base64"),m=[`GET ws://${/:/.test(l)?`[${l}]`:l}:${T}${N}?${R}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${f}`];S.write(m.join(`\r
`)+`\r
\r
`);const E=a=>{a.toString().indexOf(`\r
\r
`)>=0&&(S.off("data",E),w(void 0,new U.NodeSocket(S,I)))};S.on("data",E)});S.setNoDelay(!0),S.once("error",P)}}}),define(re[290],oe([0,1,64,34,136,289,6,2,17,9,26,224,78,111,4]),function(te,e,O,U,l,T,N,R,I,w,P,S,p,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function E(v,L,n,r,t){let i;for(let s=3;s&&(i?.dispose(),i=await new a(v,L,n,r,t).waitForReady(),!(t&&l.BROWSER_RESTRICTED_PORTS[t]||!l.BROWSER_RESTRICTED_PORTS[i.tunnelLocalPort]));s--);return i}class a extends R.Disposable{constructor(L,n,r,t,i){super(),this.j=n,this.k=i,this.privacy=p.TunnelPrivacyId.Private,this.i=new Map,this.a=L,this.b=O.createServer(),this.c=new N.Barrier,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=s=>this.l(s),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=t,this.tunnelRemoteHost=r}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.i.values()).forEach(n=>{n()})}async waitForReady(){const L=this.k??this.tunnelRemotePort,n=(0,p.isAllInterfaces)(this.j)?"0.0.0.0":"127.0.0.1";let r=await(0,l.findFreePortFaster)(L,2,1e3,n),t=null;return this.b.listen(r,this.j),await this.c.wait(),t=this.b.address(),t||(r=0,this.b.listen(r,this.j),await this.c.wait(),t=this.b.address()),this.tunnelLocalPort=t.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${t.port}`,this}async l(L){L.pause();const n=(0,p.isLocalhost)(this.tunnelRemoteHost)||(0,p.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,r=await(0,S.connectRemoteAgentTunnel)(this.a,n,this.tunnelRemotePort),t=r.getSocket().socket,i=r.readEntireBuffer();r.dispose(),i.byteLength>0&&L.write(i.buffer),L.on("end",()=>{L.localAddress&&this.i.delete(L.localAddress),t.end()}),L.on("close",()=>t.end()),L.on("error",()=>{L.localAddress&&this.i.delete(L.localAddress),t.destroy()}),t.on("end",()=>L.end()),t.on("close",()=>L.end()),t.on("error",()=>{L.destroy()}),L.pipe(t),t.pipe(L),L.localAddress&&this.i.set(L.localAddress,()=>{L.end(),t.end()})}}let u=class extends p.AbstractTunnelService{constructor(L,n,r,t,i){super(n,i),this.t=L,this.u=r,this.v=t}isPortPrivileged(L){return(0,p.isPortPrivileged)(L,this.k,m.OS,U.release())}r(L,n,r,t,i,s,o,c){const y=this.q(n,r);if(y)return++y.refcount,y.value;if(this.e)return this.s(this.e,n,r,i,s,o,c);{this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${r} on local port ${i}.`);const b={commit:this.v.commit,quality:this.v.quality,socketFactory:this.t,addressProvider:L,signService:this.u,logService:this.i,ipcLogger:null},g=E(b,t,n,r,i);return this.i.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.o(n,r,g),g}}};u=ye([G(1,w.ILogService),G(2,f.ISignService),G(3,P.IProductService),G(4,I.IConfigurationService)],u),e.BaseTunnelService=u;let h=class extends u{constructor(L,n,r,t){super(T.nodeSocketFactory,L,n,r,t)}};h=ye([G(0,w.ILogService),G(1,f.ISignService),G(2,P.IProductService),G(3,I.IConfigurationService)],h),e.TunnelService=h;let d=class extends R.Disposable{constructor(L,n,r,t){super(),this.b=L,this.c=n,this.f=r,this.g=t,this.a=new Map}async openTunnel(L,n,r,t,i,s,o,c,y){if(this.b.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${r}:${t} on local port ${s}.`),!this.a.has(L)){const b=new h(this.b,this.f,this.c,this.g);this.D(b),this.a.set(L,b),b.onTunnelClosed(async()=>{(await b.tunnels).length===0&&(b.dispose(),this.a.delete(L))})}return this.a.get(L).openTunnel(n,r,t,i,s,o,c,y)}};d=ye([G(0,w.ILogService),G(1,P.IProductService),G(2,f.ISignService),G(3,I.IConfigurationService)],d),e.SharedTunnelsService=d}),define(re[300],oe([0,1,150,229,248,34,38,10,2,22,11,39,152,216,217,209,210,284,200,202,17,221,99,233,100,226,15,230,120,270,29,101,201,128,102,14,212,213,69,5,208,72,74,239,9,106,107,26,59,20,112,19,113,114,115,47,242,117,251,81,118,24,79,275,261,262,82,276,279,280,281,61,274,264,111,232,78,290,225,252,110,30,253,4,254,203,219,218,80,269,18,51,215,58,273,241,265,109,278,287,7,214,263,88,105,234,268,227,197,57,282,271,73,272]),function(te,e,O,U,l,T,N,R,I,w,P,S,p,f,m,E,a,u,h,d,v,L,n,r,t,i,s,o,c,y,b,g,D,A,F,j,x,V,B,Z,J,K,Y,H,$,X,ie,se,ae,q,C,k,M,z,_,W,Q,ee,le,he,pe,de,be,Ce,Re,ke,We,Ye,ce,fe,ge,Ie,Pe,Fe,Le,qe,Me,Ne,je,ne,ue,me,we,ve,Ee,De,Ae,Te,Ue,$e,ze,et,nt,vt,Rt,kt,Lt,wt,At,Ot,Tt,Nt,Ut,Ze,St,Mt,Ft,jt,$t,zt,qt,Wt,bt,Bt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class xt extends I.Disposable{constructor(Se,Oe){super(),this.f=Se,this.g=Oe,this.b=void 0,this.c=void 0,(0,Ze.isUtilityProcess)(process)?this.a=this.D(new p.Server):this.a=this.D(new O.Server),this.h()}h(){let Se=!1;const Oe=()=>{Se||(Se=!0,this.c?.fireOnWillShutdown(),this.dispose())};if(process.once("exit",Oe),(0,Ze.isUtilityProcess)(process)?(0,p.once)(process.parentPort,"vscode:electron-main->shared-process=exit",Oe):this.g.once("vscode:electron-main->shared-process=exit",Oe),!(0,Ze.isUtilityProcess)(process)){const xe="vscode:electron-main->shared-process=disposeWorker",Be=(st,Ve)=>{this.i(Ve)};this.g.on(xe,Be),this.D((0,I.toDisposable)(()=>this.g.removeListener(xe,Be)))}}i(Se){this.b?.disposeWorker(Se)}async init(){const Se=await this.j();(0,de.registerConfiguration)(),Se.invokeFunction(Oe=>{const xe=Oe.get($.ILogService);xe.trace("sharedProcess configuration",JSON.stringify(this.f)),this.k(Oe),this.l(xe)}),this.D((0,I.combinedDisposable)(Se.createInstance(f.CodeCacheCleaner,this.f.codeCachePath),Se.createInstance(m.LanguagePackCachedDataCleaner),Se.createInstance(u.UnusedWorkspaceStorageDataCleaner),Se.createInstance(a.LogsDataCleaner),Se.createInstance(E.LocalizationsUpdater),Se.createInstance(Ot.ExtensionsContributions),Se.createInstance(Lt.UserDataProfilesCleaner)))}async j(){const Se=new K.ServiceCollection,Oe={_serviceBrand:void 0,...ie.default};Se.set(se.IProductService,Oe);const xe=new S.StaticRouter(Ke=>Ke==="main"),Be=new bt.MainProcessService(this.a,xe);Se.set(bt.IMainProcessService,Be);const st=this.f.policiesData?new nt.PolicyChannelClient(this.f.policiesData,Be.getChannel("policy")):new vt.NullPolicyService;Se.set(vt.IPolicyService,st);const Ve=new o.SharedProcessEnvironmentService(this.f.args,Oe);Se.set(s.INativeEnvironmentService,Ve);const _e=new X.LoggerChannelClient(void 0,this.f.logLevel,Ve.logsHome,this.f.loggers.map(Ke=>({...Ke,resource:P.URI.revive(Ke.resource)})),Be.getChannel("logger"));Se.set($.ILoggerService,_e);const ct=this.D(_e.createLogger("sharedprocess",{name:(0,Tt.localize)(0,null)})),ht=this.D(new $.ConsoleLogger(ct.getLevel())),Ge=this.D(new Nt.LogService(ct,[ht]));Se.set($.ILogService,Ge),this.c=this.D(new St.SharedProcessLifecycleService(Ge)),Se.set(St.ISharedProcessLifecycleService,this.c),this.b=new U.SharedProcessWorkerService(Ge),Se.set(ue.ISharedProcessWorkerService,this.b);const Qe=this.D(new x.FileService(Ge));Se.set(j.IFileService,Qe);const ft=this.D(new V.DiskFileSystemProvider(Ge));Qe.registerProvider(w.Schemas.file,ft);const dt=this.D(new Ee.FileUserDataProvider(w.Schemas.file,this.D(new De.DiskFileSystemProviderClient(Be.getChannel(De.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:ve.isLinux})),w.Schemas.vscodeUserData,Ge));Qe.registerProvider(w.Schemas.vscodeUserData,dt);const tt=this.D(new Rt.UserDataProfilesService(this.f.profiles.all,P.URI.revive(this.f.profiles.home).with({scheme:Ve.userRoamingDataHome.scheme}),Be.getChannel("userDataProfiles")));Se.set(ze.IUserDataProfilesService,tt);const Je=this.D(new L.ConfigurationService(tt.defaultProfile.settingsResource,Qe,st,Ge));Se.set(v.IConfigurationService,Je);const rt=new Bt.RemoteStorageService(void 0,{defaultProfile:tt.defaultProfile,currentProfile:tt.defaultProfile},Be,Ve);Se.set(q.IStorageService,rt),this.D((0,I.toDisposable)(()=>rt.flush())),await Promise.all([Je.initialize(),rt.initialize()]);const gt=new we.UriIdentityService(Qe);Se.set(me.IUriIdentityService,gt),Se.set(ae.IRequestService,new jt.RequestChannelClient(Be.getChannel("request"))),Se.set(h.IChecksumService,new B.SyncDescriptor(d.ChecksumService,void 0,!1)),Se.set(Te.IV8InspectProfilingService,new B.SyncDescriptor(Ae.InspectProfilingService,void 0,!1));const lt=S.ProxyChannel.toService(Be.getChannel("nativeHost"),{context:this.f.windowId});Se.set(zt.INativeHostService,lt),Se.set(t.IDownloadService,new B.SyncDescriptor(i.DownloadService,void 0,!0));const mt=this.D(new Fe.ActiveWindowManager(lt)),Vt=new S.StaticRouter(Ke=>mt.getActiveClientId().then(pt=>Ke===pt));Se.set(F.IExtensionRecommendationNotificationService,new $t.ExtensionRecommendationNotificationServiceChannelClient(this.a.getChannel("extensionRecommendationNotification",Vt)));let ut;const ot=[],Ct=(0,W.isInternalTelemetry)(Oe,Je);if((0,W.supportsTelemetry)(Oe,Ve)){const Ke=new z.TelemetryLogAppender(Ge,_e,Ve,Oe);ot.push(Ke);const{installSourcePath:pt}=Ve;if(Oe.aiConfig?.ariaKey){const Pt=new kt.OneDataSystemAppender(Ct,"monacoworkbench",null,Oe.aiConfig.ariaKey);this.D((0,I.toDisposable)(()=>Pt.flush())),ot.push(Pt)}ut=new _.TelemetryService({appenders:ot,commonProperties:(0,C.resolveCommonProperties)(Qe,(0,T.release)(),(0,T.hostname)(),process.arch,Oe.commit,Oe.version,this.f.machineId,Ct,pt),sendErrorTelemetry:!0,piiPaths:(0,W.getPiiPathsFromEnvironment)(Ve)},Je,Oe)}else{ut=W.NullTelemetryService;const Ke=W.NullAppender;ot.push(Ke)}this.a.registerChannel("telemetryAppender",new M.TelemetryAppenderChannel(ot)),Se.set(k.ITelemetryService,ut);const Ht=new Q.CustomEndpointTelemetryService(Je,ut,Ge,_e,Ve,Oe);Se.set(k.ICustomEndpointTelemetryService,Ht),Se.set(et.IExtensionsProfileScannerService,new B.SyncDescriptor(Ft.ExtensionsProfileScannerService,void 0,!0)),Se.set(Ue.IExtensionsScannerService,new B.SyncDescriptor($e.ExtensionsScannerService,void 0,!0)),Se.set(g.IExtensionSignatureVerificationService,new B.SyncDescriptor(g.ExtensionSignatureVerificationService,void 0,!0)),Se.set(A.INativeServerExtensionManagementService,new B.SyncDescriptor(A.ExtensionManagementService,void 0,!0)),Se.set(b.IExtensionGalleryService,new B.SyncDescriptor(y.ExtensionGalleryService,void 0,!0)),Se.set(b.IExtensionTipsService,new B.SyncDescriptor(Wt.ExtensionTipsService,void 0,!1)),Se.set(Y.ILanguagePackService,new B.SyncDescriptor(H.NativeLanguagePackService,void 0,!1)),Se.set(n.IDiagnosticsService,new B.SyncDescriptor(r.DiagnosticsService,void 0,!1)),Se.set(be.IUserDataSyncAccountService,new B.SyncDescriptor(be.UserDataSyncAccountService,void 0,!0)),Se.set(de.IUserDataSyncLogService,new B.SyncDescriptor(ke.UserDataSyncLogService,void 0,!0)),Se.set(de.IUserDataSyncUtilService,new Re.UserDataSyncUtilServiceClient(this.a.getChannel("userDataSyncUtil",Ke=>Ke.ctx!=="main"))),Se.set(b.IGlobalExtensionEnablementService,new B.SyncDescriptor(c.GlobalExtensionEnablementService,void 0,!1)),Se.set(pe.IIgnoredExtensionsManagementService,new B.SyncDescriptor(pe.IgnoredExtensionsManagementService,void 0,!0)),Se.set(he.IExtensionStorageService,new B.SyncDescriptor(he.ExtensionStorageService)),Se.set(de.IUserDataSyncStoreManagementService,new B.SyncDescriptor(ge.UserDataSyncStoreManagementService,void 0,!0)),Se.set(de.IUserDataSyncStoreService,new B.SyncDescriptor(ge.UserDataSyncStoreService,void 0,!0)),Se.set(We.IUserDataSyncMachinesService,new B.SyncDescriptor(We.UserDataSyncMachinesService,void 0,!0)),Se.set(de.IUserDataSyncBackupStoreService,new B.SyncDescriptor(Ce.UserDataSyncBackupStoreService,void 0,!1)),Se.set(de.IUserDataSyncEnablementService,new B.SyncDescriptor(Ye.UserDataSyncEnablementService,void 0,!0)),Se.set(de.IUserDataSyncService,new B.SyncDescriptor(ce.UserDataSyncService,void 0,!1)),Se.set(Ie.IUserDataProfileStorageService,new B.SyncDescriptor(Pe.NativeUserDataProfileStorageService,void 0,!0)),Se.set(de.IUserDataSyncResourceProviderService,new B.SyncDescriptor(At.UserDataSyncResourceProviderService,void 0,!0));const It=new le.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:Je.getValue("terminal.integrated.persistentSessionScrollback")??100},!1,Je,Ve,Ge,_e);return It.initialize(),Se.set(l.ILocalPtyService,this.D(It)),Se.set(Le.ISignService,new B.SyncDescriptor(qe.SignService,void 0,!1)),Se.set(Me.ISharedTunnelsService,new B.SyncDescriptor(Ne.SharedTunnelsService)),Se.set(je.ISharedProcessTunnelService,new B.SyncDescriptor(ne.SharedProcessTunnelService)),Se.set(wt.IRemoteTunnelService,new B.SyncDescriptor(Mt.RemoteTunnelService)),new J.InstantiationService(Se)}k(Se){const Oe=new D.ExtensionManagementChannel(Se.get(b.IExtensionManagementService),()=>null);this.a.registerChannel("extensions",Oe);const xe=S.ProxyChannel.fromService(Se.get(Y.ILanguagePackService));this.a.registerChannel("languagePacks",xe);const Be=S.ProxyChannel.fromService(Se.get(n.IDiagnosticsService));this.a.registerChannel("diagnostics",Be);const st=new D.ExtensionTipsChannel(Se.get(b.IExtensionTipsService));this.a.registerChannel("extensionTipsService",st);const Ve=S.ProxyChannel.fromService(Se.get(h.IChecksumService));this.a.registerChannel("checksum",Ve);const _e=S.ProxyChannel.fromService(Se.get(Te.IV8InspectProfilingService));this.a.registerChannel("v8InspectProfiling",_e);const ct=new Re.UserDataSyncMachinesServiceChannel(Se.get(We.IUserDataSyncMachinesService));this.a.registerChannel("userDataSyncMachines",ct);const ht=S.ProxyChannel.fromService(Se.get(k.ICustomEndpointTelemetryService));this.a.registerChannel("customEndpointTelemetry",ht);const Ge=new Re.UserDataSyncAccountServiceChannel(Se.get(be.IUserDataSyncAccountService));this.a.registerChannel("userDataSyncAccount",Ge);const Qe=new Re.UserDataSyncStoreManagementServiceChannel(Se.get(de.IUserDataSyncStoreManagementService));this.a.registerChannel("userDataSyncStoreManagement",Qe);const ft=new fe.UserDataSyncChannel(Se.get(de.IUserDataSyncService),Se.get(ze.IUserDataProfilesService),Se.get($.ILogService));this.a.registerChannel("userDataSync",ft);const dt=this.D(Se.get(Z.IInstantiationService).createInstance(qt.UserDataAutoSyncService)),tt=new Re.UserDataAutoSyncChannel(dt);this.a.registerChannel("userDataAutoSync",tt);const Je=Se.get(l.ILocalPtyService),rt=S.ProxyChannel.fromService(Je);this.a.registerChannel(ee.TerminalIpcChannels.LocalPty,rt);const gt=S.ProxyChannel.fromService(Se.get(je.ISharedProcessTunnelService));this.a.registerChannel(je.ipcSharedProcessTunnelChannelName,gt);const lt=S.ProxyChannel.fromService(Se.get(ue.ISharedProcessWorkerService));this.a.registerChannel(Ut.ipcUtilityProcessWorkerChannelName,lt);const mt=S.ProxyChannel.fromService(Se.get(wt.IRemoteTunnelService));this.a.registerChannel("remoteTunnel",mt)}l(Se){(0,Ze.isUtilityProcess)(process)?(process.on("uncaughtException",Oe=>(0,R.onUnexpectedError)(Oe)),process.on("unhandledRejection",Oe=>(0,R.onUnexpectedError)(Oe))):globalThis.addEventListener("unhandledrejection",Oe=>{(0,R.onUnexpectedError)(Oe.reason),Oe.preventDefault()}),(0,R.setUnexpectedErrorHandler)(Oe=>{const xe=(0,N.toErrorMessage)(Oe,!0);!xe||Se.error(`[uncaught exception in sharedProcess]: ${xe}`)})}}async function Et(at){let Se;(0,Ze.isUtilityProcess)(process)||(Se=(await new Promise((xe,Be)=>{te(["electron"],xe,Be)})).ipcRenderer);const Oe=new xt(at,Se);(0,Ze.isUtilityProcess)(process)?process.parentPort.postMessage("vscode:shared-process->electron-main=ipc-ready"):Se.send("vscode:shared-process->electron-main=ipc-ready"),await Oe.init(),(0,Ze.isUtilityProcess)(process)?process.parentPort.postMessage("vscode:shared-process->electron-main=init-done"):Se.send("vscode:shared-process->electron-main=init-done")}e.main=Et,(0,Ze.isUtilityProcess)(process)&&process.parentPort.once("message",at=>{Et(at.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/3a168b2d1ec767eea02b46d6ed38c755805b43a7/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
